/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var z=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],G=function(F){for(var t=[],P=0,R=F.length;P<R;P++)t[P]=z[F[P]];return t},Ee=this,Se=typeof global=="object"?global:{},ee;(function(F){F.global=Ee;var t=function(){function P(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(P.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),P.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=P._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof F.global.importScripts=="function")},P._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},P}();F.Environment=t})(ee||(ee={}));var ee;(function(F){var t=function(){function C(l,b,a){this.type=l,this.detail=b,this.timestamp=a}return C}();F.LoaderEvent=t;var P=function(){function C(l){this._events=[new t(1,"",l)]}return C.prototype.record=function(l,b){this._events.push(new t(l,b,F.Utilities.getHighPerformanceTimestamp()))},C.prototype.getEvents=function(){return this._events},C}();F.LoaderEventRecorder=P;var R=function(){function C(){}return C.prototype.record=function(l,b){},C.prototype.getEvents=function(){return[]},C.INSTANCE=new C,C}();F.NullLoaderEventRecorder=R})(ee||(ee={}));var ee;(function(F){var t=function(){function P(){}return P.fileUriToFilePath=function(R,C){if(C=decodeURI(C).replace(/%23/g,"#"),R){if(/^file:\/\/\//.test(C))return C.substr(8);if(/^file:\/\//.test(C))return C.substr(5)}else if(/^file:\/\//.test(C))return C.substr(7);return C},P.startsWith=function(R,C){return R.length>=C.length&&R.substr(0,C.length)===C},P.endsWith=function(R,C){return R.length>=C.length&&R.substr(R.length-C.length)===C},P.containsQueryString=function(R){return/^[^\#]*\?/gi.test(R)},P.isAbsolutePath=function(R){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(R)},P.forEachProperty=function(R,C){if(R){var l=void 0;for(l in R)R.hasOwnProperty(l)&&C(l,R[l])}},P.isEmpty=function(R){var C=!0;return P.forEachProperty(R,function(){C=!1}),C},P.recursiveClone=function(R){if(!R||typeof R!="object"||R instanceof RegExp||!Array.isArray(R)&&Object.getPrototypeOf(R)!==Object.prototype)return R;var C=Array.isArray(R)?[]:{};return P.forEachProperty(R,function(l,b){b&&typeof b=="object"?C[l]=P.recursiveClone(b):C[l]=b}),C},P.generateAnonymousModule=function(){return"===anonymous"+P.NEXT_ANONYMOUS_ID+++"==="},P.isAnonymousModule=function(R){return P.startsWith(R,"===anonymous")},P.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=F.global.performance&&typeof F.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?F.global.performance.now():Date.now()},P.NEXT_ANONYMOUS_ID=1,P.PERFORMANCE_NOW_PROBED=!1,P.HAS_PERFORMANCE_NOW=!1,P}();F.Utilities=t})(ee||(ee={}));var ee;(function(F){function t(C){if(C instanceof Error)return C;var l=new Error(C.message||String(C)||"Unknown Error");return C.stack&&(l.stack=C.stack),l}F.ensureError=t;var P=function(){function C(){}return C.validateConfigurationOptions=function(l){function b(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=b),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(F.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var a=t(new Error("INVALID cached data configuration, 'path' MUST be set"));a.phase="configuration",l.onError(a),l.nodeCachedData=void 0}return l},C.mergeConfigurationOptions=function(l,b){l===void 0&&(l=null),b===void 0&&(b=null);var a=F.Utilities.recursiveClone(b||{});return F.Utilities.forEachProperty(l,function(u,o){u==="ignoreDuplicateModules"&&typeof a.ignoreDuplicateModules!="undefined"?a.ignoreDuplicateModules=a.ignoreDuplicateModules.concat(o):u==="paths"&&typeof a.paths!="undefined"?F.Utilities.forEachProperty(o,function(L,w){return a.paths[L]=w}):u==="config"&&typeof a.config!="undefined"?F.Utilities.forEachProperty(o,function(L,w){return a.config[L]=w}):a[u]=F.Utilities.recursiveClone(o)}),C.validateConfigurationOptions(a)},C}();F.ConfigurationOptionsUtil=P;var R=function(){function C(l,b){if(this._env=l,this.options=P.mergeConfigurationOptions(b),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var a=this.options.nodeRequire.main.filename,u=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var a=this.options.nodeMain,u=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,u+1)}}}return C.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},C.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,b=this.options.nodeModules;l<b.length;l++){var a=b[l];this.nodeModulesMap[a]=!0}},C.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],F.Utilities.forEachProperty(this.options.paths,function(b,a){Array.isArray(a)?l.sortedPathsRules.push({from:b,to:a}):l.sortedPathsRules.push({from:b,to:[a]})}),this.sortedPathsRules.sort(function(b,a){return a.from.length-b.from.length})},C.prototype.cloneAndMerge=function(l){return new C(this._env,P.mergeConfigurationOptions(l,this.options))},C.prototype.getOptionsLiteral=function(){return this.options},C.prototype._applyPaths=function(l){for(var b,a=0,u=this.sortedPathsRules.length;a<u;a++)if(b=this.sortedPathsRules[a],F.Utilities.startsWith(l,b.from)){for(var o=[],L=0,w=b.to.length;L<w;L++)o.push(b.to[L]+l.substr(b.from.length));return o}return[l]},C.prototype._addUrlArgsToUrl=function(l){return F.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},C.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},C.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var b=0,a=l.length;b<a;b++)l[b]=this._addUrlArgsToUrl(l[b]);return l},C.prototype.moduleIdToPaths=function(l){var b=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(b)return this.isBuild()?["empty:"]:["node|"+l];var a=l,u;if(!F.Utilities.endsWith(a,".js")&&!F.Utilities.isAbsolutePath(a)){u=this._applyPaths(a);for(var o=0,L=u.length;o<L;o++)this.isBuild()&&u[o]==="empty:"||(F.Utilities.isAbsolutePath(u[o])||(u[o]=this.options.baseUrl+u[o]),!F.Utilities.endsWith(u[o],".js")&&!F.Utilities.containsQueryString(u[o])&&(u[o]=u[o]+".js"))}else!F.Utilities.endsWith(a,".js")&&!F.Utilities.containsQueryString(a)&&(a=a+".js"),u=[a];return this._addUrlArgsIfNecessaryToUrls(u)},C.prototype.requireToUrl=function(l){var b=l;return F.Utilities.isAbsolutePath(b)||(b=this._applyPaths(b)[0],F.Utilities.isAbsolutePath(b)||(b=this.options.baseUrl+b)),this._addUrlArgsIfNecessaryToUrl(b)},C.prototype.isBuild=function(){return this.options.isBuild},C.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},C.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},C.prototype.shouldCatchError=function(){return this.options.catchError},C.prototype.shouldRecordStats=function(){return this.options.recordStats},C.prototype.onError=function(l){this.options.onError(l)},C}();F.Configuration=R})(ee||(ee={}));var ee;(function(F){var t=function(){function u(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(o,L,w,d){var c=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new C;else if(this._env.isElectronRenderer){var _=o.getConfig().getOptionsLiteral().preferScriptTags;_?this._scriptLoader=new P:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new P;var E={callback:w,errorback:d};if(this._callbackMap.hasOwnProperty(L)){this._callbackMap[L].push(E);return}this._callbackMap[L]=[E],this._scriptLoader.load(o,L,function(){return c.triggerCallback(L)},function(N){return c.triggerErrorback(L,N)})},u.prototype.triggerCallback=function(o){var L=this._callbackMap[o];delete this._callbackMap[o];for(var w=0;w<L.length;w++)L[w].callback()},u.prototype.triggerErrorback=function(o,L){var w=this._callbackMap[o];delete this._callbackMap[o];for(var d=0;d<w.length;d++)w[d].errorback(L)},u}(),P=function(){function u(){}return u.prototype.attachListeners=function(o,L,w){var d=function(){o.removeEventListener("load",c),o.removeEventListener("error",_)},c=function(E){d(),L()},_=function(E){d(),w(E)};o.addEventListener("load",c),o.addEventListener("error",_)},u.prototype.load=function(o,L,w,d){if(/^node\|/.test(L)){var c=o.getConfig().getOptionsLiteral(),_=b(o.getRecorder(),c.nodeRequire||F.global.nodeRequire),E=L.split("|"),N=null;try{N=_(E[1])}catch(r){d(r);return}o.enqueueDefineAnonymousModule([],function(){return N}),w()}else{var S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript"),this.attachListeners(S,w,d);var n=o.getConfig().getOptionsLiteral().trustedTypesPolicy;n&&(L=n.createScriptURL(L)),S.setAttribute("src",L);var i=o.getConfig().getOptionsLiteral().cspNonce;i&&S.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(S)}},u}();function R(u){var o=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var L=o?self.eval(o.createScript("","true")):new Function("true");return L.call(self),!0}catch(w){return!1}}var C=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(o){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=R(o)),this._cachedCanUseEval},u.prototype.load=function(o,L,w,d){var c=o.getConfig().getOptionsLiteral().trustedTypesPolicy,_=/^((http:)|(https:)|(file:))/.test(L)&&L.substring(0,self.origin.length)!==self.origin;if(!_&&this._canUseEval(o)){fetch(L).then(function(E){if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(function(E){E=E+`
//# sourceURL=`+L;var N=c?self.eval(c.createScript("",E)):new Function(E);N.call(self),w()}).then(void 0,d);return}try{c&&(L=c.createScriptURL(L)),importScripts(L),w()}catch(E){d(E)}},u}(),l=function(){function u(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))},u.prototype._initNodeRequire=function(o,L){var w=L.getConfig().getOptionsLiteral().nodeCachedData;if(!w||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var d=this,c=o("module");function _(E){var N=E.constructor,S=function(i){try{return E.require(i)}finally{}};return S.resolve=function(i,r){return N._resolveFilename(i,E,!1,r)},S.resolve.paths=function(i){return N._resolveLookupPaths(i,E)},S.main=process.mainModule,S.extensions=N._extensions,S.cache=N._cache,S}c.prototype._compile=function(E,N){var S=c.wrap(E.replace(/^#!.*/,"")),n=L.getRecorder(),i=d._getCachedDataPath(w,N),r={filename:N},s;try{var h=d._fs.readFileSync(i);s=h.slice(0,16),r.cachedData=h.slice(16),n.record(60,i)}catch(p){n.record(61,i)}var v=new d._vm.Script(S,r),f=v.runInThisContext(r),g=d._path.dirname(N),m=_(this),M=[this.exports,m,this,N,g,process,Se,Buffer],D=f.apply(this.exports,M);return d._handleCachedData(v,S,i,!r.cachedData,L),d._verifyCachedData(v,S,i,s,L),D}},u.prototype.load=function(o,L,w,d){var c=this,_=o.getConfig().getOptionsLiteral(),E=b(o.getRecorder(),_.nodeRequire||F.global.nodeRequire),N=_.nodeInstrumenter||function(f){return f};this._init(E),this._initNodeRequire(E,o);var S=o.getRecorder();if(/^node\|/.test(L)){var n=L.split("|"),i=null;try{i=E(n[1])}catch(f){d(f);return}o.enqueueDefineAnonymousModule([],function(){return i}),w()}else{L=F.Utilities.fileUriToFilePath(this._env.isWindows,L);var r=this._path.normalize(L),s=this._getElectronRendererScriptPathOrUri(r),h=Boolean(_.nodeCachedData),v=h?this._getCachedDataPath(_.nodeCachedData,L):void 0;this._readSourceAndCachedData(r,v,S,function(f,g,m,M){if(f){d(f);return}var D;g.charCodeAt(0)===u._BOM?D=u._PREFIX+g.substring(1)+u._SUFFIX:D=u._PREFIX+g+u._SUFFIX,D=N(D,r);var p={filename:s,cachedData:m},U=c._createAndEvalScript(o,D,p,w,d);c._handleCachedData(U,D,v,h&&!m,o),c._verifyCachedData(U,D,v,M,o)})}},u.prototype._createAndEvalScript=function(o,L,w,d,c){var _=o.getRecorder();_.record(31,w.filename);var E=new this._vm.Script(L,w),N=E.runInThisContext(w),S=o.getGlobalAMDDefineFunc(),n=!1,i=function(){return n=!0,S.apply(null,arguments)};return i.amd=S.amd,N.call(F.global,o.getGlobalAMDRequireFunc(),i,w.filename,this._path.dirname(w.filename)),_.record(32,w.filename),n?d():c(new Error("Didn't receive define call in "+w.filename+"!")),E},u.prototype._getElectronRendererScriptPathOrUri=function(o){if(!this._env.isElectronRenderer)return o;var L=o.match(/^([a-z])\:(.*)/i);return L?"file:///"+(L[1].toUpperCase()+":"+L[2]).replace(/\\/g,"/"):"file://"+o},u.prototype._getCachedDataPath=function(o,L){var w=this._crypto.createHash("md5").update(L,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(L).replace(/\.js$/,"");return this._path.join(o.path,d+"-"+w+".code")},u.prototype._handleCachedData=function(o,L,w,d,c){var _=this;o.cachedDataRejected?this._fs.unlink(w,function(E){c.getRecorder().record(62,w),_._createAndWriteCachedData(o,L,w,c),E&&c.getConfig().onError(E)}):d&&this._createAndWriteCachedData(o,L,w,c)},u.prototype._createAndWriteCachedData=function(o,L,w,d){var c=this,_=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),E=-1,N=0,S=void 0,n=function(){setTimeout(function(){S||(S=c._crypto.createHash("md5").update(L,"utf8").digest());var i=o.createCachedData();if(!(i.length===0||i.length===E||N>=5)){if(i.length<E){n();return}E=i.length,c._fs.writeFile(w,Buffer.concat([S,i]),function(r){r&&d.getConfig().onError(r),d.getRecorder().record(63,w),n()})}},_*Math.pow(4,N++))};n()},u.prototype._readSourceAndCachedData=function(o,L,w,d){if(!L)this._fs.readFile(o,{encoding:"utf8"},d);else{var c=void 0,_=void 0,E=void 0,N=2,S=function(n){n?d(n):--N==0&&d(void 0,c,_,E)};this._fs.readFile(o,{encoding:"utf8"},function(n,i){c=i,S(n)}),this._fs.readFile(L,function(n,i){!n&&i&&i.length>0?(E=i.slice(0,16),_=i.slice(16),w.record(60,L)):w.record(61,L),S()})}},u.prototype._verifyCachedData=function(o,L,w,d,c){var _=this;!d||o.cachedDataRejected||setTimeout(function(){var E=_._crypto.createHash("md5").update(L,"utf8").digest();d.equals(E)||(c.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+w+"' now, but a RESTART IS REQUIRED")),_._fs.unlink(w,function(N){N&&c.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function b(u,o){if(o.__$__isRecorded)return o;var L=function(d){u.record(33,d);try{return o(d)}finally{u.record(34,d)}};return L.__$__isRecorded=!0,L}F.ensureRecordedNodeRequire=b;function a(u){return new t(u)}F.createScriptLoader=a})(ee||(ee={}));var ee;(function(F){var t=function(){function a(u){var o=u.lastIndexOf("/");o!==-1?this.fromModulePath=u.substr(0,o+1):this.fromModulePath=""}return a._normalizeModuleId=function(u){var o=u,L;for(L=/\/\.\//;L.test(o);)o=o.replace(L,"/");for(o=o.replace(/^\.\//g,""),L=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;L.test(o);)o=o.replace(L,"/");return o=o.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),o},a.prototype.resolveModule=function(u){var o=u;return F.Utilities.isAbsolutePath(o)||(F.Utilities.startsWith(o,"./")||F.Utilities.startsWith(o,"../"))&&(o=a._normalizeModuleId(this.fromModulePath+o)),o},a.ROOT=new a(""),a}();F.ModuleIdResolver=t;var P=function(){function a(u,o,L,w,d,c){this.id=u,this.strId=o,this.dependencies=L,this._callback=w,this._errorback=d,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return a._safeInvokeFunction=function(u,o){try{return{returnedValue:u.apply(F.global,o),producedError:null}}catch(L){return{returnedValue:null,producedError:L}}},a._invokeFactory=function(u,o,L,w){return u.isBuild()&&!F.Utilities.isAnonymousModule(o)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(L,w):{returnedValue:L.apply(F.global,w),producedError:null}},a.prototype.complete=function(u,o,L){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var d=a._invokeFactory(o,this.strId,this._callback,L);w=d.producedError,u.record(22,this.strId),!w&&typeof d.returnedValue!="undefined"&&(!this.exportsPassedIn||F.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(w){var c=F.ensureError(w);c.phase="factory",c.moduleId=this.strId,this.error=c,o.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},a.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},a.prototype.isComplete=function(){return this._isComplete},a}();F.Module=P;var R=function(){function a(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return a.prototype.getMaxModuleId=function(){return this._nextId},a.prototype.getModuleId=function(u){var o=this._strModuleIdToIntModuleId.get(u);return typeof o=="undefined"&&(o=this._nextId++,this._strModuleIdToIntModuleId.set(u,o),this._intModuleIdToStrModuleId[o]=u),o},a.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},a}(),C=function(){function a(u){this.id=u}return a.EXPORTS=new a(0),a.MODULE=new a(1),a.REQUIRE=new a(2),a}();F.RegularDependency=C;var l=function(){function a(u,o,L){this.id=u,this.pluginId=o,this.pluginParam=L}return a}();F.PluginDependency=l;var b=function(){function a(u,o,L,w,d){d===void 0&&(d=0),this._env=u,this._scriptLoader=o,this._loaderAvailableTimestamp=d,this._defineFunc=L,this._requireFunc=w,this._moduleIdProvider=new R,this._config=new F.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return a.prototype.reset=function(){return new a(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},a.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},a.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},a._findRelevantLocationInStack=function(u,o){for(var L=function(r){return r.replace(/\\/g,"/")},w=L(u),d=o.split(/\n/),c=0;c<d.length;c++){var _=d[c].match(/(.*):(\d+):(\d+)\)?$/);if(_){var E=_[1],N=_[2],S=_[3],n=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr(n),E=L(E),E===w){var i={line:parseInt(N,10),col:parseInt(S,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+u)},a.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],o=0,L=0,w=this._modules2.length;L<w;L++){var d=this._modules2[L];if(!!d){var c=this._buildInfoPath[d.id]||null,_=this._buildInfoDefineStack[d.id]||null,E=this._buildInfoDependencies[d.id];u[o++]={id:d.strId,path:c,defineLocation:c&&_?a._findRelevantLocationInStack(c,_):null,dependencies:E,shim:null,exports:d.exports}}}return u},a.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new F.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=F.NullLoaderEventRecorder.INSTANCE),this._recorder},a.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},a.prototype.enqueueDefineAnonymousModule=function(u,o){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var L=null;this._config.isBuild()&&(L=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:L,dependencies:u,callback:o}},a.prototype.defineModule=function(u,o,L,w,d,c){var _=this;c===void 0&&(c=new t(u));var E=this._moduleIdProvider.getModuleId(u);if(this._modules2[E]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var N=new P(E,u,this._normalizeDependencies(o,c),L,w,c);this._modules2[E]=N,this._config.isBuild()&&(this._buildInfoDefineStack[E]=d,this._buildInfoDependencies[E]=(N.dependencies||[]).map(function(S){return _._moduleIdProvider.getStrModuleId(S.id)})),this._resolve(N)},a.prototype._normalizeDependency=function(u,o){if(u==="exports")return C.EXPORTS;if(u==="module")return C.MODULE;if(u==="require")return C.REQUIRE;var L=u.indexOf("!");if(L>=0){var w=o.resolveModule(u.substr(0,L)),d=o.resolveModule(u.substr(L+1)),c=this._moduleIdProvider.getModuleId(w+"!"+d),_=this._moduleIdProvider.getModuleId(w);return new l(c,_,d)}return new C(this._moduleIdProvider.getModuleId(o.resolveModule(u)))},a.prototype._normalizeDependencies=function(u,o){for(var L=[],w=0,d=0,c=u.length;d<c;d++)L[w++]=this._normalizeDependency(u[d],o);return L},a.prototype._relativeRequire=function(u,o,L,w){if(typeof o=="string")return this.synchronousRequire(o,u);this.defineModule(F.Utilities.generateAnonymousModule(),o,L,w,null,u)},a.prototype.synchronousRequire=function(u,o){o===void 0&&(o=new t(u));var L=this._normalizeDependency(u,o),w=this._modules2[L.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},a.prototype.configure=function(u,o){var L=this._config.shouldRecordStats();o?this._config=new F.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!L&&(this._recorder=null)},a.prototype.getConfig=function(){return this._config},a.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var o=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),o.dependencies,o.callback,null,o.stack)}},a.prototype._createLoadError=function(u,o){var L=this,w=this._moduleIdProvider.getStrModuleId(u),d=(this._inverseDependencies2[u]||[]).map(function(_){return L._moduleIdProvider.getStrModuleId(_)}),c=F.ensureError(o);return c.phase="loading",c.moduleId=w,c.neededBy=d,c},a.prototype._onLoadError=function(u,o){var L=this._createLoadError(u,o);this._modules2[u]||(this._modules2[u]=new P(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},function(){},null));for(var w=[],d=0,c=this._moduleIdProvider.getMaxModuleId();d<c;d++)w[d]=!1;var _=!1,E=[];for(E.push(u),w[u]=!0;E.length>0;){var N=E.shift(),S=this._modules2[N];S&&(_=S.onDependencyError(L)||_);var n=this._inverseDependencies2[N];if(n)for(var d=0,c=n.length;d<c;d++){var i=n[d];w[i]||(E.push(i),w[i]=!0)}}_||this._config.onError(L)},a.prototype._hasDependencyPath=function(u,o){var L=this._modules2[u];if(!L)return!1;for(var w=[],d=0,c=this._moduleIdProvider.getMaxModuleId();d<c;d++)w[d]=!1;var _=[];for(_.push(L),w[u]=!0;_.length>0;){var E=_.shift(),N=E.dependencies;if(N)for(var d=0,c=N.length;d<c;d++){var S=N[d];if(S.id===o)return!0;var n=this._modules2[S.id];n&&!w[S.id]&&(w[S.id]=!0,_.push(n))}}return!1},a.prototype._findCyclePath=function(u,o,L){if(u===o||L===50)return[u];var w=this._modules2[u];if(!w)return null;var d=w.dependencies;if(d)for(var c=0,_=d.length;c<_;c++){var E=this._findCyclePath(d[c].id,o,L+1);if(E!==null)return E.push(u),E}return null},a.prototype._createRequire=function(u){var o=this,L=function(w,d,c){return o._relativeRequire(u,w,d,c)};return L.toUrl=function(w){return o._config.requireToUrl(u.resolveModule(w))},L.getStats=function(){return o.getLoaderEvents()},L.hasDependencyCycle=function(){return o._hasDependencyCycle},L.config=function(w,d){d===void 0&&(d=!1),o.configure(w,d)},L.__$__nodeRequire=F.global.nodeRequire,L},a.prototype._loadModule=function(u){var o=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var L=this._moduleIdProvider.getStrModuleId(u),w=this._config.moduleIdToPaths(L),d=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(L.indexOf("/")===-1||d.test(L))&&w.push("node|"+L);var c=-1,_=function(E){if(c++,c>=w.length)o._onLoadError(u,E);else{var N=w[c],S=o.getRecorder();if(o._config.isBuild()&&N==="empty:"){o._buildInfoPath[u]=N,o.defineModule(o._moduleIdProvider.getStrModuleId(u),[],null,null,null),o._onLoad(u);return}S.record(10,N),o._scriptLoader.load(o,N,function(){o._config.isBuild()&&(o._buildInfoPath[u]=N),S.record(11,N),o._onLoad(u)},function(n){S.record(12,N),_(n)})}};_(null)}},a.prototype._loadPluginDependency=function(u,o){var L=this;if(!(this._modules2[o.id]||this._knownModules2[o.id])){this._knownModules2[o.id]=!0;var w=function(d){L.defineModule(L._moduleIdProvider.getStrModuleId(o.id),[],d,null,null)};w.error=function(d){L._config.onError(L._createLoadError(o.id,d))},u.load(o.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}},a.prototype._resolve=function(u){var o=this,L=u.dependencies;if(L)for(var w=0,d=L.length;w<d;w++){var c=L[w];if(c===C.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(c===C.MODULE){u.unresolvedDependenciesCount--;continue}if(c===C.REQUIRE){u.unresolvedDependenciesCount--;continue}var _=this._modules2[c.id];if(_&&_.isComplete()){if(_.error){u.onDependencyError(_.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var E=this._findCyclePath(c.id,u.id,0)||[];E.reverse(),E.push(c.id),console.warn(E.map(function(n){return o._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(u.id),c instanceof l){var N=this._modules2[c.pluginId];if(N&&N.isComplete()){this._loadPluginDependency(N.exports,c);continue}var S=this._inversePluginDependencies2.get(c.pluginId);S||(S=[],this._inversePluginDependencies2.set(c.pluginId,S)),S.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},a.prototype._onModuleComplete=function(u){var o=this,L=this.getRecorder();if(!u.isComplete()){var w=u.dependencies,d=[];if(w)for(var c=0,_=w.length;c<_;c++){var E=w[c];if(E===C.EXPORTS){d[c]=u.exports;continue}if(E===C.MODULE){d[c]={id:u.strId,config:function(){return o._config.getConfigForModule(u.strId)}};continue}if(E===C.REQUIRE){d[c]=this._createRequire(u.moduleIdResolver);continue}var N=this._modules2[E.id];if(N){d[c]=N.exports;continue}d[c]=null}u.complete(L,this._config,d);var S=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,S)for(var c=0,_=S.length;c<_;c++){var n=S[c],i=this._modules2[n];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(u.id);if(r){this._inversePluginDependencies2.delete(u.id);for(var c=0,_=r.length;c<_;c++)this._loadPluginDependency(u.exports,r[c])}}},a}();F.ModuleManager=b})(ee||(ee={}));var $,ee;(function(F){var t=new F.Environment,P=null,R=function(a,u,o){typeof a!="string"&&(o=u,u=a,a=null),(typeof u!="object"||!Array.isArray(u))&&(o=u,u=null),u||(u=["require","exports","module"]),a?P.defineModule(a,u,o,null,null):P.enqueueDefineAnonymousModule(u,o)};R.amd={jQuery:!0};var C=function(a,u){u===void 0&&(u=!1),P.configure(a,u)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){C(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(F.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=C,l.getConfig=function(){return P.getConfig().getOptionsLiteral()},l.reset=function(){P=P.reset()},l.getBuildInfo=function(){return P.getBuildInfo()},l.getStats=function(){return P.getLoaderEvents()},l.define=function(){return R.apply(null,arguments)};function b(){if(typeof F.global.require!="undefined"||typeof require!="undefined"){var a=F.global.require||require;if(typeof a=="function"&&typeof a.resolve=="function"){var u=F.ensureRecordedNodeRequire(P.getRecorder(),a);F.global.nodeRequire=u,l.nodeRequire=u,l.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer?(module.exports=l,require=l):(t.isElectronRenderer||(F.global.define=R),F.global.require=l)}F.init=b,(typeof F.global.define!="function"||!F.global.define.amd)&&(P=new F.ModuleManager(t,F.createScriptLoader(t),R,l,F.Utilities.getHighPerformanceTimestamp()),typeof F.global.require!="undefined"&&typeof F.global.require!="function"&&l.config(F.global.require),$=function(){return R.apply(null,arguments)},$.amd=R.amd,typeof doNotInitLoader=="undefined"&&b())})(ee||(ee={}));var be=this,ge;(function(F){var t=be||{},P=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,R=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function C(o,L){var w;return L.length===0?w=o:w=o.replace(/\{(\d+)\}/g,function(d,c){var _=c[0];return typeof L[_]!="undefined"?L[_]:d}),R&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function l(o,L){var w=o[L];return w||(w=o["*"],w)?w:null}function b(o,L){for(var w=[],d=0;d<arguments.length-2;d++)w[d]=arguments[d+2];return C(L,w)}function a(o){return function(L,w){var d=Array.prototype.slice.call(arguments,2);return C(o[L],d)}}var u=function(){function o(){this.localize=b}return o.prototype.setPseudoTranslation=function(L){R=L},o.prototype.create=function(L,w){return{localize:a(w[L])}},o.prototype.load=function(L,w,d,c){if(c=c||{},!L||L.length===0)d({localize:b});else{var _=void 0;if(P&&P.getString)_=".nls.keys",w([L+_],function(S){d({localize:function(n,i){if(!S[n])return"NLS error: unknown key "+n;var r=S[n].keys;if(i>=r.length)return"NLS error unknown index "+i;var s=r[i],h=[];h[0]=n+"_"+s;for(var v=0;v<arguments.length-2;v++)h[v+1]=arguments[v+2];return P.getString.apply(P,h)}})});else if(c.isBuild)w([L+".nls",L+".nls.keys"],function(S,n){o.BUILD_MAP[L]=S,o.BUILD_MAP_KEYS[L]=n,d(S)});else{var E=c["vs/nls"]||{},N=E.availableLanguages?l(E.availableLanguages,L):null;_=".nls",N!==null&&N!==o.DEFAULT_TAG&&(_=_+"."+N),w([L+_],function(S){Array.isArray(S)?S.localize=a(S):S.localize=a(S[L]),d(S)})}}},o.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},o.prototype.write=function(L,w,d){var c=d.getEntryPoint(),_=this._getEntryPointsMap();_[c]=_[c]||[],_[c].push(w),w!==c&&d.asModule(L+"!"+w,"define(['vs/nls', 'vs/nls!"+c+`'], function(nls, data) { return nls.create("`+w+'", data); });')},o.prototype.writeFile=function(L,w,d,c,_){var E=this._getEntryPointsMap();if(E.hasOwnProperty(w)){for(var N=d.toUrl(w+".nls.js"),S=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=E[w],i={},r=0;r<n.length;r++)i[n[r]]=o.BUILD_MAP[n[r]];S.push('define("'+w+'.nls", '+JSON.stringify(i,null,"	")+");"),c(N,S.join(`\r
`))}},o.prototype.finishBuild=function(L){L("nls.metadata.json",JSON.stringify({keys:o.BUILD_MAP_KEYS,messages:o.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},o.DEFAULT_TAG="i-default",o.BUILD_MAP={},o.BUILD_MAP_KEYS={},o}();F.NLSPlugin=u,function(){$("vs/nls",new u)}()})(ge||(ge={})),$(z[15],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(C,l,b,a){this.originalStart=C,this.originalLength=l,this.modifiedStart=b,this.modifiedLength=a}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),$(z[4],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.listeners.push(h),()=>{this._removeListener(h)}}emit(h){this.listeners.forEach(v=>{v(h)})}_removeListener(h){this.listeners.splice(this.listeners.indexOf(h),1)}setUnexpectedErrorHandler(h){this.unexpectedErrorHandler=h}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}t.ErrorHandler=P,t.errorHandler=new P;function R(s){t.errorHandler.setUnexpectedErrorHandler(s)}t.setUnexpectedErrorHandler=R;function C(s){u(s)||t.errorHandler.onUnexpectedError(s)}t.onUnexpectedError=C;function l(s){u(s)||t.errorHandler.onUnexpectedExternalError(s)}t.onUnexpectedExternalError=l;function b(s){if(s instanceof Error){let{name:h,message:v}=s;const f=s.stacktrace||s.stack;return{$isError:!0,name:h,message:v,stack:f}}return s}t.transformErrorForSerialization=b;const a="Canceled";function u(s){return s instanceof Error&&s.name===a&&s.message===a}t.isPromiseCanceledError=u;class o extends Error{constructor(){super(a);this.name=this.message}}t.CancellationError=o;function L(){const s=new Error(a);return s.name=s.message,s}t.canceled=L;function w(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}t.illegalArgument=w;function d(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}t.illegalState=d;function c(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=c;function _(s){const h=new Error(`${s} has been disposed`);return h.name="DISPOSED",h}t.disposed=_;function E(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}t.getErrorMessage=E;class N extends Error{constructor(h){super("NotImplemented");h&&(this.message=h)}}t.NotImplementedError=N;class S extends Error{constructor(h){super("NotSupported");h&&(this.message=h)}}t.NotSupportedError=S;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(s){const h=s;return h instanceof Error&&Array.isArray(h.actions)}t.isErrorWithActions=i;function r(s,h=Object.create(null)){const v=new Error(s);return h.actions&&(v.actions=h.actions),v}t.createErrorWithActions=r}),$(z[7],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function P(R){const C=this;let l=!1,b;return function(){return l||(l=!0,b=R.apply(C,arguments)),b}}t.once=P}),$(z[16],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(R){function C(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=C;const l=Object.freeze([]);function b(){return l}R.empty=b;function*a(s){yield s}R.single=a;function u(s){return s||l}R.from=u;function o(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=o;function L(s){return s[Symbol.iterator]().next().value}R.first=L;function w(s,h){for(const v of s)if(h(v))return!0;return!1}R.some=w;function d(s,h){for(const v of s)if(h(v))return v}R.find=d;function*c(s,h){for(const v of s)h(v)&&(yield v)}R.filter=c;function*_(s,h){let v=0;for(const f of s)yield h(f,v++)}R.map=_;function*E(...s){for(const h of s)for(const v of h)yield v}R.concat=E;function*N(s){for(const h of s)for(const v of h)yield v}R.concatNested=N;function S(s,h,v){let f=v;for(const g of s)f=h(f,g);return f}R.reduce=S;function*n(s,h,v=s.length){for(h<0&&(h+=s.length),v<0?v+=s.length:v>s.length&&(v=s.length);h<v;h++)yield s[h]}R.slice=n;function i(s,h=Number.POSITIVE_INFINITY){const v=[];if(h===0)return[v,s];const f=s[Symbol.iterator]();for(let g=0;g<h;g++){const m=f.next();if(m.done)return[v,R.empty()];v.push(m.value)}return[v,{[Symbol.iterator](){return f}}]}R.consume=i;function r(s,h,v=(f,g)=>f===g){const f=s[Symbol.iterator](),g=h[Symbol.iterator]();for(;;){const m=f.next(),M=g.next();if(m.done!==M.done)return!1;if(m.done)return!0;if(!v(m.value,M.value))return!1}}R.equals=r})(P=t.Iterable||(t.Iterable={}))}),$(z[17],G([0,1,4]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var R;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(R=t.KeyCode||(t.KeyCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const l=new C,b=new C,a=new C;(function(){function n(i,r,s=r,h=s){l.define(i,r),b.define(i,s),a.define(i,h)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var u;(function(n){function i(f){return l.keyCodeToStr(f)}n.toString=i;function r(f){return l.strToKeyCode(f)}n.fromString=r;function s(f){return b.keyCodeToStr(f)}n.toUserSettingsUS=s;function h(f){return a.keyCodeToStr(f)}n.toUserSettingsGeneral=h;function v(f){return b.strToKeyCode(f)||a.strToKeyCode(f)}n.fromUserSettings=v})(u=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(o||(o={}));var L;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(L=t.KeyMod||(t.KeyMod={}));function w(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=w;function d(n,i){if(n===0)return null;const r=(n&65535)>>>0,s=(n&4294901760)>>>16;return s!==0?new E([c(r,i),c(s,i)]):new E([c(r,i)])}t.createKeybinding=d;function c(n,i){const r=!!(n&2048),s=!!(n&256),h=i===2?s:r,v=!!(n&1024),f=!!(n&512),g=i===2?r:s,m=n&255;return new _(h,v,f,g,m)}t.createSimpleKeybinding=c;class _{constructor(i,r,s,h,v){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=h,this.keyCode=v}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",s=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${i}${r}${s}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new E([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=_;class E{constructor(i){if(i.length===0)throw(0,P.illegalArgument)("parts");this.parts=i}getHashCode(){let i="";for(let r=0,s=this.parts.length;r<s;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=E;class N{constructor(i,r,s,h,v,f){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=h,this.keyLabel=v,this.keyAriaLabel=f}}t.ResolvedKeybindingPart=N;class S{}t.ResolvedKeybinding=S}),$(z[8],G([0,1,7,16]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const C=!1;let l=null;function b(g){l=g}if(t.setDisposableTracker=b,C){const g="__is_disposable_tracked__";b(new class{trackDisposable(m){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[g]||console.log(M)},3e3)}setParent(m,M){if(m&&m!==n.None)try{m[g]=!0}catch{}}markAsDisposed(m){if(m&&m!==n.None)try{m[g]=!0}catch{}}markAsSingleton(m){}})}function a(g){return l?.trackDisposable(g),g}function u(g){l?.markAsDisposed(g)}function o(g,m){l?.setParent(g,m)}function L(g,m){if(!!l)for(const M of g)l.setParent(M,m)}function w(g){return l?.markAsSingleton(g),g}t.markAsSingleton=w;class d extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}t.MultiDisposeError=d;function c(g){return typeof g.dispose=="function"&&g.dispose.length===0}t.isDisposable=c;function _(g){if(R.Iterable.is(g)){let m=[];for(const M of g)if(M)try{M.dispose()}catch(D){m.push(D)}if(m.length===1)throw m[0];if(m.length>1)throw new d(m);return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}t.dispose=_;function E(...g){const m=N(()=>_(g));return L(g,m),m}t.combinedDisposable=E;function N(g){const m=a({dispose:(0,P.once)(()=>{u(m),g()})});return m}t.toDisposable=N;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,a(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{_(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return o(m,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}t.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this._store=new S,a(this),o(this._store,this)}dispose(){u(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}t.Disposable=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&o(m,this),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const m=this._value;return this._value=void 0,m&&o(m,null),m}}t.MutableDisposable=i;class r{constructor(m){this._disposable=m,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=r;class s{constructor(){this.references=new Map}acquire(m,...M){let D=this.references.get(m);D||(D={counter:0,object:this.createReferencedObject(m,...M)},this.references.set(m,D));const{object:p}=D,U=(0,P.once)(()=>{--D.counter==0&&(this.destroyReferencedObject(m,D.object),this.references.delete(m))});return D.counter++,{object:p,dispose:U}}}t.ReferenceCollection=s;class h{constructor(m){this.referenceCollection=m}async acquire(m,...M){const D=this.referenceCollection.acquire(m,...M);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(p){throw D.dispose(),p}}}t.AsyncReferenceCollection=h;class v{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=v;function f(g){const m=new S;try{g(m)}finally{m.dispose()}}t.disposeOnReturn=f}),$(z[18],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{constructor(l){this.element=l,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class R{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let l=this._first;for(;l!==P.Undefined;){const b=l.next;l.prev=P.Undefined,l.next=P.Undefined,l=b}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,b){const a=new P(l);if(this._first===P.Undefined)this._first=a,this._last=a;else if(b){const o=this._last;this._last=a,a.prev=o,o.next=a}else{const o=this._first;this._first=a,a.next=o,o.prev=a}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(a))}}shift(){if(this._first!==P.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==P.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==P.Undefined&&l.next!==P.Undefined){const b=l.prev;b.next=l.next,l.next.prev=b}else l.prev===P.Undefined&&l.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):l.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):l.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==P.Undefined;)yield l.element,l=l.next}}t.LinkedList=R}),$(z[2],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isElectronSandboxed=t.globals=void 0;const P="en";let R=!1,C=!1,l=!1,b=!1,a=!1,u=!1,o=!1,L,w=P,d,c;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?_=t.globals.vscode.process:typeof process!="undefined"&&(_=process);const E=typeof _?.versions?.electron=="string"&&_.type==="renderer";if(t.isElectronSandboxed=E&&_?.sandboxed,typeof navigator=="object"&&!E)c=navigator.userAgent,R=c.indexOf("Windows")>=0,C=c.indexOf("Macintosh")>=0,o=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=c.indexOf("Linux")>=0,u=!0,L=navigator.language,w=L;else if(typeof _=="object"){R=_.platform==="win32",C=_.platform==="darwin",l=_.platform==="linux",b=l&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,L=P,w=P;const f=_.env.VSCODE_NLS_CONFIG;if(f)try{const g=JSON.parse(f),m=g.availableLanguages["*"];L=g.locale,w=m||P,d=g._translationsConfigFile}catch(g){}a=!0}else console.error("Unable to resolve platform.");var N;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(N=t.Platform||(t.Platform={}));function S(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=S;let n=0;C?n=1:R?n=3:l&&(n=2),t.isWindows=R,t.isMacintosh=C,t.isLinux=l,t.isLinuxSnap=b,t.isNative=a,t.isWeb=u,t.isIOS=o,t.platform=n,t.userAgent=c,t.language=w;var i;(function(f){function g(){return t.language}f.value=g;function m(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}f.isDefaultVariant=m;function M(){return t.language==="en"}f.isDefault=M})(i=t.Language||(t.Language={})),t.locale=L,t.translationsConfigFile=d,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let m=[];t.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let p=0,U=m.length;p<U;p++){const k=m[p];if(k.id===D.data.vscodeSetImmediateId){m.splice(p,1),k.callback();return}}});let M=0;return D=>{const p=++M;m.push({id:p,callback:D}),t.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof _?.nextTick=="function")return _.nextTick.bind(_);const g=Promise.resolve();return m=>g.then(m)}();var r;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(r=t.OperatingSystem||(t.OperatingSystem={})),t.OS=C||o?2:R?1:3;let s=!0,h=!1;function v(){if(!h){h=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,s=new Uint16Array(f.buffer)[0]===(2<<8)+1}return s}t.isLittleEndian=v}),$(z[19],G([0,1,2]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.nextTick=t.platform=t.env=t.cwd=void 0;let R;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.process!="undefined"){const C=P.globals.vscode.process;R={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(l){return(0,P.setImmediate)(l)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,P.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};t.cwd=R.cwd,t.env=R.env,t.platform=R.platform,t.nextTick=R.nextTick,t.arch=R.arch}),$(z[20],G([0,1,19]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const R=65,C=97,l=90,b=122,a=46,u=47,o=92,L=58,w=63;class d extends Error{constructor(r,s,h){let v;typeof s=="string"&&s.indexOf("not ")===0?(v="must not be",s=s.replace(/^not /,"")):v="must be";const f=r.indexOf(".")!==-1?"property":"argument";let g=`The "${r}" ${f} ${v} of type ${s}`;g+=`. Received type ${typeof h}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,r){if(typeof i!="string")throw new d(r,"string",i)}function _(i){return i===u||i===o}function E(i){return i===u}function N(i){return i>=R&&i<=l||i>=C&&i<=b}function S(i,r,s,h){let v="",f=0,g=-1,m=0,M=0;for(let D=0;D<=i.length;++D){if(D<i.length)M=i.charCodeAt(D);else{if(h(M))break;M=u}if(h(M)){if(!(g===D-1||m===1))if(m===2){if(v.length<2||f!==2||v.charCodeAt(v.length-1)!==a||v.charCodeAt(v.length-2)!==a){if(v.length>2){const p=v.lastIndexOf(s);p===-1?(v="",f=0):(v=v.slice(0,p),f=v.length-1-v.lastIndexOf(s)),g=D,m=0;continue}else if(v.length!==0){v="",f=0,g=D,m=0;continue}}r&&(v+=v.length>0?`${s}..`:"..",f=2)}else v.length>0?v+=`${s}${i.slice(g+1,D)}`:v=i.slice(g+1,D),f=D-g-1;g=D,m=0}else M===a&&m!==-1?++m:m=-1}return v}function n(i,r){if(r===null||typeof r!="object")throw new d("pathObject","Object",r);const s=r.dir||r.root,h=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${h}`:`${s}${i}${h}`:h}t.win32={resolve(...i){let r="",s="",h=!1;for(let v=i.length-1;v>=-1;v--){let f;if(v>=0){if(f=i[v],c(f,"path"),f.length===0)continue}else r.length===0?f=P.cwd():(f=P.env[`=${r}`]||P.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==r.toLowerCase()&&f.charCodeAt(2)===o)&&(f=`${r}\\`));const g=f.length;let m=0,M="",D=!1;const p=f.charCodeAt(0);if(g===1)_(p)&&(m=1,D=!0);else if(_(p))if(D=!0,_(f.charCodeAt(1))){let U=2,k=U;for(;U<g&&!_(f.charCodeAt(U));)U++;if(U<g&&U!==k){const W=f.slice(k,U);for(k=U;U<g&&_(f.charCodeAt(U));)U++;if(U<g&&U!==k){for(k=U;U<g&&!_(f.charCodeAt(U));)U++;(U===g||U!==k)&&(M=`\\\\${W}\\${f.slice(k,U)}`,m=U)}}}else m=1;else N(p)&&f.charCodeAt(1)===L&&(M=f.slice(0,2),m=2,g>2&&_(f.charCodeAt(2))&&(D=!0,m=3));if(M.length>0)if(r.length>0){if(M.toLowerCase()!==r.toLowerCase())continue}else r=M;if(h){if(r.length>0)break}else if(s=`${f.slice(m)}\\${s}`,h=D,D&&r.length>0)break}return s=S(s,!h,"\\",_),h?`${r}\\${s}`:`${r}${s}`||"."},normalize(i){c(i,"path");const r=i.length;if(r===0)return".";let s=0,h,v=!1;const f=i.charCodeAt(0);if(r===1)return E(f)?"\\":i;if(_(f))if(v=!0,_(i.charCodeAt(1))){let m=2,M=m;for(;m<r&&!_(i.charCodeAt(m));)m++;if(m<r&&m!==M){const D=i.slice(M,m);for(M=m;m<r&&_(i.charCodeAt(m));)m++;if(m<r&&m!==M){for(M=m;m<r&&!_(i.charCodeAt(m));)m++;if(m===r)return`\\\\${D}\\${i.slice(M)}\\`;m!==M&&(h=`\\\\${D}\\${i.slice(M,m)}`,s=m)}}}else s=1;else N(f)&&i.charCodeAt(1)===L&&(h=i.slice(0,2),s=2,r>2&&_(i.charCodeAt(2))&&(v=!0,s=3));let g=s<r?S(i.slice(s),!v,"\\",_):"";return g.length===0&&!v&&(g="."),g.length>0&&_(i.charCodeAt(r-1))&&(g+="\\"),h===void 0?v?`\\${g}`:g:v?`${h}\\${g}`:`${h}${g}`},isAbsolute(i){c(i,"path");const r=i.length;if(r===0)return!1;const s=i.charCodeAt(0);return _(s)||r>2&&N(s)&&i.charCodeAt(1)===L&&_(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,s;for(let f=0;f<i.length;++f){const g=i[f];c(g,"path"),g.length>0&&(r===void 0?r=s=g:r+=`\\${g}`)}if(r===void 0)return".";let h=!0,v=0;if(typeof s=="string"&&_(s.charCodeAt(0))){++v;const f=s.length;f>1&&_(s.charCodeAt(1))&&(++v,f>2&&(_(s.charCodeAt(2))?++v:h=!1))}if(h){for(;v<r.length&&_(r.charCodeAt(v));)v++;v>=2&&(r=`\\${r.slice(v)}`)}return t.win32.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r)return"";const s=t.win32.resolve(i),h=t.win32.resolve(r);if(s===h||(i=s.toLowerCase(),r=h.toLowerCase(),i===r))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===o;)v++;let f=i.length;for(;f-1>v&&i.charCodeAt(f-1)===o;)f--;const g=f-v;let m=0;for(;m<r.length&&r.charCodeAt(m)===o;)m++;let M=r.length;for(;M-1>m&&r.charCodeAt(M-1)===o;)M--;const D=M-m,p=g<D?g:D;let U=-1,k=0;for(;k<p;k++){const H=i.charCodeAt(v+k);if(H!==r.charCodeAt(m+k))break;H===o&&(U=k)}if(k!==p){if(U===-1)return h}else{if(D>p){if(r.charCodeAt(m+k)===o)return h.slice(m+k+1);if(k===2)return h.slice(m+k)}g>p&&(i.charCodeAt(v+k)===o?U=k:k===2&&(U=3)),U===-1&&(U=0)}let W="";for(k=v+U+1;k<=f;++k)(k===f||i.charCodeAt(k)===o)&&(W+=W.length===0?"..":"\\..");return m+=U,W.length>0?`${W}${h.slice(m,M)}`:(h.charCodeAt(m)===o&&++m,h.slice(m,M))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===o){if(r.charCodeAt(1)===o){const s=r.charCodeAt(2);if(s!==w&&s!==a)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(N(r.charCodeAt(0))&&r.charCodeAt(1)===L&&r.charCodeAt(2)===o)return`\\\\?\\${r}`;return i},dirname(i){c(i,"path");const r=i.length;if(r===0)return".";let s=-1,h=0;const v=i.charCodeAt(0);if(r===1)return _(v)?i:".";if(_(v)){if(s=h=1,_(i.charCodeAt(1))){let m=2,M=m;for(;m<r&&!_(i.charCodeAt(m));)m++;if(m<r&&m!==M){for(M=m;m<r&&_(i.charCodeAt(m));)m++;if(m<r&&m!==M){for(M=m;m<r&&!_(i.charCodeAt(m));)m++;if(m===r)return i;m!==M&&(s=h=m+1)}}}}else N(v)&&i.charCodeAt(1)===L&&(s=r>2&&_(i.charCodeAt(2))?3:2,h=s);let f=-1,g=!0;for(let m=r-1;m>=h;--m)if(_(i.charCodeAt(m))){if(!g){f=m;break}}else g=!1;if(f===-1){if(s===-1)return".";f=s}return i.slice(0,f)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let s=0,h=-1,v=!0,f;if(i.length>=2&&N(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(s=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let g=r.length-1,m=-1;for(f=i.length-1;f>=s;--f){const M=i.charCodeAt(f);if(_(M)){if(!v){s=f+1;break}}else m===-1&&(v=!1,m=f+1),g>=0&&(M===r.charCodeAt(g)?--g==-1&&(h=f):(g=-1,h=m))}return s===h?h=m:h===-1&&(h=i.length),i.slice(s,h)}for(f=i.length-1;f>=s;--f)if(_(i.charCodeAt(f))){if(!v){s=f+1;break}}else h===-1&&(v=!1,h=f+1);return h===-1?"":i.slice(s,h)},extname(i){c(i,"path");let r=0,s=-1,h=0,v=-1,f=!0,g=0;i.length>=2&&i.charCodeAt(1)===L&&N(i.charCodeAt(0))&&(r=h=2);for(let m=i.length-1;m>=r;--m){const M=i.charCodeAt(m);if(_(M)){if(!f){h=m+1;break}continue}v===-1&&(f=!1,v=m+1),M===a?s===-1?s=m:g!==1&&(g=1):s!==-1&&(g=-1)}return s===-1||v===-1||g===0||g===1&&s===v-1&&s===h+1?"":i.slice(s,v)},format:n.bind(null,"\\"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.length;let h=0,v=i.charCodeAt(0);if(s===1)return _(v)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(_(v)){if(h=1,_(i.charCodeAt(1))){let U=2,k=U;for(;U<s&&!_(i.charCodeAt(U));)U++;if(U<s&&U!==k){for(k=U;U<s&&_(i.charCodeAt(U));)U++;if(U<s&&U!==k){for(k=U;U<s&&!_(i.charCodeAt(U));)U++;U===s?h=U:U!==k&&(h=U+1)}}}}else if(N(v)&&i.charCodeAt(1)===L){if(s<=2)return r.root=r.dir=i,r;if(h=2,_(i.charCodeAt(2))){if(s===3)return r.root=r.dir=i,r;h=3}}h>0&&(r.root=i.slice(0,h));let f=-1,g=h,m=-1,M=!0,D=i.length-1,p=0;for(;D>=h;--D){if(v=i.charCodeAt(D),_(v)){if(!M){g=D+1;break}continue}m===-1&&(M=!1,m=D+1),v===a?f===-1?f=D:p!==1&&(p=1):f!==-1&&(p=-1)}return m!==-1&&(f===-1||p===0||p===1&&f===m-1&&f===g+1?r.base=r.name=i.slice(g,m):(r.name=i.slice(g,f),r.base=i.slice(g,m),r.ext=i.slice(f,m))),g>0&&g!==h?r.dir=i.slice(0,g-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",s=!1;for(let h=i.length-1;h>=-1&&!s;h--){const v=h>=0?i[h]:P.cwd();c(v,"path"),v.length!==0&&(r=`${v}/${r}`,s=v.charCodeAt(0)===u)}return r=S(r,!s,"/",E),s?`/${r}`:r.length>0?r:"."},normalize(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u,s=i.charCodeAt(i.length-1)===u;return i=S(i,!r,"/",E),i.length===0?r?"/":s?"./":".":(s&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return c(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let r;for(let s=0;s<i.length;++s){const h=i[s];c(h,"path"),h.length>0&&(r===void 0?r=h:r+=`/${h}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const s=1,h=i.length,v=h-s,f=1,g=r.length-f,m=v<g?v:g;let M=-1,D=0;for(;D<m;D++){const U=i.charCodeAt(s+D);if(U!==r.charCodeAt(f+D))break;U===u&&(M=D)}if(D===m)if(g>m){if(r.charCodeAt(f+D)===u)return r.slice(f+D+1);if(D===0)return r.slice(f+D)}else v>m&&(i.charCodeAt(s+D)===u?M=D:D===0&&(M=0));let p="";for(D=s+M+1;D<=h;++D)(D===h||i.charCodeAt(D)===u)&&(p+=p.length===0?"..":"/..");return`${p}${r.slice(f+M)}`},toNamespacedPath(i){return i},dirname(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u;let s=-1,h=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===u){if(!h){s=v;break}}else h=!1;return s===-1?r?"/":".":r&&s===1?"//":i.slice(0,s)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let s=0,h=-1,v=!0,f;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let g=r.length-1,m=-1;for(f=i.length-1;f>=0;--f){const M=i.charCodeAt(f);if(M===u){if(!v){s=f+1;break}}else m===-1&&(v=!1,m=f+1),g>=0&&(M===r.charCodeAt(g)?--g==-1&&(h=f):(g=-1,h=m))}return s===h?h=m:h===-1&&(h=i.length),i.slice(s,h)}for(f=i.length-1;f>=0;--f)if(i.charCodeAt(f)===u){if(!v){s=f+1;break}}else h===-1&&(v=!1,h=f+1);return h===-1?"":i.slice(s,h)},extname(i){c(i,"path");let r=-1,s=0,h=-1,v=!0,f=0;for(let g=i.length-1;g>=0;--g){const m=i.charCodeAt(g);if(m===u){if(!v){s=g+1;break}continue}h===-1&&(v=!1,h=g+1),m===a?r===-1?r=g:f!==1&&(f=1):r!==-1&&(f=-1)}return r===-1||h===-1||f===0||f===1&&r===h-1&&r===s+1?"":i.slice(r,h)},format:n.bind(null,"/"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.charCodeAt(0)===u;let h;s?(r.root="/",h=1):h=0;let v=-1,f=0,g=-1,m=!0,M=i.length-1,D=0;for(;M>=h;--M){const p=i.charCodeAt(M);if(p===u){if(!m){f=M+1;break}continue}g===-1&&(m=!1,g=M+1),p===a?v===-1?v=M:D!==1&&(D=1):v!==-1&&(D=-1)}if(g!==-1){const p=f===0&&s?1:f;v===-1||D===0||D===1&&v===g-1&&v===f+1?r.base=r.name=i.slice(p,g):(r.name=i.slice(p,v),r.base=i.slice(p,g),r.ext=i.slice(v,g))}return f>0?r.dir=i.slice(0,f-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=P.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=P.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=P.platform==="win32"?t.win32.join:t.posix.join,t.resolve=P.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=P.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=P.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=P.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=P.platform==="win32"?t.win32.extname:t.posix.extname,t.format=P.platform==="win32"?t.win32.format:t.posix.format,t.parse=P.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=P.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=P.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=P.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),$(z[9],G([0,1,2]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const R=P.globals.performance&&typeof P.globals.performance.now=="function";class C{constructor(b){this._highResolution=R&&b,this._startTime=this._now(),this._stopTime=-1}static create(b=!0){return new C(b)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}t.StopWatch=C}),$(z[10],G([0,1,4,7,8,18,9]),function(F,t,P,R,C,l,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var a;(function(r){r.None=()=>C.Disposable.None;function s(q){return(y,Y=null,j)=>{let Q=!1,Z;return Z=q(K=>{if(!Q)return Z?Z.dispose():Q=!0,y.call(Y,K)},null,j),Q&&Z.dispose(),Z}}r.once=s;function h(q,y){return D((Y,j=null,Q)=>q(Z=>Y.call(j,y(Z)),null,Q))}r.map=h;function v(q,y){return D((Y,j=null,Q)=>q(Z=>{y(Z),Y.call(j,Z)},null,Q))}r.forEach=v;function f(q,y){return D((Y,j=null,Q)=>q(Z=>y(Z)&&Y.call(j,Z),null,Q))}r.filter=f;function g(q){return q}r.signal=g;function m(...q){return(y,Y=null,j)=>(0,C.combinedDisposable)(...q.map(Q=>Q(Z=>y.call(Y,Z),null,j)))}r.any=m;function M(q,y,Y){let j=Y;return h(q,Q=>(j=y(j,Q),j))}r.reduce=M;function D(q){let y;const Y=new d({onFirstListenerAdd(){y=q(Y.fire,Y)},onLastListenerRemove(){y.dispose()}});return Y.event}function p(q,y,Y=100,j=!1,Q){let Z,K,ne,ae=0;const oe=new d({leakWarningThreshold:Q,onFirstListenerAdd(){Z=q(he=>{ae++,K=y(K,he),j&&!ne&&(oe.fire(K),K=void 0),clearTimeout(ne),ne=setTimeout(()=>{const de=K;K=void 0,ne=void 0,(!j||ae>1)&&oe.fire(de),ae=0},Y)})},onLastListenerRemove(){Z.dispose()}});return oe.event}r.debounce=p;function U(q,y=(Y,j)=>Y===j){let Y=!0,j;return f(q,Q=>{const Z=Y||!y(Q,j);return Y=!1,j=Q,Z})}r.latch=U;function k(q,y){return[r.filter(q,y),r.filter(q,Y=>!y(Y))]}r.split=k;function W(q,y=!1,Y=[]){let j=Y.slice(),Q=q(ne=>{j?j.push(ne):K.fire(ne)});const Z=()=>{j&&j.forEach(ne=>K.fire(ne)),j=null},K=new d({onFirstListenerAdd(){Q||(Q=q(ne=>K.fire(ne)))},onFirstListenerDidAdd(){j&&(y?setTimeout(Z):Z())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return K.event}r.buffer=W;class H{constructor(y){this.event=y}map(y){return new H(h(this.event,y))}forEach(y){return new H(v(this.event,y))}filter(y){return new H(f(this.event,y))}reduce(y,Y){return new H(M(this.event,y,Y))}latch(){return new H(U(this.event))}debounce(y,Y=100,j=!1,Q){return new H(p(this.event,y,Y,j,Q))}on(y,Y,j){return this.event(y,Y,j)}once(y,Y,j){return s(this.event)(y,Y,j)}}function J(q){return new H(q)}r.chain=J;function V(q,y,Y=j=>j){const j=(...ne)=>K.fire(Y(...ne)),Q=()=>q.on(y,j),Z=()=>q.removeListener(y,j),K=new d({onFirstListenerAdd:Q,onLastListenerRemove:Z});return K.event}r.fromNodeEventEmitter=V;function x(q,y,Y=j=>j){const j=(...ne)=>K.fire(Y(...ne)),Q=()=>q.addEventListener(y,j),Z=()=>q.removeEventListener(y,j),K=new d({onFirstListenerAdd:Q,onLastListenerRemove:Z});return K.event}r.fromDOMEventEmitter=x;function e(q){return new Promise(y=>s(q)(y))}r.toPromise=e})(a=t.Event||(t.Event={}));class u{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${u._idPool++}`}start(s){this._stopWatch=new b.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let o=-1;function L(r){const s=o;return o=r,{dispose(){o=s}}}t.setGlobalLeakWarningThreshold=L;class w{constructor(s,h=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let h=o;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||s<h)return;this._stacks||(this._stacks=new Map);const v=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(v)||0;if(this._stacks.set(v,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let g,m=0;for(const[M,D]of this._stacks)(!g||m<D)&&(g=M,m=D);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${m}):`),console.warn(g)}return()=>{const g=this._stacks.get(v)||0;this._stacks.set(v,g-1)}}}class d{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=o>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(s,h,v)=>{this._listeners||(this._listeners=new l.LinkedList);const f=this._listeners.isEmpty();f&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const g=this._listeners.push(h?[s,h]:s);f&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,h);const m=this._leakageMon?.check(this._listeners.size),M=(0,C.toDisposable)(()=>{m&&m(),this._disposed||(g(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof C.DisposableStore?v.add(M):Array.isArray(v)&&v.push(M),M}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new l.LinkedList);for(let h of this._listeners)this._deliveryQueue.push([h,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[h,v]=this._deliveryQueue.shift();try{typeof h=="function"?h.call(void 0,v):h[0].call(h[1],v)}catch(f){(0,P.onUnexpectedError)(f)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}t.Emitter=d;class c extends d{async fireAsync(s,h,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new l.LinkedList);for(const f of this._listeners)this._asyncDeliveryQueue.push([f,s]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[f,g]=this._asyncDeliveryQueue.shift(),m=[],M={...g,waitUntil:D=>{if(Object.isFrozen(m))throw new Error("waitUntil can NOT be called asynchronous");v&&(D=v(D,typeof f=="function"?f:f[0])),m.push(D)}};try{typeof f=="function"?f.call(void 0,M):f[0].call(f[1],M)}catch(D){(0,P.onUnexpectedError)(D);continue}Object.freeze(m),await Promise.allSettled(m).then(D=>{for(const p of D)p.status==="rejected"&&(0,P.onUnexpectedError)(p.reason)})}}}}t.AsyncEmitter=c;class _ extends d{constructor(s){super(s);this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}t.PauseableEmitter=_;class E extends _{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}t.DebounceEmitter=E;class N extends d{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]})}}t.MicrotaskEmitter=N;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const h={event:s,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const v=()=>{this.hasListeners&&this.unhook(h);const f=this.events.indexOf(h);this.events.splice(f,1)};return(0,C.toDisposable)((0,R.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(h=>this.emitter.fire(h))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=S;class n{constructor(){this.buffers=[]}wrapEvent(s){return(h,v,f)=>s(g=>{const m=this.buffers[this.buffers.length-1];m?m.push(()=>h.call(v,g)):h.call(v,g)},void 0,f)}bufferEvents(s){const h=[];this.buffers.push(h);const v=s();return this.buffers.pop(),h.forEach(f=>f()),v}}t.EventBufferer=n;class i{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=C.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=i}),$(z[21],G([0,1,10]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const R=Object.freeze(function(a,u){const o=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(o)}}});var C;(function(a){function u(o){return o===a.None||o===a.Cancelled||o instanceof l?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=t.CancellationToken||(t.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class b{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=C.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=C.None}}t.CancellationTokenSource=b}),$(z[5],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function P(A){return!A||typeof A!="string"?!0:A.trim().length===0}t.isFalsyOrWhitespace=P;const R=/{(\d+)}/g;function C(A,...I){return I.length===0?A:A.replace(R,function(T,O){const B=parseInt(O,10);return isNaN(B)||B<0||B>=I.length?T:I[B]})}t.format=C;const l=/{([^}]+)}/g;function b(A,I){return A.replace(l,(T,O)=>I[O]??T)}t.format2=b;function a(A){return A.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}t.escape=a;function u(A){return A.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=u;function o(A,I){let T=0;const O=I.charCodeAt(0);for(let B=A.length-1;B>=0;B--)A.charCodeAt(B)===O&&T++;return T}t.count=o;function L(A,I,T="\u2026"){return A.length<=I?A:`${A.substr(0,I)}${T}`}t.truncate=L;function w(A,I=" "){const T=d(A,I);return c(T,I)}t.trim=w;function d(A,I){if(!A||!I)return A;const T=I.length;if(T===0||A.length===0)return A;let O=0;for(;A.indexOf(I,O)===O;)O=O+T;return A.substring(O)}t.ltrim=d;function c(A,I){if(!A||!I)return A;const T=I.length,O=A.length;if(T===0||O===0)return A;let B=O,X=-1;for(;X=A.lastIndexOf(I,B-1),!(X===-1||X+T!==B);){if(X===0)return"";B=X}return A.substring(0,B)}t.rtrim=c;function _(A){return A.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function E(A){return A.replace(/\*/g,"")}t.stripWildcards=E;function N(A,I,T={}){if(!A)throw new Error("Cannot create regex from empty string");I||(A=u(A)),T.wholeWord&&(/\B/.test(A.charAt(0))||(A="\\b"+A),/\B/.test(A.charAt(A.length-1))||(A=A+"\\b"));let O="";return T.global&&(O+="g"),T.matchCase||(O+="i"),T.multiline&&(O+="m"),T.unicode&&(O+="u"),new RegExp(A,O)}t.createRegExp=N;function S(A){return A.source==="^"||A.source==="^$"||A.source==="$"||A.source==="^\\s*$"?!1:!!(A.exec("")&&A.lastIndex===0)}t.regExpLeadsToEndlessLoop=S;function n(A){return!!A.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=n;function i(A){return(A.global?"g":"")+(A.ignoreCase?"i":"")+(A.multiline?"m":"")+(A.unicode?"u":"")}t.regExpFlags=i;function r(A){return A.split(/\r\n|\r|\n/)}t.splitLines=r;function s(A){for(let I=0,T=A.length;I<T;I++){const O=A.charCodeAt(I);if(O!==32&&O!==9)return I}return-1}t.firstNonWhitespaceIndex=s;function h(A,I=0,T=A.length){for(let O=I;O<T;O++){const B=A.charCodeAt(O);if(B!==32&&B!==9)return A.substring(I,O)}return A.substring(I,T)}t.getLeadingWhitespace=h;function v(A,I=A.length-1){for(let T=I;T>=0;T--){const O=A.charCodeAt(T);if(O!==32&&O!==9)return T}return-1}t.lastNonWhitespaceIndex=v;function f(A,I){return A<I?-1:A>I?1:0}t.compare=f;function g(A,I,T=0,O=A.length,B=0,X=I.length){for(;T<O&&B<X;T++,B++){let se=A.charCodeAt(T),re=I.charCodeAt(B);if(se<re)return-1;if(se>re)return 1}const te=O-T,ie=X-B;return te<ie?-1:te>ie?1:0}t.compareSubstring=g;function m(A,I){return M(A,I,0,A.length,0,I.length)}t.compareIgnoreCase=m;function M(A,I,T=0,O=A.length,B=0,X=I.length){for(;T<O&&B<X;T++,B++){let se=A.charCodeAt(T),re=I.charCodeAt(B);if(se===re)continue;const ue=se-re;if(!(ue===32&&p(re))&&!(ue===-32&&p(se)))return D(se)&&D(re)?ue:g(A.toLowerCase(),I.toLowerCase(),T,O,B,X)}const te=O-T,ie=X-B;return te<ie?-1:te>ie?1:0}t.compareSubstringIgnoreCase=M;function D(A){return A>=97&&A<=122}t.isLowerAsciiLetter=D;function p(A){return A>=65&&A<=90}t.isUpperAsciiLetter=p;function U(A){return D(A)||p(A)}function k(A,I){return A.length===I.length&&W(A,I)}t.equalsIgnoreCase=k;function W(A,I,T=A.length){for(let O=0;O<T;O++){const B=A.charCodeAt(O),X=I.charCodeAt(O);if(B!==X){if(U(B)&&U(X)){const te=Math.abs(B-X);if(te!==0&&te!==32)return!1}else if(String.fromCharCode(B).toLowerCase()!==String.fromCharCode(X).toLowerCase())return!1}}return!0}function H(A,I){const T=I.length;return I.length>A.length?!1:W(A,I,T)}t.startsWithIgnoreCase=H;function J(A,I){let T,O=Math.min(A.length,I.length);for(T=0;T<O;T++)if(A.charCodeAt(T)!==I.charCodeAt(T))return T;return O}t.commonPrefixLength=J;function V(A,I){let T,O=Math.min(A.length,I.length);const B=A.length-1,X=I.length-1;for(T=0;T<O;T++)if(A.charCodeAt(B-T)!==I.charCodeAt(X-T))return T;return O}t.commonSuffixLength=V;function x(A){return 55296<=A&&A<=56319}t.isHighSurrogate=x;function e(A){return 56320<=A&&A<=57343}t.isLowSurrogate=e;function q(A,I){return(A-55296<<10)+(I-56320)+65536}t.computeCodePoint=q;function y(A,I,T){const O=A.charCodeAt(T);if(x(O)&&T+1<I){const B=A.charCodeAt(T+1);if(e(B))return q(O,B)}return O}t.getNextCodePoint=y;function Y(A,I){const T=A.charCodeAt(I-1);if(e(T)&&I>1){const O=A.charCodeAt(I-2);if(x(O))return q(O,T)}return T}function j(A,I){const T=le.getInstance(),O=I,B=A.length,X=y(A,B,I);I+=X>=65536?2:1;let te=T.getGraphemeBreakType(X);for(;I<B;){const ie=y(A,B,I),se=T.getGraphemeBreakType(ie);if(ce(te,se))break;I+=ie>=65536?2:1,te=se}return I-O}t.nextCharLength=j;function Q(A,I){const T=le.getInstance(),O=I,B=Y(A,I);I-=B>=65536?2:1;let X=T.getGraphemeBreakType(B);for(;I>0;){const te=Y(A,I),ie=T.getGraphemeBreakType(te);if(ce(ie,X))break;I-=te>=65536?2:1,X=ie}return O-I}t.prevCharLength=Q;function Z(A,I){const T=le.getInstance(),O=A.length,B=I,X=y(A,O,I),te=T.getGraphemeBreakType(X);I+=X>=65536?2:1;let ie=te;for(;I<O;){const re=y(A,O,I),ue=T.getGraphemeBreakType(re);if(ce(ie,ue))break;I+=re>=65536?2:1,ie=ue}const se=I;for(I=B,ie=te;I>0;){const re=Y(A,I),ue=T.getGraphemeBreakType(re);if(ce(ue,ie))break;I-=re>=65536?2:1,ie=ue}return[I,se]}function K(A,I){return I>0&&e(A.charCodeAt(I))?Z(A,I-1):Z(A,I)}t.getCharContainingOffset=K;const ne=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ae(A){return ne.test(A)}t.containsRTL=ae;const oe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function he(A){return oe.test(A)}t.containsEmoji=he;const de=/^[\t\n\r\x20-\x7E]*$/;function Ae(A){return de.test(A)}t.isBasicASCII=Ae,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ne(A){return t.UNUSUAL_LINE_TERMINATORS.test(A)}t.containsUnusualLineTerminators=Ne;function we(A){for(let I=0,T=A.length;I<T;I++)if(me(A.charCodeAt(I)))return!0;return!1}t.containsFullWidthCharacter=we;function me(A){return A=+A,A>=11904&&A<=55215||A>=63744&&A<=64255||A>=65281&&A<=65374}t.isFullWidthCharacter=me;function _e(A){return A>=127462&&A<=127487||A===8986||A===8987||A===9200||A===9203||A>=9728&&A<=10175||A===11088||A===11093||A>=127744&&A<=128591||A>=128640&&A<=128764||A>=128992&&A<=129003||A>=129280&&A<=129535||A>=129648&&A<=129750}t.isEmojiImprecise=_e;function Ce(A,I){if(A.length<I)return A;const T=/\b/g;let O=0;for(;T.test(A)&&!(A.length-T.lastIndex<I);)O=T.lastIndex,T.lastIndex+=1;return A.substring(O).replace(/^\s/,"")}t.lcut=Ce;const Pe=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function De(A){return A&&(A=A.replace(Pe,""),A=A.replace(Me,""),A=A.replace(pe,"")),A}t.removeAnsiEscapeCodes=De,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(A){return!!(A&&A.length>0&&A.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ve;function Ue(A){return ve(A)?A.substr(1):A}t.stripUTF8BOM=Ue;function Re(A,I){if(!A||!I||A.length<I.length)return!1;const T=I.length,O=A.toLowerCase();let B=0,X=-1;for(;B<T;){const te=O.indexOf(I[B],X+1);if(te<0)return!1;X=te,B++}return!0}t.fuzzyContains=Re;function Ie(A,I=!1){return A?(I&&(A=A.replace(/\\./g,"")),A.toLowerCase()!==A):!1}t.containsUppercaseCharacter=Ie;function Fe(A){return A.charAt(0).toUpperCase()+A.slice(1)}t.uppercaseFirstLetter=Fe;function Te(A,I=1){if(I===0)return"";let T=-1;do T=A.indexOf(`
`,T+1),I--;while(I>0&&T>=0);return T===-1?A:(A[T-1]==="\r"&&T--,A.substr(0,T))}t.getNLines=Te;function ke(A){const I=90-65+1;return A=A%(2*I),A<I?String.fromCharCode(97+A):String.fromCharCode(65+A-I)}t.singleLetterHash=ke;function ye(A){return le.getInstance().getGraphemeBreakType(A)}t.getGraphemeBreakType=ye;function ce(A,I){return A===0?I!==5&&I!==7:A===2&&I===3?!1:A===4||A===2||A===3||I===4||I===2||I===3?!0:!(A===8&&(I===8||I===9||I===11||I===12)||(A===11||A===9)&&(I===9||I===10)||(A===12||A===10)&&I===10||I===5||I===13||I===7||A===1||A===13&&I===14||A===6&&I===6)}t.breakBetweenGraphemeBreakType=ce;var We;(function(A){A[A.Other=0]="Other",A[A.Prepend=1]="Prepend",A[A.CR=2]="CR",A[A.LF=3]="LF",A[A.Control=4]="Control",A[A.Extend=5]="Extend",A[A.Regional_Indicator=6]="Regional_Indicator",A[A.SpacingMark=7]="SpacingMark",A[A.L=8]="L",A[A.V=9]="V",A[A.T=10]="T",A[A.LV=11]="LV",A[A.LVT=12]="LVT",A[A.ZWJ=13]="ZWJ",A[A.Extended_Pictographic=14]="Extended_Pictographic"})(We=t.GraphemeBreakType||(t.GraphemeBreakType={}));class le{constructor(){this._data=Oe()}static getInstance(){return le._INSTANCE||(le._INSTANCE=new le),le._INSTANCE}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const T=this._data,O=T.length/3;let B=1;for(;B<=O;)if(I<T[3*B])B=2*B;else if(I>T[3*B+1])B=2*B+1;else return T[3*B+2];return 0}}le._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function qe(A,I){if(A===0)return 0;const T=Be(A,I);if(T!==void 0)return T;const O=Y(I,A);return A-=fe(O),A}t.getLeftDeleteOffset=qe;function Be(A,I){let T=Y(I,A);for(A-=fe(T);He(T)||T===65039||T===8419;){if(A===0)return;T=Y(I,A),A-=fe(T)}if(!!_e(T)){if(A>=0){const O=Y(I,A);O===8205&&(A-=fe(O))}return A}}function fe(A){return A>=65536?2:1}function He(A){return 127995<=A&&A<=127999}var Le;(function(A){A[A.zwj=8205]="zwj",A[A.emojiVariantSelector=65039]="emojiVariantSelector",A[A.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={}))}),$(z[22],G([0,1,5]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function R(S){return C(S,0)}t.hash=R;function C(S,n){switch(typeof S){case"object":return S===null?l(349,n):Array.isArray(S)?u(S,n):o(S,n);case"string":return a(S,n);case"boolean":return b(S,n);case"number":return l(S,n);case"undefined":return l(937,n);default:return l(617,n)}}t.doHash=C;function l(S,n){return(n<<5)-n+S|0}function b(S,n){return l(S?433:863,n)}function a(S,n){n=l(149417,n);for(let i=0,r=S.length;i<r;i++)n=l(S.charCodeAt(i),n);return n}t.stringHash=a;function u(S,n){return n=l(104579,n),S.reduce((i,r)=>C(r,i),n)}function o(S,n){return n=l(181387,n),Object.keys(S).sort().reduce((i,r)=>(i=a(r,i),C(S[r],i)),n)}class L{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=C(n,this._value),this._value}}t.Hasher=L;var w;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function d(S,n,i=32){const r=i-n,s=~((1<<r)-1);return(S<<n|(s&S)>>>r)>>>0}function c(S,n=0,i=S.byteLength,r=0){for(let s=0;s<i;s++)S[n+s]=r}function _(S,n,i="0"){for(;S.length<n;)S=i+S;return S}function E(S,n=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(i=>i.toString(16).padStart(2,"0")).join(""):_((S>>>0).toString(16),n/4)}t.toHexString=E;class N{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i===0)return;const r=this._buff;let s=this._buffLen,h=this._leftoverHighSurrogate,v,f;for(h!==0?(v=h,f=-1,h=0):(v=n.charCodeAt(0),f=0);;){let g=v;if(P.isHighSurrogate(v))if(f+1<i){const m=n.charCodeAt(f+1);P.isLowSurrogate(m)?(f++,g=P.computeCodePoint(v,m)):g=65533}else{h=v;break}else P.isLowSurrogate(v)&&(g=65533);if(s=this._push(r,s,g),f++,f<i)v=n.charCodeAt(f);else break}this._buffLen=s,this._leftoverHighSurrogate=h}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=N._bigBlock32,i=this._buffDV;for(let D=0;D<64;D+=4)n.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)n.setUint32(D,d(n.getUint32(D-12,!1)^n.getUint32(D-32,!1)^n.getUint32(D-56,!1)^n.getUint32(D-64,!1),1),!1);let r=this._h0,s=this._h1,h=this._h2,v=this._h3,f=this._h4,g,m,M;for(let D=0;D<80;D++)D<20?(g=s&h|~s&v,m=1518500249):D<40?(g=s^h^v,m=1859775393):D<60?(g=s&h|s&v|h&v,m=2400959708):(g=s^h^v,m=3395469782),M=d(r,5)+g+f+m+n.getUint32(D*4,!1)&4294967295,f=v,v=h,h=d(s,30),s=r,r=M;this._h0=this._h0+r&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+h&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+f&4294967295}}t.StringSHA1=N,N._bigBlock32=new DataView(new ArrayBuffer(320))}),$(z[11],G([0,1,15,22]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class C{constructor(d){this.source=d}getElements(){const d=this.source,c=new Int32Array(d.length);for(let _=0,E=d.length;_<E;_++)c[_]=d.charCodeAt(_);return c}}t.StringDiffSequence=C;function l(w,d,c){return new L(new C(w),new C(d)).ComputeDiff(c).changes}t.stringDiff=l;class b{static Assert(d,c){if(!d)throw new Error(c)}}t.Debug=b;class a{static Copy(d,c,_,E,N){for(let S=0;S<N;S++)_[E+S]=d[c+S]}static Copy2(d,c,_,E,N){for(let S=0;S<N;S++)_[E+S]=d[c+S]}}t.MyArray=a;var u;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(d,c){this.m_originalStart=Math.min(this.m_originalStart,d),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(d,c){this.m_originalStart=Math.min(this.m_originalStart,d),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class L{constructor(d,c,_=null){this.ContinueProcessingPredicate=_,this._originalSequence=d,this._modifiedSequence=c;const[E,N,S]=L._getElements(d),[n,i,r]=L._getElements(c);this._hasStrings=S&&r,this._originalStringElements=E,this._originalElementsOrHash=N,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(d){return d.length>0&&typeof d[0]=="string"}static _getElements(d){const c=d.getElements();if(L._isStringArray(c)){const _=new Int32Array(c.length);for(let E=0,N=c.length;E<N;E++)_[E]=(0,R.stringHash)(c[E],0);return[c,_,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(d,c){return this._originalElementsOrHash[d]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[d]===this._modifiedStringElements[c]:!0}ElementsAreStrictEqual(d,c){if(!this.ElementsAreEqual(d,c))return!1;const _=L._getStrictElement(this._originalSequence,d),E=L._getStrictElement(this._modifiedSequence,c);return _===E}static _getStrictElement(d,c){return typeof d.getStrictElement=="function"?d.getStrictElement(c):null}OriginalElementsAreEqual(d,c){return this._originalElementsOrHash[d]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[d]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(d,c){return this._modifiedElementsOrHash[d]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[d]===this._modifiedStringElements[c]:!0}ComputeDiff(d){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,d)}_ComputeDiff(d,c,_,E,N){const S=[!1];let n=this.ComputeDiffRecursive(d,c,_,E,S);return N&&(n=this.PrettifyChanges(n)),{quitEarly:S[0],changes:n}}ComputeDiffRecursive(d,c,_,E,N){for(N[0]=!1;d<=c&&_<=E&&this.ElementsAreEqual(d,_);)d++,_++;for(;c>=d&&E>=_&&this.ElementsAreEqual(c,E);)c--,E--;if(d>c||_>E){let h;return _<=E?(b.Assert(d===c+1,"originalStart should only be one more than originalEnd"),h=[new P.DiffChange(d,0,_,E-_+1)]):d<=c?(b.Assert(_===E+1,"modifiedStart should only be one more than modifiedEnd"),h=[new P.DiffChange(d,c-d+1,_,0)]):(b.Assert(d===c+1,"originalStart should only be one more than originalEnd"),b.Assert(_===E+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const S=[0],n=[0],i=this.ComputeRecursionPoint(d,c,_,E,S,n,N),r=S[0],s=n[0];if(i!==null)return i;if(!N[0]){const h=this.ComputeDiffRecursive(d,r,_,s,N);let v=[];return N[0]?v=[new P.DiffChange(r+1,c-(r+1)+1,s+1,E-(s+1)+1)]:v=this.ComputeDiffRecursive(r+1,c,s+1,E,N),this.ConcatenateChanges(h,v)}return[new P.DiffChange(d,c-d+1,_,E-_+1)]}WALKTRACE(d,c,_,E,N,S,n,i,r,s,h,v,f,g,m,M,D,p){let U=null,k=null,W=new o,H=c,J=_,V=f[0]-M[0]-E,x=-1073741824,e=this.m_forwardHistory.length-1;do{const q=V+d;q===H||q<J&&r[q-1]<r[q+1]?(h=r[q+1],g=h-V-E,h<x&&W.MarkNextChange(),x=h,W.AddModifiedElement(h+1,g),V=q+1-d):(h=r[q-1]+1,g=h-V-E,h<x&&W.MarkNextChange(),x=h-1,W.AddOriginalElement(h,g+1),V=q-1-d),e>=0&&(r=this.m_forwardHistory[e],d=r[0],H=1,J=r.length-1)}while(--e>=-1);if(U=W.getReverseChanges(),p[0]){let q=f[0]+1,y=M[0]+1;if(U!==null&&U.length>0){const Y=U[U.length-1];q=Math.max(q,Y.getOriginalEnd()),y=Math.max(y,Y.getModifiedEnd())}k=[new P.DiffChange(q,v-q+1,y,m-y+1)]}else{W=new o,H=S,J=n,V=f[0]-M[0]-i,x=1073741824,e=D?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const q=V+N;q===H||q<J&&s[q-1]>=s[q+1]?(h=s[q+1]-1,g=h-V-i,h>x&&W.MarkNextChange(),x=h+1,W.AddOriginalElement(h+1,g+1),V=q+1-N):(h=s[q-1],g=h-V-i,h>x&&W.MarkNextChange(),x=h,W.AddModifiedElement(h+1,g+1),V=q-1-N),e>=0&&(s=this.m_reverseHistory[e],N=s[0],H=1,J=s.length-1)}while(--e>=-1);k=W.getChanges()}return this.ConcatenateChanges(U,k)}ComputeRecursionPoint(d,c,_,E,N,S,n){let i=0,r=0,s=0,h=0,v=0,f=0;d--,_--,N[0]=0,S[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const g=c-d+(E-_),m=g+1,M=new Int32Array(m),D=new Int32Array(m),p=E-_,U=c-d,k=d-_,W=c-E,J=(U-p)%2==0;M[p]=d,D[U]=c,n[0]=!1;for(let V=1;V<=g/2+1;V++){let x=0,e=0;s=this.ClipDiagonalBound(p-V,V,p,m),h=this.ClipDiagonalBound(p+V,V,p,m);for(let y=s;y<=h;y+=2){y===s||y<h&&M[y-1]<M[y+1]?i=M[y+1]:i=M[y-1]+1,r=i-(y-p)-k;const Y=i;for(;i<c&&r<E&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(M[y]=i,i+r>x+e&&(x=i,e=r),!J&&Math.abs(y-U)<=V-1&&i>=D[y])return N[0]=i,S[0]=r,Y<=D[y]&&1447>0&&V<=1447+1?this.WALKTRACE(p,s,h,k,U,v,f,W,M,D,i,c,N,r,E,S,J,n):null}const q=(x-d+(e-_)-V)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(x,q))return n[0]=!0,N[0]=x,S[0]=e,q>0&&1447>0&&V<=1447+1?this.WALKTRACE(p,s,h,k,U,v,f,W,M,D,i,c,N,r,E,S,J,n):(d++,_++,[new P.DiffChange(d,c-d+1,_,E-_+1)]);v=this.ClipDiagonalBound(U-V,V,U,m),f=this.ClipDiagonalBound(U+V,V,U,m);for(let y=v;y<=f;y+=2){y===v||y<f&&D[y-1]>=D[y+1]?i=D[y+1]-1:i=D[y-1],r=i-(y-U)-W;const Y=i;for(;i>d&&r>_&&this.ElementsAreEqual(i,r);)i--,r--;if(D[y]=i,J&&Math.abs(y-p)<=V&&i<=M[y])return N[0]=i,S[0]=r,Y>=M[y]&&1447>0&&V<=1447+1?this.WALKTRACE(p,s,h,k,U,v,f,W,M,D,i,c,N,r,E,S,J,n):null}if(V<=1447){let y=new Int32Array(h-s+2);y[0]=p-s+1,a.Copy2(M,s,y,1,h-s+1),this.m_forwardHistory.push(y),y=new Int32Array(f-v+2),y[0]=U-v+1,a.Copy2(D,v,y,1,f-v+1),this.m_reverseHistory.push(y)}}return this.WALKTRACE(p,s,h,k,U,v,f,W,M,D,i,c,N,r,E,S,J,n)}PrettifyChanges(d){for(let c=0;c<d.length;c++){const _=d[c],E=c<d.length-1?d[c+1].originalStart:this._originalElementsOrHash.length,N=c<d.length-1?d[c+1].modifiedStart:this._modifiedElementsOrHash.length,S=_.originalLength>0,n=_.modifiedLength>0;for(;_.originalStart+_.originalLength<E&&_.modifiedStart+_.modifiedLength<N&&(!S||this.OriginalElementsAreEqual(_.originalStart,_.originalStart+_.originalLength))&&(!n||this.ModifiedElementsAreEqual(_.modifiedStart,_.modifiedStart+_.modifiedLength));){const r=this.ElementsAreStrictEqual(_.originalStart,_.modifiedStart);if(this.ElementsAreStrictEqual(_.originalStart+_.originalLength,_.modifiedStart+_.modifiedLength)&&!r)break;_.originalStart++,_.modifiedStart++}let i=[null];if(c<d.length-1&&this.ChangesOverlap(d[c],d[c+1],i)){d[c]=i[0],d.splice(c+1,1),c--;continue}}for(let c=d.length-1;c>=0;c--){const _=d[c];let E=0,N=0;if(c>0){const h=d[c-1];E=h.originalStart+h.originalLength,N=h.modifiedStart+h.modifiedLength}const S=_.originalLength>0,n=_.modifiedLength>0;let i=0,r=this._boundaryScore(_.originalStart,_.originalLength,_.modifiedStart,_.modifiedLength);for(let h=1;;h++){const v=_.originalStart-h,f=_.modifiedStart-h;if(v<E||f<N||S&&!this.OriginalElementsAreEqual(v,v+_.originalLength)||n&&!this.ModifiedElementsAreEqual(f,f+_.modifiedLength))break;const m=(v===E&&f===N?5:0)+this._boundaryScore(v,_.originalLength,f,_.modifiedLength);m>r&&(r=m,i=h)}_.originalStart-=i,_.modifiedStart-=i;const s=[null];if(c>0&&this.ChangesOverlap(d[c-1],d[c],s)){d[c-1]=s[0],d.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,_=d.length;c<_;c++){const E=d[c-1],N=d[c],S=N.originalStart-E.originalStart-E.originalLength,n=E.originalStart,i=N.originalStart+N.originalLength,r=i-n,s=E.modifiedStart,h=N.modifiedStart+N.modifiedLength,v=h-s;if(S<5&&r<20&&v<20){const f=this._findBetterContiguousSequence(n,r,s,v,S);if(f){const[g,m]=f;(g!==E.originalStart+E.originalLength||m!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=g-E.originalStart,E.modifiedLength=m-E.modifiedStart,N.originalStart=g+S,N.modifiedStart=m+S,N.originalLength=i-N.originalStart,N.modifiedLength=h-N.modifiedStart)}}}return d}_findBetterContiguousSequence(d,c,_,E,N){if(c<N||E<N)return null;const S=d+c-N+1,n=_+E-N+1;let i=0,r=0,s=0;for(let h=d;h<S;h++)for(let v=_;v<n;v++){const f=this._contiguousSequenceScore(h,v,N);f>0&&f>i&&(i=f,r=h,s=v)}return i>0?[r,s]:null}_contiguousSequenceScore(d,c,_){let E=0;for(let N=0;N<_;N++){if(!this.ElementsAreEqual(d+N,c+N))return 0;E+=this._originalStringElements[d+N].length}return E}_OriginalIsBoundary(d){return d<=0||d>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[d])}_OriginalRegionIsBoundary(d,c){if(this._OriginalIsBoundary(d)||this._OriginalIsBoundary(d-1))return!0;if(c>0){const _=d+c;if(this._OriginalIsBoundary(_-1)||this._OriginalIsBoundary(_))return!0}return!1}_ModifiedIsBoundary(d){return d<=0||d>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[d])}_ModifiedRegionIsBoundary(d,c){if(this._ModifiedIsBoundary(d)||this._ModifiedIsBoundary(d-1))return!0;if(c>0){const _=d+c;if(this._ModifiedIsBoundary(_-1)||this._ModifiedIsBoundary(_))return!0}return!1}_boundaryScore(d,c,_,E){const N=this._OriginalRegionIsBoundary(d,c)?1:0,S=this._ModifiedRegionIsBoundary(_,E)?1:0;return N+S}ConcatenateChanges(d,c){let _=[];if(d.length===0||c.length===0)return c.length>0?c:d;if(this.ChangesOverlap(d[d.length-1],c[0],_)){const E=new Array(d.length+c.length-1);return a.Copy(d,0,E,0,d.length-1),E[d.length-1]=_[0],a.Copy(c,1,E,d.length,c.length-1),E}else{const E=new Array(d.length+c.length);return a.Copy(d,0,E,0,d.length),a.Copy(c,0,E,d.length,c.length),E}}ChangesOverlap(d,c,_){if(b.Assert(d.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),b.Assert(d.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=c.originalStart||d.modifiedStart+d.modifiedLength>=c.modifiedStart){const E=d.originalStart;let N=d.originalLength;const S=d.modifiedStart;let n=d.modifiedLength;return d.originalStart+d.originalLength>=c.originalStart&&(N=c.originalStart+c.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=c.modifiedStart&&(n=c.modifiedStart+c.modifiedLength-d.modifiedStart),_[0]=new P.DiffChange(E,N,S,n),!0}else return _[0]=null,!1}ClipDiagonalBound(d,c,_,E){if(d>=0&&d<E)return d;const N=_,S=E-_-1,n=c%2==0;if(d<0){const i=N%2==0;return n===i?0:1}else{const i=S%2==0;return n===i?E-1:E-2}}}t.LcsDiff=L}),$(z[12],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPromise=t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function P(p){return Array.isArray(p)}t.isArray=P;function R(p){return typeof p=="string"}t.isString=R;function C(p){return Array.isArray(p)&&p.every(U=>R(U))}t.isStringArray=C;function l(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}t.isObject=l;function b(p){return typeof p=="number"&&!isNaN(p)}t.isNumber=b;function a(p){return!!p&&typeof p[Symbol.iterator]=="function"}t.isIterable=a;function u(p){return p===!0||p===!1}t.isBoolean=u;function o(p){return typeof p=="undefined"}t.isUndefined=o;function L(p){return!w(p)}t.isDefined=L;function w(p){return o(p)||p===null}t.isUndefinedOrNull=w;function d(p,U){if(!p)throw new Error(U?`Unexpected type, expected '${U}'`:"Unexpected type")}t.assertType=d;function c(p){if(w(p))throw new Error("Assertion Failed: argument is undefined or null");return p}t.assertIsDefined=c;function _(...p){const U=[];for(let k=0;k<p.length;k++){const W=p[k];if(w(W))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);U.push(W)}return U}t.assertAllDefined=_;const E=Object.prototype.hasOwnProperty;function N(p){if(!l(p))return!1;for(let U in p)if(E.call(p,U))return!1;return!0}t.isEmptyObject=N;function S(p){return typeof p=="function"}t.isFunction=S;function n(...p){return p.length>0&&p.every(S)}t.areFunctions=n;function i(p,U){const k=Math.min(p.length,U.length);for(let W=0;W<k;W++)r(p[W],U[W])}t.validateConstraints=i;function r(p,U){if(R(U)){if(typeof p!==U)throw new Error(`argument does not match constraint: typeof ${U}`)}else if(S(U)){try{if(p instanceof U)return}catch{}if(!w(p)&&p.constructor===U||U.length===1&&U.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function s(p){let U=[],k=Object.getPrototypeOf(p);for(;Object.prototype!==k;)U=U.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return U}t.getAllPropertyNames=s;function h(p){const U=[];for(const k of s(p))typeof p[k]=="function"&&U.push(k);return U}t.getAllMethodNames=h;function v(p,U){const k=H=>function(){const J=Array.prototype.slice.call(arguments,0);return U(H,J)};let W={};for(const H of p)W[H]=k(H);return W}t.createProxyObject=v;function f(p){return p===null?void 0:p}t.withNullAsUndefined=f;function g(p){return typeof p=="undefined"?null:p}t.withUndefinedAsNull=g;function m(p){return class{constructor(){return new Proxy({},{get(U,k){if(U[k])return U[k];throw new Error(`Not Implemented: ${p}->${String(k)}`)}})}}}t.NotImplementedProxy=m;function M(p,U="Unreachable"){throw new Error(U)}t.assertNever=M;function D(p){return!!p&&typeof p.then=="function"&&typeof p.catch=="function"}t.isPromise=D}),$(z[13],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(l){l[l.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",l[l.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",l[l.MAX_UINT_8=255]="MAX_UINT_8",l[l.MAX_UINT_16=65535]="MAX_UINT_16",l[l.MAX_UINT_32=4294967295]="MAX_UINT_32",l[l.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=t.Constants||(t.Constants={}));function R(l){return l<0?0:l>255?255:l|0}t.toUint8=R;function C(l){return l<0?0:l>4294967295?4294967295:l|0}t.toUint32=C}),$(z[14],G([0,1,20,2]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const C=/^\w[\w\d+.-]*$/,l=/^\//,b=/^\/\//;function a(f,g){if(!f.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!C.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!l.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(f,g){return!f&&!g?"file":f}function o(f,g){switch(f){case"https":case"http":case"file":g?g[0]!==w&&(g=w+g):g=w;break}return g}const L="",w="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{constructor(g,m,M,D,p,U=!1){typeof g=="object"?(this.scheme=g.scheme||L,this.authority=g.authority||L,this.path=g.path||L,this.query=g.query||L,this.fragment=g.fragment||L):(this.scheme=u(g,U),this.authority=m||L,this.path=o(this.scheme,M||L),this.query=D||L,this.fragment=p||L,a(this,U))}static isUri(g){return g instanceof c?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}get fsPath(){return i(this,!1)}with(g){if(!g)return this;let{scheme:m,authority:M,path:D,query:p,fragment:U}=g;return m===void 0?m=this.scheme:m===null&&(m=L),M===void 0?M=this.authority:M===null&&(M=L),D===void 0?D=this.path:D===null&&(D=L),p===void 0?p=this.query:p===null&&(p=L),U===void 0?U=this.fragment:U===null&&(U=L),m===this.scheme&&M===this.authority&&D===this.path&&p===this.query&&U===this.fragment?this:new E(m,M,D,p,U)}static parse(g,m=!1){const M=d.exec(g);return M?new E(M[2]||L,v(M[4]||L),v(M[5]||L),v(M[7]||L),v(M[9]||L),m):new E(L,L,L,L,L)}static file(g){let m=L;if(R.isWindows&&(g=g.replace(/\\/g,w)),g[0]===w&&g[1]===w){const M=g.indexOf(w,2);M===-1?(m=g.substring(2),g=w):(m=g.substring(2,M),g=g.substring(M)||w)}return new E("file",m,g,L,L)}static from(g){const m=new E(g.scheme,g.authority,g.path,g.query,g.fragment);return a(m,!0),m}static joinPath(g,...m){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return R.isWindows&&g.scheme==="file"?M=c.file(P.win32.join(i(g,!0),...m)).path:M=P.posix.join(g.path,...m),g.with({path:M})}toString(g=!1){return r(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof c)return g;{const m=new E(g);return m._formatted=g.external,m._fsPath=g._sep===_?g.fsPath:null,m}}else return g}}t.URI=c;const _=R.isWindows?1:void 0;class E extends c{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(g=!1){return g?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=_),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const N={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(f,g){let m,M=-1;for(let D=0;D<f.length;D++){const p=f.charCodeAt(D);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||g&&p===47)M!==-1&&(m+=encodeURIComponent(f.substring(M,D)),M=-1),m!==void 0&&(m+=f.charAt(D));else{m===void 0&&(m=f.substr(0,D));const U=N[p];U!==void 0?(M!==-1&&(m+=encodeURIComponent(f.substring(M,D)),M=-1),m+=U):M===-1&&(M=D)}}return M!==-1&&(m+=encodeURIComponent(f.substring(M))),m!==void 0?m:f}function n(f){let g;for(let m=0;m<f.length;m++){const M=f.charCodeAt(m);M===35||M===63?(g===void 0&&(g=f.substr(0,m)),g+=N[M]):g!==void 0&&(g+=f[m])}return g!==void 0?g:f}function i(f,g){let m;return f.authority&&f.path.length>1&&f.scheme==="file"?m=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?g?m=f.path.substr(1):m=f.path[1].toLowerCase()+f.path.substr(2):m=f.path,R.isWindows&&(m=m.replace(/\//g,"\\")),m}t.uriToFsPath=i;function r(f,g){const m=g?n:S;let M="",{scheme:D,authority:p,path:U,query:k,fragment:W}=f;if(D&&(M+=D,M+=":"),(p||D==="file")&&(M+=w,M+=w),p){let H=p.indexOf("@");if(H!==-1){const J=p.substr(0,H);p=p.substr(H+1),H=J.indexOf(":"),H===-1?M+=m(J,!1):(M+=m(J.substr(0,H),!1),M+=":",M+=m(J.substr(H+1),!1)),M+="@"}p=p.toLowerCase(),H=p.indexOf(":"),H===-1?M+=m(p,!1):(M+=m(p.substr(0,H),!1),M+=p.substr(H))}if(U){if(U.length>=3&&U.charCodeAt(0)===47&&U.charCodeAt(2)===58){const H=U.charCodeAt(1);H>=65&&H<=90&&(U=`/${String.fromCharCode(H+32)}:${U.substr(3)}`)}else if(U.length>=2&&U.charCodeAt(1)===58){const H=U.charCodeAt(0);H>=65&&H<=90&&(U=`${String.fromCharCode(H+32)}:${U.substr(2)}`)}M+=m(U,!0)}return k&&(M+="?",M+=m(k,!1)),W&&(M+="#",M+=g?W:S(W,!1)),M}function s(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+s(f.substr(3)):f}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(f){return f.match(h)?f.replace(h,g=>s(g)):f}}),$(z[34],G([0,1,4,8,2,12]),function(F,t,P,R,C,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const b="$initialize";let a=!1;function u(c){!C.isWeb||(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}t.logOnceWebWorkerWarning=u;class o{constructor(_){this._workerId=-1,this._handler=_,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(_){this._workerId=_}sendMessage(_,E){let N=String(++this._lastSentReq);return new Promise((S,n)=>{this._pendingReplies[N]={resolve:S,reject:n},this._send({vsWorker:this._workerId,req:N,method:_,args:E})})}handleMessage(_){!_||!_.vsWorker||this._workerId!==-1&&_.vsWorker!==this._workerId||this._handleMessage(_)}_handleMessage(_){if(_.seq){let n=_;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),i.reject(r);return}i.resolve(n.res);return}let E=_,N=E.req;this._handler.handleMessage(E.method,E.args).then(n=>{this._send({vsWorker:this._workerId,seq:N,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=(0,P.transformErrorForSerialization)(n.detail)),this._send({vsWorker:this._workerId,seq:N,res:void 0,err:(0,P.transformErrorForSerialization)(n)})})}_send(_){let E=[];if(_.req){const N=_;for(let S=0;S<N.args.length;S++)N.args[S]instanceof ArrayBuffer&&E.push(N.args[S])}else{const N=_;N.res instanceof ArrayBuffer&&E.push(N.res)}this._handler.sendMessage(_,E)}}class L extends R.Disposable{constructor(_,E,N){super();let S=null;this._worker=this._register(_.create("vs/base/common/worker/simpleWorker",s=>{this._protocol.handleMessage(s)},s=>{S&&S(s)})),this._protocol=new o({sendMessage:(s,h)=>{this._worker.postMessage(s,h)},handleMessage:(s,h)=>{if(typeof N[s]!="function")return Promise.reject(new Error("Missing method "+s+" on main thread host."));try{return Promise.resolve(N[s].apply(N,h))}catch(v){return Promise.reject(v)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const i=l.getAllMethodNames(N);this._onModuleLoaded=this._protocol.sendMessage(b,[this._worker.getId(),JSON.parse(JSON.stringify(n)),E,i]);const r=(s,h)=>this._request(s,h);this._lazyProxy=new Promise((s,h)=>{S=h,this._onModuleLoaded.then(v=>{s(l.createProxyObject(v,r))},v=>{h(v),this._onError("Worker failed to load "+E,v)})})}getProxyObject(){return this._lazyProxy}_request(_,E){return new Promise((N,S)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(_,E).then(N,S)},S)})}_onError(_,E){console.error(_),console.info(E)}}t.SimpleWorkerClient=L;class w{constructor(_,E){this._requestHandlerFactory=E,this._requestHandler=null,this._protocol=new o({sendMessage:(N,S)=>{_(N,S)},handleMessage:(N,S)=>this._handleMessage(N,S)})}onmessage(_){this._protocol.handleMessage(_)}_handleMessage(_,E){if(_===b)return this.initialize(E[0],E[1],E[2],E[3]);if(!this._requestHandler||typeof this._requestHandler[_]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+_));try{return Promise.resolve(this._requestHandler[_].apply(this._requestHandler,E))}catch(N){return Promise.reject(N)}}initialize(_,E,N,S){this._protocol.setWorkerId(_);const n=(r,s)=>this._protocol.sendMessage(r,s),i=l.createProxyObject(S,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(l.getAllMethodNames(this._requestHandler))):(E&&(typeof E.baseUrl!="undefined"&&delete E.baseUrl,typeof E.paths!="undefined"&&typeof E.paths.vs!="undefined"&&delete E.paths.vs,typeof E.trustedTypesPolicy!==void 0&&delete E.trustedTypesPolicy,E.catchError=!0,self.require.config(E)),new Promise((r,s)=>{self.require([N],h=>{if(this._requestHandler=h.create(i),!this._requestHandler){s(new Error("No RequestHandler!"));return}r(l.getAllMethodNames(this._requestHandler))},s)}))}}t.SimpleWorkerServer=w;function d(c){return new w(c,null)}t.create=d}),$(z[23],G([0,1,13]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class R{constructor(a){let u=(0,P.toUint8)(a);this._defaultValue=u,this._asciiMap=R._createAsciiMap(u),this._map=new Map}static _createAsciiMap(a){let u=new Uint8Array(256);for(let o=0;o<256;o++)u[o]=a;return u}set(a,u){let o=(0,P.toUint8)(u);a>=0&&a<256?this._asciiMap[a]=o:this._map.set(a,o)}get(a){return a>=0&&a<256?this._asciiMap[a]:this._map.get(a)||this._defaultValue}}t.CharacterClassifier=R;var C;(function(b){b[b.False=0]="False",b[b.True=1]="True"})(C||(C={}));class l{constructor(){this._actual=new R(0)}add(a){this._actual.set(a,1)}has(a){return this._actual.get(a)===1}}t.CharacterSet=l}),$(z[3],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(C,l){this.lineNumber=C,this.column=l}with(C=this.lineNumber,l=this.column){return C===this.lineNumber&&l===this.column?this:new P(C,l)}delta(C=0,l=0){return this.with(this.lineNumber+C,this.column+l)}equals(C){return P.equals(this,C)}static equals(C,l){return!C&&!l?!0:!!C&&!!l&&C.lineNumber===l.lineNumber&&C.column===l.column}isBefore(C){return P.isBefore(this,C)}static isBefore(C,l){return C.lineNumber<l.lineNumber?!0:l.lineNumber<C.lineNumber?!1:C.column<l.column}isBeforeOrEqual(C){return P.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,l){return C.lineNumber<l.lineNumber?!0:l.lineNumber<C.lineNumber?!1:C.column<=l.column}static compare(C,l){let b=C.lineNumber|0,a=l.lineNumber|0;if(b===a){let u=C.column|0,o=l.column|0;return u-o}return b-a}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new P(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}t.Position=P}),$(z[6],G([0,1,3]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class R{constructor(l,b,a,u){l>a||l===a&&b>u?(this.startLineNumber=a,this.startColumn=u,this.endLineNumber=l,this.endColumn=b):(this.startLineNumber=l,this.startColumn=b,this.endLineNumber=a,this.endColumn=u)}isEmpty(){return R.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return R.containsPosition(this,l)}static containsPosition(l,b){return!(b.lineNumber<l.startLineNumber||b.lineNumber>l.endLineNumber||b.lineNumber===l.startLineNumber&&b.column<l.startColumn||b.lineNumber===l.endLineNumber&&b.column>l.endColumn)}containsRange(l){return R.containsRange(this,l)}static containsRange(l,b){return!(b.startLineNumber<l.startLineNumber||b.endLineNumber<l.startLineNumber||b.startLineNumber>l.endLineNumber||b.endLineNumber>l.endLineNumber||b.startLineNumber===l.startLineNumber&&b.startColumn<l.startColumn||b.endLineNumber===l.endLineNumber&&b.endColumn>l.endColumn)}strictContainsRange(l){return R.strictContainsRange(this,l)}static strictContainsRange(l,b){return!(b.startLineNumber<l.startLineNumber||b.endLineNumber<l.startLineNumber||b.startLineNumber>l.endLineNumber||b.endLineNumber>l.endLineNumber||b.startLineNumber===l.startLineNumber&&b.startColumn<=l.startColumn||b.endLineNumber===l.endLineNumber&&b.endColumn>=l.endColumn)}plusRange(l){return R.plusRange(this,l)}static plusRange(l,b){let a,u,o,L;return b.startLineNumber<l.startLineNumber?(a=b.startLineNumber,u=b.startColumn):b.startLineNumber===l.startLineNumber?(a=b.startLineNumber,u=Math.min(b.startColumn,l.startColumn)):(a=l.startLineNumber,u=l.startColumn),b.endLineNumber>l.endLineNumber?(o=b.endLineNumber,L=b.endColumn):b.endLineNumber===l.endLineNumber?(o=b.endLineNumber,L=Math.max(b.endColumn,l.endColumn)):(o=l.endLineNumber,L=l.endColumn),new R(a,u,o,L)}intersectRanges(l){return R.intersectRanges(this,l)}static intersectRanges(l,b){let a=l.startLineNumber,u=l.startColumn,o=l.endLineNumber,L=l.endColumn,w=b.startLineNumber,d=b.startColumn,c=b.endLineNumber,_=b.endColumn;return a<w?(a=w,u=d):a===w&&(u=Math.max(u,d)),o>c?(o=c,L=_):o===c&&(L=Math.min(L,_)),a>o||a===o&&u>L?null:new R(a,u,o,L)}equalsRange(l){return R.equalsRange(this,l)}static equalsRange(l,b){return!!l&&!!b&&l.startLineNumber===b.startLineNumber&&l.startColumn===b.startColumn&&l.endLineNumber===b.endLineNumber&&l.endColumn===b.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(l){return new P.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(l){return new P.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,b){return new R(this.startLineNumber,this.startColumn,l,b)}setStartPosition(l,b){return new R(l,b,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(l){return new R(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,b=l){return new R(l.lineNumber,l.column,b.lineNumber,b.column)}static lift(l){return l?new R(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,b){return!(l.endLineNumber<b.startLineNumber||l.endLineNumber===b.startLineNumber&&l.endColumn<b.startColumn||b.endLineNumber<l.startLineNumber||b.endLineNumber===l.startLineNumber&&b.endColumn<l.startColumn)}static areIntersecting(l,b){return!(l.endLineNumber<b.startLineNumber||l.endLineNumber===b.startLineNumber&&l.endColumn<=b.startColumn||b.endLineNumber<l.startLineNumber||b.endLineNumber===l.startLineNumber&&b.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,b){if(l&&b){const o=l.startLineNumber|0,L=b.startLineNumber|0;if(o===L){const w=l.startColumn|0,d=b.startColumn|0;if(w===d){const c=l.endLineNumber|0,_=b.endLineNumber|0;if(c===_){const E=l.endColumn|0,N=b.endColumn|0;return E-N}return c-_}return w-d}return o-L}return(l?1:0)-(b?1:0)}static compareRangesUsingEnds(l,b){return l.endLineNumber===b.endLineNumber?l.endColumn===b.endColumn?l.startLineNumber===b.startLineNumber?l.startColumn-b.startColumn:l.startLineNumber-b.startLineNumber:l.endColumn-b.endColumn:l.endLineNumber-b.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}t.Range=R}),$(z[24],G([0,1,3,6]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var C;(function(b){b[b.LTR=0]="LTR",b[b.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));class l extends R.Range{constructor(a,u,o,L){super(a,u,o,L);this.selectionStartLineNumber=a,this.selectionStartColumn=u,this.positionLineNumber=o,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(a){return l.selectionsEqual(this,a)}static selectionsEqual(a,u){return a.selectionStartLineNumber===u.selectionStartLineNumber&&a.selectionStartColumn===u.selectionStartColumn&&a.positionLineNumber===u.positionLineNumber&&a.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(a,u){return this.getDirection()===0?new l(this.startLineNumber,this.startColumn,a,u):new l(a,u,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(a,u){return this.getDirection()===0?new l(a,u,this.endLineNumber,this.endColumn):new l(this.endLineNumber,this.endColumn,a,u)}static fromPositions(a,u=a){return new l(a.lineNumber,a.column,u.lineNumber,u.column)}static liftSelection(a){return new l(a.selectionStartLineNumber,a.selectionStartColumn,a.positionLineNumber,a.positionColumn)}static selectionsArrEqual(a,u){if(a&&!u||!a&&u)return!1;if(!a&&!u)return!0;if(a.length!==u.length)return!1;for(let o=0,L=a.length;o<L;o++)if(!this.selectionsEqual(a[o],u[o]))return!1;return!0}static isISelection(a){return a&&typeof a.selectionStartLineNumber=="number"&&typeof a.selectionStartColumn=="number"&&typeof a.positionLineNumber=="number"&&typeof a.positionColumn=="number"}static createWithDirection(a,u,o,L,w){return w===0?new l(a,u,o,L):new l(o,L,a,u)}}t.Selection=l}),$(z[25],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class P{constructor(b,a,u){this._tokenBrand=void 0,this.offset=b|0,this.type=a,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=P;class R{constructor(b,a){this._tokenizationResultBrand=void 0,this.tokens=b,this.endState=a}}t.TokenizationResult=R;class C{constructor(b,a){this._tokenizationResult2Brand=void 0,this.tokens=b,this.endState=a}}t.TokenizationResult2=C}),$(z[26],G([0,1,11,5]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const C=3;function l(E,N,S,n){return new P.LcsDiff(E,N,S).ComputeDiff(n)}class b{constructor(N){const S=[],n=[];for(let i=0,r=N.length;i<r;i++)S[i]=d(N[i],1),n[i]=c(N[i],1);this.lines=N,this._startColumns=S,this._endColumns=n}getElements(){const N=[];for(let S=0,n=this.lines.length;S<n;S++)N[S]=this.lines[S].substring(this._startColumns[S]-1,this._endColumns[S]-1);return N}getStrictElement(N){return this.lines[N]}getStartLineNumber(N){return N+1}getEndLineNumber(N){return N+1}createCharSequence(N,S,n){const i=[],r=[],s=[];let h=0;for(let v=S;v<=n;v++){const f=this.lines[v],g=N?this._startColumns[v]:1,m=N?this._endColumns[v]:f.length+1;for(let M=g;M<m;M++)i[h]=f.charCodeAt(M-1),r[h]=v+1,s[h]=M,h++}return new a(i,r,s)}}class a{constructor(N,S,n){this._charCodes=N,this._lineNumbers=S,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(N){return this._lineNumbers[N]}getStartColumn(N){return this._columns[N]}getEndLineNumber(N){return this._lineNumbers[N]}getEndColumn(N){return this._columns[N]+1}}class u{constructor(N,S,n,i,r,s,h,v){this.originalStartLineNumber=N,this.originalStartColumn=S,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=s,this.modifiedEndLineNumber=h,this.modifiedEndColumn=v}static createFromDiffChange(N,S,n){let i,r,s,h,v,f,g,m;return N.originalLength===0?(i=0,r=0,s=0,h=0):(i=S.getStartLineNumber(N.originalStart),r=S.getStartColumn(N.originalStart),s=S.getEndLineNumber(N.originalStart+N.originalLength-1),h=S.getEndColumn(N.originalStart+N.originalLength-1)),N.modifiedLength===0?(v=0,f=0,g=0,m=0):(v=n.getStartLineNumber(N.modifiedStart),f=n.getStartColumn(N.modifiedStart),g=n.getEndLineNumber(N.modifiedStart+N.modifiedLength-1),m=n.getEndColumn(N.modifiedStart+N.modifiedLength-1)),new u(i,r,s,h,v,f,g,m)}}function o(E){if(E.length<=1)return E;const N=[E[0]];let S=N[0];for(let n=1,i=E.length;n<i;n++){const r=E[n],s=r.originalStart-(S.originalStart+S.originalLength),h=r.modifiedStart-(S.modifiedStart+S.modifiedLength);Math.min(s,h)<C?(S.originalLength=r.originalStart+r.originalLength-S.originalStart,S.modifiedLength=r.modifiedStart+r.modifiedLength-S.modifiedStart):(N.push(r),S=r)}return N}class L{constructor(N,S,n,i,r){this.originalStartLineNumber=N,this.originalEndLineNumber=S,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(N,S,n,i,r,s,h){let v,f,g,m,M;if(S.originalLength===0?(v=n.getStartLineNumber(S.originalStart)-1,f=0):(v=n.getStartLineNumber(S.originalStart),f=n.getEndLineNumber(S.originalStart+S.originalLength-1)),S.modifiedLength===0?(g=i.getStartLineNumber(S.modifiedStart)-1,m=0):(g=i.getStartLineNumber(S.modifiedStart),m=i.getEndLineNumber(S.modifiedStart+S.modifiedLength-1)),s&&S.originalLength>0&&S.originalLength<20&&S.modifiedLength>0&&S.modifiedLength<20&&r()){const D=n.createCharSequence(N,S.originalStart,S.originalStart+S.originalLength-1),p=i.createCharSequence(N,S.modifiedStart,S.modifiedStart+S.modifiedLength-1);let U=l(D,p,r,!0).changes;h&&(U=o(U)),M=[];for(let k=0,W=U.length;k<W;k++)M.push(u.createFromDiffChange(U[k],D,p))}return new L(v,f,g,m,M)}}class w{constructor(N,S,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=N,this.modifiedLines=S,this.original=new b(N),this.modified=new b(S),this.continueLineDiff=_(n.maxComputationTime),this.continueCharDiff=_(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const N=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),S=N.changes,n=N.quitEarly;if(this.shouldIgnoreTrimWhitespace){const h=[];for(let v=0,f=S.length;v<f;v++)h.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,S[v],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:h}}const i=[];let r=0,s=0;for(let h=-1,v=S.length;h<v;h++){const f=h+1<v?S[h+1]:null,g=f?f.originalStart:this.originalLines.length,m=f?f.modifiedStart:this.modifiedLines.length;for(;r<g&&s<m;){const M=this.originalLines[r],D=this.modifiedLines[s];if(M!==D){{let p=d(M,1),U=d(D,1);for(;p>1&&U>1;){const k=M.charCodeAt(p-2),W=D.charCodeAt(U-2);if(k!==W)break;p--,U--}(p>1||U>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,p,s+1,1,U)}{let p=c(M,1),U=c(D,1);const k=M.length+1,W=D.length+1;for(;p<k&&U<W;){const H=M.charCodeAt(p-1),J=M.charCodeAt(U-1);if(H!==J)break;p++,U++}(p<k||U<W)&&this._pushTrimWhitespaceCharChange(i,r+1,p,k,s+1,U,W)}}r++,s++}f&&(i.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,f,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=f.originalLength,s+=f.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(N,S,n,i,r,s,h){if(this._mergeTrimWhitespaceCharChange(N,S,n,i,r,s,h))return;let v;this.shouldComputeCharChanges&&(v=[new u(S,n,S,i,r,s,r,h)]),N.push(new L(S,S,r,r,v))}_mergeTrimWhitespaceCharChange(N,S,n,i,r,s,h){const v=N.length;if(v===0)return!1;const f=N[v-1];return f.originalEndLineNumber===0||f.modifiedEndLineNumber===0?!1:f.originalEndLineNumber+1===S&&f.modifiedEndLineNumber+1===r?(f.originalEndLineNumber=S,f.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&f.charChanges&&f.charChanges.push(new u(S,n,S,i,r,s,r,h)),!0):!1}}t.DiffComputer=w;function d(E,N){const S=R.firstNonWhitespaceIndex(E);return S===-1?N:S+1}function c(E,N){const S=R.lastNonWhitespaceIndex(E);return S===-1?N:S+2}function _(E){if(E===0)return()=>!0;const N=Date.now();return()=>Date.now()-N<E}}),$(z[27],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(a=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const o of t.USUAL_WORD_SEPARATORS)a.indexOf(o)>=0||(u+="\\"+o);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=P();function R(a){let u=t.DEFAULT_WORD_REGEXP;if(a&&a instanceof RegExp)if(a.global)u=a;else{let o="g";a.ignoreCase&&(o+="i"),a.multiline&&(o+="m"),a.unicode&&(o+="u"),u=new RegExp(a.source,o)}return u.lastIndex=0,u}t.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function l(a,u,o,L,w=C){if(o.length>w.maxLen){let N=a-w.maxLen/2;return N<0?N=0:L+=N,o=o.substring(N,a+w.maxLen/2),l(a,u,o,L,w)}const d=Date.now(),c=a-1-L;let _=-1,E=null;for(let N=1;!(Date.now()-d>=w.timeBudget);N++){const S=c-w.windowSize*N;u.lastIndex=Math.max(0,S);const n=b(u,o,c,_);if(!n&&E||(E=n,S<=0))break;_=S}if(E){let N={word:E[0],startColumn:L+1+E.index,endColumn:L+1+E.index+E[0].length};return u.lastIndex=0,N}return null}t.getWordAtText=l;function b(a,u,o,L){let w;for(;w=a.exec(u);){const d=w.index||0;if(d<=o&&a.lastIndex>=o)return w;if(L>0&&d>L)return null}return null}}),$(z[28],G([0,1,23]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var R;(function(c){c[c.Invalid=0]="Invalid",c[c.Start=1]="Start",c[c.H=2]="H",c[c.HT=3]="HT",c[c.HTT=4]="HTT",c[c.HTTP=5]="HTTP",c[c.F=6]="F",c[c.FI=7]="FI",c[c.FIL=8]="FIL",c[c.BeforeColon=9]="BeforeColon",c[c.AfterColon=10]="AfterColon",c[c.AlmostThere=11]="AlmostThere",c[c.End=12]="End",c[c.Accept=13]="Accept",c[c.LastKnownState=14]="LastKnownState"})(R=t.State||(t.State={}));class C{constructor(_,E,N){const S=new Uint8Array(_*E);for(let n=0,i=_*E;n<i;n++)S[n]=N;this._data=S,this.rows=_,this.cols=E}get(_,E){return this._data[_*this.cols+E]}set(_,E,N){this._data[_*this.cols+E]=N}}t.Uint8Matrix=C;class l{constructor(_){let E=0,N=0;for(let n=0,i=_.length;n<i;n++){let[r,s,h]=_[n];s>E&&(E=s),r>N&&(N=r),h>N&&(N=h)}E++,N++;let S=new C(N,E,0);for(let n=0,i=_.length;n<i;n++){let[r,s,h]=_[n];S.set(r,s,h)}this._states=S,this._maxCharCode=E}nextState(_,E){return E<0||E>=this._maxCharCode?0:this._states.get(_,E)}}t.StateMachine=l;let b=null;function a(){return b===null&&(b=new l([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),b}var u;(function(c){c[c.None=0]="None",c[c.ForceTermination=1]="ForceTermination",c[c.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let o=null;function L(){if(o===null){o=new P.CharacterClassifier(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<c.length;E++)o.set(c.charCodeAt(E),1);const _=".,;";for(let E=0;E<_.length;E++)o.set(_.charCodeAt(E),2)}return o}class w{static _createLink(_,E,N,S,n){let i=n-1;do{const r=E.charCodeAt(i);if(_.get(r)!==2)break;i--}while(i>S);if(S>0){const r=E.charCodeAt(S-1),s=E.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:N,startColumn:S+1,endLineNumber:N,endColumn:i+2},url:E.substring(S,i+1)}}static computeLinks(_,E=a()){const N=L();let S=[];for(let n=1,i=_.getLineCount();n<=i;n++){const r=_.getLineContent(n),s=r.length;let h=0,v=0,f=0,g=1,m=!1,M=!1,D=!1,p=!1;for(;h<s;){let U=!1;const k=r.charCodeAt(h);if(g===13){let W;switch(k){case 40:m=!0,W=0;break;case 41:W=m?0:1;break;case 91:D=!0,M=!0,W=0;break;case 93:D=!1,W=M?0:1;break;case 123:p=!0,W=0;break;case 125:W=p?0:1;break;case 39:W=f===34||f===96?0:1;break;case 34:W=f===39||f===96?0:1;break;case 96:W=f===39||f===34?0:1;break;case 42:W=f===42?1:0;break;case 124:W=f===124?1:0;break;case 32:W=D?0:1;break;default:W=N.get(k)}W===1&&(S.push(w._createLink(N,r,n,v,h)),U=!0)}else if(g===12){let W;k===91?(M=!0,W=0):W=N.get(k),W===1?U=!0:g=13}else g=E.nextState(g,k),g===0&&(U=!0);U&&(g=1,m=!1,M=!1,p=!1,v=h+1,f=k),h++}g===13&&S.push(w._createLink(N,r,n,v,s))}return S}}t.LinkComputer=w;function d(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:w.computeLinks(c)}t.computeLinks=d}),$(z[29],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(C,l,b,a,u){if(C&&l){let o=this.doNavigateValueSet(l,u);if(o)return{range:C,value:o}}if(b&&a){let o=this.doNavigateValueSet(a,u);if(o)return{range:b,value:o}}return null}doNavigateValueSet(C,l){let b=this.numberReplace(C,l);return b!==null?b:this.textReplace(C,l)}numberReplace(C,l){let b=Math.pow(10,C.length-(C.lastIndexOf(".")+1)),a=Number(C),u=parseFloat(C);return!isNaN(a)&&!isNaN(u)&&a===u?a===0&&!l?null:(a=Math.floor(a*b),a+=l?b:-b,String(a/b)):null}textReplace(C,l){return this.valueSetsReplace(this._defaultValueSet,C,l)}valueSetsReplace(C,l,b){let a=null;for(let u=0,o=C.length;a===null&&u<o;u++)a=this.valueSetReplace(C[u],l,b);return a}valueSetReplace(C,l,b){let a=C.indexOf(l);return a>=0?(a+=b?1:-1,a<0?a=C.length-1:a%=C.length,C[a]):null}}t.BasicInplaceReplace=P,P.INSTANCE=new P}),$(z[30],G([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var P;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(P=t.AccessibilitySupport||(t.AccessibilitySupport={}));var R;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(R=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var C;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(C=t.CompletionItemKind||(t.CompletionItemKind={}));var l;(function(e){e[e.Deprecated=1]="Deprecated"})(l=t.CompletionItemTag||(t.CompletionItemTag={}));var b;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var o;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(o=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var L;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(L=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var d;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.bracketPairColorization=12]="bracketPairColorization",e[e.guides=13]="guides",e[e.codeLens=14]="codeLens",e[e.codeLensFontFamily=15]="codeLensFontFamily",e[e.codeLensFontSize=16]="codeLensFontSize",e[e.colorDecorators=17]="colorDecorators",e[e.columnSelection=18]="columnSelection",e[e.comments=19]="comments",e[e.contextmenu=20]="contextmenu",e[e.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",e[e.cursorBlinking=22]="cursorBlinking",e[e.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",e[e.cursorStyle=24]="cursorStyle",e[e.cursorSurroundingLines=25]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",e[e.cursorWidth=27]="cursorWidth",e[e.disableLayerHinting=28]="disableLayerHinting",e[e.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",e[e.domReadOnly=30]="domReadOnly",e[e.dragAndDrop=31]="dragAndDrop",e[e.emptySelectionClipboard=32]="emptySelectionClipboard",e[e.extraEditorClassName=33]="extraEditorClassName",e[e.fastScrollSensitivity=34]="fastScrollSensitivity",e[e.find=35]="find",e[e.fixedOverflowWidgets=36]="fixedOverflowWidgets",e[e.folding=37]="folding",e[e.foldingStrategy=38]="foldingStrategy",e[e.foldingHighlight=39]="foldingHighlight",e[e.foldingImportsByDefault=40]="foldingImportsByDefault",e[e.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=42]="fontFamily",e[e.fontInfo=43]="fontInfo",e[e.fontLigatures=44]="fontLigatures",e[e.fontSize=45]="fontSize",e[e.fontWeight=46]="fontWeight",e[e.formatOnPaste=47]="formatOnPaste",e[e.formatOnType=48]="formatOnType",e[e.glyphMargin=49]="glyphMargin",e[e.glyphMarginRightPadding=50]="glyphMarginRightPadding",e[e.gotoLocation=51]="gotoLocation",e[e.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",e[e.hover=53]="hover",e[e.inDiffEditor=54]="inDiffEditor",e[e.inlineSuggest=55]="inlineSuggest",e[e.letterSpacing=56]="letterSpacing",e[e.lightbulb=57]="lightbulb",e[e.lineDecorationsWidth=58]="lineDecorationsWidth",e[e.lineHeight=59]="lineHeight",e[e.lineNumbers=60]="lineNumbers",e[e.lineNumbersMinChars=61]="lineNumbersMinChars",e[e.linkedEditing=62]="linkedEditing",e[e.links=63]="links",e[e.matchBrackets=64]="matchBrackets",e[e.minimap=65]="minimap",e[e.mouseStyle=66]="mouseStyle",e[e.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=68]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",e[e.multiCursorModifier=70]="multiCursorModifier",e[e.multiCursorPaste=71]="multiCursorPaste",e[e.occurrencesHighlight=72]="occurrencesHighlight",e[e.overviewRulerBorder=73]="overviewRulerBorder",e[e.overviewRulerLanes=74]="overviewRulerLanes",e[e.padding=75]="padding",e[e.parameterHints=76]="parameterHints",e[e.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",e[e.quickSuggestions=79]="quickSuggestions",e[e.quickSuggestionsDelay=80]="quickSuggestionsDelay",e[e.readOnly=81]="readOnly",e[e.renameOnType=82]="renameOnType",e[e.renderControlCharacters=83]="renderControlCharacters",e[e.renderFinalNewline=84]="renderFinalNewline",e[e.renderLineHighlight=85]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=87]="renderValidationDecorations",e[e.renderWhitespace=88]="renderWhitespace",e[e.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",e[e.roundedSelection=90]="roundedSelection",e[e.rulers=91]="rulers",e[e.scrollbar=92]="scrollbar",e[e.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=94]="scrollBeyondLastLine",e[e.scrollPredominantAxis=95]="scrollPredominantAxis",e[e.selectionClipboard=96]="selectionClipboard",e[e.selectionHighlight=97]="selectionHighlight",e[e.selectOnLineNumbers=98]="selectOnLineNumbers",e[e.showFoldingControls=99]="showFoldingControls",e[e.showUnused=100]="showUnused",e[e.snippetSuggestions=101]="snippetSuggestions",e[e.smartSelect=102]="smartSelect",e[e.smoothScrolling=103]="smoothScrolling",e[e.stickyTabStops=104]="stickyTabStops",e[e.stopRenderingLineAfter=105]="stopRenderingLineAfter",e[e.suggest=106]="suggest",e[e.suggestFontSize=107]="suggestFontSize",e[e.suggestLineHeight=108]="suggestLineHeight",e[e.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",e[e.suggestSelection=110]="suggestSelection",e[e.tabCompletion=111]="tabCompletion",e[e.tabIndex=112]="tabIndex",e[e.unusualLineTerminators=113]="unusualLineTerminators",e[e.useShadowDOM=114]="useShadowDOM",e[e.useTabStops=115]="useTabStops",e[e.wordSeparators=116]="wordSeparators",e[e.wordWrap=117]="wordWrap",e[e.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=120]="wordWrapColumn",e[e.wordWrapOverride1=121]="wordWrapOverride1",e[e.wordWrapOverride2=122]="wordWrapOverride2",e[e.wrappingIndent=123]="wrappingIndent",e[e.wrappingStrategy=124]="wrappingStrategy",e[e.showDeprecated=125]="showDeprecated",e[e.inlayHints=126]="inlayHints",e[e.editorClassName=127]="editorClassName",e[e.pixelRatio=128]="pixelRatio",e[e.tabFocusMode=129]="tabFocusMode",e[e.layoutInfo=130]="layoutInfo",e[e.wrappingInfo=131]="wrappingInfo"})(d=t.EditorOption||(t.EditorOption={}));var c;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c=t.EndOfLinePreference||(t.EndOfLinePreference={}));var _;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(_=t.EndOfLineSequence||(t.EndOfLineSequence={}));var E;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(E=t.IndentAction||(t.IndentAction={}));var N;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(N=t.InlayHintKind||(t.InlayHintKind={}));var S;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(S=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(n=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(i=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var h;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(h=t.MouseTargetType||(t.MouseTargetType={}));var v;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(v=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var f;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(f=t.OverviewRulerLane||(t.OverviewRulerLane={}));var g;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(g=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var m;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(m=t.RenderMinimap||(t.RenderMinimap={}));var M;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(M=t.ScrollType||(t.ScrollType={}));var D;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(D=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var p;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(p=t.SelectionDirection||(t.SelectionDirection={}));var U;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(U=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var k;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(k=t.SymbolKind||(t.SymbolKind={}));var W;(function(e){e[e.Deprecated=1]="Deprecated"})(W=t.SymbolTag||(t.SymbolTag={}));var H;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(H=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var J;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(J=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var V;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(V=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var x;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(x=t.WrappingIndent||(t.WrappingIndent={}))}),$(z[31],G([0,1,21,10,17,14,3,6,24,25,30]),function(F,t,P,R,C,l,b,a,u,o,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class w{static chord(_,E){return(0,C.KeyChord)(_,E)}}t.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:R.Emitter,KeyCode:L.KeyCode,KeyMod:w,Position:b.Position,Range:a.Range,Selection:u.Selection,SelectionDirection:L.SelectionDirection,MarkerSeverity:L.MarkerSeverity,MarkerTag:L.MarkerTag,Uri:l.URI,Token:o.Token}}t.createMonacoBaseAPI=d}),$(z[32],G([0,1,13]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class R{constructor(b,a){this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=a}}t.PrefixSumIndexOfResult=R;class C{constructor(b){this.values=b,this.prefixSum=new Uint32Array(b.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(b,a){b=(0,P.toUint32)(b);const u=this.values,o=this.prefixSum,L=a.length;return L===0?!1:(this.values=new Uint32Array(u.length+L),this.values.set(u.subarray(0,b),0),this.values.set(u.subarray(b),b+L),this.values.set(a,b),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(o.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(b,a){return b=(0,P.toUint32)(b),a=(0,P.toUint32)(a),this.values[b]===a?!1:(this.values[b]=a,b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),!0)}removeValues(b,a){b=(0,P.toUint32)(b),a=(0,P.toUint32)(a);const u=this.values,o=this.prefixSum;if(b>=u.length)return!1;let L=u.length-b;return a>=L&&(a=L),a===0?!1:(this.values=new Uint32Array(u.length-a),this.values.set(u.subarray(0,b),0),this.values.set(u.subarray(b+a),b),this.prefixSum=new Uint32Array(this.values.length),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(o.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(b){return b<0?0:(b=(0,P.toUint32)(b),this._getPrefixSum(b))}_getPrefixSum(b){if(b<=this.prefixSumValidIndex[0])return this.prefixSum[b];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),b>=this.values.length&&(b=this.values.length-1);for(let u=a;u<=b;u++)this.prefixSum[u]=this.prefixSum[u-1]+this.values[u];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],b),this.prefixSum[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let a=0,u=this.values.length-1,o=0,L=0,w=0;for(;a<=u;)if(o=a+(u-a)/2|0,L=this.prefixSum[o],w=L-this.values[o],b<w)u=o-1;else if(b>=L)a=o+1;else break;return new R(o,b-w)}}t.PrefixSumComputer=C}),$(z[33],G([0,1,5,3,32]),function(F,t,P,R,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class l{constructor(a,u,o,L){this._uri=a,this._lines=u,this._eol=o,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(a){a.eol&&a.eol!==this._eol&&(this._eol=a.eol,this._lineStarts=null);const u=a.changes;for(const o of u)this._acceptDeleteRange(o.range),this._acceptInsertText(new R.Position(o.range.startLineNumber,o.range.startColumn),o.text);this._versionId=a.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const a=this._eol.length,u=this._lines.length,o=new Uint32Array(u);for(let L=0;L<u;L++)o[L]=this._lines[L].length+a;this._lineStarts=new C.PrefixSumComputer(o)}}_setLineText(a,u){this._lines[a]=u,this._lineStarts&&this._lineStarts.changeValue(a,this._lines[a].length+this._eol.length)}_acceptDeleteRange(a){if(a.startLineNumber===a.endLineNumber){if(a.startColumn===a.endColumn)return;this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.startLineNumber-1].substring(a.endColumn-1));return}this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.endLineNumber-1].substring(a.endColumn-1)),this._lines.splice(a.startLineNumber,a.endLineNumber-a.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(a.startLineNumber,a.endLineNumber-a.startLineNumber)}_acceptInsertText(a,u){if(u.length===0)return;let o=(0,P.splitLines)(u);if(o.length===1){this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+o[0]+this._lines[a.lineNumber-1].substring(a.column-1));return}o[o.length-1]+=this._lines[a.lineNumber-1].substring(a.column-1),this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+o[0]);let L=new Uint32Array(o.length-1);for(let w=1;w<o.length;w++)this._lines.splice(a.lineNumber+w-1,0,o[w]),L[w-1]=o[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(a.lineNumber,L)}}t.MirrorTextModel=l}),$(z[35],G([0,1,11,2,14,3,6,26,33,27,28,29,31,12,9]),function(F,t,P,R,C,l,b,a,u,o,L,w,d,c,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=t.MirrorModel=void 0;class E extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let s=(0,o.getWordAtText)(i.column,(0,o.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return s?new b.Range(i.lineNumber,s.startColumn,i.lineNumber,s.endColumn):null}getWordUntilPosition(i,r){const s=this.getWordAtPosition(i,r);return s?{word:this._lines[i.lineNumber-1].substring(s.startColumn-1,i.column-1),startColumn:s.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,s=this._wordenize.bind(this);let h=0,v="",f=0,g=[];return{*[Symbol.iterator](){for(;;)if(f<g.length){const m=v.substring(g[f].start,g[f].end);f+=1,yield m}else if(h<r.length)v=r[h],g=s(v,i),f=0,h+=1;else break}}}getLineWords(i,r){let s=this._lines[i-1],h=this._wordenize(s,r),v=[];for(const f of h)v.push({word:s.substring(f.start,f.end),startColumn:f.start+1,endColumn:f.end+1});return v}_wordenize(i,r){const s=[];let h;for(r.lastIndex=0;(h=r.exec(i))&&h[0].length!==0;)s.push({start:h.index,end:h.index+h[0].length});return s}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,s=i.startLineNumber-1,h=i.endLineNumber-1,v=[];v.push(this._lines[s].substring(i.startColumn-1));for(let f=s+1;f<h;f++)v.push(this._lines[f]);return v.push(this._lines[h].substring(0,i.endColumn-1)),v.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),s=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||s.lineNumber!==i.endLineNumber||s.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:i}_validatePosition(i){if(!l.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:s}=i,h=!1;if(r<1)r=1,s=1,h=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,h=!0;else{let v=this._lines[r-1].length+1;s<1?(s=1,h=!0):s>v&&(s=v,h=!0)}return h?{lineNumber:r,column:s}:i}}t.MirrorModel=E;class N{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new E(C.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,s,h){const v=this._getModel(i),f=this._getModel(r);if(!v||!f)return null;const g=v.getLinesContent(),m=f.getLinesContent(),D=new a.DiffComputer(g,m,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:h}).computeDiff(),p=D.changes.length>0?!1:this._modelsAreIdentical(v,f);return{quitEarly:D.quitEarly,identical:p,changes:D.changes}}_modelsAreIdentical(i,r){const s=i.getLineCount(),h=r.getLineCount();if(s!==h)return!1;for(let v=1;v<=s;v++){const f=i.getLineContent(v),g=r.getLineContent(v);if(f!==g)return!1}return!0}async computeDirtyDiff(i,r,s){let h=this._getModel(i),v=this._getModel(r);if(!h||!v)return null;let f=h.getLinesContent(),g=v.getLinesContent();return new a.DiffComputer(f,g,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const s=this._getModel(i);if(!s)return r;const h=[];let v;r=r.slice(0).sort((f,g)=>{if(f.range&&g.range)return b.Range.compareRangesUsingStarts(f.range,g.range);let m=f.range?0:1,M=g.range?0:1;return m-M});for(let{range:f,text:g,eol:m}of r){if(typeof m=="number"&&(v=m),b.Range.isEmpty(f)&&!g)continue;const M=s.getValueInRange(f);if(g=g.replace(/\r\n|\n|\r/g,s.eol),M===g)continue;if(Math.max(g.length,M.length)>N._diffLimit){h.push({range:f,text:g});continue}const D=(0,P.stringDiff)(M,g,!1),p=s.offsetAt(b.Range.lift(f).getStartPosition());for(const U of D){const k=s.positionAt(p+U.originalStart),W=s.positionAt(p+U.originalStart+U.originalLength),H={text:g.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:k.lineNumber,startColumn:k.column,endLineNumber:W.lineNumber,endColumn:W.column}};s.getValueInRange(H.range)!==H.text&&h.push(H)}}return typeof v=="number"&&h.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),h}async computeLinks(i){let r=this._getModel(i);return r?(0,L.computeLinks)(r):null}async textualSuggest(i,r,s,h){const v=new _.StopWatch(!0),f=new RegExp(s,h),g=new Set;e:for(let m of i){const M=this._getModel(m);if(!!M){for(let D of M.words(f))if(!(D===r||!isNaN(Number(D)))&&(g.add(D),g.size>N._suggestionsLimit))break e}}return{words:Array.from(g),duration:v.elapsed()}}async computeWordRanges(i,r,s,h){let v=this._getModel(i);if(!v)return Object.create(null);const f=new RegExp(s,h),g=Object.create(null);for(let m=r.startLineNumber;m<r.endLineNumber;m++){let M=v.getLineWords(m,f);for(const D of M){if(!isNaN(Number(D.word)))continue;let p=g[D.word];p||(p=[],g[D.word]=p),p.push({startLineNumber:m,startColumn:D.startColumn,endLineNumber:m,endColumn:D.endColumn})}}return g}async navigateValueSet(i,r,s,h,v){let f=this._getModel(i);if(!f)return null;let g=new RegExp(h,v);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let m=f.getValueInRange(r),M=f.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},g);if(!M)return null;let D=f.getValueInRange(M);return w.BasicInplaceReplace.INSTANCE.navigateValueSet(r,m,M,D,s)}loadForeignModule(i,r,s){const h=(g,m)=>this._host.fhr(g,m);let f={host:c.createProxyObject(s,h),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(f,r),Promise.resolve(c.getAllMethodNames(this._foreignModule))):new Promise((g,m)=>{F([i],M=>{this._foreignModule=M.create(f,r),g(c.getAllMethodNames(this._foreignModule))},m)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}t.EditorSimpleWorker=N,N._diffLimit=1e5,N._suggestionsLimit=1e4;function S(n){return new N(n,null)}t.create=S,typeof importScripts=="function"&&(R.globals.monaco=(0,d.createMonacoBaseAPI)())}),function(){const F=self.MonacoEnvironment,t=F&&F.baseUrl?F.baseUrl:"../../../",P=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:u=>u,createScript:(u,...o)=>{const L=o.slice(0,-1).join(","),w=o.pop().toString();return`(function anonymous(${L}) {
${w}
})`}}):void 0;function R(){try{return(P?self.eval(P.createScript("","true")):new Function("true")).call(self),!0}catch(u){return!1}}function C(){return new Promise((u,o)=>{if(typeof self.define=="function"&&self.define.amd)return u();const L=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(L)&&L.substring(0,self.origin.length)!==self.origin)&&R()){fetch(L).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${L}`,(P?self.eval(P.createScript("",d)):new Function(d)).call(self),u()}).then(void 0,o);return}P?importScripts(P.createScriptURL(L)):importScripts(L),u()})}const l=function(u){C().then(()=>{require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P}),require([u],function(o){setTimeout(function(){let L=o.create((w,d)=>{self.postMessage(w,d)},null);for(self.onmessage=w=>L.onmessage(w.data);a.length>0;)self.onmessage(a.shift())},0)})})};let b=!0,a=[];self.onmessage=u=>{if(!b){a.push(u);return}b=!1,l(u.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/214ac689ca9874a8a4be386f73d5cb60e15af25e/core/vs/base/worker/workerMain.js.map
