/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","child_process","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","vs/platform/extensions/common/extensions","crypto","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensions/node/extensionHostStarter","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","assert","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(J){for(var e=[],R=0,k=J.length;R<k;R++)e[R]=te[J[R]];return e};define(te[99],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(k,D){if(!k)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(te[65],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function k(n){const C=[];for(let g in n)R.call(n,g)&&C.push(n[g]);return C}e.values=k;function D(n,C){for(let g in n)if(R.call(n,g)&&C({key:g,value:n[g]},function(){delete n[g]})===!1)return}e.forEach=D;function T(n,C){const g=Object.create(null);for(const b of n){const h=C(b);let p=g[h];p||(p=g[h]=[]),p.push(b)}return g}e.groupBy=T;function L(n){const C=Object.create(null);return n&&n.forEach((g,b)=>{C[b]=g}),C}e.fromMap=L;function P(n,C){const g=[],b=[];for(let h of n)C.has(h)||g.push(h);for(let h of C)n.has(h)||b.push(h);return{removed:g,added:b}}e.diffSets=P;function S(n,C){const g=[],b=[];for(let[h,p]of n)C.has(h)||g.push(p);for(let[h,p]of C)n.has(h)||b.push(p);return{removed:g,added:b}}e.diffMaps=S;class I{constructor(){this.map=new Map}add(C,g){let b=this.map.get(C);b||(b=new Set,this.map.set(C,b)),b.add(g)}delete(C,g){const b=this.map.get(C);!b||(b.delete(g),b.size===0&&this.map.delete(C))}forEach(C,g){const b=this.map.get(C);!b||b.forEach(g)}}e.SetMap=I}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(L){return(P,S,I)=>{let n=null,C=null;if(typeof I.value=="function"?(n="value",C=I.value):typeof I.get=="function"&&(n="get",C=I.get),!C)throw new Error("not supported");I[n]=L(C,S)}}e.createDecorator=R;function k(L,P,S){let I=null,n=null;if(typeof S.value=="function"?(I="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(I="get",n=S.get),!n)throw new Error("not supported");const C=`$memoize$${P}`;S[I]=function(...g){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,g)}),this[C]}}e.memoize=k;function D(L,P,S){return R((I,n)=>{const C=`$debounce$${n}`,g=`$debounce$result$${n}`;return function(...b){this[g]||(this[g]=S?S():void 0),clearTimeout(this[C]),P&&(this[g]=P(this[g],...b),b=[this[g]]),this[C]=setTimeout(()=>{I.apply(this,b),this[g]=S?S():void 0},L)}})}e.debounce=D;function T(L,P,S){return R((I,n)=>{const C=`$throttle$timer$${n}`,g=`$throttle$result$${n}`,b=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...p){if(this[g]||(this[g]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...p)),this[h])return;const f=this[b]+L;f<=Date.now()?(this[b]=Date.now(),I.apply(this,[this[g]]),this[g]=S?S():void 0):(this[h]=!0,this[C]=setTimeout(()=>{this[h]=!1,this[b]=Date.now(),I.apply(this,[this[g]]),this[g]=S?S():void 0},f-Date.now()))}})}e.throttle=T}),define(te[8],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=R,e.errorHandler=new R;function k(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=k;function D(o){S(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=D;function T(o){S(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=T;function L(o){if(o instanceof Error){let{name:t,message:s}=o;const i=o.stacktrace||o.stack;return{$isError:!0,name:t,message:s,stack:i}}return o}e.transformErrorForSerialization=L;const P="Canceled";function S(o){return o instanceof Error&&o.name===P&&o.message===P}e.isPromiseCanceledError=S;class I extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=I;function n(){const o=new Error(P);return o.name=o.message,o}e.canceled=n;function C(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=C;function g(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=g;function b(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function h(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function p(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=p;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function y(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=y;function c(o,t=Object.create(null)){const s=new Error(o);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=c}),define(te[17],ne([0,1,8]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(N,W=0){return N[N.length-(1+W)]}e.tail=k;function D(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=D;function T(N,W,X=(Z,B)=>Z===B){if(N===W)return!0;if(!N||!W||N.length!==W.length)return!1;for(let Z=0,B=N.length;Z<B;Z++)if(!X(N[Z],W[Z]))return!1;return!0}e.equals=T;function L(N,W,X){let Z=0,B=N.length-1;for(;Z<=B;){const V=(Z+B)/2|0,ie=X(N[V],W);if(ie<0)Z=V+1;else if(ie>0)B=V-1;else return V}return-(Z+1)}e.binarySearch=L;function P(N,W){let X=0,Z=N.length;if(Z===0)return 0;for(;X<Z;){const B=Math.floor((X+Z)/2);W(N[B])?Z=B:X=B+1}return X}e.findFirstInSorted=P;function S(N,W,X){if(N=N|0,N>=W.length)throw new TypeError("invalid index");let Z=W[Math.floor(W.length*Math.random())],B=[],V=[],ie=[];for(let re of W){const ae=X(re,Z);ae<0?B.push(re):ae>0?V.push(re):ie.push(re)}return N<B.length?S(N,B,X):N<B.length+ie.length?ie[0]:S(N-(B.length+ie.length),V,X)}e.quickSelect=S;function I(N,W){const X=[];let Z;for(const B of N.slice(0).sort(W))!Z||W(Z[0],B)!==0?(Z=[B],X.push(Z)):Z.push(B);return X}e.groupBy=I;function n(N,W,X){const Z=[];function B(re,ae,ue){if(ae===0&&ue.length===0)return;const fe=Z[Z.length-1];fe&&fe.start+fe.deleteCount===re?(fe.deleteCount+=ae,fe.toInsert.push(...ue)):Z.push({start:re,deleteCount:ae,toInsert:ue})}let V=0,ie=0;for(;;){if(V===N.length){B(V,0,W.slice(ie));break}if(ie===W.length){B(V,N.length-V,[]);break}const re=N[V],ae=W[ie],ue=X(re,ae);ue===0?(V+=1,ie+=1):ue<0?(B(V,1,[]),V+=1):ue>0&&(B(V,0,[ae]),ie+=1)}return Z}e.sortedDiff=n;function C(N,W,X){const Z=n(N,W,X),B=[],V=[];for(const ie of Z)B.push(...N.slice(ie.start,ie.start+ie.deleteCount)),V.push(...ie.toInsert);return{removed:B,added:V}}e.delta=C;function g(N,W,X){if(X===0)return[];const Z=N.slice(0,X).sort(W);return h(N,W,Z,X,N.length),Z}e.top=g;function b(N,W,X,Z,B){return X===0?Promise.resolve([]):new Promise((V,ie)=>{(async()=>{const re=N.length,ae=N.slice(0,X).sort(W);for(let ue=X,fe=Math.min(X+Z,re);ue<re;ue=fe,fe=Math.min(fe+Z,re)){if(ue>X&&await new Promise(ge=>setTimeout(ge)),B&&B.isCancellationRequested)throw(0,R.canceled)();h(N,W,ae,ue,fe)}return ae})().then(V,ie)})}e.topAsync=b;function h(N,W,X,Z,B){for(const V=X.length;Z<B;Z++){const ie=N[Z];if(W(ie,X[V-1])<0){X.pop();const re=P(X,ae=>W(ie,ae)<0);X.splice(re,0,ie)}}}function p(N){return N.filter(W=>!!W)}e.coalesce=p;function f(N){let W=0;for(let X=0;X<N.length;X++)N[X]&&(N[W]=N[X],W+=1);N.length=W}e.coalesceInPlace=f;function E(N,W,X){N.splice(X,0,N.splice(W,1)[0])}e.move=E;function v(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=v;function y(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=y;function c(N,W){if(!W)return N.filter((Z,B)=>N.indexOf(Z)===B);const X=Object.create(null);return N.filter(Z=>{const B=W(Z);return X[B]?!1:(X[B]=!0,!0)})}e.distinct=c;function o(N){const W=new Set;return N.filter(X=>W.has(X)?!1:(W.add(X),!0))}e.distinctES6=o;function t(N){const W=Object.create(null);return X=>{const Z=N(X);return W[Z]?!1:(W[Z]=!0,!0)}}e.uniqueFilter=t;function s(N,W){const X=i(N,W);if(X!==-1)return N[X]}e.findLast=s;function i(N,W){for(let X=N.length-1;X>=0;X--){const Z=N[X];if(W(Z))return X}return-1}e.lastIndex=i;function r(N,W){return N.length>0?N[0]:W}e.firstOrDefault=r;function a(N,W,X=(Z,B)=>Z===B){let Z=0;for(let B=0,V=Math.min(N.length,W.length);B<V&&X(N[B],W[B]);B++)Z++;return Z}e.commonPrefixLength=a;function l(N){return[].concat(...N)}e.flatten=l;function u(N,W){let X=typeof W=="number"?N:0;typeof W=="number"?X=N:(X=0,W=N);const Z=[];if(X<=W)for(let B=X;B<W;B++)Z.push(B);else for(let B=X;B>W;B--)Z.push(B);return Z}e.range=u;function d(N,W,X){return N.reduce((Z,B)=>(Z[W(B)]=X?X(B):B,Z),Object.create(null))}e.index=d;function m(N,W){return N.push(W),()=>A(N,W)}e.insert=m;function A(N,W){const X=N.indexOf(W);if(X>-1)return N.splice(X,1),W}e.remove=A;function _(N,W,X){const Z=N.slice(0,W),B=N.slice(W);return Z.concat(X,B)}e.arrayInsert=_;function w(N,W){let X;if(typeof W=="number"){let Z=W;X=()=>{const B=Math.sin(Z++)*179426549;return B-Math.floor(B)}}else X=Math.random;for(let Z=N.length-1;Z>0;Z-=1){const B=Math.floor(X()*(Z+1)),V=N[Z];N[Z]=N[B],N[B]=V}}e.shuffle=w;function U(N,W){const X=N.indexOf(W);X>-1&&(N.splice(X,1),N.unshift(W))}e.pushToStart=U;function O(N,W){const X=N.indexOf(W);X>-1&&(N.splice(X,1),N.push(W))}e.pushToEnd=O;function $(N,W){return Array.isArray(N)?N.map(W):W(N)}e.mapArrayOrNot=$;function K(N){return Array.isArray(N)?N:[N]}e.asArray=K;function M(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=M;function H(N,W){for(const X of N){const Z=W(X);if(Z!==void 0)return Z}}e.mapFind=H;function j(N,W,X){const Z=q(N,W),B=N.length,V=X.length;N.length=B+V;for(let ie=B-1;ie>=Z;ie--)N[ie+V]=N[ie];for(let ie=0;ie<V;ie++)N[ie+Z]=X[ie]}e.insertInto=j;function z(N,W,X,Z){const B=q(N,W),V=N.splice(B,X);return j(N,B,Z),V}e.splice=z;function q(N,W){return W<0?Math.max(W+N.length,0):Math.min(W,N.length)}function F(N,W){let X=Number.MAX_SAFE_INTEGER,Z=0;return N.forEach((B,V)=>{const ie=W(B);ie<X&&(X=ie,Z=V)}),Z}e.minIndex=F;function G(N,W){let X=Number.MIN_SAFE_INTEGER,Z=0;return N.forEach((B,V)=>{const ie=W(B);ie>X&&(X=ie,Z=V)}),Z}e.maxIndex=G;class x{constructor(W){this.items=W,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(W){let X=this.firstIdx;for(;X<this.items.length&&W(this.items[X]);)X++;const Z=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,Z}takeFromEndWhile(W){let X=this.lastIdx;for(;X>=0&&W(this.items[X]);)X--;const Z=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,Z}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=x}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(k){const D=this;let T=!1,L;return function(){return T||(T=!0,L=k.apply(D,arguments)),L}}e.once=R}),define(te[55],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(k){function D(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}k.is=D;const T=Object.freeze([]);function L(){return T}k.empty=L;function*P(o){yield o}k.single=P;function S(o){return o||T}k.from=S;function I(o){return!o||o[Symbol.iterator]().next().done===!0}k.isEmpty=I;function n(o){return o[Symbol.iterator]().next().value}k.first=n;function C(o,t){for(const s of o)if(t(s))return!0;return!1}k.some=C;function g(o,t){for(const s of o)if(t(s))return s}k.find=g;function*b(o,t){for(const s of o)t(s)&&(yield s)}k.filter=b;function*h(o,t){let s=0;for(const i of o)yield t(i,s++)}k.map=h;function*p(...o){for(const t of o)for(const s of t)yield s}k.concat=p;function*f(o){for(const t of o)for(const s of t)yield s}k.concatNested=f;function E(o,t,s){let i=s;for(const r of o)i=t(i,r);return i}k.reduce=E;function*v(o,t,s=o.length){for(t<0&&(t+=o.length),s<0?s+=o.length:s>o.length&&(s=o.length);t<s;t++)yield o[t]}k.slice=v;function y(o,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,o];const i=o[Symbol.iterator]();for(let r=0;r<t;r++){const a=i.next();if(a.done)return[s,k.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return i}}]}k.consume=y;function c(o,t,s=(i,r)=>i===r){const i=o[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const a=i.next(),l=r.next();if(a.done!==l.done)return!1;if(a.done)return!0;if(!s(a.value,l.value))return!1}}k.equals=c})(R=e.Iterable||(e.Iterable={}))}),define(te[36],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function L(t,s=!1){let i=0,r=t.length,a="",l=0,u=16,d=0;function m(K){let M=0,H=0;for(;M<K;){const j=t.charCodeAt(i);if(j>=48&&j<=57)H=H*16+j-48;else if(j>=65&&j<=70)H=H*16+j-65+10;else if(j>=97&&j<=102)H=H*16+j-97+10;else break;i++,M++}return M<K&&(H=-1),H}function A(K){i=K,a="",l=0,u=16,d=0}function _(){const K=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&I(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&I(t.charCodeAt(i)))for(i++;i<t.length&&I(t.charCodeAt(i));)i++;else return d=3,t.substring(K,i);let M=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&I(t.charCodeAt(i))){for(i++;i<t.length&&I(t.charCodeAt(i));)i++;M=i}else d=3;return t.substring(K,M)}function w(){let K="",M=i;for(;;){if(i>=r){K+=t.substring(M,i),d=2;break}const H=t.charCodeAt(i);if(H===34){K+=t.substring(M,i),i++;break}if(H===92){if(K+=t.substring(M,i),i++,i>=r){d=2;break}switch(t.charCodeAt(i++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const z=m(4);z>=0?K+=String.fromCharCode(z):d=4;break;default:d=5}M=i;continue}if(H>=0&&H<=31)if(S(H)){K+=t.substring(M,i),d=2;break}else d=6;i++}return K}function U(){if(a="",d=0,l=i,i>=r)return l=r,u=17;let K=t.charCodeAt(i);if(P(K)){do i++,a+=String.fromCharCode(K),K=t.charCodeAt(i);while(P(K));return u=15}if(S(K))return i++,a+=String.fromCharCode(K),K===13&&t.charCodeAt(i)===10&&(i++,a+=`
`),u=14;switch(K){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,a=w(),u=10;case 47:const M=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!S(t.charCodeAt(i));)i++;return a=t.substring(M,i),u=12}if(t.charCodeAt(i+1)===42){i+=2;const H=r-1;let j=!1;for(;i<H;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,j=!0;break}i++}return j||(i++,d=1),a=t.substring(M,i),u=13}return a+=String.fromCharCode(K),i++,u=16;case 45:if(a+=String.fromCharCode(K),i++,i===r||!I(t.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=_(),u=11;default:for(;i<r&&O(K);)i++,K=t.charCodeAt(i);if(l!==i){switch(a=t.substring(l,i),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode(K),i++,u=16}}function O(K){if(P(K)||S(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let K;do K=U();while(K>=12&&K<=15);return K}return{setPosition:A,getPosition:()=>i,scan:s?$:U,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>d}}e.createScanner=L;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function C(t,s){const i=[],r=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(m,A,_,w){l.value=m,l.offset=A,l.length=_,l.type=w,l.colonOffset=void 0,a=l}try{y(t,{onObjectBegin:(m,A)=>{if(s<=m)throw r;a=void 0,u=s>m,i.push("")},onObjectProperty:(m,A,_)=>{if(s<A||(d(m,A,_,"property"),i[i.length-1]=m,s<=A+_))throw r},onObjectEnd:(m,A)=>{if(s<=m)throw r;a=void 0,i.pop()},onArrayBegin:(m,A)=>{if(s<=m)throw r;a=void 0,i.push(0)},onArrayEnd:(m,A)=>{if(s<=m)throw r;a=void 0,i.pop()},onLiteralValue:(m,A,_)=>{if(s<A||(d(m,A,_,o(m)),s<=A+_))throw r},onSeparator:(m,A,_)=>{if(s<=A)throw r;if(m===":"&&a&&a.type==="property")a.colonOffset=A,u=!1,a=void 0;else if(m===","){const w=i[i.length-1];typeof w=="number"?i[i.length-1]=w+1:(u=!0,i[i.length-1]=""),a=void 0}}})}catch(m){if(m!==r)throw m}return{path:i,previousNode:a,isAtPropertyKey:u,matches:m=>{let A=0;for(let _=0;A<m.length&&_<i.length;_++)if(m[A]===i[_]||m[A]==="*")A++;else if(m[A]!=="**")return!1;return A===m.length}}}e.getLocation=C;function g(t,s=[],i=T.DEFAULT){let r=null,a=[];const l=[];function u(m){Array.isArray(a)?a.push(m):r!==null&&(a[r]=m)}return y(t,{onObjectBegin:()=>{const m={};u(m),l.push(a),a=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const m=[];u(m),l.push(a),a=m,r=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:u,onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},i),a[0]}e.parse=g;function b(t,s=[],i=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(m){r.type==="property"&&(r.length=m-r.offset,r=r.parent)}function l(m){return r.children.push(m),m}y(t,{onObjectBegin:m=>{r=l({type:"object",offset:m,length:-1,parent:r,children:[]})},onObjectProperty:(m,A,_)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:m,offset:A,length:_,parent:r})},onObjectEnd:(m,A)=>{r.length=m+A-r.offset,r=r.parent,a(m+A)},onArrayBegin:(m,A)=>{r=l({type:"array",offset:m,length:-1,parent:r,children:[]})},onArrayEnd:(m,A)=>{r.length=m+A-r.offset,r=r.parent,a(m+A)},onLiteralValue:(m,A,_)=>{l({type:o(m),offset:A,length:_,parent:r,value:m}),a(A+_)},onSeparator:(m,A,_)=>{r.type==="property"&&(m===":"?r.colonOffset=A:m===","&&a(A))},onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},i);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=b;function h(t,s){if(!t)return;let i=t;for(let r of s)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===r){i=l.children[1],a=!0;break}if(!a)return}else{const a=r;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}e.findNodeAtLocation=h;function p(t){if(!t.parent||!t.parent.children)return[];const s=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=p;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let i of t.children){const r=i.children[1];r&&(s[i.children[0].value]=f(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function E(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=E;function v(t,s,i=!1){if(E(t,s,i)){const r=t.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=s;a++){const l=v(r[a],s,i);if(l)return l}return t}}e.findNodeAtOffset=v;function y(t,s,i=T.DEFAULT){const r=L(t,!1);function a(W){return W?()=>W(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(W){return W?X=>W(X,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),d=l(s.onObjectProperty),m=a(s.onObjectEnd),A=a(s.onArrayBegin),_=a(s.onArrayEnd),w=l(s.onLiteralValue),U=l(s.onSeparator),O=a(s.onComment),$=l(s.onError),K=i&&i.disallowComments,M=i&&i.allowTrailingComma;function H(){for(;;){const W=r.scan();switch(r.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:K||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(W){case 12:case 13:K?j(10):O();break;case 16:j(1);break;case 15:case 14:break;default:return W}}}function j(W,X=[],Z=[]){if($(W),X.length+Z.length>0){let B=r.getToken();for(;B!==17;){if(X.indexOf(B)!==-1){H();break}else if(Z.indexOf(B)!==-1)break;B=H()}}}function z(W){const X=r.getTokenValue();return W?w(X):d(X),H(),!0}function q(){switch(r.getToken()){case 11:let W=0;try{W=JSON.parse(r.getTokenValue()),typeof W!="number"&&(j(2),W=0)}catch(X){j(2)}w(W);break;case 7:w(null);break;case 8:w(!0);break;case 9:w(!1);break;default:return!1}return H(),!0}function F(){return r.getToken()!==10?(j(3,[],[2,5]),!1):(z(!1),r.getToken()===6?(U(":"),H(),N()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function G(){u(),H();let W=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(W||j(4,[],[]),U(","),H(),r.getToken()===2&&M)break}else W&&j(6,[],[]);F()||j(4,[],[2,5]),W=!0}return m(),r.getToken()!==2?j(7,[2],[]):H(),!0}function x(){A(),H();let W=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(W||j(4,[],[]),U(","),H(),r.getToken()===4&&M)break}else W&&j(6,[],[]);N()||j(4,[],[4,5]),W=!0}return _(),r.getToken()!==4?j(8,[4],[]):H(),!0}function N(){switch(r.getToken()){case 3:return x();case 1:return G();case 10:return z(!0);default:return q()}}return H(),r.getToken()===17?i.allowEmptyContent?!0:(j(4,[],[]),!1):N()?(r.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=y;function c(t,s){let i=L(t),r=[],a,l=0,u;do switch(u=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:l!==u&&r.push(t.substring(l,u)),s!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,s)),l=i.getPosition();break}while(a!==17);return r.join("")}e.stripComments=c;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(te[48],ne([0,1,36]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(S,I,n){let C,g,b,h,p;if(I){for(h=I.offset,p=h+I.length,b=h;b>0&&!P(S,b-1);)b--;let l=p;for(;l<S.length&&!P(S,l);)l++;g=S.substring(b,l),C=T(g,n)}else g=S,C=0,b=0,h=0,p=S.length;const f=L(n,S);let E=!1,v=0,y;n.insertSpaces?y=D(" ",n.tabSize||4):y="	";const c=(0,R.createScanner)(g,!1);let o=!1;function t(){return f+D(y,C+v)}function s(){let l=c.scan();for(E=!1;l===15||l===14;)E=E||l===14,l=c.scan();return o=l===16||c.getTokenError()!==0,l}const i=[];function r(l,u,d){!o&&u<p&&d>h&&S.substring(u,d)!==l&&i.push({offset:u,length:d-u,content:l})}let a=s();if(a!==17){const l=c.getTokenOffset()+b,u=D(y,C);r(u,b,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+b,u=s(),d="";for(;!E&&(u===12||u===13);){const A=c.getTokenOffset()+b;r(" ",l,A),l=c.getTokenOffset()+c.getTokenLength()+b,d=u===12?t():"",u=s()}if(u===2)a!==1&&(v--,d=t());else if(u===4)a!==3&&(v--,d=t());else{switch(a){case 3:case 1:v++,d=t();break;case 5:case 12:d=t();break;case 13:E?d=t():d=" ";break;case 6:d=" ";break;case 10:if(u===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?d=" ":u!==5&&u!==17&&(o=!0);break;case 16:o=!0;break}E&&(u===12||u===13)&&(d=t())}const m=c.getTokenOffset()+b;r(d,l,m),a=u}return i}e.format=k;function D(S,I){let n="";for(let C=0;C<I;C++)n+=S;return n}function T(S,I){let n=0,C=0;const g=I.tabSize||4;for(;n<S.length;){const b=S.charAt(n);if(b===" ")C++;else if(b==="	")C+=g;else break;n++}return Math.floor(C/g)}function L(S,I){for(let n=0;n<I.length;n++){const C=I.charAt(n);if(C==="\r")return n+1<I.length&&I.charAt(n+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=L;function P(S,I){return`\r
`.indexOf(S.charAt(I))!==-1}e.isEOL=P}),define(te[44],ne([0,1,36,48]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(I,n,C){return T(I,n,void 0,C)}e.removeProperty=D;function T(I,n,C,g,b){const h=n.slice(),p=[],f=(0,R.parseTree)(I,p);let E,v;for(;h.length>0&&(v=h.pop(),E=(0,R.findNodeAtLocation)(f,h),E===void 0&&C!==void 0);)typeof v=="string"?C={[v]:C}:C=[C];if(E)if(E.type==="object"&&typeof v=="string"&&Array.isArray(E.children)){const y=(0,R.findNodeAtLocation)(E,[v]);if(y!==void 0)if(C===void 0){if(!y.parent)throw new Error("Malformed AST");const c=E.children.indexOf(y.parent);let o,t=y.parent.offset+y.parent.length;if(c>0){const s=E.children[c-1];o=s.offset+s.length}else o=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return L(I,{offset:o,length:t-o,content:""},g)}else return L(I,{offset:y.offset,length:y.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const c=`${JSON.stringify(v)}: ${JSON.stringify(C)}`,o=b?b(E.children.map(s=>s.children[0].value)):E.children.length;let t;if(o>0){const s=E.children[o-1];t={offset:s.offset+s.length,length:0,content:","+c}}else E.children.length===0?t={offset:E.offset+1,length:0,content:c}:t={offset:E.offset+1,length:0,content:c+","};return L(I,t,g)}}else if(E.type==="array"&&typeof v=="number"&&Array.isArray(E.children))if(C!==void 0){const y=`${JSON.stringify(C)}`;let c;if(E.children.length===0||v===0)c={offset:E.offset+1,length:0,content:E.children.length===0?y:y+","};else{const o=v===-1||v>E.children.length?E.children.length:v,t=E.children[o-1];c={offset:t.offset+t.length,length:0,content:","+y}}return L(I,c,g)}else{const y=v,c=E.children[y];let o;if(E.children.length===1)o={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===y){const t=E.children[y-1],s=t.offset+t.length,i=E.offset+E.length;o={offset:s,length:i-2-s,content:""}}else o={offset:c.offset,length:E.children[y+1].offset-c.offset,content:""};return L(I,o,g)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${E.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return L(I,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(C)},g)}}e.setProperty=T;function L(I,n,C){let g=P(I,n),b=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;b>0&&!(0,k.isEOL)(g,b-1);)b--;for(;h<g.length&&!(0,k.isEOL)(g,h);)h++}const p=(0,k.format)(g,{offset:b,length:h-b},C);for(let E=p.length-1;E>=0;E--){const v=p[E];g=P(g,v),b=Math.min(b,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const f=I.length-(g.length-h)-b;return[{offset:b,length:f,content:g.substring(b,h)}]}e.withFormatting=L;function P(I,n){return I.substring(0,n.offset)+n.content+I.substring(n.offset+n.length)}e.applyEdit=P;function S(I,n){let C=n.slice(0).sort((b,h)=>{const p=b.offset-h.offset;return p===0?b.length-h.length:p}),g=I.length;for(let b=C.length-1;b>=0;b--){let h=C[b];if(h.offset+h.length<=g)I=P(I,h);else throw new Error("Overlapping edit");g=h.offset}return I}e.applyEdits=S}),define(te[2],ne([0,1,67,55]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let T=null;function L(r){T=r}if(e.setDisposableTracker=L,D){const r="__is_disposable_tracked__";L(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==v.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function P(r){return T?.trackDisposable(r),r}function S(r){T?.markAsDisposed(r)}function I(r,a){T?.setParent(r,a)}function n(r,a){if(!!T)for(const l of r)T.setParent(l,a)}function C(r){return T?.markAsSingleton(r),r}e.markAsSingleton=C;class g extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=g;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=b;function h(r){if(k.Iterable.is(r)){let a=[];for(const l of r)if(l)try{l.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new g(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function p(...r){const a=f(()=>h(r));return n(r,a),a}e.combinedDisposable=p;function f(r){const a=P({dispose:(0,R.once)(()=>{S(a),r()})});return a}e.toDisposable=f;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return I(a,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new E,P(this),I(this._store,this)}dispose(){S(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&I(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&I(a,null),a}}e.MutableDisposable=y;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class o{constructor(){this.references=new Map}acquire(a,...l){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...l)},this.references.set(a,u));const{object:d}=u,m=(0,R.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:d,dispose:m}}}e.ReferenceCollection=o;class t{constructor(a){this.referenceCollection=a}async acquire(a,...l){const u=this.referenceCollection.acquire(a,...l);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function i(r){const a=new E;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=i}),define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class k{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const L=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=L}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,L){const P=new R(T);if(this._first===R.Undefined)this._first=P,this._last=P;else if(L){const I=this._last;this._last=P,P.prev=I,I.next=P}else{const I=this._first;this._first=P,P.next=I,I.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(){function J(D){const T=[];typeof D=="number"&&T.push("code/timeOrigin",D);function L(S){T.push(S,Date.now())}function P(){const S=[];for(let I=0;I<T.length;I+=2)S.push({name:T[I],startTime:T[I+1]});return S}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(D+L.startTime)});return T}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=R(k))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let k=!1,D=!1,T=!1,L=!1,P=!1,S=!1,I=!1,n,C=R,g,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const p=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=p&&h?.sandboxed,typeof navigator=="object"&&!p)b=navigator.userAgent,k=b.indexOf("Windows")>=0,D=b.indexOf("Macintosh")>=0,I=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=b.indexOf("Linux")>=0,S=!0,n=navigator.language,C=n;else if(typeof h=="object"){k=h.platform==="win32",D=h.platform==="darwin",T=h.platform==="linux",L=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=R,C=R;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const r=JSON.parse(i),a=r.availableLanguages["*"];n=r.locale,C=a||R,g=r._translationsConfigFile}catch(r){}P=!0}else console.error("Unable to resolve platform.");var f;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function E(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let v=0;D?v=1:k?v=3:T&&(v=2),e.isWindows=k,e.isMacintosh=D,e.isLinux=T,e.isLinuxSnap=L,e.isNative=P,e.isWeb=S,e.isIOS=I,e.platform=v,e.userAgent=b,e.language=C;var y;(function(i){function r(){return e.language}i.value=r;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=a;function l(){return e.language==="en"}i.isDefault=l})(y=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let d=0,m=a.length;d<m;d++){const A=a[d];if(A.id===u.data.vscodeSetImmediateId){a.splice(d,1),A.callback();return}}});let l=0;return u=>{const d=++l;a.push({id:d,callback:u}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const r=Promise.resolve();return a=>r.then(a)}();var c;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||I?2:k?1:3;let o=!0,t=!1;function s(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,o=new Uint16Array(i.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;k={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(T){return(0,R.setImmediate)(T)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:k={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick,e.arch=k.arch}),define(te[9],ne([0,1,31]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,D=97,T=90,L=122,P=46,S=47,I=92,n=58,C=63;class g extends Error{constructor(c,o,t){let s;typeof o=="string"&&o.indexOf("not ")===0?(s="must not be",o=o.replace(/^not /,"")):s="must be";const i=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${i} ${s} of type ${o}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function b(y,c){if(typeof y!="string")throw new g(c,"string",y)}function h(y){return y===S||y===I}function p(y){return y===S}function f(y){return y>=k&&y<=T||y>=D&&y<=L}function E(y,c,o,t){let s="",i=0,r=-1,a=0,l=0;for(let u=0;u<=y.length;++u){if(u<y.length)l=y.charCodeAt(u);else{if(t(l))break;l=S}if(t(l)){if(!(r===u-1||a===1))if(a===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(o);d===-1?(s="",i=0):(s=s.slice(0,d),i=s.length-1-s.lastIndexOf(o)),r=u,a=0;continue}else if(s.length!==0){s="",i=0,r=u,a=0;continue}}c&&(s+=s.length>0?`${o}..`:"..",i=2)}else s.length>0?s+=`${o}${y.slice(r+1,u)}`:s=y.slice(r+1,u),i=u-r-1;r=u,a=0}else l===P&&a!==-1?++a:a=-1}return s}function v(y,c){if(c===null||typeof c!="object")throw new g("pathObject","Object",c);const o=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return o?o===c.root?`${o}${t}`:`${o}${y}${t}`:t}e.win32={resolve(...y){let c="",o="",t=!1;for(let s=y.length-1;s>=-1;s--){let i;if(s>=0){if(i=y[s],b(i,"path"),i.length===0)continue}else c.length===0?i=R.cwd():(i=R.env[`=${c}`]||R.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==c.toLowerCase()&&i.charCodeAt(2)===I)&&(i=`${c}\\`));const r=i.length;let a=0,l="",u=!1;const d=i.charCodeAt(0);if(r===1)h(d)&&(a=1,u=!0);else if(h(d))if(u=!0,h(i.charCodeAt(1))){let m=2,A=m;for(;m<r&&!h(i.charCodeAt(m));)m++;if(m<r&&m!==A){const _=i.slice(A,m);for(A=m;m<r&&h(i.charCodeAt(m));)m++;if(m<r&&m!==A){for(A=m;m<r&&!h(i.charCodeAt(m));)m++;(m===r||m!==A)&&(l=`\\\\${_}\\${i.slice(A,m)}`,a=m)}}}else a=1;else f(d)&&i.charCodeAt(1)===n&&(l=i.slice(0,2),a=2,r>2&&h(i.charCodeAt(2))&&(u=!0,a=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(o=`${i.slice(a)}\\${o}`,t=u,u&&c.length>0)break}return o=E(o,!t,"\\",h),t?`${c}\\${o}`:`${c}${o}`||"."},normalize(y){b(y,"path");const c=y.length;if(c===0)return".";let o=0,t,s=!1;const i=y.charCodeAt(0);if(c===1)return p(i)?"\\":y;if(h(i))if(s=!0,h(y.charCodeAt(1))){let a=2,l=a;for(;a<c&&!h(y.charCodeAt(a));)a++;if(a<c&&a!==l){const u=y.slice(l,a);for(l=a;a<c&&h(y.charCodeAt(a));)a++;if(a<c&&a!==l){for(l=a;a<c&&!h(y.charCodeAt(a));)a++;if(a===c)return`\\\\${u}\\${y.slice(l)}\\`;a!==l&&(t=`\\\\${u}\\${y.slice(l,a)}`,o=a)}}}else o=1;else f(i)&&y.charCodeAt(1)===n&&(t=y.slice(0,2),o=2,c>2&&h(y.charCodeAt(2))&&(s=!0,o=3));let r=o<c?E(y.slice(o),!s,"\\",h):"";return r.length===0&&!s&&(r="."),r.length>0&&h(y.charCodeAt(c-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(y){b(y,"path");const c=y.length;if(c===0)return!1;const o=y.charCodeAt(0);return h(o)||c>2&&f(o)&&y.charCodeAt(1)===n&&h(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let c,o;for(let i=0;i<y.length;++i){const r=y[i];b(r,"path"),r.length>0&&(c===void 0?c=o=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,s=0;if(typeof o=="string"&&h(o.charCodeAt(0))){++s;const i=o.length;i>1&&h(o.charCodeAt(1))&&(++s,i>2&&(h(o.charCodeAt(2))?++s:t=!1))}if(t){for(;s<c.length&&h(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(y,c){if(b(y,"from"),b(c,"to"),y===c)return"";const o=e.win32.resolve(y),t=e.win32.resolve(c);if(o===t||(y=o.toLowerCase(),c=t.toLowerCase(),y===c))return"";let s=0;for(;s<y.length&&y.charCodeAt(s)===I;)s++;let i=y.length;for(;i-1>s&&y.charCodeAt(i-1)===I;)i--;const r=i-s;let a=0;for(;a<c.length&&c.charCodeAt(a)===I;)a++;let l=c.length;for(;l-1>a&&c.charCodeAt(l-1)===I;)l--;const u=l-a,d=r<u?r:u;let m=-1,A=0;for(;A<d;A++){const w=y.charCodeAt(s+A);if(w!==c.charCodeAt(a+A))break;w===I&&(m=A)}if(A!==d){if(m===-1)return t}else{if(u>d){if(c.charCodeAt(a+A)===I)return t.slice(a+A+1);if(A===2)return t.slice(a+A)}r>d&&(y.charCodeAt(s+A)===I?m=A:A===2&&(m=3)),m===-1&&(m=0)}let _="";for(A=s+m+1;A<=i;++A)(A===i||y.charCodeAt(A)===I)&&(_+=_.length===0?"..":"\\..");return a+=m,_.length>0?`${_}${t.slice(a,l)}`:(t.charCodeAt(a)===I&&++a,t.slice(a,l))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const c=e.win32.resolve(y);if(c.length<=2)return y;if(c.charCodeAt(0)===I){if(c.charCodeAt(1)===I){const o=c.charCodeAt(2);if(o!==C&&o!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(f(c.charCodeAt(0))&&c.charCodeAt(1)===n&&c.charCodeAt(2)===I)return`\\\\?\\${c}`;return y},dirname(y){b(y,"path");const c=y.length;if(c===0)return".";let o=-1,t=0;const s=y.charCodeAt(0);if(c===1)return h(s)?y:".";if(h(s)){if(o=t=1,h(y.charCodeAt(1))){let a=2,l=a;for(;a<c&&!h(y.charCodeAt(a));)a++;if(a<c&&a!==l){for(l=a;a<c&&h(y.charCodeAt(a));)a++;if(a<c&&a!==l){for(l=a;a<c&&!h(y.charCodeAt(a));)a++;if(a===c)return y;a!==l&&(o=t=a+1)}}}}else f(s)&&y.charCodeAt(1)===n&&(o=c>2&&h(y.charCodeAt(2))?3:2,t=o);let i=-1,r=!0;for(let a=c-1;a>=t;--a)if(h(y.charCodeAt(a))){if(!r){i=a;break}}else r=!1;if(i===-1){if(o===-1)return".";i=o}return y.slice(0,i)},basename(y,c){c!==void 0&&b(c,"ext"),b(y,"path");let o=0,t=-1,s=!0,i;if(y.length>=2&&f(y.charCodeAt(0))&&y.charCodeAt(1)===n&&(o=2),c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let r=c.length-1,a=-1;for(i=y.length-1;i>=o;--i){const l=y.charCodeAt(i);if(h(l)){if(!s){o=i+1;break}}else a===-1&&(s=!1,a=i+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=a))}return o===t?t=a:t===-1&&(t=y.length),y.slice(o,t)}for(i=y.length-1;i>=o;--i)if(h(y.charCodeAt(i))){if(!s){o=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":y.slice(o,t)},extname(y){b(y,"path");let c=0,o=-1,t=0,s=-1,i=!0,r=0;y.length>=2&&y.charCodeAt(1)===n&&f(y.charCodeAt(0))&&(c=t=2);for(let a=y.length-1;a>=c;--a){const l=y.charCodeAt(a);if(h(l)){if(!i){t=a+1;break}continue}s===-1&&(i=!1,s=a+1),l===P?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===t+1?"":y.slice(o,s)},format:v.bind(null,"\\"),parse(y){b(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const o=y.length;let t=0,s=y.charCodeAt(0);if(o===1)return h(s)?(c.root=c.dir=y,c):(c.base=c.name=y,c);if(h(s)){if(t=1,h(y.charCodeAt(1))){let m=2,A=m;for(;m<o&&!h(y.charCodeAt(m));)m++;if(m<o&&m!==A){for(A=m;m<o&&h(y.charCodeAt(m));)m++;if(m<o&&m!==A){for(A=m;m<o&&!h(y.charCodeAt(m));)m++;m===o?t=m:m!==A&&(t=m+1)}}}}else if(f(s)&&y.charCodeAt(1)===n){if(o<=2)return c.root=c.dir=y,c;if(t=2,h(y.charCodeAt(2))){if(o===3)return c.root=c.dir=y,c;t=3}}t>0&&(c.root=y.slice(0,t));let i=-1,r=t,a=-1,l=!0,u=y.length-1,d=0;for(;u>=t;--u){if(s=y.charCodeAt(u),h(s)){if(!l){r=u+1;break}continue}a===-1&&(l=!1,a=u+1),s===P?i===-1?i=u:d!==1&&(d=1):i!==-1&&(d=-1)}return a!==-1&&(i===-1||d===0||d===1&&i===a-1&&i===r+1?c.base=c.name=y.slice(r,a):(c.name=y.slice(r,i),c.base=y.slice(r,a),c.ext=y.slice(i,a))),r>0&&r!==t?c.dir=y.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let c="",o=!1;for(let t=y.length-1;t>=-1&&!o;t--){const s=t>=0?y[t]:R.cwd();b(s,"path"),s.length!==0&&(c=`${s}/${c}`,o=s.charCodeAt(0)===S)}return c=E(c,!o,"/",p),o?`/${c}`:c.length>0?c:"."},normalize(y){if(b(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===S,o=y.charCodeAt(y.length-1)===S;return y=E(y,!c,"/",p),y.length===0?c?"/":o?"./":".":(o&&(y+="/"),c?`/${y}`:y)},isAbsolute(y){return b(y,"path"),y.length>0&&y.charCodeAt(0)===S},join(...y){if(y.length===0)return".";let c;for(let o=0;o<y.length;++o){const t=y[o];b(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(y,c){if(b(y,"from"),b(c,"to"),y===c||(y=e.posix.resolve(y),c=e.posix.resolve(c),y===c))return"";const o=1,t=y.length,s=t-o,i=1,r=c.length-i,a=s<r?s:r;let l=-1,u=0;for(;u<a;u++){const m=y.charCodeAt(o+u);if(m!==c.charCodeAt(i+u))break;m===S&&(l=u)}if(u===a)if(r>a){if(c.charCodeAt(i+u)===S)return c.slice(i+u+1);if(u===0)return c.slice(i+u)}else s>a&&(y.charCodeAt(o+u)===S?l=u:u===0&&(l=0));let d="";for(u=o+l+1;u<=t;++u)(u===t||y.charCodeAt(u)===S)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(i+l)}`},toNamespacedPath(y){return y},dirname(y){if(b(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===S;let o=-1,t=!0;for(let s=y.length-1;s>=1;--s)if(y.charCodeAt(s)===S){if(!t){o=s;break}}else t=!1;return o===-1?c?"/":".":c&&o===1?"//":y.slice(0,o)},basename(y,c){c!==void 0&&b(c,"ext"),b(y,"path");let o=0,t=-1,s=!0,i;if(c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let r=c.length-1,a=-1;for(i=y.length-1;i>=0;--i){const l=y.charCodeAt(i);if(l===S){if(!s){o=i+1;break}}else a===-1&&(s=!1,a=i+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=a))}return o===t?t=a:t===-1&&(t=y.length),y.slice(o,t)}for(i=y.length-1;i>=0;--i)if(y.charCodeAt(i)===S){if(!s){o=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":y.slice(o,t)},extname(y){b(y,"path");let c=-1,o=0,t=-1,s=!0,i=0;for(let r=y.length-1;r>=0;--r){const a=y.charCodeAt(r);if(a===S){if(!s){o=r+1;break}continue}t===-1&&(s=!1,t=r+1),a===P?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||t===-1||i===0||i===1&&c===t-1&&c===o+1?"":y.slice(c,t)},format:v.bind(null,"/"),parse(y){b(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const o=y.charCodeAt(0)===S;let t;o?(c.root="/",t=1):t=0;let s=-1,i=0,r=-1,a=!0,l=y.length-1,u=0;for(;l>=t;--l){const d=y.charCodeAt(l);if(d===S){if(!a){i=l+1;break}continue}r===-1&&(a=!1,r=l+1),d===P?s===-1?s=l:u!==1&&(u=1):s!==-1&&(u=-1)}if(r!==-1){const d=i===0&&o?1:i;s===-1||u===0||u===1&&s===r-1&&s===i+1?c.base=c.name=y.slice(d,r):(c.name=y.slice(d,s),c.base=y.slice(d,r),c.ext=y.slice(s,r))}return i>0?c.dir=y.slice(0,i-1):o&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var k;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(T,...L){const P=L.reduce((n,C)=>(n[C]=!0,n),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(n=>!P[n]).forEach(n=>{for(let C=0;C<S.length;C++)if(n.search(S[C])!==-1){delete T[n];break}})}e.sanitizeProcessEnvironment=D}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var k in R)(typeof exports=="object"?exports:J)[k]=R[k]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function R(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return J[k].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=J,R.c=e,R.d=function(k,D,T){R.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:T})},R.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},R.t=function(k,D){if(1&D&&(k=R(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var L in k)R.d(T,L,function(P){return k[P]}.bind(null,L));return T},R.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return R.d(D,"a",D),D},R.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},R.p="",R(R.s=0)}([function(J,e,R){(function(k){var D;e=J.exports=Z,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],I=0,n=I++;S[n]="0|[1-9]\\d*";var C=I++;S[C]="[0-9]+";var g=I++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=I++;S[b]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var h=I++;S[h]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var p=I++;S[p]="(?:"+S[n]+"|"+S[g]+")";var f=I++;S[f]="(?:"+S[C]+"|"+S[g]+")";var E=I++;S[E]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var v=I++;S[v]="(?:-?("+S[f]+"(?:\\."+S[f]+")*))";var y=I++;S[y]="[0-9A-Za-z-]+";var c=I++;S[c]="(?:\\+("+S[y]+"(?:\\."+S[y]+")*))";var o=I++,t="v?"+S[b]+S[E]+"?"+S[c]+"?";S[o]="^"+t+"$";var s="[v=\\s]*"+S[h]+S[v]+"?"+S[c]+"?",i=I++;S[i]="^"+s+"$";var r=I++;S[r]="((?:<|>)?=?)";var a=I++;S[a]=S[C]+"|x|X|\\*";var l=I++;S[l]=S[n]+"|x|X|\\*";var u=I++;S[u]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[E]+")?"+S[c]+"?)?)?";var d=I++;S[d]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[v]+")?"+S[c]+"?)?)?";var m=I++;S[m]="^"+S[r]+"\\s*"+S[u]+"$";var A=I++;S[A]="^"+S[r]+"\\s*"+S[d]+"$";var _=I++;S[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=I++;S[w]="(?:~>?)";var U=I++;S[U]="(\\s*)"+S[w]+"\\s+",P[U]=new RegExp(S[U],"g");var O=I++;S[O]="^"+S[w]+S[u]+"$";var $=I++;S[$]="^"+S[w]+S[d]+"$";var K=I++;S[K]="(?:\\^)";var M=I++;S[M]="(\\s*)"+S[K]+"\\s+",P[M]=new RegExp(S[M],"g");var H=I++;S[H]="^"+S[K]+S[u]+"$";var j=I++;S[j]="^"+S[K]+S[d]+"$";var z=I++;S[z]="^"+S[r]+"\\s*("+s+")$|^$";var q=I++;S[q]="^"+S[r]+"\\s*("+t+")$|^$";var F=I++;S[F]="(\\s*)"+S[r]+"\\s*("+s+"|"+S[u]+")",P[F]=new RegExp(S[F],"g");var G=I++;S[G]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var x=I++;S[x]="^\\s*("+S[d]+")\\s+-\\s+("+S[d]+")\\s*$";var N=I++;S[N]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)D(W,S[W]),P[W]||(P[W]=new RegExp(S[W]));function X(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>T||!(oe?P[i]:P[o]).test(ee))return null;try{return new Z(ee,oe)}catch(ce){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Z))return new Z(ee,oe);D("SemVer",ee,oe),this.loose=oe;var ce=ee.trim().match(oe?P[i]:P[o]);if(!ce)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Se=+ye;if(Se>=0&&Se<L)return Se}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=X,e.valid=function(ee,oe){var ce=X(ee,oe);return ce?ce.version:null},e.clean=function(ee,oe){var ce=X(ee.trim().replace(/^[=v]+/,""),oe);return ce?ce.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),V(this.major,ee.major)||V(this.minor,ee.minor)||V(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ce=this.prerelease[oe],ye=ee.prerelease[oe];if(D("prerelease compare",oe,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return V(ce,ye)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new Z(ee,ce).inc(oe,ye).version}catch(Se){return null}},e.diff=function(ee,oe){if(ue(ee,oe))return null;var ce=X(ee),ye=X(oe);if(ce.prerelease.length||ye.prerelease.length){for(var Se in ce)if((Se==="major"||Se==="minor"||Se==="patch")&&ce[Se]!==ye[Se])return"pre"+Se;return"prerelease"}for(var Se in ce)if((Se==="major"||Se==="minor"||Se==="patch")&&ce[Se]!==ye[Se])return Se},e.compareIdentifiers=V;var B=/^[0-9]+$/;function V(ee,oe){var ce=B.test(ee),ye=B.test(oe);return ce&&ye&&(ee=+ee,oe=+oe),ce&&!ye?-1:ye&&!ce?1:ee<oe?-1:ee>oe?1:0}function ie(ee,oe,ce){return new Z(ee,ce).compare(new Z(oe,ce))}function re(ee,oe,ce){return ie(ee,oe,ce)>0}function ae(ee,oe,ce){return ie(ee,oe,ce)<0}function ue(ee,oe,ce){return ie(ee,oe,ce)===0}function fe(ee,oe,ce){return ie(ee,oe,ce)!==0}function ge(ee,oe,ce){return ie(ee,oe,ce)>=0}function Ie(ee,oe,ce){return ie(ee,oe,ce)<=0}function Pe(ee,oe,ce,ye){var Se;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),Se=ee===ce;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),Se=ee!==ce;break;case"":case"=":case"==":Se=ue(ee,ce,ye);break;case"!=":Se=fe(ee,ce,ye);break;case">":Se=re(ee,ce,ye);break;case">=":Se=ge(ee,ce,ye);break;case"<":Se=ae(ee,ce,ye);break;case"<=":Se=Ie(ee,ce,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return Se}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);D("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,oe){return V(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=ie,e.compareLoose=function(ee,oe){return ie(ee,oe,!0)},e.rcompare=function(ee,oe,ce){return ie(oe,ee,ce)},e.sort=function(ee,oe){return ee.sort(function(ce,ye){return e.compare(ce,ye,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ce,ye){return e.rcompare(ce,ye,oe)})},e.gt=re,e.lt=ae,e.eq=ue,e.neq=fe,e.gte=ge,e.lte=Ie,e.cmp=Pe,e.Comparator=Ee;var _e={};function De(ee,oe){if(ee instanceof De)return ee.loose===oe?ee:new De(ee.raw,oe);if(ee instanceof Ee)return new De(ee.value,oe);if(!(this instanceof De))return new De(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ke(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ce,ye,Se,Oe,Te,Ue,Ae,Y,se,le,de){return((oe=ke(ce)?"":ke(ye)?">="+ce+".0.0":ke(Se)?">="+ce+"."+ye+".0":">="+oe)+" "+(Ue=ke(Ae)?"":ke(Y)?"<"+(+Ae+1)+".0.0":ke(se)?"<"+Ae+"."+(+Y+1)+".0":le?"<="+Ae+"."+Y+"."+se+"-"+le:"<="+Ue)).trim()}function Ne(ee,oe){for(var ce=0;ce<ee.length;ce++)if(!ee[ce].test(oe))return!1;if(oe.prerelease.length){for(ce=0;ce<ee.length;ce++)if(D(ee[ce].semver),ee[ce].semver!==_e&&ee[ce].semver.prerelease.length>0){var ye=ee[ce].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function ze(ee,oe,ce){try{oe=new De(oe,ce)}catch(ye){return!1}return oe.test(ee)}function xe(ee,oe,ce,ye){var Se,Oe,Te,Ue,Ae;switch(ee=new Z(ee,ye),oe=new De(oe,ye),ce){case">":Se=re,Oe=Ie,Te=ae,Ue=">",Ae=">=";break;case"<":Se=ae,Oe=ge,Te=re,Ue="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(ee,oe,ye))return!1;for(var Y=0;Y<oe.set.length;++Y){var se=oe.set[Y],le=null,de=null;if(se.forEach(function(me){me.semver===_e&&(me=new Ee(">=0.0.0")),le=le||me,de=de||me,Se(me.semver,le.semver,ye)?le=me:Te(me.semver,de.semver,ye)&&(de=me)}),le.operator===Ue||le.operator===Ae||(!de.operator||de.operator===Ue)&&Oe(ee,de.semver)||de.operator===Ae&&Te(ee,de.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?P[z]:P[q],ce=ee.match(oe);if(!ce)throw new TypeError("Invalid comparator: "+ee);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new Z(ce[2],this.loose):this.semver=_e},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===_e||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Pe(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new De(ee.value,oe),ze(this.value,ce,oe);if(ee.operator==="")return ce=new De(this.value,oe),ze(ee.semver,ce,oe);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Oe=this.semver.version===ee.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ue=Pe(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ae=Pe(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||Se||Oe&&Te||Ue||Ae},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),D("range",ee,oe);var ce=oe?P[x]:P[G];ee=ee.replace(ce,Fe),D("hyphen replace",ee),ee=ee.replace(P[F],"$1$2$3"),D("comparator trim",ee,P[F]),ee=(ee=(ee=ee.replace(P[U],"$1~")).replace(P[M],"$1^")).split(/\s+/).join(" ");var ye=oe?P[z]:P[q],Se=ee.split(" ").map(function(Oe){return function(Te,Ue){return D("comp",Te),Te=function(Ae,Y){return Ae.trim().split(/\s+/).map(function(se){return function(le,de){D("caret",le,de);var me=de?P[j]:P[H];return le.replace(me,function(be,pe,we,Ce,Re){var Le;return D("caret",le,be,pe,we,Ce,Re),ke(pe)?Le="":ke(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Ce)?Le=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":Re?(D("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+Re+" <"+(+pe+1)+".0.0"):(D("no pr"),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+" <"+(+pe+1)+".0.0"),D("caret return",Le),Le})}(se,Y)}).join(" ")}(Te,Ue),D("caret",Te),Te=function(Ae,Y){return Ae.trim().split(/\s+/).map(function(se){return function(le,de){var me=de?P[$]:P[O];return le.replace(me,function(be,pe,we,Ce,Re){var Le;return D("tilde",le,be,pe,we,Ce,Re),ke(pe)?Le="":ke(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Ce)?Le=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":Re?(D("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Le=">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0"):Le=">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0",D("tilde return",Le),Le})}(se,Y)}).join(" ")}(Te,Ue),D("tildes",Te),Te=function(Ae,Y){return D("replaceXRanges",Ae,Y),Ae.split(/\s+/).map(function(se){return function(le,de){le=le.trim();var me=de?P[A]:P[m];return le.replace(me,function(be,pe,we,Ce,Re,Le){D("xRange",le,be,pe,we,Ce,Re,Le);var nt=ke(we),He=nt||ke(Ce),je=He||ke(Re);return pe==="="&&je&&(pe=""),nt?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(He&&(Ce=0),je&&(Re=0),pe===">"?(pe=">=",He?(we=+we+1,Ce=0,Re=0):je&&(Ce=+Ce+1,Re=0)):pe==="<="&&(pe="<",He?we=+we+1:Ce=+Ce+1),be=pe+we+"."+Ce+"."+Re):He?be=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(be=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),D("xRange return",be),be})}(se,Y)}).join(" ")}(Te,Ue),D("xrange",Te),Te=function(Ae,Y){return D("replaceStars",Ae,Y),Ae.trim().replace(P[N],"")}(Te,Ue),D("stars",Te),Te}(Oe,oe)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Oe){return!!Oe.match(ye)})),Se=Se.map(function(Oe){return new Ee(Oe,oe)})},De.prototype.intersects=function(ee,oe){if(!(ee instanceof De))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ee.set.some(function(Se){return Se.every(function(Oe){return ye.intersects(Oe,oe)})})})})},e.toComparators=function(ee,oe){return new De(ee,oe).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if(Ne(this.set[oe],ee))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(ee,oe,ce){var ye=null,Se=null;try{var Oe=new De(oe,ce)}catch(Te){return null}return ee.forEach(function(Te){Oe.test(Te)&&(ye&&Se.compare(Te)!==-1||(Se=new Z(ye=Te,ce)))}),ye},e.minSatisfying=function(ee,oe,ce){var ye=null,Se=null;try{var Oe=new De(oe,ce)}catch(Te){return null}return ee.forEach(function(Te){Oe.test(Te)&&(ye&&Se.compare(Te)!==1||(Se=new Z(ye=Te,ce)))}),ye},e.validRange=function(ee,oe){try{return new De(ee,oe).range||"*"}catch(ce){return null}},e.ltr=function(ee,oe,ce){return xe(ee,oe,"<",ce)},e.gtr=function(ee,oe,ce){return xe(ee,oe,">",ce)},e.outside=xe,e.prerelease=function(ee,oe){var ce=X(ee,oe);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ee,oe,ce){return ee=new De(ee,ce),oe=new De(oe,ce),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(P[_]);return oe==null?null:X((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,R(1))},function(J,e){var R,k,D=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(f){if(R===setTimeout)return setTimeout(f,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(f,0);try{return R(f,0)}catch(E){try{return R.call(null,f,0)}catch(v){return R.call(this,f,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch(f){R=T}try{k=typeof clearTimeout=="function"?clearTimeout:L}catch(f){k=L}})();var S,I=[],n=!1,C=-1;function g(){n&&S&&(n=!1,S.length?I=S.concat(I):C=-1,I.length&&b())}function b(){if(!n){var f=P(g);n=!0;for(var E=I.length;E;){for(S=I,I=[];++C<E;)S&&S[C].run();C=-1,E=I.length}S=null,n=!1,function(v){if(k===clearTimeout)return clearTimeout(v);if((k===L||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(v);try{k(v)}catch(y){try{return k.call(null,v)}catch(c){return k.call(this,v)}}}(f)}}function h(f,E){this.fun=f,this.array=E}function p(){}D.nextTick=function(f){var E=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)E[v-1]=arguments[v];I.push(new h(f,E)),I.length!==1||n||P(b)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=p,D.addListener=p,D.once=p,D.off=p,D.removeListener=p,D.removeAllListeners=p,D.emit=p,D.prependListener=p,D.prependOnceListener=p,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[102],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(L){this._highResolution=k&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new D(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,8,67,2,100,102]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(c){c.None=()=>D.Disposable.None;function o(M){return(H,j=null,z)=>{let q=!1,F;return F=M(G=>{if(!q)return F?F.dispose():q=!0,H.call(j,G)},null,z),q&&F.dispose(),F}}c.once=o;function t(M,H){return u((j,z=null,q)=>M(F=>j.call(z,H(F)),null,q))}c.map=t;function s(M,H){return u((j,z=null,q)=>M(F=>{H(F),j.call(z,F)},null,q))}c.forEach=s;function i(M,H){return u((j,z=null,q)=>M(F=>H(F)&&j.call(z,F),null,q))}c.filter=i;function r(M){return M}c.signal=r;function a(...M){return(H,j=null,z)=>(0,D.combinedDisposable)(...M.map(q=>q(F=>H.call(j,F),null,z)))}c.any=a;function l(M,H,j){let z=j;return t(M,q=>(z=H(z,q),z))}c.reduce=l;function u(M){let H;const j=new g({onFirstListenerAdd(){H=M(j.fire,j)},onLastListenerRemove(){H.dispose()}});return j.event}function d(M,H,j=100,z=!1,q){let F,G,x,N=0;const W=new g({leakWarningThreshold:q,onFirstListenerAdd(){F=M(X=>{N++,G=H(G,X),z&&!x&&(W.fire(G),G=void 0),clearTimeout(x),x=setTimeout(()=>{const Z=G;G=void 0,x=void 0,(!z||N>1)&&W.fire(Z),N=0},j)})},onLastListenerRemove(){F.dispose()}});return W.event}c.debounce=d;function m(M,H=(j,z)=>j===z){let j=!0,z;return i(M,q=>{const F=j||!H(q,z);return j=!1,z=q,F})}c.latch=m;function A(M,H){return[c.filter(M,H),c.filter(M,j=>!H(j))]}c.split=A;function _(M,H=!1,j=[]){let z=j.slice(),q=M(x=>{z?z.push(x):G.fire(x)});const F=()=>{z&&z.forEach(x=>G.fire(x)),z=null},G=new g({onFirstListenerAdd(){q||(q=M(x=>G.fire(x)))},onFirstListenerDidAdd(){z&&(H?setTimeout(F):F())},onLastListenerRemove(){q&&q.dispose(),q=null}});return G.event}c.buffer=_;class w{constructor(H){this.event=H}map(H){return new w(t(this.event,H))}forEach(H){return new w(s(this.event,H))}filter(H){return new w(i(this.event,H))}reduce(H,j){return new w(l(this.event,H,j))}latch(){return new w(m(this.event))}debounce(H,j=100,z=!1,q){return new w(d(this.event,H,j,z,q))}on(H,j,z){return this.event(H,j,z)}once(H,j,z){return o(this.event)(H,j,z)}}function U(M){return new w(M)}c.chain=U;function O(M,H,j=z=>z){const z=(...x)=>G.fire(j(...x)),q=()=>M.on(H,z),F=()=>M.removeListener(H,z),G=new g({onFirstListenerAdd:q,onLastListenerRemove:F});return G.event}c.fromNodeEventEmitter=O;function $(M,H,j=z=>z){const z=(...x)=>G.fire(j(...x)),q=()=>M.addEventListener(H,z),F=()=>M.removeEventListener(H,z),G=new g({onFirstListenerAdd:q,onLastListenerRemove:F});return G.event}c.fromDOMEventEmitter=$;function K(M){return new Promise(H=>o(M)(H))}c.toPromise=K})(P=e.Event||(e.Event={}));class S{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${S._idPool++}`}start(o){this._stopWatch=new L.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let I=-1;function n(c){const o=I;return I=c,{dispose(){I=o}}}e.setGlobalLeakWarningThreshold=n;class C{constructor(o,t=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let t=I;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||o<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(s)||0;if(this._stacks.set(s,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let r,a=0;for(const[l,u]of this._stacks)(!r||a<u)&&(r=l,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}class g{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=I>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(o,t,s)=>{this._listeners||(this._listeners=new T.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(t?[o,t]:o);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,t);const a=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof D.DisposableStore?s.add(l):Array.isArray(s)&&s.push(l),l}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(i){(0,R.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class b extends g{async fireAsync(o,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,o]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[i,r]=this._asyncDeliveryQueue.shift(),a=[],l={...r,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof i=="function"?i:i[0])),a.push(u)}};try{typeof i=="function"?i.call(void 0,l):i[0].call(i[1],l)}catch(u){(0,R.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const d of u)d.status==="rejected"&&(0,R.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=b;class h extends g{constructor(o){super(o);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=h;class p extends h{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=p;class f extends g{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class E{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const t={event:o,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const i=this.events.indexOf(t);this.events.splice(i,1)};return(0,D.toDisposable)((0,k.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(t=>this.emitter.fire(t))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=E;class v{constructor(){this.buffers=[]}wrapEvent(o){return(t,s,i)=>o(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>t.call(s,r)):t.call(s,r)},void 0,i)}bufferEvents(o){const t=[];this.buffers.push(t);const s=o();return this.buffers.pop(),t.forEach(i=>i()),s}}e.EventBufferer=v;class y{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(te[27],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(P,S){const I=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(I)}}});var D;(function(P){function S(I){return I===P.None||I===P.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(D=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=L}),define(te[49],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(C){const g=this._icons.get(C.id);g?C.description?g.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new k;e.iconRegistry=D;function T(n,C){return new P(n,C)}e.registerCodicon=T;function L(n){return n?n.replace(/\$\((.*?)\)/g,(C,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=L;class P{constructor(C,g,b){this.id=C,this.definition=g,this.description=b,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function S(n,C){const g=["codicon","codicon-"+n];return C&&g.push("codicon-modifier-"+C),g}e.getClassNamesArray=S;var I;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function g(p){if(p instanceof P)return["codicon","codicon-"+p.id];const f=C.exec(p.id);if(!f)return g(P.error);let[,E,v]=f;const y=["codicon","codicon-"+E];return v&&y.push("codicon-modifier-"+v.substr(1)),y}n.asClassNameArray=g;function b(p){return g(p).join(" ")}n.asClassName=b;function h(p){return"."+g(p).join(".")}n.asCSSSelector=h})(I=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,8,2]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(y){const c=y;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=D;function T(y){const c=y;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function L(y,c){return new P(y,c)}e.newWriteableStream=L;class P{constructor(c,o){this.reducer=c,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(o=>o(c))}emitError(c){this.listeners.error.length===0?(0,R.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(o=>o(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,o){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(c,o){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(o);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(y,c){const o=[];let t;for(;(t=y.read())!==null;)o.push(t);return c(o)}e.consumeReadable=S;function I(y,c,o){const t=[];let s;for(;(s=y.read())!==null&&t.length<o;)t.push(s);return s===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return y.read()}}}e.peekReadable=I;function n(y,c){return new Promise((o,t)=>{const s=[];C(y,{onData:i=>{c&&s.push(i)},onError:i=>{c?t(i):o(void 0)},onEnd:()=>{o(c?c(s):void 0)}})})}e.consumeStream=n;function C(y,c){y.on("error",o=>c.onError(o)),y.on("end",()=>c.onEnd()),y.on("data",o=>c.onData(o))}e.listenStream=C;function g(y,c){return new Promise((o,t)=>{const s=new k.DisposableStore,i=[],r=u=>{if(i.push(u),i.length>c)return s.dispose(),y.pause(),o({stream:y,buffer:i,ended:!1})},a=u=>t(u),l=()=>o({stream:y,buffer:i,ended:!0});s.add((0,k.toDisposable)(()=>y.removeListener("error",a))),y.on("error",a),s.add((0,k.toDisposable)(()=>y.removeListener("end",l))),y.on("end",l),s.add((0,k.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=g;function b(y,c){const o=L(c);return o.end(y),o}e.toStream=b;function h(){const y=L(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=h;function p(y){let c=!1;return{read:()=>c?null:(c=!0,y)}}e.toReadable=p;function f(y,c,o){const t=L(o);return C(y,{onData:s=>t.write(c.data(s)),onError:s=>t.error(c.error?c.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function E(y,c,o){let t=!1;return{read:()=>{const s=c.read();return t?s:(t=!0,s!==null?o([y,s]):y)}}}e.prefixedReadable=E;function v(y,c,o){let t=!1;const s=L(o);return C(c,{onData:i=>t?s.write(i):(t=!0,s.write(o([y,i]))),onError:i=>s.error(i),onEnd:()=>{t||(t=!0,s.write(y)),s.end()}}),s}e.prefixedStream=v}),define(te[22],ne([0,1,50]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined";let D,T;class L{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return k?new L(Buffer.allocUnsafe(r)):new L(new Uint8Array(r))}static wrap(r){return k&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new L(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&k?new L(Buffer.from(r)):(D||(D=new TextEncoder),new L(D.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let d=0,m=r.length;d<m;d++)a+=r[d].byteLength}const l=L.alloc(a);let u=0;for(let d=0,m=r.length;d<m;d++){const A=r[d];l.set(A,u),u+=A.byteLength}return l}toString(){return k?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(r,a){return new L(this.buffer.subarray(r,a))}set(r,a){r instanceof L?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return I(this.buffer,r)}writeUInt32BE(r,a){n(this.buffer,r,a)}readUInt32LE(r){return C(this.buffer,r)}writeUInt32LE(r,a){g(this.buffer,r,a)}readUInt8(r){return b(this.buffer,r)}writeUInt8(r,a){h(this.buffer,r,a)}}e.VSBuffer=L;function P(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}e.readUInt16LE=P;function S(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255}e.writeUInt16LE=S;function I(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}e.readUInt32BE=I;function n(i,r,a){i[a+3]=r,r=r>>>8,i[a+2]=r,r=r>>>8,i[a+1]=r,r=r>>>8,i[a]=r}e.writeUInt32BE=n;function C(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}e.readUInt32LE=C;function g(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255,r=r>>>8,i[a+2]=r&255,r=r>>>8,i[a+3]=r&255}e.writeUInt32LE=g;function b(i,r){return i[r]}e.readUInt8=b;function h(i,r,a){i[a]=r}e.writeUInt8=h;function p(i){return R.consumeReadable(i,r=>L.concat(r))}e.readableToBuffer=p;function f(i){return R.toReadable(i)}e.bufferToReadable=f;function E(i){return R.consumeStream(i,r=>L.concat(r))}e.streamToBuffer=E;async function v(i){return i.ended?L.concat(i.buffer):L.concat([...i.buffer,await E(i.stream)])}e.bufferedStreamToBuffer=v;function y(i){return R.toStream(i,r=>L.concat(r))}e.bufferToStream=y;function c(i){return R.transform(i,{data:r=>typeof r=="string"?L.fromString(r):L.wrap(r)},r=>L.concat(r))}e.streamToBufferReadableStream=c;function o(i){return R.newWriteableStream(r=>L.concat(r),i)}e.newWriteableBufferStream=o;function t(i,r){return R.prefixedReadable(i,r,a=>L.concat(a))}e.prefixedBufferReadable=t;function s(i,r){return R.prefixedStream(i,r,a=>L.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=R;const k=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(k,function(le,de){const me=parseInt(de,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=D;const T=/{([^}]+)}/g;function L(Y,se){return Y.replace(T,(le,de)=>se[de]??le)}e.format2=L;function P(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function S(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function I(Y,se){let le=0;const de=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===de&&le++;return le}e.count=I;function n(Y,se,le="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${le}`}e.truncate=n;function C(Y,se=" "){const le=g(Y,se);return b(le,se)}e.trim=C;function g(Y,se){if(!Y||!se)return Y;const le=se.length;if(le===0||Y.length===0)return Y;let de=0;for(;Y.indexOf(se,de)===de;)de=de+le;return Y.substring(de)}e.ltrim=g;function b(Y,se){if(!Y||!se)return Y;const le=se.length,de=Y.length;if(le===0||de===0)return Y;let me=de,be=-1;for(;be=Y.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return Y.substring(0,me)}e.rtrim=b;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p(Y){return Y.replace(/\*/g,"")}e.stripWildcards=p;function f(Y,se,le={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=S(Y)),le.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let de="";return le.global&&(de+="g"),le.matchCase||(de+="i"),le.multiline&&(de+="m"),le.unicode&&(de+="u"),new RegExp(Y,de)}e.createRegExp=f;function E(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function v(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function y(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=y;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function o(Y){for(let se=0,le=Y.length;se<le;se++){const de=Y.charCodeAt(se);if(de!==32&&de!==9)return se}return-1}e.firstNonWhitespaceIndex=o;function t(Y,se=0,le=Y.length){for(let de=se;de<le;de++){const me=Y.charCodeAt(de);if(me!==32&&me!==9)return Y.substring(se,de)}return Y.substring(se,le)}e.getLeadingWhitespace=t;function s(Y,se=Y.length-1){for(let le=se;le>=0;le--){const de=Y.charCodeAt(le);if(de!==32&&de!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function i(Y,se){return Y<se?-1:Y>se?1:0}e.compare=i;function r(Y,se,le=0,de=Y.length,me=0,be=se.length){for(;le<de&&me<be;le++,me++){let Ce=Y.charCodeAt(le),Re=se.charCodeAt(me);if(Ce<Re)return-1;if(Ce>Re)return 1}const pe=de-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstring=r;function a(Y,se){return l(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=a;function l(Y,se,le=0,de=Y.length,me=0,be=se.length){for(;le<de&&me<be;le++,me++){let Ce=Y.charCodeAt(le),Re=se.charCodeAt(me);if(Ce===Re)continue;const Le=Ce-Re;if(!(Le===32&&d(Re))&&!(Le===-32&&d(Ce)))return u(Ce)&&u(Re)?Le:r(Y.toLowerCase(),se.toLowerCase(),le,de,me,be)}const pe=de-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstringIgnoreCase=l;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function d(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=d;function m(Y){return u(Y)||d(Y)}function A(Y,se){return Y.length===se.length&&_(Y,se)}e.equalsIgnoreCase=A;function _(Y,se,le=Y.length){for(let de=0;de<le;de++){const me=Y.charCodeAt(de),be=se.charCodeAt(de);if(me!==be){if(m(me)&&m(be)){const pe=Math.abs(me-be);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function w(Y,se){const le=se.length;return se.length>Y.length?!1:_(Y,se,le)}e.startsWithIgnoreCase=w;function U(Y,se){let le,de=Math.min(Y.length,se.length);for(le=0;le<de;le++)if(Y.charCodeAt(le)!==se.charCodeAt(le))return le;return de}e.commonPrefixLength=U;function O(Y,se){let le,de=Math.min(Y.length,se.length);const me=Y.length-1,be=se.length-1;for(le=0;le<de;le++)if(Y.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return de}e.commonSuffixLength=O;function $(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=$;function K(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=K;function M(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=M;function H(Y,se,le){const de=Y.charCodeAt(le);if($(de)&&le+1<se){const me=Y.charCodeAt(le+1);if(K(me))return M(de,me)}return de}e.getNextCodePoint=H;function j(Y,se){const le=Y.charCodeAt(se-1);if(K(le)&&se>1){const de=Y.charCodeAt(se-2);if($(de))return M(de,le)}return le}function z(Y,se){const le=ce.getInstance(),de=se,me=Y.length,be=H(Y,me,se);se+=be>=65536?2:1;let pe=le.getGraphemeBreakType(be);for(;se<me;){const we=H(Y,me,se),Ce=le.getGraphemeBreakType(we);if(ee(pe,Ce))break;se+=we>=65536?2:1,pe=Ce}return se-de}e.nextCharLength=z;function q(Y,se){const le=ce.getInstance(),de=se,me=j(Y,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const pe=j(Y,se),we=le.getGraphemeBreakType(pe);if(ee(we,be))break;se-=pe>=65536?2:1,be=we}return de-se}e.prevCharLength=q;function F(Y,se){const le=ce.getInstance(),de=Y.length,me=se,be=H(Y,de,se),pe=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let we=pe;for(;se<de;){const Re=H(Y,de,se),Le=le.getGraphemeBreakType(Re);if(ee(we,Le))break;se+=Re>=65536?2:1,we=Le}const Ce=se;for(se=me,we=pe;se>0;){const Re=j(Y,se),Le=le.getGraphemeBreakType(Re);if(ee(Le,we))break;se-=Re>=65536?2:1,we=Le}return[se,Ce]}function G(Y,se){return se>0&&K(Y.charCodeAt(se))?F(Y,se-1):F(Y,se)}e.getCharContainingOffset=G;const x=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function N(Y){return x.test(Y)}e.containsRTL=N;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(Y){return W.test(Y)}e.containsEmoji=X;const Z=/^[\t\n\r\x20-\x7E]*$/;function B(Y){return Z.test(Y)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=V;function ie(Y){for(let se=0,le=Y.length;se<le;se++)if(re(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=ie;function re(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=re;function ae(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=ae;function ue(Y,se){if(Y.length<se)return Y;const le=/\b/g;let de=0;for(;le.test(Y)&&!(Y.length-le.lastIndex<se);)de=le.lastIndex,le.lastIndex+=1;return Y.substring(de).replace(/^\s/,"")}e.lcut=ue;const fe=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Pe(Y){return Y&&(Y=Y.replace(fe,""),Y=Y.replace(ge,""),Y=Y.replace(Ie,"")),Y}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function _e(Y){return Ee(Y)?Y.substr(1):Y}e.stripUTF8BOM=_e;function De(Y,se){if(!Y||!se||Y.length<se.length)return!1;const le=se.length,de=Y.toLowerCase();let me=0,be=-1;for(;me<le;){const pe=de.indexOf(se[me],be+1);if(pe<0)return!1;be=pe,me++}return!0}e.fuzzyContains=De;function ke(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=ke;function Fe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Fe;function Ne(Y,se=1){if(se===0)return"";let le=-1;do le=Y.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?Y:(Y[le-1]==="\r"&&le--,Y.substr(0,le))}e.getNLines=Ne;function ze(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=ze;function xe(Y){return ce.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=xe;function ee(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=ee;var oe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ce{constructor(){this._data=ye()}static getInstance(){return ce._INSTANCE||(ce._INSTANCE=new ce),ce._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,de=le.length/3;let me=1;for(;me<=de;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ce._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(Y,se){if(Y===0)return 0;const le=Oe(Y,se);if(le!==void 0)return le;const de=j(se,Y);return Y-=Te(de),Y}e.getLeftDeleteOffset=Se;function Oe(Y,se){let le=j(se,Y);for(Y-=Te(le);Ue(le)||le===65039||le===8419;){if(Y===0)return;le=j(se,Y),Y-=Te(le)}if(!!ae(le)){if(Y>=0){const de=j(se,Y);de===8205&&(Y-=Te(de))}return Y}}function Te(Y){return Y>=65536?2:1}function Ue(Y){return 127995<=Y&&Y<=127999}var Ae;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={}))}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(d){return Array.isArray(d)}e.isArray=R;function k(d){return typeof d=="string"}e.isString=k;function D(d){return Array.isArray(d)&&d.every(m=>k(m))}e.isStringArray=D;function T(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=T;function L(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=L;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function S(d){return d===!0||d===!1}e.isBoolean=S;function I(d){return typeof d=="undefined"}e.isUndefined=I;function n(d){return!C(d)}e.isDefined=n;function C(d){return I(d)||d===null}e.isUndefinedOrNull=C;function g(d,m){if(!d)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=g;function b(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=b;function h(...d){const m=[];for(let A=0;A<d.length;A++){const _=d[A];if(C(_))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);m.push(_)}return m}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function f(d){if(!T(d))return!1;for(let m in d)if(p.call(d,m))return!1;return!0}e.isEmptyObject=f;function E(d){return typeof d=="function"}e.isFunction=E;function v(...d){return d.length>0&&d.every(E)}e.areFunctions=v;function y(d,m){const A=Math.min(d.length,m.length);for(let _=0;_<A;_++)c(d[_],m[_])}e.validateConstraints=y;function c(d,m){if(k(m)){if(typeof d!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(E(m)){try{if(d instanceof m)return}catch{}if(!C(d)&&d.constructor===m||m.length===1&&m.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function o(d){let m=[],A=Object.getPrototypeOf(d);for(;Object.prototype!==A;)m=m.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return m}e.getAllPropertyNames=o;function t(d){const m=[];for(const A of o(d))typeof d[A]=="function"&&m.push(A);return m}e.getAllMethodNames=t;function s(d,m){const A=w=>function(){const U=Array.prototype.slice.call(arguments,0);return m(w,U)};let _={};for(const w of d)_[w]=A(w);return _}e.createProxyObject=s;function i(d){return d===null?void 0:d}e.withNullAsUndefined=i;function r(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=r;function a(d){return class{constructor(){return new Proxy({},{get(m,A){if(m[A])return m[A];throw new Error(`Not Implemented: ${d}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function l(d,m="Unreachable"){throw new Error(m)}e.assertNever=l;function u(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=u}),define(te[40],ne([0,1,9,4,25,18]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(i){return i===47||i===92}e.isPathSeparator=L;function P(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function S(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function I(i,r=R.posix.sep){if(!i)return"";const a=i.length,l=i.charCodeAt(0);if(L(l)){if(L(i.charCodeAt(1))&&!L(i.charCodeAt(2))){let d=3;const m=d;for(;d<a&&!L(i.charCodeAt(d));d++);if(m!==d&&!L(i.charCodeAt(d+1))){for(d+=1;d<a;d++)if(L(i.charCodeAt(d)))return i.slice(0,d+1).replace(/[\\/]/g,r)}}return r}else if(E(l)&&i.charCodeAt(1)===58)return L(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(L(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=I;function n(i){if(!k.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let a=2;const l=a;for(;a<i.length&&(r=i.charCodeAt(a),r!==92);a++);return!(l===a||(r=i.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=n;const C=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,r=k.isWindows){const a=r?C:g;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||r&&b.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function p(i,r,a){const l=i===r;return!a||l?l:!i||!r?!1:(0,D.equalsIgnoreCase)(i,r)}e.isEqual=p;function f(i,r,a,l=R.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(i,r))return!1;if(r.length===i.length)return!0;let d=r.length;return r.charAt(r.length-1)===l&&d--,i.charAt(d)===l}return r.charAt(r.length-1)!==l&&(r+=l),i.indexOf(r)===0}e.isEqualOrParent=f;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function v(i,r){return k.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(r,i)),i=(0,R.normalize)(i),k.isWindows?(i=(0,D.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,D.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=v;function y(i){const r=(0,R.normalize)(i);return k.isWindows?i.length>3?!1:c(r)&&(i.length===2||r.charCodeAt(2)===92):r===R.posix.sep}e.isRootOrDriveLetter=y;function c(i){return k.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function o(i){return c(i)?i[0]:void 0}e.getDriveLetter=o;function t(i,r,a){return r.length>i.length?-1:i===r?0:(a&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=t;function s(i){const r=i.split(":");let a,l,u;if(r.forEach(d=>{const m=Number(d);(0,T.isNumber)(m)?l===void 0?l=m:u===void 0&&(u=m):a=a?[a,d].join(":"):d}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:u!==void 0?u:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const f=Array.isArray(p)?[]:{};return Object.keys(p).forEach(E=>{p[E]&&typeof p[E]=="object"?f[E]=k(p[E]):f[E]=p[E]}),f}e.deepClone=k;function D(p){if(!p||typeof p!="object")return p;const f=[p];for(;f.length>0;){const E=f.shift();Object.freeze(E);for(const v in E)if(T.call(E,v)){const y=E[v];typeof y=="object"&&!Object.isFrozen(y)&&f.push(y)}}return p}e.deepFreeze=D;const T=Object.prototype.hasOwnProperty;function L(p,f){return P(p,f,new Set)}e.cloneAndChange=L;function P(p,f,E){if((0,R.isUndefinedOrNull)(p))return p;const v=f(p);if(typeof v!="undefined")return v;if((0,R.isArray)(p)){const y=[];for(const c of p)y.push(P(c,f,E));return y}if((0,R.isObject)(p)){if(E.has(p))throw new Error("Cannot clone recursive data-structure");E.add(p);const y={};for(let c in p)T.call(p,c)&&(y[c]=P(p[c],f,E));return E.delete(p),y}return p}function S(p,f,E=!0){return(0,R.isObject)(p)?((0,R.isObject)(f)&&Object.keys(f).forEach(v=>{v in p?E&&((0,R.isObject)(p[v])&&(0,R.isObject)(f[v])?S(p[v],f[v],E):p[v]=f[v]):p[v]=f[v]}),p):f}e.mixin=S;function I(p,f){if(p===f)return!0;if(p==null||f===null||f===void 0||typeof p!=typeof f||typeof p!="object"||Array.isArray(p)!==Array.isArray(f))return!1;let E,v;if(Array.isArray(p)){if(p.length!==f.length)return!1;for(E=0;E<p.length;E++)if(!I(p[E],f[E]))return!1}else{const y=[];for(v in p)y.push(v);y.sort();const c=[];for(v in f)c.push(v);if(c.sort(),!I(y,c))return!1;for(E=0;E<y.length;E++)if(!I(p[y[E]],f[y[E]]))return!1}return!0}e.equals=I;function n(p){const f=new Set;return JSON.stringify(p,(E,v)=>{if((0,R.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=n;function C(p,f,E){const v=f(p);return typeof v=="undefined"?E:v}e.getOrDefault=C;function g(p,f){const E=Object.create(null);return!p||!f||Object.keys(f).forEach(y=>{const c=p[y],o=f[y];I(c,o)||(E[y]=o)}),E}e.distinct=g;function b(p,f){const E=f.toLowerCase(),v=Object.keys(p).find(y=>y.toLowerCase()===E);return v?p[v]:p[f]}e.getCaseInsensitive=b;function h(p,f){const E=Object.create(null);for(const v of Object.keys(p))f(v,p[v])&&(E[v]=p[v]);return E}e.filter=h}),define(te[7],ne([0,1,9,4]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,T=/^\//,L=/^\/\//;function P(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,r){return!i&&!r?"file":i}function I(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const n="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(r,a,l,u,d,m=!1){typeof r=="object"?(this.scheme=r.scheme||n,this.authority=r.authority||n,this.path=r.path||n,this.query=r.query||n,this.fragment=r.fragment||n):(this.scheme=S(r,m),this.authority=a||n,this.path=I(this.scheme,l||n),this.query=u||n,this.fragment=d||n,P(this,m))}static isUri(r){return r instanceof b?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return y(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:l,path:u,query:d,fragment:m}=r;return a===void 0?a=this.scheme:a===null&&(a=n),l===void 0?l=this.authority:l===null&&(l=n),u===void 0?u=this.path:u===null&&(u=n),d===void 0?d=this.query:d===null&&(d=n),m===void 0?m=this.fragment:m===null&&(m=n),a===this.scheme&&l===this.authority&&u===this.path&&d===this.query&&m===this.fragment?this:new p(a,l,u,d,m)}static parse(r,a=!1){const l=g.exec(r);return l?new p(l[2]||n,s(l[4]||n),s(l[5]||n),s(l[7]||n),s(l[9]||n),a):new p(n,n,n,n,n)}static file(r){let a=n;if(k.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const l=r.indexOf(C,2);l===-1?(a=r.substring(2),r=C):(a=r.substring(2,l),r=r.substring(l)||C)}return new p("file",a,r,n,n)}static from(r){const a=new p(r.scheme,r.authority,r.path,r.query,r.fragment);return P(a,!0),a}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return k.isWindows&&r.scheme==="file"?l=b.file(R.win32.join(y(r,!0),...a)).path:l=R.posix.join(r.path,...a),r.with({path:l})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof b)return r;{const a=new p(r);return a._formatted=r.external,a._fsPath=r._sep===h?r.fsPath:null,a}}else return r}}e.URI=b;const h=k.isWindows?1:void 0;class p extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,r){let a,l=-1;for(let u=0;u<i.length;u++){const d=i.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)l!==-1&&(a+=encodeURIComponent(i.substring(l,u)),l=-1),a!==void 0&&(a+=i.charAt(u));else{a===void 0&&(a=i.substr(0,u));const m=f[d];m!==void 0?(l!==-1&&(a+=encodeURIComponent(i.substring(l,u)),l=-1),a+=m):l===-1&&(l=u)}}return l!==-1&&(a+=encodeURIComponent(i.substring(l))),a!==void 0?a:i}function v(i){let r;for(let a=0;a<i.length;a++){const l=i.charCodeAt(a);l===35||l===63?(r===void 0&&(r=i.substr(0,a)),r+=f[l]):r!==void 0&&(r+=i[a])}return r!==void 0?r:i}function y(i,r){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,k.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=y;function c(i,r){const a=r?v:E;let l="",{scheme:u,authority:d,path:m,query:A,fragment:_}=i;if(u&&(l+=u,l+=":"),(d||u==="file")&&(l+=C,l+=C),d){let w=d.indexOf("@");if(w!==-1){const U=d.substr(0,w);d=d.substr(w+1),w=U.indexOf(":"),w===-1?l+=a(U,!1):(l+=a(U.substr(0,w),!1),l+=":",l+=a(U.substr(w+1),!1)),l+="@"}d=d.toLowerCase(),w=d.indexOf(":"),w===-1?l+=a(d,!1):(l+=a(d.substr(0,w),!1),l+=d.substr(w))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const w=m.charCodeAt(1);w>=65&&w<=90&&(m=`/${String.fromCharCode(w+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const w=m.charCodeAt(0);w>=65&&w<=90&&(m=`${String.fromCharCode(w+32)}:${m.substr(2)}`)}l+=a(m,!0)}return A&&(l+="?",l+=a(A,!1)),_&&(l+="#",l+=r?_:E(_,!1)),l}function o(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+o(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(t)?i.replace(t,r=>o(r)):i}}),define(te[103],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(I){const n=I;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=k;function D(I){const n=[];let C;try{const g=JSON.parse(I.arguments),b=g[g.length-1];b&&b.__$stack&&(g.pop(),C=b.__$stack),n.push(...g)}catch(g){n.push("Unable to log remote console arguments",I.arguments)}return{args:n,stack:C}}e.parse=D;function T(I){if(typeof I!="string")return T(D(I).stack);const n=I;if(n){const C=L(n),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(g&&g.length===4)return{uri:R.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function L(I){if(!I)return I;const n=I.indexOf(`
`);return n===-1?I:I.substring(0,n)}function P(I,n){const{args:C,stack:g}=D(I),b=typeof C[0]=="string"&&C.length===1;let h=L(g);h&&(h=`(${h.trim()})`);let p=[];if(typeof C[0]=="string"?h&&b?p=[`%c[${n}] %c${C[0]} %c${h}`,S("blue"),S(""),S("grey")]:p=[`%c[${n}] %c${C[0]}`,S("blue"),S(""),...C.slice(1)]:p=[`%c[${n}]%`,S("blue"),...C],h&&!b&&p.push(h),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,p)}e.log=P;function S(I){return`color: ${I}`}});var St=this&&this.__classPrivateFieldSet||function(J,e,R,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(J,R):D?D.value=R:e.set(J,R),R},We=this&&this.__classPrivateFieldGet||function(J,e,R,k){if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?k:R==="a"?k.call(J):k?k.value:e.get(J)};define(te[41],ne([0,1,17,25,7]),function(J,e,R,k,D){"use strict";var T,L,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(s,i,r){let a=s.get(i);return a===void 0&&(a=r,s.set(i,a)),a}e.getOrSet=S;function I(s){const i=[];return s.forEach((r,a)=>{i.push(`${a} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=I;function n(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=n;class C{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=C;class g{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class b{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var h;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(h||(h={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,k.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(i){this._iter=i}static forUris(i=()=>!1){return new E(new p(i))}static forPaths(){return new E(new b)}static forStrings(){return new E(new C)}static forConfigKeys(){return new E(new g)}clear(){this._root=void 0}set(i,r){const a=this._iter.reset(i);let l;for(this._root||(this._root=new f,this._root.segment=a.value()),l=this._root;;){const d=a.cmp(l.segment);if(d>0)l.left||(l.left=new f,l.left.segment=a.value()),l=l.left;else if(d<0)l.right||(l.right=new f,l.right.segment=a.value()),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new f,l.mid.segment=a.value()),l=l.mid;else break}const u=l.value;return l.value=r,l.key=i,u}fill(i,r){const a=r.slice(0);(0,R.shuffle)(a);for(let l of a)this.set(l,i)}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const l=r.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const a=this._iter.reset(i),l=[];let u=this._root;for(;u;){const d=a.cmp(u.segment);if(d>0)l.push([1,u]),u=u.left;else if(d<0)l.push([-1,u]),u=u.right;else if(a.hasNext())a.next(),l.push([0,u]),u=u.mid;else{for(r?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;l.length>0&&u.isEmpty();){let[m,A]=l.pop();switch(m){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}u=A}break}}}findSubstr(i){const r=this._iter.reset(i);let a=this._root,l;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const l=r.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[r,a]of this)i(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const r=[i];for(;r.length>0;){const a=r.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&r.push(a.left),a.mid&&r.push(a.mid),a.right&&r.push(a.right))}}}e.TernarySearchTree=E;class v{constructor(i,r){this[T]="ResourceMap",i instanceof v?(this.map=new Map(i.map),this.toKey=r??v.defaultToKey):(this.map=new Map,this.toKey=i??v.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),r),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[a,l]of this.map)i(l,D.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield D.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[D.URI.parse(i[0]),i[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[D.URI.parse(i[0]),i[1]]}}e.ResourceMap=v,v.defaultToKey=s=>s.toString();var y;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class c{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const a=this._map.get(i);if(!!a)return r!==0&&this.touch(a,r),a.value}set(i,r,a=0){let l=this._map.get(i);if(l)l.value=r,a!==0&&this.touch(l,a);else{switch(l={key:i,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const a=this._state;let l=this._head;for(;l;){if(r?i.bind(r)(l.value,l.key,this):i(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,r=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.key,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return l}values(){const i=this,r=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.value,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return l}entries(){const i=this,r=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:[a.key,a.value],done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return l}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>i;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,a=i.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const a=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const a=i.next,l=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,a)=>{i.push([a,r])}),i}fromJSON(i){this.clear();for(const[r,a]of i)this.set(r,a)}}e.LinkedMap=c;class o extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class t{constructor(i){P.set(this,void 0),St(this,P,i,"f")}get size(){return We(this,P,"f").size}forEach(i,r){We(this,P,"f").forEach(i,r)}get(i){return We(this,P,"f").get(i)}has(i){return We(this,P,"f").has(i)}entries(){return We(this,P,"f").entries()}keys(){return We(this,P,"f").keys()}values(){return We(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return We(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(te[104],ne([0,1,22,25,7]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,S)}e.stringify=T;function L(n){let C=JSON.parse(n);return C=I(C),C}e.parse=L;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function S(n,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,k.regExpFlags)(C)}:C}function I(n,C=0){if(!n||C>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof R.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let g=0;g<n.length;++g)n[g]=I(n[g],C+1);else for(const g in n)Object.hasOwnProperty.call(n,g)&&(n[g]=I(n[g],C+1))}return n}e.revive=I}),define(te[15],ne([0,1,4,7]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,I,n){this._hosts[S]=I,this._ports[S]=n}setConnectionToken(S,I){this._connectionTokens[S]=I}rewrite(S){if(this._delegate)return this._delegate(S);const I=S.authority;let n=this._hosts[I];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const C=this._ports[I],g=this._connectionTokens[I];let b=`path=${encodeURIComponent(S.path)}`;return typeof g=="string"&&(b+=`&tkn=${encodeURIComponent(g)}`),k.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${C}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new T;class L{asBrowserUri(S,I){const n=this.toUri(S,I);return n.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?n.with({scheme:D.vscodeFileResource,authority:n.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(S,I){const n=this.toUri(S,I);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==L.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,I){return k.URI.isUri(S)?S:k.URI.parse(I.toUrl(S))}}L.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new L}),define(te[68],ne([0,1,41]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const k=new R.LRUCache(1e4);function D(I){return S(I,"NFC",k)}e.normalizeNFC=D;const T=new R.LRUCache(1e4);function L(I){return S(I,"NFD",T)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function S(I,n,C){if(!I)return I;const g=C.get(I);if(g)return g;let b;return P.test(I)?b=I.normalize(n):b=I,C.set(I,b),b}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(n){return L(n).replace(I,"")}}()}),define(te[16],ne([0,1,40,15,9,4,25,7]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,P.uriToFsPath)(b,!0)}e.originalFSPath=S;class I{constructor(h){this._ignorePathCasing=h}compare(h,p,f=!1){return h===p?0:(0,L.compare)(this.getComparisonKey(h,f),this.getComparisonKey(p,f))}isEqual(h,p,f=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,f)===this.getComparisonKey(p,f)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,f=!1){if(h.scheme===p.scheme){if(h.scheme===k.Schemas.file)return R.isEqualOrParent(S(h),S(p),this._ignorePathCasing(h))&&h.query===p.query&&(f||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return R.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(f||h.fragment===p.fragment)}return!1}joinPath(h,...p){return P.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===k.Schemas.file?p=P.URI.file(D.dirname(S(h))).path:(p=D.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===k.Schemas.file?p=P.URI.file(D.normalize(S(h))).path:p=D.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===k.Schemas.file){const v=D.relative(S(h),S(p));return T.isWindows?R.toSlashes(v):v}let f=h.path||"/",E=p.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const y=Math.min(f.length,E.length);v<y&&!(f.charCodeAt(v)!==E.charCodeAt(v)&&f.charAt(v).toLowerCase()!==E.charAt(v).toLowerCase());v++);f=E.substr(0,v)+f.substr(v)}return D.posix.relative(f,E)}resolvePath(h,p){if(h.scheme===k.Schemas.file){const f=P.URI.file(D.resolve(S(h),p));return h.with({authority:f.authority,path:f.path})}return p=R.toPosixPath(p),h.with({path:D.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||(0,L.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=D.sep){if(h.scheme===k.Schemas.file){const f=S(h);return f.length>R.getRoot(f).length&&f[f.length-1]===p}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=D.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=D.sep){let f=!1;if(h.scheme===k.Schemas.file){const E=S(h);f=E!==void 0&&E.length===R.getRoot(E).length&&E[E.length-1]===p}else{p="/";const E=h.path;f=E.length===1&&E.charCodeAt(E.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(b=>b.scheme===k.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(b,h){const p=[];for(let f=0;f<b.length;f++){const E=h(b[f]);b.some((v,y)=>y===f?!1:(0,e.isEqualOrParent)(E,h(v)))||p.push(b[f])}return p}e.distinctParents=n;var C;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function h(p){const f=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(y=>{const[c,o]=y.split(":");c&&o&&f.set(c,o)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&f.set(b.META_DATA_MIME,v),f}b.parseMetaData=h})(C=e.DataUri||(e.DataUri={}));function g(b,h,p){if(h){let f=b.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),b.with({scheme:p,authority:h,path:f})}return b.with({scheme:p})}e.toLocalResource=g}),define(te[6],ne([0,1,27,8,3,2,16]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(j){return!!j&&typeof j.then=="function"}e.isThenable=P;function S(j){const z=new R.CancellationTokenSource,q=j(z.token),F=new Promise((G,x)=>{const N=z.token.onCancellationRequested(()=>{N.dispose(),z.dispose(),x((0,k.canceled)())});Promise.resolve(q).then(W=>{N.dispose(),z.dispose(),G(W)},W=>{N.dispose(),z.dispose(),x(W)})});return new class{cancel(){z.cancel()}then(G,x){return F.then(G,x)}catch(G){return this.then(void 0,G)}finally(G){return F.finally(G)}}}e.createCancelablePromise=S;function I(j,z,q){return Promise.race([j,new Promise(F=>z.onCancellationRequested(()=>F(q)))])}e.raceCancellation=I;async function n(j){let z=-1;const q=j.map((G,x)=>G.then(N=>(z=x,N))),F=await Promise.race(q);return j.forEach((G,x)=>{x!==z&&G.cancel()}),F}e.raceCancellablePromises=n;function C(j,z,q){let F;const G=setTimeout(()=>{F?.(void 0),q?.()},z);return Promise.race([j.finally(()=>clearTimeout(G)),new Promise(x=>F=x)])}e.raceTimeout=C;function g(j){return new Promise((z,q)=>{const F=j();P(F)?F.then(z,q):z(F)})}e.asPromise=g;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(q,q).then(F)})}return new Promise((q,F)=>{this.queuedPromise.then(q,F)})}return this.activePromise=z(),new Promise((q,F)=>{this.activePromise.then(G=>{this.activePromise=null,q(G)},G=>{this.activePromise=null,F(G)})})}}e.Throttler=b;class h{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=h;class p{constructor(){this.promiseMap=new Map}queue(z,q){const G=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(z)===G&&this.promiseMap.delete(z)});return this.promiseMap.set(z,G),G}}e.SequencerByKey=p;class f{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,q=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,G)=>{this.doResolve=F,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class E{constructor(z){this.delayer=new f(z),this.throttler=new b}trigger(z,q){return this.delayer.trigger(()=>this.throttler.queue(z),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class v{constructor(){this._isOpen=!1,this._promise=new Promise((z,q)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class y extends v{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=y;function c(j,z){return z?new Promise((q,F)=>{const G=setTimeout(()=>{x.dispose(),q()},j),x=z.onCancellationRequested(()=>{clearTimeout(G),x.dispose(),F((0,k.canceled)())})}):S(q=>c(j,q))}e.timeout=c;function o(j,z=0){const q=setTimeout(j,z);return(0,T.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=o;function t(j){const z=[];let q=0;const F=j.length;function G(){return q<F?j[q++]():null}function x(N){N!=null&&z.push(N);const W=G();return W?W.then(x):Promise.resolve(z)}return Promise.resolve(null).then(x)}e.sequence=t;function s(j,z=F=>!!F,q=null){let F=0;const G=j.length,x=()=>{if(F>=G)return Promise.resolve(q);const N=j[F++];return Promise.resolve(N()).then(X=>z(X)?Promise.resolve(X):x())};return x()}e.first=s;function i(j,z=F=>!!F,q=null){if(j.length===0)return Promise.resolve(q);let F=j.length;const G=()=>{F=-1;for(const x of j)x.cancel?.()};return new Promise((x,N)=>{for(const W of j)W.then(X=>{--F>=0&&z(X)?(G(),x(X)):F===0&&x(q)}).catch(X=>{--F>=0&&(G(),N(X))})})}e.firstParallel=i;class r{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((q,F)=>{this.outstandingPromises.push({factory:z,c:q,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const q=z.factory();q.then(z.c,z.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class a extends r{constructor(){super(1)}}e.Queue=a;class l{constructor(){this.queues=new Map}queueFor(z,q=L.extUri){const F=q.getComparisonKey(z);let G=this.queues.get(F);return G||(G=new a,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(F)}),this.queues.set(F,G)),G}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=l;class u{constructor(z,q){this._token=-1,typeof z=="function"&&typeof q=="number"&&this.setIfNotSet(z,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},q)}setIfNotSet(z,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},q))}}e.TimeoutTimer=u;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,q){this.cancel(),this._token=setInterval(()=>{z()},q)}}e.IntervalTimer=d;class m{constructor(z,q){this.timeoutToken=-1,this.runner=z,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=m;class A{constructor(z,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class _ extends m{constructor(z,q){super(z,q);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class w extends T.Disposable{constructor(z,q,F,G){super();this.maxWorkChunkSize=z,this.maxPendingWork=q,this.throttleDelay=F,this.handler=G,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new m(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=w,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{const z=setTimeout(()=>{const F=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0,clearTimeout(z))}}}:e.runWhenIdle=(j,z)=>{const q=requestIdleCallback(j,typeof z=="number"?{timeout:z}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(q))}}}}();class U{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function O(j,z,q){let F;for(let G=0;G<q;G++)try{return await j()}catch(x){F=x,await c(z)}throw F}e.retry=O;class ${hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,q,F){return this._pending={taskId:z,cancel:()=>F?.(),promise:q},q.then(()=>this.donePending(z),()=>this.donePending(z)),q}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let q,F;const G=new Promise((x,N)=>{q=x,F=N});this._next={run:z,promise:G,promiseResolve:q,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=$;class K{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,q)=>{this.completeCallback=z,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(q=>{this.completeCallback(z),this.resolved=!0,q()})}error(z){return new Promise(q=>{this.errorCallback(z),this.rejected=!0,q()})}cancel(){new Promise(z=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=M;var H;(function(j){async function z(q){let F;const G=await Promise.all(q.map(x=>x.then(N=>N,N=>{F||(F=N)})));if(typeof F!="undefined")throw F;return G}j.settled=z})(H=e.Promises||(e.Promises={}))}),define(te[69],ne([0,1,6,40,41,9,25]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",I="/",n="[/\\\\]",C="[^/\\\\]",g=/\//g;function b(F){switch(F){case 0:return"";case 1:return`${C}*?`;default:return`(?:${n}|${C}+${n}|${n}${C}+)*?`}}function h(F,G){if(!F)return[];const x=[];let N=!1,W=!1,X="";for(const Z of F){switch(Z){case G:if(!N&&!W){x.push(X),X="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":W=!0;break;case"]":W=!1;break}X+=Z}return X&&x.push(X),x}e.splitGlobAware=h;function p(F){if(!F)return"";let G="";const x=h(F,I);if(x.every(N=>N===S))G=".*";else{let N=!1;x.forEach((W,X)=>{if(W===S){N||(G+=b(2),N=!0);return}let Z=!1,B="",V=!1,ie="";for(const re of W){if(re!=="}"&&Z){B+=re;continue}if(V&&(re!=="]"||!ie)){let ae;re==="-"?ae=re:(re==="^"||re==="!")&&!ie?ae="^":re===I?ae="":ae=L.escapeRegExpCharacters(re),ie+=ae;continue}switch(re){case"{":Z=!0;continue;case"[":V=!0;continue;case"}":G+=`(?:${h(B,",").map(fe=>p(fe)).join("|")})`,Z=!1,B="";break;case"]":G+="["+ie+"]",V=!1,ie="";break;case"?":G+=C;continue;case"*":G+=b(1);continue;default:G+=L.escapeRegExpCharacters(re)}}X<x.length-1&&(x[X+1]!==S||X+2<x.length)&&(G+=n),N=!1})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),s=function(){return!1},i=function(){return null};function r(F,G){if(!F)return i;let x;typeof F!="string"?x=F.pattern:x=F,x=x.trim();const N=`${x}_${!!G.trimForExclusions}`;let W=t.get(N);if(W)return a(W,F);let X;if(f.test(x)){const Z=x.substr(4);W=function(B,V){return typeof B=="string"&&B.endsWith(Z)?x:null}}else(X=E.exec(l(x,G)))?W=u(X[1],x):(G.trimForExclusions?y:v).test(x)?W=d(x,G):(X=c.exec(l(x,G)))?W=m(X[1].substr(1),x,!0):(X=o.exec(l(x,G)))?W=m(X[1],x,!1):W=A(x);return t.set(N,W),a(W,F)}function a(F,G){return typeof G=="string"?F:function(x,N){return k.isEqualOrParent(x,G.base)?F(T.relative(G.base,x),N):null}}function l(F,G){return G.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,G){const x=`/${F}`,N=`\\${F}`,W=function(Z,B){return typeof Z!="string"?null:B?B===F?G:null:Z===F||Z.endsWith(x)||Z.endsWith(N)?G:null},X=[F];return W.basenames=X,W.patterns=[G],W.allBasenames=X,W}function d(F,G){const x=q(F.slice(1,-1).split(",").map(B=>r(B,G)).filter(B=>B!==i),F),N=x.length;if(!N)return i;if(N===1)return x[0];const W=function(B,V){for(let ie=0,re=x.length;ie<re;ie++)if(x[ie](B,V))return F;return null},X=x.find(B=>!!B.allBasenames);X&&(W.allBasenames=X.allBasenames);const Z=x.reduce((B,V)=>V.allPaths?B.concat(V.allPaths):B,[]);return Z.length&&(W.allPaths=Z),W}function m(F,G,x){const N=T.sep===T.posix.sep,W=N?F:F.replace(g,T.sep),X=T.sep+W,Z=T.posix.sep+F,B=x?function(V,ie){return typeof V=="string"&&(V===W||V.endsWith(X)||!N&&(V===F||V.endsWith(Z)))?G:null}:function(V,ie){return typeof V=="string"&&(V===W||!N&&V===F)?G:null};return B.allPaths=[(x?"*/":"./")+F],B}function A(F){try{const G=new RegExp(`^${p(F)}$`);return function(x){return G.lastIndex=0,typeof x=="string"&&G.test(x)?F:null}}catch(G){return i}}function _(F,G,x){return!F||typeof G!="string"?!1:w(F)(G,void 0,x)}e.match=_;function w(F,G={}){if(!F)return s;if(typeof F=="string"||K(F)){const x=r(F,G);if(x===i)return s;const N=function(W,X){return!!x(W,X)};return x.allBasenames&&(N.allBasenames=x.allBasenames),x.allPaths&&(N.allPaths=x.allPaths),N}return j(F,G)}e.parse=w;function U(F){if(!F)return;let G;return x=>(G||(G=(F()||Promise.resolve([])).then(N=>N?$(N):{})),G.then(N=>!!N[x]))}e.hasSiblingPromiseFn=U;function O(F){if(!F)return;let G;return x=>{if(!G){const N=F();G=N?$(N):{}}return!!G[x]}}e.hasSiblingFn=O;function $(F){const G={};for(const x of F)G[x]=!0;return G}function K(F){const G=F;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=K;function M(F){return F.allBasenames||[]}e.getBasenameTerms=M;function H(F){return F.allPaths||[]}e.getPathTerms=H;function j(F,G){const x=q(Object.getOwnPropertyNames(F).map(B=>z(B,F[B],G)).filter(B=>B!==i)),N=x.length;if(!N)return i;if(!x.some(B=>!!B.requiresSiblings)){if(N===1)return x[0];const B=function(re,ae){for(let ue=0,fe=x.length;ue<fe;ue++){const ge=x[ue](re,ae);if(ge)return ge}return null},V=x.find(re=>!!re.allBasenames);V&&(B.allBasenames=V.allBasenames);const ie=x.reduce((re,ae)=>ae.allPaths?re.concat(ae.allPaths):re,[]);return ie.length&&(B.allPaths=ie),B}const W=function(B,V,ie){let re;for(let ae=0,ue=x.length;ae<ue;ae++){const fe=x[ae];fe.requiresSiblings&&ie&&(V||(V=T.basename(B)),re||(re=V.substr(0,V.length-T.extname(B).length)));const ge=fe(B,V,re,ie);if(ge)return ge}return null},X=x.find(B=>!!B.allBasenames);X&&(W.allBasenames=X.allBasenames);const Z=x.reduce((B,V)=>V.allPaths?B.concat(V.allPaths):B,[]);return Z.length&&(W.allPaths=Z),W}function z(F,G,x){if(G===!1)return i;const N=r(F,x);if(N===i)return i;if(typeof G=="boolean")return N;if(G){const W=G.when;if(typeof W=="string"){const X=(Z,B,V,ie)=>{if(!ie||!N(Z,B))return null;const re=W.replace("$(basename)",V),ae=ie(re);return(0,R.isThenable)(ae)?ae.then(ue=>ue?F:null):ae?F:null};return X.requiresSiblings=!0,X}}return N}function q(F,G){const x=F.filter(B=>!!B.basenames);if(x.length<2)return F;const N=x.reduce((B,V)=>{const ie=V.basenames;return ie?B.concat(ie):B},[]);let W;if(G){W=[];for(let B=0,V=N.length;B<V;B++)W.push(G)}else W=x.reduce((B,V)=>{const ie=V.patterns;return ie?B.concat(ie):B},[]);const X=function(B,V){if(typeof B!="string")return null;if(!V){let re;for(re=B.length;re>0;re--){const ae=B.charCodeAt(re-1);if(ae===47||ae===92)break}V=B.substr(re)}const ie=N.indexOf(V);return ie!==-1?W[ie]:null};X.basenames=N,X.patterns=W,X.allBasenames=N;const Z=F.filter(B=>!B.basenames);return Z.push(X),Z}}),define(te[105],ne([0,1,69,15,9,16,25]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let S=[],I=[],n=[];function C(r,a=!1){const l=g(r);S.push(l),l.userConfigured?n.push(l):I.push(l),a&&!l.userConfigured&&S.forEach(u=>{u.mime===l.mime||u.userConfigured||(l.extension&&u.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&u.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&u.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&u.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=C;function g(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,R.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(D.posix.sep)>=0:!1}}function b(r){r?(S=S.filter(a=>!a.userConfigured),n=[]):(S=[],I=[],n=[])}e.clearTextMimes=b;function h(r,a){let l;if(r)switch(r.scheme){case k.Schemas.file:l=r.fsPath;break;case k.Schemas.data:l=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const u=(0,D.basename)(l),d=p(l,u,n);if(d)return[d,P.text];const m=p(l,u,I);if(m)return[m,P.text];if(a){const A=f(a);if(A)return[A,P.text]}return[P.unknown]}e.guessMimeTypes=h;function p(r,a,l){let u=null,d=null,m=null;for(let A=l.length-1;A>=0;A--){const _=l[A];if(a===_.filenameLowercase){u=_;break}if(_.filepattern&&(!d||_.filepattern.length>d.filepattern.length)){const w=_.filepatternOnPath?r:a;_.filepatternLowercase?.(w)&&(d=_)}_.extension&&(!m||_.extension.length>m.extension.length)&&a.endsWith(_.extensionLowercase)&&(m=_)}return u?u.mime:d?d.mime:m?m.mime:null}function f(r){if((0,L.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let a=S.length-1;a>=0;a--){const l=S[a];if(!l.firstline)continue;const u=r.match(l.firstline);if(u&&u.length>0)return l.mime}return null}function E(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&E(r[0]):!0}e.isUnspecific=E;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(r){const a=(0,D.extname)(r),l=v[a.toLowerCase()];return l!==void 0?l:o(r)}e.getMediaOrTextMime=c;function o(r){const a=(0,D.extname)(r);return y[a.toLowerCase()]}e.getMediaMime=o;function t(r){for(const a in y)if(y[a]===r)return a}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function i(r,a){const l=s.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:a?void 0:r}e.normalizeMimeType=i}),define(te[106],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(n){return n.toJSON()}class D{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:k(R.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:k(R.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:R.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,C,g){if(!n||g>200)return null;if(typeof n=="object"){if(n instanceof R.URI)return C.transformOutgoing(n);for(let b in n)if(Object.hasOwnProperty.call(n,b)){const h=T(n[b],C,g+1);h!==null&&(n[b]=h)}}return null}function L(n,C){const g=T(n,C,0);return g===null?n:g}e.transformOutgoingURIs=L;function P(n,C,g,b){if(!n||b>200)return null;if(typeof n=="object"){if(n.$mid===1)return g?R.URI.revive(C.transformIncoming(n)):C.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const p=P(n[h],C,g,b+1);p!==null&&(n[h]=p)}}return null}function S(n,C){const g=P(n,C,!1,0);return g===null?n:g}e.transformIncomingURIs=S;function I(n,C){const g=P(n,C,!0,0);return g===null?n:g}e.transformAndReviveIncomingURIs=I}),define(te[30],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(S){return R.test(S)}e.isUUID=k;const D=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(S){for(let I=0;I<S.length;I++)S[I]=Math.floor(Math.random()*256);return S};function P(){L(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,I="";return I+=T[D[S++]],I+=T[D[S++]],I+=T[D[S++]],I+=T[D[S++]],I+="-",I+=T[D[S++]],I+=T[D[S++]],I+="-",I+=T[D[S++]],I+=T[D[S++]],I+="-",I+=T[D[S++]],I+=T[D[S++]],I+="-",I+=T[D[S++]],I+=T[D[S++]],I+=T[D[S++]],I+=T[D[S++]],I+=T[D[S++]],I+=T[D[S++]],I}e.generateUuid=P}),define(te[70],ne([0,1,107]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(T="utf8"){this.stringDecoder=new R.StringDecoder(T),this.remaining=null}write(T){const L=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return L;let S=0,I,n=S;for(;n<P.length;)if(I=P.charCodeAt(n),I===13||I===10){if(L.push(P.substring(S,n)),n++,n<P.length){const C=I;I=P.charCodeAt(n),(C===13&&I===10||C===10&&I===13)&&n++}S=n}else n++;return this.remaining=S<P.length?P.substr(S):null,L}end(){return this.remaining}}e.LineDecoder=k}),define(te[108],ne([0,1,32]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(P){const S=P.replace(/\-/g,":").toLowerCase();return!k.has(S)}function T(){return new Promise(async(P,S)=>{const I=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await L())}catch(n){S(n)}finally{clearTimeout(I)}})}e.getMac=T;function L(){return new Promise((P,S)=>{try{const I=(0,R.networkInterfaces)();for(let n in I){const C=I[n];if(C){for(const{mac:g}of C)if(D(g))return P(g)}}S("Unable to retrieve mac address (unexpected format)")}catch(I){S(I)}})}}),define(te[109],ne([0,1,32,8,41,30,108]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,C=0;const g=(0,R.networkInterfaces)();for(let b in g){const h=g[b];if(h)for(const{mac:p,internal:f}of h)f||(C+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(n+=1))}this._value=C>0?n/C:0}return this._value}};let P;async function S(){return P||(P=(async()=>await I()||T.generateUuid())()),P}e.getMachineId=S;async function I(){try{const n=await new Promise((g,b)=>{J(["crypto"],g,b)}),C=await(0,L.getMac)();return n.createHash("sha256").update(C,"utf8").digest("hex")}catch(n){k.onUnexpectedError(n);return}}}),define(te[19],ne([0,1,51,32,235,6,40,68,9,4,16,7,30]),function(J,e,R,k,D,T,L,P,S,I,n,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function h(M,H=b.UNLINK){if((0,L.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return H===b.UNLINK?f(M):p(M)}async function p(M){try{const H=(0,S.join)((0,k.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(M,H)}catch(j){return f(M)}f(H).catch(j=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function f(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function E(M){if((0,L.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(M,{recursive:!0})}e.rimrafSync=E;async function v(M,H){return o(await(H?y(M):(0,D.promisify)(R.readdir)(M)))}async function y(M){try{return await(0,D.promisify)(R.readdir)(M,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const H=[],j=await v(M);for(const z of j){let q=!1,F=!1,G=!1;try{const x=await e.Promises.lstat((0,S.join)(M,z));q=x.isFile(),F=x.isDirectory(),G=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}H.push({name:z,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>G})}return H}function c(M){return o(R.readdirSync(M))}e.readdirSync=c;function o(M){return M.map(H=>typeof H=="string"?I.isMacintosh?(0,P.normalizeNFC)(H):H:(H.name=I.isMacintosh?(0,P.normalizeNFC)(H.name):H.name,H))}async function t(M){const H=await v(M),j=[];for(const z of H)await i.existsDirectory((0,S.join)(M,z))&&j.push(z);return j}function s(M,H=1e3){return new Promise(j=>{let z=!1;const q=setInterval(()=>{z||(z=!0,R.access(M,F=>{z=!1,F&&(clearInterval(q),j(void 0))}))},H)})}e.whenDeleted=s;var i;(function(M){async function H(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch(G){}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(I.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw x}throw G}}M.stat=H;async function j(q){try{const{stat:F,symbolicLink:G}=await M.stat(q);return F.isFile()&&G?.dangling!==!0}catch(F){}return!1}M.existsFile=j;async function z(q){try{const{stat:F,symbolicLink:G}=await M.stat(q);return F.isDirectory()&&G?.dangling!==!0}catch(F){}return!1}M.existsDirectory=z})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function a(M,H,j){return r.queueFor(C.URI.file(M),n.extUriBiasedIgnorePathCase).queue(()=>{const z=m(j);return new Promise((q,F)=>u(M,H,z,G=>G?F(G):q()))})}let l=!0;function u(M,H,j,z){if(!l)return R.writeFile(M,H,{mode:j.mode,flag:j.flag},z);R.open(M,j.flag,j.mode,(q,F)=>{if(q)return z(q);R.writeFile(F,H,G=>{if(G)return R.close(F,()=>z(G));R.fdatasync(F,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),l=!1),R.close(F,N=>z(N))))})})}function d(M,H,j){const z=m(j);if(!l)return R.writeFileSync(M,H,{mode:z.mode,flag:z.flag});const q=R.openSync(M,z.flag,z.mode);try{R.writeFileSync(q,H);try{R.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),l=!1}}finally{R.closeSync(q)}}e.writeFileSync=d;function m(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,H){if(M===H)return;async function j(z){try{const q=await e.Promises.lstat(z);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(z,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(M,H),await j(H)}catch(z){if(M.toLowerCase()!==H.toLowerCase()&&z.code==="EXDEV"||M.endsWith("."))await _(M,H,{preserveSymlinks:!1}),await h(M,b.MOVE),await j(H);else throw z}}async function _(M,H,j){return U(M,H,{root:{source:M,target:H},options:j,handledSourcePaths:new Set})}const w=511;async function U(M,H,j){if(j.handledSourcePaths.has(M))return;j.handledSourcePaths.add(M);const{stat:z,symbolicLink:q}=await i.stat(M);if(q){if(j.options.preserveSymlinks)try{return await K(M,H,j)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return z.isDirectory()?O(M,H,z.mode&w,j):$(M,H,z.mode&w)}async function O(M,H,j,z){await e.Promises.mkdir(H,{recursive:!0,mode:j});const q=await v(M);for(const F of q)await U((0,S.join)(M,F),(0,S.join)(H,F),z)}async function $(M,H,j){await e.Promises.copyFile(M,H),await e.Promises.chmod(H,j)}async function K(M,H,j){let z=await e.Promises.readlink(M);(0,L.isEqualOrParent)(z,j.root.source,!I.isLinux)&&(z=(0,S.join)(j.root.target,z.substr(j.root.source.length+1))),await e.Promises.symlink(z,H)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return h}get move(){return A}get copy(){return _}}}),define(te[110],ne([0,1,51,9,25,19]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function L(n){const C=(0,k.dirname)(n);if(n===C)return n;const g=((0,k.basename)(n)||n).toLowerCase();try{const h=(0,T.readdirSync)(C).filter(p=>p.toLowerCase()===g);if(h.length===1){const p=L(C);if(p)return(0,k.join)(p,h[0])}else if(h.length>1){const p=h.indexOf(g);if(p>=0){const f=L(C);if(f)return(0,k.join)(f,h[p])}}}catch(b){}return null}e.realcaseSync=L;async function P(n){try{return await T.Promises.realpath(n)}catch(C){const g=I(n);return await T.Promises.access(g,R.constants.R_OK),g}}e.realpath=P;function S(n){try{return R.realpathSync(n)}catch(C){const g=I(n);return R.accessSync(g,R.constants.R_OK),g}}e.realpathSync=S;function I(n){return(0,D.rtrim)((0,k.normalize)(n),k.sep)}}),define(te[111],ne([0,1,56]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function k(P,S,I,n=1){let C=!1;return new Promise(g=>{const b=setTimeout(()=>{if(!C)return C=!0,g(0)},I);D(P,S,n,h=>{if(!C)return C=!0,clearTimeout(b),g(h)})})}e.findFreePort=k;function D(P,S,I,n){if(S===0)return n(0);const C=new R.Socket;C.once("connect",()=>(L(C),D(P+I,S-1,I,n))),C.once("data",()=>{}),C.once("error",g=>(L(C),g.code!=="ECONNREFUSED"?D(P+I,S-1,I,n):n(P))),C.connect(P,"127.0.0.1")}function T(P,S,I){let n=!1,C,g=1;const b=R.createServer({pauseOnConnect:!0});function h(p,f){n||(n=!0,b.removeAllListeners(),b.close(),C&&clearTimeout(C),f(p))}return new Promise(p=>{C=setTimeout(()=>{h(0,p)},I),b.on("listening",()=>{h(P,p)}),b.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&g<S?(P++,g++,b.listen(P,"127.0.0.1")):h(0,p)}),b.on("close",()=>{h(0,p)}),b.listen(P,"127.0.0.1")})}e.findFreePortFaster=T;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(S){console.error(S)}}}),define(te[71],ne([0,1,32,9,19]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var S;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(S||(S={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class C{constructor(o,t,s){this.exePath=o,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?I===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:c=!1,findPreview:o=!1}={}){const t=g({useAlternateBitness:c});if(!t)return null;const s=k.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let i=-1,r=null;for(const u of await D.Promises.readdir(s)){let d=-1;if(o){const A=u.indexOf("-");if(A<0)continue;const _=u.substring(0,A);if(!T.test(_)||u.substring(A+1)!=="preview")continue;d=parseInt(_,10)}else{if(!T.test(u))continue;d=parseInt(u,10)}if(d<=i)continue;const m=k.join(s,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(m)||(r=m,i=d)}if(!r)return null;const a=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new C(r,`PowerShell${l}${a}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const o=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(o))if(t.test(i)){const r=k.join(o,i,"pwsh.exe");return new C(r,s)}return null}function p(){const c=k.join(R.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function f(){const c=k.join(process.env.windir,I===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}async function*E(){let c=await b();c&&(yield c),c=await b({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=p(),c&&(yield c),c=await b({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await b({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=f(),c&&(yield c)}async function*v(){for await(const c of E())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=v;async function y(){for await(const c of v())return c;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[112],ne([0,1,37,15]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(L){return new Promise((P,S)=>{let I;const n=new Map;function C(b,h,p,f,E){const v=n.get(h);if(b===L||v){const y={name:g(p),cmd:p,pid:b,ppid:h,load:f,mem:E};n.set(b,y),b===L&&(I=y),v&&(v.children||(v.children=[]),v.children.push(y),v.children.length>1&&(v.children=v.children.sort((c,o)=>c.pid-o.pid)))}}function g(b){const h=/--disable-blink-features=Auxclick/,p=/\\watcher\\win32\\CodeHelper\.exe/,f=/--crashes-directory/,E=/\\pipe\\winpty-control/,v=/conhost\.exe/,y=/--type=([a-zA-Z-]+)/;if(p.exec(b))return"watcherService ";if(f.exec(b))return"electron-crash-reporter";if(E.exec(b))return"winpty-process";if(v.exec(b))return"console-window-host (Windows internal process)";let c=y.exec(b);if(c&&c.length===2)return c[1]==="renderer"?h.exec(b)?"shared-process":"window":c[1];const o=/[a-zA-Z-]+\.js/g;let t="";do c=o.exec(b),c&&(t+=c+" ");while(c);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,p)=>{J(["windows-process-tree"],h,p)}).then(h=>{h.getProcessList(L,p=>{h.getProcessCpuUsage(p,f=>{const E=new Map;f.forEach(v=>{const y=b(v.commandLine||"");E.set(v.pid,{name:g(y),cmd:y,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),I=E.get(L),I?(E.forEach(v=>{const y=E.get(v.ppid);y&&(y.children||(y.children=[]),y.children.push(v))}),E.forEach(v=>{v.children&&(v.children=v.children.sort((y,c)=>y.pid-c.pid))}),P(I)):S(new Error(`Root process ${L} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let b=function(){let h=[I];const p=[];for(;h.length;){const E=h.shift();E&&(p.push(E.pid),E.children&&(h=h.concat(E.children)))}let f=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);f+=" "+p.join(" "),(0,R.exec)(f,{},(E,v,y)=>{if(E||y)S(E||new Error(y.toString()));else{const c=v.toString().split(`
`);for(let o=0;o<p.length;o++){const t=n.get(p[o]);t.load=parseFloat(c[o])}if(!I){S(new Error(`Root process ${L} not found`));return}P(I)}})};(0,R.exec)("which ps",{},(h,p,f)=>{if(h||f)if(process.platform!=="linux")S(h||new Error(f.toString()));else{const E=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,R.exec)(E,{},(v,y,c)=>{v||c?S(v||new Error(c.toString())):(T(y,C),b())})}else{const E=p.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${E} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,c,o)=>{y||o&&!o.includes("screen size is bogus")?S(y||new Error(o.toString())):(T(c,C),process.platform==="linux"?b():I?P(I):S(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=D;function T(L,P){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=L.toString().split(`
`);for(const n of I){const C=S.exec(n.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(te[113],ne([0,1,51,27,40,2,68,9,4,19]),function(J,e,R,k,D,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function n(h,p,f){return g({path:h,isDirectory:!1},p,f)}e.watchFile=n;function C(h,p,f){return g({path:h,isDirectory:!0},p,f)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function g(h,p,f){if(S.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return f(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const E=(0,P.basename)(h.path),v=new Map;let y=!1,c=[(0,T.toDisposable)(()=>{v.forEach(o=>(0,T.dispose)(o)),v.clear()})];try{const o=(0,R.watch)(h.path);c.push((0,T.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const t=new Set;h.isDirectory&&I.Promises.readdir(h.path).then(s=>s.forEach(i=>t.add(i))),o.on("error",(s,i)=>{y||f(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${i})`)}),o.on("change",(s,i)=>{if(y)return;let r="";if(i&&(r=i.toString(),S.isMacintosh&&(r=(0,L.normalizeNFC)(r))),!r||s!=="change"&&s!=="rename")return;const a=h.isDirectory?(0,P.join)(h.path,r):h.path;if(h.isDirectory)if(s==="rename"){const l=v.get(a);l&&(0,T.dispose)(l);const u=setTimeout(async()=>{v.delete(a);const d=await I.Promises.exists(a);if(y)return;let m;d?t.has(r)?m="changed":(m="added",t.add(r)):(t.delete(r),m="deleted"),p(m,a)},e.CHANGE_BUFFER_DELAY);v.set(a,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let l;t.has(r)?l="changed":(l="added",t.add(r)),p(l,a)}else if(s==="rename"||r!==E){const l=setTimeout(async()=>{const u=await I.Promises.exists(a);y||(u?(p("changed",a),c=[g(h,p,f)]):p("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(c),c=[(0,T.toDisposable)(()=>clearTimeout(l))]}else p("changed",a)})}catch(o){I.Promises.exists(h.path).then(t=>{t&&!y&&f(`Failed to watch ${h.path} for changes using fs.watch() (${o.toString()})`)})}return(0,T.toDisposable)(()=>{y=!0,c=(0,T.dispose)(c)})}async function b(h,p,f,E=512){const v=await I.Promises.open(h,"r"),y=Buffer.allocUnsafe(E),c=new k.CancellationTokenSource(f);let o,t=!1;const s=n(h,async i=>{if(i==="changed"){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:r}=await I.Promises.read(v,y,0,E,null);if(!r||c.token.isCancellationRequested)break;p(y.slice(0,r))}}catch(r){o=new Error(r),c.dispose(!0)}finally{t=!1}}},i=>{o=new Error(i),c.dispose(!0)});return new Promise((i,r)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await I.Promises.close(v),o?r(o):i()})})}e.watchFileContents=b});var he=this&&this.__decorate||function(J,e,R,k){var D=arguments.length,T=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,R):k,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,R,k);else for(var P=J.length-1;P>=0;P--)(L=J[P])&&(T=(D<3?L(T):D>3?L(e,R,T):L(e,R))||T);return D>3&&T&&Object.defineProperty(e,R,T),T};define(te[33],ne([0,1,17,6,22,27,66,8,3,2,104,25,18]),function(J,e,R,k,D,T,L,P,S,I,n,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function f(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(E||(E={}));class v{constructor(F){this.buffer=F,this.pos=0}read(F){const G=this.buffer.slice(this.pos,this.pos+F);return this.pos+=G.byteLength,G}}class y{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(c||(c={}));function o(q){const F=D.VSBuffer.alloc(4);return F.writeUInt32BE(q,0),F}function t(q){return q.read(4).readUInt32BE(0)}function s(q){const F=D.VSBuffer.alloc(1);return F.writeUInt8(q,0),F}const i={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},r=typeof Buffer!="undefined";function a(q,F){if(typeof F=="undefined")q.write(i.Undefined);else if(typeof F=="string"){const G=D.VSBuffer.fromString(F);q.write(i.String),q.write(o(G.byteLength)),q.write(G)}else if(r&&Buffer.isBuffer(F)){const G=D.VSBuffer.wrap(F);q.write(i.Buffer),q.write(o(G.byteLength)),q.write(G)}else if(F instanceof D.VSBuffer)q.write(i.VSBuffer),q.write(o(F.byteLength)),q.write(F);else if(Array.isArray(F)){q.write(i.Array),q.write(o(F.length));for(const G of F)a(q,G)}else{const G=D.VSBuffer.fromString(JSON.stringify(F));q.write(i.Object),q.write(o(G.byteLength)),q.write(G)}}function l(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(t(q)).toString();case c.Buffer:return q.read(t(q)).buffer;case c.VSBuffer:return q.read(t(q));case c.Array:{const G=t(q),x=[];for(let N=0;N<G;N++)x.push(l(q));return x}case c.Object:return JSON.parse(q.read(t(q)).toString())}}class u{constructor(F,G,x=null,N=1e3){this.protocol=F,this.ctx=G,this.logger=x,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(F,G){this.channels.set(F,G),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const G=this.send([F.type]);this.logger&&this.logger.logOutgoing(G,0,1,f(F.type));return}case 201:case 202:case 204:case 203:{const G=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(G,F.id,1,f(F.type),F.data);return}}}send(F,G=void 0){const x=new y;return a(x,F),a(x,G),this.sendBuffer(x.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(G){return 0}}onRawMessage(F){const G=new v(F),x=l(G),N=l(G),W=x[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${h(W)}: ${x[2]}.${x[3]}`,N),this.onPromise({type:W,id:x[1],channelName:x[2],name:x[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${h(W)}: ${x[2]}.${x[3]}`,N),this.onEventListen({type:W,id:x[1],channelName:x[2],name:x[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:x[1]})}}onPromise(F){const G=this.channels.get(F.channelName);if(!G){this.collectPendingRequest(F);return}const x=new T.CancellationTokenSource;let N;try{N=G.call(this.ctx,F.name,F.arg,x.token)}catch(Z){N=Promise.reject(Z)}const W=F.id;N.then(Z=>{this.sendResponse({id:W,data:Z,type:201}),this.activeRequests.delete(F.id)},Z=>{Z instanceof Error?this.sendResponse({id:W,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:W,data:Z,type:203}),this.activeRequests.delete(F.id)});const X=(0,I.toDisposable)(()=>x.cancel());this.activeRequests.set(F.id,X)}onEventListen(F){const G=this.channels.get(F.channelName);if(!G){this.collectPendingRequest(F);return}const x=F.id,W=G.listen(this.ctx,F.name,F.arg)(X=>this.sendResponse({id:x,data:X,type:204}));this.activeRequests.set(F.id,W)}disposeActiveRequest(F){const G=this.activeRequests.get(F.id);G&&(G.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let G=this.pendingRequests.get(F.channelName);G||(G=[],this.pendingRequests.set(F.channelName,G));const x=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:F,timeoutTimer:x})}flushPendingRequests(F){const G=this.pendingRequests.get(F);if(G){for(const x of G)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(F,G=null){this.protocol=F,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=G}getChannel(F){const G=this;return{call(x,N,W){return G.isDisposed?Promise.reject(P.canceled()):G.requestPromise(F,x,N,W)},listen(x,N){return G.isDisposed?Promise.reject(P.canceled()):G.requestEvent(F,x,N)}}}requestPromise(F,G,x,N=T.CancellationToken.None){const W=this.lastRequestId++,Z={id:W,type:100,channelName:F,name:G,arg:x};if(N.isCancellationRequested)return Promise.reject(P.canceled());let B;return new Promise((ie,re)=>{if(N.isCancellationRequested)return re(P.canceled());const ae=()=>{const Ie=Pe=>{switch(Pe.type){case 201:this.handlers.delete(W),ie(Pe.data);break;case 202:this.handlers.delete(W);const Ee=new Error(Pe.data.message);Ee.stack=Pe.data.stack,Ee.name=Pe.data.name,re(Ee);break;case 203:this.handlers.delete(W),re(Pe.data);break}};this.handlers.set(W,Ie),this.sendRequest(Z)};let ue=null;this.state===E.Idle?ae():(ue=(0,k.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const fe=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:W,type:101}),re(P.canceled())},ge=N.onCancellationRequested(fe);B=(0,I.combinedDisposable)((0,I.toDisposable)(fe),ge),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(F,G,x){const N=this.lastRequestId++,X={id:N,type:102,channelName:F,name:G,arg:x};let Z=null;const B=new S.Emitter({onFirstListenerAdd:()=>{Z=(0,k.createCancelablePromise)(ie=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(B),this.sendRequest(X)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(B),this.sendRequest({id:N,type:103}))}}),V=ie=>B.fire(ie.data);return this.handlers.set(N,V),B.event}sendRequest(F){switch(F.type){case 100:case 102:{const G=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(G,F.id,0,`${h(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const G=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(G,F.id,0,h(F.type));return}}}send(F,G=void 0){const x=new y;return a(x,F),a(x,G),this.sendBuffer(x.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(G){return 0}}onBuffer(F){const G=new v(F),x=l(G),N=l(G),W=x[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,f(W)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],0,f(W),N),this.onResponse({type:x[0],id:x[1],data:N})}}onResponse(F){if(F.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(F.id);G&&G(F)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}he([L.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class A{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:G,onDidClientDisconnect:x})=>{S.Event.once(G.onMessage)(W=>{const X=new v(W),Z=l(X),B=new u(G,Z),V=new m(G);this.channels.forEach((re,ae)=>B.registerChannel(ae,re));const ie={channelServer:B,channelClient:V,ctx:Z};this._connections.add(ie),this._onDidAddConnection.fire(ie),x(()=>{B.dispose(),V.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const F=[];return this._connections.forEach(G=>F.push(G)),F}getChannel(F,G){const x=this;return{call(N,W,X){let Z;if((0,g.isFunction)(G)){let V=(0,R.getRandomElement)(x.connections.filter(G));Z=V?Promise.resolve(V):S.Event.toPromise(S.Event.filter(x.onDidAddConnection,G))}else Z=G.routeCall(x,N,W);const B=Z.then(V=>V.channelClient.getChannel(F));return w(B).call(N,W,X)},listen(N,W){if((0,g.isFunction)(G))return x.getMulticastEvent(F,G,N,W);const X=G.routeEvent(x,N,W).then(Z=>Z.channelClient.getChannel(F));return w(X).listen(N,W)}}}getMulticastEvent(F,G,x,N){const W=this;let X=new I.DisposableStore;const Z=new S.Emitter({onFirstListenerAdd:()=>{X=new I.DisposableStore;const B=new S.EventMultiplexer,V=new Map,ie=ae=>{const fe=ae.channelClient.getChannel(F).listen(x,N),ge=B.add(fe);V.set(ae,ge)},re=ae=>{const ue=V.get(ae);!ue||(ue.dispose(),V.delete(ae))};W.connections.filter(G).forEach(ie),S.Event.filter(W.onDidAddConnection,G)(ie,void 0,X),W.onDidRemoveConnection(re,void 0,X),B.event(Z.fire,Z,X),X.add(B)},onLastListenerRemove:()=>{X.dispose()}});return Z.event}registerChannel(F,G){this.channels.set(F,G),this._connections.forEach(x=>{x.channelServer.registerChannel(F,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class _{constructor(F,G,x=null){const N=new y;a(N,G),F.send(N.buffer),this.channelClient=new m(F,x),this.channelServer=new u(F,G,x)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,G){this.channelServer.registerChannel(F,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function w(q){return{call(F,G,x){return q.then(N=>N.call(F,G,x))},listen(F,G){const x=new S.Relay;return q.then(N=>x.input=N.listen(F,G)),x.event}}}e.getDelayedChannel=w;function U(q){let F=!1;return{call(G,x,N){return F?q.call(G,x,N):(0,k.timeout)(0).then(()=>F=!0).then(()=>q.call(G,x,N))},listen(G,x){if(F)return q.listen(G,x);const N=new S.Relay;return(0,k.timeout)(0).then(()=>F=!0).then(()=>N.input=q.listen(G,x)),N.event}}}e.getNextTickChannel=U;class O{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const G of F.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await S.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=O;var $;(function(q){function F(W,X){const Z=W,B=X&&X.disableMarshalling,V=new Map;for(const ie in Z)x(ie)&&V.set(ie,S.Event.buffer(Z[ie],!0));return new class{listen(ie,re,ae){const ue=V.get(re);if(ue)return ue;if(N(re)){const fe=Z[re];if(typeof fe=="function")return fe.call(Z,ae)}throw new Error(`Event not found: ${re}`)}call(ie,re,ae){const ue=Z[re];if(typeof ue=="function"){if(!B&&Array.isArray(ae))for(let fe=0;fe<ae.length;fe++)ae[fe]=(0,n.revive)(ae[fe]);return ue.apply(Z,ae)}throw new Error(`Method not found: ${re}`)}}}q.fromService=F;function G(W,X){const Z=X&&X.disableMarshalling;return new Proxy({},{get(B,V){if(typeof V=="string")return X?.properties?.has(V)?X.properties.get(V):N(V)?function(ie){return W.listen(V,ie)}:x(V)?W.listen(V):async function(...ie){let re;X&&!(0,g.isUndefinedOrNull)(X.context)?re=[X.context,...ie]:re=ie;const ae=await W.call(V,re);return Z?ae:(0,n.revive)(ae)};throw new Error(`Property not found: ${String(V)}`)}})}q.toService=G;function x(W){return W[0]==="o"&&W[1]==="n"&&C.isUpperAsciiLetter(W.charCodeAt(2))}function N(W){return/^onDynamic/.test(W)&&C.isUpperAsciiLetter(W.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let F=q.toString();if(F!=="[object Object]")return F}return q}function H(q){return Array.isArray(q)?q.map(M):M(q)}function j(q,F,G,x,N,W,X){X=H(X);const Z=K[N],B=Z[x%Z.length];let V=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(W)?(V=V.concat(X),V.push(")")):V.push(X),console.log.apply(console,V)}e.logWithColors=j;class z{constructor(F,G){this._outgoingPrefix=F,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,G,x,N,W){this._totalOutgoing+=F,j(this._outgoingPrefix,this._totalOutgoing,F,G,x,N,W)}logIncoming(F,G,x,N,W){this._totalIncoming+=F,j(this._incomingPrefix,this._totalIncoming,F,G,x,N,W)}}e.IPCLogger=z}),define(te[114],ne([0,1,22,3,33]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(S){this.port=S,this.onMessage=k.Event.fromDOMEventEmitter(this.port,"message",I=>R.VSBuffer.wrap(I.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class L extends D.IPCClient{constructor(S,I){const n=new T(S);super(n,I);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=L}),define(te[72],ne([0,1,22,3,2,4,31,33]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function n(){return I||(I=R.VSBuffer.alloc(0)),I}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return n();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const m=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),m}if(this._chunks[0].byteLength>r){const m=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),m}let l=R.VSBuffer.alloc(r),u=0,d=0;for(;r>0;){const m=this._chunks[d];if(m.byteLength>r){const A=m.slice(0,r);l.set(A,u),u+=r,a&&(this._chunks[d]=m.slice(r),this._totalLength-=r),r-=r}else l.set(m,u),u+=m.byteLength,a?(this._chunks.shift(),this._totalLength-=m.byteLength):d++,r-=m.byteLength}return l}}e.ChunkStream=C;var g;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var b;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(r,a,l,u){this.type=r,this.id=a,this.ack=l,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends D.Disposable{constructor(r){super();this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const l=this._state.messageType,u=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(l,u,d,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=R.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._writeSoon(a,r.data)}_bufferAdd(r,a){const l=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,l}_bufferTake(){const r=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends D.Disposable{constructor(r){super();this._onMessage=new k.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new h(1,0,0,r))}}e.Protocol=E;class v extends P.IPCClient{constructor(r,a,l=null){super(r,a,l);this.protocol=r}static fromSocket(r,a){return new v(new E(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=v;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new k.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,L.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,l=this._first;for(;l;)r[a++]=l.data,l=l.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new c(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const r=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let u=0;u<t._HISTORY_LENGTH;u++)r-this.lastRuns[u]<=a&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(r,a=null,l=t.getInstance()){this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new h(5,0,0,n());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const a=new h(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let a=0,l=r.length;a<l;a++)this._socketWriter.write(r[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,n())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const a=this._outgoingUnackMsg.toArray();for(let l=0,u=a.length;l<u;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(r){const a=new h(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,n());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(te[115],ne([0,1,116,3,33,114]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends D.IPCServer{static getOnDidClientConnect(){const S=k.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(I,n)=>n);return k.Event.map(S,I=>{const{port1:n,port2:C}=new MessageChannel,b={protocol:new T.Protocol(n),onDidClientDisconnect:k.Event.fromDOMEventEmitter(n,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[C]),b})}constructor(){super(L.getOnDidClientConnect())}}e.Server=L}),define(te[117],ne([0,1,22,8]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(P,S){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((n,C)=>{I.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(I,P),I.responseType="arraybuffer",I.onerror=g=>C(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=g=>{n({res:{statusCode:I.status,headers:L(I)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=g=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(I.timeout=P.timeout),I.send(P.data),S.onCancellationRequested(()=>{I.abort(),C((0,k.canceled)())})})}e.request=D;function T(P,S){if(S.headers){e:for(let I in S.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(I,S.headers[I])}}}function L(P){const S=Object.create(null);for(const I of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const n=I.indexOf(":");S[I.substr(0,n).trim().toLowerCase()]=I.substr(n+1).trim()}return S}}),define(te[73],ne([0,1,6,3,2,18]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function P(C){const g=C;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var S;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(S||(S={}));class I extends D.Disposable{constructor(g,b=Object.create(null)){super();this.database=g,this.options=b,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((b,h)=>this.accept(h,b)),g.deleted?.forEach(b=>this.accept(b,void 0))}accept(g,b){if(this.state===S.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(b)?h=this.cache.delete(g):this.cache.get(g)!==b&&(this.cache.set(g,b),h=!0),h&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,b){const h=this.cache.get(g);return(0,T.isUndefinedOrNull)(h)?b:h}getBoolean(g,b){const h=this.get(g);return(0,T.isUndefinedOrNull)(h)?b:h==="true"}getNumber(g,b){const h=this.get(g);return(0,T.isUndefinedOrNull)(h)?b:parseInt(h,10)}async set(g,b){if(this.state===S.Closed)return;if((0,T.isUndefinedOrNull)(b))return this.delete(g);const h=String(b);if(this.cache.get(g)!==h)return this.cache.set(g,h),this.pendingInserts.set(g,h),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===S.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class n{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((b,h)=>this.items.set(h,b)),g.delete&&g.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=n}),define(te[118],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[57],ne([0,1,118]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,T=D*24,L=T*7,P=T*30,S=T*365;function I(C,g){typeof C!="number"&&(C=C.getTime());const b=Math.round((new Date().getTime()-C)/1e3);if(b<-30)return(0,R.localize)(0,null,I(new Date().getTime()+b*1e3,!1));if(b<30)return(0,R.localize)(1,null);let h;return b<k?(h=b,g?h===1?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):h===1?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h)):b<D?(h=Math.floor(b/k),g?h===1?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):h===1?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):b<T?(h=Math.floor(b/D),g?h===1?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):h===1?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h)):b<L?(h=Math.floor(b/T),g?h===1?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):h===1?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):b<P?(h=Math.floor(b/L),g?h===1?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):h===1?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h)):b<S?(h=Math.floor(b/P),g?h===1?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):h===1?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):(h=Math.floor(b/S),g?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h))}e.fromNow=I;function n(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(te[119],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,17,18,119]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(I,n){return n&&(I.stack||I.stacktrace)?D.localize(0,null,P(I),L(I.stack)||L(I.stacktrace)):P(I)}function L(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function S(I=null,n=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const C=R.coalesce(I),g=S(C[0],n);return C.length>1?D.localize(4,null,g,C.length):g}if(k.isString(I))return I;if(I.detail){const C=I.detail;if(C.error)return T(C.error,n);if(C.exception)return T(C.exception,n)}return I.stack?T(I,n):I.message?I.message:D.localize(5,null)}e.toErrorMessage=S}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,37,40,15,26,9,4,31,101,18,70,19,120]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(o,t){if(P.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};t&&(s.cwd=t);const i=R.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",a=>{r({success:!1,error:a})}),i.once("exit",(a,l)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?h(s.status):1})}else if(P.isLinux||P.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(i=>{R.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,l)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function f(o=S.env){return o.comspec||"cmd.exe"}e.getWindowsShell=f;class E{constructor(t,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=t,this.args=s,this.shell=i,this.options=r;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(S.env).forEach(l=>{a[l]=S.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const s=t.lastIndexOf(L.sep);return s!==-1&&(t=t.substring(s+1)),E.WellKnowCommands[t]?t:"other"}start(t){return P.isWindows&&(this.options&&this.options.cwd&&k.isUNC(this.options.cwd)||!this.options&&k.isUNC(S.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(s=>{let i,r;const a=new Promise((l,u)=>{i=l,r=u});if(s){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=R.exec(l,this.options,(u,d,m)=>{this.childProcess=null;const A=u;A&&A.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:m.toString()}):this.handleExec(i,t,u,d,m)})}else{let l=null;const u=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,i,t,r);const m={terminated:this.terminateRequested};n.isNumber(d)&&(m.cmdCode=d),i(m)};if(this.shell&&P.isWindows){const d=T.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let m=!1,A=!1;const _=[];let w=this.ensureQuotes(this.cmd);_.push(w.value),m=w.quoted,this.args&&this.args.forEach(O=>{w=this.ensureQuotes(O),_.push(w.value),A=A&&w.quoted});const U=["/s","/c"];m?A?U.push('"'+_.join(" ")+'"'):_.length>1?U.push('"'+_[0]+'" '+_.slice(1).join(" ")):U.push('"'+_[0]+'"'):U.push(_.join(" ")),l=R.spawn(f(),U,d)}else this.cmd&&(l=R.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(n.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",u),this.handleSpawn(l,i,t,r,!0)))}return a})}handleClose(t,s,i,r){}ensureQuotes(t){return E.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,p(t,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!P.isWindows)return t(!1);const s=R.spawn(f(),["/s","/c"]);s.on("error",i=>t(!0)),s.on("exit",i=>t(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class v extends E{constructor(t,s,i,r){super(t,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,s,i,r,a){[r,a].forEach((l,u)=>{const d=new C.LineDecoder;d.write(l).forEach(_=>{s({line:_,source:u===0?0:1})});const A=d.end();A&&s({line:A,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:i})}handleSpawn(t,s,i,r,a){const l=new C.LineDecoder,u=new C.LineDecoder;t.stdout.on("data",d=>{l.write(d).forEach(A=>i({line:A,source:0}))}),t.stderr.on("data",d=>{u.write(d).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=u}handleClose(t,s,i,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}e.LineProcess=v;function y(o){let t=[],s=!1;const i=function(r){if(s){t.push(r);return}(!o.send(r,l=>{if(l&&console.error(l),s=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(d=>i(d))}})||P.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=y;var c;(function(o){async function t(s,i,r){if(L.isAbsolute(s))return s;if(i===void 0&&(i=S.cwd()),L.dirname(s)!=="."||(r===void 0&&n.isString(S.env.PATH)&&(r=S.env.PATH.split(L.delimiter)),r===void 0||r.length===0))return L.join(i,s);async function l(u){if(await g.Promises.exists(u)){let d;try{d=await g.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(d=await g.Promises.lstat(u))}return d?!d.isDirectory():!1}return!1}for(let u of r){let d;if(L.isAbsolute(u)?d=L.join(u,s):d=L.join(i,u,s),await l(d))return d;let m=d+".com";if(await l(m)||(m=d+".exe",await l(m)))return m}return L.join(i,s)}o.findExecutable=t})(c=e.win32||(e.win32={}))}),define(te[121],ne([0,1,32,4,71,74]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(b,h){return b===1?k.isWindows?C():T.getWindowsShell(h):I(b,h)}e.getSystemShell=L;function P(b,h){return b===1?k.isWindows?g(h):T.getWindowsShell(h):I(b,h)}e.getSystemShellSync=P;let S=null;function I(b,h){if(k.isLinux&&b===2||k.isMacintosh&&b===3)return"/bin/bash";if(!S){let p;if(k.isWindows)p="/bin/bash";else{if(p=h.SHELL,!p)try{p=(0,R.userInfo)().shell}catch(f){}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}S=p}return S}let n=null;async function C(){return n||(n=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),n}function g(b){if(n)return n;const h=k.isWindows&&parseFloat((0,R.release)())>=10,p=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${b.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?f:T.getWindowsShell(b)}}),define(te[52],ne([0,1,37,6,22,27,103,8,3,2,26,4,74,33]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends b.ChannelServer{constructor(E){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(y){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=h;class p{constructor(E,v){this.modulePath=E,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new k.Delayer(y),this.child=null,this._client=null}getChannel(E){const v=this;return{call(y,c,o){return v.requestPromise(E,y,c,o)},listen(y,c){return v.requestEvent(E,y,c)}}}requestPromise(E,v,y,c=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(E),t=(0,k.createCancelablePromise)(r=>o.call(v,y,r)),s=c.onCancellationRequested(()=>t.cancel()),i=(0,I.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,v,y){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let c;const o=new S.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(E).listen(v,y)(o.fire,o),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),C.isMacintosh&&v.env&&delete v.env.DYLD_LIBRARY_PATH,this.child=(0,R.fork)(this.modulePath,E,v);const y=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,L.isRemoteConsoleLog)(a)){(0,L.log)(a,`IPC Library: ${this.options.serverName}`);return}y.fire(D.VSBuffer.wrap(Buffer.from(a,"base64")))});const o=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&o.send(a.buffer.toString("base64")),s=y.event,i={send:t,onMessage:s};this._client=new b.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,I.dispose)(u)),this.activeRequests.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:l})})}return this._client}getCachedChannel(E){let v=this.channels.get(E);return v||(v=this.client.getChannel(E),this.channels.set(E,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[123],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,57,66,15,9,31,16,7]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(p,f,E){this._args=p,this.paths=f,this.productService=E}get appRoot(){return(0,T.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(S.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=L.env.VSCODE_PORTABLE;return p?S.URI.file((0,T.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,T.resolve)(p):(0,T.normalize)((0,T.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,T.resolve)(p):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,T.resolve)(p);const f=L.env.VSCODE_EXTENSIONS;if(f)return f;const E=L.env.VSCODE_PORTABLE;return E?(0,T.join)(E,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(f=>/^[^:/?#]+?:\/\//.test(f)?S.URI.parse(f):S.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?S.URI.parse(p):S.URI.file((0,T.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([k.memoize],I.prototype,"appRoot",null),he([k.memoize],I.prototype,"userHome",null),he([k.memoize],I.prototype,"userDataPath",null),he([k.memoize],I.prototype,"appSettingsHome",null),he([k.memoize],I.prototype,"tmpDir",null),he([k.memoize],I.prototype,"userRoamingDataHome",null),he([k.memoize],I.prototype,"settingsResource",null),he([k.memoize],I.prototype,"userDataSyncHome",null),he([k.memoize],I.prototype,"userDataSyncLogResource",null),he([k.memoize],I.prototype,"sync",null),he([k.memoize],I.prototype,"machineSettingsResource",null),he([k.memoize],I.prototype,"globalStorageHome",null),he([k.memoize],I.prototype,"workspaceStorageHome",null),he([k.memoize],I.prototype,"keybindingsResource",null),he([k.memoize],I.prototype,"keyboardLayoutResource",null),he([k.memoize],I.prototype,"argvResource",null),he([k.memoize],I.prototype,"snippetsHome",null),he([k.memoize],I.prototype,"isExtensionDevelopment",null),he([k.memoize],I.prototype,"untitledWorkspacesHome",null),he([k.memoize],I.prototype,"installSourcePath",null),he([k.memoize],I.prototype,"builtinExtensionsPath",null),he([k.memoize],I.prototype,"extensionsPath",null),he([k.memoize],I.prototype,"extensionDevelopmentLocationURI",null),he([k.memoize],I.prototype,"extensionDevelopmentKind",null),he([k.memoize],I.prototype,"extensionTestsLocationURI",null),he([k.memoize],I.prototype,"debugExtensionHost",null),he([k.memoize],I.prototype,"serviceMachineIdResource",null),he([k.memoize],I.prototype,"telemetryLogResource",null),he([k.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function n(h,p){return b(h["inspect-extensions"],h["inspect-brk-extensions"],5870,p,h.debugId)}e.parseExtensionHostPort=n;function C(h,p){return b(h["inspect-search"],h["inspect-brk-search"],5876,p)}e.parseSearchPort=C;function g(h,p){return b(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,p)}e.parsePtyHostPort=g;function b(h,p,f,E,v){const c=Number(p||h)||(E?null:f),o=c?Boolean(!!p):!1;return{port:c,break:o,debugId:v}}}),define(te[146],ne([0,1,236,4,124]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,p,f=L){const E={},v=[],y=[];for(let s in p){const i=p[s];i.alias&&(E[s]=i.alias),i.type==="string"||i.type==="string[]"?(v.push(s),i.deprecates&&v.push(i.deprecates)):i.type==="boolean"&&(y.push(s),i.deprecates&&y.push(i.deprecates))}const c=R(h,{string:v,boolean:y,alias:E}),o={},t=c;o._=c._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in p){const i=p[s];i.alias&&delete t[i.alias];let r=t[s];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(r||(r=t[i.deprecates]),delete t[i.deprecates]),typeof r!="undefined"&&(i.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):i.type==="string"&&Array.isArray(r)&&(r=r.pop(),f.onMultipleValues(s,r)),o[s]=r),delete t[s]}for(let s in t)f.onUnknownOption(s);return o}e.parseArgs=P;function S(h,p){let f="";return p.args&&(Array.isArray(p.args)?f=` <${p.args.join("> <")}>`:f=` <${p.args}>`),p.alias?`-${p.alias} --${h}${f}`:`--${h}${f}`}function I(h,p){let f=0,E=[];for(const o in h){const t=h[o],s=S(o,t);f=Math.max(f,s.length),E.push([s,t.description])}let v=f+2+1;if(p-v<25)return E.reduce((o,t)=>o.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let y=p-v-1,c=[];for(const o of E){let t=o[0],s=C(o[1],y),i=n(v-t.length-2);c.push("  "+t+i+s[0]);for(let r=1;r<s.length;r++)c.push(n(v)+s[r])}return c}e.formatOptions=I;function n(h){return" ".repeat(h)}function C(h,p){let f=[];for(;h.length;){let E=h.length<p?h.length:h.lastIndexOf(" ",p),v=h.slice(0,E).trim();h=h.slice(E),f.push(v)}return f}function g(h,p,f,E,v=!0){const y=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${h} ${f}`];c.push(""),c.push(`${(0,D.localize)(32,null)}: ${p} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),c.push(""),v&&(k.isWindows?c.push((0,D.localize)(35,null,p)):c.push((0,D.localize)(36,null,p)),c.push(""));const o={};for(const t in E){const s=E[t];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[t]=s}}for(let t in o){const s=t;let i=o[s];i&&(c.push(T[s]),c.push(...I(i,y)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=g;function b(h,p){return`${h||(0,D.localize)(37,null)}
${p||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=b}),function(){"use strict";function J(e,R,k,D){function T(P){const S=L(P),I=[S];return e.isAbsolute(S)||I.unshift(D),e.resolve(...I)}function L(P){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,k);const n=P["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(C,"AppData","Roaming")}break;case"darwin":I=e.join(R.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,k)}return{getUserDataPath:T}}if(typeof define=="function")define(te[147],ne([0,148,32,15,16,31]),function(e,R,k,D,T,L){const P=T.dirname(D.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return J(R,k,S.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),k=require("os");module.exports=J(R,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[149],ne([0,1,32,75,147]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends k.AbstractNativeEnvironmentService{constructor(P,S){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},S)}}e.NativeEnvironmentService=T}),define(te[150],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(f){const E=f.match(L);return E?E[1]:null}function n(f){if(f.indexOf("://")===-1){const E=f.match(k);return E?I(E[2]):null}try{const E=R.URI.parse(f);if(E.authority)return I(E.authority)}catch(E){}return null}function C(f,E){const v=new Set;let y;for(;y=P.exec(f);){const o=n(y[1]);o&&v.add(o)}const c=new Set(E);return Array.from(v).map(o=>c.has(o)?o:o.replace(S,"a"))}e.getDomainsOfRemotes=C;function g(f){const E=f.match(T);return E?E[2]:null}function b(f,E,v){return f&&E?(v&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${f}${E}`:`${f}/${E}`):null}function h(f,E){if(f.indexOf("://")===-1){const v=f.match(D);if(v)return b(v[2],v[3],E)}try{const v=R.URI.parse(f);if(v.authority)return b(g(v.authority),v.path,E)}catch(v){}return null}function p(f,E=!1){const v=[];let y;for(;y=P.exec(f);){const c=h(y[1],E);c&&v.push(c)}return v}e.getRemotes=p}),define(te[151],ne([0,1,26]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function D(T,L){const P=S=>{if(typeof S!="string")return;const I=k.exec(S);if(!I)return;const n=L[I[1]]??S;return typeof n=="string"?n:typeof n.message=="string"?n.message:S};return(0,R.cloneAndChange)(T,P)}e.localizeManifest=D}),define(te[152],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,L,P,S){return this.channel.call("promptImportantExtensionsInstallNotification",[T,L,P,S])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class k{constructor(T){this.service=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(te[76],ne([0,1,132]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function T(g){return g=g.trim(),g==="*"||k.test(g)}e.isValidVersionStr=T;function L(g){if(!T(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=g.match(k);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=L;function P(g){if(!g)return null;let b=g.majorBase,h=g.majorMustEqual,p=g.minorBase,f=g.minorMustEqual,E=g.patchBase,v=g.patchMustEqual;g.hasCaret&&(b===0||(f=!1),v=!1);let y=0;if(g.preRelease){const c=D.exec(g.preRelease);if(c){const[,o,t,s]=c;y=Date.UTC(Number(o),Number(t)-1,Number(s))}}return{majorBase:b,majorMustEqual:h,minorBase:p,minorMustEqual:f,patchBase:E,patchMustEqual:v,isMinimum:g.hasGreaterEquals,notBefore:y}}e.normalizeVersion=P;function S(g,b,h){let p;typeof g=="string"?p=P(L(g)):p=g;let f;b instanceof Date?f=b.getTime():typeof b=="string"&&(f=new Date(b).getTime());let E;if(typeof h=="string"?E=P(L(h)):E=h,!p||!E)return!1;let v=p.majorBase,y=p.minorBase,c=p.patchBase,o=E.majorBase,t=E.minorBase,s=E.patchBase,i=E.notBefore,r=E.majorMustEqual,a=E.minorMustEqual,l=E.patchMustEqual;return E.isMinimum?v>o?!0:v<o?!1:y>t?!0:y<t||f&&f<i?!1:c>=s:(v===1&&o===0&&(!r||!a||!l)&&(o=1,t=0,s=0,r=!0,a=!1,l=!1),v<o?!1:v>o?!r:y<t?!1:y>t?!a:c<s?!1:c>s?!l:!(f&&f<i))}e.isValidVersion=S;function I(g,b,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:C(g,b,h.engines.vscode,p)}e.isValidExtensionVersion=I;function n(g,b,h){return g==="*"||C(b,h,g)}e.isEngineValid=n;function C(g,b,h,p=[]){let f=P(L(h));if(!f)return p.push(R.localize(0,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return p.push(R.localize(1,null,h)),!1}else if(!f.majorMustEqual)return p.push(R.localize(2,null,h)),!1;return S(g,b,f)?!0:(p.push(R.localize(3,null,g,h)),!1)}}),define(te[153],ne([0,1,2,15,33,52]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends R.Disposable{constructor(S,I,n,C){super();this.requests=S,this.onDidFilesChange=I,this.onLogMessage=n,this.verboseLogging=C,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I))),this.watch(this.requests)}setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}watch(S){this.requests=S,this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(te[154],ne([0,1,2,15,33,52]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends R.Disposable{constructor(S,I,n,C,g={}){super();this.folders=S,this.onDidFilesChange=I,this.onLogMessage=n,this.verboseLogging=C,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(S.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I))),this.service.watch(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}watch(S){this.folders=S,this.service&&this.service.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(te[155],ne([0,1,37,69,15,70]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class L{constructor(S,I,n,C,g){this.watchedFolder=S,this.eventCallback=n,this.logCallback=C,this.verboseLogging=g,this.restartCounter=0,Array.isArray(I)?this.ignored=I.map(b=>(0,k.parse)(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}, excludes: ${I.join(",")}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=(0,R.spawn)(D.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",J).fsPath,S);const I=new T.LineDecoder;this.handle.stdout.on("data",n=>{const C=[];for(const g of I.write(n)){const b=g.split("|");if(b.length===2){const h=Number(b[0]),p=b[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(f=>f(p))){this.verboseLogging&&this.log(p);continue}C.push({type:L.changeTypeMap[h],path:p})}else this.log(b[1])}}C.length>0&&this.eventCallback(C)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,C)=>this.onExit(n,C))}onError(S){this.error("process error: "+S.toString())}onExit(S,I){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${I})`),this.restartCounter<=L.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=L,L.MAX_RESTARTS=5,L.changeTypeMap=[0,1,2]}),define(te[156],ne([0,1,9,25,155]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(P,S,I,n){this.onDidFilesChange=S,this.onLogMessage=I,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,k.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new D.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,T=[],L=!1){this.ctor=D,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=R}),define(te[77],ne([0,1,53]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function D(L,P,S){P instanceof R.SyncDescriptor||(P=new R.SyncDescriptor(P,[],S)),k.push([L,P])}e.registerSingleton=D;function T(){return k}e.getSingletonServiceDescriptors=T}),define(te[157],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=R;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const P=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(L);P.outgoing.set(this._hashFn(L),S),S.incoming.set(this._hashFn(T),P)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(let P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let P=this._nodes.get(L);return P||(P=new R(T),this._nodes.set(L,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[L,P]of this._nodes)T.push(`${L}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,L]of this._nodes){const P=new Set([T]),S=this._findCycle(L,P);if(S)return S}}_findCycle(T,L){for(let[P,S]of T.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const I=this._findCycle(S,L);if(I)return I;L.delete(P)}}}e.Graph=k}),define(te[5],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function S(I){return I[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=S})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function k(P,S,I,n){S[R.DI_TARGET]===S?S[R.DI_DEPENDENCIES].push({id:P,index:I,optional:n}):(S[R.DI_DEPENDENCIES]=[{id:P,index:I,optional:n}],S[R.DI_TARGET]=S)}function D(P){if(R.serviceIds.has(P))return R.serviceIds.get(P);const S=function(I,n,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(S,I,C,!1)};return S.toString=()=>P,R.serviceIds.set(P,S),S}e.createDecorator=D;function T(P){return P}e.refineServiceDecorator=T;function L(P){return function(S,I,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(P,S,n,!0)}}e.optional=L}),define(te[158],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(te[159],ne([0,1,4,25,5]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=R.userAgent||"";const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",R.isMacintosh),L.set("isLinux",R.isLinux),L.set("isWindows",R.isWindows),L.set("isWeb",R.isWeb),L.set("isMacNative",R.isMacintosh&&!R.isWeb),L.set("isEdge",T.indexOf("Edg/")>=0),L.set("isFirefox",T.indexOf("Firefox")>=0),L.set("isChrome",T.indexOf("Chrome")>=0),L.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var S;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(w){return b.create(w)}static equals(w,U){return h.create(w,U)}static notEquals(w,U){return E.create(w,U)}static regex(w,U){return s.create(w,U)}static in(w,U){return p.create(w,U)}static not(w){return v.create(w)}static and(...w){return r.create(w,null)}static or(...w){return a.create(w,null,!0)}static greater(w,U){return y.create(w,U)}static less(w,U){return o.create(w,U)}static deserialize(w,U=!1){if(!!w)return this._deserializeOrExpression(w,U)}static _deserializeOrExpression(w,U){let O=w.split("||");return a.create(O.map($=>this._deserializeAndExpression($,U)),null,!0)}static _deserializeAndExpression(w,U){let O=w.split("&&");return r.create(O.map($=>this._deserializeOne($,U)),null)}static _deserializeOne(w,U){if(w=w.trim(),w.indexOf("!=")>=0){let O=w.split("!=");return E.create(O[0].trim(),this._deserializeValue(O[1],U))}if(w.indexOf("==")>=0){let O=w.split("==");return h.create(O[0].trim(),this._deserializeValue(O[1],U))}if(w.indexOf("=~")>=0){let O=w.split("=~");return s.create(O[0].trim(),this._deserializeRegexValue(O[1],U))}if(w.indexOf(" in ")>=0){let O=w.split(" in ");return p.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const O=w.split(">=");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const O=w.split(">");return y.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const O=w.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const O=w.split("<");return o.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(w)?v.create(w.substr(1).trim()):b.create(w)}static _deserializeValue(w,U){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let O=/^'([^']*)'$/.exec(w);return O?O[1].trim():w}static _deserializeRegexValue(w,U){if((0,k.isFalsyOrWhitespace)(w)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=w.indexOf("/"),$=w.lastIndexOf("/");if(O===$||O<0){if(U)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let K=w.slice(O+1,$),M=w[$+1]==="i"?"i":"";try{return new RegExp(K,M)}catch(H){if(U)throw new Error(`bad regexp-value '${w}', parse error: ${H}`);return console.warn(`bad regexp-value '${w}', parse error: ${H}`),null}}}e.ContextKeyExpr=I;function n(_,w){return _.cmp(w)}class C{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class b{constructor(w,U){this.key=w,this.negated=U,this.type=2}static create(w,U=null){const O=L.get(w);return typeof O=="boolean"?O?g.INSTANCE:C.INSTANCE:new b(w,U)}cmp(w){return w.type!==this.type?this.type-w.type:u(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class h{constructor(w,U,O){this.key=w,this.value=U,this.negated=O,this.type=4}static create(w,U,O=null){if(typeof U=="boolean")return U?b.create(w,O):v.create(w,O);const $=L.get(w);return typeof $=="boolean"?U===($?"true":"false")?g.INSTANCE:C.INSTANCE:new h(w,U,O)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class p{constructor(w,U){this.key=w,this.valueKey=U,this.type=10,this.negated=null}static create(w,U){return new p(w,U)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const U=w.getValue(this.valueKey),O=w.getValue(this.key);return Array.isArray(U)?U.indexOf(O)>=0:typeof O=="string"&&typeof U=="object"&&U!==null?P.call(U,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=p;class f{constructor(w){this._actual=w,this.type=11}static create(w){return new f(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new f(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class E{constructor(w,U,O){this.key=w,this.value=U,this.negated=O,this.type=5}static create(w,U,O=null){if(typeof U=="boolean")return U?v.create(w,O):b.create(w,O);const $=L.get(w);return typeof $=="boolean"?U===($?"true":"false")?C.INSTANCE:g.INSTANCE:new E(w,U,O)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class v{constructor(w,U){this.key=w,this.negated=U,this.type=3}static create(w,U=null){const O=L.get(w);return typeof O=="boolean"?O?C.INSTANCE:g.INSTANCE:new v(w,U)}cmp(w){return w.type!==this.type?this.type-w.type:u(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;class y{constructor(w,U,O){this.key=w,this.value=U,this.negated=O,this.type=12}static create(w,U,O=null){return new y(w,U,O)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=y;class c{constructor(w,U,O){this.key=w,this.value=U,this.negated=O,this.type=13}static create(w,U,O=null){return new c(w,U,O)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class o{constructor(w,U,O){this.key=w,this.value=U,this.negated=O,this.type=14}static create(w,U,O=null){return new o(w,U,O)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class t{constructor(w,U,O){this.key=w,this.value=U,this.negated=O,this.type=15}static create(w,U,O=null){return new t(w,U,O)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(w,U){this.key=w,this.regexp=U,this.type=7,this.negated=null}static create(w,U){return new s(w,U)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const U=this.regexp?this.regexp.source:"",O=w.regexp?w.regexp.source:"";return U<O?-1:U>O?1:0}equals(w){if(w.type===this.type){const U=this.regexp?this.regexp.source:"",O=w.regexp?w.regexp.source:"";return this.key===w.key&&U===O}return!1}evaluate(w){let U=w.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class i{constructor(w){this._actual=w,this.type=8}static create(w){return new i(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new i(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class r{constructor(w,U){this.expr=w,this.negated=U,this.type=6}static create(w,U){return r._normalizeArr(w,U)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let U=0,O=this.expr.length;U<O;U++){const $=n(this.expr[U],w.expr[U]);if($!==0)return $}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let U=0,O=this.expr.length;U<O;U++)if(!this.expr[U].equals(w.expr[U]))return!1;return!0}return!1}evaluate(w){for(let U=0,O=this.expr.length;U<O;U++)if(!this.expr[U].evaluate(w))return!1;return!0}static _normalizeArr(w,U){const O=[];let $=!1;for(const K of w)if(!!K){if(K.type===1){$=!0;continue}if(K.type===0)return C.INSTANCE;if(K.type===6){O.push(...K.expr);continue}O.push(K)}if(O.length===0&&$)return g.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(n);for(let K=1;K<O.length;K++)O[K-1].equals(O[K])&&(O.splice(K,1),K--);if(O.length===1)return O[0];for(;O.length>1;){const K=O[O.length-1];if(K.type!==9)break;O.pop();const M=O.pop(),H=O.length===0,j=a.create(K.expr.map(z=>r.create([z,M],null)),null,H);j&&(O.push(j),O.sort(n))}return O.length===1?O[0]:new r(O,U)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let U of this.expr)w.push(...U.keys());return w}map(w){return new r(this.expr.map(U=>U.map(w)),null)}negate(){if(!this.negated){const w=[];for(let U of this.expr)w.push(U.negate());this.negated=a.create(w,this,!0)}return this.negated}}class a{constructor(w,U){this.expr=w,this.negated=U,this.type=9}static create(w,U,O){return a._normalizeArr(w,U,O)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let U=0,O=this.expr.length;U<O;U++){const $=n(this.expr[U],w.expr[U]);if($!==0)return $}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let U=0,O=this.expr.length;U<O;U++)if(!this.expr[U].equals(w.expr[U]))return!1;return!0}return!1}evaluate(w){for(let U=0,O=this.expr.length;U<O;U++)if(this.expr[U].evaluate(w))return!0;return!1}static _normalizeArr(w,U,O){let $=[],K=!1;if(w){for(let M=0,H=w.length;M<H;M++){const j=w[M];if(!!j){if(j.type===0){K=!0;continue}if(j.type===1)return g.INSTANCE;if(j.type===9){$=$.concat(j.expr);continue}$.push(j)}}if($.length===0&&K)return C.INSTANCE;$.sort(n)}if($.length!==0){if($.length===1)return $[0];for(let M=1;M<$.length;M++)$[M-1].equals($[M])&&($.splice(M,1),M--);if($.length===1)return $[0];if(O){for(let M=0;M<$.length;M++)for(let H=M+1;H<$.length;H++)m($[M],$[H])&&($.splice(H,1),H--);if($.length===1)return $[0]}return new a($,U)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let U of this.expr)w.push(...U.keys());return w}map(w){return new a(this.expr.map(U=>U.map(w)),null)}negate(){if(!this.negated){let w=[];for(let U of this.expr)w.push(U.negate());for(;w.length>1;){const U=w.shift(),O=w.shift(),$=[];for(const M of A(U))for(const H of A(O))$.push(r.create([M,H],null));const K=w.length===0;w.unshift(a.create($,null,K))}this.negated=w[0]}return this.negated}}class l extends b{constructor(w,U,O){super(w,null);this._defaultValue=U,typeof O=="object"?l._info.push({...O,key:w}):O!==!0&&l._info.push({key:w,description:O,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return h.create(this.key,w)}notEqualsTo(w){return E.create(this.key,w)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(_,w){return _<w?-1:_>w?1:0}function d(_,w,U,O){return _<U?-1:_>U?1:w<O?-1:w>O?1:0}function m(_,w){if(w.type===6&&_.type!==9&&_.type!==6){for(const $ of w.expr)if(_.equals($))return!0}const U=_.negate(),O=A(U).concat(A(w));O.sort(n);for(let $=0;$<O.length;$++){const M=O[$].negate();for(let H=$+1;H<O.length;H++){const j=O[H];if(M.equals(j))return!0}}return!1}e.implies=m;function A(_){return _.type===9?_.expr:[_]}}),define(te[78],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function k(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=k}),define(te[79],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(te[13],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ne([0,1,15,127,5]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function L(v){switch(v){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function P(v){switch(v){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function S(v,y){switch(v){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function I(v,y){return y==="web"&&!v.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function n(v,y,c){return I(y,c)?!1:v==="undefined"||v==="universal"?!0:v==="unknown"?!1:v===c?!0:C(c).includes(v)}e.isTargetPlatformCompatible=n;function C(v){switch(v){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function g(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=g;var b;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var h;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(v){v.Install="install",v.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class E extends Error{constructor(y,c){super(y);this.code=c,this.name=c}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var Q=this&&this.__param||function(J,e){return function(R,k){e(R,k,J)}};define(te[160],ne([0,1,2,28]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(L){super();this.extensionManagementService=L,this._register(L),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([Q(0,k.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[161],ne([0,1,3,2,26,7,106,28]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(p,f){return T.URI.revive(f?f.transformIncoming(p):p)}function I(p,f){return f?f.transformOutgoingURI(p):p}function n(p,f){f=f||L.DefaultURITransformer;const E=p.manifest;return{...(0,L.transformAndReviveIncomingURIs)({...p,manifest:void 0},f),manifest:E}}function C(p,f){return f?(0,D.cloneAndChange)(p,E=>E instanceof T.URI?f.transformOutgoingURI(E):void 0):p}class g{constructor(f,E){this.service=f,this.getUriTransformer=E,this.onInstallExtension=R.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,E){const v=this.getUriTransformer(f);switch(E){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,y=>y.map(c=>({...c,local:c.local?C(c.local,v):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,E,v){const y=this.getUriTransformer(f);switch(E){case"zip":return this.service.zip(n(v[0],y)).then(c=>I(c,y));case"unzip":return this.service.unzip(S(v[0],y));case"install":return this.service.install(S(v[0],y),v[1]);case"getManifest":return this.service.getManifest(S(v[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],v[1]);case"uninstall":return this.service.uninstall(n(v[0],y),v[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(n(v[0],y));case"getInstalled":return this.service.getInstalled(v[0]).then(c=>c.map(o=>C(o,y)));case"updateMetadata":return this.service.updateMetadata(n(v[0],y),v[1]).then(c=>C(c,y));case"updateExtensionScope":return this.service.updateExtensionScope(n(v[0],y),v[1]).then(c=>C(c,y));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class b extends k.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(E=>this._onInstallExtension.fire({identifier:E.identifier,source:this.isUriComponents(E.source)?T.URI.revive(E.source):E.source}))),this._register(this.channel.listen("onDidInstallExtensions")(E=>this._onDidInstallExtensions.fire(E.map(v=>({...v,local:v.local?n(v.local,null):v.local,source:this.isUriComponents(v.source)?T.URI.revive(v.source):v.source}))))),this._register(this.channel.listen("onUninstallExtension")(E=>this._onUninstallExtension.fire(E))),this._register(this.channel.listen("onDidUninstallExtension")(E=>this._onDidUninstallExtension.fire(E)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const E=await this.getTargetPlatform();return f.allTargetPlatforms.some(v=>(0,P.isTargetPlatformCompatible)(v,f.allTargetPlatforms,E))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(E=>T.URI.revive(E)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,E){return Promise.resolve(this.channel.call("install",[f,E])).then(v=>n(v,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,E){return Promise.resolve(this.channel.call("installFromGallery",[f,E])).then(v=>n(v,null))}uninstall(f,E){return Promise.resolve(this.channel.call("uninstall",[f,E]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(E=>E.map(v=>n(v,null)))}updateMetadata(f,E){return Promise.resolve(this.channel.call("updateMetadata",[f,E])).then(v=>n(v,null))}updateExtensionScope(f,E){return Promise.resolve(this.channel.call("updateExtensionScope",[f,E])).then(v=>n(v,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=b;class h{constructor(f){this.service=f}listen(f,E){throw new Error("Invalid listen")}call(f,E,v){switch(E){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function D(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var T;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,R.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[82],ne([0,1,25,5]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,g){if(typeof C=="undefined"||C===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof C=="string"||typeof g=="string"){let b=typeof C=="string"?C:C.value,h=typeof g=="string"?g:g.value;return R.equalsIgnoreCase(b,h)}return C._lower===g._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function I(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[34],ne([0,1,25,82]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,R.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=D;class T{constructor(p,f){this.version=f,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof T?D(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=T;function L(h,p){return`${h}.${p}`}e.getExtensionId=L;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(h,p){return P(L(h,p))}e.getGalleryExtensionId=S;function I(h,p){const f=[],E=v=>{for(const y of f)if(y.some(c=>D(p(c),p(v))))return y;return null};for(const v of h){const y=E(v);y?y.push(v):f.push([v])}return f}e.groupByExtension=I;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function C(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(h){const p=new Set;for(const f of h)f.malicious&&p.add(f.id.id);return p}e.getMaliciousExtensionsSet=g;function b(h,p){const f=[],E=p.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const v=E.shift();if(v&&f.every(y=>!D(y.identifier,{id:v}))){const y=h.filter(c=>D(c.identifier,{id:v}));y.length===1&&(f.push(y[0]),E.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=b}),define(te[162],ne([0,1,2,9,19,82]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends R.Disposable{constructor(S,I){super();this.environmentService=S,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(I.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(S){S.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(te[14],ne([0,1,41,9,25,18,7,134,5]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function I(M){return M.create===!0}e.isFileOpenForWriteOptions=I;var n;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var g;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=b;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function f(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=f;var E;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(H,j){super(H);this.code=j}}e.FileSystemProviderError=v;function y(M,H){const j=new v(M.toString(),H);return o(j,H),j}e.createFileSystemProviderError=y;function c(M){return M||y((0,P.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=c;function o(M,H){return M.name=H?`${H} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=o;function t(M){if(!M)return E.Unknown;if(M instanceof v)return M.code;const H=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!H)return E.Unknown;switch(H[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function s(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(H,j,z){this.resource=H,this.operation=j,this.target=z}isOperation(H){return this.operation===H}}e.FileOperationEvent=r;var a;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(H,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of H)switch(z.type){case 1:this.added||(this.added=R.TernarySearchTree.forUris(()=>j)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=R.TernarySearchTree.forUris(()=>j)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=R.TernarySearchTree.forUris(()=>j)),this.deleted.set(z.resource,z);break}}contains(H,...j){return this.doContains(H,{includeChildren:!1},...j)}affects(H,...j){return this.doContains(H,{includeChildren:!0},...j)}doContains(H,j,...z){if(!H)return!1;const q=z.length>0;return!!((!q||z.includes(1))&&(this.added?.get(H)||j.includeChildren&&this.added?.findSuperstr(H))||(!q||z.includes(0))&&(this.updated?.get(H)||j.includeChildren&&this.updated?.findSuperstr(H))||(!q||z.includes(2))&&(this.deleted?.findSubstr(H)||j.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function u(M,H,j){return!M||!H||M===H||H.length>M.length?!1:(H.charAt(H.length-1)!==k.sep&&(H+=k.sep),j?(0,D.startsWithIgnoreCase)(M,H):M.indexOf(H)===0)}e.isParent=u;class d extends Error{constructor(H,j,z){super(H);this.fileOperationResult=j,this.options=z}}e.FileOperationError=d;class m extends d{constructor(H,j,z){super(H,2,z);this.stat=j}}e.NotModifiedSinceFileOperationError=m;var A;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=w;async function U(M,H){if(!H.canHandleResource(L.URI.from({scheme:M.scheme})))return new Promise(j=>{const z=H.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===M.scheme&&q.added&&(z.dispose(),j())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(H){return(0,T.isNumber)(H)||(H=0),H<O.KB?(0,P.localize)(1,null,H.toFixed(0)):H<O.MB?(0,P.localize)(2,null,(H/O.KB).toFixed(2)):H<O.GB?(0,P.localize)(3,null,(H/O.MB).toFixed(2)):H<O.TB?(0,P.localize)(4,null,(H/O.GB).toFixed(2)):(0,P.localize)(5,null,(H/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var $;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function K(M){return{maxFileSize:M===0?300*O.MB:16*O.GB,maxHeapSize:M===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=K}),define(te[163],ne([0,1,83,50,14]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(S,I)=>{const n=(0,R.createHash)("md5"),C=(await this.fileService.readFileStream(P)).value;(0,k.listenStream)(C,{onData:g=>n.update(g.buffer),onError:g=>I(g),onEnd:()=>S(n.digest("base64").replace(/=+$/,""))})})}};T=he([Q(0,D.IFileService)],T),e.ChecksumService=T}),define(te[164],ne([0,1,237,125,146,14]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function L(g,b){const h={onUnknownOption:f=>{console.warn((0,k.localize)(0,null,f))},onMultipleValues:(f,E)=>{console.warn((0,k.localize)(1,null,f,E))}},p=(0,D.parseArgs)(g,D.OPTIONS,b?h:void 0);return p.goto&&p._.forEach(f=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,k.localize)(2,null))),p["max-memory"]&&R(parseInt(p["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),p}function P(g){const b=g.findIndex(h=>!/^-/.test(h));if(b>-1)return[...g.slice(0,b),...g.slice(b+1)]}function S(g){let[,...b]=g;process.env.VSCODE_DEV&&(b=P(b)||[]);const h=!C(process.env);return L(b,h)}e.parseMainProcessArgv=S;function I(g){const[,,...b]=g;return L(b,!0)}e.parseCLIProcessArgv=I;function n(g,...b){const h=g.indexOf("--");return h===-1?g.push(...b):g.splice(h,0,...b),g}e.addArg=n;function C(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[165],ne([0,1,37,148,27,38,8,4,30,121,164]),function(J,e,R,k,D,T,L,P,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function C(h,p,f){return p["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,n.isLaunchedFromCli)(f)&&!p["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,n.isLaunchedFromCli)(f)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=new Promise(async E=>{const v=new D.CancellationTokenSource,y=setTimeout(()=>{h.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),v.dispose(!0),E({})},1e4);try{const c=await b(h,v.token);E(c)}catch(c){(0,L.isPromiseCanceledError)(c)||h.error(`[resolve shell env] Unable to resolve shell environment (${c}). Proceeding without shell environment...`),E({})}finally{clearTimeout(y),v.dispose()}})),g)}e.resolveShellEnv=C;let g;async function b(h,p){const f=new Promise(async(E,v)=>{const y=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",y);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",c);const o=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"(.*)"+o),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",s);const i=await(0,I.getSystemShell)(P.OS,s);if(h.trace("getUnixShellEnvironment#shell",i),p.isCancellationRequested)return v(L.canceled);const r=k.basename(i);let a,l;/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,l=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),a);const u=(0,R.spawn)(i,[...l,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});p.onCancellationRequested(()=>(u.kill(),v(L.canceled))),u.on("error",A=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(A)),E({})});const d=[];u.stdout.on("data",A=>d.push(A));const m=[];u.stderr.on("data",A=>m.push(A)),u.on("close",(A,_)=>{const w=Buffer.concat(d).toString("utf8");h.trace("getUnixShellEnvironment#raw",w);const U=Buffer.concat(m).toString("utf8");if(U.trim()&&h.trace("getUnixShellEnvironment#stderr",U),A||_)return v(new Error(`Failed to get environment (code ${A}, signal ${_})`));const O=t.exec(w),$=O?O[1]:"{}";try{const K=JSON.parse($);y?K.ELECTRON_RUN_AS_NODE=y:delete K.ELECTRON_RUN_AS_NODE,c?K.ELECTRON_NO_ATTACH_CONSOLE=c:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",K),E(K)}catch(K){h.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(K)),v(K)}})});try{return await f}catch(E){return h.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(E)),{}}}}),define(te[84],ne([0,1,4,7,14]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(S){return S.map(I=>({type:I.type,resource:k.URI.file(I.path)}))}e.toFileChanges=T;function L(S){const I=new P;for(const n of S)I.processEvent(n);return I.normalize()}e.normalizeFileChanges=L;class P{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return R.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const n=this.mapPathToChange.get(this.toKey(I));let C=!1;if(n){const g=n.type,b=I.type;n.path!==I.path&&(b===1||b===0)?(n.type=2,C=!0):g===1&&b===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(n)):g===2&&b===1?n.type=0:g===1&&b===0||(n.type=b)}else C=!0;C&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],n=[];return Array.from(this.normalized).filter(C=>C.type!==2?(I.push(C),!1):!0).sort((C,g)=>C.path.length-g.path.length).filter(C=>n.some(g=>(0,D.isParent)(C.path,g,!R.isLinux))?!1:(n.push(C.path),!0)).concat(I)}}}),define(te[166],ne([0,1,6,2,9,110,19,113,84]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends k.Disposable{constructor(C,g,b,h){super();this.path=C,this.onDidFilesChange=g,this.onLogMessage=b,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:g}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(g)try{b=await(0,T.realpath)(b)}catch(h){if(this.onError(h),g.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(b,(h,p)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(p))})},h=>this.onError(h))):this._register((0,P.watchFile)(b,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,S.normalizeFileChanges)(g);if(this.verboseLogging)for(const h of b)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I}),define(te[85],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[T,L]of D)this.set(T,L)}set(D,T){const L=this._entries.get(D);return this._entries.set(D,T),L}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(te[167],ne([0,1,6,8,53,157,5,85]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class I extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new P.ServiceCollection,p=!1,f){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=f,this._services.set(L.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...p){let f=g.traceInvocation(h),E=!1;try{return h({get:(y,c)=>{if(E)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(y,f);if(!o&&c!==L.optional)throw new Error(`[invokeFunction] unknown service '${y}'`);return o}},...p)}finally{E=!0,f.stop()}}createInstance(h,...p){let f,E;return h instanceof D.SyncDescriptor?(f=g.traceCreation(h.ctor),E=this._createInstance(h.ctor,h.staticArguments.concat(p),f)):(f=g.traceCreation(h),E=this._createInstance(h,p,f)),f.stop(),E}_createInstance(h,p=[],f){let E=L._util.getServiceDependencies(h).sort((c,o)=>c.index-o.index),v=[];for(const c of E){let o=this._getOrCreateServiceInstance(c.id,f);if(!o&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);v.push(o)}let y=E.length>0?E[0].index:p.length;if(p.length!==y){console.warn(`[createInstance] First service dependency of ${h.name} at position ${y+1} conflicts with ${p.length} static arguments`);let c=y-p.length;c>0?p=p.concat(new Array(c)):p=p.slice(0,y)}return new h(...[...p,...v])}_setServiceInstance(h,p){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let f=this._getServiceInstanceOrDescriptor(h);return f instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,f,p.branch(h,!0)):(p.branch(h,!1),f)}_safeCreateAndCacheServiceInstance(h,p,f){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,f)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,f){const E=new T.Graph(c=>c.id.toString());let v=0;const y=[{id:h,desc:p,_trace:f}];for(;y.length;){const c=y.pop();if(E.lookupOrInsertNode(c),v++>1e3)throw new I(E);for(let o of L._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${h} depends on ${o.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:o.id,desc:t,_trace:c._trace.branch(o.id,!0)};E.insertEdge(c,s),y.push(s)}}}for(;;){const c=E.roots();if(c.length===0){if(!E.isEmpty())throw new I(E);break}for(const{data:o}of c){if(this._getServiceInstanceOrDescriptor(o.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}E.removeNode(o)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,f=[],E,v){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(p,f,E,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,f,E,v);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],f,E){if(f){const v=new R.IdleValue(()=>this._createInstance(h,p,E));return new Proxy(Object.create(null),{get(y,c){if(c in y)return y[c];let o=v.value,t=o[c];return typeof t!="function"||(t=t.bind(o),y[c]=t),t},set(y,c,o){return v.value[c]=o,!0}})}else return this._createInstance(h,p,E)}}e.InstantiationService=n;var C;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(C||(C={}));class g{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new g(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(h){return S?new g(0,h.name):g._None}branch(h,p){let f=new g(2,h.toString());return this._dep.push([h,p,f]),f}stop(){let h=Date.now()-this._start;g._totals+=h;let p=!1;function f(v,y){let c=[],o=new Array(v+1).join("	");for(const[t,s,i]of y._dep)if(s&&i){p=!0,c.push(`${o}CREATES -> ${t}`);let r=f(v+1,i);r&&c.push(r)}else c.push(`${o}uses -> ${t}`);return c.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(E.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(te[168],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,T){this.server=D,this.router=T}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,T){this.server.registerChannel(D,T)}}e.MessagePortMainProcessService=R}),define(te[169],ne([0,1,33,53,77,5]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(b,h,p){const f=p.getChannel(b);return P(h)?new h.channelClientCtor(f):R.ProxyChannel.toService(f,h?.proxyOptions)}}function P(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let S=class extends L{constructor(b,h,p){super(b,h,p)}};S=he([Q(2,e.IMainProcessService)],S);function I(g,b,h){(0,D.registerSingleton)(g,new k.SyncDescriptor(S,[b,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let n=class extends L{constructor(b,h,p){super(b,h,p)}};n=he([Q(2,e.ISharedProcessService)],n);function C(g,b,h){(0,D.registerSingleton)(g,new k.SyncDescriptor(n,[b,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[58],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function k(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const T of D.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=k}),define(te[170],ne([0,1,2,58]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(L){super();this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([Q(0,k.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[10],ne([0,1,38,3,2,4,5]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,L.createDecorator)("logService"),e.ILoggerService=(0,L.createDecorator)("loggerService");function P(){return new Date().toISOString()}var S;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class n extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(S.Error,this.format(i))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let i=0;i<t.length;i++){let r=t[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}s+=(i>0?" ":"")+r}return s}}e.AbstractMessageLogger=n;class C extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...s):console.warn(`[main ${P()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=g;class b extends I{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class h extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const i of this.logServices)i.trace(t,...s)}debug(t,...s){for(const i of this.logServices)i.debug(t,...s)}info(t,...s){for(const i of this.logServices)i.info(t,...s)}warn(t,...s){for(const i of this.logServices)i.warn(t,...s)}error(t,...s){for(const i of this.logServices)i.error(t,...s)}critical(t,...s){for(const i of this.logServices)i.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class p extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=p;class f extends D.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),i),s?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class E{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=E;function v(o){if(o.verbose)return S.Trace;if(typeof o.logLevel=="string"){const t=y(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function y(o){switch(o){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=y;function c(o){switch(o){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c}),define(te[171],ne([0,1,6,8,2,9,19,13,10]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends D.Disposable{constructor(C,g){super();this.environmentService=C,this.logService=g,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),g=(0,T.dirname)(this.environmentService.logsPath),p=(await L.Promises.readdir(g)).filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter(E=>E!==C),f=p.slice(0,Math.max(0,p.length-9));f.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(E=>L.Promises.rm((0,T.join)(g,E)))))}catch(C){(0,k.onUnexpectedError)(C)}}};I=he([Q(0,P.IEnvironmentService),Q(1,S.ILogService)],I),e.LogsDataCleaner=I}),define(te[172],ne([0,1,6,8,2,9,19,13,10]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class vt extends D.Disposable{constructor(C,g,b){super();this.backupWorkspacesPath=C,this.environmentService=g,this.logService=b,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const C=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(C).emptyWorkspaceInfos.map(p=>p.backupFolder),h=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async p=>{p.length!==vt.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(p)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${p}.`),await L.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,p)))}))}catch(C){(0,k.onUnexpectedError)(C)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I=he([Q(1,P.INativeEnvironmentService),Q(2,S.ILogService)],I),e.StorageDataCleaner=I}),define(te[173],ne([0,1,6,8,2,4,16,59,7,30,19,13,28,34,14,10]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends D.Disposable{constructor(y,c,o,t){super();this.fileService=c,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=S.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,c){await this.cleanUpPromise;const o=this.getName(y),t=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const s=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(y,s,c);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch(r){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,s.path),i}}return t}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,c,o){try{await n.Promises.rename(y.fsPath,c.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${y} to ${c} with 'EPERM' error. Trying again...`),this.rename(y,c,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const c=[],o=[];for(const i of y.children){const r=this.parse(i.name);r&&o.push([r,i])}const t=(0,b.groupByExtension)(o,([i])=>i),s=[];for(const i of t)i.sort((r,a)=>P.rcompare(r[0].version,a[0].version)),c.push(...i.slice(1).map(r=>r[1].resource)),s.push(i[0][1]);s.sort((i,r)=>i.mtime-r.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(i=>i.resource)),await R.Promises.settled(c.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new b.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,I.generateUuid)()}parse(y){const c=f.exec(y);return c&&c[1]&&c[2]?new b.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};E=he([Q(0,C.INativeEnvironmentService),Q(1,h.IFileService),Q(2,g.IExtensionGalleryService),Q(3,p.ILogService)],E),e.ExtensionsDownloader=E}),define(te[174],ne([0,1,37,6,38,3,2,15,9,19,13,10]),function(J,e,R,k,D,T,L,P,S,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends L.Disposable{constructor(h,p){super();this.environmentService=h,this.logService=p,this.processesLimiter=new k.Limiter(5)}async postUninstall(h){const p=this.parseScript(h,"uninstall");return p&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),I.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(h,p){const f=`vscode:${p}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const E=h.manifest.scripts[f].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,S.join)(h.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(h,p,f,E,v){return new Promise((y,c)=>{const o=this.start(h,p,f,v);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?c(i):y(void 0)};o.on("error",i=>{s((0,D.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,r)=>{s(i?`post-${p} process exited with code ${i}`:void 0)}),E&&(t=setTimeout(()=>{t=null,o.kill(),c("timed out")},5e3))})}start(h,p,f,E){const v={silent:!0,execArgv:void 0},y=(0,R.fork)(h,[`--type=extension-post-${p}`,...f],v);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const c=T.Event.fromNodeEventEmitter(y.stdout,"data"),o=T.Event.fromNodeEventEmitter(y.stderr,"data");c(i=>this.logService.info(E.identifier.id,E.manifest.version,`post-${p}`,i)),o(i=>this.logService.error(E.identifier.id,E.manifest.version,`post-${p}`,i));const t=T.Event.any(T.Event.map(c,i=>({data:`%c${i}`,format:[""]})),T.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(E.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(h){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};g=he([Q(0,n.IEnvironmentService),Q(1,C.ILogService)],g),e.ExtensionsLifecycle=g}),define(te[175],ne([0,1,3,2,16,7,13,34,14,10]),function(J,e,R,k,D,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends k.Disposable{constructor(g,b,h,p){super();this.extensionsManagementService=g,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(v=>this.onInstallExtension(v))),this._register(g.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(g.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const f=T.URI.file(h.extensionsPath),E=new D.ExtUri(v=>!b.hasCapability(v,1024));this._register(b.watch(f)),this._register(R.Event.filter(b.onDidChangeFilesRaw,v=>v.changes.some(y=>this.doesChangeAffects(y,f,E)))(()=>this.onDidChange()))}doesChangeAffects(g,b,h){return h.isEqual(h.dirname(g.resource),b)?h.isEqual(g.resource,h.joinPath(b,".obsolete"))?!0:!(g.type!==1&&g.type!==2||h.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const b of g)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(b=>!(0,P.areSameExtensions)(b,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,P.areSameExtensions)(b,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),b=g.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,P.areSameExtensions)(f,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),h=this.installedExtensions.filter(p=>this.installingExtensions.some(f=>(0,P.areSameExtensions)(f,p))?!1:g.every(f=>!(0,P.areSameExtensions)(f.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=g.map(p=>p.identifier),(b.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:h})}}};n=he([Q(1,S.IFileService),Q(2,L.INativeEnvironmentService),Q(3,I.ILogService)],n),e.ExtensionsWatcher=n}),define(te[176],ne([0,1,8,2,81,3,37,15,107,4,10,77]),function(J,e,R,k,D,T,L,P,S,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class extends k.Disposable{constructor(p,f){super();this.id=p,this._logService=f,this._onStdout=this._register(new T.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new T.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onExit=this._register(new T.Emitter),this.onExit=this._onExit.event,this._process=null}register(p){this._register(p)}start(p){this._process=(0,L.fork)(P.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],p);const f=this._process.pid;this._logService.info(`Starting extension host with pid ${f}.`);const E=new S.StringDecoder("utf-8");this._process.stdout?.on("data",y=>{const c=typeof y=="string"?y:E.write(y);this._onStdout.fire(c)});const v=new S.StringDecoder("utf-8");return this._process.stderr?.on("data",y=>{const c=typeof y=="string"?y:v.write(y);this._onStderr.fire(c)}),this._process.on("message",y=>{this._onMessage.fire(y)}),this._process.on("error",y=>{this._onError.fire({error:(0,R.transformErrorForSerialization)(y)})}),this._process.on("exit",(y,c)=>{this._onExit.fire({pid:f,code:y,signal:c})}),{pid:f}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):I.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};g=he([Q(1,n.ILogService)],g);let b=class pt{constructor(p){this._logService=p,this._extHosts=new Map}dispose(){}_getExtHost(p){const f=this._extHosts.get(p);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(p){return this._getExtHost(p).onStdout}onDynamicStderr(p){return this._getExtHost(p).onStderr}onDynamicMessage(p){return this._getExtHost(p).onMessage}onDynamicError(p){return this._getExtHost(p).onError}onDynamicExit(p){return this._getExtHost(p).onExit}async createExtensionHost(){const p=String(++pt._lastId),f=new g(p,this._logService);return this._extHosts.set(p,f),f.onExit(({pid:E,code:v,signal:y})=>{this._logService.info(`Extension host with pid ${E} exited with code: ${v}, signal: ${y}.`),setTimeout(()=>{f.dispose(),this._extHosts.delete(p)})}),{id:p}}async start(p,f){return this._getExtHost(p).start(f)}async enableInspectPort(p){return this._getExtHost(p).enableInspectPort()}async kill(p){this._getExtHost(p).kill()}};b._lastId=0,b=he([Q(0,n.ILogService)],b),e.ExtensionHostStarter=b,(0,C.registerSingleton)(D.IExtensionHostStarter,b,!0)}),define(te[177],ne([0,1,83,17,6,2,15,9,19,13,28,34,58,10]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends T.Disposable{constructor(E,v,y){super();this.extensionManagementService=E,this.logService=y,this.cache=this._register(new p(v,y)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const E=await this.cache.getLanguagePacks(),v=["en",...Object.keys(E)];return(0,k.distinct)(v)}async postInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",E.identifier.id),await this.update())}async postUninstallExtension(E){const v=await this.cache.getLanguagePacks();Object.keys(v).some(y=>v[y]&&v[y].extensions.some(c=>(0,C.areSameExtensions)(c.extensionIdentifier,E.identifier)))&&(this.logService.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(v);return!(0,k.equals)(Object.keys(E),Object.keys(y))}};h=he([Q(0,n.IExtensionManagementService),Q(1,I.INativeEnvironmentService),Q(2,b.ILogService)],h),e.LocalizationsService=h;let p=class extends T.Disposable{constructor(E,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(v=>{Object.keys(v).forEach(y=>delete v[y]),this.createLanguagePacksFromExtensions(v,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...v){for(const y of v)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,y);Object.keys(E).forEach(y=>this.updateHash(E[y]))}createLanguagePacksFromExtension(E,v){const y=v.identifier,c=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const o of c)if(v.location.scheme===L.Schemas.file&&(0,g.isValidLocalization)(o)){let t=E[o.languageId];t||(t={hash:"",extensions:[],translations:{}},E[o.languageId]=t);let s=t.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,y))[0];s?s.version=v.manifest.version:t.extensions.push({extensionIdentifier:y,version:v.manifest.version});for(const i of o.translations)t.translations[i.id]=(0,P.join)(v.location.fsPath,i.path)}}updateHash(E){if(E){const v=(0,R.createHash)("md5");for(const y of E.extensions)v.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);E.hash=v.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch(c){return{}}}).then(y=>(v=E(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.languagePacks=y,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),S.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>v,y=>this.logService.error(y))})}};p=he([Q(0,I.INativeEnvironmentService),Q(1,b.ILogService)],p)}),define(te[86],ne([0,1,3,7,10]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(g){this.service=g,this.onDidChangeLogLevel=R.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(g,b,h){switch(b){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=T;class L{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){L.setLevel(this.channel,g)}static setLevel(g,b){return g.call("setLevel",b)}}e.LogLevelChannelClient=L;class P{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,b){throw new Error(`Event not found: ${b}`)}async call(g,b,h){switch(b){case"createLogger":this.createLogger(k.URI.revive(h[0]),h[1]);return;case"log":return this.log(k.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${b}`)}createLogger(g,b){this.loggers.set(g.toString(),this.loggerService.createLogger(g,b))}consoleLog(g,b){let h=console.log;switch(g){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...b)}log(g,b){const h=this.loggers.get(g.toString());if(!h)throw new Error("Create the logger before logging");for(const[p,f]of b)switch(p){case D.LogLevel.Trace:h.trace(f);break;case D.LogLevel.Debug:h.debug(f);break;case D.LogLevel.Info:h.info(f);break;case D.LogLevel.Warning:h.warn(f);break;case D.LogLevel.Error:h.error(f);break;case D.LogLevel.Critical:h.critical(f);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class S extends D.AbstractLoggerService{constructor(g,b,h){super(g,b);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(g,b)=>{this.channel.call("consoleLog",[g,b])}})}doCreateLogger(g,b,h){return new I(this.channel,g,b,h)}}e.LoggerChannelClient=S;class I extends D.AbstractMessageLogger{constructor(g,b,h,p){super(p?.always);this.channel=g,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[b,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,b){const h=[[g,b]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(g){this.channel.call("log",[this.file,g])}}class n extends D.LogService{constructor(g,b){super(b);this.parent=g,this._register(g.onDidChangeLogLevel(h=>b.setLevel(h)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=n}),define(te[60],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(te[42],ne([0,1,15,4,31,16]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.context!="undefined"){const P=k.globals.vscode.context.configuration();if(P)L=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const P=(0,T.dirname)(R.FileAccess.asFileUri("",J));L=J.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const S=J.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`}),Object.assign(L,{version:S.version})}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=L}),define(te[87],ne([0,1,22,8,135,14,42]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(C,g,b,h,p,f){let E;try{await S(C,g,b,h,p,f)}catch(v){E=v}finally{E&&p.errorTransformer&&(E=p.errorTransformer(E)),typeof E!="undefined"&&b.error(E),b.end()}}e.readFileIntoStream=P;async function S(C,g,b,h,p,f){I(f);const E=await C.open(g,{create:!1});try{I(f);let v=0,y=0,c=p&&typeof p.length=="number"?p.length:void 0,o=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),t=p&&typeof p.position=="number"?p.position:0,s=0;do y=await C.read(E,t,o.buffer,s,o.byteLength-s),t+=y,s+=y,v+=y,typeof c=="number"&&(c-=y),s===o.byteLength&&(await b.write(h(o)),o=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),s=0);while(y>0&&(typeof c!="number"||c>0)&&I(f)&&n(v,p));if(s>0){let i=s;typeof c=="number"&&(i=Math.min(s,c)),b.write(h(o.slice(0,i)))}}catch(v){throw(0,T.ensureFileSystemProviderError)(v)}finally{await C.close(E)}}function I(C){if(C.isCancellationRequested)throw(0,k.canceled)();return!0}function n(C,g){if(g?.limits){if(typeof g.limits.memory=="number"&&C>g.limits.memory)throw(0,T.createFileSystemProviderError)((0,D.localize)(0,null,L.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&C>g.limits.size)throw(0,T.createFileSystemProviderError)((0,D.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[178],ne([0,1,17,6,22,27,3,55,2,41,15,179,16,50,133,14,87,10]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class Ve extends S.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new L.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new k.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new p.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new k.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new p.FileChangesEvent(o,!0)))),this.watchedResources=I.TernarySearchTree.forUris(o=>{const t=this.getProvider(o.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new k.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o});const t=new S.DisposableStore;return t.add(o.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(o)))),t.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),typeof o.onDidErrorOccur=="function"&&t.add(o.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,S.dispose)(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){o.push(t)}}),!this.provider.has(c)&&await k.Promises.settled(o)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,o){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return P.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new p.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const t=new Error;throw t.name="ENOPRO",t.message=(0,h.localize)(1,null,c.toString()),t}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(o)||(0,p.hasReadWriteCapability)(o)||(0,p.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(o)||(0,p.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(t){throw(0,p.toFileSystemProviderErrorCode)(t)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,p.ensureFileSystemProviderError)(t)}}async doResolveFile(c,o){const t=await this.withProvider(c),s=this.isPathCaseSensitive(t),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,l=await t.stat(c);let u;return this.toFileStat(t,c,l,void 0,!!a,(d,m)=>{if(!u&&(u=I.TernarySearchTree.forUris(()=>!s),u.set(c,!0),i))for(const A of i)u.set(A,!0);return u.get(d.resource)||u.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?m===1:!1})}async toFileStat(c,o,t,s,i,r){const{providerExtUri:a}=this.getExtUri(c),l={resource:o,name:a.basename(o),isFile:(t.type&p.FileType.File)!=0,isDirectory:(t.type&p.FileType.Directory)!=0,isSymbolicLink:(t.type&p.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&p.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,p.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&r(l,s)){try{const u=await c.readdir(o),d=await k.Promises.settled(u.map(async([m,A])=>{try{const _=a.joinPath(o,m),w=i?await c.stat(_):{type:A};return await this.toFileStat(c,_,w,u.length,i,r)}catch(_){return this.logService.trace(_),null}}));l.children=(0,R.coalesce)(d)}catch(u){this.logService.trace(u),l.children=[]}return l}return l}async resolveAll(c){return k.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch(t){return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(t){return t}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new p.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=D.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const s=await this.writeFile(c,o);return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,s)),s}async writeFile(c,o,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,t)||await this.mkdirp(s,i.dirname(c));let a;if((0,p.hasReadWriteCapability)(s)&&!(o instanceof D.VSBuffer))if((0,b.isReadableStream)(o)){const l=await(0,b.peekStream)(o,3);l.ended?a=D.VSBuffer.concat(l.buffer):a=l}else a=(0,b.peekReadable)(o,l=>D.VSBuffer.concat(l),3);else a=o;!(0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,t,a):await this.doWriteBuffered(s,c,t,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new p.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,t){if(!!t?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch(r){return}if((i.type&p.FileType.Directory)!=0)throw new p.FileOperationError((0,h.localize)(6,null,this.resourceForError(o)),0,t);if(this.throwIfFileIsReadonly(o,i),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==p.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,p.etag)({mtime:t.mtime,size:i.size}))throw new p.FileOperationError((0,h.localize)(7,null),3,t);return i}async readFile(c,o){const t=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(t,c,o):this.doReadFile(t,c,o)}async doReadFileAtomic(c,o,t){return new Promise((s,i)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(c,o,t);s(r)}catch(r){i(r)}})})}async doReadFile(c,o,t){const s=await this.doReadFileStream(c,o,{...t,preferUnbuffered:!0});return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(c,o){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,o)}async doReadFileStream(c,o,t){const s=new T.CancellationTokenSource,i=this.validateReadFile(o,t).then(a=>a,a=>{throw s.cancel(),a});let r;try{return typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&await i,!((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasFileReadStreamCapability)(c))||(0,p.hasReadWriteCapability)(c)&&t?.preferUnbuffered?r=this.readFileUnbuffered(c,o,t):(0,p.hasFileReadStreamCapability)(c)?r=this.readFileStreamed(c,o,s.token,t):r=this.readFileBuffered(c,o,s.token,t),{...await i,value:r}}catch(a){r&&await(0,b.consumeStream)(r);const l=(0,h.localize)(8,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(a).toString());throw a instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(l,a.stat,t):new p.FileOperationError(l,(0,p.toFileOperationResult)(a),t)}}readFileStreamed(c,o,t,s=Object.create(null)){const i=c.readFileStream(o,s,t);return(0,b.transform)(i,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new p.FileOperationError((0,h.localize)(9,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,o,t,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,f.readFileIntoStream)(c,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new p.FileOperationError((0,h.localize)(10,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)},t),i}readFileUnbuffered(c,o,t){const s=(0,b.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i=await c.readFile(o);typeof t?.position=="number"&&(i=i.slice(t.position)),typeof t?.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(o,i.byteLength,t),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,o){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new p.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==p.ETAG_DISABLED&&o.etag===t.etag)throw new p.NotModifiedSinceFileOperationError((0,h.localize)(12,null),t,o);return this.validateReadFileLimits(c,t.size,o),t}validateReadFileLimits(c,o,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&o>t.limits.size&&(s=7),typeof s=="number")throw new p.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,o,t){return this.doCanMoveCopy(c,o,"move",t)}async canCopy(c,o,t){return this.doCanMoveCopy(c,o,"copy",t)}async doCanMoveCopy(c,o,t,s){if(c.toString()!==o.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,r,o,t,s)}catch(i){return i}return!0}async move(c,o,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"move",!!t),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="move"?2:3,a)),a}async copy(c,o,t){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"copy",!!t),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="copy"?3:2,a)),a}async doMoveCopy(c,o,t,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,o,t,s,i,r);if(a&&!l&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),i==="copy"){if(c===t&&(0,p.hasFileFolderCopyCapability)(c))await c.copy(o,s,{overwrite:r});else{const u=await this.resolve(o);u.isDirectory?await this.doCopyFolder(c,u,t,s):await this.doCopyFile(c,o,t,s)}return i}else return c===t?(await c.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(c,o,t,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,t,s){if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,o,t,s);if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,o,t,s);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,o,t,s);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,o,t,s)}async doCopyFolder(c,o,t,s){await t.mkdir(s),Array.isArray(o.children)&&await k.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(t).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),t,r):this.doCopyFile(c,i.resource,t,r)}))}async doValidateMoveCopy(c,o,t,s,i,r){let a=!1;if(c===t){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(c);if(d||(a=u.isEqual(o,s)),a&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,o))throw new Error((0,h.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!a){if(!r)throw new p.FileOperationError((0,h.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(c===t){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(o,s))throw new Error((0,h.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,t)),t}async mkdirp(c,o){const t=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(o,s.dirname(o));)try{if(((await c.stat(o)).type&p.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,p.toFileSystemProviderErrorCode)(i)!==p.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(s.basename(o)),o=s.dirname(o)}for(let i=t.length-1;i>=0;i--){o=s.joinPath(o,t[i]);try{await c.mkdir(o)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(t){return t}return!0}async doValidateDelete(c,o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let i;try{i=await t.stat(c)}catch(a){}if(i)this.throwIfFileIsReadonly(c,i);else throw new p.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return t}async del(c,o){const t=await this.doValidateDelete(c,o),s=!!o?.useTrash,i=!!o?.recursive;await t.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new p.FileOperationEvent(c,1))}onDidChangeFile(c,o){this._onDidChangeFilesRaw.fire({changes:c});let t,s;{for(const i of c)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(s||(s=[]),s.push(i));t&&this._onDidFilesChange.fire(new p.FileChangesEvent(t,!o))}if(s){const i=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(s)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,o={recursive:!1,excludes:[]}){const t=new S.DisposableStore;{let s=!1,i=()=>{s=!0};t.add((0,S.toDisposable)(()=>i())),this.doWatch(c,o).then(r=>{s?(0,S.dispose)(r):i=()=>(0,S.dispose)(r)},r=>this.logService.error(r))}return o.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),t.add((0,S.toDisposable)(()=>{const s=this.watchedResources.get(c);typeof s=="number"&&(s<=1?this.watchedResources.delete(c):this.watchedResources.set(c,s-1))}))),t}async doWatch(c,o){const t=await this.withProvider(c),s=this.toWatchKey(t,c,o),i=this.activeWatchers.get(s)||{count:0,disposable:t.watch(c,o)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,i),i.count+=1,(0,S.toDisposable)(()=>{i.count--,i.count===0&&((0,S.dispose)(i.disposable),this.activeWatchers.delete(s))})}toWatchKey(c,o,t){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(o),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,t,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,b.isReadableStream)(s)||(0,b.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,t){let s=0,i;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=D.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,s,0),s+=r.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(r,a)=>{(0,b.listenStream)(i,{onData:async l=>{i.pause();try{await this.doWriteBuffer(c,o,l,l.byteLength,s,0)}catch(u){return a(u)}s+=l.byteLength,setTimeout(()=>i.resume())},onError:l=>a(l),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,t){let s=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,o,t,s,i,r){let a=0;for(;a<s;)a+=await c.write(o,i+a,t.buffer,r+a,s-a)}async doWriteUnbuffered(c,o,t,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,t,s))}async doWriteUnbufferedQueued(c,o,t,s){let i;s instanceof D.VSBuffer?i=s:(0,b.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,b.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(c,o,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,t,s))}async doPipeBufferedQueued(c,o,t,s){let i,r;try{i=await c.open(o,{create:!1}),r=await t.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,d=0;do d=await c.read(i,l,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(t,r,a,d,l,u),l+=d,u+=d,u===a.byteLength&&(u=0);while(d>0)}catch(a){throw(0,p.ensureFileSystemProviderError)(a)}finally{await k.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,t,s))}async doPipeUnbufferedQueued(c,o,t,s){return t.writeFile(s,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,t,s))}async doPipeUnbufferedToBufferedQueued(c,o,t,s){const i=await t.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(t,i,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(c,o,t,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,o,T.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new p.FileOperationError((0,h.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===n.Schemas.file?c.fsPath:c.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=he([Q(0,E.ILogService)],v),e.FileService=v}),define(te[180],ne([0,1,17,6,22,3,40,2,9,4,16,50,19,136,14,87,166,153,154,84,156,10,42]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends P.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new k.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:l}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,l),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(a.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,n.joinPath)(r,u.name))).type:d=this.toType(u),l.push([u.name,d])}catch(d){this.logService.trace(d)}})),l}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let l;return a?.dangling?l=h.FileType.Unknown:r.isFile()?l=h.FileType.File:r.isDirectory()?l=h.FileType.Directory:l=h.FileType.Unknown,a&&(l|=h.FileType.SymbolicLink),l}async readFile(r){try{const a=this.toFilePath(r);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,l){const u=(0,C.newWriteableStream)(d=>D.VSBuffer.concat(d.map(m=>D.VSBuffer.wrap(m))).buffer);return(0,p.readFileIntoStream)(this,r,u,d=>d.buffer,{...a,bufferSize:this.BUFFER_SIZE},l),u}async writeFile(r,a,l){let u;try{const d=this.toFilePath(r);if(!l.create||!l.overwrite){if(await g.Promises.exists(d)){if(!l.overwrite)throw(0,h.createFileSystemProviderError)((0,b.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,h.createFileSystemProviderError)((0,b.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(u,0,a,0,a.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(r,d)}finally{typeof u=="number"&&await this.close(u)}}async open(r,a){try{const l=this.toFilePath(r);if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:m}=await g.SymlinkSupport.stat(l);m.mode&128||await g.Promises.chmod(l,m.mode|128)}catch(m){this.logService.trace(m)}let u;if((0,h.isFileOpenForWriteOptions)(a)){if(I.isWindows)try{await g.Promises.truncate(l,0),u="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}u||(u="w")}else u="r";const d=await g.Promises.open(l,u);return this.mapHandleToPos.set(d,0),(0,h.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(d,r),d}catch(l){throw(0,h.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,l,u,d){const m=this.normalizePos(r,a);let A=null;try{const _=await g.Promises.read(r,l,u,d,m);return typeof _=="number"?A=_:A=_.bytesRead,A}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,m,A)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,l){const u=this.mapHandleToPos.get(r);typeof u=="number"&&(typeof a=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,u+l):this.mapHandleToPos.delete(r)))}async write(r,a,l,u,d){return(0,k.retry)(()=>this.doWrite(r,a,l,u,d),100,3)}async doWrite(r,a,l,u,d){const m=this.normalizePos(r,a);let A=null;try{const _=await g.Promises.write(r,l,u,d,m);return typeof _=="number"?A=_:A=_.bytesWritten,A}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,m,A)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const l=this.toFilePath(r);await this.doDelete(l,a)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,a){a.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,a,l){const u=this.toFilePath(r),d=this.toFilePath(a);if(u!==d)try{await this.validateTargetDeleted(r,a,"move",l.overwrite),await g.Promises.move(u,d)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(2,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(r,a,l){const u=this.toFilePath(r),d=this.toFilePath(a);if(u!==d)try{await this.validateTargetDeleted(r,a,"copy",l.overwrite),await g.Promises.copy(u,d,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(3,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(r,a,l,u){const d=this.toFilePath(r),m=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,L.isEqual)(d,m,!0)),A&&l==="copy")throw(0,h.createFileSystemProviderError)((0,b.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!A&&await g.Promises.exists(m)){if(!u)throw(0,h.createFileSystemProviderError)((0,b.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const l={path:this.toFilePath(r),excludes:a.excludes},u=(0,R.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{u(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof E.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=v.FileWatcher,a=this.options?.watcher;else{let l;this.options?.enableLegacyRecursiveWatcher?l=!0:l=t.default.quality==="stable"&&I.isLinux,l&&this.recursiveFoldersToWatch.length===1?I.isWindows?r=c.FileWatcher:r=v.FileWatcher:r=E.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,y.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===o.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new f.FileWatcher(this.toFilePath(r),u=>this._onDidChangeFile.fire((0,y.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===o.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)});return(0,P.combinedDisposable)(a,l)}toFilePath(r){return(0,S.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof h.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let l=this.toFileSystemProviderError(a);if(r&&l.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await g.SymlinkSupport.stat(this.toFilePath(r));u.mode&128||(l=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return l}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(te[29],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(te[181],ne([0,1,6,8,2,9,19,10,29]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends D.Disposable{constructor(C,g,b){super();this.productService=g,this.logService=b,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),b=(0,T.dirname)(C),h=(0,T.basename)(C),p=await L.Promises.readdir(b);await Promise.all(p.map(async f=>{if(f===h)return;const E=(0,T.join)(b,f),v=await L.Promises.stat(E);if(v.isDirectory()&&g-v.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${f}.`),L.Promises.rm(E)}))}catch(g){(0,k.onUnexpectedError)(g)}}};I=he([Q(1,S.IProductService),Q(2,P.ILogService)],I),e.CodeCacheCleaner=I}),define(te[182],ne([0,1,6,8,2,9,19,13,10,29]),function(J,e,R,k,D,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends D.Disposable{constructor(g,b,h){super();this.environmentService=g,this.logService=b,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),b=JSON.parse(await L.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let v of Object.keys(b)){const y=b[v];g[`${y.hash}.${v}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const f=await L.Promises.readdir(h);for(const v of f){if(g[v]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await L.Promises.rm((0,T.join)(h,v))}const E=Date.now();for(const v of Object.keys(g)){const y=(0,T.join)(h,v),c=await L.Promises.readdir(y);for(const o of c){if(o==="tcf.json")continue;const t=(0,T.join)(y,o),s=await L.Promises.stat(t);s.isDirectory()&&E-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(v,o)}`),await L.Promises.rm(t))}}}catch(g){(0,k.onUnexpectedError)(g)}}};n=he([Q(0,P.INativeEnvironmentService),Q(1,S.ILogService),Q(2,I.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(te[35],ne([0,1,99,18]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(L,P){R.ok(k.isString(L)),R.ok(k.isObject(P)),R.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new D}),define(te[88],ne([0,1,3,35]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,I){this.schemasById[D(S)]=I,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;k.Registry.add(e.Extensions.JSONContribution,L)}),define(te[39],ne([0,1,17,3,18,123,88,35]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=P.Registry.as(L.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,c=!0){this.registerConfigurations([y],c)}registerConfigurations(y,c=!0){const o=this.doRegisterConfigurations(y,c);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(y){const c=this.doDeregisterConfigurations(y);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:y,remove:c}){const o=[];o.push(...this.doDeregisterConfigurations(c)),o.push(...this.doRegisterConfigurations(y,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(o))}registerDefaultConfigurations(y){const c=[],o=[];for(const t of y)for(const s in t)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const i={type:"object",default:this.defaultValues[s],description:T.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};o.push(b(s)),this.configurationProperties[s]=i,this.defaultLanguageConfigurationOverridesNode.properties[s]=i}else{this.defaultValues[s]=t[s];const i=this.configurationProperties[s];i&&(this.updatePropertyDefaultValue(s,i),this.updateSchema(s,i))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(y){const c=[];for(const o of y)for(const t in o)if(c.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const c of y)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(y,c){const o=[];return y.forEach(t=>{o.push(...this.validateAndRegisterProperties(t,c,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),o}doDeregisterConfigurations(y){const c=[],o=t=>{if(t.properties)for(const s in t.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>o(s))};for(const t of y){o(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(y,c=!0,o,t=3){t=D.isUndefinedOrNull(y.scope)?t:y.scope;let s=[],i=y.properties;if(i)for(let a in i){if(c&&f(a)){delete i[a];continue}const l=i[a];if(this.updatePropertyDefaultValue(a,l),e.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(a):l.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),s.push(a)}let r=y.allOf;if(r)for(let a of r)s.push(...this.validateAndRegisterProperties(a,c,o,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const c=o=>{let t=o.properties;if(t)for(const i in t)this.updateSchema(i,t[i]);let s=o.allOf;s&&s.forEach(c)};c(y)}updateSchema(y,c){switch(e.allSettings.properties[y]=c,c.scope){case 1:e.applicationSettings.properties[y]=c;break;case 2:e.machineSettings.properties[y]=c;break;case 6:e.machineOverridableSettings.properties[y]=c;break;case 3:e.windowSettings.properties[y]=c;break;case 4:e.resourceSettings.properties[y]=c;break;case 5:e.resourceSettings.properties[y]=c,this.resourceLanguageSettingsSchema.properties[y]=c;break}}removeFromSchema(y,c){switch(delete e.allSettings.properties[y],c.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const c=`[${y}]`,o={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,o),e.allSettings.properties[c]=o,e.applicationSettings.properties[c]=o,e.machineSettings.properties[c]=o,e.machineOverridableSettings.properties[c]=o,e.windowSettings.properties[c]=o,e.resourceSettings.properties[c]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,c){let o=this.defaultValues[y];D.isUndefined(o)&&(o=c.default),D.isUndefined(o)&&(o=h(c.type)),c.default=o}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function b(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=b;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new C;P.Registry.add(e.Extensions.Configuration,p);function f(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?T.localize(5,null,v):p.getConfigurationProperties()[v]!==void 0?T.localize(6,null,v):null:T.localize(4,null)}e.validateProperty=f;function E(){const v=[],y=p.getConfigurationProperties();for(const c of Object.keys(y))v.push([c,y[c].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=E}),define(te[20],ne([0,1,26,18,7,39,5,35]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=S;var I;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function C(s,i){const r=i?s?i.keys.filter(_=>s.keys.indexOf(_)===-1):[...i.keys]:[],a=s?i?s.keys.filter(_=>i.keys.indexOf(_)===-1):[...s.keys]:[],l=[];if(i&&s){for(const _ of s.keys)if(i.keys.indexOf(_)!==-1){const w=E(s.contents,_),U=E(i.contents,_);R.equals(w,U)||l.push(_)}}const u=[],d=_=>{const w={};for(const U of _)for(const O of U.identifiers)w[o(O)]=U;return w},m=i?d(i.overrides):{},A=s?d(s.overrides):{};if(Object.keys(m).length)for(const _ of r){const w=m[_];w&&u.push([(0,T.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(A).length)for(const _ of a){const w=A[_];w&&u.push([(0,T.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(m).length&&Object.keys(A).length)for(const _ of l){const w=A[_],U=m[_];if(w&&U){const O=C({contents:w.contents,keys:w.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});u.push([(0,T.overrideIdentifierFromKey)(_),[...O.added,...O.removed,...O.updated]])}}return{added:r,removed:a,updated:l,overrides:u}}e.compare=C;function g(s,i){const r=[];for(const a of Object.keys(s))if(T.OVERRIDE_PROPERTY_PATTERN.test(a)){const l={};for(const u in s[a])l[u]=s[a][u];r.push({identifiers:[(0,T.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(l),contents:b(l,i)})}return r}e.toOverrides=g;function b(s,i){const r=Object.create(null);for(let a in s)h(r,a,s[a],i);return r}e.toValuesTree=b;function h(s,i,r,a){const l=i.split("."),u=l.pop();let d=s;for(let m=0;m<l.length;m++){let A=l[m],_=d[A];switch(typeof _){case"undefined":_=d[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${l.slice(0,m+1).join(".")} is ${JSON.stringify(_)}`);return}d=_}if(typeof d=="object"&&d!==null)try{d[u]=r}catch(m){a(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=h;function p(s,i){const r=i.split(".");f(s,r)}e.removeFromValueTree=p;function f(s,i){const r=i.shift();if(i.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const a=s[r];typeof a=="object"&&!Array.isArray(a)&&(f(a,i),Object.keys(a).length===0&&delete s[r])}}function E(s,i,r){function a(d,m){let A=d;for(const _ of m){if(typeof A!="object"||A===null)return;A=A[_]}return A}const l=i.split("."),u=a(s,l);return typeof u=="undefined"?r:u}e.getConfigurationValue=E;function v(s,i,r){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in s?k.isObject(s[a])&&k.isObject(i[a])?v(s[a],i[a],r):r&&(s[a]=i[a]):s[a]=i[a])})}e.merge=v;function y(){const s=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=y;function c(){const s=Object.create(null),i=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let r in i){let a=i[r].default;h(s,r,a,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=c;function o(s){return`[${s}]`}e.keyFromOverrideIdentifier=o;function t(s,i,r){const a=s.inspect(i),l=s.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:a.defaultValue}e.getMigratedSettingValue=t}),define(te[89],ne([0,1,17,3,36,2,41,26,18,7,20,39,35]),function(J,e,R,k,D,T,L,P,S,I,n,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},s=[],i=[]){this._contents=t,this._keys=s,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const i=this.getContentsForOverrideIdentifer(s);return i?t?(0,n.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let i={};for(const r of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r],l=s[r];l&&(typeof a=="object"&&typeof l=="object"?(a=P.deepClone(a),this.mergeContents(a,l)):a=l),i[r]=a}return new b(i,this.keys,this.overrides)}merge(...t){const s=P.deepClone(this.contents),i=P.deepClone(this.overrides),r=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const l of a.overrides){const[u]=i.filter(d=>R.equals(d.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):i.push(P.deepClone(l))}for(const l of a.keys)r.indexOf(l)===-1&&r.push(l)}return new b(s,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const i of Object.keys(s)){if(i in t&&S.isObject(t[i])&&S.isObject(s[i])){this.mergeContents(t[i],s[i]);continue}t[i]=P.deepClone(s[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,n.addToValueTree)(this.contents,t,s,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let i=0;i<s;i++)t.indexOf(this.keys[i])===0&&(s=i);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=b;class h extends b{constructor(){const t=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),i=[];for(const r of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,C.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,n.toValuesTree)(t[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,i)}}e.DefaultConfigurationModel=h;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:i,keys:r,overrides:a,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new b(i,r,a),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},i=null,r=[],a=[],l=[];function u(m){Array.isArray(r)?r.push(m):i!==null&&(r[i]=m)}let d={onObjectBegin:()=>{let m={};u(m),a.push(r),r=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let m=[];u(m),a.push(r),r=m,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:u,onError:(m,A,_)=>{l.push({error:m,offset:A,length:_})}};if(t)try{D.visit(t,d),s=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return s}doParseRaw(t,s){const i=g.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,i,!0,s);t=r.raw;const a=(0,n.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),u=(0,n.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:l,overrides:u,restricted:r.restricted}}filter(t,s,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const a={},l=[];for(let u in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(u)&&i){const d=this.filter(t[u],s,!1,r);a[u]=d.raw,l.push(...d.restricted)}else{const d=s[u],m=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(u),(m===void 0||r.scopes===void 0||r.scopes.includes(m))&&(r.skipRestricted&&d?.restricted||(a[u]=t[u]))}return{raw:a,restricted:l}}}e.ConfigurationModelParser=p;class f extends T.Disposable{constructor(t,s,i,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class E{constructor(t,s,i=new b,r=new b,a=new L.ResourceMap,l=new b,u=new L.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,s,i){return this.getConsolidateConfigurationModel(s,i).getValue(t)}updateValue(t,s,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new b,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,i){const r=this.getConsolidateConfigurationModel(s,i),a=this.getFolderConfigurationModelForResource(s.resource,i),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=i?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,w=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,U=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),O=r.getValue(t),$=R.distinct(R.flatten(r.overrides.map(K=>K.identifiers))).filter(K=>r.getOverrideValue(t,K)!==void 0);return{defaultValue:u,userValue:d,userLocalValue:m,userRemoteValue:A,workspaceValue:_,workspaceFolderValue:w,memoryValue:U,value:O,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:w!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const i=s.filter(r=>C.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,C.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),d=[...u.filter(m=>l.indexOf(m)===-1),...l.filter(m=>u.indexOf(m)===-1),...l.filter(m=>!P.equals(this._defaultConfiguration.override(a).getValue(m),t.override(a).getValue(m)))];return[a,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),l=[...s,...i,...r];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let l=[...s,...i,...r];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:i,removed:r,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let l=[...s,...i,...r];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const i=this.folderConfigurations.get(t),{added:r,updated:a,removed:l,overrides:u}=(0,n.compare)(i,s);let d=[...r,...a,...l];return(d.length||!i)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:r,removed:a,overrides:l}=(0,n.compare)(s,void 0);return{keys:[...i,...r,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let i=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const a=this._memoryConfigurationByResource.get(t);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=i.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=i}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const i=s.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:i,overrides:r,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:i,overrides:r,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((l,u)=>(l.set(I.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new L.ResourceMap);return new E(s,i,new b,r,a,new b,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>t.add(a)),r.overrides.forEach(([a,l])=>{const u=(0,L.getOrSet)(s,a,new Set);l.forEach(d=>u.add(d))});const i=[];return s.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=v;class y{constructor(t,s,i,r){this.change=t,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const l=new b;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!P.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let i=(0,n.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(t=t[r],!t)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=y;class c extends y{constructor(t,s,i,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(te[183],ne([0,1,6,3,2,16,20,89,39,35]),function(J,e,R,k,D,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends D.Disposable{constructor(g,b){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,b)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,b){const h=typeof g=="string"?g:void 0,p=(0,L.isConfigurationOverrides)(g)?g:(0,L.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(h,p,void 0)}updateValue(g,b,h,p){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const b=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(h,b,1)}onDidDefaultConfigurationChange(g){const b=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,g);this.trigger(h,b,6)}trigger(g,b,h){const p=new P.ConfigurationChangeEvent(g,{data:b},this.configuration);p.source=h,p.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(te[184],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var k;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(L,P=k.Unknown,S){super(L);this._message=L,this._code=P,this._detail=S,this.isHandled=P===k.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(L){return L instanceof D&&L._code===k.TemporarilyNotAvailable}static isNoResolverFound(L){return L instanceof D&&L._code===k.NoResolverFound}static isHandled(L){return L instanceof D&&L.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[185],ne([0,1,6,22,27,8,3,2,30,72,184]),function(J,e,R,k,D,T,L,P,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var g;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function b(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(x){const N=new D.CancellationTokenSource;return setTimeout(()=>N.cancel(),x),N.token}function p(x,N){if(x.isCancellationRequested||N.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return x.onCancellationRequested(()=>W.cancel()),N.onCancellationRequested(()=>W.cancel()),W.token}class f{constructor(N){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((W,X)=>{this._resolvePromise=W,this._rejectPromise=X}),N.isCancellationRequested?this._timeout():this._disposables.add(N.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(N){this._state==="pending"?this._disposables.add(N):N.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(N))}reject(N){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(N))}}function E(x,N){const W=new f(N);return W.registerDisposable(x.onControlMessage(X=>{const Z=JSON.parse(X.toString()),B=j(Z);B?W.reject(B):W.resolve(Z)})),W.promise}function v(x,N,W,X,Z,B){const V=new f(B);return N.connect(W,X,Z,(ie,re)=>{V.didTimeout?(ie&&x.error(ie),re?.dispose()):ie||!re?V.reject(ie):V.resolve(re)}),V.promise}function y(x,N){const W=new f(N);return x.then(X=>{W.didTimeout||W.resolve(X)},X=>{W.didTimeout||W.reject(X)}),W.promise}async function c(x,N,W,X){const Z=F(x,N);x.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let B;try{B=await v(x.logService,x.socketFactory,x.host,x.port,`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,X)}catch(ae){throw x.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),x.logService.error(ae),ae}x.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let V,ie;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(B,null),V=x.reconnectionProtocol,ie=!1):(V=new I.PersistentProtocol(B,null),ie=!0),x.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:x.connectionToken||"00000000000000000000"};V.sendControl(k.VSBuffer.fromString(JSON.stringify(re)));try{const ae=await E(V,p(X,h(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}x.logService.trace(`${Z} 4/6. received SignRequest control message.`);const ue=await y(x.signService.sign(ae.data),X),fe={type:"connectionType",commit:x.commit,signedData:ue,desiredConnectionType:N};return W&&(fe.args=W),x.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(k.VSBuffer.fromString(JSON.stringify(fe))),{protocol:V,ownsProtocol:ie}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(x.logService.error(`${Z} the handshake timed out. Error:`),x.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${Z} received error control message when negotiating connection. Error:`),x.logService.error(ae)),ie&&H(V),ae}}async function o(x,N,W,X){const Z=Date.now(),B=F(x,N),{protocol:V,ownsProtocol:ie}=await c(x,N,W,X),re=new f(X);return re.registerDisposable(V.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),fe=j(ue);fe?(x.logService.error(`${B} received error control message when negotiating connection. Error:`),x.logService.error(fe),ie&&H(V),re.reject(fe)):(x.reconnectionProtocol&&x.reconnectionProtocol.endAcceptReconnection(),x.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${G(Z)}!`),re.resolve({protocol:V,firstMessage:ue}))})),re.promise}async function t(x,N){const{protocol:W}=await o(x,1,void 0,N);return{protocol:W}}async function s(x,N,W){const{protocol:X,firstMessage:Z}=await o(x,2,N,W),B=Z&&Z.debugPort;return{protocol:X,debugPort:B}}async function i(x,N,W){const X=Date.now(),Z=F(x,3),{protocol:B}=await c(x,3,N,W);return x.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(X)}!`),B}async function r(x,N,W){const{host:X,port:Z,connectionToken:B}=await x.addressProvider.getAddress();return{commit:x.commit,host:X,port:Z,connectionToken:B,reconnectionToken:N,reconnectionProtocol:W,socketFactory:x.socketFactory,signService:x.signService,logService:x.logService}}async function a(x,N,W){try{const X=(0,S.generateUuid)(),Z=await r(x,X,null),{protocol:B}=await t(Z,D.CancellationToken.None);return new K(x,N,W,X,B)}catch(X){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(X),$.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(X)),X}}e.connectRemoteAgentManagement=a;async function l(x,N){try{const W=(0,S.generateUuid)(),X=await r(x,W,null),{protocol:Z,debugPort:B}=await s(X,N,D.CancellationToken.None);return new M(x,N,W,Z,B)}catch(W){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(W),$.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=l;async function u(x,N,W){const X=await r(x,(0,S.generateUuid)(),null);return await i(X,{host:N,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function d(x){return(0,R.createCancelablePromise)(N=>new Promise((W,X)=>{const Z=setTimeout(W,x*1e3);N.onCancellationRequested(()=>{clearTimeout(Z),W()})}))}var m;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(N,W){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=A;class _{constructor(N,W,X,Z){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.durationSeconds=X,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class w{constructor(N,W,X){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=X,this.type=2}}e.ReconnectionRunningEvent=w;class U{constructor(N,W,X){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=X,this.type=4}}e.ConnectionGainEvent=U;class O{constructor(N,W,X,Z){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=X,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=O;class $ extends P.Disposable{constructor(N,W,X,Z){super();this._connectionType=N,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=X,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new U(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(B=>{const V=q(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${V} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${V} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${V} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const B=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${B} received socket timeout event.`),this._beginReconnecting()})),$._instances.push(this),$._permanentFailure&&this._gotoPermanentFailure($._permanentFailureMillisSinceLastIncomingData,$._permanentFailureAttempt,$._permanentFailureHandled)}static triggerPermanentFailure(N,W,X){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=N,this._permanentFailureAttempt=W,this._permanentFailureHandled=X,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if($._permanentFailure)return;const N=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const Z=X<W.length?W[X]:W[W.length-1];try{if(Z>0){const V=d(Z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,V)),this._options.logService.info(`${N} waiting for ${Z} seconds before reconnecting...`);try{await V}catch{}}if($._permanentFailure){this._options.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new w(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this._options.logService.info(`${N} resolving connection...`);const B=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${N} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,h(C)),this._options.logService.info(`${N} reconnected!`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this._options.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,T.isPromiseCanceledError)(B)){this._options.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,n.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!$._permanentFailure)}_gotoPermanentFailure(N,W,X){this._onDidStateChange.fire(new O(this.reconnectionToken,N,W,X)),H(this.protocol)}}$._permanentFailure=!1,$._permanentFailureMillisSinceLastIncomingData=0,$._permanentFailureAttempt=0,$._permanentFailureHandled=!1,$._instances=[];class K extends ${constructor(N,W,X,Z,B){super(1,N,Z,B);this.client=this._register(new I.Client(B,{remoteAuthority:W,clientId:X},N.ipcLogger))}async _reconnect(N,W){await t(N,W)}}e.ManagementPersistentConnection=K;class M extends ${constructor(N,W,X,Z,B){super(2,N,X,Z);this._startArguments=W,this.debugPort=B}async _reconnect(N,W){await s(N,this._startArguments,W)}}e.ExtensionHostPersistentConnection=M;function H(x){try{x.acceptDisconnect();const N=x.getSocket();x.dispose(),N.dispose()}catch(N){(0,T.onUnexpectedError)(N)}}function j(x){if(x&&x.type==="error"){const N=new Error(`Connection error: ${x.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function z(x,N){for(;x.length<N;)x+=" ";return x}function q(x,N,W){return`[remote-connection][${z(b(x),13)}][${N.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function F(x,N){return`${q(N,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.host}:${x.port}]`}function G(x){return`${Date.now()-x} ms`}}),define(te[186],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[61],ne([0,1,3,4,5,10]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var L;(function(h){h.Http="http",h.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=C;function g(h,p){return p?p!==1&&h<1024:!k.isWindows&&h<1024}e.isPortPrivileged=g;let b=class{constructor(p){this.logService=p,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,f){return this._tunnelProvider=p,p?(this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async p=>{const f=[],E=Array.from(this._tunnels.values());for(let v of E){const y=Array.from(v.values());for(let c of y){const o=await c.value;o&&f.push(o)}}p(f)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:f}of p.values())await f.then(E=>E?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,f,E,v,y=!1,c=P.Private,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${E} on local port ${v}.`),!p)return;f||(f="localhost");const t=this.retainOrCreateTunnel(p,f,E,v,y,c,o);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,E);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==E)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const f=this._tunnels.get(p.tunnelRemoteHost);if(f){const E=f.get(p.tunnelRemotePort);E&&(E.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,E))}}}}async tryDisposeTunnel(p,f,E){if(E.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${f}.`);const v=E.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(f),v}}async closeTunnel(p,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${f} `);const E=this._tunnels.get(p);if(E&&E.has(f)){const v=E.get(f);v.refcount=0,await this.tryDisposeTunnel(p,f,v)}}addTunnelToMap(p,f,E){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(f,{refcount:1,value:E})}async removeEmptyTunnelFromMap(p,f){const E=this._tunnels.get(p);E&&(await E.get(f)||E.delete(f),E.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,f){let E=[p];n(p)?(E.push(...e.LOCALHOST_ADDRESSES),E.push(...e.ALL_INTERFACES_ADDRESSES)):C(p)&&E.push(...e.ALL_INTERFACES_ADDRESSES);const v=E.map(y=>this._tunnels.get(y));for(const y of v){const c=y?.get(f);if(c)return c}}canTunnel(p){return!!I(p)}createWithProvider(p,f,E,v,y,c,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${E} on local port ${v}.`);const s={elevationRequired:y?g(v===void 0?E:v):!1},i={remoteAddress:{host:f,port:E},localAddressPort:v,privacy:c,public:c!==P.Private,protocol:o},r=p.forwardPort(i,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(f,E,r),r}};b=he([Q(0,T.ILogService)],b),e.AbstractTunnelService=b}),define(te[187],ne([0,1,10,61,2,8,6]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new L.DeferredPromise),this._addressPromise.p)}setAddress(n){this._address=n,this._addressPromise&&(this._addressPromise.complete(n),this._addressPromise=null)}setTunnel(n){this._register(n)}}let S=class yt extends D.Disposable{constructor(n,C){super();this._tunnelService=n,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(n=>n.dispose())}async createTunnel(){return{id:String(++yt._lastId)}}async startTunnel(n,C,g,b,h){const p=new P,f=await Promise.resolve(this._tunnelService.openTunnel(p,C,g,b,h));if(!f)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${C}:${g} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(n))throw this._disposedTunnels.delete(n),p.dispose(),await f.dispose(),(0,T.canceled)();return p.setTunnel(f),this._tunnels.set(n,p),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${n}: ${f.localAddress} (local) to ${C}:${g} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(n,C){const g=this._tunnels.get(n);!g||g.setAddress(C)}async destroyTunnel(n){const C=this._tunnels.get(n);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${n}.`),this._tunnels.delete(n),await C.dispose();return}this._disposedTunnels.add(n)}};S._lastId=0,S=he([Q(0,k.ITunnelService),Q(1,R.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[188],ne([0,1,117,20,10]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,S){this.configurationService=P,this.logService=S}request(P,S){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,S)}async resolveProxy(P){}};T=he([Q(0,k.IConfigurationService),Q(1,D.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,22,137,39,5,35]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function S(h){return h.res.statusCode===204}async function I(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,R.streamToBuffer)(h.stream)).toString()}e.asText=I;async function n(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const f=(await(0,R.streamToBuffer)(h.stream)).toString();try{return JSON.parse(f)}catch(E){throw E.message+=`:
`+f,E}}e.asJson=n;function C(h){b(h)}e.updateProxyConfigurationsScope=C;let g;function b(h){const p=L.Registry.as(D.Extensions.Configuration),f=g;g={id:"http",order:15,title:(0,k.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(4,null),(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],default:"override",description:(0,k.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[g],remove:f?[f]:[]})}b(2)}),define(te[189],ne([0,1,27,15,14,43]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(S,I){this.requestService=S,this.fileService=I}async download(S,I,n=R.CancellationToken.None){if(S.scheme===k.Schemas.file||S.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(S,I);return}const C={type:"GET",url:S.toString()},g=await this.requestService.request(C,n);if(g.res.statusCode===200)await this.fileService.writeFile(I,g.stream);else{const b=await(0,T.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${b}`)}}};L=he([Q(0,T.IRequestService),Q(1,D.IFileService)],L),e.DownloadService=L}),define(te[190],ne([0,1,17,27,65,2,16,150,14,10,29,43]),function(J,e,R,k,D,T,L,P,S,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends T.Disposable{constructor(h,p,f,E){super();this.fileService=h,this.productService=p,this.requestService=f,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const p=[];for(const[f,E]of this.allConfigBasedTips)if(!(E.configScheme&&E.configScheme!==h.scheme))try{const v=await this.fileService.readFile((0,L.joinPath)(h,f)),y=new Map;(0,D.forEach)(E.recommendations,({key:o,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const s of t.remotes)y.set(s,{extensionId:o,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else p.push({extensionId:o,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const c=(0,P.getDomainsOfRemotes)(v.value.toString(),[...y.keys()]);for(const o of c){const t=y.get(o);t&&p.push(t)}}catch(v){}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},k.CancellationToken.None);if(h.res.statusCode!==200)return[];const p=await(0,C.asJson)(h);return p?p.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};g=he([Q(0,S.IFileService),Q(1,n.IProductService),Q(2,C.IRequestService),Q(3,I.ILogService)],g),e.ExtensionTipsService=g}),define(te[45],ne([0,1,22,30]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(T,L,P){let S=P&&P.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await L.readFile(T.serviceMachineIdResource)).value.toString();S=(0,k.isUUID)(n)?n:null}catch(I){S=null}if(!S){S=(0,k.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(S))}catch(I){}}return P&&P.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=D}),define(te[90],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[191],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{vsda(){return new Promise((D,T)=>J(["vsda"],D,T))}async sign(D){try{const T=await this.vsda(),L=new T.signer;if(L)return L.sign(D)}catch(T){}return D}}e.SignService=R}),define(te[23],ne([0,1,6,3,2,18,73,5]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var I;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var C;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class g extends D.Disposable{constructor(f={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,E){E===S?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:E,target:this.getKeyTargets(f)[E]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,E,v){return this.getStorage(E)?.get(f,v)}getBoolean(f,E,v){return this.getStorage(E)?.getBoolean(f,v)}getNumber(f,E,v){return this.getStorage(E)?.getNumber(f,v)}store(f,E,v,y){if((0,T.isUndefinedOrNull)(E)){this.remove(f,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,v,y),this.getStorage(v)?.set(f,E)})}remove(f,E){this.withPausedEmitters(()=>{this.updateKeyTarget(f,E,void 0),this.getStorage(E)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,E){const v=[],y=this.getKeyTargets(f);for(const c of Object.keys(y))y[c]===E&&v.push(c);return v}updateKeyTarget(f,E,v){const y=this.getKeyTargets(E);typeof v=="number"?y[f]!==v&&(y[f]=v,this.getStorage(E)?.set(S,JSON.stringify(y))):typeof y[f]=="number"&&(delete y[f],this.getStorage(E)?.set(S,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const E=this.get(S,f);if(E)try{return JSON.parse(E)}catch(v){}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this._onWillSaveState.fire({reason:f}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const f=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return h(f,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends g{constructor(){super();this.globalStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}e.InMemoryStorageService=b;async function h(p,f,E,v){const y=a=>{try{return JSON.parse(a)}catch(l){return a}},c=new Map,o=new Map;p.forEach((a,l)=>{c.set(l,a),o.set(l,y(a))});const t=new Map,s=new Map;f.forEach((a,l)=>{t.set(l,a),s.set(l,y(a))}),console.group(`Storage: Global (path: ${E})`);let i=[];c.forEach((a,l)=>{i.push({key:l,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${v})`);let r=[];t.forEach((a,l)=>{r.push({key:l,value:a})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=h}),define(te[192],ne([0,1,3,2,18,28,34,23]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends k.Disposable{constructor(C){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(C)),this._register(this.storageManger.onDidChange(g=>this._onDidChangeEnablement.fire({extensions:g,source:"storage"})))}async enableExtension(C,g){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:g}),!0):!1}async disableExtension(C,g){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let g=this.getDisabledExtensions();return g.every(b=>!(0,L.areSameExtensions)(b,C))?(g.push(C),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(C){let g=this.getDisabledExtensions();for(let b=0;b<g.length;b++){const h=g[b];if((0,L.areSameExtensions)(h,C))return g.splice(b,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,g){this.storageManger.set(C,g,0)}};S=he([Q(0,P.IStorageService)],S),e.GlobalExtensionEnablementService=S;class I extends k.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(C,g){let b;return g===0?((0,D.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,g)),b=this.storage[C]):b=this._get(C,g),JSON.parse(b)}set(C,g,b){let h=JSON.stringify(g.map(({id:f,uuid:E})=>({id:f,uuid:E})));this._get(C,b)!==h&&(b===0&&(g.length?this.storage[C]=h:delete this.storage[C]),this._set(C,g.length?h:void 0,b))}onDidStorageChange(C){if(C.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const b=this.get(C.key,C.scope);delete this.storage[C.key];const h=this.get(C.key,C.scope),p=b.filter(E=>!h.some(v=>(0,L.areSameExtensions)(E,v))),f=h.filter(E=>!b.some(v=>(0,L.areSameExtensions)(v,E)));(p.length||f.length)&&this._onDidChange.fire([...p,...f])}}_get(C,g){return this.storageService.get(C,g,"[]")}_set(C,g,b){g?this.storageService.store(C,g,b,1):this.storageService.remove(C,b)}}e.StorageManager=I}),define(te[193],ne([0,1,3,2]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends k.Disposable{constructor(I,n){super();this.channel=I,this.workspace=n}async getItems(){const I={workspace:this.workspace},n=await this.channel.call("getItems",I);return new Map(n)}updateItems(I){const n={workspace:this.workspace};return I.insert&&(n.insert=Array.from(I.insert.entries())),I.delete&&(n.delete=Array.from(I.delete.values())),this.channel.call("updateItems",n)}}class T extends D{constructor(I){super(I,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(I=>this.onDidChangeGlobalStorage(I)))}onDidChangeGlobalStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}async close(){this.dispose()}}class L extends D{constructor(I,n){super(I,n);this.onDidChangeItemsExternal=R.Event.None}async close(){const I={workspace:this.workspace};return this.channel.call("close",I)}}class P extends k.Disposable{constructor(I,n){super();this.channel=I,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new L(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[194],ne([0,1,6,2,179,16,73,23,193]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class I extends P.AbstractStorageService{constructor(C,g,b){super();this.mainProcessService=g,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new k.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(C)}createGlobalStorage(){const C=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),g=new L.Storage(C.globalStorage);return this._register(g.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),g}createWorkspaceStorage(C){const g=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),C);if(g.workspaceStorage){const b=new L.Storage(g.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=C?.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,D.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,D.mark)("code/didInitStorage")}}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(C){const g=this.workspaceStorage,b=g?.items??new Map;g&&(await g.close(),g.dispose()),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init();for(const[h,p]of b)this.workspaceStorage.set(h,p)}}e.NativeStorageService=I}),define(te[195],ne([0,1,4,31,7,30]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(I){if(R.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function P(I,n,C,g,b,h,p,f,E,v){const y=Object.create(null);y["common.machineId"]=p,y.sessionID=(0,T.generateUuid)()+Date.now(),y.commitHash=b,y.version=h,y["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,R.PlatformToString)(R.platform),y["common.nodePlatform"]=k.platform,y["common.nodeArch"]=g,y["common.product"]=v||"desktop";const c=S(f||[]);c&&(y["common.msftInternal"]=c);let o=0;const t=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),R.isLinuxSnap&&(y["common.snap"]="true");const s=L(C);s&&(y["common.platformDetail"]=s);try{const i=await I.readFile(D.URI.file(E));y["common.source"]=i.value.toString().slice(0,30)}catch(i){}return y}e.resolveCommonProperties=P;function S(I){const n=k.env.USERDNSDOMAIN;if(!n)return!1;const C=n.toLowerCase();return I.some(g=>C===g)}e.verifyMicrosoftInternalDomain=S}),define(te[21],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(T){T[T.NONE=0]="NONE",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(T){T.OFF="off",T.ERROR="error",T.ON="on"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[196],ne([0,1,32,55,36,15,9,4,7,109,19,112,78,14,29,21]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function f(o,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,r=new Map,a=2e4;function l(m,A,_,w){const U=A.substring(m.length+1);return new Promise(async O=>{let $;try{$=await n.Promises.readdir(A,{withFileTypes:!0})}catch(H){O();return}if(w.count>=a){w.count+=$.length,w.maxReached=!0,O();return}let K=$.length;if(K===0){O();return}let M=$;w.count+$.length>a&&(w.maxReached=!0,K=a-w.count,M=$.slice(0,K)),w.count+=$.length;for(const H of M)if(H.isDirectory()){if(_.includes(H.name)||await l(m,(0,L.join)(A,H.name),_,w),--K==0){O();return}}else{const j=H.name.lastIndexOf(".");if(j>=0){const z=H.name.substring(j+1);z&&i.set(z,(i.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(U)!==!1&&z.filePattern.test(H.name)&&r.set(z.tag,(r.get(z.tag)??0)+1);if(--K==0){O();return}}})}const u={count:0,maxReached:!1};await l(o,o,t,u);const d=await y(o);return{configFiles:E(r),fileTypes:E(i),fileCount:u.count,maxFilesReached:u.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=f;function E(o){return[...k.Iterable.map(o.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function v(){const o={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=v;async function y(o){try{const t=new Map,s=(0,L.join)(o,".vscode","launch.json"),i=await n.Promises.readFile(s),r=[],a=(0,D.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,D.getNodeType)(a)==="object"&&a.configurations)for(const l of a.configurations){const u=l.type;u&&(t.has(u)?t.set(u,t.get(u)+1):t.set(u,1))}return E(t)}catch(t){return[]}}e.collectLaunchConfigs=y;let c=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const i=R.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(R.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||s.push(`Load (avg):       ${R.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[r,a]=i,l=this.formatProcessList(t,r);return s.forEach(u=>{if((0,g.isRemoteDiagnosticError)(u))l+=`
${u.errorMessage}`,a+=`
${u.errorMessage}`;else if(l+=`

Remote: ${u.hostName}`,u.processes&&(l+=`
${this.formatProcessList(t,u.processes)}`),u.workspaceMetadata){a+=`
|  Remote: ${u.hostName}`;for(const d of Object.keys(u.workspaceMetadata)){const m=u.workspaceMetadata[d];let A=`${m.fileCount} files`;m.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${d}): ${A}`,a+=this.formatWorkspaceStats(m)}}}),{processInfo:l,workspaceInfo:a}})}async getSystemInfo(t,s){const{memory:i,vmHint:r,os:a,cpus:l}=v(),u={os:a,memory:i,cpus:l,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return P.isWindows||(u.load=`${R.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(t,s){const i=[];return(0,C.listProcesses)(t.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,r)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),s.forEach(a=>{if((0,g.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const l of Object.keys(a.workspaceMetadata)){const u=a.workspaceMetadata[l];let d=`${u.fileCount} files`;u.maxFilesReached&&(d=`more than ${d}`),i.push(`Folder (${l}): ${d}`),i.push(this.formatWorkspaceStats(u))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const s=[],i=60;let r=0;const a=(m,A)=>{const _=` ${m}(${A})`;r+_.length>i?(s.push(l),l="|                 ",r=l.length):r+=_.length,l+=_};let l="|      File types:";const u=10;let d=t.fileTypes.length>u?u:t.fileTypes.length;for(let m=0;m<d;m++){const A=t.fileTypes[m];a(A.name,A.count)}if(s.push(l),t.configFiles.length>=0&&(l="|      Conf files:",r=0,t.configFiles.forEach(m=>{a(m.name,m.count)}),s.push(l)),t.launchConfigFiles.length>0){let m="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{m+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),s.push(m)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],i=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const l=S.URI.revive(a);if(l.scheme===T.Schemas.file){const u=l.fsPath;i.push(f(u,["node_modules",".git"]).then(d=>{let m=`${d.fileCount} files`;d.maxFilesReached&&(m=`more than ${m}`),s.push(`|    Folder (${(0,L.basename)(u)}): ${m}`),s.push(this.formatWorkspaceStats(d))}).catch(d=>{s.push(`|      Error: Unable to collect workspace stats for folder ${u} (${d.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,s){const i=new Map;t.windows.forEach(a=>i.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(t,s,i,r,a){const l=a===0;let u;l?u=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(u=`${u} (${s.get(r.pid)})`));const d=process.platform==="win32"?r.mem:R.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(d/b.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(r.children)&&r.children.forEach(m=>this.formatProcessItem(t,s,i,m,a+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const i=S.URI.revive(s);if(i.scheme!==T.Schemas.file)continue;const r=i.fsPath;try{const a=await f(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),a.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),a.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};c=he([Q(0,p.ITelemetryService),Q(1,h.IProductService)],c),e.DiagnosticsService=c}),define(te[197],ne([0,1,17,6,27,8,3,2,4,7,126,28,34,10,42,21]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let f=class extends P.Disposable{constructor(o,t,s){super();this.galleryService=o,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const t=await this.getTargetPlatform();return o.allTargetPlatforms.some(s=>(0,C.isTargetPlatformCompatible)(s,o.allTargetPlatforms,t))}async installFromGallery(o,t={}){if(!this.galleryService.isEnabled())throw new Error(n.localize(0,null));if(!await this.canInstall(o)){const i=await this.getTargetPlatform(),r=new C.ExtensionManagementError(n.localize(1,null,o.identifier.id,h.default.nameLong,(0,C.TargetPlatformToString)(i)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",o.identifier.id,r.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,r),r}try{o=await this.checkAndGetCompatibleVersion(o,!t.installGivenVersion)}catch(i){throw this.logService.error((0,T.getErrorMessage)(i)),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,i),i}const s=await this.galleryService.getManifest(o,D.CancellationToken.None);if(s===null){const i=new C.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",o.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,i),i}if(s.version!==o.version){const i=new C.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,i),i}return this.installExtension(s,o,t)}async uninstall(o,t={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,t)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(2,null));const t=await this.findGalleryExtension(o);if(!t)throw new Error(n.localize(3,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const o=new Date().getTime();return(!this.reportedExtensions||o-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=o),this.reportedExtensions}registerParticipant(o){this.participants.push(o)}async installExtension(o,t,s){if(!I.URI.isUri(t)){let u=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(u)return this.logService.info("Extensions is already requested to install",t.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],r=[],a=this.createInstallExtensionTask(o,t,s);I.URI.isUri(t)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,o.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:t}),this.logService.info("Installing extension:",a.identifier.id),i.push({task:a,manifest:o});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,o,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:m,manifest:A}of d)if(l=l||!!A.extensionDependencies?.some(_=>(0,g.areSameExtensions)({id:_},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(m.identifier,m.version).key()))this.logService.info("Extension is already requested to install",m.identifier.id);else{const _=this.createInstallExtensionTask(A,m,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(_.identifier,A.version).key(),_),this._onInstallExtension.fire({identifier:_.identifier,source:m}),this.logService.info("Installing extension:",_.identifier.id),i.push({task:_,manifest:A})}}catch(d){if(I.URI.isUri(a.source))(0,R.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,d.message),(0,R.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(d),d}const u=i.reduce((d,{task:m,manifest:A})=>(d.set(m.identifier.id.toLowerCase(),{task:m,manifest:A}),d),new Map);for(;u.size;){let d;const m=[...u.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(_=>u.has(_.toLowerCase())));m.length?d=u.size===1?m:m.filter(({task:A})=>!(A===a&&!l)):(this.logService.info("Found extensions with circular dependencies",m.map(({task:A})=>A.identifier.id)),d=[...u.values()]),await this.joinAllSettled(d.map(async({task:A})=>{const _=new Date().getTime();try{const w=await A.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall(w,A.source,s,D.CancellationToken.None))),!I.URI.isUri(A.source)&&(v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,void 0),S.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(w.manifest.publisher,w.manifest.name,w.manifest.version,"install")}catch(U){}r.push({local:w,identifier:A.identifier,operation:A.operation,source:A.source})}catch(w){throw I.URI.isUri(A.source)||v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,w),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(w),w}finally{u.delete(A.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:d})=>(0,g.areSameExtensions)(d,a.identifier))[0].local}catch(u){if(i.forEach(({task:d})=>d.cancel()),r.length)try{const d=await Promise.allSettled(r.map(({local:m})=>this.createUninstallExtensionTask(m,{versionOnly:!0}).run()));for(let m=0;m<d.length;m++){const A=d[m],{identifier:_}=r[m];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",_.id):this.logService.warn("Rollback: Error while uninstalling extension",_.id,(0,T.getErrorMessage)(A.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(d),r.map(({identifier:m})=>m.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,T.getErrorMessage)(u)),this._onDidInstallExtensions.fire(i.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:d}of i)if(!I.URI.isUri(u.source)){const m=new g.ExtensionIdentifierWithVersion(u.identifier,d.version).key();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(o){const t=[],s=[],i=await Promise.allSettled(o);for(const r of i)r.status==="fulfilled"?t.push(r.value):s.push(r.reason);if(s.length)throw E(s);return t}async getAllDepsAndPackExtensionsToInstall(o,t,s){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const r=[o,...i.map(u=>u.identifier)],a=[],l=async(u,d)=>{const m=d.extensionDependencies||[],A=[...m];if(d.extensionPack){const _=s?i.find(w=>(0,g.areSameExtensions)(w.identifier,u)):void 0;for(const w of d.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(U=>(0,g.areSameExtensions)({id:U},{id:w}))||A.every(U=>!(0,g.areSameExtensions)({id:U},{id:w}))&&A.push(w)}if(A.length){const _=[...r,...a.map(U=>U.gallery.identifier)],w=A.filter(U=>_.every(O=>!(0,g.areSameExtensions)(O,{id:U})));if(w.length){const U=await this.galleryService.query({names:w,pageSize:A.length},D.CancellationToken.None);for(const O of U.firstPage){if(_.find(H=>(0,g.areSameExtensions)(H,O.identifier)))continue;if(!m.some(H=>(0,g.areSameExtensions)({id:H},O.identifier))&&!await this.canInstall(O)){this.logService.info("Skipping the packed extension as it cannot be installed",O.identifier.id);continue}const K=await this.checkAndGetCompatibleVersion(O,!0),M=await this.galleryService.getManifest(K,D.CancellationToken.None);if(M===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${K.identifier.id}`,e.INSTALL_ERROR_VALIDATING);a.push({gallery:K,manifest:M}),await l(K.identifier,M)}}}};return await l(o,t),i=await this.getInstalled(),a.filter(u=>!i.some(d=>(0,g.areSameExtensions)(d.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(o,t){if(await this.isMalicious(o))throw new C.ExtensionManagementError(n.localize(4,null,o.identifier.id),C.INSTALL_ERROR_MALICIOUS);const s=await this.getCompatibleVersion(o,t);if(!s)throw new C.ExtensionManagementError(n.localize(5,null,o.identifier.id,h.default.version),C.INSTALL_ERROR_INCOMPATIBLE);return s}async getCompatibleVersion(o,t){const s=await this.getTargetPlatform();let i=null;return await this.galleryService.isExtensionCompatible(o,s)&&(i=o),!i&&t&&(i=await this.galleryService.getCompatibleExtension(o,s)),i}async isMalicious(o){const t=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(t).has(o.identifier.id)}async unininstallExtension(o,t){const s=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),s.waitUntilTaskIsFinished();const i=(u,d)=>{const m=this.createUninstallExtensionTask(u,d);return this.uninstallingExtensions.set(m.extension.identifier.id.toLowerCase(),m),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),m},r=(u,d)=>{d?this.logService.error("Failed to uninstall extension:",u.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(u),void 0,d),this._onDidUninstallExtension.fire({identifier:u.identifier,error:d?.code})},a=[],l=[];try{a.push(i(o,{}));const u=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(o,u);for(const m of d)this.uninstallingExtensions.has(m.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",m.identifier.id):a.push(i(m,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(a.map(d=>d.extension),u,o),await this.joinAllSettled(a.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(m=>m.postUninstall(d.extension,t,D.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(m){}r(d.extension)}catch(m){const A=m instanceof C.ExtensionManagementError?m:new C.ExtensionManagementError((0,T.getErrorMessage)(m),e.ERROR_UNKNOWN);throw r(d.extension,A),A}finally{l.push(d)}}))}catch(u){const d=u instanceof C.ExtensionManagementError?u:new C.ExtensionManagementError((0,T.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const m of a){try{m.cancel()}catch(A){}l.includes(m)||r(m.extension,d)}throw d}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(o,t,s){for(const i of o){const r=this.getDependents(i,t);if(r.length){const a=r.filter(l=>!o.some(u=>(0,g.areSameExtensions)(u.identifier,l.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(i,a,s))}}}getDependentsErrorMessage(o,t,s){return s===o?t.length===1?n.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?n.localize(9,null,s.manifest.displayName||s.manifest.name,o.manifest.displayName||o.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(10,null,s.manifest.displayName||s.manifest.name,o.manifest.displayName||o.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(11,null,s.manifest.displayName||s.manifest.name,o.manifest.displayName||o.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(o,t,s=[]){if(s.indexOf(o)!==-1)return[];s.push(o);const i=o.manifest.extensionPack?o.manifest.extensionPack:[];if(i.length){const r=t.filter(l=>!l.isBuiltin&&i.some(u=>(0,g.areSameExtensions)({id:u},l.identifier))),a=[];for(const l of r)a.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...r,...a]}return[]}getDependents(o,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(i=>(0,g.areSameExtensions)({id:i},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const t=await this.findGalleryExtensionById(o.identifier.uuid);return t||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${o.length} reported extensions from service`),o}catch(o){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};f=he([Q(0,C.IExtensionGalleryService),Q(1,p.ITelemetryService),Q(2,b.ILogService)],f),e.AbstractExtensionManagementService=f;function E(c){const o=Array.isArray(c)?c:[c];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=E;function v(c,o,t,s,i){const r=i?i instanceof C.ExtensionManagementError?i.code:e.ERROR_UNKNOWN:void 0;c.publicLogError(o,{...t,success:!i,duration:s,errorcode:r})}e.reportTelemetry=v;class y{constructor(){this.barrier=new k.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(o=>new Promise((t,s)=>{const i=o.onCancellationRequested(()=>{i.dispose(),s((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=y}),define(te[198],ne([0,1,17,6,65,3,9,4,31,7,128,13,28,190,80,14,10,60,29,43,23,21]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let i=class extends b.ExtensionTipsService{constructor(a,l,u,d,m,A,_,w,U,O){super(_,w,U,O);this.environmentService=a,this.telemetryService=l,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=m,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,w.exeBasedExtensionTips&&(0,D.forEach)(w.exeBasedExtensionTips,({key:$,value:K})=>{const M=[],H=[],j=[];(0,D.forEach)(K.recommendations,({key:z,value:q})=>{q.important?K.important?M.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):H.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):j.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set($,{exeFriendlyName:K.friendlyName,windowsPath:K.windowsPath,recommendations:M}),H.length&&this.mediumImportanceExecutableTips.set($,{exeFriendlyName:K.friendlyName,windowsPath:K.windowsPath,recommendations:H}),j.length&&this.allOtherExecutableTips.set($,{exeFriendlyName:K.friendlyName,windowsPath:K.windowsPath,recommendations:j})}),(0,k.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(a,l){const u=new Map;a.forEach(w=>u.set(w.extensionId.toLowerCase(),w));const{installed:d,uninstalled:m}=this.groupByInstalled([...u.keys()],l);for(const w of d){const U=u.get(w);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:w,exeName:U.exeName})}for(const w of m){const U=u.get(w);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:w,exeName:U.exeName})}const A=this.getPromptedExecutableTips(),_=new Map;for(const w of m){const U=u.get(w);if(U&&(!A[U.exeName]||!A[U.exeName].includes(U.extensionId))){let O=_.get(U.exeName);O||(O=[],_.set(U.exeName,O)),O.push(U)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const d=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const m=this._register((0,k.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),l=Date.now()-a,u=7*24*60*60*1e3;if(l<u){const A=this._register((0,k.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[d,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(m[0].exeName,m);const _=this._register((0,k.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const w=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(w(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const U=this._register((0,k.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const l=a.map(({extensionId:d})=>d.toLowerCase()),u=(0,n.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,l){const u=this.getPromptedExecutableTips();u[a]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(a,l){const u=[],d=[],m=l.reduce((A,_)=>(A.add(_.identifier.id.toLowerCase()),A),new Set);return a.forEach(A=>{m.has(A.toLowerCase())?u.push(A):d.push(A)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(a){const l=[],u=new Map;for(const d of a.keys()){const m=a.get(d);if(!m||!(0,R.isNonEmptyArray)(m.recommendations))continue;const A=[];P.isWindows?m.windowsPath&&A.push(m.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(A.push((0,L.join)("/usr/local/bin",d)),A.push((0,L.join)("/usr/bin",d)),A.push((0,L.join)(this.environmentService.userHome.fsPath,d)));for(const _ of A){let w=u.get(_);if(w===void 0&&(w=await this.fileService.exists(I.URI.file(_)),u.set(_,w)),w)for(const{extensionId:U,extensionName:O,isExtensionPack:$}of m.recommendations)l.push({extensionId:U,extensionName:O,isExtensionPack:$,exeName:d,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return l}};i=he([Q(0,C.INativeEnvironmentService),Q(1,o.ITelemetryService),Q(2,g.IExtensionManagementService),Q(3,c.IStorageService),Q(4,E.INativeHostService),Q(5,h.IExtensionRecommendationNotificationService),Q(6,p.IFileService),Q(7,v.IProductService),Q(8,y.IRequestService),Q(9,f.ILogService)],i),e.ExtensionTipsService=i}),define(te[91],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appender=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,{eventName:P,data:S}){return this.appender.log(P,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class k{constructor(T){this.channel=T}log(T,L){return this.channel.call("log",{eventName:T,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(te[46],ne([0,1,26,18,20,21]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(E,v){return Promise.resolve(void 0)}publicLog2(E,v){return this.publicLog(E,v)}publicLogError(E,v){return Promise.resolve(void 0)}publicLogError2(E,v){return this.publicLogError(E,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class P{async publicLog(E,v,y){}async publicLogError(E,v,y){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(f,E){return E.onDidChangeConfiguration(v=>{v.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(v.source),configurationKeys:h(v.sourceConfig)})})}e.configurationTelemetry=S;function I(f,E){return!(E.disableTelemetry||!f.enableTelemetry)}e.supportsTelemetry=I;function n(f){const E=f.getValue(T.TELEMETRY_SETTING_ID),v=f.getValue(T.TELEMETRY_OLD_SETTING_ID);if(v!==void 0&&v===!1)return 0;switch(E??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}e.getTelemetryLevel=n;function C(f){const E=Object.create(null),v=Object.create(null),y=Object.create(null);b(f,y);for(let c in y){c=c.length>150?c.substr(c.length-149):c;const o=y[c];typeof o=="number"?v[c]=o:typeof o=="boolean"?v[c]=o?1:0:typeof o=="string"?E[c]=o.substring(0,1023):typeof o!="undefined"&&o!==null&&(E[c]=o)}return{properties:E,measurements:v}}e.validateTelemetryData=C;function g(f){if(!f)return"none";let E="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{f.indexOf(`${y}+`)===0&&(E=y)}),E}e.cleanRemoteAuthority=g;function b(f,E,v=0,y){if(!!f)for(let c of Object.getOwnPropertyNames(f)){const o=f[c],t=y?y+c:c;Array.isArray(o)?E[t]=(0,R.safeStringify)(o):o instanceof Date?E[t]=o.toISOString():(0,k.isObject)(o)?v<2?b(o,E,v+1,t+"."):E[t]=(0,R.safeStringify)(o):E[t]=o}}function h(f){if(!f)return[];const E=[];return p(E,"",f),E}function p(f,E,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(y=>p(f,E?`${E}.${y}`:y,v[y])):f.push(E)}}),define(te[199],ne([0,1,17,27,8,26,4,31,7,20,13,28,34,76,14,10,29,43,45,23,21,46]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=L.isWeb?"web":(0,C.getTargetPlatform)(L.platform,P.arch);var s;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(s||(s={}));function i(...B){return String(B.reduce((V,ie)=>V|ie,0))}var r;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class m{constructor(V=d){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,ie=this.state.pageSize){return new m({...this.state,pageNumber:V,pageSize:ie})}withFilter(V,...ie){const re=[...this.state.criteria,...ie.length?ie.map(ae=>({filterType:V,value:ae})):[{filterType:V}]];return new m({...this.state,criteria:re})}withSortBy(V){return new m({...this.state,sortBy:V})}withSortOrder(V){return new m({...this.state,sortOrder:V})}withFlags(...V){return new m({...this.state,flags:V.reduce((ie,re)=>ie|re,0)})}withAssetTypes(...V){return new m({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue,flags:fe,assetTypes:ge}=this.state;return{filters:[{criteria:V,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue}],assetTypes:ge,flags:fe}}get searchText(){const V=this.state.criteria.filter(ie=>ie.filterType===r.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(B,V){const ie=(B||[]).filter(re=>re.statisticName===V)[0];return ie?ie.value:0}function _(B){const V="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(re=>re.assetType.indexOf(V)===0).reduce((re,ae)=>{const ue=$(B,ae.assetType);return ue&&re.push([ae.assetType.substring(V.length),ue]),re},[])}function w(B){if(B.properties){const V=B.properties.filter(ae=>ae.key===a.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=V.filter(ae=>ie.test(ae.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return $(B,a.Repository)}function U(B){return{uri:`${B.fallbackAssetUri}/${a.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${a.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function O(B){const V=$(B,a.Icon);if(V)return V;const ie=C.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function $(B,V){return B.files.filter(re=>re.assetType===V)[0]?{uri:`${B.assetUri}/${V}`,fallbackUri:`${B.fallbackAssetUri}/${V}`}:null}function K(B,V){const ie=B.properties?B.properties.filter(ae=>ae.key===V):[],re=ie.length>0&&ie[0].value;return re?re.split(",").map(ae=>(0,g.adoptToGalleryExtensionId)(ae)):[]}function M(B){const V=B.properties?B.properties.filter(ie=>ie.key===l.Engine):[];return V.length>0&&V[0].value||""}function H(B){const V=B.properties?B.properties.filter(re=>re.key===l.LocalizedLanguages):[],ie=V.length>0&&V[0].value||"";return ie?ie.split(","):[]}function j(B){return B.indexOf("preview")!==-1}function z(B){return B.targetPlatform?(0,C.toTargetPlatform)(B.targetPlatform):"undefined"}function q(B){const V=(0,R.distinct)(B.versions.map(z)),ie=!!B.tags?.includes(C.WEB_EXTENSION_TAG),re=V.indexOf("web");return ie?re===-1&&V.push("web"):re!==-1&&V.splice(re,1),V}function F(B,V){const ie=(0,C.getFallbackTargetPlarforms)(V);for(let re=0;re<B.length;re++){const ae=B[re];if(ae.version===B[re-1]?.version){let ue=re;const fe=z(ae);if(fe===V)for(;ue>0&&B[ue-1].version===ae.version;)ue--;else if(ie.includes(fe))for(;ue>0&&B[ue-1].version===ae.version&&z(B[ue-1])!==V;)ue--;ue!==re&&(B.splice(re,1),B.splice(ue,0,ae))}}return B}e.sortExtensionVersions=F;function G(B,V,ie,re,ae){const ue=q(B);let fe=B.versions[0];return fe=B.versions.find(ge=>ge.version===fe.version&&(0,C.isTargetPlatformCompatible)(z(ge),ue,ae))||fe,x(B,fe,ue,V,ie,re)}function x(B,V,ie,re,ae,ue){const fe={manifest:$(V,a.Manifest),readme:$(V,a.Details),changelog:$(V,a.Changelog),license:$(V,a.License),repository:w(V),download:U(V),icon:O(V),coreTranslations:_(V)};return{identifier:{id:(0,g.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:V.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,description:B.shortDescription||"",installCount:A(B.statistics,"install"),rating:A(B.statistics,"averagerating"),ratingCount:A(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:ie,assets:fe,properties:{dependencies:K(V,l.Dependency),extensionPack:K(V,l.ExtensionPack),engine:M(V),localizedLanguages:H(V),targetPlatform:z(V)},preview:j(B.flags),telemetryData:{index:(ae.pageNumber-1)*ae.pageSize+re,querySource:ue}}}let N=class{constructor(V,ie,re,ae,ue,fe,ge,Ie){this.requestService=ie,this.logService=re,this.environmentService=ae,this.telemetryService=ue,this.fileService=fe,this.productService=ge,this.configurationService=Ie;const Pe=ge.extensionsGallery;this.extensionsGalleryUrl=Pe&&Pe.serviceUrl,this.extensionsControlUrl=Pe&&Pe.controlUrl,this.commonHeadersPromise=Z(ge.version,ge,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,ie){const re=[];let ae=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,V.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...V.map(({id:fe})=>fe.toLowerCase()));V.every(fe=>!fe.version)&&(ae=ae.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ae,t,k.CancellationToken.None);for(let fe=0;fe<ue.length;fe++){const ge=ue[fe];if(!ge.versions.length)continue;const Ie=(0,g.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),Pe=V.find(Ee=>(0,g.areSameExtensions)(Ee,{id:Ie}))?.version;if(Pe){const Ee=ge.versions.find(_e=>_e.version===Pe);Ee&&re.push(x(ge,Ee,q(ge),fe,ae))}else re.push(G(ge,fe,ae,void 0,t))}return re}async getCompatibleExtension(V,ie){const re=(0,C.isIExtensionIdentifier)(V)?null:V;if(re){if((0,C.isNotWebExtensionInWebTargetPlatform)(re.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(re,ie))return re}const{id:ae,uuid:ue}=re?re.identifier:V;let fe=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?fe=fe.withFilter(r.ExtensionId,ue):fe=fe.withFilter(r.ExtensionName,ae);const{galleryExtensions:ge}=await this.queryGallery(fe,ie,k.CancellationToken.None),[Ie]=ge;if(!Ie||!Ie.versions.length)return null;const Pe=q(Ie);if((0,C.isNotWebExtensionInWebTargetPlatform)(Pe,ie))return null;for(let Ee of Ie.versions){if(!M(Ee)){const _e=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:_e}]}}if(await this.isRawExtensionVersionCompatible(Ee,Pe,ie))return x(Ie,Ee,Pe,0,fe)}return null}async isExtensionCompatible(V,ie){if(!(0,C.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,ie))return!1;let re=V.properties.engine;if(!re){const ae=await this.getManifest(V,k.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");re=ae.engines.vscode}return(0,b.isEngineValid)(re,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(V,ie,re){if(!(0,C.isTargetPlatformCompatible)(z(V),ie,re))return!1;const ae=await this.getEngine(V);return(0,b.isEngineValid)(ae,this.productService.version,this.productService.date)}async query(V,ie){const re=k.CancellationToken.isCancellationToken(V)?{}:V,ae=k.CancellationToken.isCancellationToken(V)?V:ie;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=re.text||"";const fe=(0,T.getOrDefault)(re,De=>De.pageSize,50);let ge=new m().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,fe).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,ke,Fe)=>(ge=ge.withFilter(r.Category,Fe||ke),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,ke,Fe)=>(ge=ge.withFilter(r.Tag,Fe||ke),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(ge=ge.withFilter(r.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),ge=ge.withFilter(r.SearchText,ue)),ge=ge.withSortBy(0)):re.ids?ge=ge.withFilter(r.ExtensionId,...re.ids):re.names?ge=ge.withFilter(r.ExtensionName,...re.names):ge=ge.withSortBy(4),typeof re.sortBy=="number"&&(ge=ge.withSortBy(re.sortBy)),typeof re.sortOrder=="number"&&(ge=ge.withSortOrder(re.sortOrder));const{galleryExtensions:Ie,total:Pe}=await this.queryGallery(ge,t,ae),Ee=Ie.map((De,ke)=>G(De,ke,ge,re.source,t)),_e=async(De,ke)=>{if(ke.isCancellationRequested)throw(0,D.canceled)();const Fe=ge.withPage(De+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,t,ke);return Ne.map((ze,xe)=>G(ze,xe,Fe,re.source,t))};return{firstPage:Ee,total:Pe,pageSize:ge.pageSize,getPage:_e}}async queryGallery(V,ie,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,s.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,i(s.Unpublished));const ae=await this.commonHeadersPromise,ue=JSON.stringify(V.raw),fe={...ae,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},ge=new Date().getTime();let Ie,Pe,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:fe},re),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const _e=await(0,E.asJson)(Ie);if(_e){const De=_e.results[0],ke=De.extensions;ke.forEach(Ne=>F(Ne.versions,ie));const Fe=De.resultMetadata&&De.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:ke,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(_e){throw Pe=_e,_e}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-ge,success:!!Ie&&(0,E.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Pe?(0,D.isPromiseCanceledError)(Pe)?"canceled":(0,D.getErrorMessage)(Pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(V,ie,re,ae){if(!this.isEnabled())return;const ue=L.isWeb?this.api(`/itemName/${V}.${ie}/version/${re}/statType/${ae==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${ie}/${re}/stats?statType=${ae}`),fe=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},k.CancellationToken.None)}catch(Pe){}}async download(V,ie,re){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const ae=(0,g.getGalleryExtensionTelemetryData)(V),ue=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:Ee}),ge=re===1?"install":re===2?"update":"",Ie=ge?{uri:`${V.assets.download.uri}${S.URI.parse(V.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${V.assets.download.fallbackUri}${S.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:V.assets.download,Pe=await this.getAsset(Ie);await this.fileService.writeFile(ie,Pe.stream),fe(new Date().getTime()-ue)}async getReadme(V,ie){if(V.assets.readme){const re=await this.getAsset(V.assets.readme,{},ie);return await(0,E.asText)(re)||""}return""}async getManifest(V,ie){if(V.assets.manifest){const re=await this.getAsset(V.assets.manifest,{},ie),ae=await(0,E.asText)(re);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(V,ie){const re=$(V,a.Manifest);if(!re)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},ue=await this.getAsset(re,{headers:ae});return await(0,E.asJson)(ue)}async getCoreTranslation(V,ie){const re=V.assets.coreTranslations.filter(ae=>ae[0]===ie.toUpperCase())[0];if(re){const ae=await this.getAsset(re[1]),ue=await(0,E.asText)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(V,ie){if(V.assets.changelog){const re=await this.getAsset(V.assets.changelog,{},ie);return await(0,E.asText)(re)||""}return""}async getAllCompatibleVersions(V,ie){let re=new m().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");V.identifier.uuid?re=re.withFilter(r.ExtensionId,V.identifier.uuid):re=re.withFilter(r.ExtensionName,V.identifier.id);const{galleryExtensions:ae}=await this.queryGallery(re,ie,k.CancellationToken.None);if(!ae.length)return[];const ue=q(ae[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ue,ie))return[];const fe=[];for(const ge of ae[0].versions)try{fe[fe.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,ue,ie)&&fe.push({version:ge.version,date:ge.lastUpdated})}catch(Ie){}return fe}async getAsset(V,ie={},re=k.CancellationToken.None){const ae=await this.commonHeadersPromise,ue={type:"GET"},fe={...ae,...ie.headers||{}};ie={...ie,...ue,headers:fe};const ge=V.uri,Ie=V.fallbackUri,Pe={...ie,url:ge};try{const Ee=await this.requestService.request(Pe,re);if(Ee.res.statusCode===200)return Ee;const _e=await(0,E.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${_e}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const _e=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:_e});const De={...ie,url:Ie};return this.requestService.request(De,re)}}async getEngine(V){let ie=M(V);if(!ie){const re=await this.getManifestFromRawExtensionVersion(V,k.CancellationToken.None);if(!re)throw new Error("Manifest was not found");ie=re.engines.vscode}return ie}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},k.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,E.asJson)(V),re=new Map;if(ie)for(const ae of ie.malicious){const ue=re.get(ae)||{id:{id:ae},malicious:!0,slow:!1};ue.malicious=!0,re.set(ae,ue)}return[...re.values()]}};N=he([Q(1,E.IRequestService),Q(2,p.ILogService),Q(3,n.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,h.IFileService),Q(6,f.IProductService),Q(7,I.IConfigurationService)],N);let W=class extends N{constructor(V,ie,re,ae,ue,fe,ge,Ie){super(V,ie,re,ae,ue,fe,ge,Ie)}};W=he([Q(0,y.IStorageService),Q(1,E.IRequestService),Q(2,p.ILogService),Q(3,n.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,h.IFileService),Q(6,f.IProductService),Q(7,I.IConfigurationService)],W),e.ExtensionGalleryService=W;let X=class extends N{constructor(V,ie,re,ae,ue,fe,ge){super(void 0,V,ie,re,ae,ue,fe,ge)}};X=he([Q(0,E.IRequestService),Q(1,p.ILogService),Q(2,n.IEnvironmentService),Q(3,c.ITelemetryService),Q(4,h.IFileService),Q(5,f.IProductService),Q(6,I.IConfigurationService)],X),e.ExtensionGalleryServiceWithNoStorageService=X;async function Z(B,V,ie,re,ae,ue){const fe={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},ge=await(0,v.getServiceMachineId)(ie,ae,ue);return(0,o.supportsTelemetry)(V,ie)&&(0,o.getTelemetryLevel)(re)===3&&(fe["X-Market-User-Id"]=ge),fe}e.resolveMarketplaceHeaders=Z}),define(te[92],ne([0,1,2,13,10,46]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends R.Disposable{constructor(S,I,n=""){super();this.prefix=n;const C=S.getLogger(I.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(S.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,I){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,T.validateTelemetryData)(I))}};L=he([Q(0,D.ILoggerService),Q(1,k.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(te[93],ne([0,1,2,26,4,25,138,20,39,42,35,21,46]),function(J,e,R,k,D,T,L,P,S,I,n,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(f,E){this._configurationService=E,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const y=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(f,E){this._experimentProperties[f]=E}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let E=f.sessionID,v=f["common.instanceId"],y=f["common.machineId"],c=f["common.firstSessionDate"],o=f["common.msftInternal"];return{sessionId:E,instanceId:v,machineId:y,firstSessionDate:c,msftInternal:o}}dispose(){this._disposables.dispose()}_log(f,E,v,y){return this.telemetryLevel<E?Promise.resolve(void 0):this._commonProperties.then(c=>{v=(0,k.mixin)(v,c),v=(0,k.mixin)(v,this._experimentProperties),v=(0,k.cloneAndChange)(v,o=>{if(typeof o=="string")return this._cleanupInfo(o,y)}),this._appenders.forEach(o=>o.log(f,v))},c=>{console.error(c)})}publicLog(f,E,v){return this._log(f,3,E,v)}publicLog2(f,E,v){return this.publicLog(f,E,v)}publicLogError(f,E){return this.sendErrorTelemetry?this._log(f,2,E,!0):Promise.resolve(void 0)}publicLogError2(f,E){return this.publicLogError(f,E)}_anonymizeFilePaths(f){let E=f;const v=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(f);if(!s)break;v.push([s.index,t.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(E="";;){const t=c.exec(f);if(!t)break;!y.test(t[0])&&v.every(([s,i])=>t.index<s||t.index>=i)&&(E+=f.substring(o,t.index)+"<REDACTED: user-file-path>",o=c.lastIndex)}return o<f.length&&(E+=f.substr(o)),E}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const E=f.toLowerCase(),v=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(E)?"<REDACTED: secret>":v.test(E)?"<REDACTED: email>":f}_cleanupInfo(f,E){let v=f;E&&(v=this._anonymizeFilePaths(v));for(let y of this._cleanupPatterns)v=v.replace(y,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=he([Q(1,P.IConfigurationService)],b),e.TelemetryService=b;const h=D.isWeb?"":" "+(0,L.localize)(0,null);n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(1,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null)],markdownDescription:I.default.privacyStatementUrl?(0,L.localize)(6,null,I.default.nameLong,I.default.privacyStatementUrl)+h:(0,L.localize)(5,null,I.default.nameLong)+h,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(7,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,L.localize)(9,null,I.default.nameLong,I.default.privacyStatementUrl):(0,L.localize)(8,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(10,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[200],ne([0,1,8,26,46]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const S=await new Promise((n,C)=>{J(["applicationinsights"],n,C)});let I;return S.defaultClient?(I=new S.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(S.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=S.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),I}class L{constructor(S,I,n){this._eventPrefix=S,this._defaultData=I,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(I=>{S(I)},I=>{(0,R.onUnexpectedError)(I),console.error(I)})}}log(S,I){!this._aiClient||(I=(0,k.mixin)(I,this._defaultData),I=(0,D.validateTelemetryData)(I),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:I.properties,measurements:I.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(I=>{I.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=L}),define(te[201],ne([0,1,15,52,20,13,10,21,91,92,93]),function(J,e,R,k,D,T,L,P,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(b,h,p,f){this.configurationService=b,this.telemetryService=h,this.loggerService=p,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(b){if(!this.customTelemetryServices.has(b.id)){const{machineId:h,sessionId:p}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=h,f["common.vscodesessionid"]=p;const E=[b.id,JSON.stringify(f),b.aiKey],y=new k.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new S.TelemetryAppenderClient(y),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${b.id}] `)];this.customTelemetryServices.set(b.id,new n.TelemetryService({appenders:c,sendErrorTelemetry:b.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(b.id)}async publicLog(b,h,p){await(await this.getCustomTelemetryService(b)).publicLog(h,p)}async publicLogError(b,h,p){await(await this.getCustomTelemetryService(b)).publicLogError(h,p)}};C=he([Q(0,D.IConfigurationService),Q(1,P.ITelemetryService),Q(2,L.ILoggerService),Q(3,T.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(te[202],ne([0,1,6,27,3,2,10]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(I,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((n,C)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,n),this._onCreateRequest.fire({requestId:g,...I});const b=new k.CancellationTokenSource;(0,R.timeout)(this._timeout,b.token).then(()=>C(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,T.toDisposable)(()=>b.cancel())])})}acceptReply(I,n){const C=this._pendingRequests.get(I);C?(this._pendingRequests.delete(I),(0,T.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),C(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};P=he([Q(1,L.ILogService)],P),e.RequestStore=P}),define(te[94],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var k;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(k=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var L;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(L=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var S;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var n;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(n=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(f){f.TerminalView="view",f.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(f){f.CwdDetection="cwdDetection"})(g=e.ProcessCapability||(e.ProcessCapability={}));var b;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(b=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}))}),define(te[203],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(te[204],ne([0,1,32,26,9,4,31,18,19]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let g=0;return C&&C.length===4&&(g=parseInt(C[3])),g}e.getWindowsBuildNumber=I;async function n(C,g,b,h=L.env,p=S.Promises.exists){if(D.isAbsolute(C))return await p(C)?C:void 0;if(g===void 0&&(g=L.cwd()),D.dirname(C)!=="."){const y=D.join(g,C);return await p(y)?y:void 0}const E=(0,k.getCaseInsensitive)(h,"PATH");if(b===void 0&&(0,P.isString)(E)&&(b=E.split(D.delimiter)),b===void 0||b.length===0){const y=D.join(g,C);return await p(y)?y:void 0}for(let y of b){let c;if(D.isAbsolute(y)?c=D.join(y,C):c=D.join(g,y,C),await p(c))return c;if(T.isWindows){let o=c+".com";if(await p(o)||(o=c+".exe",await p(o)))return o}}const v=D.join(g,C);return await p(v)?v:void 0}e.findExecutable=n}),define(te[205],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(te[95],ne([0,1,49,3,2,5,35,205]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(f){function E(v){return v&&typeof v=="object"&&typeof v.id=="string"}f.isThemeColor=E})(S=e.ThemeColor||(e.ThemeColor={}));function I(f){return{id:f}}e.themeColorFromId=I;var n;(function(f){function E(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}f.isThemeIcon=E;const v=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function y(s){const i=v.exec(s);if(!i)return;let[,r]=i;return{id:r}}f.fromString=y;function c(s,i){let r=s.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),i&&(r=`${r}~${i}`),{id:r}}f.modify=c;function o(s,i){return s.id===i.id&&s.color?.id===i.color?.id}f.isEqual=o;function t(s,i){return{id:s.id,color:i?I(i):void 0}}f.asThemeIcon=t,f.asClassNameArray=R.CSSIcon.asClassNameArray,f.asClassName=R.CSSIcon.asClassName,f.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function C(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(E);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new g;L.Registry.add(e.Extensions.ThemingContribution,b);function h(f){return b.onColorThemeChange(f)}e.registerThemingParticipant=h;class p extends D.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,v){let y=this.theme.getColor(E);return y&&v&&(y=v(y,this.theme)),y?y.toString():null}}e.Themable=p}),define(te[206],ne([0,1,49,95]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function D(P,S){const I=P.map(n=>({name:n.profileName,description:T(n)}));return S&&I.push(...S.map(n=>({name:n.title,description:L(n)}))),{values:I.map(n=>n.name),markdownDescriptions:I.map(n=>n.description)}}e.createProfileSchemaEnums=D;function T(P){let S=`$(${k.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?S+=`
- args: "${P.args}"`:S+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(S+=`
- overrideName: ${P.overrideName}`),P.color&&(S+=`
- color: ${P.color}`),P.env&&(S+=`
- env: ${JSON.stringify(P.env)}`),S}function L(P){return`$(${k.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(te[207],ne([0,1,49,139,39,35,206]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,k.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},I=(0,k.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,k.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,k.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g={id:"terminal",order:100,title:(0,k.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,k.localize)(19,null)}},{type:"string",markdownDescription:(0,k.localize)(20,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(23,null),type:"string"},id:{description:(0,k.localize)(24,null),type:"string"},title:{description:(0,k.localize)(25,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(27,null),type:"string"},id:{description:(0,k.localize)(28,null),type:"string"},title:{description:(0,k.localize)(29,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(31,null),type:"string"},id:{description:(0,k.localize)(32,null),type:"string"},title:{description:(0,k.localize)(33,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,k.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,k.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,k.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,k.localize)(37,null),type:"boolean",default:!0}}};function b(){T.Registry.as(D.Extensions.Configuration).registerConfiguration(g),p()}e.registerTerminalPlatformConfiguration=b;let h;function p(f,E){const v=T.Registry.as(D.Extensions.Configuration);let y;f&&(y=(0,L.createProfileSchemaEnums)(f?.profiles,E));const c=h;h={id:"terminal",order:100,title:(0,k.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?y?.values:void 0,markdownEnumDescriptions:f?.os===3?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?y?.values:void 0,markdownEnumDescriptions:f?.os===2?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?y?.values:void 0,markdownEnumDescriptions:f?.os===1?y?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[h],remove:c?[c]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(te[208],ne([0,1,37,49,9,4,19,71,204,95]),function(J,e,R,k,D,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function C(t,s,i,r,a=process.env,l,u,d,m){return l=l||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},T.isWindows?g(i,l,a,u,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),m,d):y(l,u,i,t&&typeof t=="object"?{...t}:r.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),m,d,a)}e.detectAvailableProfiles=C;async function g(t,s,i,r,a,l,u,d,m){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let w=!1;(0,S.getWindowsBuildNumber)()>=16299&&(w=!0),await p(d);const U=new Map;t&&(U.set("PowerShell",{source:"PowerShell",icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),U.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:k.Codicon.terminalCmd,isAutoDetected:!0})),c(l,U);const O=await b(U.entries(),u,s,i,r,m);if(t||!t&&a)try{const $=await E(`${_}\\${w?"wsl":"bash"}.exe`,u);for(const K of $)(!l||!(K.profileName in l))&&O.push(K)}catch($){r?.info("WSL is not installed, so could not detect WSL profiles")}return O}async function b(t,s,i,r=process.env,a,l){const u=[];for(const[d,m]of t){if(m===null)continue;let A,_,w;if("source"in m){const $=n?.get(m.source);if(!$)continue;A=$.paths,_=m.args||$.args,m.icon?w=h(m.icon):$.icon&&(w=$.icon)}else A=Array.isArray(m.path)?m.path:[m.path],_=T.isWindows||Array.isArray(m.args)?m.args:void 0,w=h(m.icon)||void 0;const U=await l?.(A)||A.slice(),O=await o(d,s,U,i,r,_,m.env,m.overrideName,m.isAutoDetected,a);O?(O.isAutoDetected=m.isAutoDetected,O.icon=w,O.color=m.color,u.push(O)):a?.trace("profile not validated",d,A)}return u}function h(t){return typeof t=="string"?{id:t}:t}async function p(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await f(),icon:I.ThemeIcon.asThemeIcon(k.Codicon.terminalPowershell)}))}async function f(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function E(t,s){const i=[],r=await new Promise((u,d)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le"},(m,A)=>{if(m)return d("Problem occurred when getting wsl distros");u(A)})});if(!r)return[];const a=new RegExp(/[\r?\n]/),l=r.split(a).filter(u=>u.trim().length>0&&u!=="");for(const u of l){if(u===""||u.startsWith("docker-desktop"))continue;const d=`${u} (WSL)`,m={profileName:d,path:t,args:["-d",`${u}`],isDefault:d===s,icon:v(u)};i.push(m)}return i}function v(t){return t.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(k.Codicon.terminalUbuntu):t.includes("Debian")?I.ThemeIcon.asThemeIcon(k.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(k.Codicon.terminalLinux)}async function y(t,s,i,r,a,l,u,d){const m=new Map;if(i){const A=(await t.readFile("/etc/shells")).toString(),_=l||A.split(`
`).filter(U=>U.trim().indexOf("#")!==0&&U.trim().length>0),w=new Map;for(const U of _){let O=(0,D.basename)(U),$=w.get(O)||0;$++,$>1&&(O=`${O} (${$})`),w.set(O,$),m.set(O,{path:U,isAutoDetected:!0})}}return c(r,m),await b(m.entries(),a,t,d,s,u)}function c(t,s){if(!!t)for(const[i,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?s.delete(i):s.set(i,r)}async function o(t,s,i,r,a,l,u,d,m,A){if(i.length===0)return Promise.resolve(void 0);const _=i.shift();if(_==="")return o(t,s,i,r,a,l,u,d,m);const w={profileName:t,path:_,args:l,env:u,overrideName:d,isAutoDetected:m,isDefault:t===s};if((0,D.basename)(_)===_){const O=a.PATH?a.PATH.split(D.delimiter):void 0;return await(0,S.findExecutable)(_,void 0,O,void 0,r.existsFile)?w:o(t,s,i,r,a,l)}return await r.existsFile((0,D.normalize)(_))?w:o(t,s,i,r,a,l,u,d,m)}}),define(te[209],ne([0,1,3,2,15,4,33,52,20,13,75,165,10,86,21,202,94,207,208]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let c=0,o=class extends k.Disposable{constructor(s,i,r,a,l){super();this._reconnectConstants=s,this._configurationService=i,this._environmentService=r,this._logService=a,this._telemetryService=l,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new R.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new R.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new R.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new R.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new R.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,E.registerTerminalPlatformConfiguration)(),this._shellEnv=T.isWindows?Promise.resolve(process.env):(0,C.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,k.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,n.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?s.debugBrk=i.port:!i.break&&i.port&&(s.debug=i.port));const r=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),L.ProxyChannel.toService(r.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(r.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const l=r.getChannel(f.TerminalIpcChannels.Log);b.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{b.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const u=L.ProxyChannel.toService(r.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(d=>this._onProcessData.fire(d))),this._register(u.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(u.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(u.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(u.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(u.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(u.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(u.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(u.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(u.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(u.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(u.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[r,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,i,r,a,l,u,d,m,A,_,w){const U=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(s,i,r,a,l,u,d,m,A,_,w);return clearTimeout(U),c=Math.max(c,O),O}updateTitle(s,i,r){return this._proxy.updateTitle(s,i,r)}updateIcon(s,i,r){return this._proxy.updateIcon(s,i,r)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,i){return this._proxy.shutdown(s,i)}input(s,i){return this._proxy.input(s,i)}processBinary(s,i){return this._proxy.processBinary(s,i)}resize(s,i,r){return this._proxy.resize(s,i,r)}acknowledgeDataEvent(s,i){return this._proxy.acknowledgeDataEvent(s,i)}setUnicodeVersion(s,i){return this._proxy.setUnicodeVersion(s,i)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,i,r,a=!1){const l=await this._shellEnv;return(0,v.detectAvailableProfiles)(i,r,a,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,i){return this._proxy.requestDetachInstance(s,i)}async acceptDetachInstanceReply(s,i){return this._proxy.acceptDetachInstanceReply(s,i)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,i){return this._proxy.refreshProperty(s,i)}async updateProperty(s,i,r){return this._proxy.updateProperty(s,i,r)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:i})}async acceptPtyHostResolvedVariables(s,i){this._resolveVariablesRequestStore.acceptReply(s,i)}};o=he([Q(1,S.IConfigurationService),Q(2,I.IEnvironmentService),Q(3,g.ILogService),Q(4,h.ITelemetryService)],o),e.PtyHostService=o}),define(te[54],ne([0,1,44]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(L,P,S,I){const n=(0,R.setProperty)(L,P,S,I)[0];return n&&(L=L.substring(0,n.offset)+n.content+L.substring(n.offset+n.length)),L}e.edit=k;function D(L,P,S){let I=S;for(;I>=0;){if(L.charAt(I)===P.charAt(P.length-1)&&P.length===1)return I+1;if(I--,P.length===2&&I>=0&&L.charAt(I)===P.charAt(0))return I+2}return 0}e.getLineStartOffset=D;function T(L,P,S){let I=S;for(;I>=0;)if(L.charAt(I)===P.charAt(P.length-1)&&P.length===1||(I++,P.length===2&&I>=0&&L.charAt(I)===P.charAt(1)))return I;return L.length-1}e.getLineEndOffset=T}),define(te[210],ne([0,1,26,59]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(C,g,b,h,p){const f=[],E=[],v=[];if(!g){const _=C.filter(({identifier:w})=>p.every(U=>U.toLowerCase()!==w.id.toLowerCase()));return{local:{added:f,removed:E,updated:v},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}C=C.map(I),g=g.map(I),b=b?b.map(I):null;const y=new Map,c=_=>{_.uuid&&y.set(_.id.toLowerCase(),_.uuid)};C.forEach(({identifier:_})=>c(_)),g.forEach(({identifier:_})=>c(_)),b&&b.forEach(({identifier:_})=>c(_));const o=_=>{const w=_.identifier.uuid||y.get(_.identifier.id.toLowerCase());return w?`uuid:${w}`:`id:${_.identifier.id.toLowerCase()}`},t=(_,w)=>(_.set(o(w),w),_),s=C.reduce(t,new Map),i=g.reduce(t,new Map),r=g.reduce((_,w)=>{const U=o(w);w=(0,R.deepClone)(w);const O=s.get(U);return O&&(O.installed&&(w.installed=!0),w.version||(w.version=O.version)),t(_,w)},new Map),a=b?b.reduce(t,new Map):null,l=h.reduce(t,new Map),u=p.reduce((_,w)=>{const U=y.get(w.toLowerCase());return _.add(U?`uuid:${U}`:`id:${w.toLowerCase()}`)},new Set),d=T(s,i,u);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const _=T(a,s,u),w=T(a,i,u),U=(O,$)=>{const K=s.get(O);if(K){const M=i.get(O);return{...$?M:K,version:(M.version&&k.gt(M.version,K.version),K.version),state:L(K,M,a?.get(O))}}};for(const O of w.removed.values()){const $=s.get(O);$&&E.push($.identifier)}for(const O of w.added.values())if(_.added.has(O)){if(d.updated.has(O)){const $=U(O,!0);$&&(v.push(n($,O)),r.set(O,$))}}else{const $=i.get(O);$.installed&&f.push(n($,O))}for(const O of w.updated.values()){const $=U(O,!0);$&&(v.push(n($,O)),r.set(O,$))}for(const O of _.added.values())w.added.has(O)||r.set(O,s.get(O));for(const O of _.updated.values())if(!w.removed.has(O)&&!w.updated.has(O)){const $=U(O,!1);$&&(r.get(O)?.installed&&($.installed=!0),r.set(O,$))}for(const O of _.removed.values())!l.has(O)&&!w.updated.has(O)&&a?.get(O)?.installed&&r.delete(O)}const m=[],A=T(i,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&r.forEach((_,w)=>m.push(n(_,w))),{local:{added:f,removed:E,updated:v},remote:m.length?{added:[...A.added].map(_=>r.get(_)),updated:[...A.updated].map(_=>r.get(_)),removed:[...A.removed].map(_=>i.get(_)),all:m}:null}}e.merge=D;function T(C,g,b,{checkInstalledProperty:h,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const f=C?[...C.keys()].filter(o=>!b.has(o)):[],E=[...g.keys()].filter(o=>!b.has(o)),v=E.filter(o=>f.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),y=f.filter(o=>E.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),c=new Set;for(const o of f){if(y.has(o))continue;const t=C.get(o),s=g.get(o);(!s||t.disabled!==s.disabled||!S(t.state,s.state)||p&&t.version!==s.version||h&&t.installed!==s.installed)&&c.add(o)}return{added:v,removed:y,updated:c}}function L(C,g,b){const h=C.state,p=g.state,f=b?.state;if(!g.version||h&&k.gt(C.version,g.version))return h;if(p&&k.gt(g.version,C.version)||!h)return p;if(!p)return h;const E=(0,R.deepClone)(h),v=f?P(f,p):{added:Object.keys(p).reduce((c,o)=>(c.add(o),c),new Set),removed:new Set,updated:new Set},y=f?P(f,h):{added:Object.keys(h).reduce((c,o)=>(c.add(o),c),new Set),removed:new Set,updated:new Set};for(const c of[...v.added.values(),...v.updated.values()])E[c]=p[c];for(const c of v.removed.values())y.updated.has(c)||delete E[c];return E}function P(C,g){const b=Object.keys(C),h=Object.keys(g),p=h.filter(v=>b.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),f=b.filter(v=>h.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),E=new Set;for(const v of b){if(f.has(v))continue;const y=C[v],c=g[v];(0,R.equals)(y,c)||E.add(v)}return{added:p,removed:f,updated:E}}function S(C={},g={}){const{added:b,removed:h,updated:p}=P(C,g);return b.size===0&&h.size===0&&p.size===0}function I(C){return{...C,disabled:!!C.disabled,installed:!!C.installed}}function n(C,g){const b={identifier:{id:C.identifier.id,uuid:g.startsWith("uuid:")?g.substring("uuid:".length):void 0}};return C.version&&(b.version=C.version),C.disabled&&(b.disabled=!0),C.installed&&(b.installed=!0),C.state&&(b.state=C.state),b}}),define(te[96],ne([0,1,17,3,2,34,5,29,23]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,L.createDecorator)("IExtensionsStorageSyncService");const I=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class tt extends D.Disposable{constructor(g,b){super();this.storageService=g,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(g){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const b=I.exec(g);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const g=this.storageService.keys(0,1);for(const b of g){const h=tt.fromKey(b);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=tt.fromKey(g.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,b){this.storageService.store(tt.toKey(g),JSON.stringify(b),0,1)}getKeysForSync(g){const b=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],h=this.storageService.get(tt.toKey(g),0),p=h?JSON.parse(h):void 0;return p&&b?(0,R.distinct)([...p,...b]):p||b}};n=he([Q(0,S.IStorageService),Q(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(te[97],ne([0,1,17,20,5]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,S){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return I=I.filter(n=>n!==P&&n!==`-${P}`),S&&I.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}updateSynchronizedExtensions(P,S){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return I=I.filter(n=>n!==P&&n!==`-${P}`),S&&I.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}getIgnoredExtensions(P){const S=P.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),n=[],C=[];if(Array.isArray(I))for(const g of I)g.startsWith("-")?C.push(g.substring(1)):n.push(g);return(0,R.distinct)([...S,...n].filter(g=>C.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};T=he([Q(0,k.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[211],ne([0,1,17,36,26,159,54]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(c){return(0,k.parse)(c)||[]}e.parseKeybindings=P;async function S(c,o,t,s,i){const r=P(c),a=P(o),l=t?P(t):null,u=[...r,...a,...l||[]].map(H=>H.key),d=await i.resolveUserBindings(u);let m=n(r,a,l,d);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const A=g(r),_=g(a),w=l?g(l):null,U=h(A,_,d),O=w?h(w,A,d):{added:[...A.keys()].reduce((H,j)=>(H.add(j),H),new Set),removed:new Set,updated:new Set},$=w?h(w,_,d):{added:[..._.keys()].reduce((H,j)=>(H.add(j),H),new Set),removed:new Set,updated:new Set},K=I(U,O,$);let M=c;for(const H of K.removed.values())K.conflicts.has(H)||(M=v(M,H,s));for(const H of K.added.values()){if(K.conflicts.has(H))continue;const j=_.get(H);if(j.some(z=>z.command!==`-${H}`&&m.conflicts.has(d[z.key]))){K.conflicts.add(H);continue}M=E(M,j,s)}for(const H of K.updated.values()){if(K.conflicts.has(H))continue;const j=_.get(H);if(j.some(z=>z.command!==`-${H}`&&m.conflicts.has(d[z.key]))){K.conflicts.add(H);continue}M=y(M,H,j,s)}return{mergeContent:M,hasChanges:!0,hasConflicts:K.conflicts.size>0}}e.merge=S;function I(c,o,t){const s=new Set,i=new Set,r=new Set,a=new Set;for(const l of o.removed.values())t.updated.has(l)&&a.add(l);for(const l of t.removed.values())a.has(l)||(o.updated.has(l)?a.add(l):i.add(l));for(const l of o.added.values())a.has(l)||t.added.has(l)&&c.updated.has(l)&&a.add(l);for(const l of t.added.values())a.has(l)||(o.added.has(l)?c.updated.has(l)&&a.add(l):s.add(l));for(const l of o.updated.values())a.has(l)||t.updated.has(l)&&c.updated.has(l)&&a.add(l);for(const l of t.updated.values())a.has(l)||(o.updated.has(l)?c.updated.has(l)&&a.add(l):r.add(l));return{added:s,removed:i,updated:r,conflicts:a}}function n(c,o,t,s){const i=new Set,r=C(c,s),a=C(o,s),l=t?C(t,s):null,u=b(r,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const d=l?b(l,r):{added:[...r.keys()].reduce((O,$)=>(O.add($),O),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const m=l?b(l,a):{added:[...a.keys()].reduce((O,$)=>(O.add($),O),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:A,removed:_,updated:w,conflicts:U}=I(u,d,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:_,updated:w,conflicts:U}}function C(c,o){const t=new Map;for(const s of c){const i=o[s.key];let r=t.get(i);r||(r=[],t.set(i,r)),r.push(s)}return t}function g(c){const o=new Map;for(const t of c){const s=t.command[0]==="-"?t.command.substring(1):t.command;let i=o.get(s);i||(i=[],o.set(s,i)),i.push(t)}return o}function b(c,o){const t=[...c.keys()],s=[...o.keys()],i=s.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),r=t.filter(l=>s.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),a=new Set;for(const l of t){if(r.has(l))continue;const u=c.get(l).map(m=>({...m,key:l})),d=o.get(l).map(m=>({...m,key:l}));(0,R.equals)(u,d,(m,A)=>f(m,A))||a.add(l)}return{added:i,removed:r,updated:a}}function h(c,o,t){const s=[...c.keys()],i=[...o.keys()],r=i.filter(u=>s.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),a=s.filter(u=>i.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),l=new Set;for(const u of s){if(a.has(u))continue;const d=c.get(u).map(A=>({...A,key:t[A.key]})),m=o.get(u).map(A=>({...A,key:t[A.key]}));p(d,m)||l.add(u)}return{added:r,removed:a,updated:l}}function p(c,o){return!(!(0,R.equals)(c.filter(({command:t})=>t[0]!=="-"),o.filter(({command:t})=>t[0]!=="-"),(t,s)=>f(t,s))||!(0,R.equals)(c.filter(({command:t})=>t[0]==="-"),o.filter(({command:t})=>t[0]==="-"),(t,s)=>f(t,s)))}function f(c,o){if(c.command!==o.command||c.key!==o.key)return!1;const t=T.ContextKeyExpr.deserialize(c.when),s=T.ContextKeyExpr.deserialize(o.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!D.equals(c.args,o.args))}function E(c,o,t){for(const s of o)c=L.edit(c,[-1],s,t);return c}function v(c,o,t){const s=P(c);for(let i=s.length-1;i>=0;i--)(s[i].command===o||s[i].command===`-${o}`)&&(c=L.edit(c,[i],void 0,t));return c}function y(c,o,t,s){const i=P(c),r=i.findIndex(a=>a.command===o||a.command===`-${o}`);for(let a=i.length-1;a>=0;a--)(i[a].command===o||i[a].command===`-${o}`)&&(c=L.edit(c,[a],void 0,s));for(let a=t.length-1;a>=0;a--)c=L.edit(c,[r],t[a],s);return c}}),define(te[212],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,L,P){const S={},I={},n=new Set;if(!L)return{local:{added:S,updated:I,removed:[...n.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=k(T,L);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:S,updated:I,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=k(P,T),b=k(P,L),h={},p={},f=new Set,E=new Set;for(const v of g.removed.values())b.updated.has(v)?S[v]=L[v]:f.add(v);for(const v of b.removed.values())E.has(v)||(g.updated.has(v)?E.add(v):n.add(v));for(const v of g.updated.values())E.has(v)||(b.updated.has(v)?C.updated.has(v)&&E.add(v):p[v]=T[v]);for(const v of b.updated.values())E.has(v)||(g.updated.has(v)?C.updated.has(v)&&E.add(v):T[v]!==void 0&&(I[v]=L[v]));for(const v of g.added.values())E.has(v)||(b.added.has(v)?C.updated.has(v)&&E.add(v):h[v]=T[v]);for(const v of b.added.values())E.has(v)||(g.added.has(v)?C.updated.has(v)&&E.add(v):S[v]=L[v]);return{local:{added:S,removed:[...n.values()],updated:I},remote:{added:h,removed:[...f.values()],updated:p},conflicts:[...E.values()]}}e.merge=R;function k(T,L){const P=T?Object.keys(T):[],S=L?Object.keys(L):[],I=S.filter(g=>P.indexOf(g)===-1).reduce((g,b)=>(g.add(b),g),new Set),n=P.filter(g=>S.indexOf(g)===-1).reduce((g,b)=>(g.add(b),g),new Set),C=new Set;for(const g of P){if(n.has(g))continue;const b=T[g],h=L[g];b!==h&&C.add(g)}return{added:I,removed:n,updated:C}}function D(T,L){const{added:P,removed:S,updated:I}=k(T,L);return P.size===0&&S.size===0&&I.size===0}e.areSame=D}),define(te[24],ne([0,1,17,16,18,144,39,28,5,88,35]),function(J,e,R,k,D,T,L,P,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const l=n.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(u=>!!l[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function g(){const l=n.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(l).filter(A=>!!l[A].ignoreSync),d=Object.keys(l).filter(A=>l[A].scope===2||l[A].scope===6),m=C();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...m])}e.getDefaultIgnoredSettings=g,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function b(){const l="vscode://schemas/ignoredSettings",u=n.Registry.as(L.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=n.Registry.as(I.Extensions.JSONContribution),m=()=>{const A=C(),_=g().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),w=Object.keys(L.allSettings.properties).filter($=>_.indexOf($)===-1),U=_.filter($=>A.indexOf($)===-1),O={items:{type:"string",enum:[...w,...U.map($=>`-${$}`)]}};d.registerSchema(l,O)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=b;function h(l){return l&&(0,D.isObject)(l)&&(0,D.isString)(l.id)&&(0,D.isArray)(l.scopes)}e.isAuthenticationProvider=h;var p;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(l,u,d){return d.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(l){const u={};return u[e.HEADER_EXECUTION_ID]=l,u}e.createSyncHeaders=E;var v;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(u,d,m,A){super(u);this.code=d,this.resource=m,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class c extends y{constructor(u,d,m,A,_){super(u,m,void 0,_);this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=c;class o extends y{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=o,function(l){function u(d){if(d instanceof l)return d;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(m&&m[1]){const A=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new l(d.message,m[1],A,_)}return new l(d.message,"Unknown")}l.toUserDataSyncError=u}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var i;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(l){return`sync.enable.${l}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(l,u){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,k.isEqualOrParent)(l,(0,k.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[47],ne([0,1,17,6,22,27,3,36,2,16,25,18,7,140,20,13,14,45,23,21,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=o;let t=class extends S.Disposable{constructor(l,u,d,m,A,_,w,U,O,$){super();this.resource=l,this.fileService=u,this.environmentService=d,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=w,this.telemetryService=U,this.logService=O,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new k.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,n.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?I.extUri:I.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,E.getServiceMachineId)(d,u,m)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,this.getUserDataSyncConfiguration(),T.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const u=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,u={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),u)}async preview(l,u,d={}){return this._sync(l,!1,u,d)}async apply(l,u={}){try{this.syncHeaders={...u};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,u,d,m){try{if(this.syncHeaders={...m},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const _=await this.getLastSyncUserData(),w=await this.getLatestRemoteUserData(l,_);return A=await this.performSync(w,_,u,d),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(l){const u=await this.resolveContent(l);if(!u)return!1;const d=this.parseSyncData(u);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const m=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,m),_=await this.isRemoteDataFromCurrentMachine(A),w=await this.generateSyncPreview({ref:A.ref,syncData:d},m,_,this.getUserDataSyncConfiguration(),T.CancellationToken.None),U=[];for(const O of w){const $=await this.getAcceptResult(O,O.remoteResource,void 0,T.CancellationToken.None),{remoteChange:K}=await this.getAcceptResult(O,O.previewResource,O.remoteContent,T.CancellationToken.None);U.push([O,{...$,remoteChange:K!==0?K:2}])}await this.applyResult(A,m,U,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const u=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===u}async getLatestRemoteUserData(l,u){if(u){const d=l&&l.latest?l.latest[this.resource]:void 0;if(u.ref===d||d===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(l,u,d,m){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,u,d,m)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,u,d,m);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(l,u,d,m)}throw A}}async doSync(l,u,d,m){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,k.createCancelablePromise)(_=>this.doGenerateSyncResourcePreview(l,u,d,m,_)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(d?.content||""));const m=d&&!d.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=m,u.mergeState=d.hasConflicts?"conflict":m?"accepted":"preview",u.localChange=m?m.localChange:d.localChange,u.remoteChange=m?m.remoteChange:d.remoteChange,u}),this.syncPreviewPromise}async accept(l,u){return await this.updateSyncResourcePreview(l,async d=>{const m=await this.getAcceptResult(d,l,u,T.CancellationToken.None);return d.acceptResult=m,d.mergeState="accepted",d.localChange=m.localChange,d.remoteChange=m.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(d.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=d.localChange,u.remoteChange=d.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(l,u){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const m=d.resourcePreviews.findIndex(({localResource:A,remoteResource:_,previewResource:w})=>this.extUri.isEqual(A,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(w,l));m!==-1&&(this.syncPreviewPromise=(0,k.createCancelablePromise)(async A=>{const _=[...d.resourcePreviews];return _[m]=await u(_[m]),{...d,resourcePreviews:_}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const u=l.filter(({mergeState:d})=>d==="conflict");(0,R.equals)(this._conflicts,u,(d,m)=>this.extUri.isEqual(d.previewResource,m.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return g.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return g.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(l){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const d of u.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,u,d,m,A){const _=await this.isRemoteDataFromCurrentMachine(l),w=await this.generateSyncPreview(l,u,_,m,A),U=[];for(const O of w){const $=O.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(O.localChange===0&&O.remoteChange===0)U.push({...O,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const K=d?await this.getMergeResult(O,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(O.previewResource,D.VSBuffer.fromString(K?.content||""));const M=K&&!K.hasConflicts?await this.getAcceptResult(O,O.previewResource,void 0,A):void 0;U.push({...O,acceptResult:M,mergeState:K?.hasConflicts?"conflict":M?"accepted":"preview",localChange:M?M.localChange:K?K.localChange:O.localChange,remoteChange:M?M.remoteChange:K?K.remoteChange:O.remoteChange})}}return{remoteUserData:l,lastSyncUserData:u,resourcePreviews:U,isLastSyncFromCurrentMachine:_}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&d&&u.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const m=u;if(m.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(m.content);if(o(A))return{...u,syncData:A,content:void 0}}catch(l){l instanceof f.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),m={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(m)))}async getRemoteUserData(l){const{ref:u,content:d}=await this.getUserData(l);let m=null;return d!==null&&(m=this.parseSyncData(d)),{ref:u,syncData:m}}parseSyncData(l){try{const u=JSON.parse(l);if(o(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,C.isString)(l)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:u}}else{const u=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(l,u){const d=await this.currentMachineIdPromise,m={version:this.version,machineId:d,content:l};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(m),u,this.syncHeaders),{ref:u,syncData:m}}async backupLocal(l){const u={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=he([Q(1,f.IFileService),Q(2,p.IEnvironmentService),Q(3,v.IStorageService),Q(4,c.IUserDataSyncStoreService),Q(5,c.IUserDataSyncBackupStoreService),Q(6,c.IUserDataSyncResourceEnablementService),Q(7,y.ITelemetryService),Q(8,c.IUserDataSyncLogService),Q(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,u,d,m,A,_,w,U,O,$,K){super(u,d,m,A,_,w,U,O,$,K);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,u,d){try{u?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(l),d?void 0:u):await this.fileService.createFile(this.file,D.VSBuffer.fromString(l),{overwrite:d})}catch(m){throw m instanceof f.FileOperationError&&m.fileOperationResult===1||m instanceof f.FileOperationError&&m.fileOperationResult===3?new c.UserDataSyncError(m.message,"LocalPreconditionFailed"):m}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=he([Q(2,f.IFileService),Q(3,p.IEnvironmentService),Q(4,v.IStorageService),Q(5,c.IUserDataSyncStoreService),Q(6,c.IUserDataSyncBackupStoreService),Q(7,c.IUserDataSyncResourceEnablementService),Q(8,y.ITelemetryService),Q(9,c.IUserDataSyncLogService),Q(10,h.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let i=class extends s{constructor(l,u,d,m,A,_,w,U,O,$,K,M){super(l,u,d,m,A,_,w,U,O,$,M);this.userDataSyncUtilService=K,this._formattingOptions=void 0}hasErrors(l){const u=[];return(0,P.parse)(l,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=he([Q(2,f.IFileService),Q(3,p.IEnvironmentService),Q(4,v.IStorageService),Q(5,c.IUserDataSyncStoreService),Q(6,c.IUserDataSyncBackupStoreService),Q(7,c.IUserDataSyncResourceEnablementService),Q(8,y.ITelemetryService),Q(9,c.IUserDataSyncLogService),Q(10,c.IUserDataSyncUtilService),Q(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let r=class{constructor(l,u,d,m){this.resource=l,this.environmentService=u,this.logService=d,this.fileService=m,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?I.extUri:I.extUriIgnorePathCase,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,I.extUri)}async initialize({ref:l,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(u);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(A){this.logService.error(A)}}parseSyncData(l){try{const u=JSON.parse(l);if(o(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,u={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(d)))}};r=he([Q(1,p.IEnvironmentService),Q(2,c.IUserDataSyncLogService),Q(3,f.IFileService)],r),e.AbstractInitializer=r}),define(te[213],ne([0,1,6,27,8,3,44,48,25,7,20,13,28,34,14,23,21,47,210,96,97,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,u){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const m=(await u.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)l.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),l.version===2&&m.every(_=>!(0,b.areSameExtensions)(_.identifier,A.identifier))&&(A.installed=!0)}return d}function s(l,u,d){const m=d.get((0,b.getExtensionId)(l,u),0)||"{}";return JSON.parse(m)}e.getExtensionStorageState=s;function i(l,u,d,m){m.store((0,b.getExtensionId)(l,u),JSON.stringify(d),0,1)}e.storeExtensionStorageState=i;let r=class ft extends E.AbstractSynchroniser{constructor(u,d,m,A,_,w,U,O,$,K,M,H,j,z){super("extensions",d,u,m,A,_,H,j,$,M);this.storageService=m,this.extensionManagementService=w,this.extensionEnablementService=U,this.ignoredExtensionsManagementService=O,this.extensionGalleryService=K,this.extensionsStorageSyncService=z,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:F})=>!!F)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,d){const m=u.syncData?await t(u.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],_=d?.syncData?await t(d.syncData,this.extensionManagementService):null,w=await this.extensionManagementService.getInstalled(),U=this.getLocalExtensions(w),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(w);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:K}=(0,v.merge)(U,m,_,A,O),M={local:$,remote:K,content:this.getPreviewContent(U,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:K!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(U),localExtensions:U,remoteResource:this.remoteResource,remoteContent:m?this.format(m):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,d,m,A){const _=[...d,...m],w=new Set,U=O=>{w.add(O.id.toLowerCase()),O.uuid&&w.add(O.uuid)};_.forEach(({identifier:O})=>U(O)),A.forEach(U);for(const O of u)w.has(O.identifier.id.toLowerCase())||O.identifier.uuid&&w.has(O.identifier.uuid)||_.push(O);return this.format(_)}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,m,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,v.merge)(u.localExtensions,null,null,u.skippedExtensions,m),{local:_,remote:w}=A;return{content:u.localContent,local:_,remote:w,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:w!==null?2:0}}async acceptRemote(u){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=u.remoteContent?JSON.parse(u.remoteContent):null;if(A!==null){const _=(0,v.merge)(u.localExtensions,A,u.localExtensions,[],m),{local:w,remote:U}=_;return{content:u.remoteContent,local:w,remote:U,localChange:w.added.length>0||w.removed.length>0||w.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,m,A){let{skippedExtensions:_,localExtensions:w}=m[0][0],{local:U,remote:O,localChange:$,remoteChange:K}=m[0][1];if($===0&&K===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(w)),_=await this.updateLocalExtensions(U.added,U.removed,U.updated,_)),O){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(O.all);u=await this.updateRemoteUserData(M,A?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${O.added.length?` Added: ${JSON.stringify(O.added.map(H=>H.identifier.id))}.`:""}${O.updated.length?` Updated: ${JSON.stringify(O.updated.map(H=>H.identifier.id))}.`:""}${O.removed.length?` Removed: ${JSON.stringify(O.removed.map(H=>H.identifier.id))}.`:""}`)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ft.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ft.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),_=this.getLocalExtensions(m).filter(w=>!A.some(U=>(0,b.areSameExtensions)({id:U},w.identifier)));return this.format(_)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let d=await super.resolveContent(u);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(u)),d){const m=this.parseSyncData(d);if(m)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(m))}}return null}format(u){u.sort((A,_)=>!A.identifier.uuid&&_.identifier.uuid?-1:A.identifier.uuid&&!_.identifier.uuid?1:(0,S.compare)(A.identifier.id,_.identifier.id));const d=JSON.stringify(u),m=(0,P.format)(d,void 0,{});return(0,L.applyEdits)(d,m)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(m=>m.installed||m.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,d,m,A){const _=[],w=[],U=await this.extensionManagementService.getInstalled();if(d.length){const $=U.filter(({identifier:K,isBuiltin:M})=>!M&&d.some(H=>(0,b.areSameExtensions)(K,H)));await R.Promises.settled($.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),_.push(K.identifier)}))}(u.length||m.length)&&await R.Promises.settled([...u,...m].map(async $=>{const K=U.find(H=>(0,b.areSameExtensions)(H.identifier,$.identifier));if(K&&K.isBuiltin){$.state&&K.manifest.version===$.version&&this.updateExtensionState($.state,K.manifest.publisher,K.manifest.name,K.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),_.push($.identifier);return}const M=(await this.extensionGalleryService.getExtensions([$.identifier],k.CancellationToken.None))[0];if($.state&&(K?K.manifest.version===$.version:!!M)){const H=K?K.manifest.publisher:M.publisher,j=K?K.manifest.name:M.name;this.updateExtensionState($.state,H,j,K?.manifest.version)}if(M)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,M.version)),K||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,M.version),_.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),w.push($)))}catch(H){w.push($),H instanceof g.ExtensionManagementError&&H.code===g.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(H),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else w.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const O=[];for(const $ of A)_.some(K=>(0,b.areSameExtensions)(K,$.identifier))||O.push($);for(const $ of w)O.some(K=>(0,b.areSameExtensions)(K.identifier,$.identifier))||O.push($);return O}updateExtensionState(u,d,m,A){const _=s(d,m,this.storageService),w=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,b.getGalleryExtensionId)(d,m),version:A}):void 0;w?w.forEach(U=>{_[U]=u[U]}):Object.keys(u).forEach(U=>_[U]=u[U]),i(d,m,_,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const d=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:m,isBuiltin:A,manifest:_})=>{const w={identifier:m,version:_.version};d.some(U=>(0,b.areSameExtensions)(U,m))&&(w.disabled=!0),A||(w.installed=!0);try{const U=this.extensionsStorageSyncService.getKeysForSync({id:m.id,version:_.version});if(U){const O=s(_.publisher,_.name,this.storageService);w.state=Object.keys(O).reduce(($,K)=>(U.includes(K)&&($[K]=O[K]),$),{})}}catch(U){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(U))}return w})}};r.EXTENSIONS_DATA_URI=I.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=he([Q(0,C.IEnvironmentService),Q(1,h.IFileService),Q(2,p.IStorageService),Q(3,o.IUserDataSyncStoreService),Q(4,o.IUserDataSyncBackupStoreService),Q(5,g.IExtensionManagementService),Q(6,g.IGlobalExtensionEnablementService),Q(7,c.IIgnoredExtensionsManagementService),Q(8,o.IUserDataSyncLogService),Q(9,g.IExtensionGalleryService),Q(10,n.IConfigurationService),Q(11,o.IUserDataSyncResourceEnablementService),Q(12,f.ITelemetryService),Q(13,y.IExtensionsStorageSyncService)],r),e.ExtensionsSynchroniser=r;let a=class extends E.AbstractInitializer{constructor(u,d,m,A,_){super("extensions",A,_,m);this.extensionManagementService=u,this.ignoredExtensionsManagementService=d}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,d){const m=[],A=[],_=[];for(const w of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(w.identifier.id))continue;const U=d.find(O=>(0,b.areSameExtensions)(O.identifier,w.identifier));U?(m.push(U),w.disabled&&_.push(w.identifier)):w.installed&&(A.push(w.identifier),w.disabled&&_.push(w.identifier))}return{installedExtensions:m,newExtensions:A,disabledExtensions:_,remoteExtensions:u}}};a=he([Q(0,g.IExtensionManagementService),Q(1,c.IIgnoredExtensionsManagementService),Q(2,h.IFileService),Q(3,C.IEnvironmentService),Q(4,o.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(te[214],ne([0,1,26,24]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,S,I,n,C){if(!S)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const g=T(P,S);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=I?T(I,S):{added:Object.keys(S).reduce((v,y)=>(v.add(y),v),new Set),removed:new Set,updated:new Set},h=I?T(I,P):{added:Object.keys(P).reduce((v,y)=>(v.add(y),v),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},f=R.deepClone(S),E=!I;for(const v of h.added.values())v!==k.SYNC_SERVICE_URL_TYPE&&E&&b.added.has(v)||(f[v]=P[v]);for(const v of h.updated.values())f[v]=P[v];for(const v of h.removed.values())n.unregistered.includes(v)||delete f[v];for(const v of b.added.values()){const y=S[v];if(n.machine.includes(v)){C.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(I&&h.added.has(v))continue;const c=P[v];c&&c.value===y.value||v===k.SYNC_SERVICE_URL_TYPE&&E&&h.added.has(v)||(c?p.updated[v]=y:p.added[v]=y)}for(const v of b.updated.values()){const y=S[v];if(n.machine.includes(v)){C.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(v)||h.removed.has(v))continue;const c=P[v];c&&c.value===y.value||(p.updated[v]=y)}for(const v of b.removed.values()){if(n.machine.includes(v)){C.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}h.updated.has(v)||h.removed.has(v)||p.removed.push(v)}return{local:p,remote:L(f,S)?null:f}}e.merge=D;function T(P,S){const I=Object.keys(P),n=Object.keys(S),C=n.filter(h=>I.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),g=I.filter(h=>n.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),b=new Set;for(const h of I){if(g.has(h))continue;const p=P[h],f=S[h];R.equals(p,f)||b.add(h)}return{added:C,removed:g,updated:b}}function L(P,S){const{added:I,removed:n,updated:C}=T(P,S);return I.size===0&&n.size===0&&C.size===0}}),define(te[215],ne([0,1,22,3,36,44,48,4,7,30,20,13,14,10,45,23,21,47,54,214,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",t=["locale"];function s(u){const d=u.storage?Object.keys(u.storage).sort():[],m={};d.forEach(w=>m[w]=u.storage[w]),u.storage=m;const A=JSON.stringify(u),_=(0,L.format)(A,void 0,{});return(0,T.applyEdits)(A,_)}const i=1;let r=class dt extends E.AbstractSynchroniser{constructor(d,m,A,_,w,U,O,$,K){super("globalState",d,w,K,m,A,U,O,_,$);this.storageService=K,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(d.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),k.Event.filter(K.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:K.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,m,A){const _=d.syncData?JSON.parse(d.syncData.content):null;m=m===null&&A?d:m;const w=m&&m.syncData?JSON.parse(m.syncData.content):null,U=await this.getLocalGlobalState();_?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const O=this.getStorageKeys(w),{local:$,remote:K}=(0,y.merge)(U.storage,_?_.storage:null,w?w.storage:null,O,this.logService),M={content:null,local:$,remote:K,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:K!==null?2:0};return[{localResource:this.localResource,localContent:s(U),localUserData:U,remoteResource:this.remoteResource,remoteContent:_?s(_):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource,storageKeys:O}]}async getMergeResult(d,m){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,m,A,_){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(m,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const m=JSON.parse(d.remoteContent),{local:A,remote:_}=(0,y.merge)(d.localUserData.storage,m.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:A,remote:_,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,m,A,_){let{localUserData:w}=A[0][0],{local:U,remote:O,localChange:$,remoteChange:K}=A[0][1];if($===0&&K===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(w)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),K!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:O});d=await this.updateRemoteUserData(M,_?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}m?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:dt.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,dt.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return s(A)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let m=await super.resolveContent(d);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(d)),m){const A=this.parseSyncData(m);if(A)switch(this.extUri.basename(d)){case"globalState.json":return s(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${o}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},m=await this.getLocalArgvContent(),A=(0,D.parse)(m);for(const _ of t)A[_]!==void 0&&(d[`${o}${_}`]={version:1,value:A[_]});for(const _ of this.storageService.keys(0,0)){const w=this.storageService.get(_,0);w&&(d[_]={version:1,value:w})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:m,updated:A}){const _={},w={},U=($,K)=>{for(const M of $){if(M.startsWith(o)){_[M.substring(o.length)]=K?K[M].value:void 0;continue}if(K){const H=K[M];H.value!==String(this.storageService.get(M,0))&&(w[M]=H.value)}else this.storageService.get(M,0)!==void 0&&(w[M]=void 0)}};if(U(Object.keys(d),d),U(Object.keys(A),A),U(m),Object.keys(_).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(_),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(w).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(w))this.storageService.store($,w[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(w))}}async updateArgv(d){const m=await this.getLocalArgvContent();let A=m;for(const _ of Object.keys(d))A=(0,v.edit)(A,[_],d[_],{});m!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const m=this.storageService.keys(0,0),A=this.storageService.keys(0,1),_=[...m,...A],w=d?.storage?Object.keys(d.storage).filter(U=>!U.startsWith(o)&&!_.includes(U)&&this.storageService.get(U,0)!==void 0):[];if(!P.isWeb){const U=[...c.ALL_SYNC_RESOURCES.map(O=>(0,c.getEnablementKey)(O)),c.SYNC_SERVICE_URL_TYPE];w.push(...U),A.push(...U)}return{user:m,machine:A,unregistered:w}}};r.GLOBAL_STATE_DATA_URI=S.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),r=he([Q(0,g.IFileService),Q(1,c.IUserDataSyncStoreService),Q(2,c.IUserDataSyncBackupStoreService),Q(3,c.IUserDataSyncLogService),Q(4,C.IEnvironmentService),Q(5,c.IUserDataSyncResourceEnablementService),Q(6,f.ITelemetryService),Q(7,n.IConfigurationService),Q(8,p.IStorageService)],r),e.GlobalStateSynchroniser=r;let a=class extends E.AbstractInitializer{constructor(d,m,A,_){super("globalState",A,_,m);this.storageService=d}async doInitialize(d){const m=d.syncData?JSON.parse(d.syncData.content):null;if(!m){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},_={};for(const w of Object.keys(m.storage))w.startsWith(o)?A[w.substring(o.length)]=m.storage[w].value:this.storageService.get(w,0)===void 0&&(_[w]=m.storage[w].value);if(Object.keys(A).length){let w="{}";try{w=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(U){}for(const U of Object.keys(A))w=(0,v.edit)(w,[U],A[U],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(w))}if(Object.keys(_).length)for(const w of Object.keys(_))this.storageService.store(w,_[w],0,0)}};a=he([Q(0,p.IStorageService),Q(1,g.IFileService),Q(2,C.IEnvironmentService),Q(3,c.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let l=class{constructor(d,m,A,_,w){this.userDataSyncStoreClient=d,this.storageService=m,this.environmentService=A,this.fileService=_,this.logService=w}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const m=(0,c.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(d,m)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,m)}throw A}}async doSync(d,m){const A=await this.userDataSyncStoreClient.read("globalState",null,m),_=this.parseGlobalState(A)||{storage:{}};_.storage[c.SYNC_SERVICE_URL_TYPE]={value:d,version:i};const w=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:i,machineId:w,content:s(_)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(U),A.ref,m)}parseGlobalState({content:d}){if(!d)return null;const m=JSON.parse(d);if((0,E.isSyncData)(m))return m?JSON.parse(m.content):null;throw new Error("Invalid remote data")}};l=he([Q(1,p.IStorageService),Q(2,C.IEnvironmentService),Q(3,g.IFileService),Q(4,b.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(te[216],ne([0,1,17,22,3,36,4,18,141,20,13,14,23,21,47,211,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(c,o,t){try{const s=JSON.parse(c);if(!o)return(0,P.isUndefined)(s.all)?null:s.all;switch(L.OS){case 2:return(0,P.isUndefined)(s.mac)?null:s.mac;case 3:return(0,P.isUndefined)(s.linux)?null:s.linux;case 1:return(0,P.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=E;let v=class extends h.AbstractJsonFileSynchroniser{constructor(o,t,s,i,r,a,l,u,d,m){super(l.keybindingsResource,"keybindings",a,l,u,o,t,r,m,s,d,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,s,i){const r=o.syncData?E(o.syncData.content,i.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?o:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),u=await this.getFormattingOptions();let d=null,m=!1,A=!1,_=!1;if(r){let U=l?l.value.toString():"[]";if(U=U||"[]",this.hasErrors(U))throw new f.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const O=await(0,p.merge)(U,r,a,u,this.userDataSyncUtilService);O.hasChanges&&(d=O.mergeContent,_=O.hasConflicts,m=_||O.mergeContent!==U,A=_||O.mergeContent!==r)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),A=!0);const w={content:d,localChange:m?l?2:1:0,remoteChange:A?2:0,hasConflicts:_};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:w.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:w.remoteChange,previewResource:this.previewResource,previewResult:w,acceptedResource:this.acceptedResource}]}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,s,i){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,s,i){const{fileContent:r}=s[0][0];let{content:a,localChange:l,remoteChange:u}=s[0][1];if(l===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new f.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(d,i?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,T.parse)(o.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(o)){case"keybindings.json":return E(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:E(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let s={};try{s=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=o,L.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};v=he([Q(0,f.IUserDataSyncStoreService),Q(1,f.IUserDataSyncBackupStoreService),Q(2,f.IUserDataSyncLogService),Q(3,I.IConfigurationService),Q(4,f.IUserDataSyncResourceEnablementService),Q(5,C.IFileService),Q(6,n.IEnvironmentService),Q(7,g.IStorageService),Q(8,f.IUserDataSyncUtilService),Q(9,b.ITelemetryService)],v),e.KeybindingsSynchroniser=v;let y=class extends h.AbstractInitializer{constructor(o,t,s){super("keybindings",t,s,o)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,k.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(o.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return E(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};y=he([Q(0,C.IFileService),Q(1,n.IEnvironmentService),Q(2,f.IUserDataSyncLogService)],y),e.KeybindingsInitializer=y}),define(te[217],ne([0,1,17,36,44,48,26,54,24]),function(J,e,R,k,D,T,L,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function I(l,u,d){let m=[];d?m=C(d):m=n(u);const A=[],_=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const w of m)w.startsWith("-")?_.push(w.substring(1)):A.push(w);return(0,R.distinct)([...l,...A].filter(w=>_.indexOf(w)===-1))}e.getIgnoredSettings=I;function n(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function C(l){const u=(0,k.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function g(l,u,d,m){if(d.length){const A=a(u),_=(0,k.parse)(u),w=(0,k.parse)(l),U=[];for(const O of d){const $=_[O],K=w[O];$===void 0?l=P.edit(l,[O],void 0,m):K!==void 0?l=P.edit(l,[O],$,m):U.push(o(O,A))}U.sort((O,$)=>O.startOffset-$.startOffset),U.forEach(O=>l=E(O.setting.key,u,l,m))}return l}e.updateIgnoredSettings=g;function b(l,u,d,m,A,_){const w=g(l,u,m,_),U=d!==w,O=d!==u;if(!U&&!O)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!O)return{conflictsSettings:[],localContent:null,remoteContent:w,hasConflicts:!1};if(O&&!U)return{conflictsSettings:[],localContent:g(u,l,m,_),remoteContent:null,hasConflicts:!1};if(d===null&&p(l)){const V=h(l,u,m)?null:g(u,l,m,_);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let $=l,K=u;const M=(0,k.parse)(l),H=(0,k.parse)(u),j=d?(0,k.parse)(d):null,z=m.reduce((V,ie)=>(V.add(ie),V),new Set),q=f(M,H,z),F=f(j,M,z),G=f(j,H,z),x=new Map,N=new Set,W=V=>{N.add(V);const ie=A.filter(({key:re})=>re===V)[0];ie?($=P.edit($,[V],ie.value,_),K=P.edit(K,[V],ie.value,_)):x.set(V,{key:V,localValue:M[V],remoteValue:H[V]})};for(const V of F.removed.values())G.updated.has(V)?W(V):K=P.edit(K,[V],void 0,_);for(const V of G.removed.values())N.has(V)||(F.updated.has(V)?W(V):$=P.edit($,[V],void 0,_));for(const V of F.updated.values())N.has(V)||(G.updated.has(V)?q.updated.has(V)&&W(V):K=P.edit(K,[V],M[V],_));for(const V of G.updated.values())N.has(V)||(F.updated.has(V)?q.updated.has(V)&&W(V):$=P.edit($,[V],H[V],_));for(const V of F.added.values())N.has(V)||(G.added.has(V)?q.updated.has(V)&&W(V):K=E(V,$,K,_));for(const V of G.added.values())N.has(V)||(F.added.has(V)?q.updated.has(V)&&W(V):$=E(V,K,$,_));const X=x.size>0||!h($,K,m),Z=X||!h($,l,[]),B=X||!h(K,u,[]);return{localContent:Z?$:null,remoteContent:B?K:null,conflictsSettings:[...x.values()],hasConflicts:X}}e.merge=b;function h(l,u,d){if(l===u)return!0;const m=(0,k.parse)(l),A=(0,k.parse)(u),_=d.reduce((O,$)=>(O.add($),O),new Set),w=a(l).filter(O=>!(O.setting&&_.has(O.setting.key))),U=a(u).filter(O=>!(O.setting&&_.has(O.setting.key)));if(w.length!==U.length)return!1;for(let O=0;O<w.length;O++){const $=w[O],K=U[O];if($.setting&&K.setting){if($.setting.key!==K.setting.key||!L.equals(m[$.setting.key],A[$.setting.key]))return!1}else if(!$.setting&&!K.setting){if($.value!==K.value)return!1}else return!1}return!0}e.areSame=h;function p(l){return l?a(l).length===0:!0}e.isEmpty=p;function f(l,u,d){const m=l?Object.keys(l).filter(O=>!d.has(O)):[],A=Object.keys(u).filter(O=>!d.has(O)),_=A.filter(O=>m.indexOf(O)===-1).reduce((O,$)=>(O.add($),O),new Set),w=m.filter(O=>A.indexOf(O)===-1).reduce((O,$)=>(O.add($),O),new Set),U=new Set;if(l)for(const O of m){if(w.has(O))continue;const $=l[O],K=u[O];L.equals($,K)||U.add(O)}return{added:_,removed:w,updated:U}}function E(l,u,d,m){const A=(0,k.parse)(u),_=a(u),w=a(d),U=v(l,_,w);return y(d,l,A[l],U,w,m)}e.addSetting=E;function v(l,u,d){const m=u.findIndex(_=>_.setting?.key===l),A=u[m-1];if(A){if(A.setting){const w=o(A.setting.key,d);if(w)return{index:d.indexOf(w),insertAfter:!0}}else{const w=t(m,u);if(w){const U=o(w.setting.key,d);if(U){const O=s(d.indexOf(U),d),$=i(u,w,u[m]);if(O){const K=i(d,U,O),M=r($,K);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf(O),insertAfter:!1}}else{const K=i(d,U,d[d.length-1]),M=r($,K);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const _=u[m+1];if(_)if(_.setting){const w=o(_.setting.key,d);if(w)return{index:d.indexOf(w),insertAfter:!1}}else{const w=s(m,u);if(w){const U=o(w.setting.key,d);if(U){const O=t(d.indexOf(U),d),$=i(u,u[m],w);if(O){const K=i(d,O,U),M=r($.reverse(),K.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf(O),insertAfter:!0}}else{const K=i(d,d[0],U),M=r($.reverse(),K.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function y(l,u,d,m,A,_){let w;return m.index===-1?w=(0,D.setProperty)(l,[u],d,_):w=c(l,u,d,m,A,_).map(U=>(0,D.withFormatting)(l,U,_)[0]),(0,D.applyEdits)(l,w)}function c(l,u,d,m,A,_){const w=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,U=(0,T.getEOL)(_,l),O=A[m.index];if(m.insertAfter){const $=[];if(O.setting)$.push({offset:O.endOffset,length:0,content:","+w});else{const K=s(m.index,A),M=t(m.index,A),H=M?.setting?.commaOffset;M&&H===void 0&&$.push({offset:M.endOffset,length:0,content:","});const j=H!==void 0&&H>O.endOffset;$.push({offset:j?H+1:O.endOffset,length:0,content:K?U+w+",":U+w})}return $}else{if(O.setting)return[{offset:O.startOffset,length:0,content:w+","}];const $=(A[m.index-1]&&!A[m.index-1].setting?U:"")+w+(s(m.index,A)?",":"")+U;return[{offset:O.startOffset,length:0,content:$}]}}function o(l,u){return u.filter(d=>d.setting?.key===l)[0]}function t(l,u){for(let d=l-1;d>=0;d--)if(u[d].setting)return u[d]}function s(l,u){for(let d=l+1;d<u.length;d++)if(u[d].setting)return u[d]}function i(l,u,d){const m=l.indexOf(u),A=l.indexOf(d);return l.filter((_,w)=>m<w&&w<A)}function r(l,u){if(l.length&&u.length){let d=0;for(;d<u.length&&d<l.length;d++)if(l[d].value!==u[d].value)return u[d-1];return u[d-1]}}function a(l){const u=[];let d=-1,m,A;const _={onObjectBegin:w=>{d++},onObjectProperty:(w,U,O)=>{d===0&&(m=U,A=w)},onObjectEnd:(w,U)=>{d--,d===0&&u.push({startOffset:m,endOffset:w+U,value:l.substring(m,w+U),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(w,U)=>{d++},onArrayEnd:(w,U)=>{d--,d===0&&u.push({startOffset:m,endOffset:w+U,value:l.substring(m,w+U),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(w,U,O)=>{d===0&&u.push({startOffset:m,endOffset:U+O,value:l.substring(m,U+O),setting:{key:A,commaOffset:void 0}})},onSeparator:(w,U,O)=>{if(d===0&&w===","){let $=u.length-1;for(;$>=0&&!u[$].setting;$--);const K=u[$];K&&u.splice($,1,{startOffset:K.startOffset,endOffset:K.endOffset,value:K.value,setting:{key:K.setting.key,commaOffset:U}})}},onComment:(w,U)=>{d===0&&u.push({startOffset:w,endOffset:w+U,value:l.substring(w,w+U)})}};return(0,k.visit)(l,_),u}}),define(te[218],ne([0,1,22,3,44,142,20,89,13,28,14,23,21,47,54,217,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function E(t){return t&&t.settings&&typeof t.settings=="string"&&Object.keys(t).length===1}function v(t){const s=JSON.parse(t);return E(s)?s:{settings:t}}e.parseSettingsSyncContent=v;let y=class extends b.AbstractJsonFileSynchroniser{constructor(s,i,r,a,l,u,d,m,A,_,w){super(i.settingsResource,"settings",s,i,r,a,l,A,_,u,d,m);this.extensionManagementService=w,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const i=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(s,i),a=this.getSettingsSyncContent(r),l=new P.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&l.parse(a.settings),l.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,i,r){const a=await this.getLocalFileContent(),l=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);i=i===null&&r?s:i;const d=i?this.getSettingsSyncContent(i):null,m=await this.getIgnoredSettings();let A=null,_=!1,w=!1,U=!1;if(u){let $=a?a.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const K=(0,p.merge)($,u.settings,d?d.settings:null,m,[],l);A=K.localContent||K.remoteContent,_=K.localContent!==null,w=K.remoteContent!==null,U=K.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=a.value.toString(),w=!0);const O={content:A,localChange:_?2:0,remoteChange:w?2:0,hasConflicts:U};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(s,i){const r=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,p.updateIgnoredSettings)(s.previewResult.content,"{}",a,r):null}}async getAcceptResult(s,i,r,a){const l=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:s.fileContent?(0,p.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:s.remoteContent!==null?(0,p.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r!==null?(0,p.updateIgnoredSettings)(r,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(s,i,r,a){const{fileContent:l}=r[0][0];let{content:u,localChange:d,remoteChange:m}=r[0][1];if(d===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(u,l,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const A=await this.getFormattingOptions(),_=this.getSettingsSyncContent(s),w=await this.getIgnoredSettings(u);u=(0,p.updateIgnoredSettings)(u,_?_.settings:"{}",w,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),a?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(A){}i?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const i=await this.getFormattingOptions(),r=(0,h.edit)(s.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,p.isEmpty)(r)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:i}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let i=await super.resolveContent(s);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(s)),i){const r=this.parseSyncData(i);if(r){const a=this.parseSettingsSyncContent(r.content);if(a)switch(this.extUri.basename(s)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(s){let i=await super.resolvePreviewContent(s);if(i){const r=await this.getFormattingOptions(),a=await this.getIgnoredSettings();i=(0,p.updateIgnoredSettings)(i,"{}",a,r)}return i}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return v(s)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:l})=>!!l)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(i,this.configurationService,s)}validateContent(s){if(this.hasErrors(s))throw new f.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const s=await this.getLocalFileContent();if(!s)return;const i=JSON.parse(s.value.toString());if(!o(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const r=this.parseSettingsSyncContent(i.content);if(!r||!r.settings)return;let a=r.settings;const l=await this.getFormattingOptions();for(const u in i)if(["version","content","machineId"].indexOf(u)===-1&&i[u]!==void 0){const d=(0,D.setProperty)(a,[u],i[u],l);d.length&&(a=(0,D.applyEdits)(a,d))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(a))}catch(s){}}};y=he([Q(0,n.IFileService),Q(1,S.IEnvironmentService),Q(2,C.IStorageService),Q(3,f.IUserDataSyncStoreService),Q(4,f.IUserDataSyncBackupStoreService),Q(5,f.IUserDataSyncLogService),Q(6,f.IUserDataSyncUtilService),Q(7,L.IConfigurationService),Q(8,f.IUserDataSyncResourceEnablementService),Q(9,g.ITelemetryService),Q(10,I.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let c=class extends b.AbstractInitializer{constructor(s,i,r){super("settings",i,r,s)}async doInitialize(s){const i=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return v(s)}catch(i){this.logService.error(i)}return null}};c=he([Q(0,n.IFileService),Q(1,S.IEnvironmentService),Q(2,f.IUserDataSyncLogService)],c),e.SettingsInitializer=c;function o(t){return!!(t&&t.version!==void 0&&typeof t.version=="number"&&t.content!==void 0&&typeof t.content=="string"&&t.machineId!==void 0&&typeof t.machineId=="string")}}),define(te[219],ne([0,1,22,3,26,20,13,14,23,21,47,212,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends n.AbstractSynchroniser{constructor(f,E,v,y,c,o,t,s,i){super("snippets",E,f,v,y,c,s,i,o,t);this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(k.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,E,v){const y=await this.getSnippetsFileContents(),c=this.toSnippetsContents(y),o=f.syncData?this.parseSnippets(f.syncData):null;E=E===null&&v?f:E;const t=E&&E.syncData?this.parseSnippets(E.syncData):null;o?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,C.merge)(c,o,t);return this.getResourcePreviews(s,y,o||{})}async getMergeResult(f,E){return f.previewResult}async getAcceptResult(f,E,v,y){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return v===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:v,localChange:v===null?f.fileContent!==null?3:0:2,remoteChange:v===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(f,E,v,y){const c=v.map(([o,t])=>({...o,acceptResult:t}));c.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,y)),c.some(({remoteChange:o})=>o!==0)&&(f=await this.updateRemoteSnippets(c,f,y)),E?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of c)try{await this.fileService.del(o)}catch(t){}}getResourcePreviews(f,E,v){const y=new Map;for(const c of Object.keys(f.local.added)){const o={content:f.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};y.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.local.updated)){const o={content:f.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.local.removed){const o={content:null,hasConflicts:!1,localChange:3,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.added)){const o={content:f.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.updated)){const o={content:f.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.remote.removed){const o={content:null,hasConflicts:!1,localChange:0,remoteChange:3};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.conflicts){const o={content:E[c]?E[c].value.toString():null,hasConflicts:!0,localChange:E[c]?2:1,remoteChange:v[c]?2:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c]||null,localContent:E[c]?E[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(E))if(!y.has(c)){const o={content:E[c]?E[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c]||null,localContent:E[c]?E[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...y.values()]}async getAssociatedResources({uri:f}){let E=await super.resolveContent(f);if(E){const v=this.parseSyncData(E);if(v){const y=this.parseSnippets(v),c=[];for(const o of Object.keys(y)){const t=this.extUri.joinPath(f,o),s=this.extUri.joinPath(this.snippetsFolder,o),i=await this.fileService.exists(s);c.push({resource:t,comparableResource:i?s:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let E=await super.resolveContent(f);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(f)),E){const v=this.parseSyncData(E);if(v)return this.parseSnippets(v)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch(f){}return!1}async updateLocalBackup(f){const E={};for(const v of f)v.fileContent&&(E[this.extUri.basename(v.localResource)]=v.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(f,E){for(const{fileContent:v,acceptResult:y,localResource:c,remoteResource:o,localChange:t}of f)if(t!==0){const s=o?this.extUri.basename(o):this.extUri.basename(c),i=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,R.VSBuffer.fromString(y.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,R.VSBuffer.fromString(y.content),E?void 0:v),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(f,E,v){const y=E.syncData?this.parseSnippets(E.syncData):{},c=(0,D.deepClone)(y);for(const{acceptResult:o,localResource:t,remoteResource:s,remoteChange:i}of f)if(i!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s);i===3?delete c[r]:c[r]=o.content}return(0,C.areSame)(y,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(c),v?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const E={};for(const v of Object.keys(f))E[v]=f[v].value.toString();return E}async getSnippetsFileContents(){const f={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(v){if(v instanceof P.FileOperationError&&v.fileOperationResult===1)return f;throw v}for(const v of E.children||[]){const y=v.resource,c=this.extUri.extname(y);if(c===".json"||c===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,y),t=await this.fileService.readFile(y);f[o]=t}}return f}};b=he([Q(0,L.IEnvironmentService),Q(1,P.IFileService),Q(2,S.IStorageService),Q(3,g.IUserDataSyncStoreService),Q(4,g.IUserDataSyncBackupStoreService),Q(5,g.IUserDataSyncLogService),Q(6,T.IConfigurationService),Q(7,g.IUserDataSyncResourceEnablementService),Q(8,I.ITelemetryService)],b),e.SnippetsSynchroniser=b;let h=class extends n.AbstractInitializer{constructor(f,E,v){super("snippets",E,v,f)}async doInitialize(f){const E=f.syncData?JSON.parse(f.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const y of Object.keys(E)){const c=E[y];if(c){const o=this.extUri.joinPath(this.environmentService.snippetsHome,y);await this.fileService.createFile(o,R.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};h=he([Q(0,P.IFileService),Q(1,L.IEnvironmentService),Q(2,g.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[62],ne([0,1,3,2,5,24]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let L=class extends k.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};L=he([Q(0,T.IUserDataSyncStoreService)],L),e.UserDataSyncAccountService=L}),define(te[220],ne([0,1,6,22,57,2,16,20,13,14,24]),function(J,e,R,k,D,T,L,P,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(b,h,p,f){super();this.environmentService=b,this.fileService=h,this.configurationService=p,this.logService=f,n.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(b){const h=(0,L.joinPath)(this.environmentService.userDataSyncHome,b),p=await this.fileService.resolve(h);return p.children?p.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(b,h){if(!h){const p=await this.getAllRefs(b);p.length&&(h=p[p.length-1].ref)}if(h){const p=(0,L.joinPath)(this.environmentService.userDataSyncHome,b,h);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(b,h){const p=(0,L.joinPath)(this.environmentService.userDataSyncHome,b),f=(0,L.joinPath)(p,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,k.VSBuffer.fromString(h))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(b)}catch(E){}}async cleanUpBackup(b){const h=(0,L.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(h))return}catch(f){return}const p=await this.fileService.resolve(h);if(p.children){const f=p.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=f.filter(c=>Date.now()-this.getCreationTime(c)>E);const y=f.length-v.length;y<10&&(v=v.slice(10-y)),await R.Promises.settled(v.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};C=he([Q(0,S.IEnvironmentService),Q(1,I.IFileService),Q(2,P.IConfigurationService),Q(3,n.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[221],ne([0,1,2,7]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(g){this.service=g}listen(g,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class T{constructor(g){this.service=g}listen(g,b){throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(k.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class L{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(g){this.service=g}listen(g,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(g,b,h){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class S{constructor(g){this.service=g}listen(g,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class I{constructor(g){this.service=g}listen(g,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class n extends R.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:k.URI.revive(g.url),type:g.type,defaultUrl:k.URI.revive(g.defaultUrl),insidersUrl:k.URI.revive(g.insidersUrl),stableUrl:k.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(te[222],ne([0,1,13,10]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends k.AbstractLogger{constructor(L,P){super();this.logger=this._register(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.logger.trace(L,...P)}debug(L,...P){this.logger.debug(L,...P)}info(L,...P){this.logger.info(L,...P)}warn(L,...P){this.logger.warn(L,...P)}error(L,...P){this.logger.error(L,...P)}critical(L,...P){this.logger.critical(L,...P)}flush(){this.logger.flush()}};D=he([Q(0,k.ILoggerService),Q(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[63],ne([0,1,3,2,4,25,145,13,14,5,29,45,23,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let p=class Ze extends k.Disposable{constructor(E,v,y,c,o,t){super();this.storageService=y,this.userDataSyncStoreService=c,this.logService=o,this.productService=t,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(E,v,y)}async getMachines(E){const v=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(c=>({...c,isCurrent:c.id===v}))}async addCurrentMachine(E){const v=await this.currentMachineIdPromise,y=await this.readMachinesData(E);y.machines.some(({id:c})=>c===v)||(y.machines.push({id:v,name:this.computeCurrentMachineName(y.machines)}),await this.writeMachinesData(y))}async removeCurrentMachine(E){const v=await this.currentMachineIdPromise,y=await this.readMachinesData(E),c=y.machines.filter(({id:o})=>o!==v);c.length!==y.machines.length&&(y.machines=c,await this.writeMachinesData(y))}async renameMachine(E,v,y){const c=await this.currentMachineIdPromise,o=await this.readMachinesData(y),t=o.machines.find(({id:s})=>s===E);t&&(t.name=v,await this.writeMachinesData(o),o.machines.some(({id:s})=>s===c)&&this.storageService.store(h,v,0,1))}async setEnablement(E,v){const y=await this.readMachinesData(),c=y.machines.find(({id:o})=>o===E);c&&(c.disabled=v?void 0:!0,await this.writeMachinesData(y))}computeCurrentMachineName(E){const v=this.storageService.get(h,0);if(v)return v;const y=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,T.escapeRegExpCharacters)(y)}\\s#(\\d+)`);let o=0;for(const t of E){const s=c.exec(t.name),i=s?parseInt(s[1]):0;o=i>o?i:o}return`${y} #${o+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const v=this.parse(this.userData);if(v.version!==Ze.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return v}async writeMachinesData(E){const v=JSON.stringify(E),y=await this.userDataSyncStoreService.write(Ze.RESOURCE,v,this.userData?.ref||null);this.userData={ref:y,content:v},this._onDidChange.fire()}async readUserData(E){if(this.userData){const v=E&&E.latest?E.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===v)return this.userData;if(v===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(v){this.logService.error(v)}return{version:Ze.VERSION,machines:[]}}};p.VERSION=1,p.RESOURCE="machines",p=he([Q(0,P.IEnvironmentService),Q(1,S.IFileService),Q(2,g.IStorageService),Q(3,b.IUserDataSyncStoreService),Q(4,b.IUserDataSyncLogService),Q(5,n.IProductService)],p),e.UserDataSyncMachinesService=p}),define(te[98],ne([0,1,6,57,38,8,3,2,4,16,7,143,13,29,23,21,24,62,63]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const y="sync.enable",c="sync.disableMachineEventually",o="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let i=class extends P.Disposable{constructor(u,d,m){super();this.storageService=u,this.environmentService=d,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(y,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(y,u,0,1)}onDidStorageChange(u){if(u.scope===0&&y===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Q(0,h.IStorageService),Q(1,g.IEnvironmentService),Q(2,f.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let r=class extends P.Disposable{constructor(u,d,m,A,_,w,U,O,$,K,M){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=m,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=_,this.logService=w,this.userDataSyncAccountService=U,this.telemetryService=O,this.userDataSyncMachinesService=$,this.storageService=K,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(U.onDidChangeAccount(()=>this.updateAutoSync())),this._register(m.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(_.onDidChangeLocal,(H,j)=>H?[...H,j]:[j],1e3)(H=>this.triggerSync(H,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,H])=>H)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?n.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:d}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(m=>this.onDidFinishSync(m))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,k.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,d,m){try{this.userDataSyncAccountService.account&&!m&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(d)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(y,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const d=f.UserDataSyncError.toUserDataSyncError(u);d instanceof f.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?S.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,d,m){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",m)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=he([Q(0,b.IProductService),Q(1,f.IUserDataSyncStoreManagementService),Q(2,f.IUserDataSyncStoreService),Q(3,f.IUserDataSyncResourceEnablementService),Q(4,f.IUserDataSyncService),Q(5,f.IUserDataSyncLogService),Q(6,E.IUserDataSyncAccountService),Q(7,p.ITelemetryService),Q(8,v.IUserDataSyncMachinesService),Q(9,h.IStorageService),Q(10,f.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class a extends P.Disposable{constructor(u,d,m,A,_,w,U,O){super();this.lastSyncUrl=u,this.interval=d,this.userDataSyncStoreManagementService=m,this.userDataSyncStoreService=A,this.userDataSyncService=_,this.userDataSyncMachinesService=w,this.logService=U,this.storageService=O,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,d){const m=(0,R.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(_){if((0,T.isPromiseCanceledError)(_))return}return this.doSync(u,d,A)});return this.syncPromise=m,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!u&&(!(0,I.isEqual)(d.defaultUrl,u.defaultUrl)||!(0,I.isEqual)(d.insidersUrl,u.insidersUrl)||!(0,I.isEqual)(d.stableUrl,u.stableUrl))}async doSync(u,d,m){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),m.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const _=this.storageService.get(o,0);if(_&&this.manifest&&_!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const w=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(m.isCancellationRequested)return;const U=w.find(O=>O.isCurrent);if(U?.disabled)throw new f.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new f.UserDataAutoSyncError((0,D.toErrorMessage)(O),O instanceof f.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==_&&this.storageService.store(o,this.manifest.session,0,1),m.isCancellationRequested)return;U||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(_){this.logService.error(_),A=_}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[223],ne([0,1,3,2,4,23,21,24]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends k.Disposable{constructor(n,C){super();this.storageService=n,this.telemetryService=C,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(g=>this.onDidStorageChange(g)))}isResourceEnabled(n){return this.storageService.getBoolean((0,P.getEnablementKey)(n),0,!0)}setResourceEnablement(n,C){if(this.isResourceEnabled(n)!==C){const g=(0,P.getEnablementKey)(n);this.telemetryService.publicLog2(g,{enabled:C}),this.storeResourceEnablement(g,C)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,C){this.storageService.store(n,C,0,D.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(g=>(0,P.getEnablementKey)(g)===n.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};S=he([Q(0,T.IStorageService),Q(1,L.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[224],ne([0,1,17,6,38,8,3,2,16,30,20,5,23,21,213,215,216,218,219,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let o=class extends P.Disposable{constructor(r,a,l,u,d,m,A){super();this.userDataSyncStoreService=r,this.userDataSyncStoreManagementService=a,this.instantiationService=l,this.configurationService=u,this.logService=d,this.telemetryService=m,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(E.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(f.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(v.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(L.Event.any(...this.synchronisers.map(_=>L.Event.map(_.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(L.Event.any(...this.synchronisers.map(_=>L.Event.map(_.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=L.Event.any(...this.synchronisers.map(_=>L.Event.map(_.onDidChangeLocal,()=>_.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(r,a){await this.checkEnablement();const l=(0,I.generateUuid)();try{const A=(0,y.createSyncHeaders)(l);a&&(A["Cache-Control"]="no-cache"),r=await this.userDataSyncStoreService.manifest(r,A)}catch(A){const _=y.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(_,l),_}let u=!1;const d=this;let m;return{manifest:r,run(){if(u)throw new Error("Can run a task only once");return m=(0,k.createCancelablePromise)(A=>d.sync(r,l,A)),m.finally(()=>m=void 0)},async stop(){if(m&&m.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const r=(0,I.generateUuid)(),a=(0,y.createSyncHeaders)(r);let l;try{l=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const d=y.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(d,r),d}return new t(r,l,a,this.synchronisers,this.configurationService,this.logService)}async sync(r,a,l){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),l.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,y.createSyncHeaders)(a);for(const m of this.synchronisers){if(l.isCancellationRequested)return;try{await m.sync(r,d)}catch(A){let _=!1;if(A instanceof y.UserDataSyncError)switch(A.code){case"TooLarge":A=new y.UserDataSyncError(A.message,A.code,m.resource),_=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":_=!0;break}const w=y.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(w,a),_)throw w;this.logService.error(A),this.logService.error(`${m.resource}: ${(0,D.toErrorMessage)(A)}`),this._syncErrors.push([m.resource,w])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(d){const m=y.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(m,a),m}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const r of this.synchronisers)try{r.status!=="idle"&&await r.stop()}catch(a){this.logService.error(a)}}async replace(r){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(r))return}async accept(r,a,l,u){await this.checkEnablement();const d=this.getSynchroniser(r);await d.accept(a,l),u&&await d.apply(!1,(0,y.createSyncHeaders)((0,I.generateUuid)()))}async resolveContent(r){for(const a of this.synchronisers){const l=await a.resolveContent(r);if(l)return l}return null}getRemoteSyncResourceHandles(r){return this.getSynchroniser(r).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(r){return this.getSynchroniser(r).getLocalSyncResourceHandles()}getAssociatedResources(r,a){return this.getSynchroniser(r).getAssociatedResources(a)}getMachineId(r,a){return this.getSynchroniser(r).getMachineId(a)}async hasLocalData(){const r=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of r)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(r){this.logService.error(r)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const r of this.synchronisers)try{await r.resetLocal()}catch(a){this.logService.error(`${r.resource}: ${(0,D.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const r of this.synchronisers)if(await r.hasPreviouslySynced())return!0;return!1}setStatus(r){const a=this._status;this._status!==r&&(this._status=r,this._onDidChangeStatus.fire(r),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const r=this.computeStatus();this.setStatus(r)}updateConflicts(){const r=this.computeConflicts();(0,R.equals)(this._conflicts,r,([a,l],[u,d])=>a===a&&(0,R.equals)(l,d,(m,A)=>(0,S.isEqual)(m.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(r))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(r,a){this.telemetryService.publicLog2("sync/error",{code:r.code,serverCode:r instanceof y.UserDataSyncStoreError?String(r.serverCode):void 0,url:r instanceof y.UserDataSyncStoreError?r.url:void 0,resource:r.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(r=>r.status==="hasConflicts").map(r=>[r.resource,r.conflicts.map(s)])}getSynchroniser(r){return this.synchronisers.find(a=>a.resource===r)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=he([Q(0,y.IUserDataSyncStoreService),Q(1,y.IUserDataSyncStoreManagementService),Q(2,C.IInstantiationService),Q(3,n.IConfigurationService),Q(4,y.IUserDataSyncLogService),Q(5,b.ITelemetryService),Q(6,g.IStorageService)],o),e.UserDataSyncService=o;class t extends P.Disposable{constructor(r,a,l,u,d,m){super();this.id=r,this.manifest=a,this.syncHeaders=l,this.synchronisers=u,this.configurationService=d,this.logService=m,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,k.createCancelablePromise)(r=>this.getPreviews(r))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(r){throw this.logService.error(r),r}}async accept(r,a){try{return await this.performAction(r,l=>l.accept(r,a))}catch(l){throw this.logService.error(l),l}}async merge(r){try{return r?await this.performAction(r,a=>a.merge(r)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(r){try{return await this.performAction(r,a=>a.discard(r))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const r=[];for(const[,a]of this.previews)for(const l of a.resourcePreviews)l.mergeState==="conflict"&&r.push(l.previewResource);for(const a of r)await this.discard(a);return this.previews}catch(r){throw this.logService.error(r),r}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const r=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);for(const m of l.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&await u.merge(m.previewResource);const d=await u.apply(!1,this.syncHeaders);d&&r.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}catch(r){throw this.logService.error(r),r}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,a]of this.previews){this.synchronizingResources.push([r,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===r);for(const u of a.resourcePreviews)await l.accept(u.remoteResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,a]of this.previews){this.synchronizingResources.push([r,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===r);for(const u of a.resourcePreviews)await l.accept(u.localResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async stop(){for(const r of this.synchronisers)try{await r.stop()}catch(a){(0,T.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(r,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const l=this.previews.findIndex(([,O])=>O.resourcePreviews.some(({localResource:$,previewResource:K,remoteResource:M})=>(0,S.isEqual)(r,$)||(0,S.isEqual)(r,K)||(0,S.isEqual)(r,M)));if(l===-1)return this.previews;const[u,d]=this.previews[l],m=d.resourcePreviews.find(({localResource:O,remoteResource:$,previewResource:K})=>(0,S.isEqual)(O,r)||(0,S.isEqual)($,r)||(0,S.isEqual)(K,r));if(!m)return this.previews;let A=this.synchronizingResources.find(O=>O[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(O=>(0,S.isEqual)(O,m.localResource))||(A[1].push(m.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const _=this.synchronisers.find(O=>O.resource===this.previews[l][0]),w=await a(_);w?this.previews.splice(l,1,this.toSyncResourcePreview(_.resource,w)):this.previews.splice(l,1);const U=this.synchronizingResources.findIndex(O=>O[0]===u);return this.synchronizingResources[U][1].splice(A[1].findIndex(O=>(0,S.isEqual)(O,m.localResource)),1),A[1].length||(this.synchronizingResources.splice(U,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const r=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);let d=l;for(const m of l.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&(d=await u.merge(m.previewResource));d&&r.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}async getPreviews(r){const a=[],l=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(r.isCancellationRequested)return[];const d=await u.preview(this.manifest,l,this.syncHeaders);d&&a.push(this.toSyncResourcePreview(u.resource,d))}return a}async getUserDataSyncConfiguration(){const r=this.configurationService.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(l=>l instanceof E.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...r,...a}}toSyncResourcePreview(r,a){return[r,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(te[225],ne([0,1,3,2,18,7,24]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,g){this.service=C,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(C,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(C,g,b){try{return await this._call(C,g,b)}catch(h){throw this.logService.error(h),h}}async _call(C,g,b){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],T.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:T.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:T.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const h=g.substring("manualSync/".length),p=b[0],f=this.getManualSyncTask(p);switch(b=b.slice(1),h){case"preview":return f.preview();case"accept":return f.accept(T.URI.revive(b[0]),b[1]);case"merge":return f.merge(T.URI.revive(b[0]));case"discard":return f.discard(T.URI.revive(b[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(C){const g=this.manualSyncTasks.get(this.createKey(C));if(!g)throw new Error(`Manual sync taks not found: ${C}`);return g.manualSyncTask}async createManualSyncTask(){const C=new k.DisposableStore,g=C.add(await this.service.createManualSyncTask());return C.add(g.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:b}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:C}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(C){C.dispose();const g=this.createKey(C.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class S extends k.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,b,h){return C.call(g,b,h).then(null,p=>{throw L.UserDataSyncError.toUserDataSyncError(p)})},listen(g,b){return C.listen(g,b)}},this.channel.call("_getInitialData").then(([g,b,h])=>{this.updateStatus(g),this.updateConflicts(b),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([b,h])=>[b,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:g,status:b}=await this.channel.call("createManualSyncTask"),h=this,p=new I(C,g,b,{async call(f,E,v){return h.channel.call(`manualSync/${f}`,[C,...(0,D.isArray)(E)?E:[E]],v)},listen(f,E){return R.Event.map(R.Event.filter(h.channel.listen(`manualSync/${f}`,E),v=>!p.isDiposed()&&v.manualSyncTaskId===C),v=>v.data)}});return p}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,g,b,h){return this.channel.call("accept",[C,g,b,h])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:b,uri:h})=>({created:b,uri:T.URI.revive(h)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:b,uri:h})=>({created:b,uri:T.URI.revive(h)}))}async getAssociatedResources(C,g){return(await this.channel.call("getAssociatedResources",[C,g])).map(({resource:h,comparableResource:p})=>({resource:T.URI.revive(h),comparableResource:T.URI.revive(p)}))}async getMachineId(C,g){return this.channel.call("getMachineId",[C,g])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([g,b])=>[g,b.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=S;class I extends k.Disposable{constructor(C,g,b,h){super();this.id=C,this.manifest=g,this._disposed=!1,this._status=b;const p=this;this.channel={async call(f,E,v){try{const y=await h.call(f,E,v);return p.isDiposed()||(p._status=await h.call("_getStatus")),y}catch(y){throw L.UserDataSyncError.toUserDataSyncError(y)}},listen(f,E){return h.listen(f,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,g){const b=await this.channel.call("accept",[C,g]);return this.deserializePreviews(b)}async merge(C){const g=await this.channel.call("merge",[C]);return this.deserializePreviews(g)}async discard(C){const g=await this.channel.call("discard",[C]);return this.deserializePreviews(g)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([g,b])=>[g,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource),acceptedResource:T.URI.revive(h.acceptedResource)}))}])}}}),define(te[226],ne([0,1,6,27,8,3,2,105,4,16,18,7,30,20,13,14,29,43,45,23,24]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",i="sync.machine-session-id",r=100,a=1e3*60*5;let l=class extends L.Disposable{constructor(w,U,O){super();this.productService=w,this.configurationService=U,this.storageService=O,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(O.onDidChangeValue,$=>$.key===c.SYNC_SERVICE_URL_TYPE&&$.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(w){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,w,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(w,U){w=S.isWeb&&w?.web?{...w,...w.web}:w;const O={...w||{},...U||{}};if(O&&(0,n.isString)(O.url)&&(0,n.isObject)(O.authenticationProviders)&&Object.keys(O.authenticationProviders).every($=>(0,n.isArray)(O.authenticationProviders[$].scopes))){const $=O,K=!!$.canSwitch&&!U?.url,M=$.url===$.insidersUrl?"insiders":"stable",H=(K?this.userDataSyncStoreType:void 0)||M,j=U?.url||(H==="insiders"?$.insidersUrl:H==="stable"?$.stableUrl:$.url);return{url:C.URI.parse(j),type:H,defaultType:M,defaultUrl:C.URI.parse($.url),stableUrl:C.URI.parse($.stableUrl),insidersUrl:C.URI.parse($.insidersUrl),canSwitch:K,authenticationProviders:Object.keys($.authenticationProviders).reduce((z,q)=>(z.push({id:q,scopes:$.authenticationProviders[q].scopes}),z),[])}}}};l=he([Q(0,f.IProductService),Q(1,b.IConfigurationService),Q(2,y.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let u=class extends l{constructor(w,U,O){super(w,U,O);const $=this.storageService.get(o,0);$&&(this.previousConfigurationSyncStore=JSON.parse($));const K=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];K?this.storageService.store(o,JSON.stringify(K),0,1):this.storageService.remove(o,0)}async switch(w){w!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=w,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([Q(0,f.IProductService),Q(1,b.IConfigurationService),Q(2,y.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let d=class extends L.Disposable{constructor(w,U,O,$,K,M,H){super();this.requestService=O,this.logService=$,this.storageService=H,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(w),this.commonHeadersPromise=(0,v.getServiceMachineId)(K,M,H).then(j=>{const z={"X-Client-Name":`${U.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(z["X-Client-Commit"]=U.commit),z}),this.session=new A(r,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(w,U){this.authToken={token:w,type:U}}updateUserDataSyncStoreUrl(w){this.userDataSyncStoreUrl=w?(0,I.joinPath)(w,"v1"):void 0}initDonotMakeRequestsUntil(){const w=this.storageService.getNumber(t,0);w&&Date.now()<w&&this.setDonotMakeRequestsUntil(new Date(w))}setDonotMakeRequestsUntil(w){this._donotMakeRequestsUntil?.getTime()!==w?.getTime()&&(this._donotMakeRequestsUntil=w,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(U=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(w){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w),O={},$=await this.request(U.toString(),{type:"GET",headers:O},[],k.CancellationToken.None);return(await(0,E.asJson)($)||[]).map(({url:M,created:H})=>({ref:(0,I.relativePath)(U,U.with({path:M})),created:H*1e3}))}async resolveContent(w,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w,U).toString(),$={};$["Cache-Control"]="no-cache";const K=await this.request(O,{type:"GET",headers:$},[],k.CancellationToken.None);return await(0,E.asText)(K)}async delete(w){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w).toString(),O={};await this.request(U,{type:"DELETE",headers:O},[],k.CancellationToken.None)}async read(w,U,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w,"latest").toString();O={...O},O["Cache-Control"]="no-cache",U&&(O["If-None-Match"]=U.ref);const K=await this.request($,{type:"GET",headers:O},[304],k.CancellationToken.None);let M=null;if(K.res.statusCode===304&&(M=U),M===null){const H=K.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",K.res.statusCode,K.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,E.asText)(K);if(!j&&K.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",K.res.statusCode,K.res.headers[c.HEADER_OPERATION_ID]);M={ref:H,content:j}}return M}async write(w,U,O,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w).toString();$={...$},$["Content-Type"]=P.Mimes.text,O&&($["If-Match"]=O);const M=await this.request(K,{type:"POST",data:U,headers:$},[],k.CancellationToken.None),H=M.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",K,"NoRef",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);return H}async manifest(w,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",w&&(U["If-None-Match"]=w.ref);const $=await this.request(O,{type:"GET",headers:U},[304],k.CancellationToken.None);let K=null;if($.res.statusCode===304&&(K=w),!K){const H=$.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",O,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,E.asText)($);if(!j&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",O,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);j&&(K={...JSON.parse(j),ref:H})}const M=this.storageService.get(s,0);return M&&K&&M!==K.session&&this.clearSession(),K===null&&M&&this.clearSession(),K&&this.storageService.store(s,K.session,0,1),K}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const w=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(w,{type:"DELETE",headers:U},[],k.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(i,0)}async request(w,U,O,$){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",w,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${U.type} request '${w}' failed because of too many requests (429).`,w,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const K=await this.commonHeadersPromise;U.headers={...U.headers||{},...K,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:w,type:U.type,headers:{...U.headers,authorization:void 0}});let M;try{M=await this.session.request(w,U,$)}catch(q){if(!(q instanceof c.UserDataSyncStoreError)){let F="RequestFailed";const G=(0,D.getErrorMessage)(q).toLowerCase();G.includes("xhr timeout")?F="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?F="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":G.includes("headers must be an object")?F="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(q)&&(F="RequestCanceled"),q=new c.UserDataSyncStoreError(`Connection refused for the request '${w}'.`,w,F,void 0,void 0)}throw this.logService.info("Request failed",w),q}const H=M.res.headers[c.HEADER_OPERATION_ID],j={url:w,status:M.res.statusCode,"execution-id":U.headers[c.HEADER_EXECUTION_ID],"operation-id":H},z=(0,E.isSuccess)(M)||M.res.statusCode&&O.indexOf(M.res.statusCode)!==-1;if(z?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${w}' failed because of Unauthorized (401).`,w,"Unauthorized",M.res.statusCode,H);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new c.UserDataSyncStoreError(`${U.type} request '${w}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,w,"Conflict",M.res.statusCode,H);if(M.res.statusCode===410)throw new c.UserDataSyncStoreError(`${U.type} request '${w}' failed because the requested resource is not longer available (410).`,w,"Gone",M.res.statusCode,H);if(M.res.statusCode===412)throw new c.UserDataSyncStoreError(`${U.type} request '${w}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,w,"PreconditionFailed",M.res.statusCode,H);if(M.res.statusCode===413)throw new c.UserDataSyncStoreError(`${U.type} request '${w}' failed because of too large payload (413).`,w,"TooLarge",M.res.statusCode,H);if(M.res.statusCode===426)throw new c.UserDataSyncStoreError(`${U.type} request '${w}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,w,"UpgradeRequired",M.res.statusCode,H);if(M.res.statusCode===429){const q=M.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new c.UserDataSyncStoreError(`${U.type} request '${w}' failed because of too many requests (429).`,w,"TooManyRequestsAndRetryAfter",M.res.statusCode,H)):new c.UserDataSyncStoreError(`${U.type} request '${w}' failed because of too many requests (429).`,w,"RemoteTooManyRequests",M.res.statusCode,H)}if(!z)throw new c.UserDataSyncStoreError("Server returned "+M.res.statusCode,w,"Unknown",M.res.statusCode,H);return M}addSessionHeaders(w){let U=this.storageService.get(i,0);U===void 0&&(U=(0,g.generateUuid)(),this.storageService.store(i,U,0,1)),w["X-Machine-Session-Id"]=U;const O=this.storageService.get(s,0);O!==void 0&&(w["X-User-Session-Id"]=O)}};d=he([Q(1,f.IProductService),Q(2,E.IRequestService),Q(3,c.IUserDataSyncLogService),Q(4,h.IEnvironmentService),Q(5,p.IFileService),Q(6,y.IStorageService)],d),e.UserDataSyncStoreClient=d;let m=class extends d{constructor(w,U,O,$,K,M,H){super(w.userDataSyncStore?.url,U,O,$,K,M,H);this._register(w.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(w.userDataSyncStore?.url)))}};m=he([Q(0,c.IUserDataSyncStoreManagementService),Q(1,f.IProductService),Q(2,E.IRequestService),Q(3,c.IUserDataSyncLogService),Q(4,h.IEnvironmentService),Q(5,p.IFileService),Q(6,y.IStorageService)],m),e.UserDataSyncStoreService=m;class A{constructor(w,U,O,$){this.limit=w,this.interval=U,this.requestService=O,this.logService=$,this.requests=[],this.startTime=void 0}request(w,U,O){if(this.isExpired()&&this.reset(),U.url=w,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,w,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(w),this.requestService.request(U,O)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[227],ne([0,1,3,60,29,23,21,98,24,62,63]),function(J,e,R,k,D,T,L,P,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(b,h,p,f,E,v,y,c,o,t,s,i){super(b,h,p,f,E,y,c,o,t,s,i);this._register(R.Event.debounce(R.Event.any(R.Event.map(v.onDidFocusWindow,()=>"windowFocus"),R.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(r,a)=>r?[...r,a]:[a],1e3)(r=>this.triggerSync(r,!0,!1)))}};C=he([Q(0,D.IProductService),Q(1,S.IUserDataSyncStoreManagementService),Q(2,S.IUserDataSyncStoreService),Q(3,S.IUserDataSyncResourceEnablementService),Q(4,S.IUserDataSyncService),Q(5,k.INativeHostService),Q(6,S.IUserDataSyncLogService),Q(7,I.IUserDataSyncAccountService),Q(8,L.ITelemetryService),Q(9,n.IUserDataSyncMachinesService),Q(10,T.IStorageService),Q(11,S.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(te[228],ne([0,1,6,3,2]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:S,getActiveWindowId:I}){super();this.disposables=this._register(new D.DisposableStore),k.Event.latch(k.Event.any(P,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>I()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[64],ne([0,1,51,6,9,18,19,122,238,239]),function(J,e,R,k,D,T,L,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=s}}e.ExtractError=n;function C(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function g(o){if(o instanceof n)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new n(t,o)}function b(o,t,s,i,r,a){const l=D.dirname(t),u=D.join(i,l);if(!u.startsWith(i))return Promise.reject(new Error(P.localize(0,null,t)));const d=D.join(i,t);let m;return a.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(L.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,_)=>{if(!a.isCancellationRequested)try{m=(0,R.createWriteStream)(d,{mode:s}),m.once("close",()=>A()),m.once("error",_),o.once("error",_),o.pipe(m)}catch(w){_(w)}}))}function h(o,t,s,i){let r=(0,k.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{r.cancel(),o.close()}),new Promise((l,u)=>{const d=new k.Sequencer,m=A=>{A.isCancellationRequested||(a++,o.readEntry())};o.once("error",u),o.once("close",()=>r.then(()=>{i.isCancellationRequested||o.entryCount===a?l():u(new n("Incomplete",new Error(P.localize(1,null,a,o.entryCount))))},u)),o.readEntry(),o.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){m(i);return}const _=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const O=D.join(t,_);r=(0,k.createCancelablePromise)($=>L.Promises.mkdir(O,{recursive:!0}).then(()=>m($)).then(void 0,u));return}const w=f(o,A),U=C(A);r=(0,k.createCancelablePromise)(O=>d.queue(()=>w.then($=>b($,_,U,t,s,O).then(()=>m(O)))).then(null,u))})})}function p(o,t=!1){return new Promise((s,i)=>{(0,S.open)(o,t?{lazyEntries:!0}:void 0,(r,a)=>{r?i(g(r)):s((0,T.assertIsDefined)(a))})})}function f(o,t){return new Promise((s,i)=>{o.openReadStream(t,(r,a)=>{r?i(g(r)):s((0,T.assertIsDefined)(a))})})}function E(o,t){return new Promise((s,i)=>{const r=new I.ZipFile;t.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const a=(0,R.createWriteStream)(o);r.outputStream.pipe(a),r.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>s(o))})}e.zip=E;function v(o,t,s={},i){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=p(o,!0);return s.overwrite&&(a=a.then(l=>L.Promises.rm(t).then(()=>l))),a.then(l=>h(l,t,{sourcePathRegex:r},i))}e.extract=v;function y(o,t){return p(o).then(s=>new Promise((i,r)=>{s.on("entry",a=>{a.fileName===t&&f(s,a).then(l=>i(l),l=>r(l))}),s.once("close",()=>r(new Error(P.localize(2,null,t))))}))}function c(o,t){return y(o,t).then(s=>new Promise((i,r)=>{const a=[];s.once("error",r),s.on("data",l=>a.push(l)),s.on("end",()=>i(Buffer.concat(a)))}))}e.buffer=c}),define(te[229],ne([0,1,64,130]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(T){return(0,R.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch(P){throw new Error((0,k.localize)(0,null))}})}e.getManifest=D}),define(te[230],ne([0,1,17,6,8,2,15,9,4,16,59,7,30,19,64,131,13,28,34,151,14,10,29]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",i="scanningUser",r="extracting",a="deleting",l="renaming";let u=class extends T.Disposable{constructor(m,A,_,w,U){super();this.beforeRemovingExtension=m,this.fileService=A,this.logService=_,this.environmentService=w,this.productService=U,this._devSystemExtensionsPath=null,this.systemExtensionsPath=w.builtinExtensionsPath,this.extensionsPath=w.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(m){const A=[];(m===null||m===0)&&A.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(_).message,s)))),(m===null||m===1)&&A.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(_).message,i))));try{const _=await Promise.all(A);return(0,R.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(m){this.logService.trace("Started scanning user extensions");let[A,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(w=>!A[new v.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]),m&&(_=(0,v.groupByExtension)(_,U=>U.identifier).map(U=>U.sort((O,$)=>n.rcompare(O.manifest.version,$.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(m,A,_,w){const U=m.key(),O=P.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),$=P.join(this.extensionsPath,U);try{await b.Promises.rm($)}catch(M){try{await b.Promises.rm($)}catch(H){}throw new E.ExtensionManagementError((0,p.localize)(0,null,$,m.id),a)}await this.extractAtLocation(m,A,O,w);let K=await this.scanExtension(C.URI.file(O),1);if(!K)throw new Error((0,p.localize)(1,null,O));await this.storeMetadata(K,{..._,installedTimestamp:Date.now()});try{await this.rename(m,O,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(M){try{await b.Promises.rm(O)}catch(H){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",m.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(M)}. Deleted from extracted location`,O),M}try{K=await this.scanExtension(C.URI.file($),1)}catch(M){}if(K)return K;throw new Error((0,p.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(m,A){return this.setMetadata(m,A),await this.storeMetadata(m,{...A,installedTimestamp:m.installedTimestamp}),m}async storeMetadata(m,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const _=P.join(m.location.fsPath,"package.json"),w=await b.Promises.readFile(_,"utf8"),{manifest:U}=await this.parseManifest(w);return U.__metadata=A,await b.Promises.writeFile(_,JSON.stringify(U,null,"	")),m}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...m){const A=m.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{A.forEach(w=>_[w.key()]=!0)})}async setInstalled(m){await this.withUninstalledExtensions(w=>delete w[m.key()]);const _=(await this.scanExtensions(1)).find(w=>new v.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).equals(m))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(m){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(w){if(w.code!=="ENOENT")throw w}let _={};if(A)try{_=JSON.parse(A)}catch(w){}return m&&(m(_),Object.keys(_).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await b.Promises.rm(this.uninstalledPath)),_})}async removeExtension(m,A){this.logService.trace(`Deleting ${A} extension from disk`,m.identifier.id,m.location.fsPath),await b.Promises.rm(m.location.fsPath),this.logService.info("Deleted from disk",m.identifier.id,m.location.fsPath)}async removeUninstalledExtension(m){await this.removeExtension(m,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new v.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()])}async extractAtLocation(m,A,_,w){this.logService.trace(`Started extracting the extension from ${A} to ${_}`);try{await b.Promises.rm(_)}catch(U){throw new E.ExtensionManagementError(this.joinErrors(U).message,a)}try{await(0,h.extract)(A,_,{sourcePath:"extension",overwrite:!0},w),this.logService.info(`Extracted extension to ${_}:`,m.id)}catch(U){try{await b.Promises.rm(_)}catch(O){}throw new E.ExtensionManagementError(U.message,U instanceof h.ExtractError&&U.type?U.type:r)}}async rename(m,A,_,w){try{await b.Promises.rename(A,_)}catch(U){if(S.isWindows&&U&&U.code==="EPERM"&&Date.now()<w)return this.logService.info(`Failed renaming ${A} to ${_} with 'EPERM' error. Trying again...`,m.id),this.rename(m,A,_,w);throw new E.ExtensionManagementError(U.message||(0,p.localize)(3,null,A,_),U.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const m=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return m;const A=this.scanDevSystemExtensions(),[_,w]=await Promise.all([m,A]);return[..._,...w]}async scanExtensionsInDir(m,A){const _=new k.Limiter(10),w=await this.fileService.resolve(C.URI.file(m));return w.children?(await Promise.all(w.children.filter(O=>O.isDirectory).map(O=>_.queue(async()=>A===1&&(0,I.basename)(O.resource).indexOf(".")===0?null:this.scanExtension(O.resource,A))))).filter(O=>O&&O.identifier):[]}async scanExtension(m,A){try{const _=await this.fileService.resolve(m);if(_.children){const{manifest:w,metadata:U}=await this.readManifest(m.fsPath),O=_.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,$=_.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource,K={id:(0,v.getGalleryExtensionId)(w.publisher,w.name)},M={type:A,identifier:K,manifest:w,location:m,readmeUrl:O,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return U&&(this.setMetadata(M,U),M.installedTimestamp=U.installedTimestamp),M}}catch(_){A!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const m=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",m.length),m}async scanDevSystemExtensions(){const m=this.getDevSystemExtensionsList();if(m.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(_=>m.some(w=>(0,v.areSameExtensions)(_.identifier,{id:w})))}else return[]}setMetadata(m,A){m.publisherDisplayName=A.publisherDisplayName||null,m.publisherId=A.publisherId||null,m.identifier.uuid=A.id,m.isMachineScoped=!!A.isMachineScoped,m.isBuiltin=m.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const m=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),_=new Set;for(const O of A)m[new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]||_.add(O.identifier.id.toLowerCase());const w=(0,v.groupByExtension)(A,O=>O.identifier);await k.Promises.settled(w.map(async O=>{const $=O.sort((K,M)=>n.rcompare(K.manifest.version,M.manifest.version))[0];_.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension($)}));const U=A.filter(O=>m[new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]);await k.Promises.settled(U.map(O=>this.removeUninstalledExtension(O)))}async removeOutdatedExtensions(){const m=await this.scanAllUserExtensions(),A=[],_=(0,v.groupByExtension)(m,w=>w.identifier);A.push(...(0,R.flatten)(_.map(w=>w.sort((U,O)=>n.rcompare(U.manifest.version,O.manifest.version)).slice(1)))),await k.Promises.settled(A.map(w=>this.removeExtension(w,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(m=>m.name)}joinErrors(m){const A=Array.isArray(m)?m:[m];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((_,w)=>new Error(`${_.message}${_.message?",":""}${w instanceof Error?w.message:w}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(L.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(m){const A=[b.Promises.readFile(P.join(m,"package.json"),"utf8").then(O=>this.parseManifest(O)),b.Promises.readFile(P.join(m,"package.nls.json"),"utf8").then(void 0,O=>O.code!=="ENOENT"?Promise.reject(O):"{}").then(O=>JSON.parse(O))],[{manifest:_,metadata:w},U]=await Promise.all(A);return{manifest:(0,y.localizeManifest)(_,U),metadata:w}}parseManifest(m){return new Promise((A,_)=>{try{const w=JSON.parse(m),U=w.__metadata||null;A({manifest:w,metadata:U})}catch(w){_(new Error((0,p.localize)(4,null)))}})}};u=he([Q(1,c.IFileService),Q(2,o.ILogService),Q(3,f.INativeEnvironmentService),Q(4,t.IProductService)],u),e.ExtensionsScanner=u}),define(te[231],ne([0,1,38,8,15,9,4,31,16,59,7,30,19,64,129,79,13,197,28,34,173,174,229,162,230,175,76,14,5,10,42,21]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c,o,t,s,i,r,a,l,u,d,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",w="downloading";let U=class extends E.AbstractExtensionManagementService{constructor(j,z,q,F,G,x,N){super(j,z,q);this.environmentService=F,this.downloadService=G,this.fileService=N;const W=this._register(x.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(x.createInstance(i.ExtensionsScanner,Z=>W.postUninstall(Z))),this.manifestCache=this._register(new s.ExtensionsManifestCache(F,this)),this.extensionsDownloader=this._register(x.createInstance(c.ExtensionsDownloader));const X=this._register(new r.ExtensionsWatcher(this,N,F,q));this._register(X.onDidChangeExtensionsByAnotherSource(({added:Z,removed:B})=>{Z.length&&this._onDidInstallExtensions.fire(Z.map(V=>({identifier:V.identifier,operation:0,local:V}))),B.forEach(V=>this._onDidUninstallExtension.fire({identifier:V}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const j=await this.isAlpineLinux(),z=(0,v.getTargetPlatform)(j?"alpine":L.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",z),z})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let j;try{j=(await this.fileService.readFile(n.URI.file("/etc/os-release"))).value.toString()}catch(z){try{j=(await this.fileService.readFile(n.URI.file("/usr/lib/os-release"))).value.toString()}catch(q){this.logService.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(q))}}return!!j&&(j.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const z=await this.collectFiles(j),q=await(0,b.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,z);return n.URI.file(q)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const z=await this.downloadVsix(j),q=T.resolve(z.fsPath);return(0,t.getManifest)(q)}getInstalled(j=null){return this.extensionsScanner.scanExtensions(j)}async install(j,z={}){this.logService.trace("ExtensionManagementService#install",j.toString());const q=await this.downloadVsix(j),F=await(0,t.getManifest)(T.resolve(q.fsPath));if(F.engines&&F.engines.vscode&&!(0,a.isEngineValid)(F.engines.vscode,m.default.version,m.default.date))throw new Error(h.localize(0,null,(0,y.getGalleryExtensionId)(F.publisher,F.name),m.default.version));return this.installExtension(F,q,z)}async updateMetadata(j,z){return this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},...z}),this.manifestCache.invalidate(),j}async updateExtensionScope(j,z){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},isMachineScoped:z}),this.manifestCache.invalidate(),j}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(j){if(j.scheme===D.Schemas.file)return j;const z=(0,S.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(j,z),z}createInstallExtensionTask(j,z,q){return n.URI.isUri(z)?new K(j,z,q,this.galleryService,this.extensionsScanner,this.logService):new $(z,q,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(j,z){return new M(j,z,this.extensionsScanner)}async collectFiles(j){const z=async F=>{let G=await g.Promises.readdir(F);G=G.map(W=>T.join(F,W));const x=await Promise.all(G.map(W=>g.Promises.stat(W)));let N=Promise.resolve([]);return x.forEach((W,X)=>{const Z=G[X];W.isFile()&&(N=N.then(B=>[...B,Z])),W.isDirectory()&&(N=N.then(B=>z(Z).then(V=>[...B,...V])))}),N};return(await z(j.location.fsPath)).map(F=>({path:`extension/${T.relative(j.location.fsPath,F)}`,localPath:F}))}};U=he([Q(0,v.IExtensionGalleryService),Q(1,A.ITelemetryService),Q(2,d.ILogService),Q(3,f.INativeEnvironmentService),Q(4,p.IDownloadService),Q(5,u.IInstantiationService),Q(6,l.IFileService)],U),e.ExtensionManagementService=U;class O extends E.AbstractExtensionTask{constructor(j,z,q,F){super();this.identifier=j,this.source=z,this.extensionsScanner=q,this.logService=F,this._operation=1}get operation(){return this._operation}async installExtension(j,z){try{const q=await this.unsetUninstalledAndGetLocal(j.identifierWithVersion);if(q)return j.metadata?this.extensionsScanner.saveMetadataForLocalExtension(q,j.metadata):q}catch(q){throw L.isMacintosh?new v.ExtensionManagementError(h.localize(1,null),_):new v.ExtensionManagementError(h.localize(2,null),_)}return this.extract(j,z)}async unsetUninstalledAndGetLocal(j){if(!await this.isUninstalled(j))return null;this.logService.trace("Removing the extension from uninstalled list:",j.id);const q=await this.extensionsScanner.setInstalled(j);return this.logService.info("Removed the extension from uninstalled list:",j.id),q}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.key()]}async extract({zipPath:j,identifierWithVersion:z,metadata:q},F){let G=await this.extensionsScanner.extractUserExtension(z,j,q,F);return this.logService.info("Extracting completed.",z.id),G}}class $ extends O{constructor(j,z,q,F,G){super(j.identifier,j,F,G);this.gallery=j,this.options=z,this.extensionsDownloader=q}async doRun(j){const q=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,y.areSameExtensions)(G.identifier,this.gallery.identifier));q&&(this._operation=2);const F=await this.downloadInstallableExtension(this.gallery,this._operation);F.metadata.isMachineScoped=this.options.isMachineScoped||q?.isMachineScoped,F.metadata.isBuiltin=this.options.isBuiltin||q?.isBuiltin;try{const G=await this.installExtension(F,j);return q&&I.neq(q.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(q),G}catch(G){throw await this.deleteDownloadedVSIX(F.zipPath),G}}async deleteDownloadedVSIX(j){try{await this.extensionsDownloader.delete(n.URI.file(j))}catch(z){this.logService.warn("Error while deleting the downloaded vsix",j.toString(),(0,k.getErrorMessage)(z))}}async downloadInstallableExtension(j,z){const q={id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName};let F;try{this.logService.trace("Started downloading extension:",j.identifier.id),F=(await this.extensionsDownloader.downloadExtension(j,z)).fsPath,this.logService.info("Downloaded extension:",j.identifier.id,F)}catch(G){throw new v.ExtensionManagementError((0,E.joinErrors)(G).message,w)}try{const G=await(0,t.getManifest)(F);return{zipPath:F,identifierWithVersion:new y.ExtensionIdentifierWithVersion(j.identifier,G.version),metadata:q}}catch(G){throw await this.deleteDownloadedVSIX(F),new v.ExtensionManagementError((0,E.joinErrors)(G).message,E.INSTALL_ERROR_VALIDATING)}}}class K extends O{constructor(j,z,q,F,G,x){super({id:(0,y.getGalleryExtensionId)(j.publisher,j.name)},z,G,x);this.manifest=j,this.location=z,this.options=q,this.galleryService=F}async doRun(j){const z=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),F=(await this.extensionsScanner.scanExtensions(1)).find(x=>(0,y.areSameExtensions)(this.identifier,x.identifier)),G=await this.getMetadata(this.identifier.id,j);if(G.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||F?.isBuiltin,F)if(this._operation=2,z.equals(new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version)))try{await this.extensionsScanner.removeExtension(F,"existing")}catch(x){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(F.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(F);else{const x=await this.unsetUninstalledAndGetLocal(z);if(x)try{await this.extensionsScanner.removeExtension(x,"existing")}catch(N){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:z,metadata:G},j)}async getMetadata(j,z){try{const q=(await this.galleryService.query({names:[j],pageSize:1},z)).firstPage[0];if(q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId}}catch(q){}return{}}}class M extends E.AbstractExtensionTask{constructor(j,z,q){super();this.extension=j,this.options=z,this.extensionsScanner=q}async doRun(j){const z=[],q=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const F=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);z.push(...q.filter(G=>F.equals(new y.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version))))}else z.push(...q.filter(F=>(0,y.areSameExtensions)(F.identifier,this.extension.identifier)));if(!z.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...z),this.options.remove)for(const F of z)try{j.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(F)}catch(G){throw new Error(h.localize(6,null,(0,R.toErrorMessage)(G)))}}}}),define(te[232],ne([0,1,83,56,32,22,8,3,2,9,4,30,33,72,240]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(u){this.socket=u,this._errorListener=d=>{if(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const d=m=>u(T.VSBuffer.wrap(m));return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(u){const d=m=>{u({type:0,hadError:m,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}}end(){this.socket.end()}drain(){return new Promise((u,d)=>{if(this.socket.bufferSize===0){u();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),u()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=p;var f;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var E;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(E||(E={}));class v extends S.Disposable{constructor(u,d,m,A){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=d,this._recordInflateBytes=A,d?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,L.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),m&&(this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,L.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):T.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let d=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.length-4),this._isEnded||this._write(T.VSBuffer.wrap(d),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,d){let m=2;u.byteLength<126?m+=0:u.byteLength<2**16?m+=2:m+=8;const A=T.VSBuffer.alloc(m);if(d?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let _=1;A.writeUInt8(u.byteLength>>>8&255,++_),A.writeUInt8(u.byteLength>>>0&255,++_)}else{A.writeUInt8(127,1);let _=1;A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(u.byteLength>>>24&255,++_),A.writeUInt8(u.byteLength>>>16&255,++_),A.writeUInt8(u.byteLength>>>8&255,++_),A.writeUInt8(u.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(T.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),m=d.readUInt8(0),A=(m&128)>>>7,_=(m&64)>>>6,w=d.readUInt8(1),U=(w&128)>>>7,O=w&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),m=d.readUInt8(1),A=(m&128)>>>7;let _=m&127,w=1;_===126?_=d.readUInt8(++w)*2**8+d.readUInt8(++w):_===127&&(_=d.readUInt8(++w)*0+d.readUInt8(++w)*0+d.readUInt8(++w)*0+d.readUInt8(++w)*0+d.readUInt8(++w)*2**24+d.readUInt8(++w)*2**16+d.readUInt8(++w)*2**8+d.readUInt8(++w));let U=0;A&&(U=d.readUInt8(++w)*2**24+d.readUInt8(++w)*2**16+d.readUInt8(++w)*2**8+d.readUInt8(++w)),this._state.state=3,this._state.readLen=_,this._state.mask=U}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);y(d,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(d.buffer)),this._zlibInflate.write(d.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const m=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=m.length,this._onData.fire(T.VSBuffer.wrap(m))})):(this._totalIncomingDataBytes+=d.byteLength,this._onData.fire(d))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function y(l,u){if(u===0)return;let d=l.byteLength>>>2;for(let O=0;O<d;O++){const $=l.readUInt32BE(O*4);l.writeUInt32BE($^u,O*4)}let m=d*4,A=l.byteLength-m;const _=u>>>24&255,w=u>>>16&255,U=u>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(m)^_,m),A>=2&&l.writeUInt8(l.readUInt8(m+1)^w,m+1),A>=3&&l.writeUInt8(l.readUInt8(m+2)^U,m+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function o(){const l=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):u=(0,I.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),s(u),u}e.createRandomIPCHandle=o;function t(l,u,d){const m=(0,R.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${d}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${d}-${u}.sock`):A=(0,I.join)(l,`${d}-${u}.sock`),s(A),A}e.createStaticIPCHandle=t;function s(l){const u=c[n.platform];typeof u=="number"&&l.length>=u&&console.warn(`WARNING: IPC handle "${l}" is longer than ${u} chars, try a shorter --user-data-dir`)}class i extends g.IPCServer{constructor(u){super(i.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const d=P.Event.fromNodeEventEmitter(u,"connection");return P.Event.map(d,m=>({protocol:new b.Protocol(new p(m)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(m,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(l){return new Promise((u,d)=>{const m=(0,k.createServer)();m.on("error",d),m.listen(l,()=>{m.removeListener("error",d),u(new i(m))})})}e.serve=r;function a(l,u){return new Promise((d,m)=>{const A=(0,k.createConnection)(l,()=>{A.removeListener("error",m),d(b.Client.fromSocket(new p(A),u))});A.once("error",m)})}e.connect=a}),define(te[233],ne([0,1,56,232]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,T,L,P){const S=n=>P(n,void 0),I=R.createConnection({host:D,port:T},()=>{I.removeListener("error",S);const n=Buffer.alloc(16);for(let h=0;h<16;h++)n[h]=Math.round(Math.random()*256);const C=n.toString("base64");let g=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${T}/?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`];I.write(g.join(`\r
`)+`\r
\r
`);const b=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",b),P(void 0,new k.NodeSocket(I)))};I.on("data",b)});I.once("error",S)}}}),define(te[234],ne([0,1,56,111,233,6,2,20,10,29,185,61,90]),function(J,e,R,k,D,T,L,P,S,I,n,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function b(E,v,y,c,o){return new h(E,v,y,c,o).waitForReady()}class h extends L.Disposable{constructor(v,y,c,o,t){super();this.defaultTunnelHost=y,this.suggestedLocalPort=t,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=v,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(y=>{y()})}async waitForReady(){let v=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),y=null;return this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address(),y||(v=0,this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address()),this.tunnelLocalPort=y.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${y.port}`,this}async _onConnection(v){v.pause();const y=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,n.connectRemoteAgentTunnel)(this._options,y,this.tunnelRemotePort),o=c.getSocket().socket,t=c.readEntireBuffer();c.dispose(),t.byteLength>0&&v.write(t.buffer),v.on("end",()=>{this._socketsDispose.delete(v.localAddress),o.end()}),v.on("close",()=>o.end()),v.on("error",()=>{this._socketsDispose.delete(v.localAddress),o.destroy()}),o.on("end",()=>v.end()),o.on("close",()=>v.end()),o.on("error",()=>{v.destroy()}),v.pipe(o),o.pipe(v),this._socketsDispose.set(v.localAddress,()=>{v.end(),o.end()})}}let p=class extends C.AbstractTunnelService{constructor(v,y,c,o,t){super(y);this.socketFactory=v,this.signService=c,this.productService=o,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(v,y,c,o,t,s,i){const r=this.getTunnelFromMap(y,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,y,c,o,t,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${y}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:v,signService:this.signService,logService:this.logService,ipcLogger:null},l=b(a,this.defaultTunnelHost,y,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(y,c,l),l}}};p=he([Q(1,S.ILogService),Q(2,g.ISignService),Q(3,I.IProductService),Q(4,P.IConfigurationService)],p),e.BaseTunnelService=p;let f=class extends p{constructor(v,y,c,o){super(D.nodeSocketFactory,v,y,c,o)}};f=he([Q(0,S.ILogService),Q(1,g.ISignService),Q(2,I.IProductService),Q(3,P.IConfigurationService)],f),e.TunnelService=f}),define(te[241],ne([0,1,116,51,242,32,38,8,2,15,16,7,33,115,181,160,182,170,171,172,158,163,20,183,78,196,79,189,13,149,192,199,28,161,198,231,80,152,14,178,180,53,5,167,85,168,169,58,177,10,86,60,42,29,188,43,23,194,195,21,91,92,93,46,200,201,94,203,209,96,97,98,24,62,220,221,222,63,223,224,225,226,227,228,81,176,90,191,61,234,186,187]),function(J,e,R,k,D,T,L,P,S,I,n,C,g,b,h,p,f,E,v,y,c,o,t,s,i,r,a,l,u,d,m,A,_,w,U,O,$,K,M,H,j,z,q,F,G,x,N,W,X,Z,B,V,ie,re,ae,ue,fe,ge,Ie,Pe,Ee,_e,De,ke,Fe,Ne,ze,xe,ee,oe,ce,ye,Se,Oe,Te,Ue,Ae,Y,se,le,de,me,be,pe,we,Ce,Re,Le,nt,He,je,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Et extends S.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new b.Server),(0,D.gracefulify)(k),this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve)}async open(){const ve=await this.initServices();(0,Se.registerConfiguration)(),ve.invokeFunction(Me=>{const qe=Me.get(Z.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(qe)}),this._register((0,S.combinedDisposable)(ve.createInstance(h.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(f.LanguagePackCachedDataCleaner),ve.createInstance(y.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(E.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new G.ServiceCollection,Me={_serviceBrand:void 0,...ie.default};ve.set(re.IProductService,Me);const qe=new g.StaticRouter(Ye=>Ye==="main"),Je=new x.MessagePortMainProcessService(this.server,qe);ve.set(N.IMainProcessService,Je);const $e=new d.NativeEnvironmentService(this.configuration.args,Me);ve.set(u.INativeEnvironmentService,$e);const it=new B.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Xe=new B.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const at=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,n.joinPath)(C.URI.file($e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new B.FollowerLogService(it,at));ve.set(Z.ILogService,Ge);const Qe=this._register(new H.FileService(Ge));ve.set(M.IFileService,Qe);const ot=this._register(new j.DiskFileSystemProvider(Ge));Qe.registerProvider(I.Schemas.file,ot);const Be=this._register(new s.ConfigurationService($e.settingsResource,Qe));ve.set(t.IConfigurationService,Be),await Be.initialize();const et=new ge.NativeStorageService(void 0,Je,$e);ve.set(fe.IStorageService,et),await et.initialize(),this._register((0,S.toDisposable)(()=>et.flush())),ve.set(ue.IRequestService,new z.SyncDescriptor(ae.RequestService)),ve.set(c.IChecksumService,new z.SyncDescriptor(o.ChecksumService));const rt=g.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(V.INativeHostService,rt),ve.set(a.IDownloadService,new z.SyncDescriptor(l.DownloadService));const ct=this._register(new pe.ActiveWindowManager(rt)),lt=new g.StaticRouter(Ye=>ct.getActiveClientId().then(ht=>Ye===ht));ve.set($.IExtensionRecommendationNotificationService,new K.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Ke,st;const ut=[];if((0,ke.supportsTelemetry)(Me,$e)){st=new _e.TelemetryLogAppender(Xe,$e),ut.push(st);const{appRoot:Ye,extensionsPath:ht,installSourcePath:Ct}=$e;if(Me.aiConfig&&Me.aiConfig.asimovKey){const mt=new Fe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,S.toDisposable)(()=>mt.flush())),ut.push(mt)}Ke=new De.TelemetryService({appenders:ut,commonProperties:(0,Ie.resolveCommonProperties)(Qe,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ct),sendErrorTelemetry:!0,piiPaths:[Ye,ht]},Be)}else Ke=ke.NullTelemetryService,st=ke.NullAppender;this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(st)),ve.set(Pe.ITelemetryService,Ke);const It=new Ne.CustomEndpointTelemetryService(Be,Ke,Xe,$e);return ve.set(Pe.ICustomEndpointTelemetryService,It),ve.set(_.IExtensionManagementService,new z.SyncDescriptor(O.ExtensionManagementService)),ve.set(_.IExtensionGalleryService,new z.SyncDescriptor(A.ExtensionGalleryService)),ve.set(_.IExtensionTipsService,new z.SyncDescriptor(U.ExtensionTipsService)),ve.set(W.ILocalizationsService,new z.SyncDescriptor(X.LocalizationsService)),ve.set(i.IDiagnosticsService,new z.SyncDescriptor(r.DiagnosticsService)),ve.set(Oe.IUserDataSyncAccountService,new z.SyncDescriptor(Oe.UserDataSyncAccountService)),ve.set(Se.IUserDataSyncLogService,new z.SyncDescriptor(Ae.UserDataSyncLogService)),ve.set(Se.IUserDataSyncUtilService,new Ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ve.set(_.IGlobalExtensionEnablementService,new z.SyncDescriptor(m.GlobalExtensionEnablementService)),ve.set(ce.IIgnoredExtensionsManagementService,new z.SyncDescriptor(ce.IgnoredExtensionsManagementService)),ve.set(oe.IExtensionsStorageSyncService,new z.SyncDescriptor(oe.ExtensionsStorageSyncService)),ve.set(Se.IUserDataSyncStoreManagementService,new z.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(Se.IUserDataSyncStoreService,new z.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new z.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(Se.IUserDataSyncBackupStoreService,new z.SyncDescriptor(Te.UserDataSyncBackupStoreService)),ve.set(Se.IUserDataAutoSyncEnablementService,new z.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),ve.set(Se.IUserDataSyncResourceEnablementService,new z.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(Se.IUserDataSyncService,new z.SyncDescriptor(le.UserDataSyncService)),ve.set(xe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,$e,Ge,Ke))),ve.set(we.IExtensionHostStarter,this._register(new Ce.ExtensionHostStarter(Ge))),ve.set(Re.ISignService,new z.SyncDescriptor(Le.SignService)),ve.set(nt.ITunnelService,new z.SyncDescriptor(He.TunnelService)),ve.set(je.ISharedProcessTunnelService,new z.SyncDescriptor(wt.SharedProcessTunnelService)),new F.InstantiationService(ve)}initChannels(ve){const Me=new w.ExtensionManagementChannel(ve.get(_.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const qe=g.ProxyChannel.fromService(ve.get(W.ILocalizationsService));this.server.registerChannel("localizations",qe);const Je=g.ProxyChannel.fromService(ve.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const $e=new w.ExtensionTipsChannel(ve.get(_.IExtensionTipsService));this.server.registerChannel("extensionTipsService",$e);const it=g.ProxyChannel.fromService(ve.get(c.IChecksumService));this.server.registerChannel("checksum",it);const Xe=new Ue.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Xe);const at=g.ProxyChannel.fromService(ve.get(Pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ge=new Ue.UserDataSyncAccountServiceChannel(ve.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Qe=new Ue.UserDataSyncStoreManagementServiceChannel(ve.get(Se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ot=new de.UserDataSyncChannel(ve.get(Se.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ot);const Be=this._register(ve.get(q.IInstantiationService).createInstance(be.UserDataAutoSyncService)),et=new Ue.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",et);const rt=ve.get(xe.ILocalPtyService),ct=g.ProxyChannel.fromService(rt);this.server.registerChannel(ze.TerminalIpcChannels.LocalPty,ct);const lt=g.ProxyChannel.fromService(ve.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,lt);const Ke=g.ProxyChannel.fromService(ve.get(je.ISharedProcessTunnelService));this.server.registerChannel(je.ipcSharedProcessTunnelChannelName,Ke)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,P.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Me=>{const qe=(0,L.toErrorMessage)(Me,!0);!qe||ve.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function bt(gt){const ve=new Et(gt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=bt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/214ac689ca9874a8a4be386f73d5cb60e15af25e/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
