/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/extpath","fs","vs/base/common/process","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function(V){for(var e=[],p=0,L=V.length;p<L;p++)e[p]=Z[V[p]];return e};define(Z[103],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=p}),define(Z[47],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(b){return(n,f,w)=>{let t=null,P=null;if(typeof w.value=="function"?(t="value",P=w.value):typeof w.get=="function"&&(t="get",P=w.get),!P)throw new Error("not supported");w[t]=b(P,f)}}e.createDecorator=p;function L(b,n,f){let w=null,t=null;if(typeof f.value=="function"?(w="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",t=f.get),!t)throw new Error("not supported");const P=`$memoize$${n}`;f[w]=function(...I){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,I)}),this[P]}}e.memoize=L;function k(b,n,f){return p((w,t)=>{const P=`$debounce$${t}`,I=`$debounce$result$${t}`;return function(...y){this[I]||(this[I]=f?f():void 0),clearTimeout(this[P]),n&&(this[I]=n(this[I],...y),y=[this[I]]),this[P]=setTimeout(()=>{w.apply(this,y),this[I]=f?f():void 0},b)}})}e.debounce=k;function M(b,n,f){return p((w,t)=>{const P=`$throttle$timer$${t}`,I=`$throttle$result$${t}`,y=`$throttle$lastRun$${t}`,d=`$throttle$pending$${t}`;return function(...g){if(this[I]||(this[I]=f?f():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[I]=n(this[I],...g)),this[d])return;const E=this[y]+b;E<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[I]]),this[I]=f?f():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),w.apply(this,[this[I]]),this[I]=f?f():void 0},E-Date.now()))}})}e.throttle=M}),define(Z[17],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(l=>{l(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=p,e.errorHandler=new p;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function k(u){f(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=k;function M(u){f(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function b(u){if(u instanceof Error){let{name:i,message:l}=u;const r=u.stacktrace||u.stack;return{$isError:!0,name:i,message:l,stack:r}}return u}e.transformErrorForSerialization=b;const n="Canceled";function f(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function t(){const u=new Error(n);return u.name=u.message,u}e.canceled=t;function P(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=P;function I(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=I;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(u){const i=new Error(`${u} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class E extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=E;class v extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=v;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(u){const i=u;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=h;function a(u,i=Object.create(null)){const l=new Error(u);return i.actions&&(l.actions=i.actions),l}e.createErrorWithActions=a}),define(Z[30],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(A,F=0){return A[A.length-(1+F)]}e.tail=L;function k(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=k;function M(A,F,B=(Y,_)=>Y===_){if(A===F)return!0;if(!A||!F||A.length!==F.length)return!1;for(let Y=0,_=A.length;Y<_;Y++)if(!B(A[Y],F[Y]))return!1;return!0}e.equals=M;function b(A,F,B){let Y=0,_=A.length-1;for(;Y<=_;){const N=(Y+_)/2|0,Q=B(A[N],F);if(Q<0)Y=N+1;else if(Q>0)_=N-1;else return N}return-(Y+1)}e.binarySearch=b;function n(A,F){let B=0,Y=A.length;if(Y===0)return 0;for(;B<Y;){const _=Math.floor((B+Y)/2);F(A[_])?Y=_:B=_+1}return B}e.findFirstInSorted=n;function f(A,F,B){if(A=A|0,A>=F.length)throw new TypeError("invalid index");let Y=F[Math.floor(F.length*Math.random())],_=[],N=[],Q=[];for(let J of F){const re=B(J,Y);re<0?_.push(J):re>0?N.push(J):Q.push(J)}return A<_.length?f(A,_,B):A<_.length+Q.length?Q[0]:f(A-(_.length+Q.length),N,B)}e.quickSelect=f;function w(A,F){const B=[];let Y;for(const _ of A.slice(0).sort(F))!Y||F(Y[0],_)!==0?(Y=[_],B.push(Y)):Y.push(_);return B}e.groupBy=w;function t(A,F,B){const Y=[];function _(J,re,le){if(re===0&&le.length===0)return;const te=Y[Y.length-1];te&&te.start+te.deleteCount===J?(te.deleteCount+=re,te.toInsert.push(...le)):Y.push({start:J,deleteCount:re,toInsert:le})}let N=0,Q=0;for(;;){if(N===A.length){_(N,0,F.slice(Q));break}if(Q===F.length){_(N,A.length-N,[]);break}const J=A[N],re=F[Q],le=B(J,re);le===0?(N+=1,Q+=1):le<0?(_(N,1,[]),N+=1):le>0&&(_(N,0,[re]),Q+=1)}return Y}e.sortedDiff=t;function P(A,F,B){const Y=t(A,F,B),_=[],N=[];for(const Q of Y)_.push(...A.slice(Q.start,Q.start+Q.deleteCount)),N.push(...Q.toInsert);return{removed:_,added:N}}e.delta=P;function I(A,F,B){if(B===0)return[];const Y=A.slice(0,B).sort(F);return d(A,F,Y,B,A.length),Y}e.top=I;function y(A,F,B,Y,_){return B===0?Promise.resolve([]):new Promise((N,Q)=>{(async()=>{const J=A.length,re=A.slice(0,B).sort(F);for(let le=B,te=Math.min(B+Y,J);le<J;le=te,te=Math.min(te+Y,J)){if(le>B&&await new Promise(ae=>setTimeout(ae)),_&&_.isCancellationRequested)throw(0,p.canceled)();d(A,F,re,le,te)}return re})().then(N,Q)})}e.topAsync=y;function d(A,F,B,Y,_){for(const N=B.length;Y<_;Y++){const Q=A[Y];if(F(Q,B[N-1])<0){B.pop();const J=n(B,re=>F(Q,re)<0);B.splice(J,0,Q)}}}function g(A){return A.filter(F=>!!F)}e.coalesce=g;function E(A){let F=0;for(let B=0;B<A.length;B++)A[B]&&(A[F]=A[B],F+=1);A.length=F}e.coalesceInPlace=E;function v(A,F,B){A.splice(B,0,A.splice(F,1)[0])}e.move=v;function c(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=c;function h(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=h;function a(A,F){if(!F)return A.filter((Y,_)=>A.indexOf(Y)===_);const B=Object.create(null);return A.filter(Y=>{const _=F(Y);return B[_]?!1:(B[_]=!0,!0)})}e.distinct=a;function u(A){const F=new Set;return A.filter(B=>F.has(B)?!1:(F.add(B),!0))}e.distinctES6=u;function i(A){const F=Object.create(null);return B=>{const Y=A(B);return F[Y]?!1:(F[Y]=!0,!0)}}e.uniqueFilter=i;function l(A,F){const B=r(A,F);if(B!==-1)return A[B]}e.findLast=l;function r(A,F){for(let B=A.length-1;B>=0;B--){const Y=A[B];if(F(Y))return B}return-1}e.lastIndex=r;function s(A,F){return A.length>0?A[0]:F}e.firstOrDefault=s;function o(A,F,B=(Y,_)=>Y===_){let Y=0;for(let _=0,N=Math.min(A.length,F.length);_<N&&B(A[_],F[_]);_++)Y++;return Y}e.commonPrefixLength=o;function m(A){return[].concat(...A)}e.flatten=m;function S(A,F){let B=typeof F=="number"?A:0;typeof F=="number"?B=A:(B=0,F=A);const Y=[];if(B<=F)for(let _=B;_<F;_++)Y.push(_);else for(let _=B;_>F;_--)Y.push(_);return Y}e.range=S;function D(A,F,B){return A.reduce((Y,_)=>(Y[F(_)]=B?B(_):_,Y),Object.create(null))}e.index=D;function R(A,F){return A.push(F),()=>T(A,F)}e.insert=R;function T(A,F){const B=A.indexOf(F);if(B>-1)return A.splice(B,1),F}e.remove=T;function C(A,F,B){const Y=A.slice(0,F),_=A.slice(F);return Y.concat(B,_)}e.arrayInsert=C;function G(A,F){let B;if(typeof F=="number"){let Y=F;B=()=>{const _=Math.sin(Y++)*179426549;return _-Math.floor(_)}}else B=Math.random;for(let Y=A.length-1;Y>0;Y-=1){const _=Math.floor(B()*(Y+1)),N=A[Y];A[Y]=A[_],A[_]=N}}e.shuffle=G;function ne(A,F){const B=A.indexOf(F);B>-1&&(A.splice(B,1),A.unshift(F))}e.pushToStart=ne;function oe(A,F){const B=A.indexOf(F);B>-1&&(A.splice(B,1),A.push(F))}e.pushToEnd=oe;function K(A,F){return Array.isArray(A)?A.map(F):F(A)}e.mapArrayOrNot=K;function ee(A){return Array.isArray(A)?A:[A]}e.asArray=ee;function O(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=O;function j(A,F){for(const B of A){const Y=F(B);if(Y!==void 0)return Y}}e.mapFind=j;function $(A,F,B){const Y=H(A,F),_=A.length,N=B.length;A.length=_+N;for(let Q=_-1;Q>=Y;Q--)A[Q+N]=A[Q];for(let Q=0;Q<N;Q++)A[Q+Y]=B[Q]}e.insertInto=$;function z(A,F,B,Y){const _=H(A,F),N=A.splice(_,B);return $(A,_,Y),N}e.splice=z;function H(A,F){return F<0?Math.max(F+A.length,0):Math.min(F,A.length)}function W(A,F){let B=Number.MAX_SAFE_INTEGER,Y=0;return A.forEach((_,N)=>{const Q=F(_);Q<B&&(B=Q,Y=N)}),Y}e.minIndex=W;function q(A,F){let B=Number.MIN_SAFE_INTEGER,Y=0;return A.forEach((_,N)=>{const Q=F(_);Q>B&&(B=Q,Y=N)}),Y}e.maxIndex=q;class U{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let B=this.firstIdx;for(;B<this.items.length&&F(this.items[B]);)B++;const Y=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,Y}takeFromEndWhile(F){let B=this.lastIdx;for(;B>=0&&F(this.items[B]);)B--;const Y=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,Y}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=U}),define(Z[43],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const k=this;let M=!1,b;return function(){return M||(M=!0,b=L.apply(k,arguments)),b}}e.once=p}),define(Z[64],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function k(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function b(){return M}L.empty=b;function*n(u){yield u}L.single=n;function f(u){return u||M}L.from=f;function w(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=w;function t(u){return u[Symbol.iterator]().next().value}L.first=t;function P(u,i){for(const l of u)if(i(l))return!0;return!1}L.some=P;function I(u,i){for(const l of u)if(i(l))return l}L.find=I;function*y(u,i){for(const l of u)i(l)&&(yield l)}L.filter=y;function*d(u,i){let l=0;for(const r of u)yield i(r,l++)}L.map=d;function*g(...u){for(const i of u)for(const l of i)yield l}L.concat=g;function*E(u){for(const i of u)for(const l of i)yield l}L.concatNested=E;function v(u,i,l){let r=l;for(const s of u)r=i(r,s);return r}L.reduce=v;function*c(u,i,l=u.length){for(i<0&&(i+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);i<l;i++)yield u[i]}L.slice=c;function h(u,i=Number.POSITIVE_INFINITY){const l=[];if(i===0)return[l,u];const r=u[Symbol.iterator]();for(let s=0;s<i;s++){const o=r.next();if(o.done)return[l,L.empty()];l.push(o.value)}return[l,{[Symbol.iterator](){return r}}]}L.consume=h;function a(u,i,l=(r,s)=>r===s){const r=u[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const o=r.next(),m=s.next();if(o.done!==m.done)return!1;if(o.done)return!0;if(!l(o.value,m.value))return!1}}L.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function b(i,l=!1){let r=0,s=i.length,o="",m=0,S=16,D=0;function R(ee){let O=0,j=0;for(;O<ee;){const $=i.charCodeAt(r);if($>=48&&$<=57)j=j*16+$-48;else if($>=65&&$<=70)j=j*16+$-65+10;else if($>=97&&$<=102)j=j*16+$-97+10;else break;r++,O++}return O<ee&&(j=-1),j}function T(ee){r=ee,o="",m=0,S=16,D=0}function C(){const ee=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&w(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&w(i.charCodeAt(r)))for(r++;r<i.length&&w(i.charCodeAt(r));)r++;else return D=3,i.substring(ee,r);let O=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&w(i.charCodeAt(r))){for(r++;r<i.length&&w(i.charCodeAt(r));)r++;O=r}else D=3;return i.substring(ee,O)}function G(){let ee="",O=r;for(;;){if(r>=s){ee+=i.substring(O,r),D=2;break}const j=i.charCodeAt(r);if(j===34){ee+=i.substring(O,r),r++;break}if(j===92){if(ee+=i.substring(O,r),r++,r>=s){D=2;break}switch(i.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const z=R(4);z>=0?ee+=String.fromCharCode(z):D=4;break;default:D=5}O=r;continue}if(j>=0&&j<=31)if(f(j)){ee+=i.substring(O,r),D=2;break}else D=6;r++}return ee}function ne(){if(o="",D=0,m=r,r>=s)return m=s,S=17;let ee=i.charCodeAt(r);if(n(ee)){do r++,o+=String.fromCharCode(ee),ee=i.charCodeAt(r);while(n(ee));return S=15}if(f(ee))return r++,o+=String.fromCharCode(ee),ee===13&&i.charCodeAt(r)===10&&(r++,o+=`
`),S=14;switch(ee){case 123:return r++,S=1;case 125:return r++,S=2;case 91:return r++,S=3;case 93:return r++,S=4;case 58:return r++,S=6;case 44:return r++,S=5;case 34:return r++,o=G(),S=10;case 47:const O=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!f(i.charCodeAt(r));)r++;return o=i.substring(O,r),S=12}if(i.charCodeAt(r+1)===42){r+=2;const j=s-1;let $=!1;for(;r<j;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,D=1),o=i.substring(O,r),S=13}return o+=String.fromCharCode(ee),r++,S=16;case 45:if(o+=String.fromCharCode(ee),r++,r===s||!w(i.charCodeAt(r)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=C(),S=11;default:for(;r<s&&oe(ee);)r++,ee=i.charCodeAt(r);if(m!==r){switch(o=i.substring(m,r),o){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return o+=String.fromCharCode(ee),r++,S=16}}function oe(ee){if(n(ee)||f(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ee;do ee=ne();while(ee>=12&&ee<=15);return ee}return{setPosition:T,getPosition:()=>r,scan:l?K:ne,getToken:()=>S,getTokenValue:()=>o,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>D}}e.createScanner=b;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function P(i,l){const r=[],s=new Object;let o;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(R,T,C,G){m.value=R,m.offset=T,m.length=C,m.type=G,m.colonOffset=void 0,o=m}try{h(i,{onObjectBegin:(R,T)=>{if(l<=R)throw s;o=void 0,S=l>R,r.push("")},onObjectProperty:(R,T,C)=>{if(l<T||(D(R,T,C,"property"),r[r.length-1]=R,l<=T+C))throw s},onObjectEnd:(R,T)=>{if(l<=R)throw s;o=void 0,r.pop()},onArrayBegin:(R,T)=>{if(l<=R)throw s;o=void 0,r.push(0)},onArrayEnd:(R,T)=>{if(l<=R)throw s;o=void 0,r.pop()},onLiteralValue:(R,T,C)=>{if(l<T||(D(R,T,C,u(R)),l<=T+C))throw s},onSeparator:(R,T,C)=>{if(l<=T)throw s;if(R===":"&&o&&o.type==="property")o.colonOffset=T,S=!1,o=void 0;else if(R===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(S=!0,r[r.length-1]=""),o=void 0}}})}catch(R){if(R!==s)throw R}return{path:r,previousNode:o,isAtPropertyKey:S,matches:R=>{let T=0;for(let C=0;T<R.length&&C<r.length;C++)if(R[T]===r[C]||R[T]==="*")T++;else if(R[T]!=="**")return!1;return T===R.length}}}e.getLocation=P;function I(i,l=[],r=M.DEFAULT){let s=null,o=[];const m=[];function S(R){Array.isArray(o)?o.push(R):s!==null&&(o[s]=R)}return h(i,{onObjectBegin:()=>{const R={};S(R),m.push(o),o=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const R=[];S(R),m.push(o),o=R,s=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:S,onError:(R,T,C)=>{l.push({error:R,offset:T,length:C})}},r),o[0]}e.parse=I;function y(i,l=[],r=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function m(R){return s.children.push(R),R}h(i,{onObjectBegin:R=>{s=m({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,T,C)=>{s=m({type:"property",offset:T,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:T,length:C,parent:s})},onObjectEnd:(R,T)=>{s.length=R+T-s.offset,s=s.parent,o(R+T)},onArrayBegin:(R,T)=>{s=m({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,T)=>{s.length=R+T-s.offset,s=s.parent,o(R+T)},onLiteralValue:(R,T,C)=>{m({type:u(R),offset:T,length:C,parent:s,value:R}),o(T+C)},onSeparator:(R,T,C)=>{s.type==="property"&&(R===":"?s.colonOffset=T:R===","&&o(T))},onError:(R,T,C)=>{l.push({error:R,offset:T,length:C})}},r);const D=s.children[0];return D&&delete D.parent,D}e.parseTree=y;function d(i,l){if(!i)return;let r=i;for(let s of l)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===s){r=m.children[1],o=!0;break}if(!o)return}else{const o=s;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=d;function g(i){if(!i.parent||!i.parent.children)return[];const l=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}e.getNodePath=g;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":const l=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(l[r.children[0].value]=E(s))}return l;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function v(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}e.contains=v;function c(i,l,r=!1){if(v(i,l,r)){const s=i.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=l;o++){const m=c(s[o],l,r);if(m)return m}return i}}e.findNodeAtOffset=c;function h(i,l,r=M.DEFAULT){const s=b(i,!1);function o(F){return F?()=>F(s.getTokenOffset(),s.getTokenLength()):()=>!0}function m(F){return F?B=>F(B,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=o(l.onObjectBegin),D=m(l.onObjectProperty),R=o(l.onObjectEnd),T=o(l.onArrayBegin),C=o(l.onArrayEnd),G=m(l.onLiteralValue),ne=m(l.onSeparator),oe=o(l.onComment),K=m(l.onError),ee=r&&r.disallowComments,O=r&&r.allowTrailingComma;function j(){for(;;){const F=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:ee||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(F){case 12:case 13:ee?$(10):oe();break;case 16:$(1);break;case 15:case 14:break;default:return F}}}function $(F,B=[],Y=[]){if(K(F),B.length+Y.length>0){let _=s.getToken();for(;_!==17;){if(B.indexOf(_)!==-1){j();break}else if(Y.indexOf(_)!==-1)break;_=j()}}}function z(F){const B=s.getTokenValue();return F?G(B):D(B),j(),!0}function H(){switch(s.getToken()){case 11:let F=0;try{F=JSON.parse(s.getTokenValue()),typeof F!="number"&&($(2),F=0)}catch(B){$(2)}G(F);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return j(),!0}function W(){return s.getToken()!==10?($(3,[],[2,5]),!1):(z(!1),s.getToken()===6?(ne(":"),j(),A()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function q(){S(),j();let F=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(F||$(4,[],[]),ne(","),j(),s.getToken()===2&&O)break}else F&&$(6,[],[]);W()||$(4,[],[2,5]),F=!0}return R(),s.getToken()!==2?$(7,[2],[]):j(),!0}function U(){T(),j();let F=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(F||$(4,[],[]),ne(","),j(),s.getToken()===4&&O)break}else F&&$(6,[],[]);A()||$(4,[],[4,5]),F=!0}return C(),s.getToken()!==4?$(8,[4],[]):j(),!0}function A(){switch(s.getToken()){case 3:return U();case 1:return q();case 10:return z(!0);default:return H()}}return j(),s.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):A()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=h;function a(i,l){let r=b(i),s=[],o,m=0,S;do switch(S=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:m!==S&&s.push(i.substring(m,S)),l!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,l)),m=r.getPosition();break}while(o!==17);return s.join("")}e.stripComments=a;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[104],x([0,1,40]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,t){let P,I,y,d,g;if(w){for(d=w.offset,g=d+w.length,y=d;y>0&&!n(f,y-1);)y--;let m=g;for(;m<f.length&&!n(f,m);)m++;I=f.substring(y,m),P=M(I,t)}else I=f,P=0,y=0,d=0,g=f.length;const E=b(t,f);let v=!1,c=0,h;t.insertSpaces?h=k(" ",t.tabSize||4):h="	";const a=(0,p.createScanner)(I,!1);let u=!1;function i(){return E+k(h,P+c)}function l(){let m=a.scan();for(v=!1;m===15||m===14;)v=v||m===14,m=a.scan();return u=m===16||a.getTokenError()!==0,m}const r=[];function s(m,S,D){!u&&S<g&&D>d&&f.substring(S,D)!==m&&r.push({offset:S,length:D-S,content:m})}let o=l();if(o!==17){const m=a.getTokenOffset()+y,S=k(h,P);s(S,y,m)}for(;o!==17;){let m=a.getTokenOffset()+a.getTokenLength()+y,S=l(),D="";for(;!v&&(S===12||S===13);){const T=a.getTokenOffset()+y;s(" ",m,T),m=a.getTokenOffset()+a.getTokenLength()+y,D=S===12?i():"",S=l()}if(S===2)o!==1&&(c--,D=i());else if(S===4)o!==3&&(c--,D=i());else{switch(o){case 3:case 1:c++,D=i();break;case 5:case 12:D=i();break;case 13:v?D=i():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(u=!0);break;case 16:u=!0;break}v&&(S===12||S===13)&&(D=i())}const R=a.getTokenOffset()+y;s(D,m,R),o=S}return r}e.format=L;function k(f,w){let t="";for(let P=0;P<w;P++)t+=f;return t}function M(f,w){let t=0,P=0;const I=w.tabSize||4;for(;t<f.length;){const y=f.charAt(t);if(y===" ")P++;else if(y==="	")P+=I;else break;t++}return Math.floor(P/I)}function b(f,w){for(let t=0;t<w.length;t++){const P=w.charAt(t);if(P==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=b;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Z[77],x([0,1,40,104]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,t,P){return M(w,t,void 0,P)}e.removeProperty=k;function M(w,t,P,I,y){const d=t.slice(),g=[],E=(0,p.parseTree)(w,g);let v,c;for(;d.length>0&&(c=d.pop(),v=(0,p.findNodeAtLocation)(E,d),v===void 0&&P!==void 0);)typeof c=="string"?P={[c]:P}:P=[P];if(v)if(v.type==="object"&&typeof c=="string"&&Array.isArray(v.children)){const h=(0,p.findNodeAtLocation)(v,[c]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const a=v.children.indexOf(h.parent);let u,i=h.parent.offset+h.parent.length;if(a>0){const l=v.children[a-1];u=l.offset+l.length}else u=v.offset+1,v.children.length>1&&(i=v.children[1].offset);return b(w,{offset:u,length:i-u,content:""},I)}else return b(w,{offset:h.offset,length:h.length,content:JSON.stringify(P)},I);else{if(P===void 0)return[];const a=`${JSON.stringify(c)}: ${JSON.stringify(P)}`,u=y?y(v.children.map(l=>l.children[0].value)):v.children.length;let i;if(u>0){const l=v.children[u-1];i={offset:l.offset+l.length,length:0,content:","+a}}else v.children.length===0?i={offset:v.offset+1,length:0,content:a}:i={offset:v.offset+1,length:0,content:a+","};return b(w,i,I)}}else if(v.type==="array"&&typeof c=="number"&&Array.isArray(v.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let a;if(v.children.length===0||c===0)a={offset:v.offset+1,length:0,content:v.children.length===0?h:h+","};else{const u=c===-1||c>v.children.length?v.children.length:c,i=v.children[u-1];a={offset:i.offset+i.length,length:0,content:","+h}}return b(w,a,I)}else{const h=c,a=v.children[h];let u;if(v.children.length===1)u={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===h){const i=v.children[h-1],l=i.offset+i.length,r=v.offset+v.length;u={offset:l,length:r-2-l,content:""}}else u={offset:a.offset,length:v.children[h+1].offset-a.offset,content:""};return b(w,u,I)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${v.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return b(w,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(P)},I)}}e.setProperty=M;function b(w,t,P){let I=n(w,t),y=t.offset,d=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;y>0&&!(0,L.isEOL)(I,y-1);)y--;for(;d<I.length&&!(0,L.isEOL)(I,d);)d++}const g=(0,L.format)(I,{offset:y,length:d-y},P);for(let v=g.length-1;v>=0;v--){const c=g[v];I=n(I,c),y=Math.min(y,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const E=w.length-(I.length-d)-y;return[{offset:y,length:E,content:I.substring(y,d)}]}e.withFormatting=b;function n(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=n;function f(w,t){let P=t.slice(0).sort((y,d)=>{const g=y.offset-d.offset;return g===0?y.length-d.length:g}),I=w.length;for(let y=P.length-1;y>=0;y--){let d=P[y];if(d.offset+d.length<=I)w=n(w,d);else throw new Error("Overlapping edit");I=d.offset}return w}e.applyEdits=f}),define(Z[57],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,a){this._keyCodeToStr[h]=a,this._strToKeyCode[a.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const M=new k,b=new k,n=new k;(function(){function c(h,a,u=a,i=u){M.define(h,a),b.define(h,u),n.define(h,i)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var f;(function(c){function h(r){return M.keyCodeToStr(r)}c.toString=h;function a(r){return M.strToKeyCode(r)}c.fromString=a;function u(r){return b.keyCodeToStr(r)}c.toUserSettingsUS=u;function i(r){return n.keyCodeToStr(r)}c.toUserSettingsGeneral=i;function l(r){return b.strToKeyCode(r)||n.strToKeyCode(r)}c.fromUserSettings=l})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function P(c,h){const a=(h&65535)<<16>>>0;return(c|a)>>>0}e.KeyChord=P;function I(c,h){if(c===0)return null;const a=(c&65535)>>>0,u=(c&4294901760)>>>16;return u!==0?new g([y(a,h),y(u,h)]):new g([y(a,h)])}e.createKeybinding=I;function y(c,h){const a=!!(c&2048),u=!!(c&256),i=h===2?u:a,l=!!(c&1024),r=!!(c&512),s=h===2?a:u,o=c&255;return new d(i,l,r,s,o)}e.createSimpleKeybinding=y;class d{constructor(h,a,u,i,l){this.ctrlKey=h,this.shiftKey=a,this.altKey=u,this.metaKey=i,this.keyCode=l}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",u=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${h}${a}${u}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(h){if(h.length===0)throw(0,p.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let a=0,u=this.parts.length;a<u;a++)a!==0&&(h+=";"),h+=this.parts[a].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(h.parts[a]))return!1;return!0}}e.ChordKeybinding=g;class E{constructor(h,a,u,i,l,r){this.ctrlKey=h,this.shiftKey=a,this.altKey=u,this.metaKey=i,this.keyLabel=l,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=E;class v{}e.ResolvedKeybinding=v}),define(Z[2],x([0,1,43,64]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function b(s){M=s}if(e.setDisposableTracker=b,k){const s="__is_disposable_tracked__";b(new class{trackDisposable(o){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[s]||console.log(m)},3e3)}setParent(o,m){if(o&&o!==c.None)try{o[s]=!0}catch{}}markAsDisposed(o){if(o&&o!==c.None)try{o[s]=!0}catch{}}markAsSingleton(o){}})}function n(s){return M?.trackDisposable(s),s}function f(s){M?.markAsDisposed(s)}function w(s,o){M?.setParent(s,o)}function t(s,o){if(!!M)for(const m of s)M.setParent(m,o)}function P(s){return M?.markAsSingleton(s),s}e.markAsSingleton=P;class I extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=I;function y(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=y;function d(s){if(L.Iterable.is(s)){let o=[];for(const m of s)if(m)try{m.dispose()}catch(S){o.push(S)}if(o.length===1)throw o[0];if(o.length>1)throw new I(o);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=d;function g(...s){const o=E(()=>d(s));return t(s,o),o}e.combinedDisposable=g;function E(s){const o=n({dispose:(0,p.once)(()=>{f(o),s()})});return o}e.toDisposable=E;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new v,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&w(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&w(o,null),o}}e.MutableDisposable=h;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(o,...m){let S=this.references.get(o);S||(S={counter:0,object:this.createReferencedObject(o,...m)},this.references.set(o,S));const{object:D}=S,R=(0,p.once)(()=>{--S.counter==0&&(this.destroyReferencedObject(o,S.object),this.references.delete(o))});return S.counter++,{object:D,dispose:R}}}e.ReferenceCollection=u;class i{constructor(o){this.referenceCollection=o}async acquire(o,...m){const S=this.referenceCollection.acquire(o,...m);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(D){throw S.dispose(),D}}}e.AsyncReferenceCollection=i;class l{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=l;function r(s){const o=new v;try{s(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(Z[105],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(M){this.element=M,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let M=this._first;for(;M!==p.Undefined;){const b=M.next;M.prev=p.Undefined,M.next=p.Undefined,M=b}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,b){const n=new p(M);if(this._first===p.Undefined)this._first=n,this._last=n;else if(b){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==p.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==p.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==p.Undefined&&M.next!==p.Undefined){const b=M.prev;b.next=M.next,M.next.prev=b}else M.prev===p.Undefined&&M.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):M.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):M.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==p.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function V(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function b(f){M.push(f,Date.now())}function n(){const f=[];for(let w=0;w<M.length;w+=2)f.push({name:M[w],startTime:M[w+1]});return f}return{mark:b,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const b of performance.getEntriesByType("mark"))M.push({name:b.name,startTime:Math.round(k+b.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function p(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Z[3],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,k=!1,M=!1,b=!1,n=!1,f=!1,w=!1,t,P=p,I,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)y=navigator.userAgent,L=y.indexOf("Windows")>=0,k=y.indexOf("Macintosh")>=0,w=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=y.indexOf("Linux")>=0,f=!0,t=navigator.language,P=t;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",M=d.platform==="linux",b=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,t=p,P=p;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),o=s.availableLanguages["*"];t=s.locale,P=o||p,I=s._translationsConfigFile}catch(s){}n=!0}else console.error("Unable to resolve platform.");var E;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function v(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let c=0;k?c=1:L?c=3:M&&(c=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=b,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=c,e.userAgent=y,e.language=P;var h;(function(r){function s(){return e.language}r.value=s;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function m(){return e.language==="en"}r.isDefault=m})(h=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=I,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let D=0,R=o.length;D<R;D++){const T=o[D];if(T.id===S.data.vscodeSetImmediateId){o.splice(D,1),T.callback();return}}});let m=0;return S=>{const D=++m;o.push({id:D,callback:S}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const s=Promise.resolve();return o=>s.then(o)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let u=!0,i=!1;function l(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,u=new Uint16Array(r.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=l}),define(Z[33],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const k=p.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,p.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,p.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,33]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,b=122,n=46,f=47,w=92,t=58,P=63;class I extends Error{constructor(a,u,i){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const r=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${r} ${l} of type ${u}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function y(h,a){if(typeof h!="string")throw new I(a,"string",h)}function d(h){return h===f||h===w}function g(h){return h===f}function E(h){return h>=L&&h<=M||h>=k&&h<=b}function v(h,a,u,i){let l="",r=0,s=-1,o=0,m=0;for(let S=0;S<=h.length;++S){if(S<h.length)m=h.charCodeAt(S);else{if(i(m))break;m=f}if(i(m)){if(!(s===S-1||o===1))if(o===2){if(l.length<2||r!==2||l.charCodeAt(l.length-1)!==n||l.charCodeAt(l.length-2)!==n){if(l.length>2){const D=l.lastIndexOf(u);D===-1?(l="",r=0):(l=l.slice(0,D),r=l.length-1-l.lastIndexOf(u)),s=S,o=0;continue}else if(l.length!==0){l="",r=0,s=S,o=0;continue}}a&&(l+=l.length>0?`${u}..`:"..",r=2)}else l.length>0?l+=`${u}${h.slice(s+1,S)}`:l=h.slice(s+1,S),r=S-s-1;s=S,o=0}else m===n&&o!==-1?++o:o=-1}return l}function c(h,a){if(a===null||typeof a!="object")throw new I("pathObject","Object",a);const u=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${i}`:`${u}${h}${i}`:i}e.win32={resolve(...h){let a="",u="",i=!1;for(let l=h.length-1;l>=-1;l--){let r;if(l>=0){if(r=h[l],y(r,"path"),r.length===0)continue}else a.length===0?r=p.cwd():(r=p.env[`=${a}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===w)&&(r=`${a}\\`));const s=r.length;let o=0,m="",S=!1;const D=r.charCodeAt(0);if(s===1)d(D)&&(o=1,S=!0);else if(d(D))if(S=!0,d(r.charCodeAt(1))){let R=2,T=R;for(;R<s&&!d(r.charCodeAt(R));)R++;if(R<s&&R!==T){const C=r.slice(T,R);for(T=R;R<s&&d(r.charCodeAt(R));)R++;if(R<s&&R!==T){for(T=R;R<s&&!d(r.charCodeAt(R));)R++;(R===s||R!==T)&&(m=`\\\\${C}\\${r.slice(T,R)}`,o=R)}}}else o=1;else E(D)&&r.charCodeAt(1)===t&&(m=r.slice(0,2),o=2,s>2&&d(r.charCodeAt(2))&&(S=!0,o=3));if(m.length>0)if(a.length>0){if(m.toLowerCase()!==a.toLowerCase())continue}else a=m;if(i){if(a.length>0)break}else if(u=`${r.slice(o)}\\${u}`,i=S,S&&a.length>0)break}return u=v(u,!i,"\\",d),i?`${a}\\${u}`:`${a}${u}`||"."},normalize(h){y(h,"path");const a=h.length;if(a===0)return".";let u=0,i,l=!1;const r=h.charCodeAt(0);if(a===1)return g(r)?"\\":h;if(d(r))if(l=!0,d(h.charCodeAt(1))){let o=2,m=o;for(;o<a&&!d(h.charCodeAt(o));)o++;if(o<a&&o!==m){const S=h.slice(m,o);for(m=o;o<a&&d(h.charCodeAt(o));)o++;if(o<a&&o!==m){for(m=o;o<a&&!d(h.charCodeAt(o));)o++;if(o===a)return`\\\\${S}\\${h.slice(m)}\\`;o!==m&&(i=`\\\\${S}\\${h.slice(m,o)}`,u=o)}}}else u=1;else E(r)&&h.charCodeAt(1)===t&&(i=h.slice(0,2),u=2,a>2&&d(h.charCodeAt(2))&&(l=!0,u=3));let s=u<a?v(h.slice(u),!l,"\\",d):"";return s.length===0&&!l&&(s="."),s.length>0&&d(h.charCodeAt(a-1))&&(s+="\\"),i===void 0?l?`\\${s}`:s:l?`${i}\\${s}`:`${i}${s}`},isAbsolute(h){y(h,"path");const a=h.length;if(a===0)return!1;const u=h.charCodeAt(0);return d(u)||a>2&&E(u)&&h.charCodeAt(1)===t&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let a,u;for(let r=0;r<h.length;++r){const s=h[r];y(s,"path"),s.length>0&&(a===void 0?a=u=s:a+=`\\${s}`)}if(a===void 0)return".";let i=!0,l=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++l;const r=u.length;r>1&&d(u.charCodeAt(1))&&(++l,r>2&&(d(u.charCodeAt(2))?++l:i=!1))}if(i){for(;l<a.length&&d(a.charCodeAt(l));)l++;l>=2&&(a=`\\${a.slice(l)}`)}return e.win32.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a)return"";const u=e.win32.resolve(h),i=e.win32.resolve(a);if(u===i||(h=u.toLowerCase(),a=i.toLowerCase(),h===a))return"";let l=0;for(;l<h.length&&h.charCodeAt(l)===w;)l++;let r=h.length;for(;r-1>l&&h.charCodeAt(r-1)===w;)r--;const s=r-l;let o=0;for(;o<a.length&&a.charCodeAt(o)===w;)o++;let m=a.length;for(;m-1>o&&a.charCodeAt(m-1)===w;)m--;const S=m-o,D=s<S?s:S;let R=-1,T=0;for(;T<D;T++){const G=h.charCodeAt(l+T);if(G!==a.charCodeAt(o+T))break;G===w&&(R=T)}if(T!==D){if(R===-1)return i}else{if(S>D){if(a.charCodeAt(o+T)===w)return i.slice(o+T+1);if(T===2)return i.slice(o+T)}s>D&&(h.charCodeAt(l+T)===w?R=T:T===2&&(R=3)),R===-1&&(R=0)}let C="";for(T=l+R+1;T<=r;++T)(T===r||h.charCodeAt(T)===w)&&(C+=C.length===0?"..":"\\..");return o+=R,C.length>0?`${C}${i.slice(o,m)}`:(i.charCodeAt(o)===w&&++o,i.slice(o,m))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const a=e.win32.resolve(h);if(a.length<=2)return h;if(a.charCodeAt(0)===w){if(a.charCodeAt(1)===w){const u=a.charCodeAt(2);if(u!==P&&u!==n)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(E(a.charCodeAt(0))&&a.charCodeAt(1)===t&&a.charCodeAt(2)===w)return`\\\\?\\${a}`;return h},dirname(h){y(h,"path");const a=h.length;if(a===0)return".";let u=-1,i=0;const l=h.charCodeAt(0);if(a===1)return d(l)?h:".";if(d(l)){if(u=i=1,d(h.charCodeAt(1))){let o=2,m=o;for(;o<a&&!d(h.charCodeAt(o));)o++;if(o<a&&o!==m){for(m=o;o<a&&d(h.charCodeAt(o));)o++;if(o<a&&o!==m){for(m=o;o<a&&!d(h.charCodeAt(o));)o++;if(o===a)return h;o!==m&&(u=i=o+1)}}}}else E(l)&&h.charCodeAt(1)===t&&(u=a>2&&d(h.charCodeAt(2))?3:2,i=u);let r=-1,s=!0;for(let o=a-1;o>=i;--o)if(d(h.charCodeAt(o))){if(!s){r=o;break}}else s=!1;if(r===-1){if(u===-1)return".";r=u}return h.slice(0,r)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,i=-1,l=!0,r;if(h.length>=2&&E(h.charCodeAt(0))&&h.charCodeAt(1)===t&&(u=2),a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,o=-1;for(r=h.length-1;r>=u;--r){const m=h.charCodeAt(r);if(d(m)){if(!l){u=r+1;break}}else o===-1&&(l=!1,o=r+1),s>=0&&(m===a.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=o))}return u===i?i=o:i===-1&&(i=h.length),h.slice(u,i)}for(r=h.length-1;r>=u;--r)if(d(h.charCodeAt(r))){if(!l){u=r+1;break}}else i===-1&&(l=!1,i=r+1);return i===-1?"":h.slice(u,i)},extname(h){y(h,"path");let a=0,u=-1,i=0,l=-1,r=!0,s=0;h.length>=2&&h.charCodeAt(1)===t&&E(h.charCodeAt(0))&&(a=i=2);for(let o=h.length-1;o>=a;--o){const m=h.charCodeAt(o);if(d(m)){if(!r){i=o+1;break}continue}l===-1&&(r=!1,l=o+1),m===n?u===-1?u=o:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||l===-1||s===0||s===1&&u===l-1&&u===i+1?"":h.slice(u,l)},format:c.bind(null,"\\"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.length;let i=0,l=h.charCodeAt(0);if(u===1)return d(l)?(a.root=a.dir=h,a):(a.base=a.name=h,a);if(d(l)){if(i=1,d(h.charCodeAt(1))){let R=2,T=R;for(;R<u&&!d(h.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&d(h.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&!d(h.charCodeAt(R));)R++;R===u?i=R:R!==T&&(i=R+1)}}}}else if(E(l)&&h.charCodeAt(1)===t){if(u<=2)return a.root=a.dir=h,a;if(i=2,d(h.charCodeAt(2))){if(u===3)return a.root=a.dir=h,a;i=3}}i>0&&(a.root=h.slice(0,i));let r=-1,s=i,o=-1,m=!0,S=h.length-1,D=0;for(;S>=i;--S){if(l=h.charCodeAt(S),d(l)){if(!m){s=S+1;break}continue}o===-1&&(m=!1,o=S+1),l===n?r===-1?r=S:D!==1&&(D=1):r!==-1&&(D=-1)}return o!==-1&&(r===-1||D===0||D===1&&r===o-1&&r===s+1?a.base=a.name=h.slice(s,o):(a.name=h.slice(s,r),a.base=h.slice(s,o),a.ext=h.slice(r,o))),s>0&&s!==i?a.dir=h.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let a="",u=!1;for(let i=h.length-1;i>=-1&&!u;i--){const l=i>=0?h[i]:p.cwd();y(l,"path"),l.length!==0&&(a=`${l}/${a}`,u=l.charCodeAt(0)===f)}return a=v(a,!u,"/",g),u?`/${a}`:a.length>0?a:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===f,u=h.charCodeAt(h.length-1)===f;return h=v(h,!a,"/",g),h.length===0?a?"/":u?"./":".":(u&&(h+="/"),a?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let a;for(let u=0;u<h.length;++u){const i=h[u];y(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.posix.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a||(h=e.posix.resolve(h),a=e.posix.resolve(a),h===a))return"";const u=1,i=h.length,l=i-u,r=1,s=a.length-r,o=l<s?l:s;let m=-1,S=0;for(;S<o;S++){const R=h.charCodeAt(u+S);if(R!==a.charCodeAt(r+S))break;R===f&&(m=S)}if(S===o)if(s>o){if(a.charCodeAt(r+S)===f)return a.slice(r+S+1);if(S===0)return a.slice(r+S)}else l>o&&(h.charCodeAt(u+S)===f?m=S:S===0&&(m=0));let D="";for(S=u+m+1;S<=i;++S)(S===i||h.charCodeAt(S)===f)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(r+m)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===f;let u=-1,i=!0;for(let l=h.length-1;l>=1;--l)if(h.charCodeAt(l)===f){if(!i){u=l;break}}else i=!1;return u===-1?a?"/":".":a&&u===1?"//":h.slice(0,u)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,i=-1,l=!0,r;if(a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,o=-1;for(r=h.length-1;r>=0;--r){const m=h.charCodeAt(r);if(m===f){if(!l){u=r+1;break}}else o===-1&&(l=!1,o=r+1),s>=0&&(m===a.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=o))}return u===i?i=o:i===-1&&(i=h.length),h.slice(u,i)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===f){if(!l){u=r+1;break}}else i===-1&&(l=!1,i=r+1);return i===-1?"":h.slice(u,i)},extname(h){y(h,"path");let a=-1,u=0,i=-1,l=!0,r=0;for(let s=h.length-1;s>=0;--s){const o=h.charCodeAt(s);if(o===f){if(!l){u=s+1;break}continue}i===-1&&(l=!1,i=s+1),o===n?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===u+1?"":h.slice(a,i)},format:c.bind(null,"/"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.charCodeAt(0)===f;let i;u?(a.root="/",i=1):i=0;let l=-1,r=0,s=-1,o=!0,m=h.length-1,S=0;for(;m>=i;--m){const D=h.charCodeAt(m);if(D===f){if(!o){r=m+1;break}continue}s===-1&&(o=!1,s=m+1),D===n?l===-1?l=m:S!==1&&(S=1):l!==-1&&(S=-1)}if(s!==-1){const D=r===0&&u?1:r;l===-1||S===0||S===1&&l===s-1&&l===r+1?a.base=a.name=h.slice(D,s):(a.name=h.slice(D,l),a.base=h.slice(D,s),a.ext=h.slice(l,s))}return r>0?a.dir=h.slice(0,r-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...b){const n=b.reduce((t,P)=>(t[P]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!n[t]).forEach(t=>{for(let P=0;P<f.length;P++)if(t.search(f[P])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=k}),define(Z[79],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var p;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(p=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class b{constructor(f,w,t,P,I){this.ctrlKey=f,this.shiftKey=w,this.altKey=t,this.metaKey=P,this.scanCode=I}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=b,function(){function n(f,w){L[f]=w,k[w]=f,M[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[106],x([0,1,57,79]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(b){b=b.toLowerCase().trim();let n=!1,f=!1,w=!1,t=!1,P;do P=!1,/^ctrl(\+|\-)/.test(b)&&(n=!0,b=b.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(b)&&(f=!0,b=b.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(b)&&(w=!0,b=b.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(b)&&(t=!0,b=b.substr("meta-".length),P=!0),/^win(\+|\-)/.test(b)&&(t=!0,b=b.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(b)&&(t=!0,b=b.substr("cmd-".length),P=!0);while(P);let I;const y=b.indexOf(" ");return y>0?(I=b.substring(0,y),b=b.substring(y)):(I=b,b=""),{remains:b,ctrl:n,shift:f,alt:w,meta:t,key:I}}static parseSimpleKeybinding(b){const n=this._readModifiers(b),f=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(b,n){if(!b)return null;const f=[];let w;do[w,b]=this.parseSimpleKeybinding(b),f.push(w);while(b.length>0);return new p.ChordKeybinding(f)}static parseSimpleUserBinding(b){const n=this._readModifiers(b),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],P=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,P),n.remains]}const w=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(b){if(!b)return[];const n=[];let f;for(;b.length>0;)[f,b]=this.parseSimpleUserBinding(b),n.push(f);return n}}e.KeybindingParser=k}),define(Z[107],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class k{constructor(b){this._highResolution=L&&b,this._startTime=this._now(),this._stopTime=-1}static create(b=!0){return new k(b)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[4],x([0,1,17,43,2,105,107]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(a){a.None=()=>k.Disposable.None;function u(O){return(j,$=null,z)=>{let H=!1,W;return W=O(q=>{if(!H)return W?W.dispose():H=!0,j.call($,q)},null,z),H&&W.dispose(),W}}a.once=u;function i(O,j){return S(($,z=null,H)=>O(W=>$.call(z,j(W)),null,H))}a.map=i;function l(O,j){return S(($,z=null,H)=>O(W=>{j(W),$.call(z,W)},null,H))}a.forEach=l;function r(O,j){return S(($,z=null,H)=>O(W=>j(W)&&$.call(z,W),null,H))}a.filter=r;function s(O){return O}a.signal=s;function o(...O){return(j,$=null,z)=>(0,k.combinedDisposable)(...O.map(H=>H(W=>j.call($,W),null,z)))}a.any=o;function m(O,j,$){let z=$;return i(O,H=>(z=j(z,H),z))}a.reduce=m;function S(O){let j;const $=new I({onFirstListenerAdd(){j=O($.fire,$)},onLastListenerRemove(){j.dispose()}});return $.event}function D(O,j,$=100,z=!1,H){let W,q,U,A=0;const F=new I({leakWarningThreshold:H,onFirstListenerAdd(){W=O(B=>{A++,q=j(q,B),z&&!U&&(F.fire(q),q=void 0),clearTimeout(U),U=setTimeout(()=>{const Y=q;q=void 0,U=void 0,(!z||A>1)&&F.fire(Y),A=0},$)})},onLastListenerRemove(){W.dispose()}});return F.event}a.debounce=D;function R(O,j=($,z)=>$===z){let $=!0,z;return r(O,H=>{const W=$||!j(H,z);return $=!1,z=H,W})}a.latch=R;function T(O,j){return[a.filter(O,j),a.filter(O,$=>!j($))]}a.split=T;function C(O,j=!1,$=[]){let z=$.slice(),H=O(U=>{z?z.push(U):q.fire(U)});const W=()=>{z&&z.forEach(U=>q.fire(U)),z=null},q=new I({onFirstListenerAdd(){H||(H=O(U=>q.fire(U)))},onFirstListenerDidAdd(){z&&(j?setTimeout(W):W())},onLastListenerRemove(){H&&H.dispose(),H=null}});return q.event}a.buffer=C;class G{constructor(j){this.event=j}map(j){return new G(i(this.event,j))}forEach(j){return new G(l(this.event,j))}filter(j){return new G(r(this.event,j))}reduce(j,$){return new G(m(this.event,j,$))}latch(){return new G(R(this.event))}debounce(j,$=100,z=!1,H){return new G(D(this.event,j,$,z,H))}on(j,$,z){return this.event(j,$,z)}once(j,$,z){return u(this.event)(j,$,z)}}function ne(O){return new G(O)}a.chain=ne;function oe(O,j,$=z=>z){const z=(...U)=>q.fire($(...U)),H=()=>O.on(j,z),W=()=>O.removeListener(j,z),q=new I({onFirstListenerAdd:H,onLastListenerRemove:W});return q.event}a.fromNodeEventEmitter=oe;function K(O,j,$=z=>z){const z=(...U)=>q.fire($(...U)),H=()=>O.addEventListener(j,z),W=()=>O.removeEventListener(j,z),q=new I({onFirstListenerAdd:H,onLastListenerRemove:W});return q.event}a.fromDOMEventEmitter=K;function ee(O){return new Promise(j=>u(O)(j))}a.toPromise=ee})(n=e.Event||(e.Event={}));class f{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${f._idPool++}`}start(u){this._stopWatch=new b.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function t(a){const u=w;return w=a,{dispose(){w=u}}}e.setGlobalLeakWarningThreshold=t;class P{constructor(u,i=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let i=w;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||u<i)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(l)||0;if(this._stacks.set(l,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let s,o=0;for(const[m,S]of this._stacks)(!s||o<S)&&(s=m,o=S);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${o}):`),console.warn(s)}return()=>{const s=this._stacks.get(l)||0;this._stacks.set(l,s-1)}}}class I{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=w>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(u,i,l)=>{this._listeners||(this._listeners=new M.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(i?[u,i]:u);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,i);const o=this._leakageMon?.check(this._listeners.size),m=(0,k.toDisposable)(()=>{o&&o(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof k.DisposableStore?l.add(m):Array.isArray(l)&&l.push(m),m}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,l]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,l):i[0].call(i[1],l)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=I;class y extends I{async fireAsync(u,i,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,u]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),o=[],m={...s,waitUntil:S=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");l&&(S=l(S,typeof r=="function"?r:r[0])),o.push(S)}};try{typeof r=="function"?r.call(void 0,m):r[0].call(r[1],m)}catch(S){(0,p.onUnexpectedError)(S);continue}Object.freeze(o),await Promise.allSettled(o).then(S=>{for(const D of S)D.status==="rejected"&&(0,p.onUnexpectedError)(D.reason)})}}}}e.AsyncEmitter=y;class d extends I{constructor(u){super(u);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=d;class g extends d{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=g;class E extends I{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new I({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const i={event:u,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const l=()=>{this.hasListeners&&this.unhook(i);const r=this.events.indexOf(i);this.events.splice(r,1)};return(0,k.toDisposable)((0,L.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(i=>this.emitter.fire(i))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class c{constructor(){this.buffers=[]}wrapEvent(u){return(i,l,r)=>u(s=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>i.call(l,s)):i.call(l,s)},void 0,r)}bufferEvents(u){const i=[];this.buffers.push(i);const l=u();return this.buffers.pop(),i.forEach(r=>r()),l}}e.EventBufferer=c;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new I({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(Z[23],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var k;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class b{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=b}),define(Z[108],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(P){const I=this._icons.get(P.id);I?P.description?I.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(t,P){return new n(t,P)}e.registerCodicon=M;function b(t){return t?t.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=b;class n{constructor(P,I,y){this.id=P,this.definition=I,this.description=y,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,P){const I=["codicon","codicon-"+t];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=f;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function I(g){if(g instanceof n)return["codicon","codicon-"+g.id];const E=P.exec(g.id);if(!E)return I(n.error);let[,v,c]=E;const h=["codicon","codicon-"+v];return c&&h.push("codicon-modifier-"+c.substr(1)),h}t.asClassNameArray=I;function y(g){return I(g).join(" ")}t.asClassName=y;function d(g){return"."+I(g).join(".")}t.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[65],x([0,1,17,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(h){const a=h;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=k;function M(h){const a=h;return a?k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function b(h,a){return new n(h,a)}e.newWriteableStream=b;class n{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let i;switch(a){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const l=i.indexOf(u);l>=0&&i.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,a){const u=[];let i;for(;(i=h.read())!==null;)u.push(i);return a(u)}e.consumeReadable=f;function w(h,a,u){const i=[];let l;for(;(l=h.read())!==null&&i.length<u;)i.push(l);return l===null&&i.length>0?a(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l!="undefined"){const r=l;return l=void 0,r}return h.read()}}}e.peekReadable=w;function t(h,a){return new Promise((u,i)=>{const l=[];P(h,{onData:r=>{a&&l.push(r)},onError:r=>{a?i(r):u(void 0)},onEnd:()=>{u(a?a(l):void 0)}})})}e.consumeStream=t;function P(h,a){h.on("error",u=>a.onError(u)),h.on("end",()=>a.onEnd()),h.on("data",u=>a.onData(u))}e.listenStream=P;function I(h,a){return new Promise((u,i)=>{const l=new L.DisposableStore,r=[],s=S=>{if(r.push(S),r.length>a)return l.dispose(),h.pause(),u({stream:h,buffer:r,ended:!1})},o=S=>i(S),m=()=>u({stream:h,buffer:r,ended:!0});l.add((0,L.toDisposable)(()=>h.removeListener("error",o))),h.on("error",o),l.add((0,L.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),l.add((0,L.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=I;function y(h,a){const u=b(a);return u.end(h),u}e.toStream=y;function d(){const h=b(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let a=!1;return{read:()=>a?null:(a=!0,h)}}e.toReadable=g;function E(h,a,u){const i=b(u);return P(h,{onData:l=>i.write(a.data(l)),onError:l=>i.error(a.error?a.error(l):l),onEnd:()=>i.end()}),i}e.transform=E;function v(h,a,u){let i=!1;return{read:()=>{const l=a.read();return i?l:(i=!0,l!==null?u([h,l]):h)}}}e.prefixedReadable=v;function c(h,a,u){let i=!1;const l=b(u);return P(a,{onData:r=>i?l.write(r):(i=!0,l.write(u([h,r]))),onError:r=>l.error(r),onEnd:()=>{i||(i=!0,l.write(h)),l.end()}}),l}e.prefixedStream=c}),define(Z[18],x([0,1,65]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,M;class b{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new b(Buffer.allocUnsafe(s)):new b(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new b(s)}static fromString(s,o){return!(o?.dontUseNodeBuffer||!1)&&L?new b(Buffer.from(s)):(k||(k=new TextEncoder),new b(k.encode(s)))}static concat(s,o){if(typeof o=="undefined"){o=0;for(let D=0,R=s.length;D<R;D++)o+=s[D].byteLength}const m=b.alloc(o);let S=0;for(let D=0,R=s.length;D<R;D++){const T=s[D];m.set(T,S),S+=T.byteLength}return m}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(s,o){return new b(this.buffer.subarray(s,o))}set(s,o){s instanceof b?this.buffer.set(s.buffer,o):this.buffer.set(s,o)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,o){t(this.buffer,s,o)}readUInt32LE(s){return P(this.buffer,s)}writeUInt32LE(s,o){I(this.buffer,s,o)}readUInt8(s){return y(this.buffer,s)}writeUInt8(s,o){d(this.buffer,s,o)}}e.VSBuffer=b;function n(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=n;function f(r,s,o){r[o+0]=s&255,s=s>>>8,r[o+1]=s&255}e.writeUInt16LE=f;function w(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=w;function t(r,s,o){r[o+3]=s,s=s>>>8,r[o+2]=s,s=s>>>8,r[o+1]=s,s=s>>>8,r[o]=s}e.writeUInt32BE=t;function P(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=P;function I(r,s,o){r[o+0]=s&255,s=s>>>8,r[o+1]=s&255,s=s>>>8,r[o+2]=s&255,s=s>>>8,r[o+3]=s&255}e.writeUInt32LE=I;function y(r,s){return r[s]}e.readUInt8=y;function d(r,s,o){r[o]=s}e.writeUInt8=d;function g(r){return p.consumeReadable(r,s=>b.concat(s))}e.readableToBuffer=g;function E(r){return p.toReadable(r)}e.bufferToReadable=E;function v(r){return p.consumeStream(r,s=>b.concat(s))}e.streamToBuffer=v;async function c(r){return r.ended?b.concat(r.buffer):b.concat([...r.buffer,await v(r.stream)])}e.bufferedStreamToBuffer=c;function h(r){return p.toStream(r,s=>b.concat(s))}e.bufferToStream=h;function a(r){return p.transform(r,{data:s=>typeof s=="string"?b.fromString(s):b.wrap(s)},s=>b.concat(s))}e.streamToBufferReadableStream=a;function u(r){return p.newWriteableStream(s=>b.concat(s),r)}e.newWriteableBufferStream=u;function i(r,s){return p.prefixedReadable(r,s,o=>b.concat(o))}e.prefixedBufferReadable=i;function l(r,s){return p.prefixedStream(r,s,o=>b.concat(o))}e.prefixedBufferStream=l}),define(Z[25],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function k(X,...se){return se.length===0?X:X.replace(L,function(ce,we){const ye=parseInt(we,10);return isNaN(ye)||ye<0||ye>=se.length?ce:se[ye]})}e.format=k;const M=/{([^}]+)}/g;function b(X,se){return X.replace(M,(ce,we)=>se[we]??ce)}e.format2=b;function n(X){return X.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=n;function f(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(X,se){let ce=0;const we=se.charCodeAt(0);for(let ye=X.length-1;ye>=0;ye--)X.charCodeAt(ye)===we&&ce++;return ce}e.count=w;function t(X,se,ce="\u2026"){return X.length<=se?X:`${X.substr(0,se)}${ce}`}e.truncate=t;function P(X,se=" "){const ce=I(X,se);return y(ce,se)}e.trim=P;function I(X,se){if(!X||!se)return X;const ce=se.length;if(ce===0||X.length===0)return X;let we=0;for(;X.indexOf(se,we)===we;)we=we+ce;return X.substring(we)}e.ltrim=I;function y(X,se){if(!X||!se)return X;const ce=se.length,we=X.length;if(ce===0||we===0)return X;let ye=we,De=-1;for(;De=X.lastIndexOf(se,ye-1),!(De===-1||De+ce!==ye);){if(De===0)return"";ye=De}return X.substring(0,ye)}e.rtrim=y;function d(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(X){return X.replace(/\*/g,"")}e.stripWildcards=g;function E(X,se,ce={}){if(!X)throw new Error("Cannot create regex from empty string");se||(X=f(X)),ce.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(X,we)}e.createRegExp=E;function v(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function c(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function h(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=h;function a(X){return X.split(/\r\n|\r|\n/)}e.splitLines=a;function u(X){for(let se=0,ce=X.length;se<ce;se++){const we=X.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}e.firstNonWhitespaceIndex=u;function i(X,se=0,ce=X.length){for(let we=se;we<ce;we++){const ye=X.charCodeAt(we);if(ye!==32&&ye!==9)return X.substring(se,we)}return X.substring(se,ce)}e.getLeadingWhitespace=i;function l(X,se=X.length-1){for(let ce=se;ce>=0;ce--){const we=X.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=l;function r(X,se){return X<se?-1:X>se?1:0}e.compare=r;function s(X,se,ce=0,we=X.length,ye=0,De=se.length){for(;ce<we&&ye<De;ce++,ye++){let Ne=X.charCodeAt(ce),ze=se.charCodeAt(ye);if(Ne<ze)return-1;if(Ne>ze)return 1}const Fe=we-ce,We=De-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=s;function o(X,se){return m(X,se,0,X.length,0,se.length)}e.compareIgnoreCase=o;function m(X,se,ce=0,we=X.length,ye=0,De=se.length){for(;ce<we&&ye<De;ce++,ye++){let Ne=X.charCodeAt(ce),ze=se.charCodeAt(ye);if(Ne===ze)continue;const he=Ne-ze;if(!(he===32&&D(ze))&&!(he===-32&&D(Ne)))return S(Ne)&&S(ze)?he:s(X.toLowerCase(),se.toLowerCase(),ce,we,ye,De)}const Fe=we-ce,We=De-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=m;function S(X){return X>=97&&X<=122}e.isLowerAsciiLetter=S;function D(X){return X>=65&&X<=90}e.isUpperAsciiLetter=D;function R(X){return S(X)||D(X)}function T(X,se){return X.length===se.length&&C(X,se)}e.equalsIgnoreCase=T;function C(X,se,ce=X.length){for(let we=0;we<ce;we++){const ye=X.charCodeAt(we),De=se.charCodeAt(we);if(ye!==De){if(R(ye)&&R(De)){const Fe=Math.abs(ye-De);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(ye).toLowerCase()!==String.fromCharCode(De).toLowerCase())return!1}}return!0}function G(X,se){const ce=se.length;return se.length>X.length?!1:C(X,se,ce)}e.startsWithIgnoreCase=G;function ne(X,se){let ce,we=Math.min(X.length,se.length);for(ce=0;ce<we;ce++)if(X.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return we}e.commonPrefixLength=ne;function oe(X,se){let ce,we=Math.min(X.length,se.length);const ye=X.length-1,De=se.length-1;for(ce=0;ce<we;ce++)if(X.charCodeAt(ye-ce)!==se.charCodeAt(De-ce))return ce;return we}e.commonSuffixLength=oe;function K(X){return 55296<=X&&X<=56319}e.isHighSurrogate=K;function ee(X){return 56320<=X&&X<=57343}e.isLowSurrogate=ee;function O(X,se){return(X-55296<<10)+(se-56320)+65536}e.computeCodePoint=O;function j(X,se,ce){const we=X.charCodeAt(ce);if(K(we)&&ce+1<se){const ye=X.charCodeAt(ce+1);if(ee(ye))return O(we,ye)}return we}e.getNextCodePoint=j;function $(X,se){const ce=X.charCodeAt(se-1);if(ee(ce)&&se>1){const we=X.charCodeAt(se-2);if(K(we))return O(we,ce)}return ce}function z(X,se){const ce=Be.getInstance(),we=se,ye=X.length,De=j(X,ye,se);se+=De>=65536?2:1;let Fe=ce.getGraphemeBreakType(De);for(;se<ye;){const We=j(X,ye,se),Ne=ce.getGraphemeBreakType(We);if(Ce(Fe,Ne))break;se+=We>=65536?2:1,Fe=Ne}return se-we}e.nextCharLength=z;function H(X,se){const ce=Be.getInstance(),we=se,ye=$(X,se);se-=ye>=65536?2:1;let De=ce.getGraphemeBreakType(ye);for(;se>0;){const Fe=$(X,se),We=ce.getGraphemeBreakType(Fe);if(Ce(We,De))break;se-=Fe>=65536?2:1,De=We}return we-se}e.prevCharLength=H;function W(X,se){const ce=Be.getInstance(),we=X.length,ye=se,De=j(X,we,se),Fe=ce.getGraphemeBreakType(De);se+=De>=65536?2:1;let We=Fe;for(;se<we;){const ze=j(X,we,se),he=ce.getGraphemeBreakType(ze);if(Ce(We,he))break;se+=ze>=65536?2:1,We=he}const Ne=se;for(se=ye,We=Fe;se>0;){const ze=$(X,se),he=ce.getGraphemeBreakType(ze);if(Ce(he,We))break;se-=ze>=65536?2:1,We=he}return[se,Ne]}function q(X,se){return se>0&&ee(X.charCodeAt(se))?W(X,se-1):W(X,se)}e.getCharContainingOffset=q;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(X){return U.test(X)}e.containsRTL=A;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(X){return F.test(X)}e.containsEmoji=B;const Y=/^[\t\n\r\x20-\x7E]*$/;function _(X){return Y.test(X)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=N;function Q(X){for(let se=0,ce=X.length;se<ce;se++)if(J(X.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=Q;function J(X){return X=+X,X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=J;function re(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129003||X>=129280&&X<=129535||X>=129648&&X<=129750}e.isEmojiImprecise=re;function le(X,se){if(X.length<se)return X;const ce=/\b/g;let we=0;for(;ce.test(X)&&!(X.length-ce.lastIndex<se);)we=ce.lastIndex,ce.lastIndex+=1;return X.substring(we).replace(/^\s/,"")}e.lcut=le;const te=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function fe(X){return X&&(X=X.replace(te,""),X=X.replace(ae,""),X=X.replace(ge,"")),X}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function Pe(X){return de(X)?X.substr(1):X}e.stripUTF8BOM=Pe;function pe(X,se){if(!X||!se||X.length<se.length)return!1;const ce=se.length,we=X.toLowerCase();let ye=0,De=-1;for(;ye<ce;){const Fe=we.indexOf(se[ye],De+1);if(Fe<0)return!1;De=Fe,ye++}return!0}e.fuzzyContains=pe;function me(X,se=!1){return X?(se&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=me;function be(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=be;function ke(X,se=1){if(se===0)return"";let ce=-1;do ce=X.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?X:(X[ce-1]==="\r"&&ce--,X.substr(0,ce))}e.getNLines=ke;function Ae(X){const se=90-65+1;return X=X%(2*se),X<se?String.fromCharCode(97+X):String.fromCharCode(65+X-se)}e.singleLetterHash=Ae;function Ue(X){return Be.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ue;function Ce(X,se){return X===0?se!==5&&se!==7:X===2&&se===3?!1:X===4||X===2||X===3||se===4||se===2||se===3?!0:!(X===8&&(se===8||se===9||se===11||se===12)||(X===11||X===9)&&(se===9||se===10)||(X===12||X===10)&&se===10||se===5||se===13||se===7||X===1||X===13&&se===14||X===6&&se===6)}e.breakBetweenGraphemeBreakType=Ce;var Ge;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=ot()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,we=ce.length/3;let ye=1;for(;ye<=we;)if(se<ce[3*ye])ye=2*ye;else if(se>ce[3*ye+1])ye=2*ye+1;else return ce[3*ye+2];return 0}}Be._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(X,se){if(X===0)return 0;const ce=at(X,se);if(ce!==void 0)return ce;const we=$(se,X);return X-=Ye(we),X}e.getLeftDeleteOffset=Ze;function at(X,se){let ce=$(se,X);for(X-=Ye(ce);ht(ce)||ce===65039||ce===8419;){if(X===0)return;ce=$(se,X),X-=Ye(ce)}if(!!re(ce)){if(X>=0){const we=$(se,X);we===8205&&(X-=Ye(we))}return X}}function Ye(X){return X>=65536?2:1}function ht(X){return 127995<=X&&X<=127999}var xe;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(Z[80],x([0,1,25]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(v){return k(v,0)}e.hash=L;function k(v,c){switch(typeof v){case"object":return v===null?M(349,c):Array.isArray(v)?f(v,c):w(v,c);case"string":return n(v,c);case"boolean":return b(v,c);case"number":return M(v,c);case"undefined":return M(937,c);default:return M(617,c)}}e.doHash=k;function M(v,c){return(c<<5)-c+v|0}function b(v,c){return M(v?433:863,c)}function n(v,c){c=M(149417,c);for(let h=0,a=v.length;h<a;h++)c=M(v.charCodeAt(h),c);return c}e.stringHash=n;function f(v,c){return c=M(104579,c),v.reduce((h,a)=>k(a,h),c)}function w(v,c){return c=M(181387,c),Object.keys(v).sort().reduce((h,a)=>(h=n(a,h),k(v[a],h)),c)}class t{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=k(c,this._value),this._value}}e.Hasher=t;var P;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function I(v,c,h=32){const a=h-c,u=~((1<<a)-1);return(v<<c|(u&v)>>>a)>>>0}function y(v,c=0,h=v.byteLength,a=0){for(let u=0;u<h;u++)v[c+u]=a}function d(v,c,h="0"){for(;v.length<c;)v=h+v;return v}function g(v,c=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((v>>>0).toString(16),c/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const a=this._buff;let u=this._buffLen,i=this._leftoverHighSurrogate,l,r;for(i!==0?(l=i,r=-1,i=0):(l=c.charCodeAt(0),r=0);;){let s=l;if(p.isHighSurrogate(l))if(r+1<h){const o=c.charCodeAt(r+1);p.isLowSurrogate(o)?(r++,s=p.computeCodePoint(l,o)):s=65533}else{i=l;break}else p.isLowSurrogate(l)&&(s=65533);if(u=this._push(a,u,s),r++,r<h)l=c.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=i}_push(c,h,a){return a<128?c[h++]=a:a<2048?(c[h++]=192|(a&1984)>>>6,c[h++]=128|(a&63)>>>0):a<65536?(c[h++]=224|(a&61440)>>>12,c[h++]=128|(a&4032)>>>6,c[h++]=128|(a&63)>>>0):(c[h++]=240|(a&1835008)>>>18,c[h++]=128|(a&258048)>>>12,c[h++]=128|(a&4032)>>>6,c[h++]=128|(a&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=E._bigBlock32,h=this._buffDV;for(let S=0;S<64;S+=4)c.setUint32(S,h.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)c.setUint32(S,I(c.getUint32(S-12,!1)^c.getUint32(S-32,!1)^c.getUint32(S-56,!1)^c.getUint32(S-64,!1),1),!1);let a=this._h0,u=this._h1,i=this._h2,l=this._h3,r=this._h4,s,o,m;for(let S=0;S<80;S++)S<20?(s=u&i|~u&l,o=1518500249):S<40?(s=u^i^l,o=1859775393):S<60?(s=u&i|u&l|i&l,o=2400959708):(s=u^i^l,o=3395469782),m=I(a,5)+s+r+o+c.getUint32(S*4,!1)&4294967295,r=l,l=i,i=I(u,30),u=a,a=m;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(D){return Array.isArray(D)}e.isArray=p;function L(D){return typeof D=="string"}e.isString=L;function k(D){return Array.isArray(D)&&D.every(R=>L(R))}e.isStringArray=k;function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=M;function b(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=b;function n(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=n;function f(D){return D===!0||D===!1}e.isBoolean=f;function w(D){return typeof D=="undefined"}e.isUndefined=w;function t(D){return!P(D)}e.isDefined=t;function P(D){return w(D)||D===null}e.isUndefinedOrNull=P;function I(D,R){if(!D)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=I;function y(D){if(P(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=y;function d(...D){const R=[];for(let T=0;T<D.length;T++){const C=D[T];if(P(C))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);R.push(C)}return R}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function E(D){if(!M(D))return!1;for(let R in D)if(g.call(D,R))return!1;return!0}e.isEmptyObject=E;function v(D){return typeof D=="function"}e.isFunction=v;function c(...D){return D.length>0&&D.every(v)}e.areFunctions=c;function h(D,R){const T=Math.min(D.length,R.length);for(let C=0;C<T;C++)a(D[C],R[C])}e.validateConstraints=h;function a(D,R){if(L(R)){if(typeof D!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(v(R)){try{if(D instanceof R)return}catch{}if(!P(D)&&D.constructor===R||R.length===1&&R.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(D){let R=[],T=Object.getPrototypeOf(D);for(;Object.prototype!==T;)R=R.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return R}e.getAllPropertyNames=u;function i(D){const R=[];for(const T of u(D))typeof D[T]=="function"&&R.push(T);return R}e.getAllMethodNames=i;function l(D,R){const T=G=>function(){const ne=Array.prototype.slice.call(arguments,0);return R(G,ne)};let C={};for(const G of D)C[G]=T(G);return C}e.createProxyObject=l;function r(D){return D===null?void 0:D}e.withNullAsUndefined=r;function s(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=s;function o(D){return class{constructor(){return new Proxy({},{get(R,T){if(R[T])return R[T];throw new Error(`Not Implemented: ${D}->${String(T)}`)}})}}}e.NotImplementedProxy=o;function m(D,R="Unreachable"){throw new Error(R)}e.assertNever=m;function S(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=S}),define(Z[31],x([0,1,8,3,25,13]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function b(r){return r===47||r===92}e.isPathSeparator=b;function n(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function w(r,s=p.posix.sep){if(!r)return"";const o=r.length,m=r.charCodeAt(0);if(b(m)){if(b(r.charCodeAt(1))&&!b(r.charCodeAt(2))){let D=3;const R=D;for(;D<o&&!b(r.charCodeAt(D));D++);if(R!==D&&!b(r.charCodeAt(D+1))){for(D+=1;D<o;D++)if(b(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,s)}}return s}else if(v(m)&&r.charCodeAt(1)===58)return b(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<o;S++)if(b(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=w;function t(r){if(!L.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let o=2;const m=o;for(;o<r.length&&(s=r.charCodeAt(o),s!==92);o++);return!(m===o||(s=r.charCodeAt(o+1),isNaN(s)||s===92))}e.isUNC=t;const P=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,s=L.isWindows){const o=s?P:I;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||s&&y.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function g(r,s,o){const m=r===s;return!o||m?m:!r||!s?!1:(0,k.equalsIgnoreCase)(r,s)}e.isEqual=g;function E(r,s,o,m=p.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let D=s.length;return s.charAt(s.length-1)===m&&D--,r.charAt(D)===m}return s.charAt(s.length-1)!==m&&(s+=m),r.indexOf(s)===0}e.isEqualOrParent=E;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function c(r,s){return L.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(s,r)),r=(0,p.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,k.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=c;function h(r){const s=(0,p.normalize)(r);return L.isWindows?r.length>3?!1:a(s)&&(r.length===2||s.charCodeAt(2)===92):s===p.posix.sep}e.isRootOrDriveLetter=h;function a(r){return L.isWindows?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(r){return a(r)?r[0]:void 0}e.getDriveLetter=u;function i(r,s,o){return s.length>r.length?-1:r===s?0:(o&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function l(r){const s=r.split(":");let o,m,S;if(s.forEach(D=>{const R=Number(D);(0,M.isNumber)(R)?m===void 0?m=R:S===void 0&&(S=R):o=o?[o,D].join(":"):D}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(Z[44],x([0,1,13]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(v=>{g[v]&&typeof g[v]=="object"?E[v]=L(g[v]):E[v]=g[v]}),E}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const c in v)if(M.call(v,c)){const h=v[c];typeof h=="object"&&!Object.isFrozen(h)&&E.push(h)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function b(g,E){return n(g,E,new Set)}e.cloneAndChange=b;function n(g,E,v){if((0,p.isUndefinedOrNull)(g))return g;const c=E(g);if(typeof c!="undefined")return c;if((0,p.isArray)(g)){const h=[];for(const a of g)h.push(n(a,E,v));return h}if((0,p.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const h={};for(let a in g)M.call(g,a)&&(h[a]=n(g[a],E,v));return v.delete(g),h}return g}function f(g,E,v=!0){return(0,p.isObject)(g)?((0,p.isObject)(E)&&Object.keys(E).forEach(c=>{c in g?v&&((0,p.isObject)(g[c])&&(0,p.isObject)(E[c])?f(g[c],E[c],v):g[c]=E[c]):g[c]=E[c]}),g):E}e.mixin=f;function w(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let v,c;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(v=0;v<g.length;v++)if(!w(g[v],E[v]))return!1}else{const h=[];for(c in g)h.push(c);h.sort();const a=[];for(c in E)a.push(c);if(a.sort(),!w(h,a))return!1;for(v=0;v<h.length;v++)if(!w(g[h[v]],E[h[v]]))return!1}return!0}e.equals=w;function t(g){const E=new Set;return JSON.stringify(g,(v,c)=>{if((0,p.isObject)(c)||Array.isArray(c)){if(E.has(c))return"[Circular]";E.add(c)}return c})}e.safeStringify=t;function P(g,E,v){const c=E(g);return typeof c=="undefined"?v:c}e.getOrDefault=P;function I(g,E){const v=Object.create(null);return!g||!E||Object.keys(E).forEach(h=>{const a=g[h],u=E[h];w(a,u)||(v[h]=u)}),v}e.distinct=I;function y(g,E){const v=E.toLowerCase(),c=Object.keys(g).find(h=>h.toLowerCase()===v);return c?g[c]:g[E]}e.getCaseInsensitive=y;function d(g,E){const v=Object.create(null);for(const c of Object.keys(g))E(c,g[c])&&(v[c]=g[c]);return v}e.filter=d}),define(Z[7],x([0,1,8,3]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,b=/^\/\//;function n(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,s){return!r&&!s?"file":r}function w(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const t="",P="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(s,o,m,S,D,R=!1){typeof s=="object"?(this.scheme=s.scheme||t,this.authority=s.authority||t,this.path=s.path||t,this.query=s.query||t,this.fragment=s.fragment||t):(this.scheme=f(s,R),this.authority=o||t,this.path=w(this.scheme,m||t),this.query=S||t,this.fragment=D||t,n(this,R))}static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:m,path:S,query:D,fragment:R}=s;return o===void 0?o=this.scheme:o===null&&(o=t),m===void 0?m=this.authority:m===null&&(m=t),S===void 0?S=this.path:S===null&&(S=t),D===void 0?D=this.query:D===null&&(D=t),R===void 0?R=this.fragment:R===null&&(R=t),o===this.scheme&&m===this.authority&&S===this.path&&D===this.query&&R===this.fragment?this:new g(o,m,S,D,R)}static parse(s,o=!1){const m=I.exec(s);return m?new g(m[2]||t,l(m[4]||t),l(m[5]||t),l(m[7]||t),l(m[9]||t),o):new g(t,t,t,t,t)}static file(s){let o=t;if(L.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const m=s.indexOf(P,2);m===-1?(o=s.substring(2),s=P):(o=s.substring(2,m),s=s.substring(m)||P)}return new g("file",o,s,t,t)}static from(s){const o=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return n(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&s.scheme==="file"?m=y.file(p.win32.join(h(s,!0),...o)).path:m=p.posix.join(s.path,...o),s.with({path:m})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const o=new g(s);return o._formatted=s.external,o._fsPath=s._sep===d?s.fsPath:null,o}}else return s}}e.URI=y;const d=L.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,s){let o,m=-1;for(let S=0;S<r.length;S++){const D=r.charCodeAt(S);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47)m!==-1&&(o+=encodeURIComponent(r.substring(m,S)),m=-1),o!==void 0&&(o+=r.charAt(S));else{o===void 0&&(o=r.substr(0,S));const R=E[D];R!==void 0?(m!==-1&&(o+=encodeURIComponent(r.substring(m,S)),m=-1),o+=R):m===-1&&(m=S)}}return m!==-1&&(o+=encodeURIComponent(r.substring(m))),o!==void 0?o:r}function c(r){let s;for(let o=0;o<r.length;o++){const m=r.charCodeAt(o);m===35||m===63?(s===void 0&&(s=r.substr(0,o)),s+=E[m]):s!==void 0&&(s+=r[o])}return s!==void 0?s:r}function h(r,s){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=h;function a(r,s){const o=s?c:v;let m="",{scheme:S,authority:D,path:R,query:T,fragment:C}=r;if(S&&(m+=S,m+=":"),(D||S==="file")&&(m+=P,m+=P),D){let G=D.indexOf("@");if(G!==-1){const ne=D.substr(0,G);D=D.substr(G+1),G=ne.indexOf(":"),G===-1?m+=o(ne,!1):(m+=o(ne.substr(0,G),!1),m+=":",m+=o(ne.substr(G+1),!1)),m+="@"}D=D.toLowerCase(),G=D.indexOf(":"),G===-1?m+=o(D,!1):(m+=o(D.substr(0,G),!1),m+=D.substr(G))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const G=R.charCodeAt(1);G>=65&&G<=90&&(R=`/${String.fromCharCode(G+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const G=R.charCodeAt(0);G>=65&&G<=90&&(R=`${String.fromCharCode(G+32)}:${R.substr(2)}`)}m+=o(R,!0)}return T&&(m+="?",m+=o(T,!1)),C&&(m+="#",m+=s?C:v(C,!1)),m}function u(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+u(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(r){return r.match(i)?r.replace(i,s=>u(s)):r}}),define(Z[109],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const t=[];let P;try{const I=JSON.parse(w.arguments),y=I[I.length-1];y&&y.__$stack&&(I.pop(),P=y.__$stack),t.push(...I)}catch(I){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:P}}e.parse=k;function M(w){if(typeof w!="string")return M(k(w).stack);const t=w;if(t){const P=b(t),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(I&&I.length===4)return{uri:p.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=M;function b(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function n(w,t){const{args:P,stack:I}=k(w),y=typeof P[0]=="string"&&P.length===1;let d=b(I);d&&(d=`(${d.trim()})`);let g=[];if(typeof P[0]=="string"?d&&y?g=[`%c[${t}] %c${P[0]} %c${d}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:g=[`%c[${t}]%`,f("blue"),...P],d&&!y&&g.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=n;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(V,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!k:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(V,p):k?k.value=p:e.set(V,p),p},je=this&&this.__classPrivateFieldGet||function(V,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(V):L?L.value:e.get(V)};define(Z[37],x([0,1,30,25,7]),function(V,e,p,L,k){"use strict";var M,b,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(l,r,s){let o=l.get(r);return o===void 0&&(o=s,l.set(r,o)),o}e.getOrSet=f;function w(l){const r=[];return l.forEach((s,o)=>{r.push(`${o} => ${s}`)}),`Map(${l.size}) {${r.join(", ")}}`}e.mapToString=w;function t(l){const r=[];return l.forEach(s=>{r.push(s)}),`Set(${l.size}) {${r.join(", ")}}`}e.setToString=t;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class y{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var d;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(d||(d={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class E{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(r){this._iter=r}static forUris(r=()=>!1){return new v(new g(r))}static forPaths(){return new v(new y)}static forStrings(){return new v(new P)}static forConfigKeys(){return new v(new I)}clear(){this._root=void 0}set(r,s){const o=this._iter.reset(r);let m;for(this._root||(this._root=new E,this._root.segment=o.value()),m=this._root;;){const D=o.cmp(m.segment);if(D>0)m.left||(m.left=new E,m.left.segment=o.value()),m=m.left;else if(D<0)m.right||(m.right=new E,m.right.segment=o.value()),m=m.right;else if(o.hasNext())o.next(),m.mid||(m.mid=new E,m.mid.segment=o.value()),m=m.mid;else break}const S=m.value;return m.value=s,m.key=r,S}fill(r,s){const o=s.slice(0);(0,p.shuffle)(o);for(let m of o)this.set(m,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const m=s.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const o=this._iter.reset(r),m=[];let S=this._root;for(;S;){const D=o.cmp(S.segment);if(D>0)m.push([1,S]),S=S.left;else if(D<0)m.push([-1,S]),S=S.right;else if(o.hasNext())o.next(),m.push([0,S]),S=S.mid;else{for(s?(S.left=void 0,S.mid=void 0,S.right=void 0):S.value=void 0;m.length>0&&S.isEmpty();){let[R,T]=m.pop();switch(R){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}S=T}break}}}findSubstr(r){const s=this._iter.reset(r);let o=this._root,m;for(;o;){const S=s.cmp(o.segment);if(S>0)o=o.left;else if(S<0)o=o.right;else if(s.hasNext())s.next(),m=o.value||m,o=o.mid;else break}return o&&o.value||m}findSuperstr(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const m=s.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[s,o]of this)r(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const o=s.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&s.push(o.left),o.mid&&s.push(o.mid),o.right&&s.push(o.right))}}}e.TernarySearchTree=v;class c{constructor(r,s){this[M]="ResourceMap",r instanceof c?(this.map=new Map(r.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=r??c.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[o,m]of this.map)r(m,k.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=c,c.defaultToKey=l=>l.toString();var h;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class a{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const o=this._map.get(r);if(!!o)return s!==0&&this.touch(o,s),o.value}set(r,s,o=0){let m=this._map.get(r);if(m)m.value=s,o!==0&&this.touch(m,o);else{switch(m={key:r,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const o=this._state;let m=this._head;for(;m;){if(s?r.bind(s)(m.value,m.key,this):r(m.value,m.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,s=this._state;let o=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:o.key,done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return m}values(){const r=this,s=this._state;let o=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:o.value,done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return m}entries(){const r=this,s=this._state;let o=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:[o.key,o.value],done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return m}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>r;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,o=r.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const o=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(o.previous=m,m.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const o=r.next,m=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=m,m.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,o)=>{r.push([o,s])}),r}fromJSON(r){this.clear();for(const[s,o]of r)this.set(s,o)}}e.LinkedMap=a;class u extends a{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class i{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return je(this,n,"f").size}forEach(r,s){je(this,n,"f").forEach(r,s)}get(r){return je(this,n,"f").get(r)}has(r){return je(this,n,"f").has(r)}entries(){return je(this,n,"f").entries()}keys(){return je(this,n,"f").keys()}values(){return je(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return je(this,n,"f").entries()}}e.ReadonlyMapView=i}),define(Z[110],x([0,1,18,25,7]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,f)}e.stringify=M;function b(t){let P=JSON.parse(t);return P=w(P),P}e.parse=b;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function w(t,P=0){if(!t||P>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof p.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let I=0;I<t.length;++I)t[I]=w(t[I],P+1);else for(const I in t)Object.hasOwnProperty.call(t,I)&&(t[I]=w(t[I],P+1))}return t}e.revive=w}),define(Z[10],x([0,1,3,7]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,t){this._hosts[f]=w,this._ports[f]=t}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const P=this._ports[w],I=this._connectionTokens[w];let y=`path=${encodeURIComponent(f.path)}`;return typeof I=="string"&&(y+=`&tkn=${encodeURIComponent(I)}`),L.URI.from({scheme:p.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${P}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new M;class b{asBrowserUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${k.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==b.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}b.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new b}),define(Z[66],x([0,1,37]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function k(w){return f(w,"NFC",L)}e.normalizeNFC=k;const M=new p.LRUCache(1e4);function b(w){return f(w,"NFD",M)}e.normalizeNFD=b;const n=/[^\u0000-\u0080]/;function f(w,t,P){if(!w)return w;const I=P.get(w);if(I)return I;let y;return n.test(w)?y=w.normalize(t):y=w,P.set(w,y),y}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return b(t).replace(w,"")}}()}),define(Z[15],x([0,1,31,10,8,3,25,7]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(y){return(0,n.uriToFsPath)(y,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,g,E=!1){return d===g?0:(0,b.compare)(this.getComparisonKey(d,E),this.getComparisonKey(g,E))}isEqual(d,g,E=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,E)===this.getComparisonKey(g,E)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,E=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return p.isEqualOrParent(f(d),f(g),this._ignorePathCasing(d))&&d.query===g.query&&(E||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return p.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(E||d.fragment===g.fragment)}return!1}joinPath(d,...g){return n.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.dirname(f(d))).path:(g=k.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.normalize(f(d))).path:g=k.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const c=k.relative(f(d),f(g));return M.isWindows?p.toSlashes(c):c}let E=d.path||"/",v=g.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const h=Math.min(E.length,v.length);c<h&&!(E.charCodeAt(c)!==v.charCodeAt(c)&&E.charAt(c).toLowerCase()!==v.charAt(c).toLowerCase());c++);E=v.substr(0,c)+E.substr(c)}return k.posix.relative(E,v)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const E=n.URI.file(k.resolve(f(d),g));return d.with({authority:E.authority,path:E.path})}return g=p.toPosixPath(g),d.with({path:k.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,b.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=k.sep){if(d.scheme===L.Schemas.file){const E=f(d);return E.length>p.getRoot(E).length&&E[E.length-1]===g}else{const E=d.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=k.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=k.sep){let E=!1;if(d.scheme===L.Schemas.file){const v=f(d);E=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===g}else{g="/";const v=d.path;E=v.length===1&&v.charCodeAt(v.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(y=>y.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(y,d){const g=[];for(let E=0;E<y.length;E++){const v=d(y[E]);y.some((c,h)=>h===E?!1:(0,e.isEqualOrParent)(v,d(c)))||g.push(y[E])}return g}e.distinctParents=t;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[a,u]=h.split(":");a&&u&&E.set(a,u)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&E.set(y.META_DATA_MIME,c),E}y.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function I(y,d,g){if(d){let E=y.path;return E&&E[0]!==k.posix.sep&&(E=k.posix.sep+E),y.with({scheme:g,authority:d,path:E})}return y.with({scheme:g})}e.toLocalResource=I}),define(Z[9],x([0,1,23,17,4,2,15]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n($){return!!$&&typeof $.then=="function"}e.isThenable=n;function f($){const z=new p.CancellationTokenSource,H=$(z.token),W=new Promise((q,U)=>{const A=z.token.onCancellationRequested(()=>{A.dispose(),z.dispose(),U((0,L.canceled)())});Promise.resolve(H).then(F=>{A.dispose(),z.dispose(),q(F)},F=>{A.dispose(),z.dispose(),U(F)})});return new class{cancel(){z.cancel()}then(q,U){return W.then(q,U)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=f;function w($,z,H){return Promise.race([$,new Promise(W=>z.onCancellationRequested(()=>W(H)))])}e.raceCancellation=w;async function t($){let z=-1;const H=$.map((q,U)=>q.then(A=>(z=U,A))),W=await Promise.race(H);return $.forEach((q,U)=>{U!==z&&q.cancel()}),W}e.raceCancellablePromises=t;function P($,z,H){let W;const q=setTimeout(()=>{W?.(void 0),H?.()},z);return Promise.race([$.finally(()=>clearTimeout(q)),new Promise(U=>W=U)])}e.raceTimeout=P;function I($){return new Promise((z,H)=>{const W=$();n(W)?W.then(z,H):z(W)})}e.asPromise=I;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(H,H).then(W)})}return new Promise((H,W)=>{this.queuedPromise.then(H,W)})}return this.activePromise=z(),new Promise((H,W)=>{this.activePromise.then(q=>{this.activePromise=null,H(q)},q=>{this.activePromise=null,W(q)})})}}e.Throttler=y;class d{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(z,H){const q=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(z)===q&&this.promiseMap.delete(z)});return this.promiseMap.set(z,q),q}}e.SequencerByKey=g;class E{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,H=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,q)=>{this.doResolve=W,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class v{constructor(z){this.delayer=new E(z),this.throttler=new y}trigger(z,H){return this.delayer.trigger(()=>this.throttler.queue(z),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class c{constructor(){this._isOpen=!1,this._promise=new Promise((z,H)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class h extends c{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function a($,z){return z?new Promise((H,W)=>{const q=setTimeout(()=>{U.dispose(),H()},$),U=z.onCancellationRequested(()=>{clearTimeout(q),U.dispose(),W((0,L.canceled)())})}):f(H=>a($,H))}e.timeout=a;function u($,z=0){const H=setTimeout($,z);return(0,M.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=u;function i($){const z=[];let H=0;const W=$.length;function q(){return H<W?$[H++]():null}function U(A){A!=null&&z.push(A);const F=q();return F?F.then(U):Promise.resolve(z)}return Promise.resolve(null).then(U)}e.sequence=i;function l($,z=W=>!!W,H=null){let W=0;const q=$.length,U=()=>{if(W>=q)return Promise.resolve(H);const A=$[W++];return Promise.resolve(A()).then(B=>z(B)?Promise.resolve(B):U())};return U()}e.first=l;function r($,z=W=>!!W,H=null){if($.length===0)return Promise.resolve(H);let W=$.length;const q=()=>{W=-1;for(const U of $)U.cancel?.()};return new Promise((U,A)=>{for(const F of $)F.then(B=>{--W>=0&&z(B)?(q(),U(B)):W===0&&U(H)}).catch(B=>{--W>=0&&(q(),A(B))})})}e.firstParallel=r;class s{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((H,W)=>{this.outstandingPromises.push({factory:z,c:H,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const H=z.factory();H.then(z.c,z.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class o extends s{constructor(){super(1)}}e.Queue=o;class m{constructor(){this.queues=new Map}queueFor(z,H=b.extUri){const W=H.getComparisonKey(z);let q=this.queues.get(W);return q||(q=new o,k.Event.once(q.onFinished)(()=>{q?.dispose(),this.queues.delete(W)}),this.queues.set(W,q)),q}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=m;class S{constructor(z,H){this._token=-1,typeof z=="function"&&typeof H=="number"&&this.setIfNotSet(z,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},H)}setIfNotSet(z,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},H))}}e.TimeoutTimer=S;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,H){this.cancel(),this._token=setInterval(()=>{z()},H)}}e.IntervalTimer=D;class R{constructor(z,H){this.timeoutToken=-1,this.runner=z,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class T{constructor(z,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class C extends R{constructor(z,H){super(z,H);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class G extends M.Disposable{constructor(z,H,W,q){super();this.maxWorkChunkSize=z,this.maxPendingWork=H,this.throttleDelay=W,this.handler=q,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{const z=setTimeout(()=>{const W=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0,clearTimeout(z))}}}:e.runWhenIdle=($,z)=>{const H=requestIdleCallback($,typeof z=="number"?{timeout:z}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(H))}}}}();class ne{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function oe($,z,H){let W;for(let q=0;q<H;q++)try{return await $()}catch(U){W=U,await a(z)}throw W}e.retry=oe;class K{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,H,W){return this._pending={taskId:z,cancel:()=>W?.(),promise:H},H.then(()=>this.donePending(z),()=>this.donePending(z)),H}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let H,W;const q=new Promise((U,A)=>{H=U,W=A});this._next={run:z,promise:q,promiseResolve:H,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=K;class ee{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class O{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,H)=>{this.completeCallback=z,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(H=>{this.completeCallback(z),this.resolved=!0,H()})}error(z){return new Promise(H=>{this.errorCallback(z),this.rejected=!0,H()})}cancel(){new Promise(z=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=O;var j;(function($){async function z(H){let W;const q=await Promise.all(H.map(U=>U.then(A=>A,A=>{W||(W=A)})));if(typeof W!="undefined")throw W;return q}$.settled=z})(j=e.Promises||(e.Promises={}))}),define(Z[111],x([0,1,9,31,37,8,25]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",w="/",t="[/\\\\]",P="[^/\\\\]",I=/\//g;function y(W){switch(W){case 0:return"";case 1:return`${P}*?`;default:return`(?:${t}|${P}+${t}|${t}${P}+)*?`}}function d(W,q){if(!W)return[];const U=[];let A=!1,F=!1,B="";for(const Y of W){switch(Y){case q:if(!A&&!F){U.push(B),B="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":F=!0;break;case"]":F=!1;break}B+=Y}return B&&U.push(B),U}e.splitGlobAware=d;function g(W){if(!W)return"";let q="";const U=d(W,w);if(U.every(A=>A===f))q=".*";else{let A=!1;U.forEach((F,B)=>{if(F===f){A||(q+=y(2),A=!0);return}let Y=!1,_="",N=!1,Q="";for(const J of F){if(J!=="}"&&Y){_+=J;continue}if(N&&(J!=="]"||!Q)){let re;J==="-"?re=J:(J==="^"||J==="!")&&!Q?re="^":J===w?re="":re=b.escapeRegExpCharacters(J),Q+=re;continue}switch(J){case"{":Y=!0;continue;case"[":N=!0;continue;case"}":q+=`(?:${d(_,",").map(te=>g(te)).join("|")})`,Y=!1,_="";break;case"]":q+="["+Q+"]",N=!1,Q="";break;case"?":q+=P;continue;case"*":q+=y(1);continue;default:q+=b.escapeRegExpCharacters(J)}}B<U.length-1&&(U[B+1]!==f||B+2<U.length)&&(q+=t),A=!1})}return q}const E=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),l=function(){return!1},r=function(){return null};function s(W,q){if(!W)return r;let U;typeof W!="string"?U=W.pattern:U=W,U=U.trim();const A=`${U}_${!!q.trimForExclusions}`;let F=i.get(A);if(F)return o(F,W);let B;if(E.test(U)){const Y=U.substr(4);F=function(_,N){return typeof _=="string"&&_.endsWith(Y)?U:null}}else(B=v.exec(m(U,q)))?F=S(B[1],U):(q.trimForExclusions?h:c).test(U)?F=D(U,q):(B=a.exec(m(U,q)))?F=R(B[1].substr(1),U,!0):(B=u.exec(m(U,q)))?F=R(B[1],U,!1):F=T(U);return i.set(A,F),o(F,W)}function o(W,q){return typeof q=="string"?W:function(U,A){return L.isEqualOrParent(U,q.base)?W(M.relative(q.base,U),A):null}}function m(W,q){return q.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function S(W,q){const U=`/${W}`,A=`\\${W}`,F=function(Y,_){return typeof Y!="string"?null:_?_===W?q:null:Y===W||Y.endsWith(U)||Y.endsWith(A)?q:null},B=[W];return F.basenames=B,F.patterns=[q],F.allBasenames=B,F}function D(W,q){const U=H(W.slice(1,-1).split(",").map(_=>s(_,q)).filter(_=>_!==r),W),A=U.length;if(!A)return r;if(A===1)return U[0];const F=function(_,N){for(let Q=0,J=U.length;Q<J;Q++)if(U[Q](_,N))return W;return null},B=U.find(_=>!!_.allBasenames);B&&(F.allBasenames=B.allBasenames);const Y=U.reduce((_,N)=>N.allPaths?_.concat(N.allPaths):_,[]);return Y.length&&(F.allPaths=Y),F}function R(W,q,U){const A=M.sep===M.posix.sep,F=A?W:W.replace(I,M.sep),B=M.sep+F,Y=M.posix.sep+W,_=U?function(N,Q){return typeof N=="string"&&(N===F||N.endsWith(B)||!A&&(N===W||N.endsWith(Y)))?q:null}:function(N,Q){return typeof N=="string"&&(N===F||!A&&N===W)?q:null};return _.allPaths=[(U?"*/":"./")+W],_}function T(W){try{const q=new RegExp(`^${g(W)}$`);return function(U){return q.lastIndex=0,typeof U=="string"&&q.test(U)?W:null}}catch(q){return r}}function C(W,q,U){return!W||typeof q!="string"?!1:G(W)(q,void 0,U)}e.match=C;function G(W,q={}){if(!W)return l;if(typeof W=="string"||ee(W)){const U=s(W,q);if(U===r)return l;const A=function(F,B){return!!U(F,B)};return U.allBasenames&&(A.allBasenames=U.allBasenames),U.allPaths&&(A.allPaths=U.allPaths),A}return $(W,q)}e.parse=G;function ne(W){if(!W)return;let q;return U=>(q||(q=(W()||Promise.resolve([])).then(A=>A?K(A):{})),q.then(A=>!!A[U]))}e.hasSiblingPromiseFn=ne;function oe(W){if(!W)return;let q;return U=>{if(!q){const A=W();q=A?K(A):{}}return!!q[U]}}e.hasSiblingFn=oe;function K(W){const q={};for(const U of W)q[U]=!0;return q}function ee(W){const q=W;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=ee;function O(W){return W.allBasenames||[]}e.getBasenameTerms=O;function j(W){return W.allPaths||[]}e.getPathTerms=j;function $(W,q){const U=H(Object.getOwnPropertyNames(W).map(_=>z(_,W[_],q)).filter(_=>_!==r)),A=U.length;if(!A)return r;if(!U.some(_=>!!_.requiresSiblings)){if(A===1)return U[0];const _=function(J,re){for(let le=0,te=U.length;le<te;le++){const ae=U[le](J,re);if(ae)return ae}return null},N=U.find(J=>!!J.allBasenames);N&&(_.allBasenames=N.allBasenames);const Q=U.reduce((J,re)=>re.allPaths?J.concat(re.allPaths):J,[]);return Q.length&&(_.allPaths=Q),_}const F=function(_,N,Q){let J;for(let re=0,le=U.length;re<le;re++){const te=U[re];te.requiresSiblings&&Q&&(N||(N=M.basename(_)),J||(J=N.substr(0,N.length-M.extname(_).length)));const ae=te(_,N,J,Q);if(ae)return ae}return null},B=U.find(_=>!!_.allBasenames);B&&(F.allBasenames=B.allBasenames);const Y=U.reduce((_,N)=>N.allPaths?_.concat(N.allPaths):_,[]);return Y.length&&(F.allPaths=Y),F}function z(W,q,U){if(q===!1)return r;const A=s(W,U);if(A===r)return r;if(typeof q=="boolean")return A;if(q){const F=q.when;if(typeof F=="string"){const B=(Y,_,N,Q)=>{if(!Q||!A(Y,_))return null;const J=F.replace("$(basename)",N),re=Q(J);return(0,p.isThenable)(re)?re.then(le=>le?W:null):re?W:null};return B.requiresSiblings=!0,B}}return A}function H(W,q){const U=W.filter(_=>!!_.basenames);if(U.length<2)return W;const A=U.reduce((_,N)=>{const Q=N.basenames;return Q?_.concat(Q):_},[]);let F;if(q){F=[];for(let _=0,N=A.length;_<N;_++)F.push(q)}else F=U.reduce((_,N)=>{const Q=N.patterns;return Q?_.concat(Q):_},[]);const B=function(_,N){if(typeof _!="string")return null;if(!N){let J;for(J=_.length;J>0;J--){const re=_.charCodeAt(J-1);if(re===47||re===92)break}N=_.substr(J)}const Q=A.indexOf(N);return Q!==-1?F[Q]:null};B.basenames=A,B.patterns=F,B.allBasenames=A;const Y=W.filter(_=>!_.basenames);return Y.push(B),Y}}),define(Z[34],x([0,1,31,10,8,3,15,25,7]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,o,m){if(typeof s=="string"&&(s=f.URI.file(s)),m){const D=m.getWorkspaceFolder(s);if(D){const R=m.getWorkspace().folders.length>1;let T;if((0,b.isEqual)(D.uri,s)?T="":T=(0,b.relativePath)(D.uri,s),R){const C=D.name?D.name:(0,b.basename)(D.uri);T=T?C+" \u2022 "+T:C}return T}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(s.fsPath))return(0,k.normalize)(P(s.fsPath));let S=(0,k.normalize)(s.fsPath);return!M.isWindows&&o?.userHome&&(S=y(S,o.userHome.fsPath)),S}e.getPathLabel=w;function t(s){if(!s)return;typeof s=="string"&&(s=f.URI.file(s));const o=(0,b.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return M.isWindows&&(0,p.isRootOrDriveLetter)(o)?P(o):o}e.getBaseLabel=t;function P(s){return(0,p.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let I=Object.create(null);function y(s,o){if(M.isWindows||!s||!o)return s;let m=I.original===o?I.normalized:void 0;return m||(m=`${(0,n.rtrim)(o,k.posix.sep)}${k.posix.sep}`,I={original:o,normalized:m}),(M.isLinux?s.startsWith(m):(0,n.startsWithIgnoreCase)(s,m))&&(s=`~/${s.substr(m.length)}`),s}e.tildify=y;function d(s,o){return s.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=d;const g="\u2026",E="\\\\",v="~";function c(s,o=k.sep){const m=new Array(s.length);let S=!1;for(let D=0;D<s.length;D++){let R=s[D];if(R===""){m[D]=`.${o}`;continue}if(!R){m[D]=R;continue}S=!0;let T="";R.indexOf(E)===0?(T=R.substr(0,R.indexOf(E)+E.length),R=R.substr(R.indexOf(E)+E.length)):R.indexOf(o)===0?(T=R.substr(0,R.indexOf(o)+o.length),R=R.substr(R.indexOf(o)+o.length)):R.indexOf(v)===0&&(T=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const C=R.split(o);for(let G=1;S&&G<=C.length;G++)for(let ne=C.length-G;S&&ne>=0;ne--){S=!1;let oe=C.slice(ne,ne+G).join(o);for(let K=0;!S&&K<s.length;K++)if(K!==D&&s[K]&&s[K].indexOf(oe)>-1){const ee=ne+G===C.length,O=ne>0&&s[K].indexOf(o)>-1?o+oe:oe,j=s[K].endsWith(O);S=!ee||j}if(!S){let K="";(C[0].endsWith(":")||T!=="")&&(ne===1&&(ne=0,G++,oe=C[0]+o+oe),ne>0&&(K=C[0]+o),K=T+K),ne>0&&(K=K+g+o),K=K+oe,ne+G<C.length&&(K=K+o+g),m[D]=K}}S&&(m[D]=R)}return m}e.shorten=c;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function a(s,o=Object.create(null)){const m=[];let S=!1,D="";for(const R of s)if(R==="$"||S&&R==="{")D&&m.push({value:D,type:h.TEXT}),D="",S=!0;else if(R==="}"&&S){const T=o[D];if(typeof T=="string")T.length&&m.push({value:T,type:h.VARIABLE});else if(T){const C=m[m.length-1];(!C||C.type!==h.SEPARATOR)&&m.push({value:T.label,type:h.SEPARATOR})}D="",S=!1}else D+=R;return D&&!S&&m.push({value:D,type:h.TEXT}),m.filter((R,T)=>{if(R.type===h.SEPARATOR){const C=m[T-1],G=m[T+1];return[C,G].every(ne=>ne&&(ne.type===h.VARIABLE||ne.type===h.TEXT)&&ne.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=a;function u(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function i(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,m=>m==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function l(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=l;function r(s){const o=s.indexOf("/")!==-1?k.posix:k.win32,m=o.basename(s),S=o.dirname(s);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}e.splitName=r}),define(Z[28],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return p.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){b(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,w="";return w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w}e.generateUuid=n}),define(Z[112],x([0,1,58,32,43]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(b,n){if(await new Promise((t,P)=>{const I=L.createReadStream(b),y=p.createHash("sha1");I.pipe(y);const d=(0,k.once)((g,E)=>{I.removeAllListeners(),y.removeAllListeners(),g?P(g):t(E)});I.once("error",d),I.once("end",d),y.once("error",d),y.once("data",g=>d(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[81],x([0,1,239]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new p.StringDecoder(M),this.remaining=null}write(M){const b=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return b;let f=0,w,t=f;for(;t<n.length;)if(w=n.charCodeAt(t),w===13||w===10){if(b.push(n.substring(f,t)),t++,t<n.length){const P=w;w=n.charCodeAt(t),(P===13&&w===10||P===10&&w===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,b}end(){return this.remaining}}e.LineDecoder=L}),define(Z[113],x([0,1,26]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await b())}catch(t){f(t)}finally{clearTimeout(w)}})}e.getMac=M;function b(){return new Promise((n,f)=>{try{const w=(0,p.networkInterfaces)();for(let t in w){const P=w[t];if(P){for(const{mac:I}of P)if(k(I))return n(I)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Z[67],x([0,1,26,17,37,28,113]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,P=0;const I=(0,p.networkInterfaces)();for(let y in I){const d=I[y];if(d)for(const{mac:g,internal:E}of d)E||(P+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=P>0?t/P:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||M.generateUuid())()),n}e.getMachineId=f;async function w(){try{const t=await new Promise((I,y)=>{V(["crypto"],I,y)}),P=await(0,b.getMac)();return t.createHash("sha256").update(P,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(Z[19],x([0,1,32,26,114,9,31,66,8,3,15,7,28]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(O,j=y.UNLINK){if((0,b.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return j===y.UNLINK?E(O):g(O)}async function g(O){try{const j=(0,f.join)((0,L.tmpdir)(),(0,I.generateUuid)());try{await e.Promises.rename(O,j)}catch($){return E(O)}E(j).catch($=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function E(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function v(O){if((0,b.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(O,{recursive:!0})}e.rimrafSync=v;async function c(O,j){return u(await(j?h(O):(0,k.promisify)(p.readdir)(O)))}async function h(O){try{return await(0,k.promisify)(p.readdir)(O,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const j=[],$=await c(O);for(const z of $){let H=!1,W=!1,q=!1;try{const U=await e.Promises.lstat((0,f.join)(O,z));H=U.isFile(),W=U.isDirectory(),q=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}j.push({name:z,isFile:()=>H,isDirectory:()=>W,isSymbolicLink:()=>q})}return j}function a(O){return u(p.readdirSync(O))}e.readdirSync=a;function u(O){return O.map(j=>typeof j=="string"?w.isMacintosh?(0,n.normalizeNFC)(j):j:(j.name=w.isMacintosh?(0,n.normalizeNFC)(j.name):j.name,j))}async function i(O){const j=await c(O),$=[];for(const z of j)await r.existsDirectory((0,f.join)(O,z))&&$.push(z);return $}function l(O,j=1e3){return new Promise($=>{let z=!1;const H=setInterval(()=>{z||(z=!0,p.access(O,W=>{z=!1,W&&(clearInterval(H),$(void 0))}))},j)})}e.whenDeleted=l;var r;(function(O){async function j(H){let W;try{if(W=await e.Promises.lstat(H),!W.isSymbolicLink())return{stat:W}}catch(q){}try{return{stat:await e.Promises.stat(H),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(w.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw U}throw q}}O.stat=j;async function $(H){try{const{stat:W,symbolicLink:q}=await O.stat(H);return W.isFile()&&q?.dangling!==!0}catch(W){}return!1}O.existsFile=$;async function z(H){try{const{stat:W,symbolicLink:q}=await O.stat(H);return W.isDirectory()&&q?.dangling!==!0}catch(W){}return!1}O.existsDirectory=z})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new M.ResourceQueue;function o(O,j,$){return s.queueFor(P.URI.file(O),t.extUriBiasedIgnorePathCase).queue(()=>{const z=R($);return new Promise((H,W)=>S(O,j,z,q=>q?W(q):H()))})}let m=!0;function S(O,j,$,z){if(!m)return p.writeFile(O,j,{mode:$.mode,flag:$.flag},z);p.open(O,$.flag,$.mode,(H,W)=>{if(H)return z(H);p.writeFile(W,j,q=>{if(q)return p.close(W,()=>z(q));p.fdatasync(W,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),m=!1),p.close(W,A=>z(A))))})})}function D(O,j,$){const z=R($);if(!m)return p.writeFileSync(O,j,{mode:z.mode,flag:z.flag});const H=p.openSync(O,z.flag,z.mode);try{p.writeFileSync(H,j);try{p.fdatasyncSync(H)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),m=!1}}finally{p.closeSync(H)}}e.writeFileSync=D;function R(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function T(O,j){if(O===j)return;async function $(z){try{const H=await e.Promises.lstat(z);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(z,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(O,j),await $(j)}catch(z){if(O.toLowerCase()!==j.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await C(O,j,{preserveSymlinks:!1}),await d(O,y.MOVE),await $(j);else throw z}}async function C(O,j,$){return ne(O,j,{root:{source:O,target:j},options:$,handledSourcePaths:new Set})}const G=511;async function ne(O,j,$){if($.handledSourcePaths.has(O))return;$.handledSourcePaths.add(O);const{stat:z,symbolicLink:H}=await r.stat(O);if(H){if($.options.preserveSymlinks)try{return await ee(O,j,$)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(H.dangling)return}return z.isDirectory()?oe(O,j,z.mode&G,$):K(O,j,z.mode&G)}async function oe(O,j,$,z){await e.Promises.mkdir(j,{recursive:!0,mode:$});const H=await c(O);for(const W of H)await ne((0,f.join)(O,W),(0,f.join)(j,W),z)}async function K(O,j,$){await e.Promises.copyFile(O,j),await e.Promises.chmod(j,$)}async function ee(O,j,$){let z=await e.Promises.readlink(O);(0,b.isEqualOrParent)(z,$.root.source,!w.isLinux)&&(z=(0,f.join)($.root.target,z.substr($.root.source.length+1))),await e.Promises.symlink(z,j)}e.Promises=new class{get access(){return(0,k.promisify)(p.access)}get stat(){return(0,k.promisify)(p.stat)}get lstat(){return(0,k.promisify)(p.lstat)}get utimes(){return(0,k.promisify)(p.utimes)}get read(){return(0,k.promisify)(p.read)}get readFile(){return(0,k.promisify)(p.readFile)}get write(){return(0,k.promisify)(p.write)}get appendFile(){return(0,k.promisify)(p.appendFile)}get fdatasync(){return(0,k.promisify)(p.fdatasync)}get truncate(){return(0,k.promisify)(p.truncate)}get rename(){return(0,k.promisify)(p.rename)}get copyFile(){return(0,k.promisify)(p.copyFile)}get open(){return(0,k.promisify)(p.open)}get close(){return(0,k.promisify)(p.close)}get symlink(){return(0,k.promisify)(p.symlink)}get readlink(){return(0,k.promisify)(p.readlink)}get chmod(){return(0,k.promisify)(p.chmod)}get mkdir(){return(0,k.promisify)(p.mkdir)}get unlink(){return(0,k.promisify)(p.unlink)}get rmdir(){return(0,k.promisify)(p.rmdir)}get realpath(){return(0,k.promisify)(p.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return i}get writeFile(){return o}get rm(){return d}get move(){return T}get copy(){return C}}}),define(Z[82],x([0,1,32,8,25,19]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function b(t){const P=(0,L.dirname)(t);if(t===P)return t;const I=((0,L.basename)(t)||t).toLowerCase();try{const d=(0,M.readdirSync)(P).filter(g=>g.toLowerCase()===I);if(d.length===1){const g=b(P);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(I);if(g>=0){const E=b(P);if(E)return(0,L.join)(E,d[g])}}}catch(y){}return null}e.realcaseSync=b;async function n(t){try{return await M.Promises.realpath(t)}catch(P){const I=w(t);return await M.Promises.access(I,p.constants.R_OK),I}}e.realpath=n;function f(t){try{return p.realpathSync(t)}catch(P){const I=w(t);return p.accessSync(I,p.constants.R_OK),I}}e.realpathSync=f;function w(t){return(0,k.rtrim)((0,L.normalize)(t),L.sep)}}),define(Z[115],x([0,1,59]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,t=1){let P=!1;return new Promise(I=>{const y=setTimeout(()=>{if(!P)return P=!0,I(0)},w);k(n,f,t,d=>{if(!P)return P=!0,clearTimeout(y),I(d)})})}e.findFreePort=L;function k(n,f,w,t){if(f===0)return t(0);const P=new p.Socket;P.once("connect",()=>(b(P),k(n+w,f-1,w,t))),P.once("data",()=>{}),P.once("error",I=>(b(P),I.code!=="ECONNREFUSED"?k(n+w,f-1,w,t):t(n))),P.connect(n,"127.0.0.1")}function M(n,f,w){let t=!1,P,I=1;const y=p.createServer({pauseOnConnect:!0});function d(g,E){t||(t=!0,y.removeAllListeners(),y.close(),P&&clearTimeout(P),E(g))}return new Promise(g=>{P=setTimeout(()=>{d(0,g)},w),y.on("listening",()=>{d(n,g)}),y.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&I<f?(n++,I++,y.listen(n,"127.0.0.1")):d(0,g)}),y.on("close",()=>{d(0,g)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function b(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Z[116],x([0,1,26,8,19]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,b=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class P{constructor(u,i,l){this.exePath=u,this.displayName=i,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:a=!1}={}){return a?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:a=!1,findPreview:u=!1}={}){const i=I({useAlternateBitness:a});if(!i)return null;const l=L.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(l))return null;let r=-1,s=null;for(const S of await k.Promises.readdir(l)){let D=-1;if(u){const T=S.indexOf("-");if(T<0)continue;const C=S.substring(0,T);if(!M.test(C)||S.substring(T+1)!=="preview")continue;D=parseInt(C,10)}else{if(!M.test(S))continue;D=parseInt(S,10)}if(D<=r)continue;const R=L.join(l,S,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(s=R,r=D)}if(!s)return null;const o=i.includes("x86")?" (x86)":"",m=u?" Preview":"";return new P(s,`PowerShell${m}${o}`,!0)}async function d({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:l}=a?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:b,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(u))if(i.test(r)){const s=L.join(u,r,"pwsh.exe");return new P(s,l)}return null}function g(){const a=L.join(p.homedir(),".dotnet","tools","pwsh.exe");return new P(a,".NET Core PowerShell Global Tool")}function E(){const a=L.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(a,"Windows PowerShell",!0)}async function*v(){let a=await y();a&&(yield a),a=await y({useAlternateBitness:!0}),a&&(yield a),a=await d(),a&&(yield a),a=g(),a&&(yield a),a=await y({findPreview:!0}),a&&(yield a),a=await d({findPreview:!0}),a&&(yield a),a=await y({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=E(),a&&(yield a)}async function*c(){for await(const a of v())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=c;async function h(){for await(const a of c())return a;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[83],x([0,1,41,10]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(b){return new Promise((n,f)=>{let w;const t=new Map;function P(y,d,g,E,v){const c=t.get(d);if(y===b||c){const h={name:I(g),cmd:g,pid:y,ppid:d,load:E,mem:v};t.set(y,h),y===b&&(w=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((a,u)=>a.pid-u.pid)))}}function I(y){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,v=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(y))return"watcherService ";if(E.exec(y))return"electron-crash-reporter";if(v.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let a=h.exec(y);if(a&&a.length===2)return a[1]==="renderer"?d.exec(y)?"shared-process":"window":a[1];const u=/[a-zA-Z-]+\.js/g;let i="";do a=u.exec(y),a&&(i+=a+" ");while(a);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{V(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(b,g=>{d.getProcessCpuUsage(g,E=>{const v=new Map;E.forEach(c=>{const h=y(c.commandLine||"");v.set(c.pid,{name:I(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),w=v.get(b),w?(v.forEach(c=>{const h=v.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),v.forEach(c=>{c.children&&(c.children=c.children.sort((h,a)=>h.pid-a.pid))}),n(w)):f(new Error(`Root process ${b} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[w];const g=[];for(;d.length;){const v=d.shift();v&&(g.push(v.pid),v.children&&(d=d.concat(v.children)))}let E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);E+=" "+g.join(" "),(0,p.exec)(E,{},(v,c,h)=>{if(v||h)f(v||new Error(h.toString()));else{const a=c.toString().split(`
`);for(let u=0;u<g.length;u++){const i=t.get(g[u]);i.load=parseFloat(a[u])}if(!w){f(new Error(`Root process ${b} not found`));return}n(w)}})};(0,p.exec)("which ps",{},(d,g,E)=>{if(d||E)if(process.platform!=="linux")f(d||new Error(E.toString()));else{const v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,p.exec)(v,{},(c,h,a)=>{c||a?f(c||new Error(a.toString())):(M(h,P),y())})}else{const v=g.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,a,u)=>{h||u&&!u.includes("screen size is bogus")?f(h||new Error(u.toString())):(M(a,P),process.platform==="linux"?y():w?n(w):f(new Error(`Root process ${b} not found`)))})}})}})}e.listProcesses=k;function M(b,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=b.toString().split(`
`);for(const t of w){const P=f.exec(t.trim());P&&P.length===6&&n(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(Z[117],x([0,1,32,23,31,2,66,8,3,19]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function t(d,g,E){return I({path:d,isDirectory:!1},g,E)}e.watchFile=t;function P(d,g,E){return I({path:d,isDirectory:!0},g,E)}e.watchFolder=P,e.CHANGE_BUFFER_DELAY=100;function I(d,g,E){if(f.isMacintosh&&(0,k.isEqualOrParent)(d.path,"/Volumes/"))return E(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const v=(0,n.basename)(d.path),c=new Map;let h=!1,a=[(0,M.toDisposable)(()=>{c.forEach(u=>(0,M.dispose)(u)),c.clear()})];try{const u=(0,p.watch)(d.path);a.push((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const i=new Set;d.isDirectory&&w.Promises.readdir(d.path).then(l=>l.forEach(r=>i.add(r))),u.on("error",(l,r)=>{h||E(`Failed to watch ${d.path} for changes using fs.watch() (${l}, ${r})`)}),u.on("change",(l,r)=>{if(h)return;let s="";if(r&&(s=r.toString(),f.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!s||l!=="change"&&l!=="rename")return;const o=d.isDirectory?(0,n.join)(d.path,s):d.path;if(d.isDirectory)if(l==="rename"){const m=c.get(o);m&&(0,M.dispose)(m);const S=setTimeout(async()=>{c.delete(o);const D=await w.Promises.exists(o);if(h)return;let R;D?i.has(s)?R="changed":(R="added",i.add(s)):(i.delete(s),R="deleted"),g(R,o)},e.CHANGE_BUFFER_DELAY);c.set(o,(0,M.toDisposable)(()=>clearTimeout(S)))}else{let m;i.has(s)?m="changed":(m="added",i.add(s)),g(m,o)}else if(l==="rename"||s!==v){const m=setTimeout(async()=>{const S=await w.Promises.exists(o);h||(S?(g("changed",o),a=[I(d,g,E)]):g("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(a),a=[(0,M.toDisposable)(()=>clearTimeout(m))]}else g("changed",o)})}catch(u){w.Promises.exists(d.path).then(i=>{i&&!h&&E(`Failed to watch ${d.path} for changes using fs.watch() (${u.toString()})`)})}return(0,M.toDisposable)(()=>{h=!0,a=(0,M.dispose)(a)})}async function y(d,g,E,v=512){const c=await w.Promises.open(d,"r"),h=Buffer.allocUnsafe(v),a=new L.CancellationTokenSource(E);let u,i=!1;const l=t(d,async r=>{if(r==="changed"){if(i)return;i=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:s}=await w.Promises.read(c,h,0,v,null);if(!s||a.token.isCancellationRequested)break;g(h.slice(0,s))}}catch(s){u=new Error(s),a.dispose(!0)}finally{i=!1}}},r=>{u=new Error(r),a.dispose(!0)});return new Promise((r,s)=>{a.token.onCancellationRequested(async()=>{l.dispose(),await w.Promises.close(c),u?s(u):r()})})}e.watchFileContents=y}),define(Z[118],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[119],x([0,1,14,13,118]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){p.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,w,t,P)=>{const I=b(n,t,w);I.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(n.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{I&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function b(n,f,w){const t=new p.Menu;return w.forEach(P=>{let I;P.type==="separator"?I=new p.MenuItem({type:P.type}):Array.isArray(P.submenu)?I=new p.MenuItem({submenu:b(n,f,P.submenu),label:P.label}):I=new p.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(y,d,g)=>n.sender.send(f,P.id,g)}),t.append(I)}),t}});var ue=this&&this.__decorate||function(V,e,p,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,b;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(V,e,p,L);else for(var n=V.length-1;n>=0;n--)(b=V[n])&&(M=(k<3?b(M):k>3?b(e,p,M):b(e,p))||M);return k>3&&M&&Object.defineProperty(e,p,M),M};define(Z[35],x([0,1,30,9,18,23,47,17,4,2,110,25,13]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(v||(v={}));class c{constructor(W){this.buffer=W,this.pos=0}read(W){const q=this.buffer.slice(this.pos,this.pos+W);return this.pos+=q.byteLength,q}}class h{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}var a;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(a||(a={}));function u(H){const W=k.VSBuffer.alloc(4);return W.writeUInt32BE(H,0),W}function i(H){return H.read(4).readUInt32BE(0)}function l(H){const W=k.VSBuffer.alloc(1);return W.writeUInt8(H,0),W}const r={Undefined:l(a.Undefined),String:l(a.String),Buffer:l(a.Buffer),VSBuffer:l(a.VSBuffer),Array:l(a.Array),Object:l(a.Object)},s=typeof Buffer!="undefined";function o(H,W){if(typeof W=="undefined")H.write(r.Undefined);else if(typeof W=="string"){const q=k.VSBuffer.fromString(W);H.write(r.String),H.write(u(q.byteLength)),H.write(q)}else if(s&&Buffer.isBuffer(W)){const q=k.VSBuffer.wrap(W);H.write(r.Buffer),H.write(u(q.byteLength)),H.write(q)}else if(W instanceof k.VSBuffer)H.write(r.VSBuffer),H.write(u(W.byteLength)),H.write(W);else if(Array.isArray(W)){H.write(r.Array),H.write(u(W.length));for(const q of W)o(H,q)}else{const q=k.VSBuffer.fromString(JSON.stringify(W));H.write(r.Object),H.write(u(q.byteLength)),H.write(q)}}function m(H){switch(H.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return H.read(i(H)).toString();case a.Buffer:return H.read(i(H)).buffer;case a.VSBuffer:return H.read(i(H));case a.Array:{const q=i(H),U=[];for(let A=0;A<q;A++)U.push(m(H));return U}case a.Object:return JSON.parse(H.read(i(H)).toString())}}class S{constructor(W,q,U=null,A=1e3){this.protocol=W,this.ctx=q,this.logger=U,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(W,q){this.channels.set(W,q),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const q=this.send([W.type]);this.logger&&this.logger.logOutgoing(q,0,1,E(W.type));return}case 201:case 202:case 204:case 203:{const q=this.send([W.type,W.id],W.data);this.logger&&this.logger.logOutgoing(q,W.id,1,E(W.type),W.data);return}}}send(W,q=void 0){const U=new h;return o(U,W),o(U,q),this.sendBuffer(U.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch(q){return 0}}onRawMessage(W){const q=new c(W),U=m(q),A=m(q),F=U[0];switch(F){case 100:return this.logger&&this.logger.logIncoming(W.byteLength,U[1],1,`${d(F)}: ${U[2]}.${U[3]}`,A),this.onPromise({type:F,id:U[1],channelName:U[2],name:U[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(W.byteLength,U[1],1,`${d(F)}: ${U[2]}.${U[3]}`,A),this.onEventListen({type:F,id:U[1],channelName:U[2],name:U[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(W.byteLength,U[1],1,`${d(F)}`),this.disposeActiveRequest({type:F,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(W.byteLength,U[1],1,`${d(F)}`),this.disposeActiveRequest({type:F,id:U[1]})}}onPromise(W){const q=this.channels.get(W.channelName);if(!q){this.collectPendingRequest(W);return}const U=new M.CancellationTokenSource;let A;try{A=q.call(this.ctx,W.name,W.arg,U.token)}catch(Y){A=Promise.reject(Y)}const F=W.id;A.then(Y=>{this.sendResponse({id:F,data:Y,type:201}),this.activeRequests.delete(W.id)},Y=>{Y instanceof Error?this.sendResponse({id:F,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:F,data:Y,type:203}),this.activeRequests.delete(W.id)});const B=(0,w.toDisposable)(()=>U.cancel());this.activeRequests.set(W.id,B)}onEventListen(W){const q=this.channels.get(W.channelName);if(!q){this.collectPendingRequest(W);return}const U=W.id,F=q.listen(this.ctx,W.name,W.arg)(B=>this.sendResponse({id:U,data:B,type:204}));this.activeRequests.set(W.id,F)}disposeActiveRequest(W){const q=this.activeRequests.get(W.id);q&&(q.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let q=this.pendingRequests.get(W.channelName);q||(q=[],this.pendingRequests.set(W.channelName,q));const U=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:W,timeoutTimer:U})}flushPendingRequests(W){const q=this.pendingRequests.get(W);if(q){for(const U of q)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(W=>W.dispose()),this.activeRequests.clear()}}e.ChannelServer=S;var D;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(W,q=null){this.protocol=W,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=q}getChannel(W){const q=this;return{call(U,A,F){return q.isDisposed?Promise.reject(n.canceled()):q.requestPromise(W,U,A,F)},listen(U,A){return q.isDisposed?Promise.reject(n.canceled()):q.requestEvent(W,U,A)}}}requestPromise(W,q,U,A=M.CancellationToken.None){const F=this.lastRequestId++,Y={id:F,type:100,channelName:W,name:q,arg:U};if(A.isCancellationRequested)return Promise.reject(n.canceled());let _;return new Promise((Q,J)=>{if(A.isCancellationRequested)return J(n.canceled());const re=()=>{const ge=fe=>{switch(fe.type){case 201:this.handlers.delete(F),Q(fe.data);break;case 202:this.handlers.delete(F);const de=new Error(fe.data.message);de.stack=fe.data.stack,de.name=fe.data.name,J(de);break;case 203:this.handlers.delete(F),J(fe.data);break}};this.handlers.set(F,ge),this.sendRequest(Y)};let le=null;this.state===v.Idle?re():(le=(0,L.createCancelablePromise)(ge=>this.whenInitialized()),le.then(()=>{le=null,re()}));const te=()=>{le?(le.cancel(),le=null):this.sendRequest({id:F,type:101}),J(n.canceled())},ae=A.onCancellationRequested(te);_=(0,w.combinedDisposable)((0,w.toDisposable)(te),ae),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(W,q,U){const A=this.lastRequestId++,B={id:A,type:102,channelName:W,name:q,arg:U};let Y=null;const _=new f.Emitter({onFirstListenerAdd:()=>{Y=(0,L.createCancelablePromise)(Q=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(_),this.sendRequest(B)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(_),this.sendRequest({id:A,type:103}))}}),N=Q=>_.fire(Q.data);return this.handlers.set(A,N),_.event}sendRequest(W){switch(W.type){case 100:case 102:{const q=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger&&this.logger.logOutgoing(q,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const q=this.send([W.type,W.id]);this.logger&&this.logger.logOutgoing(q,W.id,0,d(W.type));return}}}send(W,q=void 0){const U=new h;return o(U,W),o(U,q),this.sendBuffer(U.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch(q){return 0}}onBuffer(W){const q=new c(W),U=m(q),A=m(q),F=U[0];switch(F){case 200:return this.logger&&this.logger.logIncoming(W.byteLength,0,0,E(F)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(W.byteLength,U[1],0,E(F),A),this.onResponse({type:U[0],id:U[1],data:A})}}onResponse(W){if(W.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(W.id);q&&q(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(W=>W.dispose()),this.activeRequests.clear()}}ue([b.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class T{constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,W(({protocol:q,onDidClientDisconnect:U})=>{f.Event.once(q.onMessage)(F=>{const B=new c(F),Y=m(B),_=new S(q,Y),N=new R(q);this.channels.forEach((J,re)=>_.registerChannel(re,J));const Q={channelServer:_,channelClient:N,ctx:Y};this._connections.add(Q),this._onDidAddConnection.fire(Q),U(()=>{_.dispose(),N.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const W=[];return this._connections.forEach(q=>W.push(q)),W}getChannel(W,q){const U=this;return{call(A,F,B){let Y;if((0,I.isFunction)(q)){let N=(0,p.getRandomElement)(U.connections.filter(q));Y=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(U.onDidAddConnection,q))}else Y=q.routeCall(U,A,F);const _=Y.then(N=>N.channelClient.getChannel(W));return G(_).call(A,F,B)},listen(A,F){if((0,I.isFunction)(q))return U.getMulticastEvent(W,q,A,F);const B=q.routeEvent(U,A,F).then(Y=>Y.channelClient.getChannel(W));return G(B).listen(A,F)}}}getMulticastEvent(W,q,U,A){const F=this;let B=new w.DisposableStore;const Y=new f.Emitter({onFirstListenerAdd:()=>{B=new w.DisposableStore;const _=new f.EventMultiplexer,N=new Map,Q=re=>{const te=re.channelClient.getChannel(W).listen(U,A),ae=_.add(te);N.set(re,ae)},J=re=>{const le=N.get(re);!le||(le.dispose(),N.delete(re))};F.connections.filter(q).forEach(Q),f.Event.filter(F.onDidAddConnection,q)(Q,void 0,B),F.onDidRemoveConnection(J,void 0,B),_.event(Y.fire,Y,B),B.add(_)},onLastListenerRemove:()=>{B.dispose()}});return Y.event}registerChannel(W,q){this.channels.set(W,q),this._connections.forEach(U=>{U.channelServer.registerChannel(W,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class C{constructor(W,q,U=null){const A=new h;o(A,q),W.send(A.buffer),this.channelClient=new R(W,U),this.channelServer=new S(W,q,U)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,q){this.channelServer.registerChannel(W,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function G(H){return{call(W,q,U){return H.then(A=>A.call(W,q,U))},listen(W,q){const U=new f.Relay;return H.then(A=>U.input=A.listen(W,q)),U.event}}}e.getDelayedChannel=G;function ne(H){let W=!1;return{call(q,U,A){return W?H.call(q,U,A):(0,L.timeout)(0).then(()=>W=!0).then(()=>H.call(q,U,A))},listen(q,U){if(W)return H.listen(q,U);const A=new f.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>A.input=H.listen(q,U)),A.event}}}e.getNextTickChannel=ne;class oe{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const q of W.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await f.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=oe;var K;(function(H){function W(F,B){const Y=F,_=B&&B.disableMarshalling,N=new Map;for(const Q in Y)U(Q)&&N.set(Q,f.Event.buffer(Y[Q],!0));return new class{listen(Q,J,re){const le=N.get(J);if(le)return le;if(A(J)){const te=Y[J];if(typeof te=="function")return te.call(Y,re)}throw new Error(`Event not found: ${J}`)}call(Q,J,re){const le=Y[J];if(typeof le=="function"){if(!_&&Array.isArray(re))for(let te=0;te<re.length;te++)re[te]=(0,t.revive)(re[te]);return le.apply(Y,re)}throw new Error(`Method not found: ${J}`)}}}H.fromService=W;function q(F,B){const Y=B&&B.disableMarshalling;return new Proxy({},{get(_,N){if(typeof N=="string")return B?.properties?.has(N)?B.properties.get(N):A(N)?function(Q){return F.listen(N,Q)}:U(N)?F.listen(N):async function(...Q){let J;B&&!(0,I.isUndefinedOrNull)(B.context)?J=[B.context,...Q]:J=Q;const re=await F.call(N,J);return Y?re:(0,t.revive)(re)};throw new Error(`Property not found: ${String(N)}`)}})}H.toService=q;function U(F){return F[0]==="o"&&F[1]==="n"&&P.isUpperAsciiLetter(F.charCodeAt(2))}function A(F){return/^onDynamic/.test(F)&&P.isUpperAsciiLetter(F.charCodeAt(9))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let W=H.toString();if(W!=="[object Object]")return W}return H}function j(H){return Array.isArray(H)?H.map(O):O(H)}function $(H,W,q,U,A,F,B){B=j(B);const Y=ee[A],_=Y[U%Y.length];let N=[`%c[${H}]%c[${String(W).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(F)?(N=N.concat(B),N.push(")")):N.push(B),console.log.apply(console,N)}e.logWithColors=$;class z{constructor(W,q){this._outgoingPrefix=W,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,q,U,A,F){this._totalOutgoing+=W,$(this._outgoingPrefix,this._totalOutgoing,W,q,U,A,F)}logIncoming(W,q,U,A,F){this._totalIncoming+=W,$(this._incomingPrefix,this._totalIncoming,W,q,U,A,F)}}e.IPCLogger=z}),define(Z[120],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[121],x([0,1,18,4,35]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>p.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class b extends k.IPCClient{constructor(f,w){const t=new M(f);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=b}),define(Z[84],x([0,1,18,4,2,3,33,35]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=p.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return t();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let m=p.VSBuffer.alloc(s),S=0,D=0;for(;s>0;){const R=this._chunks[D];if(R.byteLength>s){const T=R.slice(0,s);m.set(T,S),S+=s,o&&(this._chunks[D]=R.slice(s),this._totalLength-=s),s-=s}else m.set(R,S),S+=R.byteLength,o?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,s-=R.byteLength}return m}}e.ChunkStream=P;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,o,m,S){this.type=s,this.id=o,this.ack=m,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const m=this._state.messageType,S=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(m,S,D,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=p.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._writeSoon(o,s.data)}_bufferAdd(s,o){const m=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,m}_bufferTake(){const s=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends k.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=v;class c extends n.IPCClient{constructor(s,o,m=null){super(s,o,m);this.protocol=s}static fromSocket(s,o){return new c(new v(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,b.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class a{constructor(s){this.data=s,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,m=this._first;for(;m;)s[o++]=m.data,m=m.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new a(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class i{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<i._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=i._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const s=Date.now(),o=(1+i._HISTORY_LENGTH)*1e3;let m=0;for(let S=0;S<i._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=o&&m++;return 1-m/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class l{constructor(s,o=null,m=i.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,t());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const o=new d(4,0,0,t());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let o=0,m=s.length;o<m;o++)this._socketWriter.write(s[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new d(6,0,0,t())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const o=this._outgoingUnackMsg.toArray();for(let m=0,S=o.length;m<S;m++)this._socketWriter.write(o[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new d(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(s){const o=new d(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,t());this._socketWriter.write(s)}}e.PersistentProtocol=l}),define(Z[122],x([0,1,14,18,4,2,35,120]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,P){const I=k.Event.fromNodeEventEmitter(p.ipcMain,P,(d,g)=>({event:d,message:g})),y=k.Event.filter(I,({event:d})=>d.sender.id===t);return k.Event.map(y,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends b.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=k.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:I})=>I);return k.Event.map(P,I=>{const y=I.id,d=w.Clients.get(y);d&&d.dispose();const g=new k.Emitter;w.Clients.set(y,(0,M.toDisposable)(()=>g.fire()));const E=f(y,"vscode:message"),v=k.Event.any(k.Event.signal(f(y,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(I,E),onDidClientDisconnect:v}})}}e.Server=w,w.Clients=new Map}),define(Z[85],x([0,1,14,4,28,121]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class b extends M.Client{constructor(w,t){super({addEventListener:(P,I)=>w.addListener(P,I),removeEventListener:(P,I)=>w.removeListener(P,I),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=b;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const t=L.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(I,y)=>({nonce:y,port:I.ports[0]})),{port:P}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,I=>I.nonce===w)));return P}e.connect=n}),define(Z[86],x([0,1,9,4,2,13]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var b;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(b=e.StorageHint||(e.StorageHint={}));function n(P){const I=P;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f||(f={}));class w extends k.Disposable{constructor(I,y=Object.create(null)){super();this.database=I,this.options=y,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((y,d)=>this.accept(d,y)),I.deleted?.forEach(y=>this.accept(y,void 0))}accept(I,y){if(this.state===f.Closed)return;let d=!1;(0,M.isUndefinedOrNull)(y)?d=this.cache.delete(I):this.cache.get(I)!==y&&(this.cache.set(I,y),d=!0),d&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,y){const d=this.cache.get(I);return(0,M.isUndefinedOrNull)(d)?y:d}getBoolean(I,y){const d=this.get(I);return(0,M.isUndefinedOrNull)(d)?y:d==="true"}getNumber(I,y){const d=this.get(I);return(0,M.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(I,y){if(this.state===f.Closed)return;if((0,M.isUndefinedOrNull)(y))return this.delete(I);const d=String(y);if(this.cache.get(I)!==d)return this.cache.set(I,d),this.pendingInserts.set(I,d),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async delete(I){if(!(this.state===f.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((y,d)=>this.items.set(d,y)),I.delete&&I.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=t}),define(Z[123],x([0,1,9,4,37,8,19]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,P=Object.create(null)){this.path=t,this.options=P,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,P=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(y=>P.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(t){const P=await this.whenConnected;return this.doUpdateItems(P,t)}doUpdateItems(t,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,k.mapToString)(P.insert):"0"}), delete(${P.delete?(0,k.setToString)(P.delete):"0"})`),this.transaction(t,()=>{const I=P.insert,y=P.delete;if(I&&I.size>0){const d=[];d.push([]);let g=0;I.forEach((E,v)=>{let c=d[g];c.length>n.MAX_HOST_PARAMETERS&&(g++,c=[],d.push(c)),c.push(v,E)}),d.forEach(E=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,v=>v.run(E),()=>{const v=[];let c=0;return I.forEach((h,a)=>{v.push(a),c+=h.length}),`Keys: ${v.join(", ")} Length: ${c}`})})}if(y&&y.size){const d=[];d.push([]);let g=0;y.forEach(E=>{let v=d[g];v.length>n.MAX_HOST_PARAMETERS&&(g++,v=[],d.push(v)),v.push(E)}),d.forEach(E=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,v=>v.run(E),()=>{const v=[];return y.forEach(c=>{v.push(c)}),`Keys: ${v.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,t)}doClose(t,P){return new Promise((I,y)=>{t.db.close(d=>(d&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?I():!t.isErroneous&&!t.isInMemory?this.backup().then(I,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),I())):typeof P=="function"?b.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const E=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:P()}).then(()=>E(),v=>(E(),Promise.reject(v)))})).then(I,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return b.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const P=await this.whenConnected,I=await this.get(P,t?"PRAGMA integrity_check":"PRAGMA quick_check"),y=t?I.integrity_check:I.quick_check;return P.isErroneous?`${y} (last error: ${P.lastError})`:P.isInMemory?`${y} (in-memory!)`:y}async connect(t,P=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${P})`);try{return await this.doConnect(t)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&P)return await(0,p.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await b.Promises.unlink(t);try{await b.Promises.rename(this.toBackupPath(t),t)}catch(y){}return await this.doConnect(t)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,P){t.isErroneous=!0,t.lastError=P,this.logger.error(P)}doConnect(t){return new Promise((P,I)=>{new Promise((y,d)=>{V(["@vscode/sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(t,g=>g?d.db?d.db.close(()=>I(g)):I(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),E=>d.db.close(()=>I(E)))),isInMemory:t===n.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},I)})}exec(t,P){return new Promise((I,y)=>{t.db.exec(P,d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${d}`),y(d)):I())})}get(t,P){return new Promise((I,y)=>{t.db.get(P,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${d}`),y(d)):I(g))})}all(t,P){return new Promise((I,y)=>{t.db.all(P,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${d}`),y(d)):I(g))})}transaction(t,P){return new Promise((I,y)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),P(),t.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${d}`),y(d)):I())})})}prepare(t,P,I,y){const d=t.db.prepare(P),g=E=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${E} (${P}). Details: ${y()}`)};d.on("error",g),I(d),d.finalize(E=>{E&&g(E),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[124],x([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Z[125],x([0,1,124]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,b=M*7,n=M*30,f=M*365;function w(P,I){typeof P!="number"&&(P=P.getTime());const y=Math.round((new Date().getTime()-P)/1e3);if(y<-30)return(0,p.localize)(0,null,w(new Date().getTime()+y*1e3,!1));if(y<30)return(0,p.localize)(1,null);let d;return y<L?(d=y,I?d===1?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):d===1?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d)):y<k?(d=Math.floor(y/L),I?d===1?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):d===1?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):y<M?(d=Math.floor(y/k),I?d===1?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):d===1?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d)):y<b?(d=Math.floor(y/M),I?d===1?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):d===1?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):y<n?(d=Math.floor(y/b),I?d===1?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):d===1?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d)):y<f?(d=Math.floor(y/n),I?d===1?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):d===1?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):(d=Math.floor(y/f),I?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d))}e.fromNow=w;function t(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(Z[126],x([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Z[68],x([0,1,30,13,126]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(w,t){return t&&(w.stack||w.stacktrace)?k.localize(0,null,n(w),b(w.stack)||b(w.stacktrace)):n(w)}function b(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,t=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const P=p.coalesce(w),I=f(P[0],t);return P.length>1?k.localize(4,null,I,P.length):I}if(L.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return M(P.error,t);if(P.exception)return M(P.exception,t)}return w.stack?M(w,t):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f}),define(Z[127],x([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Z[128],x([0,1,127]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(b,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=b,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(b,n,f){if(n.length===0)return null;const w=[];for(let t=0,P=n.length;t<P;t++){const I=n[t],y=f(I);if(y===null)return null;w[t]=k(I,y,this.modifierLabels[b])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,b,n){if(b===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),b!==""&&f.push(b),f.join(n.separator)}}),define(Z[129],x([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Z[69],x([0,1,41,31,10,44,8,3,33,78,13,81,19,129]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(u,i){if(n.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};i&&(l.cwd=i);const r=p.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],l);return new Promise(s=>{r.once("error",o=>{s({success:!1,error:o})}),r.once("exit",(o,m)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?d(l.status):1})}else if(n.isLinux||n.isMacintosh)try{const l=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(r=>{p.execFile(l,[u.pid.toString()],{encoding:"utf8",shell:!0},(s,o,m)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function E(u=f.env){return u.comspec||"cmd.exe"}e.getWindowsShell=E;class v{constructor(i,l,r,s){if(l!==void 0&&r!==void 0&&s!==void 0)this.cmd=i,this.args=l,this.shell=r,this.options=s;else{const o=i;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(f.env).forEach(m=>{o[m]=f.env[m]}),Object.keys(this.options.env).forEach(m=>{o[m]=this.options.env[m]}),this.options.env=o}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const l=i.lastIndexOf(b.sep);return l!==-1&&(i=i.substring(l+1)),v.WellKnowCommands[i]?i:"other"}start(i){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(l=>{let r,s;const o=new Promise((m,S)=>{r=m,s=S});if(l){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=p.exec(m,this.options,(S,D,R)=>{this.childProcess=null;const T=S;T&&T.killed?s({killed:this.terminateRequested,stdout:D.toString(),stderr:R.toString()}):this.handleExec(r,i,S,D,R)})}else{let m=null;const S=D=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(D,r,i,s);const R={terminated:this.terminateRequested};t.isNumber(D)&&(R.cmdCode=D),r(R)};if(this.shell&&n.isWindows){const D=M.deepClone(this.options);D.windowsVerbatimArguments=!0,D.detached=!1;let R=!1,T=!1;const C=[];let G=this.ensureQuotes(this.cmd);C.push(G.value),R=G.quoted,this.args&&this.args.forEach(oe=>{G=this.ensureQuotes(oe),C.push(G.value),T=T&&G.quoted});const ne=["/s","/c"];R?T?ne.push('"'+C.join(" ")+'"'):C.length>1?ne.push('"'+C[0]+'" '+C.slice(1).join(" ")):ne.push('"'+C[0]+'"'):ne.push(C.join(" ")),m=p.spawn(E(),ne,D)}else this.cmd&&(m=p.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(t.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",D=>{this.childProcess=null,s({terminated:this.terminateRequested,error:D})}),m.pid&&(this.childProcess.on("close",S),this.handleSpawn(m,r,i,s,!0)))}return o})}handleClose(i,l,r,s){}ensureQuotes(i){return v.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,g(i,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!n.isWindows)return i(!1);const l=p.spawn(E(),["/s","/c"]);l.on("error",r=>i(!0)),l.on("exit",r=>i(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class c extends v{constructor(i,l,r,s){super(i,l,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,l,r,s,o){[s,o].forEach((m,S)=>{const D=new P.LineDecoder;D.write(m).forEach(C=>{l({line:C,source:S===0?0:1})});const T=D.end();T&&l({line:T,source:S===0?0:1})}),i({terminated:this.terminateRequested,error:r})}handleSpawn(i,l,r,s,o){const m=new P.LineDecoder,S=new P.LineDecoder;i.stdout.on("data",D=>{m.write(D).forEach(T=>r({line:T,source:0}))}),i.stderr.on("data",D=>{S.write(D).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=S}handleClose(i,l,r,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&r({line:m,source:1})}}e.LineProcess=c;function h(u){let i=[],l=!1;const r=function(s){if(l){i.push(s);return}(!u.send(s,m=>{if(m&&console.error(m),l=!1,i.length>0){const S=i.slice(0);i=[],S.forEach(D=>r(D))}})||n.isWindows)&&(l=!0)};return{send:r}}e.createQueuedSender=h;var a;(function(u){async function i(l,r,s){if(b.isAbsolute(l))return l;if(r===void 0&&(r=f.cwd()),b.dirname(l)!=="."||(s===void 0&&t.isString(f.env.PATH)&&(s=f.env.PATH.split(b.delimiter)),s===void 0||s.length===0))return b.join(r,l);async function m(S){if(await I.Promises.exists(S)){let D;try{D=await I.Promises.stat(S)}catch(R){R.message.startsWith("EACCES")&&(D=await I.Promises.lstat(S))}return D?!D.isDirectory():!1}return!1}for(let S of s){let D;if(b.isAbsolute(S)?D=b.join(S,l):D=b.join(r,S,l),await m(D))return D;let R=D+".com";if(await m(R)||(R=D+".exe",await m(R)))return R}return b.join(r,l)}u.findExecutable=i})(a=e.win32||(e.win32={}))}),define(Z[130],x([0,1,26,3,116,69]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function b(y,d){return y===1?L.isWindows?P():M.getWindowsShell(d):w(y,d)}e.getSystemShell=b;function n(y,d){return y===1?L.isWindows?I(d):M.getWindowsShell(d):w(y,d)}e.getSystemShellSync=n;let f=null;function w(y,d){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,p.userInfo)().shell}catch(E){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function P(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function I(y){if(t)return t;const d=L.isWindows&&parseFloat((0,p.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?E:M.getWindowsShell(y)}}),define(Z[87],x([0,1,41,9,18,23,109,17,4,2,44,3,69,35]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(v){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",c=>k.VSBuffer.wrap(Buffer.from(c,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(v,c){this.modulePath=v,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(v){const c=this;return{call(h,a,u){return c.requestPromise(v,h,a,u)},listen(h,a){return c.requestEvent(v,h,a)}}}requestPromise(v,c,h,a=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(v),i=(0,L.createCancelablePromise)(s=>u.call(c,h,s)),l=a.onCancellationRequested(()=>i.cancel()),r=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{l.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(v,c,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let a;const u=new f.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(v).listen(c,h)(u.fire,u),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),P.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,v,c);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,b.isRemoteConsoleLog)(o)){(0,b.log)(o,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const u=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&u.send(o.buffer.toString("base64")),l=h.event,r={send:i,onMessage:l};this._client=new y.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,m)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>(0,w.dispose)(S)),this.activeRequests.clear(),o!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:m})})}return this._client}getCachedChannel(v){let c=this.channels.get(v);return c||(c=this.client.getChannel(v),this.channels.set(v,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Z[131],x([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Z[132],x([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[133],x([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[134],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Z[135],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Z[136],x([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[137],x([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[138],x([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[139],x([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Z[140],x([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Z[141],x([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Z[142],x([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[143],x([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[144],x([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[145],x([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[146],x([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Z[147],x([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[148],x([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[149],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Z[150],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[151],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[152],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[153],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[154],x([0,1,4,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},w])}}e.ExtensionHostDebugChannelClient=M}),define(Z[155],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(b){this.driver=b}listen(b,n){throw new Error(`No event found: ${n}`)}call(b,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=p;class L{constructor(b){this.channel=b}click(b,n,f){return this.channel.call("click",[b,n,f])}doubleClick(b){return this.channel.call("doubleClick",b)}setValue(b,n){return this.channel.call("setValue",[b,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(b){return this.channel.call("isActiveElement",b)}getElements(b,n){return this.channel.call("getElements",[b,n])}getElementXY(b,n,f){return this.channel.call("getElementXY",[b,n,f])}typeInEditor(b,n){return this.channel.call("typeInEditor",[b,n])}getTerminalBuffer(b){return this.channel.call("getTerminalBuffer",b)}writeInTerminal(b,n){return this.channel.call("writeInTerminal",[b,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(b){this.channel=b}registerWindowDriver(b){return this.channel.call("registerWindowDriver",b)}reloadWindowDriver(b){return this.channel.call("reloadWindowDriver",b)}}e.WindowDriverRegistryChannelClient=k}),define(Z[156],x([0,1,125,47,10,8,33,15,7]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(g,E,v){this._args=g,this.paths=E,this.productService=v}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",V).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=b.env.VSCODE_PORTABLE;return g?f.URI.file((0,M.join)(g,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,M.resolve)(g):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const E=b.env.VSCODE_EXTENSIONS;if(E)return E;const v=b.env.VSCODE_PORTABLE;return v?(0,M.join)(v,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(E=>/^[^:/?#]+?:\/\//.test(E)?f.URI.parse(E):f.URI.file((0,M.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!b.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([L.memoize],w.prototype,"appRoot",null),ue([L.memoize],w.prototype,"userHome",null),ue([L.memoize],w.prototype,"userDataPath",null),ue([L.memoize],w.prototype,"appSettingsHome",null),ue([L.memoize],w.prototype,"tmpDir",null),ue([L.memoize],w.prototype,"userRoamingDataHome",null),ue([L.memoize],w.prototype,"settingsResource",null),ue([L.memoize],w.prototype,"userDataSyncHome",null),ue([L.memoize],w.prototype,"userDataSyncLogResource",null),ue([L.memoize],w.prototype,"sync",null),ue([L.memoize],w.prototype,"machineSettingsResource",null),ue([L.memoize],w.prototype,"globalStorageHome",null),ue([L.memoize],w.prototype,"workspaceStorageHome",null),ue([L.memoize],w.prototype,"keybindingsResource",null),ue([L.memoize],w.prototype,"keyboardLayoutResource",null),ue([L.memoize],w.prototype,"argvResource",null),ue([L.memoize],w.prototype,"snippetsHome",null),ue([L.memoize],w.prototype,"isExtensionDevelopment",null),ue([L.memoize],w.prototype,"untitledWorkspacesHome",null),ue([L.memoize],w.prototype,"installSourcePath",null),ue([L.memoize],w.prototype,"builtinExtensionsPath",null),ue([L.memoize],w.prototype,"extensionsPath",null),ue([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ue([L.memoize],w.prototype,"extensionDevelopmentKind",null),ue([L.memoize],w.prototype,"extensionTestsLocationURI",null),ue([L.memoize],w.prototype,"debugExtensionHost",null),ue([L.memoize],w.prototype,"serviceMachineIdResource",null),ue([L.memoize],w.prototype,"telemetryLogResource",null),ue([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(d,g){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId)}e.parseExtensionHostPort=t;function P(d,g){return y(d["inspect-search"],d["inspect-brk-search"],5876,g)}e.parseSearchPort=P;function I(d,g){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g)}e.parsePtyHostPort=I;function y(d,g,E,v,c){const a=Number(g||d)||(v?null:E),u=a?Boolean(!!g):!1;return{port:a,break:u,debugId:c}}}),define(Z[88],x([0,1,240,3,134]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const b={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,g,E=b){const v={},c=[],h=[];for(let l in g){const r=g[l];r.alias&&(v[l]=r.alias),r.type==="string"||r.type==="string[]"?(c.push(l),r.deprecates&&c.push(r.deprecates)):r.type==="boolean"&&(h.push(l),r.deprecates&&h.push(r.deprecates))}const a=p(d,{string:c,boolean:h,alias:v}),u={},i=a;u._=a._.map(l=>String(l)).filter(l=>l.length>0),delete i._;for(let l in g){const r=g[l];r.alias&&delete i[r.alias];let s=i[l];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(s||(s=i[r.deprecates]),delete i[r.deprecates]),typeof s!="undefined"&&(r.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):r.type==="string"&&Array.isArray(s)&&(s=s.pop(),E.onMultipleValues(l,s)),u[l]=s),delete i[l]}for(let l in i)E.onUnknownOption(l);return u}e.parseArgs=n;function f(d,g){let E="";return g.args&&(Array.isArray(g.args)?E=` <${g.args.join("> <")}>`:E=` <${g.args}>`),g.alias?`-${g.alias} --${d}${E}`:`--${d}${E}`}function w(d,g){let E=0,v=[];for(const u in d){const i=d[u],l=f(u,i);E=Math.max(E,l.length),v.push([l,i.description])}let c=E+2+1;if(g-c<25)return v.reduce((u,i)=>u.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let h=g-c-1,a=[];for(const u of v){let i=u[0],l=P(u[1],h),r=t(c-i.length-2);a.push("  "+i+r+l[0]);for(let s=1;s<l.length;s++)a.push(t(c)+l[s])}return a}e.formatOptions=w;function t(d){return" ".repeat(d)}function P(d,g){let E=[];for(;d.length;){let v=d.length<g?d.length:d.lastIndexOf(" ",g),c=d.slice(0,v).trim();d=d.slice(v),E.push(c)}return E}function I(d,g,E,v,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${d} ${E}`];a.push(""),a.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),a.push(""),c&&(L.isWindows?a.push((0,k.localize)(35,null,g)):a.push((0,k.localize)(36,null,g)),a.push(""));const u={};for(const i in v){const l=v[i];if(l.description&&l.cat){let r=u[l.cat];r||(u[l.cat]=r={}),r[i]=l}}for(let i in u){const l=i;let r=u[l];r&&(a.push(M[l]),a.push(...w(r,h)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=I;function y(d,g){return`${d||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Z[157],x([0,1,59,154,88]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f,w){const t=(0,k.parseArgs)(n,k.OPTIONS);t.debugRenderer=w;const P=t.extensionDevelopmentPath;if(!P)return{success:!1};let I;const y=Object.keys(f);for(let h of y){let a=f[h];a===null||(I||(I=Object.create(null)),I[h]=a)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:t,userEnv:I});if(!w)return{success:!0};const g=d.win;if(!g)return{success:!0};const E=g.webContents.debugger;let v=E.isAttached()?Infinity:0;const c=(0,p.createServer)(h=>{v++==0&&E.attach();let a=!1;const u=r=>{a||h.write(JSON.stringify(r)+"\0")},i=(r,s,o,m)=>u({method:s,params:o,sessionId:m});g.on("close",()=>{E.removeListener("message",i),h.end(),a=!0}),E.addListener("message",i);let l=Buffer.alloc(0);h.on("data",r=>{l=Buffer.concat([l,r]);for(let s=l.indexOf(0);s!==-1;s=l.indexOf(0)){let o;try{const m=l.slice(0,s).toString("utf8");l=l.slice(s+1),o=JSON.parse(m)}catch(m){console.error("error reading cdp line",m)}E.sendCommand(o.method,o.params,o.sessionId).then(m=>u({id:o.id,sessionId:o.sessionId,result:m})).catch(m=>u({id:o.id,sessionId:o.sessionId,error:{code:0,message:m.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{a=!0,--v==0&&E.detach()})});return await new Promise(h=>c.listen(0,h)),g.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function V(e,p,L,k){function M(n){const f=b(n),w=[f];return e.isAbsolute(f)||w.unshift(k),e.resolve(...w)}function b(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(p.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[158],x([0,159,26,10,15,33]),function(e,p,L,k,M,b){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return V(p,L,f.name,b.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=V(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[160],x([0,1,26,156,158]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(Z[161],x([0,1,32,26,8]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(b){const n=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(n,""),b&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){b&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(Z[162],x([0,1,137]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(I){return I=I.trim(),I==="*"||L.test(I)}e.isValidVersionStr=M;function b(I){if(!M(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=I.match(L);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=b;function n(I){if(!I)return null;let y=I.majorBase,d=I.majorMustEqual,g=I.minorBase,E=I.minorMustEqual,v=I.patchBase,c=I.patchMustEqual;I.hasCaret&&(y===0||(E=!1),c=!1);let h=0;if(I.preRelease){const a=k.exec(I.preRelease);if(a){const[,u,i,l]=a;h=Date.UTC(Number(u),Number(i)-1,Number(l))}}return{majorBase:y,majorMustEqual:d,minorBase:g,minorMustEqual:E,patchBase:v,patchMustEqual:c,isMinimum:I.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function f(I,y,d){let g;typeof I=="string"?g=n(b(I)):g=I;let E;y instanceof Date?E=y.getTime():typeof y=="string"&&(E=new Date(y).getTime());let v;if(typeof d=="string"?v=n(b(d)):v=d,!g||!v)return!1;let c=g.majorBase,h=g.minorBase,a=g.patchBase,u=v.majorBase,i=v.minorBase,l=v.patchBase,r=v.notBefore,s=v.majorMustEqual,o=v.minorMustEqual,m=v.patchMustEqual;return v.isMinimum?c>u?!0:c<u?!1:h>i?!0:h<i||E&&E<r?!1:a>=l:(c===1&&u===0&&(!s||!o||!m)&&(u=1,i=0,l=0,s=!0,o=!1,m=!1),c<u?!1:c>u?!s:h<i?!1:h>i?!o:a<l?!1:a>l?!m:!(E&&E<r))}e.isValidVersion=f;function w(I,y,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:P(I,y,d.engines.vscode,g)}e.isValidExtensionVersion=w;function t(I,y,d){return I==="*"||P(y,d,I)}e.isEngineValid=t;function P(I,y,d,g=[]){let E=n(b(d));if(!E)return g.push(p.localize(0,null,d)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(p.localize(1,null,d)),!1}else if(!E.majorMustEqual)return g.push(p.localize(2,null,d)),!1;return f(I,y,E)?!0:(g.push(p.localize(3,null,I,d)),!1)}}),define(Z[163],x([0,1,2,10,35,87]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends p.Disposable{constructor(f,w,t,P){super();this.requests=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=b.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}setVerboseLogging(f){this.verboseLogging=f,this.isDisposed||this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}watch(f){this.requests=f,this.service?.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b,b.MAX_RESTARTS=5}),define(Z[164],x([0,1,2,10,35,87]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends p.Disposable{constructor(f,w,t,P,I={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=b.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.watch(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}watch(f){this.folders=f,this.service&&this.service.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b,b.MAX_RESTARTS=5}),define(Z[165],x([0,1,41,111,10,81]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class b{constructor(f,w,t,P,I){this.watchedFolder=f,this.eventCallback=t,this.logCallback=P,this.verboseLogging=I,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(y=>(0,L.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,p.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",V).fsPath,f);const w=new M.LineDecoder;this.handle.stdout.on("data",t=>{const P=[];for(const I of w.write(t)){const y=I.split("|");if(y.length===2){const d=Number(y[0]),g=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(E=>E(g))){this.verboseLogging&&this.log(g);continue}P.push({type:b.changeTypeMap[d],path:g})}else this.log(y[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,P)=>this.onExit(t,P))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=b.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=b,b.MAX_RESTARTS=5,b.changeTypeMap=[0,1,2]}),define(Z[166],x([0,1,8,25,165]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,w,t){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=t,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(p.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,p.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(Z[70],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(k,M=[],b=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=b}}e.SyncDescriptor=p}),define(Z[167],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=p;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let b of this._nodes.values())b.outgoing.size===0&&M.push(b);return M}insertEdge(M,b){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(b);n.outgoing.set(this._hashFn(b),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const b=this._hashFn(M);this._nodes.delete(b);for(let n of this._nodes.values())n.outgoing.delete(b),n.incoming.delete(b)}lookupOrInsertNode(M){const b=this._hashFn(M);let n=this._nodes.get(b);return n||(n=new p(M),this._nodes.set(b,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[b,n]of this._nodes)M.push(`${b}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,b]of this._nodes){const n=new Set([M]),f=this._findCycle(b,n);if(f)return f}}_findCycle(M,b){for(let[n,f]of M.outgoing){if(b.has(n))return[...b,n].join(" -> ");b.add(n);const w=this._findCycle(f,b);if(w)return w;b.delete(n)}}}e.Graph=L}),define(Z[5],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(p=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(n,f,w,t){f[p.DI_TARGET]===f?f[p.DI_DEPENDENCIES].push({id:n,index:w,optional:t}):(f[p.DI_DEPENDENCIES]=[{id:n,index:w,optional:t}],f[p.DI_TARGET]=f)}function k(n){if(p.serviceIds.has(n))return p.serviceIds.get(n);const f=function(w,t,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,P,!1)};return f.toString=()=>n,p.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function b(n){return function(f,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,t,!0)}}e.optional=b}),define(Z[71],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[89],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,b)=>V(["vscode-encrypt"],M,b))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(b){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(b){return M}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,136,5]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function b(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function n(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(c,h){return h==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function t(c,h,a){return w(h,a)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===a?!0:P(a).includes(c)}e.isTargetPlatformCompatible=t;function P(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function I(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=I;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var d;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var E;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(h,a){super(h);this.code=a,this.name=a}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[170],x([0,1,25,5]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class n{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,I){if(typeof P=="undefined"||P===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof P=="string"||typeof I=="string"){let y=typeof P=="string"?P:P.value,d=typeof I=="string"?I:I.value;return p.equalsIgnoreCase(y,d)}return P._lower===I._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=n;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[171],x([0,1,25,170]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,p.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function b(d,g){return`${d}.${g}`}e.getExtensionId=b;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,g){return n(b(d,g))}e.getGalleryExtensionId=f;function w(d,g){const E=[],v=c=>{for(const h of E)if(h.some(a=>k(g(a),g(c))))return h;return null};for(const c of d){const h=v(c);h?h.push(c):E.push([c])}return E}e.groupByExtension=w;function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function P(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function I(d){const g=new Set;for(const E of d)E.malicious&&g.add(E.id.id);return g}e.getMaliciousExtensionsSet=I;function y(d,g){const E=[],v=g.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const c=v.shift();if(c&&E.every(h=>!k(h.identifier,{id:c}))){const h=d.filter(a=>k(a.identifier,{id:c}));h.length===1&&(E.push(h[0]),v.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=y}),define(Z[90],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[172],x([0,1,41,10,8,3,78,19,69,138,90]),function(V,e,p,L,k,M,b,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends I{openTerminal(a,u){return this.spawnTerminal(p,a,f.getWindowsShell(),u)}spawnTerminal(a,u,i,l){const r=u.windowsExec||y.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const s=k.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return a.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(s==="wt"||s==="wt.exe")&&o.push("-d ."),new Promise((m,S)=>{const D=E(process),R=a.spawn(i,o,{cwd:l,env:D});R.on("error",S),R.on("exit",()=>m())})}runInTerminal(a,u,i,l,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((o,m)=>{const S=`"${u} - ${P}"`,D=`""${i.join('" "')}" & pause"`,R=["/c","start",S,"/wait",s,"/c",D],T=Object.assign({},E(process),l);Object.keys(T).filter(ne=>T[ne]===null).forEach(ne=>delete T[ne]);const C={cwd:u,env:T,windowsVerbatimArguments:!0};p.spawn(y.CMD,R,C).on("error",ne=>{m(v(ne))}),o(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends I{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,i,l,r){const s=r.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((o,m)=>{if(s===t.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const S=s===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,V).fsPath,"-t",a||P,"-w",u];for(let G of i)R.push("-a"),R.push(G);if(l){const G=Object.assign({},E(process),l);for(let ne in G){const oe=G[ne];oe===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${oe}`))}}let T="";const C=p.spawn(d.OSASCRIPT,R);C.on("error",G=>{m(v(G))}),C.stderr.on("data",G=>{T+=G.toString()}),C.on("exit",G=>{if(G===0)o(void 0);else if(T){const ne=T.split(`
`,1);m(new Error(ne[0]))}else m(new Error(w.localize(1,null,S,G)))})}else m(new Error(w.localize(2,null,s)))})}spawnTerminal(a,u,i){const l=u.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const o=["-a",l];i&&o.push(i);const m=E(process),S=a.spawn("/usr/bin/open",o,{cwd:i,env:m});S.on("error",s),S.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends I{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,i,l,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((o,m)=>{let S=[];s.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const R=`${c(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;S.push(`''${R}''`);const T=Object.assign({},E(process),l);Object.keys(T).filter(oe=>T[oe]===null).forEach(oe=>delete T[oe]);const C={cwd:u,env:T};let G="";const ne=p.spawn(D,S,C);ne.on("error",oe=>{m(v(oe))}),ne.stderr.on("data",oe=>{G+=oe.toString()}),ne.on("exit",oe=>{if(oe===0)o(void 0);else if(G){const K=G.split(`
`,1);m(new Error(K[0]))}else m(new Error(w.localize(4,null,D,oe)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,u,i){const l=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{l.then(o=>{const m=E(process),S=a.spawn(o,[],{cwd:i,env:m});S.on("error",s),S.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function E(h){const a={...h.env};return(0,b.sanitizeProcessEnvironment)(a),a}function v(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function c(h){let a="";for(let u of h)u.indexOf(" ")>=0?a+='"'+u+'"':a+=u,a+=" ";return a}}),define(Z[20],x([0,1,37,8,25,13,7,140,5]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(O){return O.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var P;(function(O){O[O.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var I;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=y;function d(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=E;var v;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(j,$){super(j);this.code=$}}e.FileSystemProviderError=c;function h(O,j){const $=new c(O.toString(),j);return u($,j),$}e.createFileSystemProviderError=h;function a(O){return O||h((0,n.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function u(O,j){return O.name=j?`${j} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=u;function i(O){if(!O)return v.Unknown;if(O instanceof c)return O.code;const j=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!j)return v.Unknown;switch(j[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=i;function l(O){if(O instanceof D)return O.fileOperationResult;switch(i(O)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(j,$,z){this.resource=j,this.operation=$,this.target=z}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var o;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class m{constructor(j,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of j)switch(z.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>$)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>$)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>$)),this.deleted.set(z.resource,z);break}}contains(j,...$){return this.doContains(j,{includeChildren:!1},...$)}affects(j,...$){return this.doContains(j,{includeChildren:!0},...$)}doContains(j,$,...z){if(!j)return!1;const H=z.length>0;return!!((!H||z.includes(1))&&(this.added?.get(j)||$.includeChildren&&this.added?.findSuperstr(j))||(!H||z.includes(0))&&(this.updated?.get(j)||$.includeChildren&&this.updated?.findSuperstr(j))||(!H||z.includes(2))&&(this.deleted?.findSubstr(j)||$.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function S(O,j,$){return!O||!j||O===j||j.length>O.length?!1:(j.charAt(j.length-1)!==L.sep&&(j+=L.sep),$?(0,k.startsWithIgnoreCase)(O,j):O.indexOf(j)===0)}e.isParent=S;class D extends Error{constructor(j,$,z){super(j);this.fileOperationResult=$,this.options=z}}e.FileOperationError=D;class R extends D{constructor(j,$,z){super(j,2,z);this.stat=$}}e.NotModifiedSinceFileOperationError=R;var T;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=G;async function ne(O,j){if(!j.canHandleResource(b.URI.from({scheme:O.scheme})))return new Promise($=>{const z=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===O.scheme&&H.added&&(z.dispose(),$())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(j){return(0,M.isNumber)(j)||(j=0),j<oe.KB?(0,n.localize)(1,null,j.toFixed(0)):j<oe.MB?(0,n.localize)(2,null,(j/oe.KB).toFixed(2)):j<oe.GB?(0,n.localize)(3,null,(j/oe.MB).toFixed(2)):j<oe.TB?(0,n.localize)(4,null,(j/oe.GB).toFixed(2)):(0,n.localize)(5,null,(j/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var K;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function ee(O){return{maxFileSize:O===0?300*oe.MB:16*oe.GB,maxHeapSize:O===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=ee}),define(Z[54],x([0,1,241,135,88,20]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function b(I,y){const d={onUnknownOption:E=>{console.warn((0,L.localize)(0,null,E))},onMultipleValues:(E,v)=>{console.warn((0,L.localize)(1,null,E,v))}},g=(0,k.parseArgs)(I,k.OPTIONS,y?d:void 0);return g.goto&&g._.forEach(E=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,L.localize)(2,null))),g["max-memory"]&&p(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(I){const y=I.findIndex(d=>!/^-/.test(d));if(y>-1)return[...I.slice(0,y),...I.slice(y+1)]}function f(I){let[,...y]=I;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!P(process.env);return b(y,d)}e.parseMainProcessArgv=f;function w(I){const[,,...y]=I;return b(y,!0)}e.parseCLIProcessArgv=w;function t(I,...y){const d=I.indexOf("--");return d===-1?I.push(...y):I.splice(d,0,...y),I}e.addArg=t;function P(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(Z[91],x([0,1,41,159,23,68,17,3,28,130,54]),function(V,e,p,L,k,M,b,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function P(d,g,E){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(E)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(E)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=new Promise(async v=>{const c=new k.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),c.dispose(!0),v({})},1e4);try{const a=await y(d,c.token);v(a)}catch(a){(0,b.isPromiseCanceledError)(a)||d.error(`[resolve shell env] Unable to resolve shell environment (${a}). Proceeding without shell environment...`),v({})}finally{clearTimeout(h),c.dispose()}})),I)}e.resolveShellEnv=P;let I;async function y(d,g){const E=new Promise(async(v,c)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",a);const u=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"(.*)"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",l);const r=await(0,w.getSystemShell)(n.OS,l);if(d.trace("getUnixShellEnvironment#shell",r),g.isCancellationRequested)return c(b.canceled);const s=L.basename(r);let o,m;/^pwsh(-preview)?$/.test(s)?(o=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,m=["-Login","-Command"]):(o=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),o);const S=(0,p.spawn)(r,[...m,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});g.onCancellationRequested(()=>(S.kill(),c(b.canceled))),S.on("error",T=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(T)),v({})});const D=[];S.stdout.on("data",T=>D.push(T));const R=[];S.stderr.on("data",T=>R.push(T)),S.on("close",(T,C)=>{const G=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const ne=Buffer.concat(R).toString("utf8");if(ne.trim()&&d.trace("getUnixShellEnvironment#stderr",ne),T||C)return c(new Error(`Failed to get environment (code ${T}, signal ${C})`));const oe=i.exec(G),K=oe?oe[1]:"{}";try{const ee=JSON.parse(K);h?ee.ELECTRON_RUN_AS_NODE=h:delete ee.ELECTRON_RUN_AS_NODE,a?ee.ELECTRON_NO_ATTACH_CONSOLE=a:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ee),v(ee)}catch(ee){d.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(ee)),c(ee)}})});try{return await E}catch(v){return d.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(v)),{}}}}),define(Z[92],x([0,1,3,7,20]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=M;function b(f){const w=new n;for(const t of f)w.processEvent(t);return w.normalize()}e.normalizeFileChanges=b;class n{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(w){return p.isLinux?w.path:w.path.toLowerCase()}processEvent(w){const t=this.mapPathToChange.get(this.toKey(w));let P=!1;if(t){const I=t.type,y=w.type;t.path!==w.path&&(y===1||y===0)?(t.type=2,P=!0):I===1&&y===2?(this.mapPathToChange.delete(this.toKey(w)),this.normalized.delete(t)):I===2&&y===1?t.type=0:I===1&&y===0||(t.type=y)}else P=!0;P&&(this.normalized.add(w),this.mapPathToChange.set(this.toKey(w),w))}normalize(){const w=[],t=[];return Array.from(this.normalized).filter(P=>P.type!==2?(w.push(P),!1):!0).sort((P,I)=>P.path.length-I.path.length).filter(P=>t.some(I=>(0,k.isParent)(P.path,I,!p.isLinux))?!1:(t.push(P.path),!0)).concat(w)}}}),define(Z[173],x([0,1,9,2,8,82,19,117,92]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(P,I,y,d){super();this.path=P,this.onDidFilesChange=I,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:I}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(I)try{y=await(0,M.realpath)(y)}catch(d){if(this.onError(d),I.dangling)return}P.isDirectory()?this._register((0,n.watchFolder)(y,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},d=>this.onError(d))):this._register((0,n.watchFile)(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,f.normalizeFileChanges)(I);if(this.verboseLogging)for(const d of y)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[72],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...k){this._entries=new Map;for(let[M,b]of k)this.set(M,b)}set(k,M){const b=this._entries.get(k);return this._entries.set(k,M),b}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=p}),define(Z[174],x([0,1,9,17,70,167,5,72]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class t{constructor(d=new n.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=E,this._services.set(b.IInstantiationService,this)}createChild(d){return new t(d,this._strict,this)}invokeFunction(d,...g){let E=I.traceInvocation(d),v=!1;try{return d({get:(h,a)=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(h,E);if(!u&&a!==b.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return u}},...g)}finally{v=!0,E.stop()}}createInstance(d,...g){let E,v;return d instanceof k.SyncDescriptor?(E=I.traceCreation(d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(g),E)):(E=I.traceCreation(d),v=this._createInstance(d,g,E)),E.stop(),v}_createInstance(d,g=[],E){let v=b._util.getServiceDependencies(d).sort((a,u)=>a.index-u.index),c=[];for(const a of v){let u=this._getOrCreateServiceInstance(a.id,E);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${a.id}.`);c.push(u)}let h=v.length>0?v[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${g.length} static arguments`);let a=h-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,h)}return new d(...[...g,...c])}_setServiceInstance(d,g){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let E=this._getServiceInstanceOrDescriptor(d);return E instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,E,g.branch(d,!0)):(g.branch(d,!1),E)}_safeCreateAndCacheServiceInstance(d,g,E){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,E)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,E){const v=new M.Graph(a=>a.id.toString());let c=0;const h=[{id:d,desc:g,_trace:E}];for(;h.length;){const a=h.pop();if(v.lookupOrInsertNode(a),c++>1e3)throw new w(v);for(let u of b._util.getServiceDependencies(a.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(u.id);if(!i&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const l={id:u.id,desc:i,_trace:a._trace.branch(u.id,!0)};v.insertEdge(a,l),h.push(l)}}}for(;;){const a=v.roots();if(a.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof k.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,E=[],v,c){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(g,E,v,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,E,v,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],E,v){if(E){const c=new p.IdleValue(()=>this._createInstance(d,g,v));return new Proxy(Object.create(null),{get(h,a){if(a in h)return h[a];let u=c.value,i=u[a];return typeof i!="function"||(i=i.bind(u),h[a]=i),i},set(h,a,u){return c.value[a]=u,!0}})}else return this._createInstance(d,g,v)}}e.InstantiationService=t;var P;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(P||(P={}));class I{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new I(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(d){return f?new I(0,d.name):I._None}branch(d,g){let E=new I(2,d.toString());return this._dep.push([d,g,E]),E}stop(){let d=Date.now()-this._start;I._totals+=d;let g=!1;function E(c,h){let a=[],u=new Array(c+1).join("	");for(const[i,l,r]of h._dep)if(l&&r){g=!0,a.push(`${u}CREATES -> ${i}`);let s=E(c+1,r);s&&a.push(s)}else a.push(`${u}uses -> ${i}`);return a.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(v.join(`
`))}}I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(Z[175],x([0,1,17,128,57]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,p.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(Z[176],x([0,1,57,175]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(b,n){super(n,b.parts)}_keyCodeToUILabel(b){if(this._os===2)switch(b){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(b)}_getLabel(b){return b.isDuplicateModifierCase()?"":this._keyCodeToUILabel(b.keyCode)}_getAriaLabel(b){return b.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(b.keyCode)}_keyCodeToElectronAccelerator(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return p.KeyCodeUtils.toString(b)}_getElectronAccelerator(b){return b.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(b.keyCode)}_getUserSettingsLabel(b){if(b.isDuplicateModifierCase())return"";const n=p.KeyCodeUtils.toUserSettingsUS(b.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(b){return k.getDispatchStr(b)}static getDispatchStr(b){if(b.isModifierKey())return null;let n="";return b.ctrlKey&&(n+="ctrl+"),b.shiftKey&&(n+="shift+"),b.altKey&&(n+="alt+"),b.metaKey&&(n+="meta+"),n+=p.KeyCodeUtils.toString(b.keyCode),n}_getSingleModifierDispatchPart(b){return b.keyCode===5&&!b.shiftKey&&!b.altKey&&!b.metaKey?"ctrl":b.keyCode===4&&!b.ctrlKey&&!b.altKey&&!b.metaKey?"shift":b.keyCode===6&&!b.ctrlKey&&!b.shiftKey&&!b.metaKey?"alt":b.keyCode===57&&!b.ctrlKey&&!b.shiftKey&&!b.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(Z[177],x([0,1,9]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const b=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,p.isThenable)(f)&&b.push(f.then(w=>{w&&(n=!0)},w=>{M(w),n=!0}))}return p.Promises.settled(b).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,68,4,2,3,5]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...l){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...l]))}debug(i,...l){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...l]))}info(i,...l){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...l]))}warn(i,...l){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...l]))}error(i,...l){if(this.checkLogLevel(f.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([i,...l]))}critical(i,...l){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...l]))}flush(){}format(i){let l="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(o){}l+=(r>0?" ":"")+s}return l}}e.AbstractMessageLogger=t;class P extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...l){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...l):console.log(`[main ${n()}]`,i,...l))}debug(i,...l){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...l):console.log(`[main ${n()}]`,i,...l))}info(i,...l){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...l):console.log(`[main ${n()}]`,i,...l))}warn(i,...l){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...l):console.warn(`[main ${n()}]`,i,...l))}error(i,...l){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...l):console.error(`[main ${n()}]`,i,...l))}critical(i,...l){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...l):console.error(`[main ${n()}]`,i,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class I extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...l){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...l)}debug(i,...l){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...l)}info(i,...l){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...l)}warn(i,...l){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...l)}error(i,...l){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...l)}critical(i,...l){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...l)}dispose(){}flush(){}}e.ConsoleLogger=I;class y extends w{constructor(i,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(l)}trace(i,...l){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...l])}debug(i,...l){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...l])}info(i,...l){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...l])}warn(i,...l){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...l])}error(i,...l){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...l])}critical(i,...l){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...l])}extractMessage(i){return typeof i=="string"?i:(0,p.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const l of this.logServices)l.setLevel(i);super.setLevel(i)}trace(i,...l){for(const r of this.logServices)r.trace(i,...l)}debug(i,...l){for(const r of this.logServices)r.debug(i,...l)}info(i,...l){for(const r of this.logServices)r.info(i,...l)}warn(i,...l){for(const r of this.logServices)r.warn(i,...l)}error(i,...l){for(const r of this.logServices)r.error(i,...l)}critical(i,...l){for(const r of this.logServices)r.critical(i,...l)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...l){this.logger.trace(i,...l)}debug(i,...l){this.logger.debug(i,...l)}info(i,...l){this.logger.info(i,...l)}warn(i,...l){this.logger.warn(i,...l)}error(i,...l){this.logger.error(i,...l)}critical(i,...l){this.logger.critical(i,...l)}flush(){this.logger.flush()}}e.LogService=g;class E extends k.Disposable{constructor(i,l){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,l){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,l?.always?f.Trace:this.logLevel,l),this.loggers.set(i.toString(),r),l?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class v{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...l){}debug(i,...l){}info(i,...l){}warn(i,...l){}error(i,...l){}critical(i,...l){}dispose(){}flush(){}}e.NullLogService=v;function c(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const i=h(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function a(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=a});var ie=this&&this.__param||function(V,e){return function(p,L){e(p,L,V)}};define(Z[178],x([0,1,9,18,40,77,48,20,5,6]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(I){I.ERROR_INVALID_FILE="ERROR_INVALID_FILE",I.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let P=class{constructor(y,d,g){this.environmentService=y,this.fileService=d,this.logService=g,this.queue=new p.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:E,mtime:v,etag:c}=await this.fileService.readFile(y,{atomic:!0});let h=E.toString();const a=[];if((0,k.parse)(h,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(d,h,g)[0];if(u){h=h.substring(0,u.offset)+u.content+h.substring(u.offset+u.length);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(h),{etag:c,mtime:v})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},g,E){return d.length?(0,M.setProperty)(g,d,y,E):[{content:JSON.stringify(y,null,E.insertSpaces&&E.tabSize?" ".repeat(E.tabSize):"	"),length:g.length,offset:0}]}};P=ue([ie(0,b.IEnvironmentService),ie(1,n.IFileService),ie(2,w.ILogService)],P),e.UserConfigurationFileService=P}),define(Z[93],x([0,1,6]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,b){switch(b){case p.LogLevel.Trace:return M.trace;case p.LogLevel.Debug:return M.debug;case p.LogLevel.Info:return M.info;case p.LogLevel.Warning:return M.warn;case p.LogLevel.Error:return M.error;case p.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends p.AbstractLogger{constructor(b=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(b),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(b){this._logger=b;for(const{level:n,args:f}of this.buffer)L(b,n).apply(b,f);this.buffer=[]}_log(b,...n){this._logger?L(this._logger,b).apply(this._logger,n):this.getLevel()<=b&&this.buffer.push({level:b,args:n})}trace(b,...n){this._log(p.LogLevel.Trace,b,...n)}debug(b,...n){this._log(p.LogLevel.Debug,b,...n)}info(b,...n){this._log(p.LogLevel.Info,b,...n)}warn(b,...n){this._log(p.LogLevel.Warning,b,...n)}error(b,...n){this._log(p.LogLevel.Error,b,...n)}critical(b,...n){this._log(p.LogLevel.Critical,b,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(Z[179],x([0,1,9,18,15,20,5,93,6]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*M.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(y,d,g,E,v){super();this.name=y,this.resource=d,this.donotUseFormatters=E,this.fileService=v,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=d:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=E=>E<10?`0${E}`:E,d=E=>E<10?`00${E}`:E<100?`0${E}`:E,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let g=0;g<y.length;g++){let E=y[g];if(typeof E=="object")try{E=JSON.stringify(E)}catch(v){}d+=(g>0?" ":"")+E}return d}};t=ue([ie(4,M.IFileService)],t),e.FileLogger=t;let P=class extends f.AbstractLoggerService{constructor(y,d,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(y,d,g){const E=new n.BufferLogService(d);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(t,(0,k.basename)(y),y,E.getLevel(),!!g?.donotUseFormatters)),E}};P=ue([ie(0,f.ILogService),ie(1,b.IInstantiationService),ie(2,M.IFileService)],P),e.FileLoggerService=P}),define(Z[180],x([0,1,4,7,6]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(I){this.service=I,this.onDidChangeLogLevel=p.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(I,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=M;class b{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){b.setLevel(this.channel,I)}static setLevel(I,y){return I.call("setLevel",y)}}e.LogLevelChannelClient=b;class n{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,y){throw new Error(`Event not found: ${y}`)}async call(I,y,d){switch(y){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(I,y){this.loggers.set(I.toString(),this.loggerService.createLogger(I,y))}consoleLog(I,y){let d=console.log;switch(I){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(I,y){const d=this.loggers.get(I.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,E]of y)switch(g){case k.LogLevel.Trace:d.trace(E);break;case k.LogLevel.Debug:d.debug(E);break;case k.LogLevel.Info:d.info(E);break;case k.LogLevel.Warning:d.warn(E);break;case k.LogLevel.Error:d.error(E);break;case k.LogLevel.Critical:d.critical(E);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(I,y,d){super(I,y);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(I,y)=>{this.channel.call("consoleLog",[I,y])}})}doCreateLogger(I,y,d){return new w(this.channel,I,y,d)}}e.LoggerChannelClient=f;class w extends k.AbstractMessageLogger{constructor(I,y,d,g){super(g?.always);this.channel=I,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,y){const d=[[I,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(I){this.channel.call("log",[this.file,I])}}class t extends k.LogService{constructor(I,y){super(y);this.parent=I,this._register(I.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=t}),define(Z[94],x([0,1,20,6]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,w,t,P){try{const I=await new Promise((y,d)=>{V(["spdlog"],y,d)});return I.setFlushOn(L.LogLevel.Trace),I.createAsyncRotatingLogger(f,w,t,P)}catch(I){console.error(I)}return null}function M(f,w,t,P){const I=V.__$__nodeRequire("spdlog");return I.setFlushOn(L.LogLevel.Trace),I.createRotatingLogger(f,w,t,P)}e.createRotatingLogger=M;function b(f,w,t){switch(w){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,t,P,I){super();this.name=w,this.filepath=t,this.rotating=P,this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*p.ByteSize.MB;return k(this.name,this.filepath,t,w).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:I,message:y}of this.buffer)b(this._logger,I,y);this.buffer=[]}})}log(w,t){this._logger?b(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[181],x([0,1,10,15,28,20,179,6,94]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(P,I){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=I}doCreateLogger(P,I,y){if(P.scheme===p.Schemas.file){const d=new f.SpdLogLogger(y?.name||(0,k.generateUuid)(),P.fsPath,!y?.donotRotate,I);return y?.donotUseFormatters&&d.clearFormatters(),d}else return new b.FileLogger(y?.name??(0,L.basename)(P),P,I,!!y?.donotUseFormatters,this.fileService)}};w=ue([ie(0,n.ILogService),ie(1,M.IFileService)],w),e.LoggerService=w}),define(Z[182],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(b){return b.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function L(b){return b.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(b){return b.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(b){return!p(b)&&!L(b)&&!k(b)}e.isMenubarMenuItemAction=M}),define(Z[45],x([0,1,10,3,33,15]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let b;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)b=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,M.dirname)(p.FileAccess.asFileUri("",V));b=V.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=V.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(b,{nameShort:`${b.nameShort} Dev`,nameLong:`${b.nameLong} Dev`,dataFolderName:`${b.dataFolderName}-dev`}),Object.assign(b,{version:f.version})}else b={},Object.keys(b).length===0&&Object.assign(b,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=b}),define(Z[95],x([0,1,18,17,141,20,45]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(P,I,y,d,g,E){let v;try{await f(P,I,y,d,g,E)}catch(c){v=c}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v!="undefined"&&y.error(v),y.end()}}e.readFileIntoStream=n;async function f(P,I,y,d,g,E){w(E);const v=await P.open(I,{create:!1});try{w(E);let c=0,h=0,a=g&&typeof g.length=="number"?g.length:void 0,u=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,l=0;do h=await P.read(v,i,u.buffer,l,u.byteLength-l),i+=h,l+=h,c+=h,typeof a=="number"&&(a-=h),l===u.byteLength&&(await y.write(d(u)),u=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),l=0);while(h>0&&(typeof a!="number"||a>0)&&w(E)&&t(c,g));if(l>0){let r=l;typeof a=="number"&&(r=Math.min(l,a)),y.write(d(u.slice(0,r)))}}catch(c){throw(0,M.ensureFileSystemProviderError)(c)}finally{await P.close(v)}}function w(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function t(P,I){if(I?.limits){if(typeof I.limits.memory=="number"&&P>I.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,b.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&P>I.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[183],x([0,1,30,9,18,23,4,64,2,37,10,73,15,65,139,20,95,6]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Ke extends f.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new b.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new b.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new b.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new b.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new b.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new b.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=w.TernarySearchTree.forUris(u=>{const i=this.getProvider(u.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const i=new f.DisposableStore;return i.add(u.onDidChangeFile(l=>this.onDidChangeFile(l,this.isPathCaseSensitive(u)))),i.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidErrorOccur=="function"&&i.add(u.onDidErrorOccur(l=>this._onError.fire(new Error(l)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,f.dispose)(i)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(i){u.push(i)}}),!this.provider.has(a)&&await L.Promises.settled(u)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,u){const i=this.provider.get(a.scheme);return!!(i&&i.capabilities&u)}listCapabilities(){return n.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,I.isAbsolutePath)(a))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const i=new Error;throw i.name="ENOPRO",i.message=(0,d.localize)(1,null,a.toString()),i}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(a,u){const i=await this.withProvider(a),l=this.isPathCaseSensitive(i),r=u?.resolveTo,s=u?.resolveSingleChildDescendants,o=u?.resolveMetadata,m=await i.stat(a);let S;return this.toFileStat(i,a,m,void 0,!!o,(D,R)=>{if(!S&&(S=w.TernarySearchTree.forUris(()=>!l),S.set(a,!0),r))for(const T of r)S.set(T,!0);return S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?R===1:!1})}async toFileStat(a,u,i,l,r,s){const{providerExtUri:o}=this.getExtUri(a),m={resource:u,name:o.basename(u),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(m.isDirectory&&s(m,l)){try{const S=await a.readdir(u),D=await L.Promises.settled(S.map(async([R,T])=>{try{const C=o.joinPath(u,R),G=r?await a.stat(C):{type:T};return await this.toFileStat(a,C,G,S.length,r,s)}catch(C){return this.logService.trace(C),null}}));m.children=(0,p.coalesce)(D)}catch(S){this.logService.trace(S),m.children=[]}return m}return m}async resolveAll(a){return L.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(i){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(i){return i}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(a,i);const l=await this.writeFile(a,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,l)),l}async writeFile(a,u,i){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(l);try{await this.validateWriteFile(l,a,i)||await this.mkdirp(l,r.dirname(a));let o;if((0,g.hasReadWriteCapability)(l)&&!(u instanceof k.VSBuffer))if((0,y.isReadableStream)(u)){const m=await(0,y.peekStream)(u,3);m.ended?o=k.VSBuffer.concat(m.buffer):o=m}else o=(0,y.peekReadable)(u,m=>k.VSBuffer.concat(m),3);else o=u;!(0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)&&o instanceof k.VSBuffer?await this.doWriteUnbuffered(l,a,i,o):await this.doWriteBuffered(l,a,i,o instanceof k.VSBuffer?(0,k.bufferToReadable)(o):o)}catch(s){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),i)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,i){if(!!i?.unlock&&!(a.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(u)));let r;try{r=await a.stat(u)}catch(s){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(u)),0,i);if(this.throwIfFileIsReadonly(u,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:r.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,i);return r}async readFile(a,u){const i=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(i,a,u):this.doReadFile(i,a,u)}async doReadFileAtomic(a,u,i){return new Promise((l,r)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,u,i);l(s)}catch(s){r(s)}})})}async doReadFile(a,u,i){const l=await this.doReadFileStream(a,u,{...i,preferUnbuffered:!0});return{...l,value:await(0,k.streamToBuffer)(l.value)}}async readFileStream(a,u){const i=await this.withReadProvider(a);return this.doReadFileStream(i,a,u)}async doReadFileStream(a,u,i){const l=new M.CancellationTokenSource,r=this.validateReadFile(u,i).then(o=>o,o=>{throw l.cancel(),o});let s;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&i?.preferUnbuffered?s=this.readFileUnbuffered(a,u,i):(0,g.hasFileReadStreamCapability)(a)?s=this.readFileStreamed(a,u,l.token,i):s=this.readFileBuffered(a,u,l.token,i),{...await r,value:s}}catch(o){s&&await(0,y.consumeStream)(s);const m=(0,d.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(o).toString());throw o instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,o.stat,i):new g.FileOperationError(m,(0,g.toFileOperationResult)(o),i)}}readFileStreamed(a,u,i,l=Object.create(null)){const r=a.readFileStream(u,l,i);return(0,y.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),l)},s=>k.VSBuffer.concat(s))}readFileBuffered(a,u,i,l=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,E.readFileIntoStream)(a,u,r,s=>s,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),l)},i),r}readFileUnbuffered(a,u,i){const l=(0,y.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(u);typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(u,r.byteLength,i),l.end(k.VSBuffer.wrap(r))}catch(r){l.error(r),l.end()}})(),l}async validateReadFile(a,u){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(a)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),i,u);return this.validateReadFileLimits(a,i.size,u),i}validateReadFileLimits(a,u,i){if(i?.limits){let l;if(typeof i.limits.memory=="number"&&u>i.limits.memory&&(l=9),typeof i.limits.size=="number"&&u>i.limits.size&&(l=7),typeof l=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(a)),l)}}async canMove(a,u,i){return this.doCanMoveCopy(a,u,"move",i)}async canCopy(a,u,i){return this.doCanMoveCopy(a,u,"copy",i)}async doCanMoveCopy(a,u,i,l){if(a.toString()!==u.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(r,a,s,u,i,l)}catch(r){return r}return!0}async move(a,u,i){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),s=await this.doMoveCopy(l,a,r,u,"move",!!i),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,s==="move"?2:3,o)),o}async copy(a,u,i){const l=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),s=await this.doMoveCopy(l,a,r,u,"copy",!!i),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,s==="copy"?3:2,o)),o}async doMoveCopy(a,u,i,l,r,s){if(u.toString()===l.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(a,u,i,l,r,s);if(o&&!m&&s&&await this.del(l,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(l)),r==="copy"){if(a===i&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(u,l,{overwrite:s});else{const S=await this.resolve(u);S.isDirectory?await this.doCopyFolder(a,S,i,l):await this.doCopyFile(a,u,i,l)}return r}else return a===i?(await a.rename(u,l,{overwrite:s}),r):(await this.doMoveCopy(a,u,i,l,"copy",s),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,i,l){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(a,u,i,l);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(a,u,i,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(a,u,i,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(a,u,i,l)}async doCopyFolder(a,u,i,l){await i.mkdir(l),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async r=>{const s=this.getExtUri(i).providerExtUri.joinPath(l,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),i,s):this.doCopyFile(a,r.resource,i,s)}))}async doValidateMoveCopy(a,u,i,l,r,s){let o=!1;if(a===i){const{providerExtUri:S,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(o=S.isEqual(u,l)),o&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(u),this.resourceForError(l)));if(!o&&S.isEqualOrParent(l,u))throw new Error((0,d.localize)(15,null,this.resourceForError(u),this.resourceForError(l)))}const m=await this.exists(l);if(m&&!o){if(!s)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(u),this.resourceForError(l)),4);if(a===i){const{providerExtUri:S}=this.getExtUri(a);if(S.isEqualOrParent(u,l))throw new Error((0,d.localize)(17,null,this.resourceForError(u),this.resourceForError(l)))}}return{exists:m,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const i=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,i)),i}async mkdirp(a,u){const i=[],{providerExtUri:l}=this.getExtUri(a);for(;!l.isEqual(u,l.dirname(u));)try{if(((await a.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(u)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(l.basename(u)),u=l.dirname(u)}for(let r=i.length-1;r>=0;r--){u=l.joinPath(u,i[r]);try{await a.mkdir(u)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(i){return i}return!0}async doValidateDelete(a,u){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(i.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(a)));let r;try{r=await i.stat(a)}catch(o){}if(r)this.throwIfFileIsReadonly(a,r);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(a)))}return i}async del(a,u){const i=await this.doValidateDelete(a,u),l=!!u?.useTrash,r=!!u?.recursive;await i.delete(a,{recursive:r,useTrash:l}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let i,l;{for(const r of a)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(l||(l=[]),l.push(r));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!u))}if(l){const r=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(l)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let l=!1,r=()=>{l=!0};i.add((0,f.toDisposable)(()=>r())),this.doWatch(a,u).then(s=>{l?(0,f.dispose)(s):r=()=>(0,f.dispose)(s)},s=>this.logService.error(s))}return u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),i.add((0,f.toDisposable)(()=>{const l=this.watchedResources.get(a);typeof l=="number"&&(l<=1?this.watchedResources.delete(a):this.watchedResources.set(a,l-1))}))),i}async doWatch(a,u){const i=await this.withProvider(a),l=this.toWatchKey(i,a,u),r=this.activeWatchers.get(l)||{count:0,disposable:i.watch(a,u)};return this.activeWatchers.has(l)||this.activeWatchers.set(l,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(l))})}toWatchKey(a,u,i){const{providerExtUri:l}=this.getExtUri(a);return[l.getComparisonKey(u),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,f.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,u,i,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(u,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(l)||(0,y.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(a,r,l):await this.doWriteReadableBufferedQueued(a,r,l)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,u,i){let l=0,r;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(a,u,s,s.byteLength,l,0),l+=s.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(s,o)=>{(0,y.listenStream)(r,{onData:async m=>{r.pause();try{await this.doWriteBuffer(a,u,m,m.byteLength,l,0)}catch(S){return o(S)}l+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>o(m),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,u,i){let l=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(a,u,r,r.byteLength,l,0),l+=r.byteLength}async doWriteBuffer(a,u,i,l,r,s){let o=0;for(;o<l;)o+=await a.write(u,r+o,i.buffer,s+o,l-o)}async doWriteUnbuffered(a,u,i,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,i,l))}async doWriteUnbufferedQueued(a,u,i,l){let r;l instanceof k.VSBuffer?r=l:(0,y.isReadableStream)(l)?r=await(0,k.streamToBuffer)(l):(0,y.isReadableBufferedStream)(l)?r=await(0,k.bufferedStreamToBuffer)(l):r=(0,k.readableToBuffer)(l),await a.writeFile(u,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(a,u,i,l){return this.writeQueue.queueFor(l,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,i,l))}async doPipeBufferedQueued(a,u,i,l){let r,s;try{r=await a.open(u,{create:!1}),s=await i.open(l,{create:!0,unlock:!1});const o=k.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,S=0,D=0;do D=await a.read(r,m,o.buffer,S,o.byteLength-S),await this.doWriteBuffer(i,s,o,D,m,S),m+=D,S+=D,S===o.byteLength&&(S=0);while(D>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await L.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,u,i,l){return this.writeQueue.queueFor(l,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,i,l))}async doPipeUnbufferedQueued(a,u,i,l){return i.writeFile(l,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,i,l){return this.writeQueue.queueFor(l,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,i,l))}async doPipeUnbufferedToBufferedQueued(a,u,i,l){const r=await i.open(l,{create:!0,unlock:!1});try{const s=await a.readFile(u);await this.doWriteBuffer(i,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(a,u,i,l){const r=await(0,k.streamToBuffer)(this.readFileBuffered(a,u,M.CancellationToken.None));await this.doWriteUnbuffered(i,l,void 0,r)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===t.Schemas.file?a.fsPath:a.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=ue([ie(0,v.ILogService)],c),e.FileService=c}),define(Z[184],x([0,1,30,9,18,4,31,2,8,3,15,65,19,142,20,95,173,163,164,92,166,6,45]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class l extends n.Disposable{constructor(s,o){super();this.logService=s,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:o,symbolicLink:m}=await I.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(o,m),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(s){try{const o=await I.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),m=[];return await Promise.all(o.map(async S=>{try{let D;S.isSymbolicLink()?D=(await this.stat((0,t.joinPath)(s,S.name))).type:D=this.toType(S),m.push([S.name,D])}catch(D){this.logService.trace(D)}})),m}catch(o){throw this.toFileSystemProviderError(o)}}toType(s,o){let m;return o?.dangling?m=d.FileType.Unknown:s.isFile()?m=d.FileType.File:s.isDirectory()?m=d.FileType.Directory:m=d.FileType.Unknown,o&&(m|=d.FileType.SymbolicLink),m}async readFile(s){try{const o=this.toFilePath(s);return await I.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(s,o,m){const S=(0,P.newWriteableStream)(D=>k.VSBuffer.concat(D.map(R=>k.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,s,S,D=>D.buffer,{...o,bufferSize:this.BUFFER_SIZE},m),S}async writeFile(s,o,m){let S;try{const D=this.toFilePath(s);if(!m.create||!m.overwrite){if(await I.Promises.exists(D)){if(!m.overwrite)throw(0,d.createFileSystemProviderError)((0,y.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,d.createFileSystemProviderError)((0,y.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:m.unlock}),await this.write(S,0,o,0,o.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof S=="number"&&await this.close(S)}}async open(s,o){try{const m=this.toFilePath(s);if((0,d.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:R}=await I.SymlinkSupport.stat(m);R.mode&128||await I.Promises.chmod(m,R.mode|128)}catch(R){this.logService.trace(R)}let S;if((0,d.isFileOpenForWriteOptions)(o)){if(w.isWindows)try{await I.Promises.truncate(m,0),S="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}S||(S="w")}else S="r";const D=await I.Promises.open(m,S);return this.mapHandleToPos.set(D,0),(0,d.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(D,s),D}catch(m){throw(0,d.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(s,m):this.toFileSystemProviderError(m)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await I.Promises.fdatasync(s)}catch(o){this.canFlush=!1,this.logService.error(o)}return await I.Promises.close(s)}catch(o){throw this.toFileSystemProviderError(o)}}async read(s,o,m,S,D){const R=this.normalizePos(s,o);let T=null;try{const C=await I.Promises.read(s,m,S,D,R);return typeof C=="number"?T=C:T=C.bytesRead,T}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(s,R,T)}}normalizePos(s,o){return o===this.mapHandleToPos.get(s)?null:o}updatePos(s,o,m){const S=this.mapHandleToPos.get(s);typeof S=="number"&&(typeof o=="number"||(typeof m=="number"?this.mapHandleToPos.set(s,S+m):this.mapHandleToPos.delete(s)))}async write(s,o,m,S,D){return(0,L.retry)(()=>this.doWrite(s,o,m,S,D),100,3)}async doWrite(s,o,m,S,D){const R=this.normalizePos(s,o);let T=null;try{const C=await I.Promises.write(s,m,S,D,R);return typeof C=="number"?T=C:T=C.bytesWritten,T}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),C)}finally{this.updatePos(s,R,T)}}async mkdir(s){try{await I.Promises.mkdir(this.toFilePath(s))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(s,o){try{const m=this.toFilePath(s);await this.doDelete(m,o)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(s,o){o.recursive?await I.Promises.rm(s,I.RimRafMode.MOVE):await I.Promises.unlink(s)}async rename(s,o,m){const S=this.toFilePath(s),D=this.toFilePath(o);if(S!==D)try{await this.validateTargetDeleted(s,o,"move",m.overwrite),await I.Promises.move(S,D)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(2,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,o,m){const S=this.toFilePath(s),D=this.toFilePath(o);if(S!==D)try{await this.validateTargetDeleted(s,o,"copy",m.overwrite),await I.Promises.copy(S,D,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(3,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(s,o,m,S){const D=this.toFilePath(s),R=this.toFilePath(o);let T=!1;if(!!(this.capabilities&1024)||(T=(0,b.isEqual)(D,R,!0)),T&&m==="copy")throw(0,d.createFileSystemProviderError)((0,y.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!T&&await I.Promises.exists(R)){if(!S)throw(0,d.createFileSystemProviderError)((0,y.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(s,o){return o.recursive?this.watchRecursive(s,o):this.watchNonRecursive(s)}watchRecursive(s,o){const m={path:this.toFilePath(s),excludes:o.excludes},S=(0,p.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,o;if(this.options?.watcher?.usePolling)s=c.FileWatcher,o=this.options?.watcher;else{let m;this.options?.enableLegacyRecursiveWatcher?m=!0:m=i.default.quality==="stable"&&w.isLinux,m&&this.recursiveFoldersToWatch.length===1?w.isWindows?s=a.FileWatcher:s=c.FileWatcher:s=v.FileWatcher}this.recursiveWatcher=new s(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===u.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))}}watchNonRecursive(s){const o=new E.FileWatcher(this.toFilePath(s),S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===u.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)});return(0,n.combinedDisposable)(o,m)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof d.FileSystemProviderError)return s;let o;switch(s.code){case"ENOENT":o=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=d.FileSystemProviderErrorCode.NoPermissions;break;default:o=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(s,o)}async toFileSystemProviderWriteError(s,o){let m=this.toFileSystemProviderError(o);if(s&&m.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await I.SymlinkSupport.stat(this.toFilePath(s));S.mode&128||(m=(0,d.createFileSystemProviderError)(o,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return m}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=l}),define(Z[21],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[185],x([0,1,58,6,21]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,P]=w;let I=this.trustedExtensionUrlPublicKeys.get(n);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[n],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...I])}const y=Buffer.from(decodeURIComponent(P),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=y.slice(0,6),g=y.readUIntBE(0,6),E=Date.now()-g;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const v=y.slice(6),c=p.createVerify("SHA256");c.write(d),c.write(Buffer.from(t)),c.end();for(let h=0;h<I.length;h++){let a=I[h];if(a!==null){if(typeof a=="string")try{a=p.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),I[h]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,u),I[h]=null;continue}if(c.verify(a,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=ue([ie(0,k.IProductService),ie(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[55],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[186],x([0,1,14,2,37,10,3,15,7,28,48,6]),function(V,e,p,L,k,M,b,n,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends L.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!b.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=p.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,E)=>this.handleResourceRequest(g,E)),d.protocol.interceptFileProtocol(M.Schemas.file,(g,E)=>this.handleFileRequest(g,E)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const E=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${E.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}handleResourceRequest(d,g){const E=f.URI.parse(d.url),v=M.FileAccess.asFileUri(E);return this.validRoots.findSubstr(v)?g({path:v.fsPath}):this.validExtensions.has((0,n.extname)(v))?g({path:v.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),E=g.toString(),v=async()=>d;return p.ipcMain.handle(E,v),this.logService.trace(`IPC Object URL: Registered new channel ${E}.`),{resource:g,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${E}.`),p.ipcMain.removeHandler(E)}}}};I=ue([ie(0,t.INativeEnvironmentService),ie(1,P.ILogService)],I),e.ProtocolMainService=I}),define(Z[38],x([0,1,103,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(b,n){p.ok(L.isString(b)),p.ok(L.isObject(n)),p.ok(!this.data.has(b),"There is already an extension with this id"),this.data.set(b,n)}knows(b){return this.data.has(b)}as(b){return this.data.get(b)||null}}e.Registry=new k}),define(Z[187],x([0,1,4,38]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[k(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const b=new M;L.Registry.add(e.Extensions.JSONContribution,b)}),define(Z[49],x([0,1,30,4,13,132,187,38]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=n.Registry.as(b.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,a=!0){this.registerConfigurations([h],a)}registerConfigurations(h,a=!0){const u=this.doRegisterConfigurations(h,a);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(h){const a=this.doDeregisterConfigurations(h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}updateConfigurations({add:h,remove:a}){const u=[];u.push(...this.doDeregisterConfigurations(a)),u.push(...this.doRegisterConfigurations(h,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(u))}registerDefaultConfigurations(h){const a=[],u=[];for(const i of h)for(const l in i)if(a.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]={...this.defaultValues[l]||{},...i[l]};const r={type:"object",default:this.defaultValues[l],description:M.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(y(l)),this.configurationProperties[l]=r,this.defaultLanguageConfigurationOverridesNode.properties[l]=r}else{this.defaultValues[l]=i[l];const r=this.configurationProperties[l];r&&(this.updatePropertyDefaultValue(l,r),this.updateSchema(l,r))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(h){const a=[];for(const u of h)for(const i in u)if(a.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const l=this.configurationProperties[i];l&&(this.updatePropertyDefaultValue(i,l),this.updateSchema(i,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const a of h)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,a){const u=[];return h.forEach(i=>{u.push(...this.validateAndRegisterProperties(i,a,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),u}doDeregisterConfigurations(h){const a=[],u=i=>{if(i.properties)for(const l in i.properties)a.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,i.properties[l]);i.allOf&&i.allOf.forEach(l=>u(l))};for(const i of h){u(i);const l=this.configurationContributors.indexOf(i);l!==-1&&this.configurationContributors.splice(l,1)}return a}validateAndRegisterProperties(h,a=!0,u,i=3){i=k.isUndefinedOrNull(h.scope)?i:h.scope;let l=[],r=h.properties;if(r)for(let o in r){if(a&&E(o)){delete r[o];continue}const m=r[o];if(this.updatePropertyDefaultValue(o,m),e.OVERRIDE_PROPERTY_PATTERN.test(o)?m.scope=void 0:(m.scope=k.isUndefinedOrNull(m.scope)?i:m.scope,m.restricted=k.isUndefinedOrNull(m.restricted)?!!u?.restrictedConfigurations?.includes(o):m.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),l.push(o)}let s=h.allOf;if(s)for(let o of s)l.push(...this.validateAndRegisterProperties(o,a,u,i));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const a=u=>{let i=u.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let l=u.allOf;l&&l.forEach(a)};a(h)}updateSchema(h,a){switch(e.allSettings.properties[h]=a,a.scope){case 1:e.applicationSettings.properties[h]=a;break;case 2:e.machineSettings.properties[h]=a;break;case 6:e.machineOverridableSettings.properties[h]=a;break;case 3:e.windowSettings.properties[h]=a;break;case 4:e.resourceSettings.properties[h]=a;break;case 5:e.resourceSettings.properties[h]=a,this.resourceLanguageSettingsSchema.properties[h]=a;break}}removeFromSchema(h,a){switch(delete e.allSettings.properties[h],a.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const a=`[${h}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,u),e.allSettings.properties[a]=u,e.applicationSettings.properties[a]=u,e.machineSettings.properties[a]=u,e.machineOverridableSettings.properties[a]=u,e.windowSettings.properties[a]=u,e.resourceSettings.properties[a]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,a){let u=this.defaultValues[h];k.isUndefined(u)&&(u=a.default),k.isUndefined(u)&&(u=d(a.type)),a.default=u}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function y(c){return c.substring(1,c.length-1)}e.overrideIdentifierFromKey=y;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new P;n.Registry.add(e.Extensions.Configuration,g);function E(c){return c.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(c)?M.localize(5,null,c):g.getConfigurationProperties()[c]!==void 0?M.localize(6,null,c):null:M.localize(4,null)}e.validateProperty=E;function v(){const c=[],h=g.getConfigurationProperties();for(const a of Object.keys(h))c.push([a,h[a].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=v}),define(Z[16],x([0,1,44,13,7,49,5,38]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function f(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof k.URI)}e.isConfigurationOverrides=f;var w;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function P(l,r){const s=r?l?r.keys.filter(C=>l.keys.indexOf(C)===-1):[...r.keys]:[],o=l?r?l.keys.filter(C=>r.keys.indexOf(C)===-1):[...l.keys]:[],m=[];if(r&&l){for(const C of l.keys)if(r.keys.indexOf(C)!==-1){const G=v(l.contents,C),ne=v(r.contents,C);p.equals(G,ne)||m.push(C)}}const S=[],D=C=>{const G={};for(const ne of C)for(const oe of ne.identifiers)G[u(oe)]=ne;return G},R=r?D(r.overrides):{},T=l?D(l.overrides):{};if(Object.keys(R).length)for(const C of s){const G=R[C];G&&S.push([(0,M.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(T).length)for(const C of o){const G=T[C];G&&S.push([(0,M.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(R).length&&Object.keys(T).length)for(const C of m){const G=T[C],ne=R[C];if(G&&ne){const oe=P({contents:G.contents,keys:G.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});S.push([(0,M.overrideIdentifierFromKey)(C),[...oe.added,...oe.removed,...oe.updated]])}}return{added:s,removed:o,updated:m,overrides:S}}e.compare=P;function I(l,r){const s=[];for(const o of Object.keys(l))if(M.OVERRIDE_PROPERTY_PATTERN.test(o)){const m={};for(const S in l[o])m[S]=l[o][S];s.push({identifiers:[(0,M.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(m),contents:y(m,r)})}return s}e.toOverrides=I;function y(l,r){const s=Object.create(null);for(let o in l)d(s,o,l[o],r);return s}e.toValuesTree=y;function d(l,r,s,o){const m=r.split("."),S=m.pop();let D=l;for(let R=0;R<m.length;R++){let T=m[R],C=D[T];switch(typeof C){case"undefined":C=D[T]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(C)}`);return}D=C}if(typeof D=="object"&&D!==null)try{D[S]=s}catch(R){o(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}else o(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(l,r){const s=r.split(".");E(l,s)}e.removeFromValueTree=g;function E(l,r){const s=r.shift();if(r.length===0){delete l[s];return}if(Object.keys(l).indexOf(s)!==-1){const o=l[s];typeof o=="object"&&!Array.isArray(o)&&(E(o,r),Object.keys(o).length===0&&delete l[s])}}function v(l,r,s){function o(D,R){let T=D;for(const C of R){if(typeof T!="object"||T===null)return;T=T[C]}return T}const m=r.split("."),S=o(l,m);return typeof S=="undefined"?s:S}e.getConfigurationValue=v;function c(l,r,s){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in l?L.isObject(l[o])&&L.isObject(r[o])?c(l[o],r[o],s):s&&(l[o]=r[o]):l[o]=r[o])})}e.merge=c;function h(){const l=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=h;function a(){const l=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let s in r){let o=r[s].default;d(l,s,o,m=>console.error(`Conflict in default settings: ${m}`))}return l}e.getDefaultValues=a;function u(l){return`[${l}]`}e.keyFromOverrideIdentifier=u;function i(l,r,s){const o=l.inspect(r),m=l.inspect(s);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:o.defaultValue}e.getMigratedSettingValue=i}),define(Z[188],x([0,1,30,4,40,2,37,44,13,7,16,49,38]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},l=[],r=[]){this._contents=i,this._keys=l,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,l){const r=this.getContentsForOverrideIdentifer(l);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.keys;return[]}override(i){const l=this.getContentsForOverrideIdentifer(i);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let r={};for(const s of p.distinct([...Object.keys(this.contents),...Object.keys(l)])){let o=this.contents[s],m=l[s];m&&(typeof o=="object"&&typeof m=="object"?(o=n.deepClone(o),this.mergeContents(o,m)):o=m),r[s]=o}return new y(r,this.keys,this.overrides)}merge(...i){const l=n.deepClone(this.contents),r=n.deepClone(this.overrides),s=[...this.keys];for(const o of i){this.mergeContents(l,o.contents);for(const m of o.overrides){const[S]=r.filter(D=>p.equals(D.identifiers,m.identifiers));S?this.mergeContents(S.contents,m.contents):r.push(n.deepClone(m))}for(const m of o.keys)s.indexOf(m)===-1&&s.push(m)}return new y(l,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,l){for(const r of Object.keys(l)){if(r in i&&f.isObject(i[r])&&f.isObject(l[r])){this.mergeContents(i[r],l[r]);continue}i[r]=n.deepClone(l[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,l){this.addKey(i),(0,t.addToValueTree)(this.contents,i,l,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let l=this.keys.length;for(let r=0;r<l;r++)i.indexOf(this.keys[r])===0&&(l=r);this.keys.splice(l,1,i)}removeKey(i){let l=this.keys.indexOf(i);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const i=(0,t.getDefaultValues)(),l=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))P.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],o=>console.error(`Conflict in default settings file: ${o}`))});super(i,l,r)}}e.DefaultConfigurationModel=d;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,l){if(!f.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,l)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,l){this._raw=i;const{contents:r,keys:s,overrides:o,restricted:m}=this.doParseRaw(i,l);this._configurationModel=new y(r,s,o),this._restrictedConfigurations=m||[]}doParseContent(i){let l={},r=null,s=[],o=[],m=[];function S(R){Array.isArray(s)?s.push(R):r!==null&&(s[r]=R)}let D={onObjectBegin:()=>{let R={};S(R),o.push(s),s=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{let R=[];S(R),o.push(s),s=R,r=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:S,onError:(R,T,C)=>{m.push({error:R,offset:T,length:C})}};if(i)try{k.visit(i,D),l=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return l}doParseRaw(i,l){const r=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,l);i=s.raw;const o=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(i),S=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:o,keys:m,overrides:S,restricted:s.restricted}}filter(i,l,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const o={},m=[];for(let S in i)if(P.OVERRIDE_PROPERTY_PATTERN.test(S)&&r){const D=this.filter(i[S],l,!1,s);o[S]=D.raw,m.push(...D.restricted)}else{const D=l[S],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(S),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&D?.restricted||(o[S]=i[S]))}return{raw:o,restricted:m}}}e.ConfigurationModelParser=g;class E extends M.Disposable{constructor(i,l,r,s){super();this.userSettingsResource=i,this.scopes=l,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class v{constructor(i,l,r=new y,s=new y,o=new b.ResourceMap,m=new y,S=new b.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=l,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=o,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new b.ResourceMap,this._userConfiguration=null}getValue(i,l,r){return this.getConsolidateConfigurationModel(l,r).getValue(i)}updateValue(i,l,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new y,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,l===void 0?s.removeValue(i):s.setValue(i,l),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,l,r){const s=this.getConsolidateConfigurationModel(l,r),o=this.getFolderConfigurationModelForResource(l.resource,r),m=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,S=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),T=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),C=r?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,G=o?l.overrideIdentifier?o.freeze().override(l.overrideIdentifier).getValue(i):o.freeze().getValue(i):void 0,ne=l.overrideIdentifier?m.override(l.overrideIdentifier).getValue(i):m.getValue(i),oe=s.getValue(i),K=p.distinct(p.flatten(s.overrides.map(ee=>ee.identifiers))).filter(ee=>s.getOverrideValue(i,ee)!==void 0);return{defaultValue:S,userValue:D,userLocalValue:R,userRemoteValue:T,workspaceValue:C,workspaceFolderValue:G,memoryValue:ne,value:oe,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:o?.freeze().getValue(i),override:l.overrideIdentifier?o?.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:m.getValue(i),override:l.overrideIdentifier?m.getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(i){const l=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,l){this._folderConfigurations.set(i,l),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,l){const r=l.filter(s=>P.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const o=(0,P.overrideIdentifierFromKey)(s),m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),S=i.getKeysForOverrideIdentifier(o),D=[...S.filter(R=>m.indexOf(R)===-1),...m.filter(R=>S.indexOf(R)===-1),...m.filter(R=>!n.equals(this._defaultConfiguration.override(o).getValue(R),i.override(o).getValue(R)))];return[o,D]});return this.updateDefaultConfiguration(i),{keys:l,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:l,updated:r,removed:s,overrides:o}=(0,t.compare)(this.localUserConfiguration,i),m=[...l,...r,...s];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:l,updated:r,removed:s,overrides:o}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...l,...r,...s];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:l,updated:r,removed:s,overrides:o}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...l,...r,...s];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(i,l){const r=this.folderConfigurations.get(i),{added:s,updated:o,removed:m,overrides:S}=(0,t.compare)(r,l);let D=[...s,...o,...m];return(D.length||!r)&&this.updateFolderConfiguration(i,l),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(i){const l=this.folderConfigurations.get(i);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:o,overrides:m}=(0,t.compare)(l,void 0);return{keys:[...r,...s,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,l){let r=this.getConsolidatedConfigurationModelForResource(i,l);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},l){let r=this.getWorkspaceConsolidatedConfiguration();if(l&&i){const s=l.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const o=this._memoryConfigurationByResource.get(i);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let l=this._foldersConsolidatedConfigurations.get(i);if(!l){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(l=r.merge(s),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(i,l)):l=r}return l}getFolderConfigurationModelForResource(i,l){if(l&&i){const r=l.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,l)=>{const{contents:r,overrides:s,keys:o}=this._folderConfigurations.get(l);return i.push([l,{contents:r,overrides:s,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>i.add(l)),this.userConfiguration.freeze().keys.forEach(l=>i.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>l.add(s))),[...l.values()]}static parse(i){const l=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),o=i.folders.reduce((m,S)=>(m.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new b.ResourceMap);return new v(l,r,new y,s,o,new y,new b.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=v;function c(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const i=new Set,l=new Map;for(const s of u)s.keys.forEach(o=>i.add(o)),s.overrides.forEach(([o,m])=>{const S=(0,b.getOrSet)(l,o,new Set);m.forEach(D=>S.add(D))});const r=[];return l.forEach((s,o)=>r.push([o,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=c;class h{constructor(i,l,r,s){this.change=i,this.previous=l,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(S=>o.add(S)),i.overrides.forEach(([,S])=>S.forEach(D=>o.add(D))),this.affectedKeys=[...o.values()];const m=new y;this.affectedKeys.forEach(S=>m.setValue(S,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(l){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,l,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,l,this.currentWorkspace);return!n.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,l){let r=(0,t.toValuesTree)({[l]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=h;class a extends h{constructor(i,l,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,l);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=a}),define(Z[189],x([0,1,9,4,2,15,16,188,49,38]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(I,y){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,y)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,y){const d=typeof I=="string"?I:void 0,g=(0,b.isConfigurationOverrides)(I)?I:(0,b.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,g,void 0)}updateValue(I,y,d,g){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(d,y,1)}onDidDefaultConfigurationChange(I){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,I);this.trigger(d,y,6)}trigger(I,y,d){const g=new n.ConfigurationChangeEvent(I,{data:y},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(Z[190],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(b,n=L.Unknown,f){super(b);this._message=b,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(b){return b instanceof k&&b._code===L.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof k&&b._code===L.NoResolverFound}static isHandled(b){return b instanceof k&&b.isHandled}}e.RemoteAuthorityResolverError=k}),define(Z[191],x([0,1,9,18,23,17,4,2,28,84,190]),function(V,e,p,L,k,M,b,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var I;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function y(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(U){const A=new k.CancellationTokenSource;return setTimeout(()=>A.cancel(),U),A.token}function g(U,A){if(U.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const F=new k.CancellationTokenSource;return U.onCancellationRequested(()=>F.cancel()),A.onCancellationRequested(()=>F.cancel()),F.token}class E{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((F,B)=>{this._resolvePromise=F,this._rejectPromise=B}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function v(U,A){const F=new E(A);return F.registerDisposable(U.onControlMessage(B=>{const Y=JSON.parse(B.toString()),_=$(Y);_?F.reject(_):F.resolve(Y)})),F.promise}function c(U,A,F,B,Y,_){const N=new E(_);return A.connect(F,B,Y,(Q,J)=>{N.didTimeout?(Q&&U.error(Q),J?.dispose()):Q||!J?N.reject(Q):N.resolve(J)}),N.promise}function h(U,A){const F=new E(A);return U.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function a(U,A,F,B){const Y=W(U,A);U.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let _;try{_=await c(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,B)}catch(re){throw U.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),U.logService.error(re),re}U.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let N,Q;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(_,null),N=U.reconnectionProtocol,Q=!1):(N=new w.PersistentProtocol(_,null),Q=!0),U.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const J={type:"auth",auth:U.connectionToken||"00000000000000000000"};N.sendControl(L.VSBuffer.fromString(JSON.stringify(J)));try{const re=await v(N,g(B,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ae=new Error("Unexpected handshake message");throw ae.code="VSCODE_CONNECTION_ERROR",ae}U.logService.trace(`${Y} 4/6. received SignRequest control message.`);const le=await h(U.signService.sign(re.data),B),te={type:"connectionType",commit:U.commit,signedData:le,desiredConnectionType:A};return F&&(te.args=F),U.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(te))),{protocol:N,ownsProtocol:Q}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(U.logService.error(`${Y} the handshake timed out. Error:`),U.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${Y} received error control message when negotiating connection. Error:`),U.logService.error(re)),Q&&j(N),re}}async function u(U,A,F,B){const Y=Date.now(),_=W(U,A),{protocol:N,ownsProtocol:Q}=await a(U,A,F,B),J=new E(B);return J.registerDisposable(N.onControlMessage(re=>{const le=JSON.parse(re.toString()),te=$(le);te?(U.logService.error(`${_} received error control message when negotiating connection. Error:`),U.logService.error(te),Q&&j(N),J.reject(te)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${q(Y)}!`),J.resolve({protocol:N,firstMessage:le}))})),J.promise}async function i(U,A){const{protocol:F}=await u(U,1,void 0,A);return{protocol:F}}async function l(U,A,F){const{protocol:B,firstMessage:Y}=await u(U,2,A,F),_=Y&&Y.debugPort;return{protocol:B,debugPort:_}}async function r(U,A,F){const B=Date.now(),Y=W(U,3),{protocol:_}=await a(U,3,A,F);return U.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${q(B)}!`),_}async function s(U,A,F){const{host:B,port:Y,connectionToken:_}=await U.addressProvider.getAddress();return{commit:U.commit,host:B,port:Y,connectionToken:_,reconnectionToken:A,reconnectionProtocol:F,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function o(U,A,F){try{const B=(0,f.generateUuid)(),Y=await s(U,B,null),{protocol:_}=await i(Y,k.CancellationToken.None);return new ee(U,A,F,B,_)}catch(B){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(B),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentManagement=o;async function m(U,A){try{const F=(0,f.generateUuid)(),B=await s(U,F,null),{protocol:Y,debugPort:_}=await l(B,A,k.CancellationToken.None);return new O(U,A,F,Y,_)}catch(F){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(F),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentExtensionHost=m;async function S(U,A,F){const B=await s(U,(0,f.generateUuid)(),null);return await r(B,{host:A,port:F},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function D(U){return(0,p.createCancelablePromise)(A=>new Promise((F,B)=>{const Y=setTimeout(F,U*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),F()})}))}var R;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(A,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.type=0}}e.ConnectionLostEvent=T;class C{constructor(A,F,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class G{constructor(A,F,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=G;class ne{constructor(A,F,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.ConnectionGainEvent=ne;class oe{constructor(A,F,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class K extends n.Disposable{constructor(A,F,B,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new b.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=F,this.reconnectionToken=B,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(_=>{const N=H(this._connectionType,this.reconnectionToken,!0);_?_.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${_.hadError}).`),_.error&&this._options.logService.error(_.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this._options.logService.error(_.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const _=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${_} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(A,F,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=F,this._permanentFailureHandled=B,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const A=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const Y=B<F.length?F[B]:F[F.length-1];try{if(Y>0){const N=D(Y);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,N)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await N}catch{}}if(K._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${A} resolving connection...`);const _=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${_.host}:${_.port}...`),await this._reconnect(_,d(P)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(_),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(_),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(_)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(_);continue}if((0,M.isPromiseCanceledError)(_)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(_);continue}if(_ instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(_),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,t.RemoteAuthorityResolverError.isHandled(_));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(_),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(A,F,B){this._onDidStateChange.fire(new oe(this.reconnectionToken,A,F,B)),j(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class ee extends K{constructor(A,F,B,Y,_){super(1,A,Y,_);this.client=this._register(new w.Client(_,{remoteAuthority:F,clientId:B},A.ipcLogger))}async _reconnect(A,F){await i(A,F)}}e.ManagementPersistentConnection=ee;class O extends K{constructor(A,F,B,Y,_){super(2,A,B,Y);this._startArguments=F,this.debugPort=_}async _reconnect(A,F){await l(A,this._startArguments,F)}}e.ExtensionHostPersistentConnection=O;function j(U){try{U.acceptDisconnect();const A=U.getSocket();U.dispose(),A.dispose()}catch(A){(0,M.onUnexpectedError)(A)}}function $(U){if(U&&U.type==="error"){const A=new Error(`Connection error: ${U.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function z(U,A){for(;U.length<A;)U+=" ";return U}function H(U,A,F){return`[remote-connection][${z(y(U),13)}][${A.substr(0,5)}\u2026][${F?"reconnect":"initial"}]`}function W(U,A){return`${H(A,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function q(U){return`${Date.now()-U} ms`}}),define(Z[74],x([0,1,10]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===p.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function k(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=k;function M(w){return w.scheme!==p.Schemas.file&&w.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=M;function b(w){if(w.folders.length)return w.folders.every(t=>M(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&M(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=b;function n(w){return b(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return b(w)!==void 0}e.isVirtualWorkspace=f}),define(Z[96],x([0,1,4,3,5,6]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var b;(function(d){d.Http="http",d.Https="https"})(b=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(n=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function I(d,g){return g?g!==1&&d<1024:!L.isWindows&&d<1024}e.isPortPrivileged=I;let y=class{constructor(g){this.logService=g,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,E){return this._tunnelProvider=g,g?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async g=>{const E=[],v=Array.from(this._tunnels.values());for(let c of v){const h=Array.from(c.values());for(let a of h){const u=await a.value;u&&E.push(u)}}g(E)})}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,v,c,h=!1,a=n.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${v} on local port ${c}.`),!g)return;E||(E="localhost");const i=this.retainOrCreateTunnel(g,E,v,c,h,a,u);return i?i.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(l);return(l.tunnelRemoteHost!==E||l.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const v=E.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,E,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const c=v.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),c}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const v=this._tunnels.get(g);if(v&&v.has(E)){const c=v.get(E);c.refcount=0,await this.tryDisposeTunnel(g,E,c)}}addTunnelToMap(g,E,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,E){const v=this._tunnels.get(g);v&&(await v.get(E)||v.delete(E),v.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let v=[g];t(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):P(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const c=v.map(h=>this._tunnels.get(h));for(const h of c){const a=h?.get(E);if(a)return a}}canTunnel(g){return!!w(g)}createWithProvider(g,E,v,c,h,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${v} on local port ${c}.`);const l={elevationRequired:h?I(c===void 0?v:c):!1},r={remoteAddress:{host:E,port:v},localAddressPort:c,privacy:a,public:a!==n.Private,protocol:u},s=g.forwardPort(r,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(E,v,s),s}};y=ue([ie(0,M.ILogService)],y),e.AbstractTunnelService=y}),define(Z[50],x([0,1,18,146,49,5,38]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function w(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,p.streamToBuffer)(d.stream)).toString()}e.asText=w;async function t(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const E=(await(0,p.streamToBuffer)(d.stream)).toString();try{return JSON.parse(E)}catch(v){throw v.message+=`:
`+E,v}}e.asJson=t;function P(d){y(d)}e.updateProxyConfigurationsScope=P;let I;function y(d){const g=b.Registry.as(k.Extensions.Configuration),E=I;I={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[I],remove:E?[E]:[]})}y(2)}),define(Z[192],x([0,1,193,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(b,n){return b.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:b.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(b,n,f={}){const w=(0,p.parse)(b),t=f.proxyUrl||k(w,n);if(!t)return null;const P=(0,p.parse)(t);if(!/^https?:$/.test(P.protocol||""))return null;const I={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((y,d)=>{V(["http-proxy-agent"],y,d)}))(I):new(await new Promise((y,d)=>{V(["https-proxy-agent"],y,d)}))(I)}e.getProxyAgent=M}),define(Z[194],x([0,1,18,28]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,b,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await b.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await b.writeFile(M.serviceMachineIdResource,p.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(Z[75],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[195],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((k,M)=>V(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),b=new M.signer;if(b)return b.sign(k)}catch(M){}return k}}e.SignService=p}),define(Z[39],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[22],x([0,1,14,9,4,2,3,33,13,5,177,6,39]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class ct extends M.Disposable{constructor(E,v){super();this.logService=E,this.stateMainService=v,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",E);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",E),p.app.removeListener("window-all-closed",v),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(v){E.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(E)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let v=this.phaseWhen.get(E);v||(v=new L.Barrier,this.phaseWhen.set(E,v)),await v.wait()}registerWindow(E){const v=new M.DisposableStore;this.windowCounter++,v.add(E.onWillLoad(h=>this._onWillLoadWindow.fire({window:E,workspace:h.workspace,reason:h.reason})));const c=(0,f.assertIsDefined)(E.win);c.on("close",h=>{const a=E.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),h.preventDefault(),this.unload(E,1).then(u=>{if(u){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(E),E.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,v){await this.unload(E,3)||E.reload(v)}async unload(E,v){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const c=this._quitRequested?2:v;let h=await this.onBeforeUnloadWindowInRenderer(E,c);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(E,c),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,c),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,v){return new Promise(c=>{const h=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${h}`,u=`vscode:cancel${h}`;p.ipcMain.once(a,()=>{c(!1)}),p.ipcMain.once(u,()=>{c(!0)}),E.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:u,reason:v})})}onBeforeUnloadWindowInMain(E,v){const c=[];return this._onBeforeUnloadWindow.fire({reason:v,window:E,veto(h){c.push(h)}}),(0,t.handleVetos)(c,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(E,v){return new Promise(c=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(a,()=>c()),E.send("vscode:onWillUnload",{replyChannel:a,reason:v})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(E?.addArgs&&v.push(...E.addArgs),E?.removeArgs)for(const a of E.removeArgs){const u=v.indexOf(a);u>=0&&v.splice(u,1)}const c=()=>{try{if(b.isWindows){const a=(0,n.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",c),await this.quit(!0)&&p.app.removeListener("quit",c)}async kill(E){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let c;v.webContents&&!v.webContents.isDestroyed()?c=new Promise(h=>v.once("closed",h)):c=Promise.resolve(),v.destroy(),await c}})()]),p.app.exit(E)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ue([ie(0,P.ILogService),ie(1,I.IStateMainService)],d),e.LifecycleMainService=d}),define(Z[196],x([0,1,4,2,5,22]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let b=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,P)=>{V(["native-keymap"],t,P)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};b=ue([ie(0,M.ILifecycleMainService)],b),e.KeyboardLayoutMainService=b;function n(f){const w=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(Z[97],x([0,1,9,4,2,13,86,5]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var P;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(P=e.StorageTarget||(e.StorageTarget={}));class I extends k.Disposable{constructor(E={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super();this.options=E,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,v){v===f?(E===0?this._globalKeyTargets=void 0:E===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:E})):this._onDidChangeValue.fire({scope:E,key:v,target:this.getKeyTargets(E)[v]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,v,c){return this.getStorage(v)?.get(E,c)}getBoolean(E,v,c){return this.getStorage(v)?.getBoolean(E,c)}getNumber(E,v,c){return this.getStorage(v)?.getNumber(E,c)}store(E,v,c,h){if((0,M.isUndefinedOrNull)(v)){this.remove(E,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(E,c,h),this.getStorage(c)?.set(E,v)})}remove(E,v){this.withPausedEmitters(()=>{this.updateKeyTarget(E,v,void 0),this.getStorage(v)?.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,v){const c=[],h=this.getKeyTargets(E);for(const a of Object.keys(h))h[a]===v&&c.push(a);return c}updateKeyTarget(E,v,c){const h=this.getKeyTargets(v);typeof c=="number"?h[E]!==c&&(h[E]=c,this.getStorage(v)?.set(f,JSON.stringify(h))):typeof h[E]=="number"&&(delete h[E],this.getStorage(v)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(E){return E===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(E){const v=this.get(f,E);if(v)try{return JSON.parse(v)}catch(c){}return Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=w.NONE){this._onWillSaveState.fire({reason:E}),await p.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const E=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return d(E,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=I,I.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends I{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.globalStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E)))}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(E){}}e.InMemoryStorageService=y;async function d(g,E,v,c){const h=o=>{try{return JSON.parse(o)}catch(m){return o}},a=new Map,u=new Map;g.forEach((o,m)=>{a.set(m,o),u.set(m,h(o))});const i=new Map,l=new Map;E.forEach((o,m)=>{i.set(m,o),l.set(m,h(o))}),console.group(`Storage: Global (path: ${v})`);let r=[];a.forEach((o,m)=>{r.push({key:m,value:o})}),console.table(r),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${c})`);let s=[];i.forEach((o,m)=>{s.push({key:m,value:o})}),console.table(s),console.groupEnd(),console.log(l)}e.logStorage=d}),define(Z[197],x([0,1,3,33,7,28]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function b(w){if(p.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,t,P,I,y,d,g,E,v,c){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=(0,M.generateUuid)()+Date.now(),h.commitHash=y,h.version=d,h["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,p.PlatformToString)(p.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=I,h["common.product"]=c||"desktop";const a=f(E||[]);a&&(h["common.msftInternal"]=a);let u=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),p.isLinuxSnap&&(h["common.snap"]="true");const l=b(P);l&&(h["common.platformDetail"]=l);try{const r=await w.readFile(k.URI.file(v));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function f(w){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const P=t.toLowerCase();return w.some(I=>P===I)}e.verifyMicrosoftInternalDomain=f}),define(Z[29],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.ERROR="error",M.ON="on"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[198],x([0,1,26,64,40,10,8,3,7,67,19,83,71,20,21,29]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(u,i){const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,s=new Map,o=2e4;function m(R,T,C,G){const ne=T.substring(R.length+1);return new Promise(async oe=>{let K;try{K=await t.Promises.readdir(T,{withFileTypes:!0})}catch(j){oe();return}if(G.count>=o){G.count+=K.length,G.maxReached=!0,oe();return}let ee=K.length;if(ee===0){oe();return}let O=K;G.count+K.length>o&&(G.maxReached=!0,ee=o-G.count,O=K.slice(0,ee)),G.count+=K.length;for(const j of O)if(j.isDirectory()){if(C.includes(j.name)||await m(R,(0,b.join)(T,j.name),C,G),--ee==0){oe();return}}else{const $=j.name.lastIndexOf(".");if($>=0){const z=j.name.substring($+1);z&&r.set(z,(r.get(z)??0)+1)}for(const z of l)z.relativePathPattern?.test(ne)!==!1&&z.filePattern.test(j.name)&&s.set(z.tag,(s.get(z.tag)??0)+1);if(--ee==0){oe();return}}})}const S={count:0,maxReached:!1};await m(u,u,i,S);const D=await h(u);return{configFiles:v(s),fileTypes:v(r),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=E;function v(u){return[...L.Iterable.map(u.entries(),([i,l])=>({name:i,count:l}))].sort((i,l)=>l.count-i.count)}function c(){const u={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},i=p.cpus();return i&&i.length>0&&(u.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),u}e.getMachineInfo=c;async function h(u){try{const i=new Map,l=(0,b.join)(u,".vscode","launch.json"),r=await t.Promises.readFile(l),s=[],o=(0,k.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${l}`),[];if((0,k.getNodeType)(o)==="object"&&o.configurations)for(const m of o.configurations){const S=m.type;S&&(i.has(S)?i.set(S,i.get(S)+1):i.set(S,1))}return v(i)}catch(i){return[]}}e.collectLaunchConfigs=h;let a=class{constructor(i,l){this.telemetryService=i,this.productService=l}formatMachineInfo(i){const l=[];return l.push(`OS Version:       ${i.os}`),l.push(`CPUs:             ${i.cpus}`),l.push(`Memory (System):  ${i.memory}`),l.push(`VM:               ${i.vmHint}`),l.join(`
`)}formatEnvironment(i){const l=[];l.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),l.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const r=p.cpus();return r&&r.length>0&&l.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),l.push(`Memory (System):  ${(p.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||l.push(`Load (avg):       ${p.loadavg().map(s=>Math.round(s)).join(", ")}`),l.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),l.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),l.push(`Process Argv:     ${i.mainArguments.join(" ")}`),l.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),l.join(`
`)}async getPerformanceInfo(i,l){return Promise.all([(0,P.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[s,o]=r,m=this.formatProcessList(i,s);return l.forEach(S=>{if((0,I.isRemoteDiagnosticError)(S))m+=`
${S.errorMessage}`,o+=`
${S.errorMessage}`;else if(m+=`

Remote: ${S.hostName}`,S.processes&&(m+=`
${this.formatProcessList(i,S.processes)}`),S.workspaceMetadata){o+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const R=S.workspaceMetadata[D];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),o+=`|    Folder (${D}): ${T}`,o+=this.formatWorkspaceStats(R)}}}),{processInfo:m,workspaceInfo:o}})}async getSystemInfo(i,l){const{memory:r,vmHint:s,os:o,cpus:m}=c(),S={os:o,memory:r,cpus:m,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:l};return n.isWindows||(S.load=`${p.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(i,l){const r=[];return(0,P.listProcesses)(i.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,s)),i.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),l.forEach(o=>{if((0,I.isRemoteDiagnosticError)(o))r.push(`
${o.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${o.hostName}`),r.push(this.formatMachineInfo(o.machineInfo)),o.processes&&r.push(this.formatProcessList(i,o.processes)),o.workspaceMetadata)for(const m of Object.keys(o.workspaceMetadata)){const S=o.workspaceMetadata[m];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${m}): ${D}`),r.push(this.formatWorkspaceStats(S))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const l=[],r=60;let s=0;const o=(R,T)=>{const C=` ${R}(${T})`;s+C.length>r?(l.push(m),m="|                 ",s=m.length):s+=C.length,m+=C};let m="|      File types:";const S=10;let D=i.fileTypes.length>S?S:i.fileTypes.length;for(let R=0;R<D;R++){const T=i.fileTypes[R];o(T.name,T.count)}if(l.push(m),i.configFiles.length>=0&&(m="|      Conf files:",s=0,i.configFiles.forEach(R=>{o(R.name,R.count)}),l.push(m)),i.launchConfigFiles.length>0){let R="|      Launch Configs:";i.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),l.push(R)}return l.join(`
`)}expandGPUFeatures(i){const l=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(l-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const l=[],r=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(l.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const m=f.URI.revive(o);if(m.scheme===M.Schemas.file){const S=m.fsPath;r.push(E(S,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),l.push(`|    Folder (${(0,b.basename)(S)}): ${R}`),l.push(this.formatWorkspaceStats(D))}).catch(D=>{l.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else l.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>l.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,l){const r=new Map;i.windows.forEach(o=>r.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),l&&this.formatProcessItem(i.mainPID,r,s,l,0),s.join(`
`)}formatProcessItem(i,l,r,s,o){const m=o===0;let S;m?S=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(S=`${S} (${l.get(s.pid)})`));const D=process.platform==="win32"?s.mem:p.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(i,l,r,R,o+1))}async reportWorkspaceStats(i){for(const{uri:l}of i.folders){const r=f.URI.revive(l);if(r.scheme!==M.Schemas.file)continue;const s=r.fsPath;try{const o=await E(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),o.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),o.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),o.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};a=ue([ie(0,g.ITelemetryService),ie(1,d.IProductService)],a),e.DiagnosticsService=a}),define(Z[199],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(M){this.appender=M}listen(M,b){throw new Error(`Event not found: ${b}`)}call(M,b,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(M){this.channel=M}log(M,b){return this.channel.call("log",{eventName:M,data:b}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[60],x([0,1,44,13,16,29]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,c){return Promise.resolve(void 0)}publicLog2(v,c){return this.publicLog(v,c)}publicLogError(v,c){return Promise.resolve(void 0)}publicLogError2(v,c){return this.publicLogError(v,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class n{async publicLog(v,c,h){}async publicLogError(v,c,h){}}e.NullEndpointTelemetryService=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(E,v){return v.onDidChangeConfiguration(c=>{c.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(c.source),configurationKeys:d(c.sourceConfig)})})}e.configurationTelemetry=f;function w(E,v){return!(v.disableTelemetry||!E.enableTelemetry)}e.supportsTelemetry=w;function t(E){const v=E.getValue(M.TELEMETRY_SETTING_ID),c=E.getValue(M.TELEMETRY_OLD_SETTING_ID);if(c!==void 0&&c===!1)return 0;switch(v??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}e.getTelemetryLevel=t;function P(E){const v=Object.create(null),c=Object.create(null),h=Object.create(null);y(E,h);for(let a in h){a=a.length>150?a.substr(a.length-149):a;const u=h[a];typeof u=="number"?c[a]=u:typeof u=="boolean"?c[a]=u?1:0:typeof u=="string"?v[a]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(v[a]=u)}return{properties:v,measurements:c}}e.validateTelemetryData=P;function I(E){if(!E)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{E.indexOf(`${h}+`)===0&&(v=h)}),v}e.cleanRemoteAuthority=I;function y(E,v,c=0,h){if(!!E)for(let a of Object.getOwnPropertyNames(E)){const u=E[a],i=h?h+a:a;Array.isArray(u)?v[i]=(0,p.safeStringify)(u):u instanceof Date?v[i]=u.toISOString():(0,L.isObject)(u)?c<2?y(u,v,c+1,i+"."):v[i]=(0,p.safeStringify)(u):v[i]=u}}function d(E){if(!E)return[];const v=[];return g(v,"",E),v}function g(E,v,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(h=>g(E,v?`${v}.${h}`:h,c[h])):E.push(v)}}),define(Z[200],x([0,1,30,23,17,44,3,33,7,16,48,168,171,162,20,6,21,50,194,97,29,60]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=b.isWeb?"web":(0,P.getTargetPlatform)(b.platform,n.arch);var l;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(l||(l={}));function r(..._){return String(_.reduce((N,Q)=>N|Q,0))}var s;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class R{constructor(N=D){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Q=this.state.pageSize){return new R({...this.state,pageNumber:N,pageSize:Q})}withFilter(N,...Q){const J=[...this.state.criteria,...Q.length?Q.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new R({...this.state,criteria:J})}withSortBy(N){return new R({...this.state,sortBy:N})}withSortOrder(N){return new R({...this.state,sortOrder:N})}withFlags(...N){return new R({...this.state,flags:N.reduce((Q,J)=>Q|J,0)})}withAssetTypes(...N){return new R({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le,flags:te,assetTypes:ae}=this.state;return{filters:[{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le}],assetTypes:ae,flags:te}}get searchText(){const N=this.state.criteria.filter(Q=>Q.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(_,N){const Q=(_||[]).filter(J=>J.statisticName===N)[0];return Q?Q.value:0}function C(_){const N="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(J=>J.assetType.indexOf(N)===0).reduce((J,re)=>{const le=K(_,re.assetType);return le&&J.push([re.assetType.substring(N.length),le]),J},[])}function G(_){if(_.properties){const N=_.properties.filter(re=>re.key===o.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=N.filter(re=>Q.test(re.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return K(_,o.Repository)}function ne(_){return{uri:`${_.fallbackAssetUri}/${o.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${o.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function oe(_){const N=K(_,o.Icon);if(N)return N;const Q=P.DefaultIconPath;return{uri:Q,fallbackUri:Q}}function K(_,N){return _.files.filter(J=>J.assetType===N)[0]?{uri:`${_.assetUri}/${N}`,fallbackUri:`${_.fallbackAssetUri}/${N}`}:null}function ee(_,N){const Q=_.properties?_.properties.filter(re=>re.key===N):[],J=Q.length>0&&Q[0].value;return J?J.split(",").map(re=>(0,I.adoptToGalleryExtensionId)(re)):[]}function O(_){const N=_.properties?_.properties.filter(Q=>Q.key===m.Engine):[];return N.length>0&&N[0].value||""}function j(_){const N=_.properties?_.properties.filter(J=>J.key===m.LocalizedLanguages):[],Q=N.length>0&&N[0].value||"";return Q?Q.split(","):[]}function $(_){return _.indexOf("preview")!==-1}function z(_){return _.targetPlatform?(0,P.toTargetPlatform)(_.targetPlatform):"undefined"}function H(_){const N=(0,p.distinct)(_.versions.map(z)),Q=!!_.tags?.includes(P.WEB_EXTENSION_TAG),J=N.indexOf("web");return Q?J===-1&&N.push("web"):J!==-1&&N.splice(J,1),N}function W(_,N){const Q=(0,P.getFallbackTargetPlarforms)(N);for(let J=0;J<_.length;J++){const re=_[J];if(re.version===_[J-1]?.version){let le=J;const te=z(re);if(te===N)for(;le>0&&_[le-1].version===re.version;)le--;else if(Q.includes(te))for(;le>0&&_[le-1].version===re.version&&z(_[le-1])!==N;)le--;le!==J&&(_.splice(J,1),_.splice(le,0,re))}}return _}e.sortExtensionVersions=W;function q(_,N,Q,J,re){const le=H(_);let te=_.versions[0];return te=_.versions.find(ae=>ae.version===te.version&&(0,P.isTargetPlatformCompatible)(z(ae),le,re))||te,U(_,te,le,N,Q,J)}function U(_,N,Q,J,re,le){const te={manifest:K(N,o.Manifest),readme:K(N,o.Details),changelog:K(N,o.Changelog),license:K(N,o.License),repository:G(N),download:ne(N),icon:oe(N),coreTranslations:C(N)};return{identifier:{id:(0,I.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:N.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:T(_.statistics,"install"),rating:T(_.statistics,"averagerating"),ratingCount:T(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:Q,assets:te,properties:{dependencies:ee(N,m.Dependency),extensionPack:ee(N,m.ExtensionPack),engine:O(N),localizedLanguages:j(N),targetPlatform:z(N)},preview:$(_.flags),telemetryData:{index:(re.pageNumber-1)*re.pageSize+J,querySource:le}}}let A=class{constructor(N,Q,J,re,le,te,ae,ge){this.requestService=Q,this.logService=J,this.environmentService=re,this.telemetryService=le,this.fileService=te,this.productService=ae,this.configurationService=ge;const fe=ae.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=Y(ae.version,ae,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Q){const J=[];let re=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,N.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...N.map(({id:te})=>te.toLowerCase()));N.every(te=>!te.version)&&(re=re.withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties,l.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(re,i,L.CancellationToken.None);for(let te=0;te<le.length;te++){const ae=le[te];if(!ae.versions.length)continue;const ge=(0,I.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),fe=N.find(de=>(0,I.areSameExtensions)(de,{id:ge}))?.version;if(fe){const de=ae.versions.find(Pe=>Pe.version===fe);de&&J.push(U(ae,de,H(ae),te,re))}else J.push(q(ae,te,re,void 0,i))}return J}async getCompatibleExtension(N,Q){const J=(0,P.isIExtensionIdentifier)(N)?null:N;if(J){if((0,P.isNotWebExtensionInWebTargetPlatform)(J.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(J,Q))return J}const{id:re,uuid:le}=J?J.identifier:N;let te=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?te=te.withFilter(s.ExtensionId,le):te=te.withFilter(s.ExtensionName,re);const{galleryExtensions:ae}=await this.queryGallery(te,Q,L.CancellationToken.None),[ge]=ae;if(!ge||!ge.versions.length)return null;const fe=H(ge);if((0,P.isNotWebExtensionInWebTargetPlatform)(fe,Q))return null;for(let de of ge.versions){if(!O(de)){const Pe=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:m.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(de,fe,Q))return U(ge,de,fe,0,te)}return null}async isExtensionCompatible(N,Q){if(!(0,P.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Q))return!1;let J=N.properties.engine;if(!J){const re=await this.getManifest(N,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");J=re.engines.vscode}return(0,y.isEngineValid)(J,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Q,J){if(!(0,P.isTargetPlatformCompatible)(z(N),Q,J))return!1;const re=await this.getEngine(N);return(0,y.isEngineValid)(re,this.productService.version,this.productService.date)}async query(N,Q){const J=L.CancellationToken.isCancellationToken(N)?{}:N,re=L.CancellationToken.isCancellationToken(N)?N:Q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=J.text||"";const te=(0,M.getOrDefault)(J,pe=>pe.pageSize,50);let ae=new R().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,te).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(ae=ae.withFilter(s.Category,be||me),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(ae=ae.withFilter(s.Tag,be||me),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(s.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),ae=ae.withFilter(s.SearchText,le)),ae=ae.withSortBy(0)):J.ids?ae=ae.withFilter(s.ExtensionId,...J.ids):J.names?ae=ae.withFilter(s.ExtensionName,...J.names):ae=ae.withSortBy(4),typeof J.sortBy=="number"&&(ae=ae.withSortBy(J.sortBy)),typeof J.sortOrder=="number"&&(ae=ae.withSortOrder(J.sortOrder));const{galleryExtensions:ge,total:fe}=await this.queryGallery(ae,i,re),de=ge.map((pe,me)=>q(pe,me,ae,J.source,i)),Pe=async(pe,me)=>{if(me.isCancellationRequested)throw(0,k.canceled)();const be=ae.withPage(pe+1),{galleryExtensions:ke}=await this.queryGallery(be,i,me);return ke.map((Ae,Ue)=>q(Ae,Ue,be,J.source,i))};return{firstPage:de,total:fe,pageSize:ae.pageSize,getPage:Pe}}async queryGallery(N,Q,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,l.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(l.Unpublished));const re=await this.commonHeadersPromise,le=JSON.stringify(N.raw),te={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},ae=new Date().getTime();let ge,fe,de=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:te},J),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:de};const Pe=await(0,v.asJson)(ge);if(Pe){const pe=Pe.results[0],me=pe.extensions;me.forEach(ke=>W(ke.versions,Q));const be=pe.resultMetadata&&pe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return de=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:de}}return{galleryExtensions:[],total:de}}catch(Pe){throw fe=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-ae,success:!!ge&&(0,v.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:fe?(0,k.isPromiseCanceledError)(fe)?"canceled":(0,k.getErrorMessage)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(N,Q,J,re){if(!this.isEnabled())return;const le=b.isWeb?this.api(`/itemName/${N}.${Q}/version/${J}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Q}/${J}/stats?statType=${re}`),te=b.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:te};try{await this.requestService.request({type:"POST",url:le,headers:ge},L.CancellationToken.None)}catch(fe){}}async download(N,Q,J){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,I.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),te=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:de}),ae=J===1?"install":J===2?"update":"",ge=ae?{uri:`${N.assets.download.uri}${f.URI.parse(N.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${N.assets.download.fallbackUri}${f.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:N.assets.download,fe=await this.getAsset(ge);await this.fileService.writeFile(Q,fe.stream),te(new Date().getTime()-le)}async getReadme(N,Q){if(N.assets.readme){const J=await this.getAsset(N.assets.readme,{},Q);return await(0,v.asText)(J)||""}return""}async getManifest(N,Q){if(N.assets.manifest){const J=await this.getAsset(N.assets.manifest,{},Q),re=await(0,v.asText)(J);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(N,Q){const J=K(N,o.Manifest);if(!J)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.getAsset(J,{headers:re});return await(0,v.asJson)(le)}async getCoreTranslation(N,Q){const J=N.assets.coreTranslations.filter(re=>re[0]===Q.toUpperCase())[0];if(J){const re=await this.getAsset(J[1]),le=await(0,v.asText)(re);return le?JSON.parse(le):null}return null}async getChangelog(N,Q){if(N.assets.changelog){const J=await this.getAsset(N.assets.changelog,{},Q);return await(0,v.asText)(J)||""}return""}async getAllCompatibleVersions(N,Q){let J=new R().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?J=J.withFilter(s.ExtensionId,N.identifier.uuid):J=J.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:re}=await this.queryGallery(J,Q,L.CancellationToken.None);if(!re.length)return[];const le=H(re[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(le,Q))return[];const te=[];for(const ae of re[0].versions)try{te[te.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,le,Q)&&te.push({version:ae.version,date:ae.lastUpdated})}catch(ge){}return te}async getAsset(N,Q={},J=L.CancellationToken.None){const re=await this.commonHeadersPromise,le={type:"GET"},te={...re,...Q.headers||{}};Q={...Q,...le,headers:te};const ae=N.uri,ge=N.fallbackUri,fe={...Q,url:ae};try{const de=await this.requestService.request(fe,J);if(de.res.statusCode===200)return de;const Pe=await(0,v.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Pe}`)}catch(de){if((0,k.isPromiseCanceledError)(de))throw de;const Pe=(0,k.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Pe});const pe={...Q,url:ge};return this.requestService.request(pe,J)}}async getEngine(N){let Q=O(N);if(!Q){const J=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");Q=J.engines.vscode}return Q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,v.asJson)(N),J=new Map;if(Q)for(const re of Q.malicious){const le=J.get(re)||{id:{id:re},malicious:!0,slow:!1};le.malicious=!0,J.set(re,le)}return[...J.values()]}};A=ue([ie(1,v.IRequestService),ie(2,g.ILogService),ie(3,t.IEnvironmentService),ie(4,a.ITelemetryService),ie(5,d.IFileService),ie(6,E.IProductService),ie(7,w.IConfigurationService)],A);let F=class extends A{constructor(N,Q,J,re,le,te,ae,ge){super(N,Q,J,re,le,te,ae,ge)}};F=ue([ie(0,h.IStorageService),ie(1,v.IRequestService),ie(2,g.ILogService),ie(3,t.IEnvironmentService),ie(4,a.ITelemetryService),ie(5,d.IFileService),ie(6,E.IProductService),ie(7,w.IConfigurationService)],F),e.ExtensionGalleryService=F;let B=class extends A{constructor(N,Q,J,re,le,te,ae){super(void 0,N,Q,J,re,le,te,ae)}};B=ue([ie(0,v.IRequestService),ie(1,g.ILogService),ie(2,t.IEnvironmentService),ie(3,a.ITelemetryService),ie(4,d.IFileService),ie(5,E.IProductService),ie(6,w.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B;async function Y(_,N,Q,J,re,le){const te={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},ae=await(0,c.getServiceMachineId)(Q,re,le);return(0,u.supportsTelemetry)(N,Q)&&(0,u.getTelemetryLevel)(J)===3&&(te["X-Market-User-Id"]=ae),te}e.resolveMarketplaceHeaders=Y}),define(Z[201],x([0,1,2,44,3,25,147,16,49,45,38,29,60]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(E,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(c=>{const h=/^[a-f0-9]+$/i.test(c["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(E,v){this._experimentProperties[E]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,I.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let v=E.sessionID,c=E["common.instanceId"],h=E["common.machineId"],a=E["common.firstSessionDate"],u=E["common.msftInternal"];return{sessionId:v,instanceId:c,machineId:h,firstSessionDate:a,msftInternal:u}}dispose(){this._disposables.dispose()}_log(E,v,c,h){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(a=>{c=(0,L.mixin)(c,a),c=(0,L.mixin)(c,this._experimentProperties),c=(0,L.cloneAndChange)(c,u=>{if(typeof u=="string")return this._cleanupInfo(u,h)}),this._appenders.forEach(u=>u.log(E,c))},a=>{console.error(a)})}publicLog(E,v,c){return this._log(E,3,v,c)}publicLog2(E,v,c){return this.publicLog(E,v,c)}publicLogError(E,v){return this.sendErrorTelemetry?this._log(E,2,v,!0):Promise.resolve(void 0)}publicLogError2(E,v){return this.publicLogError(E,v)}_anonymizeFilePaths(E){let v=E;const c=[];for(let i of this._cleanupPatterns)for(;;){const l=i.exec(E);if(!l)break;c.push([l.index,i.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(v="";;){const i=a.exec(E);if(!i)break;!h.test(i[0])&&c.every(([l,r])=>i.index<l||i.index>=r)&&(v+=E.substring(u,i.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<E.length&&(v+=E.substr(u)),v}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const v=E.toLowerCase(),c=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":c.test(v)?"<REDACTED: email>":E}_cleanupInfo(E,v){let c=E;v&&(c=this._anonymizeFilePaths(c));for(let h of this._cleanupPatterns)c=c.replace(h,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ue([ie(1,n.IConfigurationService)],y),e.TelemetryService=y;const d=k.isWeb?"":" "+(0,b.localize)(0,null);t.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(1,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,b.localize)(2,null),(0,b.localize)(3,null),(0,b.localize)(4,null)],markdownDescription:w.default.privacyStatementUrl?(0,b.localize)(6,null,w.default.nameLong,w.default.privacyStatementUrl)+d:(0,b.localize)(5,null,w.default.nameLong)+d,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),t.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(7,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,b.localize)(9,null,w.default.nameLong,w.default.privacyStatementUrl):(0,b.localize)(8,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(10,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[202],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[203],x([0,1,108,4,2,5,38,202]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(E){function v(c){return c&&typeof c=="object"&&typeof c.id=="string"}E.isThemeColor=v})(f=e.ThemeColor||(e.ThemeColor={}));function w(E){return{id:E}}e.themeColorFromId=w;var t;(function(E){function v(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||f.isThemeColor(l.color))}E.isThemeIcon=v;const c=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function h(l){const r=c.exec(l);if(!r)return;let[,s]=r;return{id:s}}E.fromString=h;function a(l,r){let s=l.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),r&&(s=`${s}~${r}`),{id:s}}E.modify=a;function u(l,r){return l.id===r.id&&l.color?.id===r.color?.id}E.isEqual=u;function i(l,r){return{id:l.id,color:r?w(r):void 0}}E.asThemeIcon=i,E.asClassNameArray=p.CSSIcon.asClassNameArray,E.asClassName=p.CSSIcon.asClassName,E.asCSSSelector=p.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function P(E){switch(E){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,k.toDisposable)(()=>{const c=this.themingParticipants.indexOf(v);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new I;b.Registry.add(e.Extensions.ThemingContribution,y);function d(E){return y.onColorThemeChange(E)}e.registerThemingParticipant=d;class g extends k.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,c){let h=this.theme.getColor(v);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(Z[61],x([0,1,14,3,5,39]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const b="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",t="themeBackground",P="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let I=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(t,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=g==="hc-black"?f:g==="vs"?b:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:P,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const E of p.BrowserWindow.getAllWindows())if(E.id===d){E.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};I=ue([ie(0,M.IStateMainService)],I),e.ThemeMainService=I}),define(Z[42],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,b)=>({type:"idle",updateType:M,error:b}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[204],x([0,1,3,148,49,38]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[205],x([0,1,4,42]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[98],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[206],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(p.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,w,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const P=p.URI.revive(w);if(P&&P.query){const I=/\bwindowId=(\d+)/.exec(P.query);if(I){const y=I[1],d=new RegExp(`window:${y}`),g=n.connections.find(E=>d.test(E.ctx));if(g)return g}}}return this.next.routeCall(n,f,w,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(Z[207],x([0,1,9,2,7,21]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class b extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const P=[...this.handlers.values()];return(0,p.first)(P.map(I=>()=>I.handleURL(w,t)),void 0,!1).then(I=>I||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=b;let n=class extends b{constructor(w){super();this.productService=w}create(w){let{authority:t,path:P,query:I,fragment:y}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&P&&P.indexOf("/")!==0&&(P=`/${P}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:P,query:I,fragment:y})}};n=ue([ie(0,M.IProductService)],n),e.NativeURLService=n}),define(Z[208],x([0,1,14,9,4,2,3,7]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(P){return null}}class w{constructor(P,I,y,d,g){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=P,b.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),p.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,c)}const E=k.Event.map(k.Event.fromNodeEventEmitter(p.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(E(c=>{const h=f(c);!h||this.urlService.open(h,{originalUrl:c})})),y.getWindows().filter(c=>c.isReady).length>0?this.flush():k.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||P.push(I);P.length!==0&&(this.uris=P,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Z[209],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[210],x([0,1,14,2,10,7]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class b extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const t=M.URI.parse(f.url),P=b.validWebviewFilePaths.get(t.path);if(typeof P=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${P}`,y=k.FileAccess.asFileUri(I,V);return w(decodeURIComponent(y.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=b,b.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[62],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function k(w){return!!w.folderUri}e.isFolderToOpen=k;function M(w){return!!w.fileUri}e.isFileToOpen=M;function b(w){const t=n(w),P=w.getValue("window.menuBarVisibility");return P==="default"||t==="native"&&P==="compact"||p.isMacintosh&&p.isNative?"classic":P}e.getMenuBarVisibility=b;function n(w){if(p.isWeb)return"custom";const t=w.getValue("window");if(t){if(p.isMacintosh&&t.nativeTabs===!0||p.isMacintosh&&t.nativeFullScreen===!1)return"native";const y=t.titleBarStyle;if(y==="native"||y==="custom")return y}return p.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Z[36],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const b=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=b;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[211],x([0,1,14,4,2,210,36]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let P;if(typeof w.windowId=="number"){const{windowId:I}=w,y=this.windowsMainService.getWindowById(I);if(!y?.win)throw new Error(`Invalid windowId: ${I}`);P=y.win.webContents}else{const{webContentsId:I}=w;if(P=p.webContents.fromId(I),!P)throw new Error(`Invalid webContentsId: ${I}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,P,I){const y=this.getFrameByName(w,t),d=y;if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:I.findNext,forward:I.forward});const g=(E,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),y.removeListener("found-in-frame",g))};y.on("found-in-frame",g)}}async stopFindInFrame(w,t,P){const y=this.getFrameByName(w,t);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const I=P.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===t);if(!I)throw new Error(`Unknown frame: ${t}`);return I}};n=ue([ie(0,b.IWindowsMainService)],n),e.WebviewMainService=n}),define(Z[212],x([0,1,9,4,2]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch(P){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[213],x([0,1,37,15,7,5]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var b;(function(I){I[I.EMPTY=1]="EMPTY",I[I.FOLDER=2]="FOLDER",I[I.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function n(I){const y=I;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function f(I){const y=I;return!!(y&&typeof y=="object"&&k.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(y,d,g,E,v){this._id=y,this._transient=g,this._configuration=E,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._transient=y.transient,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class t{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function P(I){return new t({uri:I,index:0,name:(0,L.basenameOrAuthority)(I)},{uri:I.toString()})}e.toWorkspaceFolder=P}),define(Z[27],x([0,1,31,40,77,34,10,8,3,15,7,151,5,74,213]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(O){return(typeof O=="string"?(0,n.extname)(O):(0,w.extname)(O))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function v(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function c(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=h;function a(O){const j=O;return typeof j?.id=="string"&&t.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=a;function u(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=u;function i(O){const j=O;return typeof j?.id=="string"&&t.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=i;function l(O){const j=O;if(j?.uri)return{id:j.id,uri:t.URI.revive(j.uri)};const $=O;if($?.configPath)return{id:$.id,configPath:t.URI.revive($.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=l;function r(O,j){return w.extUriBiasedIgnorePathCase.isEqualOrParent(O,j.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(O){return o(O)||m(O)}e.isStoredWorkspaceFolder=s;function o(O){const j=O;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=o;function m(O){const j=O;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=m;function S(O,j,$,z,H=!f.isWindows,W){if(O.scheme!==z.scheme)return{name:$,uri:O.toString(!0)};let q=j?void 0:W.relativePath(z,O);if(q!==void 0)q.length===0?q=".":f.isWindows&&O.scheme===b.Schemas.file&&!H&&(q=q.replace(/\//g,"\\"));else if(O.scheme===b.Schemas.file)q=O.fsPath,f.isWindows&&(q=(0,M.normalizeDriveLetter)(q),H&&(q=(0,p.toSlashes)(q)));else{if(!W.isEqualAuthority(O.authority,z.authority))return{name:$,uri:O.toString(!0)};q=O.path}return{name:$,path:q}}e.getStoredWorkspaceFolder=S;function D(O,j,$){let z=[],H=new Set;const W=$.dirname(j);for(let q of O){let U;if(o(q))q.path&&(U=$.resolvePath(W,q.path));else if(m(q))try{U=t.URI.parse(q.uri),U.path[0]!=="/"&&(U=U.with({path:"/"+U.path}))}catch(A){console.warn(A)}if(U){let A=$.getComparisonKey(U);if(!H.has(A)){H.add(A);const F=q.name||$.basenameOrAuthority(U);z.push(new d.WorkspaceFolder({uri:U,name:F,index:z.length},q))}}}return z}e.toWorkspaceFolders=D;function R(O,j,$,z,H){let W=T(j,O);const q=H.dirname(j),U=H.dirname(z),A=[],F=C(W.folders);for(const N of W.folders){const Q=o(N)?H.resolvePath(q,N.path):t.URI.parse(N.uri);let J;$?J=!1:J=!o(N)||(0,n.isAbsolute)(N.path),A.push(S(Q,J,N.name,U,F,H))}const B={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},Y=k.setProperty(O,["folders"],A,B);let _=k.applyEdits(O,Y);return W.remoteAuthority===(0,y.getRemoteAuthority)(z)&&(_=k.applyEdits(_,k.removeProperty(_,["remoteAuthority"],B))),_}e.rewriteWorkspaceFileForNewLocation=R;function T(O,j){let $=L.parse(j);if($&&Array.isArray($.folders))$.folders=$.folders.filter(z=>s(z));else throw new Error(`${O} looks like an invalid workspace file.`);return $}function C(O){return f.isWindows?O.some(j=>o(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function G(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function ne(O){return typeof O.folderUri=="string"}function oe(O){return typeof O.fileUri=="string"}function K(O,j){const $={workspaces:[],files:[]};if(O){const z=function(W,q){for(let U=0;U<W.length;U++)try{q(W[U],U)}catch(A){j.warn(`Error restoring recent entry ${JSON.stringify(W[U])}: ${A.toString()}. Skip entry.`)}},H=O;if(Array.isArray(H.entries))z(H.entries,W=>{const q=W.label,U=W.remoteAuthority;G(W)?$.workspaces.push({label:q,remoteAuthority:U,workspace:{id:W.workspace.id,configPath:t.URI.parse(W.workspace.configPath)}}):ne(W)?$.workspaces.push({label:q,remoteAuthority:U,folderUri:t.URI.parse(W.folderUri)}):oe(W)&&$.files.push({label:q,remoteAuthority:U,fileUri:t.URI.parse(W.fileUri)})});else{const W=O;Array.isArray(W.workspaces3)&&z(W.workspaces3,(q,U)=>{const A=Array.isArray(W.workspaceLabels)&&W.workspaceLabels[U]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?$.workspaces.push({label:A,workspace:{id:q.id,configPath:t.URI.parse(q.configURIPath)}}):typeof q=="string"&&$.workspaces.push({label:A,folderUri:t.URI.parse(q)})}),Array.isArray(W.files2)&&z(W.files2,(q,U)=>{const A=Array.isArray(W.fileLabels)&&W.fileLabels[U]||void 0;typeof q=="string"&&$.files.push({label:A,fileUri:t.URI.parse(q)})})}}return $}e.restoreRecentlyOpened=K;function ee(O){const j={entries:[]};for(const $ of O.workspaces)c($)?j.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):j.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of O.files)j.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return j}e.toStoreData=ee}),define(Z[51],x([0,1,5,27]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function k(M){const b=M;return b&&(0,L.isWorkspaceIdentifier)(b.workspace)}e.isWorkspaceBackupInfo=k}),define(Z[52],x([0,1,14,9,80,34,2,66,8,3,13,19,133,5,6,39,27]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let v=class gt{constructor(h,a){this.stateMainService=h,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,a){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},a)}pickFolder(h,a){return this.doPick({...h,pickFolders:!0,title:(0,I.localize)(1,null)},a)}pickFile(h,a){return this.doPick({...h,pickFiles:!0,title:(0,I.localize)(2,null)},a)}pickWorkspace(h,a){const u=(0,I.localize)(3,null),i=(0,M.mnemonicButtonLabel)((0,I.localize)(4,null)),l=E.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:u,filters:l,buttonLabel:i},a)}async doPick(h,a){const u={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};u.defaultPath=h.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(u.properties=void 0,h.pickFiles&&h.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&u.properties.push("treatPackageAsDirectory");const i=a||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(u,(0,t.withNullAsUndefined)(i));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(h){if(h){let a=this.windowDialogQueues.get(h.id);return a||(a=new L.Queue,this.windowDialogQueues.set(h.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(h,a){return this.getWindowDialogQueue(a).queue(async()=>a?p.dialog.showMessageBox(a,h):p.dialog.showMessageBox(h))}async showSaveDialog(h,a){const u=this.acquireFileDialogLock(h,a);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let i;return a?i=await p.dialog.showSaveDialog(a,h):i=await p.dialog.showSaveDialog(h),i.filePath=this.normalizePath(i.filePath),i})}finally{(0,b.dispose)(u)}}normalizePath(h){return h&&w.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(a=>this.normalizePath(a))}async showOpenDialog(h,a){h.defaultPath&&(await P.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const u=this.acquireFileDialogLock(h,a);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let i;return a?i=await p.dialog.showOpenDialog(a,h):i=await p.dialog.showOpenDialog(h),i.filePaths=this.normalizePaths(i.filePaths),i})}finally{(0,b.dispose)(u)}}acquireFileDialogLock(h,a){if(!a)return b.Disposable.None;let u=this.windowFileDialogLocks.get(a.id);u||(u=new Set,this.windowFileDialogLocks.set(a.id,u));const i=(0,k.hash)(h);if(!u.has(i))return u.add(i),(0,b.toDisposable)(()=>{u?.delete(i),u?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([ie(0,g.IStateMainService),ie(1,d.ILogService)],v),e.DialogMainService=v}),define(Z[214],x([0,1,4,2,27]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(t=>{const P=this.storageMainService.globalStorage.get(t.key);typeof P=="string"?f.set(t.key,P):w.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const t=(0,k.reviveIdentifier)(w.workspace),P=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(P.items.entries());case"updateItems":{const I=w;if(I.insert)for(const[y,d]of I.insert)P.set(y,d);I.delete&&I.delete.forEach(y=>P.delete(y));break}case"close":{if(t)return P.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[215],x([0,1,4,2,8,28,19,86,123,6,97,29,27]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends L.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(v);const c=v.getBoolean(t.IS_NEW_KEY);c===void 0?v.set(t.IS_NEW_KEY,!0):c&&v.set(t.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,c){return this.storage.get(v,c)}set(v,c){return this.storage.set(v,c)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(v,c,h){super(c);this.options=v,this.environmentService=h}async doCreate(){let v;return this.options.useInMemoryStorage?v=f.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,k.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(P.instanceStorageKey,void 0)===void 0&&v.set(P.instanceStorageKey,(0,M.generateUuid)()),v.get(P.firstSessionDateStorageKey,void 0)===void 0&&v.set(P.firstSessionDateStorageKey,new Date().toUTCString());const a=v.get(P.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();v.set(P.lastSessionDateStorageKey,typeof a=="undefined"?null:a),v.set(P.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends y{constructor(v,c,h,a){super(h);this.workspace=v,this.options=c,this.environmentService=a}async doCreate(){const{storageFilePath:v,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,k.join)(v,g.WORKSPACE_STORAGE_NAME);return await b.Promises.exists(v)?{storageFilePath:c,wasCreated:!1}:(await b.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let c;if((0,I.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,I.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=(0,k.join)(v,g.WORKSPACE_META_NAME);await b.Promises.exists(h)||await b.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[99],x([0,1,43,2,48,5,22,6,215]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(P,I,y){super();this.logService=P,this.environmentService=I,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async P=>{P.workspace&&this.workspaceStorage(P.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(P=>{P.join(this.globalStorage.close());for(const[,I]of this.mapWorkspaceToStorage)P.join(I.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const P=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(P.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),P}createWorkspaceStorage(P){return new f.WorkspaceStorageMain(P,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(P){let I=this.mapWorkspaceToStorage.get(P.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${P.id})`),I=this.createWorkspaceStorage(P),this.mapWorkspaceToStorage.set(P.id,I),(0,p.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${P.id})`),this.mapWorkspaceToStorage.delete(P.id)})),I}};w=ue([ie(0,n.ILogService),ie(1,k.IEnvironmentService),ie(2,b.ILifecycleMainService)],w),e.StorageMainService=w}),define(Z[100],x([0,1,15,7,27]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,w,t){for(const I of f){const y=I.openedWorkspace;if((0,k.isWorkspaceIdentifier)(y)){const d=t(y);if(d){if(d.folders.some(g=>p.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return I}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(w,y.configPath))return I}}const P=f.filter(I=>(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(w,I.openedWorkspace.uri));if(P.length)return P.sort((I,y)=>-(I.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function b(f,w){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=b;function n(f,w){const t=P=>w.some(I=>p.extUriBiasedIgnorePathCase.isEqual(L.URI.file(I),L.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(I=>t(I)))return P}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[216],x([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends L.Disposable{constructor(h,a,u,i,l){super();this.windowsMainService=h,this.stateMainService=a,this.lifecycleMainService=u,this.logService=i,this.configurationService=l,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),i&&(h.lastActiveWindow=this.toWindowState(i))}const a=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);a&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const u=E(h);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(u=>{const i=(0,I.isWorkspaceIdentifier)(h.openedWorkspace)&&u.workspace?.id===h.openedWorkspace.id,l=(0,I.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&u.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(u.folderUri,h.openedWorkspace.uri);(i||l)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(h){return{workspace:(0,I.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,I.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const a=this.doGetNewWindowState(h),u=this.configurationService.getValue("window");let i;return a.hasDefaultState?i=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(i=!1)),a.mode===3&&!i&&(a.mode=1),a}doGetNewWindowState(h){const a=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=h.workspace;if((0,I.isWorkspaceIdentifier)(o)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===o.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,I.isSingleFolderWorkspaceIdentifier)(o)){const S=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,o.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(h.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===h.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!a&&m)return m.uiState}let u;const i=p.screen.getAllDisplays();if(i.length===1)u=i[0];else{if(k.isMacintosh){const o=p.screen.getCursorScreenPoint();u=p.screen.getDisplayNearestPoint(o)}!u&&a&&(u=p.screen.getDisplayMatching(a.getBounds())),u||(u=p.screen.getPrimaryDisplay()||i[0])}let l=(0,P.defaultWindowState)();l.x=Math.round(u.bounds.x+u.bounds.width/2-l.width/2),l.y=Math.round(u.bounds.y+u.bounds.height/2-l.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")l.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")l.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?l.mode=3:l=o,s=l.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===h.x||u.y===h.y);)h.x+=30,h.y+=30;return h}};y.windowsStateStorageKey="windowsState",y=ue([ie(0,P.IWindowsMainService),ie(1,t.IStateMainService),ie(2,f.ILifecycleMainService),ie(3,w.ILogService),ie(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(c){const h={openedWindows:[]},a=c||{openedWindows:[]};return a.lastActiveWindow&&(h.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(h.openedWindows=a.openedWindows.map(u=>g(u))),h}e.restoreWindowsState=d;function g(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=b.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:b.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function E(c){return{lastActiveWindow:c.lastActiveWindow&&v(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&v(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>v(h))}}e.getWindowsStateStoreData=E;function v(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Z[101],x([0,1,58,32,10,3,15]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function t(){let P=w.scheme===k.Schemas.file?(0,b.originalFSPath)(w):w.toString();return M.isLinux||(P=P.toLowerCase()),(0,p.createHash)("md5").update(P).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,t){function P(){if(w.scheme!==k.Schemas.file)return(0,p.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(w.fsPath)}catch(d){return}let y;return M.isLinux?y=t.ino:M.isMacintosh?y=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?y=Math.floor(t.birthtimeMs):y=t.birthtime.getTime()),(0,p.createHash)("md5").update(w.fsPath).update(y?String(y):"").digest("hex")}const I=P();if(typeof I=="string")return{id:I,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[56],x([0,1,58,59,26,18,17,4,2,8,3,28,35,84,217]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(S){this.socket=S,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const D=R=>S(M.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(S){const D=R=>{S({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((S,D)=>{if(this.socket.bufferSize===0){S();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),S()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var E;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class c extends f.Disposable{constructor(S,D,R,T){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=T,D?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,b.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,b.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new y.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,D){let R=2;S.byteLength<126?R+=0:S.byteLength<2**16?R+=2:R+=8;const T=M.VSBuffer.alloc(R);if(D?T.writeUInt8(194,0):T.writeUInt8(130,0),S.byteLength<126)T.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){T.writeUInt8(126,1);let C=1;T.writeUInt8(S.byteLength>>>8&255,++C),T.writeUInt8(S.byteLength>>>0&255,++C)}else{T.writeUInt8(127,1);let C=1;T.writeUInt8(0,++C),T.writeUInt8(0,++C),T.writeUInt8(0,++C),T.writeUInt8(0,++C),T.writeUInt8(S.byteLength>>>24&255,++C),T.writeUInt8(S.byteLength>>>16&255,++C),T.writeUInt8(S.byteLength>>>8&255,++C),T.writeUInt8(S.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=T.byteLength+S.byteLength,this.socket.write(M.VSBuffer.concat([T,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),R=D.readUInt8(0),T=(R&128)>>>7,C=(R&64)>>>6,G=D.readUInt8(1),ne=(G&128)>>>7,oe=G&127;this._state.state=2,this._state.readLen=2+(ne?4:0)+(oe===126?2:0)+(oe===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(C)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),T=(R&128)>>>7;let C=R&127,G=1;C===126?C=D.readUInt8(++G)*2**8+D.readUInt8(++G):C===127&&(C=D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G));let ne=0;T&&(ne=D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G)),this._state.state=3,this._state.readLen=C,this._state.mask=ne}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);h(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(m,S){if(S===0)return;let D=m.byteLength>>>2;for(let oe=0;oe<D;oe++){const K=m.readUInt32BE(oe*4);m.writeUInt32BE(K^S,oe*4)}let R=D*4,T=m.byteLength-R;const C=S>>>24&255,G=S>>>16&255,ne=S>>>8&255;T>=1&&m.writeUInt8(m.readUInt8(R)^C,R),T>=2&&m.writeUInt8(m.readUInt8(R+1)^G,R+1),T>=3&&m.writeUInt8(m.readUInt8(R+2)^ne,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function u(){const m=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):S=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),l(S),S}e.createRandomIPCHandle=u;function i(m,S,D){const R=(0,p.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${S}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${S}.sock`):T=(0,w.join)(m,`${D}-${S}.sock`),l(T),T}e.createStaticIPCHandle=i;function l(m){const S=a[t.platform];typeof S=="number"&&m.length>=S&&console.warn(`WARNING: IPC handle "${m}" is longer than ${S} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{constructor(S){super(r.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const D=n.Event.fromNodeEventEmitter(S,"connection");return n.Event.map(D,R=>({protocol:new y.Protocol(new g(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(m){return new Promise((S,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(m,()=>{R.removeListener("error",D),S(new r(R))})})}e.serve=s;function o(m,S){return new Promise((D,R)=>{const T=(0,L.createConnection)(m,()=>{T.removeListener("error",R),D(y.Client.fromSocket(new g(T),S))});T.once("error",R)})}e.connect=o}),define(Z[218],x([0,1,56]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,t,P){return this.channel.call("click",[f,w,t,P])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,t){return this.channel.call("setValue",[f,w,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,t){return this.channel.call("getElements",[f,w,t])}getElementXY(f,w,t,P){return this.channel.call("getElementXY",[f,w,t,P])}typeInEditor(f,w,t){return this.channel.call("typeInEditor",[f,w,t])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,t){return this.channel.call("writeInTerminal",[f,w,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=M;async function b(n){const f=await(0,p.connect)(n,"driverClient"),w=f.getChannel("driver"),t=new k(w);return{client:f,driver:t}}e.connect=b}),define(Z[219],x([0,1,9,4,106,57,2,3,79,35,56,155,218,176,22,36]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function E(h){return h<21}let v=class{constructor(a,u,i,l){this.windowServer=a,this.options=u,this.windowsMainService=i,this.lifecycleMainService=l,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(a){return this.registeredWindowIds.add(a),this.reloadingWindowIds.delete(a),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(a){this.reloadingWindowIds.add(a)}async getWindowIds(){return this.windowsMainService.getWindows().map(a=>a.id).filter(a=>this.registeredWindowIds.has(a)&&!this.reloadingWindowIds.has(a))}async capturePage(a){await this.whenUnfrozen(a);const u=this.windowsMainService.getWindowById(a);if(!u?.win)throw new Error("Invalid window");return(await u.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(a){await this.whenUnfrozen(a);const u=this.windowsMainService.getWindowById(a);if(!u)throw new Error("Invalid window");this.reloadingWindowIds.add(a),this.lifecycleMainService.reload(u)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(a,u){await this.whenUnfrozen(a);const i=k.KeybindingParser.parseUserBinding(u);for(let l of i)await this._dispatchKeybinding(a,l)}async _dispatchKeybinding(a,u){if(u instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(a);if(!i?.win)throw new Error("Invalid window");const l=i.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,u.keyCode),o=new y.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),m=[];u.ctrlKey&&m.push("ctrl"),u.metaKey&&m.push("meta"),u.shiftKey&&m.push("shift"),u.altKey&&m.push("alt"),l.sendInputEvent({type:"keyDown",keyCode:o,modifiers:m}),E(u.keyCode)||l.sendInputEvent({type:"char",keyCode:o,modifiers:m}),l.sendInputEvent({type:"keyUp",keyCode:o,modifiers:m}),await(0,p.timeout)(100)}async click(a,u,i,l){await(await this.getWindowDriver(a)).click(u,i,l)}async doubleClick(a,u){await(await this.getWindowDriver(a)).doubleClick(u)}async setValue(a,u,i){await(await this.getWindowDriver(a)).setValue(u,i)}async getTitle(a){return await(await this.getWindowDriver(a)).getTitle()}async isActiveElement(a,u){return await(await this.getWindowDriver(a)).isActiveElement(u)}async getElements(a,u,i){return await(await this.getWindowDriver(a)).getElements(u,i)}async getElementXY(a,u,i,l){return await(await this.getWindowDriver(a)).getElementXY(u,i,l)}async typeInEditor(a,u,i){await(await this.getWindowDriver(a)).typeInEditor(u,i)}async getTerminalBuffer(a,u){return await(await this.getWindowDriver(a)).getTerminalBuffer(u)}async writeInTerminal(a,u,i){await(await this.getWindowDriver(a)).writeInTerminal(u,i)}async getLocaleInfo(a){return await(await this.getWindowDriver(a)).getLocaleInfo()}async getLocalizedStrings(a){return await(await this.getWindowDriver(a)).getLocalizedStrings()}async getWindowDriver(a){await this.whenUnfrozen(a);const u=`window:${a}`,i=new w.StaticRouter(r=>r===u),l=this.windowServer.getChannel("windowDriver",i);return new P.WindowDriverChannelClient(l)}async whenUnfrozen(a){for(;this.reloadingWindowIds.has(a);)await L.Event.toPromise(this.onDidReloadingChange.event)}};v=ue([ie(2,g.IWindowsMainService),ie(3,d.ILifecycleMainService)],v),e.Driver=v;async function c(h,a,u,i){const l=u.driverVerbose,r=i.createInstance(v,h,{verbose:l}),s=new I.WindowDriverRegistryChannel(r);h.registerChannel("windowDriverRegistry",s);const o=await(0,t.serve)(a),m=new I.DriverChannel(r);return o.registerChannel("driver",m),(0,b.combinedDisposable)(o,h)}e.serve=c}),define(Z[24],x([0,1,47,8,56,48,160,5]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends b.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([p.memoize],f.prototype,"cachedLanguagesPath",null),ue([p.memoize],f.prototype,"backupHome",null),ue([p.memoize],f.prototype,"backupWorkspacesPath",null),ue([p.memoize],f.prototype,"mainIPCHandle",null),ue([p.memoize],f.prototype,"mainLockfile",null),ue([p.memoize],f.prototype,"sandbox",null),ue([p.memoize],f.prototype,"driverVerbose",null),ue([p.memoize],f.prototype,"disableUpdates",null),ue([p.memoize],f.prototype,"disableKeytar",null),ue([p.memoize],f.prototype,"codeCachePath",null),ue([p.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[220],x([0,1,58,32,31,10,8,3,15,7,19,51,16,24,20,6,27]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(h,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,l)=>(0,k.isEqual)(i,l,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let a=[];try{Array.isArray(h.rootURIWorkspaces)&&(a=h.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(h.folderURIWorkspaces)&&(u=h.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,a){this.workspaces.some(i=>h.workspace.id===i.workspace.id)||(this.workspaces.push(h),this.saveSync());const u=this.getBackupPath(h.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(h,a){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(a))try{L.renameSync(a,h)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(h){const a=h.id,u=this.workspaces.findIndex(i=>i.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(a=>this.backupUriComparer.isEqual(h,a))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(h,u));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(h,a){const u=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(h){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,h));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(h){return(0,b.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const a=new Set,u=[];for(let i of h){const l=i.workspace;if(!(0,E.isWorkspaceIdentifier)(l))return[];if(!a.has(l.id)){a.add(l.id);const r=this.getBackupPath(l.id);await this.doHasBackups(r)?l.configPath.scheme!==M.Schemas.file||await t.Promises.exists(l.configPath.fsPath)?u.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return u}async validateFolders(h){if(!Array.isArray(h))return[];const a=[],u=new Set;for(let i of h){const l=this.backupUriComparer.getComparisonKey(i);if(!u.has(l)){u.add(l);const r=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(r)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?a.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const a=[],u=new Set;for(let i of h){const l=i.backupFolder;if(typeof l!="string")return[];if(!u.has(l)){u.add(l);const r=this.getBackupPath(l);await this.doHasBackups(r)?a.push(i):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(h){try{await t.Promises.exists(h)&&await t.Promises.rm(h,t.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await t.Promises.rename(h,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{L.renameSync(h,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const h=[];for(const a of this.workspaces)await this.hasBackups(a)&&h.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&h.push(a);return h}hasBackups(h){let a;return w.URI.isUri(h)?a=this.getBackupPath(this.getFolderHash(h)):(0,P.isWorkspaceBackupInfo)(h)?a=this.getBackupPath(h.workspace.id):a=h.backupFolder,this.doHasBackups(a)}async doHasBackups(h){try{const a=await t.Promises.readdir(h);for(const u of a)try{if((await t.Promises.readdir((0,b.join)(h,u))).length>0)return!0}catch(i){}}catch(a){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let a;return h.scheme===M.Schemas.file?a=n.isLinux?h.fsPath:h.fsPath.toLowerCase():a=h.toString().toLowerCase(),(0,p.createHash)("md5").update(a).digest("hex")}};v=ue([ie(0,y.IEnvironmentMainService),ie(1,I.IConfigurationService),ie(2,g.ILogService)],v),e.BackupMainService=v}),define(Z[221],x([0,1,59,56]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,b,n){const f=t=>n(t,void 0),w=p.createConnection({host:k,port:M},()=>{w.removeListener("error",f);const t=Buffer.alloc(16);for(let d=0;d<16;d++)t[d]=Math.round(Math.random()*256);const P=t.toString("base64");let I=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`];w.write(I.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",y),n(void 0,new L.NodeSocket(w)))};w.on("data",y)});w.once("error",f)}}}),define(Z[222],x([0,1,59,115,221,9,2,16,6,21,191,96,75]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(v,c,h,a,u){return new d(v,c,h,a,u).waitForReady()}class d extends b.Disposable{constructor(c,h,a,u,i){super();this.defaultTunnelHost=h,this.suggestedLocalPort=i,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=p.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let c=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(c){c.pause();const h=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,t.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),u=a.getSocket().socket,i=a.readEntireBuffer();a.dispose(),i.byteLength>0&&c.write(i.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),u.end()}),c.on("close",()=>u.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),u.destroy()}),u.on("end",()=>c.end()),u.on("close",()=>c.end()),u.on("error",()=>{c.destroy()}),c.pipe(u),u.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),u.end()})}}let g=class extends P.AbstractTunnelService{constructor(c,h,a,u,i){super(h);this.socketFactory=c,this.signService=a,this.productService=u,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,a,u,i,l,r){const s=this.getTunnelFromMap(h,a);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,a,u,i,l,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${a} on local port ${u}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},m=y(o,this.defaultTunnelHost,h,a,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,a,m),m}}};g=ue([ie(1,f.ILogService),ie(2,I.ISignService),ie(3,w.IProductService),ie(4,n.IConfigurationService)],g),e.BaseTunnelService=g;let E=class extends g{constructor(c,h,a,u){super(k.nodeSocketFactory,c,h,a,u)}};E=ue([ie(0,f.ILogService),ie(1,I.ISignService),ie(2,w.IProductService),ie(3,n.IConfigurationService)],E),e.TunnelService=E}),define(Z[223],x([0,1,193,18,17,2,13,16,48,91,6,192,217]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends M.Disposable{constructor(g,E,v){super();this.environmentService=E,this.logService=v,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,E){this.logService.trace("RequestService#request",g.url);const{proxyUrl:v,strictSSL:c}=this,h={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},a=g.agent?g.agent:await(0,P.getProxyAgent)(g.url||"",h,{proxyUrl:v,strictSSL:c});return g.agent=a,g.strictSSL=c,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,E)}async getNodeRequest(g){return((0,p.parse)(g.url).protocol==="https:"?await new Promise((c,h)=>{V(["https"],c,h)}):await new Promise((c,h)=>{V(["http"],c,h)})).request}_request(g,E){return new Promise(async(v,c)=>{let h;const a=(0,p.parse)(g.url),u=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,b.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),h=u(i,l=>{const r=(0,b.isNumber)(g.followRedirects)?g.followRedirects:3;if(l.statusCode&&l.statusCode>=300&&l.statusCode<400&&r>0&&l.headers.location)this._request({...g,url:l.headers.location,followRedirects:r-1},E).then(v,c);else{let s=l;l.headers["content-encoding"]==="gzip"&&(s=l.pipe((0,I.createGunzip)())),v({res:l,stream:(0,L.streamToBufferReadableStream)(s)})}}),h.on("error",c),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),E.onCancellationRequested(()=>{h.abort(),c((0,k.canceled)())})})}async resolveProxy(g){}};y=ue([ie(0,n.IConfigurationService),ie(1,f.INativeEnvironmentService),ie(2,t.ILogService)],y),e.RequestService=y}),define(Z[224],x([0,1,14,223]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(b){return p.net.request}class M extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(Z[225],x([0,1,14,9,4,2,10,13,85,24,22,6,45,55,61]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(v,c,h,a,u,i,l){super();this.machineId=v,this.userEnv=c,this.environmentMainService=h,this.lifecycleMainService=a,this.logService=u,this.themeMainService=i,this.protocolMainService=l,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),p.ipcMain.on("vscode:createSharedProcessMessageChannel",async(v,c)=>this.onWindowConnection(v,c))}async onWindowConnection(v,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(v.sender.isDestroyed())return h.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[h])}onWillShutdown(){const v=this.window;!v||(!v.isDestroyed()&&!v.webContents.isDestroyed()&&v.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(c){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){const v=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${v.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),v.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:I.default}),this.window.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(v,c,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:c}})))}async connect(){await this.whenIpcReady;const v=(0,n.assertIsDefined)(this.window);return(0,f.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=ue([ie(2,w.IEnvironmentMainService),ie(3,t.ILifecycleMainService),ie(4,P.ILogService),ie(5,d.IThemeMainService),ie(6,y.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[226],x([0,1,9,18,8,13,7,24,20,6]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(y,d,g){this.storagePath=y,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const g=this.storage[y];return(0,M.isUndefinedOrNull)(g)?d:g}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:g,data:E}of y)this.storage[g]!==E&&((0,M.isUndefinedOrNull)(E)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=E,d=!0));d&&this.save()}removeItem(y){(0,M.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let P=class yt{constructor(y,d,g){this.fileStorage=new t(b.URI.file((0,k.join)(y.userDataPath,yt.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=ue([ie(0,n.IEnvironmentMainService),ie(1,w.ILogService),ie(2,f.IFileService)],P),e.StateMainService=P}),define(Z[76],x([0,1,9,23,4,16,24,22,6,21,50,42]),function(V,e,p,L,k,M,b,n,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(d,g,E){return`${E.updateUrl}/api/update/${d}/${g}/${E.commit}`}e.createUpdateURL=I;let y=class{constructor(g,E,v,c,h,a){this.lifecycleMainService=g,this.configurationService=E,this.environmentMainService=v,this.requestService=c,this.logService=h,this.productService=a,this._state=P.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),E=this.getProductQuality(g);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,p.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=ue([ie(0,n.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,b.IEnvironmentMainService),ie(3,t.IRequestService),ie(4,f.ILogService),ie(5,w.IProductService)],y),e.AbstractUpdateService=y}),define(Z[227],x([0,1,14,47,4,2,16,24,22,6,21,50,29,42,76]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends d.AbstractUpdateService{constructor(v,c,h,a,u,i,l){super(v,c,a,u,i,l);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,c)=>c)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,c,h,a)=>({releaseNotes:c,version:h,productVersion:h,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(y.State.Idle(1,h))}buildUpdateFeedUrl(v){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(c,v,this.productService);try{p.autoUpdater.setFeedURL({url:h})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return h}doCheckForUpdates(v){this.setState(y.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(y.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([L.memoize],g.prototype,"onRawError",null),ue([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ue([ie(0,f.ILifecycleMainService),ie(1,b.IConfigurationService),ie(2,I.ITelemetryService),ie(3,n.IEnvironmentMainService),ie(4,P.IRequestService),ie(5,w.ILogService),ie(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(Z[228],x([0,1,41,32,9,4,8,24,22,6,29,42]),function(V,e,p,L,k,M,b,n,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(g,E,v){if(this.lifecycleMainService=g,this.logService=v,this._state=P.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ue([ie(0,f.ILifecycleMainService),ie(1,n.IEnvironmentMainService),ie(2,w.ILogService)],I);let y=class extends I{constructor(g,E,v,c,h,a){super(v,c,h);this.snap=g,this.snapRevision=E,this.telemetryService=a;const u=(0,L.watch)(b.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(u,"change",(o,m)=>m),l=M.Event.filter(i,o=>o==="current"),s=M.Event.debounce(l,(o,m)=>m,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{s.dispose(),u.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+b.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((v,c)=>(0,L.realpath)(`${b.dirname(this.snap)}/current`,(h,a)=>h?c(h):v(a))),E=b.basename(g);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=ue([ie(2,f.ILifecycleMainService),ie(3,n.IEnvironmentMainService),ie(4,w.ILogService),ie(5,t.ITelemetryService)],y),e.SnapUpdateService=y}),define(Z[46],x([0,1,14,32,4,40,34,2,10,8,3,15,13,19,153,51,52,24,5,6,21,100,27,101]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(o,m,S,D,R){super();this.environmentMainService=o,this.logService=m,this.backupMainService=S,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,m=>y.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(o,m){if(!!this.isWorkspacePath(o)&&o.scheme===f.Schemas.file)try{const S=m(o.fsPath);return S instanceof Promise?S.then(D=>this.doResolveWorkspace(o,D),D=>{}):this.doResolveWorkspace(o,S)}catch{return}}isWorkspacePath(o){return(0,i.isUntitledWorkspace)(o,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,m){try{const S=this.doParseStoredWorkspace(o,m),D=(0,l.getWorkspaceIdentifier)(o);return{id:D.id,configPath:D.configPath,folders:(0,i.toWorkspaceFolders)(S.folders,D.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(o,m){const S=(0,M.parse)(m);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(D=>(0,i.isStoredWorkspaceFolder)(D));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(o,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(o,m),R=S.configPath.fsPath;return await y.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await y.Promises.writeFile(R,JSON.stringify(D,null,"	")),S}createUntitledWorkspaceSync(o,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(o,m),R=S.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,y.writeFileSync)(R,JSON.stringify(D,null,"	")),S}newUntitledWorkspace(o=[],m){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,P.joinPath)(this.untitledWorkspacesHome,S),R=(0,P.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),T=[];for(const C of o)T.push((0,i.getStoredWorkspaceFolder)(C.uri,!0,C.name,D,!t.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:T,remoteAuthority:m}}}async getWorkspaceIdentifier(o){return(0,l.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,i.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const m=(0,P.originalFSPath)(o.configPath);try{(0,y.rimrafSync)((0,w.dirname)(m));const S=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,L.existsSync)(S)&&(0,y.writeFileSync)((0,w.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${m} (${S}).`)}}getUntitledWorkspacesSync(){const o=[];try{const m=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,P.joinPath)(this.untitledWorkspacesHome,S,i.UNTITLED_WORKSPACE_NAME));for(const S of m){const D=(0,l.getWorkspaceIdentifier)(S),R=this.resolveLocalWorkspaceSync(S);R?o.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return o}async enterWorkspace(o,m,S){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,m,S))return;const R=this.doEnterWorkspace(o,(0,l.getWorkspaceIdentifier)(S));if(!!R)return this._onDidEnterWorkspace.fire({window:o,workspace:R.workspace}),R}async isValidTargetWorkspacePath(o,m,S){if(!S)return!0;if((0,i.isWorkspaceIdentifier)(o.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,S))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(m,S)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,P.basename)(S)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,I.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,m){if(!o.config)return;o.focus();let S;return o.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,i.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=m,o.config.backupPath=S,{workspace:m,backupPath:S}}};r=ue([ie(0,v.IEnvironmentMainService),ie(1,h.ILogService),ie(2,g.IBackupMainService),ie(3,E.IDialogMainService),ie(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[102],x([0,1,14,30,23,3,13,7,19,16,54,5,6,98,36,27,46]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let v=class{constructor(h,a,u,i,l){this.logService=h,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=i,this.configurationService=l}async start(h,a){this.logService.trace("Received data from other instance: ",h,a),M.isMacintosh&&p.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:l,url:r}of u)this.urlService.open(l,{originalUrl:r})})}else return this.startOpenWindow(h,a)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(a=>{try{return{uri:n.URI.parse(a),url:a}}catch(u){return null}})):[]}async startOpenWindow(h,a){const u=(0,t.isLaunchedFromCli)(a)?0:4;let i=[];const l=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:u,cli:h,userEnv:a,waitMarkerFileURI:l,remoteAuthority:r});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let s=!1;if(h["new-window"]||h["unity-launch"])s=!0;else if(h["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!M.isMacintosh}if(s)i=this.windowsMainService.open({context:u,cli:h,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:l,remoteAuthority:r});else{const o=this.windowsMainService.getLastActiveWindow();o?(o.focus(),i=[o]):i=this.windowsMainService.open({context:u,cli:h,forceEmpty:!0,remoteAuthority:r})}}else i=this.windowsMainService.open({context:u,cli:h,userEnv:a,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:l,gotoLineMode:h.goto,remoteAuthority:r});if(l&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return p.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?h.push(this.codeWindowToInfo(u)):h.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(i=>new Promise(l=>{const r=i.remoteAuthority;if(r){const s=`vscode:getDiagnosticInfoResponse${i.id}`,o={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:s,args:o}),p.ipcMain.once(s,(m,S)=>{S||l({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),l(S)}),setTimeout(()=>{l({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else l(void 0)})))).filter(i=>!!i)}getFolderURIs(h){const a=[],u=h.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);i&&i.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(h){const a=this.getFolderURIs(h),u=(0,b.assertIsDefined)(h.win);return this.browserWindowToInfo(u,a,h.remoteAuthority)}browserWindowToInfo(h,a=[],u){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:a,remoteAuthority:u}}};v=ue([ie(0,I.ILogService),ie(1,d.IWindowsMainService),ie(2,y.IURLService),ie(3,E.IWorkspacesManagementMainService),ie(4,w.IConfigurationService)],v),e.LaunchMainService=v}),define(Z[53],x([0,1,41,14,26,114,47,4,34,2,10,8,3,7,82,67,19,145,52,24,5,22,6,21,29,61,36,27,46]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i,l,r,s,o,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let D=class ut extends w.Disposable{constructor(T,C,G,ne,oe,K,ee,O,j,$){super();this.sharedProcess=T,this.windowsMainService=C,this.dialogMainService=G,this.lifecycleMainService=ne,this.environmentMainService=oe,this.telemetryService=K,this.logService=ee,this.productService=O,this.themeMainService=j,this.workspacesManagementMainService=$,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,z=>z.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(z,H)=>H.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(z,H)=>H.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(z,H)=>H.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),z=>!!z),z=>z.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(z,H)=>H.id),z=>!!this.windowsMainService.getWindowById(z))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(z,H,W)=>W),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const C=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(T,C,G){return Array.isArray(C)?this.doOpenWindow(T,C,G):this.doOpenEmptyWindow(T,C)}async doOpenWindow(T,C,G=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:G.forceNewWindow,forceReuseWindow:G.forceReuseWindow,preferNewWindow:G.preferNewWindow,diffMode:G.diffMode,addMode:G.addMode,gotoLineMode:G.gotoLineMode,noRecentEntry:G.noRecentEntry,waitMarkerFileURI:G.waitMarkerFileURI,remoteAuthority:G.remoteAuthority||void 0})}async doOpenEmptyWindow(T,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},C)}async toggleFullScreen(T){const C=this.windowById(T);C&&C.toggleFullScreen()}async handleTitleDoubleClick(T){const C=this.windowById(T);C&&C.handleTitleDoubleClick()}async isMaximized(T){const C=this.windowById(T);return C?.win?C.win.isMaximized():!1}async maximizeWindow(T){const C=this.windowById(T);C?.win&&C.win.maximize()}async unmaximizeWindow(T){const C=this.windowById(T);C?.win&&C.win.unmaximize()}async minimizeWindow(T){const C=this.windowById(T);C?.win&&C.win.minimize()}async focusWindow(T,C){C&&typeof C.windowId=="number"&&(T=C.windowId);const G=this.windowById(T);G&&G.focus({force:C?.force??!1})}async setMinimumSize(T,C,G){const ne=this.windowById(T);if(ne?.win){const[oe,K]=ne.win.getSize(),[ee,O]=ne.win.getMinimumSize(),[j,$]=[C??ee,G??O],[z,H]=[Math.max(oe,j),Math.max(K,$)];(ee!==j||O!==$)&&ne.win.setMinimumSize(j,$),(oe!==z||K!==H)&&ne.win.setSize(z,H)}}async saveWindowSplash(T,C){this.themeMainService.saveWindowSplash(T,C)}async installShellCommand(T){const{source:C,target:G}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await E.SymlinkSupport.stat(C);if(ne&&!ne.dangling){const oe=await(0,d.realpath)(C);if(G===oe)return}await E.Promises.unlink(C)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await E.Promises.symlink(G,C)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:oe}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${G}' '${C}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(K)}catch(K){throw new Error((0,v.localize)(3,null,C))}}}async uninstallShellCommand(T){const{source:C}=await this.getShellCommandLink();try{await E.Promises.unlink(C)}catch(G){switch(G.code){case"EACCES":const{response:ne}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const oe=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(oe)}catch(oe){throw new Error((0,v.localize)(7,null,C))}break;case"ENOENT":break;default:throw G}}}async getShellCommandLink(){const T=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(T))throw new Error((0,v.localize)(8,null,T));return{source:C,target:T}}async showMessageBox(T,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(T))}async showSaveDialog(T,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(T))}async showOpenDialog(T,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(T))}toBrowserWindow(T){const C=this.windowById(T);if(C?.win)return C.win}async pickFileFolderAndOpen(T,C){const G=await this.dialogMainService.pickFileFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(G.map(async ne=>await E.SymlinkSupport.existsDirectory(ne)?{folderUri:y.URI.file(ne)}:{fileUri:y.URI.file(ne)})),C,T))}async pickFolderAndOpen(T,C){const G=await this.dialogMainService.pickFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({folderUri:y.URI.file(ne)})),C,T))}async pickFileAndOpen(T,C){const G=await this.dialogMainService.pickFile(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({fileUri:y.URI.file(ne)})),C,T))}async pickWorkspaceAndOpen(T,C){const G=await this.dialogMainService.pickWorkspace(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({workspaceUri:y.URI.file(ne)})),C,T))}doOpenPicked(T,C,G){this.windowsMainService.open({context:3,contextWindowId:G,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(T,C,G){const ne=T?T.length:0;this.telemetryService.publicLog(C,{...G,outcome:ne?"success":"canceled",numberOfPaths:ne})}async showItemInFolder(T,C){L.shell.showItemInFolder(C)}async setRepresentedFilename(T,C){const G=this.windowById(T);G&&G.setRepresentedFilename(C)}async setDocumentEdited(T,C){const G=this.windowById(T);G&&G.setDocumentEdited(C)}async openExternal(T,C){return I.isLinuxSnap?this.safeSnapOpenExternal(C):L.shell.openExternal(C),!0}safeSnapOpenExternal(T){const C=process.env.GDK_PIXBUF_MODULE_FILE,G=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(T),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=G}moveItemToTrash(T,C){return L.shell.trashItem(C)}async isAdmin(){let T;return I.isWindows?T=(await new Promise((C,G)=>{V(["native-is-elevated"],C,G)}))():T=process.getuid()===0,T}async writeElevated(T,C,G,ne){const oe=await new Promise((K,ee)=>{V(["sudo-prompt"],K,ee)});return new Promise((K,ee)=>{const O=[`"${this.cliPath}"`];ne?.unlock&&O.push("--file-chmod"),O.push("--file-write",`"${C.fsPath}"`,`"${G.fsPath}"`);const j={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(O.join(" "),j,($,z,H)=>{z&&this.logService.trace(`[sudo-prompt] received stdout: ${z}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),$?ee($):K(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(T,C,G){process.kill(C,G)}async readClipboardText(T,C){return L.clipboard.readText(C)}async writeClipboardText(T,C,G){return L.clipboard.writeText(C,G)}async readClipboardFindText(T){return L.clipboard.readFindText()}async writeClipboardFindText(T,C){return L.clipboard.writeFindText(C)}async writeClipboardBuffer(T,C,G,ne){return L.clipboard.writeBuffer(C,Buffer.from(G),ne)}async readClipboardBuffer(T,C){return L.clipboard.readBuffer(C)}async hasClipboard(T,C,G){return L.clipboard.has(C,G)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,C){const G=this.windowById(T);G&&G.updateTouchBar(C)}async notifyReady(T){const C=this.windowById(T);C&&C.setReady()}async relaunch(T,C){return this.lifecycleMainService.relaunch(C)}async reload(T,C){const G=this.windowById(T);if(G){if((0,m.isWorkspaceIdentifier)(G.openedWorkspace)){const ne=G.openedWorkspace.configPath;if(ne.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(G.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(G,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,C){const G=this.windowById(C);if(G?.win)return G.win.close()}async quit(T){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(T,C){await this.lifecycleMainService.kill(C)}async resolveProxy(T,C){const ne=this.windowById(T)?.win?.webContents?.session;if(ne)return ne.resolveProxy(C)}async openDevTools(T,C){const G=this.windowById(T);G?.win&&G.win.webContents.openDevTools(C)}async toggleDevTools(T){const C=this.windowById(T);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(T,C){const G=this.windowById(T);G?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&G.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(T,C,G,ne){if(!I.isWindows)return;const oe=await new Promise((K,ee)=>{V(["vscode-windows-registry"],K,ee)});try{return oe.GetStringRegKey(C,G,ne)}catch{return}}async getPassword(T,C,G){const ne=await this.withKeytar(),oe=await ne.getPassword(C,G);if(oe)try{let{content:K,hasNextChunk:ee}=JSON.parse(oe);if(!K||!ee)return oe;let O=1;for(;ee;){const j=await ne.getPassword(C,`${G}-${O}`),$=JSON.parse(j);K+=$.content,ee=$.hasNextChunk,O++}return K}catch{return oe}return oe}async setPassword(T,C,G,ne){const oe=await this.withKeytar(),K=3,ee=async(O,j,$)=>{let z=0,H;for(;z<K;)try{await oe.setPassword(O,j,$);return}catch(W){H=W,this.logService.warn("Error attempting to set a password: ",W),z++,await new Promise(q=>setTimeout(q,200))}throw H};if(I.isWindows&&ne.length>ut.MAX_PASSWORD_LENGTH){let O=0,j=0,$=!0;for(;$;){const z=ne.substring(O,O+ut.PASSWORD_CHUNK_SIZE);O+=ut.PASSWORD_CHUNK_SIZE,$=ne.length-O>0;const H={content:z,hasNextChunk:$};await ee(C,j?`${G}-${j}`:G,JSON.stringify(H)),j++}}else await ee(C,G,ne);this._onDidChangePassword.fire({service:C,account:G})}async deletePassword(T,C,G){const oe=await(await this.withKeytar()).deletePassword(C,G);return oe&&this._onDidChangePassword.fire({service:C,account:G}),oe}async findPassword(T,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(T,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((T,C)=>{V(["keytar"],T,C)})}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,ue([b.memoize],D.prototype,"cliPath",null),D=ue([ie(1,o.IWindowsMainService),ie(2,c.IDialogMainService),ie(3,u.ILifecycleMainService),ie(4,h.IEnvironmentMainService),ie(5,r.ITelemetryService),ie(6,i.ILogService),ie(7,l.IProductService),ie(8,s.IThemeMainService),ie(9,S.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(Z[229],x([0,1,14,23,4,80,2,28,89,6,53,21,36]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends b.Disposable{constructor(E,v,c,h,a){super();this.logService=E,this.windowsMainService=v,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=k.Event.fromNodeEventEmitter(p.app,"login",(v,c,h,a,u)=>({event:v,webContents:c,req:h,authInfo:a,callback:u}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:v,req:c,callback:h}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(a?.username,a?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(E);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const v=String((0,M.hash)({scheme:E.scheme,host:E.host,port:E.port}));let c,h;try{const l=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(l){const r=JSON.parse(await this.encryptionMainService.decrypt(l));c=r.username,h=r.password}}catch(l){this.logService.error(l)}if(this.state!==y.StoredCredentialsUsed&&typeof c=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:c,password:h};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:E,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=y.LoginDialogShown;const i=await new Promise(l=>{const r=async(s,o,m)=>{if(o===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),m){const S={username:m.username,password:m.password};try{if(m.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(S));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(D){this.logService.error(D)}l({username:S.username,password:S.password})}else l(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};d=ue([ie(0,w.ILogService),ie(1,I.IWindowsMainService),ie(2,t.INativeHostMainService),ie(3,f.IEncryptionMainService),ie(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[230],x([0,1,14,26,34,2,10,3,83,143,71,52,24,5,102,6,53,45,21,55,62]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class St{constructor(l,r,s,o,m,S,D,R,T){this.userEnv=l,this.environmentMainService=r,this.launchMainService=s,this.logService=o,this.diagnosticsService=m,this.dialogMainService=S,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=T,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(r,s);this.safeSend(l,"vscode:issueSystemInfoResponse",o)}),p.ipcMain.on("vscode:listProcesses",async l=>{const r=[];try{const s=await this.launchMainService.getMainProcessId();r.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,t.isRemoteDiagnosticError)(m)?r.push({name:m.hostName,rootProcess:m}):m.processes&&r.push({name:m.hostName,rootProcess:m.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(l,"vscode:listProcessesResponse",r)}),p.ipcMain.on("vscode:issueReporterClipboard",async l=>{const r={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",s.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const r=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",r)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(l,r)=>{const{id:s,from:o,args:m}=r;let S;switch(o){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}S&&S.webContents.send("vscode:runAction",{id:s,from:o,args:m})}),p.ipcMain.on("vscode:openExternal",(l,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),p.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async l=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",r.windows)})}safeSend(l,r,...s){l.sender.isDestroyed()||l.sender.send(r,...s)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,s,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:v.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,s,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:v.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(l,r,s){const o=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:s.title,backgroundColor:s.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return o.setMenuBarVisibility(!1),o}async getSystemStatus(){const[l,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,r)}getWindowPosition(l,r,s){let o;const m=p.screen.getAllDisplays();if(m.length===1)o=m[0];else{if(n.isMacintosh){const R=p.screen.getCursorScreenPoint();o=p.screen.getDisplayNearestPoint(R)}!o&&l&&(o=p.screen.getDisplayMatching(l.getBounds())),o||(o=p.screen.getPrimaryDisplay()||m[0])}const S={width:r,height:s},D=o.bounds;return S.x=D.x+D.width/2-S.width/2,S.y=D.y+D.height/2-S.height/2,D.width>0&&D.height>0&&(S.x<D.x&&(S.x=D.x),S.y<D.y&&(S.y=D.y),S.x>D.x+D.width&&(S.x=D.x),S.y>D.y+D.height&&(S.y=D.y),S.width>D.width&&(S.width=D.width),S.height>D.height&&(S.height=D.height)),S}async getPerformanceInfo(){try{const[l,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,r)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=ue([ie(1,I.IEnvironmentMainService),ie(2,d.ILaunchMainService),ie(3,g.ILogService),ie(4,t.IDiagnosticsService),ie(5,P.IDialogMainService),ie(6,E.INativeHostMainService),ie(7,h.IProtocolMainService),ie(8,c.IProductService)],u),e.IssueMainService=u}),define(Z[231],x([0,1,23,16,24,22,6,53,21,50,29,42,76]),function(V,e,p,L,k,M,b,n,f,w,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends I.AbstractUpdateService{constructor(g,E,v,c,h,a,u,i){super(g,E,c,h,a,i);this.telemetryService=v,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,I.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(P.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},p.CancellationToken.None).then(w.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const v=g?E.message||E:void 0;this.setState(P.State.Idle(1,v))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(P.State.Idle(1))}};y=ue([ie(0,M.ILifecycleMainService),ie(1,L.IConfigurationService),ie(2,t.ITelemetryService),ie(3,k.IEnvironmentMainService),ie(4,w.IRequestService),ie(5,b.ILogService),ie(6,n.INativeHostMainService),ie(7,f.IProductService)],y),e.LinuxUpdateService=y}),define(Z[232],x([0,1,41,32,26,9,23,47,8,7,112,19,16,24,20,22,6,53,21,50,29,42,76]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(m,S=1e3){for(;!m();)await(0,M.timeout)(S)}let r;function s(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let o=class extends i.AbstractUpdateService{constructor(S,D,R,T,C,G,ne,oe,K){super(S,D,T,C,G,K);this.telemetryService=R,this.fileService=ne,this.nativeHostMainService=oe}get cachePath(){const S=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),s()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),s()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,i.createUpdateURL)(D,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(u.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},b.CancellationToken.None).then(h.asJson).then(D=>{const R=s();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(u.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(T=>P.Promises.exists(T).then(C=>{if(C)return Promise.resolve(T);const G=D.url,ne=D.hash,oe=`${T}.tmp`;return this.requestService.request({url:G},b.CancellationToken.None).then(K=>this.fileService.writeFile(w.URI.file(oe),K.stream)).then(ne?()=>(0,t.checksum)(oe,D.hash):()=>{}).then(()=>P.Promises.rename(oe,T)).then(()=>T)})).then(T=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},C&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(D)):this.setState(u.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const R=S?D.message||D:void 0;this.setState(u.State.Idle(s(),R))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(u.State.Idle(s()))}async getUpdatePackagePath(S){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const D=S?G=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(G):()=>!0,R=await this.cachePath,C=(await P.Promises.readdir(R)).filter(D).map(async G=>{try{await P.Promises.unlink(f.join(R,G))}catch(ne){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(u.State.Updating(S));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(s()))});const T=`${this.productService.win32MutexName}-ready`,C=await new Promise((G,ne)=>{V(["windows-mutex"],G,ne)});l(()=>C.isActive(T)).then(()=>this.setState(u.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};ue([n.memoize],o.prototype,"cachePath",null),o=ue([ie(0,g.ILifecycleMainService),ie(1,I.IConfigurationService),ie(2,a.ITelemetryService),ie(3,y.IEnvironmentMainService),ie(4,h.IRequestService),ie(5,E.ILogService),ie(6,d.IFileService),ie(7,v.INativeHostMainService),ie(8,c.IProductService)],o),e.Win32UpdateService=o}),define(Z[233],x([0,1,14,9,23,4,34,2,10,8,73,3,7,149,51,16,52,24,54,200,20,22,6,21,55,99,29,203,61,62,36,27,46]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i,l,r,s,o,m,S,D,R,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(G||(G={}));let ne=class extends n.Disposable{constructor(K,ee,O,j,$,z,H,W,q,U,A,F,B,Y){super();this.logService=ee,this.environmentMainService=O,this.fileService=j,this.configurationService=z,this.themeMainService=H,this.workspacesManagementMainService=W,this.backupMainService=q,this.telemetryService=U,this.dialogMainService=A,this.lifecycleMainService=F,this.productService=B,this.protocolMainService=Y,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[_,N]=this.restoreWindowState(K.state);this.windowState=_,this.logService.trace("window#ctor: using window state",_);const Q=this.windowState.mode===0||this.windowState.mode===3,J=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(J?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};P.isLinux?re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):P.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),P.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),P.isMacintosh&&(re.acceptFirstMouse=!0,J?.clickThroughInactive===!1&&(re.acceptFirstMouse=!1));const le=P.isMacintosh&&J?.nativeTabs===!0;le&&(re.tabbingIdentifier=this.productService.nameShort);const te=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(te&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,P.isMacintosh||(re.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(re),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),P.isMacintosh&&te&&this._win.setSheetOffset(22),P.isMacintosh&&N&&(!le||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}Q&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:_=>$.globalStorage.get(_),store:(_,N)=>$.globalStorage.set(_,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){P.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return P.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){P.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return P.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){P.isMacintosh&&K?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function ee(){O.dispose(),j.dispose(),K()}const O=this.onDidClose(()=>ee()),j=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",($,z,H)=>this.onWindowError(3,{reason:H,exitCode:z})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),ee=$=>{for(let z=$;z;z=z.parent)if(z.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},O=$=>$.resourceType==="xhr"||ee($.frame);this._win.webContents.session.webRequest.onBeforeRequest(($,z)=>{const H=I.URI.parse($.url);return H.path.endsWith(".svg")&&!K.has(H.scheme)?z({cancel:!O($)}):z({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived(($,z)=>{const H=$.responseHeaders,W=H["content-type"]||H["Content-Type"];if(W&&Array.isArray(W)){const q=I.URI.parse($.url);if(q.path.endsWith(".svg")&&K.has(q.scheme))return H["Content-Type"]=["image/svg+xml"],z({cancel:!1,responseHeaders:H});if(!q.path.includes(f.Schemas.vscodeRemoteResource)&&W.some(U=>U.toLowerCase().includes("image/svg")))return z({cancel:!O($)})}return z({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async($,z)=>{const H=await this.marketplaceHeadersPromise;z({cancel:!1,requestHeaders:Object.assign($.requestHeaders,H)})})}async onWindowError(K,ee){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:ee?.reason,code:ee?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const O=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,y.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,y.localize)(2,null))],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;O.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):O.response===2&&this.destroyWindow()}else if(K===2){let O;ee?O=(0,y.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):O=(0,y.localize)(5,null);const j=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,y.localize)(7,null)),(0,b.mnemonicButtonLabel)((0,y.localize)(8,null))],message:O,detail:(0,y.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;j.response===0?this.reload():j.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const O=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||O!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=O;const j=ee||"",$=O?`${O},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(K){P.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,ee),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const O=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:ee.isReload?3:O?2:1})}updateConfiguration(K,ee){const O=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(O){const j=(0,c.isLaunchedFromCli)(O)&&!(0,c.isLaunchedFromCli)(K.userEnv),$=this.isExtensionDevelopmentHost;(j||$)&&(K.userEnv={...O,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(K["disable-extensions"]=ee.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),K.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&K&&(ee.verbose=K.verbose,ee.debugId=K.debugId,ee["inspect-extensions"]=K["inspect-extensions"],ee["inspect-brk-extensions"]=K["inspect-brk-extensions"],ee["extensions-dir"]=K["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,T.isWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.configPath;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.uri;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let O;try{O=p.screen.getDisplayMatching(this.getBounds())}catch(z){}const j=(0,R.defaultWindowState)();return{mode:3,display:O?O.id:void 0,width:this.windowState.width||j.width,height:this.windowState.height||j.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let ee;if(!P.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?K.mode=0:K.mode=1,ee===1||ee===0){let O;ee===1?O=this.getBounds():O=this._win.getNormalBounds(),K.x=O.x,K.y=O.y,K.width=O.width,K.height=O.height}return K}restoreWindowState(K){(0,t.mark)("code/willRestoreCodeWindowState");let ee=!1;if(K)try{const O=p.screen.getAllDisplays();ee=O.length>1,K=this.validateWindowState(K,O)}catch(O){this.logService.warn(`Unexpected error validating window state: ${O}
${O.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),ee]}validateWindowState(K,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const $=this.getWorkingArea(ee[0]);if($){let z=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!$||(K.x<$.x&&(K.x=$.x),K.y<$.y&&(K.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),z(),K.width>$.width&&(K.width=$.width),K.height>$.height&&(K.height=$.height),K.x>$.x+$.width-128&&(K.x=$.x+$.width-K.width),K.y>$.y+$.height-128&&(K.y=$.y+$.height-K.height),z()}return K}if(K.display&&K.mode===3){const $=ee.find(z=>z.id===K.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const z=(0,R.defaultWindowState)(3);return z.x=$.bounds.x,z.y=$.bounds.y,z}}let O,j;try{O=p.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),j=this.getWorkingArea(O)}catch($){}if(O&&j&&K.x+K.width>j.x&&K.y+K.height>j.y&&K.x<j.x+j.width&&K.y<j.y+j.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",j),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,ee]=this._win.getPosition(),[O,j]=this._win.getSize();return{x:K,y:ee,width:O,height:j}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,ee=!0){P.isMacintosh||(K==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,y.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const ee=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(P.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,ee,...O){this.isReady?this.send(K,...O):this.ready().then(()=>{ee.isCancellationRequested||this.send(K,...O)})}send(K,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${K} for window that is destroyed`);return}this._win.webContents.send(K,...ee)}}updateTouchBar(K){!P.isMacintosh||this.touchBarGroups.forEach((ee,O)=>{const j=K[O];ee.segments=this.createTouchBarGroupSegments(j)})}createTouchBar(){if(!!P.isMacintosh){for(let K=0;K<10;K++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const ee=this.createTouchBarGroupSegments(K),O=new p.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:O.segments[j].id,from:"touchbar"})}});return O}createTouchBarGroupSegments(K=[]){return K.map(O=>{let j;O.icon&&!m.ThemeIcon.isThemeIcon(O.icon)&&O.icon?.dark?.scheme===f.Schemas.file&&(j=p.nativeImage.createFromPath(I.URI.revive(O.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let $;return typeof O.title=="string"?$=O.title:$=O.title.value,{id:O.id,label:j?void 0:$,icon:j}})}dispose(){super.dispose(),this._win=null}};ne=ue([ie(1,i.ILogService),ie(2,v.IEnvironmentMainService),ie(3,a.IFileService),ie(4,s.IStorageMainService),ie(5,g.IConfigurationService),ie(6,S.IThemeMainService),ie(7,C.IWorkspacesManagementMainService),ie(8,d.IBackupMainService),ie(9,o.ITelemetryService),ie(10,E.IDialogMainService),ie(11,u.ILifecycleMainService),ie(12,l.IProductService),ie(13,r.IProtocolMainService)],ne),e.CodeWindow=ne}),define(Z[63],x([0,1,14,30,9,4,34,2,10,3,15,7,19,152,5,22,6,39,27,46]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let a=class He extends n.Disposable{constructor(m,S,D,R){super();this.stateMainService=m,this.logService=S,this.workspacesManagementMainService=D,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const S=[],D=[];for(let R of m)if((0,c.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&l(S,R.workspace)===-1&&S.push(R);else if((0,c.isRecentFolder)(R))r(S,R.folderUri)===-1&&S.push(R);else{const T=s(D,R.fileUri)>=0,C=R.fileUri.scheme===f.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,t.basename)(R.fileUri))>=0;!T&&!C&&(D.push(R),w.isWindows&&R.fileUri.scheme===f.Schemas.file&&p.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(S,D),S.length>He.MAX_TOTAL_RECENT_ENTRIES&&(S.length=He.MAX_TOTAL_RECENT_ENTRIES),D.length>He.MAX_TOTAL_RECENT_ENTRIES&&(D.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:D}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const S=C=>{const G=i(C);for(const ne of m)if(t.extUriBiasedIgnorePathCase.isEqual(ne,G))return!1;return!0},D=this.getRecentlyOpened(),R=D.workspaces.filter(S),T=D.files.filter(S);(R.length!==D.workspaces.length||T.length!==D.files.length)&&(this.saveRecentlyOpened({files:T,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;p.app.clearRecentDocuments();const m=this.getRecentlyOpened(),S=[];let D=0;for(let T=0;T<m.workspaces.length&&D<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;T++){const C=i(m.workspaces[T]);if(C.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(C);await I.Promises.exists(G)&&(S.push(G),D++)}}const R=[];for(let T=0;T<m.files.length&&D<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;T++){const C=i(m.files[T]);if(C.scheme===f.Schemas.file){const G=(0,t.originalFSPath)(C);if(He.COMMON_FILES_FILTER.includes((0,t.basename)(C))||S.includes(G))continue;await I.Promises.exists(G)&&(R.push(G),D++)}}R.reverse().forEach(T=>p.app.addRecentDocument(T)),S.reverse().forEach(T=>p.app.addRecentDocument(T))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const S=[],D=[],R=m?.config?.workspace;(0,c.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?S.push({workspace:R}):(0,c.isSingleFolderWorkspaceIdentifier)(R)&&S.push({folderUri:R.uri});const T=m?.config?.filesToOpenOrCreate;if(T)for(let C of T){const G=C.fileUri;G&&s(D,G)===-1&&D.push({fileUri:G})}return this.addEntriesFromStorage(S,D),{workspaces:S,files:D}}addEntriesFromStorage(m,S){let D=this.getRecentlyOpenedFromStorage();for(let R of D.workspaces){let T=(0,c.isRecentFolder)(R)?r(m,R.folderUri):l(m,R.workspace);T>=0?m[T].label=m[T].label||R.label:m.push(R)}for(let R of D.files){let T=s(S,R.fileUri);T>=0?S[T].label=S[T].label||R.label:S.push(R)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,c.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const S=(0,c.toStoreData)(m);this.stateMainService.setItem(He.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let T of p.app.getJumpListSettings().removedItems){const C=T.args;if(C){const G=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);G&&S.push(P.URI.parse(G[2]))}}this.removeRecentlyOpened(S);let D=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(T=>{const C=(0,c.isRecentWorkspace)(T)?T.workspace:T.folderUri,{title:G,description:ne}=this.getWindowsJumpListLabel(C,T.label);let oe;return P.URI.isUri(C)?oe=`--folder-uri "${C.toString()}"`:(D=!0,oe=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:G.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:oe,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&m.push({type:"custom",name:D?(0,y.localize)(2,null):(0,y.localize)(3,null),items:R})}m.push({type:"recent"});try{p.app.setJumpList(m)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(m,S){if(S)return{title:(0,b.splitName)(S).name,description:S};if(P.URI.isUri(m))return{title:(0,t.basename)(m),description:u(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,y.localize)(4,null),description:""};let D=(0,t.basename)(m.configPath);return D.endsWith(c.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,D),description:u(m.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ue([ie(0,v.IStateMainService),ie(1,E.ILogService),ie(2,h.IWorkspacesManagementMainService),ie(3,g.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function u(o){return o.scheme==="file"?(0,b.normalizeDriveLetter)(o.fsPath):o.toString()}function i(o){return(0,c.isRecentFolder)(o)?o.folderUri:(0,c.isRecentFile)(o)?o.fileUri:o.workspace.configPath}function l(o,m){return o.findIndex(S=>(0,c.isRecentWorkspace)(S)&&S.workspace.id===m.id)}function r(o,m){return o.findIndex(S=>(0,c.isRecentFolder)(S)&&t.extUriBiasedIgnorePathCase.isEqual(S.folderUri,m))}function s(o,m){return o.findIndex(S=>t.extUriBiasedIgnorePathCase.isEqual(S.fileUri,m))}}),define(Z[234],x([0,1,14,9,23,34,3,7,144,16,24,22,6,182,53,21,39,29,42,62,36,63]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let l=class wt{constructor(o,m,S,D,R,T,C,G,ne,oe,K){this.updateService=o,this.configurationService=m,this.windowsMainService=S,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=T,this.stateMainService=C,this.lifecycleMainService=G,this.logService=ne,this.nativeHostMainService=oe,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(b.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,C,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,C,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(b.language){const T=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${T}lang=${b.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!b.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,m){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!b.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!b.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=p.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(b.isMacintosh?new p.Menu:null);return}const m=new p.Menu;let S;if(b.isMacintosh){const R=new p.Menu;S=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),m.append(S)}if(b.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),m.append(T)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),m.append(T)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),m.append(T)}if(this.shouldDrawMenu("View")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),m.append(T)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),m.append(T)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),m.append(T)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),m.append(T)}let D;if(this.shouldDrawMenu("Window")){const R=new p.Menu;D=new p.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&m.append(D),this.shouldDrawMenu("Help")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),m.append(T)}m.items&&m.items.length>0?p.Menu.setApplicationMenu(m):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const m=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const ee=new p.Menu;this.setMenuById(ee,"Preferences"),D=new p.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:ee})}const R=new p.Menu,T=new p.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),C=new p.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new p.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new p.MenuItem({label:f.localize(15,null),role:"unhide"}),oe=new p.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[m];K.push(...S),D&&K.push(r(),D),K.push(r(),T,r(),C,G,ne,r(),oe),K.forEach(ee=>o.append(ee))}shouldDrawMenu(o){if(!b.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(b.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(b.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,m){m.forEach(S=>{if((0,y.isMenubarMenuItemSeparator)(S))o.append(r());else if((0,y.isMenubarMenuItemSubmenu)(S)){const D=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(S.label),submenu:D});this.setMenu(D,S.submenu.items),o.append(R)}else(0,y.isMenubarMenuItemRecentAction)(S)?o.append(this.createOpenRecentMenuItem(S)):(0,y.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),b.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?o.append(new p.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):o.append(this.createMenuItem(S.label,S.id,!1,S.checked)):o.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):o.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(o,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(o,this.menubarMenus[m].items)}insertCheckForUpdatesItems(o){const m=this.getUpdateMenuItems();m.length&&(m.forEach(S=>o.append(S)),o.append(r()))}createOpenRecentMenuItem(o){const m=n.URI.revive(o.uri),S=o.id,D=S==="openRecentFile"?{fileUri:m}:S==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new p.MenuItem(this.likeAction(S,{label:o.label,click:(R,T,C)=>{const G=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(o){return!!(o&&(!b.isMacintosh&&(o.ctrlKey||o.shiftKey)||b.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,m,S){const D={label:this.mnemonicLabel(o),role:S,enabled:!0};return new p.MenuItem(this.withKeybinding(m,D))}setMacWindowMenu(o){const m=new p.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new p.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new p.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(r()),T.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,S,r(),R,...T,r(),D].forEach(C=>o.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,m,S,D){const R=this.mnemonicLabel(o),T=typeof m=="function"?m:(K,ee,O)=>{const j=K?K.userSettingsLabel:null;let $=m;Array.isArray(m)&&($=this.isOptionClick(O)?m[1]:m[0]),j&&O.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:j}):this.runActionInRenderer({type:"commandId",commandId:$})},C=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,G=typeof D=="boolean"?D:!1,ne={label:R,click:T,enabled:C};G&&(ne.type="checkbox",ne.checked=G);let oe;return typeof m=="string"?oe=m:Array.isArray(m)&&(oe=m[0]),b.isMacintosh&&(oe==="editor.action.clipboardCutAction"?ne.role="cut":oe==="editor.action.clipboardCopyAction"?ne.role="copy":oe==="editor.action.clipboardPasteAction"&&(ne.role="paste"),oe==="undo"?ne.click=this.makeContextAwareClickHandler(T,{inDevTools:K=>K.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?ne.click=this.makeContextAwareClickHandler(T,{inDevTools:K=>K.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(T,{inDevTools:K=>K.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(oe,ne))}makeContextAwareClickHandler(o,m){return(S,D,R)=>{const T=p.BrowserWindow.getFocusedWindow();if(!T)return m.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return m.inDevTools(T.webContents.devToolsWebContents);o(S,D||T,R)}}runActionInRenderer(o){let m=p.BrowserWindow.getFocusedWindow();if(!m){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const S=m?this.windowsMainService.getWindowById(m.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",o),b.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,m){const S=typeof o=="string"?this.keybindings[o]:void 0;if(S?.label){if(S.isNative!==!1)m.accelerator=S.label,m.userSettingsLabel=S.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${S.label}]`:m.label=`${m.label} [${S.label}]`}}else m.accelerator=void 0;return m}likeAction(o,m,S=!m.accelerator){S&&(m=this.withKeybinding(o,m));const D=m.click;return m.click=(R,T,C)=>{this.reportMenuActionTelemetry(o),D&&D(R,T,C)},m}openUrl(o,m){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:i})}mnemonicLabel(o){return(0,M.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=ue([ie(0,c.IUpdateService),ie(1,w.IConfigurationService),ie(2,a.IWindowsMainService),ie(3,t.IEnvironmentMainService),ie(4,v.ITelemetryService),ie(5,u.IWorkspacesHistoryMainService),ie(6,E.IStateMainService),ie(7,P.ILifecycleMainService),ie(8,I.ILogService),ie(9,d.INativeHostMainService),ie(10,g.IProductService)],l),e.Menubar=l;function r(){return new p.MenuItem({type:"separator"})}}),define(Z[235],x([0,1,5,22,6,234]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let b=class{constructor(f,w,t){this.instantiationService=f,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};b=ue([ie(0,p.IInstantiationService),ie(1,L.ILifecycleMainService),ie(2,k.ILogService)],b),e.MenubarMainService=b}),define(Z[236],x([0,1,14,32,26,30,23,4,31,43,34,2,10,8,73,3,33,15,13,7,150,51,16,52,24,20,5,22,6,45,21,55,74,39,62,233,100,216,27,101,63,46]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i,l,r,s,o,m,S,D,R,T,C,G,ne,oe,K,ee,O,j,$,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(U){return(0,O.isWorkspaceIdentifier)(U?.workspace)}function W(U){return(0,O.isSingleFolderWorkspaceIdentifier)(U?.workspace)}let q=class Je extends P.Disposable{constructor(A,F,B,Y,_,N,Q,J,re,le,te,ae,ge,fe,de){super();this.machineId=A,this.initialUserEnv=F,this.logService=B,this.stateMainService=Y,this.environmentMainService=_,this.lifecycleMainService=N,this.backupMainService=Q,this.configurationService=J,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=le,this.instantiationService=te,this.dialogMainService=ae,this.fileService=ge,this.productService=fe,this.protocolMainService=de,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new ee.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new P.DisposableStore;if(F.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const B of A.config.extensionDevelopmentPath)F.add(this.protocolMainService.addValidFileRoot(h.URI.file(B)));A.config.extensionTestsPath&&F.add(this.protocolMainService.addValidFileRoot(h.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,F){let B=this.environmentMainService.args;const Y=F?.remoteAuthority||void 0,_=!0,N=F?.forceReuseWindow,Q=!N;return this.open({...A,cli:B,forceEmpty:_,forceNewWindow:Q,forceReuseWindow:N,remoteAuthority:Y})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],B=[],Y=[],_=[],N=[];let Q,J=0;const re=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const fe of re)W(fe)?A.addMode?F.push(fe):B.push(fe):H(fe)?Y.push(fe):fe.fileUri?(Q||(Q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:fe.remoteAuthority}),Q.filesToOpenOrCreate.push(fe)):fe.backupPath?N.push({backupFolder:(0,y.basename)(fe.backupPath),remoteAuthority:fe.remoteAuthority}):J++;A.diffMode&&Q&&Q.filesToOpenOrCreate.length>=2&&(Q.filesToDiff=Q.filesToOpenOrCreate.slice(0,2),Q.filesToOpenOrCreate=[]),Q&&A.waitMarkerFileURI&&(Q.filesToWait={paths:[...Q.filesToDiff,...Q.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(_.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(..._),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:te}=this.doOpen(A,Y,B,N,J,Q,F);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${B.length}, emptyToRestore: ${N.length}, emptyToOpen: ${J})`),le.length>1)if(te)te.focus();else{const fe=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let de=!0,Pe=!0;if(fe){const pe=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),de=!1,Pe=!1)}if(de)for(let pe=le.length-1;pe>=0;pe--){const me=le[pe];if(!(me.openedWorkspace&&_.some(be=>me.openedWorkspace&&be.workspace.id===me.openedWorkspace.id)||me.backupPath&&N.some(be=>me.backupPath&&be.backupFolder===(0,y.basename)(me.backupPath)))){me.focus(),Pe=!1;break}}Pe&&le[le.length-1].focus()}const ae=Q&&Q.filesToDiff.length>0;if(!le.some(fe=>fe.isExtensionDevelopmentHost)&&!ae&&!A.noRecentEntry){const fe=[];for(const de of re)H(de)&&!de.transient?fe.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):W(de)?fe.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&fe.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(fe)}const ge=A.waitMarkerFileURI;return A.context===0&&ge&&le.length===1&&le[0]&&(async()=>{await le[0].whenClosedOrLoaded;try{await this.fileService.del(ge)}catch(fe){}})(),le}doOpen(A,F,B,Y,_,N,Q){const J=[];let re;function le(pe,me){J.push(pe),me&&(re=pe,N=void 0)}let{openFolderInNewWindow:te,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Q.length>0){const pe=Q[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(pe);me&&le(this.doAddFoldersToExistingWindow(me,Q.map(be=>be.workspace.uri)))}const ge=B.length+F.length+Y.length;if(N&&ge===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0],me=this.getWindows().filter(ke=>N&&ke.remoteAuthority===N.remoteAuthority);let be;pe?.fileUri&&!ae&&((A.context===4||A.context===0||A.context===1)&&(be=(0,K.findWindowOnFile)(me,pe.fileUri,ke=>ke.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),be||(be=this.doGetLastActiveWindow(me))),be?(0,O.isWorkspaceIdentifier)(be.openedWorkspace)?F.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,O.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?B.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,be,N),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const fe=(0,M.distinct)(F,pe=>pe.workspace.id);if(fe.length>0){const pe=(0,M.coalesce)(fe.map(me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(pe.length>0){const me=pe[0],be=N?.remoteAuthority===me.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,me,be),!!be),te=!0}fe.forEach(me=>{if(pe.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===me.workspace.id))return;const be=me.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(A,me,te,ke),!!ke),te=!0})}const de=(0,M.distinct)(B,pe=>v.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(de.length>0){const pe=(0,M.coalesce)(de.map(me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(pe.length>0){const me=pe[0],be=N?.remoteAuthority===me.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,me,be),!!be),te=!0}de.forEach(me=>{if(pe.some(Ae=>(0,O.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,me.workspace.uri)))return;const be=me.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(A,me,te,ke),!!ke),te=!0})}const Pe=(0,M.distinct)(Y,pe=>pe.backupFolder);if(Pe.length>0&&Pe.forEach(pe=>{const me=pe.remoteAuthority,be=N?.remoteAuthority===me?N:void 0;le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:be,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:pe}),!!be),te=!0}),J.length===0||N){N&&!_&&_++;const pe=N?N.remoteAuthority:A.remoteAuthority;for(let me=0;me<_;me++)le(this.doOpenEmpty(A,te,pe,N),!!N),te=!0}return{windows:(0,M.distinct)(J),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,F,B){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const Y={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToWait:B?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",b.CancellationToken.None,Y),F}doAddFoldersToExistingWindow(A,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const B={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",b.CancellationToken.None,B),A}doOpenEmpty(A,F,B,Y,_){return!F&&!_&&typeof A.contextWindowId=="number"&&(_=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:_})}doOpenFolderOrWorkspace(A,F,B,Y,_){return!B&&!_&&typeof A.contextWindowId=="number"&&(_=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:_})}getPathsToOpen(A){let F,B=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=this.doExtractPathsFromAPI(A),B=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=this.doExtractPathsFromCLI(A.cli),F.length===0&&F.push(Object.create(null)),B=!0):(F=this.doGetPathsFromLastSession(),F.length===0&&F.push(Object.create(null)),Y=!0),!A.addMode&&B){const _=F.filter(N=>W(N));if(_.length>1){const N=_[0].remoteAuthority;if(_.every(Q=>Q.remoteAuthority===N)){const Q=this.workspacesManagementMainService.createUntitledWorkspaceSync(_.map(J=>({uri:J.workspace.uri})));F.push({workspace:Q,remoteAuthority:N}),F=F.filter(J=>!W(J))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&F.unshift(...this.doGetPathsFromLastSession().filter(_=>H(_)||W(_)||_.backupPath)),F}doExtractPathsFromAPI(A){const F=[],B={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of(0,M.coalesce)(A.urisToOpen||[])){const _=this.resolveOpenable(Y,B);if(_)_.label=Y.label,F.push(_);else{const N=this.resourceFromOpenable(Y),Q={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:N.scheme===I.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:N.scheme===I.Schemas.file?(0,a.localize)(3,null,(0,t.getPathLabel)(N.fsPath,this.environmentMainService)):(0,a.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Q,(0,c.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(A){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const Q of Y){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable({folderUri:J},B);re&&F.push(re)}}const _=A["file-uri"];if(_)for(const Q of _){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable((0,O.hasWorkspaceFileExtension)(Q)?{workspaceUri:J}:{fileUri:J},B);re&&F.push(re)}}const N=A._;for(const Q of N){const J=B.remoteAuthority?this.doResolvePathRemote(Q,B):this.doResolveFilePath(Q,B);J&&F.push(J)}return F}cliArgToUri(A){try{const F=h.URI.parse(A);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${A}, ${F.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];A!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const Y of F)if(Y.workspace){const _=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});H(_)&&B.push(_)}else if(Y.folderUri){const _=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});W(_)&&B.push(_)}else A!=="folders"&&Y.backupPath&&B.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return B}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,F=Object.create(null)){let B=this.resourceFromOpenable(A);return B.scheme===I.Schemas.file?((0,ne.isFileToOpen)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(A,F)}doResolveRemoteOpenable(A,F){let B=this.resourceFromOpenable(A);const Y=(0,C.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(B)),(0,ne.isFileToOpen)(A)){if(F.gotoLineMode){const{path:_,line:N,column:Q}=(0,f.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:_}),selection:N?{startLineNumber:N,startColumn:Q||1}:void 0,remoteAuthority:Y}}return{fileUri:B,remoteAuthority:Y}}else if((0,ne.isWorkspaceToOpen)(A))return{workspace:(0,j.getWorkspaceIdentifier)(B),remoteAuthority:Y};return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:Y}}resourceFromOpenable(A){return(0,ne.isWorkspaceToOpen)(A)?A.workspaceUri:(0,ne.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,F){let B,Y;F.gotoLineMode&&({path:A,line:B,column:Y}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,y.normalize)(A),(0,E.cwd)());try{const _=(0,L.statSync)(A);if(_.isFile()){if(!F.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(A));if(N)return N.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:h.URI.file(A),selection:B?{startLineNumber:B,startColumn:Y||1}:void 0,exists:!0}}else if(_.isDirectory())return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(h.URI.file(A),_),exists:!0}}catch(_){const N=h.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),F.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(A,F){const B=A.charCodeAt(0),Y=F.remoteAuthority;let _,N;F.gotoLineMode&&({path:A,line:_,column:N}=(0,f.parseLineAndColumnAware)(A)),B!==47&&((0,f.isWindowsDriveLetter)(B)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const Q=h.URI.from({scheme:I.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,O.hasWorkspaceFileExtension)(A))return F.forceOpenWorkspaceAsFile?{fileUri:Q,selection:_?{startLineNumber:_,startColumn:N||1}:void 0,remoteAuthority:F.remoteAuthority}:{workspace:(0,j.getWorkspaceIdentifier)(Q),remoteAuthority:Y};if(F.gotoLineMode||y.posix.basename(A).indexOf(".")!==-1)return{fileUri:Q,selection:_?{startLineNumber:_,startColumn:N||1}:void 0,remoteAuthority:Y}}return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(Q),remoteAuthority:Y}}shouldOpenNewWindow(A){const F=this.configurationService.getValue("window"),B=F?.openFoldersInNewWindow||"default",Y=F?.openFilesInNewWindow||"off";let _=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(B==="on"||B==="off")&&(_=B==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(g.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(N=Y==="on")),{openFolderInNewWindow:!!_,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(A,F){const B=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let Y=F.cli["folder-uri"]||[],_=F.cli["file-uri"]||[],N=F.cli._;if(!N.length&&!Y.length&&!_.length&&!F.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,te=le&&(le.workspace||le.folderUri);te&&(h.URI.isUri(te)?te.scheme===I.Schemas.file?N=[te.fsPath]:Y=[te.toString()]:te.configPath.scheme===I.Schemas.file?N=[(0,v.originalFSPath)(te.configPath)]:_=[te.configPath.toString()])}let Q=F.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const te=h.URI.parse(le),ae=(0,C.getRemoteAuthority)(te);ae&&(Q?ae!==Q&&this.logService.error("more than one extension development path authority"):Q=ae)}N=N.filter(le=>{const te=h.URI.file(le);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),te)?!1:(0,C.getRemoteAuthority)(te)===Q}),Y=Y.filter(le=>{const te=this.cliArgToUri(le);return te&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),te)?!1:te?(0,C.getRemoteAuthority)(te)===Q:!1}),_=_.filter(le=>{const te=this.cliArgToUri(le);return te&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),te)?!1:te?(0,C.getRemoteAuthority)(te)===Q:!1}),F.cli._=N,F.cli["folder-uri"]=Y,F.cli["file-uri"]=_;const J=!N.length&&!Y.length&&!_.length,re={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:J,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Q};return this.open(re)}openInBrowserWindow(A){const F=this.configurationService.getValue("window"),B={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,enableLegacyRecursiveWatcher:this.configurationService.getValue("files.legacyWatcher"),autoDetectHighContrast:F?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const _=Y.config;!B.extensionDevelopmentPath&&_&&!!_.extensionDevelopmentPath&&(B.extensionDevelopmentPath=_.extensionDevelopmentPath,B.verbose=_.verbose,B["inspect-brk-extensions"]=_["inspect-brk-extensions"],B.debugId=_.debugId,B["inspect-extensions"]=_["inspect-extensions"],B["extensions-dir"]=_["extensions-dir"])}else{const _=this.windowsStateHandler.getNewWindowState(B);(0,d.mark)("code/willCreateCodeWindow");const N=Y=this.instantiationService.createInstance(oe.CodeWindow,{state:_,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(N)}Je.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,w.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,w.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Q=(0,c.assertIsDefined)(N.win?.webContents);Q.removeAllListeners("devtools-reload-page"),Q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return B.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(_=>{_||this.doOpenInBrowserWindow(Y,B,A)}):this.doOpenInBrowserWindow(Y,B,A),Y}doOpenInBrowserWindow(A,F,B){if(!F.extensionDevelopmentPath)if((0,O.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,O.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const Y=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,F.remoteAuthority)}A.load(F)}onWindowClosed(A){const F=Je.WINDOWS.indexOf(A);Je.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=p.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===A))}doGetLastActiveWindow(A){const F=Math.max.apply(Math,A.map(B=>B.lastFocusTime));return A.find(B=>B.lastFocusTime===F)}sendToFocused(A,...F){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(A,b.CancellationToken.None,...F)}sendToAll(A,F,B){for(const Y of this.getWindows())B&&B.indexOf(Y.id)>=0||Y.sendWhenReady(A,b.CancellationToken.None,F)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(A){const F=this.getWindows().filter(B=>B.id===A);return(0,M.firstOrDefault)(F)}getWindowByWebContents(A){const F=p.BrowserWindow.fromWebContents(A);if(!!F)return this.getWindowById(F.id)}};q.WINDOWS=[],q=ue([ie(2,S.ILogService),ie(3,G.IStateMainService),ie(4,r.IEnvironmentMainService),ie(5,m.ILifecycleMainService),ie(6,u.IBackupMainService),ie(7,i.IConfigurationService),ie(8,$.IWorkspacesHistoryMainService),ie(9,z.IWorkspacesManagementMainService),ie(10,o.IInstantiationService),ie(11,l.IDialogMainService),ie(12,s.IFileService),ie(13,R.IProductService),ie(14,T.IProtocolMainService)],q),e.WindowsMainService=q}),define(Z[237],x([0,1,51,36,63,46]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let b=class{constructor(f,w,t,P){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};b=ue([ie(0,M.IWorkspacesManagementMainService),ie(1,L.IWindowsMainService),ie(2,k.IWorkspacesHistoryMainService),ie(3,p.IBackupMainService)],b),e.WorkspacesMainService=b}),define(Z[238],x([0,1,14,32,26,18,17,31,43,40,34,2,10,8,3,15,13,7,28,67,119,35,122,85,229,131,51,220,16,178,157,71,52,219,89,24,54,91,169,185,90,172,20,70,5,72,230,196,102,22,6,180,235,53,21,74,225,75,39,214,99,197,29,199,201,60,42,205,227,231,228,232,98,206,207,208,209,211,36,236,212,27,63,237,46]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i,l,r,s,o,m,S,D,R,T,C,G,ne,oe,K,ee,O,j,$,z,H,W,q,U,A,F,B,Y,_,N,Q,J,re,le,te,ae,ge,fe,de,Pe,pe,me,be,ke,Ae,Ue,Ce,Ge,Be,ot,Ze,at,Ye,ht,xe,X,se,ce,we,ye,De,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ne=class extends P.Disposable{constructor(he,Se,Ee,ve,Ie,Le,Me,Re,Te,qe){super();this.mainProcessNodeIpcServer=he,this.userEnv=Se,this.mainInstantiationService=Ee,this.logService=ve,this.environmentMainService=Ie,this.lifecycleMainService=Le,this.configurationService=Me,this.stateMainService=Re,this.fileService=Te,this.productService=qe,this.configureSession(),this.registerListeners()}configureSession(){const he=ve=>ve?.startsWith(`${I.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((ve,Ie,Le,Me)=>he(Me.requestingUrl)?Le(Se.has(Ie)):Le(!1)),p.session.defaultSession.setPermissionCheckHandler((ve,Ie,Le,Me)=>he(Me.requestingUrl)?Se.has(Ie):!1);const Ee=p.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,b.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,b.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,a.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Ee,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),p.app.on("activate",(Ee,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Ee,ve)=>{ve.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),ve.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let he=[],Se;p.app.on("open-file",(Ee,ve)=>{this.logService.trace("app#open-file: ",ve),Ee.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],Se=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const ve=this.windowsMainService?.getWindowByWebContents(Ee.sender);let Ie,Le;return ve?.config?(Ie=ve.config,Le={...process.env,...ve.config.userEnv}):(Ie=this.environmentMainService.args,Le=process.env),(0,ee.resolveShellEnv)(this.logService,Ie,Le)}),p.ipcMain.handle("vscode:writeNlsFile",(Ee,ve,Ie)=>{const Le=this.validateNlsPath([ve]);if(!Le||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Ie))}),p.ipcMain.handle("vscode:readNlsFile",async(Ee,...ve)=>{const Ie=this.validateNlsPath(ve);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(he){let Se;for(const Ee of he)typeof Ee=="string"&&(typeof Se!="string"?Se=Ee:Se=(0,y.join)(Se,Ee));if(!(typeof Se!="string"||!(0,y.isAbsolute)(Se)||!(0,n.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(Se)}onUnexpectedError(he){if(he){const Se={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const he=this.productService.win32AppUserModelId;d.isWindows&&he&&p.app.setAppUserModelId(he);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const Se=new i.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:ve,sharedProcessReady:Ie,sharedProcessClient:Le}=this.setupSharedProcess(Ee),Me=await this.initServices(Ee,ve,Ie);if(this.environmentMainService.driverHandle){const Te=await(0,G.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,Se,Le));const Re=Me.invokeFunction(Te=>this.openFirstWindow(Te,Se));Me.invokeFunction(Te=>this.afterWindowOpen(Te,ve)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let he=this.stateMainService.getItem(pe.machineIdKey);return(!he||d.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,h.getMachineId)(),this.stateMainService.setItem(pe.machineIdKey,he)),he}setupSharedProcess(he){const Se=this._register(this.mainInstantiationService.createInstance(te.SharedProcess,he,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new l.Client(Ie,"main")})(),ve=(async()=>(await Se.whenReady(),Ee))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:Ee}}async initServices(he,Se,Ee){const ve=new U.ServiceCollection;switch(process.platform){case"win32":ve.set(Ae.IUpdateService,new W.SyncDescriptor(ot.Win32UpdateService));break;case"linux":d.isLinuxSnap?ve.set(Ae.IUpdateService,new W.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ae.IUpdateService,new W.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":ve.set(Ae.IUpdateService,new W.SyncDescriptor(Ce.DarwinUpdateService));break}ve.set(se.IWindowsMainService,new W.SyncDescriptor(ce.WindowsMainService,[he,this.userEnv])),ve.set(C.IDialogMainService,new W.SyncDescriptor(C.DialogMainService)),ve.set(B.ILaunchMainService,new W.SyncDescriptor(B.LaunchMainService)),ve.set(T.IDiagnosticsService,u.ProxyChannel.toService((0,u.getDelayedChannel)(Ee.then(Le=>Le.getChannel("diagnostics"))))),ve.set(A.IIssueMainService,new W.SyncDescriptor(A.IssueMainService,[this.userEnv])),ve.set(ne.IEncryptionMainService,new W.SyncDescriptor(ne.EncryptionMainService,[he])),ve.set(F.IKeyboardLayoutMainService,new W.SyncDescriptor(F.KeyboardLayoutMainService)),ve.set(J.INativeHostMainService,new W.SyncDescriptor(J.NativeHostMainService,[Se])),ve.set(xe.IWebviewManagerService,new W.SyncDescriptor(X.WebviewMainService)),ve.set(ye.IWorkspacesService,new W.SyncDescriptor(Fe.WorkspacesMainService)),ve.set(We.IWorkspacesManagementMainService,new W.SyncDescriptor(We.WorkspacesManagementMainService)),ve.set(De.IWorkspacesHistoryMainService,new W.SyncDescriptor(De.WorkspacesHistoryMainService)),ve.set(Q.IMenubarMainService,new W.SyncDescriptor(Q.MenubarMainService)),ve.set(O.IExtensionUrlTrustService,new W.SyncDescriptor(j.ExtensionUrlTrustService)),ve.set(de.IStorageMainService,new W.SyncDescriptor(de.StorageMainService)),d.isWindows?ve.set($.IExternalTerminalMainService,new W.SyncDescriptor(z.WindowsExternalTerminalService)):d.isMacintosh?ve.set($.IExternalTerminalMainService,new W.SyncDescriptor(z.MacExternalTerminalService)):d.isLinux&&ve.set($.IExternalTerminalMainService,new W.SyncDescriptor(z.LinuxExternalTerminalService));const Ie=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(o.IBackupMainService,Ie),ve.set(Ze.IURLService,new W.SyncDescriptor(Ye.NativeURLService)),(0,ke.supportsTelemetry)(this.productService,this.environmentMainService)){const Le=(0,u.getDelayedChannel)(Ee.then(Ve=>Ve.getChannel("telemetryAppender"))),Me=new me.TelemetryAppenderClient(Le),Re=(0,Pe.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],qe={appenders:[Me],commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};ve.set(pe.ITelemetryService,new W.SyncDescriptor(be.TelemetryService,[qe]))}else ve.set(pe.ITelemetryService,ke.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(he,Se,Ee){const ve=u.ProxyChannel.fromService(he.get(B.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve),Se.registerChannel(D.UserConfigurationFileServiceId,u.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ue.UpdateChannel(he.get(Ae.IUpdateService));Se.registerChannel("update",Ie);const Le=u.ProxyChannel.fromService(he.get(A.IIssueMainService));Se.registerChannel("issue",Le);const Me=u.ProxyChannel.fromService(he.get(ne.IEncryptionMainService));Se.registerChannel("encryption",Me);const Re=u.ProxyChannel.fromService(he.get(ae.ISignService));Se.registerChannel("sign",Re);const Te=u.ProxyChannel.fromService(he.get(F.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Te),this.nativeHostMainService=he.get(J.INativeHostMainService);const qe=u.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",qe),Ee.then($e=>$e.registerChannel("nativeHost",qe));const Ve=u.ProxyChannel.fromService(he.get(ye.IWorkspacesService));Se.registerChannel("workspaces",Ve);const et=u.ProxyChannel.fromService(he.get(Q.IMenubarMainService));Se.registerChannel("menubar",et);const tt=u.ProxyChannel.fromService(he.get(Ze.IURLService));Se.registerChannel("url",tt);const it=u.ProxyChannel.fromService(he.get(O.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",it);const _e=u.ProxyChannel.fromService(he.get(xe.IWebviewManagerService));Se.registerChannel("webview",_e);const nt=this._register(new fe.StorageDatabaseChannel(this.logService,he.get(de.IStorageMainService)));Se.registerChannel("storage",nt),Ee.then($e=>$e.registerChannel("storage",nt));const rt=u.ProxyChannel.fromService(he.get($.IExternalTerminalMainService));Se.registerChannel("externalTerminal",rt);const Xe=new N.LogLevelChannel(he.get(_.ILogService));Se.registerChannel("logLevel",Xe),Ee.then($e=>$e.registerChannel("logLevel",Xe));const st=new N.LoggerChannel(he.get(_.ILoggerService));Se.registerChannel("logger",st),Ee.then($e=>$e.registerChannel("logger",st));const lt=new R.ElectronExtensionHostDebugBroadcastChannel(he.get(se.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",lt)}openFirstWindow(he,Se){const Ee=this.windowsMainService=he.get(se.IWindowsMainService),ve=he.get(Ze.IURLService),Ie=he.get(J.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:v.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Le.push(Qe),!1):!0}),Re=this,Te=this.environmentMainService,qe=this.productService;ve.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===qe.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:v.URI.parse(Oe.query).path,query:""})),Re.shouldBlockURI(Oe))return!0;const vt=Re.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=Ee.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(d.isMacintosh&&Ee.getWindowCount()===0){const[ft]=Ee.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,le.getRemoteAuthority)(Oe)});return await ft.ready(),ve.open(Oe,Qe)}return!1}});const Ve=this._register(new we.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new u.StaticRouter(Oe=>Ve.getActiveClientId().then(Qe=>Oe===Qe)),tt=new at.URLHandlerRouter(et),it=Se.getChannel("urlHandler",tt);ve.registerHandler(new at.URLHandlerChannelClient(it)),this._register(new ht.ElectronURLListener(Me,ve,Ee,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,nt=global.macOpenFiles,rt=(0,K.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,st=!!_e["folder-uri"],lt=!!_e["file-uri"],$e=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?v.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?Ee.open({context:rt,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!st&&!lt?Ee.open({context:rt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):nt.length&&!Xe&&!st&&!lt?Ee.open({context:1,cli:_e,urisToOpen:nt.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0}):Ee.open({context:rt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:$e,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(he){return!!(he.authority===I.Schemas.file&&d.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,t.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===I.Schemas.file)return{fileUri:v.URI.file(he.fsPath)};if(he.authority===I.Schemas.vscodeRemote){const Se=he.path.indexOf(y.posix.sep,1);if(Se!==-1){const Ee=he.path.substring(1,Se),ve=he.path.substring(Se),Ie=v.URI.from({scheme:I.Schemas.vscodeRemote,authority:Ee,path:ve,query:he.query,fragment:he.fragment});return(0,ye.hasWorkspaceFileExtension)(ve)?{workspaceUri:Ie}:/:[\d]+$/.test(ve)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(he){try{if((0,L.statSync)(he).isDirectory())return{folderUri:v.URI.file(he)};if((0,ye.hasWorkspaceFileExtension)(he))return{workspaceUri:v.URI.file(he)}}catch(Se){}return{fileUri:v.URI.file(he)}}async afterWindowOpen(he,Se){this.lifecycleMainService.phase=3;let Ee=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const ve=he.get(pe.ITelemetryService);this._register(Se.onDidError(({type:Me,details:Re})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(Te)),ve.publicLog2("sharedprocesserror",{type:Me,reason:Re?.reason,code:Re?.exitCode,visible:Se.isVisible(),shuttingdown:Ee})}));const Ie=this.productService.win32MutexName;if(d.isWindows&&Ie)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Re=new Me(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(I.Schemas.vscodeRemoteResource,(Me,Re)=>{Re({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const Le=he.get(Ae.IUpdateService);(Le instanceof ot.Win32UpdateService||Le instanceof Ge.LinuxUpdateService||Le instanceof Ce.DarwinUpdateService)&&Le.initialize(),(0,ee.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,w.stripComments)(Re))["enable-crash-reporter"]===void 0){const Ve=(0,ke.getTelemetryLevel)(this.configurationService)>=2,et=typeof Ve=="boolean"?Ve:!0,tt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${et},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],it=Re.substring(0,Re.length-2).concat(`,
`,tt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(it))}}catch(Me){this.logService.error(Me)}}stopTracingEventually(he,Se){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=he.get(C.IDialogMainService);let ve=!1;const Ie=async Me=>{if(ve)return;ve=!0;const Re=await p.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Re),buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,E.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Ie(!0),3e4);Promise.all(Se.map(Me=>Me.ready())).then(()=>{clearTimeout(Le),Ie(!1)})}};Ne=ue([ie(2,q.IInstantiationService),ie(3,_.ILogService),ie(4,oe.IEnvironmentMainService),ie(5,Y.ILifecycleMainService),ie(6,S.IConfigurationService),ie(7,ge.IStateMainService),ie(8,H.IFileService),ie(9,re.IProductService)],Ne),e.CodeApplication=Ne}),define(Z[242],x([0,1,14,32,30,9,68,17,31,43,34,10,8,73,3,33,25,19,35,56,238,11,16,189,198,24,54,161,20,183,184,70,174,72,22,93,6,181,94,45,21,55,186,96,222,50,224,75,195,39,226,60,61,204]),function(V,e,p,L,k,M,b,n,f,w,t,P,I,y,d,g,E,v,c,h,a,u,i,l,r,s,o,m,S,D,R,T,C,G,ne,oe,K,ee,O,j,$,z,H,W,q,U,A,F,B,Y,_,N,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(te){console.error(te.message),p.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(me=>console.error(me));const[te,ae,ge,fe,de,Pe,pe]=this.createServices();try{try{await this.initServices(ge,fe,de)}catch(me){throw this.handleStartupDataDirError(ge,pe.nameLong,me),me}await te.invokeFunction(async me=>{const be=me.get(K.ILogService),ke=me.get(ne.ILifecycleMainService),Ae=me.get(S.IFileService),Ue=await this.claimInstance(be,ge,ke,te,pe,!0);return v.Promises.writeFile(ge.mainLockfile,String(process.pid)).catch(Ce=>{be.warn(`Error writing main lockfile: ${Ce.stack}`)}),Pe.logger=new O.SpdLogLogger("main",(0,I.join)(ge.logsPath,"main.log"),!0,Pe.getLevel()),(0,w.once)(ke.onWillShutdown)(Ce=>{Ae.dispose(),fe.dispose(),Ce.join(v.Promises.unlink(ge.mainLockfile).catch(()=>{}))}),te.createInstance(a.CodeApplication,Ue,ae).startup()})}catch(me){te.invokeFunction(this.quit,me)}}createServices(){const te=new G.ServiceCollection,ae={_serviceBrand:void 0,...j.default};te.set($.IProductService,ae);const ge=new s.EnvironmentMainService(this.resolveArgs(),ae),fe=this.patchEnvironment(ge);te.set(s.IEnvironmentMainService,ge);const de=new oe.BufferLogService,Pe=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(ge)),de]);process.once("exit",()=>Pe.dispose()),te.set(K.ILogService,Pe);const pe=new D.FileService(Pe);te.set(S.IFileService,pe);const me=new R.DiskFileSystemProvider(Pe);pe.registerProvider(P.Schemas.file,me),te.set(K.ILoggerService,new ee.LoggerService(Pe,pe));const be=new l.ConfigurationService(ge.settingsResource,pe);te.set(i.IConfigurationService,be),te.set(ne.ILifecycleMainService,new T.SyncDescriptor(ne.LifecycleMainService));const ke=new _.StateMainService(ge,Pe,pe);return te.set(Y.IStateMainService,ke),te.set(U.IRequestService,new T.SyncDescriptor(A.RequestMainService)),te.set(Q.IThemeMainService,new T.SyncDescriptor(Q.ThemeMainService)),te.set(F.ISignService,new T.SyncDescriptor(B.SignService)),te.set(W.ITunnelService,new T.SyncDescriptor(q.TunnelService)),te.set(z.IProtocolMainService,new T.SyncDescriptor(H.ProtocolMainService)),[new C.InstantiationService(te,!0),fe,ge,be,ke,de,ae]}patchEnvironment(te){const ae={VSCODE_IPC_HOOK:te.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ge=>{const fe=process.env[ge];typeof fe=="string"&&(ae[ge]=fe)}),Object.assign(process.env,ae),ae}initServices(te,ae,ge){return M.Promises.settled([Promise.all([te.extensionsPath,te.codeCachePath,te.logsPath,te.globalStorageHome.fsPath,te.workspaceStorageHome.fsPath,te.backupHome].map(fe=>fe?v.Promises.mkdir(fe,{recursive:!0}):void 0)),ae.initialize(),ge.init()])}async claimInstance(te,ae,ge,fe,de,Pe){let pe;try{(0,y.mark)("code/willStartMainServer"),pe=await(0,h.serve)(ae.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,w.once)(ge.onWillShutdown)(()=>pe.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,de.nameLong,me),me;let be;try{be=await(0,h.connect)(ae.mainIPCHandle,"main")}catch(Ue){if(!Pe||d.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,de.nameShort),(0,u.localize)(1,null),de.nameLong),Ue;try{(0,L.unlinkSync)(ae.mainIPCHandle)}catch(Ce){throw te.warn("Could not delete obsolete instance handle",Ce),Ce}return this.claimInstance(te,ae,ge,fe,de,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw te.error(Ue),be.dispose(),new Error(Ue)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,de.nameShort),(0,u.localize)(3,null),de.nameLong)},1e4));const Ae=c.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return fe.invokeFunction(async()=>{const Ue=new r.DiagnosticsService(N.NullTelemetryService,de),Ce=await Ae.getMainProcessInfo(),Ge=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ue.getDiagnostics(Ce,Ge);throw console.log(Be),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,te),te.trace("Sending env to running instance..."),await Ae.start(ae.args,process.env),be.dispose(),ke&&clearTimeout(ke),new n.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw te.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),pe}handleStartupDataDirError(te,ae,ge){if(ge.code==="EACCES"||ge.code==="EPERM"){const fe=(0,k.coalesce)([te.userDataPath,te.extensionsPath,h.XDG_RUNTIME_DIR]).map(de=>(0,t.getPathLabel)(de,te));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,b.toErrorMessage)(ge),fe.join(`
`)),ae)}}showStartupWarningDialog(te,ae,ge){p.dialog.showMessageBoxSync({title:ge,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,u.localize)(6,null))],message:te,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(te,ae){if(d.isWindows){const ge=await te.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ge);try{(await new Promise((fe,de)=>{V(["windows-foreground-love"],fe,de)})).allowSetForegroundWindow(ge)}catch(fe){ae.error(fe)}}}quit(te,ae){const ge=te.get(K.ILogService),fe=te.get(ne.ILifecycleMainService);let de=0;ae&&(ae.isExpected?ae.message&&ge.trace(ae.message):(de=1,ae.stack?ge.error(ae.stack):ge.error(`Startup error: ${ae.toString()}`))),fe.kill(de)}resolveArgs(){const te=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(te.wait&&!te.waitMarkerFilePath){const ae=(0,m.createWaitMarkerFile)(te.verbose);ae&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ae),te.waitMarkerFilePath=ae)}return te}validatePaths(te){if(te["open-url"]&&(te._urls=te._,te._=[]),!te.remote){const ae=this.doValidatePaths(te._,te.goto);te._=ae}return te}doValidatePaths(te,ae){const ge=(0,g.cwd)(),fe=te.map(pe=>{let me=String(pe),be;ae&&(be=(0,f.parseLineAndColumnAware)(me),me=be.path),me&&(me=this.preparePath(ge,me));const ke=(0,f.sanitizeFilePath)(me,ge),Ae=(0,I.basename)(ke);return Ae&&!(0,f.isValidBasename)(Ae)?null:ae&&be?(be.path=ke,this.toPath(be)):ke}),de=d.isWindows||d.isMacintosh,Pe=(0,k.distinct)(fe,pe=>pe&&de?pe.toLowerCase():pe||"");return(0,k.coalesce)(Pe)}preparePath(te,ae){return d.isWindows&&(ae=(0,E.rtrim)(ae,'"')),ae=(0,E.trim)((0,E.trim)(ae," "),"	"),d.isWindows&&(ae=(0,I.resolve)(te,ae),ae=(0,E.rtrim)(ae,".")),ae}toPath(te){const ae=[te.path];return typeof te.line=="number"&&ae.push(String(te.line)),typeof te.column=="number"&&ae.push(String(te.column)),ae.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/214ac689ca9874a8a4be386f73d5cb60e15af25e/core/vs/code/electron-main/main.js.map
