/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/base/common/types","vs/base/node/pfs","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/platform/environment/node/argvHelper","vs/base/node/watcher","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function($){for(var t=[],O=0,S=$.length;O<S;O++)t[O]=Z[$[O]];return t};define(Z[58],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function O(S,w){if(!S)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=O}),define(Z[45],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function O(R){return(T,l,d)=>{let p=null,I=null;if(typeof d.value=="function"?(p="value",I=d.value):typeof d.get=="function"&&(p="get",I=d.get),!I)throw new Error("not supported");d[p]=R(I,l)}}t.createDecorator=O;function S(R,T,l){let d=null,p=null;if(typeof l.value=="function"?(d="value",p=l.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(d="get",p=l.get),!p)throw new Error("not supported");const I=`$memoize$${T}`;l[d]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,g)}),this[I]}}t.memoize=S;function w(R,T,l){return O((d,p)=>{const I=`$debounce$${p}`,g=`$debounce$result$${p}`;return function(...P){this[g]||(this[g]=l?l():void 0),clearTimeout(this[I]),T&&(this[g]=T(this[g],...P),P=[this[g]]),this[I]=setTimeout(()=>{d.apply(this,P),this[g]=l?l():void 0},R)}})}t.debounce=w;function L(R,T,l){return O((d,p)=>{const I=`$throttle$timer$${p}`,g=`$throttle$result$${p}`,P=`$throttle$lastRun$${p}`,u=`$throttle$pending$${p}`;return function(...c){if(this[g]||(this[g]=l?l():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),T&&(this[g]=T(this[g],...c)),this[u])return;const E=this[P]+R;E<=Date.now()?(this[P]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0):(this[u]=!0,this[I]=setTimeout(()=>{this[u]=!1,this[P]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0},E-Date.now()))}})}t.throttle=L}),define(Z[59],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var O;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(O=t.ScanError||(t.ScanError={}));var S;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(S=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(e){e.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function R(e,i=!1){let n=0,r=e.length,a="",m=0,b=16,F=0;function v(te){let ue=0,ce=0;for(;ue<te;){const G=e.charCodeAt(n);if(G>=48&&G<=57)ce=ce*16+G-48;else if(G>=65&&G<=70)ce=ce*16+G-65+10;else if(G>=97&&G<=102)ce=ce*16+G-97+10;else break;n++,ue++}return ue<te&&(ce=-1),ce}function C(te){n=te,a="",m=0,b=16,F=0}function N(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return F=3,e.substring(te,n);let ue=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;ue=n}else F=3;return e.substring(te,ue)}function W(){let te="",ue=n;for(;;){if(n>=r){te+=e.substring(ue,n),F=2;break}const ce=e.charCodeAt(n);if(ce===34){te+=e.substring(ue,n),n++;break}if(ce===92){if(te+=e.substring(ue,n),n++,n>=r){F=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const ne=v(4);ne>=0?te+=String.fromCharCode(ne):F=4;break;default:F=5}ue=n;continue}if(ce>=0&&ce<=31)if(l(ce)){te+=e.substring(ue,n),F=2;break}else F=6;n++}return te}function Y(){if(a="",F=0,m=n,n>=r)return m=r,b=17;let te=e.charCodeAt(n);if(T(te)){do n++,a+=String.fromCharCode(te),te=e.charCodeAt(n);while(T(te));return b=15}if(l(te))return n++,a+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),b=14;switch(te){case 123:return n++,b=1;case 125:return n++,b=2;case 91:return n++,b=3;case 93:return n++,b=4;case 58:return n++,b=6;case 44:return n++,b=5;case 34:return n++,a=W(),b=10;case 47:const ue=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!l(e.charCodeAt(n));)n++;return a=e.substring(ue,n),b=12}if(e.charCodeAt(n+1)===42){n+=2;const ce=r-1;let G=!1;for(;n<ce;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,F=1),a=e.substring(ue,n),b=13}return a+=String.fromCharCode(te),n++,b=16;case 45:if(a+=String.fromCharCode(te),n++,n===r||!d(e.charCodeAt(n)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),b=11;default:for(;n<r&&ie(te);)n++,te=e.charCodeAt(n);if(m!==n){switch(a=e.substring(m,n),a){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return a+=String.fromCharCode(te),n++,b=16}}function ie(te){if(T(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let te;do te=Y();while(te>=12&&te<=15);return te}return{setPosition:C,getPosition:()=>n,scan:i?oe:Y,getToken:()=>b,getTokenValue:()=>a,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>F}}t.createScanner=R;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var p;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(p||(p={}));function I(e,i){const n=[],r=new Object;let a;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function F(v,C,N,W){m.value=v,m.offset=C,m.length=N,m.type=W,m.colonOffset=void 0,a=m}try{h(e,{onObjectBegin:(v,C)=>{if(i<=v)throw r;a=void 0,b=i>v,n.push("")},onObjectProperty:(v,C,N)=>{if(i<C||(F(v,C,N,"property"),n[n.length-1]=v,i<=C+N))throw r},onObjectEnd:(v,C)=>{if(i<=v)throw r;a=void 0,n.pop()},onArrayBegin:(v,C)=>{if(i<=v)throw r;a=void 0,n.push(0)},onArrayEnd:(v,C)=>{if(i<=v)throw r;a=void 0,n.pop()},onLiteralValue:(v,C,N)=>{if(i<C||(F(v,C,N,s(v)),i<=C+N))throw r},onSeparator:(v,C,N)=>{if(i<=C)throw r;if(v===":"&&a&&a.type==="property")a.colonOffset=C,b=!1,a=void 0;else if(v===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(b=!0,n[n.length-1]=""),a=void 0}}})}catch(v){if(v!==r)throw v}return{path:n,previousNode:a,isAtPropertyKey:b,matches:v=>{let C=0;for(let N=0;C<v.length&&N<n.length;N++)if(v[C]===n[N]||v[C]==="*")C++;else if(v[C]!=="**")return!1;return C===v.length}}}t.getLocation=I;function g(e,i=[],n=L.DEFAULT){let r=null,a=[];const m=[];function b(v){Array.isArray(a)?a.push(v):r!==null&&(a[r]=v)}return h(e,{onObjectBegin:()=>{const v={};b(v),m.push(a),a=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const v=[];b(v),m.push(a),a=v,r=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:b,onError:(v,C,N)=>{i.push({error:v,offset:C,length:N})}},n),a[0]}t.parse=g;function P(e,i=[],n=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function m(v){return r.children.push(v),v}h(e,{onObjectBegin:v=>{r=m({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,C,N)=>{r=m({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:C,length:N,parent:r})},onObjectEnd:(v,C)=>{r.length=v+C-r.offset,r=r.parent,a(v+C)},onArrayBegin:(v,C)=>{r=m({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,C)=>{r.length=v+C-r.offset,r=r.parent,a(v+C)},onLiteralValue:(v,C,N)=>{m({type:s(v),offset:C,length:N,parent:r,value:v}),a(C+N)},onSeparator:(v,C,N)=>{r.type==="property"&&(v===":"?r.colonOffset=C:v===","&&a(C))},onError:(v,C,N)=>{i.push({error:v,offset:C,length:N})}},n);const F=r.children[0];return F&&delete F.parent,F}t.parseTree=P;function u(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===r){n=m.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=u;function c(e){if(!e.parent||!e.parent.children)return[];const i=c(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=c;function E(e){switch(e.type){case"array":return e.children.map(E);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=E(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=E;function y(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=y;function f(e,i,n=!1){if(y(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const m=f(r[a],i,n);if(m)return m}return e}}t.findNodeAtOffset=f;function h(e,i,n=L.DEFAULT){const r=R(e,!1);function a(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(B){return B?J=>B(J,r.getTokenOffset(),r.getTokenLength()):()=>!0}const b=a(i.onObjectBegin),F=m(i.onObjectProperty),v=a(i.onObjectEnd),C=a(i.onArrayBegin),N=a(i.onArrayEnd),W=m(i.onLiteralValue),Y=m(i.onSeparator),ie=a(i.onComment),oe=m(i.onError),te=n&&n.disallowComments,ue=n&&n.allowTrailingComma;function ce(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:te?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,J=[],q=[]){if(oe(B),J.length+q.length>0){let k=r.getToken();for(;k!==17;){if(J.indexOf(k)!==-1){ce();break}else if(q.indexOf(k)!==-1)break;k=ce()}}}function ne(B){const J=r.getTokenValue();return B?W(J):F(J),ce(),!0}function z(){switch(r.getToken()){case 11:let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch(J){G(2)}W(B);break;case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ce(),!0}function D(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(ne(!1),r.getToken()===6?(Y(":"),ce(),K()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function M(){b(),ce();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ce(),r.getToken()===2&&ue)break}else B&&G(6,[],[]);D()||G(4,[],[2,5]),B=!0}return v(),r.getToken()!==2?G(7,[2],[]):ce(),!0}function U(){C(),ce();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ce(),r.getToken()===4&&ue)break}else B&&G(6,[],[]);K()||G(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?G(8,[4],[]):ce(),!0}function K(){switch(r.getToken()){case 3:return U();case 1:return M();case 10:return ne(!0);default:return z()}}return ce(),r.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):K()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=h;function o(e,i){let n=R(e),r=[],a,m=0,b;do switch(b=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:m!==b&&r.push(e.substring(m,b)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),m=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(w){const L=[];typeof w=="number"&&L.push("code/timeOrigin",w);function R(l){L.push(l,Date.now())}function T(){const l=[];for(let d=0;d<L.length;d+=2)l.push({name:L[d],startTime:L[d+1]});return l}return{mark:R,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(w+R.startTime)});return L}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function O(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=O(S))}(),define(Z[60],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var O;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(O=t.Source||(t.Source={}));var S;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(S=t.TerminateResponseCode||(t.TerminateResponseCode={}));function w(L,...R){const T=R.reduce((p,I)=>(p[I]=!0,p),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(p=>!T[p]).forEach(p=>{for(let I=0;I<l.length;I++)if(p.search(l[I])!==-1){delete L[p];break}})}t.sanitizeProcessEnvironment=w}),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var O=t();for(var S in O)(typeof exports=="object"?exports:$)[S]=O[S]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function O(S){if(t[S])return t[S].exports;var w=t[S]={i:S,l:!1,exports:{}};return $[S].call(w.exports,w,w.exports,O),w.l=!0,w.exports}return O.m=$,O.c=t,O.d=function(S,w,L){O.o(S,w)||Object.defineProperty(S,w,{enumerable:!0,get:L})},O.r=function(S){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},O.t=function(S,w){if(1&w&&(S=O(S)),8&w||4&w&&typeof S=="object"&&S&&S.__esModule)return S;var L=Object.create(null);if(O.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:S}),2&w&&typeof S!="string")for(var R in S)O.d(L,R,function(T){return S[T]}.bind(null,R));return L},O.n=function(S){var w=S&&S.__esModule?function(){return S.default}:function(){return S};return O.d(w,"a",w),w},O.o=function(S,w){return Object.prototype.hasOwnProperty.call(S,w)},O.p="",O(O.s=0)}([function($,t,O){(function(S){var w;t=$.exports=q,w=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],l=t.src=[],d=0,p=d++;l[p]="0|[1-9]\\d*";var I=d++;l[I]="[0-9]+";var g=d++;l[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=d++;l[P]="("+l[p]+")\\.("+l[p]+")\\.("+l[p]+")";var u=d++;l[u]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var c=d++;l[c]="(?:"+l[p]+"|"+l[g]+")";var E=d++;l[E]="(?:"+l[I]+"|"+l[g]+")";var y=d++;l[y]="(?:-("+l[c]+"(?:\\."+l[c]+")*))";var f=d++;l[f]="(?:-?("+l[E]+"(?:\\."+l[E]+")*))";var h=d++;l[h]="[0-9A-Za-z-]+";var o=d++;l[o]="(?:\\+("+l[h]+"(?:\\."+l[h]+")*))";var s=d++,e="v?"+l[P]+l[y]+"?"+l[o]+"?";l[s]="^"+e+"$";var i="[v=\\s]*"+l[u]+l[f]+"?"+l[o]+"?",n=d++;l[n]="^"+i+"$";var r=d++;l[r]="((?:<|>)?=?)";var a=d++;l[a]=l[I]+"|x|X|\\*";var m=d++;l[m]=l[p]+"|x|X|\\*";var b=d++;l[b]="[v=\\s]*("+l[m]+")(?:\\.("+l[m]+")(?:\\.("+l[m]+")(?:"+l[y]+")?"+l[o]+"?)?)?";var F=d++;l[F]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[f]+")?"+l[o]+"?)?)?";var v=d++;l[v]="^"+l[r]+"\\s*"+l[b]+"$";var C=d++;l[C]="^"+l[r]+"\\s*"+l[F]+"$";var N=d++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=d++;l[W]="(?:~>?)";var Y=d++;l[Y]="(\\s*)"+l[W]+"\\s+",T[Y]=new RegExp(l[Y],"g");var ie=d++;l[ie]="^"+l[W]+l[b]+"$";var oe=d++;l[oe]="^"+l[W]+l[F]+"$";var te=d++;l[te]="(?:\\^)";var ue=d++;l[ue]="(\\s*)"+l[te]+"\\s+",T[ue]=new RegExp(l[ue],"g");var ce=d++;l[ce]="^"+l[te]+l[b]+"$";var G=d++;l[G]="^"+l[te]+l[F]+"$";var ne=d++;l[ne]="^"+l[r]+"\\s*("+i+")$|^$";var z=d++;l[z]="^"+l[r]+"\\s*("+e+")$|^$";var D=d++;l[D]="(\\s*)"+l[r]+"\\s*("+i+"|"+l[b]+")",T[D]=new RegExp(l[D],"g");var M=d++;l[M]="^\\s*("+l[b]+")\\s+-\\s+("+l[b]+")\\s*$";var U=d++;l[U]="^\\s*("+l[F]+")\\s+-\\s+("+l[F]+")\\s*$";var K=d++;l[K]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)w(B,l[B]),T[B]||(T[B]=new RegExp(l[B]));function J(x,_){if(x instanceof q)return x;if(typeof x!="string"||x.length>L||!(_?T[n]:T[s]).test(x))return null;try{return new q(x,_)}catch(H){return null}}function q(x,_){if(x instanceof q){if(x.loose===_)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof q))return new q(x,_);w("SemVer",x,_),this.loose=_;var H=x.trim().match(_?T[n]:T[s]);if(!H)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var he=+ae;if(he>=0&&he<R)return he}return ae}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=J,t.valid=function(x,_){var H=J(x,_);return H?H.version:null},t.clean=function(x,_){var H=J(x.trim().replace(/^[=v]+/,""),_);return H?H.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(x){return w("SemVer.compare",this.version,this.loose,x),x instanceof q||(x=new q(x,this.loose)),this.compareMain(x)||this.comparePre(x)},q.prototype.compareMain=function(x){return x instanceof q||(x=new q(x,this.loose)),A(this.major,x.major)||A(this.minor,x.minor)||A(this.patch,x.patch)},q.prototype.comparePre=function(x){if(x instanceof q||(x=new q(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var _=0;do{var H=this.prerelease[_],ae=x.prerelease[_];if(w("prerelease compare",_,H,ae),H===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if(H===void 0)return-1;if(H!==ae)return A(H,ae)}while(++_)},q.prototype.inc=function(x,_){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,_,H,ae){typeof H=="string"&&(ae=H,H=void 0);try{return new q(x,H).inc(_,ae).version}catch(he){return null}},t.diff=function(x,_){if(Q(x,_))return null;var H=J(x),ae=J(_);if(H.prerelease.length||ae.prerelease.length){for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==ae[he])return"pre"+he;return"prerelease"}for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==ae[he])return he},t.compareIdentifiers=A;var k=/^[0-9]+$/;function A(x,_){var H=k.test(x),ae=k.test(_);return H&&ae&&(x=+x,_=+_),H&&!ae?-1:ae&&!H?1:x<_?-1:x>_?1:0}function j(x,_,H){return new q(x,H).compare(new q(_,H))}function V(x,_,H){return j(x,_,H)>0}function X(x,_,H){return j(x,_,H)<0}function Q(x,_,H){return j(x,_,H)===0}function se(x,_,H){return j(x,_,H)!==0}function re(x,_,H){return j(x,_,H)>=0}function me(x,_,H){return j(x,_,H)<=0}function ye(x,_,H,ae){var he;switch(_){case"===":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x===H;break;case"!==":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x!==H;break;case"":case"=":case"==":he=Q(x,H,ae);break;case"!=":he=se(x,H,ae);break;case">":he=V(x,H,ae);break;case">=":he=re(x,H,ae);break;case"<":he=X(x,H,ae);break;case"<=":he=me(x,H,ae);break;default:throw new TypeError("Invalid operator: "+_)}return he}function fe(x,_){if(x instanceof fe){if(x.loose===_)return x;x=x.value}if(!(this instanceof fe))return new fe(x,_);w("comparator",x,_),this.loose=_,this.parse(x),this.semver===Pe?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(x,_){return A(_,x)},t.major=function(x,_){return new q(x,_).major},t.minor=function(x,_){return new q(x,_).minor},t.patch=function(x,_){return new q(x,_).patch},t.compare=j,t.compareLoose=function(x,_){return j(x,_,!0)},t.rcompare=function(x,_,H){return j(_,x,H)},t.sort=function(x,_){return x.sort(function(H,ae){return t.compare(H,ae,_)})},t.rsort=function(x,_){return x.sort(function(H,ae){return t.rcompare(H,ae,_)})},t.gt=V,t.lt=X,t.eq=Q,t.neq=se,t.gte=re,t.lte=me,t.cmp=ye,t.Comparator=fe;var Pe={};function pe(x,_){if(x instanceof pe)return x.loose===_?x:new pe(x.raw,_);if(x instanceof fe)return new pe(x.value,_);if(!(this instanceof pe))return new pe(x,_);if(this.loose=_,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Ee(x){return!x||x.toLowerCase()==="x"||x==="*"}function Ae(x,_,H,ae,he,Re,we,Oe,Ie,Ce,Ne,Le,Te){return((_=Ee(H)?"":Ee(ae)?">="+H+".0.0":Ee(he)?">="+H+"."+ae+".0":">="+_)+" "+(Oe=Ee(Ie)?"":Ee(Ce)?"<"+(+Ie+1)+".0.0":Ee(Ne)?"<"+Ie+"."+(+Ce+1)+".0":Le?"<="+Ie+"."+Ce+"."+Ne+"-"+Le:"<="+Oe)).trim()}function Me(x,_){for(var H=0;H<x.length;H++)if(!x[H].test(_))return!1;if(_.prerelease.length){for(H=0;H<x.length;H++)if(w(x[H].semver),x[H].semver!==Pe&&x[H].semver.prerelease.length>0){var ae=x[H].semver;if(ae.major===_.major&&ae.minor===_.minor&&ae.patch===_.patch)return!0}return!1}return!0}function Ue(x,_,H){try{_=new pe(_,H)}catch(ae){return!1}return _.test(x)}function ze(x,_,H,ae){var he,Re,we,Oe,Ie;switch(x=new q(x,ae),_=new pe(_,ae),H){case">":he=V,Re=me,we=X,Oe=">",Ie=">=";break;case"<":he=X,Re=re,we=V,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,_,ae))return!1;for(var Ce=0;Ce<_.set.length;++Ce){var Ne=_.set[Ce],Le=null,Te=null;if(Ne.forEach(function(Fe){Fe.semver===Pe&&(Fe=new fe(">=0.0.0")),Le=Le||Fe,Te=Te||Fe,he(Fe.semver,Le.semver,ae)?Le=Fe:we(Fe.semver,Te.semver,ae)&&(Te=Fe)}),Le.operator===Oe||Le.operator===Ie||(!Te.operator||Te.operator===Oe)&&Re(x,Te.semver)||Te.operator===Ie&&we(x,Te.semver))return!1}return!0}fe.prototype.parse=function(x){var _=this.loose?T[ne]:T[z],H=x.match(_);if(!H)throw new TypeError("Invalid comparator: "+x);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new q(H[2],this.loose):this.semver=Pe},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(x){return w("Comparator.test",x,this.loose),this.semver===Pe||(typeof x=="string"&&(x=new q(x,this.loose)),ye(x,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(x,_){if(!(x instanceof fe))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new pe(x.value,_),Ue(this.value,H,_);if(x.operator==="")return H=new pe(this.value,_),Ue(x.semver,H,_);var ae=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Re=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=ye(this.semver,"<",x.semver,_)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ie=ye(this.semver,">",x.semver,_)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ae||he||Re&&we||Oe||Ie},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(x){var _=this.loose;x=x.trim(),w("range",x,_);var H=_?T[U]:T[M];x=x.replace(H,Ae),w("hyphen replace",x),x=x.replace(T[D],"$1$2$3"),w("comparator trim",x,T[D]),x=(x=(x=x.replace(T[Y],"$1~")).replace(T[ue],"$1^")).split(/\s+/).join(" ");var ae=_?T[ne]:T[z],he=x.split(" ").map(function(Re){return function(we,Oe){return w("comp",we),we=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(Ne){return function(Le,Te){w("caret",Le,Te);var Fe=Te?T[G]:T[ce];return Le.replace(Fe,function(ke,ge,ve,Se,be){var De;return w("caret",Le,ke,ge,ve,Se,be),Ee(ge)?De="":Ee(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?De=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":be?(w("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+be+" <"+(+ge+1)+".0.0"):(w("no pr"),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+" <"+(+ge+1)+".0.0"),w("caret return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),w("caret",we),we=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(Ne){return function(Le,Te){var Fe=Te?T[oe]:T[ie];return Le.replace(Fe,function(ke,ge,ve,Se,be){var De;return w("tilde",Le,ke,ge,ve,Se,be),Ee(ge)?De="":Ee(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?De=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":be?(w("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0"):De=">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0",w("tilde return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),w("tildes",we),we=function(Ie,Ce){return w("replaceXRanges",Ie,Ce),Ie.split(/\s+/).map(function(Ne){return function(Le,Te){Le=Le.trim();var Fe=Te?T[C]:T[v];return Le.replace(Fe,function(ke,ge,ve,Se,be,De){w("xRange",Le,ke,ge,ve,Se,be,De);var je=Ee(ve),Ve=je||Ee(Se),We=Ve||Ee(be);return ge==="="&&We&&(ge=""),je?ke=ge===">"||ge==="<"?"<0.0.0":"*":ge&&We?(Ve&&(Se=0),We&&(be=0),ge===">"?(ge=">=",Ve?(ve=+ve+1,Se=0,be=0):We&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?ve=+ve+1:Se=+Se+1),ke=ge+ve+"."+Se+"."+be):Ve?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":We&&(ke=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),w("xRange return",ke),ke})}(Ne,Ce)}).join(" ")}(we,Oe),w("xrange",we),we=function(Ie,Ce){return w("replaceStars",Ie,Ce),Ie.trim().replace(T[K],"")}(we,Oe),w("stars",we),we}(Re,_)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Re){return!!Re.match(ae)})),he=he.map(function(Re){return new fe(Re,_)})},pe.prototype.intersects=function(x,_){if(!(x instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ae){return x.set.some(function(he){return he.every(function(Re){return ae.intersects(Re,_)})})})})},t.toComparators=function(x,_){return new pe(x,_).set.map(function(H){return H.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new q(x,this.loose));for(var _=0;_<this.set.length;_++)if(Me(this.set[_],x))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(x,_,H){var ae=null,he=null;try{var Re=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Re.test(we)&&(ae&&he.compare(we)!==-1||(he=new q(ae=we,H)))}),ae},t.minSatisfying=function(x,_,H){var ae=null,he=null;try{var Re=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Re.test(we)&&(ae&&he.compare(we)!==1||(he=new q(ae=we,H)))}),ae},t.validRange=function(x,_){try{return new pe(x,_).range||"*"}catch(H){return null}},t.ltr=function(x,_,H){return ze(x,_,"<",H)},t.gtr=function(x,_,H){return ze(x,_,">",H)},t.outside=ze,t.prerelease=function(x,_){var H=J(x,_);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(x,_,H){return x=new pe(x,H),_=new pe(_,H),x.intersects(_)},t.coerce=function(x){if(x instanceof q)return x;if(typeof x!="string")return null;var _=x.match(T[N]);return _==null?null:J((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,O(1))},function($,t){var O,S,w=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function T(E){if(O===setTimeout)return setTimeout(E,0);if((O===L||!O)&&setTimeout)return O=setTimeout,setTimeout(E,0);try{return O(E,0)}catch(y){try{return O.call(null,E,0)}catch(f){return O.call(this,E,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:L}catch(E){O=L}try{S=typeof clearTimeout=="function"?clearTimeout:R}catch(E){S=R}})();var l,d=[],p=!1,I=-1;function g(){p&&l&&(p=!1,l.length?d=l.concat(d):I=-1,d.length&&P())}function P(){if(!p){var E=T(g);p=!0;for(var y=d.length;y;){for(l=d,d=[];++I<y;)l&&l[I].run();I=-1,y=d.length}l=null,p=!1,function(f){if(S===clearTimeout)return clearTimeout(f);if((S===R||!S)&&clearTimeout)return S=clearTimeout,clearTimeout(f);try{S(f)}catch(h){try{return S.call(null,f)}catch(o){return S.call(this,f)}}}(E)}}function u(E,y){this.fun=E,this.array=y}function c(){}w.nextTick=function(E){var y=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)y[f-1]=arguments[f];d.push(new u(E,y)),d.length!==1||p||T(P)},u.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=c,w.addListener=c,w.once=c,w.off=c,w.removeListener=c,w.removeAllListeners=c,w.emit=c,w.prependListener=c,w.prependOnceListener=c,w.listeners=function(E){return[]},w.binding=function(E){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(E){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Z[37],ee([0,1,9,2]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function w(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=w;function L(h){const o=h;return o?w(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=L;function R(h,o){return new T(h,o)}t.newWriteableStream=R;class T{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,O.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function d(h,o,s){const e=[];let i;for(;(i=h.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return h.read()}}}t.peekReadable=d;function p(h,o){return new Promise((s,e)=>{const i=[];I(h,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=p;function I(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=I;function g(h,o){return new Promise((s,e)=>{const i=new S.DisposableStore,n=[],r=b=>{if(n.push(b),n.length>o)return i.dispose(),h.pause(),s({stream:h,buffer:n,ended:!1})},a=b=>e(b),m=()=>s({stream:h,buffer:n,ended:!0});i.add((0,S.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,S.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),i.add((0,S.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}t.peekStream=g;function P(h,o){const s=R(o);return s.end(h),s}t.toStream=P;function u(){const h=R(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=u;function c(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=c;function E(h,o,s){const e=R(s);return I(h,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=E;function y(h,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([h,i]):h)}}}t.prefixedReadable=y;function f(h,o,s){let e=!1;const i=R(s);return I(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([h,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(h)),i.end()}}),i}t.prefixedStream=f}),define(Z[17],ee([0,1,37]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const S=typeof Buffer!="undefined";let w,L;class R{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return S?new R(Buffer.allocUnsafe(r)):new R(new Uint8Array(r))}static wrap(r){return S&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new R(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&S?new R(Buffer.from(r)):(w||(w=new TextEncoder),new R(w.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let F=0,v=r.length;F<v;F++)a+=r[F].byteLength}const m=R.alloc(a);let b=0;for(let F=0,v=r.length;F<v;F++){const C=r[F];m.set(C,b),b+=C.byteLength}return m}toString(){return S?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(r,a){return new R(this.buffer.subarray(r,a))}set(r,a){r instanceof R?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,a){p(this.buffer,r,a)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,a){g(this.buffer,r,a)}readUInt8(r){return P(this.buffer,r)}writeUInt8(r,a){u(this.buffer,r,a)}}t.VSBuffer=R;function T(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=T;function l(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=l;function d(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=d;function p(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=p;function I(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=I;function g(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=g;function P(n,r){return n[r]}t.readUInt8=P;function u(n,r,a){n[a]=r}t.writeUInt8=u;function c(n){return O.consumeReadable(n,r=>R.concat(r))}t.readableToBuffer=c;function E(n){return O.toReadable(n)}t.bufferToReadable=E;function y(n){return O.consumeStream(n,r=>R.concat(r))}t.streamToBuffer=y;async function f(n){return n.ended?R.concat(n.buffer):R.concat([...n.buffer,await y(n.stream)])}t.bufferedStreamToBuffer=f;function h(n){return O.toStream(n,r=>R.concat(r))}t.bufferToStream=h;function o(n){return O.transform(n,{data:r=>typeof r=="string"?R.fromString(r):R.wrap(r)},r=>R.concat(r))}t.streamToBufferReadableStream=o;function s(n){return O.newWriteableStream(r=>R.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return O.prefixedReadable(n,r,a=>R.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return O.prefixedStream(n,r,a=>R.concat(a))}t.prefixedBufferStream=i}),define(Z[18],ee([0,1,11]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const E=Array.isArray(c)?[]:{};return Object.keys(c).forEach(y=>{c[y]&&typeof c[y]=="object"?E[y]=S(c[y]):E[y]=c[y]}),E}t.deepClone=S;function w(c){if(!c||typeof c!="object")return c;const E=[c];for(;E.length>0;){const y=E.shift();Object.freeze(y);for(const f in y)if(L.call(y,f)){const h=y[f];typeof h=="object"&&!Object.isFrozen(h)&&E.push(h)}}return c}t.deepFreeze=w;const L=Object.prototype.hasOwnProperty;function R(c,E){return T(c,E,new Set)}t.cloneAndChange=R;function T(c,E,y){if((0,O.isUndefinedOrNull)(c))return c;const f=E(c);if(typeof f!="undefined")return f;if((0,O.isArray)(c)){const h=[];for(const o of c)h.push(T(o,E,y));return h}if((0,O.isObject)(c)){if(y.has(c))throw new Error("Cannot clone recursive data-structure");y.add(c);const h={};for(let o in c)L.call(c,o)&&(h[o]=T(c[o],E,y));return y.delete(c),h}return c}function l(c,E,y=!0){return(0,O.isObject)(c)?((0,O.isObject)(E)&&Object.keys(E).forEach(f=>{f in c?y&&((0,O.isObject)(c[f])&&(0,O.isObject)(E[f])?l(c[f],E[f],y):c[f]=E[f]):c[f]=E[f]}),c):E}t.mixin=l;function d(c,E){if(c===E)return!0;if(c==null||E===null||E===void 0||typeof c!=typeof E||typeof c!="object"||Array.isArray(c)!==Array.isArray(E))return!1;let y,f;if(Array.isArray(c)){if(c.length!==E.length)return!1;for(y=0;y<c.length;y++)if(!d(c[y],E[y]))return!1}else{const h=[];for(f in c)h.push(f);h.sort();const o=[];for(f in E)o.push(f);if(o.sort(),!d(h,o))return!1;for(y=0;y<h.length;y++)if(!d(c[h[y]],E[h[y]]))return!1}return!0}t.equals=d;function p(c){const E=new Set;return JSON.stringify(c,(y,f)=>{if((0,O.isObject)(f)||Array.isArray(f)){if(E.has(f))return"[Circular]";E.add(f)}return f})}t.safeStringify=p;function I(c,E,y){const f=E(c);return typeof f=="undefined"?y:f}t.getOrDefault=I;function g(c,E){const y=Object.create(null);return!c||!E||Object.keys(E).forEach(h=>{const o=c[h],s=E[h];d(o,s)||(y[h]=s)}),y}t.distinct=g;function P(c,E){const y=E.toLowerCase(),f=Object.keys(c).find(h=>h.toLowerCase()===y);return f?c[f]:c[E]}t.getCaseInsensitive=P;function u(c,E){const y=Object.create(null);for(const f of Object.keys(c))E(f,c[f])&&(y[f]=c[f]);return y}t.filter=u}),define(Z[61],ee([0,1,7]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function S(d){const p=d;return p&&typeof p.type=="string"&&typeof p.severity=="string"}t.isRemoteConsoleLog=S;function w(d){const p=[];let I;try{const g=JSON.parse(d.arguments),P=g[g.length-1];P&&P.__$stack&&(g.pop(),I=P.__$stack),p.push(...g)}catch(g){p.push("Unable to log remote console arguments",d.arguments)}return{args:p,stack:I}}t.parse=w;function L(d){if(typeof d!="string")return L(w(d).stack);const p=d;if(p){const I=R(p),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:O.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=L;function R(d){if(!d)return d;const p=d.indexOf(`
`);return p===-1?d:d.substring(0,p)}function T(d,p){const{args:I,stack:g}=w(d),P=typeof I[0]=="string"&&I.length===1;let u=R(g);u&&(u=`(${u.trim()})`);let c=[];if(typeof I[0]=="string"?u&&P?c=[`%c[${p}] %c${I[0]} %c${u}`,l("blue"),l(""),l("grey")]:c=[`%c[${p}] %c${I[0]}`,l("blue"),l(""),...I.slice(1)]:c=[`%c[${p}]%`,l("blue"),...I],u&&!P&&c.push(u),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,c)}t.log=T;function l(d){return`color: ${d}`}}),define(Z[62],ee([0,1,17,22,7]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function L(p){return JSON.stringify(p,l)}t.stringify=L;function R(p){let I=JSON.parse(p);return I=d(I),I}t.parse=R;var T;(function(p){p[p.Uri=1]="Uri",p[p.Regexp=2]="Regexp",p[p.ScmResource=3]="ScmResource",p[p.ScmResourceGroup=4]="ScmResourceGroup",p[p.ScmProvider=5]="ScmProvider",p[p.CommentController=6]="CommentController",p[p.CommentThread=7]="CommentThread",p[p.CommentThreadReply=8]="CommentThreadReply",p[p.CommentNode=9]="CommentNode",p[p.CommentThreadNode=10]="CommentThreadNode",p[p.TimelineActionContext=11]="TimelineActionContext",p[p.NotebookCellActionContext=12]="NotebookCellActionContext",p[p.TestItemContext=13]="TestItemContext"})(T=t.MarshalledId||(t.MarshalledId={}));function l(p,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,S.regExpFlags)(I)}:I}function d(p,I=0){if(!p||I>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return w.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof O.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let g=0;g<p.length;++g)p[g]=d(p[g],I+1);else for(const g in p)Object.hasOwnProperty.call(p,g)&&(p[g]=d(p[g],I+1))}return p}t.revive=d}),define(Z[63],ee([0,1,3,38,46,4,22]),function($,t,O,S,w,L,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const l="**",d="/",p="[/\\\\]",I="[^/\\\\]",g=/\//g;function P(D){switch(D){case 0:return"";case 1:return`${I}*?`;default:return`(?:${p}|${I}+${p}|${p}${I}+)*?`}}function u(D,M){if(!D)return[];const U=[];let K=!1,B=!1,J="";for(const q of D){switch(q){case M:if(!K&&!B){U.push(J),J="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":B=!0;break;case"]":B=!1;break}J+=q}return J&&U.push(J),U}t.splitGlobAware=u;function c(D){if(!D)return"";let M="";const U=u(D,d);if(U.every(K=>K===l))M=".*";else{let K=!1;U.forEach((B,J)=>{if(B===l){K||(M+=P(2),K=!0);return}let q=!1,k="",A=!1,j="";for(const V of B){if(V!=="}"&&q){k+=V;continue}if(A&&(V!=="]"||!j)){let X;V==="-"?X=V:(V==="^"||V==="!")&&!j?X="^":V===d?X="":X=R.escapeRegExpCharacters(V),j+=X;continue}switch(V){case"{":q=!0;continue;case"[":A=!0;continue;case"}":M+=`(?:${u(k,",").map(se=>c(se)).join("|")})`,q=!1,k="";break;case"]":M+="["+j+"]",A=!1,j="";break;case"?":M+=I;continue;case"*":M+=P(1);continue;default:M+=R.escapeRegExpCharacters(V)}}J<U.length-1&&(U[J+1]!==l||J+2<U.length)&&(M+=p),K=!1})}return M}const E=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),i=function(){return!1},n=function(){return null};function r(D,M){if(!D)return n;let U;typeof D!="string"?U=D.pattern:U=D,U=U.trim();const K=`${U}_${!!M.trimForExclusions}`;let B=e.get(K);if(B)return a(B,D);let J;if(E.test(U)){const q=U.substr(4);B=function(k,A){return typeof k=="string"&&k.endsWith(q)?U:null}}else(J=y.exec(m(U,M)))?B=b(J[1],U):(M.trimForExclusions?h:f).test(U)?B=F(U,M):(J=o.exec(m(U,M)))?B=v(J[1].substr(1),U,!0):(J=s.exec(m(U,M)))?B=v(J[1],U,!1):B=C(U);return e.set(K,B),a(B,D)}function a(D,M){return typeof M=="string"?D:function(U,K){return S.isEqualOrParent(U,M.base)?D(L.relative(M.base,U),K):null}}function m(D,M){return M.trimForExclusions&&D.endsWith("/**")?D.substr(0,D.length-2):D}function b(D,M){const U=`/${D}`,K=`\\${D}`,B=function(q,k){return typeof q!="string"?null:k?k===D?M:null:q===D||q.endsWith(U)||q.endsWith(K)?M:null},J=[D];return B.basenames=J,B.patterns=[M],B.allBasenames=J,B}function F(D,M){const U=z(D.slice(1,-1).split(",").map(k=>r(k,M)).filter(k=>k!==n),D),K=U.length;if(!K)return n;if(K===1)return U[0];const B=function(k,A){for(let j=0,V=U.length;j<V;j++)if(U[j](k,A))return D;return null},J=U.find(k=>!!k.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((k,A)=>A.allPaths?k.concat(A.allPaths):k,[]);return q.length&&(B.allPaths=q),B}function v(D,M,U){const K=L.sep===L.posix.sep,B=K?D:D.replace(g,L.sep),J=L.sep+B,q=L.posix.sep+D,k=U?function(A,j){return typeof A=="string"&&(A===B||A.endsWith(J)||!K&&(A===D||A.endsWith(q)))?M:null}:function(A,j){return typeof A=="string"&&(A===B||!K&&A===D)?M:null};return k.allPaths=[(U?"*/":"./")+D],k}function C(D){try{const M=new RegExp(`^${c(D)}$`);return function(U){return M.lastIndex=0,typeof U=="string"&&M.test(U)?D:null}}catch(M){return n}}function N(D,M,U){return!D||typeof M!="string"?!1:W(D)(M,void 0,U)}t.match=N;function W(D,M={}){if(!D)return i;if(typeof D=="string"||te(D)){const U=r(D,M);if(U===n)return i;const K=function(B,J){return!!U(B,J)};return U.allBasenames&&(K.allBasenames=U.allBasenames),U.allPaths&&(K.allPaths=U.allPaths),K}return G(D,M)}t.parse=W;function Y(D){if(!D)return;let M;return U=>(M||(M=(D()||Promise.resolve([])).then(K=>K?oe(K):{})),M.then(K=>!!K[U]))}t.hasSiblingPromiseFn=Y;function ie(D){if(!D)return;let M;return U=>{if(!M){const K=D();M=K?oe(K):{}}return!!M[U]}}t.hasSiblingFn=ie;function oe(D){const M={};for(const U of D)M[U]=!0;return M}function te(D){const M=D;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=te;function ue(D){return D.allBasenames||[]}t.getBasenameTerms=ue;function ce(D){return D.allPaths||[]}t.getPathTerms=ce;function G(D,M){const U=z(Object.getOwnPropertyNames(D).map(k=>ne(k,D[k],M)).filter(k=>k!==n)),K=U.length;if(!K)return n;if(!U.some(k=>!!k.requiresSiblings)){if(K===1)return U[0];const k=function(V,X){for(let Q=0,se=U.length;Q<se;Q++){const re=U[Q](V,X);if(re)return re}return null},A=U.find(V=>!!V.allBasenames);A&&(k.allBasenames=A.allBasenames);const j=U.reduce((V,X)=>X.allPaths?V.concat(X.allPaths):V,[]);return j.length&&(k.allPaths=j),k}const B=function(k,A,j){let V;for(let X=0,Q=U.length;X<Q;X++){const se=U[X];se.requiresSiblings&&j&&(A||(A=L.basename(k)),V||(V=A.substr(0,A.length-L.extname(k).length)));const re=se(k,A,V,j);if(re)return re}return null},J=U.find(k=>!!k.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((k,A)=>A.allPaths?k.concat(A.allPaths):k,[]);return q.length&&(B.allPaths=q),B}function ne(D,M,U){if(M===!1)return n;const K=r(D,U);if(K===n)return n;if(typeof M=="boolean")return K;if(M){const B=M.when;if(typeof B=="string"){const J=(q,k,A,j)=>{if(!j||!K(q,k))return null;const V=B.replace("$(basename)",A),X=j(V);return(0,O.isThenable)(X)?X.then(Q=>Q?D:null):X?D:null};return J.requiresSiblings=!0,J}}return K}function z(D,M){const U=D.filter(k=>!!k.basenames);if(U.length<2)return D;const K=U.reduce((k,A)=>{const j=A.basenames;return j?k.concat(j):k},[]);let B;if(M){B=[];for(let k=0,A=K.length;k<A;k++)B.push(M)}else B=U.reduce((k,A)=>{const j=A.patterns;return j?k.concat(j):k},[]);const J=function(k,A){if(typeof k!="string")return null;if(!A){let V;for(V=k.length;V>0;V--){const X=k.charCodeAt(V-1);if(X===47||X===92)break}A=k.substr(V)}const j=K.indexOf(A);return j!==-1?B[j]:null};J.basenames=K,J.patterns=B,J.allBasenames=K;const q=D.filter(k=>!k.basenames);return q.push(J),q}}),define(Z[64],ee([0,1,38,8,4,10,19,22,7]),function($,t,O,S,w,L,R,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(r,a,m){if(typeof r=="string"&&(r=l.URI.file(r)),m){const F=m.getWorkspaceFolder(r);if(F){const v=m.getWorkspace().folders.length>1;let C;if((0,R.isEqual)(F.uri,r)?C="":C=(0,R.relativePath)(F.uri,r),v){const N=F.name?F.name:(0,R.basename)(F.uri);C=C?N+" \u2022 "+C:N}return C}}if(r.scheme!==S.Schemas.file&&r.scheme!==S.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,O.hasDriveLetter)(r.fsPath))return(0,w.normalize)(I(r.fsPath));let b=(0,w.normalize)(r.fsPath);return!L.isWindows&&a?.userHome&&(b=P(b,a.userHome.fsPath)),b}t.getPathLabel=d;function p(r){if(!r)return;typeof r=="string"&&(r=l.URI.file(r));const a=(0,R.basename)(r)||(r.scheme===S.Schemas.file?r.fsPath:r.path);return L.isWindows&&(0,O.isRootOrDriveLetter)(a)?I(a):a}t.getBaseLabel=p;function I(r){return(0,O.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=I;let g=Object.create(null);function P(r,a){if(L.isWindows||!r||!a)return r;let m=g.original===a?g.normalized:void 0;return m||(m=`${(0,T.rtrim)(a,w.posix.sep)}${w.posix.sep}`,g={original:a,normalized:m}),(L.isLinux?r.startsWith(m):(0,T.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}t.tildify=P;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const c="\u2026",E="\\\\",y="~";function f(r,a=w.sep){const m=new Array(r.length);let b=!1;for(let F=0;F<r.length;F++){let v=r[F];if(v===""){m[F]=`.${a}`;continue}if(!v){m[F]=v;continue}b=!0;let C="";v.indexOf(E)===0?(C=v.substr(0,v.indexOf(E)+E.length),v=v.substr(v.indexOf(E)+E.length)):v.indexOf(a)===0?(C=v.substr(0,v.indexOf(a)+a.length),v=v.substr(v.indexOf(a)+a.length)):v.indexOf(y)===0&&(C=v.substr(0,v.indexOf(y)+y.length),v=v.substr(v.indexOf(y)+y.length));const N=v.split(a);for(let W=1;b&&W<=N.length;W++)for(let Y=N.length-W;b&&Y>=0;Y--){b=!1;let ie=N.slice(Y,Y+W).join(a);for(let oe=0;!b&&oe<r.length;oe++)if(oe!==F&&r[oe]&&r[oe].indexOf(ie)>-1){const te=Y+W===N.length,ue=Y>0&&r[oe].indexOf(a)>-1?a+ie:ie,ce=r[oe].endsWith(ue);b=!te||ce}if(!b){let oe="";(N[0].endsWith(":")||C!=="")&&(Y===1&&(Y=0,W++,ie=N[0]+a+ie),Y>0&&(oe=N[0]+a),oe=C+oe),Y>0&&(oe=oe+c+a),oe=oe+ie,Y+W<N.length&&(oe=oe+a+c),m[F]=oe}}b&&(m[F]=v)}return m}t.shorten=f;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,a=Object.create(null)){const m=[];let b=!1,F="";for(const v of r)if(v==="$"||b&&v==="{")F&&m.push({value:F,type:h.TEXT}),F="",b=!0;else if(v==="}"&&b){const C=a[F];if(typeof C=="string")C.length&&m.push({value:C,type:h.VARIABLE});else if(C){const N=m[m.length-1];(!N||N.type!==h.SEPARATOR)&&m.push({value:C.label,type:h.SEPARATOR})}F="",b=!1}else F+=v;return F&&!b&&m.push({value:F,type:h.TEXT}),m.filter((v,C)=>{if(v.type===h.SEPARATOR){const N=m[C-1],W=m[C+1];return[N,W].every(Y=>Y&&(Y.type===h.VARIABLE||Y.type===h.TEXT)&&Y.value.length>0)}return!0}).map(v=>v.value).join("")}t.template=o;function s(r,a){return L.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return L.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):L.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?w.posix:w.win32,m=a.basename(r),b=a.dirname(r);return m.length?{name:m,parentPath:b}:{name:b,parentPath:""}}t.splitName=n}),define(Z[47],ee([0,1,127]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class S{constructor(L="utf8"){this.stringDecoder=new O.StringDecoder(L),this.remaining=null}write(L){const R=[],T=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(T.length<1)return R;let l=0,d,p=l;for(;p<T.length;)if(d=T.charCodeAt(p),d===13||d===10){if(R.push(T.substring(l,p)),p++,p<T.length){const I=d;d=T.charCodeAt(p),(I===13&&d===10||I===10&&d===13)&&p++}l=p}else p++;return this.remaining=l<T.length?T.substr(l):null,R}end(){return this.remaining}}t.LineDecoder=S}),define(Z[65],ee([0,1,48,4,22,12]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(p){const I=(0,S.dirname)(p);if(p===I)return p;const g=((0,S.basename)(p)||p).toLowerCase();try{const u=(0,L.readdirSync)(I).filter(c=>c.toLowerCase()===g);if(u.length===1){const c=R(I);if(c)return(0,S.join)(c,u[0])}else if(u.length>1){const c=u.indexOf(g);if(c>=0){const E=R(I);if(E)return(0,S.join)(E,u[c])}}}catch(P){}return null}t.realcaseSync=R;async function T(p){try{return await L.Promises.realpath(p)}catch(I){const g=d(p);return await L.Promises.access(g,O.constants.R_OK),g}}t.realpath=T;function l(p){try{return O.realpathSync(p)}catch(I){const g=d(p);return O.accessSync(g,O.constants.R_OK),g}}t.realpathSync=l;function d(p){return(0,w.rtrim)((0,S.normalize)(p),S.sep)}}),define(Z[66],ee([0,1,34,4,12]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,R=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class I{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:o});if(!e)return null;const i=S.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const b of await w.Promises.readdir(i)){let F=-1;if(s){const C=b.indexOf("-");if(C<0)continue;const N=b.substring(0,C);if(!L.test(N)||b.substring(C+1)!=="preview")continue;F=parseInt(N,10)}else{if(!L.test(b))continue;F=parseInt(b,10)}if(F<=n)continue;const v=S.join(i,b,"pwsh.exe");!await w.SymlinkSupport.existsFile(v)||(r=v,n=F)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",m=s?" Preview":"";return new I(r,`PowerShell${m}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=S.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const n of await w.Promises.readdir(s))if(e.test(n)){const r=S.join(s,n,"pwsh.exe");return new I(r,i)}return null}function c(){const o=S.join(O.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function E(){const o=S.join(process.env.windir,d===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*y(){let o=await P();o&&(yield o),o=await P({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=c(),o&&(yield o),o=await P({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await P({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=E(),o&&(yield o)}async function*f(){for await(const o of y())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=f;async function h(){for await(const o of f())return o;return null}t.getFirstAvailablePowerShellInstallation=h});var de=this&&this.__decorate||function($,t,O,S){var w=arguments.length,L=w<3?t:S===null?S=Object.getOwnPropertyDescriptor(t,O):S,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,t,O,S);else for(var T=$.length-1;T>=0;T--)(R=$[T])&&(L=(w<3?R(L):w>3?R(t,O,L):R(t,O))||L);return w>3&&L&&Object.defineProperty(t,O,L),L};define(Z[39],ee([0,1,20,3,17,25,45,9,13,2,62,22,11]),function($,t,O,S,w,L,R,T,l,d,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var P;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(P=t.RequestType||(t.RequestType={}));function u(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function E(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(y||(y={}));class f{constructor(D){this.buffer=D,this.pos=0}read(D){const M=this.buffer.slice(this.pos,this.pos+D);return this.pos+=M.byteLength,M}}class h{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function s(z){const D=w.VSBuffer.alloc(4);return D.writeUInt32BE(z,0),D}function e(z){return z.read(4).readUInt32BE(0)}function i(z){const D=w.VSBuffer.alloc(1);return D.writeUInt8(z,0),D}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(z,D){if(typeof D=="undefined")z.write(n.Undefined);else if(typeof D=="string"){const M=w.VSBuffer.fromString(D);z.write(n.String),z.write(s(M.byteLength)),z.write(M)}else if(r&&Buffer.isBuffer(D)){const M=w.VSBuffer.wrap(D);z.write(n.Buffer),z.write(s(M.byteLength)),z.write(M)}else if(D instanceof w.VSBuffer)z.write(n.VSBuffer),z.write(s(D.byteLength)),z.write(D);else if(Array.isArray(D)){z.write(n.Array),z.write(s(D.length));for(const M of D)a(z,M)}else{const M=w.VSBuffer.fromString(JSON.stringify(D));z.write(n.Object),z.write(s(M.byteLength)),z.write(M)}}function m(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(e(z)).toString();case o.Buffer:return z.read(e(z)).buffer;case o.VSBuffer:return z.read(e(z));case o.Array:{const M=e(z),U=[];for(let K=0;K<M;K++)U.push(m(z));return U}case o.Object:return JSON.parse(z.read(e(z)).toString())}}class b{constructor(D,M,U=null,K=1e3){this.protocol=D,this.ctx=M,this.logger=U,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(D,M){this.channels.set(D,M),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const M=this.send([D.type]);this.logger&&this.logger.logOutgoing(M,0,1,E(D.type));return}case 201:case 202:case 204:case 203:{const M=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(M,D.id,1,E(D.type),D.data);return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onRawMessage(D){const M=new f(D),U=m(M),K=m(M),B=U[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=new L.CancellationTokenSource;let K;try{K=M.call(this.ctx,D.name,D.arg,U.token)}catch(q){K=Promise.reject(q)}const B=D.id;K.then(q=>{this.sendResponse({id:B,data:q,type:201}),this.activeRequests.delete(D.id)},q=>{q instanceof Error?this.sendResponse({id:B,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:B,data:q,type:203}),this.activeRequests.delete(D.id)});const J=(0,d.toDisposable)(()=>U.cancel());this.activeRequests.set(D.id,J)}onEventListen(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=D.id,B=M.listen(this.ctx,D.name,D.arg)(J=>this.sendResponse({id:U,data:J,type:204}));this.activeRequests.set(D.id,B)}disposeActiveRequest(D){const M=this.activeRequests.get(D.id);M&&(M.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let M=this.pendingRequests.get(D.channelName);M||(M=[],this.pendingRequests.set(D.channelName,M));const U=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:D,timeoutTimer:U})}flushPendingRequests(D){const M=this.pendingRequests.get(D);if(M){for(const U of M)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}t.ChannelServer=b;var F;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class v{constructor(D,M=null){this.protocol=D,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=M}getChannel(D){const M=this;return{call(U,K,B){return M.isDisposed?Promise.reject(T.canceled()):M.requestPromise(D,U,K,B)},listen(U,K){return M.isDisposed?Promise.reject(T.canceled()):M.requestEvent(D,U,K)}}}requestPromise(D,M,U,K=L.CancellationToken.None){const B=this.lastRequestId++,q={id:B,type:100,channelName:D,name:M,arg:U};if(K.isCancellationRequested)return Promise.reject(T.canceled());let k;return new Promise((j,V)=>{if(K.isCancellationRequested)return V(T.canceled());const X=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(B),j(ye.data);break;case 202:this.handlers.delete(B);const fe=new Error(ye.data.message);fe.stack=ye.data.stack,fe.name=ye.data.name,V(fe);break;case 203:this.handlers.delete(B),V(ye.data);break}};this.handlers.set(B,me),this.sendRequest(q)};let Q=null;this.state===y.Idle?X():(Q=(0,S.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,X()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:B,type:101}),V(T.canceled())},re=K.onCancellationRequested(se);k=(0,d.combinedDisposable)((0,d.toDisposable)(se),re),this.activeRequests.add(k)}).finally(()=>{this.activeRequests.delete(k)})}requestEvent(D,M,U){const K=this.lastRequestId++,J={id:K,type:102,channelName:D,name:M,arg:U};let q=null;const k=new l.Emitter({onFirstListenerAdd:()=>{q=(0,S.createCancelablePromise)(j=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(k),this.sendRequest(J)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(k),this.sendRequest({id:K,type:103}))}}),A=j=>k.fire(j.data);return this.handlers.set(K,A),k.event}sendRequest(D){switch(D.type){case 100:case 102:{const M=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(M,D.id,0,`${u(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const M=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(M,D.id,0,u(D.type));return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onBuffer(D){const M=new f(D),U=m(M),K=m(M),B=U[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,E(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],0,E(B),K),this.onResponse({type:U[0],id:U[1],data:K})}}onResponse(D){if(D.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(D.id);M&&M(D)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}de([R.memoize],v.prototype,"onDidInitializePromise",null),t.ChannelClient=v;class C{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:M,onDidClientDisconnect:U})=>{l.Event.once(M.onMessage)(B=>{const J=new f(B),q=m(J),k=new b(M,q),A=new v(M);this.channels.forEach((V,X)=>k.registerChannel(X,V));const j={channelServer:k,channelClient:A,ctx:q};this._connections.add(j),this._onDidAddConnection.fire(j),U(()=>{k.dispose(),A.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const D=[];return this._connections.forEach(M=>D.push(M)),D}getChannel(D,M){const U=this;return{call(K,B,J){let q;if((0,g.isFunction)(M)){let A=(0,O.getRandomElement)(U.connections.filter(M));q=A?Promise.resolve(A):l.Event.toPromise(l.Event.filter(U.onDidAddConnection,M))}else q=M.routeCall(U,K,B);const k=q.then(A=>A.channelClient.getChannel(D));return W(k).call(K,B,J)},listen(K,B){if((0,g.isFunction)(M))return U.getMulticastEvent(D,M,K,B);const J=M.routeEvent(U,K,B).then(q=>q.channelClient.getChannel(D));return W(J).listen(K,B)}}}getMulticastEvent(D,M,U,K){const B=this;let J=new d.DisposableStore;const q=new l.Emitter({onFirstListenerAdd:()=>{J=new d.DisposableStore;const k=new l.EventMultiplexer,A=new Map,j=X=>{const se=X.channelClient.getChannel(D).listen(U,K),re=k.add(se);A.set(X,re)},V=X=>{const Q=A.get(X);!Q||(Q.dispose(),A.delete(X))};B.connections.filter(M).forEach(j),l.Event.filter(B.onDidAddConnection,M)(j,void 0,J),B.onDidRemoveConnection(V,void 0,J),k.event(q.fire,q,J),J.add(k)},onLastListenerRemove:()=>{J.dispose()}});return q.event}registerChannel(D,M){this.channels.set(D,M),this._connections.forEach(U=>{U.channelServer.registerChannel(D,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=C;class N{constructor(D,M,U=null){const K=new h;a(K,M),D.send(K.buffer),this.channelClient=new v(D,U),this.channelServer=new b(D,M,U)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,M){this.channelServer.registerChannel(D,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function W(z){return{call(D,M,U){return z.then(K=>K.call(D,M,U))},listen(D,M){const U=new l.Relay;return z.then(K=>U.input=K.listen(D,M)),U.event}}}t.getDelayedChannel=W;function Y(z){let D=!1;return{call(M,U,K){return D?z.call(M,U,K):(0,S.timeout)(0).then(()=>D=!0).then(()=>z.call(M,U,K))},listen(M,U){if(D)return z.listen(M,U);const K=new l.Relay;return(0,S.timeout)(0).then(()=>D=!0).then(()=>K.input=z.listen(M,U)),K.event}}}t.getNextTickChannel=Y;class ie{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const M of D.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await l.Event.toPromise(D.onDidAddConnection),await this.route(D)}}t.StaticRouter=ie;var oe;(function(z){function D(B,J){const q=B,k=J&&J.disableMarshalling,A=new Map;for(const j in q)U(j)&&A.set(j,l.Event.buffer(q[j],!0));return new class{listen(j,V,X){const Q=A.get(V);if(Q)return Q;if(K(V)){const se=q[V];if(typeof se=="function")return se.call(q,X)}throw new Error(`Event not found: ${V}`)}call(j,V,X){const Q=q[V];if(typeof Q=="function"){if(!k&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,p.revive)(X[se]);return Q.apply(q,X)}throw new Error(`Method not found: ${V}`)}}}z.fromService=D;function M(B,J){const q=J&&J.disableMarshalling;return new Proxy({},{get(k,A){if(typeof A=="string")return J?.properties?.has(A)?J.properties.get(A):K(A)?function(j){return B.listen(A,j)}:U(A)?B.listen(A):async function(...j){let V;J&&!(0,g.isUndefinedOrNull)(J.context)?V=[J.context,...j]:V=j;const X=await B.call(A,V);return q?X:(0,p.revive)(X)};throw new Error(`Property not found: ${String(A)}`)}})}z.toService=M;function U(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function K(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let D=z.toString();if(D!=="[object Object]")return D}return z}function ce(z){return Array.isArray(z)?z.map(ue):ue(z)}function G(z,D,M,U,K,B,J){J=ce(J);const q=te[K],k=q[U%q.length];let A=[`%c[${z}]%c[${String(D).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(B)?(A=A.concat(J),A.push(")")):A.push(J),console.log.apply(console,A)}t.logWithColors=G;class ne{constructor(D,M){this._outgoingPrefix=D,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,M,U,K,B){this._totalOutgoing+=D,G(this._outgoingPrefix,this._totalOutgoing,D,M,U,K,B)}logIncoming(D,M,U,K,B){this._totalIncoming+=D,G(this._incomingPrefix,this._totalIncoming,D,M,U,K,B)}}t.IPCLogger=ne}),define(Z[67],ee([0,1,3,13,2,11]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var R;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=t.StorageHint||(t.StorageHint={}));function T(I){const g=I;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=T;var l;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(l||(l={}));class d extends w.Disposable{constructor(g,P=Object.create(null)){super();this.database=g,this.options=P,this._onDidChangeStorage=this._register(new S.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((P,u)=>this.accept(u,P)),g.deleted?.forEach(P=>this.accept(P,void 0))}accept(g,P){if(this.state===l.Closed)return;let u=!1;(0,L.isUndefinedOrNull)(P)?u=this.cache.delete(g):this.cache.get(g)!==P&&(this.cache.set(g,P),u=!0),u&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,P){const u=this.cache.get(g);return(0,L.isUndefinedOrNull)(u)?P:u}getBoolean(g,P){const u=this.get(g);return(0,L.isUndefinedOrNull)(u)?P:u==="true"}getNumber(g,P){const u=this.get(g);return(0,L.isUndefinedOrNull)(u)?P:parseInt(u,10)}async set(g,P){if(this.state===l.Closed)return;if((0,L.isUndefinedOrNull)(P))return this.delete(g);const u=String(P);if(this.cache.get(g)!==u)return this.cache.set(g,u),this.pendingInserts.set(g,u),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((P,u)=>this.items.set(u,P)),g.delete&&g.delete.forEach(P=>this.items.delete(P))}async close(){}}t.InMemoryStorageDatabase=p}),define(Z[68],ee([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Z[69],ee([0,1,68]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const S=60,w=S*60,L=w*24,R=L*7,T=L*30,l=L*365;function d(I,g){typeof I!="number"&&(I=I.getTime());const P=Math.round((new Date().getTime()-I)/1e3);if(P<-30)return(0,O.localize)(0,null,d(new Date().getTime()+P*1e3,!1));if(P<30)return(0,O.localize)(1,null);let u;return P<S?(u=P,g?u===1?(0,O.localize)(2,null,u):(0,O.localize)(3,null,u):u===1?(0,O.localize)(4,null,u):(0,O.localize)(5,null,u)):P<w?(u=Math.floor(P/S),g?u===1?(0,O.localize)(6,null,u):(0,O.localize)(7,null,u):u===1?(0,O.localize)(8,null,u):(0,O.localize)(9,null,u)):P<L?(u=Math.floor(P/w),g?u===1?(0,O.localize)(10,null,u):(0,O.localize)(11,null,u):u===1?(0,O.localize)(12,null,u):(0,O.localize)(13,null,u)):P<R?(u=Math.floor(P/L),g?u===1?(0,O.localize)(14,null,u):(0,O.localize)(15,null,u):u===1?(0,O.localize)(16,null,u):(0,O.localize)(17,null,u)):P<T?(u=Math.floor(P/R),g?u===1?(0,O.localize)(18,null,u):(0,O.localize)(19,null,u):u===1?(0,O.localize)(20,null,u):(0,O.localize)(21,null,u)):P<l?(u=Math.floor(P/T),g?u===1?(0,O.localize)(22,null,u):(0,O.localize)(23,null,u):u===1?(0,O.localize)(24,null,u):(0,O.localize)(25,null,u)):(u=Math.floor(P/l),g?u===1?(0,O.localize)(26,null,u):(0,O.localize)(27,null,u):u===1?(0,O.localize)(28,null,u):(0,O.localize)(29,null,u))}t.fromNow=d;function p(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=p}),define(Z[70],ee([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Z[30],ee([0,1,20,11,70]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function L(d,p){return p&&(d.stack||d.stacktrace)?w.localize(0,null,T(d),R(d.stack)||R(d.stacktrace)):T(d)}function R(d){return Array.isArray(d)?d.join(`
`):d}function T(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?w.localize(1,null,d.message):d.message||w.localize(2,null)}function l(d=null,p=!1){if(!d)return w.localize(3,null);if(Array.isArray(d)){const I=O.coalesce(d),g=l(I[0],p);return I.length>1?w.localize(4,null,g,I.length):g}if(S.isString(d))return d;if(d.detail){const I=d.detail;if(I.error)return L(I.error,p);if(I.exception)return L(I.exception,p)}return d.stack?L(d,p):d.message?d.message:w.localize(5,null)}t.toErrorMessage=l}),define(Z[71],ee([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Z[49],ee([0,1,35,38,8,18,4,10,28,60,11,47,12,71]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function u(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(s,e){if(T.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=O.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{n.once("error",a=>{r({success:!1,error:a})}),n.once("exit",(a,m)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(T.isLinux||T.isMacintosh)try{const i=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{O.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,a,m)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function E(s=l.env){return s.comspec||"cmd.exe"}t.getWindowsShell=E;class y{constructor(e,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=r;else{const a=e;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(l.env).forEach(m=>{a[m]=l.env[m]}),Object.keys(this.options.env).forEach(m=>{a[m]=this.options.env[m]}),this.options.env=a}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(R.sep);return i!==-1&&(e=e.substring(i+1)),y.WellKnowCommands[e]?e:"other"}start(e){return T.isWindows&&(this.options&&this.options.cwd&&S.isUNC(this.options.cwd)||!this.options&&S.isUNC(l.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(i=>{let n,r;const a=new Promise((m,b)=>{n=m,r=b});if(i){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=O.exec(m,this.options,(b,F,v)=>{this.childProcess=null;const C=b;C&&C.killed?r({killed:this.terminateRequested,stdout:F.toString(),stderr:v.toString()}):this.handleExec(n,e,b,F,v)})}else{let m=null;const b=F=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(F,n,e,r);const v={terminated:this.terminateRequested};p.isNumber(F)&&(v.cmdCode=F),n(v)};if(this.shell&&T.isWindows){const F=L.deepClone(this.options);F.windowsVerbatimArguments=!0,F.detached=!1;let v=!1,C=!1;const N=[];let W=this.ensureQuotes(this.cmd);N.push(W.value),v=W.quoted,this.args&&this.args.forEach(ie=>{W=this.ensureQuotes(ie),N.push(W.value),C=C&&W.quoted});const Y=["/s","/c"];v?C?Y.push('"'+N.join(" ")+'"'):N.length>1?Y.push('"'+N[0]+'" '+N.slice(1).join(" ")):Y.push('"'+N[0]+'"'):Y.push(N.join(" ")),m=O.spawn(E(),Y,F)}else this.cmd&&(m=O.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(p.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",F=>{this.childProcess=null,r({terminated:this.terminateRequested,error:F})}),m.pid&&(this.childProcess.on("close",b),this.handleSpawn(m,n,e,r,!0)))}return a})}handleClose(e,i,n,r){}ensureQuotes(e){return y.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,c(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!T.isWindows)return e(!1);const i=O.spawn(E(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class f extends y{constructor(e,i,n,r){super(e,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,r,a){[r,a].forEach((m,b)=>{const F=new I.LineDecoder;F.write(m).forEach(N=>{i({line:N,source:b===0?0:1})});const C=F.end();C&&i({line:C,source:b===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,r,a){const m=new I.LineDecoder,b=new I.LineDecoder;e.stdout.on("data",F=>{m.write(F).forEach(C=>n({line:C,source:0}))}),e.stderr.on("data",F=>{b.write(F).forEach(C=>n({line:C,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=b}handleClose(e,i,n,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&n({line:m,source:1})}}t.LineProcess=f;function h(s){let e=[],i=!1;const n=function(r){if(i){e.push(r);return}(!s.send(r,m=>{if(m&&console.error(m),i=!1,e.length>0){const b=e.slice(0);e=[],b.forEach(F=>n(F))}})||T.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=h;var o;(function(s){async function e(i,n,r){if(R.isAbsolute(i))return i;if(n===void 0&&(n=l.cwd()),R.dirname(i)!=="."||(r===void 0&&p.isString(l.env.PATH)&&(r=l.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(n,i);async function m(b){if(await g.Promises.exists(b)){let F;try{F=await g.Promises.stat(b)}catch(v){v.message.startsWith("EACCES")&&(F=await g.Promises.lstat(b))}return F?!F.isDirectory():!1}return!1}for(let b of r){let F;if(R.isAbsolute(b)?F=R.join(b,i):F=R.join(n,b,i),await m(F))return F;let v=F+".com";if(await m(v)||(v=F+".exe",await m(v)))return v}return R.join(n,i)}s.findExecutable=e})(o=t.win32||(t.win32={}))}),define(Z[72],ee([0,1,34,10,66,49]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function R(P,u){return P===1?S.isWindows?I():L.getWindowsShell(u):d(P,u)}t.getSystemShell=R;function T(P,u){return P===1?S.isWindows?g(u):L.getWindowsShell(u):d(P,u)}t.getSystemShellSync=T;let l=null;function d(P,u){if(S.isLinux&&P===2||S.isMacintosh&&P===3)return"/bin/bash";if(!l){let c;if(S.isWindows)c="/bin/bash";else{if(c=u.SHELL,!c)try{c=(0,O.userInfo)().shell}catch(E){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}l=c}return l}let p=null;async function I(){return p||(p=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),p}function g(P){if(p)return p;const u=S.isWindows&&parseFloat((0,O.release)())>=10,c=P.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${P.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?E:L.getWindowsShell(P)}}),define(Z[50],ee([0,1,35,3,17,25,61,9,13,2,18,10,49,39]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends P.ChannelServer{constructor(y){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch(h){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",f=>w.VSBuffer.wrap(Buffer.from(f,"base64")))},y);process.once("disconnect",()=>this.dispose())}}t.Server=u;class c{constructor(y,f){this.modulePath=y,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new S.Delayer(h),this.child=null,this._client=null}getChannel(y){const f=this;return{call(h,o,s){return f.requestPromise(y,h,o,s)},listen(h,o){return f.requestEvent(y,h,o)}}}requestPromise(y,f,h,o=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(y),e=(0,S.createCancelablePromise)(r=>s.call(f,h,r)),i=o.onCancellationRequested(()=>e.cancel()),n=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(y,f,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let o;const s=new l.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(y).listen(f,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&f.env&&delete f.env.DYLD_LIBRARY_PATH,this.child=(0,O.fork)(this.modulePath,y,f);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,R.isRemoteConsoleLog)(a)){(0,R.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(w.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=h.event,n={send:e,onMessage:i};this._client=new P.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,m)=>{process.removeListener("exit",r),this.activeRequests.forEach(b=>(0,d.dispose)(b)),this.activeRequests.clear(),a!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:m})})}return this._client}getCachedChannel(y){let f=this.channels.get(y);return f||(f=this.client.getChannel(y),this.channels.set(y,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(Z[73],ee([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Z[74],ee([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[75],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[76],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[77],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[78],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[79],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[80],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[81],ee([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[82],ee([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Z[83],ee([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Z[84],ee([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[85],ee([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Z[86],ee([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[87],ee([0,1,69,45,8,4,28,19,7]),function($,t,O,S,w,L,R,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(c,E,y){this._args=c,this.paths=E,this.productService=y}get appRoot(){return(0,L.dirname)(w.FileAccess.asFileUri("",$).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(l.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=R.env.VSCODE_PORTABLE;return c?l.URI.file((0,L.join)(c,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,L.resolve)(c):(0,L.normalize)((0,L.join)(w.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,L.resolve)(c):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,L.resolve)(c);const E=R.env.VSCODE_EXTENSIONS;if(E)return E;const y=R.env.VSCODE_PORTABLE;return y?(0,L.join)(y,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(E=>/^[^:/?#]+?:\/\//.test(E)?l.URI.parse(E):l.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?l.URI.parse(c):l.URI.file((0,L.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([S.memoize],d.prototype,"appRoot",null),de([S.memoize],d.prototype,"userHome",null),de([S.memoize],d.prototype,"userDataPath",null),de([S.memoize],d.prototype,"appSettingsHome",null),de([S.memoize],d.prototype,"tmpDir",null),de([S.memoize],d.prototype,"userRoamingDataHome",null),de([S.memoize],d.prototype,"settingsResource",null),de([S.memoize],d.prototype,"userDataSyncHome",null),de([S.memoize],d.prototype,"userDataSyncLogResource",null),de([S.memoize],d.prototype,"sync",null),de([S.memoize],d.prototype,"machineSettingsResource",null),de([S.memoize],d.prototype,"globalStorageHome",null),de([S.memoize],d.prototype,"workspaceStorageHome",null),de([S.memoize],d.prototype,"keybindingsResource",null),de([S.memoize],d.prototype,"keyboardLayoutResource",null),de([S.memoize],d.prototype,"argvResource",null),de([S.memoize],d.prototype,"snippetsHome",null),de([S.memoize],d.prototype,"isExtensionDevelopment",null),de([S.memoize],d.prototype,"untitledWorkspacesHome",null),de([S.memoize],d.prototype,"installSourcePath",null),de([S.memoize],d.prototype,"builtinExtensionsPath",null),de([S.memoize],d.prototype,"extensionsPath",null),de([S.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([S.memoize],d.prototype,"extensionDevelopmentKind",null),de([S.memoize],d.prototype,"extensionTestsLocationURI",null),de([S.memoize],d.prototype,"debugExtensionHost",null),de([S.memoize],d.prototype,"serviceMachineIdResource",null),de([S.memoize],d.prototype,"telemetryLogResource",null),de([S.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function p(u,c){return P(u["inspect-extensions"],u["inspect-brk-extensions"],5870,c,u.debugId)}t.parseExtensionHostPort=p;function I(u,c){return P(u["inspect-search"],u["inspect-brk-search"],5876,c)}t.parseSearchPort=I;function g(u,c){return P(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c)}t.parsePtyHostPort=g;function P(u,c,E,y,f){const o=Number(c||u)||(y?null:E),s=o?Boolean(!!c):!1;return{port:o,break:s,debugId:f}}}),function(){"use strict";function $(t,O,S,w){function L(T){const l=R(T),d=[l];return t.isAbsolute(l)||d.unshift(w),t.resolve(...d)}function R(T){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,S);const p=T["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(I,"AppData","Roaming")}break;case"darwin":d=t.join(O.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,S)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[88],ee([0,89,34,8,19,28]),function(t,O,S,w,L,R){const T=L.dirname(w.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(L.joinPath(T,"package.json").fsPath);return $(O,S,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),O=require("path"),S=require("os");module.exports=$(O,S,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[90],ee([0,1,34,87,88]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends S.AbstractNativeEnvironmentService{constructor(T,l){super(T,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,w.getUserDataPath)(T)},l)}}t.NativeEnvironmentService=L}),define(Z[91],ee([0,1,18]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const S=/^%([\w\d.-]+)%$/i;function w(L,R){const T=l=>{if(typeof l!="string")return;const d=S.exec(l);if(!d)return;const p=R[d[1]]??l;return typeof p=="string"?p:typeof p.message=="string"?p.message:l};return(0,O.cloneAndChange)(L,T)}t.localizeManifest=w}),define(Z[51],ee([0,1,81]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function L(g){return g=g.trim(),g==="*"||S.test(g)}t.isValidVersionStr=L;function R(g){if(!L(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let P=g.match(S);return P?{hasCaret:P[1]==="^",hasGreaterEquals:P[1]===">=",majorBase:P[2]==="x"?0:parseInt(P[2],10),majorMustEqual:P[2]!=="x",minorBase:P[4]==="x"?0:parseInt(P[4],10),minorMustEqual:P[4]!=="x",patchBase:P[6]==="x"?0:parseInt(P[6],10),patchMustEqual:P[6]!=="x",preRelease:P[8]||null}:null}t.parseVersion=R;function T(g){if(!g)return null;let P=g.majorBase,u=g.majorMustEqual,c=g.minorBase,E=g.minorMustEqual,y=g.patchBase,f=g.patchMustEqual;g.hasCaret&&(P===0||(E=!1),f=!1);let h=0;if(g.preRelease){const o=w.exec(g.preRelease);if(o){const[,s,e,i]=o;h=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:P,majorMustEqual:u,minorBase:c,minorMustEqual:E,patchBase:y,patchMustEqual:f,isMinimum:g.hasGreaterEquals,notBefore:h}}t.normalizeVersion=T;function l(g,P,u){let c;typeof g=="string"?c=T(R(g)):c=g;let E;P instanceof Date?E=P.getTime():typeof P=="string"&&(E=new Date(P).getTime());let y;if(typeof u=="string"?y=T(R(u)):y=u,!c||!y)return!1;let f=c.majorBase,h=c.minorBase,o=c.patchBase,s=y.majorBase,e=y.minorBase,i=y.patchBase,n=y.notBefore,r=y.majorMustEqual,a=y.minorMustEqual,m=y.patchMustEqual;return y.isMinimum?f>s?!0:f<s?!1:h>e?!0:h<e||E&&E<n?!1:o>=i:(f===1&&s===0&&(!r||!a||!m)&&(s=1,e=0,i=0,r=!0,a=!1,m=!1),f<s?!1:f>s?!r:h<e?!1:h>e?!a:o<i?!1:o>i?!m:!(E&&E<n))}t.isValidVersion=l;function d(g,P,u,c){return u.isBuiltin||typeof u.main=="undefined"?!0:I(g,P,u.engines.vscode,c)}t.isValidExtensionVersion=d;function p(g,P,u){return g==="*"||I(P,u,g)}t.isEngineValid=p;function I(g,P,u,c=[]){let E=T(R(u));if(!E)return c.push(O.localize(0,null,u)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return c.push(O.localize(1,null,u)),!1}else if(!E.majorMustEqual)return c.push(O.localize(2,null,u)),!1;return l(g,P,E)?!0:(c.push(O.localize(3,null,g,u)),!1)}}),define(Z[92],ee([0,1,2,8,39,50]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends O.Disposable{constructor(l,d,p,I){super();this.requests=l,this.onDidFilesChange=d,this.onLogMessage=p,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.watch(this.requests)}setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}watch(l){this.requests=l,this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Z[93],ee([0,1,2,8,39,50]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends O.Disposable{constructor(l,d,p,I,g={}){super();this.folders=l,this.onDidFilesChange=d,this.onLogMessage=p,this.verboseLogging=I,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.watch(this.folders)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}setVerboseLogging(l){this.verboseLogging=l,this.service&&this.service.setVerboseLogging(l)}watch(l){this.folders=l,this.service&&this.service.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Z[94],ee([0,1,35,63,8,47]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class R{constructor(l,d,p,I,g){this.watchedFolder=l,this.eventCallback=p,this.logCallback=I,this.verboseLogging=g,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(P=>(0,S.parse)(P)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${l}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const l=[this.watchedFolder];this.verboseLogging&&l.push("-verbose"),this.handle=(0,O.spawn)(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,l);const d=new L.LineDecoder;this.handle.stdout.on("data",p=>{const I=[];for(const g of d.write(p)){const P=g.split("|");if(P.length===2){const u=Number(P[0]),c=P[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(E=>E(c))){this.verboseLogging&&this.log(c);continue}I.push({type:R.changeTypeMap[u],path:c})}else this.log(P[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",p=>this.onError(p)),this.handle.stderr.on("data",p=>this.onError(p)),this.handle.on("exit",(p,I)=>this.onExit(p,I))}onError(l){this.error("process error: "+l.toString())}onExit(l,d){this.handle&&(this.error(`terminated unexpectedly (code: ${l}, signal: ${d})`),this.restartCounter<=R.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(l){this.logCallback({type:"error",message:`[File Watcher (C#)] ${l}`})}log(l){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${l}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=R,R.MAX_RESTARTS=5,R.changeTypeMap=[0,1,2]}),define(Z[95],ee([0,1,4,22,94]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L{constructor(T,l,d,p){this.onDidFilesChange=l,this.onLogMessage=d,this.verboseLogging=p,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,S.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new w.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=L}),define(Z[52],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class O{constructor(w,L=[],R=!1){this.ctor=w,this.staticArguments=L,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=O}),define(Z[96],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class O{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=O;class S{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let R of this._nodes.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const T=this.lookupOrInsertNode(L),l=this.lookupOrInsertNode(R);T.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(L),T)}removeNode(L){const R=this._hashFn(L);this._nodes.delete(R);for(let T of this._nodes.values())T.outgoing.delete(R),T.incoming.delete(R)}lookupOrInsertNode(L){const R=this._hashFn(L);let T=this._nodes.get(R);return T||(T=new O(L),this._nodes.set(R,T)),T}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[R,T]of this._nodes)L.push(`${R}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,R]of this._nodes){const T=new Set([L]),l=this._findCycle(R,T);if(l)return l}}_findCycle(L,R){for(let[T,l]of L.outgoing){if(R.has(T))return[...R,T].join(" -> ");R.add(T);const d=this._findCycle(l,R);if(d)return d;R.delete(T)}}}t.Graph=S}),define(Z[53],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Z[21],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,O.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,O.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[23],ee([0,1,8,76,15]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var L;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(L=t.TargetPlatform||(t.TargetPlatform={}));function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=R;function T(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=T;function l(f,h){switch(f){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function d(f,h){return h==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function p(f,h,o){return d(h,o)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===o?!0:I(o).includes(f)}t.isTargetPlatformCompatible=p;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=I;function g(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=g;var P;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(P=t.SortBy||(t.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var c;(function(f){f.Install="install",f.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var E;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(E=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,w.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,w.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,w.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,w.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=O.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,S.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,S.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,w.createDecorator)("IExtensionManagementCLIService")}),define(Z[40],ee([0,1,22,15]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function w(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}t.getWorkspaceSupportTypeMessage=w;function L(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R=t.ExtensionType||(t.ExtensionType={}));class T{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,g){if(typeof I=="undefined"||I===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof I=="string"||typeof g=="string"){let P=typeof I=="string"?I:I.value,u=typeof g=="string"?g:g.value;return O.equalsIgnoreCase(P,u)}return I._lower===g._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}t.ExtensionIdentifier=T;function l(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}t.isLanguagePackExtension=l;function d(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,S.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[24],ee([0,1,22,40]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function w(u,c){return u.uuid&&c.uuid?u.uuid===c.uuid:u.id===c.id?!0:(0,O.compareIgnoreCase)(u.id,c.id)===0}t.areSameExtensions=w;class L{constructor(c,E){this.version=E,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof L?w(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=L;function R(u,c){return`${u}.${c}`}t.getExtensionId=R;function T(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function l(u,c){return T(R(u,c))}t.getGalleryExtensionId=l;function d(u,c){const E=[],y=f=>{for(const h of E)if(h.some(o=>w(c(o),c(f))))return h;return null};for(const f of u){const h=y(f);h?h.push(f):E.push([f])}return E}t.groupByExtension=d;function p(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=p;function I(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=I,t.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function g(u){const c=new Set;for(const E of u)E.malicious&&c.add(E.id.id);return c}t.getMaliciousExtensionsSet=g;function P(u,c){const E=[],y=c.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const f=y.shift();if(f&&E.every(h=>!w(h.identifier,{id:f}))){const h=u.filter(o=>w(o.identifier,{id:f}));h.length===1&&(E.push(h[0]),y.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}t.getExtensionDependencies=P});var le=this&&this.__param||function($,t){return function(O,S){t(O,S,$)}};define(Z[97],ee([0,1,25,9,64,8,41,7,77,23,24,40]),function($,t,O,S,w,L,R,T,l,d,p,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=f=>(0,l.localize)(0,null,f),P=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(f,h){return h?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function E(f){const h=c.exec(f);return h&&h[1]?[(0,p.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,p.adoptToGalleryExtensionId)(f),void 0]}t.getIdAndVersion=E;let y=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=I.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(m=>m.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(u(r.manifest,h)))}async installExtensions(h,o,s,e,i=console){const n=[],r=[];h.length&&i.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),m=(v,C)=>{const N=a.find(W=>(0,p.areSameExtensions)(W.identifier,{id:v}));if(N){if(!C&&!e)return i.log((0,l.localize)(5,null,v,N.manifest.version,v)),!1;if(C&&N.manifest.version===C)return i.log((0,l.localize)(6,null,`${v}@${C}`)),!1}return!0},b=[],F=[];for(const v of h)if(v instanceof T.URI)b.push(v);else{const[C,N]=E(v);m(C,N)&&F.push({id:C,version:N,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const v of o){const[C,N]=E(v);m(C,N)&&F.push({id:C,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(b.length&&await Promise.all(b.map(async v=>{try{const C=await this.installVSIX(v,{isBuiltin:!1,isMachineScoped:s},e,i);C&&r.push(C)}catch(C){i.error(C.message||C.stack||C),n.push(v.toString())}})),F.length){const v=await this.getGalleryExtensions(F);await Promise.all(F.map(async C=>{const N=v.get(C.id.toLowerCase());if(N)try{const W=await this.installFromGallery(C,N,a,e,i);W&&r.push(W)}catch(W){i.error(W.message||W.stack||W),n.push(C.id)}else i.error(`${g(C.version?`${C.id}@${C.version}`:C.id)}
${P}`),n.push(C.id)}))}if(n.length)throw new Error((0,l.localize)(7,null,n.join(", ")))}async installVSIX(h,o,s,e){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,l.localize)(8,null,(0,w.getBaseLabel)(h))),i}catch(r){if((0,S.isPromiseCanceledError)(r))return e.log((0,l.localize)(9,null,(0,w.getBaseLabel)(h))),null;throw r}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,O.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,O.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const m=i.find(b=>(0,p.areSameExtensions)(b.identifier,e.identifier));if(m){if(e.version===m.manifest.version)return r.log((0,l.localize)(10,null,o?`${h}@${o}`:h)),null;r.log((0,l.localize)(11,null,h,e.version))}try{return s.isBuiltin?r.log(o?(0,l.localize)(12,null,h,o):(0,l.localize)(13,null,h)):r.log(o?(0,l.localize)(14,null,h,o):(0,l.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,l.localize)(16,null,h,e.version)),a}catch(b){if((0,S.isPromiseCanceledError)(b))return r.log((0,l.localize)(17,null,h)),null;throw b}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,p.getGalleryExtensionId)(h.publisher,h.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,p.areSameExtensions)(e,r.identifier)&&(0,R.gt)(r.manifest.version,h.version));return n&&!o?(s.log((0,l.localize)(18,null,n.identifier.id,n.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async n=>{if(n instanceof T.URI){const r=await this.extensionManagementService.getManifest(n);return u(r)}return n},i=[];for(const n of h){const r=await e(n),m=(await this.extensionManagementService.getInstalled()).filter(b=>(0,p.areSameExtensions)(b.identifier,{id:r}));if(!m.length)throw new Error(`${this.notInstalled(r)}
${P}`);if(m.some(b=>b.type===0)){s.log((0,l.localize)(19,null,r));return}if(!o&&m.some(b=>b.isBuiltin)){s.log((0,l.localize)(20,null,r));return}s.log((0,l.localize)(21,null,r));for(const b of m)await this.extensionManagementService.uninstall(b),i.push(b);this.location?s.log((0,l.localize)(22,null,r,this.location)):s.log((0,l.localize)(23,null,r))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===L.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?(0,l.localize)(24,null,h,this.location):(0,l.localize)(25,null,h)}};y=de([le(0,d.IExtensionManagementService),le(1,d.IExtensionGalleryService)],y),t.ExtensionManagementCLIService=y}),define(Z[98],ee([0,1,2,4,12,40]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class R extends O.Disposable{constructor(l,d){super();this.environmentService=l,this.extensionsManifestCache=(0,S.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(d.onDidUninstallExtension(p=>this.onDidUnInstallExtension(p)))}onDidInstallExtensions(l){l.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=R}),define(Z[99],ee([0,1,35,89,25,30,9,10,31,72,128]),function($,t,O,S,w,L,R,T,l,d,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function I(u,c,E){return c["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):T.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(E)&&!c["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(E)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=new Promise(async y=>{const f=new w.CancellationTokenSource,h=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),f.dispose(!0),y({})},1e4);try{const o=await P(u,f.token);y(o)}catch(o){(0,R.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),y({})}finally{clearTimeout(h),f.dispose()}})),g)}t.resolveShellEnv=I;let g;async function P(u,c){const E=new Promise(async(y,f)=>{const h=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const s=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",i);const n=await(0,d.getSystemShell)(T.OS,i);if(u.trace("getUnixShellEnvironment#shell",n),c.isCancellationRequested)return f(R.canceled);const r=S.basename(n);let a,m;/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,m=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,m=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),a);const b=(0,O.spawn)(n,[...m,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});c.onCancellationRequested(()=>(b.kill(),f(R.canceled))),b.on("error",C=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(C)),y({})});const F=[];b.stdout.on("data",C=>F.push(C));const v=[];b.stderr.on("data",C=>v.push(C)),b.on("close",(C,N)=>{const W=Buffer.concat(F).toString("utf8");u.trace("getUnixShellEnvironment#raw",W);const Y=Buffer.concat(v).toString("utf8");if(Y.trim()&&u.trace("getUnixShellEnvironment#stderr",Y),C||N)return f(new Error(`Failed to get environment (code ${C}, signal ${N})`));const ie=e.exec(W),oe=ie?ie[1]:"{}";try{const te=JSON.parse(oe);h?te.ELECTRON_RUN_AS_NODE=h:delete te.ELECTRON_RUN_AS_NODE,o?te.ELECTRON_NO_ATTACH_CONSOLE=o:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",te),y(te)}catch(te){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(te)),f(te)}})});try{return await E}catch(y){return u.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(y)),{}}}}),define(Z[54],ee([0,1,10,7,16]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function L(l){return l.map(d=>({type:d.type,resource:S.URI.file(d.path)}))}t.toFileChanges=L;function R(l){const d=new T;for(const p of l)d.processEvent(p);return d.normalize()}t.normalizeFileChanges=R;class T{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(d){return O.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.mapPathToChange.get(this.toKey(d));let I=!1;if(p){const g=p.type,P=d.type;p.path!==d.path&&(P===1||P===0)?(p.type=2,I=!0):g===1&&P===2?(this.mapPathToChange.delete(this.toKey(d)),this.normalized.delete(p)):g===2&&P===1?p.type=0:g===1&&P===0||(p.type=P)}else I=!0;I&&(this.normalized.add(d),this.mapPathToChange.set(this.toKey(d),d))}normalize(){const d=[],p=[];return Array.from(this.normalized).filter(I=>I.type!==2?(d.push(I),!1):!0).sort((I,g)=>I.path.length-g.path.length).filter(I=>p.some(g=>(0,w.isParent)(I.path,g,!O.isLinux))?!1:(p.push(I.path),!0)).concat(d)}}}),define(Z[100],ee([0,1,3,2,4,65,12,129,54]),function($,t,O,S,w,L,R,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends S.Disposable{constructor(I,g,P,u){super();this.path=I,this.onDidFilesChange=g,this.onLogMessage=P,this.verboseLogging=u,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:g}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let P=this.path;if(g)try{P=await(0,L.realpath)(P)}catch(u){if(this.onError(u),g.dangling)return}I.isDirectory()?this._register((0,T.watchFolder)(P,(u,c)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(c))})},u=>this.onError(u))):this._register((0,T.watchFile)(P,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const P=(0,l.normalizeFileChanges)(g);if(this.verboseLogging)for(const u of P)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);P.length>0&&this.onDidFilesChange(P)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Z[55],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class O{constructor(...w){this._entries=new Map;for(let[L,R]of w)this.set(L,R)}set(w,L){const R=this._entries.get(w);return this._entries.set(w,L),R}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=O}),define(Z[101],ee([0,1,3,9,52,96,15,55]),function($,t,O,S,w,L,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class d extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class p{constructor(u=new T.ServiceCollection,c=!1,E){this._activeInstantiations=new Set,this._services=u,this._strict=c,this._parent=E,this._services.set(R.IInstantiationService,this)}createChild(u){return new p(u,this._strict,this)}invokeFunction(u,...c){let E=g.traceInvocation(u),y=!1;try{return u({get:(h,o)=>{if(y)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,E);if(!s&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...c)}finally{y=!0,E.stop()}}createInstance(u,...c){let E,y;return u instanceof w.SyncDescriptor?(E=g.traceCreation(u.ctor),y=this._createInstance(u.ctor,u.staticArguments.concat(c),E)):(E=g.traceCreation(u),y=this._createInstance(u,c,E)),E.stop(),y}_createInstance(u,c=[],E){let y=R._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),f=[];for(const o of y){let s=this._getOrCreateServiceInstance(o.id,E);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);f.push(s)}let h=y.length>0?y[0].index:c.length;if(c.length!==h){console.warn(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${c.length} static arguments`);let o=h-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,h)}return new u(...[...c,...f])}_setServiceInstance(u,c){if(this._services.get(u)instanceof w.SyncDescriptor)this._services.set(u,c);else if(this._parent)this._parent._setServiceInstance(u,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let c=this._services.get(u);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):c}_getOrCreateServiceInstance(u,c){let E=this._getServiceInstanceOrDescriptor(u);return E instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,E,c.branch(u,!0)):(c.branch(u,!1),E)}_safeCreateAndCacheServiceInstance(u,c,E){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,c,E)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,c,E){const y=new L.Graph(o=>o.id.toString());let f=0;const h=[{id:u,desc:c,_trace:E}];for(;h.length;){const o=h.pop();if(y.lookupOrInsertNode(o),f++>1e3)throw new d(y);for(let s of R._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof w.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};y.insertEdge(o,i),h.push(i)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new d(y);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}y.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,c,E=[],y,f){if(this._services.get(u)instanceof w.SyncDescriptor)return this._createServiceInstance(c,E,y,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,c,E,y,f);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(u,c=[],E,y){if(E){const f=new O.IdleValue(()=>this._createInstance(u,c,y));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=f.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return f.value[o]=s,!0}})}else return this._createInstance(u,c,y)}}t.InstantiationService=p;var I;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(I||(I={}));class g{constructor(u,c){this.type=u,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new g(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(u){return l?new g(0,u.name):g._None}branch(u,c){let E=new g(2,u.toString());return this._dep.push([u,c,E]),E}stop(){let u=Date.now()-this._start;g._totals+=u;let c=!1;function E(f,h){let o=[],s=new Array(f+1).join("	");for(const[e,i,n]of h._dep)if(i&&n){c=!0,o.push(`${s}CREATES -> ${e}`);let r=E(f+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(u>2||c)&&console.log(y.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Z[56],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,O.createDecorator)("localizationsService");function S(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const L of w.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}t.isValidLocalization=S}),define(Z[14],ee([0,1,30,13,2,10,15]),function($,t,O,S,w,L,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,R.createDecorator)("logService"),t.ILoggerService=(0,R.createDecorator)("loggerService");function T(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class d extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class p extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(l.Error,this.format(n))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=p;class I extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!L.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,e,...i):console.warn(`[main ${T()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class g extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=g;class P extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,O.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=P;class u extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class c extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=c;class E extends w.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=E;class y{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=y;function f(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=f;function h(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=h;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o}),define(Z[102],ee([0,1,3,9,2,10,19,41,7,31,12,21,23,24,16,14]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let y=class extends w.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,R.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,o,s){try{await p.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(L.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const n of h.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,P.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>T.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await O.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new P.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(h){const o=E.exec(h);return o&&o[1]&&o[2]?new P.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};y=de([le(0,I.INativeEnvironmentService),le(1,u.IFileService),le(2,g.IExtensionGalleryService),le(3,c.ILogService)],y),t.ExtensionsDownloader=y}),define(Z[103],ee([0,1,35,3,30,13,2,8,4,12,21,14]),function($,t,O,S,w,L,R,T,l,d,p,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends R.Disposable{constructor(u,c){super();this.environmentService=u,this.logService=c,this.processesLimiter=new S.Limiter(5)}async postUninstall(u){const c=this.parseScript(u,"uninstall");return c&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${E}`)))),d.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(u,c){const E=`vscode:${c}`;if(u.location.scheme===T.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[E]=="string"){const y=u.manifest.scripts[E].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${E} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}runLifecycleHook(u,c,E,y,f){return new Promise((h,o)=>{const s=this.start(u,c,E,f);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):h(void 0)};s.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),y&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,c,E,y){const f={silent:!0,execArgv:void 0},h=(0,O.fork)(u,[`--type=extension-post-${c}`,...E],f);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=L.Event.fromNodeEventEmitter(h.stdout,"data"),s=L.Event.fromNodeEventEmitter(h.stderr,"data");o(n=>this.logService.info(y.identifier.id,y.manifest.version,`post-${c}`,n)),s(n=>this.logService.error(y.identifier.id,y.manifest.version,`post-${c}`,n));const e=L.Event.any(L.Event.map(o,n=>({data:`%c${n}`,format:[""]})),L.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(y.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};g=de([le(0,p.IEnvironmentService),le(1,I.ILogService)],g),t.ExtensionsLifecycle=g}),define(Z[104],ee([0,1,13,2,19,7,21,24,16,14]),function($,t,O,S,w,L,R,T,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let p=class extends S.Disposable{constructor(g,P,u,c){super();this.extensionsManagementService=g,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(f=>{this.installedExtensions=f.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(f=>this.onInstallExtension(f))),this._register(g.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(g.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const E=L.URI.file(u.extensionsPath),y=new w.ExtUri(f=>!P.hasCapability(f,1024));this._register(P.watch(E)),this._register(O.Event.filter(P.onDidChangeFilesRaw,f=>f.changes.some(h=>this.doesChangeAffects(h,E,y)))(()=>this.onDidChange()))}doesChangeAffects(g,P,u){return u.isEqual(u.dirname(g.resource),P)?u.isEqual(g.resource,u.joinPath(P,".obsolete"))?!0:!(g.type!==1&&g.type!==2||u.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const P of g)this.removeInstallingExtension(P.identifier),P.local&&this.addInstalledExtension(P.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(P=>!(0,T.areSameExtensions)(P,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(P=>!(0,T.areSameExtensions)(P,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),P=g.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,T.areSameExtensions)(E,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),u=this.installedExtensions.filter(c=>this.installingExtensions.some(E=>(0,T.areSameExtensions)(E,c))?!1:g.every(E=>!(0,T.areSameExtensions)(E.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=g.map(c=>c.identifier),(P.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P,removed:u})}}};p=de([le(1,l.IFileService),le(2,R.INativeEnvironmentService),le(3,d.ILogService)],p),t.ExtensionsWatcher=p}),define(Z[105],ee([0,1,130,20,3,2,8,4,12,21,23,24,56,14]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends L.Disposable{constructor(y,f,h){super();this.extensionManagementService=y,this.logService=h,this.cache=this._register(new c(f,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const y=await this.cache.getLanguagePacks(),f=["en",...Object.keys(y)];return(0,S.distinct)(f)}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const f=await this.cache.getLanguagePacks();Object.keys(f).some(h=>f[h]&&f[h].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(f);return!(0,S.equals)(Object.keys(y),Object.keys(h))}};u=de([le(0,p.IExtensionManagementService),le(1,d.INativeEnvironmentService),le(2,P.ILogService)],u),t.LocalizationsService=u;let c=class extends L.Disposable{constructor(y,f){super();this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(f=>{Object.keys(f).forEach(h=>delete f[h]),this.createLanguagePacksFromExtensions(f,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...f){for(const h of f)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,h);Object.keys(y).forEach(h=>this.updateHash(y[h]))}createLanguagePacksFromExtension(y,f){const h=f.identifier,o=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const s of o)if(f.location.scheme===R.Schemas.file&&(0,g.isValidLocalization)(s)){let e=y[s.languageId];e||(e={hash:"",extensions:[],translations:{}},y[s.languageId]=e);let i=e.extensions.filter(n=>(0,I.areSameExtensions)(n.extensionIdentifier,h))[0];i?i.version=f.manifest.version:e.extensions.push({extensionIdentifier:h,version:f.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,T.join)(f.location.fsPath,n.path)}}updateHash(y){if(y){const f=(0,O.createHash)("md5");for(const h of y.extensions)f.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);y.hash=f.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(f=y(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>f,h=>this.logService.error(h))})}};c=de([le(0,d.INativeEnvironmentService),le(1,P.ILogService)],c)}),define(Z[106],ee([0,1,16,14]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function w(l,d,p,I){try{const g=await new Promise((P,u)=>{$(["spdlog"],P,u)});return g.setFlushOn(S.LogLevel.Trace),g.createAsyncRotatingLogger(l,d,p,I)}catch(g){console.error(g)}return null}function L(l,d,p,I){const g=$.__$__nodeRequire("spdlog");return g.setFlushOn(S.LogLevel.Trace),g.createRotatingLogger(l,d,p,I)}t.createRotatingLogger=L;function R(l,d,p){switch(d){case S.LogLevel.Trace:l.trace(p);break;case S.LogLevel.Debug:l.debug(p);break;case S.LogLevel.Info:l.info(p);break;case S.LogLevel.Warning:l.warn(p);break;case S.LogLevel.Error:l.error(p);break;case S.LogLevel.Critical:l.critical(p);break;default:throw new Error("Invalid log level")}}class T extends S.AbstractMessageLogger{constructor(d,p,I,g){super();this.name=d,this.filepath=p,this.rotating=I,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}_createSpdLogLogger(){const d=this.rotating?6:1,p=30/d*O.ByteSize.MB;return w(this.name,this.filepath,p,d).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:g,message:P}of this.buffer)R(this._logger,g,P);this.buffer=[]}})}log(d,p){this._logger?R(this._logger,d,p):this.getLevel()<=d&&this.buffer.push({level:d,message:p})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Z[57],ee([0,1,17,9,83,16,32]),function($,t,O,S,w,L,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(I,g,P,u,c,E){let y;try{await l(I,g,P,u,c,E)}catch(f){y=f}finally{y&&c.errorTransformer&&(y=c.errorTransformer(y)),typeof y!="undefined"&&P.error(y),P.end()}}t.readFileIntoStream=T;async function l(I,g,P,u,c,E){d(E);const y=await I.open(g,{create:!1});try{d(E);let f=0,h=0,o=c&&typeof c.length=="number"?c.length:void 0,s=O.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,i=0;do h=await I.read(y,e,s.buffer,i,s.byteLength-i),e+=h,i+=h,f+=h,typeof o=="number"&&(o-=h),i===s.byteLength&&(await P.write(u(s)),s=O.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),i=0);while(h>0&&(typeof o!="number"||o>0)&&d(E)&&p(f,c));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),P.write(u(s.slice(0,n)))}}catch(f){throw(0,L.ensureFileSystemProviderError)(f)}finally{await I.close(y)}}function d(I){if(I.isCancellationRequested)throw(0,S.canceled)();return!0}function p(I,g){if(g?.limits){if(typeof g.limits.memory=="number"&&I>g.limits.memory)throw(0,L.createFileSystemProviderError)((0,w.localize)(0,null,R.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&I>g.limits.size)throw(0,L.createFileSystemProviderError)((0,w.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[107],ee([0,1,20,3,17,25,13,131,2,46,8,132,19,37,82,16,57,14]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let f=class xe extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new S.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new S.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!0)))),this.watchedResources=d.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new S.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await S.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new c.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,m=await e.stat(o);let b;return this.toFileStat(e,o,m,void 0,!!a,(F,v)=>{if(!b&&(b=d.TernarySearchTree.forUris(()=>!i),b.set(o,!0),n))for(const C of n)b.set(C,!0);return b.get(F.resource)||b.findSuperstr(F.resource.with({query:null,fragment:null}))?!0:F.isDirectory&&r?v===1:!1})}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),m={resource:s,name:a.basename(s),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(m.isDirectory&&r(m,i)){try{const b=await o.readdir(s),F=await S.Promises.settled(b.map(async([v,C])=>{try{const N=a.joinPath(s,v),W=n?await o.stat(N):{type:C};return await this.toFileStat(o,N,W,b.length,n,r)}catch(N){return this.logService.trace(N),null}}));m.children=(0,O.coalesce)(F)}catch(b){this.logService.trace(b),m.children=[]}return m}return m}async resolveAll(o){return S.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new c.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=w.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,c.hasReadWriteCapability)(i)&&!(s instanceof w.VSBuffer))if((0,P.isReadableStream)(s)){const m=await(0,P.peekStream)(s,3);m.ended?a=w.VSBuffer.concat(m.buffer):a=m}else a=(0,P.peekReadable)(s,m=>w.VSBuffer.concat(m),3);else a=s;!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&a instanceof w.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof w.VSBuffer?(0,w.bufferToReadable)(a):a)}catch(r){throw new c.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:n.size}))throw new c.FileOperationError((0,u.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,w.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new L.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await n,!((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasFileReadStreamCapability)(o))||(0,c.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,c.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,P.consumeStream)(r);const m=(0,u.localize)(8,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(a).toString());throw a instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(m,a.stat,e):new c.FileOperationError(m,(0,c.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,P.transform)(n,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,E.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,P.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new c.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!m&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,c.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const b=await this.resolve(s);b.isDirectory?await this.doCopyFolder(o,b,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await S.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:b,isPathCaseSensitive:F}=this.getExtUri(o);if(F||(a=b.isEqual(s,i)),a&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&b.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const m=await this.exists(i);if(m&&!a){if(!r)throw new c.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:b}=this.getExtUri(o);if(b.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&c.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,c.toFileSystemProviderErrorCode)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new c.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new c.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,l.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,l.dispose)(r):n=()=>(0,l.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,l.toDisposable)(()=>{n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,P.isReadableStream)(i)||(0,P.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,P.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=w.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(r,a)=>{(0,P.listenStream)(n,{onData:async m=>{n.pause();try{await this.doWriteBuffer(o,s,m,m.byteLength,i,0)}catch(b){return a(b)}i+=m.byteLength,setTimeout(()=>n.resume())},onError:m=>a(m),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof w.VSBuffer?n=i:(0,P.isReadableStream)(i)?n=await(0,w.streamToBuffer)(i):(0,P.isReadableBufferedStream)(i)?n=await(0,w.bufferedStreamToBuffer)(i):n=(0,w.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=w.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,b=0,F=0;do F=await o.read(n,m,a.buffer,b,a.byteLength-b),await this.doWriteBuffer(e,r,a,F,m,b),m+=F,b+=F,b===a.byteLength&&(b=0);while(F>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await S.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,w.streamToBuffer)(this.readFileBuffered(o,s,L.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new c.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===p.Schemas.file?o.fsPath:o.toString(!0)}};f.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},f=de([le(0,y.ILogService)],f),t.FileService=f}),define(Z[108],ee([0,1,20,3,17,13,38,2,4,10,19,37,12,84,16,57,100,92,93,54,95,14,32]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c,E,y,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends T.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new S.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:m}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,m),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),m=[];return await Promise.all(a.map(async b=>{try{let F;b.isSymbolicLink()?F=(await this.stat((0,p.joinPath)(r,b.name))).type:F=this.toType(b),m.push([b.name,F])}catch(F){this.logService.trace(F)}})),m}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let m;return a?.dangling?m=u.FileType.Unknown:r.isFile()?m=u.FileType.File:r.isDirectory()?m=u.FileType.Directory:m=u.FileType.Unknown,a&&(m|=u.FileType.SymbolicLink),m}async readFile(r){try{const a=this.toFilePath(r);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,m){const b=(0,I.newWriteableStream)(F=>w.VSBuffer.concat(F.map(v=>w.VSBuffer.wrap(v))).buffer);return(0,c.readFileIntoStream)(this,r,b,F=>F.buffer,{...a,bufferSize:this.BUFFER_SIZE},m),b}async writeFile(r,a,m){let b;try{const F=this.toFilePath(r);if(!m.create||!m.overwrite){if(await g.Promises.exists(F)){if(!m.overwrite)throw(0,u.createFileSystemProviderError)((0,P.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,u.createFileSystemProviderError)((0,P.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:m.unlock}),await this.write(b,0,a,0,a.byteLength)}catch(F){throw await this.toFileSystemProviderWriteError(r,F)}finally{typeof b=="number"&&await this.close(b)}}async open(r,a){try{const m=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:v}=await g.SymlinkSupport.stat(m);v.mode&128||await g.Promises.chmod(m,v.mode|128)}catch(v){this.logService.trace(v)}let b;if((0,u.isFileOpenForWriteOptions)(a)){if(d.isWindows)try{await g.Promises.truncate(m,0),b="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}b||(b="w")}else b="r";const F=await g.Promises.open(m,b);return this.mapHandleToPos.set(F,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(F,r),F}catch(m){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,m):this.toFileSystemProviderError(m)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,m,b,F){const v=this.normalizePos(r,a);let C=null;try{const N=await g.Promises.read(r,m,b,F,v);return typeof N=="number"?C=N:C=N.bytesRead,C}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(r,v,C)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,m){const b=this.mapHandleToPos.get(r);typeof b=="number"&&(typeof a=="number"||(typeof m=="number"?this.mapHandleToPos.set(r,b+m):this.mapHandleToPos.delete(r)))}async write(r,a,m,b,F){return(0,S.retry)(()=>this.doWrite(r,a,m,b,F),100,3)}async doWrite(r,a,m,b,F){const v=this.normalizePos(r,a);let C=null;try{const N=await g.Promises.write(r,m,b,F,v);return typeof N=="number"?C=N:C=N.bytesWritten,C}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),N)}finally{this.updatePos(r,v,C)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const m=this.toFilePath(r);await this.doDelete(m,a)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(r,a){a.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,a,m){const b=this.toFilePath(r),F=this.toFilePath(a);if(b!==F)try{await this.validateTargetDeleted(r,a,"move",m.overwrite),await g.Promises.move(b,F)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,P.localize)(2,null,(0,l.basename)(b),(0,l.basename)((0,l.dirname)(F)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(r,a,m){const b=this.toFilePath(r),F=this.toFilePath(a);if(b!==F)try{await this.validateTargetDeleted(r,a,"copy",m.overwrite),await g.Promises.copy(b,F,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,P.localize)(3,null,(0,l.basename)(b),(0,l.basename)((0,l.dirname)(F)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(r,a,m,b){const F=this.toFilePath(r),v=this.toFilePath(a);let C=!1;if(!!(this.capabilities&1024)||(C=(0,R.isEqual)(F,v,!0)),C&&m==="copy")throw(0,u.createFileSystemProviderError)((0,P.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!C&&await g.Promises.exists(v)){if(!b)throw(0,u.createFileSystemProviderError)((0,P.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const m={path:this.toFilePath(r),excludes:a.excludes},b=(0,O.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{b(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=f.FileWatcher,a=this.options?.watcher;else{let m;this.options?.enableLegacyRecursiveWatcher?m=!0:m=e.default.quality==="stable"&&d.isLinux,m&&this.recursiveFoldersToWatch.length===1?d.isWindows?r=o.FileWatcher:r=f.FileWatcher:r=y.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===s.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new E.FileWatcher(this.toFilePath(r),b=>this._onDidChangeFile.fire((0,h.toFileChanges)(b)),b=>{b.type==="error"&&this._onDidWatchErrorOccur.fire(b.message),this.logService[b.type](b.message)},this.logService.getLevel()===s.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,T.combinedDisposable)(a,m)}toFilePath(r){return(0,l.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let m=this.toFileSystemProviderError(a);if(r&&m.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:b}=await g.SymlinkSupport.stat(this.toFilePath(r));b.mode&128||(m=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(b){this.logService.trace(b)}return m}dispose(){super.dispose(),(0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,T.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Z[42],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,O.createDecorator)("productService")}),define(Z[26],ee([0,1,58,11]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(R,T){O.ok(S.isString(R)),O.ok(S.isObject(T)),O.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,T)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}t.Registry=new w}),define(Z[109],ee([0,1,13,26]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class L{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,d){this.schemasById[w(l)]=d,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new L;S.Registry.add(t.Extensions.JSONContribution,R)}),define(Z[33],ee([0,1,20,13,11,74,109,26]),function($,t,O,S,w,L,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=T.Registry.as(R.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new S.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new S.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const s=this.doRegisterConfigurations(h,o);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(h,!1)),p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,O.distinct)(s))}registerDefaultConfigurations(h){const o=[],s=[];for(const e of h)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:L.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(P(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const s of h)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const s=[];return h.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(h){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of h){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(h,o=!0,s,e=3){e=w.isUndefinedOrNull(h.scope)?e:h.scope;let i=[],n=h.properties;if(n)for(let a in n){if(o&&E(a)){delete n[a];continue}const m=n[a];if(this.updatePropertyDefaultValue(a,m),t.OVERRIDE_PROPERTY_PATTERN.test(a)?m.scope=void 0:(m.scope=w.isUndefinedOrNull(m.scope)?e:m.scope,m.restricted=w.isUndefinedOrNull(m.restricted)?!!s?.restrictedConfigurations?.includes(a):m.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=h.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(h)}updateSchema(h,o){switch(t.allSettings.properties[h]=o,o.scope){case 1:t.applicationSettings.properties[h]=o;break;case 2:t.machineSettings.properties[h]=o;break;case 6:t.machineOverridableSettings.properties[h]=o;break;case 3:t.windowSettings.properties[h]=o;break;case 4:t.resourceSettings.properties[h]=o;break;case 5:t.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete t.allSettings.properties[h],o.scope){case 1:delete t.applicationSettings.properties[h];break;case 2:delete t.machineSettings.properties[h];break;case 6:delete t.machineOverridableSettings.properties[h];break;case 3:delete t.windowSettings.properties[h];break;case 4:case 5:delete t.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let s=this.defaultValues[h];w.isUndefined(s)&&(s=o.default),w.isUndefined(s)&&(s=u(o.type)),o.default=s}}const g="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function P(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=P;function u(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const c=new I;T.Registry.add(t.Extensions.Configuration,c);function E(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?L.localize(5,null,f):c.getConfigurationProperties()[f]!==void 0?L.localize(6,null,f):null:L.localize(4,null)}t.validateProperty=E;function y(){const f=[],h=c.getConfigurationProperties();for(const o of Object.keys(h))f.push([o,h[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=y}),define(Z[27],ee([0,1,18,11,7,33,15,26]),function($,t,O,S,w,L,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,R.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof w.URI)}t.isConfigurationOverrides=l;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function p(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=p;function I(i,n){const r=n?i?n.keys.filter(N=>i.keys.indexOf(N)===-1):[...n.keys]:[],a=i?n?i.keys.filter(N=>n.keys.indexOf(N)===-1):[...i.keys]:[],m=[];if(n&&i){for(const N of i.keys)if(n.keys.indexOf(N)!==-1){const W=y(i.contents,N),Y=y(n.contents,N);O.equals(W,Y)||m.push(N)}}const b=[],F=N=>{const W={};for(const Y of N)for(const ie of Y.identifiers)W[s(ie)]=Y;return W},v=n?F(n.overrides):{},C=i?F(i.overrides):{};if(Object.keys(v).length)for(const N of r){const W=v[N];W&&b.push([(0,L.overrideIdentifierFromKey)(N),W.keys])}if(Object.keys(C).length)for(const N of a){const W=C[N];W&&b.push([(0,L.overrideIdentifierFromKey)(N),W.keys])}if(Object.keys(v).length&&Object.keys(C).length)for(const N of m){const W=C[N],Y=v[N];if(W&&Y){const ie=I({contents:W.contents,keys:W.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});b.push([(0,L.overrideIdentifierFromKey)(N),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:a,updated:m,overrides:b}}t.compare=I;function g(i,n){const r=[];for(const a of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(a)){const m={};for(const b in i[a])m[b]=i[a][b];r.push({identifiers:[(0,L.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(m),contents:P(m,n)})}return r}t.toOverrides=g;function P(i,n){const r=Object.create(null);for(let a in i)u(r,a,i[a],n);return r}t.toValuesTree=P;function u(i,n,r,a){const m=n.split("."),b=m.pop();let F=i;for(let v=0;v<m.length;v++){let C=m[v],N=F[C];switch(typeof N){case"undefined":N=F[C]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${m.slice(0,v+1).join(".")} is ${JSON.stringify(N)}`);return}F=N}if(typeof F=="object"&&F!==null)try{F[b]=r}catch(v){a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(F)}`)}else a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(F)}`)}t.addToValueTree=u;function c(i,n){const r=n.split(".");E(i,r)}t.removeFromValueTree=c;function E(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(E(a,n),Object.keys(a).length===0&&delete i[r])}}function y(i,n,r){function a(F,v){let C=F;for(const N of v){if(typeof C!="object"||C===null)return;C=C[N]}return C}const m=n.split("."),b=a(i,m);return typeof b=="undefined"?r:b}t.getConfigurationValue=y;function f(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?S.isObject(i[a])&&S.isObject(n[a])?f(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=f;function h(){const i=T.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=h;function o(){const i=Object.create(null),n=T.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;u(i,r,a,m=>console.error(`Conflict in default settings: ${m}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),m=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Z[110],ee([0,1,20,13,59,2,46,18,11,7,27,33,26]),function($,t,O,S,w,L,R,T,l,d,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class P{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,p.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,p.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],m=i[r];m&&(typeof a=="object"&&typeof m=="object"?(a=T.deepClone(a),this.mergeContents(a,m)):a=m),n[r]=a}return new P(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const m of a.overrides){const[b]=n.filter(F=>O.equals(F.identifiers,m.identifiers));b?this.mergeContents(b.contents,m.contents):n.push(T.deepClone(m))}for(const m of a.keys)r.indexOf(m)===-1&&r.push(m)}return new P(i,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&l.isObject(e[n])&&l.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,p.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,p.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=P;class u extends P{constructor(){const e=(0,p.getDefaultValues)(),i=(0,p.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,p.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:m}=this.doParseRaw(e,i);this._configurationModel=new P(n,r,a),this._restrictedConfigurations=m||[]}doParseContent(e){let i={},n=null,r=[],a=[],m=[];function b(v){Array.isArray(r)?r.push(v):n!==null&&(r[n]=v)}let F={onObjectBegin:()=>{let v={};b(v),a.push(r),r=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let v=[];b(v),a.push(r),r=v,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:b,onError:(v,C,N)=>{m.push({error:v,offset:C,length:N})}};if(e)try{w.visit(e,F),i=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return i}doParseRaw(e,i){const n=g.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,p.toValuesTree)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`)),m=Object.keys(e),b=(0,p.toOverrides)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`));return{contents:a,keys:m,overrides:b,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},m=[];for(let b in e)if(I.OVERRIDE_PROPERTY_PATTERN.test(b)&&n){const F=this.filter(e[b],i,!1,r);a[b]=F.raw,m.push(...F.restricted)}else{const F=i[b],v=F?typeof F.scope!="undefined"?F.scope:3:void 0;F?.restricted&&m.push(b),(v===void 0||r.scopes===void 0||r.scopes.includes(v))&&(r.skipRestricted&&F?.restricted||(a[b]=e[b]))}return{raw:a,restricted:m}}}t.ConfigurationModelParser=c;class E extends L.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(S.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=E;class y{constructor(e,i,n=new P,r=new P,a=new R.ResourceMap,m=new P,b=new R.ResourceMap,F=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=b,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new P,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,b=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),F=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),v=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),C=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),N=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,W=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Y=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(e):m.getValue(e),ie=r.getValue(e),oe=O.distinct(O.flatten(r.overrides.map(te=>te.identifiers))).filter(te=>r.getOverrideValue(e,te)!==void 0);return{defaultValue:b,userValue:F,userLocalValue:v,userRemoteValue:C,workspaceValue:N,workspaceFolderValue:W,memoryValue:Y,value:ie,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:W!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:m.getValue(e),override:i.overrideIdentifier?m.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,I.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),b=e.getKeysForOverrideIdentifier(a),F=[...b.filter(v=>m.indexOf(v)===-1),...m.filter(v=>b.indexOf(v)===-1),...m.filter(v=>!T.equals(this._defaultConfiguration.override(a).getValue(v),e.override(a).getValue(v)))];return[a,F]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,p.compare)(this.localUserConfiguration,e),m=[...i,...n,...r];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,p.compare)(this.remoteUserConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,p.compare)(this.workspaceConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:m,overrides:b}=(0,p.compare)(n,i);let F=[...r,...a,...m];return(F.length||!n)&&this.updateFolderConfiguration(e,i),{keys:F,overrides:b}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:m}=(0,p.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((m,b)=>(m.set(d.URI.revive(b[0]),this.parseConfigurationModel(b[1])),m),new R.ResourceMap);return new y(i,n,new P,r,a,new P,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new P(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=y;function f(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,m])=>{const b=(0,R.getOrSet)(i,a,new Set);m.forEach(F=>b.add(F))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=f;class h{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(b=>a.add(b)),e.overrides.forEach(([,b])=>b.forEach(F=>a.add(F))),this.affectedKeys=[...a.values()];const m=new P;this.affectedKeys.forEach(b=>m.setValue(b,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,p.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(Z[111],ee([0,1,3,13,2,19,27,110,33,26]),function($,t,O,S,w,L,R,T,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class p extends w.Disposable{constructor(g,P){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new S.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,P)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,P){const u=typeof g=="string"?g:void 0,c=(0,R.isConfigurationOverrides)(g)?g:(0,R.isConfigurationOverrides)(P)?P:{};return this.configuration.getValue(u,c,void 0)}updateValue(g,P,u,c){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const P=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(u,P,1)}onDidDefaultConfigurationChange(g){const P=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,g);this.trigger(u,P,6)}trigger(g,P,u){const c=new T.ConfigurationChangeEvent(g,{data:P},this.configuration);c.source=u,c.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=p}),define(Z[43],ee([0,1,17,85,33,15,26]),function($,t,O,S,w,L,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,L.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=T;function l(u){return u.res.statusCode===204}async function d(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,O.streamToBuffer)(u.stream)).toString()}t.asText=d;async function p(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const E=(await(0,O.streamToBuffer)(u.stream)).toString();try{return JSON.parse(E)}catch(y){throw y.message+=`:
`+E,y}}t.asJson=p;function I(u){P(u)}t.updateProxyConfigurationsScope=I;let g;function P(u){const c=R.Registry.as(w.Extensions.Configuration),E=g;g={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[g],remove:E?[E]:[]})}P(2)}),define(Z[112],ee([0,1,25,8,16,43]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let R=class{constructor(l,d){this.requestService=l,this.fileService=d}async download(l,d,p=O.CancellationToken.None){if(l.scheme===S.Schemas.file||l.scheme===S.Schemas.vscodeRemote){await this.fileService.copy(l,d);return}const I={type:"GET",url:l.toString()},g=await this.requestService.request(I,p);if(g.res.statusCode===200)await this.fileService.writeFile(d,g.stream);else{const P=await(0,L.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${P}`)}}};R=de([le(0,L.IRequestService),le(1,w.IFileService)],R),t.DownloadService=R}),define(Z[113],ee([0,1,114,11]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(R,T){return R.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:R.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function L(R,T,l={}){const d=(0,O.parse)(R),p=l.proxyUrl||w(d,T);if(!p)return null;const I=(0,O.parse)(p);if(!/^https?:$/.test(I.protocol||""))return null;const g={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,S.isBoolean)(l.strictSSL)?l.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((P,u)=>{$(["http-proxy-agent"],P,u)}))(g):new(await new Promise((P,u)=>{$(["https-proxy-agent"],P,u)}))(g)}t.getProxyAgent=L}),define(Z[115],ee([0,1,17,31]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(L,R,T){let l=T&&T.get("storage.serviceMachineId",0)||null;if(l)return l;try{const p=(await R.readFile(L.serviceMachineIdResource)).value.toString();l=(0,S.isUUID)(p)?p:null}catch(d){l=null}if(!l){l=(0,S.generateUuid)();try{await R.writeFile(L.serviceMachineIdResource,O.VSBuffer.fromString(l))}catch(d){}}return T&&T.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=w}),define(Z[116],ee([0,1,3,13,2,11,67,15]),function($,t,O,S,w,L,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,T.createDecorator)("storageService");var d;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var p;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(p=t.StorageScope||(t.StorageScope={}));var I;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(I=t.StorageTarget||(t.StorageTarget={}));class g extends w.Disposable{constructor(E={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=E,this._onDidChangeValue=this._register(new S.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new S.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new S.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,y){y===l?(E===0?this._globalKeyTargets=void 0:E===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:E})):this._onDidChangeValue.fire({scope:E,key:y,target:this.getKeyTargets(E)[y]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,y,f){return this.getStorage(y)?.get(E,f)}getBoolean(E,y,f){return this.getStorage(y)?.getBoolean(E,f)}getNumber(E,y,f){return this.getStorage(y)?.getNumber(E,f)}store(E,y,f,h){if((0,L.isUndefinedOrNull)(y)){this.remove(E,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(E,f,h),this.getStorage(f)?.set(E,y)})}remove(E,y){this.withPausedEmitters(()=>{this.updateKeyTarget(E,y,void 0),this.getStorage(y)?.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,y){const f=[],h=this.getKeyTargets(E);for(const o of Object.keys(h))h[o]===y&&f.push(o);return f}updateKeyTarget(E,y,f){const h=this.getKeyTargets(y);typeof f=="number"?h[E]!==f&&(h[E]=f,this.getStorage(y)?.set(l,JSON.stringify(h))):typeof h[E]=="number"&&(delete h[E],this.getStorage(y)?.set(l,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(E){return E===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(E){const y=this.get(l,E);if(y)try{return JSON.parse(y)}catch(f){}return Object.create(null)}isNew(E){return this.getBoolean(t.IS_NEW_KEY,E)===!0}async flush(E=d.NONE){this._onWillSaveState.fire({reason:E}),await O.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const E=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return u(E,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class P extends g{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.globalStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E)))}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(E){}}t.InMemoryStorageService=P;async function u(c,E,y,f){const h=a=>{try{return JSON.parse(a)}catch(m){return a}},o=new Map,s=new Map;c.forEach((a,m)=>{o.set(m,a),s.set(m,h(a))});const e=new Map,i=new Map;E.forEach((a,m)=>{e.set(m,a),i.set(m,h(a))}),console.group(`Storage: Global (path: ${y})`);let n=[];o.forEach((a,m)=>{n.push({key:m,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${f})`);let r=[];e.forEach((a,m)=>{r.push({key:m,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Z[117],ee([0,1,10,28,7,31]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function R(d){if(O.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function T(d,p,I,g,P,u,c,E,y,f){const h=Object.create(null);h["common.machineId"]=c,h.sessionID=(0,L.generateUuid)()+Date.now(),h.commitHash=P,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,O.PlatformToString)(O.platform),h["common.nodePlatform"]=S.platform,h["common.nodeArch"]=g,h["common.product"]=f||"desktop";const o=l(E||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),O.isLinuxSnap&&(h["common.snap"]="true");const i=R(I);i&&(h["common.platformDetail"]=i);try{const n=await d.readFile(w.URI.file(y));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}t.resolveCommonProperties=T;function l(d){const p=S.env.USERDNSDOMAIN;if(!p)return!1;const I=p.toLowerCase();return d.some(g=>I===g)}t.verifyMicrosoftInternalDomain=l}),define(Z[29],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,O.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var S;(function(L){L[L.NONE=0]="NONE",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(S=t.TelemetryLevel||(t.TelemetryLevel={}));var w;(function(L){L.OFF="off",L.ERROR="error",L.ON="on"})(w=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Z[118],ee([0,1,20,3,25,9,13,2,10,7,75,23,24,14,32,29]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let E=class extends T.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,I.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(p.localize(0,null));if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new I.ExtensionManagementError(p.localize(1,null,s.identifier.id,u.default.nameLong,(0,I.TargetPlatformToString)(n)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,L.getErrorMessage)(n)),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,w.CancellationToken.None);if(i===null){const n=new I.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new I.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(p.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!d.URI.isUri(e)){let b=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(b)return this.logService.info("Extensions is already requested to install",e.identifier.id),b.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);d.URI.isUri(e)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let m=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const F=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:v,manifest:C}of F)if(m=m||!!C.extensionDependencies?.some(N=>(0,g.areSameExtensions)({id:N},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(v.identifier,v.version).key()))this.logService.info("Extension is already requested to install",v.identifier.id);else{const N=this.createInstallExtensionTask(C,v,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(N.identifier,C.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:v}),this.logService.info("Installing extension:",N.identifier.id),n.push({task:N,manifest:C})}}catch(F){if(d.URI.isUri(a.source))(0,O.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,F.message),(0,O.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,F.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(F),F}const b=n.reduce((F,{task:v,manifest:C})=>(F.set(v.identifier.id.toLowerCase(),{task:v,manifest:C}),F),new Map);for(;b.size;){let F;const v=[...b.values()].filter(({manifest:C})=>!C.extensionDependencies?.some(N=>b.has(N.toLowerCase())));v.length?F=b.size===1?v:v.filter(({task:C})=>!(C===a&&!m)):(this.logService.info("Found extensions with circular dependencies",v.map(({task:C})=>C.identifier.id)),F=[...b.values()]),await this.joinAllSettled(F.map(async({task:C})=>{const N=new Date().getTime();try{const W=await C.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(W,C.source,i,w.CancellationToken.None))),!d.URI.isUri(C.source)&&(f(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,void 0),l.isWeb&&C.operation===1))try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch(Y){}r.push({local:W,identifier:C.identifier,operation:C.operation,source:C.source})}catch(W){throw d.URI.isUri(C.source)||f(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,W),this.logService.error("Error while installing the extension:",C.identifier.id),this.logService.error(W),W}finally{b.delete(C.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:F})=>this.logService.info("Extension installed successfully:",F.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:F})=>(0,g.areSameExtensions)(F,a.identifier))[0].local}catch(b){if(n.forEach(({task:F})=>F.cancel()),r.length)try{const F=await Promise.allSettled(r.map(({local:v})=>this.createUninstallExtensionTask(v,{versionOnly:!0}).run()));for(let v=0;v<F.length;v++){const C=F[v],{identifier:N}=r[v];C.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,L.getErrorMessage)(C.reason))}}catch(F){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(F),r.map(({identifier:v})=>v.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,L.getErrorMessage)(b)),this._onDidInstallExtensions.fire(n.map(({task:F})=>({identifier:F.identifier,operation:1,source:F.source}))),b instanceof Error&&(b.name=b&&b.code?b.code:t.ERROR_UNKNOWN),b}finally{for(const{task:b,manifest:F}of n)if(!d.URI.isUri(b.source)){const v=new g.ExtensionIdentifierWithVersion(b.identifier,F.version).key();this.installingExtensions.delete(v)||this.logService.warn("Installation task is not found in the cache",v)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw y(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(b=>b.identifier)],a=[],m=async(b,F)=>{const v=F.extensionDependencies||[],C=[...v];if(F.extensionPack){const N=i?n.find(W=>(0,g.areSameExtensions)(W.identifier,b)):void 0;for(const W of F.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(Y=>(0,g.areSameExtensions)({id:Y},{id:W}))||C.every(Y=>!(0,g.areSameExtensions)({id:Y},{id:W}))&&C.push(W)}if(C.length){const N=[...r,...a.map(Y=>Y.gallery.identifier)],W=C.filter(Y=>N.every(ie=>!(0,g.areSameExtensions)(ie,{id:Y})));if(W.length){const Y=await this.galleryService.query({names:W,pageSize:C.length},w.CancellationToken.None);for(const ie of Y.firstPage){if(N.find(ce=>(0,g.areSameExtensions)(ce,ie.identifier)))continue;if(!v.some(ce=>(0,g.areSameExtensions)({id:ce},ie.identifier))&&!await this.canInstall(ie)){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}const te=await this.checkAndGetCompatibleVersion(ie,!0),ue=await this.galleryService.getManifest(te,w.CancellationToken.None);if(ue===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${te.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:te,manifest:ue}),await m(te.identifier,ue)}}}};return await m(s,e),n=await this.getInstalled(),a.filter(b=>!n.some(F=>(0,g.areSameExtensions)(F.identifier,b.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new I.ExtensionManagementError(p.localize(4,null,s.identifier.id),I.INSTALL_ERROR_MALICIOUS);const i=await this.getCompatibleVersion(s,e);if(!i)throw new I.ExtensionManagementError(p.localize(5,null,s.identifier.id,u.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(b,F)=>{const v=this.createUninstallExtensionTask(b,F);return this.uninstallingExtensions.set(v.extension.identifier.id.toLowerCase(),v),this.logService.info("Uninstalling extension:",b.identifier.id),this._onUninstallExtension.fire(b.identifier),v},r=(b,F)=>{F?this.logService.error("Failed to uninstall extension:",b.identifier.id,F.message):this.logService.info("Successfully uninstalled extension:",b.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(b),void 0,F),this._onDidUninstallExtension.fire({identifier:b.identifier,error:F?.code})},a=[],m=[];try{a.push(n(s,{}));const b=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const F=this.getAllPackExtensionsToUninstall(s,b);for(const v of F)this.uninstallingExtensions.has(v.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",v.identifier.id):a.push(n(v,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(F=>F.extension),b,s),await this.joinAllSettled(a.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(v=>v.postUninstall(F.extension,e,w.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch(v){}r(F.extension)}catch(v){const C=v instanceof I.ExtensionManagementError?v:new I.ExtensionManagementError((0,L.getErrorMessage)(v),t.ERROR_UNKNOWN);throw r(F.extension,C),C}finally{m.push(F)}}))}catch(b){const F=b instanceof I.ExtensionManagementError?b:new I.ExtensionManagementError((0,L.getErrorMessage)(b),t.ERROR_UNKNOWN);for(const v of a){try{v.cancel()}catch(C){}m.includes(v)||r(v.extension,F)}throw F}finally{for(const b of a)this.uninstallingExtensions.delete(b.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",b.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(m=>!s.some(b=>(0,g.areSameExtensions)(b.identifier,m.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?p.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?p.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(m=>!m.isBuiltin&&n.some(b=>(0,g.areSameExtensions)({id:b},m.identifier))),a=[];for(const m of r)a.push(...this.getAllPackExtensionsToUninstall(m,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,g.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};E=de([le(0,I.IExtensionGalleryService),le(1,c.ITelemetryService),le(2,P.ILogService)],E),t.AbstractExtensionManagementService=E;function y(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=y;function f(o,s,e,i,n){const r=n?n instanceof I.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=f;class h{constructor(){this.barrier=new S.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,S.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,S.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(Z[36],ee([0,1,18,11,27,29]),function($,t,O,S,w,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,f){return Promise.resolve(void 0)}publicLog2(y,f){return this.publicLog(y,f)}publicLogError(y,f){return Promise.resolve(void 0)}publicLogError2(y,f){return this.publicLogError(y,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=R,t.NullTelemetryService=new R;class T{async publicLog(y,f,h){}async publicLogError(y,f,h){}}t.NullEndpointTelemetryService=T,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(E,y){return y.onDidChangeConfiguration(f=>{f.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(f.source),configurationKeys:u(f.sourceConfig)})})}t.configurationTelemetry=l;function d(E,y){return!(y.disableTelemetry||!E.enableTelemetry)}t.supportsTelemetry=d;function p(E){const y=E.getValue(L.TELEMETRY_SETTING_ID),f=E.getValue(L.TELEMETRY_OLD_SETTING_ID);if(f!==void 0&&f===!1)return 0;switch(y??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}t.getTelemetryLevel=p;function I(E){const y=Object.create(null),f=Object.create(null),h=Object.create(null);P(E,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const s=h[o];typeof s=="number"?f[o]=s:typeof s=="boolean"?f[o]=s?1:0:typeof s=="string"?y[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(y[o]=s)}return{properties:y,measurements:f}}t.validateTelemetryData=I;function g(E){if(!E)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{E.indexOf(`${h}+`)===0&&(y=h)}),y}t.cleanRemoteAuthority=g;function P(E,y,f=0,h){if(!!E)for(let o of Object.getOwnPropertyNames(E)){const s=E[o],e=h?h+o:o;Array.isArray(s)?y[e]=(0,O.safeStringify)(s):s instanceof Date?y[e]=s.toISOString():(0,S.isObject)(s)?f<2?P(s,y,f+1,e+"."):y[e]=(0,O.safeStringify)(s):y[e]=s}}function u(E){if(!E)return[];const y=[];return c(y,"",E),y}function c(E,y,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(h=>c(E,y?`${y}.${h}`:h,f[h])):E.push(y)}}),define(Z[119],ee([0,1,20,25,9,18,10,28,7,27,21,23,24,51,16,14,42,43,115,116,29,36]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c,E,y,f,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=R.isWeb?"web":(0,I.getTargetPlatform)(R.platform,T.arch);var i;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...k){return String(k.reduce((A,j)=>A|j,0))}var r;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},F={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class v{constructor(A=F){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,j=this.state.pageSize){return new v({...this.state,pageNumber:A,pageSize:j})}withFilter(A,...j){const V=[...this.state.criteria,...j.length?j.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new v({...this.state,criteria:V})}withSortBy(A){return new v({...this.state,sortBy:A})}withSortOrder(A){return new v({...this.state,sortOrder:A})}withFlags(...A){return new v({...this.state,flags:A.reduce((j,V)=>j|V,0)})}withAssetTypes(...A){return new v({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:j,pageSize:V,sortBy:X,sortOrder:Q,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:A,pageNumber:j,pageSize:V,sortBy:X,sortOrder:Q}],assetTypes:re,flags:se}}get searchText(){const A=this.state.criteria.filter(j=>j.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function C(k,A){const j=(k||[]).filter(V=>V.statisticName===A)[0];return j?j.value:0}function N(k){const A="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,X)=>{const Q=oe(k,X.assetType);return Q&&V.push([X.assetType.substring(A.length),Q]),V},[])}function W(k){if(k.properties){const A=k.properties.filter(X=>X.key===a.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(X=>j.test(X.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return oe(k,a.Repository)}function Y(k){return{uri:`${k.fallbackAssetUri}/${a.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${a.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function ie(k){const A=oe(k,a.Icon);if(A)return A;const j=I.DefaultIconPath;return{uri:j,fallbackUri:j}}function oe(k,A){return k.files.filter(V=>V.assetType===A)[0]?{uri:`${k.assetUri}/${A}`,fallbackUri:`${k.fallbackAssetUri}/${A}`}:null}function te(k,A){const j=k.properties?k.properties.filter(X=>X.key===A):[],V=j.length>0&&j[0].value;return V?V.split(",").map(X=>(0,g.adoptToGalleryExtensionId)(X)):[]}function ue(k){const A=k.properties?k.properties.filter(j=>j.key===m.Engine):[];return A.length>0&&A[0].value||""}function ce(k){const A=k.properties?k.properties.filter(V=>V.key===m.LocalizedLanguages):[],j=A.length>0&&A[0].value||"";return j?j.split(","):[]}function G(k){return k.indexOf("preview")!==-1}function ne(k){return k.targetPlatform?(0,I.toTargetPlatform)(k.targetPlatform):"undefined"}function z(k){const A=(0,O.distinct)(k.versions.map(ne)),j=!!k.tags?.includes(I.WEB_EXTENSION_TAG),V=A.indexOf("web");return j?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function D(k,A){const j=(0,I.getFallbackTargetPlarforms)(A);for(let V=0;V<k.length;V++){const X=k[V];if(X.version===k[V-1]?.version){let Q=V;const se=ne(X);if(se===A)for(;Q>0&&k[Q-1].version===X.version;)Q--;else if(j.includes(se))for(;Q>0&&k[Q-1].version===X.version&&ne(k[Q-1])!==A;)Q--;Q!==V&&(k.splice(V,1),k.splice(Q,0,X))}}return k}t.sortExtensionVersions=D;function M(k,A,j,V,X){const Q=z(k);let se=k.versions[0];return se=k.versions.find(re=>re.version===se.version&&(0,I.isTargetPlatformCompatible)(ne(re),Q,X))||se,U(k,se,Q,A,j,V)}function U(k,A,j,V,X,Q){const se={manifest:oe(A,a.Manifest),readme:oe(A,a.Details),changelog:oe(A,a.Changelog),license:oe(A,a.License),repository:W(A),download:Y(A),icon:ie(A),coreTranslations:N(A)};return{identifier:{id:(0,g.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:A.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:C(k.statistics,"install"),rating:C(k.statistics,"averagerating"),ratingCount:C(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:j,assets:se,properties:{dependencies:te(A,m.Dependency),extensionPack:te(A,m.ExtensionPack),engine:ue(A),localizedLanguages:ce(A),targetPlatform:ne(A)},preview:G(k.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+V,querySource:Q}}}let K=class{constructor(A,j,V,X,Q,se,re,me){this.requestService=j,this.logService=V,this.environmentService=X,this.telemetryService=Q,this.fileService=se,this.productService=re,this.configurationService=me;const ye=re.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=q(re.version,re,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,j){const V=[];let X=new v().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(X,e,S.CancellationToken.None);for(let se=0;se<Q.length;se++){const re=Q[se];if(!re.versions.length)continue;const me=(0,g.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),ye=A.find(fe=>(0,g.areSameExtensions)(fe,{id:me}))?.version;if(ye){const fe=re.versions.find(Pe=>Pe.version===ye);fe&&V.push(U(re,fe,z(re),se,X))}else V.push(M(re,se,X,void 0,e))}return V}async getCompatibleExtension(A,j){const V=(0,I.isIExtensionIdentifier)(A)?null:A;if(V){if((0,I.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(V,j))return V}const{id:X,uuid:Q}=V?V.identifier:A;let se=new v().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(r.ExtensionId,Q):se=se.withFilter(r.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,j,S.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const ye=z(me);if((0,I.isNotWebExtensionInWebTargetPlatform)(ye,j))return null;for(let fe of me.versions){if(!ue(fe)){const Pe=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:m.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(fe,ye,j))return U(me,fe,ye,0,se)}return null}async isExtensionCompatible(A,j){if(!(0,I.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,j))return!1;let V=A.properties.engine;if(!V){const X=await this.getManifest(A,S.CancellationToken.None);if(!X)throw new Error("Manifest was not found");V=X.engines.vscode}return(0,P.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,j,V){if(!(0,I.isTargetPlatformCompatible)(ne(A),j,V))return!1;const X=await this.getEngine(A);return(0,P.isEngineValid)(X,this.productService.version,this.productService.date)}async query(A,j){const V=S.CancellationToken.isCancellationToken(A)?{}:A,X=S.CancellationToken.isCancellationToken(A)?A:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=V.text||"";const se=(0,L.getOrDefault)(V,pe=>pe.pageSize,50);let re=new v().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Category,Ae||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Tag,Ae||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),re=re.withFilter(r.SearchText,Q)),re=re.withSortBy(0)):V.ids?re=re.withFilter(r.ExtensionId,...V.ids):V.names?re=re.withFilter(r.ExtensionName,...V.names):re=re.withSortBy(4),typeof V.sortBy=="number"&&(re=re.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(re=re.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(re,e,X),fe=me.map((pe,Ee)=>M(pe,Ee,re,V.source,e)),Pe=async(pe,Ee)=>{if(Ee.isCancellationRequested)throw(0,w.canceled)();const Ae=re.withPage(pe+1),{galleryExtensions:Me}=await this.queryGallery(Ae,e,Ee);return Me.map((Ue,ze)=>M(Ue,ze,Ae,V.source,e))};return{firstPage:fe,total:ye,pageSize:re.pageSize,getPage:Pe}}async queryGallery(A,j,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const X=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},re=new Date().getTime();let me,ye,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},V),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const Pe=await(0,y.asJson)(me);if(Pe){const pe=Pe.results[0],Ee=pe.extensions;Ee.forEach(Me=>D(Me.versions,j));const Ae=pe.resultMetadata&&pe.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Ae&&Ae.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe}}return{galleryExtensions:[],total:fe}}catch(Pe){throw ye=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-re,success:!!me&&(0,y.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,w.isPromiseCanceledError)(ye)?"canceled":(0,w.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,j,V,X){if(!this.isEnabled())return;const Q=R.isWeb?this.api(`/itemName/${A}.${j}/version/${V}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${j}/${V}/stats?statType=${X}`),se=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},S.CancellationToken.None)}catch(ye){}}async download(A,j,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,g.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=V===1?"install":V===2?"update":"",me=re?{uri:`${A.assets.download.uri}${l.URI.parse(A.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${A.assets.download.fallbackUri}${l.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:A.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(j,ye.stream),se(new Date().getTime()-Q)}async getReadme(A,j){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},j);return await(0,y.asText)(V)||""}return""}async getManifest(A,j){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},j),X=await(0,y.asText)(V);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,j){const V=oe(A,a.Manifest);if(!V)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Q=await this.getAsset(V,{headers:X});return await(0,y.asJson)(Q)}async getCoreTranslation(A,j){const V=A.assets.coreTranslations.filter(X=>X[0]===j.toUpperCase())[0];if(V){const X=await this.getAsset(V[1]),Q=await(0,y.asText)(X);return Q?JSON.parse(Q):null}return null}async getChangelog(A,j){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},j);return await(0,y.asText)(V)||""}return""}async getAllCompatibleVersions(A,j){let V=new v().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?V=V.withFilter(r.ExtensionId,A.identifier.uuid):V=V.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryGallery(V,j,S.CancellationToken.None);if(!X.length)return[];const Q=z(X[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(Q,j))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,Q,j)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(A,j={},V=S.CancellationToken.None){const X=await this.commonHeadersPromise,Q={type:"GET"},se={...X,...j.headers||{}};j={...j,...Q,headers:se};const re=A.uri,me=A.fallbackUri,ye={...j,url:re};try{const fe=await this.requestService.request(ye,V);if(fe.res.statusCode===200)return fe;const Pe=await(0,y.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Pe}`)}catch(fe){if((0,w.isPromiseCanceledError)(fe))throw fe;const Pe=(0,w.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Pe});const pe={...j,url:me};return this.requestService.request(pe,V)}}async getEngine(A){let j=ue(A);if(!j){const V=await this.getManifestFromRawExtensionVersion(A,S.CancellationToken.None);if(!V)throw new Error("Manifest was not found");j=V.engines.vscode}return j}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},S.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,y.asJson)(A),V=new Map;if(j)for(const X of j.malicious){const Q=V.get(X)||{id:{id:X},malicious:!0,slow:!1};Q.malicious=!0,V.set(X,Q)}return[...V.values()]}};K=de([le(1,y.IRequestService),le(2,c.ILogService),le(3,p.IEnvironmentService),le(4,o.ITelemetryService),le(5,u.IFileService),le(6,E.IProductService),le(7,d.IConfigurationService)],K);let B=class extends K{constructor(A,j,V,X,Q,se,re,me){super(A,j,V,X,Q,se,re,me)}};B=de([le(0,h.IStorageService),le(1,y.IRequestService),le(2,c.ILogService),le(3,p.IEnvironmentService),le(4,o.ITelemetryService),le(5,u.IFileService),le(6,E.IProductService),le(7,d.IConfigurationService)],B),t.ExtensionGalleryService=B;let J=class extends K{constructor(A,j,V,X,Q,se,re){super(void 0,A,j,V,X,Q,se,re)}};J=de([le(0,y.IRequestService),le(1,c.ILogService),le(2,p.IEnvironmentService),le(3,o.ITelemetryService),le(4,u.IFileService),le(5,E.IProductService),le(6,d.IConfigurationService)],J),t.ExtensionGalleryServiceWithNoStorageService=J;async function q(k,A,j,V,X,Q){const se={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},re=await(0,f.getServiceMachineId)(j,X,Q);return(0,s.supportsTelemetry)(A,j)&&(0,s.getTelemetryLevel)(V)===3&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=q}),define(Z[120],ee([0,1,2,18,10,22,86,27,33,32,26,29,36]),function($,t,O,S,w,L,R,T,l,d,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let P=class{constructor(E,y){this._configurationService=y,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(f=>{const h=/^[a-f0-9]+$/i.test(f["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(E,y){this._experimentProperties[E]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let y=E.sessionID,f=E["common.instanceId"],h=E["common.machineId"],o=E["common.firstSessionDate"],s=E["common.msftInternal"];return{sessionId:y,instanceId:f,machineId:h,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(E,y,f,h){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(o=>{f=(0,S.mixin)(f,o),f=(0,S.mixin)(f,this._experimentProperties),f=(0,S.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,h)}),this._appenders.forEach(s=>s.log(E,f))},o=>{console.error(o)})}publicLog(E,y,f){return this._log(E,3,y,f)}publicLog2(E,y,f){return this.publicLog(E,y,f)}publicLogError(E,y){return this.sendErrorTelemetry?this._log(E,2,y,!0):Promise.resolve(void 0)}publicLogError2(E,y){return this.publicLogError(E,y)}_anonymizeFilePaths(E){let y=E;const f=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(E);if(!i)break;f.push([i.index,e.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(y="";;){const e=o.exec(E);if(!e)break;!h.test(e[0])&&f.every(([i,n])=>e.index<i||e.index>=n)&&(y+=E.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<E.length&&(y+=E.substr(s)),y}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const y=E.toLowerCase(),f=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(y)?"<REDACTED: secret>":f.test(y)?"<REDACTED: email>":E}_cleanupInfo(E,y){let f=E;y&&(f=this._anonymizeFilePaths(f));for(let h of this._cleanupPatterns)f=f.replace(h,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=de([le(1,T.IConfigurationService)],P),t.TelemetryService=P;const u=w.isWeb?"":" "+(0,R.localize)(0,null);p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(1,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null)],markdownDescription:d.default.privacyStatementUrl?(0,R.localize)(6,null,d.default.nameLong,d.default.privacyStatementUrl)+u:(0,R.localize)(5,null,d.default.nameLong)+u,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(7,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,R.localize)(9,null,d.default.nameLong,d.default.privacyStatementUrl):(0,R.localize)(8,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(10,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[121],ee([0,1,9,18,36]),function($,t,O,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function L(T){const l=await new Promise((p,I)=>{$(["applicationinsights"],p,I)});let d;return l.defaultClient?(d=new l.TelemetryClient(T),d.channel.setUseDiskRetryCaching(!0)):(l.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=l.defaultClient),T.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class R{constructor(l,d,p){this._eventPrefix=l,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof p=="function"?this._aiClient=p():this._aiClient=p,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(d=>{l(d)},d=>{(0,O.onUnexpectedError)(d),console.error(d)})}}log(l,d){!this._aiClient||(d=(0,S.mixin)(d,this._defaultData),d=(0,w.validateTelemetryData)(d),this._withAIClient(p=>p.trackEvent({name:this._eventPrefix+"/"+l,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=R}),define(Z[122],ee([0,1,4,12]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(L,R){const T=Object.create(null),l=(p,I)=>{const g=JSON.parse(p);T[I]=g};if(R){const p=[],I=await S.Promises.readdir(R);for(const P of I)try{(await S.Promises.stat((0,O.join)(R,P))).isDirectory()&&p.push(P)}catch{}const g=[];for(const P of p)(await S.Promises.readdir((0,O.join)(R,P))).filter(c=>c==="telemetry.json").length===1&&g.push(P);for(const P of g){const u=(await S.Promises.readFile((0,O.join)(R,P,"telemetry.json"))).toString();l(u,P)}}let d=(await S.Promises.readFile((0,O.join)(L,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await S.Promises.readFile((0,O.join)(L,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(T,null,4)}t.buildTelemetryMessage=w}),define(Z[44],ee([0,1,48,3,4,11,12,73,133,134]),function($,t,O,S,w,L,R,T,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class p extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=p;function I(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function g(s){if(s instanceof p)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new p(e,s)}function P(s,e,i,n,r,a){const m=w.dirname(e),b=w.join(n,m);if(!b.startsWith(n))return Promise.reject(new Error(T.localize(0,null,e)));const F=w.join(n,e);let v;return a.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(R.Promises.mkdir(b,{recursive:!0})).then(()=>new Promise((C,N)=>{if(!a.isCancellationRequested)try{v=(0,O.createWriteStream)(F,{mode:i}),v.once("close",()=>C()),v.once("error",N),s.once("error",N),s.pipe(v)}catch(W){N(W)}}))}function u(s,e,i,n){let r=(0,S.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((m,b)=>{const F=new S.Sequencer,v=C=>{C.isCancellationRequested||(a++,s.readEntry())};s.once("error",b),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?m():b(new p("Incomplete",new Error(T.localize(1,null,a,s.entryCount))))},b)),s.readEntry(),s.on("entry",C=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){v(n);return}const N=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const ie=w.join(e,N);r=(0,S.createCancelablePromise)(oe=>R.Promises.mkdir(ie,{recursive:!0}).then(()=>v(oe)).then(void 0,b));return}const W=E(s,C),Y=I(C);r=(0,S.createCancelablePromise)(ie=>F.queue(()=>W.then(oe=>P(oe,N,Y,e,i,ie).then(()=>v(ie)))).then(null,b))})})}function c(s,e=!1){return new Promise((i,n)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(g(r)):i((0,L.assertIsDefined)(a))})})}function E(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(g(r)):i((0,L.assertIsDefined)(a))})})}function y(s,e){return new Promise((i,n)=>{const r=new d.ZipFile;e.forEach(m=>{m.contents?r.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&r.addFile(m.localPath,m.path)}),r.end();const a=(0,O.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=y;function f(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=c(s,!0);return i.overwrite&&(a=a.then(m=>R.Promises.rm(e).then(()=>m))),a.then(m=>u(m,e,{sourcePathRegex:r},n))}t.extract=f;function h(s,e){return c(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&E(i,a).then(m=>n(m),m=>r(m))}),i.once("close",()=>r(new Error(T.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",m=>a.push(m)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(Z[123],ee([0,1,44,79]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(L){return(0,O.buffer)(L,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(T){throw new Error((0,S.localize)(0,null))}})}t.getManifest=w}),define(Z[124],ee([0,1,20,3,9,2,8,4,10,19,41,7,31,12,44,80,21,23,24,91,16,14,42]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c,E,y,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",a="deleting",m="renaming";let b=class extends L.Disposable{constructor(v,C,N,W,Y){super();this.beforeRemovingExtension=v,this.fileService=C,this.logService=N,this.environmentService=W,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=W.builtinExtensionsPath,this.extensionsPath=W.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new S.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(v){const C=[];(v===null||v===0)&&C.push(this.scanSystemExtensions().then(null,N=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(N).message,i)))),(v===null||v===1)&&C.push(this.scanUserExtensions(!0).then(null,N=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(N).message,n))));try{const N=await Promise.all(C);return(0,O.flatten)(N)}catch(N){throw this.joinErrors(N)}}async scanUserExtensions(v){this.logService.trace("Started scanning user extensions");let[C,N]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return N=N.filter(W=>!C[new f.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).key()]),v&&(N=(0,f.groupByExtension)(N,Y=>Y.identifier).map(Y=>Y.sort((ie,oe)=>p.rcompare(ie.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",N.length),N}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(v,C,N,W){const Y=v.key(),ie=T.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),oe=T.join(this.extensionsPath,Y);try{await P.Promises.rm(oe)}catch(ue){try{await P.Promises.rm(oe)}catch(ce){}throw new y.ExtensionManagementError((0,c.localize)(0,null,oe,v.id),a)}await this.extractAtLocation(v,C,ie,W);let te=await this.scanExtension(I.URI.file(ie),1);if(!te)throw new Error((0,c.localize)(1,null,ie));await this.storeMetadata(te,{...N,installedTimestamp:Date.now()});try{await this.rename(v,ie,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(ue){try{await P.Promises.rm(ie)}catch(ce){}if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",v.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(ue)}. Deleted from extracted location`,ie),ue}try{te=await this.scanExtension(I.URI.file(oe),1)}catch(ue){}if(te)return te;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(v,C){return this.setMetadata(v,C),await this.storeMetadata(v,{...C,installedTimestamp:v.installedTimestamp}),v}async storeMetadata(v,C){C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.installedTimestamp=C.installedTimestamp||void 0;const N=T.join(v.location.fsPath,"package.json"),W=await P.Promises.readFile(N,"utf8"),{manifest:Y}=await this.parseManifest(W);return Y.__metadata=C,await P.Promises.writeFile(N,JSON.stringify(Y,null,"	")),v}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...v){const C=v.map(N=>new f.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version));await this.withUninstalledExtensions(N=>{C.forEach(W=>N[W.key()]=!0)})}async setInstalled(v){await this.withUninstalledExtensions(W=>delete W[v.key()]);const N=(await this.scanExtensions(1)).find(W=>new f.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).equals(v))||null;return N?(await this.storeMetadata(N,{installedTimestamp:Date.now()}),this.scanExtension(N.location,1)):null}async withUninstalledExtensions(v){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await P.Promises.readFile(this.uninstalledPath,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let N={};if(C)try{N=JSON.parse(C)}catch(W){}return v&&(v(N),Object.keys(N).length?await P.Promises.writeFile(this.uninstalledPath,JSON.stringify(N)):await P.Promises.rm(this.uninstalledPath)),N})}async removeExtension(v,C){this.logService.trace(`Deleting ${C} extension from disk`,v.identifier.id,v.location.fsPath),await P.Promises.rm(v.location.fsPath),this.logService.info("Deleted from disk",v.identifier.id,v.location.fsPath)}async removeUninstalledExtension(v){await this.removeExtension(v,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new f.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()])}async extractAtLocation(v,C,N,W){this.logService.trace(`Started extracting the extension from ${C} to ${N}`);try{await P.Promises.rm(N)}catch(Y){throw new y.ExtensionManagementError(this.joinErrors(Y).message,a)}try{await(0,u.extract)(C,N,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${N}:`,v.id)}catch(Y){try{await P.Promises.rm(N)}catch(ie){}throw new y.ExtensionManagementError(Y.message,Y instanceof u.ExtractError&&Y.type?Y.type:r)}}async rename(v,C,N,W){try{await P.Promises.rename(C,N)}catch(Y){if(l.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<W)return this.logService.info(`Failed renaming ${C} to ${N} with 'EPERM' error. Trying again...`,v.id),this.rename(v,C,N,W);throw new y.ExtensionManagementError(Y.message||(0,c.localize)(3,null,C,N),Y.code||m)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const v=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return v;const C=this.scanDevSystemExtensions(),[N,W]=await Promise.all([v,C]);return[...N,...W]}async scanExtensionsInDir(v,C){const N=new S.Limiter(10),W=await this.fileService.resolve(I.URI.file(v));return W.children?(await Promise.all(W.children.filter(ie=>ie.isDirectory).map(ie=>N.queue(async()=>C===1&&(0,d.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,C))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(v,C){try{const N=await this.fileService.resolve(v);if(N.children){const{manifest:W,metadata:Y}=await this.readManifest(v.fsPath),ie=N.children.find(({name:ce})=>/^readme(\.txt|\.md|)$/i.test(ce))?.resource,oe=N.children.find(({name:ce})=>/^changelog(\.txt|\.md|)$/i.test(ce))?.resource,te={id:(0,f.getGalleryExtensionId)(W.publisher,W.name)},ue={type:C,identifier:te,manifest:W,location:v,readmeUrl:ie,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:C===0};return Y&&(this.setMetadata(ue,Y),ue.installedTimestamp=Y.installedTimestamp),ue}}catch(N){C!==0&&this.logService.trace(N)}return null}async scanDefaultSystemExtensions(){const v=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",v.length),v}async scanDevSystemExtensions(){const v=this.getDevSystemExtensionsList();if(v.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(N=>v.some(W=>(0,f.areSameExtensions)(N.identifier,{id:W})))}else return[]}setMetadata(v,C){v.publisherDisplayName=C.publisherDisplayName||null,v.publisherId=C.publisherId||null,v.identifier.uuid=C.id,v.isMachineScoped=!!C.isMachineScoped,v.isBuiltin=v.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const v=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),N=new Set;for(const ie of C)v[new f.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||N.add(ie.identifier.id.toLowerCase());const W=(0,f.groupByExtension)(C,ie=>ie.identifier);await S.Promises.settled(W.map(async ie=>{const oe=ie.sort((te,ue)=>p.rcompare(te.manifest.version,ue.manifest.version))[0];N.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const Y=C.filter(ie=>v[new f.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await S.Promises.settled(Y.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const v=await this.scanAllUserExtensions(),C=[],N=(0,f.groupByExtension)(v,W=>W.identifier);C.push(...(0,O.flatten)(N.map(W=>W.sort((Y,ie)=>p.rcompare(Y.manifest.version,ie.manifest.version)).slice(1)))),await S.Promises.settled(C.map(W=>this.removeExtension(W,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(v=>v.name)}joinErrors(v){const C=Array.isArray(v)?v:[v];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((N,W)=>new Error(`${N.message}${N.message?",":""}${W instanceof Error?W.message:W}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(R.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(v){const C=[P.Promises.readFile(T.join(v,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),P.Promises.readFile(T.join(v,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:N,metadata:W},Y]=await Promise.all(C);return{manifest:(0,h.localizeManifest)(N,Y),metadata:W}}parseManifest(v){return new Promise((C,N)=>{try{const W=JSON.parse(v),Y=W.__metadata||null;C({manifest:W,metadata:Y})}catch(W){N(new Error((0,c.localize)(4,null)))}})}};b=de([le(1,o.IFileService),le(2,s.ILogService),le(3,E.INativeEnvironmentService),le(4,e.IProductService)],b),t.ExtensionsScanner=b}),define(Z[125],ee([0,1,30,9,8,4,10,28,19,41,7,31,12,44,78,53,21,118,23,24,102,103,123,98,124,104,51,16,15,14,32,29]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c,E,y,f,h,o,s,e,i,n,r,a,m,b,F,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const N="unsetUninstalled",W="downloading";let Y=class extends y.AbstractExtensionManagementService{constructor(G,ne,z,D,M,U,K){super(G,ne,z);this.environmentService=D,this.downloadService=M,this.fileService=K;const B=this._register(U.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(n.ExtensionsScanner,q=>B.postUninstall(q))),this.manifestCache=this._register(new i.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(U.createInstance(o.ExtensionsDownloader));const J=this._register(new r.ExtensionsWatcher(this,K,D,z));this._register(J.onDidChangeExtensionsByAnotherSource(({added:q,removed:k})=>{q.length&&this._onDidInstallExtensions.fire(q.map(A=>({identifier:A.identifier,operation:0,local:A}))),k.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const G=await this.isAlpineLinux(),ne=(0,f.getTargetPlatform)(G?"alpine":R.platform,T.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ne),ne})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let G;try{G=(await this.fileService.readFile(p.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{G=(await this.fileService.readFile(p.URI.file("/usr/lib/os-release"))).value.toString()}catch(z){this.logService.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(z))}}return!!G&&(G.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const ne=await this.collectFiles(G),z=await(0,P.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,ne);return p.URI.file(z)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const ne=await this.downloadVsix(G),z=L.resolve(ne.fsPath);return(0,e.getManifest)(z)}getInstalled(G=null){return this.extensionsScanner.scanExtensions(G)}async install(G,ne={}){this.logService.trace("ExtensionManagementService#install",G.toString());const z=await this.downloadVsix(G),D=await(0,e.getManifest)(L.resolve(z.fsPath));if(D.engines&&D.engines.vscode&&!(0,a.isEngineValid)(D.engines.vscode,v.default.version,v.default.date))throw new Error(u.localize(0,null,(0,h.getGalleryExtensionId)(D.publisher,D.name),v.default.version));return this.installExtension(D,z,ne)}async updateMetadata(G,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),G}async updateExtensionScope(G,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),G}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(G){if(G.scheme===w.Schemas.file)return G;const ne=(0,l.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(G,ne),ne}createInstallExtensionTask(G,ne,z){return p.URI.isUri(ne)?new te(G,ne,z,this.galleryService,this.extensionsScanner,this.logService):new oe(ne,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(G,ne){return new ue(G,ne,this.extensionsScanner)}async collectFiles(G){const ne=async D=>{let M=await g.Promises.readdir(D);M=M.map(B=>L.join(D,B));const U=await Promise.all(M.map(B=>g.Promises.stat(B)));let K=Promise.resolve([]);return U.forEach((B,J)=>{const q=M[J];B.isFile()&&(K=K.then(k=>[...k,q])),B.isDirectory()&&(K=K.then(k=>ne(q).then(A=>[...k,...A])))}),K};return(await ne(G.location.fsPath)).map(D=>({path:`extension/${L.relative(G.location.fsPath,D)}`,localPath:D}))}};Y=de([le(0,f.IExtensionGalleryService),le(1,C.ITelemetryService),le(2,F.ILogService),le(3,E.INativeEnvironmentService),le(4,c.IDownloadService),le(5,b.IInstantiationService),le(6,m.IFileService)],Y),t.ExtensionManagementService=Y;class ie extends y.AbstractExtensionTask{constructor(G,ne,z,D){super();this.identifier=G,this.source=ne,this.extensionsScanner=z,this.logService=D,this._operation=1}get operation(){return this._operation}async installExtension(G,ne){try{const z=await this.unsetUninstalledAndGetLocal(G.identifierWithVersion);if(z)return G.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,G.metadata):z}catch(z){throw R.isMacintosh?new f.ExtensionManagementError(u.localize(1,null),N):new f.ExtensionManagementError(u.localize(2,null),N)}return this.extract(G,ne)}async unsetUninstalledAndGetLocal(G){if(!await this.isUninstalled(G))return null;this.logService.trace("Removing the extension from uninstalled list:",G.id);const z=await this.extensionsScanner.setInstalled(G);return this.logService.info("Removed the extension from uninstalled list:",G.id),z}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.key()]}async extract({zipPath:G,identifierWithVersion:ne,metadata:z},D){let M=await this.extensionsScanner.extractUserExtension(ne,G,z,D);return this.logService.info("Extracting completed.",ne.id),M}}class oe extends ie{constructor(G,ne,z,D,M){super(G.identifier,G,D,M);this.gallery=G,this.options=ne,this.extensionsDownloader=z}async doRun(G){const z=(await this.extensionsScanner.scanExtensions(null)).find(M=>(0,h.areSameExtensions)(M.identifier,this.gallery.identifier));z&&(this._operation=2);const D=await this.downloadInstallableExtension(this.gallery,this._operation);D.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,D.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;try{const M=await this.installExtension(D,G);return z&&d.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z),M}catch(M){throw await this.deleteDownloadedVSIX(D.zipPath),M}}async deleteDownloadedVSIX(G){try{await this.extensionsDownloader.delete(p.URI.file(G))}catch(ne){this.logService.warn("Error while deleting the downloaded vsix",G.toString(),(0,S.getErrorMessage)(ne))}}async downloadInstallableExtension(G,ne){const z={id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName};let D;try{this.logService.trace("Started downloading extension:",G.identifier.id),D=(await this.extensionsDownloader.downloadExtension(G,ne)).fsPath,this.logService.info("Downloaded extension:",G.identifier.id,D)}catch(M){throw new f.ExtensionManagementError((0,y.joinErrors)(M).message,W)}try{const M=await(0,e.getManifest)(D);return{zipPath:D,identifierWithVersion:new h.ExtensionIdentifierWithVersion(G.identifier,M.version),metadata:z}}catch(M){throw await this.deleteDownloadedVSIX(D),new f.ExtensionManagementError((0,y.joinErrors)(M).message,y.INSTALL_ERROR_VALIDATING)}}}class te extends ie{constructor(G,ne,z,D,M,U){super({id:(0,h.getGalleryExtensionId)(G.publisher,G.name)},ne,M,U);this.manifest=G,this.location=ne,this.options=z,this.galleryService=D}async doRun(G){const ne=new h.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),D=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,h.areSameExtensions)(this.identifier,U.identifier)),M=await this.getMetadata(this.identifier.id,G);if(M.isMachineScoped=this.options.isMachineScoped||D?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||D?.isBuiltin,D)if(this._operation=2,ne.equals(new h.ExtensionIdentifierWithVersion(D.identifier,D.manifest.version)))try{await this.extensionsScanner.removeExtension(D,"existing")}catch(U){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(D.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(D);else{const U=await this.unsetUninstalledAndGetLocal(ne);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(K){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:M},G)}async getMetadata(G,ne){try{const z=(await this.galleryService.query({names:[G],pageSize:1},ne)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class ue extends y.AbstractExtensionTask{constructor(G,ne,z){super();this.extension=G,this.options=ne,this.extensionsScanner=z}async doRun(G){const ne=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const D=new h.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...z.filter(M=>D.equals(new h.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version))))}else ne.push(...z.filter(D=>(0,h.areSameExtensions)(D.identifier,this.extension.identifier)));if(!ne.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const D of ne)try{G.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(D)}catch(M){throw new Error(u.localize(6,null,(0,O.toErrorMessage)(M)))}}}}),define(Z[126],ee([0,1,114,17,9,2,11,27,21,99,14,113,135]),function($,t,O,S,w,L,R,T,l,d,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let P=class extends L.Disposable{constructor(c,E,y){super();this.environmentService=E,this.logService=y,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,E){this.logService.trace("RequestService#request",c.url);const{proxyUrl:y,strictSSL:f}=this,h={...process.env,...await(0,d.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=c.agent?c.agent:await(0,I.getProxyAgent)(c.url||"",h,{proxyUrl:y,strictSSL:f});return c.agent=o,c.strictSSL=f,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,E)}async getNodeRequest(c){return((0,O.parse)(c.url).protocol==="https:"?await new Promise((f,h)=>{$(["https"],f,h)}):await new Promise((f,h)=>{$(["http"],f,h)})).request}_request(c,E){return new Promise(async(y,f)=>{let h;const o=(0,O.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),h=s(e,i=>{const n=(0,R.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...c,url:i.headers.location,followRedirects:n-1},E).then(y,f);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,g.createGunzip)())),y({res:i,stream:(0,S.streamToBufferReadableStream)(r)})}}),h.on("error",f),c.timeout&&h.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&h.write(c.data),h.end(),E.onCancellationRequested(()=>{h.abort(),f((0,w.canceled)())})})}async resolveProxy(c){}};P=de([le(0,T.IConfigurationService),le(1,l.INativeEnvironmentService),le(2,p.ILogService)],P),t.RequestService=P}),define(Z[136],ee([0,1,48,137,34,3,17,30,9,2,8,4,28,7,12,27,111,53,112,21,90,119,23,97,125,16,107,108,52,101,55,56,105,14,106,32,42,43,126,117,29,120,36,121,122]),function($,t,O,S,w,L,R,T,l,d,p,I,g,P,u,c,E,y,f,h,o,s,e,i,n,r,a,m,b,F,v,C,N,W,Y,ie,oe,te,ue,ce,G,ne,z,D,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class U extends d.Disposable{constructor(J){super();this.argv=J,(0,S.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[J,q]=await this.initServices();return J.invokeFunction(async k=>{const A=k.get(W.ILogService),j=k.get(r.IFileService),V=k.get(h.INativeEnvironmentService),X=k.get(e.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(V,X,j),await Promise.all(q.map(Q=>{(0,L.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const J=new v.ServiceCollection,q={_serviceBrand:void 0,...ie.default};J.set(oe.IProductService,q);const k=new o.NativeEnvironmentService(this.argv,q);J.set(h.INativeEnvironmentService,k),await Promise.all([k.appSettingsHome.fsPath,k.extensionsPath].map(me=>me?u.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,W.getLogLevel)(k),j=[];j.push(new Y.SpdLogLogger("cli",(0,I.join)(k.logsPath,"cli.log"),!0,A)),A===W.LogLevel.Trace&&j.push(new W.ConsoleLogger(A));const V=this._register(new W.MultiplexLogService(j));J.set(W.ILogService,V);const X=this._register(new a.FileService(V));J.set(r.IFileService,X);const Q=this._register(new m.DiskFileSystemProvider(V));X.registerProvider(p.Schemas.file,Q);const se=this._register(new E.ConfigurationService(k.settingsResource,X));J.set(c.IConfigurationService,se),await se.initialize(),J.set(te.IRequestService,new b.SyncDescriptor(ue.RequestService)),J.set(y.IDownloadService,new b.SyncDescriptor(f.DownloadService)),J.set(e.IExtensionManagementService,new b.SyncDescriptor(n.ExtensionManagementService)),J.set(e.IExtensionGalleryService,new b.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),J.set(e.IExtensionManagementCLIService,new b.SyncDescriptor(i.ExtensionManagementCLIService)),J.set(C.ILocalizationsService,new b.SyncDescriptor(N.LocalizationsService));const re=[];if((0,z.supportsTelemetry)(q,k)){q.aiConfig&&q.aiConfig.asimovKey&&re.push(new D.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:fe}=k,Pe={appenders:re,sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const Ee=await u.Promises.readFile((0,I.join)(k.userDataPath,"storage.json"));pe=JSON.parse(Ee.toString())[G.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&V.error(Ee)}return(0,ce.resolveCommonProperties)(X,(0,w.release)(),(0,w.hostname)(),process.arch,q.commit,q.version,pe,q.msftInternalDomains,fe)})(),piiPaths:[me,ye]};J.set(G.ITelemetryService,new b.SyncDescriptor(ne.TelemetryService,[Pe]))}else J.set(G.ITelemetryService,z.NullTelemetryService);return[new F.InstantiationService(J),re]}registerErrorHandler(J){(0,l.setUnexpectedErrorHandler)(q=>{const k=(0,T.toErrorMessage)(q,!0);!k||J.error(`[uncaught exception in CLI]: ${k}`)}),process.on("uncaughtException",q=>(0,l.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,l.onUnexpectedError)(q))}async doRun(J,q,k){if(this.argv["install-source"])return this.setInstallSource(J,k,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(J.appRoot,J.extensionsPath))}asExtensionIdOrVSIX(J){return J.map(q=>/\.vsix$/i.test(q)?P.URI.file((0,I.isAbsolute)(q)?q:(0,I.join)((0,g.cwd)(),q)):q)}async setInstallSource(J,q,k){await q.writeFile(P.URI.file(J.installSourcePath),R.VSBuffer.fromString(k.slice(0,30)))}}async function K(B){const J=new U(B);try{await J.run()}finally{J.dispose()}}t.main=K})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/214ac689ca9874a8a4be386f73d5cb60e15af25e/core/vs/code/node/cliProcessMain.js.map
