/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ne){for(var e=[],c=0,M=ne.length;c<M;c++)e[c]=be[ne[c]];return e};define(be[42],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=c}),define(be[51],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function M(t){const b=[];for(let n in t)c.call(t,n)&&b.push(t[n]);return b}e.values=M;function E(t,b){for(let n in t)if(c.call(t,n)&&b({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,b){const n=Object.create(null);for(const f of t){const o=b(f);let l=n[o];l||(l=n[o]=[]),l.push(f)}return n}e.groupBy=A;function F(t){const b=Object.create(null);return t&&t.forEach((n,f)=>{b[f]=n}),b}e.fromMap=F;function k(t,b){const n=[],f=[];for(let o of t)b.has(o)||n.push(o);for(let o of b)t.has(o)||f.push(o);return{removed:n,added:f}}e.diffSets=k;function S(t,b){const n=[],f=[];for(let[o,l]of t)b.has(o)||n.push(l);for(let[o,l]of b)t.has(o)||f.push(l);return{removed:n,added:f}}e.diffMaps=S;class P{constructor(){this.map=new Map}add(b,n){let f=this.map.get(b);f||(f=new Set,this.map.set(b,f)),f.add(n)}delete(b,n){const f=this.map.get(b);!f||(f.delete(n),f.size===0&&this.map.delete(b))}forEach(b,n){const f=this.map.get(b);!f||f.forEach(n)}}e.SetMap=P}),define(be[52],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(F){return(k,S,P)=>{let t=null,b=null;if(typeof P.value=="function"?(t="value",b=P.value):typeof P.get=="function"&&(t="get",b=P.get),!b)throw new Error("not supported");P[t]=F(b,S)}}e.createDecorator=c;function M(F,k,S){let P=null,t=null;if(typeof S.value=="function"?(P="value",t=S.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",t=S.get),!t)throw new Error("not supported");const b=`$memoize$${k}`;S[P]=function(...n){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[b]}}e.memoize=M;function E(F,k,S){return c((P,t)=>{const b=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...f){this[n]||(this[n]=S?S():void 0),clearTimeout(this[b]),k&&(this[n]=k(this[n],...f),f=[this[n]]),this[b]=setTimeout(()=>{P.apply(this,f),this[n]=S?S():void 0},F)}})}e.debounce=E;function A(F,k,S){return c((P,t)=>{const b=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,f=`$throttle$lastRun$${t}`,o=`$throttle$pending$${t}`;return function(...l){if(this[n]||(this[n]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[n]=k(this[n],...l)),this[o])return;const w=this[f]+F;w<=Date.now()?(this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=S?S():void 0):(this[o]=!0,this[b]=setTimeout(()=>{this[o]=!1,this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=S?S():void 0},w-Date.now()))}})}e.throttle=A}),define(be[13],Ee([0,1,16]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(Z,oe=0){return Z[Z.length-(1+oe)]}e.tail=M;function E(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=E;function A(Z,oe,ve=(Ae,Se)=>Ae===Se){if(Z===oe)return!0;if(!Z||!oe||Z.length!==oe.length)return!1;for(let Ae=0,Se=Z.length;Ae<Se;Ae++)if(!ve(Z[Ae],oe[Ae]))return!1;return!0}e.equals=A;function F(Z,oe,ve){let Ae=0,Se=Z.length-1;for(;Ae<=Se;){const Ne=(Ae+Se)/2|0,We=ve(Z[Ne],oe);if(We<0)Ae=Ne+1;else if(We>0)Se=Ne-1;else return Ne}return-(Ae+1)}e.binarySearch=F;function k(Z,oe){let ve=0,Ae=Z.length;if(Ae===0)return 0;for(;ve<Ae;){const Se=Math.floor((ve+Ae)/2);oe(Z[Se])?Ae=Se:ve=Se+1}return ve}e.findFirstInSorted=k;function S(Z,oe,ve){if(Z=Z|0,Z>=oe.length)throw new TypeError("invalid index");let Ae=oe[Math.floor(oe.length*Math.random())],Se=[],Ne=[],We=[];for(let je of oe){const qe=ve(je,Ae);qe<0?Se.push(je):qe>0?Ne.push(je):We.push(je)}return Z<Se.length?S(Z,Se,ve):Z<Se.length+We.length?We[0]:S(Z-(Se.length+We.length),Ne,ve)}e.quickSelect=S;function P(Z,oe){const ve=[];let Ae;for(const Se of Z.slice(0).sort(oe))!Ae||oe(Ae[0],Se)!==0?(Ae=[Se],ve.push(Ae)):Ae.push(Se);return ve}e.groupBy=P;function t(Z,oe,ve){const Ae=[];function Se(je,qe,x){if(qe===0&&x.length===0)return;const G=Ae[Ae.length-1];G&&G.start+G.deleteCount===je?(G.deleteCount+=qe,G.toInsert.push(...x)):Ae.push({start:je,deleteCount:qe,toInsert:x})}let Ne=0,We=0;for(;;){if(Ne===Z.length){Se(Ne,0,oe.slice(We));break}if(We===oe.length){Se(Ne,Z.length-Ne,[]);break}const je=Z[Ne],qe=oe[We],x=ve(je,qe);x===0?(Ne+=1,We+=1):x<0?(Se(Ne,1,[]),Ne+=1):x>0&&(Se(Ne,0,[qe]),We+=1)}return Ae}e.sortedDiff=t;function b(Z,oe,ve){const Ae=t(Z,oe,ve),Se=[],Ne=[];for(const We of Ae)Se.push(...Z.slice(We.start,We.start+We.deleteCount)),Ne.push(...We.toInsert);return{removed:Se,added:Ne}}e.delta=b;function n(Z,oe,ve){if(ve===0)return[];const Ae=Z.slice(0,ve).sort(oe);return o(Z,oe,Ae,ve,Z.length),Ae}e.top=n;function f(Z,oe,ve,Ae,Se){return ve===0?Promise.resolve([]):new Promise((Ne,We)=>{(async()=>{const je=Z.length,qe=Z.slice(0,ve).sort(oe);for(let x=ve,G=Math.min(ve+Ae,je);x<je;x=G,G=Math.min(G+Ae,je)){if(x>ve&&await new Promise(te=>setTimeout(te)),Se&&Se.isCancellationRequested)throw(0,c.canceled)();o(Z,oe,qe,x,G)}return qe})().then(Ne,We)})}e.topAsync=f;function o(Z,oe,ve,Ae,Se){for(const Ne=ve.length;Ae<Se;Ae++){const We=Z[Ae];if(oe(We,ve[Ne-1])<0){ve.pop();const je=k(ve,qe=>oe(We,qe)<0);ve.splice(je,0,We)}}}function l(Z){return Z.filter(oe=>!!oe)}e.coalesce=l;function w(Z){let oe=0;for(let ve=0;ve<Z.length;ve++)Z[ve]&&(Z[oe]=Z[ve],oe+=1);Z.length=oe}e.coalesceInPlace=w;function D(Z,oe,ve){Z.splice(ve,0,Z.splice(oe,1)[0])}e.move=D;function _(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=_;function a(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=a;function d(Z,oe){if(!oe)return Z.filter((Ae,Se)=>Z.indexOf(Ae)===Se);const ve=Object.create(null);return Z.filter(Ae=>{const Se=oe(Ae);return ve[Se]?!1:(ve[Se]=!0,!0)})}e.distinct=d;function y(Z){const oe=new Set;return Z.filter(ve=>oe.has(ve)?!1:(oe.add(ve),!0))}e.distinctES6=y;function i(Z){const oe=Object.create(null);return ve=>{const Ae=Z(ve);return oe[Ae]?!1:(oe[Ae]=!0,!0)}}e.uniqueFilter=i;function v(Z,oe){const ve=r(Z,oe);if(ve!==-1)return Z[ve]}e.findLast=v;function r(Z,oe){for(let ve=Z.length-1;ve>=0;ve--){const Ae=Z[ve];if(oe(Ae))return ve}return-1}e.lastIndex=r;function s(Z,oe){return Z.length>0?Z[0]:oe}e.firstOrDefault=s;function u(Z,oe,ve=(Ae,Se)=>Ae===Se){let Ae=0;for(let Se=0,Ne=Math.min(Z.length,oe.length);Se<Ne&&ve(Z[Se],oe[Se]);Se++)Ae++;return Ae}e.commonPrefixLength=u;function h(Z){return[].concat(...Z)}e.flatten=h;function p(Z,oe){let ve=typeof oe=="number"?Z:0;typeof oe=="number"?ve=Z:(ve=0,oe=Z);const Ae=[];if(ve<=oe)for(let Se=ve;Se<oe;Se++)Ae.push(Se);else for(let Se=ve;Se>oe;Se--)Ae.push(Se);return Ae}e.range=p;function I(Z,oe,ve){return Z.reduce((Ae,Se)=>(Ae[oe(Se)]=ve?ve(Se):Se,Ae),Object.create(null))}e.index=I;function T(Z,oe){return Z.push(oe),()=>g(Z,oe)}e.insert=T;function g(Z,oe){const ve=Z.indexOf(oe);if(ve>-1)return Z.splice(ve,1),oe}e.remove=g;function C(Z,oe,ve){const Ae=Z.slice(0,oe),Se=Z.slice(oe);return Ae.concat(ve,Se)}e.arrayInsert=C;function m(Z,oe){let ve;if(typeof oe=="number"){let Ae=oe;ve=()=>{const Se=Math.sin(Ae++)*179426549;return Se-Math.floor(Se)}}else ve=Math.random;for(let Ae=Z.length-1;Ae>0;Ae-=1){const Se=Math.floor(ve()*(Ae+1)),Ne=Z[Ae];Z[Ae]=Z[Se],Z[Se]=Ne}}e.shuffle=m;function R(Z,oe){const ve=Z.indexOf(oe);ve>-1&&(Z.splice(ve,1),Z.unshift(oe))}e.pushToStart=R;function L(Z,oe){const ve=Z.indexOf(oe);ve>-1&&(Z.splice(ve,1),Z.push(oe))}e.pushToEnd=L;function V(Z,oe){return Array.isArray(Z)?Z.map(oe):oe(Z)}e.mapArrayOrNot=V;function q(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=q;function U(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=U;function K(Z,oe){for(const ve of Z){const Ae=oe(ve);if(Ae!==void 0)return Ae}}e.mapFind=K;function $(Z,oe,ve){const Ae=H(Z,oe),Se=Z.length,Ne=ve.length;Z.length=Se+Ne;for(let We=Se-1;We>=Ae;We--)Z[We+Ne]=Z[We];for(let We=0;We<Ne;We++)Z[We+Ae]=ve[We]}e.insertInto=$;function B(Z,oe,ve,Ae){const Se=H(Z,oe),Ne=Z.splice(Se,ve);return $(Z,Se,Ae),Ne}e.splice=B;function H(Z,oe){return oe<0?Math.max(oe+Z.length,0):Math.min(oe,Z.length)}function Q(Z,oe){let ve=Number.MAX_SAFE_INTEGER,Ae=0;return Z.forEach((Se,Ne)=>{const We=oe(Se);We<ve&&(ve=We,Ae=Ne)}),Ae}e.minIndex=Q;function re(Z,oe){let ve=Number.MIN_SAFE_INTEGER,Ae=0;return Z.forEach((Se,Ne)=>{const We=oe(Se);We>ve&&(ve=We,Ae=Ne)}),Ae}e.maxIndex=re;class ue{constructor(oe){this.items=oe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(oe){let ve=this.firstIdx;for(;ve<this.items.length&&oe(this.items[ve]);)ve++;const Ae=ve===this.firstIdx?null:this.items.slice(this.firstIdx,ve);return this.firstIdx=ve,Ae}takeFromEndWhile(oe){let ve=this.lastIdx;for(;ve>=0&&oe(this.items[ve]);)ve--;const Ae=ve===this.lastIdx?null:this.items.slice(ve+1,this.lastIdx+1);return this.lastIdx=ve,Ae}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=ue}),define(be[53],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(be[102],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function F(i,v=!1){let r=0,s=i.length,u="",h=0,p=16,I=0;function T(q){let U=0,K=0;for(;U<q;){const $=i.charCodeAt(r);if($>=48&&$<=57)K=K*16+$-48;else if($>=65&&$<=70)K=K*16+$-65+10;else if($>=97&&$<=102)K=K*16+$-97+10;else break;r++,U++}return U<q&&(K=-1),K}function g(q){r=q,u="",h=0,p=16,I=0}function C(){const q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return I=3,i.substring(q,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;U=r}else I=3;return i.substring(q,U)}function m(){let q="",U=r;for(;;){if(r>=s){q+=i.substring(U,r),I=2;break}const K=i.charCodeAt(r);if(K===34){q+=i.substring(U,r),r++;break}if(K===92){if(q+=i.substring(U,r),r++,r>=s){I=2;break}switch(i.charCodeAt(r++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const B=T(4);B>=0?q+=String.fromCharCode(B):I=4;break;default:I=5}U=r;continue}if(K>=0&&K<=31)if(S(K)){q+=i.substring(U,r),I=2;break}else I=6;r++}return q}function R(){if(u="",I=0,h=r,r>=s)return h=s,p=17;let q=i.charCodeAt(r);if(k(q)){do r++,u+=String.fromCharCode(q),q=i.charCodeAt(r);while(k(q));return p=15}if(S(q))return r++,u+=String.fromCharCode(q),q===13&&i.charCodeAt(r)===10&&(r++,u+=`
`),p=14;switch(q){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,u=m(),p=10;case 47:const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!S(i.charCodeAt(r));)r++;return u=i.substring(U,r),p=12}if(i.charCodeAt(r+1)===42){r+=2;const K=s-1;let $=!1;for(;r<K;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,I=1),u=i.substring(U,r),p=13}return u+=String.fromCharCode(q),r++,p=16;case 45:if(u+=String.fromCharCode(q),r++,r===s||!P(i.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=C(),p=11;default:for(;r<s&&L(q);)r++,q=i.charCodeAt(r);if(h!==r){switch(u=i.substring(h,r),u){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return u+=String.fromCharCode(q),r++,p=16}}function L(q){if(k(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=R();while(q>=12&&q<=15);return q}return{setPosition:g,getPosition:()=>r,scan:v?V:R,getToken:()=>p,getTokenValue:()=>u,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>I}}e.createScanner=F;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function b(i,v){const r=[],s=new Object;let u;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function I(T,g,C,m){h.value=T,h.offset=g,h.length=C,h.type=m,h.colonOffset=void 0,u=h}try{a(i,{onObjectBegin:(T,g)=>{if(v<=T)throw s;u=void 0,p=v>T,r.push("")},onObjectProperty:(T,g,C)=>{if(v<g||(I(T,g,C,"property"),r[r.length-1]=T,v<=g+C))throw s},onObjectEnd:(T,g)=>{if(v<=T)throw s;u=void 0,r.pop()},onArrayBegin:(T,g)=>{if(v<=T)throw s;u=void 0,r.push(0)},onArrayEnd:(T,g)=>{if(v<=T)throw s;u=void 0,r.pop()},onLiteralValue:(T,g,C)=>{if(v<g||(I(T,g,C,y(T)),v<=g+C))throw s},onSeparator:(T,g,C)=>{if(v<=g)throw s;if(T===":"&&u&&u.type==="property")u.colonOffset=g,p=!1,u=void 0;else if(T===","){const m=r[r.length-1];typeof m=="number"?r[r.length-1]=m+1:(p=!0,r[r.length-1]=""),u=void 0}}})}catch(T){if(T!==s)throw T}return{path:r,previousNode:u,isAtPropertyKey:p,matches:T=>{let g=0;for(let C=0;g<T.length&&C<r.length;C++)if(T[g]===r[C]||T[g]==="*")g++;else if(T[g]!=="**")return!1;return g===T.length}}}e.getLocation=b;function n(i,v=[],r=A.DEFAULT){let s=null,u=[];const h=[];function p(T){Array.isArray(u)?u.push(T):s!==null&&(u[s]=T)}return a(i,{onObjectBegin:()=>{const T={};p(T),h.push(u),u=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{const T=[];p(T),h.push(u),u=T,s=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:p,onError:(T,g,C)=>{v.push({error:T,offset:g,length:C})}},r),u[0]}e.parse=n;function f(i,v=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(T){s.type==="property"&&(s.length=T-s.offset,s=s.parent)}function h(T){return s.children.push(T),T}a(i,{onObjectBegin:T=>{s=h({type:"object",offset:T,length:-1,parent:s,children:[]})},onObjectProperty:(T,g,C)=>{s=h({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:T,offset:g,length:C,parent:s})},onObjectEnd:(T,g)=>{s.length=T+g-s.offset,s=s.parent,u(T+g)},onArrayBegin:(T,g)=>{s=h({type:"array",offset:T,length:-1,parent:s,children:[]})},onArrayEnd:(T,g)=>{s.length=T+g-s.offset,s=s.parent,u(T+g)},onLiteralValue:(T,g,C)=>{h({type:y(T),offset:g,length:C,parent:s,value:T}),u(g+C)},onSeparator:(T,g,C)=>{s.type==="property"&&(T===":"?s.colonOffset=g:T===","&&u(g))},onError:(T,g,C)=>{v.push({error:T,offset:g,length:C})}},r);const I=s.children[0];return I&&delete I.parent,I}e.parseTree=f;function o(i,v){if(!i)return;let r=i;for(let s of v)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===s){r=h.children[1],u=!0;break}if(!u)return}else{const u=s;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=o;function l(i){if(!i.parent||!i.parent.children)return[];const v=l(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;v.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&v.push(r)}return v}e.getNodePath=l;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":const v=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(v[r.children[0].value]=w(s))}return v;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=w;function D(i,v,r=!1){return v>=i.offset&&v<i.offset+i.length||r&&v===i.offset+i.length}e.contains=D;function _(i,v,r=!1){if(D(i,v,r)){const s=i.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=v;u++){const h=_(s[u],v,r);if(h)return h}return i}}e.findNodeAtOffset=_;function a(i,v,r=A.DEFAULT){const s=F(i,!1);function u(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(oe){return oe?ve=>oe(ve,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=u(v.onObjectBegin),I=h(v.onObjectProperty),T=u(v.onObjectEnd),g=u(v.onArrayBegin),C=u(v.onArrayEnd),m=h(v.onLiteralValue),R=h(v.onSeparator),L=u(v.onComment),V=h(v.onError),q=r&&r.disallowComments,U=r&&r.allowTrailingComma;function K(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:q||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(oe){case 12:case 13:q?$(10):L();break;case 16:$(1);break;case 15:case 14:break;default:return oe}}}function $(oe,ve=[],Ae=[]){if(V(oe),ve.length+Ae.length>0){let Se=s.getToken();for(;Se!==17;){if(ve.indexOf(Se)!==-1){K();break}else if(Ae.indexOf(Se)!==-1)break;Se=K()}}}function B(oe){const ve=s.getTokenValue();return oe?m(ve):I(ve),K(),!0}function H(){switch(s.getToken()){case 11:let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&($(2),oe=0)}catch(ve){$(2)}m(oe);break;case 7:m(null);break;case 8:m(!0);break;case 9:m(!1);break;default:return!1}return K(),!0}function Q(){return s.getToken()!==10?($(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(R(":"),K(),Z()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function re(){p(),K();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||$(4,[],[]),R(","),K(),s.getToken()===2&&U)break}else oe&&$(6,[],[]);Q()||$(4,[],[2,5]),oe=!0}return T(),s.getToken()!==2?$(7,[2],[]):K(),!0}function ue(){g(),K();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||$(4,[],[]),R(","),K(),s.getToken()===4&&U)break}else oe&&$(6,[],[]);Z()||$(4,[],[4,5]),oe=!0}return C(),s.getToken()!==4?$(8,[4],[]):K(),!0}function Z(){switch(s.getToken()){case 3:return ue();case 1:return re();case 10:return B(!0);default:return H()}}return K(),s.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):Z()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=a;function d(i,v){let r=F(i),s=[],u,h=0,p;do switch(p=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:h!==p&&s.push(i.substring(h,p)),v!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,v)),h=r.getPosition();break}while(u!==17);return s.join("")}e.stripComments=d;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(be[103],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new c(()=>E(this.getValue()))}}e.Lazy=c}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,ne.marked=e())}(this,function(){"use strict";function ne(Te,ye){for(var Ce=0;Ce<ye.length;Ce++){var ee=ye[Ce];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Te,ee.key,ee)}}function e(Te,ye,Ce){return ye&&ne(Te.prototype,ye),Ce&&ne(Te,Ce),Te}function c(Te,ye){if(!!Te){if(typeof Te=="string")return M(Te,ye);var Ce=Object.prototype.toString.call(Te).slice(8,-1);if(Ce==="Object"&&Te.constructor&&(Ce=Te.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Te);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Te,ye)}}function M(Te,ye){(ye==null||ye>Te.length)&&(ye=Te.length);for(var Ce=0,ee=new Array(ye);Ce<ye;Ce++)ee[Ce]=Te[Ce];return ee}function E(Te,ye){var Ce=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(Ce)return(Ce=Ce.call(Te)).next.bind(Ce);if(Array.isArray(Te)||(Ce=c(Te))||ye&&Te&&typeof Te.length=="number"){Ce&&(Te=Ce);var ee=0;return function(){return ee>=Te.length?{done:!0}:{done:!1,value:Te[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Te){A.exports.defaults=Te}A.exports={defaults:F(),getDefaults:F,changeDefaults:k};var S=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return n[ye]};function o(Te,ye){if(ye){if(S.test(Te))return Te.replace(P,f)}else if(t.test(Te))return Te.replace(b,f);return Te}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Te){return Te.replace(l,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var D=/(^|[^\[])\^/g;function _(Te,ye){Te=Te.source||Te,ye=ye||"";var Ce={replace:function(le,ge){return ge=ge.source||ge,ge=ge.replace(D,"$1"),Te=Te.replace(le,ge),Ce},getRegex:function(){return new RegExp(Te,ye)}};return Ce}var a=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Te,ye,Ce){if(Te){var ee;try{ee=decodeURIComponent(w(Ce)).replace(a,"").toLowerCase()}catch(le){return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ye&&!d.test(Ce)&&(Ce=u(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(le){return null}return Ce}var i={},v=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Te,ye){i[" "+Te]||(v.test(Te)?i[" "+Te]=Te+"/":i[" "+Te]=T(Te,"/",!0)),Te=i[" "+Te];var Ce=Te.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:Te.replace(r,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:Te.replace(s,"$1")+ye:Te+ye}var h={exec:function(){}};function p(Te){for(var ye=1,Ce,ee;ye<arguments.length;ye++){Ce=arguments[ye];for(ee in Ce)Object.prototype.hasOwnProperty.call(Ce,ee)&&(Te[ee]=Ce[ee])}return Te}function I(Te,ye){var Ce=Te.replace(/\|/g,function(ge,fe,Pe){for(var xe=!1,Oe=fe;--Oe>=0&&Pe[Oe]==="\\";)xe=!xe;return xe?"|":" |"}),ee=Ce.split(/ \|/),le=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>ye)ee.splice(ye);else for(;ee.length<ye;)ee.push("");for(;le<ee.length;le++)ee[le]=ee[le].trim().replace(/\\\|/g,"|");return ee}function T(Te,ye,Ce){var ee=Te.length;if(ee===0)return"";for(var le=0;le<ee;){var ge=Te.charAt(ee-le-1);if(ge===ye&&!Ce)le++;else if(ge!==ye&&Ce)le++;else break}return Te.substr(0,ee-le)}function g(Te,ye){if(Te.indexOf(ye[1])===-1)return-1;for(var Ce=Te.length,ee=0,le=0;le<Ce;le++)if(Te[le]==="\\")le++;else if(Te[le]===ye[0])ee++;else if(Te[le]===ye[1]&&(ee--,ee<0))return le;return-1}function C(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function m(Te,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=Te),ye>>=1,Te+=Te;return Ce+Te}var R={escape:o,unescape:w,edit:_,cleanUrl:y,resolveUrl:u,noopTest:h,merge:p,splitCells:I,rtrim:T,findClosingBracket:g,checkSanitizeDeprecation:C,repeatString:m},L=A.exports.defaults,V=R.rtrim,q=R.splitCells,U=R.escape,K=R.findClosingBracket;function $(Te,ye,Ce,ee){var le=ye.href,ge=ye.title?U(ye.title):null,fe=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ee.state.inLink=!0;var Pe={type:"link",raw:Ce,href:le,title:ge,text:fe,tokens:ee.inlineTokens(fe,[])};return ee.state.inLink=!1,Pe}else return{type:"image",raw:Ce,href:le,title:ge,text:U(fe)}}function B(Te,ye){var Ce=Te.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var ee=Ce[1];return ye.split(`
`).map(function(le){var ge=le.match(/^\s+/);if(ge===null)return le;var fe=ge[0];return fe.length>=ee.length?le.slice(ee.length):le}).join(`
`)}var H=function(){function Te(Ce){this.options=Ce||L}var ye=Te.prototype;return ye.space=function(ee){var le=this.rules.block.newline.exec(ee);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},ye.code=function(ee){var le=this.rules.block.code.exec(ee);if(le){var ge=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:V(ge,`
`)}}},ye.fences=function(ee){var le=this.rules.block.fences.exec(ee);if(le){var ge=le[0],fe=B(ge,le[3]||"");return{type:"code",raw:ge,lang:le[2]?le[2].trim():le[2],text:fe}}},ye.heading=function(ee){var le=this.rules.block.heading.exec(ee);if(le){var ge=le[2].trim();if(/#$/.test(ge)){var fe=V(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Pe={type:"heading",raw:le[0],depth:le[1].length,text:ge,tokens:[]};return this.lexer.inline(Pe.text,Pe.tokens),Pe}},ye.hr=function(ee){var le=this.rules.block.hr.exec(ee);if(le)return{type:"hr",raw:le[0]}},ye.blockquote=function(ee){var le=this.rules.block.blockquote.exec(ee);if(le){var ge=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(ee){var le=this.rules.block.list.exec(ee);if(le){var ge,fe,Pe,xe,Oe,Ke,tt,Le,de,pe,Y=le[1].trim(),W=Y.length>1,we={type:"list",raw:"",ordered:W,start:W?+Y.slice(0,-1):"",loose:!1,items:[]};Y=W?"\\d{1,9}\\"+Y.slice(-1):"\\"+Y,this.options.pedantic&&(Y=W?Y:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Y+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(le=Ie.exec(ee)));){de=le[2].split(`
`),this.options.pedantic?(xe=2,pe=de[0].trimLeft()):(xe=le[2].search(/[^ ]/),xe=le[1].length+(xe>4?1:xe),pe=de[0].slice(xe-le[1].length)),Ke=!1,ge=le[0],!de[0]&&/^ *$/.test(de[1])&&(ge=le[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<de.length;Oe++){if(Le=de[Oe],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){ge=le[1]+de.slice(0,Oe).join(`
`)+`
`;break}if(!Ke){Le.trim()||(Ke=!0),Le.search(/[^ ]/)>=xe?pe+=`
`+Le.slice(xe):pe+=`
`+Le;continue}if(Le.search(/[^ ]/)>=xe||!Le.trim()){pe+=`
`+Le.slice(xe);continue}else{ge=le[1]+de.slice(0,Oe).join(`
`)+`
`;break}}we.loose||(tt?we.loose=!0:/\n *\n *$/.test(ge)&&(tt=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(pe),fe&&(Pe=fe[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:ge,task:!!fe,checked:Pe,loose:!1,text:pe}),we.raw+=ge,ee=ee.slice(ge.length)}we.items[we.items.length-1].raw=ge.trimRight(),we.items[we.items.length-1].text=pe.trimRight(),we.raw=we.raw.trimRight();var Ue=we.items.length;for(Oe=0;Oe<Ue;Oe++)this.lexer.state.top=!1,we.items[Oe].tokens=this.lexer.blockTokens(we.items[Oe].text,[]),we.items[Oe].tokens.some(function(ct){return ct.type==="space"})&&(we.loose=!0,we.items[Oe].loose=!0);return we}},ye.html=function(ee){var le=this.rules.block.html.exec(ee);if(le){var ge={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(le[0]):U(le[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(ee){var le=this.rules.block.def.exec(ee);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ge=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:le[0],href:le[2],title:le[3]}}},ye.table=function(ee){var le=this.rules.block.table.exec(ee);if(le){var ge={type:"table",header:q(le[1]).map(function(tt){return{text:tt}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=le[0];var fe=ge.align.length,Pe,xe,Oe,Ke;for(Pe=0;Pe<fe;Pe++)/^ *-+: *$/.test(ge.align[Pe])?ge.align[Pe]="right":/^ *:-+: *$/.test(ge.align[Pe])?ge.align[Pe]="center":/^ *:-+ *$/.test(ge.align[Pe])?ge.align[Pe]="left":ge.align[Pe]=null;for(fe=ge.rows.length,Pe=0;Pe<fe;Pe++)ge.rows[Pe]=q(ge.rows[Pe],ge.header.length).map(function(tt){return{text:tt}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ke=ge.rows[xe],Oe=0;Oe<Ke.length;Oe++)Ke[Oe].tokens=[],this.lexer.inlineTokens(Ke[Oe].text,Ke[Oe].tokens);return ge}}},ye.lheading=function(ee){var le=this.rules.block.lheading.exec(ee);if(le){var ge={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(ee){var le=this.rules.block.paragraph.exec(ee);if(le){var ge={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(ee){var le=this.rules.block.text.exec(ee);if(le){var ge={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(ee){var le=this.rules.inline.escape.exec(ee);if(le)return{type:"escape",raw:le[0],text:U(le[1])}},ye.tag=function(ee){var le=this.rules.inline.tag.exec(ee);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):U(le[0]):le[0]}},ye.link=function(ee){var le=this.rules.inline.link.exec(ee);if(le){var ge=le[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=V(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Pe=K(le[2],"()");if(Pe>-1){var xe=le[0].indexOf("!")===0?5:4,Oe=xe+le[1].length+Pe;le[2]=le[2].substring(0,Pe),le[0]=le[0].substring(0,Oe).trim(),le[3]=""}}var Ke=le[2],tt="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);Le&&(Ke=Le[1],tt=Le[3])}else tt=le[3]?le[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(ge)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),$(le,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:tt&&tt.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ye.reflink=function(ee,le){var ge;if((ge=this.rules.inline.reflink.exec(ee))||(ge=this.rules.inline.nolink.exec(ee))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=le[fe.toLowerCase()],!fe||!fe.href){var Pe=ge[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return $(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(ee,le,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(ee);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=fe[1]||fe[2]||"";if(!Pe||Pe&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Oe,Ke,tt=xe,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,le=le.slice(-1*ee.length+xe);(fe=de.exec(le))!=null;)if(Oe=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Oe){if(Ke=Oe.length,fe[3]||fe[4]){tt+=Ke;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ke)%3)){Le+=Ke;continue}if(tt-=Ke,!(tt>0)){if(Ke=Math.min(Ke,Ke+tt+Le),Math.min(xe,Ke)%2){var pe=ee.slice(1,xe+fe.index+Ke);return{type:"em",raw:ee.slice(0,xe+fe.index+Ke+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var Y=ee.slice(2,xe+fe.index+Ke-1);return{type:"strong",raw:ee.slice(0,xe+fe.index+Ke+1),text:Y,tokens:this.lexer.inlineTokens(Y,[])}}}}}},ye.codespan=function(ee){var le=this.rules.inline.code.exec(ee);if(le){var ge=le[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Pe=/^ /.test(ge)&&/ $/.test(ge);return fe&&Pe&&(ge=ge.substring(1,ge.length-1)),ge=U(ge,!0),{type:"codespan",raw:le[0],text:ge}}},ye.br=function(ee){var le=this.rules.inline.br.exec(ee);if(le)return{type:"br",raw:le[0]}},ye.del=function(ee){var le=this.rules.inline.del.exec(ee);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},ye.autolink=function(ee,le){var ge=this.rules.inline.autolink.exec(ee);if(ge){var fe,Pe;return ge[2]==="@"?(fe=U(this.options.mangle?le(ge[1]):ge[1]),Pe="mailto:"+fe):(fe=U(ge[1]),Pe=fe),{type:"link",raw:ge[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(ee,le){var ge;if(ge=this.rules.inline.url.exec(ee)){var fe,Pe;if(ge[2]==="@")fe=U(this.options.mangle?le(ge[0]):ge[0]),Pe="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=U(ge[0]),ge[1]==="www."?Pe="http://"+fe:Pe=fe}return{type:"link",raw:ge[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(ee,le){var ge=this.rules.inline.text.exec(ee);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):U(ge[0]):ge[0]:fe=U(this.options.smartypants?le(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Te}(),Q=R.noopTest,re=R.edit,ue=R.merge,Z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Z.def=re(Z.def).replace("label",Z._label).replace("title",Z._title).getRegex(),Z.bullet=/(?:[*+-]|\d{1,9}[.)])/,Z.listItemStart=re(/^( *)(bull) */).replace("bull",Z.bullet).getRegex(),Z.list=re(Z.list).replace(/bull/g,Z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Z.def.source+")").getRegex(),Z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Z.html=re(Z.html,"i").replace("comment",Z._comment).replace("tag",Z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Z.paragraph=re(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.blockquote=re(Z.blockquote).replace("paragraph",Z.paragraph).getRegex(),Z.normal=ue({},Z),Z.gfm=ue({},Z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Z.gfm.table=re(Z.gfm.table).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.pedantic=ue({},Z.normal,{html:re(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:re(Z.normal._paragraph).replace("hr",Z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=re(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=re(Z._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=re(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=re(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=re(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=re(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=re(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=re(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=re(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=re(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=ue({},oe),oe.pedantic=ue({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:re(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:re(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=ue({},oe.normal,{escape:re(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=re(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=ue({},oe.gfm,{br:re(oe.br).replace("{2,}","*").getRegex(),text:re(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:Z,inline:oe},Ae=H,Se=A.exports.defaults,Ne=ve.block,We=ve.inline,je=R.repeatString;function qe(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Te){var ye="",Ce,ee,le=Te.length;for(Ce=0;Ce<le;Ce++)ee=Te.charCodeAt(Ce),Math.random()>.5&&(ee="x"+ee.toString(16)),ye+="&#"+ee+";";return ye}var G=function(){function Te(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Se,this.options.tokenizer=this.options.tokenizer||new Ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:Ne.normal,inline:We.normal};this.options.pedantic?(ee.block=Ne.pedantic,ee.inline=We.pedantic):this.options.gfm&&(ee.block=Ne.gfm,this.options.breaks?ee.inline=We.breaks:ee.inline=We.gfm),this.tokenizer.rules=ee}Te.lex=function(ee,le){var ge=new Te(le);return ge.lex(ee)},Te.lexInline=function(ee,le){var ge=new Te(le);return ge.inlineTokens(ee)};var ye=Te.prototype;return ye.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ye.blockTokens=function(ee,le){var ge=this;le===void 0&&(le=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var fe,Pe,xe,Oe;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(tt){return(fe=tt.call({lexer:ge},ee,le))?(ee=ee.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.space(ee)){ee=ee.substring(fe.raw.length),fe.type&&le.push(fe);continue}if(fe=this.tokenizer.code(ee)){ee=ee.substring(fe.raw.length),Pe=le[le.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe);continue}if(fe=this.tokenizer.fences(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.heading(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.hr(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.blockquote(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.list(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.html(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.def(ee)){ee=ee.substring(fe.raw.length),Pe=le[le.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.lheading(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(xe=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var tt=Infinity,Le=ee.slice(1),de=void 0;ge.options.extensions.startBlock.forEach(function(pe){de=pe.call({lexer:this},Le),typeof de=="number"&&de>=0&&(tt=Math.min(tt,de))}),tt<Infinity&&tt>=0&&(xe=ee.substring(0,tt+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Pe=le[le.length-1],Oe&&Pe.type==="paragraph"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe),Oe=xe.length!==ee.length,ee=ee.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(ee)){ee=ee.substring(fe.raw.length),Pe=le[le.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe);continue}if(ee){var Ke="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return this.state.top=!0,le},ye.inline=function(ee,le){this.inlineQueue.push({src:ee,tokens:le})},ye.inlineTokens=function(ee,le){var ge=this;le===void 0&&(le=[]);var fe,Pe,xe,Oe=ee,Ke,tt,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)de.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,Ke.index)+"["+je("a",Ke[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,Ke.index)+"["+je("a",Ke[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,Ke.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(tt||(Le=""),tt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(fe=Y.call({lexer:ge},ee,le))?(ee=ee.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.tag(ee)){ee=ee.substring(fe.raw.length),Pe=le[le.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.link(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(fe.raw.length),Pe=le[le.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.emStrong(ee,Oe,Le)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.codespan(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.br(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.del(ee)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.autolink(ee,x)){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(ee,x))){ee=ee.substring(fe.raw.length),le.push(fe);continue}if(xe=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=Infinity,W=ee.slice(1),we=void 0;ge.options.extensions.startInline.forEach(function(Ie){we=Ie.call({lexer:this},W),typeof we=="number"&&we>=0&&(Y=Math.min(Y,we))}),Y<Infinity&&Y>=0&&(xe=ee.substring(0,Y+1))}(),fe=this.tokenizer.inlineText(xe,qe)){ee=ee.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),tt=!0,Pe=le[le.length-1],Pe&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(ee){var pe="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return le},e(Te,null,[{key:"rules",get:function(){return{block:Ne,inline:We}}}]),Te}(),te=A.exports.defaults,ae=R.cleanUrl,j=R.escape,se=function(){function Te(Ce){this.options=Ce||te}var ye=Te.prototype;return ye.code=function(ee,le,ge){var fe=(le||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(ee,fe);Pe!=null&&Pe!==ee&&(ge=!0,ee=Pe)}return ee=ee.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+j(fe,!0)+'">'+(ge?ee:j(ee,!0))+`</code></pre>
`:"<pre><code>"+(ge?ee:j(ee,!0))+`</code></pre>
`},ye.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ye.html=function(ee){return ee},ye.heading=function(ee,le,ge,fe){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+ee+"</h"+le+`>
`:"<h"+le+">"+ee+"</h"+le+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ee,le,ge){var fe=le?"ol":"ul",Pe=le&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Pe+`>
`+ee+"</"+fe+`>
`},ye.listitem=function(ee){return"<li>"+ee+`</li>
`},ye.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ee){return"<p>"+ee+`</p>
`},ye.table=function(ee,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+le+`</table>
`},ye.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ye.tablecell=function(ee,le){var ge=le.header?"th":"td",fe=le.align?"<"+ge+' align="'+le.align+'">':"<"+ge+">";return fe+ee+"</"+ge+`>
`},ye.strong=function(ee){return"<strong>"+ee+"</strong>"},ye.em=function(ee){return"<em>"+ee+"</em>"},ye.codespan=function(ee){return"<code>"+ee+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ee){return"<del>"+ee+"</del>"},ye.link=function(ee,le,ge){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ge;var fe='<a href="'+j(ee)+'"';return le&&(fe+=' title="'+le+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(ee,le,ge){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ge;var fe='<img src="'+ee+'" alt="'+ge+'"';return le&&(fe+=' title="'+le+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(ee){return ee},Te}(),he=function(){function Te(){}var ye=Te.prototype;return ye.strong=function(ee){return ee},ye.em=function(ee){return ee},ye.codespan=function(ee){return ee},ye.del=function(ee){return ee},ye.html=function(ee){return ee},ye.text=function(ee){return ee},ye.link=function(ee,le,ge){return""+ge},ye.image=function(ee,le,ge){return""+ge},ye.br=function(){return""},Te}(),Re=function(){function Te(){this.seen={}}var ye=Te.prototype;return ye.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ee,le){var ge=ee,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[ee];do fe++,ge=ee+"-"+fe;while(this.seen.hasOwnProperty(ge))}return le||(this.seen[ee]=fe,this.seen[ge]=0),ge},ye.slug=function(ee,le){le===void 0&&(le={});var ge=this.serialize(ee);return this.getNextSafeSlug(ge,le.dryrun)},Te}(),Be=se,ze=he,Qe=Re,it=A.exports.defaults,ke=R.unescape,Ze=function(){function Te(Ce){this.options=Ce||it,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Qe}Te.parse=function(ee,le){var ge=new Te(le);return ge.parse(ee)},Te.parseInline=function(ee,le){var ge=new Te(le);return ge.parseInline(ee)};var ye=Te.prototype;return ye.parse=function(ee,le){le===void 0&&(le=!0);var ge="",fe,Pe,xe,Oe,Ke,tt,Le,de,pe,Y,W,we,Ie,Je,Ue,ct,pt,lt,mt,ut=ee.length;for(fe=0;fe<ut;fe++){if(Y=ee[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(mt=this.options.extensions.renderers[Y.type].call({parser:this},Y),mt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){ge+=mt||"";continue}switch(Y.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,ke(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(de="",Le="",Oe=Y.header.length,Pe=0;Pe<Oe;Pe++)Le+=this.renderer.tablecell(this.parseInline(Y.header[Pe].tokens),{header:!0,align:Y.align[Pe]});for(de+=this.renderer.tablerow(Le),pe="",Oe=Y.rows.length,Pe=0;Pe<Oe;Pe++){for(tt=Y.rows[Pe],Le="",Ke=tt.length,xe=0;xe<Ke;xe++)Le+=this.renderer.tablecell(this.parseInline(tt[xe].tokens),{header:!1,align:Y.align[xe]});pe+=this.renderer.tablerow(Le)}ge+=this.renderer.table(de,pe);continue}case"blockquote":{pe=this.parse(Y.tokens),ge+=this.renderer.blockquote(pe);continue}case"list":{for(W=Y.ordered,we=Y.start,Ie=Y.loose,Oe=Y.items.length,pe="",Pe=0;Pe<Oe;Pe++)Ue=Y.items[Pe],ct=Ue.checked,pt=Ue.task,Je="",Ue.task&&(lt=this.renderer.checkbox(ct),Ie?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=lt+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=lt+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:lt}):Je+=lt),Je+=this.parse(Ue.tokens,Ie),pe+=this.renderer.listitem(Je,pt,ct);ge+=this.renderer.list(pe,W,we);continue}case"html":{ge+=this.renderer.html(Y.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(pe=Y.tokens?this.parseInline(Y.tokens):Y.text;fe+1<ut&&ee[fe+1].type==="text";)Y=ee[++fe],pe+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);ge+=le?this.renderer.paragraph(pe):pe;continue}default:{var bt='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(bt);return}else throw new Error(bt)}}}return ge},ye.parseInline=function(ee,le){le=le||this.renderer;var ge="",fe,Pe,xe,Oe=ee.length;for(fe=0;fe<Oe;fe++){if(Pe=ee[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(xe=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){ge+=xe||"";continue}switch(Pe.type){case"escape":{ge+=le.text(Pe.text);break}case"html":{ge+=le.html(Pe.text);break}case"link":{ge+=le.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,le));break}case"image":{ge+=le.image(Pe.href,Pe.title,Pe.text);break}case"strong":{ge+=le.strong(this.parseInline(Pe.tokens,le));break}case"em":{ge+=le.em(this.parseInline(Pe.tokens,le));break}case"codespan":{ge+=le.codespan(Pe.text);break}case"br":{ge+=le.br();break}case"del":{ge+=le.del(this.parseInline(Pe.tokens,le));break}case"text":{ge+=le.text(Pe.text);break}default:{var Ke='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}}return ge},Te}(),z=G,J=Ze,me=H,He=se,Ye=he,st=Re,ot=R.merge,Et=R.checkSanitizeDeprecation,ft=R.escape,Dt=A.exports.getDefaults,Pt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Te,ye,Ce){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=ot({},Xe.defaults,ye||{}),Et(ye),Ce){var ee=ye.highlight,le;try{le=z.lex(Te,ye)}catch(xe){return Ce(xe)}var ge=function(Oe){var Ke;if(!Oe)try{ye.walkTokens&&Xe.walkTokens(le,ye.walkTokens),Ke=J.parse(le,ye)}catch(tt){Oe=tt}return ye.highlight=ee,Oe?Ce(Oe):Ce(null,Ke)};if(!ee||ee.length<3||(delete ye.highlight,!le.length))return ge();var fe=0;Xe.walkTokens(le,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){ee(xe.text,xe.lang,function(Oe,Ke){if(Oe)return ge(Oe);Ke!=null&&Ke!==xe.text&&(xe.text=Ke,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Pe=z.lex(Te,ye);return ye.walkTokens&&Xe.walkTokens(Pe,ye.walkTokens),J.parse(Pe,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ft(xe.message+"",!0)+"</pre>";throw xe}}Xe.options=Xe.setOptions=function(Te){return ot(Xe.defaults,Te),Pt(Xe.defaults),Xe},Xe.getDefaults=Dt,Xe.defaults=It,Xe.use=function(){for(var Te=this,ye=arguments.length,Ce=new Array(ye),ee=0;ee<ye;ee++)Ce[ee]=arguments[ee];var le=ot.apply(void 0,[{}].concat(Ce)),ge=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Pe){if(Pe.extensions&&(fe=!0,Pe.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var Ke=ge.renderers?ge.renderers[Oe.name]:null;Ke?ge.renderers[Oe.name]=function(){for(var tt=arguments.length,Le=new Array(tt),de=0;de<tt;de++)Le[de]=arguments[de];var pe=Oe.renderer.apply(this,Le);return pe===!1&&(pe=Ke.apply(this,Le)),pe}:ge.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Oe.level]?ge[Oe.level].unshift(Oe.tokenizer):ge[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?ge.startBlock?ge.startBlock.push(Oe.start):ge.startBlock=[Oe.start]:Oe.level==="inline"&&(ge.startInline?ge.startInline.push(Oe.start):ge.startInline=[Oe.start]))}Oe.childTokens&&(ge.childTokens[Oe.name]=Oe.childTokens)})),Pe.renderer&&function(){var Oe=Xe.defaults.renderer||new He,Ke=function(de){var pe=Oe[de];Oe[de]=function(){for(var Y=arguments.length,W=new Array(Y),we=0;we<Y;we++)W[we]=arguments[we];var Ie=Pe.renderer[de].apply(Oe,W);return Ie===!1&&(Ie=pe.apply(Oe,W)),Ie}};for(var tt in Pe.renderer)Ke(tt);le.renderer=Oe}(),Pe.tokenizer&&function(){var Oe=Xe.defaults.tokenizer||new me,Ke=function(de){var pe=Oe[de];Oe[de]=function(){for(var Y=arguments.length,W=new Array(Y),we=0;we<Y;we++)W[we]=arguments[we];var Ie=Pe.tokenizer[de].apply(Oe,W);return Ie===!1&&(Ie=pe.apply(Oe,W)),Ie}};for(var tt in Pe.tokenizer)Ke(tt);le.tokenizer=Oe}(),Pe.walkTokens){var xe=Xe.defaults.walkTokens;le.walkTokens=function(Oe){Pe.walkTokens.call(Te,Oe),xe&&xe(Oe)}}fe&&(le.extensions=ge),Xe.setOptions(le)})},Xe.walkTokens=function(Te,ye){for(var Ce=function(){var fe=le.value;switch(ye(fe),fe.type){case"table":{for(var Pe=E(fe.header),xe;!(xe=Pe()).done;){var Oe=xe.value;Xe.walkTokens(Oe.tokens,ye)}for(var Ke=E(fe.rows),tt;!(tt=Ke()).done;)for(var Le=tt.value,de=E(Le),pe;!(pe=de()).done;){var Y=pe.value;Xe.walkTokens(Y.tokens,ye)}break}case"list":{Xe.walkTokens(fe.items,ye);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(W){Xe.walkTokens(fe[W],ye)}):fe.tokens&&Xe.walkTokens(fe.tokens,ye)}},ee=E(Te),le;!(le=ee()).done;)Ce()},Xe.parseInline=function(Te,ye){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");ye=ot({},Xe.defaults,ye||{}),Et(ye);try{var Ce=z.lexInline(Te,ye);return ye.walkTokens&&Xe.walkTokens(Ce,ye.walkTokens),J.parseInline(Ce,ye)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ft(ee.message+"",!0)+"</pre>";throw ee}},Xe.Parser=J,Xe.parser=J.parse,Xe.Renderer=He,Xe.TextRenderer=Ye,Xe.Lexer=z,Xe.lexer=z.lex,Xe.Tokenizer=me,Xe.Slugger=st,Xe.parse=Xe;var yt=Xe;return yt}),define(be[75],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(F,k,S){return Math.min(Math.max(F,k),S)}e.clamp=c;function M(F,k){return(k+F%k)%k}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function ne(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function F(S){A.push(S,Date.now())}function k(){const S=[];for(let P=0;P<A.length;P+=2)S.push({name:A[P],startTime:A[P+1]});return S}return{mark:F,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(E+F.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function c(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=c(M))}(),define(be[104],Ee([0,1]),function(ne,e){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,S,P){this.level=k,this.key=S,this.value=P,this.forward=[]}}const E=void 0;class A{constructor(k,S=2**16){this.comparator=k,this[c]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new M(this._maxLevel,E,E)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,E,E)}has(k){return Boolean(A._search(this,k,this.comparator))}get(k){return A._search(this,k,this.comparator)?.value}set(k,S){return A._insert(this,k,S,this.comparator)&&(this._size+=1),this}delete(k){const S=A._delete(this,k,this.comparator);return S&&(this._size-=1),S}forEach(k,S){let P=this._header.forward[0];for(;P;)k.call(S,P.value,P.key,this),P=P.forward[0]}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",S=this._header.forward[0];for(;S;)k+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return k}static _search(k,S,P){let t=k._header;for(let b=k._level-1;b>=0;b--)for(;t.forward[b]&&P(t.forward[b].key,S)<0;)t=t.forward[b];if(t=t.forward[0],t&&P(t.key,S)===0)return t}static _insert(k,S,P,t){let b=[],n=k._header;for(let f=k._level-1;f>=0;f--){for(;n.forward[f]&&t(n.forward[f].key,S)<0;)n=n.forward[f];b[f]=n}if(n=n.forward[0],n&&t(n.key,S)===0)return n.value=P,!1;{let f=A._randomLevel(k);if(f>k._level){for(let o=k._level;o<f;o++)b[o]=k._header;k._level=f}n=new M(f,S,P);for(let o=0;o<f;o++)n.forward[o]=b[o].forward[o],b[o].forward[o]=n;return!0}}static _randomLevel(k,S=.5){let P=1;for(;Math.random()<S&&P<k._maxLevel;)P+=1;return P}static _delete(k,S,P){let t=[],b=k._header;for(let n=k._level-1;n>=0;n--){for(;b.forward[n]&&P(b.forward[n].key,S)<0;)b=b.forward[n];t[n]=b}if(b=b.forward[0],!b||P(b.key,S)!==0)return!1;for(let n=0;n<k._level&&t[n].forward[n]===b;n++)t[n].forward[n]=b.forward[n];for(;k._level>0&&k._header.forward[k._level-1]===E;)k._level-=1;return!0}}e.SkipList=A}),define(be[34],Ee([0,1,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(b){const n=this._icons.get(b.id);n?b.description?n.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,b){return new k(t,b)}e.registerCodicon=A;function F(t){return t?t.replace(/\$\((.*?)\)/g,(b,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class k{constructor(b,n,f){this.id=b,this.definition=n,this.description=f,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function S(t,b){const n=["codicon","codicon-"+t];return b&&n.push("codicon-modifier-"+b),n}e.getClassNamesArray=S;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(l){if(l instanceof k)return["codicon","codicon-"+l.id];const w=b.exec(l.id);if(!w)return n(k.error);let[,D,_]=w;const a=["codicon","codicon-"+D];return _&&a.push("codicon-modifier-"+_.substr(1)),a}t.asClassNameArray=n;function f(l){return n(l).join(" ")}t.asClassName=f;function o(l){return"."+n(l).join(".")}t.asCSSSelector=o})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(a){const d=a;return d?[d.on,d.pause,d.resume,d.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=E;function A(a){const d=a;return d?E(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=A;function F(a,d){return new k(a,d)}e.newWriteableStream=F;class k{constructor(d,y){this.reducer=d,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(y=>y(d))}emitError(d){this.listeners.error.length===0?(0,c.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(y=>y(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,y){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(d,y){if(this.state.destroyed)return;let i;switch(d){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const v=i.indexOf(y);v>=0&&i.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(a,d){const y=[];let i;for(;(i=a.read())!==null;)y.push(i);return d(y)}e.consumeReadable=S;function P(a,d,y){const i=[];let v;for(;(v=a.read())!==null&&i.length<y;)i.push(v);return v===null&&i.length>0?d(i):{read:()=>{if(i.length>0)return i.shift();if(typeof v!="undefined"){const r=v;return v=void 0,r}return a.read()}}}e.peekReadable=P;function t(a,d){return new Promise((y,i)=>{const v=[];b(a,{onData:r=>{d&&v.push(r)},onError:r=>{d?i(r):y(void 0)},onEnd:()=>{y(d?d(v):void 0)}})})}e.consumeStream=t;function b(a,d){a.on("error",y=>d.onError(y)),a.on("end",()=>d.onEnd()),a.on("data",y=>d.onData(y))}e.listenStream=b;function n(a,d){return new Promise((y,i)=>{const v=new M.DisposableStore,r=[],s=p=>{if(r.push(p),r.length>d)return v.dispose(),a.pause(),y({stream:a,buffer:r,ended:!1})},u=p=>i(p),h=()=>y({stream:a,buffer:r,ended:!0});v.add((0,M.toDisposable)(()=>a.removeListener("error",u))),a.on("error",u),v.add((0,M.toDisposable)(()=>a.removeListener("end",h))),a.on("end",h),v.add((0,M.toDisposable)(()=>a.removeListener("data",s))),a.on("data",s)})}e.peekStream=n;function f(a,d){const y=F(d);return y.end(a),y}e.toStream=f;function o(){const a=F(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=o;function l(a){let d=!1;return{read:()=>d?null:(d=!0,a)}}e.toReadable=l;function w(a,d,y){const i=F(y);return b(a,{onData:v=>i.write(d.data(v)),onError:v=>i.error(d.error?d.error(v):v),onEnd:()=>i.end()}),i}e.transform=w;function D(a,d,y){let i=!1;return{read:()=>{const v=d.read();return i?v:(i=!0,v!==null?y([a,v]):a)}}}e.prefixedReadable=D;function _(a,d,y){let i=!1;const v=F(y);return b(d,{onData:r=>i?v.write(r):(i=!0,v.write(y([a,r]))),onError:r=>v.error(r),onEnd:()=>{i||(i=!0,v.write(a)),v.end()}}),v}e.prefixedStream=_}),define(be[22],Ee([0,1,105]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class F{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return M?new F(Buffer.allocUnsafe(s)):new F(new Uint8Array(s))}static wrap(s){return M&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new F(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(s)):(E||(E=new TextEncoder),new F(E.encode(s)))}static concat(s,u){if(typeof u=="undefined"){u=0;for(let I=0,T=s.length;I<T;I++)u+=s[I].byteLength}const h=F.alloc(u);let p=0;for(let I=0,T=s.length;I<T;I++){const g=s[I];h.set(g,p),p+=g.byteLength}return h}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(s,u){return new F(this.buffer.subarray(s,u))}set(s,u){s instanceof F?this.buffer.set(s.buffer,u):this.buffer.set(s,u)}readUInt32BE(s){return P(this.buffer,s)}writeUInt32BE(s,u){t(this.buffer,s,u)}readUInt32LE(s){return b(this.buffer,s)}writeUInt32LE(s,u){n(this.buffer,s,u)}readUInt8(s){return f(this.buffer,s)}writeUInt8(s,u){o(this.buffer,s,u)}}e.VSBuffer=F;function k(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=k;function S(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255}e.writeUInt16LE=S;function P(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=P;function t(r,s,u){r[u+3]=s,s=s>>>8,r[u+2]=s,s=s>>>8,r[u+1]=s,s=s>>>8,r[u]=s}e.writeUInt32BE=t;function b(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=b;function n(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255,s=s>>>8,r[u+2]=s&255,s=s>>>8,r[u+3]=s&255}e.writeUInt32LE=n;function f(r,s){return r[s]}e.readUInt8=f;function o(r,s,u){r[u]=s}e.writeUInt8=o;function l(r){return c.consumeReadable(r,s=>F.concat(s))}e.readableToBuffer=l;function w(r){return c.toReadable(r)}e.bufferToReadable=w;function D(r){return c.consumeStream(r,s=>F.concat(s))}e.streamToBuffer=D;async function _(r){return r.ended?F.concat(r.buffer):F.concat([...r.buffer,await D(r.stream)])}e.bufferedStreamToBuffer=_;function a(r){return c.toStream(r,s=>F.concat(s))}e.bufferToStream=a;function d(r){return c.transform(r,{data:s=>typeof s=="string"?F.fromString(s):F.wrap(s)},s=>F.concat(s))}e.streamToBufferReadableStream=d;function y(r){return c.newWriteableStream(s=>F.concat(s),r)}e.newWriteableBufferStream=y;function i(r,s){return c.prefixedReadable(r,s,u=>F.concat(u))}e.prefixedBufferReadable=i;function v(r,s){return c.prefixedStream(r,s,u=>F.concat(u))}e.prefixedBufferStream=v}),define(be[35],Ee([0,1,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",F="warning",k="warn",S="info",P="ignore";function t(n){return n?c.equalsIgnoreCase(A,n)?E.Error:c.equalsIgnoreCase(F,n)||c.equalsIgnoreCase(k,n)?E.Warning:c.equalsIgnoreCase(S,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function b(n){switch(n){case E.Error:return A;case E.Warning:return F;case E.Info:return S;default:return P}}E.toString=b}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(r){return r===47||r===92}e.isPathSeparator=F;function k(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=k;function S(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function P(r,s=c.posix.sep){if(!r)return"";const u=r.length,h=r.charCodeAt(0);if(F(h)){if(F(r.charCodeAt(1))&&!F(r.charCodeAt(2))){let I=3;const T=I;for(;I<u&&!F(r.charCodeAt(I));I++);if(T!==I&&!F(r.charCodeAt(I+1))){for(I+=1;I<u;I++)if(F(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,s)}}return s}else if(D(h)&&r.charCodeAt(1)===58)return F(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<u;p++)if(F(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=P;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let u=2;const h=u;for(;u<r.length&&(s=r.charCodeAt(u),s!==92);u++);return!(h===u||(s=r.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=t;const b=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,s=M.isWindows){const u=s?b:n;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||s&&f.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function l(r,s,u){const h=r===s;return!u||h?h:!r||!s?!1:(0,E.equalsIgnoreCase)(r,s)}e.isEqual=l;function w(r,s,u,h=c.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(u){if(!(0,E.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let I=s.length;return s.charAt(s.length-1)===h&&I--,r.charAt(I)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=w;function D(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=D;function _(r,s){return M.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(s,r)),r=(0,c.normalize)(r),M.isWindows?(r=(0,E.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,E.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=_;function a(r){const s=(0,c.normalize)(r);return M.isWindows?r.length>3?!1:d(s)&&(r.length===2||s.charCodeAt(2)===92):s===c.posix.sep}e.isRootOrDriveLetter=a;function d(r){return M.isWindows?D(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function y(r){return d(r)?r[0]:void 0}e.getDriveLetter=y;function i(r,s,u){return s.length>r.length?-1:r===s?0:(u&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function v(r){const s=r.split(":");let u,h,p;if(s.forEach(I=>{const T=Number(I);(0,A.isNumber)(T)?h===void 0?h=T:p===void 0&&(p=T):u=u?[u,I].join(":"):I}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:p!==void 0?p:h!==void 0?1:void 0}}e.parseLineAndColumnAware=v}),define(be[23],Ee([0,1,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const w=Array.isArray(l)?[]:{};return Object.keys(l).forEach(D=>{l[D]&&typeof l[D]=="object"?w[D]=M(l[D]):w[D]=l[D]}),w}e.deepClone=M;function E(l){if(!l||typeof l!="object")return l;const w=[l];for(;w.length>0;){const D=w.shift();Object.freeze(D);for(const _ in D)if(A.call(D,_)){const a=D[_];typeof a=="object"&&!Object.isFrozen(a)&&w.push(a)}}return l}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function F(l,w){return k(l,w,new Set)}e.cloneAndChange=F;function k(l,w,D){if((0,c.isUndefinedOrNull)(l))return l;const _=w(l);if(typeof _!="undefined")return _;if((0,c.isArray)(l)){const a=[];for(const d of l)a.push(k(d,w,D));return a}if((0,c.isObject)(l)){if(D.has(l))throw new Error("Cannot clone recursive data-structure");D.add(l);const a={};for(let d in l)A.call(l,d)&&(a[d]=k(l[d],w,D));return D.delete(l),a}return l}function S(l,w,D=!0){return(0,c.isObject)(l)?((0,c.isObject)(w)&&Object.keys(w).forEach(_=>{_ in l?D&&((0,c.isObject)(l[_])&&(0,c.isObject)(w[_])?S(l[_],w[_],D):l[_]=w[_]):l[_]=w[_]}),l):w}e.mixin=S;function P(l,w){if(l===w)return!0;if(l==null||w===null||w===void 0||typeof l!=typeof w||typeof l!="object"||Array.isArray(l)!==Array.isArray(w))return!1;let D,_;if(Array.isArray(l)){if(l.length!==w.length)return!1;for(D=0;D<l.length;D++)if(!P(l[D],w[D]))return!1}else{const a=[];for(_ in l)a.push(_);a.sort();const d=[];for(_ in w)d.push(_);if(d.sort(),!P(a,d))return!1;for(D=0;D<a.length;D++)if(!P(l[a[D]],w[a[D]]))return!1}return!0}e.equals=P;function t(l){const w=new Set;return JSON.stringify(l,(D,_)=>{if((0,c.isObject)(_)||Array.isArray(_)){if(w.has(_))return"[Circular]";w.add(_)}return _})}e.safeStringify=t;function b(l,w,D){const _=w(l);return typeof _=="undefined"?D:_}e.getOrDefault=b;function n(l,w){const D=Object.create(null);return!l||!w||Object.keys(w).forEach(a=>{const d=l[a],y=w[a];P(d,y)||(D[a]=y)}),D}e.distinct=n;function f(l,w){const D=w.toLowerCase(),_=Object.keys(l).find(a=>a.toLowerCase()===D);return _?l[_]:l[w]}e.getCaseInsensitive=f;function o(l,w){const D=Object.create(null);for(const _ of Object.keys(l))w(_,l[_])&&(D[_]=l[_]);return D}e.filter=o});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[20],Ee([0,1,13,9,2]),function(ne,e,c,M,E){"use strict";var A,F,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(v,r,s){let u=v.get(r);return u===void 0&&(u=s,v.set(r,u)),u}e.getOrSet=S;function P(v){const r=[];return v.forEach((s,u)=>{r.push(`${u} => ${s}`)}),`Map(${v.size}) {${r.join(", ")}}`}e.mapToString=P;function t(v){const r=[];return v.forEach(s=>{r.push(s)}),`Set(${v.size}) {${r.join(", ")}}`}e.setToString=t;class b{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=b;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class f{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var o;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(o||(o={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new l(r))}static forPaths(){return new D(new f)}static forStrings(){return new D(new b)}static forConfigKeys(){return new D(new n)}clear(){this._root=void 0}set(r,s){const u=this._iter.reset(r);let h;for(this._root||(this._root=new w,this._root.segment=u.value()),h=this._root;;){const I=u.cmp(h.segment);if(I>0)h.left||(h.left=new w,h.left.segment=u.value()),h=h.left;else if(I<0)h.right||(h.right=new w,h.right.segment=u.value()),h=h.right;else if(u.hasNext())u.next(),h.mid||(h.mid=new w,h.mid.segment=u.value()),h=h.mid;else break}const p=h.value;return h.value=s,h.key=r,p}fill(r,s){const u=s.slice(0);(0,c.shuffle)(u);for(let h of u)this.set(h,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const h=s.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const u=this._iter.reset(r),h=[];let p=this._root;for(;p;){const I=u.cmp(p.segment);if(I>0)h.push([1,p]),p=p.left;else if(I<0)h.push([-1,p]),p=p.right;else if(u.hasNext())u.next(),h.push([0,p]),p=p.mid;else{for(s?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;h.length>0&&p.isEmpty();){let[T,g]=h.pop();switch(T){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}p=g}break}}}findSubstr(r){const s=this._iter.reset(r);let u=this._root,h;for(;u;){const p=s.cmp(u.segment);if(p>0)u=u.left;else if(p<0)u=u.right;else if(s.hasNext())s.next(),h=u.value||h,u=u.mid;else break}return u&&u.value||h}findSuperstr(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const h=s.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(r){for(const[s,u]of this)r(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const u=s.pop();u&&(u.value&&(yield[u.key,u.value]),u.left&&s.push(u.left),u.mid&&s.push(u.mid),u.right&&s.push(u.right))}}}e.TernarySearchTree=D;class _{constructor(r,s){this[A]="ResourceMap",r instanceof _?(this.map=new Map(r.map),this.toKey=s??_.defaultToKey):(this.map=new Map,this.toKey=r??_.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[u,h]of this.map)r(h,E.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield E.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[E.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[E.URI.parse(r[0]),r[1]]}}e.ResourceMap=_,_.defaultToKey=v=>v.toString();var a;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class d{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const u=this._map.get(r);if(!!u)return s!==0&&this.touch(u,s),u.value}set(r,s,u=0){let h=this._map.get(r);if(h)h.value=s,u!==0&&this.touch(h,u);else{switch(h={key:r,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const u=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return h}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>r;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,u=r.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const u=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(u.previous=h,h.next=u),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const u=r.next,h=r.previous;r===this._head?(u.previous=void 0,this._head=u):(u.previous=h,h.next=u),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,u)=>{r.push([u,s])}),r}fromJSON(r){this.clear();for(const[s,u]of r)this.set(s,u)}}e.LinkedMap=d;class y extends d{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class i{constructor(r){k.set(this,void 0),et(this,k,r,"f")}get size(){return Fe(this,k,"f").size}forEach(r,s){Fe(this,k,"f").forEach(r,s)}get(r){return Fe(this,k,"f").get(r)}has(r){return Fe(this,k,"f").has(r)}entries(){return Fe(this,k,"f").entries()}keys(){return Fe(this,k,"f").keys()}values(){return Fe(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Fe(this,k,"f").entries()}}e.ReadonlyMapView=i}),define(be[106],Ee([0,1,20,9]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...j){return function(se,he){for(let Re=0,Be=j.length;Re<Be;Re++){const ze=j[Re](se,he);if(ze)return ze}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(j,se,he){if(!he||he.length<se.length)return null;let Re;return j?Re=M.startsWithIgnoreCase(he,se):Re=he.indexOf(se)===0,Re?se.length>0?[{start:0,end:se.length}]:[]:null}function F(j,se){const he=se.toLowerCase().indexOf(j.toLowerCase());return he===-1?null:[{start:he,end:he+j.length}]}e.matchesContiguousSubString=F;function k(j,se){return S(j.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=k;function S(j,se,he,Re){if(he===j.length)return[];if(Re===se.length)return null;if(j[he]===se[Re]){let Be=null;return(Be=S(j,se,he+1,Re+1))?D({start:Re,end:Re+1},Be):null}return S(j,se,he,Re+1)}function P(j){return 97<=j&&j<=122}function t(j){return 65<=j&&j<=90}e.isUpper=t;function b(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(j=>f.add(j.charCodeAt(0)));function o(j){return n(j)||f.has(j)}function l(j,se){return j===se||o(j)&&o(se)}function w(j){return P(j)||t(j)||b(j)}function D(j,se){return se.length===0?se=[j]:j.end===se[0].start?se[0].start=j.start:se.unshift(j),se}function _(j,se){for(let he=se;he<j.length;he++){const Re=j.charCodeAt(he);if(t(Re)||b(Re)||he>0&&!w(j.charCodeAt(he-1)))return he}return j.length}function a(j,se,he,Re){if(he===j.length)return[];if(Re===se.length)return null;if(j[he]!==se[Re].toLowerCase())return null;{let Be=null,ze=Re+1;for(Be=a(j,se,he+1,Re+1);!Be&&(ze=_(se,ze))<se.length;)Be=a(j,se,he+1,ze),ze++;return Be===null?null:D({start:Re,end:Re+1},Be)}}function d(j){let se=0,he=0,Re=0,Be=0,ze=0;for(let z=0;z<j.length;z++)ze=j.charCodeAt(z),t(ze)&&se++,P(ze)&&he++,w(ze)&&Re++,b(ze)&&Be++;const Qe=se/j.length,it=he/j.length,ke=Re/j.length,Ze=Be/j.length;return{upperPercent:Qe,lowerPercent:it,alphaPercent:ke,numericPercent:Ze}}function y(j){const{upperPercent:se,lowerPercent:he}=j;return he===0&&se>.6}function i(j){const{upperPercent:se,lowerPercent:he,alphaPercent:Re,numericPercent:Be}=j;return he>.2&&se<.8&&Re>.6&&Be<.2}function v(j){let se=0,he=0,Re=0,Be=0;for(let ze=0;ze<j.length;ze++)Re=j.charCodeAt(ze),t(Re)&&se++,P(Re)&&he++,n(Re)&&Be++;return(se===0||he===0)&&Be===0?j.length<=30:se<=5}function r(j,se){if(!se||(se=se.trim(),se.length===0)||!v(j)||se.length>60)return null;const he=d(se);if(!i(he)){if(!y(he))return null;se=se.toLowerCase()}let Re=null,Be=0;for(j=j.toLowerCase();Be<se.length&&(Re=a(j,se,0,Be))===null;)Be=_(se,Be+1);return Re}e.matchesCamelCase=r;function s(j,se,he=!1){if(!se||se.length===0)return null;let Re=null,Be=0;for(j=j.toLowerCase(),se=se.toLowerCase();Be<se.length&&(Re=u(j,se,0,Be,he))===null;)Be=h(se,Be+1);return Re}e.matchesWords=s;function u(j,se,he,Re,Be){if(he===j.length)return[];if(Re===se.length)return null;if(l(j.charCodeAt(he),se.charCodeAt(Re))){let ze=null,Qe=Re+1;if(ze=u(j,se,he+1,Re+1,Be),!Be)for(;!ze&&(Qe=h(se,Qe))<se.length;)ze=u(j,se,he+1,Qe,Be),Qe++;return ze===null?null:D({start:Re,end:Re+1},ze)}else return null}function h(j,se){for(let he=se;he<j.length;he++)if(o(j.charCodeAt(he))||he>0&&o(j.charCodeAt(he-1)))return he;return j.length}const p=E(e.matchesPrefix,r,F),I=E(e.matchesPrefix,r,k),T=new c.LRUCache(1e4);function g(j,se,he=!1){if(typeof j!="string"||typeof se!="string")return null;let Re=T.get(j);Re||(Re=new RegExp(M.convertSimple2RegExpPattern(j),"i"),T.set(j,Re));const Be=Re.exec(se);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?I(j,se):p(j,se)}e.matchesFuzzy=g;function C(j,se){const he=We(j,j.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?R(he):null}e.matchesFuzzy2=C;function m(j,se,he,Re,Be,ze){const Qe=Math.min(13,j.length);for(;he<Qe;he++){const it=We(j,se,he,Re,Be,ze,!1);if(it)return it}return[0,ze]}e.anyScore=m;function R(j){if(typeof j=="undefined")return[];const se=[],he=j[1];for(let Re=j.length-1;Re>1;Re--){const Be=j[Re]+he,ze=se[se.length-1];ze&&ze.end===Be?ze.end=Be+1:se.push({start:Be,end:Be+1})}return se}e.createMatches=R;const L=128;function V(){const j=[],se=[];for(let he=0;he<=L;he++)se[he]=0;for(let he=0;he<=L;he++)j.push(se.slice(0));return j}function q(j){const se=[];for(let he=0;he<=j;he++)se[he]=0;return se}const U=q(2*L),K=q(2*L),$=V(),B=V(),H=V(),Q=!1;function re(j,se,he,Re,Be){function ze(it,ke,Ze=" "){for(;it.length<ke;)it=Ze+it;return it}let Qe=` |   |${Re.split("").map(it=>ze(it,3)).join("|")}
`;for(let it=0;it<=he;it++)it===0?Qe+=" |":Qe+=`${se[it-1]}|`,Qe+=j[it].slice(0,Be+1).map(ke=>ze(ke.toString(),3)).join("|")+`
`;return Qe}function ue(j,se,he,Re){j=j.substr(se),he=he.substr(Re),console.log(re(B,j,j.length,he,he.length)),console.log(re(H,j,j.length,he,he.length)),console.log(re($,j,j.length,he,he.length))}function Z(j,se){if(se<0||se>=j.length)return!1;const he=j.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function oe(j,se){if(se<0||se>=j.length)return!1;switch(j.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ve(j,se,he){return se[j]!==he[j]}function Ae(j,se,he,Re,Be,ze,Qe=!1){for(;se<he&&Be<ze;)j[se]===Re[Be]&&(Qe&&(U[se]=Be),se+=1),Be+=1;return se===he}e.isPatternInWord=Ae;var Se;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Ne;(function(j){j.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}j.isDefault=se})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function We(j,se,he,Re,Be,ze,Qe){const it=j.length>L?L:j.length,ke=Re.length>L?L:Re.length;if(he>=it||ze>=ke||it-he>ke-ze||!Ae(se,he,it,Be,ze,ke,!0))return;je(it,ke,he,ze,se,Be);let Ze=1,z=1,J=he,me=ze;const He=[!1];for(Ze=1,J=he;J<it;Ze++,J++){const ft=U[J],Dt=K[J],Pt=J+1<it?K[J+1]:ke;for(z=ft-ze+1,me=ft;me<Pt;z++,me++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;me<=Dt&&(It=qe(j,se,J,he,Re,Be,me,ke,ze,$[Ze-1][z-1]===0,He));let yt=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,yt=It+B[Ze-1][z-1]);const Te=me>ft,ye=Te?B[Ze][z-1]+($[Ze][z-1]>0?-5:0):0,Ce=me>ft+1&&$[Ze][z-1]>0,ee=Ce?B[Ze][z-2]+($[Ze][z-2]>0?-5:0):0;if(Ce&&(!Te||ee>=ye)&&(!Xe||ee>=yt))B[Ze][z]=ee,H[Ze][z]=3,$[Ze][z]=0;else if(Te&&(!Xe||ye>=yt))B[Ze][z]=ye,H[Ze][z]=2,$[Ze][z]=0;else if(Xe)B[Ze][z]=yt,H[Ze][z]=1,$[Ze][z]=$[Ze-1][z-1]+1;else throw new Error("not possible")}}if(Q&&ue(j,he,Re,ze),!He[0]&&!Qe)return;Ze--,z--;const Ye=[B[Ze][z],ze];let st=0,ot=0;for(;Ze>=1;){let ft=z;do{const Dt=H[Ze][ft];if(Dt===3)ft=ft-2;else if(Dt===2)ft=ft-1;else break}while(ft>=1);st>1&&se[he+Ze-1]===Be[ze+z-1]&&!ve(ft+ze-1,Re,Be)&&st+1>$[Ze][ft]&&(ft=z),ft===z?st++:st=1,ot||(ot=ft),Ze--,z=ft-1,Ye.push(z)}ke===it&&(Ye[0]+=2);const Et=ot-it;return Ye[0]-=Et,Ye}e.fuzzyScore=We;function je(j,se,he,Re,Be,ze){let Qe=j-1,it=se-1;for(;Qe>=he&&it>=Re;)Be[Qe]===ze[it]&&(K[Qe]=it,Qe--),it--}function qe(j,se,he,Re,Be,ze,Qe,it,ke,Ze,z){if(se[he]!==ze[Qe])return Number.MIN_SAFE_INTEGER;let J=1,me=!1;return Qe===he-Re?J=j[he]===Be[Qe]?7:5:ve(Qe,Be,ze)&&(Qe===0||!ve(Qe-1,Be,ze))?(J=j[he]===Be[Qe]?7:5,me=!0):Z(ze,Qe)&&(Qe===0||!Z(ze,Qe-1))?J=5:(Z(ze,Qe-1)||oe(ze,Qe-1))&&(J=5,me=!0),J>1&&he===Re&&(z[0]=!0),me||(me=ve(Qe,Be,ze)||Z(ze,Qe-1)||oe(ze,Qe-1)),he===Re?Qe>ke&&(J-=me?3:5):Ze?J+=me?2:0:J+=me?0:1,Qe+1===it&&(J-=me?3:5),J}function x(j,se,he,Re,Be,ze,Qe){return te(j,se,he,Re,Be,ze,!0,Qe)}e.fuzzyScoreGracefulAggressive=x;function G(j,se,he,Re,Be,ze,Qe){return te(j,se,he,Re,Be,ze,!1,Qe)}e.fuzzyScoreGraceful=G;function te(j,se,he,Re,Be,ze,Qe,it){let ke=We(j,se,he,Re,Be,ze,it);if(ke&&!Qe)return ke;if(j.length>=3){const Ze=Math.min(7,j.length-1);for(let z=he+1;z<Ze;z++){const J=ae(j,z);if(J){const me=We(J,J.toLowerCase(),he,Re,Be,ze,it);me&&(me[0]-=3,(!ke||me[0]>ke[0])&&(ke=me))}}}return ke}function ae(j,se){if(se+1>=j.length)return;const he=j[se],Re=j[se+1];if(he!==Re)return j.slice(0,se)+Re+he+j.slice(se+2)}}),define(be[107],Ee([0,1,34,106,9]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${A.source}`,"g");function k(l){return l.replace(F,(w,D)=>D?w:`\\${w}`)}e.escapeIcons=k;const S=new RegExp(`\\\\${A.source}`,"g");function P(l){return l.replace(S,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(w,D,_,a)=>_?w:D||a||"")}e.stripIcons=b;function n(l){const w=l.indexOf(e.iconStartMarker);return w===-1?{text:l}:f(l,w)}e.parseLabelWithIcons=n;function f(l,w){const D=[];let _="";function a(h){if(h){_+=h;for(const p of h)D.push(i)}}let d=-1,y="",i=0,v,r,s=w;const u=l.length;for(a(l.substr(0,w));s<u;)v=l[s],r=l[s+1],v===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(d=s,a(y),y=e.iconStartMarker,s++):v===")"&&d!==-1?(i+=s-d+1,d=-1,y=""):d!==-1?/^[a-z0-9\-]$/i.test(v)?y+=v:(a(y),d=-1,y=""):a(v),s++;return a(y),{text:_,iconOffsets:D}}function o(l,w,D=!1){const{text:_,iconOffsets:a}=w;if(!a||a.length===0)return(0,M.matchesFuzzy)(l,_,D);const d=(0,E.ltrim)(_," "),y=_.length-d.length,i=(0,M.matchesFuzzy)(l,d,D);if(i)for(const v of i){const r=a[v.start+y]+y;v.start+=r,v.end+=r}return i}e.matchesFuzzyIconAware=o}),define(be[76],Ee([0,1,16,107]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(f="",o=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(f,o=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(f):f).replace(/([ \t]+)/g,(l,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,o){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=A;function F(n){return k(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function k(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function S(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=S;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function b(n){const f=[],o=n.split("|").map(w=>w.trim());n=o[0];const l=o[1];if(l){const w=/height=(\d+)/.exec(l),D=/width=(\d+)/.exec(l),_=w?w[1]:"",a=D?D[1]:"",d=isFinite(parseInt(a)),y=isFinite(parseInt(_));d&&f.push(`width="${a}"`),y&&f.push(`height="${_}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=b}),define(be[54],Ee([0,1,22,9,2]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,S)}e.stringify=A;function F(t){let b=JSON.parse(t);return b=P(b),b}e.parse=F;var k;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function S(t,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function P(t,b=0){if(!t||b>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof c.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],b+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],b+1))}return t}e.revive=P}),define(be[11],Ee([0,1,25,2]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,P,t){this._hosts[S]=P,this._ports[S]=t}setConnectionToken(S,P){this._connectionTokens[S]=P}rewrite(S){if(this._delegate)return this._delegate(S);const P=S.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const b=this._ports[P],n=this._connectionTokens[P];let f=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:c.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${b}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new A;class F{asBrowserUri(S,P){const t=this.toUri(S,P);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${E.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(S,P){const t=this.toUri(S,P);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(S,P){return M.URI.isUri(S)?S:M.URI.parse(P.toUrl(S))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,k.uriToFsPath)(f,!0)}e.originalFSPath=S;class P{constructor(o){this._ignorePathCasing=o}compare(o,l,w=!1){return o===l?0:(0,F.compare)(this.getComparisonKey(o,w),this.getComparisonKey(l,w))}isEqual(o,l,w=!1){return o===l?!0:!o||!l?!1:this.getComparisonKey(o,w)===this.getComparisonKey(l,w)}getComparisonKey(o,l=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,l,w=!1){if(o.scheme===l.scheme){if(o.scheme===M.Schemas.file)return c.isEqualOrParent(S(o),S(l),this._ignorePathCasing(o))&&o.query===l.query&&(w||o.fragment===l.fragment);if((0,e.isEqualAuthority)(o.authority,l.authority))return c.isEqualOrParent(o.path,l.path,this._ignorePathCasing(o),"/")&&o.query===l.query&&(w||o.fragment===l.fragment)}return!1}joinPath(o,...l){return k.URI.joinPath(o,...l)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return E.posix.basename(o.path)}extname(o){return E.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let l;return o.scheme===M.Schemas.file?l=k.URI.file(E.dirname(S(o))).path:(l=E.posix.dirname(o.path),o.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),l="/")),o.with({path:l})}normalizePath(o){if(!o.path.length)return o;let l;return o.scheme===M.Schemas.file?l=k.URI.file(E.normalize(S(o))).path:l=E.posix.normalize(o.path),o.with({path:l})}relativePath(o,l){if(o.scheme!==l.scheme||!(0,e.isEqualAuthority)(o.authority,l.authority))return;if(o.scheme===M.Schemas.file){const _=E.relative(S(o),S(l));return A.isWindows?c.toSlashes(_):_}let w=o.path||"/",D=l.path||"/";if(this._ignorePathCasing(o)){let _=0;for(const a=Math.min(w.length,D.length);_<a&&!(w.charCodeAt(_)!==D.charCodeAt(_)&&w.charAt(_).toLowerCase()!==D.charAt(_).toLowerCase());_++);w=D.substr(0,_)+w.substr(_)}return E.posix.relative(w,D)}resolvePath(o,l){if(o.scheme===M.Schemas.file){const w=k.URI.file(E.resolve(S(o),l));return o.with({authority:w.authority,path:w.path})}return l=c.toPosixPath(l),o.with({path:E.posix.resolve(o.path,l)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,l){return o===l||(0,F.equalsIgnoreCase)(o,l)}hasTrailingPathSeparator(o,l=E.sep){if(o.scheme===M.Schemas.file){const w=S(o);return w.length>c.getRoot(w).length&&w[w.length-1]===l}else{const w=o.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,l=E.sep){return(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,l=E.sep){let w=!1;if(o.scheme===M.Schemas.file){const D=S(o);w=D!==void 0&&D.length===c.getRoot(D).length&&D[D.length-1]===l}else{l="/";const D=o.path;w=D.length===1&&D.charCodeAt(D.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path+"/"}):o}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(f=>f.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(f,o){const l=[];for(let w=0;w<f.length;w++){const D=o(f[w]);f.some((_,a)=>a===w?!1:(0,e.isEqualOrParent)(D,o(_)))||l.push(f[w])}return l}e.distinctParents=t;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function o(l){const w=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(a=>{const[d,y]=a.split(":");d&&y&&w.set(d,y)});const _=l.path.substring(0,l.path.indexOf(";"));return _&&w.set(f.META_DATA_MIME,_),w}f.parseMetaData=o})(b=e.DataUri||(e.DataUri={}));function n(f,o,l){if(o){let w=f.path;return w&&w[0]!==E.posix.sep&&(w=E.posix.sep+w),f.with({scheme:l,authority:o,path:w})}return f.with({scheme:l})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k($){return!!$&&typeof $.then=="function"}e.isThenable=k;function S($){const B=new c.CancellationTokenSource,H=$(B.token),Q=new Promise((re,ue)=>{const Z=B.token.onCancellationRequested(()=>{Z.dispose(),B.dispose(),ue((0,M.canceled)())});Promise.resolve(H).then(oe=>{Z.dispose(),B.dispose(),re(oe)},oe=>{Z.dispose(),B.dispose(),ue(oe)})});return new class{cancel(){B.cancel()}then(re,ue){return Q.then(re,ue)}catch(re){return this.then(void 0,re)}finally(re){return Q.finally(re)}}}e.createCancelablePromise=S;function P($,B,H){return Promise.race([$,new Promise(Q=>B.onCancellationRequested(()=>Q(H)))])}e.raceCancellation=P;async function t($){let B=-1;const H=$.map((re,ue)=>re.then(Z=>(B=ue,Z))),Q=await Promise.race(H);return $.forEach((re,ue)=>{ue!==B&&re.cancel()}),Q}e.raceCancellablePromises=t;function b($,B,H){let Q;const re=setTimeout(()=>{Q?.(void 0),H?.()},B);return Promise.race([$.finally(()=>clearTimeout(re)),new Promise(ue=>Q=ue)])}e.raceTimeout=b;function n($){return new Promise((B,H)=>{const Q=$();k(Q)?Q.then(B,H):B(Q)})}e.asPromise=n;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(H,H).then(Q)})}return new Promise((H,Q)=>{this.queuedPromise.then(H,Q)})}return this.activePromise=B(),new Promise((H,Q)=>{this.activePromise.then(re=>{this.activePromise=null,H(re)},re=>{this.activePromise=null,Q(re)})})}}e.Throttler=f;class o{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=o;class l{constructor(){this.promiseMap=new Map}queue(B,H){const re=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(B)===re&&this.promiseMap.delete(B)});return this.promiseMap.set(B,re),re}}e.SequencerByKey=l;class w{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,H=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,re)=>{this.doResolve=Q,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class D{constructor(B){this.delayer=new w(B),this.throttler=new f}trigger(B,H){return this.delayer.trigger(()=>this.throttler.queue(B),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class _{constructor(){this._isOpen=!1,this._promise=new Promise((B,H)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class a extends _{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function d($,B){return B?new Promise((H,Q)=>{const re=setTimeout(()=>{ue.dispose(),H()},$),ue=B.onCancellationRequested(()=>{clearTimeout(re),ue.dispose(),Q((0,M.canceled)())})}):S(H=>d($,H))}e.timeout=d;function y($,B=0){const H=setTimeout($,B);return(0,A.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=y;function i($){const B=[];let H=0;const Q=$.length;function re(){return H<Q?$[H++]():null}function ue(Z){Z!=null&&B.push(Z);const oe=re();return oe?oe.then(ue):Promise.resolve(B)}return Promise.resolve(null).then(ue)}e.sequence=i;function v($,B=Q=>!!Q,H=null){let Q=0;const re=$.length,ue=()=>{if(Q>=re)return Promise.resolve(H);const Z=$[Q++];return Promise.resolve(Z()).then(ve=>B(ve)?Promise.resolve(ve):ue())};return ue()}e.first=v;function r($,B=Q=>!!Q,H=null){if($.length===0)return Promise.resolve(H);let Q=$.length;const re=()=>{Q=-1;for(const ue of $)ue.cancel?.()};return new Promise((ue,Z)=>{for(const oe of $)oe.then(ve=>{--Q>=0&&B(ve)?(re(),ue(ve)):Q===0&&ue(H)}).catch(ve=>{--Q>=0&&(re(),Z(ve))})})}e.firstParallel=r;class s{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((H,Q)=>{this.outstandingPromises.push({factory:B,c:H,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const H=B.factory();H.then(B.c,B.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class h{constructor(){this.queues=new Map}queueFor(B,H=F.extUri){const Q=H.getComparisonKey(B);let re=this.queues.get(Q);return re||(re=new u,E.Event.once(re.onFinished)(()=>{re?.dispose(),this.queues.delete(Q)}),this.queues.set(Q,re)),re}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=h;class p{constructor(B,H){this._token=-1,typeof B=="function"&&typeof H=="number"&&this.setIfNotSet(B,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},H)}setIfNotSet(B,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},H))}}e.TimeoutTimer=p;class I{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,H){this.cancel(),this._token=setInterval(()=>{B()},H)}}e.IntervalTimer=I;class T{constructor(B,H){this.timeoutToken=-1,this.runner=B,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class g{constructor(B,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class C extends T{constructor(B,H){super(B,H);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class m extends A.Disposable{constructor(B,H,Q,re){super();this.maxWorkChunkSize=B,this.maxPendingWork=H,this.throttleDelay=Q,this.handler=re,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=m,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{const B=setTimeout(()=>{const Q=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0,clearTimeout(B))}}}:e.runWhenIdle=($,B)=>{const H=requestIdleCallback($,typeof B=="number"?{timeout:B}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(H))}}}}();class R{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function L($,B,H){let Q;for(let re=0;re<H;re++)try{return await $()}catch(ue){Q=ue,await d(B)}throw Q}e.retry=L;class V{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,H,Q){return this._pending={taskId:B,cancel:()=>Q?.(),promise:H},H.then(()=>this.donePending(B),()=>this.donePending(B)),H}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let H,Q;const re=new Promise((ue,Z)=>{H=ue,Q=Z});this._next={run:B,promise:re,promiseResolve:H,promiseReject:Q}}return this._next.promise}}e.TaskSequentializer=V;class q{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,H)=>{this.completeCallback=B,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(H=>{this.completeCallback(B),this.resolved=!0,H()})}error(B){return new Promise(H=>{this.errorCallback(B),this.rejected=!0,H()})}cancel(){new Promise(B=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=U;var K;(function($){async function B(H){let Q;const re=await Promise.all(H.map(ue=>ue.then(Z=>Z,Z=>{Q||(Q=Z)})));if(typeof Q!="undefined")throw Q;return re}$.settled=B})(K=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,14,17]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new c.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(T,g,C=!1){const m=T||"",R=g||"",L=E.value.collator.compare(m,R);return E.value.collatorIsNumeric&&L===0&&m!==R?m<R?-1:1:L}e.compareFileNames=k;function S(T,g){const C=A.value.collator;return T=T||"",g=g||"",y(C,T,g)}e.compareFileNamesDefault=S;function P(T,g){const C=A.value.collator;return T=T||"",g=g||"",s(T,g)||y(C,T,g)}e.compareFileNamesUpper=P;function t(T,g){const C=A.value.collator;return T=T||"",g=g||"",r(T,g)||y(C,T,g)}e.compareFileNamesLower=t;function b(T,g){return T=T||"",g=g||"",T===g?0:T<g?-1:1}e.compareFileNamesUnicode=b;function n(T,g,C=!1){C||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase());const[m,R]=a(T),[L,V]=a(g);return m!==L?m<L?-1:1:R===V?0:R<V?-1:1}e.noIntlCompareFileNames=n;function f(T,g){const[C,m]=a(T),[R,L]=a(g);let V=E.value.collator.compare(m,L);if(V===0){if(E.value.collatorIsNumeric&&m!==L)return m<L?-1:1;if(V=E.value.collator.compare(C,R),E.value.collatorIsNumeric&&V===0&&C!==R)return C<R?-1:1}return V}e.compareFileExtensions=f;function o(T,g){T=T||"",g=g||"";const C=d(T),m=d(g),R=A.value.collator,L=F.value.collator;return y(L,C,m)||y(R,T,g)}e.compareFileExtensionsDefault=o;function l(T,g){T=T||"",g=g||"";const C=d(T),m=d(g),R=A.value.collator,L=F.value.collator;return y(L,C,m)||s(T,g)||y(R,T,g)}e.compareFileExtensionsUpper=l;function w(T,g){T=T||"",g=g||"";const C=d(T),m=d(g),R=A.value.collator,L=F.value.collator;return y(L,C,m)||r(T,g)||y(R,T,g)}e.compareFileExtensionsLower=w;function D(T,g){T=T||"",g=g||"";const C=d(T).toLowerCase(),m=d(g).toLowerCase();return C!==m?C<m?-1:1:T!==g?T<g?-1:1:0}e.compareFileExtensionsUnicode=D;const _=/^(.*?)(\.([^.]*))?$/;function a(T,g=!1){const C=T?_.exec(T):[];let m=[C&&C[1]||"",C&&C[3]||""];return g&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function d(T){const g=T?_.exec(T):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function y(T,g,C){let m=T.compare(g,C);return m!==0?m:g.length!==C.length?g.length<C.length?-1:1:0}function i(T){const g=T.charAt(0);return g.toLocaleUpperCase()!==g}function v(T){const g=T.charAt(0);return g.toLocaleLowerCase()!==g}function r(T,g){return i(T)&&v(g)?-1:v(T)&&i(g)?1:0}function s(T,g){return v(T)&&i(g)?-1:i(T)&&v(g)?1:0}function u(T,g,C=!1){return C||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase()),T===g?0:T<g?-1:1}function h(T,g,C=!1){const m=T.split(M.sep),R=g.split(M.sep),L=m.length-1,V=R.length-1;let q,U;for(let K=0;;K++){if(q=L===K,U=V===K,q&&U)return k(m[K],R[K],C);if(q)return-1;if(U)return 1;const $=u(m[K],R[K],C);if($!==0)return $}}e.comparePaths=h;function p(T,g,C){const m=T.toLowerCase(),R=g.toLowerCase(),L=I(T,g,C);if(L)return L;const V=m.endsWith(C),q=R.endsWith(C);if(V!==q)return V?-1:1;const U=k(m,R);return U!==0?U:m.localeCompare(R)}e.compareAnything=p;function I(T,g,C){const m=T.toLowerCase(),R=g.toLowerCase(),L=m.startsWith(C),V=R.startsWith(C);if(L!==V)return L?-1:1;if(L&&V){if(m.length<R.length)return-1;if(m.length>R.length)return 1}return 0}e.compareByPrefix=I}),define(be[27],Ee([0,1,14,43,20,17,9]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const S="**",P="/",t="[/\\\\]",b="[^/\\\\]",n=/\//g;function f(Q){switch(Q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${t}|${b}+${t}|${t}${b}+)*?`}}function o(Q,re){if(!Q)return[];const ue=[];let Z=!1,oe=!1,ve="";for(const Ae of Q){switch(Ae){case re:if(!Z&&!oe){ue.push(ve),ve="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ve+=Ae}return ve&&ue.push(ve),ue}e.splitGlobAware=o;function l(Q){if(!Q)return"";let re="";const ue=o(Q,P);if(ue.every(Z=>Z===S))re=".*";else{let Z=!1;ue.forEach((oe,ve)=>{if(oe===S){Z||(re+=f(2),Z=!0);return}let Ae=!1,Se="",Ne=!1,We="";for(const je of oe){if(je!=="}"&&Ae){Se+=je;continue}if(Ne&&(je!=="]"||!We)){let qe;je==="-"?qe=je:(je==="^"||je==="!")&&!We?qe="^":je===P?qe="":qe=F.escapeRegExpCharacters(je),We+=qe;continue}switch(je){case"{":Ae=!0;continue;case"[":Ne=!0;continue;case"}":re+=`(?:${o(Se,",").map(G=>l(G)).join("|")})`,Ae=!1,Se="";break;case"]":re+="["+We+"]",Ne=!1,We="";break;case"?":re+=b;continue;case"*":re+=f(1);continue;default:re+=F.escapeRegExpCharacters(je)}}ve<ue.length-1&&(ue[ve+1]!==S||ve+2<ue.length)&&(re+=t),Z=!1})}return re}const w=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),v=function(){return!1},r=function(){return null};function s(Q,re){if(!Q)return r;let ue;typeof Q!="string"?ue=Q.pattern:ue=Q,ue=ue.trim();const Z=`${ue}_${!!re.trimForExclusions}`;let oe=i.get(Z);if(oe)return u(oe,Q);let ve;if(w.test(ue)){const Ae=ue.substr(4);oe=function(Se,Ne){return typeof Se=="string"&&Se.endsWith(Ae)?ue:null}}else(ve=D.exec(h(ue,re)))?oe=p(ve[1],ue):(re.trimForExclusions?a:_).test(ue)?oe=I(ue,re):(ve=d.exec(h(ue,re)))?oe=T(ve[1].substr(1),ue,!0):(ve=y.exec(h(ue,re)))?oe=T(ve[1],ue,!1):oe=g(ue);return i.set(Z,oe),u(oe,Q)}function u(Q,re){return typeof re=="string"?Q:function(ue,Z){return M.isEqualOrParent(ue,re.base)?Q(A.relative(re.base,ue),Z):null}}function h(Q,re){return re.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function p(Q,re){const ue=`/${Q}`,Z=`\\${Q}`,oe=function(Ae,Se){return typeof Ae!="string"?null:Se?Se===Q?re:null:Ae===Q||Ae.endsWith(ue)||Ae.endsWith(Z)?re:null},ve=[Q];return oe.basenames=ve,oe.patterns=[re],oe.allBasenames=ve,oe}function I(Q,re){const ue=H(Q.slice(1,-1).split(",").map(Se=>s(Se,re)).filter(Se=>Se!==r),Q),Z=ue.length;if(!Z)return r;if(Z===1)return ue[0];const oe=function(Se,Ne){for(let We=0,je=ue.length;We<je;We++)if(ue[We](Se,Ne))return Q;return null},ve=ue.find(Se=>!!Se.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Ae=ue.reduce((Se,Ne)=>Ne.allPaths?Se.concat(Ne.allPaths):Se,[]);return Ae.length&&(oe.allPaths=Ae),oe}function T(Q,re,ue){const Z=A.sep===A.posix.sep,oe=Z?Q:Q.replace(n,A.sep),ve=A.sep+oe,Ae=A.posix.sep+Q,Se=ue?function(Ne,We){return typeof Ne=="string"&&(Ne===oe||Ne.endsWith(ve)||!Z&&(Ne===Q||Ne.endsWith(Ae)))?re:null}:function(Ne,We){return typeof Ne=="string"&&(Ne===oe||!Z&&Ne===Q)?re:null};return Se.allPaths=[(ue?"*/":"./")+Q],Se}function g(Q){try{const re=new RegExp(`^${l(Q)}$`);return function(ue){return re.lastIndex=0,typeof ue=="string"&&re.test(ue)?Q:null}}catch(re){return r}}function C(Q,re,ue){return!Q||typeof re!="string"?!1:m(Q)(re,void 0,ue)}e.match=C;function m(Q,re={}){if(!Q)return v;if(typeof Q=="string"||q(Q)){const ue=s(Q,re);if(ue===r)return v;const Z=function(oe,ve){return!!ue(oe,ve)};return ue.allBasenames&&(Z.allBasenames=ue.allBasenames),ue.allPaths&&(Z.allPaths=ue.allPaths),Z}return $(Q,re)}e.parse=m;function R(Q){if(!Q)return;let re;return ue=>(re||(re=(Q()||Promise.resolve([])).then(Z=>Z?V(Z):{})),re.then(Z=>!!Z[ue]))}e.hasSiblingPromiseFn=R;function L(Q){if(!Q)return;let re;return ue=>{if(!re){const Z=Q();re=Z?V(Z):{}}return!!re[ue]}}e.hasSiblingFn=L;function V(Q){const re={};for(const ue of Q)re[ue]=!0;return re}function q(Q){const re=Q;return re&&typeof re.base=="string"&&typeof re.pattern=="string"}e.isRelativePattern=q;function U(Q){return Q.allBasenames||[]}e.getBasenameTerms=U;function K(Q){return Q.allPaths||[]}e.getPathTerms=K;function $(Q,re){const ue=H(Object.getOwnPropertyNames(Q).map(Se=>B(Se,Q[Se],re)).filter(Se=>Se!==r)),Z=ue.length;if(!Z)return r;if(!ue.some(Se=>!!Se.requiresSiblings)){if(Z===1)return ue[0];const Se=function(je,qe){for(let x=0,G=ue.length;x<G;x++){const te=ue[x](je,qe);if(te)return te}return null},Ne=ue.find(je=>!!je.allBasenames);Ne&&(Se.allBasenames=Ne.allBasenames);const We=ue.reduce((je,qe)=>qe.allPaths?je.concat(qe.allPaths):je,[]);return We.length&&(Se.allPaths=We),Se}const oe=function(Se,Ne,We){let je;for(let qe=0,x=ue.length;qe<x;qe++){const G=ue[qe];G.requiresSiblings&&We&&(Ne||(Ne=A.basename(Se)),je||(je=Ne.substr(0,Ne.length-A.extname(Se).length)));const te=G(Se,Ne,je,We);if(te)return te}return null},ve=ue.find(Se=>!!Se.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Ae=ue.reduce((Se,Ne)=>Ne.allPaths?Se.concat(Ne.allPaths):Se,[]);return Ae.length&&(oe.allPaths=Ae),oe}function B(Q,re,ue){if(re===!1)return r;const Z=s(Q,ue);if(Z===r)return r;if(typeof re=="boolean")return Z;if(re){const oe=re.when;if(typeof oe=="string"){const ve=(Ae,Se,Ne,We)=>{if(!We||!Z(Ae,Se))return null;const je=oe.replace("$(basename)",Ne),qe=We(je);return(0,c.isThenable)(qe)?qe.then(x=>x?Q:null):qe?Q:null};return ve.requiresSiblings=!0,ve}}return Z}function H(Q,re){const ue=Q.filter(Se=>!!Se.basenames);if(ue.length<2)return Q;const Z=ue.reduce((Se,Ne)=>{const We=Ne.basenames;return We?Se.concat(We):Se},[]);let oe;if(re){oe=[];for(let Se=0,Ne=Z.length;Se<Ne;Se++)oe.push(re)}else oe=ue.reduce((Se,Ne)=>{const We=Ne.patterns;return We?Se.concat(We):Se},[]);const ve=function(Se,Ne){if(typeof Se!="string")return null;if(!Ne){let je;for(je=Se.length;je>0;je--){const qe=Se.charCodeAt(je-1);if(qe===47||qe===92)break}Ne=Se.substr(je)}const We=Z.indexOf(Ne);return We!==-1?oe[We]:null};ve.basenames=Z,ve.patterns=oe,ve.allBasenames=Z;const Ae=Q.filter(Se=>!Se.basenames);return Ae.push(ve),Ae}}),define(be[77],Ee([0,1,43,11,17,25,24,9,2]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(s,u,h){if(typeof s=="string"&&(s=S.URI.file(s)),h){const I=h.getWorkspaceFolder(s);if(I){const T=h.getWorkspace().folders.length>1;let g;if((0,F.isEqual)(I.uri,s)?g="":g=(0,F.relativePath)(I.uri,s),T){const C=I.name?I.name:(0,F.basename)(I.uri);g=g?C+" \u2022 "+g:C}return g}}if(s.scheme!==M.Schemas.file&&s.scheme!==M.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(s.fsPath))return(0,E.normalize)(b(s.fsPath));let p=(0,E.normalize)(s.fsPath);return!A.isWindows&&u?.userHome&&(p=f(p,u.userHome.fsPath)),p}e.getPathLabel=P;function t(s){if(!s)return;typeof s=="string"&&(s=S.URI.file(s));const u=(0,F.basename)(s)||(s.scheme===M.Schemas.file?s.fsPath:s.path);return A.isWindows&&(0,c.isRootOrDriveLetter)(u)?b(u):u}e.getBaseLabel=t;function b(s){return(0,c.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=b;let n=Object.create(null);function f(s,u){if(A.isWindows||!s||!u)return s;let h=n.original===u?n.normalized:void 0;return h||(h=`${(0,k.rtrim)(u,E.posix.sep)}${E.posix.sep}`,n={original:u,normalized:h}),(A.isLinux?s.startsWith(h):(0,k.startsWithIgnoreCase)(s,h))&&(s=`~/${s.substr(h.length)}`),s}e.tildify=f;function o(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=o;const l="\u2026",w="\\\\",D="~";function _(s,u=E.sep){const h=new Array(s.length);let p=!1;for(let I=0;I<s.length;I++){let T=s[I];if(T===""){h[I]=`.${u}`;continue}if(!T){h[I]=T;continue}p=!0;let g="";T.indexOf(w)===0?(g=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length)):T.indexOf(u)===0?(g=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(D)===0&&(g=T.substr(0,T.indexOf(D)+D.length),T=T.substr(T.indexOf(D)+D.length));const C=T.split(u);for(let m=1;p&&m<=C.length;m++)for(let R=C.length-m;p&&R>=0;R--){p=!1;let L=C.slice(R,R+m).join(u);for(let V=0;!p&&V<s.length;V++)if(V!==I&&s[V]&&s[V].indexOf(L)>-1){const q=R+m===C.length,U=R>0&&s[V].indexOf(u)>-1?u+L:L,K=s[V].endsWith(U);p=!q||K}if(!p){let V="";(C[0].endsWith(":")||g!=="")&&(R===1&&(R=0,m++,L=C[0]+u+L),R>0&&(V=C[0]+u),V=g+V),R>0&&(V=V+l+u),V=V+L,R+m<C.length&&(V=V+u+l),h[I]=V}}p&&(h[I]=T)}return h}e.shorten=_;var a;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function d(s,u=Object.create(null)){const h=[];let p=!1,I="";for(const T of s)if(T==="$"||p&&T==="{")I&&h.push({value:I,type:a.TEXT}),I="",p=!0;else if(T==="}"&&p){const g=u[I];if(typeof g=="string")g.length&&h.push({value:g,type:a.VARIABLE});else if(g){const C=h[h.length-1];(!C||C.type!==a.SEPARATOR)&&h.push({value:g.label,type:a.SEPARATOR})}I="",p=!1}else I+=T;return I&&!p&&h.push({value:I,type:a.TEXT}),h.filter((T,g)=>{if(T.type===a.SEPARATOR){const C=h[g-1],m=h[g+1];return[C,m].every(R=>R&&(R.type===a.VARIABLE||R.type===a.TEXT)&&R.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=d;function y(s,u){return A.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function i(s,u){return A.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):A.isWindows?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function v(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=v;function r(s){const u=s.indexOf("/")!==-1?E.posix:E.win32,h=u.basename(s),p=u.dirname(s);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}e.splitName=r}),define(be[78],Ee([0,1,27,11,17,24,9]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown",s.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let S=[],P=[],t=[];function b(s,u=!1){const h=n(s);S.push(h),h.userConfigured?t.push(h):P.push(h),u&&!h.userConfigured&&S.forEach(p=>{p.mime===h.mime||p.userConfigured||(h.extension&&p.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&p.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&p.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&p.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=b;function n(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,c.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(E.posix.sep)>=0:!1}}function f(s){s?(S=S.filter(u=>!u.userConfigured),t=[]):(S=[],P=[],t=[])}e.clearTextMimes=f;function o(s,u){let h;if(s)switch(s.scheme){case M.Schemas.file:h=s.fsPath;break;case M.Schemas.data:h=A.DataUri.parseMetaData(s).get(A.DataUri.META_DATA_LABEL);break;default:h=s.path}if(!h)return[k.unknown];h=h.toLowerCase();const p=(0,E.basename)(h),I=l(h,p,t);if(I)return[I,k.text];const T=l(h,p,P);if(T)return[T,k.text];if(u){const g=w(u);if(g)return[g,k.text]}return[k.unknown]}e.guessMimeTypes=o;function l(s,u,h){let p=null,I=null,T=null;for(let g=h.length-1;g>=0;g--){const C=h[g];if(u===C.filenameLowercase){p=C;break}if(C.filepattern&&(!I||C.filepattern.length>I.filepattern.length)){const m=C.filepatternOnPath?s:u;C.filepatternLowercase?.(m)&&(I=C)}C.extension&&(!T||C.extension.length>T.extension.length)&&u.endsWith(C.extensionLowercase)&&(T=C)}return p?p.mime:I?I.mime:T?T.mime:null}function w(s){if((0,F.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let u=S.length-1;u>=0;u--){const h=S[u];if(!h.firstline)continue;const p=s.match(h.firstline);if(p&&p.length>0)return h.mime}return null}function D(s){return s?typeof s=="string"?s===k.binary||s===k.text||s===k.unknown:s.length===1&&D(s[0]):!0}e.isUnspecific=D;const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(s){const u=(0,E.extname)(s),h=_[u.toLowerCase()];return h!==void 0?h:y(s)}e.getMediaOrTextMime=d;function y(s){const u=(0,E.extname)(s);return a[u.toLowerCase()]}e.getMediaMime=y;function i(s){for(const u in a)if(a[u]===s)return u}e.getExtensionForMimeType=i;const v=/^(.+)\/(.+?)(;.+)?$/;function r(s,u){const h=v.exec(s);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:u?void 0:s}e.normalizeMimeType=r}),define(be[109],Ee([0,1,2]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(b){this._uriTransformer=b}transformIncoming(b){const n=this._uriTransformer.transformIncoming(b);return n===b?b:M(c.URI.from(n))}transformOutgoing(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:M(c.URI.from(n))}transformOutgoingURI(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:c.URI.from(n)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,b,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof c.URI)return b.transformOutgoing(t);for(let f in t)if(Object.hasOwnProperty.call(t,f)){const o=A(t[f],b,n+1);o!==null&&(t[f]=o)}}return null}function F(t,b){const n=A(t,b,0);return n===null?t:n}e.transformOutgoingURIs=F;function k(t,b,n,f){if(!t||f>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?c.URI.revive(b.transformIncoming(t)):b.transformIncoming(t);for(let o in t)if(Object.hasOwnProperty.call(t,o)){const l=k(t[o],b,n,f+1);l!==null&&(t[o]=l)}}return null}function S(t,b){const n=k(t,b,!1,0);return n===null?t:n}e.transformIncomingURIs=S;function P(t,b){const n=k(t,b,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(be[36],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(S){return c.test(S)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(S){for(let P=0;P<S.length;P++)S[P]=Math.floor(Math.random()*256);return S};function k(){F(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let S=0,P="";return P+=A[E[S++]],P+=A[E[S++]],P+=A[E[S++]],P+=A[E[S++]],P+="-",P+=A[E[S++]],P+=A[E[S++]],P+="-",P+=A[E[S++]],P+=A[E[S++]],P+="-",P+=A[E[S++]],P+=A[E[S++]],P+="-",P+=A[E[S++]],P+=A[E[S++]],P+=A[E[S++]],P+=A[E[S++]],P+=A[E[S++]],P+=A[E[S++]],P}e.generateUuid=k}),define(be[110],Ee([0,1,227]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends c.CharacterClassifier{constructor(k){super(0);for(let S=0,P=k.length;S<P;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(F){let k={};return S=>(k.hasOwnProperty(S)||(k[S]=F(S)),k[S])}e.getMapForWordSeparators=A(F=>new E(F))}),define(be[79],Ee([0,1,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPair=e.IndentGuide=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(D){D[D.Left=1]="Left",D[D.Center=2]="Center",D[D.Right=4]="Right",D[D.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(D){D[D.Inline=1]="Inline",D[D.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(D){D[D.TextDefined=0]="TextDefined",D[D.LF=1]="LF",D[D.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(D){D[D.LF=1]="LF",D[D.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(D){D[D.LF=0]="LF",D[D.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class P{constructor(_,a){this._findMatchBrand=void 0,this.range=_,this.matches=a}}e.FindMatch=P;var t;(function(D){D[D.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",D[D.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",D[D.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",D[D.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));class b{constructor(_,a){this.visibleColumn=_,this.className=a}}e.IndentGuide=b;class n{constructor(_,a,d,y){this.range=_,this.openingBracketRange=a,this.closingBracketRange=d,this.nestingLevel=y}}e.BracketPair=n;var f;(function(D){D[D.Left=0]="Left",D[D.Right=1]="Right",D[D.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var o;(function(D){D[D.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(o=e.ModelConstants||(e.ModelConstants={}));class l{constructor(_,a,d,y,i,v){this.identifier=_,this.range=a,this.text=d,this.forceMoveMarkers=y,this.isAutoWhitespaceEdit=i,this._isTracked=v}}e.ValidAnnotatedEditOperation=l;class w{constructor(_,a,d){this.reverseEdits=_,this.changes=a,this.trimAutoWhitespaceLineNumbers=d}}e.ApplyEditsResult=w}),define(be[111],Ee([0,1,9,110,112,44,79]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(a,d,y,i){this.searchString=a,this.isRegex=d,this.matchCase=y,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=P(this.searchString):a=this.searchString.indexOf(`
`)>=0;let d=null;try{d=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(i){return null}if(!d)return null;let y=!this.isRegex&&!a;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new t(d,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=S;function P(_){if(!_||_.length===0)return!1;for(let a=0,d=_.length;a<d;a++)if(_.charCodeAt(a)===92){if(a++,a>=d)break;const i=_.charCodeAt(a);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(a,d,y){this.regex=a,this.wordSeparators=d,this.simpleSearch=y}}e.SearchData=t;function b(_,a,d){if(!d)return new F.FindMatch(_,null);let y=[];for(let i=0,v=a.length;i<v;i++)y[i]=a[i];return new F.FindMatch(_,y)}e.createFindMatch=b;class n{constructor(a){let d=[],y=0;for(let i=0,v=a.length;i<v;i++)a.charCodeAt(i)===10&&(d[y++]=i);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(a){const d=this._lineFeedsOffsets;let y=0,i=d.length-1;if(i===-1||a<=d[0])return 0;for(;y<i;){const v=y+((i-y)/2>>0);d[v]>=a?i=v-1:d[v+1]>=a?(y=v,i=v):y=v+1}return y+1}}class f{static findMatches(a,d,y,i,v){const r=d.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,y,new D(r.wordSeparators,r.regex),i,v):this._doFindMatchesLineByLine(a,y,r,i,v):[]}static _getMultilineMatchRange(a,d,y,i,v,r){let s,u=0;i?(u=i.findLineFeedCountBeforeOffset(v),s=d+v+u):s=d+v;let h;if(i){let g=i.findLineFeedCountBeforeOffset(v+r.length)-u;h=s+r.length+g}else h=s+r.length;const p=a.getPositionAt(s),I=a.getPositionAt(h);return new A.Range(p.lineNumber,p.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(a,d,y,i,v){const r=a.getOffsetAt(d.getStartPosition()),s=a.getValueInRange(d,1),u=a.getEOL()===`\r
`?new n(s):null,h=[];let p=0,I;for(y.reset(0);I=y.next(s);)if(h[p++]=b(this._getMultilineMatchRange(a,r,s,u,I.index,I[0]),I,i),p>=v)return h;return h}static _doFindMatchesLineByLine(a,d,y,i,v){const r=[];let s=0;if(d.startLineNumber===d.endLineNumber){const h=a.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return s=this._findMatchesInLine(y,h,d.startLineNumber,d.startColumn-1,s,r,i,v),r}const u=a.getLineContent(d.startLineNumber).substring(d.startColumn-1);s=this._findMatchesInLine(y,u,d.startLineNumber,d.startColumn-1,s,r,i,v);for(let h=d.startLineNumber+1;h<d.endLineNumber&&s<v;h++)s=this._findMatchesInLine(y,a.getLineContent(h),h,0,s,r,i,v);if(s<v){const h=a.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);s=this._findMatchesInLine(y,h,d.endLineNumber,0,s,r,i,v)}return r}static _findMatchesInLine(a,d,y,i,v,r,s,u){const h=a.wordSeparators;if(!s&&a.simpleSearch){const T=a.simpleSearch,g=T.length,C=d.length;let m=-g;for(;(m=d.indexOf(T,m+g))!==-1;)if((!h||w(h,d,C,m,g))&&(r[v++]=new F.FindMatch(new A.Range(y,m+1+i,y,m+1+g+i),null),v>=u))return v;return v}const p=new D(a.wordSeparators,a.regex);let I;p.reset(0);do if(I=p.next(d),I&&(r[v++]=b(new A.Range(y,I.index+1+i,y,I.index+1+I[0].length+i),I,s),v>=u))return v;while(I);return v}static findNextMatch(a,d,y,i){const v=d.parseSearchRequest();if(!v)return null;const r=new D(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindNextMatchMultiline(a,y,r,i):this._doFindNextMatchLineByLine(a,y,r,i)}static _doFindNextMatchMultiline(a,d,y,i){const v=new E.Position(d.lineNumber,1),r=a.getOffsetAt(v),s=a.getLineCount(),u=a.getValueInRange(new A.Range(v.lineNumber,v.column,s,a.getLineMaxColumn(s)),1),h=a.getEOL()===`\r
`?new n(u):null;y.reset(d.column-1);let p=y.next(u);return p?b(this._getMultilineMatchRange(a,r,u,h,p.index,p[0]),p,i):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(a,new E.Position(1,1),y,i):null}static _doFindNextMatchLineByLine(a,d,y,i){const v=a.getLineCount(),r=d.lineNumber,s=a.getLineContent(r),u=this._findFirstMatchInLine(y,s,r,d.column,i);if(u)return u;for(let h=1;h<=v;h++){const p=(r+h-1)%v,I=a.getLineContent(p+1),T=this._findFirstMatchInLine(y,I,p+1,1,i);if(T)return T}return null}static _findFirstMatchInLine(a,d,y,i,v){a.reset(i-1);const r=a.next(d);return r?b(new A.Range(y,r.index+1,y,r.index+1+r[0].length),r,v):null}static findPreviousMatch(a,d,y,i){const v=d.parseSearchRequest();if(!v)return null;const r=new D(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindPreviousMatchMultiline(a,y,r,i):this._doFindPreviousMatchLineByLine(a,y,r,i)}static _doFindPreviousMatchMultiline(a,d,y,i){const v=this._doFindMatchesMultiline(a,new A.Range(1,1,d.lineNumber,d.column),y,i,10*k);if(v.length>0)return v[v.length-1];const r=a.getLineCount();return d.lineNumber!==r||d.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new E.Position(r,a.getLineMaxColumn(r)),y,i):null}static _doFindPreviousMatchLineByLine(a,d,y,i){const v=a.getLineCount(),r=d.lineNumber,s=a.getLineContent(r).substring(0,d.column-1),u=this._findLastMatchInLine(y,s,r,i);if(u)return u;for(let h=1;h<=v;h++){const p=(v+r-h-1)%v,I=a.getLineContent(p+1),T=this._findLastMatchInLine(y,I,p+1,i);if(T)return T}return null}static _findLastMatchInLine(a,d,y,i){let v=null,r;for(a.reset(0);r=a.next(d);)v=b(new A.Range(y,r.index+1,y,r.index+1+r[0].length),r,i);return v}}e.TextModelSearch=f;function o(_,a,d,y,i){if(y===0)return!0;const v=a.charCodeAt(y-1);if(_.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=a.charCodeAt(y);if(_.get(r)!==0)return!0}return!1}function l(_,a,d,y,i){if(y+i===d)return!0;const v=a.charCodeAt(y+i);if(_.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=a.charCodeAt(y+i-1);if(_.get(r)!==0)return!0}return!1}function w(_,a,d,y,i){return o(_,a,d,y,i)&&l(_,a,d,y,i)}e.isValidMatch=w;class D{constructor(a,d){this._wordSeparators=a,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const d=a.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(y=this._searchRegex.exec(a),!y))return null;const i=y.index,v=y[0].length;if(i===this._prevMatchStartIndex&&v===this._prevMatchLength){if(v===0){c.getNextCodePoint(a,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=v,!this._wordSeparators||w(this._wordSeparators,a,d,i,v))return y}while(y);return null}}e.Searcher=D}),define(be[113],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class M{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let S=0,P=k.notIn.length;S<P;S++)switch(k.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=E;function A(F,k,S){F.has(k)?F.get(k).push(S):F.set(k,[S])}}),define(be[55],Ee([0,1,27,17]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,F,k,S){if(Array.isArray(A)){let P=0;for(const t of A){const b=E(t,F,k,S);if(b===10)return b;b>P&&(P=b)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===k?10:0:0;if(A){const{language:P,pattern:t,scheme:b,hasAccessToAllModels:n}=A;if(!S&&!n)return 0;let f=0;if(b)if(b===F.scheme)f=10;else if(b==="*")f=5;else return 0;if(P)if(P===k)f=10;else if(P==="*")f=Math.max(f,5);else return 0;if(t){let o;if(typeof t=="string"?o=t:o={...t,base:(0,M.normalize)(t.base)},o===F.fsPath||(0,c.match)(o,F.fsPath))f=10;else return 0}return f}else return 0}}e.score=E}),define(be[114],Ee([0,1,3,6]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,k){return this._map.set(F,k),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===k&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,k){let S=null,P=!1;return this._promises.set(F,k.then(t=>{this._promises.delete(F),!(P||!t)&&(S=this.register(F,t))})),(0,M.toDisposable)(()=>{P=!0,S&&S.dispose()})}getPromise(F){const k=this.get(F);if(k)return Promise.resolve(k);const S=this._promises.get(F);return S?S.then(P=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[80],Ee([0,1,22,25]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(E||(E={}));function A(b){for(let n=0,f=b.length;n<f;n+=4){const o=b[n+0],l=b[n+1],w=b[n+2],D=b[n+3];b[n+0]=D,b[n+1]=w,b[n+2]=l,b[n+3]=o}}function F(b){const n=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return M.isLittleEndian()||A(n),c.VSBuffer.wrap(n)}function k(b){const n=b.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(b){const n=new Uint32Array(P(b));let f=0;if(n[f++]=b.id,b.type==="full")n[f++]=1,n[f++]=b.data.length,n.set(b.data,f),f+=b.data.length;else{n[f++]=2,n[f++]=b.deltas.length;for(const o of b.deltas)n[f++]=o.start,n[f++]=o.deleteCount,o.data?(n[f++]=o.data.length,n.set(o.data,f),f+=o.data.length):n[f++]=0}return F(n)}e.encodeSemanticTokensDto=S;function P(b){let n=0;if(n+=1+1,b.type==="full")n+=1+b.data.length;else{n+=1,n+=(1+1+1)*b.deltas.length;for(const f of b.deltas)f.data&&(n+=f.data.length)}return n}function t(b){const n=k(b);let f=0;const o=n[f++];if(n[f++]===1){const _=n[f++],a=n.subarray(f,f+_);return f+=_,{id:o,type:"full",data:a}}const w=n[f++];let D=[];for(let _=0;_<w;_++){const a=n[f++],d=n[f++],y=n[f++];let i;y>0&&(i=n.subarray(f,f+y),f+=y),D[_]={start:a,deleteCount:d,data:i}}return{id:o,type:"delta",deltas:D}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(be[56],Ee([0,1,13,10,115]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,t){return t&&(P.stack||P.stacktrace)?E.localize(0,null,k(P),F(P.stack)||F(P.stacktrace)):k(P)}function F(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?E.localize(1,null,P.message):P.message||E.localize(2,null)}function S(P=null,t=!1){if(!P)return E.localize(3,null);if(Array.isArray(P)){const b=c.coalesce(P),n=S(b[0],t);return b.length>1?E.localize(4,null,n,b.length):n}if(M.isString(P))return P;if(P.detail){const b=P.detail;if(b.error)return A(b.error,t);if(b.exception)return A(b.exception,t)}return P.stack?A(P,t):P.message?P.message:E.localize(5,null)}e.toErrorMessage=S}),define(be[116],Ee([18,19]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,25,118]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class k{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,me){this._values[J]=me}}e.ValidatedEditorOptions=k;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class P{constructor(J,me,He,Ye){this.id=J,this.name=me,this.defaultValue=He,this.schema=Ye}compute(J,me,He){return He}}class t{constructor(J,me=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(J){return this.defaultValue}}class b{constructor(J,me,He,Ye){this.id=J,this.name=me,this.defaultValue=He,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,me,He){return He}}function n(z,J){return typeof z=="undefined"?J:z==="false"?!1:Boolean(z)}e.boolean=n;class f extends b{constructor(J,me,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=He),super(J,me,He,Ye)}validate(J){return n(J,this.defaultValue)}}function o(z,J,me,He){if(typeof z=="undefined")return J;let Ye=parseInt(z,10);return isNaN(Ye)?J:(Ye=Math.max(me,Ye),Ye=Math.min(He,Ye),Ye|0)}e.clampedInt=o;class l extends b{constructor(J,me,He,Ye,st,ot=void 0){typeof ot!="undefined"&&(ot.type="integer",ot.default=He,ot.minimum=Ye,ot.maximum=st),super(J,me,He,ot),this.minimum=Ye,this.maximum=st}static clampedInt(J,me,He,Ye){return o(J,me,He,Ye)}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class w extends b{constructor(J,me,He,Ye,st){typeof st!="undefined"&&(st.type="number",st.default=He),super(J,me,He,st),this.validationFn=Ye}static clamp(J,me,He){return J<me?me:J>He?He:J}static float(J,me){if(typeof J=="number")return J;if(typeof J=="undefined")return me;const He=parseFloat(J);return isNaN(He)?me:He}validate(J){return this.validationFn(w.float(J,this.defaultValue))}}class D extends b{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=He),super(J,me,He,Ye)}validate(J){return D.string(J,this.defaultValue)}}function _(z,J,me){return typeof z!="string"||me.indexOf(z)===-1?J:z}e.stringSet=_;class a extends b{constructor(J,me,He,Ye,st=void 0){typeof st!="undefined"&&(st.type="string",st.enum=Ye,st.default=He),super(J,me,He,st),this._allowedValues=Ye}validate(J){return _(J,this.defaultValue,this._allowedValues)}}class d extends P{constructor(J,me,He,Ye,st,ot,Et=void 0){typeof Et!="undefined"&&(Et.type="string",Et.enum=st,Et.default=Ye),super(J,me,He,Et),this._allowedValues=st,this._convert=ot}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function y(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,He){return He===0?J.accessibilitySupport:He}}class v extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(z){switch(z){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function p(z){switch(z){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class I extends t{constructor(){super(127,[66,33])}compute(J,me,He){const Ye=["monaco-editor"];return me.get(33)&&Ye.push(me.get(33)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),me.get(66)==="default"?Ye.push("mouse-default"):me.get(66)==="copy"&&Ye.push("mouse-copy"),me.get(100)&&Ye.push("showUnused"),me.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class T extends f{constructor(){super(32,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,me,He){return He&&J.emptySelectionClipboard}}class g extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":_(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":_(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class C extends P{constructor(){super(44,"fontLigatures",C.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?C.OFF:J==="true"?C.ON:J:Boolean(J)?C.ON:C.OFF}}e.EditorFontLigatures=C,C.OFF='"liga" off, "calt" off',C.ON='"liga" on, "calt" on';class m extends t{constructor(){super(43)}compute(J,me,He){return J.fontInfo}}class R extends b{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let me=w.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:w.clamp(me,6,100)}compute(J,me,He){return J.fontInfo.fontSize}}class L extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class V extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:He,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:He,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:He,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:He,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:He,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:_(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??_(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??_(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??_(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??_(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??_(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(53,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:l.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky)}}}var U;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class K extends t{constructor(){super(130,[49,58,37,65,92,60,61,94,117,120,121,122,2])}compute(J,me,He){return K.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,He=J.scrollBeyondLastLine?me-1:0,Ye=(J.viewLineCount+He)/(J.pixelRatio*J.height),st=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:He,desiredRatio:Ye,minimapLineCount:st}}static _computeMinimapLayout(J,me){const He=J.outerWidth,Ye=J.outerHeight,st=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const ot=me.stableMinimapLayoutInput,Et=ot&&J.outerHeight===ot.outerHeight&&J.lineHeight===ot.lineHeight&&J.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&J.pixelRatio===ot.pixelRatio&&J.scrollBeyondLastLine===ot.scrollBeyondLastLine&&J.minimap.enabled===ot.minimap.enabled&&J.minimap.side===ot.minimap.side&&J.minimap.size===ot.minimap.size&&J.minimap.showSlider===ot.minimap.showSlider&&J.minimap.renderCharacters===ot.minimap.renderCharacters&&J.minimap.maxColumn===ot.minimap.maxColumn&&J.minimap.scale===ot.minimap.scale&&J.verticalScrollbarWidth===ot.verticalScrollbarWidth&&J.isViewportWrapping===ot.isViewportWrapping,ft=J.lineHeight,Dt=J.typicalHalfwidthCharacterWidth,Pt=J.scrollBeyondLastLine,It=J.minimap.renderCharacters;let Xe=st>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const yt=J.minimap.maxColumn,Te=J.minimap.size,ye=J.minimap.side,Ce=J.verticalScrollbarWidth,ee=J.viewLineCount,le=J.remainingWidth,ge=J.isViewportWrapping,fe=It?2:3;let Pe=Math.floor(st*Ye);const xe=Pe/st;let Oe=!1,Ke=!1,tt=fe*Xe,Le=Xe/st,de=1;if(Te==="fill"||Te==="fit"){const{typicalViewportLineCount:Ue,extraLinesBeyondLastLine:ct,desiredRatio:pt,minimapLineCount:lt}=K.computeContainedMinimapLineCount({viewLineCount:ee,scrollBeyondLastLine:Pt,height:Ye,lineHeight:ft,pixelRatio:st});if(ee/lt>1)Oe=!0,Ke=!0,Xe=1,tt=1,Le=Xe/st;else{let ut=!1,bt=Xe+1;if(Te==="fit"){const gt=Math.ceil((ee+ct)*tt);ge&&Et&&le<=me.stableFitRemainingWidth?(ut=!0,bt=me.stableFitMaxMinimapScale):ut=gt>Pe}if(Te==="fill"||ut){Oe=!0;const gt=Xe;tt=Math.min(ft*st,Math.max(1,Math.floor(1/pt))),ge&&Et&&le<=me.stableFitRemainingWidth&&(bt=me.stableFitMaxMinimapScale),Xe=Math.min(bt,Math.max(1,Math.floor(tt/fe))),Xe>gt&&(de=Math.min(2,Xe/gt)),Le=Xe/st/de,Pe=Math.ceil(Math.max(Ue,ee+ct)*tt),ge?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=le,me.stableFitMaxMinimapScale=Xe):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(yt*Le),Y=Math.min(pe,Math.max(0,Math.floor((le-Ce-2)*Le/(Dt+Le)))+e.MINIMAP_GUTTER_WIDTH);let W=Math.floor(st*Y);const we=W/st;W=Math.floor(W*de);const Ie=It?1:2,Je=ye==="left"?0:He-Y-Ce;return{renderMinimap:Ie,minimapLeft:Je,minimapWidth:Y,minimapHeightIsEditorHeight:Oe,minimapIsSampling:Ke,minimapScale:Xe,minimapLineHeight:tt,minimapCanvasInnerWidth:W,minimapCanvasInnerHeight:Pe,minimapCanvasOuterWidth:we,minimapCanvasOuterHeight:xe}}static computeLayout(J,me){const He=me.outerWidth|0,Ye=me.outerHeight|0,st=me.lineHeight|0,ot=me.lineNumbersDigitCount|0,Et=me.typicalHalfwidthCharacterWidth,ft=me.maxDigitWidth,Dt=me.pixelRatio,Pt=me.viewLineCount,It=J.get(122),Xe=It==="inherit"?J.get(121):It,yt=Xe==="inherit"?J.get(117):Xe,Te=J.get(120),ye=J.get(2),Ce=me.isDominatedByLongLines,ee=J.get(49),le=J.get(60).renderType!==0,ge=J.get(61),fe=J.get(94),Pe=J.get(65),xe=J.get(92),Oe=xe.verticalScrollbarSize,Ke=xe.verticalHasArrows,tt=xe.arrowSize,Le=xe.horizontalScrollbarSize,de=J.get(58),pe=J.get(37);let Y;if(typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)){const Ft=parseFloat(de.substr(0,de.length-2));Y=l.clampedInt(Ft*Et,0,0,1e3)}else Y=l.clampedInt(de,0,0,1e3);pe&&(Y+=16);let W=0;if(le){const Ft=Math.max(ot,ge);W=Math.round(Ft*ft)}let we=0;ee&&(we=st);let Ie=ee?J.get(50)??0:0,Je=0,Ue=Je+we+Ie,ct=Ue+W,pt=ct+Y;const lt=He-we-W-Y-Ie;let mt=!1,ut=!1,bt=-1;ye!==2&&(Xe==="inherit"&&Ce?(mt=!0,ut=!0):yt==="on"||yt==="bounded"?ut=!0:yt==="wordWrapColumn"&&(bt=Te));const gt=K._computeMinimapLayout({outerWidth:He,outerHeight:Ye,lineHeight:st,typicalHalfwidthCharacterWidth:Et,pixelRatio:Dt,scrollBeyondLastLine:fe,minimap:Pe,verticalScrollbarWidth:Oe,viewLineCount:Pt,remainingWidth:lt,isViewportWrapping:ut},me.memory||new S);gt.renderMinimap!==0&&gt.minimapLeft===0&&(Je+=gt.minimapWidth,Ue+=gt.minimapWidth,ct+=gt.minimapWidth,pt+=gt.minimapWidth);const $t=lt-gt.minimapWidth,Vt=Math.max(1,Math.floor(($t-Oe-2)/Et)),St=Ke?tt:0;return ut&&(bt=Math.max(1,Vt),yt==="bounded"&&(bt=Math.min(bt,Te))),{width:He,height:Ye,glyphMarginLeft:Je,glyphMarginWidth:we,lineNumbersLeft:Ue,lineNumbersWidth:W,decorationsLeft:ct,decorationsWidth:Y,contentLeft:pt,contentWidth:$t,minimap:gt,viewportColumn:Vt,isWordWrapMinified:mt,isViewportWrapping:ut,wrappingColumn:bt,verticalScrollbarWidth:Oe,horizontalScrollbarHeight:Le,overviewRuler:{top:St,width:Oe,height:Ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=K;class $ extends P{constructor(){const J={enabled:!0};super(57,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class B extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(me.fontFamily,this.defaultValue.fontFamily)}}}class H extends w{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>w.clamp(J,0,150),{markdownDescription:c.localize(46,null)})}compute(J,me,He){return J.fontInfo.lineHeight}}class Q extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(48,null),c.localize(49,null),c.localize(50,null)],default:J.size,description:c.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),size:_(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:_(me.side,this.defaultValue.side,["right","left"]),showSlider:_(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(me.scale,1,1,3),maxColumn:l.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(z){return z==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ue extends P{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:l.clampedInt(me.top,0,0,1e3),bottom:l.clampedInt(me.bottom,0,0,1e3)}}}class Z extends P{constructor(){const J={enabled:!0,cycle:!1};super(76,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class oe extends t{constructor(){super(128)}compute(J,me,He){return J.pixelRatio}}class ve extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(61,null)},comments:{type:"boolean",default:J.comments,description:c.localize(62,null)},other:{type:"boolean",default:J.other,description:c.localize(63,null)}}}],default:J,description:c.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const me=J,He={other:n(me.other,this.defaultValue.other),comments:n(me.comments,this.defaultValue.comments),strings:n(me.strings,this.defaultValue.strings)};return He.other&&He.comments&&He.strings?!0:!He.other&&!He.comments&&!He.strings?!1:He}return this.defaultValue}}var Ae;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends P{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(65,null),c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:"on",description:c.localize(69,null)})}validate(J){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(me=4,He=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function Ne(z){const J=z.get(87);return J==="editable"?z.get(81):J!=="on"}e.filterValidationDecorations=Ne;class We extends P{constructor(){const J=[],me={type:"number",description:c.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:c.localize(71,null),format:"color-hex"}}}]},default:J,description:c.localize(72,null)})}validate(J){if(Array.isArray(J)){let me=[];for(let He of J)if(typeof He=="number")me.push({column:l.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ye=He;me.push({column:l.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return me.sort((He,Ye)=>He.column-Ye.column),me}return this.defaultValue}}function je(z,J){if(typeof z!="string")return J;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)],default:"auto",description:c.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)],default:"auto",description:c.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,He=l.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=l.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(me.vertical,this.defaultValue.vertical),horizontal:je(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:l.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:l.clampedInt(me.verticalSliderSize,Ye,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}class x extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:_(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class G extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(85,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class te extends P{constructor(){const J={bracketPairs:!1,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:"boolean",default:J.bracketPairs,description:c.localize(86,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:c.localize(87,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:c.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{bracketPairs:n(me.bracketPairs,this.defaultValue.bracketPairs),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}class ae extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(89,null),c.localize(90,null)],default:J.insertMode,description:c.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(98,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(99,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(100,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(101,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(102,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(103,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(104,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(105,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(106,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(107,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(108,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(109,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(110,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:_(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:_(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class j extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(131,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class se extends t{constructor(){super(129,[81])}compute(J,me,He){return me.get(81)?!0:J.tabFocusMode}}var he;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(he=e.WrappingIndent||(e.WrappingIndent={}));function Re(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends t{constructor(){super(131,[130])}compute(J,me,He){const Ye=me.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const ze="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",it="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?Qe:M.isLinux?it:ze,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ke(z){return e.editorOptionsRegistry[z.id]=z,z}var Ze;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.bracketPairColorization=12]="bracketPairColorization",z[z.guides=13]="guides",z[z.codeLens=14]="codeLens",z[z.codeLensFontFamily=15]="codeLensFontFamily",z[z.codeLensFontSize=16]="codeLensFontSize",z[z.colorDecorators=17]="colorDecorators",z[z.columnSelection=18]="columnSelection",z[z.comments=19]="comments",z[z.contextmenu=20]="contextmenu",z[z.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",z[z.cursorBlinking=22]="cursorBlinking",z[z.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",z[z.cursorStyle=24]="cursorStyle",z[z.cursorSurroundingLines=25]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",z[z.cursorWidth=27]="cursorWidth",z[z.disableLayerHinting=28]="disableLayerHinting",z[z.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",z[z.domReadOnly=30]="domReadOnly",z[z.dragAndDrop=31]="dragAndDrop",z[z.emptySelectionClipboard=32]="emptySelectionClipboard",z[z.extraEditorClassName=33]="extraEditorClassName",z[z.fastScrollSensitivity=34]="fastScrollSensitivity",z[z.find=35]="find",z[z.fixedOverflowWidgets=36]="fixedOverflowWidgets",z[z.folding=37]="folding",z[z.foldingStrategy=38]="foldingStrategy",z[z.foldingHighlight=39]="foldingHighlight",z[z.foldingImportsByDefault=40]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=42]="fontFamily",z[z.fontInfo=43]="fontInfo",z[z.fontLigatures=44]="fontLigatures",z[z.fontSize=45]="fontSize",z[z.fontWeight=46]="fontWeight",z[z.formatOnPaste=47]="formatOnPaste",z[z.formatOnType=48]="formatOnType",z[z.glyphMargin=49]="glyphMargin",z[z.glyphMarginRightPadding=50]="glyphMarginRightPadding",z[z.gotoLocation=51]="gotoLocation",z[z.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",z[z.hover=53]="hover",z[z.inDiffEditor=54]="inDiffEditor",z[z.inlineSuggest=55]="inlineSuggest",z[z.letterSpacing=56]="letterSpacing",z[z.lightbulb=57]="lightbulb",z[z.lineDecorationsWidth=58]="lineDecorationsWidth",z[z.lineHeight=59]="lineHeight",z[z.lineNumbers=60]="lineNumbers",z[z.lineNumbersMinChars=61]="lineNumbersMinChars",z[z.linkedEditing=62]="linkedEditing",z[z.links=63]="links",z[z.matchBrackets=64]="matchBrackets",z[z.minimap=65]="minimap",z[z.mouseStyle=66]="mouseStyle",z[z.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=68]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",z[z.multiCursorModifier=70]="multiCursorModifier",z[z.multiCursorPaste=71]="multiCursorPaste",z[z.occurrencesHighlight=72]="occurrencesHighlight",z[z.overviewRulerBorder=73]="overviewRulerBorder",z[z.overviewRulerLanes=74]="overviewRulerLanes",z[z.padding=75]="padding",z[z.parameterHints=76]="parameterHints",z[z.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",z[z.quickSuggestions=79]="quickSuggestions",z[z.quickSuggestionsDelay=80]="quickSuggestionsDelay",z[z.readOnly=81]="readOnly",z[z.renameOnType=82]="renameOnType",z[z.renderControlCharacters=83]="renderControlCharacters",z[z.renderFinalNewline=84]="renderFinalNewline",z[z.renderLineHighlight=85]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=87]="renderValidationDecorations",z[z.renderWhitespace=88]="renderWhitespace",z[z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",z[z.roundedSelection=90]="roundedSelection",z[z.rulers=91]="rulers",z[z.scrollbar=92]="scrollbar",z[z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=94]="scrollBeyondLastLine",z[z.scrollPredominantAxis=95]="scrollPredominantAxis",z[z.selectionClipboard=96]="selectionClipboard",z[z.selectionHighlight=97]="selectionHighlight",z[z.selectOnLineNumbers=98]="selectOnLineNumbers",z[z.showFoldingControls=99]="showFoldingControls",z[z.showUnused=100]="showUnused",z[z.snippetSuggestions=101]="snippetSuggestions",z[z.smartSelect=102]="smartSelect",z[z.smoothScrolling=103]="smoothScrolling",z[z.stickyTabStops=104]="stickyTabStops",z[z.stopRenderingLineAfter=105]="stopRenderingLineAfter",z[z.suggest=106]="suggest",z[z.suggestFontSize=107]="suggestFontSize",z[z.suggestLineHeight=108]="suggestLineHeight",z[z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",z[z.suggestSelection=110]="suggestSelection",z[z.tabCompletion=111]="tabCompletion",z[z.tabIndex=112]="tabIndex",z[z.unusualLineTerminators=113]="unusualLineTerminators",z[z.useShadowDOM=114]="useShadowDOM",z[z.useTabStops=115]="useTabStops",z[z.wordSeparators=116]="wordSeparators",z[z.wordWrap=117]="wordWrap",z[z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=120]="wordWrapColumn",z[z.wordWrapOverride1=121]="wordWrapOverride1",z[z.wordWrapOverride2=122]="wordWrapOverride2",z[z.wrappingIndent=123]="wrappingIndent",z[z.wrappingStrategy=124]="wrappingStrategy",z[z.showDeprecated=125]="showDeprecated",z[z.inlayHints=126]="inlayHints",z[z.editorClassName=127]="editorClassName",z[z.pixelRatio=128]="pixelRatio",z[z.tabFocusMode=129]="tabFocusMode",z[z.layoutInfo=130]="layoutInfo",z[z.wrappingInfo=131]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(132,null)})),acceptSuggestionOnEnter:ke(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(133,null),""],markdownDescription:c.localize(134,null)})),accessibilitySupport:ke(new i),accessibilityPageSize:ke(new l(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(135,null)})),ariaLabel:ke(new D(4,"ariaLabel",c.localize(136,null))),autoClosingBrackets:ke(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(137,null),c.localize(138,null),""],description:c.localize(139,null)})),autoClosingDelete:ke(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(140,null),""],description:c.localize(141,null)})),autoClosingOvertype:ke(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(142,null),""],description:c.localize(143,null)})),autoClosingQuotes:ke(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(144,null),c.localize(145,null),""],description:c.localize(146,null)})),autoIndent:ke(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(147,null),c.localize(148,null),c.localize(149,null),c.localize(150,null),c.localize(151,null)],description:c.localize(152,null)})),automaticLayout:ke(new f(10,"automaticLayout",!1)),autoSurround:ke(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(153,null),c.localize(154,null),c.localize(155,null),""],description:c.localize(156,null)})),bracketPairColorization:ke(new G),bracketPairGuides:ke(new te),stickyTabStops:ke(new f(104,"stickyTabStops",!1,{description:c.localize(157,null)})),codeLens:ke(new f(14,"codeLens",!0,{description:c.localize(158,null)})),codeLensFontFamily:ke(new D(15,"codeLensFontFamily","",{description:c.localize(159,null)})),codeLensFontSize:ke(new l(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(160,null)})),colorDecorators:ke(new f(17,"colorDecorators",!0,{description:c.localize(161,null)})),columnSelection:ke(new f(18,"columnSelection",!1,{description:c.localize(162,null)})),comments:ke(new v),contextmenu:ke(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new f(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(163,null)})),cursorBlinking:ke(new d(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:c.localize(164,null)})),cursorSmoothCaretAnimation:ke(new f(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(165,null)})),cursorStyle:ke(new d(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:c.localize(166,null)})),cursorSurroundingLines:ke(new l(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(167,null)})),cursorSurroundingLinesStyle:ke(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(168,null),c.localize(169,null)],description:c.localize(170,null)})),cursorWidth:ke(new l(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(171,null)})),disableLayerHinting:ke(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new f(30,"domReadOnly",!1)),dragAndDrop:ke(new f(31,"dragAndDrop",!0,{description:c.localize(172,null)})),emptySelectionClipboard:ke(new T),extraEditorClassName:ke(new D(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new w(34,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:c.localize(173,null)})),find:ke(new g),fixedOverflowWidgets:ke(new f(36,"fixedOverflowWidgets",!1)),folding:ke(new f(37,"folding",!0,{description:c.localize(174,null)})),foldingStrategy:ke(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(175,null),c.localize(176,null)],description:c.localize(177,null)})),foldingHighlight:ke(new f(39,"foldingHighlight",!0,{description:c.localize(178,null)})),foldingImportsByDefault:ke(new f(40,"foldingImportsByDefault",!1,{description:c.localize(179,null)})),unfoldOnClickAfterEndOfLine:ke(new f(41,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(180,null)})),fontFamily:ke(new D(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(181,null)})),fontInfo:ke(new m),fontLigatures2:ke(new C),fontSize:ke(new R),fontWeight:ke(new L),formatOnPaste:ke(new f(47,"formatOnPaste",!1,{description:c.localize(182,null)})),formatOnType:ke(new f(48,"formatOnType",!1,{description:c.localize(183,null)})),glyphMargin:ke(new f(49,"glyphMargin",!0,{description:c.localize(184,null)})),glyphMarginRightPadding:ke(new l(50,"glyphMarginRightPadding",0,0,1e3,{description:c.localize(185,null)})),gotoLocation:ke(new V),hideCursorInOverviewRuler:ke(new f(52,"hideCursorInOverviewRuler",!1,{description:c.localize(186,null)})),hover:ke(new q),inDiffEditor:ke(new f(54,"inDiffEditor",!1)),letterSpacing:ke(new w(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>w.clamp(z,-5,20),{description:c.localize(187,null)})),lightbulb:ke(new $),lineDecorationsWidth:ke(new b(58,"lineDecorationsWidth",10)),lineHeight:ke(new H),lineNumbers:ke(new Se),lineNumbersMinChars:ke(new l(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new f(62,"linkedEditing",!1,{description:c.localize(188,null)})),links:ke(new f(63,"links",!0,{description:c.localize(189,null)})),matchBrackets:ke(new a(64,"matchBrackets","always",["always","near","never"],{description:c.localize(190,null)})),minimap:ke(new Q),mouseStyle:ke(new a(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new w(67,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:c.localize(191,null)})),mouseWheelZoom:ke(new f(68,"mouseWheelZoom",!1,{markdownDescription:c.localize(192,null)})),multiCursorMergeOverlapping:ke(new f(69,"multiCursorMergeOverlapping",!0,{description:c.localize(193,null)})),multiCursorModifier:ke(new d(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[c.localize(194,null),c.localize(195,null)],markdownDescription:c.localize(196,null)})),multiCursorPaste:ke(new a(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(197,null),c.localize(198,null)],markdownDescription:c.localize(199,null)})),occurrencesHighlight:ke(new f(72,"occurrencesHighlight",!0,{description:c.localize(200,null)})),overviewRulerBorder:ke(new f(73,"overviewRulerBorder",!0,{description:c.localize(201,null)})),overviewRulerLanes:ke(new l(74,"overviewRulerLanes",3,0,3)),padding:ke(new ue),parameterHints:ke(new Z),peekWidgetDefaultFocus:ke(new a(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(202,null),c.localize(203,null)],description:c.localize(204,null)})),definitionLinkOpensInPeek:ke(new f(78,"definitionLinkOpensInPeek",!1,{description:c.localize(205,null)})),quickSuggestions:ke(new ve),quickSuggestionsDelay:ke(new l(80,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(206,null)})),readOnly:ke(new f(81,"readOnly",!1)),renameOnType:ke(new f(82,"renameOnType",!1,{description:c.localize(207,null),markdownDeprecationMessage:c.localize(208,null)})),renderControlCharacters:ke(new f(83,"renderControlCharacters",!1,{description:c.localize(209,null)})),renderFinalNewline:ke(new f(84,"renderFinalNewline",!0,{description:c.localize(210,null)})),renderLineHighlight:ke(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(211,null)],description:c.localize(212,null)})),renderLineHighlightOnlyWhenFocus:ke(new f(86,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(213,null)})),renderValidationDecorations:ke(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(214,null),c.localize(215,null),c.localize(216,null),""],description:c.localize(217,null)})),revealHorizontalRightPadding:ke(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new f(90,"roundedSelection",!0,{description:c.localize(218,null)})),rulers:ke(new We),scrollbar:ke(new qe),scrollBeyondLastColumn:ke(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(219,null)})),scrollBeyondLastLine:ke(new f(94,"scrollBeyondLastLine",!0,{description:c.localize(220,null)})),scrollPredominantAxis:ke(new f(95,"scrollPredominantAxis",!0,{description:c.localize(221,null)})),selectionClipboard:ke(new f(96,"selectionClipboard",!0,{description:c.localize(222,null),included:M.isLinux})),selectionHighlight:ke(new f(97,"selectionHighlight",!0,{description:c.localize(223,null)})),selectOnLineNumbers:ke(new f(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(224,null),c.localize(225,null)],description:c.localize(226,null)})),showUnused:ke(new f(100,"showUnused",!0,{description:c.localize(227,null)})),showDeprecated:ke(new f(125,"showDeprecated",!0,{description:c.localize(228,null)})),inlayHints:ke(new B),snippetSuggestions:ke(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(229,null),c.localize(230,null),c.localize(231,null),c.localize(232,null)],description:c.localize(233,null)})),smartSelect:ke(new j),smoothScrolling:ke(new f(103,"smoothScrolling",!1,{description:c.localize(234,null)})),stopRenderingLineAfter:ke(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new ae),inlineSuggest:ke(new x),suggestFontSize:ke(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(235,null)})),suggestLineHeight:ke(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(236,null)})),suggestOnTriggerCharacters:ke(new f(109,"suggestOnTriggerCharacters",!0,{description:c.localize(237,null)})),suggestSelection:ke(new a(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(238,null),c.localize(239,null),c.localize(240,null)],description:c.localize(241,null)})),tabCompletion:ke(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(242,null),c.localize(243,null),c.localize(244,null)],description:c.localize(245,null)})),tabIndex:ke(new l(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ke(new a(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(246,null),c.localize(247,null),c.localize(248,null)],description:c.localize(249,null)})),useShadowDOM:ke(new f(114,"useShadowDOM",!0)),useTabStops:ke(new f(115,"useTabStops",!0,{description:c.localize(250,null)})),wordSeparators:ke(new D(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:c.localize(251,null)})),wordWrap:ke(new a(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(252,null),c.localize(253,null),c.localize(254,null),c.localize(255,null)],description:c.localize(256,null)})),wordWrapBreakAfterCharacters:ke(new D(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new D(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new l(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(257,null)})),wordWrapOverride1:ke(new a(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new a(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new d(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Re,{enumDescriptions:[c.localize(258,null),c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),wrappingStrategy:ke(new a(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],description:c.localize(265,null)})),editorClassName:ke(new I),pixelRatio:ke(new oe),tabFocusMode:ke(new se),layoutInfo:ke(new K),wrappingInfo:ke(new Be)}}),define(be[119],Ee([18,19]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function F(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(M);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=F;function k(n){if(!n)return null;let f=n.majorBase,o=n.majorMustEqual,l=n.minorBase,w=n.minorMustEqual,D=n.patchBase,_=n.patchMustEqual;n.hasCaret&&(f===0||(w=!1),_=!1);let a=0;if(n.preRelease){const d=E.exec(n.preRelease);if(d){const[,y,i,v]=d;a=Date.UTC(Number(y),Number(i)-1,Number(v))}}return{majorBase:f,majorMustEqual:o,minorBase:l,minorMustEqual:w,patchBase:D,patchMustEqual:_,isMinimum:n.hasGreaterEquals,notBefore:a}}e.normalizeVersion=k;function S(n,f,o){let l;typeof n=="string"?l=k(F(n)):l=n;let w;f instanceof Date?w=f.getTime():typeof f=="string"&&(w=new Date(f).getTime());let D;if(typeof o=="string"?D=k(F(o)):D=o,!l||!D)return!1;let _=l.majorBase,a=l.minorBase,d=l.patchBase,y=D.majorBase,i=D.minorBase,v=D.patchBase,r=D.notBefore,s=D.majorMustEqual,u=D.minorMustEqual,h=D.patchMustEqual;return D.isMinimum?_>y?!0:_<y?!1:a>i?!0:a<i||w&&w<r?!1:d>=v:(_===1&&y===0&&(!s||!u||!h)&&(y=1,i=0,v=0,s=!0,u=!1,h=!1),_<y?!1:_>y?!s:a<i?!1:a>i?!u:d<v?!1:d>v?!h:!(w&&w<r))}e.isValidVersion=S;function P(n,f,o,l){return o.isBuiltin||typeof o.main=="undefined"?!0:b(n,f,o.engines.vscode,l)}e.isValidExtensionVersion=P;function t(n,f,o){return n==="*"||b(f,o,n)}e.isEngineValid=t;function b(n,f,o,l=[]){let w=k(F(o));if(!w)return l.push(c.localize(0,null,o)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return l.push(c.localize(1,null,o)),!1}else if(!w.majorMustEqual)return l.push(c.localize(2,null,o)),!1;return S(n,f,w)?!0:(l.push(c.localize(3,null,n,o)),!1)}}),define(be[81],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(E,A=[],F=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=c}),define(be[57],Ee([0,1,81]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(F,k,S){k instanceof c.SyncDescriptor||(k=new c.SyncDescriptor(k,[],S)),M.push([F,k])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[139],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=c;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const k=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(F);k.outgoing.set(this._hashFn(F),S),S.incoming.set(this._hashFn(A),k)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let k of this._nodes.values())k.outgoing.delete(F),k.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let k=this._nodes.get(F);return k||(k=new c(A),this._nodes.set(F,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,k]of this._nodes)A.push(`${F}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const k=new Set([A]),S=this._findCycle(F,k);if(S)return S}}_findCycle(A,F){for(let[k,S]of A.outgoing){if(F.has(k))return[...F,k].join(" -> ");F.add(k);const P=this._findCycle(S,F);if(P)return P;F.delete(k)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function S(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=S})(c=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(k,S,P,t){S[c.DI_TARGET]===S?S[c.DI_DEPENDENCIES].push({id:k,index:P,optional:t}):(S[c.DI_DEPENDENCIES]=[{id:k,index:P,optional:t}],S[c.DI_TARGET]=S)}function E(k){if(c.serviceIds.has(k))return c.serviceIds.get(k);const S=function(P,t,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(S,P,b,!1)};return S.toString=()=>k,c.serviceIds.set(k,S),S}e.createDecorator=E;function A(k){return k}e.refineServiceDecorator=A;function F(k){return function(S,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(k,S,t,!0)}}e.optional=F}),define(be[140],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,75,55,140]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(P):!!l.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(w,D){let _={selector:w,provider:D,_score:-1,_time:this._clock++};return this._entries.push(_),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(_){let a=this._entries.indexOf(_);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),_=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const D=[];for(let _ of this._entries)_._score>0&&D.push(_.provider);return D}ordered(w){const D=[];return this._orderedForEach(w,_=>D.push(_.provider)),D}orderedGroups(w){const D=[];let _,a;return this._orderedForEach(w,d=>{_&&a===d._score?_.push(d.provider):(a=d._score,_=[d.provider],D.push(_))}),D}_orderedForEach(w,D){if(!!w){this._updateScores(w);for(const _ of this._entries)_._score>0&&D(_)}}_updateScores(w){let D={uri:w.uri.toString(),language:w.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let _ of this._entries)if(_._score=(0,k.score)(_.selector,w.uri,w.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(w)),P(_.selector)&&_._score>0){for(let a of this._entries)a._score=0;_._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(w,D){return w._score<D._score?1:w._score>D._score?-1:w._time<D._time?1:w._time>D._time?-1:0}}e.LanguageFeatureRegistry=t;const b=new WeakMap;let n=0;function f(l){let w=b.get(l);return w===void 0&&(w=++n,b.set(l,w)),w}class o{constructor(w,D,_=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=D,this.max=_,this._cache=new A.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((D,_)=>(0,M.doHash)(f(_),D),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const D=this._key(w),_=this._cache.get(D);return this._clamp(_?.value)}update(w,D){const _=this._key(w);let a=this._cache.get(_);return a||(a=new F.MovingAverage,this._cache.set(_,a)),a.update(D),this.get(w)}}e.LanguageFeatureRequestDelays=o}),define(be[59],Ee([0,1,2,44,141,114,34]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class S{constructor(C,m){this.language=C,this.id=m}}e.LanguageIdentifier=S;var P;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var b;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(b=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(C){return(C&255)>>>0}static getTokenType(C){return(C&1792)>>>8}static getFontStyle(C){return(C&14336)>>>11}static getForeground(C){return(C&8372224)>>>14}static getBackground(C){return(C&4286578688)>>>23}static getClassNameFromMetadata(C){let m=this.getForeground(C),R="mtk"+m,L=this.getFontStyle(C);return L&1&&(R+=" mtki"),L&2&&(R+=" mtkb"),L&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(C,m){const R=this.getForeground(C),L=this.getFontStyle(C);let V=`color: ${m[R]};`;return L&1&&(V+="font-style: italic;"),L&2&&(V+="font-weight: bold;"),L&4&&(V+="text-decoration: underline;"),V}}e.TokenMetadata=f;var o;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(C){const m=g[C];let R=m&&F.iconRegistry.get(m);return R||(console.info("No codicon found for CompletionItemKind "+C),R=F.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(C,m){let R=g[C];return typeof R=="undefined"&&!m&&(R=9),R}}();var l;(function(g){g[g.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var y;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(y=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&c.URI.isUri(g.uri)&&M.Range.isIRange(g.range)&&(M.Range.isIRange(g.originSelectionRange)||M.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var v;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(g){const C=new Map;C.set("file",0),C.set("module",1),C.set("namespace",2),C.set("package",3),C.set("class",4),C.set("method",5),C.set("property",6),C.set("field",7),C.set("constructor",8),C.set("enum",9),C.set("interface",10),C.set("function",11),C.set("variable",12),C.set("constant",13),C.set("string",14),C.set("number",15),C.set("boolean",16),C.set("array",17),C.set("object",18),C.set("key",19),C.set("null",20),C.set("enum-member",21),C.set("struct",22),C.set("event",23),C.set("operator",24),C.set("type-parameter",25);const m=new Map;m.set(0,"file"),m.set(1,"module"),m.set(2,"namespace"),m.set(3,"package"),m.set(4,"class"),m.set(5,"method"),m.set(6,"property"),m.set(7,"field"),m.set(8,"constructor"),m.set(9,"enum"),m.set(10,"interface"),m.set(11,"function"),m.set(12,"variable"),m.set(13,"constant"),m.set(14,"string"),m.set(15,"number"),m.set(16,"boolean"),m.set(17,"array"),m.set(18,"object"),m.set(19,"key"),m.set(20,"null"),m.set(21,"enum-member"),m.set(22,"struct"),m.set(23,"event"),m.set(24,"operator"),m.set(25,"type-parameter");function R(q){return C.get(q)}g.fromString=R;function L(q){return m.get(q)}g.toString=L;function V(q,U){const K=m.get(q);let $=K&&F.iconRegistry.get("symbol-"+K);return $||(console.info("No codicon found for SymbolKind "+q),$=F.Codicon.symbolProperty),`${U?"inline":"block"} ${$.classNames}`}g.toCssClassName=V})(s=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(C){this.value=C}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var h;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var I;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(I=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var T;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,25,9,4]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=c.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",c.isMacintosh),F.set("isLinux",c.isLinux),F.set("isWindows",c.isWindows),F.set("isWeb",c.isWeb),F.set("isMacNative",c.isMacintosh&&!c.isWeb),F.set("isEdge",A.indexOf("Edg/")>=0),F.set("isFirefox",A.indexOf("Firefox")>=0),F.set("isChrome",A.indexOf("Chrome")>=0),F.set("isSafari",A.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var S;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return b.INSTANCE}static true(){return n.INSTANCE}static has(m){return f.create(m)}static equals(m,R){return o.create(m,R)}static notEquals(m,R){return D.create(m,R)}static regex(m,R){return v.create(m,R)}static in(m,R){return l.create(m,R)}static not(m){return _.create(m)}static and(...m){return s.create(m,null)}static or(...m){return u.create(m,null,!0)}static greater(m,R){return a.create(m,R)}static less(m,R){return y.create(m,R)}static deserialize(m,R=!1){if(!!m)return this._deserializeOrExpression(m,R)}static _deserializeOrExpression(m,R){let L=m.split("||");return u.create(L.map(V=>this._deserializeAndExpression(V,R)),null,!0)}static _deserializeAndExpression(m,R){let L=m.split("&&");return s.create(L.map(V=>this._deserializeOne(V,R)),null)}static _deserializeOne(m,R){if(m=m.trim(),m.indexOf("!=")>=0){let L=m.split("!=");return D.create(L[0].trim(),this._deserializeValue(L[1],R))}if(m.indexOf("==")>=0){let L=m.split("==");return o.create(L[0].trim(),this._deserializeValue(L[1],R))}if(m.indexOf("=~")>=0){let L=m.split("=~");return v.create(L[0].trim(),this._deserializeRegexValue(L[1],R))}if(m.indexOf(" in ")>=0){let L=m.split(" in ");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const L=m.split(">=");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const L=m.split(">");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const L=m.split("<=");return i.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const L=m.split("<");return y.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(m)?_.create(m.substr(1).trim()):f.create(m)}static _deserializeValue(m,R){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let L=/^'([^']*)'$/.exec(m);return L?L[1].trim():m}static _deserializeRegexValue(m,R){if((0,M.isFalsyOrWhitespace)(m)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=m.indexOf("/"),V=m.lastIndexOf("/");if(L===V||L<0){if(R)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let q=m.slice(L+1,V),U=m[V+1]==="i"?"i":"";try{return new RegExp(q,U)}catch(K){if(R)throw new Error(`bad regexp-value '${m}', parse error: ${K}`);return console.warn(`bad regexp-value '${m}', parse error: ${K}`),null}}}e.ContextKeyExpr=P;function t(C,m){return C.cmp(m)}class b{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class n{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class f{constructor(m,R){this.key=m,this.negated=R,this.type=2}static create(m,R=null){const L=F.get(m);return typeof L=="boolean"?L?n.INSTANCE:b.INSTANCE:new f(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class o{constructor(m,R,L){this.key=m,this.value=R,this.negated=L,this.type=4}static create(m,R,L=null){if(typeof R=="boolean")return R?f.create(m,L):_.create(m,L);const V=F.get(m);return typeof V=="boolean"?R===(V?"true":"false")?n.INSTANCE:b.INSTANCE:new o(m,R,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=o;class l{constructor(m,R){this.key=m,this.valueKey=R,this.type=10,this.negated=null}static create(m,R){return new l(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}evaluate(m){const R=m.getValue(this.valueKey),L=m.getValue(this.key);return Array.isArray(R)?R.indexOf(L)>=0:typeof L=="string"&&typeof R=="object"&&R!==null?k.call(R,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=l;class w{constructor(m){this._actual=m,this.type=11}static create(m){return new w(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new w(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class D{constructor(m,R,L){this.key=m,this.value=R,this.negated=L,this.type=5}static create(m,R,L=null){if(typeof R=="boolean")return R?_.create(m,L):f.create(m,L);const V=F.get(m);return typeof V=="boolean"?R===(V?"true":"false")?b.INSTANCE:n.INSTANCE:new D(m,R,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=D;class _{constructor(m,R){this.key=m,this.negated=R,this.type=3}static create(m,R=null){const L=F.get(m);return typeof L=="boolean"?L?b.INSTANCE:n.INSTANCE:new _(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;class a{constructor(m,R,L){this.key=m,this.value=R,this.negated=L,this.type=12}static create(m,R,L=null){return new a(m,R,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class d{constructor(m,R,L){this.key=m,this.value=R,this.negated=L,this.type=13}static create(m,R,L=null){return new d(m,R,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=d;class y{constructor(m,R,L){this.key=m,this.value=R,this.negated=L,this.type=14}static create(m,R,L=null){return new y(m,R,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=y;class i{constructor(m,R,L){this.key=m,this.value=R,this.negated=L,this.type=15}static create(m,R,L=null){return new i(m,R,L)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class v{constructor(m,R){this.key=m,this.regexp=R,this.type=7,this.negated=null}static create(m,R){return new v(m,R)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const R=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return R<L?-1:R>L?1:0}equals(m){if(m.type===this.type){const R=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return this.key===m.key&&R===L}return!1}evaluate(m){let R=m.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=v;class r{constructor(m){this._actual=m,this.type=8}static create(m){return new r(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new r(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class s{constructor(m,R){this.expr=m,this.negated=R,this.type=6}static create(m,R){return s._normalizeArr(m,R)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const V=t(this.expr[R],m.expr[R]);if(V!==0)return V}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(m.expr[R]))return!1;return!0}return!1}evaluate(m){for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].evaluate(m))return!1;return!0}static _normalizeArr(m,R){const L=[];let V=!1;for(const q of m)if(!!q){if(q.type===1){V=!0;continue}if(q.type===0)return b.INSTANCE;if(q.type===6){L.push(...q.expr);continue}L.push(q)}if(L.length===0&&V)return n.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(t);for(let q=1;q<L.length;q++)L[q-1].equals(L[q])&&(L.splice(q,1),q--);if(L.length===1)return L[0];for(;L.length>1;){const q=L[L.length-1];if(q.type!==9)break;L.pop();const U=L.pop(),K=L.length===0,$=u.create(q.expr.map(B=>s.create([B,U],null)),null,K);$&&(L.push($),L.sort(t))}return L.length===1?L[0]:new s(L,R)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let R of this.expr)m.push(...R.keys());return m}map(m){return new s(this.expr.map(R=>R.map(m)),null)}negate(){if(!this.negated){const m=[];for(let R of this.expr)m.push(R.negate());this.negated=u.create(m,this,!0)}return this.negated}}class u{constructor(m,R){this.expr=m,this.negated=R,this.type=9}static create(m,R,L){return u._normalizeArr(m,R,L)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const V=t(this.expr[R],m.expr[R]);if(V!==0)return V}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(m.expr[R]))return!1;return!0}return!1}evaluate(m){for(let R=0,L=this.expr.length;R<L;R++)if(this.expr[R].evaluate(m))return!0;return!1}static _normalizeArr(m,R,L){let V=[],q=!1;if(m){for(let U=0,K=m.length;U<K;U++){const $=m[U];if(!!$){if($.type===0){q=!0;continue}if($.type===1)return n.INSTANCE;if($.type===9){V=V.concat($.expr);continue}V.push($)}}if(V.length===0&&q)return b.INSTANCE;V.sort(t)}if(V.length!==0){if(V.length===1)return V[0];for(let U=1;U<V.length;U++)V[U-1].equals(V[U])&&(V.splice(U,1),U--);if(V.length===1)return V[0];if(L){for(let U=0;U<V.length;U++)for(let K=U+1;K<V.length;K++)T(V[U],V[K])&&(V.splice(K,1),K--);if(V.length===1)return V[0]}return new u(V,R)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let R of this.expr)m.push(...R.keys());return m}map(m){return new u(this.expr.map(R=>R.map(m)),null)}negate(){if(!this.negated){let m=[];for(let R of this.expr)m.push(R.negate());for(;m.length>1;){const R=m.shift(),L=m.shift(),V=[];for(const U of g(R))for(const K of g(L))V.push(s.create([U,K],null));const q=m.length===0;m.unshift(u.create(V,null,q))}this.negated=m[0]}return this.negated}}class h extends f{constructor(m,R,L){super(m,null);this._defaultValue=R,typeof L=="object"?h._info.push({...L,key:m}):L!==!0&&h._info.push({key:m,description:L,type:R!=null?typeof R:void 0})}static all(){return h._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return o.create(this.key,m)}notEqualsTo(m){return D.create(this.key,m)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(C,m){return C<m?-1:C>m?1:0}function I(C,m,R,L){return C<R?-1:C>R?1:m<L?-1:m>L?1:0}function T(C,m){if(m.type===6&&C.type!==9&&C.type!==6){for(const V of m.expr)if(C.equals(V))return!0}const R=C.negate(),L=g(R).concat(g(m));L.sort(t);for(let V=0;V<L.length;V++){const U=L[V].negate();for(let K=V+1;K<L.length;K++){const $=L[K];if(U.equals($))return!0}}return!1}e.implies=T;function g(C){return C.type===9?C.expr:[C]}}),define(be[142],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,9,4]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));class k{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,n){if(typeof b=="undefined"||b===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof b=="string"||typeof n=="string"){let f=typeof b=="string"?b:b.value,o=typeof n=="string"?n:n.value;return c.equalsIgnoreCase(f,o)}return b._lower===n._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=k;function S(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[143],Ee([0,1,9,26]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(o,l){return o.uuid&&l.uuid?o.uuid===l.uuid:o.id===l.id?!0:(0,c.compareIgnoreCase)(o.id,l.id)===0}e.areSameExtensions=E;class A{constructor(l,w){this.version=w,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof A?E(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=A;function F(o,l){return`${o}.${l}`}e.getExtensionId=F;function k(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(o,l){return k(F(o,l))}e.getGalleryExtensionId=S;function P(o,l){const w=[],D=_=>{for(const a of w)if(a.some(d=>E(l(d),l(_))))return a;return null};for(const _ of o){const a=D(_);a?a.push(_):w.push([_])}return w}e.groupByExtension=P;function t(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function b(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(o){const l=new Set;for(const w of o)w.malicious&&l.add(w.id.id);return l}e.getMaliciousExtensionsSet=n;function f(o,l){const w=[],D=l.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const _=D.shift();if(_&&w.every(a=>!E(a.identifier,{id:_}))){const a=o.filter(d=>E(d.identifier,{id:_}));a.length===1&&(w.push(a[0]),D.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=f}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function P(U){return U.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var n;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=f;function o(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=o;function l(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function w(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=w;var D;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(K,$){super(K);this.code=$}}e.FileSystemProviderError=_;function a(U,K){const $=new _(U.toString(),K);return y($,K),$}e.createFileSystemProviderError=a;function d(U){return U||a((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=d;function y(U,K){return U.name=K?`${K} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=y;function i(U){if(!U)return D.Unknown;if(U instanceof _)return U.code;const K=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!K)return D.Unknown;switch(K[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=i;function v(U){if(U instanceof I)return U.fileOperationResult;switch(i(U)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(K,$,B){this.resource=K,this.operation=$,this.target=B}isOperation(K){return this.operation===K}}e.FileOperationEvent=s;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class h{constructor(K,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of K)switch(B.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>$)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>$)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>$)),this.deleted.set(B.resource,B);break}}contains(K,...$){return this.doContains(K,{includeChildren:!1},...$)}affects(K,...$){return this.doContains(K,{includeChildren:!0},...$)}doContains(K,$,...B){if(!K)return!1;const H=B.length>0;return!!((!H||B.includes(1))&&(this.added?.get(K)||$.includeChildren&&this.added?.findSuperstr(K))||(!H||B.includes(0))&&(this.updated?.get(K)||$.includeChildren&&this.updated?.findSuperstr(K))||(!H||B.includes(2))&&(this.deleted?.findSubstr(K)||$.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function p(U,K,$){return!U||!K||U===K||K.length>U.length?!1:(K.charAt(K.length-1)!==M.sep&&(K+=M.sep),$?(0,E.startsWithIgnoreCase)(U,K):U.indexOf(K)===0)}e.isParent=p;class I extends Error{constructor(K,$,B){super(K);this.fileOperationResult=$,this.options=B}}e.FileOperationError=I;class T extends I{constructor(K,$,B){super(K,2,B);this.stat=$}}e.NotModifiedSinceFileOperationError=T;var g;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function m(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=m;async function R(U,K){if(!K.canHandleResource(F.URI.from({scheme:U.scheme})))return new Promise($=>{const B=K.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===U.scheme&&H.added&&(B.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(K){return(0,A.isNumber)(K)||(K=0),K<L.KB?(0,k.localize)(1,null,K.toFixed(0)):K<L.MB?(0,k.localize)(2,null,(K/L.KB).toFixed(2)):K<L.GB?(0,k.localize)(3,null,(K/L.MB).toFixed(2)):K<L.TB?(0,k.localize)(4,null,(K/L.GB).toFixed(2)):(0,k.localize)(5,null,(K/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function q(U){return{maxFileSize:U===0?300*L.MB:16*L.GB,maxHeapSize:U===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=q}),define(be[61],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...E){this._entries=new Map;for(let[A,F]of E)this.set(A,F)}set(E,A){const F=this._entries.get(E);return this._entries.set(E,A),F}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=c}),define(be[144],Ee([0,1,14,16,81,139,4,61]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class t{constructor(o=new k.ServiceCollection,l=!1,w){this._activeInstantiations=new Set,this._services=o,this._strict=l,this._parent=w,this._services.set(F.IInstantiationService,this)}createChild(o){return new t(o,this._strict,this)}invokeFunction(o,...l){let w=n.traceInvocation(o),D=!1;try{return o({get:(a,d)=>{if(D)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(a,w);if(!y&&d!==F.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return y}},...l)}finally{D=!0,w.stop()}}createInstance(o,...l){let w,D;return o instanceof E.SyncDescriptor?(w=n.traceCreation(o.ctor),D=this._createInstance(o.ctor,o.staticArguments.concat(l),w)):(w=n.traceCreation(o),D=this._createInstance(o,l,w)),w.stop(),D}_createInstance(o,l=[],w){let D=F._util.getServiceDependencies(o).sort((d,y)=>d.index-y.index),_=[];for(const d of D){let y=this._getOrCreateServiceInstance(d.id,w);if(!y&&this._strict&&!d.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${d.id}.`);_.push(y)}let a=D.length>0?D[0].index:l.length;if(l.length!==a){console.warn(`[createInstance] First service dependency of ${o.name} at position ${a+1} conflicts with ${l.length} static arguments`);let d=a-l.length;d>0?l=l.concat(new Array(d)):l=l.slice(0,a)}return new o(...[...l,..._])}_setServiceInstance(o,l){if(this._services.get(o)instanceof E.SyncDescriptor)this._services.set(o,l);else if(this._parent)this._parent._setServiceInstance(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let l=this._services.get(o);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):l}_getOrCreateServiceInstance(o,l){let w=this._getServiceInstanceOrDescriptor(o);return w instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,w,l.branch(o,!0)):(l.branch(o,!1),w)}_safeCreateAndCacheServiceInstance(o,l,w){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,l,w)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,l,w){const D=new A.Graph(d=>d.id.toString());let _=0;const a=[{id:o,desc:l,_trace:w}];for(;a.length;){const d=a.pop();if(D.lookupOrInsertNode(d),_++>1e3)throw new P(D);for(let y of F._util.getServiceDependencies(d.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(y.id);if(!i&&!y.optional&&console.warn(`[createInstance] ${o} depends on ${y.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const v={id:y.id,desc:i,_trace:d._trace.branch(y.id,!0)};D.insertEdge(d,v),a.push(v)}}}for(;;){const d=D.roots();if(d.length===0){if(!D.isEmpty())throw new P(D);break}for(const{data:y}of d){if(this._getServiceInstanceOrDescriptor(y.id)instanceof E.SyncDescriptor){const v=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,v)}D.removeNode(y)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,l,w=[],D,_){if(this._services.get(o)instanceof E.SyncDescriptor)return this._createServiceInstance(l,w,D,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,l,w,D,_);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(o,l=[],w,D){if(w){const _=new c.IdleValue(()=>this._createInstance(o,l,D));return new Proxy(Object.create(null),{get(a,d){if(d in a)return a[d];let y=_.value,i=y[d];return typeof i!="function"||(i=i.bind(y),a[d]=i),i},set(a,d,y){return _.value[d]=y,!0}})}else return this._createInstance(o,l,D)}}e.InstantiationService=t;var b;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(b||(b={}));class n{constructor(o,l){this.type=o,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return S?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return S?new n(0,o.name):n._None}branch(o,l){let w=new n(2,o.toString());return this._dep.push([o,l,w]),w}stop(){let o=Date.now()-this._start;n._totals+=o;let l=!1;function w(_,a){let d=[],y=new Array(_+1).join("	");for(const[i,v,r]of a._dep)if(v&&r){l=!0,d.push(`${y}CREATES -> ${i}`);let s=w(_+1,r);s&&d.push(s)}else d.push(`${y}uses -> ${i}`);return d.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||l)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,56,3,6,25,4]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class P extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...v){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([i,...v]))}debug(i,...v){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([i,...v]))}info(i,...v){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([i,...v]))}warn(i,...v){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([i,...v]))}error(i,...v){if(this.checkLogLevel(S.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([i,...v]))}critical(i,...v){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([i,...v]))}flush(){}format(i){let v="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}v+=(r>0?" ":"")+s}return v}}e.AbstractMessageLogger=t;class b extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...v){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...v):console.log(`[main ${k()}]`,i,...v))}debug(i,...v){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...v):console.log(`[main ${k()}]`,i,...v))}info(i,...v){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...v):console.log(`[main ${k()}]`,i,...v))}warn(i,...v){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...v):console.warn(`[main ${k()}]`,i,...v))}error(i,...v){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...v):console.error(`[main ${k()}]`,i,...v))}critical(i,...v){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...v):console.error(`[main ${k()}]`,i,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...v){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...v)}debug(i,...v){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...v)}info(i,...v){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...v)}warn(i,...v){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...v)}error(i,...v){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...v)}critical(i,...v){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...v)}dispose(){}flush(){}}e.ConsoleLogger=n;class f extends P{constructor(i,v=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(v)}trace(i,...v){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...v])}debug(i,...v){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...v])}info(i,...v){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...v])}warn(i,...v){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...v])}error(i,...v){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...v])}critical(i,...v){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...v])}extractMessage(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class o extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const v of this.logServices)v.setLevel(i);super.setLevel(i)}trace(i,...v){for(const r of this.logServices)r.trace(i,...v)}debug(i,...v){for(const r of this.logServices)r.debug(i,...v)}info(i,...v){for(const r of this.logServices)r.info(i,...v)}warn(i,...v){for(const r of this.logServices)r.warn(i,...v)}error(i,...v){for(const r of this.logServices)r.error(i,...v)}critical(i,...v){for(const r of this.logServices)r.critical(i,...v)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=o;class l extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...v){this.logger.trace(i,...v)}debug(i,...v){this.logger.debug(i,...v)}info(i,...v){this.logger.info(i,...v)}warn(i,...v){this.logger.warn(i,...v)}error(i,...v){this.logger.error(i,...v)}critical(i,...v){this.logger.critical(i,...v)}flush(){this.logger.flush()}}e.LogService=l;class w extends E.Disposable{constructor(i,v){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(v(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,v){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,v?.always?S.Trace:this.logLevel,v),this.loggers.set(i.toString(),r),v?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class D{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...v){}debug(i,...v){}info(i,...v){}warn(i,...v){}error(i,...v){}critical(i,...v){}dispose(){}flush(){}}e.NullLogService=D;function _(y){if(y.verbose)return S.Trace;if(typeof y.logLevel=="string"){const i=a(y.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function a(y){switch(y){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=a;function d(y){switch(y){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=d}),define(be[82],Ee([0,1,35,122,4]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var F;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(o,l){return l-o}S.compare=P;const t=Object.create(null);t[S.Error]=(0,M.localize)(0,null),t[S.Warning]=(0,M.localize)(1,null),t[S.Info]=(0,M.localize)(2,null);function b(o){return t[o]||""}S.toString=b;function n(o){switch(o){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=n;function f(o){switch(o){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=f}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const P="";function t(n){return b(n,!0)}S.makeKey=t;function b(n,f){let o=[P];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(P),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(P),n.severity!==void 0&&n.severity!==null?o.push(F.toString(n.severity)):o.push(P),n.message&&f?o.push(n.message.replace("\xA6","\\\xA6")):o.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(P),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(P),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(P),o.push(P),o.join("\xA6")}S.makeKeyOptionalMessage=b})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,35,4]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=S}),define(be[146],Ee([0,1,6,9,2,4]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function F(k,S){return E.URI.isUri(k)?(0,M.equalsIgnoreCase)(k.scheme,S):(0,M.startsWithIgnoreCase)(k,S+":")}e.matchesScheme=F});var $e=this&&this.__decorate||function(ne,e,c,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,c):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,c,M);else for(var k=ne.length-1;k>=0;k--)(F=ne[k])&&(A=(E<3?F(A):E>3?F(e,c,A):F(e,c))||A);return E>3&&A&&Object.defineProperty(e,c,A),A},Ve=this&&this.__param||function(ne,e){return function(c,M){e(c,M,ne)}};define(be[147],Ee([0,1,14,21,6,4]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends E.Disposable{constructor(b,n){super();this.deferred=new c.DeferredPromise,n.withProgress(b,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};S=$e([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends E.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(b){this.stop();const n=++this.currentOperationId,f=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(F,k){c.ok(M.isString(F)),c.ok(M.isObject(k)),c.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,k)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new E}),define(be[83],Ee([0,1,3,28]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,P){this.schemasById[E(S)]=P,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,13,3,10,119,83,28]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=k.Registry.as(F.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(a,d=!0){this.registerConfigurations([a],d)}registerConfigurations(a,d=!0){const y=this.doRegisterConfigurations(a,d);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterConfigurations(a){const d=this.doDeregisterConfigurations(a);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}updateConfigurations({add:a,remove:d}){const y=[];y.push(...this.doDeregisterConfigurations(d)),y.push(...this.doRegisterConfigurations(a,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,c.distinct)(y))}registerDefaultConfigurations(a){const d=[],y=[];for(const i of a)for(const v in i)if(d.push(v),e.OVERRIDE_PROPERTY_PATTERN.test(v)){this.defaultValues[v]={...this.defaultValues[v]||{},...i[v]};const r={type:"object",default:this.defaultValues[v],description:A.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId};y.push(f(v)),this.configurationProperties[v]=r,this.defaultLanguageConfigurationOverridesNode.properties[v]=r}else{this.defaultValues[v]=i[v];const r=this.configurationProperties[v];r&&(this.updatePropertyDefaultValue(v,r),this.updateSchema(v,r))}this.registerOverrideIdentifiers(y),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(a){const d=[];for(const y of a)for(const i in y)if(d.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const d of a)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,d){const y=[];return a.forEach(i=>{y.push(...this.validateAndRegisterProperties(i,d,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),y}doDeregisterConfigurations(a){const d=[],y=i=>{if(i.properties)for(const v in i.properties)d.push(v),delete this.configurationProperties[v],this.removeFromSchema(v,i.properties[v]);i.allOf&&i.allOf.forEach(v=>y(v))};for(const i of a){y(i);const v=this.configurationContributors.indexOf(i);v!==-1&&this.configurationContributors.splice(v,1)}return d}validateAndRegisterProperties(a,d=!0,y,i=3){i=E.isUndefinedOrNull(a.scope)?i:a.scope;let v=[],r=a.properties;if(r)for(let u in r){if(d&&w(u)){delete r[u];continue}const h=r[u];if(this.updatePropertyDefaultValue(u,h),e.OVERRIDE_PROPERTY_PATTERN.test(u)?h.scope=void 0:(h.scope=E.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=E.isUndefinedOrNull(h.restricted)?!!y?.restrictedConfigurations?.includes(u):h.restricted),r[u].hasOwnProperty("included")&&!r[u].included){this.excludedConfigurationProperties[u]=r[u],delete r[u];continue}else this.configurationProperties[u]=r[u];!r[u].deprecationMessage&&r[u].markdownDeprecationMessage&&(r[u].deprecationMessage=r[u].markdownDeprecationMessage),v.push(u)}let s=a.allOf;if(s)for(let u of s)v.push(...this.validateAndRegisterProperties(u,d,y,i));return v}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(a){const d=y=>{let i=y.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let v=y.allOf;v&&v.forEach(d)};d(a)}updateSchema(a,d){switch(e.allSettings.properties[a]=d,d.scope){case 1:e.applicationSettings.properties[a]=d;break;case 2:e.machineSettings.properties[a]=d;break;case 6:e.machineOverridableSettings.properties[a]=d;break;case 3:e.windowSettings.properties[a]=d;break;case 4:e.resourceSettings.properties[a]=d;break;case 5:e.resourceSettings.properties[a]=d,this.resourceLanguageSettingsSchema.properties[a]=d;break}}removeFromSchema(a,d){switch(delete e.allSettings.properties[a],d.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const d=`[${a}]`,y={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,y),e.allSettings.properties[d]=y,e.applicationSettings.properties[d]=y,e.machineSettings.properties[d]=y,e.machineOverridableSettings.properties[d]=y,e.windowSettings.properties[d]=y,e.resourceSettings.properties[d]=y}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,d){let y=this.defaultValues[a];E.isUndefined(y)&&(y=d.default),E.isUndefined(y)&&(y=o(d.type)),d.default=y}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function f(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=f;function o(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const l=new b;k.Registry.add(e.Extensions.Configuration,l);function w(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?A.localize(5,null,_):l.getConfigurationProperties()[_]!==void 0?A.localize(6,null,_):null:A.localize(4,null)}e.validateProperty=w;function D(){const _=[],a=l.getConfigurationProperties();for(const d of Object.keys(a))_.push([d,a[d].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=D}),define(be[84],Ee([0,1,23,10,2,62,4,28]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function S(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof E.URI)}e.isConfigurationOverrides=S;var P;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function b(v,r){const s=r?v?r.keys.filter(C=>v.keys.indexOf(C)===-1):[...r.keys]:[],u=v?r?v.keys.filter(C=>r.keys.indexOf(C)===-1):[...v.keys]:[],h=[];if(r&&v){for(const C of v.keys)if(r.keys.indexOf(C)!==-1){const m=D(v.contents,C),R=D(r.contents,C);c.equals(m,R)||h.push(C)}}const p=[],I=C=>{const m={};for(const R of C)for(const L of R.identifiers)m[y(L)]=R;return m},T=r?I(r.overrides):{},g=v?I(v.overrides):{};if(Object.keys(T).length)for(const C of s){const m=T[C];m&&p.push([(0,A.overrideIdentifierFromKey)(C),m.keys])}if(Object.keys(g).length)for(const C of u){const m=g[C];m&&p.push([(0,A.overrideIdentifierFromKey)(C),m.keys])}if(Object.keys(T).length&&Object.keys(g).length)for(const C of h){const m=g[C],R=T[C];if(m&&R){const L=b({contents:m.contents,keys:m.keys,overrides:[]},{contents:R.contents,keys:R.keys,overrides:[]});p.push([(0,A.overrideIdentifierFromKey)(C),[...L.added,...L.removed,...L.updated]])}}return{added:s,removed:u,updated:h,overrides:p}}e.compare=b;function n(v,r){const s=[];for(const u of Object.keys(v))if(A.OVERRIDE_PROPERTY_PATTERN.test(u)){const h={};for(const p in v[u])h[p]=v[u][p];s.push({identifiers:[(0,A.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(h),contents:f(h,r)})}return s}e.toOverrides=n;function f(v,r){const s=Object.create(null);for(let u in v)o(s,u,v[u],r);return s}e.toValuesTree=f;function o(v,r,s,u){const h=r.split("."),p=h.pop();let I=v;for(let T=0;T<h.length;T++){let g=h[T],C=I[g];switch(typeof C){case"undefined":C=I[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${h.slice(0,T+1).join(".")} is ${JSON.stringify(C)}`);return}I=C}if(typeof I=="object"&&I!==null)try{I[p]=s}catch(T){u(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(I)}`)}else u(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(I)}`)}e.addToValueTree=o;function l(v,r){const s=r.split(".");w(v,s)}e.removeFromValueTree=l;function w(v,r){const s=r.shift();if(r.length===0){delete v[s];return}if(Object.keys(v).indexOf(s)!==-1){const u=v[s];typeof u=="object"&&!Array.isArray(u)&&(w(u,r),Object.keys(u).length===0&&delete v[s])}}function D(v,r,s){function u(I,T){let g=I;for(const C of T){if(typeof g!="object"||g===null)return;g=g[C]}return g}const h=r.split("."),p=u(v,h);return typeof p=="undefined"?s:p}e.getConfigurationValue=D;function _(v,r,s){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in v?M.isObject(v[u])&&M.isObject(r[u])?_(v[u],r[u],s):s&&(v[u]=r[u]):v[u]=r[u])})}e.merge=_;function a(){const v=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(v)}e.getConfigurationKeys=a;function d(){const v=Object.create(null),r=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let s in r){let u=r[s].default;o(v,s,u,h=>console.error(`Conflict in default settings: ${h}`))}return v}e.getDefaultValues=d;function y(v){return`[${v}]`}e.keyFromOverrideIdentifier=y;function i(v,r,s){const u=v.inspect(r),h=v.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:u.defaultValue}e.getMigratedSettingValue=i}),define(be[148],Ee([0,1,13,3,102,6,20,23,10,2,84,62,28]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(i={},v=[],r=[]){this._contents=i,this._keys=v,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,v){const r=this.getContentsForOverrideIdentifer(v);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.keys;return[]}override(i){const v=this.getContentsForOverrideIdentifer(i);if(!v||typeof v!="object"||!Object.keys(v).length)return this;let r={};for(const s of c.distinct([...Object.keys(this.contents),...Object.keys(v)])){let u=this.contents[s],h=v[s];h&&(typeof u=="object"&&typeof h=="object"?(u=k.deepClone(u),this.mergeContents(u,h)):u=h),r[s]=u}return new f(r,this.keys,this.overrides)}merge(...i){const v=k.deepClone(this.contents),r=k.deepClone(this.overrides),s=[...this.keys];for(const u of i){this.mergeContents(v,u.contents);for(const h of u.overrides){const[p]=r.filter(I=>c.equals(I.identifiers,h.identifiers));p?this.mergeContents(p.contents,h.contents):r.push(k.deepClone(h))}for(const h of u.keys)s.indexOf(h)===-1&&s.push(h)}return new f(v,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,v){for(const r of Object.keys(v)){if(r in i&&S.isObject(i[r])&&S.isObject(v[r])){this.mergeContents(i[r],v[r]);continue}i[r]=k.deepClone(v[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,v){this.addKey(i),(0,t.addToValueTree)(this.contents,i,v,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let v=this.keys.length;for(let r=0;r<v;r++)i.indexOf(this.keys[r])===0&&(v=r);this.keys.splice(v,1,i)}removeKey(i){let v=this.keys.indexOf(i);return v!==-1?(this.keys.splice(v,1),!0):!1}}e.ConfigurationModel=f;class o extends f{constructor(){const i=(0,t.getDefaultValues)(),v=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))b.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,b.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(i,v,r)}}e.DefaultConfigurationModel=o;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,v){if(!S.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,v)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,v){this._raw=i;const{contents:r,keys:s,overrides:u,restricted:h}=this.doParseRaw(i,v);this._configurationModel=new f(r,s,u),this._restrictedConfigurations=h||[]}doParseContent(i){let v={},r=null,s=[],u=[],h=[];function p(T){Array.isArray(s)?s.push(T):r!==null&&(s[r]=T)}let I={onObjectBegin:()=>{let T={};p(T),u.push(s),s=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let T=[];p(T),u.push(s),s=T,r=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:p,onError:(T,g,C)=>{h.push({error:T,offset:g,length:C})}};if(i)try{E.visit(i,I),v=s[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return v}doParseRaw(i,v){const r=n.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,v);i=s.raw;const u=(0,t.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),h=Object.keys(i),p=(0,t.toOverrides)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:h,overrides:p,restricted:s.restricted}}filter(i,v,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const u={},h=[];for(let p in i)if(b.OVERRIDE_PROPERTY_PATTERN.test(p)&&r){const I=this.filter(i[p],v,!1,s);u[p]=I.raw,h.push(...I.restricted)}else{const I=v[p],T=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&h.push(p),(T===void 0||s.scopes===void 0||s.scopes.includes(T))&&(s.skipRestricted&&I?.restricted||(u[p]=i[p]))}return{raw:u,restricted:h}}}e.ConfigurationModelParser=l;class w extends A.Disposable{constructor(i,v,r,s){super();this.userSettingsResource=i,this.scopes=v,this.fileService=s,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class D{constructor(i,v,r=new f,s=new f,u=new F.ResourceMap,h=new f,p=new F.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=v,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,v,r){return this.getConsolidateConfigurationModel(v,r).getValue(i)}updateValue(i,v,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new f,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,v===void 0?s.removeValue(i):s.setValue(i,v),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,v,r){const s=this.getConsolidateConfigurationModel(v,r),u=this.getFolderConfigurationModelForResource(v.resource,r),h=v.resource?this._memoryConfigurationByResource.get(v.resource)||this._memoryConfiguration:this._memoryConfiguration,p=v.overrideIdentifier?this._defaultConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=v.overrideIdentifier?this.userConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=v.overrideIdentifier?this.localUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),g=v.overrideIdentifier?this.remoteUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),C=r?v.overrideIdentifier?this._workspaceConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,m=u?v.overrideIdentifier?u.freeze().override(v.overrideIdentifier).getValue(i):u.freeze().getValue(i):void 0,R=v.overrideIdentifier?h.override(v.overrideIdentifier).getValue(i):h.getValue(i),L=s.getValue(i),V=c.distinct(c.flatten(s.overrides.map(q=>q.identifiers))).filter(q=>s.getOverrideValue(i,q)!==void 0);return{defaultValue:p,userValue:I,userLocalValue:T,userRemoteValue:g,workspaceValue:C,workspaceFolderValue:m,memoryValue:R,value:L,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspaceFolder:m!==void 0?{value:u?.freeze().getValue(i),override:v.overrideIdentifier?u?.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,memory:R!==void 0?{value:h.getValue(i),override:v.overrideIdentifier?h.getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const v=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:v?v.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,v){this._folderConfigurations.set(i,v),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,v){const r=v.filter(s=>b.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,b.overrideIdentifierFromKey)(s),h=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=i.getKeysForOverrideIdentifier(u),I=[...p.filter(T=>h.indexOf(T)===-1),...h.filter(T=>p.indexOf(T)===-1),...h.filter(T=>!k.equals(this._defaultConfiguration.override(u).getValue(T),i.override(u).getValue(T)))];return[u,I]});return this.updateDefaultConfiguration(i),{keys:v,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:u}=(0,t.compare)(this.localUserConfiguration,i),h=[...v,...r,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:u}=(0,t.compare)(this.remoteUserConfiguration,i);let h=[...v,...r,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:v,updated:r,removed:s,overrides:u}=(0,t.compare)(this.workspaceConfiguration,i);let h=[...v,...r,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:u}}compareAndUpdateFolderConfiguration(i,v){const r=this.folderConfigurations.get(i),{added:s,updated:u,removed:h,overrides:p}=(0,t.compare)(r,v);let I=[...s,...u,...h];return(I.length||!r)&&this.updateFolderConfiguration(i,v),{keys:I,overrides:p}}compareAndDeleteFolderConfiguration(i){const v=this.folderConfigurations.get(i);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:u,overrides:h}=(0,t.compare)(v,void 0);return{keys:[...r,...s,...u],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,v){let r=this.getConsolidatedConfigurationModelForResource(i,v);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},v){let r=this.getWorkspaceConsolidatedConfiguration();if(v&&i){const s=v.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const u=this._memoryConfigurationByResource.get(i);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let v=this._foldersConsolidatedConfigurations.get(i);if(!v){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(v=r.merge(s),this._freeze&&(v=v.freeze()),this._foldersConsolidatedConfigurations.set(i,v)):v=r}return v}getFolderConfigurationModelForResource(i,v){if(v&&i){const r=v.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,v)=>{const{contents:r,overrides:s,keys:u}=this._folderConfigurations.get(v);return i.push([v,{contents:r,overrides:s,keys:u}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(v=>i.add(v)),this.userConfiguration.freeze().keys.forEach(v=>i.add(v)),this._workspaceConfiguration.freeze().keys.forEach(v=>i.add(v)),this._folderConfigurations.forEach(v=>v.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const v=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>v.add(s))),[...v.values()]}static parse(i){const v=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((h,p)=>(h.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new F.ResourceMap);return new D(v,r,new f,s,u,new f,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new f(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=D;function _(...y){if(y.length===0)return{keys:[],overrides:[]};if(y.length===1)return y[0];const i=new Set,v=new Map;for(const s of y)s.keys.forEach(u=>i.add(u)),s.overrides.forEach(([u,h])=>{const p=(0,F.getOrSet)(v,u,new Set);h.forEach(I=>p.add(I))});const r=[];return v.forEach((s,u)=>r.push([u,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=_;class a{constructor(i,v,r,s){this.change=i,this.previous=v,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;i.keys.forEach(p=>u.add(p)),i.overrides.forEach(([,p])=>p.forEach(I=>u.add(I))),this.affectedKeys=[...u.values()];const h=new f;this.affectedKeys.forEach(p=>h.setValue(p,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,v){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(v){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,v,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,v,this.currentWorkspace);return!k.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,v){let r=(0,t.toValuesTree)({[v]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=a;class d extends a{constructor(i,v,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,v);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=d}),define(be[85],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(F,k=M.Unknown,S){super(F);this._message=F,this._code=k,this._detail=S,this.isHandled=k===M.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(F){return F instanceof E&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof E&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof E&&F.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[86],Ee([0,1,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===c.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function E(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=E;function A(P){return P.scheme!==c.Schemas.file&&P.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function F(P){if(P.folders.length)return P.folders.every(t=>A(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&A(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=F;function k(P){return F(P)?.scheme}e.getVirtualWorkspaceScheme=k;function S(P){return F(P)!==void 0}e.isVirtualWorkspace=S}),define(be[149],Ee([0,1,3,25,4,15]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService");var F;(function(o){o.Http="http",o.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=b;function n(o,l){return l?l!==1&&o<1024:!M.isWindows&&o<1024}e.isPortPrivileged=n;let f=class{constructor(l){this.logService=l,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,w){return this._tunnelProvider=l,l?(this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async l=>{const w=[],D=Array.from(this._tunnels.values());for(let _ of D){const a=Array.from(_.values());for(let d of a){const y=await d.value;y&&w.push(y)}}l(w)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:w}of l.values())await w.then(D=>D?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,w,D,_,a=!1,d=k.Private,y){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${D} on local port ${_}.`),!l)return;w||(w="localhost");const i=this.retainOrCreateTunnel(l,w,D,_,a,d,y);return i?i.then(v=>{if(!v){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(v);return(v.tunnelRemoteHost!==w||v.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const w=this._tunnels.get(l.tunnelRemoteHost);if(w){const D=w.get(l.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,D))}}}}async tryDisposeTunnel(l,w,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${w}.`);const _=D.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(w),_}}async closeTunnel(l,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${w} `);const D=this._tunnels.get(l);if(D&&D.has(w)){const _=D.get(w);_.refcount=0,await this.tryDisposeTunnel(l,w,_)}}addTunnelToMap(l,w,D){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(w,{refcount:1,value:D})}async removeEmptyTunnelFromMap(l,w){const D=this._tunnels.get(l);D&&(await D.get(w)||D.delete(w),D.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,w){let D=[l];t(l)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):b(l)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const _=D.map(a=>this._tunnels.get(a));for(const a of _){const d=a?.get(w);if(d)return d}}canTunnel(l){return!!P(l)}createWithProvider(l,w,D,_,a,d,y){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${D} on local port ${_}.`);const v={elevationRequired:a?n(_===void 0?D:_):!1},r={remoteAddress:{host:w,port:D},localAddressPort:_,privacy:d,public:d!==k.Private,protocol:y},s=l.forwardPort(r,v);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(w,D,s),s}};f=$e([Ve(0,A.ILogService)],f),e.AbstractTunnelService=f}),define(be[150],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,F=5){let k;return k=A(S=>{const P=typeof S=="string"?S:S.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(P);return}const b=setTimeout(()=>this.flushBuffer(E),F);t={data:[P],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(E),k.dispose()}},this._terminalBufferMap.set(E,t)}),k}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=c}),define(be[151],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(be[46],Ee([0,1,34,3,6,4,28,151]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(w){function D(_){return _&&typeof _=="object"&&typeof _.id=="string"}w.isThemeColor=D})(S=e.ThemeColor||(e.ThemeColor={}));function P(w){return{id:w}}e.themeColorFromId=P;var t;(function(w){function D(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color=="undefined"||S.isThemeColor(v.color))}w.isThemeIcon=D;const _=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function a(v){const r=_.exec(v);if(!r)return;let[,s]=r;return{id:s}}w.fromString=a;function d(v,r){let s=v.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}w.modify=d;function y(v,r){return v.id===r.id&&v.color?.id===r.color?.id}w.isEqual=y;function i(v,r){return{id:v.id,color:r?P(r):void 0}}w.asThemeIcon=i,w.asClassNameArray=c.CSSIcon.asClassNameArray,w.asClassName=c.CSSIcon.asClassName,w.asCSSSelector=c.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function b(w){switch(w){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,E.toDisposable)(()=>{const _=this.themingParticipants.indexOf(D);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;F.Registry.add(e.Extensions.ThemingContribution,f);function o(w){return f.onColorThemeChange(w)}e.registerThemingParticipant=o;class l extends E.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,_){let a=this.theme.getColor(D);return a&&_&&(a=_(a,this.theme)),a?a.toString():null}}e.Themable=l}),define(be[152],Ee([0,1,14,34,3,123,83,28,46]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(D,_,a,d){const y=this.iconsById[D];if(y){if(a&&!y.description){y.description=a,this.iconSchema.properties[D].markdownDescription=`${a} $(${D})`;const r=this.iconReferenceSchema.enum.indexOf(D);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return y}let i={id:D,description:a,defaults:_,deprecationMessage:d};this.iconsById[D]=i;let v={$ref:"#/definitions/icons"};return d&&(v.deprecationMessage=d),a&&(v.markdownDescription=`${a}: $(${D})`),this.iconSchema.properties[D]=v,this.iconReferenceSchema.enum.push(D),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:D}}deregisterIcon(D){delete this.iconsById[D],delete this.iconSchema.properties[D];const _=this.iconReferenceSchema.enum.indexOf(D);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(D=>this.iconsById[D])}getIcon(D){return this.iconsById[D]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(D,_){const a=this.iconFontsById[D];if(a)return a;let d={id:D,definition:_};return this.iconFontsById[D]=d,this._onDidChange.fire(),d}deregisterIconFont(D){delete this.iconFontsById[D]}getIconFonts(){return Object.keys(this.iconFontsById).map(D=>this.iconFontsById[D])}getIconFont(D){return this.iconFontsById[D]}toString(){const D=(y,i)=>y.id.localeCompare(i.id),_=y=>{for(;S.ThemeIcon.isThemeIcon(y.defaults);)y=this.iconsById[y.defaults.id];return`codicon codicon-${y?y.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(y=>this.iconsById[y]);for(const y of d.filter(i=>!!i.description).sort(D))a.push(`|<i class="${_(y)}"></i>|${y.id}|${S.ThemeIcon.isThemeIcon(y.defaults)?y.defaults.id:y.id}|${y.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const y of d.filter(i=>!S.ThemeIcon.isThemeIcon(i.defaults)).sort(D))a.push(`|<i class="${_(y)}"></i>|${y.id}|`);return a.join(`
`)}}const t=new P;k.Registry.add(e.Extensions.IconContribution,t);function b(w,D,_,a){return t.registerIcon(w,D,_,a)}e.registerIcon=b;function n(){return t}e.getIconRegistry=n;function f(){for(const w of M.iconRegistry.all)t.registerIcon(w.id,w.definition,w.description);M.iconRegistry.onDidRegister(w=>t.registerIcon(w.id,w.definition,w.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let o=k.Registry.as(F.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new c.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=b("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=b("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=b("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=S.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[47],Ee([0,1,20,24,2,4]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function k(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=k;function S(n){const f=n;return!!(f&&typeof f=="object"&&E.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class P{constructor(f,o,l,w,D){this._id=f,this._transient=l,this._configuration=w,this._ignorePathCasing=D,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class t{constructor(f,o){this.raw=o,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function b(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=b}),define(be[63],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k):this._providerInfo.set(k,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,14]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,k,S){this._deferredPromises=new Map,this._id=F,this._shared=k,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const b of P.values())b.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,k){let S=this._value[F];return typeof S=="undefined"&&(S=k),S}update(F,k){this._value[F]=k;let S=this._deferredPromises.get(F);if(S!==void 0)return S.p;const P=new c.DeferredPromise;return this._deferredPromises.set(F,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(F,k){super(F.identifier.value,!0,k);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=E}),define(be[154],Ee([0,1,3,2,15]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptModelChanged(S.value,P)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));P.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};A=$e([Ve(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[12],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[155],Ee([0,1,26,3]),function(ne,e,c,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,S){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(k.identifier),et(this,E,S,"f"),Fe(this,E,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Fe(this,E,"f").get(this._id,k)}store(k,S){return Fe(this,E,"f").store(this._id,k,S)}delete(k){return Fe(this,E,"f").delete(this._id,k)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(be[48],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(_,a)=>{const d={controllerId:a};return M.set(_,d),d};e.createPrivateApiFor=E;const A=_=>M.get(_);e.getPrivateApiFor=A;const F=(_,a,d,y)=>{let i=d;return{enumerable:!0,configurable:!1,get(){return i},set(v){if(!y(i,v)){const r=i;i=v,_.listener?.({op:3,key:a,value:v,previous:r})}}}},k=(_,a)=>_===a,S={range:(_,a)=>_===a?!0:!_||!a?!1:_.isEqual(a),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(_,a)=>!(_.length!==a.length||_.some(d=>!a.find(y=>d.id===y.id)))},P=Object.keys(S),t=(_,a)=>({range:F(_,"range",void 0,S.range),label:F(_,"label",a,S.label),description:F(_,"description",void 0,S.description),canResolveChildren:F(_,"canResolveChildren",!1,S.canResolveChildren),busy:F(_,"busy",!1,S.busy),error:F(_,"error",void 0,S.error),tags:F(_,"tags",[],S.tags)}),b=(_,a)=>{const d=new Map;for(const y of P)S[y](_[y],a[y])||d.set(y,a[y]);return d};e.diffTestItems=b;class n extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class o extends Error{constructor(a,d,y){super(`TestItem with ID "${a}" is from controller "${d}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=o;const l=_=>{const a=(0,e.getPrivateApiFor)(_);let d=new Map;return{get size(){return d.size},forEach(y,i){for(const v of d.values())y.call(i,v,this)},replace(y){const i=new Map,v=new Set(d.keys()),r={op:4,ops:[]};for(const s of y){if(!(s instanceof w))throw new f(s.id);const u=(0,e.getPrivateApiFor)(s).controllerId;if(u!==a.controllerId)throw new o(s.id,u,a.controllerId);if(i.has(s.id))throw new n(s.id);i.set(s.id,s),v.delete(s.id),r.ops.push({op:0,item:s})}for(const s of v.keys())r.ops.push({op:1,id:s});a.listener?.(r),d=i},add(y){if(!(y instanceof w))throw new f(y.id);d.set(y.id,y),a.listener?.({op:0,item:y})},delete(y){d.delete(y)&&a.listener?.({op:1,id:y})},get(y){return d.get(y)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class w{constructor(a,d,y,i){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const v=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return v.parent instanceof D?void 0:v.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(v,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class D extends w{constructor(a,d){super(a,a,d,void 0)}}e.TestItemRootImpl=D}),define(be[64],Ee([0,1,4,149,3,12]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(S){function P(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:b.protocol}}S.fromApiTunnel=P;function t(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==M.TunnelPrivacyId.ConstantPrivate&&b.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}S.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,t){return{dispose:()=>{}}}async $providePortAttributes(P,t,b,n,f){return[]}async $forwardPort(P,t){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=$e([Ve(0,A.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[7],Ee([0,1,13,16,76,20,78,10,2,36,60,85]),function(ne,e,c,M,E,A,F,k,S,P,t,b){"use strict";var n,f,o,l,w,D,_,a,d,y,i,v,r,s,u,h,p,I,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function C(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let m=w=class{constructor(O){n.set(this,void 0),et(this,n,O,"f")}static from(...O){let ie=O;return new w(function(){if(ie){for(const _e of ie)_e&&typeof _e.dispose=="function"&&_e.dispose();ie=void 0}})}dispose(){typeof Fe(this,n,"f")=="function"&&(Fe(this,n,"f").call(this),et(this,n,void 0,"f"))}};n=new WeakMap,m=w=$e([C],m),e.Disposable=m;let R=D=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof D)return!0;let{line:ie,character:_e}=O;return typeof ie=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&ie===0?this:new D(this.line+_e,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),_e===this.line&&ie===this.character?this:new D(_e,ie)}toJSON(){return{line:this.line,character:this.character}}};R=D=$e([C],R),e.Position=R;let L=_=class{constructor(O,ie,_e,Ge){let nt,at;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(nt=new R(O,ie),at=new R(_e,Ge)):O instanceof R&&ie instanceof R&&(nt=O,at=ie),!nt||!at)throw new Error("Invalid arguments");nt.isBefore(at)?(this._start=nt,this._end=at):(this._start=at,this._end=nt)}static isRange(O){return O instanceof _?!0:O?R.isPosition(O.start)&&R.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof _?this.contains(O._start)&&this.contains(O._end):O instanceof R?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=R.Max(O.start,this._start),_e=R.Min(O.end,this._end);if(!ie.isAfter(_e))return new _(ie,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=R.Min(O.start,this._start),_e=R.Max(O.end,this.end);return new _(ie,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return O?R.isPosition(O)?_e=O:(_e=O.start||this.start,ie=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&ie.isEqual(this.end)?this:new _(_e,ie)}toJSON(){return[this.start,this.end]}};L=_=$e([C],L),e.Range=L;let V=a=class extends L{constructor(O,ie,_e,Ge){let nt,at;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(nt=new R(O,ie),at=new R(_e,Ge)):O instanceof R&&ie instanceof R&&(nt=O,at=ie),!nt||!at)throw new Error("Invalid arguments");super(nt,at);this._anchor=nt,this._active=at}static isSelection(O){return O instanceof a?!0:O?L.isRange(O)&&R.isPosition(O.anchor)&&R.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=a=$e([C],V),e.Selection=V;class q{constructor(O,ie,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=_e}}e.ResolvedAuthority=q;class U extends Error{constructor(O,ie=b.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=ie,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(O,ie){return new U(O,b.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new U(O,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var K;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var $;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=d=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof d?!0:O?L.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new d(O,ie)}static insert(O,ie){return d.replace(new L(O,O),ie)}static delete(O){return d.replace(O,"")}static setEndOfLine(O){const ie=new d(new L(new R(0,0),new R(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!L.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=d=$e([C],B),e.TextEdit=B;var H;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,_e,Ge){this._edits.push({_type:1,from:O,to:ie,options:_e,metadata:Ge})}createFile(O,ie,_e){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:_e})}deleteFile(O,ie,_e){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:_e})}replaceNotebookMetadata(O,ie,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,_e,Ge,nt){let at,dt,Ct=[],At;if(zt.isNotebookRange(ie)&&Lt.isNotebookCellDataArray(_e)&&!Lt.isNotebookCellDataArray(Ge)?(at=ie.start,dt=ie.end,Ct=_e,At=Ge):typeof ie=="number"&&typeof _e=="number"&&Lt.isNotebookCellDataArray(Ge)&&(at=ie,dt=_e,Ct=Ge,At=nt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||Ct.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:dt-at,cells:Ct,metadata:At})}replaceNotebookCellMetadata(O,ie,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:_e}})}replace(O,ie,_e,Ge){this._edits.push({_type:2,uri:O,edit:new B(ie,_e),metadata:Ge})}insert(O,ie,_e,Ge){this.replace(O,new L(ie,ie),_e,Ge)}delete(O,ie,_e){this.replace(O,ie,"",_e)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const _e of ie)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&ie.push(_e.edit);return ie}entries(){const O=new A.ResourceMap;for(let ie of this._edits)if(ie._type===2){let _e=O.get(ie.uri);_e||(_e=[ie.uri,[]],O.set(ie.uri,_e)),_e[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=$e([C],Q),e.WorkspaceEdit=Q;let re=y=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof y?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=y._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const _e=new y;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=y._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const _e=new y;_e._tabstop=this._tabstop,ie(_e),this._tabstop=_e._tabstop,ie=_e.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};re=y=$e([C],re),e.SnippetString=re;var ue;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(ue=e.DiagnosticTag||(e.DiagnosticTag={}));var Z;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(Z=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof L)this.range=ie;else if(ie instanceof R)this.range=new L(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?L.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=$e([C],oe),e.Location=oe;let ve=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&L.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};ve=$e([C],ve),e.DiagnosticRelatedInformation=ve;let Ae=class{constructor(O,ie,_e=Z.Error){if(!L.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=_e}toJSON(){return{severity:Z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,c.equals)(O.tags,ie.tags)&&(0,c.equals)(O.relatedInformation,ie.relatedInformation,ve.isEqual)}};Ae=$e([C],Ae),e.Diagnostic=Ae;let Se=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};Se=$e([C],Se),e.Hover=Se;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(O,ie=Ne.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};We=$e([C],We),e.DocumentHighlight=We;var je;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let x=v=class{constructor(O,ie,_e,Ge,nt){this.name=O,this.kind=ie,this.containerName=nt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof oe?this.location=Ge:_e instanceof L&&(this.location=new oe(Ge,_e)),v.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};x=v=$e([C],x),e.SymbolInformation=x;let G=r=class{constructor(O,ie,_e,Ge,nt){this.name=O,this.detail=ie,this.kind=_e,this.range=Ge,this.selectionRange=nt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};G=r=$e([C],G),e.DocumentSymbol=G;var te;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,ie){this.title=O,this.kind=ie}};ae=$e([C],ae),e.CodeAction=ae;let j=s=class{constructor(O){this.value=O}append(O){return new s(this.value?this.value+s.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+s.sep)}};j.sep=".",j=s=$e([C],j),e.CodeActionKind=j,j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll");let se=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=$e([C],se),e.SelectionRange=se;class he{constructor(O,ie,_e,Ge,nt,at){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=nt,this.selectionRange=at}}e.CallHierarchyItem=he;class Re{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=Re;class Be{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=Be;var ze;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};Qe=$e([C],Qe),e.CodeLens=Qe;let it=u=class{constructor(O,ie=!1){f.set(this,void 0),et(this,f,new E.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof u?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Fe(this,f,"f").value}set value(O){Fe(this,f,"f").value=O}get isTrusted(){return Fe(this,f,"f").isTrusted}set isTrusted(O){Fe(this,f,"f").isTrusted=O}get supportThemeIcons(){return Fe(this,f,"f").supportThemeIcons}set supportThemeIcons(O){Fe(this,f,"f").supportThemeIcons=O}get supportHtml(){return Fe(this,f,"f").supportHtml}set supportHtml(O){Fe(this,f,"f").supportHtml=O}appendText(O){return Fe(this,f,"f").appendText(O),this}appendMarkdown(O){return Fe(this,f,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Fe(this,f,"f").appendCodeblock(ie??"",O),this}};f=new WeakMap,it=u=$e([C],it),e.MarkdownString=it;let ke=class{constructor(O,ie){this.label=O,this.documentation=ie}};ke=$e([C],ke),e.ParameterInformation=ke;let Ze=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};Ze=$e([C],Ze),e.SignatureInformation=Ze;let z=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};z=$e([C],z),e.SignatureHelp=z;var J;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let He=class{constructor(O,ie,_e){this.text=O,this.position=ie,this.kind=_e}};He=$e([C],He),e.InlayHint=He;var Ye;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var st;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(st=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(N){N[N.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let Et=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Et=$e([C],Et),e.CompletionItem=Et;let ft=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};ft=$e([C],ft),e.CompletionList=ft;let Dt=class{constructor(O,ie,_e){this.text=O,this.range=ie,this.command=_e}};Dt=$e([C],Dt),e.InlineSuggestion=Dt;let Pt=class{constructor(O){this.items=O}};Pt=$e([C],Pt),e.InlineSuggestions=Pt;var It;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(It=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var yt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(yt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ee;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ee=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var le;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(le=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(ie){switch(ie){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,ie){if(ie&&!S.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};ge=$e([C],ge),e.DocumentLink=ge;let fe=class{constructor(O,ie,_e,Ge){this.red=O,this.green=ie,this.blue=_e,this.alpha=Ge}};fe=$e([C],fe),e.Color=fe;let Pe=class{constructor(O,ie){if(ie&&!(ie instanceof fe))throw(0,M.illegalArgument)("color");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Pe=$e([C],Pe),e.ColorInformation=Pe;let xe=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};xe=$e([C],xe),e.ColorPresentation=xe;var Oe;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Oe=e.ColorFormat||(e.ColorFormat={}));var Ke;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ke=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class tt{constructor(O,ie,_e){if(this.startIndex=O,this.length=ie,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=tt;var Le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=de;var pe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let W=h=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};W.Clean=new h("clean","Clean"),W.Build=new h("build","Build"),W.Rebuild=new h("rebuild","Rebuild"),W.Test=new h("test","Test"),W=h=$e([C],W),e.TaskGroup=W;function we(N){let O="";for(let ie=0;ie<N.length;ie++)O+=N[ie].replace(/,/g,",,")+",";return O}let Ie=class{constructor(O,ie,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=_e):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return we(O)}};Ie=$e([C],Ie),e.ProcessExecution=Ie;let Je=class{constructor(O,ie,_e){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return we(O)}};Je=$e([C],Je),e.ShellExecution=Je;var Ue;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Ue=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class pt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=pt;let lt=p=class{constructor(O,ie,_e,Ge,nt,at){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=_e,this.execution=Ge,dt=nt,this.__deprecated=!0):ie===ct.Global||ie===ct.Workspace?(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=nt,dt=at):(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=nt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(p.EmptyType===ie||p.ProcessType===ie||p.ShellType===ie||p.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=p=$e([C],lt),e.Task=lt;var mt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,ie=bt.None){this.collapsibleState=ie,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=$e([C],ut),e.TreeItem=ut;var bt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor(O,ie){this.id=O,this.color=ie}};gt=$e([C],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let $t=class{constructor(O){this.id=O}};$t=$e([C],$t),e.ThemeColor=$t;var Vt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(O,ie){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};St=$e([C],St),e.RelativePattern=St;let Ft=class{constructor(O,ie,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};Ft=$e([C],Ft),e.Breakpoint=Ft;let ei=class extends Ft{constructor(O,ie,_e,Ge,nt){super(ie,_e,Ge,nt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ei=$e([C],ei),e.SourceBreakpoint=ei;let vt=class extends Ft{constructor(O,ie,_e,Ge,nt){super(ie,_e,Ge,nt);this.functionName=O}};vt=$e([C],vt),e.FunctionBreakpoint=vt;let Qt=class extends Ft{constructor(O,ie,_e,Ge,nt,at,dt){super(Ge,nt,at,dt);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=_e}};Qt=$e([C],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,ie,_e){this.command=O,this.args=ie||[],this.options=_e}};jt=$e([C],jt),e.DebugAdapterExecutable=jt;let ti=class{constructor(O,ie){this.port=O,this.host=ie}};ti=$e([C],ti),e.DebugAdapterServer=ti;let ii=class{constructor(O){this.path=O}};ii=$e([C],ii),e.DebugAdapterNamedPipeServer=ii;let Tt=class{constructor(O){this.implementation=O}};Tt=$e([C],Tt),e.DebugAdapterInlineImplementation=Tt;let Yt=class{constructor(O,ie){this.range=O,this.expression=ie}};Yt=$e([C],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ie){this.range=O,this.text=ie}};Wt=$e([C],Wt),e.InlineValueText=Wt;let Ht=class{constructor(O,ie,_e=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=_e}};Ht=$e([C],Ht),e.InlineValueVariableLookup=Ht;let ht=class{constructor(O,ie){this.range=O,this.expression=ie}};ht=$e([C],ht),e.InlineValueEvaluatableExpression=ht;let ni=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};ni=$e([C],ni),e.InlineValueContext=ni;var Nt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=I=class extends Error{constructor(O,ie=t.FileSystemProviderErrorCode.Unknown,_e){super(S.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new I(O,t.FileSystemProviderErrorCode.FileExists,I.FileExists)}static FileNotFound(O){return new I(O,t.FileSystemProviderErrorCode.FileNotFound,I.FileNotFound)}static FileNotADirectory(O){return new I(O,t.FileSystemProviderErrorCode.FileNotADirectory,I.FileNotADirectory)}static FileIsADirectory(O){return new I(O,t.FileSystemProviderErrorCode.FileIsADirectory,I.FileIsADirectory)}static NoPermissions(O){return new I(O,t.FileSystemProviderErrorCode.NoPermissions,I.NoPermissions)}static Unavailable(O){return new I(O,t.FileSystemProviderErrorCode.Unavailable,I.Unavailable)}};xt=I=$e([C],xt),e.FileSystemError=xt;let Jt=class{constructor(O,ie,_e){this.start=O,this.end=ie,this.kind=_e}};Jt=$e([C],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=fi;function ri(N){return typeof N=="undefined"||(0,k.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,_e=O.tokenTypes.length;ie<_e;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,_e=O.tokenModifiers.length;ie<_e;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,_e,Ge,nt){if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ie,_e,Ge,nt);if(L.isRange(O)&&typeof ie=="string"&&ri(_e))return this._push(O,ie,_e);throw(0,M.illegalArgument)()}_push(O,ie,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,nt=O.start.character,at=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(ie);let Ct=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(At);Ct|=1<<Mt>>>0}this._pushEncoded(Ge,nt,at,dt,Ct)}_pushEncoded(O,ie,_e,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Mt=0;for(let Ot=0;Ot<Ct;Ot++){let Bt=this._data[5*Ot],ci=this._data[5*Ot+1];Bt===0?(Bt=At,ci+=Mt):Bt+=At,this._data[5*Ot]=Bt,this._data[5*Ot+1]=ci,At=Bt,Mt=ci}}let at=O,dt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const _e=O.length/5|0;for(let dt=0;dt<_e;dt++)ie[dt]=dt;ie.sort((dt,Ct)=>{const At=O[5*dt],Mt=O[5*Ct];if(At===Mt){const Ot=O[5*dt+1],Bt=O[5*Ct+1];return Ot-Bt}return At-Mt});const Ge=new Uint32Array(O.length);let nt=0,at=0;for(let dt=0;dt<_e;dt++){const Ct=5*ie[dt],At=O[Ct+0],Mt=O[Ct+1],Ot=O[Ct+2],Bt=O[Ct+3],ci=O[Ct+4],xi=At-nt,qi=xi===0?Mt-at:Mt,di=5*dt;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Ot,Ge[di+3]=Bt,Ge[di+4]=ci,nt=At,at=Mt}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,ie,_e){this.start=O,this.deleteCount=ie,this.data=_e}}e.SemanticTokensEdit=oi;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new gt("arrow-left")},Xt=$e([C],Xt),e.QuickInputButtons=Xt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,_e){this.badge=O,this.tooltip=ie,this.color=_e}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=$e([C],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof zt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,_e=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(_e=O.end),ie===this._start&&_e===this._end?this:new zt(ie,_e)}}e.NotebookRange=zt;class Lt{constructor(O,ie,_e,Ge,nt,at,dt){this.kind=O,this.value=ie,this.languageId=_e,this.mime=Ge,this.outputs=nt??[],this.metadata=at,this.executionSummary=dt,Lt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Lt.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class Me{constructor(O){this.cells=O}}e.NotebookData=Me;class Rt{constructor(O,ie){this.data=O,this.mime=ie;const _e=(0,F.normalizeMimeType)(ie,!0);if(!_e)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Rt.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Rt(O,ie)}static text(O,ie=F.Mimes.text){const _e=Fe(Rt,o,"f",l).encode(String(O));return new Rt(_e,ie)}static json(O,ie="application/json"){const _e=JSON.stringify(O,void 0,"	");return Rt.text(_e,ie)}}e.NotebookCellOutputItem=Rt,o=Rt,l={value:new TextEncoder};class Kt{constructor(O,ie,_e){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=_e):(this.id=(0,P.generateUuid)(),this.metadata=ie??_e)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,k.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const _e=new Set,Ge=new Set;for(let nt=0;nt<O.length;nt++){const at=O[nt],dt=(0,F.normalizeMimeType)(at.mime);if(!_e.has(dt)){_e.add(dt);continue}Ge.add(nt),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?O:O.filter((nt,at)=>!Ge.has(at))}}e.NotebookCellOutput=Kt;var wt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(wt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,ie=[]){this.uri=O,this.provides=(0,c.asArray)(ie)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,ie){this.label=O,this.timestamp=ie}};ui=$e([C],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(O,ie,_e){this.include=O,this.exclude=ie,this.profile=_e}};X=$e([C],X),e.TestRunRequest=X;let ce=T=class{constructor(O){this.message=O}static diff(O,ie,_e){const Ge=new T(O);return Ge.expectedOutput=ie,Ge.actualOutput=_e,Ge}};ce=T=$e([C],ce),e.TestMessage=ce;let De=class{constructor(O){this.id=O}};De=$e([C],De),e.TestTag=De;let rt=class{constructor(O,ie){this.covered=O,this.total=ie}};rt=$e([C],rt),e.CoveredCount=rt;let _t=g=class{constructor(O,ie,_e,Ge){this.uri=O,this.statementCoverage=ie,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,ie){const _e=new rt(0,0),Ge=new rt(0,0),nt=new rt(0,0);for(const dt of ie)if("branches"in dt){_e.total+=1,_e.covered+=dt.executionCount>0?1:0;for(const Ct of dt.branches)Ge.total+=1,Ge.covered+=Ct.executionCount>0?1:0}else nt.total+=1,nt.covered+=dt.executionCount>0?1:0;const at=new g(O,_e,Ge.total>0?Ge:void 0,nt.total>0?nt:void 0);return at.detailedCoverage=ie,at}};_t=g=$e([C],_t),e.FileCoverage=_t;let kt=class{constructor(O,ie,_e=[]){this.executionCount=O,this.location=ie,this.branches=_e}};kt=$e([C],kt),e.StatementCoverage=kt;let Oi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Oi=$e([C],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=$e([C],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,ie,_e,Ge,nt,at){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=nt,this.selectionRange=at}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,42,11,9,228,118,7,13]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(o,l){l?P.set(o,l):P.delete(o)}e.setWordDefinitionFor=t;function b(o){return P.get(o)}e.getWordDefinitionFor=b;class n extends A.MirrorTextModel{constructor(l,w,D,_,a,d,y,i){super(w,D,_,a);this._proxy=l,this._languageId=d,this._isDirty=y,this._notebook=i,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,S.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===M.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(w){return w?l._getTextInRange(w):l.getText()},get eol(){return l._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(w){return l._lineAt(w)},offsetAt(w){return l._offsetAt(w)},positionAt(w){return l._positionAt(w)},validateRange(w){return l._validateRange(w)},validatePosition(w){return l._validatePosition(w)},getWordRangeAtPosition(w,D){return l._getWordRangeAtPosition(w,D)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,c.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,c.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const w=this._validateRange(l);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const D=this._eol,_=w.start.line,a=w.end.line,d=[];d.push(this._lines[_].substring(w.start.character));for(let y=_+1;y<a;y++)d.push(this._lines[y]);return d.push(this._lines[a].substring(0,w.end.character)),d.join(D)}_lineAt(l){let w;if(l instanceof k.Position?w=l.line:typeof l=="number"&&(w=l),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new f(w,this._lines[w],w===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(l),D=this._lines[w.index].length;return new k.Position(w.index,Math.min(w.remainder,D))}_validateRange(l){if(!(l instanceof k.Range))throw new Error("Invalid argument");const w=this._validatePosition(l.start),D=this._validatePosition(l.end);return w===l.start&&D===l.end?l:new k.Range(w.line,w.character,D.line,D.character)}_validatePosition(l){if(!(l instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:w,character:D}=l,_=!1;if(w<0)w=0,D=0,_=!0;else if(w>=this._lines.length)w=this._lines.length-1,D=this._lines[w].length,_=!0;else{const a=this._lines[w].length;D<0?(D=0,_=!0):D>a&&(D=a,_=!0)}return _?new k.Position(w,D):l}_getWordRangeAtPosition(l,w){const D=this._validatePosition(l);if(!w)w=b(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const _=(0,F.getWordAtText)(D.character+1,(0,F.ensureValidWordDefinition)(w),this._lines[D.line],0);if(_)return new k.Range(D.line,_.startColumn-1,D.line,_.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(l,w,D){this._line=l,this._text=w,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[156],Ee([0,1,7,3,229,6,55,20,2,36]),function(ne,e,c,M,E,A,F,k,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,f,o,l){this._notebook=o,this._selector=l,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(D=>{const _=this._cellUris.get(D.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>w(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const n=[],f=[];for(const o of this._notebook.getCells())o.kind===c.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),f.push(o.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let _="";for(const a of this._cells)_+=a.document.getText()+`
`;return _=_.slice(0,-1),_}if(n.isEmpty)return"";const f=this.locationAt(n.start),o=this.locationAt(n.end),l=this._cellUris.get(f.uri),w=this._cellUris.get(o.uri);if(l===void 0||w===void 0)return"";if(l===w)return this._cells[l].document.getText(new c.Range(f.range.start,o.range.end));const D=[this._cells[l].document.getText(new c.Range(f.range.start,new c.Position(this._cells[l].document.lineCount,0)))];for(let _=l+1;_<w;_++)D.push(this._cells[_].document.getText());return D.push(this._cells[w].document.getText(new c.Range(new c.Position(0,0),o.range.end))),D.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(f.index-1),l=this._cells[f.index].document.offsetAt(n.with(f.remainder));return o+l}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),l=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(l)}const f=this._cellUris.get(n.uri);if(f!==void 0){const o=this._cellLines.getPrefixSum(f-1);return new c.Position(o+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let o=f;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const l=new c.Position(f.remainder,n.start.character),w=new c.Position(o.remainder,n.end.character),D=new c.Range(l,w),_=this._cells[f.index];return new c.Location(_.document.uri,_.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(f,o)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),o=new c.Position(f.remainder,n.character),l=this._cells[f.index].document.validatePosition(o),w=this._cellLines.getPrefixSum(f.index-1);return new c.Position(w+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,12,3]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?c.ColorThemeKind.Light:k==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([Ve(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[65],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[158],Ee([0,1,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function E(k,S){if(S.serializeBuffersForPostMessage){const P=new M,t=(f,o)=>{if(o instanceof ArrayBuffer){const l=P.add(o);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(o)){const l=A(o);if(l){const w=P.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:l,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},b=JSON.stringify(k,t),n=P.buffers.map(f=>{const o=new Uint8Array(f);return c.VSBuffer.wrap(o)});return{message:b,buffers:n}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=E;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(k,S){const P=S.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),t=S.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const o=f,{index:l}=o,w=P[l];if(o.view)switch(o.view.type){case 1:return new Int8Array(w,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return f}:void 0;return{message:JSON.parse(k,t),arrayBuffers:P}}e.deserializeWebviewMessage=F}),define(be[159],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(M){function E(F){const k={items:new Map};return F.types.forEach((S,P)=>{k.items.set(S,{asString:async()=>F.items[P].asString})}),k}M.toITreeDataTransfer=E;async function A(F){const k={types:[],items:[]},S=Array.from(F.items.entries());for(const P of S)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}M.toTreeDataTransferDTO=A})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[66],Ee([0,1,11,2]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(k,S){return k.scheme===c.Schemas.http||k.scheme===c.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===c.Schemas.file&&(k=M.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:k.path})),M.URI.from({scheme:c.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=E;function A(k){return k.replace(/./g,S=>{const P=S.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?S:"-"+P.toString(16).padStart(4,"0")})}function F(k){return k.replace(/-([0-9a-f]{4})/g,(S,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=F}),define(be[160],Ee([0,1,3,6,66]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,S,P){this._proxy=k,this._editors=S,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const t=S.getVisibleTextEditors();for(const b of this._insets.values())t.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,P,t,b){let n;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===k){n=a;break}if(!n)throw new Error("not a visible editor");const f=this,o=this._handlePool++,l=new c.Emitter,w=new c.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,E.asWebviewUri)(a,f._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(a){this._options=a,f._proxy.$setOptions(o,a)}get options(){return this._options}set html(a){this._html=a,f._proxy.$setHtml(o,a)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(a){return f._proxy.$postMessage(o,a)}},_=new class{constructor(){this.editor=k,this.line=S,this.height=P,this.webview=D,this.onDidDispose=w.event}dispose(){f._insets.has(o)&&(f._insets.delete(o),f._proxy.$disposeEditorInset(o),w.fire(),w.dispose(),l.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,S+1,P,t||{},b.identifier,b.extensionLocation),this._insets.set(o,{editor:k,inset:_,onDidReceiveMessage:l}),_}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(be[161],Ee([0,1,131,10,2,6,4,45,28,13,11]),function(ne,e,c,M,E,A,F,k,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,c.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,c.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,c.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,c.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,c.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,c.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function b(R,L,V){for(const q of V.visibleEditorPanes)if(q.group.id===L&&R.matches(q.input))return q.getViewState()}e.findViewStateForEditor=b;function n(R){if(d(R))return!1;const L=R;return E.URI.isUri(L?.resource)}e.isResourceEditorInput=n;function f(R){if(d(R))return!1;const L=R;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=f;function o(R){if(d(R)||f(R))return!1;const L=R;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function l(R){if(d(R))return!1;const L=R;return L?L.resource===void 0||L.resource.scheme===t.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var w;(function(R){R[R.SHORT=0]="SHORT",R[R.MEDIUM=1]="MEDIUM",R[R.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var D;(function(R){R[R.EXPLICIT=1]="EXPLICIT",R[R.AUTO=2]="AUTO",R[R.FOCUS_CHANGE=3]="FOCUS_CHANGE",R[R.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(D=e.SaveReason||(e.SaveReason={}));var _;(function(R){R[R.None=0]="None",R[R.Readonly=2]="Readonly",R[R.Untitled=4]="Untitled",R[R.Singleton=8]="Singleton",R[R.RequiresTrust=16]="RequiresTrust",R[R.CanSplitInGroup=32]="CanSplitInGroup",R[R.ForceDescription=64]="ForceDescription"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends A.Disposable{}e.AbstractEditorInput=a;function d(R){return R instanceof a}e.isEditorInput=d;function y(R){const L=R;return E.URI.isUri(L?.preferredResource)}function i(R){const L=R;return d(L?.primary)&&d(L?.secondary)}e.isSideBySideEditorInput=i;function v(R){const L=R;return d(L?.modified)&&d(L?.original)}e.isDiffEditorInput=v;function r(R){return d(R?.editor)}e.isEditorInputWithOptions=r;function s(R){const L=R;return r(R)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function u(R){const L=R;return typeof L?.groupId=="number"&&d(L.editor)}e.isEditorIdentifier=u;var h;(function(R){R[R.UNKNOWN=0]="UNKNOWN",R[R.REPLACE=1]="REPLACE",R[R.MOVE=2]="MOVE",R[R.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var p;(function(R){R[R.PRIMARY=1]="PRIMARY",R[R.SECONDARY=2]="SECONDARY",R[R.BOTH=3]="BOTH",R[R.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class I{getOriginalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:U,secondary:K}=this.getSideEditors(L);if(U&&K){if(V?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===p.ANY)return this.getOriginalUri(U,{filterByScheme:V.filterByScheme})??this.getOriginalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===p.PRIMARY?U:K}}if(f(L)||o(L))return;const q=y(L)?L.preferredResource:L.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}getSideEditors(L){return i(L)||o(L)?{primary:L.primary,secondary:L.secondary}:v(L)||f(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:U,secondary:K}=this.getSideEditors(L);if(U&&K){if(V?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===p.ANY)return this.getCanonicalUri(U,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===p.PRIMARY?U:K}}if(f(L)||o(L))return;const q=L.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}filterUri(L,V){if(Array.isArray(V)){if(V.some(q=>L.scheme===q))return L}else if(V===L.scheme)return L}}e.EditorResourceAccessor=new I;var T;(function(R){R[R.LEFT=0]="LEFT",R[R.RIGHT=1]="RIGHT"})(T=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const V=this.instantiationService=L.get(F.IInstantiationService);for(const[q,U]of this.editorSerializerConstructors)this.createEditorSerializer(q,U,V);this.editorSerializerConstructors.clear()}createEditorSerializer(L,V,q){const U=q.createInstance(V);this.editorSerializerInstances.set(L,U)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,V){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,V,this.instantiationService):this.editorSerializerConstructors.set(L,V),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new g);async function C(R,L){if(!R||!R.length)return[];const V=await Promise.all(R.map(async q=>{const U=E.URI.revive(q.fileUri);if(!U||(await L.activateProvider(U.scheme),!L.canHandleResource(U)))return;const K=typeof q.exists=="boolean"?q.exists:await L.exists(U);if(!K&&q.openOnlyIfExists)return;const $={selection:K?q.selection:void 0,pinned:!0,override:q.editorOverrideId};let B;return K?B={resource:U,options:$}:B={resource:U,options:$,forceUntitled:!0},B}));return(0,P.coalesce)(V)}e.pathsToEditors=C;var m;(function(R){R[R.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",R[R.SEQUENTIAL=1]="SEQUENTIAL"})(m=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,45,132,4,6,20,28,13,51,23,34,152]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var o;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var l;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function w(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=w;function D(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=D;class _ extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(h,p,I){const T=this.get(h.id);if(T)return T;const g=h;return g.openCommandActionDescriptor=I?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,k.getOrSet)(this.viewContainers,p,[]).push(g),I?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:p}),g}deregisterViewContainer(h){for(const p of this.viewContainers.keys()){const I=this.viewContainers.get(p),T=I?.indexOf(h);if(T!==-1){I?.splice(T,1),I.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:p});return}}}get(h){return this.all.filter(p=>p.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(I=>I?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===h)}}S.Registry.add(o.ViewContainersRegistry,new _);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function d(u,h){const p=u.group??a.More,I=h.group??a.More;return p!==I?p.localeCompare(I):(u.order??5)-(h.order??5)}class y extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(h,p){this.registerViews2([{views:h,viewContainer:p}])}registerViews2(h){h.forEach(({views:p,viewContainer:I})=>this.addViews(p,I)),this._onViewsRegistered.fire(h)}deregisterViews(h,p){const I=this.removeViews(h,p);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:p})}moveViews(h,p){for(const I of this._views.keys())if(I!==p){const T=this.removeViews(h,I);T.length&&(this.addViews(T,p),this._onDidChangeContainer.fire({views:T,from:I,to:p}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const p of this._viewContainers){const I=(this._views.get(p)||[]).filter(T=>T.id===h)[0];if(I)return I}return null}getViewContainer(h){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(T=>T.id===h)[0])return p;return null}registerViewWelcomeContent(h,p){return this._viewWelcomeContents.add(h,p),this._onDidChangeViewWelcomeContent.fire(h),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(h,p),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,p){const I=new Map;for(const[T,g]of p)this._viewWelcomeContents.add(h,g),I.set(T,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(h,g),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),I}getViewWelcomeContent(h){const p=[];return this._viewWelcomeContents.forEach(h,I=>p.push(I)),p.sort(d)}addViews(h,p){let I=this._views.get(p);I||(I=[],this._views.set(p,I),this._viewContainers.push(p));for(const T of h){if(this.getView(T.id)!==null)throw new Error((0,E.localize)(1,null,T.id));I.push(T)}}removeViews(h,p){const I=this._views.get(p);if(!I)return[];const T=[],g=[];for(const C of I)h.includes(C)?T.push(C):g.push(C);return T.length&&(g.length?this._views.set(p,g):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),T}}S.Registry.add(o.ViewsRegistry,new y),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(u){return`view.${u}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var v;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(v=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(h,p){this.resolved=!1,this._hasResolve=!1,(0,b.mixin)(this,h),this._hasResolve=!!p,this.resolve=async I=>{if(p&&!this.resolved){const T=await p(I);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,14,133]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,P,t){const b={command:k};if(S&&Object.keys(S).length>0&&(b.arguments=S),this.internalSend("request",b),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(b.seq);if(f){this.pendingRequests.delete(b.seq);const o={type:"response",seq:0,request_seq:b.seq,success:!1,command:k,message:(0,E.localize)(0,null,t,k)};f(o)}},t)}return P&&this.pendingRequests.set(b.seq,P),b.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,M.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const S=k,P=this.pendingRequests.get(S.request_seq);P&&(this.pendingRequests.delete(S.request_seq),P(S));break}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,P)=>k.set(P,S)),await(0,M.timeout)(500),k.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[164],Ee([0,1,9,2,17,23,11]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(r,s,u){return r.replace(k,function(h,p){return s&&p.length>0&&p[0]!=="_"?h:u&&u.hasOwnProperty(p)?u[p]:h})}e.formatPII=S;function P(r){const s={};for(const u of Object.keys(r))u.startsWith("!")||(s[u]=r[u]);return s}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!b(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function b(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(s,"extensionhost")||(0,c.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?b(r.parentSession):void 0}e.getExtensionHostDebugSession=b;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function f(r,s,u){let h,p=0,I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,T=null;for(;T=I.exec(r);){let g=T.index+1,C=g+T[0].length;if(g<=s&&C>=u){h=T[0],p=g;break}}if(h){let g=/\w+/g,C=null;for(;(C=g.exec(h))&&!(C.index+1+p+C[0].length>=u););C&&(h=h.substring(0,g.lastIndex))}return h?{start:p,end:p+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(r){return!!(r&&r.match(o))}e.isUri=l;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(l(r.path))return M.URI.parse(r.path);if((0,E.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function D(r){if(typeof r.path=="object"){const s=M.URI.revive(r.path);if(s)return s.scheme===F.Schemas.file?s.fsPath:s.toString()}return r.path}function _(r,s){const u=s?w:D,h=(0,A.deepClone)(r);return d(h,(p,I)=>{p&&I&&(I.path=u(I))}),h}e.convertToDAPaths=_;function a(r,s){const u=s?w:D,h=(0,A.deepClone)(r);return d(h,(p,I)=>{!p&&I&&(I.path=u(I))}),h}e.convertToVSCPaths=a;function d(r,s){switch(r.type){case"event":const u=r;switch(u.event){case"output":s(!1,u.body.source);break;case"loadedSource":s(!1,u.body.source);break;case"breakpoint":s(!1,u.body.breakpoint.source);break;default:break}break;case"request":const h=r;switch(h.command){case"setBreakpoints":s(!0,h.arguments.source);break;case"breakpointLocations":s(!0,h.arguments.source);break;case"source":s(!0,h.arguments.source);break;case"gotoTargets":s(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(I=>s(!1,I));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(I=>s(!1,I.source));break;case"loadedSources":p.body.sources.forEach(I=>s(!1,I));break;case"scopes":p.body.scopes.forEach(I=>s(!1,I.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(I=>s(!1,I.source));break;case"setBreakpoints":p.body.breakpoints.forEach(I=>s(!1,I.source));break;default:break}break}}function y(r){return r.filter(s=>!s.presentation?.hidden).sort((s,u)=>s.presentation?u.presentation?s.presentation.group?u.presentation.group?s.presentation.group!==u.presentation.group?s.presentation.group.localeCompare(u.presentation.group):i(s.presentation.order,u.presentation.order):-1:u.presentation.group?1:i(s.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=y;function i(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function v(r,s){const u=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(u!=="none"&&(await s.saveAll(),u==="allEditorsInActiveGroup")){const h=s.activeEditorPane;h&&await s.save({editor:h.input,groupId:h.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(be[89],Ee([0,1,27,78,11,17,25,45]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var w;(function(g){g.scheme=E.Schemas.vscodeNotebookCell;const C=/^ch(\d{7,})/;function m(U,K){return U.with({scheme:g.scheme,fragment:`ch${K.toString().padStart(7,"0")}${U.scheme!==E.Schemas.file?U.scheme:""}`})}g.generate=m;function R(U){if(U.scheme!==g.scheme)return;const K=C.exec(U.fragment);return K?{handle:Number(K[1]),notebook:U.with({scheme:U.fragment.substr(K[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parse=R;function L(U){if(U.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const K=C.exec(U.fragment);return K?{handle:Number(K[1]),notebook:U.with({scheme:U.fragment.substr(K[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=L;function V(U,K,$){return U.with({scheme:$,fragment:`ch${K.toString().padStart(7,"0")}${U.scheme!==E.Schemas.file?U.scheme:""}`})}g.generateCellUri=V;function q(U,K){if(U.scheme!==K)return;const $=C.exec(U.fragment);return $?{handle:Number($[1]),notebook:U.with({scheme:U.fragment.substr($[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parseCellUri=q})(w=e.CellUri||(e.CellUri={}));const D=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(g){return D.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=_;function a(g){return D.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function d(g){return D.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=d;function y(g,C){return F.isWindows&&(g=g.replace(/\//g,"\\"),C=C.replace(/\//g,"\\")),c.match(g,C)}function i(g,C,m){let R=0;for(let L=0;L<C.length;L++){if(y(C[L],g))return R;R++}for(let L=0;L<m.length;L++){if(y(m[L],g))return R;R++}return R}function v(g,C,m){return g.sort((R,L)=>i(R,C,m)-i(L,C,m))}e.sortMimeTypes=v;function r(g,C,m,R=(L,V)=>L===V){const L=[];function V(K,$,B){if($===0&&B.length===0)return;const H=L[L.length-1];H&&H.start+H.deleteCount===K?(H.deleteCount+=$,H.toInsert.push(...B)):L.push({start:K,deleteCount:$,toInsert:B})}let q=0,U=0;for(;;){if(q===g.length){V(q,0,C.slice(U));break}if(U===C.length){V(q,g.length-q,[]);break}const K=g[q],$=C[U];if(R(K,$)){q+=1,U+=1;continue}m($)?(V(q,1,[]),q+=1):(V(q,0,[$]),U+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(g){g.default="default",g.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(g){const C=g;return!!((typeof C.include=="string"||c.isRelativePattern(C.include))&&(typeof C.exclude=="string"||c.isRelativePattern(C.exclude)))}e.isDocumentExcludePattern=u;function h(g,C,m){if(Array.isArray(g.viewType)&&g.viewType.indexOf(C)>=0||g.viewType===C)return!0;if(g.filenamePattern){let R=u(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,L=u(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(c.match(R,(0,A.basename)(m.fsPath).toLowerCase()))return!(L&&c.match(L,(0,A.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class p{constructor(C){this.textModel=C}getElements(){const C=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)C[m]=this.textModel.cells[m].getHashValue();return C}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var I;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(I=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(C){return`${T._prefix}${C}`}static parse(C){if(C.startsWith(T._prefix))return C.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,45]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=c;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(b){b[b.Unset=0]="Unset",b[b.Queued=1]="Queued",b[b.Running=2]="Running",b[b.Passed=3]="Passed",b[b.Failed=4]="Failed",b[b.Skipped=5]="Skipped",b[b.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var M;(function(b){b[b.Run=2]="Run",b[b.Debug=4]="Debug",b[b.Coverage=8]="Coverage",b[b.HasNonDefaultProfile=16]="HasNonDefaultProfile",b[b.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(b){b[b.Error=0]="Error",b[b.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(b,n)=>{n.expand!==void 0&&(b.expand=n.expand),n.item!==void 0&&(b.item=b.item?Object.assign(b.item,n.item):n.item)};e.applyTestItemUpdate=F;var k;(function(b){b[b.Function=0]="Function",b[b.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var S;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.Remove=2]="Remove",b[b.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",b[b.Retire=4]="Retire",b[b.AddTag=5]="AddTag",b[b.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const l=o[1];if(l.parent){if(this.items.has(l.parent)){const w=this.items.get(l.parent);w.children.add(l.item.extId);const D=this.createItem(l,w);this.items.set(l.item.extId,D),f.add(D)}}else{const w=this.createItem(l);this.roots.add(w),this.items.set(l.item.extId,w),f.add(w)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=o[1],w=this.items.get(l.extId);if(!w)break;l.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,l),f.update(w);break}case 2:{const l=this.items.get(o[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const w=[[o[1]]];for(;w.length;)for(const D of w.pop()){const _=this.items.get(D);_&&(w.push(_.children),this.items.delete(D),f.remove(_,_!==l),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(be[67],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(F,k=F.length){if(this.path=F,this.viewEnd=k,F.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,k,S=F.parent){if(F.id===k)return new E([k]);let P=[F.id];for(let t=S;t&&t.id!==k;t=t.parent)P.push(t.id);return P.push(k),new E(P.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new E(F.split("\0"))}static join(F,k){return new E([...F.path,k])}static joinToString(F,k){return F.toString()+"\0"+k}static compare(F,k){return F===k?0:k.startsWith(F+"\0")?2:F.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new E(this.path,F)}compare(F){if(typeof F=="string")return E.compare(this.toString(),F);for(let k=0;k<F.viewEnd&&k<this.viewEnd;k++)if(F.path[k]!==this.path[k])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=E}),define(be[168],Ee([0,1,17,91,10,23,25,77,136]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(b,n,f){this._contributedVariables=new Map,this._context=b,this._labelService=n,f&&(this._envVariablesPromise=f.then(o=>this.prepareEnv(o)))}prepareEnv(b){if(F.isWindows){const n=Object.create(null);return Object.keys(b).forEach(f=>{n[f.toLowerCase()]=b[f]}),n}return b}resolveWithEnvironment(b,n,f){return this.recursiveResolve(this.prepareEnv(b),n?n.uri:void 0,f)}async resolveAsync(b,n){return this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,n)}async resolveAnyBase(b,n,f,o){const l=A.deepClone(n);return F.isWindows&&l.windows?Object.keys(l.windows).forEach(w=>l[w]=l.windows[w]):F.isMacintosh&&l.osx?Object.keys(l.osx).forEach(w=>l[w]=l.osx[w]):F.isLinux&&l.linux&&Object.keys(l.linux).forEach(w=>l[w]=l.linux[w]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,l,f,o)}async resolveAnyAsync(b,n,f){return this.resolveAnyBase(b,n,f)}async resolveAnyMap(b,n,f){const o=new Map;return{newConfig:await this.resolveAnyBase(b,n,f,o),resolvedVariables:o}}resolveWithInteractionReplace(b,n,f,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,n,f,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,n){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,n)}recursiveResolve(b,n,f,o,l){if(E.isString(f))return this.resolveString(b,n,f,o,l);if(E.isArray(f))return f.map(w=>this.recursiveResolve(b,n,w,o,l));if(E.isObject(f)){let w=Object.create(null);return Object.keys(f).forEach(D=>{const _=this.resolveString(b,n,D,o,l);w[_]=this.recursiveResolve(b,n,f[D],o,l)}),w}return f}resolveString(b,n,f,o,l){return f.replace(P.VARIABLE_REGEXP,(D,_)=>{if(_.includes(P.VARIABLE_LHS))return D;let a=this.evaluateSingleVariable(b,D,_,n,o);return l&&l.set(_,a),a!==D&&E.isString(a)&&a.match(P.VARIABLE_REGEXP)&&(a=this.resolveString(b,n,a,o,l)),a})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,n,f,o,l){let w;const D=f.split(":");D.length>1&&(f=D[0],w=D[1]);const _=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,S.localize)(0,null,n))},a=()=>{const y=_();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,S.localize)(1,null,n,c.basename(y)))},d=()=>{if(w){const y=this._context.getFolderUri(w);if(y)return y;throw new Error((0,S.localize)(2,null,n,w))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(f){case"env":if(w){if(b){const y=b[F.isWindows?w.toLowerCase():w];if(E.isString(y))return y}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(w){const y=this._context.getConfigurationValue(o,w);if(E.isUndefinedOrNull(y))throw new Error((0,S.localize)(6,null,n,w));if(E.isObject(y))throw new Error((0,S.localize)(7,null,n,w));return y}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,w,l,"command");case"input":return this.resolveFromMap(n,w,l,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return o||w?(0,k.normalizeDriveLetter)(this.fsPath(d())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(d()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,S.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,S.localize)(10,null,n));case"file":return _();case"fileWorkspaceFolder":return a();case"relativeFile":return o||w?c.relative(this.fsPath(d()),_()):_();case"relativeFileDirname":const v=c.dirname(_());if(o||w){const h=c.relative(this.fsPath(d()),v);return h.length===0?".":h}return v;case"fileDirname":return c.dirname(_());case"fileExtname":return c.extname(_());case"fileBasename":return c.basename(_());case"fileBasenameNoExtension":const r=c.basename(_());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(_()));case"execPath":const s=this._context.getExecPath();return s||n;case"execInstallFolder":const u=this._context.getAppRoot();return u||n;case"pathSeparator":return c.sep;default:try{const h=w?`${f}:${w}`:f;return this.resolveFromMap(n,h,l,void 0)}catch(h){return n}}}}resolveFromMap(b,n,f,o){if(n&&f){const l=o===void 0?f[n]:f[o+":"+n];if(typeof l=="string")return l;throw new Error((0,S.localize)(11,null,b))}return b}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var E;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var k;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(l){const w=l;return(0,M.isEditorInput)(w?.editor)&&(0,M.isEditorInput)(w?.replacement)}e.isEditorReplacement=P;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.GROUP_LOCKED=2]="GROUP_LOCKED",l[l.EDITOR_OPEN=3]="EDITOR_OPEN",l[l.EDITOR_CLOSE=4]="EDITOR_CLOSE",l[l.EDITOR_MOVE=5]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=7]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=9]="EDITOR_PIN",l[l.EDITOR_STICKY=10]="EDITOR_STICKY",l[l.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(b=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function f(l){const w=l;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=f;function o(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(be[169],Ee([0,1,4,92]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const F=A;return typeof A=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,13,22,76,230,54,23,10,2,44,59,137,82,48,89,67,169,7]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(de){function pe(W){const{selectionStartLineNumber:we,selectionStartColumn:Ie,positionLineNumber:Je,positionColumn:Ue}=W,ct=new _.Position(we-1,Ie-1),pt=new _.Position(Je-1,Ue-1);return new _.Selection(ct,pt)}de.to=pe;function Y(W){const{anchor:we,active:Ie}=W;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}de.from=Y})(a=e.Selection||(e.Selection={}));var d;(function(de){function pe(W){if(!W)return;const{start:we,end:Ie}=W;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}de.from=pe;function Y(W){if(!W)return;const{startLineNumber:we,startColumn:Ie,endLineNumber:Je,endColumn:Ue}=W;return new _.Range(we-1,Ie-1,Je-1,Ue-1)}de.to=Y})(d=e.Range||(e.Range={}));var y;(function(de){function pe(Y){switch(Y){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 4:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}de.to=pe})(y=e.TokenType||(e.TokenType={}));var i;(function(de){function pe(W){return new _.Position(W.lineNumber-1,W.column-1)}de.to=pe;function Y(W){return{lineNumber:W.line+1,column:W.character+1}}de.from=Y})(i=e.Position||(e.Position={}));var v;(function(de){function pe(we,Ie){return(0,c.coalesce)((0,c.asArray)(we).map(Je=>Y(Je,Ie)))}de.from=pe;function Y(we,Ie){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:W(we.scheme,Ie),pattern:typeof we.pattern=="undefined"?void 0:ot.from(we.pattern),exclusive:we.exclusive}}function W(we,Ie){return Ie&&typeof we=="string"?Ie.transformOutgoingScheme(we):we}})(v=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(de){function pe(W){switch(W){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}de.from=pe;function Y(W){switch(W){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}de.to=Y})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(de){function pe(W){let we;return W.code&&((0,S.isString)(W.code)||(0,S.isNumber)(W.code)?we=String(W.code):we={value:String(W.code.value),target:W.code.target}),{...d.from(W.range),message:W.message,source:W.source,code:we,severity:h.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(u.from),tags:Array.isArray(W.tags)?(0,c.coalesce)(W.tags.map(r.from)):void 0}}de.from=pe;function Y(W){const we=new _.Diagnostic(d.to(W),W.message,h.to(W.severity));return we.source=W.source,we.code=(0,S.isString)(W.code)?W.code:W.code?.value,we.relatedInformation=W.relatedInformation&&W.relatedInformation.map(u.to),we.tags=W.tags&&(0,c.coalesce)(W.tags.map(r.to)),we}de.to=Y})(s=e.Diagnostic||(e.Diagnostic={}));var u;(function(de){function pe(W){return{...d.from(W.location.range),message:W.message,resource:W.location.uri}}de.from=pe;function Y(W){return new _.DiagnosticRelatedInformation(new _.Location(W.resource,d.to(W)),W.message)}de.to=Y})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(de){function pe(W){switch(W){case _.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}de.from=pe;function Y(W){switch(W){case f.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}de.to=Y})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var p;(function(de){function pe(W){return typeof W=="number"&&W>=_.ViewColumn.One?W-1:W===_.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}de.from=pe;function Y(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=Y})(p=e.ViewColumn||(e.ViewColumn={}));function I(de){return typeof de.range!="undefined"}function T(de){return de.length===0?!0:!!I(de[0])}e.isDecorationOptionsArr=T;var g;(function(de){function pe(Ue){return Ue.map(de.from)}de.fromMany=pe;function Y(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function W(Ue){let ct;if(Y(Ue)){const{language:ut,value:bt}=Ue;ct={value:"```"+ut+`
`+bt+"\n```\n"}}else _.MarkdownString.isMarkdownString(Ue)?ct={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?ct={value:Ue}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const lt=ut=>{try{let bt=P.URI.parse(ut,!0);bt=bt.with({query:we(bt.query,pt)}),pt[ut]=bt}catch(bt){}return""},mt=new A.Renderer;return mt.link=lt,mt.image=ut=>lt(E.parseHrefAndDimensions(ut).href),A(ct.value,{renderer:mt}),ct}de.from=W;function we(Ue,ct){if(!Ue)return Ue;let pt;try{pt=(0,F.parse)(Ue)}catch(mt){}if(!pt)return Ue;let lt=!1;return pt=(0,k.cloneAndChange)(pt,mt=>{if(P.URI.isUri(mt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ut]=mt,lt=!0,ut}else return}),lt?JSON.stringify(pt):Ue}function Ie(Ue){const ct=new _.MarkdownString(Ue.value,Ue.supportThemeIcons);return ct.isTrusted=Ue.isTrusted,ct.supportHtml=Ue.supportHtml,ct}de.to=Ie;function Je(Ue){if(!!Ue)return typeof Ue=="string"?Ue:de.from(Ue)}de.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function C(de){return T(de)?de.map(pe=>({range:d.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?g.fromMany(pe.hoverMessage):pe.hoverMessage?g.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):de.map(pe=>({range:d.from(pe)}))}e.fromRangeOrRangeWithMessage=C;function m(de){return typeof de=="undefined"?de:typeof de=="string"?P.URI.file(de):de}e.pathOrURIToURI=m;var R;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?m(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}de.from=pe})(R=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?m(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?R.from(Y.before):void 0,after:Y.after?R.from(Y.after):void 0}}de.from=pe})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(de){function pe(Y){if(typeof Y=="undefined")return Y;switch(Y){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=pe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(de){function pe(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?V.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?L.from(Y.light):void 0,dark:Y.dark?L.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?m(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?R.from(Y.before):void 0,after:Y.after?R.from(Y.after):void 0}}de.from=pe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(de){function pe(W){return{text:W.newText,eol:W.newEol&&J.from(W.newEol),range:d.from(W.range)}}de.from=pe;function Y(W){const we=new _.TextEdit(d.to(W.range),W.text);return we.newEol=typeof W.eol=="undefined"?void 0:J.to(W.eol),we}de.to=Y})(U=e.TextEdit||(e.TextEdit={}));var K;(function(de){function pe(W,we,Ie){const Je={edits:[]};if(W instanceof _.WorkspaceEdit)for(let Ue of W._allEntries())if(Ue._type===1)Je.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const ct=we?.getDocument(Ue.uri);Je.edits.push({_type:2,resource:Ue.uri,edit:U.from(Ue.edit),modelVersionId:ct?.version,metadata:Ue.metadata})}else Ue._type===3?Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}});return Je}de.from=pe;function Y(W){const we=new _.WorkspaceEdit;for(const Ie of W.edits)Ie.edit?we.replace(P.URI.revive(Ie.resource),d.to(Ie.edit.range),Ie.edit.text):we.renameFile(P.URI.revive(Ie.oldUri),P.URI.revive(Ie.newUri),Ie.options);return we}de.to=Y})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(de){const pe=Object.create(null);pe[_.SymbolKind.File]=0,pe[_.SymbolKind.Module]=1,pe[_.SymbolKind.Namespace]=2,pe[_.SymbolKind.Package]=3,pe[_.SymbolKind.Class]=4,pe[_.SymbolKind.Method]=5,pe[_.SymbolKind.Property]=6,pe[_.SymbolKind.Field]=7,pe[_.SymbolKind.Constructor]=8,pe[_.SymbolKind.Enum]=9,pe[_.SymbolKind.Interface]=10,pe[_.SymbolKind.Function]=11,pe[_.SymbolKind.Variable]=12,pe[_.SymbolKind.Constant]=13,pe[_.SymbolKind.String]=14,pe[_.SymbolKind.Number]=15,pe[_.SymbolKind.Boolean]=16,pe[_.SymbolKind.Array]=17,pe[_.SymbolKind.Object]=18,pe[_.SymbolKind.Key]=19,pe[_.SymbolKind.Null]=20,pe[_.SymbolKind.EnumMember]=21,pe[_.SymbolKind.Struct]=22,pe[_.SymbolKind.Event]=23,pe[_.SymbolKind.Operator]=24,pe[_.SymbolKind.TypeParameter]=25;function Y(we){return typeof pe[we]=="number"?pe[we]:6}de.from=Y;function W(we){for(const Ie in pe)if(pe[Ie]===we)return Number(Ie);return _.SymbolKind.Property}de.to=W})($=e.SymbolKind||(e.SymbolKind={}));var B;(function(de){function pe(W){switch(W){case _.SymbolTag.Deprecated:return 1}}de.from=pe;function Y(W){switch(W){case 1:return _.SymbolTag.Deprecated}}de.to=Y})(B=e.SymbolTag||(e.SymbolTag={}));var H;(function(de){function pe(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(B.from),containerName:W.containerName,location:oe.from(W.location)}}de.from=pe;function Y(W){const we=new _.SymbolInformation(W.name,$.to(W.kind),W.containerName,oe.to(W.location));return we.tags=W.tags&&W.tags.map(B.to),we}de.to=Y})(H=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(de){function pe(W){const we={name:W.name||"!!MISSING: name!!",detail:W.detail,range:d.from(W.range),selectionRange:d.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(B.from)??[]};return W.children&&(we.children=W.children.map(pe)),we}de.from=pe;function Y(W){const we=new _.DocumentSymbol(W.name,W.detail,$.to(W.kind),d.to(W.range),d.to(W.selectionRange));return(0,c.isNonEmptyArray)(W.tags)&&(we.tags=W.tags.map(B.to)),W.children&&(we.children=W.children.map(Y)),we}de.to=Y})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(de){function pe(W){const we=new _.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",P.URI.revive(W.uri),d.to(W.range),d.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}de.to=pe;function Y(W,we,Ie){if(we=we??W._sessionId,Ie=Ie??W._itemId,we===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Ie,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:d.from(W.range),selectionRange:d.from(W.selectionRange),tags:W.tags?.map(B.from)}}de.from=Y})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(de){function pe(Y){return new _.CallHierarchyIncomingCall(re.to(Y.from),Y.fromRanges.map(W=>d.to(W)))}de.to=pe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Z;(function(de){function pe(Y){return new _.CallHierarchyOutgoingCall(re.to(Y.to),Y.fromRanges.map(W=>d.to(W)))}de.to=pe})(Z=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var oe;(function(de){function pe(W){return{range:W.range&&d.from(W.range),uri:W.uri}}de.from=pe;function Y(W){return new _.Location(P.URI.revive(W.uri),d.to(W.range))}de.to=Y})(oe=e.location||(e.location={}));var ve;(function(de){function pe(W){const we=W,Ie=W;return{originSelectionRange:we.originSelectionRange?d.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Ie.uri,range:d.from(we.targetRange?we.targetRange:Ie.range),targetSelectionRange:we.targetSelectionRange?d.from(we.targetSelectionRange):void 0}}de.from=pe;function Y(W){return{targetUri:P.URI.revive(W.uri),targetRange:d.to(W.range),targetSelectionRange:W.targetSelectionRange?d.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?d.to(W.originSelectionRange):void 0}}de.to=Y})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Ae;(function(de){function pe(W){return{range:d.from(W.range),contents:g.fromMany(W.contents)}}de.from=pe;function Y(W){return new _.Hover(W.contents.map(g.to),d.to(W.range))}de.to=Y})(Ae=e.Hover||(e.Hover={}));var Se;(function(de){function pe(W){return{range:d.from(W.range),expression:W.expression}}de.from=pe;function Y(W){return new _.EvaluatableExpression(d.to(W.range),W.expression)}de.to=Y})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ne;(function(de){function pe(W){if(W instanceof _.InlineValueText)return{type:"text",range:d.from(W.range),text:W.text};if(W instanceof _.InlineValueVariableLookup)return{type:"variable",range:d.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}de.from=pe;function Y(W){switch(W.type){case"text":return{range:d.to(W.range),text:W.text};case"variable":return{range:d.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:d.to(W.range),expression:W.expression}}}de.to=Y})(Ne=e.InlineValue||(e.InlineValue={}));var We;(function(de){function pe(W){return{frameId:W.frameId,stoppedLocation:d.from(W.stoppedLocation)}}de.from=pe;function Y(W){return new _.InlineValueContext(W.frameId,d.to(W.stoppedLocation))}de.to=Y})(We=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(de){function pe(W){return{range:d.from(W.range),kind:W.kind}}de.from=pe;function Y(W){return new _.DocumentHighlight(d.to(W.range),W.kind)}de.to=Y})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(de){function pe(Y){switch(Y){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}de.to=pe})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var x;(function(de){function pe(Y){return{triggerKind:qe.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}de.to=pe})(x=e.CompletionContext||(e.CompletionContext={}));var G;(function(de){function pe(W){switch(W){case _.CompletionItemTag.Deprecated:return 1}}de.from=pe;function Y(W){switch(W){case 1:return _.CompletionItemTag.Deprecated}}de.to=Y})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(de){const pe=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function Y(Ie){return pe.get(Ie)??9}de.from=Y;const W=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function we(Ie){return W.get(Ie)??_.CompletionItemKind.Property}de.to=we})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function pe(Y,W){const we=new _.CompletionItem(Y.label);return we.insertText=Y.insertText,we.kind=te.to(Y.kind),we.tags=Y.tags?.map(G.to),we.detail=Y.detail,we.documentation=E.isMarkdownString(Y.documentation)?g.to(Y.documentation):Y.documentation,we.sortText=Y.sortText,we.filterText=Y.filterText,we.preselect=Y.preselect,we.commitCharacters=Y.commitCharacters,t.Range.isIRange(Y.range)?we.range=d.to(Y.range):typeof Y.range=="object"&&(we.range={inserting:d.to(Y.range.insert),replacing:d.to(Y.range.replace)}),we.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?we.insertText=new _.SnippetString(Y.insertText):(we.insertText=Y.insertText,we.textEdit=we.range instanceof _.Range?new _.TextEdit(we.range,we.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(we.additionalTextEdits=Y.additionalTextEdits.map(Ie=>U.to(Ie))),we.command=W&&Y.command?W.fromInternal(Y.command):void 0,we}de.to=pe})(ae=e.CompletionItem||(e.CompletionItem={}));var j;(function(de){function pe(W){return{label:W.label,documentation:W.documentation?g.fromStrict(W.documentation):void 0}}de.from=pe;function Y(W){return{label:W.label,documentation:E.isMarkdownString(W.documentation)?g.to(W.documentation):W.documentation}}de.to=Y})(j=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(de){function pe(W){return{label:W.label,documentation:W.documentation?g.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(j.from):[],activeParameter:W.activeParameter}}de.from=pe;function Y(W){return{label:W.label,documentation:E.isMarkdownString(W.documentation)?g.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(j.to):[],activeParameter:W.activeParameter}}de.to=Y})(se=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function pe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.from):[]}}de.from=pe;function Y(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.to):[]}}de.to=Y})(he=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(de){function pe(W){return{text:W.text,position:i.from(W.position),kind:Be.from(W.kind??_.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}de.from=pe;function Y(W){const we=new _.InlayHint(W.text,i.to(W.position),Be.to(W.kind));return we.whitespaceAfter=W.whitespaceAfter,we.whitespaceBefore=W.whitespaceBefore,we}de.to=Y})(Re=e.InlayHint||(e.InlayHint={}));var Be;(function(de){function pe(W){return W}de.from=pe;function Y(W){return W}de.to=Y})(Be=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(de){function pe(W){return{range:d.from(W.range),url:W.target,tooltip:W.tooltip}}de.from=pe;function Y(W){let we;if(W.url)try{we=typeof W.url=="string"?P.URI.parse(W.url,!0):P.URI.revive(W.url)}catch(Ie){}return new _.DocumentLink(d.to(W.range),we)}de.to=Y})(ze=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function pe(W){const we=new _.ColorPresentation(W.label);return W.textEdit&&(we.textEdit=U.to(W.textEdit)),W.additionalTextEdits&&(we.additionalTextEdits=W.additionalTextEdits.map(Ie=>U.to(Ie))),we}de.to=pe;function Y(W){return{label:W.label,textEdit:W.textEdit?U.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(we=>U.from(we)):void 0}}de.from=Y})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var it;(function(de){function pe(W){return new _.Color(W[0],W[1],W[2],W[3])}de.to=pe;function Y(W){return[W.red,W.green,W.blue,W.alpha]}de.from=Y})(it=e.Color||(e.Color={}));var ke;(function(de){function pe(W){return{range:d.from(W.range)}}de.from=pe;function Y(W){return new _.SelectionRange(d.to(W.range))}de.to=Y})(ke=e.SelectionRange||(e.SelectionRange={}));var Ze;(function(de){function pe(Y){switch(Y){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}de.to=pe})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var z;(function(de){function pe(W){switch(W){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}de.from=pe;function Y(W){switch(W){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}de.to=Y})(z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(de){function pe(W){if(W===_.EndOfLine.CRLF)return 1;if(W===_.EndOfLine.LF)return 0}de.from=pe;function Y(W){if(W===1)return _.EndOfLine.CRLF;if(W===0)return _.EndOfLine.LF}de.to=Y})(J=e.EndOfLine||(e.EndOfLine={}));var me;(function(de){function pe(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var He;(function(de){function pe(Y){const W={start:Y.start+1,end:Y.end+1};return Y.kind&&(W.kind=Ye.from(Y.kind)),W}de.from=pe})(He=e.FoldingRange||(e.FoldingRange={}));var Ye;(function(de){function pe(Y){if(Y)switch(Y){case _.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}de.from=pe})(Ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var st;(function(de){function pe(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?d.from(Y.selection):void 0,override:typeof Y.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=pe})(st=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ot;(function(de){function pe(W){return W instanceof _.RelativePattern||typeof W=="string"?W:Y(W)?new _.RelativePattern(W.base,W.pattern):W}de.from=pe;function Y(W){const we=W;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(ot=e.GlobPattern||(e.GlobPattern={}));var Et;(function(de){function pe(Y){if(Y){if(Array.isArray(Y))return Y.map(pe);if(typeof Y=="string")return Y;{const W=Y;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:ot.from(W.pattern),exclusive:W.exclusive}}}else return}de.from=pe})(Et=e.LanguageSelector||(e.LanguageSelector={}));var ft;(function(de){function pe(W){return{start:W.start,end:W.end}}de.from=pe;function Y(W){return new _.NotebookRange(W.start,W.end)}de.to=Y})(ft=e.NotebookRange||(e.NotebookRange={}));var Dt;(function(de){function pe(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}de.to=pe;function Y(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}de.from=Y})(Dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Pt;(function(de){function pe(W){switch(W){case _.NotebookCellKind.Markup:return l.CellKind.Markup;case _.NotebookCellKind.Code:default:return l.CellKind.Code}}de.from=pe;function Y(W){switch(W){case l.CellKind.Markup:return _.NotebookCellKind.Markup;case l.CellKind.Code:default:return _.NotebookCellKind.Code}}de.to=Y})(Pt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(de){function pe(W){const we={metadata:W.metadata??Object.create(null),cells:[]};for(let Ie of W.cells)_.NotebookCellData.validate(Ie),we.cells.push(Xe.from(Ie));return we}de.from=pe;function Y(W){const we=new _.NotebookData(W.cells.map(Xe.to));return(0,S.isEmptyObject)(W.metadata)||(we.metadata=W.metadata),we}de.to=Y})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function pe(W){return{cellKind:Pt.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Dt.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Te.from):[]}}de.from=pe;function Y(W){return new _.NotebookCellData(Pt.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Te.to):void 0,W.metadata,W.internalMetadata?Dt.to(W.internalMetadata):void 0)}de.to=Y})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(de){function pe(W){return{mime:W.mime,valueBytes:M.VSBuffer.wrap(W.data)}}de.from=pe;function Y(W){return new _.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}de.to=Y})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(de){function pe(W){return{outputId:W.id,items:W.items.map(yt.from),metadata:W.metadata}}de.from=pe;function Y(W){const we=W.items.map(yt.to);return new _.NotebookCellOutput(we,W.outputId,W.metadata)}de.to=Y})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(de){function pe(Ie){if(Ie!=null){if(Ie instanceof _.RelativePattern||typeof Ie=="string")return Ie;if(we(Ie))return new _.RelativePattern(Ie.base,Ie.pattern);if(W(Ie))return{include:ot.from(Ie.include)||void 0,exclude:ot.from(Ie.exclude)||void 0}}}de.from=pe;function Y(Ie){return typeof Ie=="string"?Ie:we(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}de.to=Y;function W(Ie){const Je=Ie,Ue=ot.from(Je.include);if(!(Ue&&Ue instanceof _.RelativePattern||typeof Ue=="string"))return!1;const ct=ot.from(Je.exclude);return!!(ct&&ct instanceof _.RelativePattern||typeof ct=="string")}function we(Ie){const Je=Ie;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(de){function pe(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?R.from(Y.top):void 0}}de.from=pe})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ee;(function(de){function pe(Y,W,we){const Ie=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Ie,we),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}de.from=pe})(ee=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var le;(function(de){function pe(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}de.from=pe})(le=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ge;(function(de){function pe(W){return{uri:W.uri,provides:W.provides}}de.from=pe;function Y(W){return new _.NotebookRendererScript(P.URI.revive(W.uri),W.provides)}de.to=Y})(ge=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function pe(W){return{message:g.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?oe.from(W.location):void 0}}de.from=pe;function Y(W){const we=new _.TestMessage(typeof W.message=="string"?W.message:g.to(W.message));return we.actualOutput=W.actual,we.expectedOutput=W.expected,we.location=W.location?oe.to(W.location):void 0,we}de.to=Y})(fe=e.TestMessage||(e.TestMessage={}));var Pe;(function(de){let pe;(function(Y){Y.Delimiter="\0"})(pe||(pe={})),de.namespace=(Y,W)=>Y+"\0"+W,de.denamespace=Y=>{const W=Y.indexOf("\0");return{ctrlId:Y.slice(0,W),tagId:Y.slice(W+1)}}})(Pe=e.TestTag||(e.TestTag={}));var xe;(function(de){function pe(Ie){const Je=(0,o.getPrivateApiFor)(Ie).controllerId;return{extId:w.TestId.fromExtHostTestItem(Ie,Je).toString(),label:Ie.label,uri:Ie.uri,tags:Ie.tags.map(Ue=>Pe.namespace(Je,Ue.id)),range:d.from(Ie.range)||null,description:Ie.description||null,error:Ie.error&&g.fromStrict(Ie.error)||null}}de.from=pe;function Y(Ie){return{id:w.TestId.fromString(Ie.extId).localId,label:Ie.label,uri:P.URI.revive(Ie.uri),tags:(Ie.tags||[]).map(Je=>{const{tagId:Ue}=Pe.denamespace(Je);return new _.TestTag(Ue)}),range:d.to(Ie.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ie.description||void 0}}de.toPlain=Y;function W(Ie){const Je=w.TestId.fromString(Ie.extId),Ue=new o.TestItemImpl(Je.controllerId,Je.localId,Ie.label,P.URI.revive(Ie.uri));return Ue.range=d.to(Ie.range||void 0),Ue.description=Ie.description||void 0,Ue}function we(Ie){let Je;for(const Ue of Ie.tests){const ct=W(Ue.item);(0,o.getPrivateApiFor)(ct).parent=Je,Je=ct}return Je}de.toItemFromContext=we})(xe=e.TestItem||(e.TestItem={})),function(de){function pe(W){return{id:W.id}}de.from=pe;function Y(W){return new _.TestTag(W.id)}de.to=Y}(Pe=e.TestTag||(e.TestTag={}));var Oe;(function(de){const pe=(W,we)=>{const Ie={...xe.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ue=>Ue.type===0).map(fe.to)})),children:W.children.map(Je=>we.get(Je)).filter(S.isDefined).map(Je=>pe(Je,we))};for(const Je of Ie.children)Je.parent=Ie;return Ie};function Y(W){const we=[],Ie=new Map;for(const Je of W.items)Ie.set(Je.item.extId,Je),W.request.targets.some(Ue=>Ue.controllerId===Je.controllerId&&Ue.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:W.completedAt,results:we.map(Je=>pe(Je,Ie))}}de.to=Y})(Oe=e.TestResults||(e.TestResults={}));var Ke;(function(de){function pe(Ie){return{covered:Ie.covered,total:Ie.covered}}function Y(Ie){return"line"in Ie?i.from(Ie):d.from(Ie)}function W(Ie){return"branches"in Ie?{count:Ie.executionCount,location:Y(Ie.location),type:1,branches:Ie.branches.length?Ie.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Y(Je.location)})):void 0}:{type:0,count:Ie.executionCount,location:Y(Ie.location)}}de.fromDetailed=W;function we(Ie){return{uri:Ie.uri,statement:pe(Ie.statementCoverage),branch:Ie.branchCoverage&&pe(Ie.branchCoverage),function:Ie.functionCoverage&&pe(Ie.functionCoverage),details:Ie.detailedCoverage?.map(W)}}de.fromFile=we})(Ke=e.TestCoverage||(e.TestCoverage={}));var tt;(function(de){function pe(Y){switch(Y){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}de.to=pe})(tt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function pe(W){const we=new _.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",P.URI.revive(W.uri),d.to(W.range),d.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}de.to=pe;function Y(W,we,Ie){if(we=we??W._sessionId,Ie=Ie??W._itemId,we===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Ie,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:d.from(W.range),selectionRange:d.from(W.selectionRange),tags:W.tags?.map(B.from)}}de.from=Y})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,t,b,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=b,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,b,n)=>{const o={dispose:this._callbacks.push([t,b,P])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(P,t){const b=c.URI.revive(P);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let l of[...this._callbacks]){if(n)break;const w=this._documents.getDocument(b),D=await this._deliverEventAsyncAndBlameBadListeners(l,{document:w,reason:A.TextDocumentSaveReason.to(t)});o.push(D)}}finally{clearTimeout(f)}return o}_deliverEventAsyncAndBlameBadListeners([P,t,b],n){const f=this._badListeners.get(P);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,P,t,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const l=this._badListeners.get(P);this._badListeners.set(P,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,b,n){const f=[],o=Date.now(),{document:l,reason:w}=n,{version:D}=l,_=Object.freeze({document:l,reason:w,waitUntil(a){if(Object.isFrozen(f))throw(0,M.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(a))}});try{t.apply(b,[_])}catch(a){return Promise.reject(a)}return Object.freeze(f),new Promise((a,d)=>{const y=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(y),a(i)}).catch(i=>{clearTimeout(y),d(i)})}).then(a=>{const d={edits:[]};for(const y of a)if(Array.isArray(y)&&y.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:v,range:r}of y)d.edits.push({_type:2,resource:l.uri,edit:{range:r&&A.Range.from(r),text:i,eol:v&&A.EndOfLine.from(v)}});if(d.edits.length!==0)return D===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(be[171],Ee([0,1,3,27,2,8,7]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(t,b,n,f,o){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),o&&(this._config+=4);const l=(0,M.parse)(b),w=t(D=>{if(!n)for(let _ of D.created){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidCreate.fire(a)}if(!f)for(let _ of D.changed){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidChange.fire(a)}if(!o)for(let _ of D.deleted){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(t,b,n){this._logService=b,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,b,n,f){return new k(this._onFileSystemEvent.event,t,b,n,f)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,b){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,b){return(n,f,o)=>{const l=function(D){n.call(f,D)};return l.extension=t,b.event(l,void 0,o)}}async $onWillRunFileOperation(t,b,n,f){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(o=>({oldUri:E.URI.revive(o.source),newUri:E.URI.revive(o.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(o=>E.URI.revive(o.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(o=>E.URI.revive(o.target))},n,f)}}async _fireWillEvent(t,b,n,f){const o=new Set,l=[];if(await t.fireAsync(b,f,async(D,_)=>{const a=Date.now(),d=await Promise.resolve(D);d instanceof F.WorkspaceEdit&&(l.push(d),o.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-a>n&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),f.isCancellationRequested||l.length===0)return;const w={edits:[]};for(let D of l){let{edits:_}=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(_)}return{edit:w,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=S}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,f,o,l){this.start=n,this.deletedCount=f,this.deletedItems=o,this.items=l}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(o=>o.apiCell)}))}}class P{constructor(n,f,o){this.notebook=n,this._extHostDocument=f,this._cellData=o,this.handle=o.handle,this.uri=E.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,f,o){const l=o.map(A.NotebookCellOutputItem.to),w=this._outputs.find(D=>D.id===n);w&&(f||(w.items.length=0),w.items.push(...l))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,f,o,l,w,D){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=o,this._emitter=l,this.uri=w,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(l=>l.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const o of n.rawEvents)o.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===k.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,o=n.end|0;return f<0&&(f=0),o>this._cells.length&&(o=this._cells.length),n.with({start:f,end:o})}_getCells(n){n=this._validateRange(n);const f=[];for(let o=n.start;o<n.end;o++)f.push(this._cells[o]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const o=[],l=[],w=[];n.reverse().forEach(D=>{const a=D[2].map(i=>{const v=new P(this,this._textDocumentsAndEditors,i);return f||l.push(P.asModelAddData(this.apiNotebook,i)),v}),d=new S(D[0],D[1],[],a),y=this._cells.splice(D[0],D[1],...a);for(const i of y)w.push(i.uri),d.deletedItems.push(i.apiCell);o.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:w}),f||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}_moveCell(n,f){const o=this._cells.splice(n,1);this._cells.splice(f,0,...o);const l=[new S(n,1,o.map(w=>w.apiCell),[]),new S(f,0,[],o)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(l)}))}_setCellOutputs(n,f){const o=this._cells[n];o.setOutputs(f),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,f,o,l){const w=this._cells[n];w.setOutputItems(f,o,l),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(n,f){const o=this._cells[n];o.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(o.uri,f)}_changeCellMime(n,f){const o=this._cells[n];o.apiCell.mime=f}_changeCellMetadata(n,f){const o=this._cells[n],l=o.apiCell.metadata;o.setMetadata(f);const w=o.apiCell.metadata;(0,M.equals)(l,w)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,f){const o=this._cells[n],l=o.internalMetadata;if(o.setInternalMetadata(f),l.runState!==f.runState){const w=f.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:w}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:P})}replaceCells(S,P,t){this._throwIfFinalized(),!(S===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:S,count:P-S,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(S,P,t,b,n,f){this.id=S,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=b,this._viewColumn=f}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(P){if(!Array.isArray(P)||!P.every(c.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");S._selections=P,S._trySetSelections(P)},get visibleRanges(){return S._visibleRanges},revealRange(P,t){S._proxy.$tryRevealRange(S.id,M.NotebookRange.from(P),t??c.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(P){const t=new A(this.document.version);return P(t),S._applyEdit(t.finalize())},setDecorations(P,t){return S.setDecorations(P,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(M.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let b=0;b<S.cellEdits.length;b++){if(t<0){P.push(S.cellEdits[b]),t++;continue}const f=P[t],o=S.cellEdits[b];if(f.editType===1&&o.editType===1&&f.index===o.index){f.cells.push(...S.cellEdits[b].cells),f.count+=S.cellEdits[b].count;continue}P.push(S.cellEdits[b]),t++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,P)}setDecorations(S,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return P.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),S.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,147,126,21,52]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}withProgress(b,n,f){const o=this._handles++,{title:l,location:w,cancellable:D}=n,_={label:(0,E.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this._proxy.$startProgress(o,{location:c.ProgressLocation.from(w),title:l,source:_,cancellable:D},b),this._withProgress(o,f,!!D)}_withProgress(b,n,f){let o;f&&(o=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,o));const l=D=>{this._proxy.$progressEnd(D),this._mapHandleToCancellationSource.delete(D),o&&o.dispose()};let w;try{w=n(new P(this._proxy,b),f&&o?o.token:A.CancellationToken.None)}catch(D){throw l(b),D}return w.then(D=>l(b),D=>l(b)),w}$acceptProgressCanceled(b){const n=this._mapHandleToCancellationSource.get(b);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=k;function S(t,b){return t.message=b.message,typeof b.increment=="number"&&(typeof t.increment=="number"?t.increment+=b.increment:t.increment=b.increment),t}class P extends M.Progress{constructor(b,n){super(f=>this.throttledReport(f));this._proxy=b,this._handle=n}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}$e([(0,F.throttle)(100,(t,b)=>S(t,b),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,53,8,7]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(n,f,o){const l=k._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,l,A.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:l,dispose(){n.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=k,k._Keys=new E.IdGenerator("TextEditorDecorationType");class S{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let o=null;if(n instanceof F.Position)o=new F.Range(n,n);else if(n instanceof F.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof F.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,o){const l=this._document.validateRange(n);this._collectedEdits.push({range:l,text:f,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class P{constructor(n,f,o,l){this._proxy=n,this._id=f,this._accept(o),this._logService=l;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(D){w._setTabSize(D)},get insertSpaces(){return w._insertSpaces},set insertSpaces(D){w._setInsertSpaces(D)},get cursorStyle(){return w._cursorStyle},set cursorStyle(D){w._setCursorStyle(D)},get lineNumbers(){return w._lineNumbers},set lineNumbers(D){w._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let o=!1;if(typeof n.tabSize!="undefined"){const l=this._validateTabSize(n.tabSize);l==="auto"?(o=!0,f.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,o=!0,f.tabSize=l)}if(typeof n.insertSpaces!="undefined"){const l=this._validateInsertSpaces(n.insertSpaces);l==="auto"?(o=!0,f.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,o=!0,f.insertSpaces=l)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,f.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(n){n.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,f,o,l,w,D,_,a){this.id=n,this._proxy=f,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new P(this._proxy,this.id,D,o),this._visibleRanges=_,this._viewColumn=a;const d=this;this.value=Object.freeze({get document(){return l.getValue()},set document(y){throw(0,M.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(y){if(!(y instanceof F.Selection))throw(0,M.illegalArgument)("selection");d._selections=[y],d._trySetSelection()},get selections(){return d._selections},set selections(y){if(!Array.isArray(y)||y.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");d._selections=y,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(y){throw(0,M.readonly)("visibleRanges")},get options(){return d._options.value},set options(y){d._disposed||d._options.assign(y)},get viewColumn(){return d._viewColumn},set viewColumn(y){throw(0,M.readonly)("viewColumn")},edit(y,i={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new S(l.getValue(),i);return y(v),d._applyEdit(v)},insertSnippet(y,i,v={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=d._selections.map(s=>A.Range.from(s));else if(i instanceof F.Position){const{lineNumber:s,column:u}=A.Position.from(i);r=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(i instanceof F.Range)r=[A.Range.from(i)];else{r=[];for(const s of i)if(s instanceof F.Range)r.push(A.Range.from(s));else{const{lineNumber:u,column:h}=A.Position.from(s);r.push({startLineNumber:u,startColumn:h,endLineNumber:u,endColumn:h})}}return f.$tryInsertSnippet(n,y.value,r,v)},setDecorations(y,i){const v=i.length===0;v&&!d._hasDecorationsForKey.has(y.key)||(v?d._hasDecorationsForKey.delete(y.key):d._hasDecorationsForKey.add(y.key),d._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return f.$trySetDecorations(n,y.key,A.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,u=i.length;s<u;s++){const h=i[s];r[4*s]=h.start.line+1,r[4*s+1]=h.start.character+1,r[4*s+2]=h.end.line+1,r[4*s+3]=h.end.character+1}return f.$trySetDecorationsFast(n,y.key,r)}}))},revealRange(y,i){d._runOnProxy(()=>f.$tryRevealRange(n,A.Range.from(y),i||F.TextEditorRevealType.Default))},show(y){f.$tryShowEditor(n,A.ViewColumn.from(y))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const o=f.edits.map(w=>w.range);o.sort((w,D)=>w.end.line===D.end.line?w.end.character===D.end.character?w.start.line===D.start.line?w.start.character-D.start.character:w.start.line-D.start.line:w.end.character-D.end.character:w.end.line-D.end.line);for(let w=0,D=o.length-1;w<D;w++){const _=o[w].end;if(o[w+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=f.edits.map(w=>({range:A.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,l,{setEndOfLine:typeof f.setEndOfLine=="number"?A.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,14,7,10,13,8,21,159]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(_,a){if((0,t.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let d;return Array.isArray(_.highlights)&&(d=_.highlights.filter(y=>y.length===2&&typeof y[0]=="number"&&typeof y[1]=="number"),d=d.length?d:void 0),{label:_.label,highlights:d}}}class w{constructor(a,d,y){this._proxy=a,this.commands=d,this.logService=y,this.treeViews=new Map;function i(v){return v&&v.$treeViewId&&v.$treeItemHandle}d.registerArgumentProcessor({processArgument:v=>i(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(r=>i(r)?this.convertArgument(r):r):v})}registerTreeDataProvider(a,d,y){const i=this.createTreeView(a,{treeDataProvider:d},y);return{dispose:()=>i.dispose()}}createTreeView(a,d,y){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=d.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(a,d,y);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(s){r.message=s},get title(){return r.title},set title(s){r.title=s},get description(){return r.description},set description(s){r.description=s},reveal:(s,u)=>r.reveal(s,u),dispose:async()=>{await v,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,d){const y=this.treeViews.get(a);return y?y.getChildren(d):Promise.reject(new Error((0,c.localize)(0,null,a)))}async $onDrop(a,d,y){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,c.localize)(1,null,a)));const v=o.TreeDataTransferConverter.toITreeDataTransfer(d);if(v.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await v.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>i.getExtensionElement(u)).filter(u=>!!u);s.length>0?v.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):v.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(v,y)}async $hasResolve(a){const d=this.treeViews.get(a);if(!d)throw new Error((0,c.localize)(2,null,a));return d.hasResolve}$resolve(a,d,y){const i=this.treeViews.get(a);if(!i)throw new Error((0,c.localize)(3,null,a));return i.resolveTreeItem(d,y)}$setExpanded(a,d,y){const i=this.treeViews.get(a);if(!i)throw new Error((0,c.localize)(4,null,a));i.setExpanded(d,y)}$setSelection(a,d){const y=this.treeViews.get(a);if(!y)throw new Error((0,c.localize)(5,null,a));y.setSelection(d)}$setVisible(a,d){const y=this.treeViews.get(a);if(!y)throw new Error((0,c.localize)(6,null,a));y.setVisible(d)}createExtHostTreeView(a,d,y){const i=new D(a,d,this._proxy,this.commands.converter,this.logService,y);return this.treeViews.set(a,i),i}convertArgument(a){const d=this.treeViews.get(a.$treeViewId);return d?d.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=w;class D extends F.Disposable{constructor(a,d,y,i,v,r){super();if(this.viewId=a,this.proxy=y,this.commands=i,this.logService=v,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const h in r.contributes.views)for(const p of r.contributes.views[h])p.id===a&&(this._title=p.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let s,u;this._register(A.Event.debounce(this._onDidChangeData.event,(h,p)=>(h||(h={message:!1,elements:[]}),p.element!==!1&&(s||(s=new Promise(I=>u=I),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(p.element)?h.elements.push(...p.element):h.elements.push(p.element)),p.message&&(h.message=!0),h),200,!0)(({message:h,elements:p})=>{p.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const I=u;return s=null,this.refresh(p).then(()=>I())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,t.isUndefinedOrNull)(a))}async getChildren(a){const d=a?this.getExtensionElement(a):void 0;if(a&&!d)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let y=this.getChildrenNodes(a);return y||(y=await this.fetchChildrenNodes(d)),y?y.map(i=>i.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,d){d=d||{select:!0,focus:!1};const y=(0,t.isUndefinedOrNull)(d.select)?!0:d.select,i=(0,t.isUndefinedOrNull)(d.focus)?!1:d.focus,v=(0,t.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(u=>u.item)},{select:y,focus:i,expand:v})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:y,focus:i,expand:v})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,d){const y=this.getExtensionElement(a);y&&(d?this._onDidExpandElement.fire(Object.freeze({element:y})):this._onDidCollapseElement.fire(Object.freeze({element:y})))}setSelection(a){(0,b.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,d){const y=this.getExtensionElement(d);if(!!y)return(0,S.asPromise)(()=>this.dndController?.onDrop(a,y))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,d){if(!this.dataProvider.resolveTreeItem)return;const y=this.elements.get(a);if(y){const i=this.nodes.get(y);if(i){const v=await this.dataProvider.resolveTreeItem(i.extensionItem,y,d)??i.extensionItem;return i.item.tooltip=this.getTooltip(v.tooltip),i.item.command=this.getCommand(i.disposableStore,v.command),i.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(d=>d?this.resolveUnknownParentChain(d).then(y=>this.resolveTreeNode(d,y[y.length-1]).then(i=>(y.push(i),y))):Promise.resolve([]))}resolveParent(a){const d=this.nodes.get(a);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,d){const y=this.nodes.get(a);return y?Promise.resolve(y):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(i=>this.createHandle(a,i,d,!0)).then(i=>this.getChildren(d?d.item.handle:void 0).then(()=>{const v=this.getExtensionElement(i);if(v){const r=this.nodes.get(v);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(a){if(a){let d;if(typeof a=="string"){const y=this.getExtensionElement(a);d=y?this.nodes.get(y):void 0}else d=a;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const d=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const y=a?this.nodes.get(a):void 0,i=await this.dataProvider.getChildren(a);if(d.token.isCancellationRequested)return;const v=await Promise.all((0,b.coalesce)(i||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,y):null}));return d.token.isCancellationRequested?void 0:(0,b.coalesce)(v)}finally{d.dispose()}}refresh(a){if(a.some(y=>!y))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const y=this.getHandlesToRefresh(a);if(y.length)return this.refreshHandles(y)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const d=new Set,y=a.map(v=>this.nodes.get(v));for(const v of y)if(v&&!d.has(v.item.handle)){let r=v;for(;r&&r.parent&&y.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&d.add(v.item.handle)}const i=[];return d.forEach(v=>{const r=this.elements.get(v);if(r){const s=this.nodes.get(r);s&&(!s.parent||!d.has(s.parent.item.handle))&&i.push(v)}}),i}refreshHandles(a){const d={};return Promise.all(a.map(y=>this.refreshNode(y).then(i=>{i&&(d[y]=i.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(a){const d=this.getExtensionElement(a);if(d){const y=this.nodes.get(d);if(y)return this.clearChildren(d),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(i=>{if(i){const v=this.createTreeNode(d,i,y.parent);return this.updateNodeCache(d,v,y,y.parent),y.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,d,y){const i=this.createTreeNode(a,d,y);if(d.id&&this.elements.has(i.item.handle))throw new Error((0,c.localize)(7,null,d.id));return this.addNodeToCache(a,i),this.addNodeToParentCache(i,y),i}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?n.MarkdownString.from(a):a}getCommand(a,d){return d?this.commands.toInternal(d,a):void 0}createTreeNode(a,d,y){const i=new F.DisposableStore,v=this.createHandle(a,d,y),r=this.getLightIconPath(d);return{item:{handle:v,parentHandle:y?y.item.handle:void 0,label:l(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(i,d.command),contextValue:d.contextValue,icon:r,iconDark:this.getDarkIconPath(d)||r,themeIcon:this.getThemeIcon(d),collapsibleState:(0,t.isUndefinedOrNull)(d.collapsibleState)?P.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:y,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:d,label:y,resourceUri:i},v,r){if(d)return`${D.ID_HANDLE_PREFIX}/${d}`;const s=l(y,this.extension),u=v?v.item.handle:D.LABEL_HANDLE_PREFIX;let h=s?s.label:i?(0,M.basename)(i):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const p=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,I=this.getChildrenNodes(v)||[];let T,g=0;do{if(T=`${u}/${g}:${h}`,r||!this.elements.has(T)||p===T)break;g++}while(g<=I.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||E.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return E.URI.isUri(a)?a:E.URI.file(a)}addNodeToCache(a,d){this.elements.set(d.item.handle,a),this.nodes.set(a,d)}updateNodeCache(a,d,y,i){this.elements.delete(d.item.handle),this.nodes.delete(a),d.item.handle!==y.item.handle&&this.elements.delete(y.item.handle),this.addNodeToCache(a,d);const v=this.getChildrenNodes(i)||[],r=v.filter(s=>s.item.handle===y.item.handle)[0];r&&v.splice(v.indexOf(r),1,d)}addNodeToParentCache(a,d){d?(d.children||(d.children=[]),d.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const d=this.nodes.get(a);if(d){if(d.children)for(const y of d.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}d.children=void 0}}else this.clearAll()}clear(a){const d=this.nodes.get(a);if(d){if(d.children)for(const y of d.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}this.nodes.delete(a),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}D.LABEL_HANDLE_PREFIX="0",D.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,14,3,6,10,48,8,90,67]),function(ne,e,c,M,E,A,F,k,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||f>o.expandLevels)&&(o.expandLevels=f),o.expand===1){const l=this.resolveChildren(o);return l.isOpen()?this.expandChildren(o,f-1):l.wait().then(()=>this.expandChildren(o,f-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,f-1)):this.expandChildren(o,f-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const _ of f.ops)this.onTestItemEvent(n,_);break;case 3:const{key:o,value:l,previous:w}=f,D=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(l,w,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:k.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:k.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[o]:l??null}}]);break}break;default:(0,A.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=P.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),l=(0,F.getPrivateApiFor)(n);l.parent&&l.parent!==f?.actual&&l.parent.children.delete(n.id);let w=this.tree.get(o.toString());if(!w){w={fullId:o,actual:n,parent:f?o.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(n,f),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:k.TestItem.from(n)}]),this.connectItemAndChildren(n,w,f);return}if(w.actual===n){this.connectItem(n,w,f);return}const D=w.actual.children,_=w.actual,a=(0,F.diffTestItems)(_,n);(0,F.getPrivateApiFor)(_).listener=void 0,w.actual=n,w.expand=0;for(const[d,y]of a)this.onTestItemEvent(w,{op:3,key:d,value:y,previous:_[d]});this.connectItemAndChildren(n,w,f);for(const d of D)n.children.get(d.id)||this.removeItem(P.TestId.joinToString(o,d.id))}diffTagRefs(n,f,o){const l=new Set(f.map(w=>w.id));for(const w of n)l.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:o,item:{tags:n.map(w=>k.TestTag.namespace(this.controllerId,w.id))}}]),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,k.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,F.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,o){this.setItemParent(n,o);const l=(0,F.getPrivateApiFor)(n);l.parent=o?.actual,l.listener=w=>this.onTestItemEvent(f,w),this.updateExpandability(f)}connectItemAndChildren(n,f,o){this.connectItem(n,f,o);for(const l of n.children)this.upsertItem(l,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const o=[];for(const l of n.actual.children){const w=this.expand(P.TestId.joinToString(n.fullId,l.id),f);(0,c.isThenable)(w)&&o.push(w)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const w=new c.Barrier;return w.open(),w}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new c.Barrier,o=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=w.stack||w.message||String(w))};let l;try{l=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(w){o(w)}return(0,c.isThenable)(l)?l.catch(o).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[f];for(;o.length;){const l=o.pop();if(!!l){(0,F.getPrivateApiFor)(l.actual).listener=void 0;for(const w of l.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(l.fullId.toString());for(const w of l.actual.children)o.push(this.tree.get(P.TestId.joinToString(l.fullId,w.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let b of t.activationEvents)b==="onUri"&&(b=`onUri:${c.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(t)}}keepOnly(t){const b=new Set;t.forEach(n=>b.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>b.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,b){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(n.map(f=>f.identifier)),b.length>0){const f=new Set;b.forEach(o=>f.add(c.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!f.has(c.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,D){this.addNode(w),this.addNode(D),this._arcs.has(w)?this._arcs.get(w).push(D):this._arcs.set(w,[D])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,D){const _=b.getArcs(w);for(let a=0;a<_.length;a++)if(!D.has(_[a]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let w of t){const D=c.ExtensionIdentifier.toKey(w.identifier);if(n.set(D,w),w.extensionDependencies)for(let _ of w.extensionDependencies){const a=c.ExtensionIdentifier.toKey(_);b.addArc(D,a)}}let f=new Set;b.getNodes().filter(w=>b.getArcs(w).length===0).forEach(w=>f.add(w));let o=b.getNodes().filter(w=>!f.has(w)),l;do{l=!1;for(let w=0;w<o.length;w++){const D=o[w];b.hasOnlyGoodArcs(D,f)&&(o.splice(w,1),w--,f.add(D),l=!0)}}while(l);return o.map(w=>n.get(w))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const b=this._activationMap.get(t);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const b=this._extensionsMap.get(c.ExtensionIdentifier.toKey(t));return b||void 0}}e.ExtensionDescriptionRegistry=F;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function S(P,t){const b=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(b!==n)return b-n;const f=E.posix.basename(P.extensionLocation.path),o=E.posix.basename(t.extensionLocation.path);return f<o?-1:f>o?1:0}}),define(be[178],Ee([0,1,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(k){const S=c.VSBuffer.alloc(1);switch(k){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function F(k,S){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,26,143]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var k;(function(d){d[d.None=0]="None",d[d.LocalProcess=1]="LocalProcess",d[d.LocalWebWorker=2]="LocalWebWorker",d[d.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(d){switch(d){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class P{constructor(y){this.dependency=y}}e.MissingExtensionDependency=P;var t;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(d){switch(d){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;class n{constructor(y,i,v,r){this.codeLoadingTime=y,this.activateCallTime=i,this.activateResolvedTime=v,this.activationReason=r}}e.ActivationTimes=n;class f{constructor(y,i){this.description=y,this.value=i}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var o;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function l(d){d.enableProposedApi||w(d)}e.checkProposedApiEnabled=l;function w(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=w;function D(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=D;function _(d,y){return{identifier:new A.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!y,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid}}e.toExtensionDescription=_;class a{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(y){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(y){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(y,i){return Promise.resolve()}_onWillActivateExtension(y){}_onDidActivateExtension(y,i,v,r,s){}_onDidActivateExtensionError(y,i){}_onExtensionRuntimeError(y,i){}_onExtensionHostExit(y){}}e.NullExtensionService=a}),define(be[179],Ee([0,1,26,30,15]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class F{constructor(o,l,w,D){this.startup=o,this.codeLoadingTime=l,this.activateCallTime=w,this.activateResolvedTime=D}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class k{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,l){return o===-1||l===-1?-1:l-o}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class S{constructor(o,l,w,D,_,a){this.activationFailed=o,this.activationFailedError=l,this.activationTimes=w,this.module=D,this.exports=_,this.subscriptions=a}}e.ActivatedExtension=S;class P extends S{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends S{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class b extends S{constructor(o){super(!0,o,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let n=class{constructor(o,l,w,D,_){this._logService=_,this._registry=o,this._resolvedExtensionsSet=new Set,l.forEach(a=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,w.forEach(a=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(a),a)),this._host=D,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const l=c.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(l)}getActivatedExtension(o){const l=c.ExtensionIdentifier.toKey(o),w=this._activatedExtensions.get(l);if(!w)throw new Error("Extension `"+o.value+"` is not known or not activated");return w}activateByEvent(o,l){if(this._alreadyActivatedEvents[o])return A;const w=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(w.map(D=>({id:D.identifier,reason:{startup:l,extensionId:D.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,l){const w=this._registry.getExtensionDescription(o);if(!w)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:w.identifier,reason:l}])}_handleActivateRequest(o,l,w){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(o.id))){l[c.ExtensionIdentifier.toKey(o.id)]=o;return}const D=this._registry.getExtensionDescription(o.id);if(!D){const d=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,d,new M.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(o.id),new b(d));return}const _=typeof D.extensionDependencies=="undefined"?[]:D.extensionDependencies;let a=!0;for(let d=0,y=_.length;d<y;d++){const i=_[d];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(i)))continue;const v=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(i));if(v&&!v.activationFailed)continue;if(v&&v.activationFailed){const h=D.displayName||D.identifier.value,p=this._registry.getExtensionDescription(i),I=p&&p.displayName||i,T=new Error(`Cannot activate the '${h}' extension because its dependency '${I}' failed to activate`);T.detail=v.activationFailedError,this._host.onExtensionActivationError(D.identifier,T,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(D.identifier),new b(T));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(i))){a=!1,l[c.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(i)),reason:o.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){a=!1,l[c.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:o.reason};continue}const s=D.displayName||D.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(D.identifier,u,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(D.identifier),new b(u));return}a?l[c.ExtensionIdentifier.toKey(D.identifier)]=o:w.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(_=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(_.id))),o.length===0))return Promise.resolve(void 0);const l=Object.create(null),w=[];for(let _=0,a=o.length;_<a;_++)this._handleActivateRequest(o[_],l,w);for(let _=0,a=w.length;_<a;_++){const d=c.ExtensionIdentifier.toKey(w[_].id);l[d]&&delete l[d]}const D=Object.keys(l).map(_=>l[_]);return w.length===0?Promise.all(D.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(D).then(_=>this._activateExtensions(w))}_activateExtension(o,l){const w=c.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const D=this._activatingExtensions.get(w);if(D)return D;const _=this._host.actualActivateExtension(o,l).then(void 0,a=>{const d=new Error;return a&&a.name&&(d.name=a.name),a&&a.message?d.message=`Activating extension '${o.value}' failed: ${a.message}.`:d.message=`Activating extension '${o.value}' failed: ${a}.`,a&&a.stack&&(d.stack=a.stack),this._host.onExtensionActivationError(o,d,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(a),new b(a)}).then(a=>{this._activatedExtensions.set(w,a),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,_),_}};n=$e([Ve(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,F)=>{this._actualOk=A,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,c.onUnexpectedError)(A))}then(A,F){return this._ensureActual().then(A,F)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const M=[];function E(S){const P=new c(!0,S);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=E;function A(S){const P=new c(!1,S);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=A;function F(S){return M[S].sid}e.getStringIdentifierForProxy=F;class k{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=k}),define(be[5],Ee([0,1,54,2,38]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var F;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(a){a.name="$ident";function d(i,v){return Object.defineProperty(i,a.name,{value:v,enumerable:!0}),i}a.mixin=d;function y(i){return i[a.name]}a.of=y})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(d){return d._id=f._n++,d}}e.IdObject=f,f._n=0;var o;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(a){if(a&&a.edits)for(const d of a.edits)typeof d.resource=="object"?d.resource=M.URI.revive(d.resource):(d.newUri=M.URI.revive(d.newUri),d.oldUri=M.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,c.revive)(d.metadata));return a}e.reviveWorkspaceEditDto=D;var _;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[68],Ee([0,1,5,3,4]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,P){return this._proxy.$setPassword(k,S,P)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[69],Ee([0,1,4,15,5,12]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(S,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(E.MainContext.MainThreadTelemetry)}report(S,P,t){const b=this.getUsageKey(S,P);this._reportedUsages.has(b)||(this._reportedUsages.add(b),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}getUsageKey(S,P){return`${S}-${P.identifier.value}`}};F=$e([Ve(0,A.IExtHostRpcService),Ve(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,P){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,P,t,b={}){const n=A.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(n)||[],o=[...t].sort().join(" ");let l=f.find(w=>w.scopes===o);if(l)return l.result;{const w=this._getSession(S,n,P,t,b);l={scopes:o,result:w},f.push(l),this._inFlightRequests.set(n,f);try{await w}finally{const D=f.findIndex(_=>_.scopes===o);D>-1&&(f.splice(D),this._inFlightRequests.set(n,f))}return w}}async _getSession(S,P,t,b,n={}){await this._proxy.$ensureProvider(t);const f=S.displayName||S.name;return this._proxy.$getSession(t,b,P,f,n)}async removeSession(S,P){const t=this._authenticationProviders.get(S);return t?t.provider.removeSession(P):this._proxy.$removeSession(S,P)}registerAuthenticationProvider(S,P,t,b){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:P,provider:t,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===S)||this._providers.push({id:S,label:P});const n=t.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(S,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,P,b?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const f=this._providers.findIndex(o=>o.id===S);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this._onDidChangeSessions.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[182],Ee([0,1,5,12,8]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,S){this._extHostDocumentsAndEditors=S,this._proxy=k.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const S=E.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=$e([Ve(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const F=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(k){return F.$writeText(k)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,13,15,54,44,112,2,6,4,12,48,22,38]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(s,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(F.MainContext.MainThreadCommands),this._logService=u,this.converter=new d(this,h=>{const p=this._apiCommands.get(h);return p?.result===i.Void?p:void 0},u),this._argumentProcessors=[{processArgument(h){return(0,P.revive)(h)}},{processArgument(h){return(0,A.cloneAndChange)(h,function(p){if(t.Range.isIRange(p))return E.Range.to(p);if(b.Position.isIPosition(p))return E.Position.to(p);if(t.Range.isIRange(p.range)&&n.URI.isUri(p.uri))return E.location.to(p);if(p instanceof D.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const u=this.registerCommand(!1,s.id,async(...h)=>{const p=s.args.map((T,g)=>{if(!T.validate(h[g]))throw new Error(`Invalid argument '${T.name}' when running '${s.id}', received: ${h[g]}`);return T.convert(h[g])}),I=await this.executeCommand(s.internalId,...p);return s.result.convert(I,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new M.Disposable(()=>{u.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,u,h,p,I){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:h,thisArg:p,description:I}),s&&this._proxy.$registerCommand(u),new M.Disposable(()=>{this._commands.delete(u)&&s&&this._proxy.$unregisterCommand(u)})}executeCommand(s,...u){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,u,!0)}async _doExecuteCommand(s,u,h){if(this._commands.has(s))return this._executeContributedCommand(s,u);{let p=!1;const I=(0,A.cloneAndChange)(u,function(T){if(T instanceof M.Position)return E.Position.from(T);if(T instanceof M.Range)return E.Range.from(T);if(T instanceof M.Location)return E.location.from(T);if(M.NotebookRange.isNotebookRange(T))return E.NotebookRange.from(T);if(T instanceof ArrayBuffer)return p=!0,D.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return p=!0,D.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await this._proxy.$executeCommand(s,p?new _.SerializableObjectWithBuffers(I):I,h);return(0,P.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(s,u,!1);throw T}}}async _executeContributedCommand(s,u){const h=this._commands.get(s);if(!h)throw new Error("Unknown command");let{callback:p,thisArg:I,description:T}=h;if(T)for(let g=0;g<T.args.length;g++)try{(0,c.validateConstraint)(u[g],T.args[g].constraint)}catch(C){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${T.args[g].name}' - ${T.args[g].description}`)}try{return await p.apply(I,u)}catch(g){if(s===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...u);C&&(s=C.command)}throw this._logService.error(g,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(u=u.map(h=>this._argumentProcessors.reduce((p,I)=>I.processArgument(p),h)),this._executeContributedCommand(s,u)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(u=>(s&&(u=u.filter(h=>h[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[u,h]of this._commands){let{description:p}=h;p&&(s[u]=p)}return Promise.resolve(s)}};a=$e([Ve(0,l.IExtHostRpcService),Ve(1,S.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class d{constructor(s,u,h){this._commands=s,this._lookupApiCommand=u,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,u){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const p=this._lookupApiCommand(s.command);if(p)h.id=p.internalId,h.arguments=p.args.map((I,T)=>I.convert(s.arguments&&s.arguments[T]));else if((0,k.isNonEmptyArray)(s.arguments)){const I=++this._cachIdPool;this._cache.set(I,s),u.add((0,f.toDisposable)(()=>{this._cache.delete(I),this._logService.trace("CommandsConverter#DISPOSE",I)})),h.$ident=I,h.id=this.delegatingCommandId,h.arguments=[I],this._logService.trace("CommandsConverter#CREATE",s.command,I)}return h}fromInternal(s){const u=F.ObjectIdentifier.of(s);return typeof u=="number"?this._cache.get(u):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const u=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class y{constructor(s,u,h,p){this.name=s,this.description=u,this.validate=h,this.convert=p}optional(){return new y(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,u){return new y(s??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=y,y.Uri=new y("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),y.Position=new y("position","A position in a text document",r=>M.Position.isPosition(r),E.Position.from),y.Range=new y("range","A range in a text document",r=>M.Range.isRange(r),E.Range.from),y.Selection=new y("selection","A selection in a text document",r=>M.Selection.isSelection(r),E.Selection.from),y.Number=new y("number","",r=>typeof r=="number",r=>r),y.String=new y("string","",r=>typeof r=="string",r=>r),y.CallHierarchyItem=new y("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),y.TypeHierarchyItem=new y("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),y.TestItem=new y("testItem","A VS Code TestItem",r=>r instanceof w.TestItemImpl,E.TestItem.from);class i{constructor(s,u){this.description=s,this.convert=u}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class v{constructor(s,u,h,p,I){this.id=s,this.internalId=u,this.description=h,this.args=p,this.result=I}}e.ApiCommand=v}),define(be[184],Ee([0,1,8,7,59,39,13,80]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(c.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,F.isFalsyOrEmpty)(n))return;class o extends M.SymbolInformation{static to(w){const D=new o(w.name,c.SymbolKind.to(w.kind),w.containerName||"",new M.Location(f[0],c.Range.to(w.range)));return D.detail=w.detail,D.range=D.location.range,D.selectionRange=c.Range.to(w.selectionRange),D.children=w.children?w.children.map(o.to):[],D}}return n.map(o.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(c.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(c.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>M.Position.isPosition(f)),n=>n.map(c.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let o;for(const l of f.reverse())o=new M.SelectionRange(c.Range.to(l),o);return o}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const f=[];if(Array.isArray(n))for(let o of n)f.push(...o[1].map(c.WorkspaceSymbol.to));return f})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:c.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,k.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,k.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,o)=>{if(!n)return new M.CompletionList([]);const l=n.suggestions.map(w=>c.CompletionItem.to(w,o));return new M.CompletionList(l,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,o)=>t(l=>new M.CodeLens(c.Range.to(l.range),l.command&&o.fromInternal(l.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,o)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(l.command)}else{const w=new M.CodeAction(l.title,l.kind?new M.CodeActionKind(l.kind):void 0);return l.edit&&(w.edit=c.WorkspaceEdit.to(l.edit)),l.command&&(w.command=o.fromInternal(l.command)),w.isPreferred=l.isPreferred,w}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new M.ColorInformation(c.Range.to(f.range),c.Color.to(f.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,c.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>c.NotebookExclusiveDocumentPattern.to(f))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class P{static register(f){S.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=P;function t(n){return f=>{if(Array.isArray(f))return f.map(n)}}function b(n){if(!Array.isArray(n))return;const f=[];for(const o of n)E.isLocationLink(o)?f.push(c.DefinitionLink.to(o)):f.push(c.location.to(o));return f}}),define(be[185],Ee([0,1,14,52,3,6,2,59,26,8,7,5]),function(ne,e,c,M,E,A,F,k,S,P,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,o,l){const w=f.getProxy(b.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const u=this._commentControllers.get(s.handle);return u||s}else if(s&&s.$mid===7){const u=this._commentControllers.get(s.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.commentThreadHandle);return h||s}else if(s&&s.$mid===8){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.thread.commentThreadHandle);return h?{thread:h,text:s.text}:s}else if(s&&s.$mid===9){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let p=s.commentUniqueId,I=h.getCommentByUniqueId(p);return I||s}else if(s&&s.$mid===10){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let p=s.text,I=s.commentUniqueId,T=h.getCommentByUniqueId(I);return T?(T.body=p,T):s}return s}})}createCommentController(s,u,h){const p=D.handlePool++,I=new a(s,p,u,h);this._commentControllers.set(I.handle,I);const T=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(s.identifier))||[];return T.push(I),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(s.identifier),T),I.value}$createCommentThreadTemplate(s,u,h){const p=this._commentControllers.get(s);!p||p.$createCommentThreadTemplate(u,h)}async $updateCommentThreadTemplate(s,u,h){const p=this._commentControllers.get(s);!p||p.$updateCommentThreadTemplate(u,h)}$deleteCommentThread(s,u){const h=this._commentControllers.get(s);h&&h.$deleteCommentThread(u)}$provideCommentingRanges(s,u,h){const p=this._commentControllers.get(s);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const I=l.getDocument(F.URI.revive(u));return(0,c.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(I,h)).then(T=>T?T.map(g=>P.Range.from(g)):void 0)}$toggleReaction(s,u,h,p,I){const T=this._commentControllers.get(s);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const g=T.getCommentThread(u);if(g){const C=g.getCommentByUniqueId(p.uniqueIdInThread);if(T!==void 0&&C&&T.reactionHandler)return T.reactionHandler(C,i(I))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class _{constructor(s,u,h,p,I,T,g){this._commentControllerHandle=u,this._id=h,this._uri=p,this._range=I,this._comments=T,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),w.$createCommentThread(u,this.handle,this._id,this._uri,P.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(u,this.handle)}});const C=this;this.value={get uri(){return C.uri},get range(){return C.range},set range(m){C.range=m},get comments(){return C.comments},set comments(m){C.comments=m},get collapsibleState(){return C.collapsibleState},set collapsibleState(m){C.collapsibleState=m},get canReply(){return C.canReply},set canReply(m){C.canReply=m},get contextValue(){return C.contextValue},set contextValue(m){C.contextValue=m},get label(){return C.label},set label(m){C.label=m},dispose:()=>{C.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const s=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),u={};s("range")&&(u.range=P.Range.from(this._range)),s("label")&&(u.label=this.label),s("contextValue")&&(u.contextValue=this.contextValue),s("comments")&&(u.comments=this._comments.map(h=>d(this,h,this._commentsMap))),s("collapsibleState")&&(u.collapseState=v(this._collapseState)),s("canReply")&&(u.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(s){for(let u of this._commentsMap){let h=u[0],p=u[1];if(s===p)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}_._handlePool=0,$e([(0,M.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(s,u,h,p){this._extension=s,this._handle=u,this._id=h,this._label=p,this._threads=new Map,w.$registerCommentController(this.handle,h,p);const I=this;this.value=Object.freeze({id:I.id,label:I.label,get options(){return I.options},set options(T){I.options=T},get commentingRangeProvider(){return I.commentingRangeProvider},set commentingRangeProvider(T){I.commentingRangeProvider=T},get reactionHandler(){return I.reactionHandler},set reactionHandler(T){I.reactionHandler=T},createCommentThread(T,g,C){return I.createCommentThread(T,g,C).value},dispose:()=>{I.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,u,h,p){if(typeof s=="string"){const I=new _(this.id,this.handle,s,u,h,p,this._extension.identifier);return this._threads.set(I.handle,I),I}else{const I=new _(this.id,this.handle,void 0,s,u,h,this._extension.identifier);return this._threads.set(I.handle,I),I}}$createCommentThreadTemplate(s,u){const h=new _(this.id,this.handle,void 0,F.URI.revive(s),P.Range.to(u),[],this._extension.identifier);return h.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(s,u){let h=this._threads.get(s);h&&(h.range=P.Range.to(u))}$deleteCommentThread(s){let u=this._threads.get(s);u&&u.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function d(r,s,u){let h=u.get(s);h||(h=++r.commentHandle,u.set(s,h));const p=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:h,body:P.MarkdownString.from(s.body),userName:s.author.name,userIconPath:p,label:s.label,commentReactions:s.reactions?s.reactions.map(I=>y(I)):void 0}}function y(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?F.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function v(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,12,15,13,9,17]),function(ne,e,c,M,E,A,F,k,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class vi{constructor(f,o){this._logService=o,this._provider=new Map,this._proxy=f.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,o){const l=vi._handlePool++;this._provider.set(l,{provider:f,extensionId:o}),this._proxy.$registerDecorationProvider(l,o.value);const w=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(l,null);return}let _=(0,S.asArray)(D);if(_.length<=vi._maxEventSize){this._proxy.$onDidChange(l,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,_.length);const a=_.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),d=(0,S.groupBy)(a,(i,v)=>i.rank-v.rank||(0,P.compare)(i.uri.path,v.uri.path));let y=[];e:for(let i of d){let v;for(let r of i){let s=(0,t.dirname)(r.uri.path);if(v!==s&&(v=s,y.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(l,y)});return new E.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(f,o,l){if(!this._provider.has(f))return Object.create(null);const w=Object.create(null),{provider:D,extensionId:_}=this._provider.get(f);return await Promise.all(o.map(async a=>{try{const{uri:d,id:y}=a,i=await Promise.resolve(D.provideFileDecoration(c.URI.revive(d),l));if(!i)return;try{E.FileDecoration.validate(i),w[y]=[i.propagate,i.tooltip,i.badge,i.color]}catch(v){this._logService.warn(`INVALID decoration from extension '${_.value}': ${v}`)}}catch(d){this._logService.error(d)}})),w}};b._handlePool=0,b._maxEventSize=250,b=$e([Ve(0,F.IExtHostRpcService),Ve(1,k.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[186],Ee([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n){"use strict";var f,o,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(a,d,y,i,v,r){this._name=a,this._owner=d,this._maxDiagnosticsPerFile=y,f.set(this,void 0),o.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,et(this,l,new n.SkipList((s,u)=>i.compare(s,u)),"f"),et(this,f,v,"f"),et(this,o,r,"f")}dispose(){this._isDisposed||(Fe(this,o,"f").fire([...Fe(this,l,"f").keys()]),Fe(this,f,"f")&&Fe(this,f,"f").$clear(this._owner),Fe(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,d){if(!a){this.clear();return}this._checkDisposed();let y=[];if(E.URI.isUri(a)){if(!d){this.delete(a);return}Fe(this,l,"f").set(a,d.slice()),y=[a]}else if(Array.isArray(a)){y=[];let v;a=[...a].sort(w._compareIndexedTuplesByUri);for(const r of a){const[s,u]=r;if((!v||s.toString()!==v.toString())&&(v&&Fe(this,l,"f").get(v).length===0&&Fe(this,l,"f").delete(v),v=s,y.push(s),Fe(this,l,"f").set(s,[])),u){const h=Fe(this,l,"f").get(s);h&&h.push(...u)}else{const h=Fe(this,l,"f").get(s);h&&(h.length=0)}}}if(Fe(this,o,"f").fire(y),!Fe(this,f,"f"))return;const i=[];for(let v of y){let r=[];const s=Fe(this,l,"f").get(v);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const u=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let p of s)if(p.severity===u[h]&&r.push(k.Diagnostic.from(p))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(u=>k.Diagnostic.from(u));i.push([v,r])}Fe(this,f,"f").$changeMany(this._owner,i)}delete(a){this._checkDisposed(),Fe(this,o,"f").fire([a]),Fe(this,l,"f").delete(a),Fe(this,f,"f")&&Fe(this,f,"f").$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),Fe(this,o,"f").fire([...Fe(this,l,"f").keys()]),Fe(this,l,"f").clear(),Fe(this,f,"f")&&Fe(this,f,"f").$clear(this._owner)}forEach(a,d){this._checkDisposed();for(let y of Fe(this,l,"f").keys())a.apply(d,[y,this.get(y),this])}get(a){this._checkDisposed();const d=Fe(this,l,"f").get(a);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(Fe(this,l,"f").get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,d){return a[0].toString()<d[0].toString()?-1:a[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=w,f=new WeakMap,o=new WeakMap,l=new WeakMap;let D=class Zt{constructor(a,d,y){this._logService=d,this._fileSystemInfoService=y,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(a){const d=new t.ResourceMap;for(const y of a)d.set(y,y);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(a,d){const{_collections:y,_proxy:i,_onDidChangeDiagnostics:v,_logService:r,_fileSystemInfoService:s}=this,u=new class{$changeMany(I,T){i.$changeMany(I,T),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,I,T.length===0?"CLEARING":T)}$clear(I){i.$clear(I),r.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,I)}dispose(){i.dispose()}};let h;if(!d)d="_generated_diagnostic_collection_name_#"+Zt._idPool++,h=d;else if(!y.has(d))h=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do h=d+Zt._idPool++;while(y.has(h))}return new class extends w{constructor(){super(d,h,Zt._maxDiagnosticsPerFile,s.extUri,u,v);y.set(h,this)}dispose(){super.dispose(),y.delete(h)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const d=new Map,y=[];for(const i of this._collections.values())i.forEach((v,r)=>{let s=d.get(v.toString());typeof s=="undefined"&&(s=y.length,d.set(v.toString(),s),y.push([v,[]])),y[s][1]=y[s][1].concat(...r)});return y}}_getDiagnostics(a){let d=[];for(let y of this._collections.values())y.has(a)&&(d=d.concat(y.get(a)));return d}$acceptMarkersChange(a){if(!this._mirrorCollection){const d="_generated_mirror",y=new w(d,d,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(d,y),this._mirrorCollection=y}for(const[d,y]of a)this._mirrorCollection.set(E.URI.revive(d),y.map(k.Diagnostic.to))}};D._idPool=0,D._maxDiagnosticsPerFile=1e3,D=$e([Ve(1,P.ILogService),Ve(2,b.IExtHostFileSystemInfo)],D),e.ExtHostDiagnostics=D}),define(be[187],Ee([0,1,2,5]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(k=>k?k.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(k=>k?c.URI.revive(k):void 0)}}e.ExtHostDialogs=E}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(b,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=b.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,n){if(Object.keys(F.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const f=P._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,b);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(l=>{if(l.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(f,l).then(w=>{if(!w&&typeof w!="string")return;const D=this._documentsAndEditors.getDocument(l);if(!D)return;const _=(0,S.splitLines)(w);if(!D.equalLines(_))return this._proxy.$onVirtualDocumentChange(l,w)},c.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(b,n){const f=this._documentContentProviders.get(b);return f?Promise.resolve(f.provideTextDocumentContent(M.URI.revive(n),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(ne,e,c,M,E,A,F,k,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(f,o){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const w of l)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const w of l)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const o=this._documentsAndEditors.getDocument(f);if(o)return o}getDocument(f){const o=this.getDocumentData(f);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return o.document}ensureDocumentData(f){const o=this._documentsAndEditors.getDocument(f);if(o)return Promise.resolve(o);let l=this._documentLoader.get(f.toString());return l||(l=this._proxy.$tryOpenDocument(f).then(w=>{this._documentLoader.delete(f.toString());const D=E.URI.revive(w);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(D))},w=>(this._documentLoader.delete(f.toString()),Promise.reject(w))),this._documentLoader.set(f.toString(),l)),l}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(o=>E.URI.revive(o))}$acceptModelModeChanged(f,o){const l=E.URI.revive(f),w=this._documentsAndEditors.getDocument(l);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(o),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(f){const o=E.URI.revive(f),l=this._documentsAndEditors.getDocument(o);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(f,o){const l=E.URI.revive(f),w=this._documentsAndEditors.getDocument(l);if(!w)throw new Error("unknown document");w._acceptIsDirty(o),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,o,l){const w=E.URI.revive(f),D=this._documentsAndEditors.getDocument(w);if(!D)throw new Error("unknown document");D._acceptIsDirty(l),D.onEvents(o);let _;o.isUndoing?_=t.TextDocumentChangeReason.Undo:o.isRedoing&&(_=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:D.document,contentChanges:o.changes.map(a=>({range:k.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:_}))}setWordDefinitionFor(f,o){(0,F.setWordDefinitionFor)(f,o)}}e.ExtHostDocuments=b}),define(be[49],Ee([0,1,42,3,6,2,4,5,88,12,94,8,15,20,11,232,103]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(d,y){this._extHostRpc=d,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const y=[],i=[],v=[];if(d.removedDocuments)for(const r of d.removedDocuments){const s=A.URI.revive(r),u=this._documents.get(s);u?.unref()&&(this._documents.delete(s),y.push(u.value))}if(d.addedDocuments)for(const r of d.addedDocuments){const s=A.URI.revive(r.uri);let u=this._documents.get(s);if(u&&s.scheme!==o.Schemas.vscodeNotebookCell&&s.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);u||(u=new D(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,u),i.push(u.value)),u.ref()}if(d.removedEditors)for(const r of d.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&v.push(s)}if(d.addedEditors)for(const r of d.addedEditors){const s=A.URI.revive(r.documentUri);c.ok(this._documents.has(s),`document '${s}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const u=this._documents.get(s).value,h=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>u.document),r.selections.map(b.Selection.to),r.options,r.visibleRanges.map(p=>b.Range.to(p)),typeof r.editorPosition=="number"?b.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,h)}d.newActiveEditor!==void 0&&(c.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,E.dispose)(y),(0,E.dispose)(v),d.removedDocuments&&this._onDidRemoveDocuments.fire(y),d.addedDocuments&&this._onDidAddDocuments.fire(i),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return d?y:y?.value}allEditors(){return[...this._editors.values()]}};_=$e([Ve(0,P.IExtHostRpcService),Ve(1,n.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[70],Ee([0,1,8,5,2,3,4,12,14]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let P=class{constructor(b){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let n=-1;this._tabs=b.map((o,l)=>(o.isActive&&(n=l),Object.freeze({label:o.label,viewColumn:c.ViewColumn.to(o.viewColumn),index:l,resource:E.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:w,viewId:D})=>({resource:E.URI.revive(w),viewId:D})),viewId:o.editorId,isActive:o.isActive,move:async(w,D)=>{this._proxy.$moveTab(o,w,c.ViewColumn.from(D)),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,l)=>o.viewColumn===l.viewColumn?o.index-l.index:o.viewColumn-l.viewColumn);const f=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=$e([Ve(0,k.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,22]),function(ne,e,c,M,E,A,F,k,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const o=this._schemes.indexOf(f);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),o=[];let l,w,D=14,_=14;for(const a of f){let d=l?(0,S.commonPrefixLength)(l,a):0;for(d===0?w=1:w=_;d<a.length;d++)d+1===a.length?(D=_,_=9):_+=1,o.push([w,a.toUpperCase().charCodeAt(d),_]),o.push([w,a.toLowerCase().charCodeAt(d),_]),w=_;l=a,_=D}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new k.StateMachine(o)}}provideDocumentLinks(f){this._initStateMachine();const o=[],l=k.LinkComputer.computeLinks({getLineContent(w){return f.lineAt(w-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const w of l){const D=F.DocumentLink.to(w);D.target&&o.push(D)}return o}}class b{constructor(f,o){this._extHostLanguageFeatures=o,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,o,l,w={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const D=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(D,l);let _=2;w.isCaseSensitive&&(_+=1024),w.isReadonly&&(_+=2048),typeof l.copy=="function"&&(_+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(D,o,_).catch(d=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${o}`),console.error(d)});const a=l.onDidChangeFile(d=>{const y=[];for(const i of d){let{uri:v,type:r}=i;if(v.scheme!==o)continue;let s;switch(r){case A.FileChangeType.Changed:s=0;break;case A.FileChangeType.Created:s=1;break;case A.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}y.push({resource:v,type:s})}this._proxy.$onFileSystemChange(D,y)});return(0,E.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(D),this._proxy.$unregisterProvider(D)})}static _asIStat(f){const{type:o,ctime:l,mtime:w,size:D,permissions:_}=f;return{type:o,ctime:l,mtime:w,size:D,permissions:_}}$stat(f,o){return Promise.resolve(this._getFsProvider(f).stat(c.URI.revive(o))).then(l=>b._asIStat(l))}$readdir(f,o){return Promise.resolve(this._getFsProvider(f).readDirectory(c.URI.revive(o)))}$readFile(f,o){return Promise.resolve(this._getFsProvider(f).readFile(c.URI.revive(o))).then(l=>P.VSBuffer.wrap(l))}$writeFile(f,o,l,w){return Promise.resolve(this._getFsProvider(f).writeFile(c.URI.revive(o),l.buffer,w))}$delete(f,o,l){return Promise.resolve(this._getFsProvider(f).delete(c.URI.revive(o),l))}$rename(f,o,l,w){return Promise.resolve(this._getFsProvider(f).rename(c.URI.revive(o),c.URI.revive(l),w))}$copy(f,o,l,w){const D=this._getFsProvider(f);if(!D.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(D.copy(c.URI.revive(o),c.URI.revive(l),w))}$mkdir(f,o){return Promise.resolve(this._getFsProvider(f).createDirectory(c.URI.revive(o)))}$watch(f,o,l,w){const D=this._getFsProvider(f).watch(c.URI.revive(l),w);this._watches.set(o,D)}$unwatch(f,o){const l=this._watches.get(o);l&&(l.dispose(),this._watches.delete(o))}$open(f,o,l){const w=this._getFsProvider(f);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(c.URI.revive(o),l))}$close(f,o){const l=this._getFsProvider(f);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(o))}$read(f,o,l,w){const D=this._getFsProvider(f);if(!D.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(w);return Promise.resolve(D.read(o,l,_.buffer,0,w)).then(a=>_.slice(0,a))}$write(f,o,l,w){const D=this._getFsProvider(f);if(!D.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(D.write(o,l,w.buffer,0,w.byteLength))}_getFsProvider(f){const o=this._fsProvider.get(f);if(!o){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return o}}e.ExtHostFileSystem=b}),define(be[71],Ee([0,1,5,60,7,22,4,12,37]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(b,n){const f=b.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return f.$stat(o).catch(Ut._handleError)},readDirectory(o){return f.$readdir(o).catch(Ut._handleError)},createDirectory(o){return f.$mkdir(o).catch(Ut._handleError)},async readFile(o){return f.$readFile(o).then(l=>l.buffer).catch(Ut._handleError)},writeFile(o,l){return f.$writeFile(o,A.VSBuffer.wrap(l)).catch(Ut._handleError)},delete(o,l){return f.$delete(o,{recursive:!1,useTrash:!1,...l}).catch(Ut._handleError)},rename(o,l,w){return f.$rename(o,l,{overwrite:!1,...w}).catch(Ut._handleError)},copy(o,l,w){return f.$copy(o,l,{overwrite:!1,...w}).catch(Ut._handleError)},isWritableFileSystem(o){const l=n.getCapabilities(o);if(typeof l=="number")return!(l&2048)}})}static _handleError(b){if(!(b instanceof Error))throw new E.FileSystemError(String(b));if(b.name==="ENOPRO")throw E.FileSystemError.Unavailable(b.message);switch(b.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(b.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(b.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(b.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(b.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(b.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(b.message);default:throw new E.FileSystemError(b.message,b.name)}}};P=$e([Ve(0,k.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(F,k,S,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new M.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new M.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new M.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new M.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:c.URI.revive(b.notebookUri),inputUri:c.URI.revive(b.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(b.notebookUri),inputUri:c.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,k,S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:S,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=E}),define(be[192],Ee([0,1,6,5]),function(ne,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,F),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=E}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,13,10,234,6,80,53,63,194,16,3]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(x,G){this._documents=x,this._provider=G}async provideDocumentSymbols(x,G){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentSymbols(te,G);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(E.DocumentSymbol.from):a._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((ae,j)=>{let se=ae.location.range.start.compareTo(j.location.range.start);return se===0&&(se=j.location.range.end.compareTo(ae.location.range.end)),se});const G=[],te=[];for(const ae of x){const j={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(te.length===0){te.push(j),G.push(j);break}const se=te[te.length-1];if(S.Range.containsRange(se.range,j.range)&&!S.Range.equalsRange(se.range,j.range)){se.children&&se.children.push(j),te.push(j);break}te.pop()}}return G}}class d{constructor(x,G,te){this._documents=x,this._commands=G,this._provider=te,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,G){const te=this._documents.getDocument(x),ae=await this._provider.provideCodeLenses(te,G);if(!ae||G.isCancellationRequested)return;const j=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(j,se);const he={cacheId:j,lenses:[]};for(let Re=0;Re<ae.length;Re++)he.lenses.push({cacheId:[j,Re],range:E.Range.from(ae[Re].range),command:this._commands.toInternal(ae[Re].command,se)});return he}async resolveCodeLens(x,G){const te=x.cacheId&&this._cache.get(...x.cacheId);if(!te)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ae=te:ae=await this._provider.resolveCodeLens(te,G),ae||(ae=te),G.isCancellationRequested)return;const j=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!j)return x.command=this._commands.toInternal(ae.command??d._badCmd,j),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(qe){return Array.isArray(qe)?qe.map(E.DefinitionLink.from):qe?[E.DefinitionLink.from(qe)]:[]}class i{constructor(x,G){this._documents=x,this._provider=G}async provideDefinition(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideDefinition(ae,j,te);return y(se)}}class v{constructor(x,G){this._documents=x,this._provider=G}async provideDeclaration(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideDeclaration(ae,j,te);return y(se)}}class r{constructor(x,G){this._documents=x,this._provider=G}async provideImplementation(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideImplementation(ae,j,te);return y(se)}}class s{constructor(x,G){this._documents=x,this._provider=G}async provideTypeDefinition(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideTypeDefinition(ae,j,te);return y(se)}}class u{constructor(x,G){this._documents=x,this._provider=G}async provideHover(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideHover(ae,j,te);if(!(!se||(0,P.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(j)),se.range||(se.range=new A.Range(j,j)),E.Hover.from(se)}}class h{constructor(x,G){this._documents=x,this._provider=G}async provideEvaluatableExpression(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideEvaluatableExpression(ae,j,te);if(se)return E.EvaluatableExpression.from(se)}}class p{constructor(x,G){this._documents=x,this._provider=G}async provideInlineValues(x,G,te,ae){const j=this._documents.getDocument(x),se=await this._provider.provideInlineValues(j,E.Range.to(G),E.InlineValueContext.to(te),ae);if(Array.isArray(se))return se.map(he=>E.InlineValue.from(he))}}class I{constructor(x,G){this._documents=x,this._provider=G}async provideDocumentHighlights(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideDocumentHighlights(ae,j,te);if(Array.isArray(se))return se.map(E.DocumentHighlight.from)}}class T{constructor(x,G){this._documents=x,this._provider=G}async provideLinkedEditingRanges(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.provideLinkedEditingRanges(ae,j,te);if(se&&Array.isArray(se.ranges))return{ranges:(0,P.coalesce)(se.ranges.map(E.Range.from)),wordPattern:se.wordPattern}}}class g{constructor(x,G){this._documents=x,this._provider=G}async provideReferences(x,G,te,ae){const j=this._documents.getDocument(x),se=E.Position.to(G),he=await this._provider.provideReferences(j,se,te,ae);if(Array.isArray(he))return he.map(E.location.from)}}class C{constructor(x,G,te,ae,j,se,he){this._documents=x,this._commands=G,this._diagnostics=te,this._provider=ae,this._logService=j,this._extension=se,this._apiDeprecation=he,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,G,te,ae){const j=this._documents.getDocument(x),se=b.Selection.isISelection(G)?E.Selection.to(G):E.Range.to(G),he=[];for(const ke of this._diagnostics.getDiagnostics(x))if(se.intersection(ke.range)&&he.push(ke)>C._maxCodeActionsPerFile)break;const Re={diagnostics:he,only:te.only?new A.CodeActionKind(te.only):void 0,triggerKind:E.CodeActionTriggerKind.to(te.trigger)},Be=await this._provider.provideCodeActions(j,se,Re,ae);if(!(0,P.isNonEmptyArray)(Be)||ae.isCancellationRequested)return;const ze=this._cache.add(Be),Qe=new n.DisposableStore;this._disposables.set(ze,Qe);const it=[];for(let ke=0;ke<Be.length;ke++){const Ze=Be[ke];!Ze||(C._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,Qe)})):(Re.only&&(Ze.kind?Re.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[ze,ke],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,Qe),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(E.Diagnostic.from),edit:Ze.edit&&E.WorkspaceEdit.from(Ze.edit),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:ze,actions:it}}async resolveCodeAction(x,G){const[te,ae]=x,j=this._cache.get(te,ae);if(!j||C._isCommand(j)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(j,G)??j;return se?.edit?E.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}C._maxCodeActionsPerFile=1e3;class m{constructor(x,G){this._documents=x,this._provider=G}async provideDocumentFormattingEdits(x,G,te){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentFormattingEdits(ae,G,te);if(Array.isArray(j))return j.map(E.TextEdit.from)}}class R{constructor(x,G){this._documents=x,this._provider=G}async provideDocumentRangeFormattingEdits(x,G,te,ae){const j=this._documents.getDocument(x),se=E.Range.to(G),he=await this._provider.provideDocumentRangeFormattingEdits(j,se,te,ae);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class L{constructor(x,G){this._documents=x,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,G,te,ae,j){const se=this._documents.getDocument(x),he=E.Position.to(G),Re=await this._provider.provideOnTypeFormattingEdits(se,he,te,ae,j);if(Array.isArray(Re))return Re.map(E.TextEdit.from)}}class V{constructor(x,G){this._provider=x,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,G){const te=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(x,G);if((0,P.isNonEmptyArray)(ae))for(const j of ae){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const se=F.IdObject.mixin(E.WorkspaceSymbol.from(j));this._symbolCache.set(se._id,j),te.symbols.push(se)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(x,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const te=this._symbolCache.get(x._id);if(te){const ae=await this._provider.resolveWorkspaceSymbol(te,G);return ae&&(0,M.mixin)(x,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(x){const G=this._resultCache.get(x);if(G){for(let[te,ae]=G;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(x)}}}class q{constructor(x,G,te){this._documents=x,this._provider=G,this._logService=te}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,G,te,ae){const j=this._documents.getDocument(x),se=E.Position.to(G);try{const he=await this._provider.provideRenameEdits(j,se,te,ae);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Re=q._asMessage(he);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(x,G,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(x),j=E.Position.to(G);try{const se=await this._provider.prepareRename(ae,j,te);let he,Re;if(A.Range.isRange(se)?(he=se,Re=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Re=se.placeholder),!he||!Re)return;if(he.start.line>j.line||he.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Re}}catch(se){const he=q._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class U{constructor(x,G){this.resultId=x,this.tokens=G}}class K{constructor(x,G){this._documents=x,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,G,te){const ae=this._documents.getDocument(x),j=G!==0?this._previousResults.get(G):null;let se=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,j.resultId,te):await this._provider.provideDocumentSemanticTokens(ae,te);return j&&this._previousResults.delete(G),se?(se=K._fixProvidedSemanticTokens(se),this._send(K._convertToEdits(j,se),se)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return K._isSemanticTokens(x)?K._isCorrectSemanticTokens(x)?x:new A.SemanticTokens(new Uint32Array(x.data),x.resultId):K._isSemanticTokensEdits(x)?K._isCorrectSemanticTokensEdits(x)?x:new A.SemanticTokensEdits(x.edits.map(G=>new A.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const G of x.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,G){if(!K._isSemanticTokens(G)||!x||!x.tokens)return G;const te=x.tokens,ae=te.length,j=G.data,se=j.length;let he=0;const Re=Math.min(ae,se);for(;he<Re&&te[he]===j[he];)he++;if(he===ae&&he===se)return new A.SemanticTokensEdits([],G.resultId);let Be=0;const ze=Re-he;for(;Be<ze&&te[ae-Be-1]===j[se-Be-1];)Be++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Be,data:j.subarray(he,se-Be)}],G.resultId)}_send(x,G){if(K._isSemanticTokens(x)){const te=this._nextResultId++;return this._previousResults.set(te,new U(x.resultId,x.data)),(0,f.encodeSemanticTokensDto)({id:te,type:"full",data:x.data})}if(K._isSemanticTokensEdits(x)){const te=this._nextResultId++;return K._isSemanticTokens(G)?this._previousResults.set(te,new U(G.resultId,G.data)):this._previousResults.set(te,new U(x.resultId)),(0,f.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(x.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class ${constructor(x,G){this._documents=x,this._provider=G}async provideDocumentRangeSemanticTokens(x,G,te){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(G),te);return j?this._send(j):null}_send(x){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=$;class B{constructor(x,G,te,ae,j){this._documents=x,this._commands=G,this._provider=te,this._apiDeprecation=ae,this._extension=j,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,G,te,ae){const j=this._documents.getDocument(x),se=E.Position.to(G),he=j.getWordRangeAtPosition(se)||new A.Range(se,se),Re=he.with({end:se}),Be=new w.StopWatch(!0),ze=await this._provider.provideCompletionItems(j,se,ae,E.CompletionContext.to(te));if(!ze||ae.isCancellationRequested)return;const Qe=Array.isArray(ze)?new A.CompletionList(ze):ze,it=B.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),ke=new n.DisposableStore;this._disposables.set(it,ke);const Ze=[],z={x:it,b:Ze,a:{replace:E.Range.from(he),insert:E.Range.from(Re)},c:Qe.isIncomplete||void 0,d:Be.elapsed()};for(let J=0;J<Qe.items.length;J++){const me=Qe.items[J],He=this._convertCompletionItem(me,[it,J],Re,he);Ze.push(He)}return z}async resolveCompletionItem(x,G){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...x);if(!te)return;const ae=await this._provider.resolveCompletionItem(te,G);if(!!ae)return this._convertCompletionItem(ae,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,G,te,ae){const j=this._disposables.get(G[0]);if(!j)throw Error("DisposableStore is missing...");const se={x:G,a:x.label,b:x.kind!==void 0?E.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(E.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(x.command,j)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=x.textEdit.newText):typeof x.insertText=="string"?se.h=x.insertText:x.insertText instanceof A.SnippetString&&(se.h=x.insertText.value,se.i|=4);let he;return x.textEdit?he=x.textEdit.range:x.range&&(he=x.range),A.Range.isRange(he)?se.j=E.Range.from(he):he&&(!te?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),se}}class H{constructor(x,G,te){this._documents=x,this._provider=G,this._commands=te,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,G,te,ae){const j=this._documents.getDocument(x),se=E.Position.to(G),he=await this._provider.provideInlineCompletionItems(j,se,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:E.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Re=(0,t.isArray)(he)?{items:he}:he,Be=this._cache.add(Re.items);let ze;return{pid:Be,items:Re.items.map((Qe,it)=>{let ke;return Qe.command&&(ze||(ze=new n.DisposableStore,this._disposables.set(Be,ze)),ke=this._commands.toInternal(Qe.command,ze)),{text:Qe.text,range:Qe.range?E.Range.from(Qe.range):void 0,command:ke,idx:it}})}}disposeCompletions(x){this._cache.delete(x);const G=this._disposables.get(x);G&&G.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,G){const te=this._cache.get(x,G);te&&Q.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class Q{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let G=Q.map.get(x);return G||(G=new Q,Q.map.set(x,G)),G}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=Q,Q.map=new WeakMap;class re{constructor(x,G){this._documents=x,this._provider=G,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(x,G,te,ae){const j=this._documents.getDocument(x),se=E.Position.to(G),he=this.reviveContext(te),Re=await this._provider.provideSignatureHelp(j,se,ae,he);if(Re){const Be=this._cache.add([Re]);return{...E.SignatureHelp.from(Re),id:Be}}}reviveContext(x){let G;if(x.activeSignatureHelp){const te=E.SignatureHelp.to(x.activeSignatureHelp),ae=this._cache.get(x.activeSignatureHelp.id,0);ae?(G=ae,G.activeSignature=te.activeSignature,G.activeParameter=te.activeParameter):G=te}return{...x,activeSignatureHelp:G}}releaseSignatureHelp(x){this._cache.delete(x)}}class ue{constructor(x,G){this._documents=x,this._provider=G}async provideInlayHints(x,G,te){const ae=this._documents.getDocument(x),j=await this._provider.provideInlayHints(ae,E.Range.to(G),te);return j?{hints:j.map(E.InlayHint.from)}:void 0}}class Z{constructor(x,G){this._documents=x,this._provider=G,this._cache=new l.Cache("DocumentLink")}async provideLinks(x,G){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentLinks(te,G);if(!(!Array.isArray(ae)||ae.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Z._validateLink).map(E.DocumentLink.from)};{const j=this._cache.add(ae),se={links:[],id:j};for(let he=0;he<ae.length;he++){if(!Z._validateLink(ae[he]))continue;const Re=E.DocumentLink.from(ae[he]);Re.cacheId=[j,he],se.links.push(Re)}return se}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,G){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...x);if(!te)return;const ae=await this._provider.resolveDocumentLink(te,G);if(!(!ae||!Z._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks(x){this._cache.delete(x)}}class oe{constructor(x,G){this._documents=x,this._provider=G}async provideColors(x,G){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentColors(te,G);return Array.isArray(ae)?ae.map(se=>({color:E.Color.from(se.color),range:E.Range.from(se.range)})):[]}async provideColorPresentations(x,G,te){const ae=this._documents.getDocument(x),j=E.Range.to(G.range),se=E.Color.to(G.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:j},te);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class ve{constructor(x,G){this._documents=x,this._provider=G}async provideFoldingRanges(x,G,te){const ae=this._documents.getDocument(x),j=await this._provider.provideFoldingRanges(ae,G,te);if(!!Array.isArray(j))return j.map(E.FoldingRange.from)}}class Ae{constructor(x,G,te){this._documents=x,this._provider=G,this._logService=te}async provideSelectionRanges(x,G,te){const ae=this._documents.getDocument(x),j=G.map(E.Position.to),se=await this._provider.provideSelectionRanges(ae,j,te);if(!(0,P.isNonEmptyArray)(se))return[];if(se.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Re=0;Re<j.length;Re++){const Be=[];he.push(Be);let ze=j[Re],Qe=se[Re];for(;;){if(!Qe.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(E.SelectionRange.from(Qe)),!Qe.parent)break;ze=Qe.range,Qe=Qe.parent}}return he}}class Se{constructor(x,G){this._documents=x,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.prepareCallHierarchy(ae,j,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo(x,G,te){const ae=this._itemFromCache(x,G);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!j)return j.map(se=>({from:this._cacheAndConvertItem(x,se.from),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom(x,G,te){const ae=this._itemFromCache(x,G);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!j)return j.map(se=>({to:this._cacheAndConvertItem(x,se.to),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,G){const te=this._cache.get(x),ae=E.CallHierarchyItem.from(G,x,te.size.toString(36));return te.set(ae._itemId,G),ae}_itemFromCache(x,G){return this._cache.get(x)?.get(G)}}class Ne{constructor(x,G){this._documents=x,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(x,G,te){const ae=this._documents.getDocument(x),j=E.Position.to(G),se=await this._provider.prepareTypeHierarchy(ae,j,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes(x,G,te){const ae=this._itemFromCache(x,G);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(ae,te);if(!!j)return j.map(se=>this._cacheAndConvertItem(x,se))}async provideSubtypes(x,G,te){const ae=this._itemFromCache(x,G);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(ae,te);if(!!j)return j.map(se=>this._cacheAndConvertItem(x,se))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,G){const te=this._cache.get(x),ae=E.TypeHierarchyItem.from(G,x,te.size.toString(36));return te.set(ae._itemId,G),ae}_itemFromCache(x,G){return this._cache.get(x)?.get(G)}}class We{constructor(x,G){this.adapter=x,this.extension=G}}class je{constructor(x,G,te,ae,j,se,he){this._adapter=new Map,this._uriTransformer=G,this._proxy=x.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=j,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector(x){return E.DocumentSelector.from(x,this._uriTransformer)}_createDisposable(x){return new A.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return je._handlePool++}_withAdapter(x,G,te,ae,j=!1){const se=this._adapter.get(x);if(!se)return Promise.resolve(ae);if(se.adapter instanceof G){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${G.name}'`));const Re=te(se.adapter,se.extension),Be=se.extension;return Be&&Promise.resolve(Re).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),ze=>{j&&ze instanceof D.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(ze))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,G){const te=this._nextHandle();return this._adapter.set(te,new We(x,G)),te}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,G,te,ae){const j=this._addNewAdapter(new a(this._documents,te),x),se=ae&&ae.label||je._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(G),se),this._createDisposable(j)}$provideDocumentSymbols(x,G,te){return this._withAdapter(x,a,ae=>ae.provideDocumentSymbols(c.URI.revive(G),te),void 0)}registerCodeLensProvider(x,G,te){const ae=this._nextHandle(),j=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new d(this._documents,this._commands.converter,te),x)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(G),j);let se=this._createDisposable(ae);if(j!==void 0){const he=te.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(j));se=A.Disposable.from(se,he)}return se}$provideCodeLenses(x,G,te){return this._withAdapter(x,d,ae=>ae.provideCodeLenses(c.URI.revive(G),te),void 0)}$resolveCodeLens(x,G,te){return this._withAdapter(x,d,ae=>ae.resolveCodeLens(G,te),void 0)}$releaseCodeLenses(x,G){this._withAdapter(x,d,te=>Promise.resolve(te.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(x,G,te){const ae=this._addNewAdapter(new i(this._documents,te),x);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDefinition(x,G,te,ae){return this._withAdapter(x,i,j=>j.provideDefinition(c.URI.revive(G),te,ae),[])}registerDeclarationProvider(x,G,te){const ae=this._addNewAdapter(new v(this._documents,te),x);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDeclaration(x,G,te,ae){return this._withAdapter(x,v,j=>j.provideDeclaration(c.URI.revive(G),te,ae),[])}registerImplementationProvider(x,G,te){const ae=this._addNewAdapter(new r(this._documents,te),x);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideImplementation(x,G,te,ae){return this._withAdapter(x,r,j=>j.provideImplementation(c.URI.revive(G),te,ae),[])}registerTypeDefinitionProvider(x,G,te){const ae=this._addNewAdapter(new s(this._documents,te),x);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideTypeDefinition(x,G,te,ae){return this._withAdapter(x,s,j=>j.provideTypeDefinition(c.URI.revive(G),te,ae),[])}registerHoverProvider(x,G,te,ae){const j=this._addNewAdapter(new u(this._documents,te),x);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideHover(x,G,te,ae){return this._withAdapter(x,u,j=>j.provideHover(c.URI.revive(G),te,ae),void 0)}registerEvaluatableExpressionProvider(x,G,te,ae){const j=this._addNewAdapter(new h(this._documents,te),x);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideEvaluatableExpression(x,G,te,ae){return this._withAdapter(x,h,j=>j.provideEvaluatableExpression(c.URI.revive(G),te,ae),void 0)}registerInlineValuesProvider(x,G,te,ae){const j=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new p(this._documents,te),x);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(G),j);let he=this._createDisposable(se);if(j!==void 0){const Re=te.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(j));he=A.Disposable.from(he,Re)}return he}$provideInlineValues(x,G,te,ae,j){return this._withAdapter(x,p,se=>se.provideInlineValues(c.URI.revive(G),te,ae,j),void 0)}registerDocumentHighlightProvider(x,G,te){const ae=this._addNewAdapter(new I(this._documents,te),x);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentHighlights(x,G,te,ae){return this._withAdapter(x,I,j=>j.provideDocumentHighlights(c.URI.revive(G),te,ae),void 0)}registerLinkedEditingRangeProvider(x,G,te){const ae=this._addNewAdapter(new T(this._documents,te),x);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideLinkedEditingRanges(x,G,te,ae){return this._withAdapter(x,T,async j=>{const se=await j.provideLinkedEditingRanges(c.URI.revive(G),te,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?je._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(x,G,te){const ae=this._addNewAdapter(new g(this._documents,te),x);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideReferences(x,G,te,ae,j){return this._withAdapter(x,g,se=>se.provideReferences(c.URI.revive(G),te,ae,j),void 0)}registerCodeActionProvider(x,G,te,ae){const j=new n.DisposableStore,se=this._addNewAdapter(new C(this._documents,this._commands.converter,this._diagnostics,te,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(G),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,j)}))},je._extLabel(x),Boolean(te.resolveCodeAction)),j.add(this._createDisposable(se)),j}$provideCodeActions(x,G,te,ae,j){return this._withAdapter(x,C,se=>se.provideCodeActions(c.URI.revive(G),te,ae,j),void 0)}$resolveCodeAction(x,G,te){return this._withAdapter(x,C,ae=>ae.resolveCodeAction(G,te),void 0)}$releaseCodeActions(x,G){this._withAdapter(x,C,te=>Promise.resolve(te.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(x,G,te){const ae=this._addNewAdapter(new m(this._documents,te),x);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(G),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(x,G,te,ae){return this._withAdapter(x,m,j=>j.provideDocumentFormattingEdits(c.URI.revive(G),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(x,G,te){const ae=this._addNewAdapter(new R(this._documents,te),x);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(G),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(x,G,te,ae,j){return this._withAdapter(x,R,se=>se.provideDocumentRangeFormattingEdits(c.URI.revive(G),te,ae,j),void 0)}registerOnTypeFormattingEditProvider(x,G,te,ae){const j=this._addNewAdapter(new L(this._documents,te),x);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(G),ae,x.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits(x,G,te,ae,j,se){return this._withAdapter(x,L,he=>he.provideOnTypeFormattingEdits(c.URI.revive(G),te,ae,j,se),void 0)}registerWorkspaceSymbolProvider(x,G){const te=this._addNewAdapter(new V(G,this._logService),x);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(x,G,te){return this._withAdapter(x,V,ae=>ae.provideWorkspaceSymbols(G,te),{symbols:[]})}$resolveWorkspaceSymbol(x,G,te){return this._withAdapter(x,V,ae=>ae.resolveWorkspaceSymbol(G,te),void 0)}$releaseWorkspaceSymbols(x,G){this._withAdapter(x,V,te=>te.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(x,G,te){const ae=this._addNewAdapter(new q(this._documents,te,this._logService),x);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(G),q.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(x,G,te,ae,j){return this._withAdapter(x,q,se=>se.provideRenameEdits(c.URI.revive(G),te,ae,j),void 0)}$resolveRenameLocation(x,G,te,ae){return this._withAdapter(x,q,j=>j.resolveRenameLocation(c.URI.revive(G),te,ae),void 0)}registerDocumentSemanticTokensProvider(x,G,te,ae){const j=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new We(new K(this._documents,te),x)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(G),ae,se);let he=this._createDisposable(j);if(se){const Re=te.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=A.Disposable.from(he,Re)}return he}$provideDocumentSemanticTokens(x,G,te,ae){return this._withAdapter(x,K,j=>j.provideDocumentSemanticTokens(c.URI.revive(G),te,ae),null,!0)}$releaseDocumentSemanticTokens(x,G){this._withAdapter(x,K,te=>te.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(x,G,te,ae){const j=this._addNewAdapter(new $(this._documents,te),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(G),ae),this._createDisposable(j)}$provideDocumentRangeSemanticTokens(x,G,te,ae){return this._withAdapter(x,$,j=>j.provideDocumentRangeSemanticTokens(c.URI.revive(G),te,ae),null,!0)}registerCompletionItemProvider(x,G,te,ae){const j=this._addNewAdapter(new B(this._documents,this._commands.converter,te,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(G),ae,B.supportsResolving(te),`${x.identifier.value}(${ae.join("")})`),this._createDisposable(j)}$provideCompletionItems(x,G,te,ae,j){return this._withAdapter(x,B,se=>se.provideCompletionItems(c.URI.revive(G),te,ae,j),void 0)}$resolveCompletionItem(x,G,te){return this._withAdapter(x,B,ae=>ae.resolveCompletionItem(G,te),void 0)}$releaseCompletionItems(x,G){this._withAdapter(x,B,te=>te.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(x,G,te){const ae=this._addNewAdapter(new H(this._documents,te,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideInlineCompletions(x,G,te,ae,j){return this._withAdapter(x,H,se=>se.provideInlineCompletions(c.URI.revive(G),te,ae,j),void 0)}$handleInlineCompletionDidShow(x,G,te){this._withAdapter(x,H,async ae=>{ae.handleDidShowCompletionItem(G,te)},void 0)}$freeInlineCompletionsList(x,G){this._withAdapter(x,H,async te=>{te.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(x,G,te,ae){const j=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new re(this._documents,te),x);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(G),j),this._createDisposable(se)}$provideSignatureHelp(x,G,te,ae,j){return this._withAdapter(x,re,se=>se.provideSignatureHelp(c.URI.revive(G),te,ae,j),void 0)}$releaseSignatureHelp(x,G){this._withAdapter(x,re,te=>te.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(x,G,te){const ae=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new ue(this._documents,te),x);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(G),ae);let se=this._createDisposable(j);if(ae!==void 0){const he=te.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,he)}return se}$provideInlayHints(x,G,te,ae){return this._withAdapter(x,ue,j=>j.provideInlayHints(c.URI.revive(G),te,ae),void 0)}registerDocumentLinkProvider(x,G,te){const ae=this._addNewAdapter(new Z(this._documents,te),x);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(G),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(x,G,te){return this._withAdapter(x,Z,ae=>ae.provideLinks(c.URI.revive(G),te),void 0)}$resolveDocumentLink(x,G,te){return this._withAdapter(x,Z,ae=>ae.resolveLink(G,te),void 0)}$releaseDocumentLinks(x,G){this._withAdapter(x,Z,te=>te.releaseLinks(G),void 0)}registerColorProvider(x,G,te){const ae=this._addNewAdapter(new oe(this._documents,te),x);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentColors(x,G,te){return this._withAdapter(x,oe,ae=>ae.provideColors(c.URI.revive(G),te),[])}$provideColorPresentations(x,G,te,ae){return this._withAdapter(x,oe,j=>j.provideColorPresentations(c.URI.revive(G),te,ae),void 0)}registerFoldingRangeProvider(x,G,te){const ae=this._nextHandle(),j=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new ve(this._documents,te),x)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(G),j);let se=this._createDisposable(ae);if(j!==void 0){const he=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));se=A.Disposable.from(se,he)}return se}$provideFoldingRanges(x,G,te,ae){return this._withAdapter(x,ve,j=>j.provideFoldingRanges(c.URI.revive(G),te,ae),void 0)}registerSelectionRangeProvider(x,G,te){const ae=this._addNewAdapter(new Ae(this._documents,te,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideSelectionRanges(x,G,te,ae){return this._withAdapter(x,Ae,j=>j.provideSelectionRanges(c.URI.revive(G),te,ae),[])}registerCallHierarchyProvider(x,G,te){const ae=this._addNewAdapter(new Se(this._documents,te),x);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareCallHierarchy(x,G,te,ae){return this._withAdapter(x,Se,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(x,G,te,ae){return this._withAdapter(x,Se,j=>j.provideCallsTo(G,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(x,G,te,ae){return this._withAdapter(x,Se,j=>j.provideCallsFrom(G,te,ae),void 0)}$releaseCallHierarchy(x,G){this._withAdapter(x,Se,te=>Promise.resolve(te.releaseSession(G)),void 0)}registerTypeHierarchyProvider(x,G,te){const ae=this._addNewAdapter(new Ne(this._documents,te),x);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareTypeHierarchy(x,G,te,ae){return this._withAdapter(x,Ne,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),te,ae)),void 0)}$provideTypeHierarchySupertypes(x,G,te,ae){return this._withAdapter(x,Ne,j=>j.provideSupertypes(G,te,ae),void 0)}$provideTypeHierarchySubtypes(x,G,te,ae){return this._withAdapter(x,Ne,j=>j.provideSubtypes(G,te,ae),void 0)}$releaseTypeHierarchy(x,G){this._withAdapter(x,Ne,te=>Promise.resolve(te.releaseSession(G)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,k.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:je._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?je._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?je._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:je._serializeRegExp(x.beforeText),afterText:x.afterText?je._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?je._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(je._serializeOnEnterRule)}setLanguageConfiguration(x,G,te){let{wordPattern:ae}=te;if(ae&&(0,k.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(G,ae):this._documents.setWordDefinitionFor(G,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const j=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?je._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?je._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?je._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,G,se),this._createDisposable(j)}$setWordDefinitions(x){for(const G of x)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,14,6]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(t,b,n,f){this._documents=b,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,b){await this._proxy.$changeLanguage(t,b);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,b){const n=t.version,f=M.Position.from(b),o=await this._proxy.$tokensAtPosition(t.uri,f),l={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(b)??new E.Range(b.line,b.character,b.line,b.character)};if(!o)return l;const w={range:M.Range.to(o.range),type:M.TokenType.to(o.type)};return!w.range.contains(b)||n!==t.version?l:w}createLanguageStatusItem(t,b,n){const f=this._handlePool++,o=this._proxy,l=this._ids,w=`${t.identifier.value}/${b}`;if(l.has(w))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);l.add(w);const D={selector:n,id:b,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let _,a=new k.DisposableStore;const d=()=>{_?.dispose(),_=(0,F.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(f,{id:w,name:D.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===E.LanguageStatusSeverity.Error?A.default.Error:D.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:D.command&&this._commands.toInternal(D.command,a),accessibilityInfo:D.accessibilityInformation})},0)},y={dispose(){a.dispose(),_?.dispose(),o.$removeLanguageStatus(f),l.delete(w)},get id(){return D.id},get name(){return D.name},set name(i){D.name=i,d()},get selector(){return D.selector},set selector(i){D.selector=i,d()},get text(){return D.text},set text(i){D.text=i,d()},get detail(){return D.detail},set detail(i){D.detail=i,d()},get severity(){return D.severity},set severity(i){D.severity=i,d()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(i){D.accessibilityInformation=i,d()},get command(){return D.command},set command(i){D.command=i,d()}};return d(),y}}e.ExtHostLanguages=S}),define(be[196],Ee([0,1,5,15,30]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let F=class{constructor(S,P){this._logService=P,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,P,t,b,n){const f={extension:S};let o;typeof b=="string"||A(b)?o=[b,...n]:(f.modal=b?.modal,f.useCustom=b?.useCustom,f.detail=b?.detail,o=n),f.useCustom&&(0,E.checkProposedApiEnabled)(S);const l=[];for(let w=0;w<o.length;w++){const D=o[w];if(typeof D=="string")l.push({title:D,handle:w,isCloseAffordance:!1});else if(typeof D=="object"){let{title:_,isCloseAffordance:a}=D;l.push({title:_,isCloseAffordance:!!a,handle:w})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(P,t,f,l).then(w=>{if(typeof w=="number")return o[w]})}};F=$e([Ve(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,63,5,8,7,38,172,93]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(a,d,y,i,v){this._textDocumentsAndEditors=y,this._textDocuments=i,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,u=r.cell.handle,p=this._documents.get(s)?.getCell(u);if(p)return p.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const d=this._editors.get(a);if(!d)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(a){for(const[d,y]of this._editors)if(y.apiEditor===a)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,d){const y=this._documents.get(a);if(!y&&!d)throw new Error(`NO notebook document for '${a}'`);return y}_getProviderData(a){const d=this._notebookContentProviders.get(a);if(!d)throw new Error(`NO provider for '${a}'`);return d}registerNotebookContentProvider(a,d,y,i,v){if((0,k.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:a,provider:y});let r;return y.onDidChangeNotebookContentOptions&&(r=y.onDidChangeNotebookContentOptions(()=>{const s=n.NotebookDocumentContentOptions.from(y.options);this._notebookProxy.$updateNotebookProviderOptions(d,s)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},d,n.NotebookDocumentContentOptions.from(i),D._convertNotebookRegistrationData(a,v)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(a,d){if(!d)return;const y=d.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(d.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:d.displayName,filenamePattern:y,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,d,y){const i=D._notebookStatusBarItemProviderHandlePool++,v=typeof y.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,y),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,v,d);let r;return v!==void 0&&(r=y.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(v))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,v),r&&r.dispose()})}async createNotebookDocument(a){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&n.NotebookData.from(a.content)});return P.URI.revive(d)}async openNotebookDocument(a){const d=this._documents.get(a);if(d)return d.apiNotebook;const y=await this._notebookDocumentsProxy.$tryOpenNotebook(a),i=this._documents.get(P.URI.revive(y));return(0,S.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(a,d){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let y;typeof d=="object"?y={position:n.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(n.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:y={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,y),v=i&&this._editors.get(i)?.apiEditor;if(v)return v;throw i?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,d,y,i){const v=this._notebookStatusBarItemProviders.get(a),r=P.URI.revive(d),s=this._documents.get(r);if(!s||!v)return;const u=s.getCellFromIndex(y);if(!u)return;const h=await v.provideCellStatusBarItems(u.apiCell,i);if(!h)return;const p=new A.DisposableStore,I=this._statusBarCache.add([p]),g=(Array.isArray(h)?h:[h]).map(C=>n.NotebookStatusBarItem.from(C,this._commandsConverter,p));return{cacheId:I,items:g}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,d,y,i,v){if((0,k.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,y),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},d,n.NotebookDocumentContentOptions.from(i),D._convertNotebookRegistrationData(a,v)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,d,y){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const v=await i.deserializeNotebook(d.buffer,y);return new o.SerializableObjectWithBuffers(n.NotebookData.from(v))}async $notebookToData(a,d,y){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const v=await i.serializeNotebook(n.NotebookData.to(d.value),y);return c.VSBuffer.wrap(v)}async $openNotebook(a,d,y,i,v){const{provider:r}=this._getProviderData(a),s=await r.openNotebook(P.URI.revive(d),{backupId:y,untitledDocumentData:i?.buffer},v);return new o.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(n.NotebookCellData.from)})}async $saveNotebook(a,d,y){const i=this.getNotebookDocument(P.URI.revive(d)),{provider:v}=this._getProviderData(a);return await v.saveNotebook(i.apiNotebook,y),!0}async $saveNotebookAs(a,d,y,i){const v=this.getNotebookDocument(P.URI.revive(d)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(P.URI.revive(y),v.apiNotebook,i),!0}async $backupNotebook(a,d,y){const i=this.getNotebookDocument(P.URI.revive(d)),v=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension),s=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),u=P.URI.joinPath(r,s),h=await v.provider.backupNotebook(i.apiNotebook,{destination:u},y);return i.updateBackup(h),h.id}_createExtHostEditor(a,d,y){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const i=new w.ExtHostNotebookEditor(d,this._notebookEditorsProxy,a,y.visibleRanges.map(n.NotebookRange.to),y.selections.map(n.NotebookRange.to),typeof y.viewColumn=="number"?n.ViewColumn.to(y.viewColumn):void 0);this._editors.set(d,i)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const y of a.value.removedDocuments){const i=P.URI.revive(y),v=this._documents.get(i);v&&(v.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const y=[];for(const i of a.value.addedDocuments){const v=P.URI.revive(i.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const r=this,s=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){r._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){r._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){r._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){r._onDidChangeCellExecutionState.fire(u)}},v,i);y.push(...i.cells.map(u=>l.ExtHostCell.asModelAddData(s.apiNotebook,u))),this._documents.get(v)?.dispose(),this._documents.set(v,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(a.value.addedEditors)for(const y of a.value.addedEditors){if(this._editors.has(y.id))return;const i=P.URI.revive(y.documentUri),v=this._documents.get(i);v&&this._createExtHostEditor(v,y.id,y)}const d=[];if(a.value.removedEditors)for(const y of a.value.removedEditors){const i=this._editors.get(y);i&&(this._editors.delete(y),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),d.push(i))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const y=new Set;this._visibleNotebookEditors.forEach(i=>y.add(i.id));for(const i of this._editors.values()){const v=y.has(i.id);i._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,53,15,5,12,8]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(b,n){const f=S._Keys.nextId();b.$registerNotebookEditorDecorationType(f,k.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){b.$removeNotebookEditorDecorationType(f)}}}}S._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(b,n,f){this._logService=b,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new S(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,n);const f=this._notebooksAndEditors.getEditorById(b);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(k.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(k.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const n in b)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(k.ViewColumn.to(b[n]))}};P=$e([Ve(0,E.ILogService),Ve(1,F.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(be[199],Ee([0,1,13,14,21,3,6,20,2,26,15,5,39,8,7,66,165,30,38]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(r,s,u,h,p){this._initData=s,this._extHostNotebook=u,this._commands=h,this._logService=p,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(b.MainContext.MainThreadNotebookKernels);const I=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const g=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:g}}else if(T&&"notebookEditor"in T){const g=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(g===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:g}}return T})],n.ApiCommandResult.Void);this._commands.registerApiCommand(I)}createNotebookController(r,s,u,h,p,I){for(let re of this._kernelData.values())if(re.controller.id===s&&P.ExtensionIdentifier.equals(r.identifier,re.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const T=this._handlePool++,g=this;this._logService.trace(`NotebookController[${T}], CREATED by ${r.identifier.value}, ${s}`);const C=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${r.identifier}'`);let m=!1;const R=new F.DisposableStore,L=new A.Emitter,V=new A.Emitter,q={id:`${r.identifier.value}/${s}`,notebookType:u,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:h||r.identifier.value,preloads:I?I.map(f.NotebookRendererScript.from):[]};let U=p??C,K;this._proxy.$addKernel(T,q).catch(re=>{console.log(re),m=!0});let $=0;const B=()=>{if(m)return;const re=++$;Promise.resolve().then(()=>{re===$&&this._proxy.$updateKernel(T,q)})},H=new k.ResourceMap,Q={get id(){return s},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return q.label},set label(re){q.label=re??r.displayName??r.name,B()},get detail(){return q.detail??""},set detail(re){q.detail=re,B()},get description(){return q.description??""},set description(re){q.description=re,B()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(re){q.supportedLanguages=re,B()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(re){q.supportsExecutionOrder=re,B()},get rendererScripts(){return q.preloads?q.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(re){U=re??C},get interruptHandler(){return K},set interruptHandler(re){K=re,q.supportsInterrupt=Boolean(re),B()},createNotebookCellExecution(re){if(m)throw new Error("notebook controller is DISPOSED");if(!H.has(re.notebook.uri))throw g._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return g._createNotebookCellExecution(re)},dispose:()=>{m||(this._logService.trace(`NotebookController[${T}], DISPOSED`),m=!0,this._kernelData.delete(T),R.dispose(),L.dispose(),V.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(re,ue){g._proxy.$updateNotebookPriority(T,re.uri,ue)},onDidReceiveMessage:V.event,postMessage(re,ue){return(0,D.checkProposedApiEnabled)(r),g._proxy.$postMessage(T,ue&&g._extHostNotebook.getIdByEditor(ue),re)},asWebviewUri(re){return(0,D.checkProposedApiEnabled)(r),(0,l.asWebviewUri)(re,g._initData.remote)}};return this._kernelData.set(T,{extensionId:r.identifier,controller:Q,onDidReceiveMessage:V,onDidChangeSelection:L,associatedNotebooks:H}),Q}$acceptNotebookAssociation(r,s,u){const h=this._kernelData.get(r);if(h){const p=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));u?h.associatedNotebooks.set(p.uri,!0):h.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,p.uri.toString(),u),h.onDidChangeSelection.fire({selected:u,notebook:p.apiNotebook})}}async $executeCells(r,s,u){const h=this._kernelData.get(r);if(!h)return;const p=this._extHostNotebook.getNotebookDocument(S.URI.revive(s)),I=[];for(let T of u){const g=p.getCell(T);g&&I.push(g.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,p.uri.toString(),I.length),await h.controller.executeHandler.call(h.controller,I,p.apiNotebook,h.controller)}catch(T){this._logService.error(`NotebookController[${r}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(r,s,u){const h=this._kernelData.get(r);if(!h)return;const p=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,p.apiNotebook);else for(let I of u){const T=p.getCell(I);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,u){const h=this._kernelData.get(r);if(!h)return;const p=this._extHostNotebook.getEditorById(s);h.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:u}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const h=new y(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,h);const p=h.onDidChangeState(()=>{h.state===d.Resolved&&(h.dispose(),p.dispose(),this._activeExecutions.delete(u.uri))});return h.asApiObject()}};a=$e([Ve(4,t.ILogService)],a),e.ExtHostNotebookKernels=a;var d;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(d||(d={}));class y extends F.Disposable{constructor(r,s,u){super();this._document=r,this._cell=s,this._proxy=u,this._handle=y.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new i(10,h=>this.update(h)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new _.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const u=o.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return u===s.items?f.NotebookCellOutput.from(s):f.NotebookCellOutput.from({items:u,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,u){const h=this.cellIndexToHandle(s),p=this.validateAndConvertOutputs((0,c.asArray)(r));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:h,append:u,outputs:p})}async updateOutputItems(r,s,u){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:s.id,append:u})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(u){r._executionOrder=u,r.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(u){if(r._state===d.Resolved||r._state===d.Started)throw new Error("Cannot call start again");r._state=d.Started,r._onDidChangeState.fire(),r.update({editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:u})},end(u,h){if(r._state===d.Resolved)throw new Error("Cannot call resolve twice");r._state=d.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:w.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:h,lastRunSuccess:u}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(u){return r.verifyStateForOutput(),r.updateOutputs([],u,!1)},appendOutput(u,h){return r.verifyStateForOutput(),r.updateOutputs(u,h,!0)},replaceOutput(u,h){return r.verifyStateForOutput(),r.updateOutputs(u,h,!1)},appendOutputItems(u,h){return r.verifyStateForOutput(),r.updateOutputItems(u,h,!0)},replaceOutputItems(u,h){return r.verifyStateForOutput(),r.updateOutputItems(u,h,!1)}})}}y.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,S,P){const t=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(S)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(k,S){if(!k.contributes?.notebookRenderer?.some(n=>n.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const P=!!k.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,f,o)=>{const l=P?n:w=>{const D={};t.set(D,w.editor),n({editor:D,message:w.message})};return this.getOrCreateEmitterFor(S).event(l,f,o)},postMessage:(n,f)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,f]=[f,n]);const o=P?f:t.get(f),l=o&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(l?.id,S,n)}}}getOrCreateEmitterFor(k){let S=this._rendererMessageEmitters.get(k);return S||(S=new c.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,S),S)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,12]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends E.Disposable{constructor(o,l,w,D,_){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=_,this._id=_.$register(this.name,l,w,D),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?A.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(l=>this._proxy.$clear(l,o))}show(o,l){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof o=="boolean"?o:l)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class P extends S{constructor(o,l,w){super(o,!1,void 0,l,w)}append(o){super.append(o),this._id.then(l=>this._proxy.$append(l,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends S{constructor(o,l,w){super(o,!0,l,void 0,w)}append(o){throw new Error("Not supported")}}class b{constructor(o,l){this.name=o,this._channel=l}append(o){this._channel.then(l=>l.append(o))}appendLine(o){this._channel.then(l=>l.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,l){this._channel.then(w=>w.show(o,l))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=b;let n=class{constructor(o){this._proxy=o.getProxy(c.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new P(o,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(o,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(o,l,this._proxy)}};n=$e([Ve(0,k.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,14,21,3,6,5,2,7,16,13,35,46]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(o,l,w){const D=o.getProxy(F.MainContext.MainThreadQuickOpen);class _{constructor(h,p){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=p}showQuickPick(h,p,I,T=M.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(h),C=++this._instances,m=D.$show(C,{title:I?.title,placeHolder:I?.placeHolder,matchOnDescription:I?.matchOnDescription,matchOnDetail:I?.matchOnDetail,ignoreFocusLost:I?.ignoreFocusOut,canPickMany:I?.canPickMany},T),R={},L=m.then(()=>R);return Promise.race([L,g]).then(V=>{if(V!==R)return g.then(q=>{const U=[];for(let K=0;K<q.length;K++){const $=q[K];let B,H,Q,re,ue;typeof $=="string"?B=$:(B=$.label,H=$.description,Q=$.detail,re=$.picked,ue=$.alwaysShow),U.push({label:B,description:H,handle:K,detail:Q,picked:re,alwaysShow:ue})}return I&&typeof I.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{I.onDidSelectItem(q[K])}),D.$setItems(C,U),m.then(K=>{if(typeof K=="number")return q[K];if(Array.isArray(K))return K.map($=>q[$])})})}).then(void 0,V=>{if(!(0,P.isPromiseCanceledError)(V))return D.$setError(C,V),Promise.reject(V)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,p=M.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,D.$input(h,typeof this._validateInput=="function",p).then(void 0,I=>{if(!(0,P.isPromiseCanceledError)(I))return Promise.reject(I)})}$validateInput(h){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,p=M.CancellationToken.None){const I=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!I)return;const T=await this._workspace.getWorkspaceFolders2();if(!!T)return T.find(g=>g.uri.toString()===I.uri.toString())}createQuickPick(h,p){const I=new r(h,p,()=>this._sessions.delete(I._id));return this._sessions.set(I._id,I),I}createInputBox(h){const p=new s(h,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}$onDidChangeValue(h,p){const I=this._sessions.get(h);I&&I._fireDidChangeValue(p)}$onDidAccept(h){const p=this._sessions.get(h);p&&p._fireDidAccept()}$onDidChangeActive(h,p){const I=this._sessions.get(h);I instanceof r&&I._fireDidChangeActive(p)}$onDidChangeSelection(h,p){const I=this._sessions.get(h);I instanceof r&&I._fireDidChangeSelection(p)}$onDidTriggerButton(h,p){const I=this._sessions.get(h);I&&I._fireDidTriggerButton(p)}$onDidTriggerItemButton(h,p,I){const T=this._sessions.get(h);T instanceof r&&T._fireDidTriggerItemButton(p,I)}$onDidHide(h){const p=this._sessions.get(h);p&&p._fireDidHide()}}class a{constructor(h,p){this._extensionId=h,this._onDidDispose=p,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((p,I)=>{const T=p===S.QuickInputButtons.Back?-1:I;this._handlesToButtons.set(T,p)}),this.update({buttons:h.map((p,I)=>({...v(p),tooltip:p.tooltip,handle:p===S.QuickInputButtons.Back?-1:I}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const p=this._handlesToButtons.get(h);p&&this._onDidTriggerButtonEmitter.fire(p)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),D.$dispose(this._id))}update(h){if(!this._disposed){for(const p of Object.keys(h)){const I=h[p];this._pendingUpdate[p]=I===void 0?null:I}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){D.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function d(u){if(u instanceof S.ThemeIcon)return{id:u.id};const h=i(u),p=y(u);return{dark:typeof h=="string"?k.URI.file(h):h,light:typeof p=="string"?k.URI.file(p):p}}function y(u){return typeof u=="object"&&"light"in u?u.light:u}function i(u){return typeof u=="object"&&"dark"in u?u.dark:u}function v(u){const h=d(u.iconPath);let p,I;return"id"in h?I=n.ThemeIcon.asClassName(h):p=h,{iconPath:p,iconClass:I}}class r extends a{constructor(h,p,I){super(h,I);this.enableProposedApi=p,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((p,I)=>{this._handlesToItems.set(I,p),this._itemsToHandles.set(p,I)}),this.update({items:h.map((p,I)=>({label:p.label,description:p.description,handle:I,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,buttons:p.buttons&&this.enableProposedApi?p.buttons.map((T,g)=>({...v(T),tooltip:T.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(p=>this._itemsToHandles.has(p)),this.update({activeItems:this._activeItems.map(p=>this._itemsToHandles.get(p))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(p=>this._itemsToHandles.has(p)),this.update({selectedItems:this._selectedItems.map(p=>this._itemsToHandles.get(p))})}_fireDidChangeActive(h){const p=(0,t.coalesce)(h.map(I=>this._handlesToItems.get(I)));this._activeItems=p,this._onDidChangeActiveEmitter.fire(p)}_fireDidChangeSelection(h){const p=(0,t.coalesce)(h.map(I=>this._handlesToItems.get(I)));this._selectedItems=p,this._onDidChangeSelectionEmitter.fire(p)}_fireDidTriggerItemButton(h,p){const I=this._handlesToItems.get(h);if(!I||!I.buttons||!I.buttons.length)return;const T=I.buttons[p];T&&this._onDidTriggerItemButtonEmitter.fire({button:T,item:I})}}class s extends a{constructor(h,p){super(h,p);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?b.default.Error:b.default.Ignore})}}return new _(l,w)}e.createExtHostQuickOpen=f}),define(be[202],Ee([0,1,2,3,52,6,14,5,13,108,15,26,30,46,8]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(h){if(h)return typeof h.iconPath=="string"?c.URI.file(h.iconPath):c.URI.isUri(h.iconPath)||f.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function w(h,p){if(!h.iconPath&&!p.iconPath)return 0;if(h.iconPath){if(!p.iconPath)return 1}else return-1;const I=typeof h.iconPath=="string"?h.iconPath:c.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,T=typeof p.iconPath=="string"?p.iconPath:c.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,P.comparePaths)(I,T)}function D(h,p){let I=0;if(h.strikeThrough!==p.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==p.faded)return h.faded?1:-1;if(h.tooltip!==p.tooltip)return(h.tooltip||"").localeCompare(p.tooltip||"");if(I=w(h,p),I!==0)return I;if(h.light&&p.light)I=w(h.light,p.light);else{if(h.light)return 1;if(p.light)return-1}if(I!==0)return I;if(h.dark&&p.dark)I=w(h.dark,p.dark);else{if(h.dark)return 1;if(p.dark)return-1}return I}function _(h,p){if(h.command!==p.command)return h.command<p.command?-1:1;if(h.title!==p.title)return h.title<p.title?-1:1;if(h.tooltip!==p.tooltip){if(h.tooltip!==void 0&&p.tooltip!==void 0)return h.tooltip<p.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(h.arguments===p.arguments)return 0;if(h.arguments)if(p.arguments){if(h.arguments.length!==p.arguments.length)return h.arguments.length-p.arguments.length}else return 1;else return-1;for(let I=0;I<h.arguments.length;I++){const T=h.arguments[I],g=p.arguments[I];if(T!==g)return T<g?-1:1}return 0}function a(h,p){let I=(0,P.comparePaths)(h.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(I!==0)return I;if(h.command&&p.command)I=_(h.command,p.command);else{if(h.command)return 1;if(p.command)return-1}if(I!==0)return I;if(h.decorations&&p.decorations)I=D(h.decorations,p.decorations);else{if(h.decorations)return 1;if(p.decorations)return-1}return I}function d(h,p){for(let I=0;I<h.length;I++)if(h[I]!==p[I])return!1;return!0}function y(h,p){return h.command===p.command&&h.title===p.title&&h.tooltip===p.tooltip&&(h.arguments&&p.arguments?d(h.arguments,p.arguments):h.arguments===p.arguments)}function i(h,p){return(0,S.equals)(h,p,y)}class v{constructor(p,I,T){this._extension=p,this._proxy=I,this._sourceControlHandle=T,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(p){this._proxy.$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(p){if((0,n.checkProposedApiEnabled)(this._extension),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,p))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(p,I){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,p,I)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=v;class r{constructor(p,I,T,g,C){this._proxy=p,this._commands=I,this._sourceControlHandle=T,this._id=g,this._label=C,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,I){const T=this._resourceStatesCommandsMap.get(p);return T?(0,F.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],I)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(a),T=(0,S.sortedDiff)(this._resourceSnapshot,p,a).map(m=>{const R=m.toInsert.map(L=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,L);const q=L.resourceUri;let U;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const ve=new A.DisposableStore;U=this._commands.converter.toInternal(L.command,ve),this._resourceStatesDisposablesMap.set(V,ve)}else this._resourceStatesCommandsMap.set(V,L.command);const K=l(L.decorations),$=L.decorations&&l(L.decorations.light)||K,B=L.decorations&&l(L.decorations.dark)||K,H=[$,B],Q=L.decorations&&L.decorations.tooltip||"",re=L.decorations&&!!L.decorations.strikeThrough,ue=L.decorations&&!!L.decorations.faded,Z=L.contextValue||"";return{rawResource:[V,q,H,Q,re,ue,Z,U],handle:V}});return{start:m.start,deleteCount:m.deleteCount,toInsert:R}}),g=T.map(({start:m,deleteCount:R,toInsert:L})=>[m,R,L.map(V=>V.rawResource)]),C=T.reverse();for(const{start:m,deleteCount:R,toInsert:L}of C){const V=L.map(U=>U.handle),q=this._handlesSnapshot.splice(m,R,...V);for(const U of q)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=p,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(p,I,T,g,C,m){this._extension=p,this._proxy=I,this._commands=T,this._id=g,this._label=C,this._rootUri=m,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(p,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,C,m)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,this._proxy.$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,this._proxy.$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=p;const I=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:I})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(p){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=p;const I=p!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:I??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&i(this._statusBarCommands,p))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=p;const I=(p||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:I})}get selected(){return this._selected}createResourceGroup(p,I){const T=new r(this._proxy,this._commands,this.handle,p,I),g=M.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,g),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const p=[],I=[];for(const[T,g]of this.createdResourceGroups){g.dispose();const C=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});M.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),C.dispose(),this._groups.delete(T.handle),this._proxy.$unregisterGroup(this.handle,T.handle)}),p.push([T.handle,T.id,T.label,T.features]);const m=T._takeResourceStateSnapshot();m.length>0&&I.push([T.handle,m]),this._groups.set(T.handle,T)}this._proxy.$registerGroups(this.handle,p,I),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(I=>{const T=I._takeResourceStateSnapshot();T.length!==0&&p.push([I.handle,T])}),p.length>0&&this._proxy.$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,$e([(0,E.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),$e([(0,E.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let u=class Bi{constructor(p,I,T){this._commands=I,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=p.getProxy(k.MainContext.MainThreadSCM),this._telemetry=p.getProxy(k.MainContext.MainThreadTelemetry),I.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const C=this._sourceControls.get(g.sourceControlHandle);if(!C)return g;const m=C.getResourceGroup(g.groupHandle);return m?m.getResourceState(g.handle):g}else if(g&&g.$mid===4){const C=this._sourceControls.get(g.sourceControlHandle);return C?C.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const C=this._sourceControls.get(g.handle);return C||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,I,T,g){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,I,T,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const C=Bi._handlePool++,m=new s(p,this._proxy,this._commands,I,T,g);this._sourceControls.set(C,m);const R=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier))||[];return R.push(m),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(p.identifier),R),m}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const I=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier)),T=I&&I[I.length-1];return T&&T.inputBox}$provideOriginalResource(p,I,T){const g=c.URI.revive(I);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,g.toString());const C=this._sourceControls.get(p);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>C.quickDiffProvider.provideOriginalResource(g,T)).then(m=>m||null)}$onInputBoxValueChange(p,I){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const T=this._sourceControls.get(p);return T&&T.inputBox.$onInputBoxValueChange(I),Promise.resolve(void 0)}$executeResourceCommand(p,I,T,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,I,T);const C=this._sourceControls.get(p);if(!C)return Promise.resolve(void 0);const m=C.getResourceGroup(I);return m?m.$executeResourceCommand(T,g):Promise.resolve(void 0)}$validateInput(p,I,T){this.logService.trace("ExtHostSCM#$validateInput",p);const g=this._sourceControls.get(p);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>g.inputBox.validateInput(I,T)).then(C=>{if(!C)return Promise.resolve(void 0);const m=o.MarkdownString.fromStrict(C.message);return m?Promise.resolve([m,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};u._handlePool=0,u=$e([Ve(2,t.ILogService)],u),e.ExtHostSCM=u});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[203],Ee([0,1,7,5,127,6,8,10]),function(ne,e,c,M,E,A,F,k){"use strict";var S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(o,l,w,D,_=c.StatusBarAlignment.Left,a){S.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,S,o,"f"),et(this,P,l,"f"),this._entryId=t.ID_GEN++,this._extension=w,this._id=D,this._alignment=_,this._priority=this.validatePriority(a)}validatePriority(o){if(!!(0,k.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!t.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Fe(this,P,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Fe(this,P,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let l;this._name?l=this._name:l=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Fe(this,S,"f").$setEntry(this._entryId,o,l,this._text,D,this._command?.internal,w,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,S=new WeakMap,P=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const l={message:o};return this._messages.unshift(l),this._update(),new c.Disposable(()=>{const w=this._messages.indexOf(l);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,l){this._proxy=o.getProxy(M.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new b(this)}createStatusBarEntry(o,l,w,D){return new t(this._proxy,this._commands,o,l,w,D)}setStatusBarMessage(o,l){const w=this._statusMessage.setMessage(o);let D;return typeof l=="number"?D=setTimeout(()=>w.dispose(),l):typeof l!="undefined"&&l.then(()=>w.dispose(),()=>w.dispose()),new c.Disposable(()=>{w.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(be[72],Ee([0,1,5,3,4]),function(ne,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}getValue(k,S,P){return this._proxy.$getValue(k,S).then(t=>t||P)}setValue(k,S,P){return this._proxy.$setValue(k,S,P)}$acceptValue(k,S,P){this._onDidChangeStorage.fire({shared:k,key:S,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,15,71,2]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,t,b){this._logService=t,this._extHostFileSystem=b,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return F.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(P){if(this._value)return F.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return F.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=$e([Ve(0,M.IExtHostInitDataService),Ve(1,E.ILogService),Ve(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(be[40],Ee([0,1,3,5,4,2,12,6,7,128,16,167,21,36,150,46,10]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class D{constructor(u,h,p,I){this._proxy=u,this._id=h,this._creationOptions=p,this._name=I,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const T=this;this.value={get name(){return T._name||""},get processId(){return T._pidPromise},get creationOptions(){return T._creationOptions},get exitStatus(){return T._exitStatus},get state(){return T._state},sendText(g,C=!0){T._checkDisposed(),T._proxy.$sendText(T._id,g,C)},show(g){T._checkDisposed(),T._proxy.$show(T._id,g)},hide(){T._checkDisposed(),T._proxy.$hide(T._id)},dispose(){T._disposed||(T._disposed=!0,T._proxy.$dispose(T._id))},get dimensions(){if(!(T._cols===void 0||T._rows===void 0))return{columns:T._cols,rows:T._rows}}}}async create(u,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,w.withNullAsUndefined)(u.shellPath),shellArgs:(0,w.withNullAsUndefined)(u.shellArgs),cwd:(0,w.withNullAsUndefined)(u.cwd),env:(0,w.withNullAsUndefined)(u.env),icon:(0,w.withNullAsUndefined)(v(u.iconPath)),color:l.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,w.withNullAsUndefined)(u.message),strictEnv:(0,w.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(u.location,h?.resolvedExtHostIdentifier)})}async createExtensionTerminal(u,h,p,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:l.ThemeColor.isThemeColor(I)?I.id:void 0,location:this._serializeParentTerminal(u,h)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,h){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,h){return u===this._cols&&h===this._rows||u===0||h===0?!1:(this._cols=u,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=D;class _{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new c.Emitter,this._onProcessTitleChanged=new c.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new c.Emitter,this._onProcessShellTypeChanged=new c.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(u){return Promise.resolve("")}async updateProperty(u,h){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput&&this._pty.handleInput(u)}resize(u,h){this._pty.setDimensions&&this._pty.setDimensions({columns:u,rows:h})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose&&this._pty.onDidClose((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h&&{cols:h.columns,rows:h.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(h=>this._onProcessTitleChanged.fire(h)),this._pty.open(u||void 0),this._pty.setDimensions&&u&&this._pty.setDimensions(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=_;let a=1,d=class extends k.Disposable{constructor(u,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[p,I]of this._terminalProcesses)I.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,h){const p=new D(this._proxy,(0,f.generateUuid)(),u,u.name),I=new _(u.pty);return p.createExtensionTerminal(u.location,this._serializeParentTerminal(u,h).resolvedExtHostIdentifier,v(u.iconPath),r(u.color)).then(T=>{const g=this._setupExtHostProcessListeners(T,I);this._terminalProcessDisposables[T]=g}),this._terminals.push(p),p.value}_serializeParentTerminal(u,h){if(h=h||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const p=u.location.parentTerminal;if(p){const I=this._terminals.find(T=>T.value===p);I&&(h.resolvedExtHostIdentifier=I._id)}}else u.location&&typeof u.location!="object"?h.location=u.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(u,h){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const I=new _(h),T=this._setupExtHostProcessListeners(u,I);this._terminalProcessDisposables[u]=T}async $acceptActiveTerminalChanged(u){const h=this._activeTerminal;if(u===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(u);p&&(this._activeTerminal=p,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,h){const p=this._getTerminalById(u);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:h})}async $acceptTerminalDimensions(u,h,p){const I=this._getTerminalById(u);I&&I.setDimensions(h,p)&&this._onDidChangeTerminalDimensions.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptTerminalMaximumDimensions(u,h,p){this._terminalProcesses.get(u)?.resize(h,p)}async $acceptTerminalTitleChange(u,h){const p=this._getTerminalById(u);p&&(p.name=h)}async $acceptTerminalClosed(u,h){const p=this._getTerminalObjectIndexById(this._terminals,u);if(p!==null){const I=this._terminals.splice(p,1)[0];I.setExitCode(h),this._onDidCloseTerminal.fire(I.value)}}$acceptTerminalOpened(u,h,p,I){if(h){const C=this._getTerminalObjectIndexById(this._terminals,h);if(C!==null){this._terminals[C]._id=u,this._onDidOpenTerminal.fire(this.terminals[C]),this._terminals[C].isOpen=!0;return}}const T={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:A.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},g=new D(this._proxy,u,T,p);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(u,h){const p=this._getTerminalById(u);p&&p._setProcessId(h)}async $startExtensionTerminal(u,h){const p=this._getTerminalById(u);if(!p)return{message:(0,P.localize)(0,null,u)};p.isOpen||await new Promise(T=>{const g=this.onDidOpenTerminal(async C=>{C===p.value&&(g.dispose(),T())})});const I=this._terminalProcesses.get(u);I?I.startSendingEvents(h):this._extensionTerminalAwaitingStart[u]={initialDimensions:h}}_setupExtHostProcessListeners(u,h){const p=new k.DisposableStore;p.add(h.onProcessReady(T=>this._proxy.$sendProcessReady(u,T.pid,T.cwd))),p.add(h.onProcessTitleChanged(T=>this._proxy.$sendProcessTitle(u,T))),this._bufferer.startBuffering(u,h.onProcessData),p.add(h.onProcessExit(T=>this._onProcessExit(u,T))),h.onProcessOverrideDimensions&&p.add(h.onProcessOverrideDimensions(T=>this._proxy.$sendOverrideDimensions(u,T))),this._terminalProcesses.set(u,h);const I=this._extensionTerminalAwaitingStart[u];return I&&h instanceof _&&(h.startSendingEvents(I.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),p}$acceptProcessAckDataEvent(u,h){this._terminalProcesses.get(u)?.acknowledgeDataEvent(h)}$acceptProcessInput(u,h){this._terminalProcesses.get(u)?.input(h)}$acceptTerminalInteraction(u){const h=this._getTerminalById(u);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(u,h,p){try{this._terminalProcesses.get(u)?.resize(h,p)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(u,h){this._terminalProcesses.get(u)?.shutdown(h)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(h=>this._proxy.$sendProcessInitialCwd(u,h))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(h=>this._proxy.$sendProcessCwd(u,h))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,h,p){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,p),this._proxy.$registerProfileProvider(h,u.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(u,h){const p=new n.CancellationTokenSource().token,I=await this._profileProviders.get(u)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,h);return}this.createTerminalFromOptions(I.options,h)}}async $provideLinks(u,h){const p=this._getTerminalById(u);if(!p)return[];this._terminalLinkCache.delete(u);const I=this._terminalLinkCancellationSource.get(u);I&&I.dispose(!0);const T=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,T);const g=[],C={terminal:p.value,line:h},m=[];for(const V of this._linkProviders)m.push(new Promise(async q=>{T.token.onCancellationRequested(()=>q({provider:V,links:[]}));const U=await V.provideTerminalLinks(C,T.token)||[];T.token.isCancellationRequested||q({provider:V,links:U})}));const R=await Promise.all(m);if(T.token.isCancellationRequested)return[];const L=new Map;for(const V of R)V&&V.links.length>0&&g.push(...V.links.map(q=>{const U={id:a++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return L.set(U.id,{provider:V.provider,link:q}),U}));return this._terminalLinkCache.set(u,L),g}$activateLink(u,h){const p=this._terminalLinkCache.get(u)?.get(h);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(u,h){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const p=this._terminalProcessDisposables[u];p&&(p.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,h)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,h){const p=this._getTerminalObjectIndexById(u,h);return p!==null?u[p]:null}_getTerminalObjectIndexById(u,h){let p=null;return u.some((I,T)=>I._id===h?(p=T,!0):!1),p}getEnvironmentVariableCollection(u){let h=this._environmentVariableCollections.get(u.identifier.value);return h||(h=new y,this._setEnvironmentVariableCollection(u.identifier.value,h)),h}_syncEnvironmentVariableCollection(u,h){const p=(0,b.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(u,h.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(u){u.forEach(h=>{const p=h[0],I=new y(h[1]);this._setEnvironmentVariableCollection(p,I)})}$acceptDefaultProfile(u,h){this._defaultProfile=u,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(u,h){this._environmentVariableCollections.set(u,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,h)})}};d=$e([Ve(1,F.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class y{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,h){this._setIfDiffers(u,{value:h,type:S.EnvironmentVariableMutatorType.Replace})}append(u,h){this._setIfDiffers(u,{value:h,type:S.EnvironmentVariableMutatorType.Append})}prepend(u,h){this._setIfDiffers(u,{value:h,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,h){const p=this.map.get(u);(!p||p.value!==h.value||p.type!==h.type)&&(this.map.set(u,h),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,h){this.map.forEach((p,I)=>u.call(h,I,p,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=y;let i=class extends d{constructor(u){super(!1,u)}createTerminal(u,h,p){throw new t.NotSupportedError}createTerminalFromOptions(u,h){throw new t.NotSupportedError}};i=$e([Ve(0,F.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function v(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return l.ThemeColor.isThemeColor(s)?s:void 0}});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[204],Ee([0,1,13,22,21,3,235,58,6,23,10,36,5,12,48,8,7,175,90,67]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(m,R){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=m.getProxy(n.MainContext.MainThreadTesting),this.observer=new I(this.proxy),this.runTracker=new v(this.proxy),R.registerArgumentProcessor({processArgument:L=>L?.$mid===13?l.TestItem.toItemFromContext(L):L})}createTestController(m,R){if(this.controllers.has(m))throw new Error(`Attempt to insert a duplicate controller with ID "${m}"`);const L=new S.DisposableStore,V=L.add(new D.SingleUseTestCollection(m));V.root.label=R;const q=new Map,U=this.proxy,K={items:V.root.children,get label(){return R},set label(B){R=B,V.root.label=B,U.$updateControllerLabel(m,R)},get id(){return m},createRunProfile:(B,H,Q,re,ue)=>{let Z=(0,k.hash)(B);for(;q.has(Z);)Z++;const oe=new T(this.proxy,m,Z,B,H,Q,re,ue);return q.set(Z,oe),oe},createTestItem(B,H,Q){return new o.TestItemImpl(m,B,H,Q)},createTestRun:(B,H,Q=!0)=>this.runTracker.createTestRun(m,V,B,H,Q),set resolveHandler(B){V.resolveHandler=B},get resolveHandler(){return V.resolveHandler},dispose:()=>{L.dispose()}};K.createRunConfiguration=K.createRunProfile,U.$registerTestController(m,R),L.add((0,S.toDisposable)(()=>U.$unregisterTestController(m)));const $={controller:K,collection:V,profiles:q};return this.controllers.set(m,$),L.add((0,S.toDisposable)(()=>this.controllers.delete(m))),L.add(V.onDidGenerateDiff(B=>U.$publishDiff(m,B))),K}createTestObserver(){return this.observer.checkout()}async runTests(m,R=E.CancellationToken.None){const L=r(m);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get(L.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:m.include?.map(q=>q.id)??[V.collection.root.id],profileGroup:g[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:m.exclude?.map(q=>q.id)},R)}$provideFileCoverage(m,R,L){return(0,c.mapFind)(this.runTracker.trackers,q=>q.id===m?q.getCoverage(R):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(m,R,L,V){return(0,c.mapFind)(this.runTracker.trackers,U=>U.id===m?U.getCoverage(R):void 0)?.resolveFileCoverage(L,V)??Promise.resolve([])}$configureRunProfile(m,R){this.controllers.get(m)?.profiles.get(R)?.configureHandler?.()}$publishTestResults(m){this.results=Object.freeze(m.map(R=>(0,P.deepFreeze)(l.TestResults.to(R))).concat(this.results).sort((R,L)=>L.completedAt-R.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(m,R){const L=this.controllers.get(a.TestId.fromString(m).controllerId)?.collection;L&&(await L.expand(m,R<0?Infinity:R),L.flushDiff())}$acceptDiff(m){this.observer.applyDiff(m)}async $runControllerTests(m,R){const L=this.controllers.get(m.controllerId);if(!L)return;const{collection:V,profiles:q}=L,U=q.get(m.profileId);if(!U)return;const K=m.testIds.map(Q=>V.tree.get(Q)).filter(t.isDefined),$=m.excludeExtIds.map(Q=>L.collection.tree.get(Q)).filter(t.isDefined).filter(Q=>K.some(re=>re.fullId.compare(Q.fullId)===2));if(!K.length)return;const B=new w.TestRunRequest(K.some(Q=>Q.actual instanceof o.TestItemRootImpl)?void 0:K.map(Q=>Q.actual),$.map(Q=>Q.actual),U),H=this.runTracker.prepareForMainThreadTestRun(B,s.fromInternal(m,L.collection),R);try{await U.runHandler(B,R)}finally{H.isRunning&&!R.isCancellationRequested&&await A.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(m){m===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(m)}};y=$e([Ve(0,f.IExtHostRpcService)],y),e.ExtHostTesting=y;class i extends S.Disposable{constructor(m,R,L){super();this.dto=m,this.proxy=R,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:V}of this.tasks.values())V.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(m){return this.tasks.get(m)?.coverage}createRun(m){const R=this.dto.id,L=this.dto.controllerId,V=(0,b.generateUuid)(),q=new u(this.proxy,R,V),U=H=>(Q,...re)=>{if($){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),H(Q,...re))},K=(H,Q)=>{const re=Q instanceof Array?Q.map(l.TestMessage.from):[l.TestMessage.from(Q)];if(H.uri&&H.range){const ue={range:l.Range.from(H.range),uri:H.uri};for(const Z of re)Z.location=Z.location||ue}this.proxy.$appendTestMessagesInRun(R,V,a.TestId.fromExtHostTestItem(H,L).toString(),re)};let $=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:m,get coverageProvider(){return q.coverageProvider},set coverageProvider(H){q.coverageProvider=H},enqueued:U(H=>{this.proxy.$updateTestStateInRun(R,V,a.TestId.fromExtHostTestItem(H,L).toString(),1)}),skipped:U(H=>{this.proxy.$updateTestStateInRun(R,V,a.TestId.fromExtHostTestItem(H,L).toString(),5)}),started:U(H=>{this.proxy.$updateTestStateInRun(R,V,a.TestId.fromExtHostTestItem(H,L).toString(),2)}),errored:U((H,Q,re)=>{K(H,Q),this.proxy.$updateTestStateInRun(R,V,a.TestId.fromExtHostTestItem(H,L).toString(),6,re)}),failed:U((H,Q,re)=>{K(H,Q),this.proxy.$updateTestStateInRun(R,V,a.TestId.fromExtHostTestItem(H,L).toString(),4,re)}),passed:U((H,Q)=>{this.proxy.$updateTestStateInRun(R,V,a.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,Q)}),appendOutput:(H,Q,re)=>{$||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(R,V,M.VSBuffer.fromString(H),Q&&l.location.from(Q),re&&a.TestId.fromExtHostTestItem(re,L).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(R,V),this.tasks.delete(V),this.isRunning||this.dispose())}};return this.tasks.set(V,{run:B,coverage:q}),this.proxy.$startedTestRunTask(R,{id:V,name:m,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(m){if(!(m instanceof o.TestItemImpl))throw new o.InvalidTestItemError(m.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(m,this.dto.controllerId).toString()))return;const R=[],L=this.dto.colllection.root;for(;;){const V=l.TestItem.from(m);if(R.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),m===L))break;m=m.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,R)}}class v{constructor(m){this.proxy=m,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(m,R,L){return this.getTracker(m,R,L)}cancelRunById(m){for(const R of this.tracked.values())if(R.id===m){R.dispose();return}}cancelAllRuns(){for(const m of this.tracked.values())m.dispose()}createTestRun(m,R,L,V,q){const U=this.tracked.get(L);if(U)return U.createRun(V);const K=s.fromPublic(m,R,L,q),$=r(L);this.proxy.$startedExtensionTestRun({controllerId:m,profile:$&&{group:g[$.kind],id:$.profileId},exclude:L.exclude?.map(H=>H.id)??[],id:K.id,include:L.include?.map(H=>H.id)??[R.root.id],persist:q});const B=this.getTracker(L,K);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),B.createRun(V)}getTracker(m,R,L){const V=new i(R,this.proxy,L);return this.tracked.set(m,V),V.onEnd(()=>this.tracked.delete(m)),V}}e.TestRunCoordinator=v;const r=C=>{if(!!C.profile){if(!(C.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class s{constructor(m,R,L,V,q,U){this.controllerId=m,this.id=R,this.isPersisted=q,this.colllection=U,this.includePrefix=L.map(K=>K+"\0"),this.excludePrefix=V.map(K=>K+"\0")}static fromPublic(m,R,L,V){return new s(m,(0,b.generateUuid)(),L.include?.map(q=>a.TestId.fromExtHostTestItem(q,m).toString())??[m],L.exclude?.map(q=>a.TestId.fromExtHostTestItem(q,m).toString())??[],V,R)}static fromInternal(m,R){return new s(m.controllerId,m.runId,m.testIds,m.excludeExtIds,!0,R)}isIncluded(m){const R=a.TestId.fromExtHostTestItem(m,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(R===L||R.startsWith(L))return!1;for(const L of this.includePrefix)if(R===L||R.startsWith(L))return!0;return!1}}e.TestRunDto=s;class u{constructor(m,R,L){this.proxy=m,this.runId=R,this.taskId=L}set coverageProvider(m){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!m||(this._coverageProvider=m,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(m){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(m))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(R){throw this.fileCoverage=void 0,R}}async resolveFileCoverage(m,R){const L=await this.fileCoverage;let V=L?.[m];return!this._coverageProvider||!L||!V?[]:(V.detailedCoverage||(V=L[m]=await this._coverageProvider.resolveFileCoverage?.(V,R)??V),V.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class h extends _.IncrementalChangeCollector{constructor(m){super();this.emitter=m,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(m){this.added.add(m)}update(m){Object.assign(m.revived,l.TestItem.toPlain(m.item)),this.added.has(m)||this.updated.add(m)}remove(m){if(this.added.has(m)){this.added.delete(m);return}if(this.updated.delete(m),m.parent&&this.alreadyRemoved.has(m.parent)){this.alreadyRemoved.add(m.item.extId);return}this.removed.add(m)}getChangeEvent(){const{added:m,updated:R,removed:L}=this;return{get added(){return[...m].map(V=>V.revived)},get updated(){return[...R].map(V=>V.revived)},get removed(){return[...L].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class p extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(m){return this.items.get(m)}getMirroredTestDataByReference(m){return this.items.get(m.id)}createItem(m,R){return{...m,revived:l.TestItem.toPlain(m.item),depth:R?R.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=p;class I{constructor(m){this.proxy=m}checkout(){this.current||(this.current=this.createObserverData());const m=this.current;return m.observers++,{onDidChangeTest:m.tests.onDidChangeTests,get tests(){return[...m.tests.rootTests].map(R=>R.revived)},dispose:(0,F.once)(()=>{--m.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(m){return this.current?.tests.getMirroredTestDataByReference(m)}applyDiff(m){this.current?.tests.apply(m)}createObserverData(){const m=new p;return this.proxy.$subscribeToDiffs(),{observers:0,tests:m}}}class T{constructor(m,R,L,V,q,U,K=!1,$=void 0){this.controllerId=R,this.profileId=L,this._label=V,this.kind=q,this.runHandler=U,this._isDefault=K,this._tag=$,d.set(this,void 0),et(this,d,m,"f");const B=g[q];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);Fe(this,d,"f").$publishTestRunProfile({profileId:L,controllerId:R,tag:$?l.TestTag.namespace(this.controllerId,$.id):null,label:V,group:B,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(m){m!==this._label&&(this._label=m,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:m}))}get isDefault(){return this._isDefault}set isDefault(m){m!==this._isDefault&&(this._isDefault=m,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:m}))}get tag(){return this._tag}set tag(m){m?.id!==this._tag?.id&&(this._tag=m,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:m?l.TestTag.namespace(this.controllerId,m.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(m){m!==this._configureHandler&&(this._configureHandler=m,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!m}))}dispose(){Fe(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,d=new WeakMap;const g={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,13,5,94,8,7]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(t,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const b=this._extHostDocumentsAndEditors.allEditors();return t?b:b.map(n=>n.value)}async showTextDocument(t,b,n){let f;typeof b=="number"?f={position:F.ViewColumn.from(b),preserveFocus:n}:typeof b=="object"?f={position:F.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?F.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:f={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(t.uri,f),l=o&&this._extHostDocumentsAndEditors.getEditor(o);if(l)return l.value;throw o?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,b){return new A.TextEditorDecorationType(this._proxy,t,b).value}$acceptEditorPropertiesChanged(t,b){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(b.options&&n._acceptOptions(b.options),b.selections){const f=b.selections.selections.map(F.Selection.to);n._acceptSelections(f)}if(b.visibleRanges){const f=M.coalesce(b.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(f)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...b.options,lineNumbers:F.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const f=k.TextEditorSelectionChangeKind.fromValue(b.selections.source),o=b.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:f})}if(b.visibleRanges){const f=M.coalesce(b.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(t){for(const b in t){const n=this._extHostDocumentsAndEditors.getEditor(b);if(!n)throw new Error("Unknown text editor");const f=F.ViewColumn.to(t[b]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=S}),define(be[206],Ee([0,1,2,4,5,6,7]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class k{constructor(t,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(f))?.get(n.handle)}return n}})}async $getTimeline(t,b,n,f,o){return this._providers.get(t)?.provideTimeline(c.URI.revive(b),n,f,o)}registerTimelineProvider(t,b,n,f){const o=new A.DisposableStore,l=this.convertTimelineItem(b.id,f,o).bind(this);let w;b.onDidChange&&(w=b.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:b.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:t,onDidChange:void 0,async provideTimeline(_,a,d,y){y?.resetCache&&(o.clear(),D.get(b.id)?.clear());const i=await b.provideTimeline(_,a,d);if(i==null)return;const v=l(_,y);return{...i,source:b.id,items:i.items.map(v)}},dispose(){for(const _ of D.values())_.get(b.id)?.clear();w?.dispose(),o.dispose()}})}convertTimelineItem(t,b,n){return(f,o)=>{let l;if(o?.cacheResults){let w=this._itemsBySourceAndUriMap.get(t);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(t,w));const D=S(f);l=w.get(D),l===void 0&&(l=new Map,w.set(D,l))}return w=>{const{iconPath:D,..._}=w,a=`${t}|${w.id??w.timestamp}`;l?.set(a,w);let d,y,i;return w.iconPath&&(D instanceof F.ThemeIcon?i={id:D.id,color:D.color}:c.URI.isUri(D)?(d=D,y=D):{light:d,dark:y}=D),{..._,id:_.id??void 0,handle:a,source:t,command:w.command?b.toInternal(w.command,n):void 0,icon:d,iconDark:y,themeIcon:i,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=k;function S(P){return P?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,t,b){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=b.schemes.find(f=>!F.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,b.schemes,S,b.label),(0,c.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(S,P,t){const b=this._openers.get(S);if(!b)throw new Error(`Unknown opener with id: ${S}`);const n=E.URI.revive(P);return b.canOpenExternalUri(n,t)}async $openUri(S,P,t){const b=this._openers.get(S);if(!b)throw new Error(`Unknown opener id: '${S}'`);return b.openExternalUri(E.URI.revive(P.resolvedUri),{sourceUri:E.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(ne,e,c,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(F.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const b=k.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(P)),this.handlers.set(b,t),this._proxy.$registerUriHandler(b,P),(0,E.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(P)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(P,t){const b=this.handlers.get(P);if(!b)return Promise.resolve(void 0);try{b.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[50],Ee([0,1,3,2,138,158,66,5]),function(ne,e,c,M,E,A,F,k){"use strict";var S,P,t,b,n,f,o,l,w,D,_,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(p,I,T,g,C,m,R){S.set(this,void 0),P.set(this,void 0),t.set(this,void 0),b.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,""),l.set(this,void 0),w.set(this,!1),D.set(this,!1),_.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new c.Emitter),this._onDidDispose=Fe(this,a,"f").event,et(this,S,p,"f"),et(this,P,I,"f"),et(this,l,T,"f"),et(this,b,g,"f"),et(this,n,C,"f"),et(this,f,m,"f"),et(this,_,y(m),"f"),et(this,t,R,"f")}dispose(){et(this,w,!0,"f"),Fe(this,a,"f").fire(),Fe(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return et(this,D,!0,"f"),(0,F.asWebviewUri)(p,Fe(this,b,"f").remote)}get cspSource(){return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,o,"f")}set html(p){this.assertNotDisposed(),Fe(this,o,"f")!==p&&(et(this,o,p,"f"),!Fe(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(et(this,D,!0,"f"),Fe(this,t,"f").report("Webview vscode-resource: uris",Fe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,P,"f").$setHtml(Fe(this,S,"f"),p))}get options(){return this.assertNotDisposed(),Fe(this,l,"f")}set options(p){this.assertNotDisposed(),Fe(this,P,"f").$setOptions(Fe(this,S,"f"),r(Fe(this,f,"f"),Fe(this,n,"f"),p)),et(this,l,p,"f")}async postMessage(p){if(Fe(this,w,"f"))return!1;const I=(0,A.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Fe(this,_,"f")});return Fe(this,P,"f").$postMessage(Fe(this,S,"f"),I.message,...I.buffers)}assertNotDisposed(){if(Fe(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,S=new WeakMap,P=new WeakMap,t=new WeakMap,b=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,l=new WeakMap,w=new WeakMap,D=new WeakMap,_=new WeakMap,a=new WeakMap;function y(h){try{const p=(0,E.normalizeVersion)((0,E.parseVersion)(h.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=y;class i{constructor(p,I,T,g,C){this.initData=I,this.workspace=T,this._logService=g,this._deprecationService=C,this._webviews=new Map,this._webviewProxy=p.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(p,I,...T){const g=this.getWebview(p);if(g){const{message:C}=(0,A.deserializeWebviewMessage)(I,T);g._onMessageEmitter.fire(C)}}$onMissingCsp(p,I){this._logService.warn(`${I} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,I,T){const g=new d(p,this._webviewProxy,s(I),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(p,g),g._onDidDispose(()=>{this._webviews.delete(p)}),g}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=i;function v(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=v;function r(h,p,I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,enableForms:I.enableForms,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots||u(h,p)}}e.serializeWebviewOptions=r;function s(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(p=>M.URI.from(p))}}e.reviveOptions=s;function u(h,p){return[...(p?.getWorkspaceFolders()||[]).map(I=>I.uri),h.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(i,v){this.document=i,this._storagePath=v,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,v){await this.getEdit(i).undo(),v||this.disposeBackup()}async redo(i,v){await this.getEdit(i).redo(),v||this.disposeBackup()}disposeEdits(i){for(const v of i)this._edits.delete(v)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=d(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const v=this._edits.get(i,0);if(!v)throw new Error("No edit found");return v}}class o{constructor(){this._documents=new Map}get(i,v){return this._documents.get(this.key(i,v))}add(i,v,r){const s=this.key(i,v.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${v.uri}`);const u=new f(v,r);return this._documents.set(s,u),u}delete(i,v){const r=this.key(i,v.uri);this._documents.delete(r)}key(i,v){return`${i}@@@${v}`}}var l;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(l||(l={}));class w{constructor(){this._providers=new Map}addTextProvider(i,v,r){return this.add(0,i,v,r)}addCustomProvider(i,v,r){return this.add(1,i,v,r)}get(i){return this._providers.get(i)}add(i,v,r,s){if(this._providers.has(v))throw new Error(`Provider for viewType:${v} already registered`);return this._providers.set(v,{type:i,extension:r,provider:s}),new n.Disposable(()=>this._providers.delete(v))}}class D{constructor(i,v,r,s,u){this._extHostDocuments=v,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new w,this._documents=new o,this._proxy=i.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,v,r,s){const u=new E.DisposableStore;return _(r)?(u.add(this._editorProviders.addTextProvider(v,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),v,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(u.add(this._editorProviders.addCustomProvider(v,i,r)),this.supportEditing(r)&&u.add(r.onDidChangeCustomDocument(h=>{const p=this.getCustomDocumentEntry(v,h.document.uri);if(a(h)){const I=p.addEdit(h);this._proxy.$onDidEdit(h.document.uri,v,I,h.label)}else this._proxy.$onContentChange(h.document.uri,v)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),v,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(u,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(v)}))}async $createCustomDocument(i,v,r,s,u){const h=this._editorProviders.get(v);if(!h)throw new Error(`No provider found for '${v}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${v}'`);const p=k.URI.revive(i),I=await h.provider.openCustomDocument(p,{backupId:r,untitledDocumentData:s?.buffer},u);let T;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(v,I,T),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(i,v){const r=this._editorProviders.get(v);if(!r)throw new Error(`No provider found for '${v}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${v}'`);const s=k.URI.revive(i),{document:u}=this.getCustomDocumentEntry(v,s);this._documents.delete(v,u),u.dispose()}async $resolveWebviewEditor(i,v,r,s,u,h){const p=this._editorProviders.get(r);if(!p)throw new Error(`No provider found for '${r}'`);const I=S.ViewColumn.to(u),T=this._extHostWebview.createNewWebview(v,s.webviewOptions,p.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(v,r,s.title,I,s.panelOptions,T),C=k.URI.revive(i);switch(p.type){case 1:{const{document:m}=this.getCustomDocumentEntry(r,C);return p.provider.resolveCustomEditor(m,g,h)}case 0:{const m=this._extHostDocuments.getDocument(C);return p.provider.resolveCustomTextEditor(m,g,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,v,r){this.getCustomDocumentEntry(v,i).disposeEdits(r)}async $onMoveCustomEditor(i,v,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(i);if(!u)throw new Error("No webview found");const h=k.URI.revive(v),p=this._extHostDocuments.getDocument(h);await s.provider.moveCustomTextEditor(p,u,c.CancellationToken.None)}async $undo(i,v,r,s){return this.getCustomDocumentEntry(v,i).undo(r,s)}async $redo(i,v,r,s){return this.getCustomDocumentEntry(v,i).redo(r,s)}async $revert(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(i,v,r,s){const u=this.getCustomDocumentEntry(v,i);return this.getCustomEditorProvider(v).saveCustomDocumentAs(u.document,k.URI.revive(r),s)}async $backup(i,v,r){const s=this.getCustomDocumentEntry(v,i),h=await this.getCustomEditorProvider(v).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(h),h.id}getCustomDocumentEntry(i,v){const r=this._documents.get(i,k.URI.revive(v));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function _(y){return typeof y.resolveCustomTextEditor=="function"}function a(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function d(y){const i=y.scheme===A.Schemas.file||y.scheme===A.Schemas.untitled?y.fsPath:y.toString();return(0,M.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[210],Ee([0,1,3,6,2,36,8,50,5,7]),function(ne,e,c,M,E,A,F,k,S,P){"use strict";var t,b,n,f,o,l,w,D,_,a,d,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class v extends M.Disposable{constructor(h,p,I,T,g,C,m){super();t.set(this,void 0),b.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),l.set(this,void 0),w.set(this,void 0),D.set(this,void 0),_.set(this,!0),a.set(this,!0),d.set(this,!1),y.set(this,this._register(new c.Emitter)),this.onDidDispose=Fe(this,y,"f").event,i.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Fe(this,i,"f").event,et(this,t,h,"f"),et(this,b,p,"f"),et(this,n,I,"f"),et(this,o,C,"f"),et(this,D,g,"f"),et(this,l,T,"f"),et(this,f,m,"f")}dispose(){Fe(this,d,"f")||(et(this,d,!0,"f"),Fe(this,y,"f").fire(),Fe(this,b,"f").$disposeWebview(Fe(this,t,"f")),Fe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,f,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,n,"f")}get title(){return this.assertNotDisposed(),Fe(this,l,"f")}set title(h){this.assertNotDisposed(),Fe(this,l,"f")!==h&&(et(this,l,h,"f"),Fe(this,b,"f").$setTitle(Fe(this,t,"f"),h))}get iconPath(){return this.assertNotDisposed(),Fe(this,w,"f")}set iconPath(h){this.assertNotDisposed(),Fe(this,w,"f")!==h&&(et(this,w,h,"f"),Fe(this,b,"f").$setIconPath(Fe(this,t,"f"),E.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Fe(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,D,"f")=="number"&&Fe(this,D,"f")<0))return Fe(this,D,"f")}get active(){return this.assertNotDisposed(),Fe(this,a,"f")}get visible(){return this.assertNotDisposed(),Fe(this,_,"f")}_updateViewState(h){Fe(this,d,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(et(this,a,h.active,"f"),et(this,_,h.visible,"f"),et(this,D,h.viewColumn,"f"),Fe(this,i,"f").fire({webviewPanel:this}))}reveal(h,p){this.assertNotDisposed(),Fe(this,b,"f").$reveal(Fe(this,t,"f"),{viewColumn:h?F.ViewColumn.from(h):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Fe(this,d,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,b=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,l=new WeakMap,w=new WeakMap,D=new WeakMap,_=new WeakMap,a=new WeakMap,d=new WeakMap,y=new WeakMap,i=new WeakMap;class r{constructor(h,p,I){this.webviews=p,this.workspace=I,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(h,p,I,T,g={}){const C=typeof T=="object"?T.viewColumn:T,m={viewColumn:F.ViewColumn.from(C),preserveFocus:typeof T=="object"&&!!T.preserveFocus},R=(0,k.shouldSerializeBuffersForPostMessage)(h),L=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(h),L,p,{title:I,panelOptions:s(g),webviewOptions:(0,k.serializeWebviewOptions)(h,this.workspace,g),serializeBuffersForPostMessage:R},m);const V=this.webviews.createNewWebview(L,g,h);return this.createNewWebviewPanel(L,p,I,C,g,V)}$onDidChangeWebviewPanelViewStates(h){const p=Object.keys(h);p.sort((I,T)=>{const g=h[I],C=h[T];return g.active?1:C.active?-1:+g.visible-+C.visible});for(const I of p){const T=this.getWebviewPanel(I);if(!T)continue;const g=h[I];T._updateViewState({active:g.active,visible:g.visible,viewColumn:F.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,p,I){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:I,extension:h}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(h)}),new P.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(h,p,I,T){const g=this._serializers.get(p);if(!g)throw new Error(`No serializer found for '${p}'`);const{serializer:C,extension:m}=g,R=this.webviews.createNewWebview(h,I.webviewOptions,m),L=this.createNewWebviewPanel(h,p,I.title,T,I.panelOptions,R);await C.deserializeWebviewPanel(L,I.state)}createNewWebviewPanel(h,p,I,T,g,C){const m=new v(h,this._proxy,p,I,T,g,C);return this._webviewPanels.set(h,m),m}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=r;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[211],Ee([0,1,3,6,50,5,7]),function(ne,e,c,M,E,A,F){"use strict";var k,S,P,t,b,n,f,o,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends M.Disposable{constructor(d,y,i,v,r,s){super();k.set(this,void 0),S.set(this,void 0),P.set(this,void 0),t.set(this,void 0),b.set(this,!1),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),l.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Fe(this,l,"f").event,w.set(this,this._register(new c.Emitter)),this.onDidDispose=Fe(this,w,"f").event,et(this,P,i,"f"),et(this,f,v,"f"),et(this,k,d,"f"),et(this,S,y,"f"),et(this,t,r,"f"),et(this,n,s,"f")}dispose(){Fe(this,b,"f")||(et(this,b,!0,"f"),Fe(this,w,"f").fire(),Fe(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,f,"f")}set title(d){this.assertNotDisposed(),Fe(this,f,"f")!==d&&(et(this,f,d,"f"),Fe(this,S,"f").$setWebviewViewTitle(Fe(this,k,"f"),d))}get description(){return this.assertNotDisposed(),Fe(this,o,"f")}set description(d){this.assertNotDisposed(),Fe(this,o,"f")!==d&&(et(this,o,d,"f"),Fe(this,S,"f").$setWebviewViewDescription(Fe(this,k,"f"),d))}get visible(){return Fe(this,n,"f")}get webview(){return Fe(this,t,"f")}get viewType(){return Fe(this,P,"f")}_setVisible(d){d===Fe(this,n,"f")||Fe(this,b,"f")||(et(this,n,d,"f"),Fe(this,l,"f").fire())}show(d){this.assertNotDisposed(),Fe(this,S,"f").$show(Fe(this,k,"f"),!!d)}assertNotDisposed(){if(Fe(this,b,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,P=new WeakMap,t=new WeakMap,b=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,l=new WeakMap,w=new WeakMap;class _{constructor(d,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,y,i,v){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:i,extension:d}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(d),y,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(d,y,i,v,r){const s=this._viewProviders.get(y);if(!s)throw new Error(`No view provider found for '${y}'`);const{provider:u,extension:h}=s,p=this._extHostWebview.createNewWebview(d,{},h),I=new D(d,this._proxy,y,i,p,!0);this._webviewViews.set(d,I),await u.resolveWebviewView(I,{state:v},r)}async $onDidChangeWebviewViewVisibility(d,y){this.getWebviewView(d)._setVisible(y)}async $disposeWebviewView(d){const y=this.getWebviewView(d);this._webviewViews.delete(d),y.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const y=this._webviewViews.get(d);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=_}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(b){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=b.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,n){let f;if(typeof b=="string"){f=b;try{b=E.URI.parse(b)}catch(o){return Promise.reject(`Invalid uri - '${b}'`)}}return(0,F.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,f,n)}async asExternalUri(b,n){if((0,F.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(b,n);return E.URI.from(f)}};P.InitialState={focused:!0},P=$e([Ve(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,12]),function(ne,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends c.AbstractLogger{constructor(S,P){super();this._proxy=S.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...P){this.getLevel()<=c.LogLevel.Trace&&this._proxy.$log(this._logFile,c.LogLevel.Trace,Array.from(arguments))}debug(S,...P){this.getLevel()<=c.LogLevel.Debug&&this._proxy.$log(this._logFile,c.LogLevel.Debug,Array.from(arguments))}info(S,...P){this.getLevel()<=c.LogLevel.Info&&this._proxy.$log(this._logFile,c.LogLevel.Info,Array.from(arguments))}warn(S,...P){this.getLevel()<=c.LogLevel.Warning&&this._proxy.$log(this._logFile,c.LogLevel.Warning,Array.from(arguments))}error(S,...P){this.getLevel()<=c.LogLevel.Error&&this._proxy.$log(this._logFile,c.LogLevel.Error,Array.from(arguments))}critical(S,...P){this.getLevel()<=c.LogLevel.Critical&&this._proxy.$log(this._logFile,c.LogLevel.Critical,Array.from(arguments))}flush(){}};F=$e([Ve(0,A.IExtHostRpcService),Ve(1,E.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[213],Ee([0,1,14,22,21,16,3,6,109,180,38]),function(ne,e,c,M,E,A,F,k,S,P,t){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(g,C){try{return JSON.stringify(g,C)}catch(m){return"null"}}const f="$$ref$$",o={[f]:-1};class l{constructor(C,m){this.jsonString=C,this.referencedBuffers=m}}function w(g,C=null,m=!1){const R=[];return{jsonString:(m?n:JSON.stringify)(g,(V,q)=>{if(typeof q=="undefined")return o;if(typeof q=="object"){if(q instanceof M.VSBuffer){const U=R.push(q)-1;return{[f]:U}}if(C)return C(V,q)}return q}),referencedBuffers:R}}e.stringifyJsonWithBufferRefs=w;function D(g,C,m){return JSON.parse(g,(R,L)=>{if(L){const V=L[f];if(typeof V=="number")return C[V];if(m&&L.$mid===1)return m.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=D;function _(g,C){return JSON.stringify(g,C)}function a(g){return g?(C,m)=>m&&m.$mid===1?g.transformOutgoing(m):m:null}var d;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},v=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends k.Disposable{constructor(C,m=null,R=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=C,this._logger=m,this._uriTransformer=R,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,V=t.ProxyIdentifier.count;L<V;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(C=>{this._pendingRPCReplies[C].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(C){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(C){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(C){this._responsiveState!==C&&(this._responsiveState=C,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(C){return this._uriTransformer?(0,S.transformIncomingURIs)(C,this._uriTransformer):C}getProxy(C){const{nid:m,sid:R}=C;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,R)),this._proxies[m]}_createProxy(C,m){let R={get:(L,V)=>(typeof V=="string"&&!L[V]&&V.charCodeAt(0)===36&&(L[V]=(...q)=>this._remoteCall(C,V,q)),V===r?m:L[V])};return new Proxy(Object.create(null),R)}set(C,m){return this._locals[C.nid]=m,m}assertRegistered(C){for(let m=0,R=C.length;m<R;m++){const L=C[m];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(C){if(this._isDisposed)return;const m=C.byteLength,R=u.read(C,0),L=R.readUInt8(),V=R.readUInt32();switch(L){case 1:case 2:{let{rpcId:q,method:U,args:K}=p.deserializeRequestJSONArgs(R);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(m,V,q,U,K,L===2);break}case 3:case 4:{let{rpcId:q,method:U,args:K}=p.deserializeRequestMixedArgs(R);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(m,V,q,U,K,L===4);break}case 5:{this._logger&&this._logger.logIncoming(m,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(m,V);break}case 7:{this._receiveReply(m,V,void 0);break}case 9:{let q=p.deserializeReplyOKJSON(R);this._uriTransformer&&(q=(0,S.transformIncomingURIs)(q,this._uriTransformer)),this._receiveReply(m,V,q);break}case 10:{const q=p.deserializeReplyOKJSONWithBuffers(R,this._uriTransformer);this._receiveReply(m,V,q);break}case 8:{let q=p.deserializeReplyOKVSBuffer(R);this._receiveReply(m,V,q);break}case 11:{let q=p.deserializeReplyErrError(R);this._uriTransformer&&(q=(0,S.transformIncomingURIs)(q,this._uriTransformer)),this._receiveReplyErr(m,V,q);break}case 12:{this._receiveReplyErr(m,V,void 0);break}default:console.error("received unexpected message"),console.error(C)}}_receiveRequest(C,m,R,L,V,q){this._logger&&this._logger.logIncoming(C,m,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(R)}.${L}(`,V);const U=String(m);let K,$;if(q){const H=new E.CancellationTokenSource;V.push(H.token),K=this._invokeHandler(R,L,V),$=()=>H.cancel()}else K=this._invokeHandler(R,L,V),$=i;this._cancelInvokedHandlers[U]=$;const B=p.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(B.byteLength,m,1,"ack"),this._protocol.send(B),K.then(H=>{delete this._cancelInvokedHandlers[U];const Q=p.serializeReplyOK(m,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,m,1,"reply:",H),this._protocol.send(Q)},H=>{delete this._cancelInvokedHandlers[U];const Q=p.serializeReplyErr(m,H);this._logger&&this._logger.logOutgoing(Q.byteLength,m,1,"replyErr:",H),this._protocol.send(Q)})}_receiveCancel(C,m){this._logger&&this._logger.logIncoming(C,m,1,"receiveCancel");const R=String(m);this._cancelInvokedHandlers[R]&&this._cancelInvokedHandlers[R]()}_receiveReply(C,m,R){this._logger&&this._logger.logIncoming(C,m,0,"receiveReply:",R);const L=String(m);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],V.resolveOk(R)}_receiveReplyErr(C,m,R){this._logger&&this._logger.logIncoming(C,m,0,"receiveReplyErr:",R);const L=String(m);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let q;R&&(R.$isError?(q=new Error,q.name=R.name,q.message=R.message,q.stack=R.stack):q=R),V.resolveErr(q)}_invokeHandler(C,m,R){try{return Promise.resolve(this._doInvokeHandler(C,m,R))}catch(L){return Promise.reject(L)}}_doInvokeHandler(C,m,R){const L=this._locals[C];if(!L)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(C));let V=L[m];if(typeof V!="function")throw new Error("Unknown method "+m+" on actor "+(0,t.getStringIdentifierForProxy)(C));return V.apply(L,R)}_remoteCall(C,m,R){if(this._isDisposed)return Promise.reject(A.canceled());let L=null;if(R.length>0&&E.CancellationToken.isCancellationToken(R[R.length-1])&&(L=R.pop()),L&&L.isCancellationRequested)return Promise.reject(A.canceled());const V=p.serializeRequestArguments(R,this._uriReplacer),q=++this._lastMessageId,U=String(q),K=new P.LazyPromise;L&&L.onCancellationRequested(()=>{const B=p.serializeCancel(q);this._logger&&this._logger.logOutgoing(B.byteLength,q,0,"cancel"),this._protocol.send(p.serializeCancel(q))}),this._pendingRPCReplies[U]=K,this._onWillSendRequest(q);const $=p.serializeRequest(q,C,m,V,!!L);return this._logger&&this._logger.logOutgoing($.byteLength,q,0,`request: ${(0,t.getStringIdentifierForProxy)(C)}.${m}(`,R),this._protocol.send($),K}}e.RPCProtocol=s,b=v,s.UNRESPONSIVE_TIME=3*1e3;class u{constructor(C,m){this._buff=C,this._offset=m}static alloc(C,m,R){let L=new u(M.VSBuffer.alloc(R+1+4),0);return L.writeUInt8(C),L.writeUInt32(m),L}static read(C,m){return new u(C,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(C){this._buff.writeUInt8(C,this._offset),this._offset+=1}readUInt8(){const C=this._buff.readUInt8(this._offset);return this._offset+=1,C}writeUInt32(C){this._buff.writeUInt32BE(C,this._offset),this._offset+=4}readUInt32(){const C=this._buff.readUInt32BE(this._offset);return this._offset+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this._buff.writeUInt8(C.byteLength,this._offset),this._offset+=1,this._buff.set(C,this._offset),this._offset+=C.byteLength}readShortString(){const C=this._buff.readUInt8(this._offset);this._offset+=1;const R=this._buff.slice(this._offset,this._offset+C).toString();return this._offset+=C,R}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}readLongString(){const C=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+C).toString();return this._offset+=C,R}writeBuffer(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this._buff.writeUInt32BE(C.byteLength,this._offset),this._offset+=4,this._buff.set(C,this._offset),this._offset+=C.byteLength}readVSBuffer(){const C=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+C);return this._offset+=C,m}static sizeMixedArray(C){let m=0;m+=1;for(let R=0,L=C.length;R<L;R++){const V=C[R];switch(m+=1,V.type){case 1:m+=this.sizeLongString(V.value);break;case 2:m+=this.sizeVSBuffer(V.value);break;case 3:m+=this.sizeUInt32,m+=this.sizeLongString(V.value);for(let q=0;q<V.buffers.length;++q)m+=this.sizeVSBuffer(V.buffers[q]);break;case 4:break}}return m}writeMixedArray(C){this._buff.writeUInt8(C.length,this._offset),this._offset+=1;for(let m=0,R=C.length;m<R;m++){const L=C[m];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let V=0;V<L.buffers.length;++V)this.writeBuffer(L.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(C);for(let R=0;R<C;R++)switch(this.readUInt8()){case 1:m[R]=this.readLongString();break;case 2:m[R]=this.readVSBuffer();break;case 3:const V=this.readUInt32(),q=this.readLongString(),U=[];for(let K=0;K<V;++K)U.push(this.readVSBuffer());m[R]=new t.SerializableObjectWithBuffers(D(q,U,null));break;case 4:m[R]=void 0;break}return m}}u.sizeUInt32=4;var h;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(h||(h={}));class p{static _useMixedArgSerialization(C){for(let m=0,R=C.length;m<R;m++)if(C[m]instanceof M.VSBuffer||C[m]instanceof t.SerializableObjectWithBuffers||typeof C[m]=="undefined")return!0;return!1}static serializeRequestArguments(C,m){if(this._useMixedArgSerialization(C)){const R=[];for(let L=0,V=C.length;L<V;L++){const q=C[L];if(q instanceof M.VSBuffer)R[L]={type:2,value:q};else if(typeof q=="undefined")R[L]={type:4};else if(q instanceof t.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:K}=w(q.value,m);R[L]={type:3,value:M.VSBuffer.fromString(U),buffers:K}}else R[L]={type:1,value:M.VSBuffer.fromString(_(q,m))}}return{type:1,args:R}}return{type:0,args:_(C,m)}}static serializeRequest(C,m,R,L,V){switch(L.type){case 0:return this._requestJSONArgs(C,m,R,L.args,V);case 1:return this._requestMixedArgs(C,m,R,L.args,V)}}static _requestJSONArgs(C,m,R,L,V){const q=M.VSBuffer.fromString(R),U=M.VSBuffer.fromString(L);let K=0;K+=u.sizeUInt8(),K+=u.sizeShortString(q),K+=u.sizeLongString(U);let $=u.alloc(V?2:1,C,K);return $.writeUInt8(m),$.writeShortString(q),$.writeLongString(U),$.buffer}static deserializeRequestJSONArgs(C){const m=C.readUInt8(),R=C.readShortString(),L=C.readLongString();return{rpcId:m,method:R,args:JSON.parse(L)}}static _requestMixedArgs(C,m,R,L,V){const q=M.VSBuffer.fromString(R);let U=0;U+=u.sizeUInt8(),U+=u.sizeShortString(q),U+=u.sizeMixedArray(L);let K=u.alloc(V?4:3,C,U);return K.writeUInt8(m),K.writeShortString(q),K.writeMixedArray(L),K.buffer}static deserializeRequestMixedArgs(C){const m=C.readUInt8(),R=C.readShortString(),L=C.readMixedArray(),V=new Array(L.length);for(let q=0,U=L.length;q<U;q++){const K=L[q];typeof K=="string"?V[q]=JSON.parse(K):V[q]=K}return{rpcId:m,method:R,args:V}}static serializeAcknowledged(C){return u.alloc(5,C,0).buffer}static serializeCancel(C){return u.alloc(6,C,0).buffer}static serializeReplyOK(C,m,R){if(typeof m=="undefined")return this._serializeReplyOKEmpty(C);if(m instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(C,m);if(m instanceof t.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:V}=w(m.value,R,!0);return this._serializeReplyOKJSONWithBuffers(C,L,V)}else return this._serializeReplyOKJSON(C,n(m,R))}static _serializeReplyOKEmpty(C){return u.alloc(7,C,0).buffer}static _serializeReplyOKVSBuffer(C,m){let R=0;R+=u.sizeVSBuffer(m);let L=u.alloc(8,C,R);return L.writeVSBuffer(m),L.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static _serializeReplyOKJSON(C,m){const R=M.VSBuffer.fromString(m);let L=0;L+=u.sizeLongString(R);let V=u.alloc(9,C,L);return V.writeLongString(R),V.buffer}static _serializeReplyOKJSONWithBuffers(C,m,R){const L=M.VSBuffer.fromString(m);let V=0;V+=u.sizeUInt32,V+=u.sizeLongString(L);for(const U of R)V+=u.sizeVSBuffer(U);let q=u.alloc(10,C,V);q.writeUInt32(R.length),q.writeLongString(L);for(const U of R)q.writeBuffer(U);return q.buffer}static deserializeReplyOKJSON(C){const m=C.readLongString();return JSON.parse(m)}static deserializeReplyOKJSONWithBuffers(C,m){const R=C.readUInt32(),L=C.readLongString(),V=[];for(let q=0;q<R;++q)V.push(C.readVSBuffer());return new t.SerializableObjectWithBuffers(D(L,V,m))}static serializeReplyErr(C,m){return m?this._serializeReplyErrEror(C,m):this._serializeReplyErrEmpty(C)}static _serializeReplyErrEror(C,m){const R=M.VSBuffer.fromString(n(A.transformErrorForSerialization(m),null));let L=0;L+=u.sizeLongString(R);let V=u.alloc(11,C,L);return V.writeLongString(R),V.buffer}static deserializeReplyErrError(C){const m=C.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(C){return u.alloc(12,C,0).buffer}}var I;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(I||(I={}));var T;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(T||(T={}))}),define(be[214],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(A){const F=k=>{self.removeEventListener("message",F);const S=k.data;Object.defineProperties(self,{postMessage:{value(P,t){S.postMessage(P,t)}},onmessage:{get(){return S.onmessage},set(P){S.onmessage=P}}}),S.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(A,F,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${c})('${F}'))`,P=new Blob([S],{type:"application/javascript"}),t=URL.createObjectURL(P),b=new MessageChannel,n=t,f={type:"_newWorker",id:n,port:b.port2,url:t,options:k};A(f,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};b.port1.postMessage(o),URL.revokeObjectURL(t),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(o){b.port1.onmessage=o}},onmessageerror:{get(){return b.port1.onmessageerror},set(o){b.port1.onmessageerror=o}}}),b.port1.addEventListener("messageerror",o=>{const l=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(l)}),b.port1.addEventListener("message",o=>{const l=new MessageEvent("message",{data:o.data});this.dispatchEvent(l)}),b.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,86,47,176,215]),function(ne,e,c,M,E,A,F,k,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let b=class $i{constructor(f,o,l,w){this.localUserHome=f,this.remoteAgentService=o,this.environmentService=l,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||f})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return c.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const w=o.getWorkspace().folders[0];if(w)return w.uri.scheme;const D=o.getWorkspace().configuration;return D?D.scheme:c.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?M.win32:M.posix)}async fileURI(f){let o="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const w=f.indexOf("/",2);w===-1?(o=f.substring(2),f="/"):(o=f.substring(2,w),f=f.substring(w)||"/")}return A.URI.from({scheme:c.Schemas.file,authority:o,path:f,query:"",fragment:""})}};b=$e([Ve(1,t.IRemoteAgentService),Ve(2,P.IWorkbenchEnvironmentService),Ve(3,S.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(be[98],Ee([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(F,k){this.line=F,this.character=k}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,k){return new c(0,0)}with(F){return new c(0,0)}}e.Position=c;class M{constructor(F,k,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(F,k),this.end=new c(S,P)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,13,27,23,43,9,4,17,16,98,10]),function(ne,e,c,M,E,A,F,k,S,P,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",o=(n.length+f.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var l;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function D(B){return!!B.preview}e.resultIsMatch=D;function _(B){return!!B.resource}e.isFileMatch=_;function a(B){return!!B.message}e.isProgressMessage=a;var d;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=y;class i{constructor(H,Q,re){this.ranges=Q;const ue=Array.isArray(Q)?Q:[Q];if(re&&re.matchLines===1&&v(ue)){H=(0,F.getNLines)(H,re.matchLines);let Z="",oe=0,ve=0;const Ae=Math.floor(re.charsPerLine/5),Se=[];for(const Ne of ue){const We=Math.max(Ne.startColumn-Ae,0),je=Ne.startColumn+re.charsPerLine;if(We>ve+Ae+o){const qe=n+(We-ve)+f;Z+=qe+H.slice(We,je),oe+=We-(ve+qe.length)}else Z+=H.slice(ve,je);Se.push(new s(0,Ne.startColumn-oe,Ne.endColumn-oe)),ve=je}this.preview={text:Z,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const Z=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:H,matches:(0,c.mapArrayOrNot)(Q,oe=>new r(oe.startLineNumber-Z,oe.startColumn,oe.endLineNumber-Z,oe.endColumn))}}}}e.TextSearchMatch=i;function v(B){const H=B[0].startLineNumber;for(const Q of B)if(Q.startLineNumber!==H||Q.endLineNumber!==H)return!1;return!0}class r{constructor(H,Q,re,ue){this.startLineNumber=H,this.startColumn=Q,this.endLineNumber=re,this.endColumn=ue}}e.SearchRange=r;class s extends r{constructor(H,Q,re){super(H,Q,H,re)}}e.OneLineRange=s;var u;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function h(B,H=!0){const Q=B&&B.files&&B.files.exclude,re=H&&B&&B.search&&B.search.exclude;if(!Q&&!re)return;if(!Q||!re)return Q||re;let ue=Object.create(null);return ue=E.mixin(ue,E.deepClone(Q)),ue=E.mixin(ue,E.deepClone(re),!0),ue}e.getExcludes=h;function p(B,H){return B.excludePattern&&M.match(B.excludePattern,H)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&M.match(B.includePattern,H)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(Q=>{const re=Q.folder.fsPath;if(A.isEqualOrParent(H,re)){const ue=S.relative(re,H);return!Q.includePattern||!!M.match(Q.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var I;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(I=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(H,Q){super(H);this.code=Q}}e.SearchError=T;function g(B){const H=B.message;if((0,P.isPromiseCanceledError)(B))return new T(H,I.canceled);try{const Q=JSON.parse(H);return new T(Q.message,Q.code)}catch(Q){return new T(H,I.other)}}e.deserializeSearchError=g;function C(B){const H={message:B.message,code:B.code};return new Error(JSON.stringify(H))}e.serializeSearchError=C;function m(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=m;function R(B){return B.type==="success"}e.isSerializedSearchSuccess=R;function L(B){return!!B.path}e.isSerializedFileMatch=L;function V(B,H){const Q=B.searchPath?B.searchPath:B.relativePath;return(0,F.fuzzyContains)(Q,H)}e.isFilePatternMatch=V;class q{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=q;function U(B,H){const Q={...B||{},...H||{}};return Object.keys(Q).filter(re=>{const ue=Q[re];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=U;class K{constructor(H,Q){this._parsedIncludeExpression=null,this._excludeExpression={...H.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let re=H.includePattern;Q.includePattern&&(re?re={...re,...Q.includePattern}:re=Q.includePattern),re&&(this._parsedIncludeExpression=M.parse(re))}includedInQuerySync(H,Q,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,Q,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,Q,re))}includedInQuery(H,Q,re){const ue=this._parsedExcludeExpression(H,Q,re),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(H,Q,re):!0;return(0,b.isPromise)(ue)?ue.then(oe=>oe?!1:Z()):Z()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=K;function $(B){for(const H in B)if(typeof B[H]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,13,14,21,3,20,11,75,24,9,10,2,130,4,15,145,47,37,29,12,7,41,5]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a,d,y,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(C,m,R){return new P.ExtUri(L=>p(L,R)).isEqual(C,m)}function s(C,m,R){return r(C.uri,m.uri,R)?0:(0,t.compare)(C.uri.toString(),m.uri.toString())}function u(C,m,R){return C.index!==m.index?C.index<m.index?-1:1:r(C.uri,m.uri,R)?(0,t.compare)(C.name,m.name):(0,t.compare)(C.uri.toString(),m.uri.toString())}function h(C,m,R,L){const V=C.slice(0).sort((U,K)=>R(U,K,L)),q=m.slice(0).sort((U,K)=>R(U,K,L));return(0,c.delta)(V,q,(U,K)=>R(U,K,L))}function p(C,m){const R=m.getCapabilities(C.scheme);return!(R&&R&1024)}class I extends D.Workspace{constructor(m,R,L,V,q,U,K){super(m,L.map($=>new D.WorkspaceFolder($)),V,q,K);this._name=R,this._isUntitled=U,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(K),L.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(m,R,L,V){if(!m)return{workspace:null,added:[],removed:[]};const{id:q,name:U,folders:K,configuration:$,transient:B,isUntitled:H}=m,Q=[],re=R;R?K.forEach((ve,Ae)=>{const Se=n.URI.revive(ve.uri),Ne=I._findFolder(L||R,Se,V);Ne?(Ne.name=ve.name,Ne.index=ve.index,Q.push(Ne)):Q.push({uri:Se,name:ve.name,index:Ae})}):Q.push(...K.map(({uri:ve,name:Ae,index:Se})=>({uri:n.URI.revive(ve),name:Ae,index:Se}))),Q.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const ue=new I(q,U,Q,!!B,$?n.URI.revive($):null,!!H,ve=>p(ve,V)),{added:Z,removed:oe}=h(re?re.workspaceFolders:[],ue.workspaceFolders,s,V);return{workspace:ue,added:Z,removed:oe}}static _findFolder(m,R,L){for(let V=0;V<m.folders.length;V++){const q=m.workspaceFolders[V];if(r(q.uri,R,L))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(m,R){return R&&this._structure.get(m)&&(m=(0,P.dirname)(m)),this._structure.findSubstr(m)}resolveWorkspaceFolder(m){return this._structure.get(m)}}let T=class{constructor(m,R,L,V){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=L,this._requestIdProvider=new S.Counter,this._barrier=new M.Barrier,this._proxy=m.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=m.getProxy(v.MainContext.MainThreadMessageService);const q=R.workspace;this._confirmedWorkspace=q?new I(q.id,q.name,[],!!q.transient,q.configuration?n.URI.revive(q.configuration):null,!!q.isUntitled,U=>p(U,L)):void 0}$initializeWorkspace(m,R){this._trusted=R,this.$acceptWorkspaceData(m),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(m,R,L,...V){const q=[];if(Array.isArray(V)&&V.forEach(H=>{n.URI.isUri(H.uri)&&!q.some(Q=>r(Q.uri,H.uri,this._extHostFileSystemInfo))&&q.push({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[R,L].some(H=>typeof H!="number"||H<0)||L===0&&q.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(R+L>U.length)return!1;const K=U.slice(0);K.splice(R,L,...q.map(H=>({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<K.length;H++){const Q=K[H];if(K.some((re,ue)=>ue!==H&&r(Q.uri,re.uri,this._extHostFileSystemInfo)))return!1}K.forEach((H,Q)=>H.index=Q);const{added:$,removed:B}=h(U,K,u,this._extHostFileSystemInfo);if($.length===0&&B.length===0)return!1;if(this._proxy){const H=m.displayName||m.name;this._proxy.$updateWorkspaceFolders(H,R,L,q).then(void 0,Q=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,f.localize)(0,null,H,Q.toString()),{extension:m},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(m,R){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(m,R)}async getWorkspaceFolder2(m,R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(m,R)}async resolveWorkspaceFolder(m){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(m)}getPath(){if(!this._actualWorkspace)return;const{folders:m}=this._actualWorkspace;if(m.length!==0)return m[0].uri.fsPath}getRelativePath(m,R){let L,V="";if(typeof m=="string"?(L=n.URI.file(m),V=m):typeof m!="undefined"&&(L=m,V=m.fsPath),!L)return V;const q=this.getWorkspaceFolder(L,!0);if(!q)return V;typeof R=="undefined"&&this._actualWorkspace&&(R=this._actualWorkspace.folders.length>1);let U=(0,P.relativePath)(q.uri,L);return R&&q.name&&(U=`${q.name}/${U}`),U}trySetWorkspaceFolders(m){this._actualWorkspace&&(this._unconfirmedWorkspace=I.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:m,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(m){const{workspace:R,added:L,removed:V}=I.toExtHostWorkspace(m,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=R||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:V}))}findFiles(m,R,L,V,q=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let U;if(R===null?U=!1:R&&(typeof R=="string"?U=R:U=R.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:$}=g(m);return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(K),(0,b.withUndefinedAsNull)($),(0,b.withUndefinedAsNull)(U),(0,b.withUndefinedAsNull)(L),q).then(B=>Array.isArray(B)?B.map(H=>n.URI.revive(H)):[])}async findTextInFiles(m,R,L,V,q=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),K=typeof R.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:R.previewOptions,{includePattern:$,folder:B}=g(R.include),H=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,Q={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!0,fileEncoding:R.encoding,maxResults:R.maxResults,previewOptions:K,afterContext:R.afterContext,beforeContext:R.beforeContext,includePattern:$,excludePattern:H},re=!1;if(this._activeSearchCallbacks[U]=ue=>{if(re)return;const Z=n.URI.revive(ue.resource);ue.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?L({uri:Z,preview:{text:oe.preview.text,matches:(0,c.mapArrayOrNot)(oe.preview.matches,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,c.mapArrayOrNot)(oe.ranges,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):L({uri:Z,text:oe.text,lineNumber:oe.lineNumber})})},q.isCancellationRequested)return{};try{const ue=await this._proxy.$startTextSearch(m,(0,b.withUndefinedAsNull)(B),Q,U,q);return delete this._activeSearchCallbacks[U],ue||{}}catch(ue){throw delete this._activeSearchCallbacks[U],ue}}$handleTextSearchResult(m,R){this._activeSearchCallbacks[R]&&this._activeSearchCallbacks[R](m)}saveAll(m){return this._proxy.$saveAll(m)}resolveProxy(m){return this._proxy.$resolveProxy(m)}get trusted(){return this._trusted}requestWorkspaceTrust(m){return this._proxy.$requestWorkspaceTrust(m)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=$e([Ve(0,d.IExtHostRpcService),Ve(1,a.IExtHostInitDataService),Ve(2,_.IExtHostFileSystemInfo),Ve(3,l.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function g(C){let m,R;return C&&(typeof C=="string"?m=C:(m=C.pattern,R=C.baseFolder||n.URI.file(C.base))),{includePattern:m,folder:R}}}),define(be[32],Ee([0,1,23,3,31,5,7,148,62,10,14,4,12,15,2]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(v,r){if(r){const s=r.split(".");let u=v;for(let h=0;u&&h<s.length;h++)u=u[s[h]];return u}}function w(v){return v instanceof o.URI}function D(v){return v&&v.uri instanceof o.URI&&v.languageId&&typeof v.languageId=="string"}function _(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function a(v){return v&&v.uri instanceof o.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function d(v){if(w(v))return{resource:v};if(D(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(_(v))return{overrideIdentifier:v.languageId};if(a(v))return{resource:v.uri};if(v===null)return{resource:null}}let y=class{constructor(r,s,u){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,s))}};y=$e([Ve(0,n.IExtHostRpcService),Ve(1,E.IExtHostWorkspace),Ve(2,f.ILogService)],y),e.ExtHostConfiguration=y;class i{constructor(r,s,u,h){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=h,this._extHostWorkspace=s,this._configuration=k.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(r,s,u){const h=d(s)||{},p=this._toReadonlyValue(r?l(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,h,u?.identifier);function I(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(g){return typeof l(p,g)!="undefined"},get:(g,C)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,h,u?.identifier);let m=l(p,g);if(typeof m=="undefined")m=C;else{let R;const L=(V,q)=>{let U;const K=()=>{R=R||(0,c.deepClone)(p),U=U||l(R,q)};return(0,P.isObject)(V)?new Proxy(V,{get:($,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return K(),()=>U;if(R)return U=U||l(R,q),U[B];const H=$[B];return typeof B=="string"?L(H,`${q}.${B}`):H},set:($,B,H)=>(K(),U&&(U[B]=H),!0),deleteProperty:($,B)=>(K(),U&&delete U[B],!0),defineProperty:($,B,H)=>(K(),U&&Object.defineProperty(U,B,H),!0)}):V};m=L(m,g)}return m},update:(g,C,m,R)=>{g=r?`${r}.${g}`:g;const L=I(m);return C!==void 0?this._proxy.$updateConfigurationOption(L,g,C,h,R):this._proxy.$removeConfigurationOption(L,g,h,R)},inspect:g=>{g=r?`${r}.${g}`:g;const C=(0,c.deepClone)(this._configuration.inspect(g,h,this._extHostWorkspace.workspace));if(C)return{key:g,defaultValue:C.default?.value,globalValue:C.user?.value,workspaceValue:C.workspace?.value,workspaceFolderValue:C.workspaceFolder?.value,defaultLanguageValue:C.default?.override,globalLanguageValue:C.user?.override,workspaceLanguageValue:C.workspace?.override,workspaceFolderLanguageValue:C.workspaceFolder?.override,languageIds:C.overrideIdentifiers}}};return typeof p=="object"&&(0,c.mixin)(T,p,!1),Object.freeze(T)}_toReadonlyValue(r){const s=u=>(0,P.isObject)(u)?new Proxy(u,{get:(h,p)=>s(h[p]),set:(h,p,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(h,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(h,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(r)}_validateConfigurationAccess(r,s,u){const h=S.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),p=u?`[${u.value}] `:"";if(h===4){typeof s?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){s?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const u=new k.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,p)=>u.affectsConfiguration(h,d(p))})}_toMap(r){return r.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[99],Ee([0,1,2,14,3,5,7,31,49,32,21,40,12,29,4,11,25,15,69,166,16]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(q){function U($){if($!=null)return $}q.from=U;function K($){if($!=null)return $}q.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var v;(function(q){function U($){if($!=null)return $}q.from=U;function K($){if($!=null)return $}q.to=K})(v=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(q){function U($){if($!=null)return $}q.from=U;function K($){if($!=null)return $}q.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(q){function U(B){if(B){const H=B;return H&&!!H.process}else return!1}q.is=U;function K(B){if(B==null)return;const H={process:B.process,args:B.args};return B.options&&(H.options=r.from(B.options)),H}q.from=K;function $(B){if(B!=null)return new F.ProcessExecution(B.process,B.args,B.options)}q.to=$})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(q){function U($){if($!=null)return $}q.from=U;function K($){if($!=null)return $}q.to=K})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(q){function U(B){if(B){const H=B;return H&&(!!H.commandLine||!!H.command)}else return!1}q.is=U;function K(B){if(B==null)return;const H={};return B.commandLine!==void 0?H.commandLine=B.commandLine:(H.command=B.command,H.args=B.args),B.options&&(H.options=u.from(B.options)),H}q.from=K;function $(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new F.ShellExecution(B.commandLine,B.options):new F.ShellExecution(B.command,B.args?B.args:[],B.options)}q.to=$})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(q){function U(B){if(B){let H=B;return H&&H.customExecution==="customExecution"}else return!1}q.is=U;function K(B){return{customExecution:"customExecution"}}q.from=K;function $(B,H){return H.get(B)}q.to=$})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(q){function U(K,$){let B;return K.scope!==void 0&&typeof K.scope!="number"?B=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===F.TaskScope.Workspace&&$&&$.workspaceFile?B=$.workspaceFile:B=a.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:B}}q.from=U})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(q){function U(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}q.from=U})(T=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(q){function U(B,H){if(B==null)return[];const Q=[];for(let re of B){const ue=K(re,H);ue&&Q.push(ue)}return Q}q.fromMany=U;function K(B,H){if(B==null)return;let Q;B.execution instanceof F.ProcessExecution?Q=s.from(B.execution):B.execution instanceof F.ShellExecution?Q=h.from(B.execution):B.execution&&B.execution instanceof F.CustomExecution&&(Q=p.from(B.execution));const re=i.from(B.definition);let ue;return B.scope?typeof B.scope=="number"?ue=B.scope:ue=B.scope.uri:ue=F.TaskScope.Workspace,!re||!ue?void 0:{_id:B._id,definition:re,name:B.name,source:{extensionId:H.identifier.value,label:B.source,scope:ue},execution:Q,isBackground:B.isBackground,group:T.from(B.group),presentationOptions:v.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}q.from=K;async function $(B,H,Q){if(B==null)return;let re;s.is(B.execution)?re=s.to(B.execution):h.is(B.execution)?re=h.to(B.execution):p.is(B.execution)&&(re=p.to(B._id,Q));const ue=i.to(B.definition);let Z;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Z=B.source.scope:Z=await H.resolveWorkspaceFolder(c.URI.revive(B.source.scope)):Z=F.TaskScope.Workspace),!ue||!Z)return;const oe=new F.Task(ue,Z,B.name,B.source.label,re,B.problemMatchers);return B.isBackground!==void 0&&(oe.isBackground=B.isBackground),B.group!==void 0&&(oe.group=F.TaskGroup.from(B.group._id),oe.group&&B.group.isDefault&&(oe.group=new F.TaskGroup(oe.group.id,oe.group.label),B.group.isDefault&&(oe.group.isDefault=B.group.isDefault))),B.presentationOptions&&(oe.presentationOptions=v.to(B.presentationOptions)),B._id&&(oe._id=B._id),B.detail&&(oe.detail=B.detail),oe}q.to=$})(g=e.TaskDTO||(e.TaskDTO={}));var C;(function(q){function U($){return $}q.from=U;function K($){if(!!$)return Object.assign(Object.create(null),$)}q.to=K})(C=e.TaskFilterDTO||(e.TaskFilterDTO={}));class m{constructor(U,K,$){this._id=K,this._task=$,y.set(this,void 0),et(this,y,U,"f")}get task(){return this._task}terminate(){Fe(this,y,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}y=new WeakMap;var R;(function(q){function U(K){return{id:K._id,task:void 0}}q.from=U})(R=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(U,K,$,B,H,Q,re,ue){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=U.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=B,this._configurationService=H,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,K,$){if(!$)return new F.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:K,provider:$,extension:U}),this._proxy.$registerTaskProvider(B,K),new F.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(U,K){this._proxy.$registerTaskSystem(U,K)}fetchTasks(U){return this._proxy.$fetchTasks(C.from(U)).then(async K=>{const $=[];for(let B of K){const H=await g.to(B,this._workspaceProvider,this._providedCustomExecutions2);H&&$.push(H)}return $})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(K=>U.push(K)),U}terminateTask(U){if(!(U instanceof m))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,K,$){const B=this._providedCustomExecutions2.get(U.id);if(B){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,B),this._terminalService.attachPtyToTerminal(K,await B.callback($))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const K=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:K,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:U.exitCode})}$provideTasks(U,K){const $=this._handlers.get(U);if(!$)return Promise.reject(new Error("no handler found"));const B=[],H=(0,M.asPromise)(()=>$.provider.provideTasks(t.CancellationToken.None)).then(Q=>this.provideTasksInternal(K,B,$,Q));return new Promise(Q=>{H.then(re=>{Promise.all(B).then(()=>{Q(re)})})})}async $resolveTask(U,K){const $=this._handlers.get(U);if(!$)return Promise.reject(new Error("no handler found"));if(K.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${$.type}].`);const B=await g.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const H=await $.provider.resolveTask(B,t.CancellationToken.None);if(!H)return;this.checkDeprecation(H,$);const Q=g.from(H,$.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(Q.execution)&&await this.addCustomExecution(Q,H,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,K,$){const B=await this._proxy.$createTaskId(U);!$&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,K.execution)}async getTaskExecution(U,K){if(typeof U=="string"){const H=this._taskExecutionPromises.get(U);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let $=this._taskExecutionPromises.get(U.id);if($)return $;const B=new Promise(async(H,Q)=>{const re=K||await g.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);re?H(new m(this,U.id,re)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,B),B.then(H=>(this._taskExecutions.set(U.id,H),H),H=>Promise.reject(H))}checkDeprecation(U,K){U._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let $=this._notProvidedCustomExecutions.values(),B=$.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=$.next()}};L=$e([Ve(0,n.IExtHostRpcService),Ve(1,f.IExtHostInitDataService),Ve(2,k.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,P.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,D.ILogService),Ve(7,_.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let V=class extends L{constructor(U,K,$,B,H,Q,re,ue){super(U,K,$,B,H,Q,re,ue);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(U,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const $=g.from(K,U);if($===void 0)throw new Error("Task is not valid");if(p.is($.execution))await this.addCustomExecution($,K,!1);else throw new d.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution($),K);return this._proxy.$executeTask($).catch(H=>{throw new Error(H)}),B}provideTasksInternal(U,K,$,B){const H=[];if(B)for(let Q of B){this.checkDeprecation(Q,$),(!Q.definition||!U[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const re=g.from(Q,$.extension);re&&p.is(re.execution)?(H.push(re),K.push(this.addCustomExecution(re,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:$.extension}}async resolveTaskInternal(U){if(p.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,K,$){}};V=$e([Ve(0,n.IExtHostRpcService),Ve(1,f.IExtHostInitDataService),Ve(2,k.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,P.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,D.ILogService),Ve(7,_.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,13,51,27,77,20,11,17,24,9,10,2,111,134,84,47,92,216,41]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(I,T,g,C){this.configurationService=I,this.workspaceContextService=T,this.editorGroupsService=g,this.pathService=C}text(I,T,g={}){I=this.getContentPattern(I,g);const C=this.configurationService.getValue(),m=T&&T.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(T?.map(w.toWorkspaceFolder),g),type:2,contentPattern:I,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:C.search.usePCRE2||m||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(I,T){const g=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const C={...I,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(I,T)&&(C.isCaseSensitive=!0),this.isMultiline(I)&&(C.isMultiline=!0),C}file(I,T={}){return{...this.commonQuery(I,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(I,T){return I?(I=Array.isArray(I)?I.map(s):s(I),T?this.parseSearchPaths(I):{pattern:i(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],T={}){const g=this.handleIncludeExclude(T.includePattern,T.expandPatterns),C=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),m=I.length>1,R=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,T,C)):I.map(q=>this.getFolderQueryForRoot(q,T,C,m))).filter(q=>!!q),L={_reason:T._reason,folderQueries:R,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:C.pattern,includePattern:g.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const U=c.coalesce(c.flatten(this.editorGroupsService.groups.map($=>$.editors.map(B=>B.resource)))).filter($=>(0,a.pathIncludedInQuery)(L,$.fsPath)),K=this.commonQueryFromFileList(U);return{...L,...K}}const V=T.extraFileResources&&T.extraFileResources.filter(q=>(0,a.pathIncludedInQuery)(L,q.fsPath));return L.extraFileResources=V&&V.length?V:void 0,L}commonQueryFromFileList(I){const T=[],g=new F.ResourceMap,C={};let m=!1;return I.forEach(R=>{if(R.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(R)){const V=this.workspaceContextService.getWorkspaceFolder(R)?.uri??R.with({path:S.dirname(R.fsPath)});let q=g.get(V);q||(m=!0,q={folder:V,includePattern:{}},T.push(q),g.set(V,q));const U=S.relative(V.fsPath,R.fsPath);(0,b.assertIsDefined)(q.includePattern)[U.replace(/\\/g,"/")]=!0}else R.fsPath&&(m=!0,C[R.fsPath]=!0)}),{folderQueries:T,includePattern:C,usingSearchPaths:!0,excludePattern:m?void 0:{"**/*":!0}}}isCaseSensitive(I,T){if(T.isSmartCase){if(I.isRegExp){if(t.containsUppercaseCharacter(I.pattern,!0))return!0}else if(t.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,f.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const T=K=>S.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),C=(Array.isArray(I)?I:v(I)).map(K=>{const $=this.pathService.resolvedUserHome;return $?(0,A.untildify)(K,$.scheme===k.Schemas.file?$.fsPath:$.path):K}),m=M.groupBy(C,K=>T(K)?"searchPaths":"exprSegments"),R=(m.exprSegments||[]).map(K=>t.rtrim(K,"/")).map(K=>t.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),r(K))),L={},V=this.expandSearchPathPatterns(m.searchPaths||[]);V&&V.length&&(L.searchPaths=V);const q=c.flatten(R),U=i(...q);return U&&(L.pattern=U),L}getExcludesForFolder(I,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(I,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const T=c.flatten(I.map(C=>{let{pathPortion:m,globPortion:R}=y(C);R&&(R=u(R));const L=this.expandOneSearchPath(m);return c.flatten(L.map(V=>this.resolveOneSearchPathPattern(V,R)))})),g=new Map;return T.forEach(C=>{const m=C.searchPath.toString(),R=g.get(m);R?C.pattern&&(R.pattern=R.pattern||{},R.pattern[C.pattern]=!0):g.set(m,{searchPath:C.searchPath,pattern:C.pattern?i(C.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(I){if(S.isAbsolute(I)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==k.Schemas.file?[{searchPath:T[0].uri.with({path:I})}]:[{searchPath:n.URI.file(S.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=s(I),I.startsWith("../")||I===".."){const C=S.posix.resolve(T.path,I);return[{searchPath:T.with({path:C})}]}const g=u(I);return[{searchPath:T,pattern:g}]}else{if(I==="./"||I===".\\")return[];{const T=I.replace(/^\.[\/\\]/,""),C=this.workspaceContextService.getWorkspace().folders.map(m=>{const R=T.match(new RegExp(`^${t.escapeRegExpCharacters(m.name)}(?:/(.*)|$)`));return R?{match:R,folder:m}:null}).filter(b.isDefined);if(C.length)return C.map(m=>{const R=m.match[1];return{searchPath:m.folder.uri,pattern:R&&u(R)}});{const m=I.match(/\.[\/\\](.+)[\/\\]?/),R=m?m[1]:I,L=o.localize(0,null,R);throw new Error(L)}}}}resolveOneSearchPathPattern(I,T){const g=I.pattern&&T?`${I.pattern}/${T}`:I.pattern||T,C=[{searchPath:I.searchPath,pattern:g}];return g&&!g.endsWith("**")&&C.push({searchPath:I.searchPath,pattern:g+"/**"}),C}getFolderQueryForSearchPath(I,T,g){const C=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(I.searchPath),T,g,!1);return C?{...C,includePattern:I.pattern}:null}getFolderQueryForRoot(I,T,g,C){let m;const R=n.URI.isUri(I)?I:I.uri;if(g.searchPaths){const K=g.searchPaths.filter($=>(0,P.isEqual)($.searchPath,R))[0];if(K&&!K.pattern)return null;K&&(m=K.pattern)}const L=this.configurationService.getValue({resource:R}),q={...this.getExcludesForFolder(L,T)||{},...m||{}},U=n.URI.isUri(I)?(0,P.basename)(I):I.name;return{folder:R,folderName:C?U:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!L.search.followSymlinks}}};d=$e([Ve(0,l.IConfigurationService),Ve(1,w.IWorkspaceContextService),Ve(2,D.IEditorGroupsService),Ve(3,_.IPathService)],d),e.QueryBuilder=d;function y(p){const I=p.match(/[\*\{\}\(\)\[\]\?]/);if(I){const T=I.index,g=p.substr(0,T).match(/[/|\\][^/\\]*$/);if(g){let C=p.substr(0,g.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:p.substr((g.index||0)+1)}}}return{pathPortion:p}}function i(...p){return p.length?p.reduce((I,T)=>(I[T]=!0,I),Object.create(null)):void 0}function v(p){return E.splitGlobAware(p,",").map(I=>I.trim()).filter(I=>!!I.length)}function r(p){return[`**/${p}/**`,`**/${p}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function u(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(p,I){p=c.distinct(p,C=>C.toString());const T=[],g=I.getWorkspace();return p&&p.forEach(C=>{let m;if(I.getWorkbenchState()===2)m=(0,P.relativePath)(g.folders[0].uri,C),m&&m!=="."&&(m="./"+m);else{const R=I.getWorkspaceFolder(C);if(R){const L=R.name;if(g.folders.filter(q=>q.name===L).length===1){const q=(0,P.relativePath)(R.uri,C);q===""?m=`./${R.name}`:m=`./${R.name}/${q}`}else m=C.fsPath}}m&&T.push(m)}),T}e.resolveResourcesForSearchIncludes=h}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,47]),function(ne,e,c,M,E,A,F,k,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function b(l,w){const D=w.activationEvents;if(!D)return Promise.resolve(void 0);const _=[],a=[];for(const s of D)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||l.forceUsingSearch?a.push(u):_.push(u)}if(_.length===0&&a.length===0)return Promise.resolve(void 0);let d;const y=new Promise((s,u)=>{d=s}),i=s=>d({activationEvent:s}),v=Promise.all(_.map(s=>n(l,s,i))).then(()=>{}),r=f(l,w.identifier,a,i);return Promise.all([v,r]).then(()=>{d(void 0)}),y}e.checkActivateWorkspaceContainsExtension=b;async function n(l,w,D){for(const _ of l.folders)if(await l.exists(c.joinPath(M.URI.revive(_),w))){D(`workspaceContains:${w}`);return}}async function f(l,w,D,_){if(D.length===0)return Promise.resolve(void 0);const a=new E.CancellationTokenSource,d=l.checkExists(l.folders,D,a.token),y=setTimeout(async()=>{a.cancel(),_(`workspaceContainsTimeout:${D.join(",")}`)},t);let i=!1;try{i=await d}catch(v){A.isPromiseCanceledError(v)||A.onUnexpectedError(v)}a.dispose(),clearTimeout(y),i&&_(`workspaceContains:${D.join(",")}`)}function o(l,w,D,_){const a=l.get(F.IInstantiationService),d=l.get(S.ISearchService),i=a.createInstance(k.QueryBuilder).file(w.map(v=>(0,P.toWorkspaceFolder)(M.URI.revive(v))),{_reason:"checkExists",includePattern:D,exists:!0});return d.fileSearch(i,_).then(v=>!!v.limitHit,v=>A.isPromiseCanceledError(v)?!1:Promise.reject(v))}e.checkGlobFileExists=o});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,c):E?E.value=c:e.set(ne,c),c},Fe=this&&this.__classPrivateFieldGet||function(ne,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ne):M?M.value:e.get(ne)};define(be[33],Ee([0,1,125,17,74,24,14,6,20,2,15,5,32,179,72,31,30,177,16,26,22,153,7,85,4,29,73,12,61,64,40,3,218,68,155]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a,d,y,i,v,r,s,u,h,p,I,T,g,C,m,R){"use strict";var L,V,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Wi extends k.Disposable{constructor(H,Q,re,ue,Z,oe,ve,Ae,Se,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=re,this._initData=ve,this._extHostWorkspace=ue,this._extHostConfiguration=Z,this._logService=oe,this._extHostTunnelService=Se,this._extHostTerminalService=Ne,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new m.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=H.createChild(new p.ServiceCollection([o.IExtHostStorage,this._storage],[m.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(je=>We.add(a.ExtensionIdentifier.toKey(je))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,qe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,_.transformErrorForSerialization(qe),x)},actualActivateExtension:async(je,qe)=>{if(We.has(a.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,qe),new f.HostExtension;const x=this._registry.getExtensionDescription(je);return this._activateExtension(x,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(H){_.onUnexpectedError(H)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let H=[];try{H=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch(Q){}await Promise.all(H)}isActivated(H){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(H):!1}_activateByEvent(H,Q){return this._activator.activateByEvent(H,Q)}_activateById(H,Q){return this._activator.activateById(H,Q)}activateByIdWithErrors(H,Q){return this._activateById(H,Q).then(()=>{const re=this._activator.getActivatedExtension(H);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(H=>this._registry)}getExtensionExports(H){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(H).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const H=S.TernarySearchTree.forPaths(),Q=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(ue=>H.set(P.URI.file(ue).fsPath,re))});this._extensionPathIndex=Promise.all(Q).then(()=>H)}return this._extensionPathIndex}_deactivate(H){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(H))return Q;const re=this._activator.getActivatedExtension(H);if(!re)return Q;try{typeof re.module.deactivate=="function"&&(Q=Promise.resolve(re.module.deactivate()).then(void 0,ue=>(this._logService.error(ue),Promise.resolve(void 0))))}catch(ue){this._logService.error(ue)}try{(0,k.dispose)(re.subscriptions)}catch(ue){this._logService.error(ue)}return Q}async _activateExtension(H,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier),this._doActivateExtension(H,Q).then(re=>{const ue=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(H.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,Q),this._logExtensionActivationTimes(H,Q,"success",ue),re},re=>{throw this._logExtensionActivationTimes(H,Q,"failure"),re})}_logExtensionActivationTimes(H,Q,re,ue){const Z=K(H,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...ue||{},outcome:re})}_doActivateExtension(H,Q){const re=K(H,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const ue=this._getEntryPoint(H);if(!ue)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${H.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const Z=new f.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(H.identifier,(0,A.joinPath)(H.extensionLocation,ue),Z),this._loadExtensionContext(H)]).then(oe=>(E.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),Wi._callActivate(this._logService,H.identifier,oe[0],oe[1],Z))).then(oe=>(E.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),oe))}_loadExtensionContext(H){const Q=new y.ExtensionGlobalMemento(H,this._storage),re=new y.ExtensionMemento(H.identifier.value,!1,this._storage),ue=new R.ExtensionSecrets(H,this._secretState),Z=H.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([Q.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Ae;return Object.freeze({globalState:Q,workspaceState:re,secrets:ue,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(Se){return M.join(H.extensionLocation.fsPath,Se)},get storagePath(){return ve._storagePath.workspaceValue(H)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(H).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,H.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,H.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(H)},get globalStorageUri(){return ve._storagePath.globalValue(H)},get extensionMode(){return Z},get extension(){return Ae===void 0&&(Ae=new $(ve,H.identifier,H,oe)),Ae},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(H),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(H)}})})}static _callActivate(H,Q,re,ue,Z){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional(H,Q,re,ue,Z).then(oe=>new f.ActivatedExtension(!1,null,Z.build(),re,oe,ue.subscriptions))}static _callActivateOptional(H,Q,re,ue,Z){if(typeof re.activate=="function")try{Z.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const oe=typeof global=="object"?global:self,ve=re.activate.apply(oe,[ue]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(ve).then(Ae=>(Z.activateResolveStop(),Ae))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(re)}_activateOneStartupFinished(H,Q){this._activateById(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:Q}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const H of this._registry.getAllExtensionDescriptions())if(H.activationEvents)for(const Q of H.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(H,Q)}_handleEagerExtensions(){const H=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(Q),ue=Promise.all([H,re]).then(()=>{});return Promise.race([ue,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ue}_handleWorkspaceContainsEagerExtensions(H){return H.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(H,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(H,Q){if(this.isActivated(Q.identifier))return;const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ue={folders:H.map(oe=>oe.uri),forceUsingSearch:re,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,ve,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(oe,ve,Ae)},Z=await(0,C.checkActivateWorkspaceContainsExtension)(ue,Q);if(!!Z)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:Z.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(H){throw console.error(H),H}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:Q}=this._initData.environment;if(!H||!Q)throw new Error(c.localize(0,null));const re=await this._loadCommonJSModule(null,Q,new f.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(c.localize(1,null,Q.toString()));return new Promise((ue,Z)=>{const oe=(Se,Ne)=>{Se?Z(Se):ue(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,A.originalFSPath)(Q),Ae=re.run(ve,oe);Ae&&Ae.then&&Ae.then(()=>{ue(0)}).catch(Se=>{Z(Se.toString())})})}async $extensionTestsExit(H){this._logService.info(`extension host terminating: test runner requested exit with code ${H}`),this._logService.info(`exiting with code ${H}`),this._logService.flush(),this._hostUtils.exit(H)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(H,Q){return this._resolvers[H]=Q,(0,k.toDisposable)(()=>{delete this._resolvers[H]})}async _activateAndGetResolver(H){const Q=H.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const re=H.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this._resolvers[re]}}async $resolveAuthority(H,Q){const{authorityPrefix:re,resolver:ue}=await this._activateAndGetResolver(H);if(!ue)return{type:"error",error:{code:v.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${re}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ue)),E.mark(`code/extHost/willResolveAuthority/${re}`);const Z=await ue.resolve(H,{resolveAttempt:Q});E.mark(`code/extHost/didResolveAuthorityOK/${re}`);const oe={authority:H,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},ve={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted};return{type:"ok",value:{authority:oe,options:ve,tunnelInformation:{environmentTunnels:Z.environmentTunnels}}}}catch(Z){if(E.mark(`code/extHost/didResolveAuthorityError/${re}`),Z instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(H,Q){const{authorityPrefix:re,resolver:ue}=await this._activateAndGetResolver(H);if(!ue)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${re}`);const Z=P.URI.revive(Q);if(typeof ue.getCanonicalURI=="undefined")return Z;const oe=await(0,F.asPromise)(()=>ue.getCanonicalURI(Z));return oe||Z}$startExtensionHost(H){return this._registry.keepOnly(H),this._startExtensionHost()}$activateByEvent(H,Q){return Q===1?this._activateByEvent(H,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent(H,!1))}async $activate(H,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(H)?(await this._activateById(H,Q),!0):!1}async $deltaExtensions(H,Q){H.forEach(ue=>ue.extensionLocation=P.URI.revive(ue.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ue=>{const Z=this._registry.getExtensionDescription(ue);if(!Z)return;const oe=await this._hostUtils.realpath(Z.extensionLocation.fsPath);re.delete(P.URI.file(oe).fsPath)})),await Promise.all(H.map(async ue=>{const Z=await this._hostUtils.realpath(ue.extensionLocation.fsPath);re.set(P.URI.file(Z).fsPath,ue)})),this._registry.deltaExtensions(H,Q),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){let Q=d.VSBuffer.alloc(H),re=Math.random()%256;for(let ue=0;ue<H;ue++)Q.writeUInt8(re,ue);return Q}async $updateRemoteConnectionData(H){this._remoteConnectionData=H,this._onDidChangeRemoteConnectionData.fire()}};U=$e([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,h.IExtHostRpcService),Ve(3,l.IExtHostWorkspace),Ve(4,n.IExtHostConfiguration),Ve(5,t.ILogService),Ve(6,s.IExtHostInitDataService),Ve(7,u.IExtensionStoragePaths),Ve(8,I.IExtHostTunnelService),Ve(9,T.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function K(B,H){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(H,Q,re,ue){L.set(this,void 0),V.set(this,void 0),q.set(this,void 0),et(this,L,H,"f"),et(this,V,Q,"f"),et(this,q,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ue}get isActive(){return Fe(this,L,"f").isActivated(Fe(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Fe(this,L,"f").getExtensionExports(Fe(this,q,"f"))}activate(){return Fe(this,L,"f").activateByIdWithErrors(Fe(this,q,"f"),{startup:!1,extensionId:Fe(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,L=new WeakMap,V=new WeakMap,q=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,163,31,33,49,168,32,164,12,4,10,91,70]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let d=class{constructor(p,I,T,g,C,m){this._workspaceService=I,this._extensionService=T,this._editorsService=g,this._configurationService=C,this._editorTabs=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=p.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(L=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,I){const T=p;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let g=`debug:${encodeURIComponent(T.path||"")}`,C="?";return I&&(g+=`${C}session=${encodeURIComponent(I.id)}`,C="&"),g+=`${C}ref=${T.sourceReference}`,M.URI.parse(g)}else{if(T.path)return M.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const I=[];for(const T of p.getAllExtensionDescriptions())if(T.contributes){const g=T.contributes.debuggers;if(g&&g.length>0)for(const C of g)(0,o.isDebuggerMainContribution)(C)&&I.push(C.type)}this._debugServiceProxy.$registerDebugTypes(I)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(I=>p.push(I)),p}addBreakpoints(p){this.startBreakpoints();const I=p.filter(C=>{const m=C.id;return this._breakpoints.has(m)?!1:(this._breakpoints.set(m,C),!0)});this.fireBreakpointChanges(I,[],[]);const T=[],g=new Map;for(const C of I)if(C instanceof k.SourceBreakpoint){let m=g.get(C.location.uri.toString());m||(m={type:"sourceMulti",uri:C.location.uri,lines:[]},g.set(C.location.uri.toString(),m),T.push(m)),m.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character})}else C instanceof k.FunctionBreakpoint&&T.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(p){this.startBreakpoints();const I=p.filter(m=>this._breakpoints.delete(m.id));this.fireBreakpointChanges([],I,[]);const T=I.filter(m=>m instanceof k.SourceBreakpoint).map(m=>m.id),g=I.filter(m=>m instanceof k.FunctionBreakpoint).map(m=>m.id),C=I.filter(m=>m instanceof k.DataBreakpoint).map(m=>m.id);return this._debugServiceProxy.$unregisterBreakpoints(T,g,C)}startDebugging(p,I,T){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,I,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI,suppressSaveBeforeStart:T.suppressSaveBeforeStart})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,I,T){if(!I)return new k.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:g,provider:I}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,T,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,g),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(C=>C.provider!==I),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(p,I,T){if(!T)return new k.Disposable(()=>{});if(!this.definesDebugType(p,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.getAdapterDescriptorFactoryByType(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:I,handle:g,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(I,g),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(C=>C.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(p,I){if(!I)return new k.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:T,factory:I}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==I)})}async $runInTerminal(p,I){return Promise.resolve(void 0)}async $substituteVariables(p,I){if(!this._variableResolver){const[C,m]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(C||[],this._editorsService,m)}let T;const g=await this.getFolder(p);return g&&(T={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,I)}createDebugAdapter(p,I){if(p.type==="implementation")return new s(p.implementation)}createSignService(){}async $startDASession(p,I){const T=this,g=await this.getSession(I);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const m=this.convertToDto(C),R=this.createDebugAdapter(m,g);if(!R)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const L=R;return this._debugAdapters.set(p,L),this.getDebugAdapterTrackers(g).then(V=>(V&&this._debugAdaptersTrackers.set(p,V),L.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const U=q,K={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(U.arguments.value);K.body={signature:$},L.sendResponse(K)}else throw new Error("no signer")}catch($){K.success=!1,K.message=$.message,L.sendResponse(K)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,o.convertToVSCPaths)(q,!0),T._debugServiceProxy.$acceptDAMessage(p,q)}),L.onError(q=>{V&&V.onError&&V.onError(q),this._debugServiceProxy.$acceptDAError(p,q.name,q.message,q.stack)}),L.onExit(q=>{V&&V.onExit&&V.onExit((0,D.withNullAsUndefined)(q),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,D.withNullAsUndefined)(q),void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),L.startSession()))})}$sendDAMessage(p,I){I=(0,o.convertToDAPaths)(I,!1);const T=this._debugAdaptersTrackers.get(p);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(I);const g=this._debugAdapters.get(p);g&&g.sendMessage(I)}$stopDASession(p){const I=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),I&&I.onWillStopSession&&I.onWillStopSession();const T=this._debugAdapters.get(p);return this._debugAdapters.delete(p),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const I=[],T=[],g=[];if(p.added)for(const C of p.added){const m=C.id;if(m&&!this._breakpoints.has(m)){let R;if(C.type==="function")R=new k.FunctionBreakpoint(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage);else if(C.type==="data")R=new k.DataBreakpoint(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage);else{const L=M.URI.revive(C.uri);R=new k.SourceBreakpoint(new k.Location(L,new k.Position(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage)}R._id=m,this._breakpoints.set(m,R),I.push(R)}}if(p.removed)for(const C of p.removed){const m=this._breakpoints.get(C);m&&(this._breakpoints.delete(C),T.push(m))}if(p.changed){for(const C of p.changed)if(C.id){const m=this._breakpoints.get(C.id);if(m){if(m instanceof k.FunctionBreakpoint&&C.type==="function"){const R=m;R.enabled=C.enabled,R.condition=C.condition,R.hitCondition=C.hitCondition,R.logMessage=C.logMessage,R.functionName=C.functionName}else if(m instanceof k.SourceBreakpoint&&C.type==="source"){const R=m;R.enabled=C.enabled,R.condition=C.condition,R.hitCondition=C.hitCondition,R.logMessage=C.logMessage,R.location=new k.Location(M.URI.revive(C.uri),new k.Position(C.line,C.character))}g.push(m)}}}this.fireBreakpointChanges(I,T,g)}$provideDebugConfigurations(p,I,T){return(0,A.asPromise)(async()=>{const g=this.getConfigProviderByHandle(p);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.getFolder(I);return g.provideDebugConfigurations(C,T)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(p,I,T,g){return(0,A.asPromise)(async()=>{const C=this.getConfigProviderByHandle(p);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.getFolder(I);return C.resolveDebugConfiguration(m,T,g)})}$resolveDebugConfigurationWithSubstitutedVariables(p,I,T,g){return(0,A.asPromise)(async()=>{const C=this.getConfigProviderByHandle(p);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.getFolder(I);return C.resolveDebugConfigurationWithSubstitutedVariables(m,T,g)})}async $provideDebugAdapter(p,I){const T=this.getAdapterDescriptorFactoryByHandle(p);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(I);return this.getAdapterDescriptor(T,g).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(C)})}async $acceptDebugSessionStarted(p){const I=await this.getSession(p);this._onDidStartDebugSession.fire(I)}async $acceptDebugSessionTerminated(p){const I=await this.getSession(p);I&&(this._onDidTerminateDebugSession.fire(I),this._debugSessions.delete(I.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,I){const T=await this.getSession(p);T&&T._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(p,I){const g={session:await this.getSession(p),event:I.event,body:I.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(p){if(p instanceof k.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof k.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const I=this._adapterFactories.filter(T=>T.type===p);if(I.length>0)return I[0].factory}getAdapterDescriptorFactoryByHandle(p){const I=this._adapterFactories.filter(T=>T.handle===p);if(I.length>0)return I[0].factory}getConfigProviderByHandle(p){const I=this._configProviders.filter(T=>T.handle===p);if(I.length>0)return I[0].provider}definesDebugType(p,I){if(p.contributes){const T=p.contributes.debuggers;if(T&&T.length>0){for(const g of T)if(g.label&&g.type&&g.type===I)return!0}}return!1}getDebugAdapterTrackers(p){const T=p.configuration.type,g=this._trackerFactories.filter(C=>C.type===T||C.type==="*").map(C=>(0,A.asPromise)(()=>C.factory.createDebugAdapterTracker(p)).then(m=>m,m=>null));return Promise.race([Promise.all(g).then(C=>{const m=C.filter(R=>!!R);if(m.length>0)return new r(m)}),new Promise((C,m)=>{const R=setTimeout(()=>{clearTimeout(R),m(new Error("timeout"))},1e3)})]).catch(C=>{})}async getAdapterDescriptor(p,I){const T=I.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new k.DebugAdapterServer(T));if(p){const C=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>p.createDebugAdapterDescriptor(I,this.daExecutableFromPackage(I,C))).then(m=>{if(m)return m})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(I,g))}daExecutableFromPackage(p,I){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,I,T){(p.length>0||I.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:I,changed:T}))}async getSession(p){if(p)if(typeof p=="string"){const I=this._debugSessions.get(p);if(I)return I}else{let I=this._debugSessions.get(p.id);if(!I){const T=await this.getFolder(p.folderUri),g=p.parent?this._debugSessions.get(p.parent):void 0;I=new y(this._debugServiceProxy,p.id,p.type,p.name,T,p.configuration,g),this._debugSessions.set(I.id,I),this._debugServiceProxy.$sessionCached(I.id)}return I}throw new Error("cannot find session")}getFolder(p){if(p){const I=M.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}};d=$e([Ve(0,l.IExtHostRpcService),Ve(1,P.IExtHostWorkspace),Ve(2,t.IExtHostExtensionService),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,f.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class y{constructor(p,I,T,g,C,m,R){this._debugServiceProxy=p,this._id=I,this._type=T,this._name=g,this._workspaceFolder=C,this._configuration=m,this._parentSession=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,I){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,I)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=y;class i{constructor(p){this.value=Object.freeze({append(I){p.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.ExtHostDebugConsole=i;class v extends n.AbstractVariableResolverService{constructor(p,I,T,g,C){function m(){if(I){const R=I.activeEditor();if(R)return R.document.uri;const L=g.tabs.filter(V=>V.isActive);if(L.length>0){const V=L[0].resource;return V&&(V.primary||V.secondary)?V.primary??V.secondary:L[0].resource}}}super({getFolderUri:R=>{const L=p.filter(V=>V.name===R);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(R,L)=>T.getConfiguration(void 0,R).get(L),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const R=m();if(R)return c.normalize(R.fsPath)},getWorkspaceFolderPathForFile:()=>{if(C){const R=m();if(R){const L=C.getWorkspaceFolder(R);if(L)return c.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(I){const R=I.activeEditor();if(R&&!R.selection.isEmpty)return R.document.getText(R.selection)}},getLineNumber:()=>{if(I){const R=I.activeEditor();if(R)return String(R.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=v;class r{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(I=>I.onError?I.onError(p):void 0)}onExit(p,I){this.trackers.forEach(T=>T.onExit?T.onExit(p,I):void 0)}}class s extends S.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends d{constructor(p,I,T,g,C,m){super(p,I,T,g,C,m)}createVariableResolver(p,I,T){return new v(p,I,T,this._editorTabs)}};u=$e([Ve(0,l.IExtHostRpcService),Ve(1,P.IExtHostWorkspace),Ve(2,t.IExtHostExtensionService),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,f.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(be[219],Ee([0,1,74,2,5,32,30,26,12,29,4,33,91,15]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(a,d,y,i,v,r,s){this._apiFactory=a,this._extensionRegistry=d,this._instaService=y,this._extHostConfiguration=i,this._extHostExtensionService=v,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,d,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,d,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let d of a.nodeModuleName)this._factories.set(d,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(d=>a.alternativeModuleName(d))}};o=$e([Ve(2,t.IInstantiationService),Ve(3,A.IExtHostConfiguration),Ve(4,b.IExtHostExtensionService),Ve(5,P.IExtHostInitDataService),Ve(6,f.ILogService)],o),e.RequireInterceptor=o;class l{constructor(a,d,y,i,v){this._apiFactory=a,this._extensionPaths=d,this._extensionRegistry=y,this._configProvider=i,this._logService=v,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,d){const y=this._extensionPaths.findSubstr(d.fsPath);if(y){let i=this._extApiImpl.get(k.ExtensionIdentifier.toKey(y.identifier));return i||(i=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(y.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((v,r)=>i+=`	${r} -> ${v.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(a,d){this.nodeModuleName="keytar";const{environment:y}=d,i=a.getProxy(E.MainContext.MainThreadKeytar);if(y.appRoot){let v=y.appRoot.fsPath;n.platform==="win32"&&(v=v.replace(/\\/g,"/")),v[v.length-1]==="/"&&(v=v.substr(0,v.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${v}/node_modules.asar/keytar`),this.alternativeNames.add(`${v}/node_modules/keytar`)}this._impl={getPassword:(v,r)=>i.$getPassword(v,r),setPassword:(v,r,s)=>i.$setPassword(v,r,s),deletePassword:(v,r)=>i.$deletePassword(v,r),findPassword:v=>i.$findPassword(v),findCredentials(v){return i.$findCredentials(v)}}}load(a,d){return this._impl}alternativeModuleName(a){const d=a.length;if(d<=7||!this.alternativeNames)return;const y=d-7;if((a.charAt(y)==="/"||a.charAt(y)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};w=$e([Ve(0,S.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],w);let D=class{constructor(a,d,y){this._extensionPaths=a,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(E.MainContext.MainThreadTelemetry);const i=y.getProxy(E.MainContext.MainThreadWindow);this._impl=(v,r)=>{const s=M.URI.parse(v);return r?this.callOriginal(v,r):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,v,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,v,{}):this.callOriginal(v,r)}}load(a,d,y){const i=this._extensionPaths.findSubstr(d.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=y(a),this._impl}callOriginal(a,d){return this.sendNoForwardTelemetry(),this._original(a,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=$e([Ve(2,S.IExtHostRpcService)],D)}),define(be[220],Ee([0,1,14,16,74,6,2,5,213,15,57,61,29,144,12,65,33,40]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(d,y,i,v){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new S.RPCProtocol(d,null,v),y=_._transform(y,this._rpcProtocol);const r=new b.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...y}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(l.IURITransformerService,new l.URITransformerService(v)),r.set(w.IHostUtils,i);const s=new f.InstantiationService(r,!0),u=s.invokeFunction(T=>T.get(D.IExtHostTerminalService));this._disposables.add(u),this._logService=s.invokeFunction(T=>T.get(P.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",y),this._extensionService=s.invokeFunction(T=>T.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(g,C)=>{let m="",R,L;for(const V of C)m+=`
	at ${V.toString()}`,L=V.getFileName(),!R&&L&&(R=T.findSubstr(L));return h.set(g,R),`${g.name||"Error"}: ${g.message||""}${m}`}});const p=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),I=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(T=>{const g=M.transformErrorForSerialization(T),C=h.get(T);C?p.$onExtensionRuntimeError(C.identifier,g):I.$onUnexpectedError(g)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,c.timeout)(4e3),y]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,y){d.extensions.forEach(v=>v.extensionLocation=F.URI.revive(y.transformIncomingURIs(v.extensionLocation))),d.environment.appRoot=F.URI.revive(y.transformIncomingURIs(d.environment.appRoot));const i=d.environment.extensionDevelopmentLocationURI;return i&&(d.environment.extensionDevelopmentLocationURI=i.map(v=>F.URI.revive(y.transformIncomingURIs(v)))),d.environment.extensionTestsLocationURI=F.URI.revive(y.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=F.URI.revive(y.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=F.URI.revive(y.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=F.URI.revive(y.transformIncomingURIs(d.logsLocation)),d.logFile=F.URI.revive(y.transformIncomingURIs(d.logFile)),d.workspace=y.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=_}),define(be[221],Ee([0,1,17,21,56,27,24,194,41]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,f,o){this.config=n,this.provider=f,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((o,l)=>{const w=D=>{this.resultCount++,n(D)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const _=D.toString(),a=c.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,a)||this.matchFile(w,{base:D,basename:a})}),Promise.all(f.map(D=>this.searchInFolder(D,w))).then(D=>{o({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{l(new Error((0,E.toErrorMessage)(D)))})})}async searchInFolder(n,f){const o=new M.CancellationTokenSource,l=this.getSearchOptionsForFolder(n),w=this.initDirectoryTree(),D=new S.QueryGlobTester(this.config,n),_=!D.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(o),a=k.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,o.token),y=a.elapsed(),i=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(v=>{const r=c.posix.relative(n.folder.path,v.path);if(_){const s=c.basename(v.path);this.matchFile(f,{base:n.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(w,n.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,D,f),{providerTime:y,postProcessTime:i.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const f=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,o,l){if(o===this.filePattern){const D=c.basename(this.filePattern);this.matchFile(l,{base:f,relativePath:this.filePattern,basename:D})}function w(D){const _=c.basename(D),a=c.dirname(D);let d=n[a];d||(d=n[a]=[],w(a)),d.push({base:f,relativePath:D,basename:_})}w(o)}matchDirectoryTree({rootEntries:n,pathToEntries:f},o,l){const w=this,D=this.filePattern;function _(a){const d=A.hasSiblingFn(()=>a.map(y=>y.basename));for(let y=0,i=a.length;y<i;y++){const v=a[y],{relativePath:r,basename:s}=v;if(!o.includedInQuerySync(r,s,D!==s?d:void 0))continue;const u=f[r];if(u)_(u);else{if(r===D)continue;w.matchFile(l,v)}if(w.isLimitHit)break}}_(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class t{constructor(){this.sessions=new Map}fileSearch(n,f,o,l){const w=this.getSessionTokenSource(n.cacheKey),D=new P(n,f,w&&w.token);let _=0;const a=d=>{_+=d.length,o(d.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(D,t.BATCH_SIZE,a,l).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:d.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,o,l){l.onCancellationRequested(()=>{n.cancel()});const w=_=>{_&&(D.push(_),f>0&&D.length>=f&&(o(D),D=[]))};let D=[];return n.search(w).then(_=>(D.length&&o(D),_),_=>(D.length&&o(D),Promise.reject(_)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,13,21,56,27,11,17,24,10,2,41]),function(ne,e,c,M,E,A,F,k,S,P,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(a,d,y,i){this.query=a,this.provider=d,this.fileUtils=y,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,d){const y=this.query.folderQueries||[],i=new M.CancellationTokenSource;return d.onCancellationRequested(()=>i.cancel()),new Promise((v,r)=>{this.collector=new o(a);let s=!1;const u=(h,p)=>{if(!s&&!this.isLimitHit){const I=this.resultSize(h);w(h)&&typeof this.query.maxResults=="number"&&this.resultCount+I>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const T=this.resultSize(h);this.resultCount+=T,(T>0||!w(h))&&this.collector.add(h,p)}};Promise.all(y.map((h,p)=>this.searchInFolder(h,I=>u(I,p),i.token))).then(h=>{i.dispose(),this.collector.flush();const p=h.some(I=>!!I&&!!I.limitHit);v({limitHit:this.isLimitHit||p,messages:(0,c.flatten)(h.map(I=>I?.message?(0,P.isArray)(I.message)?I.message:[I.message]:[])),stats:{type:this.processType}})},h=>{i.dispose();const p=(0,E.toErrorMessage)(h);r(new Error(p))})})}resultSize(a){return w(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,d){const y=Array.isArray(a.ranges)?a.ranges:[a.ranges],i=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:y.slice(0,d),preview:{matches:i.slice(0,d),text:a.preview.text},uri:a.uri}}async searchInFolder(a,d,y){const i=new b.QueryGlobTester(this.query,a),v=[],r={report:h=>{if(!this.validateProviderResult(h))return;const p=a.folder.scheme===F.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(h.uri))):void 0,I=S.relativePath(a.folder,h.uri);if(I){const T=i.includedInQuery(I,k.basename(I),p);(0,P.isPromise)(T)?v.push(T.then(g=>{g&&d(h)})):T&&d(h)}}},s=this.getSearchOptionsForFolder(a),u=await this.provider.provideTextSearchResults(f(this.query.contentPattern),s,r,y);return v.length&&await Promise.all(v),u}validateProviderResult(a){if(w(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const d=(0,b.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),y=(0,b.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),i={folder:t.URI.from(a.folder),excludes:y,includes:d,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function f(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class o{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,d=>this.sendItems(d))}add(a,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!S.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(l(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=o;function l(_){return w(_)?{preview:{matches:(0,c.mapArrayOrNot)(_.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:_.preview.text},ranges:(0,c.mapArrayOrNot)(_.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function w(_){return!!_.preview}e.extensionResultIsMatch=w;class D{constructor(a,d){this.maxBatchSize=a,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,d){!a||this.addItemToBatch(a,d)}addItems(a,d){!a||this.addItemsToBatch(a,d)}addItemToBatch(a,d){this.batch.push(a),this.batchSize+=d,this.onUpdate()}addItemsToBatch(a,d){this.batch=this.batch.concat(a),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,12,65,15,2,222]),function(ne,e,c,M,E,A,F,k,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let b=class{constructor(l,w,D){this.extHostRpc=l,this._uriTransformer=w,this._logService=D,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,w){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const D=this._handlePool++;return this._textSearchProvider.set(D,w),this._proxy.$registerTextSearchProvider(D,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(l,w){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const D=this._handlePool++;return this._fileSearchProvider.set(D,w),this._proxy.$registerFileSearchProvider(D,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(l,w,D,_){const a=n(D),d=this._fileSearchProvider.get(l);if(d)return this._fileSearchManager.fileSearch(a,d,y=>{this._proxy.$handleFileMatch(l,w,y.map(i=>i.resource))},_);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,w,D,_){const a=this._textSearchProvider.get(l);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const d=n(D);return this.createTextSearchManager(d,a).search(i=>this._proxy.$handleTextMatch(l,w,i),_)}$enableExtensionHostSearch(){}createTextSearchManager(l,w){return new t.TextSearchManager(l,w,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};b=$e([Ve(0,F.IExtHostRpcService),Ve(1,k.IURITransformerService),Ve(2,S.ILogService)],b),e.ExtHostSearch=b;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(f),extraFileResources:o.extraFileResources&&o.extraFileResources.map(l=>P.URI.revive(l))}}e.reviveQuery=n;function f(o){return{...o,folder:P.URI.revive(o.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,79,113,55,60,5,184,183,39,185,32,186,187,188,170,189,49,33,190,171,193,195,196,96,173,201,202,203,72,40,205,174,8,7,208,50,97,31,30,51,160,192,86,95,99,100,101,15,65,12,29,197,157,64,69,181,206,156,73,71,211,209,210,182,37,204,207,68,70,87,199,98,200,11,146,198,154,191]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a,d,y,i,v,r,s,u,h,p,I,T,g,C,m,R,L,V,q,U,K,$,B,H,Q,re,ue,Z,oe,ve,Ae,Se,Ne,We,je,qe,x,G,te,ae,j,se,he,Re,Be,ze,Qe,it,ke,Ze,z,J,me,He,Ye,st,ot,Et,ft,Dt,Pt,It,Xe,yt,Te,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(ee){const le=ee.get(te.IExtHostInitDataService),ge=ee.get(me.IExtHostFileSystemInfo),fe=ee.get(it.IExtHostConsumerFileSystem),Pe=ee.get(r.IExtHostExtensionService),xe=ee.get(re.IExtHostWorkspace),Oe=ee.get(Et.IExtHostTelemetry),Ke=ee.get(D.IExtHostConfiguration),tt=ee.get(x.IURITransformerService),Le=ee.get(G.IExtHostRpcService),de=ee.get(L.IExtHostStorage),pe=ee.get(Qe.IExtensionStoragePaths),Y=ee.get(qe.ILogService),W=ee.get(se.IExtHostTunnelService),we=ee.get(he.IExtHostApiDeprecationService),Ie=ee.get(Q.IExtHostWindow),Je=ee.get(st.IExtHostSecretState),Ue=ee.get(ot.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),Le.set(n.ExtHostContext.ExtHostLogService,Y),Le.set(n.ExtHostContext.ExtHostWorkspace,xe),Le.set(n.ExtHostContext.ExtHostConfiguration,Ke),Le.set(n.ExtHostContext.ExtHostExtensionService,Pe),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,W),Le.set(n.ExtHostContext.ExtHostWindow,Ie),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Oe),Le.set(n.ExtHostContext.ExtHostEditorTabs,Ue);const ct=Le.set(n.ExtHostContext.ExtHostDecorations,ee.get(Se.IExtHostDecorations)),pt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ee.get(v.IExtHostDocumentsAndEditors)),lt=Le.set(n.ExtHostContext.ExtHostCommands,ee.get(l.IExtHostCommands)),mt=Le.set(n.ExtHostContext.ExtHostTerminalService,ee.get(V.IExtHostTerminalService)),ut=Le.set(n.ExtHostContext.ExtHostDebugService,ee.get(We.IExtHostDebugService)),bt=Le.set(n.ExtHostContext.ExtHostSearch,ee.get(je.IExtHostSearch)),gt=Le.set(n.ExtHostContext.ExtHostTask,ee.get(Ne.IExtHostTask)),$t=Le.set(n.ExtHostContext.ExtHostOutputService,ee.get(T.IExtHostOutputService)),Vt=Le.set(n.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(Le)),St=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,pt)),Ft=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(Le,pt,Y)),ei=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(Y,St,Le.getProxy(n.MainContext.MainThreadBulkEdits))),vt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,lt,pt,St,pe)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(Y,vt)),jt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new yt.ExtHostNotebookEditors(Y,Le,vt)),ti=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new ft.ExtHostNotebookKernels(Le,le,vt,lt,Y)),ii=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Pt.ExtHostNotebookRenderers(Le,vt)),Tt=Le.set(n.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(Le,pt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),lt,Y)),wi=Le.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),Tt,le)),Wt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(Le,Y,ge)),Ht=Le.set(n.ExtHostContext.ExtHostLanguages,new p.ExtHostLanguages(Le,St,lt.converter,tt)),ht=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(Le,tt,St,lt,Wt,Y,we)),ni=Le.set(n.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Le,ht)),Nt=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Le,Y,pt)),xt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,C.createExtHostQuickOpen)(Le,xe,lt)),Jt=Le.set(n.ExtHostContext.ExtHostSCM,new m.ExtHostSCM(Le,lt,Y)),bi=Le.set(n.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(Le,lt,St)),hi=Le.set(n.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),Ei=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),fi=Le.set(n.ExtHostContext.ExtHostTheming,new j.ExtHostTheming(Le)),ri=Le.set(n.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Le)),si=Le.set(n.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(Le,lt)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Le,{remote:le.remote},xe,Y,we)),oi=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new z.ExtHostWebviewPanels(Le,qt,xe)),_i=Le.set(n.ExtHostContext.ExtHostCustomEditors,new Ze.ExtHostCustomEditors(Le,St,pe,qt,oi)),yi=Le.set(n.ExtHostContext.ExtHostWebviewViews,new ke.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Le,lt)),Xt=Le.set(n.ExtHostContext.ExtHostUriOpeners,new Ye.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Le,vt,pt,lt));const Si=(0,Z.values)(n.ExtHostContext);Le.assertRegistered(Si);const Di=new J.ExtHostBulkEdits(Le,pt),ai=new o.ExtHostClipboard(Le),li=new I.ExtHostMessageService(Le,Y),zt=new a.ExtHostDialogs(Le),Lt=new R.ExtHostStatusBar(Le,lt.converter);return f.ExtHostApiCommands.register(lt),function(Me,Rt,Kt){const wt=function(){let X=!Me.isUnderDevelopment;function ce(De){X||(Y.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function De(rt){if(Array.isArray(rt))rt.forEach(De);else if(typeof rt=="string")ce(rt);else{const _t=rt;typeof _t.scheme=="undefined"&&ce(rt),!Me.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,ue.throwProposedApiError)(Me)}return rt}}(),Ci={getSession(X,ce,De){return De?.forceNewSession&&(0,ue.checkProposedApiEnabled)(Me),ri.getSession(Me,X,ce,De)},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(X,ce,De,rt){return ri.registerAuthenticationProvider(X,ce,De,rt)}},ki={registerCommand(X,ce,De){return lt.registerCommand(!0,X,ce,De)},registerTextEditorCommand(X,ce,De){return lt.registerCommand(!0,X,(...rt)=>{const _t=Tt.getActiveTextEditor();if(!_t){Y.warn("Cannot execute "+X+" because there is no active text editor.");return}return _t.edit(kt=>{ce.apply(De,[_t,kt,...rt])}).then(kt=>{kt||Y.warn("Edits from command "+X+" were not applied.")},kt=>{Y.warn("An error occurred while running command "+X,kt)})})},registerDiffInformationCommand:(X,ce,De)=>((0,ue.checkProposedApiEnabled)(Me),lt.registerCommand(!0,X,async(...rt)=>{const _t=pt.activeEditor(!0);if(!_t){Y.warn("Cannot execute "+X+" because there is no active text editor.");return}const kt=await Tt.getDiffInformation(_t.id);ce.apply(De,[kt,...rt])})),executeCommand(X,...ce){return lt.executeCommand(X,...ce)},getCommands(X=!1){return lt.getCommands(X)}},mi={get machineId(){return le.telemetryInfo.machineId},get sessionId(){return le.telemetryInfo.sessionId},get language(){return le.environment.appLanguage},get appName(){return le.environment.appName},get appRoot(){return le.environment.appRoot?.fsPath??""},get appHost(){return le.environment.appHost},get uriScheme(){return le.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return Oe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Oe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(le.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Ie.openUri(X,{allowTunneling:!!le.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===le.environment.appUriScheme)return Vt.createAppUri(X);try{return await Ie.asExternalUri(X,{allowTunneling:!!le.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(X,It.Schemas.http)||(0,Xe.matchesScheme)(X,It.Schemas.https))return X;throw ce}},get remoteName(){return(0,Ae.getRemoteName)(le.remote.authority)},get remoteAuthority(){return(0,ue.checkProposedApiEnabled)(Me),le.remote.authority},get uiKind(){return le.uiKind}};le.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=le.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ii={createTestController(X,ce){return Gt.createTestController(X,ce)},createTestObserver(){return(0,ue.checkProposedApiEnabled)(Me),Gt.createTestObserver()},runTests(X){return(0,ue.checkProposedApiEnabled)(Me),Gt.runTests(X)},get onDidChangeTestResults(){return(0,ue.checkProposedApiEnabled)(Me),Gt.onResultsChanged},get testResults(){return(0,ue.checkProposedApiEnabled)(Me),Gt.results}},Pi={getExtension(X){const ce=Rt.getExtensionDescription(X);if(ce)return new r.Extension(Pe,Me.identifier,ce,gi)},get all(){return Rt.getAllExtensionDescriptions().map(X=>new r.Extension(Pe,Me.identifier,X,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Me.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(X,ce){return Ht.changeLanguage(X.uri,ce)},match(X,ce){return(0,t.score)(K.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,De){return ht.registerCodeActionProvider(Me,wt(X),ce,De)},registerCodeLensProvider(X,ce){return ht.registerCodeLensProvider(Me,wt(X),ce)},registerDefinitionProvider(X,ce){return ht.registerDefinitionProvider(Me,wt(X),ce)},registerDeclarationProvider(X,ce){return ht.registerDeclarationProvider(Me,wt(X),ce)},registerImplementationProvider(X,ce){return ht.registerImplementationProvider(Me,wt(X),ce)},registerTypeDefinitionProvider(X,ce){return ht.registerTypeDefinitionProvider(Me,wt(X),ce)},registerHoverProvider(X,ce){return ht.registerHoverProvider(Me,wt(X),ce,Me.identifier)},registerEvaluatableExpressionProvider(X,ce){return ht.registerEvaluatableExpressionProvider(Me,wt(X),ce,Me.identifier)},registerInlineValuesProvider(X,ce){return ht.registerInlineValuesProvider(Me,wt(X),ce,Me.identifier)},registerDocumentHighlightProvider(X,ce){return ht.registerDocumentHighlightProvider(Me,wt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ht.registerLinkedEditingRangeProvider(Me,wt(X),ce)},registerReferenceProvider(X,ce){return ht.registerReferenceProvider(Me,wt(X),ce)},registerRenameProvider(X,ce){return ht.registerRenameProvider(Me,wt(X),ce)},registerDocumentSymbolProvider(X,ce,De){return ht.registerDocumentSymbolProvider(Me,wt(X),ce,De)},registerWorkspaceSymbolProvider(X){return ht.registerWorkspaceSymbolProvider(Me,X)},registerDocumentFormattingEditProvider(X,ce){return ht.registerDocumentFormattingEditProvider(Me,wt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ht.registerDocumentRangeFormattingEditProvider(Me,wt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,De,...rt){return ht.registerOnTypeFormattingEditProvider(Me,wt(X),ce,[De].concat(rt))},registerDocumentSemanticTokensProvider(X,ce,De){return ht.registerDocumentSemanticTokensProvider(Me,wt(X),ce,De)},registerDocumentRangeSemanticTokensProvider(X,ce,De){return ht.registerDocumentRangeSemanticTokensProvider(Me,wt(X),ce,De)},registerSignatureHelpProvider(X,ce,De,...rt){return typeof De=="object"?ht.registerSignatureHelpProvider(Me,wt(X),ce,De):ht.registerSignatureHelpProvider(Me,wt(X),ce,typeof De=="undefined"?[]:[De,...rt])},registerCompletionItemProvider(X,ce,...De){return ht.registerCompletionItemProvider(Me,wt(X),ce,De)},registerInlineCompletionItemProvider(X,ce){return(0,ue.checkProposedApiEnabled)(Me),ht.registerInlineCompletionsProvider(Me,wt(X),ce)},registerDocumentLinkProvider(X,ce){return ht.registerDocumentLinkProvider(Me,wt(X),ce)},registerColorProvider(X,ce){return ht.registerColorProvider(Me,wt(X),ce)},registerFoldingRangeProvider(X,ce){return ht.registerFoldingRangeProvider(Me,wt(X),ce)},registerSelectionRangeProvider(X,ce){return ht.registerSelectionRangeProvider(Me,X,ce)},registerCallHierarchyProvider(X,ce){return ht.registerCallHierarchyProvider(Me,X,ce)},registerTypeHierarchyProvider(X,ce){return ht.registerTypeHierarchyProvider(Me,X,ce)},setLanguageConfiguration:(X,ce)=>ht.setLanguageConfiguration(Me,X,ce),getTokenInformationAtPosition(X,ce){return(0,ue.checkProposedApiEnabled)(Me),Ht.tokenAtPosition(X,ce)},registerInlayHintsProvider(X,ce){return(0,ue.checkProposedApiEnabled)(Me),ht.registerInlayHintsProvider(Me,X,ce)},createLanguageStatusItem(X,ce){return(0,ue.checkProposedApiEnabled)(Me),Ht.createLanguageStatusItem(Me,X,ce)}},Ti={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(X,ce,De){const rt=await(F.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return Tt.showTextDocument(rt,ce,De)},createTextEditorDecorationType(X){return Tt.createTextEditorDecorationType(Me,X)},onDidChangeActiveTextEditor(X,ce,De){return Tt.onDidChangeActiveTextEditor(X,ce,De)},onDidChangeVisibleTextEditors(X,ce,De){return Tt.onDidChangeVisibleTextEditors(X,ce,De)},onDidChangeTextEditorSelection(X,ce,De){return Tt.onDidChangeTextEditorSelection(X,ce,De)},onDidChangeTextEditorOptions(X,ce,De){return Tt.onDidChangeTextEditorOptions(X,ce,De)},onDidChangeTextEditorVisibleRanges(X,ce,De){return Tt.onDidChangeTextEditorVisibleRanges(X,ce,De)},onDidChangeTextEditorViewColumn(X,ce,De){return Tt.onDidChangeTextEditorViewColumn(X,ce,De)},onDidCloseTerminal(X,ce,De){return mt.onDidCloseTerminal(X,ce,De)},onDidOpenTerminal(X,ce,De){return mt.onDidOpenTerminal(X,ce,De)},onDidChangeActiveTerminal(X,ce,De){return mt.onDidChangeActiveTerminal(X,ce,De)},onDidChangeTerminalDimensions(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),mt.onDidChangeTerminalDimensions(X,ce,De)},onDidChangeTerminalState(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),mt.onDidChangeTerminalState(X,ce,De)},onDidWriteTerminalData(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),mt.onDidWriteTerminalData(X,ce,De)},get state(){return Ie.state},onDidChangeWindowState(X,ce,De){return Ie.onDidChangeWindowState(X,ce,De)},showInformationMessage(X,...ce){return li.showMessage(Me,A.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return li.showMessage(Me,A.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return li.showMessage(Me,A.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,De){return xt.showQuickPick(X,!!Me.enableProposedApi,ce,De)},showWorkspaceFolderPick(X){return xt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return xt.showInput(X,ce)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,ce,De){let rt,_t,kt;return typeof X=="string"?(rt=X,_t=ce,kt=De):(_t=X,kt=ce),Lt.createStatusBarEntry(Me,rt,_t,kt)},setStatusBarMessage(X,ce){return Lt.setStatusBarMessage(X,ce)},withScmProgress(X){return we.report("window.withScmProgress",Me,"Use 'withProgress' instead."),hi.withProgress(Me,{location:$.ProgressLocation.SourceControl},(ce,De)=>X({report(rt){}}))},withProgress(X,ce){return hi.withProgress(Me,X,ce)},createOutputChannel(X){return $t.createOutputChannel(X,Me)},createWebviewPanel(X,ce,De,rt){return oi.createWebviewPanel(Me,X,ce,De,rt)},createWebviewTextEditorInset(X,ce,De,rt){return(0,ue.checkProposedApiEnabled)(Me),wi.createWebviewEditorInset(X,ce,De,rt,Me)},createTerminal(X,ce,De){return typeof X=="object"?("location"in X&&(0,ue.checkProposedApiEnabled)(Me),"pty"in X?mt.createExtensionTerminal(X):mt.createTerminalFromOptions(X)):mt.createTerminal(X,ce,De)},registerTerminalLinkProvider(X){return mt.registerLinkProvider(X)},registerTerminalProfileProvider(X,ce){return mt.registerProfileProvider(Me,X,ce)},registerTreeDataProvider(X,ce){return Yt.registerTreeDataProvider(X,ce,Me)},createTreeView(X,ce){return Yt.createTreeView(X,ce,Me)},registerWebviewPanelSerializer:(X,ce)=>oi.registerWebviewPanelSerializer(Me,X,ce),registerCustomEditorProvider:(X,ce,De={})=>_i.registerCustomEditorProvider(Me,X,ce,De),registerFileDecorationProvider(X){return ct.registerFileDecorationProvider(X,Me.identifier)},registerUriHandler(X){return Vt.registerUriHandler(Me.identifier,X)},createQuickPick(){return xt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return xt.createInputBox(Me.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,ce,De){return fi.onDidChangeActiveColorTheme(X,ce,De)},registerWebviewViewProvider(X,ce,De){return yi.registerWebviewViewProvider(Me,X,ce,De?.webviewOptions)},get activeNotebookEditor(){return(0,ue.checkProposedApiEnabled)(Me),vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),vt.onDidChangeActiveNotebookEditor(X,ce,De)},get visibleNotebookEditors(){return(0,ue.checkProposedApiEnabled)(Me),vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ue.checkProposedApiEnabled)(Me),vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorSelection(X,ce,De)},onDidChangeNotebookEditorVisibleRanges(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorVisibleRanges(X,ce,De)},showNotebookDocument(X,ce){return(0,ue.checkProposedApiEnabled)(Me),vt.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),Xt.registerExternalUriOpener(Me.identifier,X,ce,De)},get tabs(){return(0,ue.checkProposedApiEnabled)(Me),Ue.tabs},get activeTab(){return(0,ue.checkProposedApiEnabled)(Me),Ue.activeTab},get onDidChangeTabs(){return(0,ue.checkProposedApiEnabled)(Me),Ue.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ue.checkProposedApiEnabled)(Me),Ue.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,ue.checkProposedApiEnabled)(Me),h.InlineCompletionController.get(X)}},pi={get rootPath(){return we.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return xe.getWorkspaceFolder(X)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(X){throw M.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,ce,...De)=>xe.updateWorkspaceFolders(Me,X,ce||0,...De),onDidChangeWorkspaceFolders:function(X,ce,De){return xe.onDidChangeWorkspace(X,ce,De)},asRelativePath:(X,ce)=>xe.getRelativePath(X,ce),findFiles:(X,ce,De,rt)=>xe.findFiles(K.GlobPattern.from(X),K.GlobPattern.from(ce),De,Me.identifier,rt),findTextInFiles:(X,ce,De,rt)=>{let _t,kt;return typeof ce=="object"?(_t=ce,kt=De):(_t={},kt=ce,rt=De),xe.findTextInFiles(X,_t||{},kt,Me.identifier,rt)},saveAll:X=>xe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,De,rt)=>Nt.createFileSystemWatcher(K.GlobPattern.from(X),ce,De,rt),get textDocuments(){return St.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let ce;const De=X;if(typeof X=="string")ce=Promise.resolve(F.URI.file(X));else if(F.URI.isUri(X))ce=Promise.resolve(X);else if(!De||typeof De=="object")ce=St.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(rt=>St.ensureDocumentData(rt).then(_t=>_t.document))},onDidOpenTextDocument:(X,ce,De)=>St.onDidAddDocument(X,ce,De),onDidCloseTextDocument:(X,ce,De)=>St.onDidRemoveDocument(X,ce,De),onDidChangeTextDocument:(X,ce,De)=>St.onDidChangeDocument(X,ce,De),onDidSaveTextDocument:(X,ce,De)=>St.onDidSaveDocument(X,ce,De),onWillSaveTextDocument:(X,ce,De)=>ei.getOnWillSaveTextDocumentEvent(Me)(X,ce,De),get notebookDocuments(){return vt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,ce){let De;if(F.URI.isUri(X))De=X,await vt.openNotebookDocument(X);else if(typeof X=="string")De=F.URI.revive(await vt.createNotebookDocument({viewType:X,content:ce}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(X,ce,De,rt){return vt.registerNotebookSerializer(Me,X,ce,De,Me.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,ce,De,rt)=>((0,ue.checkProposedApiEnabled)(Me),vt.registerNotebookContentProvider(Me,X,ce,De,Me.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,ce,De)=>Kt.onDidChangeConfiguration(X,ce,De),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,Kt.getConfiguration(X,ce,Me)},registerTextDocumentContentProvider(X,ce){return Ft.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(we.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Me,X,ce)),registerFileSystemProvider(X,ce,De){return ni.registerFileSystemProvider(Me.identifier,X,ce,De)},get fs(){return fe.value},registerFileSearchProvider:(X,ce)=>((0,ue.checkProposedApiEnabled)(Me),bt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,ue.checkProposedApiEnabled)(Me),bt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,ue.checkProposedApiEnabled)(Me),Pe.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,ue.checkProposedApiEnabled)(Me),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,De)=>Nt.onDidCreateFile(X,ce,De),onDidDeleteFiles:(X,ce,De)=>Nt.onDidDeleteFile(X,ce,De),onDidRenameFiles:(X,ce,De)=>Nt.onDidRenameFile(X,ce,De),onWillCreateFiles:(X,ce,De)=>Nt.getOnWillCreateFileEvent(Me)(X,ce,De),onWillDeleteFiles:(X,ce,De)=>Nt.getOnWillDeleteFileEvent(Me)(X,ce,De),onWillRenameFiles:(X,ce,De)=>Nt.getOnWillRenameFileEvent(Me)(X,ce,De),openTunnel:X=>((0,ue.checkProposedApiEnabled)(Me),W.openTunnel(Me,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ue.checkProposedApiEnabled)(Me),W.getTunnels()},onDidChangeTunnels:(X,ce,De)=>((0,ue.checkProposedApiEnabled)(Me),W.onDidChangeTunnels(X,ce,De)),registerPortAttributesProvider:(X,ce)=>((0,ue.checkProposedApiEnabled)(Me),W.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,ue.checkProposedApiEnabled)(Me),si.registerTimelineProvider(X,ce,Me.identifier,lt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:X=>((0,ue.checkProposedApiEnabled)(Me),xe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ce,De)=>xe.onDidGrantWorkspaceTrust(X,ce,De)},Ai={get inputBox(){return we.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Me)},createSourceControl(X,ce,De){return Jt.createSourceControl(Me,X,ce,De)}},Ri={createCommentController(X,ce){return bi.createCommentController(Me,X,ce)}},Fi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(X,ce,De){return ut.onDidStartDebugSession(X,ce,De)},onDidTerminateDebugSession(X,ce,De){return ut.onDidTerminateDebugSession(X,ce,De)},onDidChangeActiveDebugSession(X,ce,De){return ut.onDidChangeActiveDebugSession(X,ce,De)},onDidReceiveDebugSessionCustomEvent(X,ce,De){return ut.onDidReceiveDebugSessionCustomEvent(X,ce,De)},onDidChangeBreakpoints(X,ce,De){return ut.onDidChangeBreakpoints(X,ce,De)},registerDebugConfigurationProvider(X,ce,De){return ut.registerDebugConfigurationProvider(X,ce,De||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return ut.registerDebugAdapterDescriptorFactory(Me,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return ut.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,De){return!De||typeof De=="object"&&"configuration"in De?ut.startDebugging(X,ce,{parentSession:De}):ut.startDebugging(X,ce,De||{})},stopDebugging(X){return ut.stopDebugging(X)},addBreakpoints(X){return ut.addBreakpoints(X)},removeBreakpoints(X){return ut.removeBreakpoints(X)},asDebugSourceUri(X,ce){return ut.asDebugSourceUri(X,ce)}},Mi={registerTaskProvider:(X,ce)=>gt.registerTaskProvider(Me,X,ce),fetchTasks:X=>gt.fetchTasks(X),executeTask:X=>gt.executeTask(Me,X),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(X,ce,De)=>gt.onDidStartTask(X,ce,De),onDidEndTask:(X,ce,De)=>gt.onDidEndTask(X,ce,De),onDidStartTaskProcess:(X,ce,De)=>gt.onDidStartTaskProcess(X,ce,De),onDidEndTaskProcess:(X,ce,De)=>gt.onDidEndTaskProcess(X,ce,De)},Li={createNotebookController(X,ce,De,rt,_t){return ti.createNotebookController(Me,X,ce,De,rt,Me.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(X,ce)=>vt.registerNotebookCellStatusBarItemProvider(Me,X,ce),get onDidSaveNotebookDocument(){return(0,ue.checkProposedApiEnabled)(Me),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,ue.checkProposedApiEnabled)(Me),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ii.createRendererMessaging(Me,X)},onDidChangeNotebookDocumentMetadata(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),Qt.onDidChangeNotebookDocumentMetadata(X,ce,De)},onDidChangeNotebookCells(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCells(X,ce,De)},onDidChangeNotebookCellExecutionState(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCellExecutionState(X,ce,De)},onDidChangeCellOutputs(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),vt.onDidChangeCellOutputs(X,ce,De)},onDidChangeCellMetadata(X,ce,De){return(0,ue.checkProposedApiEnabled)(Me),vt.onDidChangeCellMetadata(X,ce,De)},createConcatTextDocument(X,ce){return(0,ue.checkProposedApiEnabled)(Me),new ze.ExtHostNotebookConcatDocument(vt,St,X,ce)}};return{version:le.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Dt.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[224],Ee([0,1,57,96,31,95,32,39,49,40,99,100,101,72,64,69,97,71,37,68,87,70]),function(ne,e,c,M,E,A,F,k,S,P,t,b,n,f,o,l,w,D,_,a,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,c.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,c.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,c.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,c.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,c.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,c.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,c.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,c.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,c.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,c.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,c.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,c.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,c.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,14,5,11]),function(ne,e,c,M,E,A,F,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(o){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(D,..._)=>{_.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const a=_.slice(0,-1).join(","),d=_.pop().toString();return`(function anonymous(${a}) {${d}
})`}});function w(...D){return l?self.eval(l.createScript("",...D)):new Function(...D)}o.create=w})(P||(P={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(l,w){for(let D of this._alternatives){let _=D(l);if(_){l=_;break}}if(this._factories.has(l))return this._factories.get(l).load(l,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class b extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);f(l,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,w,D){w=w.with({path:n(w.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const _=await fetch(S.FileAccess.asBrowserUri(w).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),_.status!==200)throw new Error(_.statusText);const a=await _.text(),d=`${w.toString(!0)}#vscode-extension`,y=`${a}
//# sourceURL=${d}`;let i;try{i=P.create(b._ttpExtensionScripts?.createScript("module")??"module",b._ttpExtensionScripts?.createScript("exports")??"exports",b._ttpExtensionScripts?.createScript("require")??"require",b._ttpExtensionScripts?.createScript(y)??y)}catch(u){throw console.error(l?`Loading code for extension ${l.value} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${w.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}const v={},r={exports:v},s=u=>{const h=this._fakeModules.getModule(u,w);if(h===void 0)throw new Error(`Cannot load module '${u}'`);return h};try{return D.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(r,v,s),r.exports!==v?r.exports:v}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),D.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+l;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=b,b._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:o=>o});function n(o,l){return o.endsWith(l)?o:o+l}function f(o,l){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(a,d){const y=console[a];console[a]=function(){o.$logExtensionHostMessage({type:"__$console",severity:d,arguments:_(arguments)}),l&&y.apply(console,arguments)}}const D=1e5;function _(a){const d=[],y=[];if(a.length)for(let i=0;i<a.length;i++){if(typeof a[i]=="undefined")a[i]="undefined";else if(a[i]instanceof Error){const v=a[i];v.stack?a[i]=v.stack:a[i]=v.toString()}y.push(a[i])}try{const i=JSON.stringify(y,function(v,r){if(r&&typeof r=="object"){if(d.indexOf(r)!==-1)return"[Circular]";d.push(r)}return r});return i.length>D?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,73,225,212]),function(ne,e,c,M,E,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(E.IExtHostExtensionService,F.ExtHostExtensionService),(0,c.registerSingleton)(M.ILogService,k.ExtHostLogService),(0,c.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[236],Ee([0,1,22,3,178,220,214,17,74,11,2,224,226]),function(ne,e,c,M,E,A,F,k,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(a,d){return a instanceof Request||/^file:/i.test(String(a))&&(a=P.FileAccess.asBrowserUri(t.URI.parse(String(a))).toString(!0)),f(a,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,d,y,i,v){return/^file:/i.test(d.toString())&&(d=P.FileAccess.asBrowserUri(t.URI.parse(d.toString())).toString(!0)),super.open(a,d,y??!0,i,v)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),d=self.Worker;Worker=function(y,i){/^file:/i.test(y.toString())&&(y=P.FileAccess.asBrowserUri(t.URI.parse(y.toString())).toString(!0));const r=`(${function(p){function I(m){return typeof m=="string"||m instanceof URL?String(m).replace(/^file:\/\//i,"vscode-file://vscode-app"):m}const T=fetch.bind(self);self.fetch=function(m,R){return m instanceof Request?T(m,R):T(I(m),R)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,R,L,V,q){return super.open(m,I(R),L??!0,V,q)}};const g=importScripts.bind(self);self.importScripts=(...m)=>{g(...m.map(I))};const C=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:m=>m}):void 0;g(C?C.createScriptURL(p):p)}.toString()}('${y}'))`;i=i||{},i.name=i.name||k.basename(y.toString());const s=new Blob([r],{type:"application/javascript"}),u=URL.createObjectURL(s);return new d(a?a.createScriptURL(u):u,i)}}else self.Worker=class extends F.NestedWorker{constructor(a,d){super(n,a,{name:k.basename(a.toString()),...d})}};const o=new class{exit(a){b()}async exists(a){return!0}async realpath(a){return a}};class l{constructor(){const d=new MessageChannel,y=new M.Emitter;let i=!1;n(d.port2,[d.port2]),d.port1.onmessage=v=>{const{data:r}=v;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,E.isMessageOfType)(s,2)){i=!0,D("received terminate message from renderer");return}y.fire(s)},this.protocol={onMessage:y.event,send:v=>{if(!i){const r=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);d.port1.postMessage(r,[r])}}}}}function w(a){return new Promise(d=>{const y=a.onMessage(i=>{y.dispose();const v=JSON.parse(i.toString());a.send((0,E.createMessageOfType)(0)),d({protocol:a,initData:v})});a.send((0,E.createMessageOfType)(1))})}let D=a=>b();function _(){const a=new l;S.mark("code/extHost/willConnectToRenderer"),w(a.protocol).then(d=>{S.mark("code/extHost/didWaitForInitData");const y=new A.ExtensionHostMain(d.protocol,d.initData,o,null);D=i=>y.terminate(i)})}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/214ac689ca9874a8a4be386f73d5cb60e15af25e/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
